*********************************************
***     TuComposer.Library Player v1.0    ***
*** CLI based TuComposer Player. Requires ***
*** tucomposer.library and valid loaders  ***
*********************************************

	IFND	_G2
	MACHINE	MC68020
	ENDC

	include	"exec/types.i"
	include	"exec/libraries.i"
	include	"exec/exec_lib.i"
	include	"libraries/dos_lib.i"
	include	"libraries/dos.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/module.i"
	include	"tucomposer/song.i"
	include	"tucomposer/position.i"
	include	"tucomposer/player.i"
	include	"tucomposer/external.i"

	moveq	#LocalSize-1,d0
	moveq	#0,d7
	lea	-LocalSize(sp),sp
	move.l	sp,a5
ClearLocalLoop:	clr.b	(a5)+
	dbra	d0,ClearLocalLoop
	move.l	sp,a5
	moveq	#37,d0
	lea	DOSName(pc),a1
	move.l	4.w,a6
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,DOSBase(a5)
	beq	Error
	moveq	#31,d0
	lea	TuCName(pc),a1
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,TuCBase(a5)
	beq	Error2
	move.l	DOSBase(a5),a6
	jsr	_LVOOutput(a6)
	move.l	d0,Output(a5)
	lea	Copyright(pc),a0
	move.l	a0,d1
	jsr	_LVOPutStr(a6)
	lea	CmdMask(pc),a0
	move.l	a0,d1
	lea	Args(a5),a0
	move.l	a0,d2
	moveq	#0,d3
	jsr	_LVOReadArgs(a6)
	move.l	d0,(a5)
	beq	Error3
	move.l	Device(a5),a1
	move.l	a1,d0
	bne.s	UseStandardDev
	lea	PaulaName(pc),a1
UseStandardDev:	moveq	#31,d0
	move.l	4.w,a6
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,Device(a5)
	beq	Error4
	move.l	Mixer(a5),a1
	move.l	a1,d0
	bne.s	UseStandardMix
	lea	LQName(pc),a1
UseStandardMix:	moveq	#31,d0
	move.l	4.w,a6
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,Mixer(a5)
	beq	Error5
	move.l	d0,a1
	move.l	mix_DefaultMixRate(a1),d1
	move.l	MixRate(a5),d0
	beq.s	PutRate
	move.l	d0,a0
	move.l	(a0),d1
PutRate:	move.l	d1,mix_MixRate(a1)
	moveq	#1,d1
	swap	d1
	move.l	Boost(a5),d0
	beq.s	PutBoost
	move.l	d0,a0
	move.l	(a0),d1
	swap	d1
	moveq	#100,d0
	divu.l	d0,d1
PutBoost:	move.l	d1,mix_VolumeBoost(a1)
	lea	PaulaFlagPass(pc),a1
	moveq	#2,d0
	move.l	d0,12(a1)
	move.l	Device(a5),a0
	move.l	LN_NAME(a0),a0
	cmp.l	#"ahid",(a0)
	bne.s	SelectMode
	clr.l	12(a1)
	tst.l	Echo(a5)
	beq.s	NotCross
	not.l	12(a1)
	tst.l	Strength(a5)
	beq.s	NotStrength
	move.l	Strength(a5),a0
	move.l	(a0),16(a1)
NotStrength:	tst.l	Delay(a5)
	beq.s	NotDelay
	move.l	Delay(a5),a0
	move.l	(a0),20(a1)
NotDelay:	tst.l	Feedback(a5)
	beq.s	NotFeedback
	move.l	Feedback(a5),a0
	move.l	(a0),24(a1)
NotFeedback:	tst.l	Cross(a5)
	beq.s	NotCross
	move.l	Cross(a5),a0
	move.l	(a0),28(a1)
NotCross:	st	Cont(a5)
SelectMode:	moveq	#4,d0
	moveq	#8,d1
	lea	PaulaFlagPass(pc),a1
	move.l	4(a1),OldFunc-PaulaFlagPass(a1)
	clr.l	4(a1)
	move.l	Device(a5),a0
	move.l	LN_NAME(a0),a0
	cmp.l	#"ahid",(a0)
	bne.s	NotAHIDevice
	moveq	#2,d0
	moveq	#4,d1
NotAHIDevice:	tst.l	Mode(a5)
	beq.s	ModeNotSelected
	move.l	Mode(a5),a1
	move.l	(a1),d0
	st	Cont(a5)
ModeNotSelected:	lea	PaulaFlagPass(pc),a0
	move.l	d0,(a0,d1.l)
	move.l	Module(a5),d1
	beq	NoPlayNewMod
	clr.l	Cont(a5)
	clr.l	MixRate(a5)
	move.l	#1005,d2
	moveq	#0,d3
	move.l	TuCBase(a5),a6
	jsr	_LVOCOpen(a6)
	move.l	d0,d7
	beq	Error6
	move.l	d7,a0
	jsr	_LVOIdentifyTCModule(a6)
	move.l	d0,d6
	beq	Error7
	lea	FlagPass(pc),a3
	move.l	a3,a1
	move.l	d6,a2
	move.l	extl_LoadFlagStr(a2),a0
	move.w	(a0),d0
FillFlagPass:	move.l	tefs_Flag0Default(a0),(a1)+
	lea	tefs_FlagxText-tefs_Flag0Text(a0),a0
	subq.w	#1,d0
	bne.s	FillFlagPass
	move.l	d7,a0
	sub.l	a1,a1
	moveq	#0,d0
	jsr	_LVOLoadTCModule(a6)
	move.l	d0,d5
	beq	Error7
	move.l	tcb_DOSBase(a6),a6
	jsr	_LVOIoErr(a6)
	cmp.l	#ERROR_ACTION_NOT_KNOWN,d0
	bne.s	NoVerErrorOk
	lea	VerErr(pc),a0
	bsr	Print
NoVerErrorOk:	move.l	TuCBase(a5),a6
	move.l	d5,a0
	jsr	_LVOAddTCModule(a6)
	move.l	tcb_PlaySoundDeviceBase(a6),d0
	beq.s	NotResetDev
	jsr	_LVOStopTCModule(a6)
	move.l	tcb_PlaySoundDeviceBase(a6),a0
	clr.l	tcb_PlaySoundDeviceBase(a6)
	move.l	extb_ExtLibList(a0),a0
	jsr	_LVOFreeSoundDevice(a6)
NotResetDev:	move.l	tcb_PlayMixerLibBase(a6),d0
	beq.s	NotResetMix
	move.l	d0,a0
	move.l	extb_ExtLibList(a0),a0
	clr.l	tcb_PlayMixerLibBase(a6)
	jsr	_LVOFreeMixer(a6)
NotResetMix:	move.l	tcb_PlayModule(a6),a0
	clr.l	tcb_PlayModule(a6)
	clr.l	tcb_PlaySong(a6)
	jsr	_LVOFreeTCModule(a6)
	move.l	d5,a1
	move.l	tcm_SongList(a1),a1
	move.l	a1,tcb_PlaySong(a6)
	move.l	Output(a5),d1
	lea	LoadStr(pc),a0
	move.l	a0,d2
	lea	PrintfMask(pc),a0
	move.l	a0,d3
	move.l	d6,a2
	move.l	extl_Descriptor(a2),(a0)+
	move.l	tcso_Name(a1),(a0)
	move.l	DOSBase(a5),a6
	jsr	_LVOVFPrintf(a6)
	move.l	TuCBase(a5),a6
	move.l	d5,tcb_PlayModule(a6)
	move.l	Mixer(a5),tcb_PlayMixerLibBase(a6)
	move.l	Device(a5),a0
	move.l	a0,tcb_PlaySoundDeviceBase(a6)
	move.l	extb_ExtLibList(a0),a0
	jsr	_LVOAllocSoundDevice(a6)
	tst.l	d0
	bne	FlushMod
	move.l	Mixer(a5),a0
	move.l	extb_ExtLibList(a0),a0
	jsr	_LVOAllocMixer(a6)
	tst.l	d0
	bne	FlushMod
	move.l	tcb_PlaySong(a6),a0
	move.l	tcso_GlobalData(a0),a1
	moveq	#100,d0
	moveq	#1,d2
	swap	d2
	tst.l	Speed(a5)
	beq.s	NoSpeedGiven
	move.l	Speed(a5),a0
	move.l	(a0),d2
	swap	d2
	divu.l	d0,d2
NoSpeedGiven:	move.l	d2,pg_RelativePitch(a1)
	move.l	d2,pg_RelativeSpeed(a1)
	moveq	#1,d2
	swap	d2
	tst.l	Pitch(a5)
	beq.s	NoPitchGiven
	move.l	Pitch(a5),a0
	move.l	(a0),d2
	swap	d2
	divu.l	d0,d2
	move.l	d2,pg_RelativePitch(a1)
NoPitchGiven:	move.l	tcb_PlaySong(a6),a0
	jsr	_LVOCalcPlayerSpeed(a6)
	move.l	Mixer(a5),a0
	move.l	d0,mix_Tempo(a0)
	move.l	d5,a1
	move.l	mix_VolumeBoost(a0),d0
	move.w  #65536*125/1000,d1
	mulu.w  tcm_Channels(a1),d1
	add.l   #65536*75/100,d1
	mulu.l	d1,d1:d0
	move.w	d1,d0
	swap	d0
	move.l  d0,mix_VolumeBoost(a0)
	move.w	tcm_Channels(a1),mix_MaxChannels(a0)
	lea	MixFlagPass(pc),a1
	move.l	a1,a2
	move.l	Bit16(a5),(a1)+
	move.l	Mono(a5),(a1)
	not.l	(a1)
	move.l	Device(a5),a1
	moveq	#64,d0
	lsl.l	#4,d0
	tst.l	Buffers(a5)
	beq.s	UseDefaultBuffers
	move.l	Buffers(a5),a2
	move.l	(a2),d0
UseDefaultBuffers:	move.l	d0,mix_MixBufSize(a0)
	move.w	#256,mix_LeftVolume(a0)
	move.w	#256,mix_RightVolume(a0)
	move.l	extb_ExtLibList(a0),a0
	jsr	_LVOInitMixer(a6)
	move.l	tcb_PlaySong(a6),a0
	jsr	_LVOResetSong(a6)
	lea	PaulaFlagPass(pc),a0
	jsr	_LVOPlayTCModule(a6)
NoPlayNewMod:	move.l	d7,d1
	moveq	#0,d7
	move.l	TuCBase(a5),a6
	jsr	_LVOCClose(a6)
	move.l	tcb_PlaySong(a6),d0
	beq	NoPitch
	move.l	d0,a2
	move.l	tcso_GlobalData(a2),a2
	tst.l	MixRate(a5)
	beq.s	NoMixRate
	move.l	MixRate(a5),a0
	move.l	(a0),d0
	move.l	tcb_PlayMixerLibBase(a6),a0
	move.l	extb_ExtLibList(a0),a0
	jsr	_LVOChangeMixerRate(a6)
NoMixRate:	moveq	#100,d4
	tst.l	Boost(a5)
	beq.s	NoBoost
	move.l	Boost(a5),a0
	move.l	(a0),d0
	swap	d0
	divu.l	d4,d0
	move.w  #65536*125/1000,d1
	move.l	tcb_PlayModule(a6),a0
	mulu.w  tcm_Channels(a0),d1
	add.l   #65536*75/100,d1
	mulu.l	d1,d1:d0
	move.w	d1,d0
	swap	d0
	move.l	tcb_PlayMixerLibBase(a6),a0
	move.w	mix_LeftVolume(a0),d1
	moveq	#0,d2
	move.w	mix_RightVolume(a0),d2
	moveq	#0,d3
	move.w	mix_MaxChannels(a0),d3
	move.l	extb_ExtLibList(a0),a0
	jsr	_LVOChangeMixerVolTable(a6)
NoBoost:	move.l	pg_RelativeSpeed(a2),d2
	tst.l	Speed(a5)
	beq.s	NoSpeed
	move.l	Speed(a5),a0
	move.l	(a0),d2
	swap	d2
	divu.l	d4,d2
NoSpeed:	move.l	d2,pg_RelativePitch(a2)
	move.l	d2,pg_RelativeSpeed(a2)
	move.l	pg_Tempo(a2),d0
	mulu.l	d2,d1:d0
	move.w	d1,d0
	swap	d0
	move.l	tcb_PlayMixerLibBase(a6),a0
	move.l	extb_ExtLibList(a0),a0
	jsr	_LVOChangeMixerTempo(a6)
	tst.l	Pitch(a5)
	beq.s	NoPitch
	move.l	Pitch(a5),a0
	move.l	(a0),d2
	swap	d2
	divu.l	d4,d2
	move.l	d2,pg_RelativePitch(a2)
NoPitch:	move.l	Save(a5),d1
	beq.s	NoSaveMod
	tst.l	tcb_PlayModule(a6)
	beq.s	NoSaveMod
	move.l	#1006,d2
	moveq	#0,d3
	jsr	_LVOCOpen(a6)
	move.l	d0,d6
	beq	SaveError
	move.l	tcb_PlayModule(a6),a0
	tst.l	tcm_PlayTimeHours(a0)
	bne.s	PlayTimeAlreadyOk
	clr.l	-(sp)
	clr.l	-(sp)
	clr.w	-(sp)
	pea	-4(sp)
	move.w	#$ff00,-(sp)
	pea	GetVChannels(pc)
	move.w	#PEHF_SongEnd<<8,-(sp)
	clr.l	-(sp)
	clr.l	-(sp)
	move.l	sp,a1
	jsr	_LVOCalcTCMPlayTime(a6)
	move.l	peh_Data(sp),d0
	move.l	tcb_PlayModule(a6),a0
	lea	peh_SIZEOF(sp),sp
	jsr	_LVOSetTCMChannels(a6)
PlayTimeAlreadyOk:	move.l	d6,a0
	move.l	tcb_PlayModule(a6),a1
	sub.l	a2,a2
	lea	XMFlagPass(pc),a3
	jsr	_LVOSaveTCModule(a6)
	move.l	d0,d3
	move.l	d6,d1
	jsr	_LVOCClose(a6)
	tst.l	d3
	bne	SaveError
NoSaveMod:	tst.l	Wait(a5)
	beq	NotWait
	tst.l	tcb_PlayModule(a6)
	beq	NotWait
	clr.l	-(sp)
	clr.l	-(sp)
	clr.l	-(sp)
	moveq	#-1,d0
	move.l	4.w,a6
	jsr	_LVOAllocSignal(a6)
	ror.l	#8,d0
	move.l	d0,-(sp)
	sub.l	a1,a1
	jsr	_LVOFindTask(a6)
	move.l	d0,-(sp)
	move.w	#PEHF_SongEnd<<8,-(sp)
	clr.l	-(sp)
	clr.l	-(sp)
	move.l	sp,a0
	move.l	TuCBase(a5),a6
	jsr	_LVOAddPlayExecHandler(a6)
	move.l	#SIGBREAKF_CTRL_C|SIGBREAKF_CTRL_D,d0
	moveq	#0,d2
	move.b	peh_SigBit(sp),d1
	bset	d1,d2
	move.l	Wait(a5),a0
	move.l	(a0),d3
	or.l	d0,d2
	move.l	4.w,a6
WaitLoop:	move.l	TuCBase(a5),a0
	move.l	tcb_PlaySong(a0),a0
	move.l	tcso_GlobalData(a0),a0
	bclr	#PGB_SongEnd,(a0)
	move.l	d2,d0
	jsr	_LVOWait(a6)
	btst	#SIGBREAKB_CTRL_D,d0
	bne.s	WaitDone
	subq.l	#1,d3
	bne.s	WaitLoop
WaitDone:	move.l	sp,a0
	move.l	TuCBase(a5),a6
	jsr	_LVORemPlayExecHandler(a6)
	moveq	#0,d0
	move.b	peh_SigBit(a2),d0
	move.l	4.w,a6
	jsr	_LVOFreeSignal(a6)
	lea	peh_SIZEOF(sp),sp
NotWait:	tst.l	Stop(a5)
	beq.s	StopOk
	move.l	TuCBase(a5),a6
	move.l	tcb_PlaySoundDeviceBase(a6),d0
	beq.s	StopOk
	move.l	d0,a0
	move.l	extb_ExtLibList(a0),a0
	jsr	_LVOStopSoundDevice(a6)
StopOk:	tst.l	Cont(a5)
	beq.s	ContOk
	move.l	TuCBase(a5),a6
	tst.l	tcb_PlayModule(a6)
	beq.s	ContOk
	move.l	tcb_PlaySoundDeviceBase(a6),d0
	beq.s	ContOk
	move.l	d0,a0
	lea	PaulaFlagPass(pc),a2
	move.l	LN_NAME(a0),a1
	cmp.l	#"ahid",(a1)
	bne.s	NotContAHIDev
	tst.l	4(a2)
	bne.s	NotContAHIDev
	move.l	OldFunc(pc),4(a2)
NotContAHIDev:	move.l	extb_ExtLibList(a0),a0
	move.l	tcb_PlayMixerLibBase(a6),a1
	jsr	_LVOPlaySoundDevice(a6)
ContOk:	tst.l	Flush(a5)
	beq.s	PlayDone
FlushMod:	move.l	TuCBase(a5),a6
	move.l	tcb_PlayModule(a6),d5
	clr.l	tcb_PlayModule(a6)
	clr.l	tcb_PlaySong(a6)
	move.l	tcb_PlaySoundDeviceBase(a6),d0
	beq.s	NoStopPlayDev
	jsr	_LVOStopTCModule(a6)
	move.l	tcb_PlaySoundDeviceBase(a6),a0
	clr.l	tcb_PlaySoundDeviceBase(a6)
	move.l	extb_ExtLibList(a0),a0
	jsr	_LVOFreeSoundDevice(a6)
NoStopPlayDev:	move.l	tcb_PlayMixerLibBase(a6),d0
	beq.s	NoStopPlayMix
	move.l	d0,a0
	clr.l	tcb_PlayMixerLibBase(a6)
	move.l	extb_ExtLibList(a0),a0
	jsr	_LVOFreeMixer(a6)
NoStopPlayMix:	move.l	d5,a0
	jsr	_LVOFreeTCModule(a6)
PlayDone:	moveq	#0,d6
Close7:	move.l	d7,d1
	move.l	TuCBase(a5),a6
	jsr	_LVOCClose(a6)
Close6:	move.l	Mixer(a5),d0
	beq.s	Close5
	move.l	d0,a1
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
Close5:	move.l	Device(a5),d0
	beq.s	Close4
	move.l	d0,a1
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
Close4:	move.l	(a5),d1
	move.l	DOSBase(a5),a6
	jsr	_LVOFreeArgs(a6)
Close3:	move.l	TuCBase(a5),a1
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
Close2:	move.l	DOSBase(a5),a1
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
Error:	lea	LocalSize(sp),sp
	move.l	d6,d0
	rts
Error7:	lea	BadFormat(pc),a0
	bsr.s	Print
	moveq	#20,d6
	bra.s	Close7
Error6:	lea	BadModFile(pc),a0
	bsr.s	Print
	moveq	#20,d6
	bra.s	Close6
Error5:	lea	InvMixErr(pc),a0
	bsr.s	Print
	moveq	#20,d6
	bra.s	Close5
Error4:	lea	InvDevErr(pc),a0
	bsr.s	Print
	moveq	#20,d6
	bra.s	Close4
Error3:	lea	ArgsErr(pc),a0
	bsr.s	Print
	moveq	#20,d6
	bra.s	Close3
Error2:	lea	TuCLibErr(pc),a0
	bsr.s	Print
	moveq	#20,d6
	bra.s	Close2
SaveError:	lea	SaveErr(pc),a0
	bsr.s	Print
	bra	NoSaveMod
Print:	move.l	a0,d1
	move.l	DOSBase(a5),a6
	jmp	_LVOPutStr(a6)
GetVChannels:	move.l	4(sp),a0
	move.l	tcb_PlaySong(a6),a1
	move.l	tcso_GlobalData(a1),a1
	clr.w	(a0)+
	move.w	pg_MaxChannels(a1),(a0)
	rts
	rsset	0
Arg:	rs.l	1
DOSBase:	rs.l	1
TuCBase:	rs.l	1
Output:	rs.l	1
Args:	rs.l	0
Module:	rs.l	1
Save:	rs.l	1
Device:	rs.l	1
Mixer:	rs.l	1
MixRate:	rs.l	1
Buffers:	rs.l	1
Boost:	rs.l	1
Speed:	rs.l	1
Pitch:	rs.l	1
Wait:	rs.l	1
Stop:	rs.l	1
Cont:	rs.l	1
Verbose:	rs.l	1
Flush:	rs.l	1
Mode:	rs.l	1
Mono:	rs.l	1
Bit16:	rs.l	1
Echo:	rs.l	1
Strength:	rs.l	1
Delay:	rs.l	1
Feedback:	rs.l	1
Cross:	rs.l	1
CmdBuf:	rs.b	0
LocalSize:	rs.b	0
PrintfMask:	ds.l	2
OldFunc:	dc.l	0
PaulaFlagPass:	dc.l	0,2,4,2,25,25,25,25
MixFlagPass:	dc.l	0,-1,1
XMFlagPass:	dc.l	-1,-1,-1,0,0
FlagPass:	ds.l	64
ArgL:	dc.l	0
DOSName:	dc.b	'dos.library',0
TuCName:	dc.b	'tucomposer.library',0
PaulaName:	dc.b	'internal_paula.library',0
LQName:	dc.b	'internal_lqmix.library',0
CmdMask:	dc.b	'MOD=MODULE/K,SAVE/K,DEVICE/K,MIXER/K,MIXRATE=RATE/K/N,BUFFERS/K/N,BOOST/K/N,SPEED/K/N,PITCH/K/N,WAIT/K/N,STOP/S,CONT=CONTINUE/S,VERBOSE/S,FLUSH/S,MODE/K/N,MONO/S,16BIT/S,ECHO/S,STRENGTH/K/N,DELAY/K/N,FEEDBACK/K/N,CROSS/K/N',0
Copyright:	dc.b	'TuCPlay v1.0  1997-98 by Sebastian Vater, Inc.',10,10,0
TuCLibErr:	dc.b	"Couldn't open tucomposer.library !",10,0
ArgsErr:	dc.b	'Argument line invalid !',10,0
InvDevErr:	dc.b	"Couldn't open sound device !",10,0
InvMixErr:	dc.b	"Couldn't open mixing device !",10,0
BadModFile:	dc.b	"Couldn't access module file !",10,0
BadFormat:	dc.b	"Unknown file format. Make sure you have an external loader !",10,0
SaveErr:	dc.b	"Unable to save TCM file !",10,0
VerErr:	dc.b	"Warning ! This module might not be played 100% correctly !",10,0
LoadStr:	dc.b	'Playing now %s: %s',15,'...',10,0