	include	"exec/types.i"
	include	"exec/libraries.i"
	include	"exec/exec_lib.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/module.i"
	include	"tucomposer/song.i"
	include	"tucomposer/player.i"
	include	"tucomposer/external.i"

	IFND	_G2
	MACHINE	MC68020
	ENDC

WRITE_PREFILL	equ	33*2352
DEBUG			equ	2

Start:	
	IFGE	DEBUG-1
	move.l	Start-4(pc),d1
	move.l	a0,a2
	lea	TuCName(pc),a1
	move.l	4.w,a6
	jsr	_LVOOldOpenLibrary(a6)
	move.l	d0,a5
	move.l	a5,a6
	lea	FileTab(pc),a0
	moveq	#68,d4
	move.l	(a0,d4.l*4),d1
	move.l	d1,a0
	lea	WAVFileSmp(pc),a1
FindDbl:	cmp.b	#":",(a0)+
	bne.s	FindDbl
CopyModLoop:	move.b	(a0)+,(a1)+
	cmp.b	#".",(a0)
	bne.s	CopyModLoop
	move.l	#".WAV",(a1)+
	clr.b	(a1)
	move.l	#1005,d2
	moveq	#0,d3
	jsr	_LVOCOpen(a6)
	move.l	d0,d7
	beq	Error7
	move.l	d7,a0
	jsr	_LVOIdentifyTCModule(a6)
	move.l	d0,d6
	beq	Error7
	lea	FlagPassList(pc),a3
	move.l	a3,a1
	move.l	d6,a2
	move.l	extl_LoadFlagStr(a2),a0
	move.w	(a0),d0
FillFlagPass:	move.l	tefs_Flag0Default(a0),(a1)+
	lea	tefs_FlagxText-tefs_Flag0Text(a0),a0
	subq.w	#1,d0
	bne.s	FillFlagPass
	move.l	d7,a0
	sub.l	a1,a1
	moveq	#0,d0
	jsr	_LVOLoadTCModule(a6)
	move.l	d0,d5
	beq	Error7
	move.l	d5,a0
	jsr	_LVOAddTCModule(a6)
	jsr	_LVOAllocPlayTCModule(a6)
	tst.l	d0
	bne	NotWait
	move.l	d5,a1
	move.l	tcm_SongList(a1),a1
	move.l	a1,tcb_PlaySong(a6)
	move.l	d5,tcb_PlayModule(a6)
	move.l	tcb_ExtMixer+8(a6),a0
	move.l	MLN_PRED(a0),a0					* Use High Quality Mixer
	move.l	a0,a4
	jsr	_LVOAllocMixer(a6)
	move.l	d0,tcb_PlayMixerAlloc(a6)
	beq	NotWait
	move.l	d0,a4
	move.l	tcb_ExtDevice+8(a6),a0
;	move.l	MLN_PRED(a0),a0					* Don't use Eternal Quiet Player
	move.l	extl_LibBase(a0),tcb_PlaySoundDeviceBase(a6)
	sub.l	a1,a1
	jsr	_LVOAllocSoundDevice(a6)
	tst.l	d0
	bne	NotWait
	move.l	d5,a0
	move.l	tcm_SongList(a0),a0
	jsr	_LVOResetSong(a6)
	move.l	d5,a0
	moveq	#1,d0
	swap	d0
	move.l	d5,a0
	move.l	tcm_SongList(a0),a0
	move.l	tcso_GlobalData(a0),a1
	move.l	d0,pg_RelativePitch(a1)
	move.l	d0,pg_RelativeSpeed(a1)
	jsr	_LVOCalcPlayerSpeed(a6)
	move.l	d0,mas_Tempo(a4)
	move.l	d5,a1
	tst.l   mas_VolumeBoost(a4)
	bne.s   VolAutoOkay
	move.w  #65536*125/1000,d1
	mulu.w  tcm_Channels(a1),d1
	add.l   #65536*75/100,d1
	add.l	d1,d1
	move.l  d1,mas_VolumeBoost(a4)
VolAutoOkay:	move.w	tcm_Channels(a1),mas_MaxChannels(a4)
	move.l	tcb_ExtDevice+8(a5),a1
	move.l	extl_LibBase(a1),a1
	lea	MixFlagPass(pc),a2
	move.l	#588,mas_MixBufSize(a4)
	move.w	#256,mas_LeftVolume(a4)
	move.w	#256,mas_RightVolume(a4)
	IFGE	DEBUG-2
	moveq	#-1,d1
	move.l	d1,(a2)		; Real 16-bit mixing
	moveq	#1,d1
	move.l	d1,8(a2)	; Interpolation
	move.l	#44100,d1
	ELSE
	move.l	#28375,d1
	ENDC
	move.l	d1,mas_MixRate(a4)
	move.l	a4,a0
	jsr	_LVOInitMixer(a6)

	move.l	tcb_ExtPostProc(a6),a0
	move.l	a4,a1

	jsr	_LVOAllocPostProcessor(a6)

	move.l	d0,a1
	move.l	a4,a0

	jsr	_LVOAddPostProcessor(a6)

	move.l	d5,a0
	move.l	tcm_SongList(a0),a0
	move.l	tcso_GlobalData(a0),a0
	bset	#7,pg_PlayType(a0)

ChkIllLoop:	illegal
	move.l	a6,a0
	jsr	_LVODoPlayerIRQ(a6)
	bra.s	ChkIllLoop
	IFGE	DEBUG-2

	lea	WAVFile(pc),a0
	move.l	a0,d1
	move.l	#1006,d2
	moveq	#0,d3
	jsr	_LVOCOpen(a6)
	move.l	d0,d4
	beq	NormalPlay
	lea	WAVHeader(pc),a2
	move.l	d4,d1
	move.l	a2,d2
	moveq	#WAVLength-WAVHeader,d3
	jsr	_LVOCWrite(a6)
	move.l	#WRITE_PREFILL+9408,d0
	jsr	_LVOAllocPMem(a6)
	move.l	d4,d1
	move.l	d0,d2
	move.l	#WRITE_PREFILL,d3
	move.l	d3,d5
	jsr	_LVOCWrite(a6)
	move.l	d2,a3
	move.l	tcb_PlayMixerAlloc(a6),a0
	move.l	mas_MixBufSize(a0),d2
	move.l	mas_MixRate(a0),d0
	move.l	d0,d1
	lsl.l	#2,d1
	rol.w	#8,d0
	swap	d0
	rol.w	#8,d0
	rol.w	#8,d1
	swap	d1
	rol.w	#8,d1
	movem.l	d0-d1,WAVSmpRate-WAVHeader(a2)
	move.l	d2,d3
	lsl.l	#2,d3
	move.l	mas_MixBuf(a0),a2
MixWriteLoop:	move.l	tcb_PlayMixerAlloc(a6),a0
	move.l	a6,-(sp)
	move.l	(a0),a6
	jsr	_LVOExternalMixerDoMix(a6)
	move.l	(sp)+,a6
	move.l	tcb_PlaySong(a6),a1
	move.l	tcso_GlobalData(a1),a1
	btst	#PGB_SongEnd,(a1)
	bne.s	WriteSongEndFound
	move.l	d3,d2
	move.l	a2,a0
	move.l	a3,a1
MixBufConvLoop:	move.l	(a0)+,d0
	move.w	(a0)+,d0
	addq.l	#2,a0
	rol.w	#8,d0
	swap	d0
	rol.w	#8,d0
	swap	d0
	move.l	d0,(a1)+
	subq.l	#4,d2
	bne.s	MixBufConvLoop
	move.l	d4,d1
	move.l	a3,d2
	jsr	_LVOCWrite(a6)
	cmp.l	d3,d0
	bne.s	WriteSongEndFound
	add.l	d3,d5
	bra.s	MixWriteLoop
WriteSongEndFound:	move.l	d4,d1
	moveq	#0,d2
	moveq	#OFFSET_BEGINNING,d3
	jsr	_LVOCSeek(a6)
	move.l	d4,d1
	lea	WAVHeader(pc),a0
	move.l	a0,d2
	move.l	d5,d3
	rol.w	#8,d3
	swap	d3
	rol.w	#8,d3
	move.l	d3,WAVData-WAVHeader(a0)
	add.l	#WAVLength-WAVHeader-8,d5
	rol.w	#8,d5
	swap	d5
	rol.w	#8,d5
	move.l	d5,4(a0)
	moveq	#WAVLength-WAVHeader,d3
	jsr	_LVOCWrite(a6)
	move.l	d4,d1
	jsr	_LVOCClose(a6)
	move.l	a3,a1
	move.l	#WRITE_PREFILL+9408,d0
	jsr	_LVOFreePMem(a6)
	bra.s	NoPlayNewMod
	ENDC
NormalPlay:	move.l	d5,a0
	move.l	tcm_SongList(a0),a0
	move.l	tcso_GlobalData(a0),a0
	bset	#PGB_TraceMode,(a0)
	move.l	tcb_ExtDevice+8(a5),a0
	move.l	a4,a1
	lea	PaulaFlagPass(pc),a2
	jsr	_LVOPlaySoundDevice(a6)
	move.l	d5,a0
	move.l	tcm_SongList(a0),a0
	move.l	tcso_GlobalData(a0),a0
	moveq	#1,d0
TraceLoop:	move.w	d0,pg_TraceCount(a0)
	btst	#6,$bfe001
	bne.s	TraceLoop
NoPlayNewMod:	move.l	mas_PostProcs(a4),a0
	jsr	_LVOFreePostProcessor(a6)
	move.l	tcb_PlayModule(a6),d5
	move.l	d7,d1
	moveq	#0,d7
	move.l	a5,a6
	jsr	_LVOCClose(a6)
	bra.s	NotWait
	lea	ExecHandler(pc),a2
	moveq	#-1,d0
	move.l	4.w,a6
	jsr	_LVOAllocSignal(a6)
	move.b	d0,peh_SigBit(a2)
	sub.l	a1,a1
	jsr	_LVOFindTask(a6)
	move.l	d0,peh_Task(a2)
	move.l	a2,a0
	move.l	a5,a6
	jsr	_LVOAddPlayExecHandler(a6)
	move.l	#SIGBREAKF_CTRL_C|SIGBREAKF_CTRL_D,d0
	moveq	#0,d2
	move.b	peh_SigBit(a2),d1
	bset	d1,d2
	moveq	#1,d3
	or.l	d0,d2
	move.l	4.w,a6
WaitLoop:	move.l	a5,a0
	move.l	tcb_PlaySong(a0),a0
	move.l	tcso_GlobalData(a0),a0
	bclr	#PGB_SongEnd,(a0)
	move.l	d2,d0
	jsr	_LVOWait(a6)
	btst	#SIGBREAKB_CTRL_D,d0
	bne.s	WaitDone
	subq.l	#1,d3
	bne.s	WaitLoop
WaitDone:	move.l	a2,a0
	move.l	a5,a6
	jsr	_LVORemPlayExecHandler(a6)
	moveq	#0,d0
	move.b	peh_SigBit(a2),d0
	move.l	4.w,a6
	jsr	_LVOFreeSignal(a6)
NotWait:	move.l	a5,a6
	jsr	_LVOStopTCModule(a6)
	move.l	tcb_PlaySoundDeviceBase(a6),a0
	clr.l	tcb_PlaySoundDeviceBase(a6)
	move.l	extb_ExtLibList(a0),a0
	jsr	_LVOFreeSoundDevice(a6)
	move.l	tcb_PlayMixerAlloc(a6),a0
	clr.l	tcb_PlayMixerAlloc(a6)
	jsr	_LVOFreeMixer(a6)
	jsr	_LVOFreePlayTCModule(a6)
	move.l	d5,a0
	jsr	_LVOFreeTCModule(a6)
	moveq	#0,d6
Close7:	move.l	d7,d1
	move.l	a5,a6
	jsr	_LVOCClose(a6)
Error:	move.l	a5,a1
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
	move.l	d6,d0
	rts
Error7:	moveq	#20,d6
	bra.s	Close7
PaulaFlagPass:	dc.l	0,0,4,2
MixFlagPass:	dc.l	0,-1,1
XMFlagPass:	dc.l	-1,-1,-1,0,0
InstrFlagPass:	dc.l	-1,3,-1,-1
LoadInstrFlagPass:	dc.l	-1,0,-1,1
FlagPassList:	ds.l	64
ExecHandler:	ds.l	2
	dc.b	PEHF_SongEnd
	dc.b	0
	dc.l	0
	dc.b	-1
	ds.b	15
WAVHeader:	dc.b	'RIFF'
	dc.l	0
	dc.b	'WAVE'
	dc.b	'fmt '
	dc.b	$10,0,0,0
	dc.w	$0100
	dc.w	$0200
WAVSmpRate:	dc.l	44100
	dc.l	176400
	dc.w	$0400
	dc.w	$1000
	dc.b	'data'
WAVData:	dc.l	0
WAVLength:
FileTab:	dc.l	File0
	dc.l	File1
	dc.l	File2
	dc.l	File3
	dc.l	File4
	dc.l	File5
	dc.l	File6
	dc.l	File7
	dc.l	File8
	dc.l	File9
	dc.l	File10
	dc.l	File11
	dc.l	File12
	dc.l	File13
	dc.l	File14
	dc.l	File15
	dc.l	File16
	dc.l	File17
	dc.l	File18
	dc.l	File19
	dc.l	File20
	dc.l	File21
	dc.l	File22
	dc.l	File23
	dc.l	File24
	dc.l	File25
	dc.l	File26
	dc.l	File27
	dc.l	File28
	dc.l	File29
	dc.l	File30
	dc.l	File31
	dc.l	File32
	dc.l	File33
	dc.l	File34
	dc.l	File35
	dc.l	File36
	dc.l	File37
	dc.l	File38
	dc.l	File39
	dc.l	File40
	dc.l	File41
	dc.l	File42
	dc.l	File43
	dc.l	File44
	dc.l	File45
	dc.l	File46
	dc.l	File47
	dc.l	File48
	dc.l	File49
	dc.l	File50
	dc.l	File51
	dc.l	File52
	dc.l	File53
	dc.l	File54
	dc.l	File55
	dc.l	File56
	dc.l	File57
	dc.l	File58
	dc.l	File59
	dc.l	File60
	dc.l	File61
	dc.l	File62
	dc.l	File63
	dc.l	File64
	dc.l	File65
	dc.l	File66
	dc.l	File67
	dc.l	File68
	dc.l	File69
	dc.l	File70
	dc.l	File71
File0:	dc.b	'MODs:MagSonic.Mod',0
File1:	dc.b	'MODs:MidRythm.Mod',0
File2:	dc.b	'MODs:HELLRAVE.XM',0
File3:	dc.b	'MODs:FcknHell.Mod',0
File4:	dc.b	'MODs:TrShades.XM',0
File5:	dc.b	'MODs:TekDrill.XM',0
File6:	dc.b	'MODs:Anti-PC.Mod',0
File7:	dc.b	'MODs:Raveland.XM',0
File8:	dc.b	'MODs:Ind_Rave.XM',0
File9:	dc.b	'MODs:Save_Nat.IT',0
File10:	dc.b	'MODs:ChpyBlow.Mod',0
File11:	dc.b	'MODs:OvrAbyss.Mod',0
File12:	dc.b	'MODs:Anti-BG.IT',0
File13:	dc.b	'MODs:Rad_Beat.S3M',0
File14:	dc.b	'MODs:TiT_Rave.S3M',0
File15:	dc.b	'MODs:X-Beats.XM',0
File16:	dc.b	'MODs:ChipTime.IT',0
File17:	dc.b	'MODs:ChipSqr.XM',0
File18:	dc.b	'MODs:ChipSwrs.Mod',0
File19:	dc.b	'MODs:Ravebott.XM',0
File20:	dc.b	'MODs:FuCk-RsR.IT',0
File21:	dc.b	'MODs:Last_Req.S3M',0
File22:	dc.b	'MODs:Night2.S3M',0
File23:	dc.b	'MODs:M11.S3M',0
File24:	dc.b	'MODs:XMasFeel.Mod',0
File25:	dc.b	'MODs:SlntDrms.IT',0
File26:	dc.b	'MODs:StrmWspr.IT',0
File27:	dc.b	'MODs:PeaceBrt.IT',0
File28:	dc.b	'MODs:Children.XM',0
File29:	dc.b	'MODs:Giana.XM',0
File30:	dc.b	'MODs:InfnHist.IT',0
File31:	dc.b	'MODs:GhostMnd.IT',0
File32:	dc.b	'MODs:HarmSeed.IT',0
File33:	dc.b	'MODs:VibeShck.IT',0
File34:	dc.b	'MODs:GrdDance.IT',0
File35:	dc.b	'MODs:MjVision.IT',0
File36:	dc.b	'MODs:Chris17B.IT',0
File37:	dc.b	'MODs:Chris31B.IT',0
File38:	dc.b	'MODs:Jeff93.IT',0
File39:	dc.b	'MODs:TRSiP48k.Mod',0
File40:	dc.b	'MODs:Blessed.IT',0
File41:	dc.b	'MODs:Jana.IT',0
File42:	dc.b	'MODs:K_Childr.XM',0
File43:	dc.b	'MODs:Chris17B.IT',0
File44:	dc.b	'MODs:Dn-NoNam.TCM',0
File45:	dc.b	'HD3:Music/Exotics/FC14/FC14.Synthtronic',0
File46:	dc.b	'HD3:Music/Exotics/FC13/FC13.Intro-34',0
File47:	dc.b	'HD3:Music/Exotics/FC13/FC13.Savage',0
File48:	dc.b	'HD3:Music/Exotics/FC13/FC13.Thalion',0
File49:	dc.b	'HD3:Music/Exotics/FC14/FC14.Rings_of_Medusa',0
File50:	dc.b	'HD1:FC14.Basty',0
File51:	dc.b	'MODs:ToxSynth.IT',0
File52:	dc.b	'MODs:Synfinte.IT',0
File53:	dc.b	'MODs:GianaInG.Mod',0
File54:	dc.b	'MODs:Monty_II.Mod',0
File55:	dc.b	'MODs:Stoned.IT',0
File56:	dc.b	'MODs:LoveWeed.IT',0
File57:	dc.b	'MODs:Infn_Duo.TCM',0
File58:	dc.b	'MODs:Spir_Vib.IT',0
File59:	dc.b	'MODs:TripISpc.IT',0
File60:	dc.b	'MODs:GtwyInfn.IT',0
File61:	dc.b	'MODs:Spir_Nat.IT',0
File62:	dc.b	'MODs:Dim_Door.IT',0
File63:	dc.b	'MODs:PltSigma.IT',0
File64:	dc.b	'MODs:Ovrdosed.IT',0
File65:	dc.b	'MODs:ByndRain.IT',0
File66:	dc.b	'MODs:Zuzana.IT',0
File67:	dc.b	'MODs:MushTrip.IT',0
File68:	dc.b	'MODs:Buddha.IT',0
File69:	dc.b	'MODs:Chai-Tea.IT',0
File70:	dc.b	'MODs:Chillout.IT',0
File71:	dc.b	'MODs:6thSense.IT',0
InstrFile:	dc.b	'Work:Entertainment/TuC/Private/TuComposer/TestFiles/Test.TCI',0
WAVFile:	dc.b	'MultiMedia:Samples/Music/'
WAVFileSmp:	ds.b	256
TuCName:	dc.b	'tucomposer.library',0

	ENDC
