********************************************
***      TuComposer DeliPlayer v1.0      ***
***                1998 by              ***
***             Basty/Seasons            ***
***   This is the TuComposer DeliPlayer  ***
***    allowing the famous DeliTracker   ***
***  to playback the TuComposer modules  ***
********************************************

	IFND	_G2
	MACHINE	MC68020
	ENDC

	include	"misc/DeliPlayer.i"
	include	"exec/types.i"
	include	"exec/libraries.i"
	include	"exec/exec_lib.i"
	include	"libraries/dos_lib.i"
	include	"libraries/dos.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/module.i"
	include	"tucomposer/song.i"
	include	"tucomposer/position.i"
	include	"tucomposer/player.i"
	include	"tucomposer/external.i"
	include	"libraries/ini_lib.i"

	SECTION Player,Code

	PLAYERHEADER PlayerTagArray

	dc.b '$VER: TuComposer 1.0 player module V1.0 (06 Apr 98)',0
	even


PlayerTagArray
	dc.l	DTP_RequestDTVersion,16
	dc.l	DTP_PlayerVersion,01<<16+0
	dc.l	DTP_PlayerName,PName
	dc.l	DTP_Creator,CName
	dc.l	DTP_DeliBase,DeliBase
	dc.l	DTP_Check1,Chk
	dc.l	DTP_CheckLen,ChkLen
	dc.l	DTP_Flags,PLYF_SONGEND|PLYF_ANYMEM
	dc.l	DTP_StartInt,PlayInt
	dc.l	DTP_StopInt,StopInt
	dc.l	DTP_InitPlayer,InitPlay
	dc.l	DTP_EndPlayer,EndPlay
	dc.l	DTP_InitSound,InitSnd
	dc.l	DTP_Volume,SetVol
	dc.l	DTP_Balance,SetVol
	dc.l	DTP_Faster,FasterSpeed
	dc.l	DTP_Slower,SlowerSpeed
	dc.l	DTP_NextPatt,NextPattern
	dc.l	DTP_PrevPatt,PrevPattern
	dc.l	DTP_ModuleName,ModNamePtr
	dc.l	DTP_NewSubSongRange,SubSong
	dc.l	DTP_Config,Config
;	dc.l	DTP_UserConfig,UserConfig
	dc.l	TAG_DONE

PName	dc.b 'TuComposer',0
CName	dc.b ' 1998 by Basty/Seasons.',10
	dc.b	'Player uses the tucomposer.library',10,'to playback the TCM modules.',10
	even

Chk
	move.l	dtg_ChkData(a5),a0
	moveq	#-1,d0
	cmp.l	#"FORM",(a0)
	bne.s	ChkEnd
	cmp.l	#"TCM1",8(a0)
	bne.s	ChkEnd
	moveq	#0,d0
ChkEnd
	rts
ChkLen = *-Chk
UserConfig:	
	rts
Config:	movem.l	d2-d5/a6,-(sp)
	move.l	dtg_DOSBase(a5),a6
	move.l	#ConfigFile,d1
	move.l	#ConfigDir,d2
	moveq	#64,d3
	lsl.l	#2,d3
	moveq	#0,d4
	jsr	_LVOGetVar(a6)
	tst.l	d0
	bne.s	NotGetVar
	lea	ConfigDir(pc),a0
	move.l	#"PROG",(a0)+
	move.l	#"DIR:",(a0)+
	move.l	#"Deli",(a0)+
	move.l	#"Conf",(a0)+
	move.l	#"ig"<<16,(a0)+
NotGetVar:	moveq	#31,d0
	lea	ININame(pc),a1
	move.l	4.w,a6
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,INIBase
	beq.s	ConfigErr
	move.l	#ConfigDir,d1
	moveq	#ACCESS_READ,d2
	move.l	dtg_DOSBase(a5),a6
	jsr	_LVOLock(a6)
	move.l	d0,d4
	beq.s	ConfigErr2
	move.l	d4,d1
	jsr	_LVOCurrentDir(a6)
	move.l	d0,d5
	beq.s	ConfigErr3
	lea	DefaultConfig(pc),a0
	lea	File(pc),a1
	move.l	#DefaultConfigLen-DefaultConfig,d0
	move.l	INIBase(pc),a6
	jsr	_LVOiniOpenDefault(a6)
	tst.l	d0
	beq.s	ConfigErr4
	move.l	d0,a0
	jsr	_LVOiniClose(a6)
	move.l	INIBase(pc),a1
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
	moveq	#0,d0
	movem.l	(sp)+,d2-d5/a6
	rts
ConfigErr4:	move.l	d5,d1
	move.l	dtg_DOSBase(a5),a6
	jsr	_LVOCurrentDir(a6)
ConfigErr3:	move.l	d4,d1
	jsr	_LVOUnLock(a6)
ConfigErr2:	move.l	INIBase(pc),a1
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
ConfigErr:	moveq	#-1,d0
	movem.l	(sp)+,d2-d5/a6
	rts
InitPlay:	movem.l	d2-d7/a2-a3/a6,-(sp)
	moveq	#31,d0
	lea	ININame(pc),a1
	move.l	4.w,a6
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,INIBase
	beq	EndPlay1
	moveq	#31,d0
	lea	TuCName(pc),a1
	move.l	4.w,a6
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,TuCBase
	beq	EndPlay2
	move.l	#ConfigDir,d1
	moveq	#ACCESS_READ,d2
	move.l	dtg_DOSBase(a5),a6
	jsr	_LVOLock(a6)
	move.l	d0,d4
	beq	EndPlay21
	move.l	d4,d1
	jsr	_LVOCurrentDir(a6)
	move.l	d0,PrevDirLock
	beq	EndPlay22
	lea	DefaultConfig(pc),a0
	lea	File(pc),a1
	move.l	#DefaultConfigLen-DefaultConfig,d0
	move.l	INIBase(pc),a6
	jsr	_LVOiniOpenDefault(a6)
	move.l	d0,INIFile

	move.l	d0,a0
	lea	GlobalContext(pc),a1
	lea	UsePlaybackDeviceItem(pc),a2
	lea	PaulaName(pc),a3
	moveq	#0,d0
	jsr	_LVOiniReadStr(a6)
	move.l	d0,DeviceName

	move.l	INIFile(pc),a0
	lea	GlobalContext(pc),a1
	lea	UseMixerDeviceItem(pc),a2
	lea	LQName(pc),a3
	moveq	#0,d0
	jsr	_LVOiniReadStr(a6)
	move.l	d0,MixerName

	move.l	#14433,d0
	move.l	INIFile(pc),a0
	move.l	MixerName(pc),a1
	lea	MixRateItem(pc),a2
	jsr	_LVOiniReadLong(a6)
	move.l	d0,ConfigBuf

	move.l	#256,d0
	move.l	INIFile(pc),a0
	move.l	MixerName(pc),a1
	lea	BufSizeItem(pc),a2
	jsr	_LVOiniReadLong(a6)
	move.l	d0,BufSize

	move.l	#65536,d0
	move.l	INIFile(pc),a0
	move.l	MixerName(pc),a1
	lea	VolumeBoostItem(pc),a2
	jsr	_LVOiniReadFloat(a6)
	move.l	d0,VolBoost
	
	moveq	#0,d0
	move.l	INIFile(pc),a0
	move.l	MixerName(pc),a1
	lea	True16BitMixingItem(pc),a2
	jsr	_LVOiniReadLong(a6)
	move.l	d0,True16Bit

	moveq	#-1,d0
	move.l	INIFile(pc),a0
	move.l	MixerName(pc),a1
	lea	StereoItem(pc),a2
	jsr	_LVOiniReadLong(a6)
	move.l	d0,Mono

	moveq	#0,d0
	move.l	INIFile(pc),a0
	move.l	MixerName(pc),a1
	lea	InterpolationItem(pc),a2
	jsr	_LVOiniReadLong(a6)
	addq.l	#1,d0
	move.l	d0,Interpolation

	moveq	#0,d0
	move.l	INIFile(pc),a0
	move.l	DeviceName(pc),a1
	lea	ReverseStereoItem(pc),a2
	jsr	_LVOiniReadLong(a6)
	move.l	d0,DevFlagPass

	moveq	#0,d0
	move.l	INIFile(pc),a0
	move.l	DeviceName(pc),a1
	lea	LowpassFilterItem(pc),a2
	jsr	_LVOiniReadLong(a6)
	move.l	d0,DevFlagPass+4

	moveq	#4,d0
	move.l	INIFile(pc),a0
	move.l	DeviceName(pc),a1
	lea	OutputModeItem(pc),a2
	jsr	_LVOiniReadLong(a6)
	move.l	d0,DevFlagPass+8

	moveq	#2,d0
	move.l	INIFile(pc),a0
	move.l	DeviceName(pc),a1
	lea	OutputBitModeItem(pc),a2
	jsr	_LVOiniReadLong(a6)
	lsr.l	#3,d0
	move.l	d0,DevFlagPass+4

	moveq	#2,d0
	move.l	INIFile(pc),a0
	move.l	DeviceName(pc),a1
	lea	OverloadActionItem(pc),a2
	jsr	_LVOiniReadLong(a6)
	move.l	d0,DevFlagPass+12

	moveq	#0,d0
	move.l	INIFile(pc),a0
	move.l	DeviceName(pc),a1
	lea	AHIEchoDSPItem(pc),a2
	jsr	_LVOiniReadLong(a6)
	move.l	d0,DevFlagPass+16

	moveq	#100,d0
	move.l	INIFile(pc),a0
	move.l	DeviceName(pc),a1
	lea	EchoStrengthItem(pc),a2
	jsr	_LVOiniReadLong(a6)
	move.l	d0,DevFlagPass+20

	moveq	#2,d0
	move.l	INIFile(pc),a0
	move.l	DeviceName(pc),a1
	lea	EchoDelayItem(pc),a2
	jsr	_LVOiniReadLong(a6)
	move.l	d0,DevFlagPass+24

	moveq	#88,d0
	move.l	INIFile(pc),a0
	move.l	DeviceName(pc),a1
	lea	EchoFeedbackItem(pc),a2
	jsr	_LVOiniReadLong(a6)
	move.l	d0,DevFlagPass+28

	moveq	#50,d0
	move.l	INIFile(pc),a0
	move.l	DeviceName(pc),a1
	lea	EchoCrossItem(pc),a2
	jsr	_LVOiniReadLong(a6)
	move.l	d0,DevFlagPass+32

	move.l	INIFile(pc),a0
	jsr	_LVOiniClose(a6)

	move.l	DeviceName(pc),a1
	moveq	#31,d0
	move.l	4.w,a6
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,PlayDevice
	beq	EndPlay3

	move.l	MixerName(pc),a1
	moveq	#31,d0
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,PlayMixer
	beq	EndPlay4
	move.l	d0,a1
	move.l	ConfigBuf(pc),mix_MixRate(a1)

	move.l	DeviceName(pc),a0
	jsr	_LVOiniFreeNameStr(a6)
	move.l	MixerName(pc),a0
	jsr	_LVOiniFreeNameStr(a6)

	move.l	dtg_PathArrayPtr(a5),d1
	move.l	dtg_SongEnd(a5),SongEnd
	move.l	#1005,d2
	moveq	#0,d3
	move.l	TuCBase(pc),a6
	jsr	_LVOCOpen(a6)
	move.l	d0,d7
	beq	EndPlay5
	move.l	d7,a0
	jsr	_LVOIdentifyTCModule(a6)
	move.l	d0,d6
	lea	FlagPass(pc),a3
	move.l	a3,a1
	move.l	d6,a2
	move.l	extl_LoadFlagStr(a2),a0
	move.w	(a0),d0
FillFlagPass:	move.l	tefs_Flag0Default(a0),(a1)+
	lea	tefs_FlagxText-tefs_Flag0Text(a0),a0
	subq.w	#1,d0
	bne.s	FillFlagPass
	move.l	d7,a0
	sub.l	a1,a1
	moveq	#0,d0
	jsr	_LVOLoadTCModule(a6)
	move.l	d0,d5
	move.l	d7,d1
	jsr	_LVOCClose(a6)
	tst.l	d5
	beq	EndPlay5
	move.l	d5,a0
	jsr	_LVOAddTCModule(a6)
	lea	SongEndHandler(pc),a0
	jsr	_LVOAddPlayExecHandler(a6)
	move.l	d5,a0
	moveq	#-2,d0
	lea	tcm_SongList(a0),a1
GetNumSubSongs:	addq.l	#1,d0
	move.l	(a1),a1
	tst.l	(a1)
	bne.s	GetNumSubSongs
	move.l	tcm_SongList(a0),a1
	move.w	d0,SubSong+4
	addq.l	#1,d0
	beq	EndPlay6
	move.l	tcso_Name(a1),d0
	bne.s	SetNewSongName
	move.l	tcm_Name(a0),d0
SetNewSongName:	move.l	d0,ModNamePtr
	move.l	a1,tcb_PlaySong(a6)
	move.l	d5,tcb_PlayModule(a6)
	move.l	PlayDevice(pc),a0
	move.l	a0,tcb_PlaySoundDeviceBase(a6)
	move.l	extb_ExtLibList(a0),a0
	jsr	_LVOAllocSoundDevice(a6)
	move.l	PlayMixer(pc),a0
	move.l	a0,tcb_PlayMixerLibBase(a6)
	move.l	extb_ExtLibList(a0),a0
	jsr	_LVOAllocMixer(a6)
	move.l	PlayMixer(pc),a0
	move.l	#50*655360,mix_Tempo(a0)
	move.l	d5,a1
	move.l	ConfigBuf+8(pc),d0
	move.w  #65536*125/1000,d1
	mulu.w  tcm_Channels(a1),d1
	add.l   #65536*75/100,d1
	mulu.l	d1,d1:d0
	move.w	d1,d0
	swap	d0
	move.l  d0,mix_VolumeBoost(a0)
	move.w	tcm_Channels(a1),mix_MaxChannels(a0)
	lea	MixFlagPass(pc),a1
	move.l	a1,a2
	move.l	ConfigBuf+12(pc),(a1)+
	move.l	ConfigBuf+16(pc),(a1)
	move.l	PlayDevice(pc),a1
	move.l	ConfigBuf+4(pc),mix_MixBufSize(a0)
	move.w	dtg_SndLBal(a5),d0
	mulu	dtg_SndVol(a5),d0
	lsr.w	#4,d0
	move.w	d0,mix_LeftVolume(a0)
	move.w	dtg_SndRBal(a5),d0
	mulu	dtg_SndVol(a5),d0
	lsr.w	#4,d0
	move.w	d0,mix_RightVolume(a0)
	move.l	a0,tcb_PlayMixerLibBase(a6)
	move.l	extb_ExtLibList(a0),a0
	jsr	_LVOInitMixer(a6)
	movem.l	(sp)+,d2-d7/a2-a3/a6
	tst.l	d0
	bne.s	EndPlay
	rts
EndPlay:	movem.l	d2-d7/a2-a3/a6,-(sp)
	move.l	TuCBase(pc),a6
	move.l	tcb_PlayModule(a6),d5
	clr.l	tcb_PlayModule(a6)
	clr.l	tcb_PlaySong(a6)
	move.l	tcb_PlaySoundDeviceBase(a6),d0
	beq.s	NoStopPlayDev
	move.l	d0,a0
	move.l	extb_ExtLibList(a0),a0
	jsr	_LVOStopSoundDevice(a6)
	move.l	tcb_PlaySoundDeviceBase(a6),a0
	clr.l	tcb_PlaySoundDeviceBase(a6)
	move.l	extb_ExtLibList(a0),a0
	jsr	_LVOFreeSoundDevice(a6)
NoStopPlayDev:	lea	SongEndHandler(pc),a0
	jsr	_LVORemPlayExecHandler(a6)
	move.l	tcb_PlayMixerLibBase(a6),d0
	beq.s	EndPlay6
	move.l	d0,a0
	clr.l	tcb_PlayMixerLibBase(a6)
	move.l	extb_ExtLibList(a0),a0
	jsr	_LVOFreeMixer(a6)
EndPlay6:	move.l	d5,a0
	jsr	_LVOFreeTCModule(a6)
EndPlay5:	move.l	PlayMixer(pc),a1
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
EndPlay4:	move.l	PlayDevice(pc),a1
	jsr	_LVOCloseLibrary(a6)
EndPlay3:	move.l	PrevDirLock(pc),d1
	move.l	dtg_DOSBase(a5),a6
	jsr	_LVOCurrentDir(a6)
EndPlay22:	move.l	d4,d1
	jsr	_LVOUnLock(a6)
EndPlay21:	move.l	TuCBase(pc),a1
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
EndPlay2:	move.l	INIBase(pc),a1
	jsr	_LVOCloseLibrary(a6)
EndPlay1:	movem.l	(sp)+,d2-d7/a2-a3/a6
	moveq	#-1,d0
	rts
InitSnd:	movem.l	d5/a2-a3/a6,-(sp)
	move.l	TuCBase(pc),a6
	move.l	tcb_PlayModule(a6),d5
	move.l	d5,a0
	move.w	dtg_SndNum(a5),d0
	lea	tcm_SongList(a0),a1
GetSongPlayNum:	move.l	(a1),a1
	dbra	d0,GetSongPlayNum
	move.l	a1,tcb_PlaySong(a6)
	move.l	tcso_Name(a1),d0
	bne.s	SetSongName
	move.l	tcm_Name(a0),d0
SetSongName:	move.l	d0,ModNamePtr
	move.l	tcso_GlobalData(a1),a0
	moveq	#1,d0
	swap	d0
	move.l	d0,pg_RelativePitch(a0)
	move.l	d0,pg_RelativeSpeed(a0)
	move.l	a1,a0
	jsr	_LVOCalcPlayerSpeed(a6)
	move.l	PlayMixer(pc),a0
	move.l	d0,mix_Tempo(a0)
	move.l	d5,a1
	move.l	ConfigBuf+8(pc),d0
	move.w  #65536*125/1000,d1
	mulu.w  tcm_Channels(a1),d1
	add.l   #65536*75/100,d1
	mulu.l	d1,d1:d0
	move.w	d1,d0
	swap	d0
	move.l  d0,mix_VolumeBoost(a0)
	move.w	tcm_Channels(a1),mix_MaxChannels(a0)
	lea	MixFlagPass(pc),a1
	move.l	a1,a2
	move.l	ConfigBuf+12(pc),(a1)+
	move.l	ConfigBuf+16(pc),(a1)
	move.l	PlayDevice(pc),a1
	move.l	ConfigBuf+4(pc),mix_MixBufSize(a0)
	move.l	ConfigBuf(pc),mix_MixRate(a0)
	move.w	dtg_SndLBal(a5),d0
	mulu.w	dtg_SndVol(a5),d0
	lsr.w	#4,d0
	move.w	d0,mix_LeftVolume(a0)
	move.w	dtg_SndRBal(a5),d0
	mulu.w	dtg_SndVol(a5),d0
	lsr.w	#4,d0
	move.w	d0,mix_RightVolume(a0)
	move.l	a0,tcb_PlayMixerLibBase(a6)
	move.l	extb_ExtLibList(a0),a0
	jsr	_LVOInitMixer(a6)
	move.l	tcb_PlaySong(a6),a0
	jsr	_LVOResetSong(a6)
	moveq	#0,d0
	movem.l	(sp)+,d5/a2-a3/a6
	rts
PlayInt:	move.l	a6,-(sp)
	lea	DevFlagPass(pc),a0
	move.l	TuCBase(pc),a6
	jsr	_LVOPlayTCModule(a6)
	move.l	(sp)+,a6
	rts
StopInt:	move.l	a6,-(sp)
	move.l	TuCBase(pc),a6
	jsr	_LVOStopTCModule(a6)
	move.l	(sp)+,a6
	rts
SetVol:	movem.l	d2-d3/a6,-(sp)
	move.l	TuCBase(pc),a6
	move.l	tcb_PlayMixerLibBase(a6),a0
	move.w	dtg_SndLBal(a5),d0
	mulu	dtg_SndVol(a5),d0
	lsr.w	#4,d0
	moveq	#0,d1
	move.w	d0,d1
	move.w	dtg_SndRBal(a5),d0
	mulu	dtg_SndVol(a5),d0
	lsr.w	#4,d0
	moveq	#0,d2
	move.w	d0,d2
	move.l	mix_VolumeBoost(a0),d0
	moveq	#0,d3
	move.w	mix_MaxChannels(a0),d3
	move.l	extb_ExtLibList(a0),a0
	jsr	_LVOChangeMixerVolTable(a6)
SetVolDone:	movem.l	(sp)+,d2-d3/a6
	rts
FasterSpeed:	move.l	a6,-(sp)
	move.l	TuCBase(pc),a6
	move.l	tcb_PlaySong(a6),a1
	move.l	tcso_GlobalData(a1),a1
	moveq	#64,d1
	lsl.l	#3,d1
	add.l	d1,pg_RelativePitch(a1)
	add.l	d1,pg_RelativeSpeed(a1)
	move.l	pg_Tempo(a1),d0
	mulu.l	pg_RelativeSpeed(a1),d1:d0
	move.w	d1,d0
	swap	d0
	move.l	tcb_PlayMixerLibBase(a6),a0
	move.l	extb_ExtLibList(a0),a0
	jsr	_LVOChangeMixerTempo(a6)
	move.l	(sp)+,a6
	rts
SlowerSpeed:	move.l	a6,-(sp)
	move.l	TuCBase(pc),a6
	move.l	tcb_PlaySong(a6),a1
	move.l	tcso_GlobalData(a1),a1
	moveq	#64,d1
	lsl.l	#3,d1
	cmp.l	pg_RelativePitch(a1),d1
	bhs.s	NotChgRelPitch
	sub.l	d1,pg_RelativePitch(a1)
NotChgRelPitch:	cmp.l	pg_RelativeSpeed(a1),d1
	bhs.s	NotChgRelSpeed
	sub.l	d1,pg_RelativeSpeed(a1)
NotChgRelSpeed:	move.l	pg_Tempo(a1),d0
	mulu.l	pg_RelativeSpeed(a1),d1:d0
	move.w	d1,d0
	swap	d0
	move.l	tcb_PlayMixerLibBase(a6),a0
	move.l	extb_ExtLibList(a0),a0
	jsr	_LVOChangeMixerTempo(a6)
	move.l	(sp)+,a6
	rts
NextPattern:	movem.l	d2-d3/a2/a6,-(sp)
	move.l	4.w,a6
	jsr	_LVODisable(a6)
	move.l	TuCBase(pc),a6
	move.l	tcb_PlaySong(a6),a0
	move.w	tcso_Channels(a0),d0
	move.l	tcso_ChannelData(a0),a1
NextPattChannelData:	move.l	(a1),a0
	move.w	tcol_NextRow(a0),phc_BreakRow(a1)
	move.l	tcol_NextPos(a0),a0
	cmp.b	#-1,phc_TempoCounter(a1)
	bne.s	NotAlreadyNP
	move.l	(a0),a0
NotAlreadyNP:	move.l	MLN_PRED(a0),(a1)
	bclr	#PHCB_PattLoop-16,phc_Flags+1(a1)
	bset	#PHCB_PatternBreak,phc_Flags+3(a1)
	st	phc_TempoCounter(a1)
	lea	phc_NextHostChannel(a1),a1
	subq.w	#1,d0
	bne.s	NextPattChannelData
	move.l	tcb_PlayModule(a6),a2
	moveq	#0,d2
	move.w	tcm_Channels(a2),d3
	move.l	tcm_ChannelData(a2),a2
	move.l	tcb_PlayMixerLibBase(a6),a6
ClrChDataLoop2:	clr.b	ms_Flags(a2)
	move.l	d2,d0
	move.l	a2,a0
	jsr	_LVOExternalMixerSetChannelPosRepFlags(a6)
	addq.l	#1,d2
	lea	pc_PlayerChannelx(a2),a2
	subq.w	#1,d3
	bne.s	ClrChDataLoop2
	move.l	4.w,a6
	jsr	_LVOEnable(a6)
	movem.l	(sp)+,d2-d3/a2/a6
	rts
PrevPattern:	movem.l	d2-d3/a2/a6,-(sp)
	move.l	4.w,a6
	jsr	_LVODisable(a6)
	move.l	TuCBase(pc),a6
	move.l	tcb_PlaySong(a6),a0
	move.w	tcso_Channels(a0),d0
	moveq	#-1,d1
	move.l	tcso_ChannelData(a0),a1
PrevPattChannelData:	move.l	(a1),a0
	tst.w	tcol_Played(a0)
	beq.s	NotDecreasePlayCount
	subq.w	#1,tcol_Played(a0)
NotDecreasePlayCount:	move.w	tcol_PrevRow(a0),phc_BreakRow(a1)
	move.l	tcol_PrevPos(a0),a0
	cmp.b	#-1,phc_TempoCounter(a1)
	bne.s	NotAlreadyPP
	move.l	(a0),a0
NotAlreadyPP:	move.l	MLN_PRED(a0),(a1)
	tst.w	tcol_Played(a0)
	beq.s	NotDecreasePlayCount2
	subq.w	#1,tcol_Played(a0)
NotDecreasePlayCount2:	bclr	#PHCB_PattLoop-16,phc_Flags+1(a1)
	bset	#PHCB_PatternBreak,phc_Flags+3(a1)
	st	phc_TempoCounter(a1)
	lea	phc_NextHostChannel(a1),a1
	subq.w	#1,d0
	bne.s	PrevPattChannelData
	move.l	tcb_PlayModule(a6),a2
	moveq	#0,d2
	move.w	tcm_Channels(a2),d3
	move.l	tcm_ChannelData(a2),a2
	move.l	tcb_PlayMixerLibBase(a6),a6
ClrChDataLoop3:	clr.b	ms_Flags(a2)
	move.l	d2,d0
	move.l	a2,a0
	jsr	_LVOExternalMixerSetChannelPosRepFlags(a6)
	addq.l	#1,d2
	lea	pc_PlayerChannelx(a2),a2
	subq.w	#1,d3
	bne.s	ClrChDataLoop3
	move.l	4.w,a6
	jsr	_LVOEnable(a6)
	movem.l	(sp)+,d2-d3/a2/a6
	rts
SignalDeli:	move.l	4(sp),a0
	jmp	(a0)
SongEndHandler:	ds.l	2
	dc.b	PEHF_SongEnd
	dc.b	0
	dc.l	SignalDeli
	dc.b	-1
	dc.b	0
SongEnd:	dc.l	0
	ds.b	10
DeliBase:	dc.l	0
TuCBase:	dc.l	0
INIBase:	dc.l	0
INIFile:	dc.l	0
PrevDirLock:	dc.l	0
DeviceName:	dc.l	0
MixerName:	dc.l	0
PlayDevice:	dc.l	0
PlayMixer:	dc.l	0
ModNamePtr:	dc.l	0
MixFlagPass:	dc.l	0,-1,1
FlagPass:	ds.l	64
SubSong:	dc.w	0,0,0
ConfigDir:	ds.b	256
ConfigBuf:	dc.l	14433
BufSize:	dc.l	256
VolBoost:	dc.l	65536
True16Bit:	dc.l	0
Mono:	dc.l	0
Interpolation:	dc.l	0
DevFlagPass:	dc.l	0,0,4,2
	dc.l	0
	dc.l	100
	dc.l	2
	dc.l	88
	dc.l	50
	ds.l	2
PaulaName:	dc.b	'internal_paula.library',0
LQName:	dc.b	'internal_lqmix.library',0
TuCName:	dc.b	'tucomposer.library',0
ININame:	dc.b	'ini.library',0
File:	dc.b	'TuComposer.prefs',0
ConfigFile:	dc.b	'DeliConfig',0
GlobalContext:	dc.b	'Global',0
UsePlaybackDeviceItem:	dc.b	'UsePlaybackDevice',0
UseMixerDeviceItem:	dc.b	'UseMixerDevice',0
MixRateItem:	dc.b	'MixRate',0
BufSizeItem:	dc.b	'BufSize',0
VolumeBoostItem:	dc.b	'VolumeBoost',0
StereoItem:	dc.b	'Stereo',0
True16BitMixingItem:	dc.b	'True16BitMixing',0
InterpolationItem:	dc.b	'Interpolation',0
ReverseStereoItem:	dc.b	'ReverseStereo',0
LowpassFilterItem:	dc.b	'LowpassFilter',0
OutputModeItem:	dc.b	'OutputMode',0
OutputBitModeItem:	dc.b	'OutputBitMode',0
OverloadActionItem:	dc.b	'OverloadAction',0
AHIEchoDSPItem:	dc.b	'AHIEchoDSP',0
EchoStrengthItem:	dc.b	'EchoStrength',0
EchoDelayItem:	dc.b	'EchoDelay',0
EchoFeedbackItem:	dc.b	'EchoFeedback',0
EchoCrossItem:	dc.b	'EchoCross',0
DefaultConfig:	dc.b	'* TuComposer DeliPlayer configuration file  1999 Basty/Seasons.',10
	dc.b	10
	dc.b	'/* This is the configuration file for the TuComposer DeliPlayer.',10
	dc.b	'   Feel free to experiment with the values. Please note that the',10
	dc.b	'   DeliPlayer requires both the tucomposer.library and the ini.library,',10
	dc.b	"   so don't forget to copy them to your LIBS: directory ! */",10
	dc.b	10
	dc.b	'[Global]                                       ; Global config entries',10
	dc.b	10
	dc.b	'UsePlaybackDevice = internal_paula.library     ; Default playback device',10
	dc.b	10
	dc.b	'/* Playback devices:',10
	dc.b	'   internal_paula.library: Standard Amiga Paula output',10
	dc.b	'   ahidevice.library: Use AHI for output (ahi.device required !',10
	dc.b	'   diskwriter.library: Output music as PCM wave data to disk */',10
	dc.b	10
	dc.b	'UseMixerDevice = internal_lqmix.library        ; Default sound mixer to use',10
	dc.b	10
	dc.b	'/* Mixer devices:',10
	dc.b	'   internal_lqmix.library: Internal Low Quality Mixer.',10
	dc.b	'   hqmix.library: High Quality Mixer (68040+ recommended for realtime !) */',10
	dc.b	10
	dc.b	'[internal_lqmix.library]   ; config for internal low quality mixer',10
	dc.b	10
	dc.b	'MixRate = 14433            ; Mixing frequency in Hz',10
	dc.b	'BufSize = 256              ; Mixing buffer size in longwords',10
	dc.b	'VolumeBoost = 1.0          ; Volume boost (1.0 is no boost)',10
	dc.b	'Stereo = On                ; Stereo mixing',10
	dc.b	'True16BitMixing = Off      ; True 16 bit mixing (is slower)',10
	dc.b	'Interpolation = 0          ; Interpolation, 0 = Off, 1 = Fast, 2 = Full',10
	dc.b	10
	dc.b	'[internal_paula.library]   ; config for internal paula device',10
	dc.b	10
	dc.b	'ReverseStereo = No         ; Reverse stereo channels',10
	dc.b	'LowpassFilter = Off        ; Amiga lowpass filter disabled',10
	dc.b	'OutputMode = 4             ; Output modes, 1 = Normal, 2 = Real surround,',10
	dc.b	'                           ;               3 = 14-bit (non-calibrated) and',10
	dc.b	'                           ;               4 = 14-bit (calibrated)',10
	dc.b	'OverloadAction = 2         ; Overload action, 1 = Stop immediately,',10
	dc.b	'                           ;                  2 = Fallback until 4kHz',10
	dc.b	'                           ;                  3 = None (careful with this!)',10
	dc.b	10
	dc.b	'[hqmix.library]            ; config for high quality mixer',10
	dc.b	10
	dc.b	'MixRate = 44100            ; Mixing frequency in Hz',10
	dc.b	'BufSize = 588              ; Mixing buffer size in longwords',10
	dc.b	'VolumeBoost = 1.0          ; Volume boost (1.0 is no boost)',10
	dc.b	'Stereo = On                ; Stereo mixing',10
	dc.b	'True16BitMixing = On       ; True 16 bit mixing (is slower)',10
	dc.b	10
	dc.b	'[ahidevice.library]        ; config for AHI device playback',10
	dc.b	10
	dc.b	'ReverseStereo = No         ; Reverse AHI stereo output',10
	dc.b	'OutputBitMode = 16         ; AHI Output bit mode, 8 or 16 bits',10
	dc.b	'AHIEchoDSP = Off           ; Enables the AHI echo DSP effects',10
	dc.b	'EchoStrength = 100         ; AHI echo strength in %',10
	dc.b	'EchoDelay = 2              ; AHI echo delay in ms',10
	dc.b	'EchoFeedback = 88          ; AHI echo feedback in %',10
	dc.b	'EchoCross = 50             ; AHI echo cross in %',10
DefaultConfigLen: