*************************************************************
***   TuComposer External Module Library for FC1.3/FC1.4  ***
***            1998 by The united Coders (TuC)           ***
***                 Main code: Basty/TuC                  ***
*** This is a FutureComposer module loader. It loads the  ***
***    FutureComposer 1.3/1.4 Modules into TuComposer.    ***
*************************************************************

	IFND	_G2
	MACHINE	MC68020
	OPT NODEBUG,NOLINE
	ENDC

	include	"exec/types.i"
	include	"exec/execbase.i"
	include	"exec/exec_lib.i"
	include	"exec/initializers.i"
	include	"exec/memory.i"
	include	"exec/resident.i"
	include	"exec/libraries.i"
	include	"libraries/dos.i"
	include	"libraries/dos_lib.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/module.i"
	include	"tucomposer/song.i"
	include	"tucomposer/position.i"
	include	"tucomposer/track.i"
	include	"tucomposer/instr.i"
	include	"tucomposer/sample.i"
	include	"tucomposer/synth.i"
	include	"tucomposer/external/external.i"
	include	"tucomposer/external/external_lib.i"
	include	"tucomposer/external/module.i"
	include	"tucomposer/external/module_lib.i"

	moveq	#-1,d0
	rts
ResidentStruct:	dc.w	RTC_MATCHWORD
	dc.l	ResidentStruct
	dc.l	0
	dc.b	RTF_AUTOINIT
	dc.b	EXTLIB_MODULE_VERSION
	dc.b	NT_LIBRARY
	dc.b	0
	dc.l	LibName
	dc.l	LibID
	dc.l	Init
LibName:	dc.b	'fc13-14.library',0
LibID:	dc.b	'TuComposer External Module Loader Version 1.00 (v31) for FutureComposer Modules (68020+, OS2.0+) (28 Jul 98) by Basty/TuC.',0
TuComposerName:	dc.b	'tucomposer.library',0
	even
Init:	dc.l	modl_SIZEOF
	dc.l	FuncTab
	dc.l	DataTab
	dc.l	PrepareLibrary

FuncTab:	dc.w	-1
	dc.w	Open-FuncTab
	dc.w	Close-FuncTab
	dc.w	Expunge-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalInitialize-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalModuleIdentify-FuncTab
	dc.w	ExternalModuleLoad-FuncTab
	dc.w	ExternalModuleSave-FuncTab
	dc.w	ExternalModuleGetInfo-FuncTab
	dc.w	ExternalModuleGetNums-FuncTab
	dc.w	-1

DataTab:	INITLONG	LN_NAME,LibName
	INITBYTE	LIB_FLAGS,LIBF_CHANGED|LIBF_SUMUSED
	INITWORD	LIB_VERSION,EXTLIB_MODULE_VERSION
	INITWORD	LIB_REVISION,EXTLIB_REVISION
	INITLONG	LIB_IDSTRING,LibID
	dc.l	0

PrepareLibrary:	btst	#AFB_68020,AttnFlags+1(a6)	
	beq.s	ExtLib
	cmp.w	#37,LIB_VERSION(a6)
	blt.s	ExtLib
	move.l	a2,-(sp)
	move.l	d0,a2
	move.l	a0,extb_SegList(a2)
	moveq	#31,d0
	lea	TuComposerName(pc),a1
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,extb_TuComposerBase(a2)
	beq.s	NoTuCLib
	lea	ExtModuleLibBase(pc),a0
	move.l	a2,(a0)
	move.l	a2,d0
NoTuCLib:	move.l	(sp)+,a2
	rts
Open:	addq.w	#1,LIB_OPENCNT(a6)
	move.l	a6,d0
	rts
Close:	subq.w	#1,LIB_OPENCNT(a6)
	bne.s	ExtLib
	btst	#LIBB_DELEXP,LIB_FLAGS(a6)
	bne.s	Expunge
ExtLib:	moveq	#0,d0
	rts
Expunge:	bset	#LIBB_DELEXP,LIB_FLAGS(a6)
	tst.w	LIB_OPENCNT(a6)
	bne.s	ExtLib
	movem.l	d2/a5-a6,-(sp)
	move.l	extb_ExtLibList(a6),d0
	beq.s	NoExtLibList
	move.l	d0,a0
	clr.l	extl_LibBase(a0)
NoExtLibList:	move.l	extb_TuComposerBase(a6),a1
	move.l	a6,a5
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
	move.l	extb_SegList(a5),d2
	move.l	a5,a1
	jsr	_LVORemove(a6)
	move.l	a5,a1
	moveq	#0,d0
	moveq	#0,d1
	move.w	LIB_NEGSIZE(a5),d1
	sub.l	d1,a1
	move.w	LIB_POSSIZE(a5),d0
	add.l	d1,d0
	jsr	_LVOFreeMem(a6)
	move.l	d2,d0
	movem.l	(sp)+,d2/a5-a6
	rts
;	INPUT
;	A0.L	=	APTR to module external list structure to be initialized
;	OUTPUT
;	D0.L	=	What type of external library is it or NULL if error
ExternalInitialize:	move.l	extb_TuComposerBase(a6),a1
	movem.l	a2/a6,-(sp)
	move.l	a0,d0
	beq.s	ExternalInitDone
	move.l	a1,a6
	move.b	#EXTLF_Loader|EXTLF_Saver,extl_Flags(a0)
	move.l	a0,a2
	lea	extl_Descriptor(a0),a0
	lea	LoadDescript(pc),a1
	jsr	_LVOSetString(a6)
	tst.l	d0
	beq.s	ExternalInitDone
	lea	LoadFlags(pc),a0
	jsr	_LVOAllocFlagStr(a6)
	move.l	d0,extl_LoadFlagStr(a2)
	beq.s	ExternalInitDone
	moveq	#EXTTYPE_MODULE,d0
ExternalInitDone:	movem.l	(sp)+,a2/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	If failed NULL else any non-zero value
ExternalModuleIdentify:	movem.l	d2-d3/a6,-(sp)
	move.l	a0,d1
	subq.l	#4,sp
	move.l	sp,d2
	moveq	#4,d3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalModuleIdDone
	cmp.l	#"SMOD",(sp)
	beq.s	ExternalModuleIdOk
	cmp.l	#"FC14",(sp)
	beq.s	ExternalModuleIdOk
ExternalModuleIdDone:	moveq	#0,d0
ExternalModuleIdOk:	addq.l	#4,sp
	movem.l	(sp)+,d2-d3/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be loaded
;	A1.L	=	APTR to target module structure or NULL to create new
;	A2.L	=	APTR to loading flag pass structure (Loader specific)
;	D0.L	=	Number of module to be loaded (NULL is the first)
;	OUTPUT
;	D0.L	=	APTR to module structure where loaded module data is
ExternalModuleLoad:	movem.l	d2-d7/a2-a6,-(sp)
	lea	-328(sp),sp
	moveq	#2-1,d0
	moveq	#0,d1
	moveq	#0,d7
CreateBitTable:	tst.l	(a2)+
	beq.s	BitNotSet
	bset	d1,d7
BitNotSet:	addq.b	#1,d1
	dbra	d0,CreateBitTable
	move.l	a0,d1
	moveq	#0,d2
	moveq	#OFFSET_END,d3
	move.l	d1,a2
	move.l	a1,a3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalLoadErr4
	move.l	a2,d1
	moveq	#0,d2
	moveq	#OFFSET_BEGINNING,d3
	jsr	_LVOCSeek(a6)
	move.l	d0,d3
	addq.l	#1,d0
	beq	ExternalLoadErr4
	add.l	#(256*16)+64+(90*16)-1,d0
	move.l	#MEMF_PUBLIC|MEMF_CLEAR,d1
	move.l	a6,a5
	move.l	4.w,a6
	jsr	_LVOAllocVec(a6)
	move.l	d0,d2
	beq	ExternalLoadErr4
	move.l	d0,(sp)
	move.l	a2,d1
	move.l	a5,a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadErr3
	move.l	(sp),a1
	lea	100(a1),a0
	cmp.l	#"SMOD",(a1)
	beq.s	IsFC13
	lea	180(a1),a0
IsFC13:	move.l	sp,a1
	addq.l	#4,a1
	move.l	a0,(a1)+
	move.l	(sp),a0
	add.l	8(a0),a0
	move.l	a0,(a1)+
	move.l	(sp),a0
	add.l	24(a0),a0
	move.l	a0,(a1)+
	move.l	(sp),a0
	add.l	16(a0),a0
	move.l	a0,(a1)+
	move.l	(sp),a0
	add.l	32(a0),a0
	move.l	a0,(a1)+
	move.l	(sp),a0
	add.l	36(a0),a0
	move.l	a0,(a1)
	move.l	(sp),a0
	add.l	d3,a0
	lea	316(sp),a1
	move.l	a0,(a1)+
	lea	256*16(a0),a0
	move.l	a0,(a1)+
	lea	64(a0),a0
	move.l	a0,(a1)
	move.l	(sp),a1
	lea	40(a1),a1
	addq.l	#4,a0
	moveq	#10-1,d0
InitSmpPointLoop:	move.w	(a1)+,(a0)+
	move.l	(a1)+,(a0)
	lea	14(a0),a0
	dbra	d0,InitSmpPointLoop
	move.l	(sp),d1
	cmp.l	#"SMOD",-100(a1)
	bne.s	InitFC14Smp
	add.l	32-100(a1),d1
	move.l	324(sp),a1
	move.l	d1,(a1)+
	moveq	#9-1,d0
	moveq	#0,d2
InitOldSynthLoop:	move.w	(a1),d2
	add.l	d2,d1
	add.l	d2,d1
	lea	12(a1),a1
	move.l	d1,(a1)+
	dbra	d0,InitOldSynthLoop
	move.l	324(sp),a0
	lea	10*16(a0),a0
	lea	WAVEFORMS(pc),a1
	move.l	a1,d2
	lea	SOUNDINFO(pc),a1
	moveq	#80-1,d1
CopySOUNDINFOLoop:	move.l	(a1)+,d0
	add.l	d2,d0
	move.l	d0,(a0)+
	move.w	(a1),(a0)+
	clr.w	(a0)+
	move.w	(a1)+,(a0)
	addq.l	#8,a0
	dbra	d1,CopySOUNDINFOLoop
	bra.s	InitSmpPointDone
InitFC14Smp:	add.l	32-100(a1),d1
	move.l	324(sp),a1
	move.l	d1,(a1)+
	moveq	#9-1,d0
	moveq	#0,d2
InitSmpPtrsLoop:	move.w	(a1),d2
	add.l	d2,d1
	add.l	d2,d1
	addq.l	#2,d1
	lea	12(a1),a1
	move.l	d1,(a1)+
	dbra	d0,InitSmpPtrsLoop
	move.l	324(sp),a0
	lea	10*16(a0),a0
	move.l	(sp),a1
	lea	100(a1),a1
	move.l	(sp),d0
	add.l	36-100(a1),d0
	moveq	#80-1,d1
	moveq	#0,d2
InitSynthPtrsLoop:	move.l	d0,(a0)+
	move.b	(a1)+,d2
	move.w	d2,(a0)+
	clr.w	(a0)+
	move.w	d2,(a0)
	addq.l	#8,a0
	add.l	d2,d0
	add.l	d2,d0
	dbra	d1,InitSynthPtrsLoop
InitSmpPointDone:	move.l	(a2),d1
	lea	28(sp),a0
	move.l	a0,d2
	move.l	tcb_DOSBase(a5),a6
	jsr	_LVOExamineFH(a6)
	moveq	#4,d0
	move.l	a5,a6
	jsr	_LVOAllocTCModule(a6)
	move.l	d0,d1
	beq	ExternalLoadErr3
	move.l	d0,a4
	lea	tcm_Name(a4),a0
	lea	28+fib_FileName(sp),a1
	jsr	_LVOSetString(a6)
	lea	tcm_BeginDate(a4),a0
	lea	28+fib_DateStamp(sp),a1
	jsr	_LVOStamp2Date(a6)
	lea	tcm_EndDate(a4),a0
	lea	28+fib_DateStamp(sp),a1
	jsr	_LVOStamp2Date(a6)
	moveq	#4,d0
	moveq	#1,d1
	moveq	#1,d2
	jsr	_LVOAllocSong(a6)
	move.l	d0,d1
	beq	ExternalLoadErr2
	move.l	d0,a1
	move.b	#TCSOCF_AmigaLimits,tcso_CompFlags(a1)
	move.l	#32<<16|255,tcso_BPMSpeedLowerLimit(a1)
	move.l	4(sp),a0
	move.b	12(a0),d0
	bne.s	SpeedOk
	moveq	#3,d0
SpeedOk:	move.b	d0,tcso_Frames+1(a1)
	move.l	a4,a0
	jsr	_LVOAddSong(a6)
	lea	([tcm_SongList.w,a4],tcso_Name.w),a0
	move.l	tcm_Name(a4),a1
	jsr	_LVOSetString(a6)
	move.l	tcm_SongList(a4),a1
	lea	([tcm_SongList.w,a4],tcso_BeginDate.w),a0
	lea	28+fib_DateStamp(sp),a1
	jsr	_LVOStamp2Date(a6)
	lea	([tcm_SongList.w,a4],tcso_EndDate.w),a0
	lea	28+fib_DateStamp(sp),a1
	jsr	_LVOStamp2Date(a6)
	moveq	#0,d6
	move.l	a2,308(sp)
ConvertPatternLoop:	moveq	#32,d0
	jsr	_LVOAllocTrack(a6)
	move.l	d0,d1
	beq	ExternalLoadErr2
	move.l	d0,a1
	move.l	a1,a2
	move.l	tcm_SongList(a4),a0
	jsr	_LVOAddTrack(a6)
	moveq	#32-1,d5
	move.l	8(sp),a0
	add.l	d6,a0
	move.l	tct_Data(a2),a2
ConvertPatternDataLoop:	move.l	a2,a1
	moveq	#$7f,d1
	move.b	(a0)+,d0
	and.l	d1,d0
	beq.s	NoteDone
	cmp.l	#"FC14",([sp])
	bne.s	NotCheckEndMark
	cmp.w	#32-1,d5
	beq.s	NotCheckEndMark
	cmp.b	#$49,d0
	bne.s	NotCheckEndMark
	moveq	#255-NOTE_END,d0
	not.b	d0
	move.w	d0,(a1)+
	bra.s	NoteDone
NotCheckEndMark:	cmp.w	#5*12+1,d0
	blo.s	NotCorrectNote
	sub.w	#6*12,d0
NotCorrectNote:	add.w	#(12*2)-1,d0
	divu.w	#12,d0
	move.b	d0,(a1)+
	swap	d0
	addq.b	#1,d0
	move.b	d0,(a1)+
NoteDone:	move.b	(a0)+,d0
	move.w	d0,d2
	tst.b	-2(a0)
	beq.s	NoNote
	and.w	#63,d0
	addq.w	#1,d0
	move.w	d0,(a1)
NoNote:	subq.l	#4,sp
	move.l	a0,-(sp)
	tst.b	d2
	bpl.s	NotPortaOn
	moveq	#FX_SYNTH_CTRL,d0
	moveq	#$001f,d1
	jsr	_LVOAllocEffect(a6)
	move.l	d0,d1
	beq	ExternalLoadError
	move.l	d0,a1
	lea	tctd_Effects(a2),a0
	move.l	4.w,a6
	jsr	_LVOAddTail(a6)
	move.l	a5,a6
	move.l	(sp),a0
	move.b	1(a0),d3
	moveq	#31,d0
	move.b	d3,d1
	and.l	d0,d1
	lsl.w	#4,d1
	btst	#5,d3
	beq.s	IsPortaUp
	neg.w	d1
IsPortaUp:	moveq	#FX_SET_SYN_VAL,d0
	jsr	_LVOAllocEffect(a6)
	move.l	d0,d1
	beq	ExternalLoadError
	move.l	d0,a1
	lea	tctd_Effects(a2),a0
	move.l	4.w,a6
	jsr	_LVOAddTail(a6)
	move.l	a5,a6
NotPortaOn:	btst	#6,d2
	beq.s	NotPortaOff
	tst.b	d2
	bmi.s	NotPortaOff
	moveq	#FX_SYNTH_CTRL,d0
	moveq	#$001f,d1
	jsr	_LVOAllocEffect(a6)
	move.l	d0,d1
	beq	ExternalLoadError
	move.l	d0,a1
	lea	tctd_Effects(a2),a0
	move.l	4.w,a6
	jsr	_LVOAddTail(a6)
	moveq	#FX_SET_SYN_VAL,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	d0,d1
	beq	ExternalLoadError
	move.l	d0,a1
	lea	tctd_Effects(a2),a0
	move.l	4.w,a6
	jsr	_LVOAddTail(a6)
	move.l	a5,a6
NotPortaOff:	move.l	(sp)+,a0
	addq.l	#4,sp
	lea	tctd_NextRow(a2),a2
	dbra	d5,ConvertPatternDataLoop
	moveq	#64,d0
	add.l	d0,d6
	move.l	(sp),a0
	cmp.l	12(a0),d6
	bne	ConvertPatternLoop
	moveq	#0,d4
	moveq	#0,d5
	move.l	(sp),a1
	move.l	4(a1),d6
	divu.w	#13,d6
	move.l	4(sp),a0
	move.l	308(sp),a2
SetPositions:	move.l	tcm_SongList(a4),a1
	move.l	tcso_Position(a1),a1
	move.l	d5,d0
	lsl.l	#5,d0
	add.l	d0,a1
	move.b	(PanningTable.w,pc,d5.w),tco_Panning(a1)
	movem.l	a0-a1,308(sp)
	jsr	_LVOAllocPositionList(a6)
	move.l	d0,a1
	beq	ExternalLoadErr2
	moveq	#0,d0
	move.l	312(sp),a0
	jsr	_LVOAddPositionList(a6)
	move.l	308(sp),a0
	moveq	#0,d0
	add.l	d4,a0
	move.b	(a0)+,d0
	move.b	(a0)+,d2
	move.b	(a0),d3
	ext.w	d3
	move.l	tcm_SongList(a4),a0
	addq.l	#1,d0
	jsr	_LVOGetTrackAddr(a6)
	movem.l	308(sp),a0-a1
	move.l	MLH_TAILPRED(a1),a1
	move.l	d0,tcol_Track(a1)
	move.b	d2,tcol_Transpose(a1)
	move.w	d3,tcol_InstrTranspose(a1)
	move.b	12(a0),tcol_Tempo+1(a1)
	move.l	MLN_PRED(a1),a0
	tst.l	MLN_PRED(a0)
	beq.s	NotSetPrevOrder
	move.l	a0,tcol_PrevPos(a1)
	move.l	a1,tcol_NextPos(a0)
NotSetPrevOrder:	move.l	308(sp),a0
	moveq	#13,d0
	add.l	d0,a0
	subq.w	#1,d6
	bne	SetPositions
	move.l	312(sp),a1
	move.l	MLH_TAILPRED(a1),a0
	move.l	(a1),a1
	move.l	a1,tcol_PrevPos(a1)
	move.l	a1,tcol_NextPos(a0)
	move.l	4(sp),a0
	addq.w	#3,d4
	addq.w	#1,d5
	move.l	(sp),a1
	move.l	4(a1),d6
	divu.w	#13,d6
	cmp.w	#12,d4
	bne	SetPositions
	move.l	(sp),a0
	move.l	28(a0),d6
	lsr.l	#6,d6
	move.l	12(sp),308(sp)
LoadInstrLoop:	moveq	#(256/4)-1,d0
	move.l	316(sp),a0
ClearReMapTableLoop:	clr.l	(a0)+
	dbra	d0,ClearReMapTableLoop
	moveq	#0,d0
	jsr	_LVOAllocInstr(a6)
	move.l	d0,d1
	beq	ExternalLoadErr2
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddInstr(a6)
	moveq	#0,d0
	sub.l	a0,a0
	jsr	_LVOAllocSample(a6)
	move.l	d0,d5
	beq	ExternalLoadErr2
	move.l	d0,a1
	move.l	#8287,tcs_Rate(a1)
	move.l	#1036,tcs_LowerRateLimit(a1)
	move.l	#31388,tcs_UpperRateLimit(a1)
	move.l	tcm_InstrList+MLH_TAILPRED(a4),a0
	jsr	_LVOAddSample(a6)
	moveq	#255-SynthCodeLen,d0
	not.b	d0
	moveq	#2,d1
	moveq	#32,d2
	jsr	_LVOAllocSynth(a6)
	move.l	d0,d4
	beq	ExternalLoadErr2
	move.l	d0,a1
	move.w	#(PitchSynthCode-VC)>>2,tcy_VolumePos(a1)
	move.w	#$1,tcy_PanningPos(a1)
	move.w	#(VibSynthCode-VC)>>2,tcy_SlidePos(a1)
	move.w	#(PortaSC-VC)>>2,tcy_SpecialPos(a1)
	move.w	#1<<5|1<<9|1<<10,tcy_VarKeepMask(a1)
	moveq	#59-1,d1
	move.l	308(sp),a0
	move.b	(a0),tcy_Variable3+1(a1)
	bne.s	NotZeroVol
	addq.b	#1,tcy_Variable3(a1)
NotZeroVol:	addq.l	#5,a0
	move.l	tcy_Waves(a1),a1
	move.l	tcyw_WaveData(a1),a1
CopyVolWaveLoop:	move.b	(a0)+,(a1)+
	dbra	d1,CopyVolWaveLoop
	move.b	#$e1,(a1)+
	move.l	#$e1e1e1e1,(a1)
	move.l	d0,a1
	move.w	#SynthCodeLen-1,d1
	lea	VC(pc),a0
	move.l	tcy_SynthCode(a1),a1
CopySynthCodeLoop:	move.l	(a0)+,(a1)+
	dbra	d1,CopySynthCodeLoop
	move.l	d5,a0
	move.l	d0,a1
	jsr	_LVOAssignSynth(a6)
	moveq	#8,d0
	moveq	#CWF_ChangeOnly,d1
	move.l	d4,a0
	move.l	tcy_Waves(a0),a0
	jsr	_LVOConvertWaveform(a6)
	moveq	#0,d0
	move.l	16(sp),a0
	move.l	308(sp),a1
	addq.l	#1,a1
	move.b	(a1)+,d0
	move.b	#1,([316.w,sp],d0.l)
	lsl.l	#6,d0
	add.l	d0,a0
	move.b	(a1)+,d1
	move.b	(a1)+,d2
	move.b	(a1)+,d3
	move.l	d4,a1
	move.b	d1,tcy_Variable6+1(a1)
	move.b	d2,tcy_Variable7+1(a1)
	move.b	d3,tcy_Variable8+1(a1)
	move.l	tcy_Waves+MLH_TAILPRED(a1),a1
	moveq	#(64/4)-1,d0
	move.l	a0,d2
	move.l	tcyw_WaveData(a1),a1
CopyPitchSeqLoop:	move.l	(a0)+,(a1)+
	dbra	d0,CopyPitchSeqLoop
	moveq	#8,d0
	moveq	#CWF_ChangeOnly,d1
	move.l	d4,a0
	move.l	tcy_Waves+MLH_TAILPRED(a0),a0
	jsr	_LVOConvertWaveform(a6)
	moveq	#1,d3
	move.l	d2,a0
FindNumPitchLoop:	addq.l	#1,d3
	moveq	#(64/4)-1,d1
	move.l	320(sp),a1
ClearDidItBuf:	clr.l	(a1)+
	dbra	d1,ClearDidItBuf
	moveq	#0,d1
	moveq	#0,d5
FindE7:	move.l	320(sp),a1
	not.b	(a1,d1.l)
	beq	FoundAllE7s
	addq.l	#1,d1
	and.w	#63,d1
	beq	FoundAllE7s
	move.b	-1(a0,d1.l),d2
	cmp.b	#$e0,d2
	bne.s	NotPitchE0
	move.b	(a0,d1.l),d1
	and.w	#$003f,d1
	bra.s	FindE7
NotPitchE0:	cmp.b	#$e1,d2
	beq	FoundAllE7s
	cmp.b	#$e2,d2
	bne.s	NotPitchE2
SkipOne:	addq.l	#1,d1
	bra.s	FindE7
NotPitchE2:	cmp.b	#$e4,d2
	beq.s	SkipOne
	cmp.b	#$e3,d2
	bne.s	NotPitchE3
SkipTwo:	addq.l	#2,d1
	bra.s	FindE7
NotPitchE3:	cmp.b	#$e8,d2
	beq.s	SkipOne
	cmp.b	#$e7,d2
	beq.s	FoundNewModSeq
	cmp.b	#$e9,d2
	beq.s	SkipTwo
	cmp.b	#$ea,d2
	beq.s	SkipTwo
	bra.s	FindE7
FoundNewModSeq:	moveq	#0,d0
	move.b	(a0,d1.l),d0
	move.l	316(sp),a1
	tst.b	(a1,d0.l)
	bne.s	FoundAllE7s
	move.b	d3,(a1,d0.l)
	move.l	d0,d5
	lsl.l	#6,d5
	add.l	16(sp),d5
	move.l	d4,a1
	move.l	tcy_Waves+MLH_TAILPRED(a1),a1
	move.l	tcyw_WaveData(a1),a1
	move.b	d3,(a1,d1.l)
	movem.l	d1/a0,-(sp)
	moveq	#32,d0
	jsr	_LVOAllocWaveform(a6)
	move.l	d0,d1
	beq	ExternalLoadError
	move.l	d4,a0
	move.l	d0,a1
	jsr	_LVOAddWaveform(a6)
	moveq	#8,d0
	moveq	#CWF_ChangeOnly,d1
	move.l	d4,a0
	move.l	tcy_Waves+MLH_TAILPRED(a0),a0
	jsr	_LVOConvertWaveform(a6)
	moveq	#(64/4)-1,d0
	move.l	d5,a0
	move.l	d4,a1
	move.l	tcy_Waves+MLH_TAILPRED(a1),a1
	move.l	tcyw_WaveData(a1),a1
CopyNewWaveDataLoop:	move.l	(a0)+,(a1)+
	dbra	d0,CopyNewWaveDataLoop
	movem.l	(sp)+,d1/a0
FoundAllE7s:	tst.l	d5
	beq.s	E7ScanDone
	move.l	d5,a0
	bra	FindNumPitchLoop
E7ScanDone:	btst	#0,d7
	beq	E2sDone
	move.w	#(256*(16/8))-1,d0
	moveq	#0,d1
	move.l	d3,d5
	subq.l	#2,d5
	move.l	316(sp),a0
ClearReMapTableLoop2:	move.l	d1,(a0)+
	move.l	d1,(a0)+
	dbra	d0,ClearReMapTableLoop2
	move.l	d4,a0
	move.l	tcy_Waves(a0),a0
ScanWaveLoop:	move.l	(a0),a0
	move.l	a0,312(sp)
	move.l	tcyw_WaveData(a0),a0
	moveq	#(64/4)-1,d1
	move.l	320(sp),a1
ClearDidItBuf2:	clr.l	(a1)+
	dbra	d1,ClearDidItBuf2
	moveq	#0,d1
FindE2:	move.l	320(sp),a1
	not.b	(a1,d1.l)
	beq	FoundAllE2s
	addq.l	#1,d1
	and.w	#63,d1
	beq	FoundAllE2s
	move.b	-1(a0,d1.l),d2
	cmp.b	#$e0,d2
	bne.s	NotE2PitchE0
	move.b	(a0,d1.l),d1
	and.w	#$003f,d1
	bra.s	FindE2
NotE2PitchE0:	cmp.b	#$e1,d2
	beq	FoundAllE2s
	cmp.b	#$e2,d2
	beq	FoundNewSmp
	cmp.b	#$e4,d2
	beq	FoundNewSmp
	cmp.b	#$e3,d2
	bne.s	NotE2PitchE3
SkipE2Two:	addq.l	#2,d1
	bra.s	FindE2
NotE2PitchE3:	cmp.b	#$e8,d2
	bne.s	NotE2PitchE8
	addq.l	#1,d1
	bra.s	FindE2
NotE2PitchE8:	cmp.b	#$e7,d2
	beq	FoundAllE2s
	cmp.b	#$e9,d2
	beq.s	FoundNewSmpPck
	cmp.b	#$ea,d2
	beq.s	SkipE2Two
	bra.s	FindE2
FoundNewSmpPck:	moveq	#0,d0
	move.b	(a0,d1.l),d0
	lsl.w	#4,d0
	moveq	#0,d2
	move.b	1(a0,d1.l),d2
	cmp.b	#$a,d2
	bhs	SmpNoExist
	add.w	d2,d0
	addq.l	#2,d1
	move.l	316(sp),a1
	tst.b	(a1,d0.l)
	beq.s	NotAlreadySmpPck
	move.b	(a1,d0.l),-1(a0,d1.l)
	bra	FindE2
NotAlreadySmpPck:	sub.w	d2,d0
	move.l	d0,d2
	add.l	324(sp),d2
	movem.l	d1/a0,-(sp)
	move.l	d2,a2
	move.l	(a2),a2
	cmp.l	#"SSMP",(a2)+
	bne	SmpNoExist
	moveq	#0,d2
	move.b	-1(a0,d1.l),d2
	add.w	d2,d0
	move.b	d3,(a1,d0.l)
	lea	320(a2),a0
	lsl.w	#4,d2
	add.l	d2,a2
	add.l	(a2),a0
	move.l	a0,d2
	move.w	4(a2),d0
	beq	SmpNoExist
	move.w	8(a0),d1
	move.l	d1,tcyw_RepLen(a1)
	subq.w	#1,d1
	bhi.s	LoopItOkPck
	addq.l	#2,d0
LoopItOkPck:	movem.l	(sp),d1/a0
	move.b	d3,-1(a0,d1.l)
	addq.l	#1,d3
	jsr	_LVOAllocWaveform(a6)
	move.l	d0,d1
	beq	ExternalLoadError
	move.l	d0,a1
	move.l	d4,a0
	jsr	_LVOAddWaveform(a6)
	moveq	#8,d0
	moveq	#CWF_ChangeOnly,d1
	move.l	d4,a0
	move.l	tcy_Waves+MLH_TAILPRED(a0),a0
	jsr	_LVOConvertWaveform(a6)
	move.l	d4,a1
	move.l	tcy_Waves+MLH_TAILPRED(a1),a1
	move.l	tcyw_Samples(a1),d0
	lsr.l	#1,d0
	move.w	6(a2),tcyw_Repeat+2(a1)
	moveq	#0,d1
	move.w	8(a2),d1
	add.l	d1,d1
	move.l	d1,tcyw_RepLen(a1)
	move.l	d2,a0
	subq.l	#2,d1
	bhi.s	LoopOkPck
	move.l	tcyw_Samples(a1),d2
	subq.l	#4,d2
	move.l	d2,tcyw_Repeat(a1)
	moveq	#4,d1
	move.l	d1,tcyw_RepLen(a1)
LoopOkPck:	move.l	tcyw_WaveData(a1),a1
	move.l	a1,d1
CopySmpPckDataLoop:	move.w	(a0)+,(a1)+
	subq.l	#1,d0
	bne.s	CopySmpPckDataLoop
	move.l	d1,a1
	movem.l	(sp)+,d1/a0
	bra	FindE2
FoundNewSmp:	moveq	#0,d0
	move.b	(a0,d1.l),d0
	lsl.w	#4,d0
	addq.l	#1,d1
	move.l	316(sp),a1
	tst.b	(a1,d0.l)
	beq.s	NotAlreadySmp
	move.b	(a1,d0.l),-1(a0,d1.l)
	bra	FindE2
NotAlreadySmp:	move.l	d0,d2
	add.l	324(sp),d2
	movem.l	d1/a0,-(sp)
	move.l	d2,a0
	move.w	4(a0),d1
	beq	SmpNoExist
	move.b	d3,(a1,d0.l)
	move.w	d1,d0
	move.w	8(a0),d1
	subq.w	#1,d1
	bhi.s	LoopItOk
	addq.l	#2,d0
LoopItOk:	movem.l	(sp),d1/a0
	move.b	d3,-1(a0,d1.l)
	addq.l	#1,d3
	jsr	_LVOAllocWaveform(a6)
	move.l	d0,d1
	beq	ExternalLoadError
	move.l	d0,a1
	move.l	d4,a0
	jsr	_LVOAddWaveform(a6)
	moveq	#8,d0
	moveq	#CWF_ChangeOnly,d1
	move.l	d4,a0
	move.l	tcy_Waves+MLH_TAILPRED(a0),a0
	jsr	_LVOConvertWaveform(a6)
	move.l	d4,a1
	move.l	tcy_Waves+MLH_TAILPRED(a1),a1
	move.l	d2,a0
	move.w	4(a0),d0
	move.w	6(a0),tcyw_Repeat+2(a1)
	moveq	#0,d1
	move.w	8(a0),d1
	add.l	d1,d1
	move.l	d1,tcyw_RepLen(a1)
	subq.l	#2,d1
	bhi.s	LoopOk
	move.l	tcyw_Samples(a1),d2
	subq.l	#4,d2
	move.l	d2,tcyw_Repeat(a1)
	moveq	#4,d1
	move.l	d1,tcyw_RepLen(a1)
LoopOk:	move.l	(a0),a0
	move.l	tcyw_WaveData(a1),a1
	move.l	a1,d1
CopySmpDataLoop:	move.w	(a0)+,(a1)+
	subq.w	#1,d0
	bne.s	CopySmpDataLoop
	move.l	d1,a1
	movem.l	(sp)+,d1/a0
	bra	FindE2
SmpNoExist:	movem.l	(sp)+,d1/a0
	move.w	#$e800,-2(a0,d1.l)
	bra	FindE2
FoundAllE2s:	move.l	312(sp),a0
	dbra	d5,ScanWaveLoop
E2sDone:	btst	#1,d7
	beq.s	NotCreateSTab
	lea	SymbolTable(pc),a2
CreateSymLoop:	move.w	(a2)+,d2
	beq.s	NotCreateSTab
	move.w	(a2)+,d0
	lea	(SymbolTable.w,pc,d0.w),a0
	jsr	_LVOAllocSymbol(a6)
	move.l	d0,d1
	beq.s	ExternalLoadErr2
	move.l	d4,a0
	move.l	d0,a1
	move.w	d2,tsst_SymbolValue(a1)
	move.b	#SYMBOL_LABEL,tsst_Type(a1)
	jsr	_LVOAddSymbol(a6)
	bra.s	CreateSymLoop
NotCreateSTab:	moveq	#64,d0
	add.l	d0,308(sp)
	subq.l	#1,d6
	bne	LoadInstrLoop
	move.l	tcm_SongList(a4),a0
	jsr	_LVOGetOptimalChannels(a6)
	move.l	tcm_SongList(a4),a0
	jsr	_LVOSetSongChannels(a6)
	move.l	a4,a0
	jsr	_LVOGetOptimalVChannels(a6)
	move.l	a4,a0
	jsr	_LVOSetTCMChannels(a6)
	move.l	a3,d0
	bne.s	ModAllocated
	move.l	a4,a3
ModAllocated:	move.l	a4,a0
	move.l	a3,a1
	jsr	_LVOReMapTCModule(a6)
	move.l	(sp),a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
ExternalLoadDone:	lea	328(sp),sp
	move.l	a3,d0
	movem.l	(sp)+,d2-d7/a2-a6
	rts
ExternalLoadError:	addq.l	#8,sp
ExternalLoadErr2:	move.l	a4,a0
	move.l	a5,a6
	jsr	_LVOFreeTCModule(a6)
ExternalLoadErr3:	move.l	(sp),a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
ExternalLoadErr4:	sub.l	a3,a3
	bra.s	ExternalLoadDone
ExternalModuleSave:	
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle from where to get the info
;	A1.L	=	APTR to module info structure where to put information
;	D0.L	=	Number of module to be scanned (NULL is the first)
;	OUTPUT
;	D0.L	=	Any non-zero value for success, NULL for error.
ExternalModuleGetInfo:	movem.l	d2-d6/a2-a4/a6,-(sp)
	movem.l	(sp)+,d2-d6/a2-a4/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	Number of modules found or NULL on any error
ExternalModuleGetNums:	moveq	#1,d0
	rts
VC:	dc.b	TCYINST_STOP,$00,$00,$00				* 0000:	STOP
VolLoop:	dc.b	TCYINST_LOAD,$52,$00,$00		* 0001:	LOAD	v5,v2
	dc.b	TCYINST_CMP,$02,$00,$40					* 0002:	CMP		0040,v2
	dc.b	TCYINST_JUMPLO,$00,$00,(NoMaxVol-VC)>>2	* 0003:	JUMPLO	NoMaxVol
	dc.b	TCYINST_LOAD,$02,$00,$40				* 0004:	LOAD	0040,v2
NoMaxVol:	dc.b	TCYINST_LSHL,$02,$00,$0A		* 0005:	LSHL	000A,v2
	dc.b	TCYINST_JUMPCC,$00,$00,(NoMaxVl2-VC)>>2	* 0006:	JUMPCC	NoMaxVl2
	dc.b	TCYINST_LOAD,$02,$FF,$FF				* 0007:	LOAD	FFFF,v2
NoMaxVl2:	dc.b	~FX_SET_VOLUME,$20,$00,$00		* 0008:	SETFX20	v2
	dc.b	TCYINST_GETTRMP,$01,$00,$00				* 0009:	GETTRMP	v1
	dc.b	TCYINST_GETTRMV,$12,$00,$00				* 000A:	GETTRMV	v1,v2
	dc.b	TCYINST_TRMWAVP,$10,$00,$01				* 000B:	TRMWAVP	v1+0001
	dc.b	TCYINST_LSHR,$02,$00,$08				* 000C:	LSHR	0008,v2
	dc.b	TCYINST_CMP,$02,$00,$E0					* 000D:	CMP		00E0,v2
	dc.b	TCYINST_JUMPEQ,$00,$00,(Cmd_E0-VC)>>2	* 000E:	JUMPEQ	Cmd_E0
	dc.b	TCYINST_CMP,$02,$00,$E1					* 000F:	CMP		00E1,v2
	dc.b	TCYINST_JUMPEQ,$00,$00,(Cmd_E1-VC)>>2	* 0010:	JUMPEQ	Cmd_E1
	dc.b	TCYINST_CMP,$02,$00,$E8					* 0011:	CMP		00E8,v2
	dc.b	TCYINST_JUMPEQ,$00,$00,(Cmd_E8-VC)>>2	* 0012:	JUMPEQ	Cmd_E8
	dc.b	TCYINST_CMP,$02,$00,$EA					* 0013:	CMP		00EA,v2
	dc.b	TCYINST_JUMPEQ,$00,$00,(Cmd_EA-VC)>>2	* 0014:	JUMPEQ	Cmd_EA
	dc.b	TCYINST_AND,$02,$00,$3F					* 0015:	AND		003F,v2
	dc.b	TCYINST_LOAD,$25,$00,$00				* 0016:	LOAD	v2,v5
	dc.b	TCYINST_LSHL,$02,$00,$0A				* 0017:	LSHL	0000A,v2
	dc.b	~FX_SET_VOLUME,$20,$00,$00				* 0018:	SETFX20	v2
WaitVol:	dc.b	TCYINST_WAIT,$30,$00,$00		* 0019:	WAIT	v3
	dc.b	TCYINST_JUMP,$00,$00,(VolLoop-VC)>>2	* 001A:	JUMP	VolLoop
Cmd_E0:	dc.b	TCYINST_GETTRMV,$12,$00,$01			* 001B:	GETTRMV	v1+0001,v2
	dc.b	TCYINST_LSHR,$02,$00,$08				* 001C:	LSHR	0008,v2
	dc.b	TCYINST_AND,$02,$00,$3F					* 001D:	AND		003F,v2
	dc.b	TCYINST_SUB,$02,$00,$05					* 001E:	SUB		0005,v2
	dc.b	TCYINST_TRMWAVP,$20,$00,$00				* 001F:	TRMWAVP	v2
	dc.b	TCYINST_JUMP,$00,$00,(VolLoop-VC)>>2	* 0020:	JUMP	VolLoop
Cmd_E1:	dc.b	TCYINST_TRMWAVP,$10,$00,$00			* 0021:	TRMWAVP	v1
	dc.b	TCYINST_STOP,$00,$00,$00				* 0022:	STOP
Cmd_E8:	dc.b	TCYINST_GETTRMV,$12,$00,$01			* 0023:	GETTRMV	v1+0001,v2
	dc.b	TCYINST_TRMWAVP,$10,$00,$02				* 0024:	TRMWAVP	v1+0002
	dc.b	TCYINST_LSHR,$02,$00,$08				* 0025:	LSHR	0008,v2
	dc.b	TCYINST_WAIT,$20,$00,$00				* 0026:	WAIT	v2
	dc.b	TCYINST_JUMP,$00,$00,(WaitVol-VC)>>2	* 0027:	JUMP	WaitVol
Cmd_EA:	dc.b	TCYINST_GETTRMV,$1E,$00,$02			* 0028:	GETTRMV	v1+0002,v14
	dc.b	TCYINST_TRMWAVP,$10,$00,$00				* 0029:	TRMWAVP	v1
VolSLoop:	dc.b	TCYINST_GETTRMP,$01,$00,$00		* 002A:	GETTRMP	v1
	dc.b	TCYINST_GETTRMV,$14,$00,$01				* 002B:	GETTRMV	v1+0001,v4
	dc.b	TCYINST_ASHR,$04,$00,$08				* 002C:	ASHR	0008,v4
	dc.b	TCYINST_ADD,$45,$00,$00					* 002D:	ADD		v4,v5
	dc.b	TCYINST_CMP,$05,$00,$80					* 002E:	CMP		0080,v5
	dc.b	TCYINST_JUMPLO,$00,$00,(VolSlClr-VC)>>2	* 002F:	JUMPLO	VolSlClr
	dc.b	TCYINST_SUB,$55,$00,$00					* 0030:	SUB		v5,v5
VolSlClr:	dc.b	TCYINST_LOAD,$54,$00,$00		* 0031:	LOAD	v5,v4
	dc.b	TCYINST_CMP,$04,$00,$40					* 0032:	CMP		0040,v4
	dc.b	TCYINST_JUMPLO,$00,$00,(FullVolS-VC)>>2	* 0033:	JUMPLO	FullVolS
	dc.b	TCYINST_LOAD,$04,$00,$40				* 0034:	LOAD	0040,v4
FullVolS:	dc.b	TCYINST_LSHL,$04,$00,$0A		* 0035:	LSHL	000A,v4
	dc.b	TCYINST_JUMPCC,$00,$00,(FullVol2-VC)>>2	* 0036:	JUMPCC	FullVol2
	dc.b	TCYINST_LOAD,$04,$FF,$FF				* 0037:	LOAD	FFFF,v4
FullVol2:	dc.b	~FX_SET_VOLUME,$40,$00,$00		* 0038:	SETFX20	v4
	dc.b	TCYINST_LOAD,$31,$00,$00				* 0039:	LOAD	v3,v1
	dc.b	TCYINST_ADD,$11,$00,$00					* 003A:	ADD		v1,v1
	dc.b	TCYINST_WAIT,$10,$00,$00				* 003B:	WAIT	v1
	dc.b	TCYINST_SUB,$0E,$01,$00					* 003C:	SUB		0100,v14
	dc.b	TCYINST_JUMPNE,$00,$00,(VolSLoop-VC)>>2	* 003D:	JUMPNE	VolSLoop
	dc.b	TCYINST_GETTRMP,$01,$00,$00				* 003E:	GETTRMP	v1
	dc.b	TCYINST_TRMWAVP,$10,$00,$03				* 003F:	TRMWAVP	v1+0003
	dc.b	TCYINST_JUMP,$00,$00,(WaitVol-VC)>>2	* 0040:	JUMP	WaitVol
PitchSynthCode:	dc.b	TCYINST_ARPWAVE,$00,$00,$01	* 0041:	ARPWAVE	0001
	dc.b	TCYINST_CMP,$09,$00,$00					* 0042:	CMP		0000,v9
	dc.b	TCYINST_JUMPNE,$00,00,(PitchLoop-VC)>>2	* 0043:	JUMPNE	PitchLoop
	dc.b	TCYINST_GETNOTE,$09,$ff,$e9				* 0044:	GETNOTE	-0017,v9
	dc.b	TCYINST_GETRANS,$01,$00,$00				* 0045:	GETRANS	v1
	dc.b	TCYINST_ADD,$19,$00,$00					* 0046:	ADD		v1,v9
PitchLoop:	dc.b	TCYINST_GETARPP,$01,$00,$00		* 0047: GETARPP	v1
	dc.b	TCYINST_GETARPV,$12,$00,$00				* 0048: GETARPV	v1,v2
	dc.b	TCYINST_ARPWAVP,$10,$00,$01				* 0049: ARPWAVP	v1+0001
	dc.b	TCYINST_LSHR,$02,$00,$08				* 004A:	LSHR	0008,v2
	dc.b	TCYINST_CMP,$02,$00,$E0					* 004B: CMP		00E0,v2
	dc.b	TCYINST_JUMPEQ,$00,$00,(Pitch_E0-VC)>>2	* 004C: JUMPEQ	Pitch_E0
	dc.b	TCYINST_CMP,$02,$00,$E1					* 004D:	CMP		00E1,v2
	dc.b	TCYINST_JUMPEQ,$00,$00,(Pitch_E1-VC)>>2	* 004E:	JUMPEQ	Pitch_E1
	dc.b	TCYINST_CMP,$02,$00,$E2					* 004F:	CMP		00E2,v2
	dc.b	TCYINST_JUMPEQ,$00,$00,(Pitch_E2-VC)>>2	* 0050:	JUMPEQ	Pitch_E2
	dc.b	TCYINST_CMP,$02,$00,$E3					* 0051:	CMP		00E3,v2
	dc.b	TCYINST_JUMPEQ,$00,$00,(Pitch_E3-VC)>>2	* 0052:	JUMPEQ	Pitch_E3
	dc.b	TCYINST_CMP,$02,$00,$E4					* 0053:	CMP		00E4,v2
	dc.b	TCYINST_JUMPEQ,$00,$00,(Pitch_E4-VC)>>2	* 0054:	JUMPEQ	Pitch_E4
	dc.b	TCYINST_CMP,$02,$00,$E7					* 0055:	CMP		00E7,v2
	dc.b	TCYINST_JUMPEQ,$00,$00,(Pitch_E7-VC)>>2	* 0056:	JUMPEQ	Pitch_E7
	dc.b	TCYINST_CMP,$02,$00,$E8					* 0057:	CMP		00E8,v2
	dc.b	TCYINST_JUMPEQ,$00,$00,(Pitch_E8-VC)>>2	* 0058:	JUMPEQ	Pitch_E8
	dc.b	TCYINST_CMP,$02,$00,$E9					* 0059:	CMP		00E9,v2
	dc.b	TCYINST_JUMPEQ,$00,$00,(Pitch_E9-VC)>>2	* 005A:	JUMPEQ	Pitch_E9
	dc.b	TCYINST_CMP,$02,$00,$EA					* 005B:	CMP		00EA,v2
	dc.b	TCYINST_JUMPEQ,$00,$00,(Pitch_EA-VC)>>2	* 005C:	JUMPEQ	Pitch_EA
IsTrsp:	dc.b	TCYINST_ARPWAVP,$10,$00,$01			* 005D:	ARPWAVP	v1+0001
	dc.b	TCYINST_CMP,$02,$00,$80					* 005E:	CMP		0080,v2
	dc.b	TCYINST_JUMPHS,$00,$00,(NegPitch-VC)>>2	* 005F:	JUMPHS	NegPitch
	dc.b	TCYINST_GETARPV,$1A,$00,$00				* 0060:	GETARPV	v1,v10
	dc.b	TCYINST_LSHR,$0A,$00,$08				* 0061:	LSHR	0008,v10
	dc.b	TCYINST_GETNOTE,$09,$ff,$e9				* 0062:	GETNOTE	-0017,v9
	dc.b	TCYINST_GETRANS,$01,$00,$00				* 0063:	GETRANS	v1
	dc.b	TCYINST_ADD,$19,$00,$00					* 0064:	ADD		v1,v9
	dc.b	TCYINST_LOAD,$91,$00,$00				* 0065:	LOAD	v9,v1
	dc.b	TCYINST_ADD,$A1,$00,$00					* 0066:	ADD		v10,v1
SetPtch:	dc.b	TCYINST_CMP,$01,$00,$3C			* 0067:	CMP		003C,v1
	dc.b	TCYINST_JUMPLO,$00,$00,(AdjPtch-VC)>>2	* 0068:	JUMPLO	AdjPtch
	dc.b	TCYINST_SUB,$01,$00,$48					* 0069:	SUB		0048,v1
	dc.b	TCYINST_JUMPMI,$00,$00,(AdjPtch-VC)>>2	* 006A:	JUMPMI	AdjPtch
	dc.b	TCYINST_SUB,$01,$00,$0C					* 006B:	SUB		000C,v1
AdjPtch:	dc.b	TCYINST_SETNOTE,$10,$00,$18		* 006C:	SETNOTE	0018+v1
	dc.b	TCYINST_RESET,$00,$00,$20				* 006D:	RESET	0020
WaitPtch:	dc.b	TCYINST_WAIT,$00,$00,$01		* 006E:	WAIT	0001
	dc.b	TCYINST_JUMP,$00,$00,(PitchLoop-VC)>>2	* 006F:	JUMP	PitchLoop
NegPitch:	dc.b	TCYINST_AND,$02,$00,$7F			* 0070:	AND		007F,v2
	dc.b	TCYINST_LOAD,$29,$00,$00				* 0071:	LOAD	v2,v9
	dc.b	TCYINST_SUB,$AA,$00,$00					* 0072:	SUB		v10,v10
	dc.b	TCYINST_LOAD,$21,$00,$00				* 0073:	LOAD	v2,v1
	dc.b	TCYINST_JUMP,$00,$00,(SetPtch-VC)>>2	* 0074:	JUMP	SetPtch
Pitch_E0:	dc.b	TCYINST_GETARPV,$12,$00,$01		* 0075:	GETARPV	v1+0001,v2
	dc.b	TCYINST_LSHR,$02,$00,$08				* 0076:	LSHR	0008,v2
	dc.b	TCYINST_AND,$02,$00,$3F					* 0077:	AND		003F,v2
	dc.b	TCYINST_ARPWAVP,$20,$00,$00				* 0078:	ARPWAVP	v2
	dc.b	TCYINST_JUMP,$00,$00,(PitchLoop-VC)>>2	* 0079:	JUMP	PitchLoop
Pitch_E1:	dc.b	TCYINST_ARPWAVP,$10,$00,$00		* 007A:	ARPWAVP	v1
	dc.b	TCYINST_STOP,$00,$00,$00				* 007B:	STOP
Pitch_E2:	dc.b	TCYINST_ADD,$01,$00,$02			* 007C:	ADD		0002,v1
	dc.b	TCYINST_TRMWAVP,$00,$00,$00				* 007D:	TRMWAVP	0000
Pitch_E29:	dc.b	TCYINST_ARPWAVP,$10,$00,$00		* 007E:	ARPWAVP	v1
	dc.b	TCYINST_GETARPV,$12,$ff,$ff				* 007F:	GETARPV	v1-0001,v2
	dc.b	TCYINST_LSHR,$02,$00,$08				* 0080:	LSHR	0008,v2
	dc.b	TCYINST_ISETWAV,$20,$00,$00				* 0081:	ISETWAV	v2
Transpose:	dc.b	TCYINST_GETARPV,$12,$00,$00		* 0082: GETARPV	v1,v2
	dc.b	TCYINST_LSHR,$02,$00,$08				* 0083:	LSHR	0008,v2
	dc.b	TCYINST_JUMP,$00,$00,(IsTrsp-VC)>>2		* 0084:	JUMP	IsTrsp
Pitch_E3:	dc.b	TCYINST_GETARPV,$16,$00,$01		* 0085:	GETARPV	v1+0001,v6
	dc.b	TCYINST_LSHR,$06,$00,$08				* 0086:	LSHR	0008,v6
	dc.b	TCYINST_GETARPV,$17,$00,$02				* 0087:	GETARPV	v1+0002,v7
	dc.b	TCYINST_LSHR,$07,$00,$08				* 0088:	LSHR	0008,v7
	dc.b	TCYINST_ARPWAVP,$10,$00,$02				* 0089: ARPWAVP	v1+0003
	dc.b	TCYINST_JUMP,$00,$00,(PitchLoop-VC)>>2	* 008A:	JUMP	PitchLoop
Pitch_E4:	dc.b	TCYINST_ADD,$01,$00,$02			* 008B:	ADD		0002,v1
	dc.b	TCYINST_ARPWAVP,$10,$00,$00				* 008C:	ARPWAVP	v1+0000
	dc.b	TCYINST_GETARPV,$12,$ff,$ff				* 008D:	GETARPV	v1-0001,v2
	dc.b	TCYINST_LSHR,$02,$00,$08				* 008E:	LSHR	0008,v2
	dc.b	TCYINST_SETWAVE,$20,$00,$00				* 008F:	SETWAVE	v2
	dc.b	TCYINST_JUMP,$00,$00,(Transpose-VC)>>2	* 0090:	JUMP	Transpose
Pitch_E7:	dc.b	TCYINST_GETARPV,$12,$00,$01		* 0091:	GETARPV	v1+0001,v2
	dc.b	TCYINST_ARPWAVP,$00,$00,$00				* 0092:	ARPWAVP	0000
	dc.b	TCYINST_LSHR,$02,$00,$08				* 0093:	LSHR	0008,v2
	dc.b	TCYINST_ARPWAVE,$20,$00,$00				* 0094:	ARPWAVE	v2
	dc.b	TCYINST_JUMP,$00,$00,(PitchLoop-VC)>>2	* 0095:	JUMP	PitchLoop
Pitch_E8:	dc.b	TCYINST_GETARPV,$12,$00,$01		* 0096:	GETARPV	v1+0001,v2
	dc.b	TCYINST_ARPWAVP,$10,$00,$02				* 0097:	ARPWAVP	v1+0002
	dc.b	TCYINST_LSHR,$02,$00,$08				* 0098:	LSHR	0008,v2
	dc.b	TCYINST_WAIT,$20,$00,$00				* 0099:	WAIT	v2
	dc.b	TCYINST_JUMP,$00,$00,(PitchLoop-VC)>>2	* 009A:	JUMP	PitchLoop
Pitch_E9:	dc.b	TCYINST_ADD,$01,$00,$03			* 009B:	ADD		0003,v1
	dc.b	TCYINST_TRMWAVP,$00,$00,$00				* 009C:	TRMWAVP	0000
	dc.b	TCYINST_JUMP,$00,$00,(Pitch_E29-VC)>>2	* 009D:	JUMP	Pitch_E29
Pitch_EA:	dc.b	TCYINST_GETARPV,$1B,$00,$02		* 009E:	GETARPV	v1+0002,v11
	dc.b	TCYINST_ARPWAVP,$10,$00,$00				* 009F:	ARPWAVP	v1
EA_Loop:	dc.b	TCYINST_GETARPP,$01,$00,$00		* 00A0:	GETARPP	v1
	dc.b	TCYINST_GETARPV,$12,$00,$01				* 00A1:	GETARPV	v1+0001,v2
	dc.b	TCYINST_LSHL,$02,$00,$08				* 00A2:	LSHL	0008,v2
	dc.b	TCYINST_JUMPEQ,$00,$00,(EA_Done-VC)>>2	* 00A3:	JUMPEQ	EA_Done
	dc.b	TCYINST_JUMPMI,$00,$00,(EA_Down-VC)>>2	* 00A4:	JUMPMI	EA_Down
	dc.b	TCYINST_PORTAUP,$20,$00,$00				* 00A5:	PORTAUP	v2
	dc.b	TCYINST_JUMP,$00,$00,(EA_Done-VC)>>2	* 00A6:	JUMP	EA_Done
EA_Down:	dc.b	TCYINST_NEG,$00,$00,$00			* 00A7:	NEG		v2
	dc.b	TCYINST_PORTADN,$20,$00,$00				* 00A8:	PORTADN	v2
EA_Done:	dc.b	TCYINST_WAIT,$00,$00,$02		* 00A9:	WAIT	0002
	dc.b	TCYINST_SUB,$0B,$00,$00					* 00AA:	SUB		0001,v11
	dc.b	TCYINST_JUMPNE,$00,$00,(EA_Loop-VC)>>2	* 00AB:	JUMPNE	EA_Loop
	dc.b	TCYINST_GETARPP,$01,$00,$00				* 00AC:	GETARPP	v1
	dc.b	TCYINST_ARPWAVP,$10,$00,$03				* 00AD:	ARPWAVP	v1+0003
	dc.b	TCYINST_JUMP,$00,$00,(Transpose-VC)>>2	* 00AE:	JUMP	Transpose
VibSynthCode:	dc.b	TCYINST_WAIT,$80,$00,$00	* 00AF:	WAIT	v8
	dc.b	TCYINST_LOAD,$78,$00,$00				* 00B0:	LOAD	v7,v8
VibLoop:	dc.b	TCYINST_LOAD,$92,$00,$00		* 00B1:	LOAD	v9,v2
	dc.b	TCYINST_CMP,$09,$00,$00					* 00B2:	CMP		0000,v9
	dc.b	TCYINST_JUMPPL,$00,$00,(Vib1-VC)>>2		* 00B3:	JUMPPL	Vib1
	dc.b	TCYINST_ADD,$02,$00,$48					* 00B4:	ADD		0048,v2
Vib1:	dc.b	TCYINST_ADD,$A2,$00,$00				* 00B5:	ADD		v10,v2
	dc.b	TCYINST_LSHL,$02,$00,$09				* 00B6:	LSHL	0009,v2
	dc.b	TCYINST_ADD,$77,$00,$00					* 00B7:	ADD		v7,v7
	dc.b	TCYINST_CMP,$0D,$00,$00					* 00B8:	CMP		0000,v13
	dc.b	TCYINST_JUMPNE,$00,$00,(Vib2-VC)>>2		* 00B9:	JUMPNE	Vib2
	dc.b	TCYINST_SUB,$68,$00,$00					* 00BA:	SUB		v6,v8
	dc.b	TCYINST_JUMPCC,$00,$00,(Vib3-VC)>>2		* 00BB:	JUMPCC	Vib3
	dc.b	TCYINST_LOAD,$0D,$FF,$FF				* 00BC:	LOAD	FFFF,v13
	dc.b	TCYINST_LOAD,$88,$00,$00				* 00BD:	SUB		v8,v8
	dc.b	TCYINST_JUMP,$00,$00,(Vib3-VC)>>2		* 00BE:	JUMP	Vib3
Vib2:	dc.b	TCYINST_ADD,$68,$00,$00				* 00BF:	ADD		v6,v8
	dc.b	TCYINST_CMP,$78,$00,$00					* 00C0:	CMP		v7,v8
	dc.b	TCYINST_JUMPCS,$00,$00,(Vib3-VC)>>2		* 00C1:	JUMPCS	Vib3
	dc.b	TCYINST_SUB,$DD,$00,$00					* 00C2:	SUB		v13,v13
	dc.b	TCYINST_LOAD,$78,$00,$00				* 00C3:	LOAD	v7,v8
Vib3:	dc.b	TCYINST_LOAD,$81,$00,$00			* 00C4:	LOAD	v8,v1
	dc.b	TCYINST_LSHR,$07,$00,$01				* 00C5:	LSHR	0001,v7
	dc.b	TCYINST_SUB,$71,$00,$00					* 00C6:	SUB		v7,v1
	dc.b	TCYINST_ADD,$02,$A0,$00					* 00C7:	ADD		A000,v2
	dc.b	TCYINST_JUMPCS,$00,$00,(Vib5-VC)>>2		* 00C8:	JUMPCS	Vib5
Vib4:	dc.b	TCYINST_ADD,$11,$00,$00				* 00C9:	ADD		v1,v1
	dc.b	TCYINST_ADD,$02,$18,$00					* 00CA:	ADD		1800,v2
	dc.b	TCYINST_JUMPCC,$00,$00,(Vib4-VC)>>2		* 00CB:	JUMPCC	Vib4
Vib5:	dc.b	TCYINST_LSHL,$01,$00,$04			* 00CC:	LSHL	0004,v1
	dc.b	TCYINST_VIBVAL,$10,$00,$00				* 00CD:	VIBVAL	v1
	dc.b	TCYINST_WAIT,$00,$00,$01				* 00CE:	WAIT	0001
	dc.b	TCYINST_JUMP,$00,$00,(VibLoop-VC)>>2	* 00CF:	JUMP	VibLoop
PortaSC:	dc.b	TCYINST_CMP,$0F,$00,$00			* 00D0:	CMP		0000,v15
	dc.b	TCYINST_JUMPEQ,$00,$00,(NoPorta-VC)>>2	* 00D1:	JUMPEQ	NoPorta
	dc.b	TCYINST_JUMPMI,$04,$00,(PortaDn-VC)>>2	* 00D2:	JUMPMI	PortaDn
	dc.b	TCYINST_PORTAUP,$F0,$00,$00				* 00D3:	PORTAUP	v15
NoPorta:	dc.b	TCYINST_WAIT,$00,$00,$02		* 00D4:	WAIT	0002
	dc.b	TCYINST_JUMP,$00,$00,(PortaSC-VC)>>2	* 00D5:	JUMP	PortaSC
PortaDn:	dc.b	TCYINST_LOAD,$F4,$00,$00		* 00D6:	LOAD	v15,v4
	dc.b	TCYINST_NEG,$04,$00,$00					* 00D7:	NEG		v4
	dc.b	TCYINST_PORTADN,$40,$00,$00				* 00D8:	PORTADN	v4
	dc.b	TCYINST_WAIT,$00,$00,$02				* 00D9:	WAIT	0002
	dc.b	TCYINST_JUMP,$00,$00,(PortaSC-VC)>>2	* 00DA:	JUMP	PortaSC
SynthCodeLen:	equ	(*-VC)>>2

SymbolTable:	dc.w	(VolLoop-VC)>>2,VolLoopName-SymbolTable
	dc.w	(NoMaxVol-VC)>>2,NoMaxVolName-SymbolTable
	dc.w	(NoMaxVl2-VC)>>2,NoMaxVl2Name-SymbolTable
	dc.w	(WaitVol-VC)>>2,WaitVolName-SymbolTable
	dc.w	(Cmd_E0-VC)>>2,Cmd_E0Name-SymbolTable
	dc.w	(Cmd_E1-VC)>>2,Cmd_E1Name-SymbolTable
	dc.w	(Cmd_E8-VC)>>2,Cmd_E8Name-SymbolTable
	dc.w	(Cmd_EA-VC)>>2,Cmd_EAName-SymbolTable
	dc.w	(VolSLoop-VC)>>2,VolSLoopName-SymbolTable
	dc.w	(VolSlClr-VC)>>2,VolSlClrName-SymbolTable
	dc.w	(FullVolS-VC)>>2,FullVolSName-SymbolTable
	dc.w	(FullVol2-VC)>>2,FullVol2Name-SymbolTable
	dc.w	(PitchSynthCode-VC)>>2,PitchSynthCodeName-SymbolTable
	dc.w	(PitchLoop-VC)>>2,PitchLoopName-SymbolTable
	dc.w	(IsTrsp-VC)>>2,IsTrspName-SymbolTable
	dc.w	(SetPtch-VC)>>2,SetPtchName-SymbolTable
	dc.w	(AdjPtch-VC)>>2,AdjPtchName-SymbolTable
	dc.w	(WaitPtch-VC)>>2,WaitPtchName-SymbolTable
	dc.w	(NegPitch-VC)>>2,NegPitchName-SymbolTable
	dc.w	(Pitch_E0-VC)>>2,Pitch_E0Name-SymbolTable
	dc.w	(Pitch_E1-VC)>>2,Pitch_E1Name-SymbolTable
	dc.w	(Pitch_E2-VC)>>2,Pitch_E2Name-SymbolTable
	dc.w	(Pitch_E29-VC)>>2,Pitch_E29Name-SymbolTable
	dc.w	(Transpose-VC)>>2,TransposeName-SymbolTable
	dc.w	(Pitch_E3-VC)>>2,Pitch_E3Name-SymbolTable
	dc.w	(Pitch_E4-VC)>>2,Pitch_E4Name-SymbolTable
	dc.w	(Pitch_E7-VC)>>2,Pitch_E7Name-SymbolTable
	dc.w	(Pitch_E8-VC)>>2,Pitch_E8Name-SymbolTable
	dc.w	(Pitch_E9-VC)>>2,Pitch_E9Name-SymbolTable
	dc.w	(Pitch_EA-VC)>>2,Pitch_EAName-SymbolTable
	dc.w	(EA_Loop-VC)>>2,EA_LoopName-SymbolTable
	dc.w	(EA_Down-VC)>>2,EA_DownName-SymbolTable
	dc.w	(EA_Done-VC)>>2,EA_DoneName-SymbolTable
	dc.w	(VibSynthCode-VC)>>2,VibSynthCodeName-SymbolTable
	dc.w	(VibLoop-VC)>>2,VibLoopName-SymbolTable
	dc.w	(Vib1-VC)>>2,Vib1Name-SymbolTable
	dc.w	(Vib2-VC)>>2,Vib2Name-SymbolTable
	dc.w	(Vib3-VC)>>2,Vib3Name-SymbolTable
	dc.w	(Vib4-VC)>>2,Vib4Name-SymbolTable
	dc.w	(Vib5-VC)>>2,Vib5Name-SymbolTable
	dc.w	(PortaSC-VC)>>2,PortaSCName-SymbolTable
	dc.w	(NoPorta-VC)>>2,NoPortaName-SymbolTable
	dc.w	(PortaDn-VC)>>2,PortaDnName-SymbolTable

SOUNDINFO:	dc.w	$0000,$0000,$0010
	dc.w	$0000,$0020,$0010
	dc.w	$0000,$0040,$0010
	dc.w	$0000,$0060,$0010
	dc.w	$0000,$0080,$0010
	dc.w	$0000,$00a0,$0010
	dc.w	$0000,$00c0,$0010
	dc.w	$0000,$00e0,$0010
	dc.w	$0000,$0100,$0010
	dc.w	$0000,$0120,$0010
	dc.w	$0000,$0140,$0010
	dc.w	$0000,$0160,$0010
	dc.w	$0000,$0180,$0010
	dc.w	$0000,$01a0,$0010
	dc.w	$0000,$01c0,$0010
	dc.w	$0000,$01e0,$0010
	dc.w	$0000,$0200,$0010
	dc.w	$0000,$0220,$0010
	dc.w	$0000,$0240,$0010
	dc.w	$0000,$0260,$0010
	dc.w	$0000,$0280,$0010
	dc.w	$0000,$02a0,$0010
	dc.w	$0000,$02c0,$0010
	dc.w	$0000,$02e0,$0010
	dc.w	$0000,$0300,$0010
	dc.w	$0000,$0320,$0010
	dc.w	$0000,$0340,$0010
	dc.w	$0000,$0360,$0010
	dc.w	$0000,$0380,$0010
	dc.w	$0000,$03a0,$0010
	dc.w	$0000,$03c0,$0010
	dc.w	$0000,$03e0,$0010
	dc.w	$0000,$0400,$0008
	dc.w	$0000,$0410,$0008
	dc.w	$0000,$0420,$0008
	dc.w	$0000,$0430,$0008
	dc.w	$0000,$0440,$0008
	dc.w	$0000,$0450,$0008
	dc.w	$0000,$0460,$0008
	dc.w	$0000,$0470,$0008
	dc.w	$0000,$0480,$0010
	dc.w	$0000,$04a0,$0008
	dc.w	$0000,$04b0,$0010
	dc.w	$0000,$04d0,$0010
	dc.w	$0000,$04f0,$0008
	dc.w	$0000,$0500,$0008
	dc.w	$0000,$0510,$0018
 
WAVEFORMS:	dc.w	$c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w	$3f37,$2f27,$1f17,$0f07,$ff07,$0f17,$1f27,$2f37
	dc.w	$c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w	$c037,$2f27,$1f17,$0f07,$ff07,$0f17,$1f27,$2f37
	dc.w	$c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w	$c0b8,$2f27,$1f17,$0f07,$ff07,$0f17,$1f27,$2f37
	dc.w	$c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w	$c0b8,$b027,$1f17,$0f07,$ff07,$0f17,$1f27,$2f37
	dc.w	$c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w	$c0b8,$b0a8,$1f17,$0f07,$ff07,$0f17,$1f27,$2f37
	dc.w	$c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w	$c0b8,$b0a8,$a017,$0f07,$ff07,$0f17,$1f27,$2f37
	dc.w	$c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w	$c0b8,$b0a8,$a098,$0f07,$ff07,$0f17,$1f27,$2f37
	dc.w	$c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w	$c0b8,$b0a8,$a098,$9007,$ff07,$0f17,$1f27,$2f37
	dc.w	$c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w	$c0b8,$b0a8,$a098,$9088,$ff07,$0f17,$1f27,$2f37
	dc.w	$c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w	$c0b8,$b0a8,$a098,$9088,$8007,$0f17,$1f27,$2f37
	dc.w	$c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w	$c0b8,$b0a8,$a098,$9088,$8088,$0f17,$1f27,$2f37
	dc.w	$c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w	$c0b8,$b0a8,$a098,$9088,$8088,$9017,$1f27,$2f37
	dc.w	$c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w	$c0b8,$b0a8,$a098,$9088,$8088,$9098,$1f27,$2f37
	dc.w	$c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w	$c0b8,$b0a8,$a098,$9088,$8088,$9098,$a027,$2f37
	dc.w	$c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w	$c0b8,$b0a8,$a098,$9088,$8088,$9098,$a0a8,$2f37
	dc.w	$c0c0,$d0d8,$e0e8,$f0f8,$00f8,$f0e8,$e0d8,$d0c8
	dc.w	$c0b8,$b0a8,$a098,$9088,$8088,$9098,$a0a8,$b037
	dc.w	$8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w	$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w	$8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w	$817f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w	$8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w	$8181,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w	$8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w	$8181,$817f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w	$8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w	$8181,$8181,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w	$8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w	$8181,$8181,$817f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w	$8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w	$8181,$8181,$8181,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w	$8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w	$8181,$8181,$8181,$817f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w	$8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w	$8181,$8181,$8181,$8181,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w	$8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w	$8181,$8181,$8181,$8181,$817f,$7f7f,$7f7f,$7f7f
	dc.w	$8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w	$8181,$8181,$8181,$8181,$8181,$7f7f,$7f7f,$7f7f
	dc.w	$8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w	$8181,$8181,$8181,$8181,$8181,$817f,$7f7f,$7f7f
	dc.w	$8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w	$8181,$8181,$8181,$8181,$8181,$8181,$7f7f,$7f7f
	dc.w	$8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
	dc.w	$8181,$8181,$8181,$8181,$8181,$8181,$817f,$7f7f
	dc.w	$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080
	dc.w	$8080,$8080,$8080,$8080,$8080,$8080,$8080,$7f7f
	dc.w	$8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080
	dc.w	$8080,$8080,$8080,$8080,$8080,$8080,$8080,$807f
	dc.w	$8080,$8080,$8080,$8080,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w	$8080,$8080,$8080,$807f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w	$8080,$8080,$8080,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w	$8080,$8080,$807f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w	$8080,$8080,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w	$8080,$807f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w	$8080,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w	$8080,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f,$7f7f
	dc.w	$8080,$9098,$a0a8,$b0b8,$c0c8,$d0d8,$e0e8,$f0f8
	dc.w	$0008,$1018,$2028,$3038,$4048,$5058,$6068,$707f
	dc.w	$8080,$a0b0,$c0d0,$e0f0,$0010,$2030,$4050,$6070
	dc.w	$4545,$797d,$7a77,$7066,$6158,$534d,$2c20,$1812
	dc.w	$04db,$d3cd,$c6bc,$b5ae,$a8a3,$9d99,$938e,$8b8a
	dc.w	$4545,$797d,$7a77,$7066,$5b4b,$4337,$2c20,$1812
	dc.w	$04f8,$e8db,$cfc6,$beb0,$a8a4,$9e9a,$9594,$8d83
	dc.w	$0000,$4060,$7f60,$4020,$00e0,$c0a0,$80a0,$c0e0
	dc.w	$0000,$4060,$7f60,$4020,$00e0,$c0a0,$80a0,$c0e0
	dc.w	$8080,$9098,$a0a8,$b0b8,$c0c8,$d0d8,$e0e8,$f0f8
	dc.w	$0008,$1018,$2028,$3038,$4048,$5058,$6068,$707f
	dc.w	$8080,$a0b0,$c0d0,$e0f0,$0010,$2030,$4050,$6070

	cnop	0,4

ExtModuleLibBase:	dc.l	0

PanningTable:	dc.b	0,$ff,$ff,0

LoadFlags:	dc.w	2
	dc.w	LoadFlagSize
	dc.l	LoadText0
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0	
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText1
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
LoadText0:	dc.b	'Load samples',0
LoadText1:	dc.b	'Create symbols',0
	even
LoadFlagSize:	equ	*-LoadFlags
VolLoopName:	dc.b	'VolLoop',0
NoMaxVolName:	dc.b	'NoMaxVol',0
NoMaxVl2Name:	dc.b	'NoMaxVl2',0
WaitVolName:	dc.b	'WaitVol',0
Cmd_E0Name:	dc.b	'Cmd_E0',0
Cmd_E1Name:	dc.b	'Cmd_E1',0
Cmd_E8Name:	dc.b	'Cmd_E8',0
Cmd_EAName:	dc.b	'Cmd_EA',0
VolSLoopName:	dc.b	'VolSLoop',0
VolSlClrName:	dc.b	'VolSlClr',0
FullVolSName:	dc.b	'FullVolS',0
FullVol2Name:	dc.b	'FullVol2',0
PitchSynthCodeName:	dc.b	'PitchSynthCode',0
PitchLoopName:	dc.b	'PitchLoop',0
IsTrspName:	dc.b	'IsTrsp',0
SetPtchName:	dc.b	'SetPtch',0
AdjPtchName:	dc.b	'AdjPtch',0
WaitPtchName:	dc.b	'WaitPtch',0
NegPitchName:	dc.b	'NegPitch',0
Pitch_E0Name:	dc.b	'Pitch_E0',0
Pitch_E1Name:	dc.b	'Pitch_E1',0
Pitch_E2Name:	dc.b	'Pitch_E2',0
Pitch_E29Name:	dc.b	'Pitch_E29',0
TransposeName:	dc.b	'Transpose',0
Pitch_E3Name:	dc.b	'Pitch_E3',0
Pitch_E4Name:	dc.b	'Pitch_E4',0
Pitch_E7Name:	dc.b	'Pitch_E7',0
Pitch_E8Name:	dc.b	'Pitch_E8',0
Pitch_E9Name:	dc.b	'Pitch_E9',0
Pitch_EAName:	dc.b	'Pitch_EA',0
EA_LoopName:	dc.b	'EA_Loop',0
EA_DownName:	dc.b	'EA_Down',0
EA_DoneName:	dc.b	'EA_Done',0
VibSynthCodeName:	dc.b	'VibSynthCode',0
VibLoopName:	dc.b	'VibLoop',0
Vib1Name:	dc.b	'Vib1',0
Vib2Name:	dc.b	'Vib2',0
Vib3Name:	dc.b	'Vib3',0
Vib4Name:	dc.b	'Vib4',0
Vib5Name:	dc.b	'Vib5',0
PortaSCName:	dc.b	'PortaSC',0
NoPortaName:	dc.b	'NoPorta',0
PortaDnName:	dc.b	'PortaDn',0
LoadDescript:	dc.b	'FutureComposer 1.3/1.4 Module (FC13/FC14)',0
