*************************************************************
***      TuComposer External Module Library for IT        ***
***           1997 by The united Coders (TuC)            ***
***                 Main code: Basty/TuC                  ***
***    This is a IT module loader. It loads the famous    ***
***     ImpulseTracker I & ][ Modules into TuComposer.    ***
*************************************************************

	IFND	_G2
	MACHINE	MC68020
	OPT NODEBUG,NOLINE
	ENDC

	include	"exec/types.i"
	include	"exec/execbase.i"
	include	"exec/exec_lib.i"
	include	"exec/initializers.i"
	include	"exec/memory.i"
	include	"exec/resident.i"
	include	"exec/libraries.i"
	include	"libraries/dos.i"
	include	"libraries/dos_lib.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/module.i"
	include	"tucomposer/song.i"
	include	"tucomposer/position.i"
	include	"tucomposer/track.i"
	include	"tucomposer/instr.i"
	include	"tucomposer/sample.i"
	include	"tucomposer/external/external.i"
	include	"tucomposer/external/external_lib.i"
	include	"tucomposer/external/module.i"
	include	"tucomposer/external/module_lib.i"

	moveq	#-1,d0
	rts
ResidentStruct:	dc.w	RTC_MATCHWORD
	dc.l	ResidentStruct
	dc.l	0
	dc.b	RTF_AUTOINIT
	dc.b	EXTLIB_MODULE_VERSION
	dc.b	NT_LIBRARY
	dc.b	0
	dc.l	LibName
	dc.l	LibID
	dc.l	Init
LibName:	dc.b	'it.library',0
LibID:	dc.b	'TuComposer External Module Loader Version 1.00 (v31) for IT (68020+, OS2.0+) (16 May 97) by Basty/TuC.',0
TuComposerName:	dc.b	'tucomposer.library',0
	even
Init:	dc.l	modl_SIZEOF
	dc.l	FuncTab
	dc.l	DataTab
	dc.l	PrepareLibrary

FuncTab:	dc.w	-1
	dc.w	Open-FuncTab
	dc.w	Close-FuncTab
	dc.w	Expunge-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalInitialize-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalModuleIdentify-FuncTab
	dc.w	ExternalModuleLoad-FuncTab
	dc.w	ExternalModuleSave-FuncTab
	dc.w	ExternalModuleGetInfo-FuncTab
	dc.w	ExternalModuleGetNums-FuncTab
	dc.w	-1

DataTab:	INITLONG	LN_NAME,LibName
	INITBYTE	LIB_FLAGS,LIBF_CHANGED|LIBF_SUMUSED
	INITWORD	LIB_VERSION,EXTLIB_MODULE_VERSION
	INITWORD	LIB_REVISION,EXTLIB_REVISION
	INITLONG	LIB_IDSTRING,LibID
	dc.l	0

PrepareLibrary:	btst	#AFB_68020,AttnFlags+1(a6)	
	beq.s	ExtLib
	cmp.w	#37,LIB_VERSION(a6)
	blt.s	ExtLib
	move.l	a2,-(sp)
	move.l	d0,a2
	move.l	a0,extb_SegList(a2)
	moveq	#31,d0
	lea	TuComposerName(pc),a1
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,extb_TuComposerBase(a2)
	beq.s	NoTuCLib
	lea	ExtModuleLibBase(pc),a0
	move.l	a2,(a0)
	move.l	a2,d0
NoTuCLib:	move.l	(sp)+,a2
	rts
Open:	addq.w	#1,LIB_OPENCNT(a6)
	move.l	a6,d0
	rts
Close:	subq.w	#1,LIB_OPENCNT(a6)
	bne.s	ExtLib
	btst	#LIBB_DELEXP,LIB_FLAGS(a6)
	bne.s	Expunge
ExtLib:	moveq	#0,d0
	rts
Expunge:	bset	#LIBB_DELEXP,LIB_FLAGS(a6)
	tst.w	LIB_OPENCNT(a6)
	bne.s	ExtLib
	movem.l	d2/a5-a6,-(sp)
	move.l	extb_ExtLibList(a6),d0
	beq.s	NoExtLibList
	move.l	d0,a0
	clr.l	extl_LibBase(a0)
NoExtLibList:	move.l	extb_TuComposerBase(a6),a1
	move.l	a6,a5
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
	move.l	extb_SegList(a5),d2
	move.l	a5,a1
	jsr	_LVORemove(a6)
	move.l	a5,a1
	moveq	#0,d0
	moveq	#0,d1
	move.w	LIB_NEGSIZE(a5),d1
	sub.l	d1,a1
	move.w	LIB_POSSIZE(a5),d0
	add.l	d1,d0
	jsr	_LVOFreeMem(a6)
	move.l	d2,d0
	movem.l	(sp)+,d2/a5-a6
	rts
;	INPUT
;	A0.L	=	APTR to module external list structure to be initialized
;	OUTPUT
;	D0.L	=	What type of external library is it or NULL if error
ExternalInitialize:	move.l	extb_TuComposerBase(a6),a1
	movem.l	a2/a6,-(sp)
	move.l	a0,d0
	beq.s	ExternalInitDone
	move.l	a1,a6
	move.b	#EXTLF_Loader|EXTLF_Saver,extl_Flags(a0)
	move.l	a0,a2
	lea	extl_Descriptor(a0),a0
	lea	LoadDescript(pc),a1
	jsr	_LVOSetString(a6)
	tst.l	d0
	beq.s	ExternalInitDone
	lea	LoadFlags(pc),a0
	jsr	_LVOAllocFlagStr(a6)
	move.l	d0,extl_LoadFlagStr(a2)
	beq.s	ExternalInitDone
	moveq	#EXTTYPE_MODULE,d0
ExternalInitDone:	movem.l	(sp)+,a2/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	If failed NULL else any non-zero value
ExternalModuleIdentify:	movem.l	d2-d3/a6,-(sp)
	move.l	a0,d1
	subq.l	#4,sp
	move.l	sp,d2
	moveq	#4,d3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalModuleIdDone
	cmp.l	#"IMPM",(sp)
	beq.s	ExternalModuleIdOk
ExternalModuleIdDone:	moveq	#0,d0
ExternalModuleIdOk:	addq.l	#4,sp
	movem.l	(sp)+,d2-d3/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be loaded
;	A1.L	=	APTR to target module structure or NULL to create new
;	A2.L	=	APTR to loading flag pass structure (Loader specific)
;	D0.L	=	Number of module to be loaded (NULL is the first)
;	OUTPUT
;	D0.L	=	APTR to module structure where loaded module data is
ExternalModuleLoad:	movem.l	d2-d7/a2-a6,-(sp)
	lea	-626(sp),sp
	moveq	#4,d0
	moveq	#0,d1
	moveq	#0,d7
CreateBitTable:	tst.l	(a2)+
	beq.s	BitNotSet
	bset	d1,d7
BitNotSet:	addq.b	#1,d1
	dbra	d0,CreateBitTable
	move.l	(a2)+,558(sp)
	move.l	(a2)+,562(sp)
	tst.l	(a2)
	beq.s	NotSetLimit
	bset	#7,d7
NotSetLimit:	move.l	a0,d1
	move.l	sp,d2
	moveq	#192/2,d3
	add.l	d3,d3
	move.l	d1,a2
	move.l	a1,a3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadErr4
	move.l	a6,a5
	move.w	42(sp),d0
	rol.w	#8,d0
	cmp.w	#$0215,d0
	seq	608(sp)
	cmp.w	#$0216,d0
	bhi	ExternalLoadWrongVersion
	moveq	#(48-32)/2-1,d0
	lea	32(sp),a0
PrepareIntel:	move.w	(a0),d1
	rol.w	#8,d1
	move.w	d1,(a0)+
	dbra	d0,PrepareIntel
	lea	192(sp),a0
	move.l	(a2),d1
	move.l	a0,d2
	move.l	tcb_DOSBase(a5),a6
	jsr	_LVOExamineFH(a6)
	btst	#4,d7
	beq.s	NotDetectChannels
	moveq	#64,d0
	lea	128(sp),a0
DetectChannels:	tst.b	-(a0)
	bpl.s	ChannelsFound
	subq.w	#1,d0
	bne.s	DetectChannels
	bra	ExternalLoadErr4
ChannelsFound:	move.l	d0,558(sp)
NotDetectChannels:	move.w	32(sp),d0
	mulu.w	558+2(sp),d0
	add.l	d0,d0
	move.l	#MEMF_PUBLIC|MEMF_CLEAR,d1
	move.l	4.w,a6
	jsr	_LVOAllocVec(a6)
	move.l	a5,a6
	move.l	d0,566(sp)
	beq	ExternalLoadErr4
	btst	#2,45(sp)
	bne.s	NotSmpMode
	move.l	558(sp),562(sp)
NotSmpMode:	move.l	562(sp),d0
	jsr	_LVOAllocTCModule(a6)
	move.l	d0,d1
	beq	ExternalLoadErr3
	move.l	d0,a4
	lea	tcm_Name(a4),a0
	lea	4(sp),a1
	clr.b	30(a1)
	jsr	_LVOSetString(a6)
	lea	tcm_BeginDate(a4),a0
	lea	192+fib_DateStamp(sp),a1
	jsr	_LVOStamp2Date(a6)
	lea	tcm_EndDate(a4),a0
	lea	192+fib_DateStamp(sp),a1
	jsr	_LVOStamp2Date(a6)
	move.l	558(sp),d0
	moveq	#1,d1
	moveq	#1,d2
	jsr	_LVOAllocSong(a6)
	move.l	d0,d1
	beq	ExternalLoadErr2
	move.l	d0,a1
	moveq	#0,d0
	btst	#3,45(sp)
	beq.s	AmigaFreqTable
	moveq	#TCSOF_LinearFreqTable,d0
AmigaFreqTable:	btst	#0,45(sp)
	bne.s	StereoIT
	addq.b	#TCSOF_Mono,d0
StereoIT:	move.b	d0,tcso_Flags(a1)
	moveq	#TCSOCF_Sync,d0
	btst	#3,d7
	bne.s	UseOldVolumes
	addq.b	#TCSOCF_OldVolumes,d0
UseOldVolumes:	move.b	d0,tcso_CompFlags(a1)
	move.l	#32<<16|255,tcso_BPMSpeedLowerLimit(a1)
	lea	50(sp),a0
	move.b	48(sp),d0
	btst	#3,d7
	beq.s	Bit6GlobalVolume
	add.b	d0,d0
	bcc.s	LoadGlobalVolume
	moveq	#-1,d0
	bra.s	LoadGlobalVolume
Bit6GlobalVolume:	addq.w	#1,d0
	lsr.w	#1,d0
LoadGlobalVolume:	move.b	d0,tcso_GlobalVolume(a1)
	move.b	(a0)+,tcso_Frames+1(a1)
	move.b	(a0)+,tcso_BPMSpeed+1(a1)
	move.b	#128,d0
	sub.b	(a0)+,d0
	move.b	d0,tcso_GlobalPanning(a1)
	move.l	a4,a0
	jsr	_LVOAddSong(a6)
	lea	([tcm_SongList.w,a4],tcso_Name.w),a0
	move.l	tcm_Name(a4),a1
	jsr	_LVOSetString(a6)
	move.l	tcm_SongList(a4),a1
	lea	([tcm_SongList.w,a4],tcso_BeginDate.w),a0
	lea	192+fib_DateStamp(sp),a1
	jsr	_LVOStamp2Date(a6)
	lea	([tcm_SongList.w,a4],tcso_EndDate.w),a0
	lea	192+fib_DateStamp(sp),a1
	jsr	_LVOStamp2Date(a6)
	move.l	a6,a5
	btst	#0,47(sp)
	beq	NoSongMessage
	move.l	a2,d1
	move.l	56(sp),d2
	rol.w	#8,d2
	swap	d2
	rol.w	#8,d2
	moveq	#OFFSET_BEGINNING,d3
	jsr	_LVOCSeek(a6)
	move.l	d0,d4
	addq.l	#1,d0
	beq	ExternalLoadErr2
	moveq	#0,d0
	move.w	54(sp),d0
	rol.w	#8,d0
	jsr	_LVOAllocPMem(a6)
	move.l	d0,d2
	beq	ExternalLoadErr2
	move.l	a2,d1
	moveq	#0,d3
	move.w	54(sp),d3
	rol.w	#8,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	beq.s	SongMsgOk
MsgMemErr:	moveq	#0,d0
	move.w	54(sp),d0
	rol.w	#8,d0
	move.l	d2,a1
	jsr	_LVOFreePMem(a6)
	bra	ExternalLoadErr2
SongMsgOk:	moveq	#13,d1
	move.l	d3,d5
	move.l	d2,a0
CheckCRLoop:	move.b	(a0)+,d0
	beq.s	CheckCRDone
	cmp.b	d1,d0
	bne.s	CheckCRLoop
	cmp.b	#10,(a0)
	beq.s	CheckCRLoop
	addq.l	#1,d3
	bra.s	CheckCRLoop
CheckCRDone:	cmp.l	d5,d3
	beq.s	CorrectMsgSize
	move.l	d3,d0
	jsr	_LVOAllocPMem(a6)
	move.l	d0,d3
	beq.s	MsgMemErr
	moveq	#13,d1
	moveq	#10,d5
	move.l	d2,a0
	move.l	d3,a1
CopyCorrectMsgLoop:	move.b	(a0)+,d0
	beq.s	CopyCorrectMsgDone
	move.b	d0,(a1)+
	cmp.b	d1,d0
	bne.s	CopyCorrectMsgLoop
	cmp.b	(a0),d5
	beq.s	CopyCorrectMsgLoop
	move.b	d5,(a1)+
	bra.s	CopyCorrectMsgLoop
CopyCorrectMsgDone:	move.l	d2,a1
	moveq	#0,d0
	move.w	54(sp),d0
	rol.w	#8,d0
	move.l	d2,a1
	jsr	_LVOFreePMem(a6)
	move.l	d3,d2
CorrectMsgSize:	move.l	d2,([tcm_SongList.w,a4],tcso_Message.w)
	move.l	a2,d1
	move.l	d4,d2
	moveq	#OFFSET_BEGINNING,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalLoadErr2
NoSongMessage:	moveq	#0,d3
	move.w	32(sp),d3
	move.l	d3,d0
	moveq	#MEMF_PUBLIC,d1
	move.l	4.w,a6
	jsr	_LVOAllocVec(a6)
	move.l	d0,d2
	beq	ExternalLoadErr2
	move.l	a2,d1
	move.l	a5,a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	beq.s	ReadOrderOk
	move.l	d2,a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
	move.l	a5,a6
	bra	ExternalLoadErr2
ReadOrderOk:	move.w	d3,d0
	move.l	558(sp),d6
	move.w	38(sp),d4
	moveq	#0,d5
	move.l	d2,a0
	move.l	566(sp),a1
GetTrackReMapNums:	moveq	#0,d1
	move.b	(a0)+,d1
	cmp.b	#$fe,d1
	blo.s	NotSpecialOrder
	ext.w	d1
	move.w	d6,d3
CopySpecialOrderLoop:	move.w	d1,(a1)+
	subq.w	#1,d3
	bne.s	CopySpecialOrderLoop
	bra.s	NextOrderEntry
NotSpecialOrder:	cmp.w	d4,d1
	blo.s	NotMoreOrders
	move.w	d1,d4
	addq.w	#1,d4
NotMoreOrders:	move.w	d6,d3
	mulu.w	d3,d1
GetTrackReMapLoop:	move.w	d1,(a1)+
	addq.w	#1,d1
	subq.w	#1,d3
	bne.s	GetTrackReMapLoop
NextOrderEntry:	subq.w	#1,d0
	bne.s	GetTrackReMapNums
	move.l	d2,a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
	move.w	34(sp),d0
	bne.s	InvalidVal
	moveq	#1,d0
InvalidVal:	lsl.l	#2,d0
	moveq	#MEMF_PUBLIC,d1
	jsr	_LVOAllocVec(a6)
	move.l	d0,578(sp)
	beq	ExternalLoadErr2
	moveq	#0,d0
	move.w	36(sp),d0
	bne.s	InvalidVal2
	moveq	#1,d0
InvalidVal2:	lsl.l	#2,d0
	moveq	#MEMF_PUBLIC,d1
	jsr	_LVOAllocVec(a6)
	move.l	d0,574(sp)
	beq	ExternalLoadErr17
	moveq	#0,d0
	move.w	38(sp),d0
	bne.s	InvalidVal3
	moveq	#1,d0
InvalidVal3:	lsl.l	#2,d0
	moveq	#MEMF_PUBLIC,d1
	jsr	_LVOAllocVec(a6)
	move.l	d0,570(sp)
	beq	ExternalLoadErr16
	move.l	a5,a6
	move.l	a2,d1
	move.l	578(sp),d2
	move.w	34(sp),d3
	lsl.l	#2,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadErr15
	move.l	a2,d1
	move.l	574(sp),d2
	moveq	#0,d3
	move.w	36(sp),d3
	lsl.l	#2,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadErr15
	move.l	a2,d1
	move.l	570(sp),d2
	moveq	#0,d3
	move.w	38(sp),d3
	lsl.l	#2,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadErr15
	move.l	a4,24(sp)
DecrunchPatternLoop:	cmp.w	38(sp),d5
	bhs.s	IsEmptyPatt
	move.l	570(sp),a0
	move.l	(a0,d5.w*4),d2
	bne.s	LongOffsetOk
IsEmptyPatt:	move.l	#$4000,(sp)
	moveq	#64,d0
	move.l	#MEMF_PUBLIC|MEMF_CLEAR,d1
	bra.s	DoPatternAlloc
LongOffsetOk:	move.l	a2,d1
	rol.w	#8,d2
	swap	d2
	rol.w	#8,d2
	moveq	#OFFSET_BEGINNING,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalLoadErr1
	move.l	a2,d1
	move.l	sp,d2
	moveq	#8,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadErr1
	tst.b	d7
	bpl.s	NotCheckPattLen
	move.w	2(sp),d0
	rol.w	#8,d0
	cmp.w	#200,d0
	bhi.s	IsEmptyPatt
NotCheckPattLen:	move.w	(sp),d0
	rol.w	#8,d0
	moveq	#MEMF_PUBLIC,d1
DoPatternAlloc:	move.l	4.w,a6
	jsr	_LVOAllocVec(a6)
	move.l	d0,d2
	beq	ExternalLoadErr1
	move.l	a5,a6
	moveq	#0,d3
	move.w	(sp),d3
	beq.s	DePackPattern
	rol.w	#8,d3
	move.l	a2,d1
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadError
	moveq	#(64/4)-1,d0
	lea	192(sp),a0
ClearStackLoop:	clr.l	(a0)+
	dbra	d0,ClearStackLoop
DePackPattern:	move.l	558(sp),d3
AllocTrackLoop:	moveq	#0,d0
	move.w	2(sp),d0
	rol.w	#8,d0
	jsr	_LVOAllocTrack(a6)
	move.l	d0,d1
	beq	ExternalLoadError
	move.l	d0,a1
	move.l	tcm_SongList(a4),a0
	move.b	#TCTCF_Slide|TCTCF_VolSlide,d0
	btst	#4,45(sp)
	bne.s	OldEffects
	addq.b	#TCTCF_SOffset,d0
OldEffects:	btst	#5,45(sp)
	beq.s	OldTPorta
	addq.b	#TCTCF_TPorta,d0
OldTPorta:	move.b	d0,tct_CompFlags(a1)
	jsr	_LVOAddTrack(a6)
	subq.w	#1,d3
	bne.s	AllocTrackLoop
	movem.l	d4-d6/a2-a4/a6,4(sp)
	move.w	2(sp),d4
	rol.w	#8,d4
	moveq	#0,d5
	move.l	d2,a2
GetNextRow2:	move.l	558(sp),d1
	move.l	tcm_SongList(a4),a3
	lea	tcso_TrackList+MLH_TAIL(a3),a3
ResetDepackTrack:	move.l	MLN_PRED(a3),a3
	move.l	#$0000ff00,tct_Reserved(a3)
	clr.w	tct_Reserved+4(a3)
	subq.w	#1,d1
	bne.s	ResetDepackTrack
GetNextRow:	move.b	(a2)+,d0
	move.l	558(sp),d1
	move.l	tcm_SongList(a4),a3
	lea	tcso_TrackList+MLH_TAIL(a3),a3
FindCorrectTrack:	move.l	MLN_PRED(a3),a3
NotNewRow:	dbra	d1,FindCorrectTrack
	move.b	d0,d6
	subq.b	#1,d0
	and.w	#63,d0
	lea	192(sp),a0
	add.w	d0,a0
FindChannel:	move.l	(a3),a3
	tst.l	(a3)
	beq.s	BadChannel
	dbra	d0,FindChannel
	lea	tct_Reserved+6(a3),a1
	move.w	-(a1),192+64+4(sp)
	move.l	-(a1),192+64(sp)
	move.l	tct_Data(a3),a3
	add.l	d5,a3
BadChannel:	move.b	(a0),d1
	tst.b	d6
	bpl.s	NotNewMask
	move.b	(a2)+,d1
	move.b	d1,(a0)
NotNewMask:	btst	#0,d1
	beq.s	NotNote
	move.b	(a2)+,192+64(sp)
	st	192+64+3(sp)
NotNote:	btst	#1,d1
	beq.s	NotInstr
	move.b	(a2)+,192+64+1(sp)
NotInstr:	btst	#2,d1
	beq.s	NotVolCol
	move.b	(a2)+,192+64+2(sp)
NotVolCol:	btst	#3,d1
	beq.s	NotFX
	move.w	(a2)+,192+64+4(sp)
NotFX:	tst.b	d6
	beq	GetRowDone
	tst.w	d0
	bpl.s	GetNextRow
	lsr.b	#1,d1
	bcc.s	NotCorNote
	move.b	192+64(sp),(a1)
	move.b	(a1),6(a1)
	move.b	192+64+3(sp),3(a1)
	move.b	3(a1),6+3(a1)
NotCorNote:	lsr.b	#1,d1
	bcc.s	NotCorInst
	move.b	192+64+1(sp),1(a1)
	move.b	1(a1),6+1(a1)
NotCorInst:	lsr.b	#1,d1
	bcc.s	NotCorVolCol
	move.b	192+64+2(sp),2(a1)
	move.b	2(a1),6+2(a1)
NotCorVolCol:	lsr.b	#1,d1
	bcc.s	NotCorFX
	move.w	192+64+4(sp),4(a1)
	move.w	4(a1),6+4(a1)
NotCorFX:	lsr.b	#1,d1
	bcc.s	NotLastNote
	move.b	6(a1),(a1)
	move.b	6+3(a1),3(a1)
NotLastNote:	lsr.b	#1,d1
	bcc.s	NotLastInstr
	move.b	6+1(a1),1(a1)
NotLastInstr:	lsr.b	#1,d1
	bcc.s	NotLastVolCol
	move.b	6+2(a1),2(a1)
NotLastVolCol:	lsr.b	#1,d1
	bcc.s	NotLastFX
	move.w	6+4(a1),4(a1)
NotLastFX:	move.w	4(a1),192+64+4(sp)
	moveq	#0,d0
	move.b	(a1)+,d0
	tst.b	2(a1)
	beq.s	NoNote
	cmp.b	#254,d0
	beq.s	NoteCut
	cmp.b	#255,d0
	bne.s	NotKeyoff
	moveq	#255-NOTE_KEYOFF,d0
SpecialNote:	not.b	d0
NoNote:	move.w	d0,(a3)+
	bra.s	NoteDone
NoteCut:	moveq	#255-NOTE_KILL,d0
	bra.s	SpecialNote
NotKeyoff:	cmp.b	#120,d0
	bcs.s	NormalNote
	moveq	#255-NOTE_FADE,d0
	bra.s	NoNote
NormalNote:	divu.w	#12,d0
	move.b	d0,(a3)+
	swap	d0
	addq.b	#1,d0
	move.b	d0,(a3)+
NoteDone:	moveq	#0,d0
	move.b	(a1)+,d0
	move.w	d0,(a3)+
	moveq	#0,d6
	move.b	(a1)+,d6
	cmp.b	#65,d6
	bcc.s	NotSetVolume
	moveq	#FX_SET_VOLUME,d0
ProcessVolCol:	tst.b	d7
	beq.s	NotVolFF
	lsl.b	#2,d6
	bcc.s	NotVolFF
	moveq	#-1,d6
NotVolFF:	bra	SetVolCol
NotSetVolume:	moveq	#10,d1
	sub.b	#75,d6
	bcc.s	NotFineVolUp
	moveq	#FX_F_VOLSL_UP,d0
ProcessVolSlide:	add.b	d1,d6
	bra.s	ProcessVolCol
NotFineVolUp:	sub.b	d1,d6
	bcc.s	NotFineVolDn
	moveq	#FX_F_VOLSL_DOWN,d0
	bra.s	ProcessVolSlide
NotFineVolDn:	sub.b	d1,d6
	bcc.s	NotVolSlUp
	moveq	#FX_VOL_SLD_UP,d0
	bra.s	ProcessVolSlide
NotVolSlUp:	sub.b	d1,d6
	bcc.s	NotVolSlDn
	moveq	#FX_VOL_SLD_DOWN,d0
	bra.s	ProcessVolSlide
NotVolSlDn:	sub.b	d1,d6
	bcc.s	NotPortaUp
	add.b	d1,d6
	moveq	#FX_PORTA_UP,d0
	bra.s	SetVolCol
NotPortaUp:	sub.b	d1,d6
	bcc.s	NotPortaDn
	add.b	d1,d6
	moveq	#FX_PORTA_DOWN,d0
	bra.s	SetVolCol
NotPortaDn:	cmp.b	#193-125,d6
	bcc.s	NotPanning
	subq.b	#128-125,d6
	bcs.s	NoVolumeColumn
	lsl.b	#2,d6
	bcc.s	NotRightVolPan
	moveq	#-1,d6
NotRightVolPan:	moveq	#FX_SET_PANNING,d0
	bra.s	SetVolCol
NotPanning:	sub.b	#203-125,d6
	bcc.s	NotTonePorta
	moveq	#FX_TONE_PORTA,d0
	add.b	d1,d6
	bra.s	SetVolCol
NotTonePorta:	sub.b	d1,d6
	bcc.s	NoVolumeColumn
	add.b	d1,d6
	add.b	d6,d6
	btst	#4,45(sp)
	bne.s	SetVibrato
	lsr.b	#1,d6
	neg.b	d6
	moveq	#FX_EXECUTE_FX,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	SetVibrato
	move.l	d0,a1
	move.l	a3,a0
	jsr	_LVOAddTail(a6)
SetVibrato:	moveq	#FX_VIBRATO,d0
	bra.s	SetVibDepth
SetVolCol:	lsl.w	#8,d6
SetVibDepth:	move.w	d6,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	NoVolumeColumn
	move.l	d0,a1
	move.l	a3,a0
	jsr	_LVOAddTail(a6)
NoVolumeColumn:	moveq	#0,d0
	move.b	192+64+4(sp),d0
	beq.s	NoEffect
	moveq	#0,d6
	move.b	192+64+5(sp),d6
	cmp.b	#26,d0
	bcc.s	NoEffect
	cmp.b	#15,d0
	bne.s	NotSmpOffset
	tst.w	tctd_Octave-tctd_Effects(a3)
	beq.s	NoEffect
NotSmpOffset:	movem.w	ProcessFXTable-4(pc,d0.w*4),d0-d1
	lea	ProcessFXTable(pc),a0
	add.l	d1,a0
	move.w	d6,d1
	jsr	(a0)
	move.w	d6,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	NoEffect
	move.l	d0,a1
	move.l	a3,a0
	jsr	_LVOAddTail(a6)
NoEffect:	bra	GetNextRow
ProcessFXTable:	dc.w	FX_SET_TEMPO,SetTempo-ProcessFXTable
	dc.w	FX_POS_JUMP,PosJump-ProcessFXTable
	dc.w	FX_PATT_BREAK,PosJump-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,SmpVolumeSlide-ProcessFXTable
	dc.w	FX_PORTA_DOWN,Porta-ProcessFXTable
	dc.w	FX_PORTA_UP,Porta-ProcessFXTable
	dc.w	FX_TONE_PORTA,TonePorta-ProcessFXTable
	dc.w	FX_VIBRATO,Vibrato-ProcessFXTable
	dc.w	FX_TREMOR,Tremor-ProcessFXTable
	dc.w	FX_ARPEGGIO,Arpeggio-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,VibFade-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,ToneFade-ProcessFXTable
	dc.w	FX_SET_TRK_VOL,SetVolume-ProcessFXTable
	dc.w	FX_TVOL_SL_UP,VolumeSlide-ProcessFXTable
	dc.w	FX_SMP_OFF_LOW,TonePorta-ProcessFXTable
	dc.w	FX_PAN_SL_LEFT,PanningSlide-ProcessFXTable
	dc.w	FX_MULTI_RETRIG,MultiRetrig-ProcessFXTable
	dc.w	FX_TREMOLO,Tremolo-ProcessFXTable
	dc.w	0,Extended-ProcessFXTable
	dc.w	FX_SET_SPEED,SetBPM-ProcessFXTable
	dc.w	FX_FINE_VIBRATO,Vibrato-ProcessFXTable
	dc.w	FX_SET_G_VOLUME,SetGVolume-ProcessFXTable
	dc.w	FX_G_VOLSL_UP,GVolumeSlide-ProcessFXTable
	dc.w	FX_SET_PANNING,TonePorta-ProcessFXTable
	dc.w	FX_PANNOLO,Pannolo-ProcessFXTable
ExtendedFXTable:	dc.w	0,NoFX-ExtendedFXTable
	dc.w	FX_EXTEND_CTRL,GlissCtrl-ExtendedFXTable
	dc.w	FX_SET_TRANSP,SetFineTune-ExtendedFXTable
	dc.w	$0302,EnvCtrl-ExtendedFXTable
	dc.w	$0402,EnvCtrl-ExtendedFXTable
	dc.w	$0502,EnvCtrl-ExtendedFXTable
	dc.w	FX_F_PATT_DELAY,PosJump-ExtendedFXTable
	dc.w	FX_ENV_CONTROL,SpecialIT-ExtendedFXTable
	dc.w	FX_SET_PANNING,SetPanning-ExtendedFXTable
	dc.w	FX_CHANNEL_CTRL,SetSurround-ExtendedFXTable
	dc.w	FX_SMP_OFF_HIGH,PosJump-ExtendedFXTable
	dc.w	FX_PATT_LOOP,PosJump-ExtendedFXTable
	dc.w	FX_NOTE_CUT,PosJump-ExtendedFXTable
	dc.w	FX_NOTE_DELAY,PosJump-ExtendedFXTable
	dc.w	FX_PATT_DELAY,PosJump-ExtendedFXTable
	dc.w	0,NoFX-ExtendedFXTable
GetRowDone:	addq.l	#tctd_NextRow/2,d5
	addq.l	#tctd_NextRow/2,d5
	subq.w	#1,d4
	bne	GetNextRow2
	move.l	d2,a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
	movem.l	4(sp),d4-d6/a2-a4/a6
	move.l	tcm_SongList(a4),a4
	lea	tcso_TrackList(a4),a2
CmpMainLoop:	move.l	(a2),a2
	tst.l	(a2)
	beq.s	CmpAllDone
	lea	tct_Reserved(a2),a0
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)
	lea	tcso_TrackList+MLH_TAIL(a4),a3
	move.l	558(sp),d0
FindPatternLoop:	move.l	MLN_PRED(a3),a3
	tst.l	MLN_PRED(a3)
	beq.s	CompareTracksLoop
	dbra	d0,FindPatternLoop
CompareTracksLoop:	move.l	(a3),a3
	tst.l	(a3)
	beq.s	CmpMainLoop
	cmp.l	a3,a2
	beq.s	CompareTracksLoop
	move.l	a3,a0
	move.l	a2,a1
	jsr	_LVOCmpTracks(a6)
	tst.l	d0
	bne.s	CompareTracksLoop
	move.l	a4,a0
	move.l	a3,a1
	jsr	_LVOGetTrackNum(a6)
	subq.w	#1,d0
	move.w	d0,d2
	move.l	a3,a0
	jsr	_LVOFreeTrack(a6)
	move.l	a4,a0
	move.l	a2,a1
	jsr	_LVOGetTrackNum(a6)
	subq.w	#1,d0
	move.w	32(sp),d1
	mulu.w	558+2(sp),d1
	move.l	566(sp),a0
ReMapOrderList:	cmp.w	#$fffe,(a0)
	bhs.s	ReMapOrderNotSub
	cmp.w	(a0),d2
	bne.s	ReMapOrderEqual
	move.w	d0,(a0)
ReMapOrderEqual:	bhs.s	ReMapOrderNotSub
	subq.w	#1,(a0)
ReMapOrderNotSub:	addq.l	#2,a0
	subq.l	#1,d1
	bne.s	ReMapOrderList
	move.l	MLN_PRED(a2),a2
	bra.s	CmpMainLoop
CmpAllDone:	movem.l	16(sp),a2-a4
	addq.w	#1,d5
	cmp.w	d5,d4
	bne	DecrunchPatternLoop
DecrunchPatternDone:	move.w	32(sp),d2
	moveq	#0,d3
	move.l	558(sp),d4
	move.w	d4,d6
	subq.l	#1,d4
	move.l	566(sp),a2
	move.l	tcm_SongList(a4),a4
	move.l	tcso_Position(a4),a3
SetOrderList:	moveq	#0,d5
SetPositions:	jsr	_LVOAllocPositionList(a6)
	move.l	d0,d1
	beq	ExternalLoadErr1
	move.l	d0,a1
	moveq	#0,d0
	move.l	a3,a0
	jsr	_LVOAddPositionList(a6)
	move.w	d5,d1
	mulu.w	d6,d1
	moveq	#0,d0
	move.w	(a2,d1.l*2),d0
	cmp.w	#$fffe,d0
	beq.s	NotSetNextOrder
	cmp.w	#$ffff,d0
	bne.s	NotSongEnd
	move.l	MLH_TAILPRED(a3),a0
	move.b	#TCOLF_EndOrder,tcol_Flags(a0)
	bra.s	NotSetNextOrder
NotSongEnd:	addq.l	#1,d0
	move.l	a4,a0
	jsr	_LVOGetTrackAddr(a6)
	move.l	MLH_TAILPRED(a3),a0
	move.l	d0,tcol_Track(a0)
NotSetNextOrder:	move.l	MLN_PRED(a0),a1
	tst.l	MLN_PRED(a1)
	beq.s	NotSetPrevOrder
	move.l	a1,tcol_PrevPos(a0)
	move.l	a0,tcol_NextPos(a1)
NotSetPrevOrder:	addq.w	#1,d5
	cmp.w	d5,d2
	bne.s	SetPositions
	move.l	MLH_TAILPRED(a3),a0
	move.l	(a3),a1
	move.l	a1,tcol_PrevPos(a1)
	move.l	a1,tcol_NextPos(a0)
	lea	64(sp,d3.w),a0
	move.b	(a0),d0
	moveq	#255-128,d1
	not.b	d1
	bclr	#7,d0
	beq.s	NotMuted
	move.b	#TCOF_Muted,tco_Flags(a3)
NotMuted:	cmp.b	#100,d0
	beq.s	GetLRLoadPanInfoOk
	move.b	d0,d1
	lsl.b	#2,d1
	bcc.s	GetLRLoadPanInfoOk
	moveq	#-1,d1
GetLRLoadPanInfoOk:	move.b	d1,tco_Panning(a3)
	cmp.b	#100,d0
	bne.s	NotSurroundTrack
	addq.b	#TCOF_Surround,tco_Flags(a3)
NotSurroundTrack:	move.b	64(a0),d0
	btst	#3,d7
	beq.s	NotOrderMaxVol
	lsl.b	#2,d0
	bcc.s	NotOrderMaxVol
	moveq	#-1,d0
NotOrderMaxVol:	move.b	d0,tco_Volume(a3)
	lea	tco_NextOrderx(a3),a3
	addq.l	#2,a2
	addq.w	#1,d3
	dbra	d4,SetOrderList
	movem.l	16(sp),a2-a4
	moveq	#0,d3
	clr.l	582(sp)
	clr.l	604(sp)
	move.l	#$80000080,d2
	btst	#1,d7
	beq	NoVibratoEnvelopes
	move.l	#$100,d0
	moveq	#ENVL_SINE,d1
	moveq	#DEFAULT_ENVNODES,d4
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,582(sp)
	beq	ExternalLoadErr2
	move.l	d0,a1
	bset	#TCIEB_Loop,tcie_Flags+1(a1)
	move.w	tcie_NumPoints(a1),tcie_LoopEnd(a1)
	subq.w	#1,tcie_LoopEnd(a1)
	move.l	a4,a0
	jsr	_LVOAddEnvelope(a6)
	move.l	#$100,d0
	moveq	#ENVL_RAMP,d1
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,d1
	beq	ExternalLoadErr2
	move.l	d0,a1
	bset	#TCIEB_Loop,tcie_Flags+1(a1)
	move.w	tcie_NumPoints(a1),tcie_LoopEnd(a1)
	subq.w	#1,tcie_LoopEnd(a1)
	move.l	a4,a0
	jsr	_LVOAddEnvelope(a6)
	move.l	#$100,d0
	moveq	#ENVL_SQUARE,d1
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,d1
	beq	ExternalLoadErr2
	move.l	d0,a1
	bset	#TCIEB_Loop,tcie_Flags+1(a1)
	move.w	tcie_NumPoints(a1),tcie_LoopEnd(a1)
	subq.w	#1,tcie_LoopEnd(a1)
	move.l	a4,a0
	jsr	_LVOAddEnvelope(a6)
NoVibratoEnvelopes:	move.l	#$80000100,d2
	btst	#2,d7
	beq.s	NoTremoloEnvelopes
	moveq	#0,d0
	move.w	d2,d0
	moveq	#ENVL_SINE,d1
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,604(sp)
	beq	ExternalLoadErr2
	move.l	d0,a1
	bset	#TCIEB_Loop,tcie_Flags+1(a1)
	move.w	tcie_NumPoints(a1),tcie_LoopEnd(a1)
	subq.w	#1,tcie_LoopEnd(a1)
	move.l	a4,a0
	jsr	_LVOAddEnvelope(a6)
	moveq	#0,d0
	move.w	d2,d0
	moveq	#ENVL_RAMP,d1
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,d1
	beq	ExternalLoadErr2
	move.l	d0,a1
	bset	#TCIEB_Loop,tcie_Flags+1(a1)
	move.w	tcie_NumPoints(a1),tcie_LoopEnd(a1)
	subq.w	#1,tcie_LoopEnd(a1)
	move.l	a4,a0
	jsr	_LVOAddEnvelope(a6)
	moveq	#0,d0
	move.w	d2,d0
	moveq	#ENVL_SQUARE,d1
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,d1
	beq	ExternalLoadErr2
	move.l	d0,a1
	bset	#TCIEB_Loop,tcie_Flags+1(a1)
	move.w	tcie_NumPoints(a1),tcie_LoopEnd(a1)
	subq.w	#1,tcie_LoopEnd(a1)
	move.l	a4,a0
	jsr	_LVOAddEnvelope(a6)
NoTremoloEnvelopes:	movem.l	a2-a4,588(sp)
	move.l	44(sp),554(sp)
	move.w	34(sp),586(sp)
	move.w	34(sp),562(sp)
	btst	#2,45(sp)
	seq	559(sp)
	move.w	36(sp),d0
	cmp.w	34(sp),d0
	bls.s	MoreInstrsSmp
	move.w	d0,562(sp)
	beq	NoLoadSamples
MoreInstrsSmp:	clr.w	600(sp)
	move.w	36(sp),602(sp)
	cmp.w	#$0200,42(sp)
	scc	558(sp)
LoadInstrLoop:	move.l	578(sp),a0
	move.w	600(sp),d0
	cmp.w	586(sp),d0
	bhs.s	NotLoadInstr
	move.l	a2,d1
	move.l	(a0,d0.w*4),d2
	rol.w	#8,d2
	swap	d2
	rol.w	#8,d2
	moveq	#OFFSET_BEGINNING,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalLoadErr2
	move.l	a2,d1
	move.l	sp,d2
	move.l	#554,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadErr2
NotLoadInstr:	moveq	#0,d0
	jsr	_LVOAllocInstr(a6)
	move.l	d0,d1
	beq	ExternalLoadErr2
	move.l	d0,a1
	move.w	#~(TCIEPF_ProcVolumeEnv|TCIEPF_ProcPanningEnv|TCIEPF_ProcSlideEnv|$8000),tci_EnvProcFlags(a1)
	move.l	a4,a0
	jsr	_LVOAddInstr(a6)
	move.l	tcm_InstrList+MLH_TAILPRED(a4),a3
	lea	tci_VibratoEnvelope(a3),a0
	move.l	582(sp),d0
	move.l	d0,(a0)+
	move.l	604(sp),d1
	beq.s	UseVibEnv
	move.l	d1,d0
UseVibEnv:	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)
	btst	#3,d7
	bne.s	NotOldGlobalVolume
	move.b	#64,tci_GlobalVolume(a3)
NotOldGlobalVolume:	move.w	600(sp),d0
	cmp.w	586(sp),d0
	bhs	NotLoadKeyboard
	lea	tci_FileName(a3),a0
	lea	4(sp),a1
	jsr	_LVOSetString(a6)
	lea	32(sp),a1
	lea	58(sp),a0
	clr.b	(a0)
FindInstNameNonNull:	cmp.l	a0,a1
	beq.s	FindInstNameDone
	tst.b	-(a0)
	beq.s	FindInstNameNonNull
ReplaceInstNameNulls:	cmp.l	a0,a1
	beq.s	FindInstNameOk
	tst.b	-(a0)
	bne.s	ReplaceInstNameNulls
	move.b	#" ",(a0)
	bra.s	ReplaceInstNameNulls
FindInstNameOk:	lea	tci_Name(a3),a0
	jsr	_LVOSetString(a6)
FindInstNameDone:	moveq	#0,d0
	lea	304(sp),a0
	tst.b	558(sp)
	bne	LoadNewInstr
	moveq	#0,d0
	move.w	#200-1,d1
GetEnvLen:	addq.l	#1,d0
	cmp.b	#$ff,(a0)+
	dbeq	d1,GetEnvLen
	bne.s	OldEnvEndFound
	subq.l	#1,d0
OldEnvEndFound:	moveq	#25-1,d1
	moveq	#-1,d4
	lea	504(sp),a0
OldEnvGetNumNodes:	addq.l	#1,d4
	cmp.w	#$ffff,(a0)+
	dbeq	d1,OldEnvGetNumNodes
	moveq	#ENVL_EMPTY,d1
	move.l	d0,d2
	moveq	#0,d3
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,tci_VolumeEnvelope(a3)
	beq	ExternalLoadErr2
	move.l	d0,a1
	move.l	a1,(sp)
	move.l	a4,a0
	jsr	_LVOAddEnvelope(a6)
	moveq	#25-1,d1
	lea	504(sp),a0
	move.l	(sp),a1
	move.l	tcie_NodePoints(a1),a1
OldEnvCopyNodes:	move.w	(a0)+,d0
	cmp.w	#$ffff,d0
	beq.s	OldEnvCopyNodesDone
	lsr.w	#8,d0
	move.w	d0,(a1)+
	dbra	d1,OldEnvCopyNodes
OldEnvCopyNodesDone:	move.l	(sp),a1
	moveq	#0,d0
	lea	17(sp),a0
	move.l	a5,(sp)
	lea	504(sp),a5
	btst	#0,(a0)
	bne.s	OldVolEnvUsed
	clr.w	tcie_Tempo(a1)
OldVolEnvUsed:	btst	#1,(a0)
	beq.s	NotUseVolLoop
	addq.b	#TCIEF_Loop,d0
NotUseVolLoop:	btst	#2,(a0)+
	beq.s	NotUseSusVolLoop
	addq.b	#TCIEF_Sustain,d0
NotUseSusVolLoop:	move.b	d0,tcie_Flags+1(a1)
	move.b	(a0)+,d0
	move.b	(a5,d0.w*2),tcie_LoopStart+1(a1)
	move.b	(a0)+,d0
	move.b	(a5,d0.w*2),tcie_LoopEnd+1(a1)
	move.b	(a0)+,d0
	move.b	(a5,d0.w*2),tcie_SustainStart+1(a1)
	move.b	(a0),d0
	move.b	(a5,d0.w*2),tcie_SustainEnd+1(a1)
	lea	304(sp),a0
	move.l	tcie_Data(a1),a1
CopyOldEnvelopeLoop:	moveq	#0,d0
	move.b	(a0)+,d0
	sub.w	#32,d0
	muls.w	#$7fff,d0
	asr.l	#5,d0
	move.w	d0,(a1)+
	subq.b	#1,d2
	bne.s	CopyOldEnvelopeLoop
	move.l	tci_VolumeEnvelope(a3),a0
	jsr	_LVOValidateEnvNodes(a6)
CopyOldDone:	move.l	(sp),a5
	lea	24(sp),a0
	move.w	(a0)+,d0
	rol.w	#8,d0
	lsl.w	#7,d0
	bcc.s	OldFadeOk
	moveq	#-1,d0
OldFadeOk:	move.w	d0,tci_FadeOut(a3)
	move.b	(a0)+,tci_NNA(a3)
	move.b	(a0)+,d0
	beq.s	NotOldDCT
	moveq	#DCTF_InstrNoteOR|DCTF_InstrAND,d0
NotOldDCT:	move.b	d0,tci_DCT(a3)
	move.b	17(sp),304(sp)
	bra	CopyIdentical
LoadNewInstr:	moveq	#0,d1
	move.l	a5,(sp)
	move.b	1(a0),d1
	beq	NotConvertVolEnvData
	move.l	d1,d4
	subq.b	#1,d1
	beq	NotConvertVolEnvData
	move.b	d1,d2
	mulu.w	#3,d1
ConvertVolGetHighest:	move.w	6+1(a0,d1.w),d3
	rol.w	#8,d3
	addq.l	#1,d3
	cmp.w	d3,d0
	bhs.s	ConvertVolIsHighest
	move.w	d3,d0
ConvertVolIsHighest:	subq.w	#3,d1
	bcc.s	ConvertVolGetHighest
	moveq	#ENVL_EMPTY,d1
	moveq	#0,d3
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,tci_VolumeEnvelope(a3)
	beq	ExternalLoadErr2
	move.l	d0,a1
	move.l	a1,-(sp)
	move.l	a4,a0
	jsr	_LVOAddEnvelope(a6)
	move.l	(sp)+,a1
	lea	304(sp),a0
	btst	#0,(a0)
	bne.s	VolEnvUsed
	clr.w	tcie_Tempo(a1)
VolEnvUsed:	moveq	#0,d0
	btst	#2,(a0)
	beq.s	NotSustainEnv
	addq.b	#TCIEF_Sustain,d0
NotSustainEnv:	btst	#1,(a0)
	beq.s	NotLoopEnv
	addq.b	#TCIEF_Loop,d0
NotLoopEnv:	move.b	d0,tcie_Flags+1(a1)
	moveq	#0,d1
	moveq	#3,d3
	addq.l	#2,a0
	move.b	(a0)+,d1
	mulu.w	d3,d1
	move.w	4(a0,d1.w),d0
	rol.w	#8,d0
	move.w	d0,tcie_LoopStart(a1)
	move.b	(a0)+,d1
	mulu.w	d3,d1
	move.w	4-1(a0,d1.w),d0
	rol.w	#8,d0
	move.w	d0,tcie_LoopEnd(a1)
	move.b	(a0)+,d1
	mulu.w	d3,d1
	move.w	4-2(a0,d1.w),d0
	rol.w	#8,d0
	move.w	d0,tcie_SustainStart(a1)
	move.b	(a0)+,d1
	mulu.w	d3,d1
	move.w	4-3(a0,d1.w),d0
	rol.w	#8,d0
	move.w	d0,tcie_SustainEnd(a1)
	moveq	#32,d6
	move.l	tcie_NodePoints(a1),a5
	move.l	tcie_Data(a1),a1
ConvertEnvelopeData:	move.b	(a0)+,d1
	sub.b	d6,d1
	ext.w	d1
	muls.w	#$7fff,d1
	asr.l	#5,d1
	move.w	(a0)+,d0
	rol.w	#8,d0
	move.w	d0,(a5)+
	move.b	(a0),d4
	sub.b	d6,d4
	ext.w	d4
	muls.w	#$7fff,d4
	asr.l	#5,d4
	move.w	1(a0),d3
	rol.w	#8,d3
	bne.s	NotNullLastVol
	move.w	d0,d3
	addq.w	#1,d3
NotNullLastVol:	sub.w	d0,d3
	bls.s	NotNullLastVol2
	sub.l	d1,d4
	divs.w	d3,d4
	moveq	#0,d5
	move.w	d3,d0
	cmp.b	#1,d2
	bne.s	AddEnvelopeData
	addq.w	#1,d0
AddEnvelopeData:	move.w	d1,(a1)+
	add.w	d4,d1
	swap	d4
	add.w	d4,d5
	bpl.s	NotSubEnvData
	add.w	d3,d5
	subq.w	#1,d1
NotSubEnvData:	cmp.w	d3,d5
	bcs.s	NotAddEnvData
	sub.w	d3,d5
	addq.w	#1,d1
NotAddEnvData:	swap	d4
	subq.w	#1,d0
	bne.s	AddEnvelopeData
NotNullLastVol2:	subq.b	#1,d2
	bne.s	ConvertEnvelopeData
	move.l	tci_VolumeEnvelope(a3),a0
	jsr	_LVOValidateEnvNodes(a6)
NotConvertVolEnvData:	lea	386+1(sp),a0
	moveq	#0,d0
	moveq	#0,d1
	move.b	(a0),d1
	beq	NotConvertPanEnvData
	move.l	d1,d4
	subq.b	#1,d1
	beq	NotConvertPanEnvData
	move.w	d1,d2
	mulu.w	#3,d1
ConvertPanGetHighest:	move.w	6(a0,d1.w),d3
	rol.w	#8,d3
	addq.l	#1,d3
	cmp.w	d3,d0
	bhs.s	ConvertPanIsHighest
	move.w	d3,d0
ConvertPanIsHighest:	subq.w	#3,d1
	bcc.s	ConvertPanGetHighest
	moveq	#ENVL_EMPTY,d1
	moveq	#0,d3
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,tci_PanningEnvelope(a3)
	beq	ExternalLoadErr2
	move.l	d0,a1
	move.l	a1,-(sp)
	move.l	a4,a0
	jsr	_LVOAddEnvelope(a6)
	move.l	(sp)+,a1
	lea	386(sp),a0
	btst	#0,(a0)
	bne.s	PanEnvUsed
	clr.w	tcie_Tempo(a1)
PanEnvUsed:	moveq	#0,d0
	btst	#2,(a0)
	beq.s	NotPanSustainEnv
	addq.b	#TCIEF_Sustain,d0
NotPanSustainEnv:	btst	#1,(a0)
	beq.s	NotLoopPanEnv
	addq.b	#TCIEF_Loop,d0
NotLoopPanEnv:	move.b	d0,tcie_Flags+1(a1)
	moveq	#0,d1
	moveq	#3,d3
	addq.l	#2,a0
	move.b	(a0)+,d1
	mulu.w	d3,d1
	move.w	4(a0,d1.w),d0
	rol.w	#8,d0
	move.w	d0,tcie_LoopStart(a1)
	move.b	(a0)+,d1
	mulu.w	d3,d1
	move.w	4-1(a0,d1.w),d0
	rol.w	#8,d0
	move.w	d0,tcie_LoopEnd(a1)
	move.b	(a0)+,d1
	mulu.w	d3,d1
	move.w	4-2(a0,d1.w),d0
	rol.w	#8,d0
	move.w	d0,tcie_SustainStart(a1)
	move.b	(a0)+,d1
	mulu.w	d3,d1
	move.w	4-3(a0,d1.w),d0
	rol.w	#8,d0
	move.w	d0,tcie_SustainEnd(a1)
	move.l	tcie_NodePoints(a1),a5
	move.l	tcie_Data(a1),a1
ConvertPanEnvelopeData:	move.b	(a0)+,d1
	ext.w	d1
	muls.w	#$7fff,d1
	asr.l	#5,d1
	move.w	(a0)+,d0
	rol.w	#8,d0
	move.w	d0,(a5)+
	move.b	(a0),d4
	ext.w	d4
	muls.w	#$7fff,d4
	asr.l	#5,d4
	move.w	1(a0),d3
	rol.w	#8,d3
	bne.s	NotNullLastPan
	move.w	d0,d3
	addq.w	#1,d3
NotNullLastPan:	sub.w	d0,d3
	bls.s	NotNullLastPan2
	sub.l	d1,d4
	divs.w	d3,d4
	moveq	#0,d5
	move.w	d3,d0
	cmp.b	#1,d2
	bne.s	AddPanEnvelopeData
	addq.w	#1,d0
AddPanEnvelopeData:	move.w	d1,(a1)+
	add.w	d4,d1
	swap	d4
	add.w	d4,d5
	bpl.s	NotSubPanEnvData
	add.w	d3,d5
	subq.w	#1,d1
NotSubPanEnvData:	cmp.w	d3,d5
	bcs.s	NotAddPanEnvData
	sub.w	d3,d5
	addq.w	#1,d1
NotAddPanEnvData:	swap	d4
	subq.w	#1,d0
	bne.s	AddPanEnvelopeData
NotNullLastPan2:	subq.b	#1,d2
	bne.s	ConvertPanEnvelopeData
	move.l	tci_PanningEnvelope(a3),a0
	jsr	_LVOValidateEnvNodes(a6)
NotConvertPanEnvData:	moveq	#0,d0
	lea	468(sp),a0
	tst.b	(a0)+
	bmi	NotConvertPitchEnvData
	moveq	#0,d1
	move.b	(a0),d1
	beq	NotConvertPitchEnvData
	move.l	d1,d4
	subq.b	#1,d1
	beq	NotConvertPitchEnvData
	move.w	d1,d2
	mulu.w	#3,d1
ConvertPitchGetHighest:	move.w	6(a0,d1.w),d3
	rol.w	#8,d3
	addq.l	#1,d3
	cmp.w	d3,d0
	bhs.s	ConvertPitchIsHighest
	move.w	d3,d0
ConvertPitchIsHighest:	subq.w	#3,d1
	bcc.s	ConvertPitchGetHighest
	moveq	#ENVL_EMPTY,d1
	moveq	#0,d3
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,tci_SlideEnvelope(a3)
	beq	ExternalLoadErr2
	move.l	d0,a1
	move.l	a1,-(sp)
	move.l	a4,a0
	jsr	_LVOAddEnvelope(a6)
	move.l	(sp)+,a1
	lea	468(sp),a0
	btst	#0,(a0)
	bne.s	PitchEnvUsed
	clr.w	tcie_Tempo(a1)
PitchEnvUsed:	moveq	#0,d0
	btst	#2,(a0)
	beq.s	NotPitchSustainEnv
	addq.b	#TCIEF_Sustain,d0
NotPitchSustainEnv:	btst	#1,(a0)
	beq.s	NotLoopPitchEnv
	addq.b	#TCIEF_Loop,d0
NotLoopPitchEnv:	move.b	d0,tcie_Flags+1(a1)
	moveq	#0,d1
	moveq	#3,d3
	addq.l	#2,a0
	move.b	(a0)+,d1
	mulu.w	d3,d1
	move.w	4(a0,d1.w),d0
	rol.w	#8,d0
	move.w	d0,tcie_LoopStart(a1)
	move.b	(a0)+,d1
	mulu.w	d3,d1
	move.w	4-1(a0,d1.w),d0
	rol.w	#8,d0
	move.w	d0,tcie_LoopEnd(a1)
	move.b	(a0)+,d1
	mulu.w	d3,d1
	move.w	4-2(a0,d1.w),d0
	rol.w	#8,d0
	move.w	d0,tcie_SustainStart(a1)
	move.b	(a0)+,d1
	mulu.w	d3,d1
	move.w	4-3(a0,d1.w),d0
	rol.w	#8,d0
	move.w	d0,tcie_SustainEnd(a1)
	move.l	tcie_NodePoints(a1),a5
	move.l	tcie_Data(a1),a1
ConvertPitchEnvelopeData:	move.b	(a0)+,d1
	ext.w	d1
	asl.w	#7,d1
	move.w	(a0)+,d0
	rol.w	#8,d0
	move.w	d0,(a5)+
	move.b	(a0),d4
	ext.w	d4
	asl.w	#7,d4
	move.w	1(a0),d3
	rol.w	#8,d3
	bne.s	NotNullLastPitch
	move.w	d0,d3
	addq.w	#1,d3
NotNullLastPitch:	sub.w	d0,d3
	bls.s	NotNullLastPitch2
	sub.w	d1,d4
	ext.l	d4
	divs.w	d3,d4
	moveq	#0,d5
	move.w	d3,d0
	cmp.b	#1,d2
	bne.s	AddPitchEnvelopeData
	addq.w	#1,d0
AddPitchEnvelopeData:	move.w	d1,d6
	move.w	d6,(a1)+
	add.w	d4,d1
	swap	d4
	add.w	d4,d5
	bpl.s	NotSubPitchEnvData
	add.w	d3,d5
	subq.w	#1,d1
NotSubPitchEnvData:	cmp.w	d3,d5
	bcs.s	NotAddPitchEnvData
	sub.w	d3,d5
	addq.w	#1,d1
NotAddPitchEnvData:	swap	d4
	subq.w	#1,d0
	bne.s	AddPitchEnvelopeData
NotNullLastPitch2:	subq.b	#1,d2
	bne.s	ConvertPitchEnvelopeData
	move.l	tci_SlideEnvelope(a3),a0
	jsr	_LVOValidateEnvNodes(a6)
NotConvertPitchEnvData:	move.l	(sp),a5
	lea	17(sp),a0
	move.b	(a0)+,tci_NNA(a3)
	moveq	#0,d1
	move.b	(a0)+,d0
	beq.s	LoadDCT
	moveq	#DCTF_InstrNoteOR|DCTF_InstrAND,d1
	subq.b	#1,d0
	beq.s	LoadDCT
	moveq	#-256+(DCTF_InstrOR|DCTF_SampleAND),d1
	subq.b	#1,d0
	beq.s	LoadDCT
	moveq	#DCTF_InstrOR,d1
	subq.b	#1,d0
	bne.s	NotLoadDCT
LoadDCT:	move.b	d1,tci_DCT(a3)
NotLoadDCT:	move.b	(a0)+,tci_DNA(a3)
	move.w	(a0)+,d0
	rol.w	#8,d0
	lsl.w	#6,d0
	bcc.s	LoadFadeOk
	moveq	#-1,d0
LoadFadeOk:	move.w	d0,tci_FadeOut(a3)
	move.b	(a0)+,d1
	ext.w	d1
	asl.w	#7,d1
	move.w	d1,tci_PitchPanSeparation(a3)
	move.b	(a0)+,tci_PitchPanCenter(a3)
	moveq	#0,d0
	move.b	(a0)+,d0
	btst	#3,d7
	beq.s	Bit6InstGlobalVolume
	add.b	d0,d0
	bcc.s	LoadInstGlobalVolume
	st	d0
	bra.s	LoadInstGlobalVolume
Bit6InstGlobalVolume:	addq.w	#1,d0
	lsr.w	#1,d0
LoadInstGlobalVolume:	move.b	d0,tci_GlobalVolume(a3)
	move.b	(a0)+,d0
	bclr	#7,d0
	bne.s	NotInstPan
	bset	#TCIB_DefaultPanning,tci_Flags(a3)
NotInstPan:	lsl.b	#2,d0
	bcc.s	NotDefPanMax
	st	d0
NotDefPanMax:	move.b	d0,tci_DefaultPanning(a3)
	move.b	(a0)+,d0
	lsl.w	#8,d0
	divu.w	#100,d0
	move.w	d0,tci_VolumeSwing(a3)
	move.b	(a0),d1
	lsl.b	#2,d1
	bcc.s	NotFullPanSwing
	moveq	#-1,d1
NotFullPanSwing:	move.b	d1,tci_PanningSwing+1(a3)
	move.w	60(sp),tci_MIDICh(a3)
CopyIdentical:	move.w	#TCIERF_RndDelayPanoEnv,tci_EnvRndDelayFlags(a3)
	tst.b	559(sp)
	bne.s	NotLoadKeyboard
	bset	#TCICB_SeparateSamples,tci_CompFlags(a3)
	moveq	#120-1,d0
	moveq	#1,d1
	lea	64(sp),a0
CheckLoadKeyboard:	cmp.w	(a0)+,d1
	bne.s	LoadKeyboard
	add.w	#$0100,d1
	dbra	d0,CheckLoadKeyboard
	bra.s	NotLoadKeyboard
LoadKeyboard:	jsr	_LVOAllocKeyboard(a6)
	move.l	d0,tci_KeyboardDefs(a3)
	beq	ExternalLoadErr2
	lea	64(sp),a0
	move.l	d0,a1
	moveq	#120-1,d0
	addq.l	#MLN_SIZE,a1
ConvertIMPIKeyboard:	moveq	#0,d1
	move.b	(a0)+,d1
	divu.w	#12,d1
	move.b	d1,2(a1)
	swap	d1
	addq.b	#1,d1
	move.b	d1,3(a1)
	move.b	(a0)+,d1
	move.w	d1,(a1)
	addq.l	#4,a1
	dbra	d0,ConvertIMPIKeyboard
	move.l	a4,a0
	move.l	tci_KeyboardDefs(a3),a1
	jsr	_LVOAddKeyboard(a6)
NotLoadKeyboard:	addq.w	#1,600(sp)
	subq.w	#1,562(sp)
	bne	LoadInstrLoop
	clr.w	600(sp)
LoadSamples:	move.l	574(sp),a0
	move.w	600(sp),d0
	lea	tcm_InstrList(a4),a3
ScanInstrLoop:	move.l	(a3),a3
	tst.l	(a3)
	dbra	d0,ScanInstrLoop
	move.l	574(sp),a0
	move.w	600(sp),d0
	move.l	a2,d1
	move.l	(a0,d0.w*4),d2
	rol.w	#8,d2
	swap	d2
	rol.w	#8,d2
	moveq	#OFFSET_BEGINNING,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalLoadErr2
	move.l	a2,d1
	move.l	sp,d2
	moveq	#80,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadErr2
	moveq	#0,d0
	btst	#0,d7
	beq.s	SampleOk
	move.l	48(sp),d0
	rol.w	#8,d0
	swap	d0
	rol.w	#8,d0
	btst	#1,18(sp)
	beq.s	SampleOk
	add.l	d0,d0
SampleOk:	sub.l	a0,a0
	jsr	_LVOAllocSample(a6)
	move.l	d0,d6
	beq	ExternalLoadErr2
	move.l	d6,a1
	lea	tcs_FileName(a1),a0
	lea	4(sp),a1
	jsr	_LVOSetString(a6)
	move.l	d6,a1
	lea	46(sp),a0
	move.b	(a0),tcs_CompFlags(a1)
	clr.b	(a0)
	lea	20(sp),a1
FindSmpNameNonNull:	cmp.l	a0,a1
	beq.s	FindSmpNameDone
	tst.b	-(a0)
	beq.s	FindSmpNameNonNull
ReplaceSmpNameNulls:	cmp.l	a0,a1
	beq.s	FindSmpNameOk
	tst.b	-(a0)
	bne.s	ReplaceSmpNameNulls
	move.b	#" ",(a0)
	bra.s	ReplaceSmpNameNulls
FindSmpNameOk:	move.l	d6,a0
	lea	tcs_Name(a0),a0
	jsr	_LVOSetString(a6)
FindSmpNameDone:	move.l	d6,a1
	move.b	17(sp),d0
	btst	#3,d7
	beq.s	NotConvSmpGlobVol
	lsl.b	#2,d0
	bcc.s	NotConvSmpGlobVol
	moveq	#-1,d0
NotConvSmpGlobVol:	move.b	d0,tcs_GlobalVolume(a1)
	move.b	19(sp),d0
	btst	#3,d7
	beq.s	NotConvSmpLoadVol
	lsl.b	#2,d0
	bcc.s	NotConvSmpLoadVol
	moveq	#-1,d0
NotConvSmpLoadVol:	move.b	d0,tcs_Volume(a1)
	move.b	18(sp),d0
	moveq	#0,d1
	btst	#4,d0
	beq.s	NotUseLoop
	addq.b	#TCSF_Loop,d1
NotUseLoop:	btst	#5,d0
	beq.s	NotUseSusLoop
	addq.b	#TCSF_SustainLoop,d1
NotUseSusLoop:	btst	#6,d0
	beq.s	NotPingpongLoop
	move.b	#TCSRF_Pingpong,tcs_RepMode(a1)
NotPingpongLoop:	tst.b	d0
	bpl.s	NotPingpongSusLoop
	move.b	#TCSRF_Pingpong,tcs_SustainRepMode(a1)
NotPingpongSusLoop:	move.b	47(sp),d0
	bclr	#7,d0
	beq.s	NotUseSmpPanning
	addq.b	#TCSF_SmpPanning,d1
NotUseSmpPanning:	move.b	d1,tcs_Flags(a1)
	lsl.b	#2,d0
	bcc.s	InsPanningOk
	moveq	#-1,d0
InsPanningOk:	move.b	d0,tcs_Panning(a1)
	movem.l	52(sp),d0-d3/d5-d6
	rol.w	#8,d0
	rol.w	#8,d1
	rol.w	#8,d2
	rol.w	#8,d3
	rol.w	#8,d5
	rol.w	#8,d6
	swap	d0
	swap	d1
	swap	d2
	swap	d3
	swap	d5
	swap	d6
	rol.w	#8,d0
	rol.w	#8,d1
	rol.w	#8,d2
	rol.w	#8,d3
	rol.w	#8,d5
	rol.w	#8,d6
	sub.l	d0,d1
	movem.l	d0-d1,tcs_Repeat(a1)
	move.l	d2,tcs_Rate(a1)
	sub.l	d3,d5
	movem.l	d3/d5,tcs_SustainRepeat(a1)
	move.l	d6,tcs_Synth(a1)
	move.b	#-12,tcs_Transpose(a1)
	move.b	#TCSEPF_LinearAutoVib,tcs_EnvProcFlags(a1)
	move.l	a1,d4
	move.l	a3,a0
	jsr	_LVOAddSample(a6)
	move.l	d4,a1
	lea	76(sp),a0
	move.b	(a0)+,tcs_VibratoRate(a1)
	move.b	(a0)+,tcs_VibratoDepth(a1)
	move.b	(a0),tcs_VibratoSweep+1(a1)
	lea	76(sp),a0
	tst.w	(a0)+
	beq.s	NoAutoVibrato
	tst.b	(a0)+
	beq.s	NoAutoVibrato
	move.b	(a0),d0
	cmp.b	#4,d0
	bcc.s	NoAutoVibrato
	moveq	#ENVL_SINE,d1
	subq.b	#1,d0
	bne.s	NotRampWave
	moveq	#ENVL_RAMP,d1
NotRampWave:	subq.b	#1,d0
	bne.s	NotSquareWave
	moveq	#ENVL_SQUARE,d1
NotSquareWave:	subq.b	#1,d0
	bne.s	NotRandomWave
	move.b	#TCSERF_RandomAVibEnv,tcs_EnvRandomFlags(a1)
NotRandomWave:	moveq	#64,d0
	lsl.w	#2,d0
	moveq	#64,d2
	add.l	d2,d2
	moveq	#0,d3
	move.l	d4,(sp)
	moveq	#DEFAULT_ENVNODES,d4
	jsr	_LVOCreateEnvelope(a6)
	move.l	(sp),d4
	move.l	d4,a1
	move.l	d0,tcs_AutoVibratoEnv(a1)
	beq	ExternalLoadErr2
	move.l	d0,a1
	bset	#TCIEB_Loop,tcie_Flags+1(a1)
	move.w	tcie_NumPoints(a1),tcie_LoopEnd(a1)
	subq.w	#1,tcie_LoopEnd(a1)
	move.l	a4,a0
	jsr	_LVOAddEnvelope(a6)
NoAutoVibrato:	move.l	tci_Samples(a3),d4
	btst	#1,18(sp)
	beq.s	Not16BitSample
	moveq	#16,d0
	moveq	#CBF_ChangeOnly,d1
	move.l	d4,a0
	jsr	_LVOConvertBits(a6)
Not16BitSample:	move.l	d4,a1
	move.l	a2,d1
	move.l	tcs_Synth(a1),d2
	clr.l	tcs_Synth(a1)
	btst	#0,18(sp)
	beq	SignedSamples
	moveq	#OFFSET_BEGINNING,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalLoadErr2
	btst	#3,18(sp)
	beq	NotDecompressSample
	movem.l	d4/d7,610(sp)
	move.l	d4,a0
	move.l	tcs_Data(a0),a1
	move.l	tcs_Samples(a0),618(sp)
	btst	#1,18(sp)
	bne	Decompress16BitLoop2
	bra.s	Decompress8BitLoop2
Decompress8BitLoop:	move.l	a1,-(sp)
	movem.l	4(sp),d0/a1
	exg	d0,a1
	jsr	_LVOFreePMem(a6)
	move.l	(sp)+,a1
	sub.l	d5,618(sp)
	bls	DecompressDone
Decompress8BitLoop2:	bsr	ReadBlock
	moveq	#0,d2
	moveq	#0,d3
	moveq	#9,d4
	moveq	#1,d5
	ror.w	#1,d5
	cmp.l	618(sp),d5
	blo.s	NotDecompress8Max
	move.l	618(sp),d5
NotDecompress8Max:	clr.l	622(sp)
Decompress8BitBlock:	cmp.l	622(sp),d5
	bls.s	Decompress8BitLoop
	move.l	d4,d0
	bsr	ReadBits
	cmp.b	#7,d4
	bhs.s	Not8Method1
	moveq	#1,d0
	move.b	d4,d1
	subq.b	#1,d1
	lsl.b	d1,d0
	cmp.b	d7,d0
	bne.s	Not8Method3
	moveq	#3,d0
	bsr	ReadBits
	move.l	d7,d1
	addq.b	#1,d1
	cmp.b	d4,d1
	blo.s	Not8Method1Add
	addq.b	#1,d1
Not8Method1Add:	move.b	d1,d4
	bra.s	Decompress8BitBlock
Not8Method1:	cmp.b	#9,d4
	bhs.s	Not8Method2
	moveq	#-1,d0
	moveq	#9,d1
	sub.b	d4,d1
	lsr.b	d1,d0
	subq.b	#4,d0
	cmp.b	d7,d0
	bhs.s	Not8Method3
	addq.b	#8,d0
	cmp.b	d7,d0
	blo.s	Not8Method3
	subq.b	#8,d0
	sub.b	d0,d7
	cmp.b	d4,d7
	blo.s	Not8Method2Add
	addq.b	#1,d7
Not8Method2Add:	move.b	d7,d4
	bra.s	Decompress8BitBlock
Not8Method2:	bne	ExternalLoadErr26
	btst	#8,d7
	beq.s	Not8Method3
	move.b	d7,d4
	addq.b	#1,d4
	bra.s	Decompress8BitBlock
Not8Method3:	move.l	d3,-(sp)
	moveq	#8,d1
	cmp.b	d1,d4
	blo.s	Not8Method31
	move.b	d7,d3
	bra.s	Not8Method32
Not8Method31:	sub.b	d4,d1
	move.b	d7,d3
	asl.b	d1,d3
	asr.b	d1,d3
Not8Method32:	add.b	d3,d2
	move.l	(sp)+,d3
	add.b	d2,d3
	move.b	d2,d0
	tst.b	608(sp)
	beq.s	Not8IT215Decompress
	move.b	d3,d0
Not8IT215Decompress:	addq.l	#1,622(sp)
	move.b	d0,(a1)+
	bra	Decompress8BitBlock
Decompress16BitLoop:	move.l	a1,-(sp)
	movem.l	4(sp),d0/a1
	exg	d0,a1
	jsr	_LVOFreePMem(a6)
	move.l	(sp)+,a1
	sub.l	d5,618(sp)
	bls	DecompressDone
Decompress16BitLoop2:	bsr	ReadBlock
	moveq	#0,d2
	moveq	#0,d3
	moveq	#17,d4
	moveq	#1,d5
	ror.w	#2,d5
	cmp.l	618(sp),d5
	blo.s	NotDecompress16Max
	move.l	618(sp),d5
NotDecompress16Max:	clr.l	622(sp)
Decompress16BitBlock:	cmp.l	622(sp),d5
	bls.s	Decompress16BitLoop
	move.l	d4,d0
	bsr	ReadBits
	cmp.b	#7,d4
	bhs.s	Not16Method1
	moveq	#1,d0
	move.b	d4,d1
	subq.b	#1,d1
	lsl.b	d1,d0
	cmp.b	d7,d0
	bne.s	Not16Method3
	moveq	#4,d0
	bsr	ReadBits
	move.l	d7,d1
	addq.b	#1,d1
	cmp.b	d4,d1
	blo.s	Not16Method1Add
	addq.b	#1,d1
Not16Method1Add:	move.b	d1,d4
	bra.s	Decompress16BitBlock
Not16Method1:	cmp.b	#17,d4
	bhs.s	Not16Method2
	moveq	#-1,d0
	moveq	#17,d1
	sub.b	d4,d1
	lsr.w	d1,d0
	subq.w	#8,d0
	cmp.w	d7,d0
	bhs.s	Not16Method3
	moveq	#16,d1
	add.w	d1,d0
	cmp.w	d7,d0
	blo.s	Not16Method3
	sub.w	d1,d0
	sub.w	d0,d7
	cmp.w	d4,d7
	blo.s	Not16Method2Add
	addq.w	#1,d7
Not16Method2Add:	move.w	d7,d4
	bra.s	Decompress16BitBlock
Not16Method2:	bne	ExternalLoadErr26
	btst	#16,d7
	beq.s	Not16Method3
	move.b	d7,d4
	addq.b	#1,d4
	bra.s	Decompress16BitBlock
Not16Method3:	move.l	d3,-(sp)
	moveq	#16,d1
	cmp.b	d1,d4
	blo.s	Not16Method31
	move.w	d7,d3
	bra.s	Not16Method32
Not16Method31:	sub.b	d4,d1
	move.w	d7,d3
	asl.w	d1,d3
	asr.w	d1,d3
Not16Method32:	add.w	d3,d2
	move.l	(sp)+,d3
	add.w	d2,d3
	move.w	d2,d0
	tst.b	608(sp)
	beq.s	Not16IT215Decompress
	move.w	d3,d0
Not16IT215Decompress:	addq.l	#1,622(sp)
	move.w	d0,(a1)+
	bra	Decompress16BitBlock
DecompressDone:	movem.l	610(sp),d4/d7
	bra.s	SignedSamples
NotDecompressSample:	move.l	a2,d1
	move.l	d4,a1
	movem.l	tcs_Data(a1),d2-d3
	jsr	_LVOCRead(a6)
	addq.l	#1,d0
	beq	ExternalLoadErr2
	move.l	d4,a0
	cmp.b	#16,tcs_BitDepth(a0)
	bne.s	NotIntelOrder
	jsr	_LVOConvertWord(a6)
NotIntelOrder:	move.l	d4,a0
	btst	#0,tcs_CompFlags(a0)
	bne.s	SignedSamples
	jsr	_LVOConvertSigned(a6)
SignedSamples:	move.l	d4,a0
	move.b	#TCSCF_VolumeOnly|TCSCF_AffectChanPan|TCSCF_StartTonePorta|TCSCF_PlayBegin,tcs_CompFlags(a0)
	addq.w	#1,600(sp)
	subq.w	#1,602(sp)
	bne	LoadSamples
NoLoadSamples:	movem.l	588(sp),a2-a4
	lea	tcm_Envelopes(a4),a2
CmpEnvMainLoop:	move.l	(a2),a2
	tst.l	(a2)
	beq.s	CmpEnvAllDone
	lea	tcm_Envelopes(a4),a5
CompareEnvsLoop:	move.l	(a5),a5
	tst.l	(a5)
	beq.s	CmpEnvMainLoop
	cmp.l	a5,a2
	beq.s	CompareEnvsLoop
	move.l	a5,a0
	move.l	a2,a1
	jsr	_LVOCmpEnvelopes(a6)
	tst.l	d0
	bne.s	CompareEnvsLoop
	lea	tcm_InstrList(a4),a0
ReplaceInstEnvLoop:	move.l	(a0),a0
	tst.l	(a0)
	beq.s	ReplaceInstEnvDone
	moveq	#(tci_ArpeggioStructure-tci_VolumeEnvelope)/4-1,d0
	lea	tci_VolumeEnvelope(a0),a1
ReMapInstEnvLoop:	cmp.l	(a1)+,a5
	bne.s	NoReMapInstEnv
	move.l	a2,-4(a1)
NoReMapInstEnv:	dbra	d0,ReMapInstEnvLoop
	move.l	a0,-(sp)
	lea	tci_Samples(a0),a0
ReMapInstSmpEnvLoop:	move.l	(a0),a0
	tst.l	(a0)
	beq.s	ReMapInstSmpEnvDone
	moveq	#(tcs_EnvUsageFlags-tcs_AutoVibratoEnv)/4-1,d0
	lea	tcs_AutoVibratoEnv(a0),a1
ReMapInstSmpEnvs:	cmp.l	(a1)+,a5
	bne.s	NoReMapInstSmpEnv
	move.l	a2,-4(a1)
NoReMapInstSmpEnv:	dbra	d0,ReMapInstSmpEnvs
	bra.s	ReMapInstSmpEnvLoop
ReMapInstSmpEnvDone:	move.l	(sp)+,a0
	bra.s	ReplaceInstEnvLoop
ReplaceInstEnvDone:	move.l	a5,a0
	jsr	_LVOFreeEnvelope(a6)
	move.l	MLN_PRED(a2),a2
	bra.s	CmpEnvMainLoop
CmpEnvAllDone:	lea	tcm_KeyboardDefs(a4),a2
CmpKeyMainLoop:	move.l	(a2),a2
	tst.l	(a2)
	beq.s	CmpKeyAllDone
	lea	tcm_KeyboardDefs(a4),a5
CompareKeysLoop:	move.l	(a5),a5
	tst.l	(a5)
	beq.s	CmpKeyMainLoop
	cmp.l	a5,a2
	beq.s	CompareKeysLoop
	move.l	a5,a0
	move.l	a2,a1
	jsr	_LVOCmpKeyboards(a6)
	tst.l	d0
	bne.s	CompareKeysLoop
	lea	tcm_InstrList(a4),a0
ReplaceInstKeyLoop:	move.l	(a0),a0
	tst.l	(a0)
	beq.s	ReplaceInstKeyDone
	cmp.l	tci_KeyboardDefs(a0),a5
	bne.s	ReplaceInstKeyLoop
	move.l	a2,tci_KeyboardDefs(a0)
	bra.s	ReplaceInstKeyLoop
ReplaceInstKeyDone:	move.l	a5,a0
	jsr	_LVOFreeKeyboard(a6)
	move.l	MLN_PRED(a2),a2
	bra.s	CmpKeyMainLoop
CmpKeyAllDone:	move.l	tcm_SongList(a4),a0
	lea	tcso_TrackList(a0),a0
	moveq	#0,d0
	move.l	(a0),a0
	tst.l	(a0)
	beq.s	ScanTrackNullDone
	move.l	a0,a1
	move.w	tct_Length(a1),d1
ScanTrackNullLoop:	addq.l	#1,d0
	move.l	(a0),a0
	tst.l	(a0)
	beq.s	ScanTrackNullDone
	cmp.w	tct_Length(a0),d1
	bne.s	ScanTrackNullLoop
	move.w	d1,d2
	move.l	tct_Data(a0),a2
CheckTrackEmptyLoop:	tst.l	(a2)+
	bne.s	ScanTrackNullLoop
	move.l	(a2),a2
	tst.l	(a2)
	bne.s	ScanTrackNullLoop
	addq.l	#tctd_Effects+MLH_TAIL,a2
	dbra	d2,CheckTrackEmptyLoop
	move.l	a0,a2
	jsr	_LVODeleteTrack(a6)
	move.l	tcm_SongList(a4),a0
	move.l	a2,a1
	sub.l	a2,a2
	jsr	_LVOInsertTrack(a6)
ScanTrackNullDone:	move.l	tcm_SongList(a4),a0
	jsr	_LVOGetOptimalChannels(a6)
	move.l	tcm_SongList(a4),a0
	jsr	_LVOSetSongChannels(a6)
	move.l	a4,a0
	jsr	_LVOGetOptimalVChannels(a6)
	move.l	a4,a0
	jsr	_LVOSetTCMChannels(a6)
	move.l	a3,d0
	bne.s	ModAllocated
	move.l	a4,a3
ModAllocated:	move.l	a4,a0
	move.l	a3,a1
	jsr	_LVOReMapTCModule(a6)
	move.l	570(sp),a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
	move.l	574(sp),a1
	jsr	_LVOFreeVec(a6)
	move.l	578(sp),a1
	jsr	_LVOFreeVec(a6)
	move.l	566(sp),a1
	jsr	_LVOFreeVec(a6)
ExternalLoadDone:	lea	626(sp),sp
	move.l	a3,d0
	movem.l	(sp)+,d2-d7/a2-a6
	rts
ExternalLoadError:	move.l	d2,a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
ExternalLoadErr1:	move.l	24(sp),a4
ExternalLoadErr15:	move.l	570(sp),a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
ExternalLoadErr16:	move.l	574(sp),a1
	jsr	_LVOFreeVec(a6)
ExternalLoadErr17:	move.l	578(sp),a1
	jsr	_LVOFreeVec(a6)
ExternalLoadErr2:	move.l	a4,a0
	move.l	a5,a6
	jsr	_LVOFreeTCModule(a6)
ExternalLoadErr3:	move.l	566(sp),a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
ExternalLoadErr4:	sub.l	a3,a3
	bra.s	ExternalLoadDone
ExternalLoadWrongVersion:	moveq	#255-ERROR_ACTION_NOT_KNOWN,d1
	not.b	d1
	move.l	tcb_DOSBase(a5),a6
	jsr	_LVOSetIoErr(a6)
	bra.s	ExternalLoadErr4
ExternalLoadErr28:	movem.l	8(sp),d0/a1
	exg	d0,a1
	jsr	_LVOFreePMem(a6)
ExternalLoadErr27:	addq.l	#8,sp
	bra.s	ExternalLoadErr25
ExternalLoadErr26:	movem.l	(sp),d0/a1
	exg	d0,a1
	jsr	_LVOFreePMem(a6)
ExternalLoadErr25:	movem.l	610(sp),d4/d7
	bra.s	ExternalLoadErr2
ReadBlock:	move.l	a1,-(sp)
	move.l	a2,d1
	move.l	sp,d2
	addq.l	#8,d2
	moveq	#2,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalLoadErr27
	move.w	8(sp),d0
	rol.w	#8,d0
	move.l	d0,d3
	addq.l	#8-1,d0
	and.b	#-8,d0
	addq.l	#8,d0
	move.l	d0,12(sp)
	jsr	_LVOAllocPMem(a6)
	move.l	d0,8(sp)
	beq.s	ExternalLoadErr27
	move.l	a2,d1
	move.l	d0,d2
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalLoadErr28
	move.l	d2,a0
	move.l	d3,d0
	addq.l	#8-1,d0
	lsr.l	#3,d0
IntelLoop:	move.l	(a0),d1
	rol.w	#8,d1
	swap	d1
	rol.w	#8,d1
	move.l	d1,(a0)+
	move.l	(a0),d1
	rol.w	#8,d1
	swap	d1
	rol.w	#8,d1
	move.l	d1,(a0)+
	subq.l	#1,d0
	bne.s	IntelLoop
	moveq	#32,d6
	move.l	d2,a0
	move.l	(sp)+,a1
	rts
ReadBits:	cmp.b	d0,d6
	blo.s	ReadBitsNew
	move.l	(a0),d7
	moveq	#1,d1
	lsl.l	d0,d1
	subq.l	#1,d1
	and.l	d1,d7
	move.l	(a0),d1
	lsr.l	d0,d1
	move.l	d1,(a0)
	sub.b	d0,d6
	rts
ReadBitsNew:	movem.l	d2-d3,-(sp)
	move.b	d0,d2
	sub.b	d6,d2
	move.l	(a0)+,d7
	move.l	(a0),d3
	moveq	#1,d1
	lsl.l	d2,d1
	subq.l	#1,d1
	and.l	d1,d3
	lsl.l	d6,d3
	or.l	d3,d7
	move.l	(a0),d3
	lsr.l	d2,d3
	move.l	d3,(a0)
	moveq	#32,d6
	sub.b	d2,d6
	movem.l	(sp)+,d2-d3
	rts
SetTempo:	tst.b	d6
	beq	NoFX
	rts
Porta:	lsr.b	#4,d1
	cmp.b	#$f,d1
	bne.s	NotFineSlide
	addq.b	#4,d0
	and.b	#$f,d6
	beq	NoFX
NotFineSlide:	cmp.b	#$e,d1
	bne.s	TonePorta
	addq.b	#4+2,d0
	and.b	#$f,d6
	beq	NoFX
	lsl.w	#2,d6
TonePorta:	lsl.w	#8,d6
	rts
ToneFade:	movem.w	d0-d1,-(sp)
	moveq	#FX_TONE_PORTA,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	ToneFadeDone
AddFadeFX:	move.l	d0,a1
	move.l	a3,a0
	jsr	_LVOAddTail(a6)
ToneFadeDone:	movem.w	(sp)+,d0-d1
	bra	VolumeSlide
VibFade:	movem.w	d0-d1,-(sp)
	btst	#4,45+8(sp)
	bne.s	OldVibFade
	moveq	#FX_EXECUTE_FX,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	ToneFadeDone
	move.l	d0,a1
	move.l	a3,a0
	jsr	_LVOAddTail(a6)
OldVibFade:	moveq	#FX_VIBRATO,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	ToneFadeDone
	btst	#4,45+8(sp)
	move.l	d0,a1
	bne.s	AddFadeFX
	move.l	a3,a0
	jsr	_LVOAddTail(a6)
	moveq	#FX_EXECUTE_FX,d0
	moveq	#1,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	ToneFadeDone
	bra.s	AddFadeFX
GVolumeSlide:	bsr.s	VolumeSlide
	lsr.w	#8,d6
	lsr.b	#1,d6
	bcc.s	Not6BitGVolSlide
	addq.b	#1,d6
Not6BitGVolSlide:	lsl.w	#8,d6
	rts
SmpVolumeSlide:	cmp.b	#$f0,d6
	beq.s	FastVolSlide
	cmp.b	#$0f,d6
	bne.s	VolumeSlide
FastVolSlide:	movem.l	d0-d1,-(sp)
	moveq	#FX_EXECUTE_FX,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	DoFastVolDone
	move.l	d0,a1
	move.l	a3,a0
	jsr	_LVOAddTail(a6)
DoFastVolDone:	movem.l	(sp)+,d0-d1
VolumeSlide:	cmp.b	#$f0,d6
	beq.s	VolSlideUp
	cmp.b	#$0f,d6
	beq.s	VolSlideDown
	cmp.b	#$ff,d6
	beq.s	VolSlideUp
CheckVolSlide:	and.b	#$f,d1
	cmp.b	#$f,d1
	beq.s	FineVolSlideUp
	move.b	d6,d1
	lsr.b	#4,d1
	cmp.b	#$f,d1
	beq.s	FineVolSlideDown
	tst.b	d1
	bne.s	VolSlideUp
	bra.s	VolSlideDown
NotFineVolSlide:	btst	#3,d7
	beq.s	SetVolOk
	moveq	#8+2,d1
	lsl.w	d1,d6
	rts
FineVolSlideUp:	addq.b	#2,d0
VolSlideUp:	lsr.b	#4,d6
	bra.s	NotFineVolSlide
FineVolSlideDown:	addq.b	#2,d0
VolSlideDown:	addq.b	#1,d0
	and.b	#$f,d6
	bra.s	NotFineVolSlide
PanningSlide:	cmp.b	#$f0,d6
	beq.s	PanSlideLeft
	cmp.b	#$0f,d6
	beq.s	PanSlideRight
	cmp.b	#$ff,d6
	beq.s	PanSlideLeft
CheckPanSlide:	and.b	#$f,d1
	cmp.b	#$f,d1
	beq.s	FinePanSlideLeft
	move.b	d6,d1
	lsr.b	#4,d1
	cmp.b	#$f,d1
	beq.s	FinePanSlideRight
	tst.b	d1
	bne.s	PanSlideLeft
	bra.s	PanSlideRight
NotFinePanSlide:	moveq	#8+2,d1
	lsl.w	d1,d6
	rts
FinePanSlideLeft:	addq.b	#2,d0
PanSlideLeft:	lsr.b	#4,d6
	bra.s	NotFinePanSlide
FinePanSlideRight:	addq.b	#2,d0
PanSlideRight:	addq.b	#1,d0
	and.b	#$f,d6
	bra.s	NotFinePanSlide
SetGVolume:	add.b	d6,d6
	bcc.s	GVolumeOk
	st	d6
GVolumeOk:	btst	#3,d7
	bne.s	SetVolOk
	lsr.b	#1,d6
	bcc.s	SetVolOk
	addq.b	#1,d6
	bra.s	SetVolOk
SetVolume:	btst	#3,d7
	beq.s	SetVolOk
	lsl.b	#2,d6
	bcc.s	SetVolOk
	moveq	#-1,d6
SetVolOk:	lsl.w	#8,d6
	rts
Extended:	lea	ExtendedFXTable(pc),a0
	lsr.b	#4,d1
	movem.w	(a0,d1.w*4),d0-d1
	add.l	d1,a0
	move.w	d6,d1
	lsr.b	#4,d1
	and.b	#$f,d6
	jmp	(a0)
NoFX:	addq.l	#4,sp
	bra	NoEffect
Tremor:	beq.s	TremorDone
	btst	#4,45+4(sp)
	beq.s	Arpeggio
	unpk	d6,d6,#$0101
TremorDone:	rts
Arpeggio:	lsl.w	#4,d6
	lsr.b	#4,d6
	rts
BPMSlideDown:	moveq	#FX_SPD_SLD_SLOW,d0
	rts
SetBPM:	lsr.b	#4,d1
	beq.s	BPMSlideDown
	cmp.b	#$2,d1
	bcc.s	PosJump
	and.b	#$f,d6
	moveq	#FX_SPD_SLD_FAST,d0
	rts
Pannolo:	bsr.s	Arpeggio
	bsr.s	Panbrello
	lsl.b	#2,d6
	rts
Tremolo:	bsr.s	Vibrato
	btst	#3,d7
	beq.s	PosJump
	lsl.b	#2,d6
	rts
Vibrato:	ror.b	#4,d6
	lsl.w	#4,d6
	lsr.b	#4,d6
	lsl.b	#2,d6
	rol.w	#8,d6
	btst	#4,45+4(sp)
	bne.s	ChkVib
	cmp.b	#$20,d0
	bcc.s	Panbrello
	neg.b	d6
Panbrello:	move.l	d0,d3
	moveq	#FX_EXECUTE_FX,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	VibDone
	move.l	d0,a1
	move.l	a3,a0
	jsr	_LVOAddTail(a6)
VibDone:	move.l	d3,d0
	rts
MultiRetrig:	and.b	#$f,d1
	lsl.w	#8,d1
	or.w	d1,d6
	lsr.b	#4,d6
	beq.s	MulRetrigNoVol
	cmp.b	#8,d6
	beq.s	MulRetrigNoVol
	cmp.b	#6,d6
	bcc.s	MulRetrig
	move.b	d6,d1
	moveq	#1,d6
	lsl.b	d1,d6
	lsr.b	#1,d6
	add.b	#$C0-1,d6
	clr.b	d1
	or.w	d1,d6
PosJump:	rts
ChkVib:	cmp.b	#$20,d0
	bcc.s	PosJump
	add.b	d6,d6
	rts
MulRetrigNoVol:	move.b	#$10,d6
	rts
MulRetrig:	subq.b	#6,d6
	bne.s	MulRetr1
	move.b	#$23,d6
	rts
MulRetr1:	subq.b	#2,d6
	bcc.s	AddRetrig
	move.b	#$12,d6
	rts
AddRetrig:	cmp.b	#$6,d6
	beq.s	DivRetr1
	cmp.b	#$7,d6
	beq.s	DivRetr2
	move.b	d6,d1
	moveq	#1,d6
	lsl.b	d1,d6
	lsr.b	#1,d6
	add.b	#$80-1,d6
	clr.b	d1
	or.w	d1,d6
	rts
DivRetr1:	move.b	#$32,d6
	rts
DivRetr2:	move.b	#$21,d6
	rts
SetNNAMode:	moveq	#FX_NNA_CONTROL,d0
	subq.b	#3,d6
	cmp.b	#1,d6
	beq.s	SetNNACont
	cmp.b	#2,d6
	bne.s	PosJump
	moveq	#1,d6
	rts
SetNNACont:	moveq	#2,d6
	rts
SetFineTune:	lsl.b	#4,d6
	rts
SpecialIT:	cmp.b	#$3,d6
	bcs.s	PastNoteCut
	cmp.b	#$7,d6
	bcs.s	SetNNAMode
	cmp.b	#$d,d6
	bcc	NoFX
	moveq	#0,d3
	subq.b	#7,d6
	lsr.b	#1,d6
	bcc.s	TurnEnvOn
	moveq	#1,d3
TurnEnvOn:	lsl.w	#8,d6
	addq.b	#5,d6
	moveq	#FX_ENV_CONTROL,d0
	move.l	d6,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	EnvOnDone
	move.l	d0,a1
	move.l	a3,a0
	jsr	_LVOAddTail(a6)
	move.w	d3,d6
EnvOnDone:	moveq	#FX_SET_ENV_VAL,d0
	rts
PastNoteCut:	moveq	#FX_EXTEND_CTRL,d0
	move.b	PastNNATab(pc,d6.w),d6
	addq.b	#3,d6
	moveq	#12,d1
	lsl.w	d1,d6
	rts
PastNNATab:	dc.b	0,2,1
	even
ExtendControl:	bset	#12,d6
	rts
GlissCtrl:	tst.b	d6
	beq.s	ExtendControl
	move.w	#$1001,d6
	rts
SetPanning:	move.b	d6,d1
	lsl.b	#4,d1
	or.b	d1,d6
	lsl.w	#8,d6
	rts
SetSurround:	subq.b	#1,d6
	bne	NoFX
	move.w	#$1001,d6
	rts
EnvCtrl:	move.w	d0,d3
	moveq	#FX_ENV_CONTROL,d0
	cmp.b	#4,d6
	blo.s	NotRetrigEnvSet
	moveq	#0,d6
NotRetrigEnvSet:	cmp.b	#3,d6
	bne.s	NotRandomEnv
	or.b	#$10,d3
NotRandomEnv:	move.w	d3,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	EnvCtrlDone
	move.l	d0,a1
	move.l	a3,a0
	jsr	_LVOAddTail(a6)
	moveq	#FX_ENV_CONTROL,d0
	clr.b	d3
	move.w	d3,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	EnvCtrlDone
	move.l	d0,a1
	move.l	a3,a0
	jsr	_LVOAddTail(a6)
	cmp.w	#$0400,d3
	bne.s	EnvCtrlDone
	addq.b	#3,d6
EnvCtrlDone:	moveq	#FX_SET_ENV_VAL,d0
	rts
ExternalModuleSave:	
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle from where to get the info
;	A1.L	=	APTR to module info structure where to put information
;	D0.L	=	Number of module to be scanned (NULL is the first)
;	OUTPUT
;	D0.L	=	Any non-zero value for success, NULL for error.
ExternalModuleGetInfo:	movem.l	d2-d6/a2-a4/a6,-(sp)
	movem.l	(sp)+,d2-d6/a2-a4/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	Number of modules found or NULL on any error
ExternalModuleGetNums:	moveq	#1,d0
	rts
AutoVibTab:	dc.b	ENVL_SINE,ENVL_SQUARE,ENVL_RAMP,0

	cnop	0,4

ExtModuleLibBase:	dc.l	0

LoadFlags:	dc.w	8
	dc.w	LoadFlagSize
	dc.l	LoadText0
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0	
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText1
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText2
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText3
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText4
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText5
	dc.b	EXTFLAG_SLIDER
	dc.b	0
	dc.w	0
	dc.l	1
	dc.l	64
	dc.l	32
	dc.l	0
	dc.l	LoadText6
	dc.b	EXTFLAG_SLIDER
	dc.b	0
	dc.w	0
	dc.l	1
	dc.l	256
	dc.l	64
	dc.l	0
	dc.l	LoadText7
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
LoadText0:	dc.b	'Load samples',0
LoadText1:	dc.b	'Make vibrato envelopes',0
LoadText2:	dc.b	'Make tremolo envelopes',0
LoadText3:	dc.b	'Convert volumes',0
LoadText4:	dc.b	'Auto-detect channels',0
LoadText5:	dc.b	'Force channels to',0
LoadText6:	dc.b	'NNA channels',0
LoadText7:	dc.b	'200 rows per pattern limit',0
	even
LoadFlagSize:	equ	*-LoadFlags
LoadDescript:	dc.b	'ImpulseTracker Module (IT)',0
