*******************************************************************
***         TuComposer External Instrument Library for IT       ***
***                 1997 by The united Coders (TuC)            ***
***                       Main code: Basty/TuC                  ***
*** This is a IT instrument loader (loads the instruments from) ***
***                    the ImpulseTracker modules               ***
*******************************************************************

	IFND	_G2
	MACHINE	MC68020
	OPT NODEBUG,NOLINE
	ENDC

	include	"exec/types.i"
	include	"exec/execbase.i"
	include	"exec/exec_lib.i"
	include	"exec/initializers.i"
	include	"exec/memory.i"
	include	"exec/resident.i"
	include	"exec/libraries.i"
	include	"libraries/dos_lib.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/module.i"
	include	"tucomposer/instr.i"
	include	"tucomposer/sample.i"
	include	"tucomposer/external/external.i"
	include	"tucomposer/external/external_lib.i"
	include	"tucomposer/external/instr.i"
	include	"tucomposer/external/instr_lib.i"

	moveq	#-1,d0
	rts
ResidentStruct:	dc.w	RTC_MATCHWORD
	dc.l	ResidentStruct
	dc.l	0
	dc.b	RTF_AUTOINIT
	dc.b	EXTLIB_INSTR_VERSION
	dc.b	NT_LIBRARY
	dc.b	0
	dc.l	LibName
	dc.l	LibID
	dc.l	Init
LibName:	dc.b	'iti.library',0
LibID:	dc.b	'TuComposer External Instrument Loader Version 1.00 (v31) for IT (68020+, OS2.0+) (21 Mar 97) by Basty/TuC.',0
TuComposerName:	dc.b	'tucomposer.library',0
	even
Init:	dc.l	insl_SIZEOF
	dc.l	FuncTab
	dc.l	DataTab
	dc.l	PrepareLibrary

FuncTab:	dc.w	-1
	dc.w	Open-FuncTab
	dc.w	Close-FuncTab
	dc.w	Expunge-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalInitialize-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalInstrIdentify-FuncTab
	dc.w	ExternalInstrLoad-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalInstrGetInfo-FuncTab
	dc.w	ExternalInstrGetNums-FuncTab
	dc.w	-1

DataTab:	INITLONG	LN_NAME,LibName
	INITBYTE	LIB_FLAGS,LIBF_CHANGED|LIBF_SUMUSED
	INITWORD	LIB_VERSION,EXTLIB_INSTR_VERSION
	INITWORD	LIB_REVISION,EXTLIB_REVISION
	INITLONG	LIB_IDSTRING,LibID
	dc.l	0

PrepareLibrary:	btst	#AFB_68020,AttnFlags+1(a6)	
	beq.s	ExtLib
	cmp.w	#37,LIB_VERSION(a6)
	blt.s	ExtLib
	move.l	a2,-(sp)
	move.l	d0,a2
	move.l	a0,extb_SegList(a2)
	moveq	#31,d0
	lea	TuComposerName(pc),a1
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,extb_TuComposerBase(a2)
	beq.s	NoTuCLib
	lea	ExtInstrLibBase(pc),a0
	move.l	a2,(a0)
	move.l	a2,d0
NoTuCLib:	move.l	(sp)+,a2
	rts
Open:	addq.w	#1,LIB_OPENCNT(a6)
	move.l	a6,d0
	rts
Close:	subq.w	#1,LIB_OPENCNT(a6)
	bne.s	ExtLib
	btst	#LIBB_DELEXP,LIB_FLAGS(a6)
	bne.s	Expunge
ExtLib:	moveq	#0,d0
	rts
Expunge:	bset	#LIBB_DELEXP,LIB_FLAGS(a6)
	tst.w	LIB_OPENCNT(a6)
	bne.s	ExtLib
	movem.l	d2/a5-a6,-(sp)
	move.l	extb_ExtLibList(a6),d0
	beq.s	NoExtLibList
	move.l	d0,a0
	clr.l	extl_LibBase(a0)
NoExtLibList:	move.l	extb_TuComposerBase(a6),a1
	move.l	a6,a5
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
	move.l	extb_SegList(a5),d2
	move.l	a5,a1
	jsr	_LVORemove(a6)
	move.l	a5,a1
	moveq	#0,d0
	moveq	#0,d1
	move.w	LIB_NEGSIZE(a5),d1
	sub.l	d1,a1
	move.w	LIB_POSSIZE(a5),d0
	add.l	d1,d0
	jsr	_LVOFreeMem(a6)
	move.l	d2,d0
	movem.l	(sp)+,d2/a5-a6
	rts
;	INPUT
;	A0.L	=	APTR to instrument external list structure to be initialized
;	OUTPUT
;	D0.L	=	What type of external library is it or NULL if error
ExternalInitialize:	move.l	extb_TuComposerBase(a6),a1
	movem.l	a2/a6,-(sp)
	move.l	a0,d0
	beq.s	ExternalInitDone
	move.l	a1,a6
	move.b	#EXTLF_Loader,extl_Flags(a0)
	move.l	a0,a2
	lea	extl_Descriptor(a0),a0
	lea	LoadDescript(pc),a1
	jsr	_LVOSetString(a6)
	beq.s	ExternalInitDone
	lea	LoadFlags(pc),a0
	jsr	_LVOAllocFlagStr(a6)
	move.l	d0,extl_LoadFlagStr(a2)
	beq.s	ExternalInitDone
	moveq	#EXTTYPE_INSTR,d0
ExternalInitDone:	movem.l	(sp)+,a2/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	If failed NULL else any non-zero value
ExternalInstrIdentify:	movem.l	d2-d3/a6,-(sp)
	move.l	a0,d1
	link	a5,#-36
	move.l	sp,d2
	moveq	#36,d3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalTrackIdDone
	cmp.l	#"IMPM",(sp)
	bne.s	ExternalTrackIdDone
	tst.w	34(sp)
	bne.s	ExternalTrackIdOk
ExternalTrackIdDone:	moveq	#0,d0
ExternalTrackIdOk:	unlk	a5
	movem.l	(sp)+,d2-d3/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be loaded
;	A1.L	=	APTR to target instrument structure or NULL to create new
;	A2.L	=	APTR to loading flag pass structure (Loader specific)
;	D0.L	=	Number of instrument to be loaded (NULL is the first)
;	OUTPUT
;	D0.L	=	APTR to instrument structure where loaded instrument data is
ExternalInstrLoad:	movem.l	d2-d7/a2-a6,-(sp)
	move.l	d0,d6
	moveq	#10,d0
	moveq	#0,d1
	moveq	#0,d7
CreateBitTable:	tst.l	(a2)+
	beq.s	BitNotSet
	bset	d1,d7
BitNotSet:	addq.b	#1,d1
	dbra	d0,CreateBitTable
	move.l	a0,d1
	lea	-576(sp),sp
	moveq	#192/2,d3
	add.l	d3,d3
	move.l	sp,d2
	move.l	d1,a2
	move.l	a1,a3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadFault
	move.w	42(sp),d4
	rol.w	#8,d4
	cmp.w	#$0215,d4
	seq	558(sp)
	cmp.w	#$0216,d4
	bhi	ExternalLoadWrongVersion
	moveq	#0,d2
	move.w	36(sp),d2
	rol.w	#8,d2
	move.w	d2,d0
	lsl.l	#2,d0
	move.l	d0,d5
	addq.l	#2,d0
	moveq	#MEMF_PUBLIC,d1
	move.l	a6,a5
	move.l	4.w,a6
	jsr	_LVOAllocVec(a6)
	move.l	a5,a6
	move.l	d0,554(sp)
	beq	ExternalLoadFault
	move.l	d0,a0
	move.w	d2,(a0)
	move.l	a2,d1
	move.w	32(sp),d2
	rol.w	#8,d2
	move.w	34(sp),d3
	rol.w	#8,d3
	lsl.l	#2,d3
	add.l	d3,d2
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalLoadError
	move.l	a2,d1
	move.l	d5,d3
	add.l	d2,d5
	move.l	554(sp),d2
	addq.l	#2,d2
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadError
	moveq	#0,d2
	move.w	34(sp),d2
	rol.w	#8,d2
	cmp.l	d2,d6
	bcc	ExternalLoadError
	move.w	32(sp),d2
	rol.w	#8,d2
	lsl.l	#2,d6
	add.l	d6,d2
	sub.l	d5,d2
	move.l	a2,d1
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalLoadError
	move.l	a2,d1
	move.l	sp,d2
	moveq	#4,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadError
	move.l	(sp),d2
	move.l	a2,d1
	rol.w	#8,d2
	swap	d2
	rol.w	#8,d2
	moveq	#OFFSET_BEGINNING,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalLoadError
	move.l	a2,d1
	move.l	sp,d2
	move.l	#554,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadError
	moveq	#0,d0
	jsr	_LVOAllocInstr(a6)
	move.l	d0,d1
	beq	ExternalLoadError
	move.l	d0,a4
	move.w	#~(TCIEPF_ProcVolumeEnv|TCIEPF_ProcPanningEnv|TCIEPF_ProcSlideEnv|$8000),tci_EnvProcFlags(a4)
	moveq	#0,d0
	lea	304(sp),a0
	cmp.w	#$0200,d4
	bcc	LoadNewInstr
	btst	#2,d7
	beq	CopyOldDone
	moveq	#0,d0
	move.w	#200-1,d1
GetEnvLen:	addq.l	#1,d0
	cmp.b	#$ff,(a0)+
	dbeq	d1,GetEnvLen
	bne.s	OldEnvEndFound
	subq.l	#1,d0
OldEnvEndFound:	moveq	#25-1,d1
	moveq	#-1,d4
	lea	504(sp),a0
OldEnvGetNumNodes:	addq.l	#1,d4
	cmp.w	#$ffff,(a0)+
	dbeq	d1,OldEnvGetNumNodes
	moveq	#ENVL_EMPTY,d1
	move.l	d0,d2
	moveq	#0,d3
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,tci_VolumeEnvelope(a4)
	beq	ExternalLoadErr
	move.l	d0,a1
	moveq	#25-1,d1
	lea	504(sp),a0
	move.l	tcie_NodePoints(a1),a5
OldEnvCopyNodes:	move.w	(a0)+,d0
	cmp.w	#$ffff,d0
	beq.s	OldEnvCopyNodesDone
	lsr.w	#8,d0
	move.w	d0,(a5)+
	dbra	d1,OldEnvCopyNodes
	move.l	tci_VolumeEnvelope(a4),a0
	jsr	_LVOValidateEnvNodes(a6)
OldEnvCopyNodesDone:	moveq	#0,d0
	lea	17(sp),a0
	lea	504(sp),a5
	btst	#1,(a0)
	beq.s	NotUseVolLoop
	addq.b	#TCIEF_Loop,d0
NotUseVolLoop:	btst	#2,(a0)+
	beq.s	NotUseSusVolLoop
	addq.b	#TCIEF_Sustain,d0
NotUseSusVolLoop:	move.b	d0,tcie_Flags+1(a1)
	move.b	(a0)+,d0
	move.b	(a5,d0.w*2),tcie_LoopStart+1(a1)
	move.b	(a0)+,d0
	move.b	(a5,d0.w*2),tcie_LoopEnd+1(a1)
	move.b	(a0)+,d0
	move.b	(a5,d0.w*2),tcie_SustainStart+1(a1)
	move.b	(a0),d0
	move.b	(a5,d0.w*2),tcie_SustainEnd+1(a1)
	lea	304(sp),a0
	move.l	tcie_Data(a1),a1
CopyOldEnvelopeLoop:	moveq	#0,d0
	move.b	(a0)+,d0
	sub.w	#32,d0
	muls.w	#$7fff,d0
	asr.l	#5,d0
	move.w	d0,(a1)+
	subq.b	#1,d2
	bne.s	CopyOldEnvelopeLoop
CopyOldDone:	lea	24(sp),a0
	move.w	(a0)+,d0
	rol.w	#8,d0
	lsl.w	#7,d0
	bcc.s	OldFadeOk
	moveq	#-1,d0
OldFadeOk:	move.w	d0,tci_FadeOut(a4)
	move.b	(a0)+,tci_NNA(a4)
	move.b	(a0)+,d0
	beq.s	NotOldDCT
	moveq	#DCTF_InstrNoteOR|DCTF_InstrAND,d0
NotOldDCT:	move.b	d0,tci_DCT(a4)
	move.b	17(sp),304(sp)
	btst	#9,d7
	bne.s	NotOldGlobalVolume
	move.b	#64,tci_GlobalVolume(a4)
NotOldGlobalVolume:	bra	CopyIdentical
LoadNewInstr:	moveq	#32,d6
	move.l	a5,(sp)
	btst	#2,d7
	beq	NotConvertVolEnvData
	moveq	#0,d1
	move.b	1(a0),d1
	beq	NotConvertVolEnvData
	move.l	d1,d4
	subq.b	#1,d1
	beq	NotConvertVolEnvData
	move.b	d1,d2
	mulu.w	#3,d1
ConvertVolGetHighest:	move.w	6+1(a0,d1.w),d3
	rol.w	#8,d3
	addq.l	#1,d3
	cmp.w	d3,d0
	bhs.s	ConvertVolIsHighest
	move.w	d3,d0
ConvertVolIsHighest:	subq.w	#3,d1
	bcc.s	ConvertVolGetHighest
	moveq	#ENVL_EMPTY,d1
	moveq	#0,d3
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,tci_VolumeEnvelope(a4)
	beq	ExternalLoadErr
	lea	304(sp),a0
	move.l	d0,a1
	moveq	#0,d0
	btst	#2,(a0)
	beq.s	NotSustainEnv
	addq.b	#TCIEF_Sustain,d0
NotSustainEnv:	btst	#1,(a0)
	beq.s	NotLoopEnv
	addq.b	#TCIEF_Loop,d0
NotLoopEnv:	move.b	d0,tcie_Flags+1(a1)
	moveq	#0,d1
	moveq	#3,d3
	addq.l	#2,a0
	move.b	(a0)+,d1
	mulu.w	d3,d1
	move.w	4(a0,d1.w),d0
	rol.w	#8,d0
	move.w	d0,tcie_LoopStart(a1)
	move.b	(a0)+,d1
	mulu.w	d3,d1
	move.w	4-1(a0,d1.w),d0
	rol.w	#8,d0
	move.w	d0,tcie_LoopEnd(a1)
	move.b	(a0)+,d1
	mulu.w	d3,d1
	move.w	4-2(a0,d1.w),d0
	rol.w	#8,d0
	move.w	d0,tcie_SustainStart(a1)
	move.b	(a0)+,d1
	mulu.w	d3,d1
	move.w	4-3(a0,d1.w),d0
	rol.w	#8,d0
	move.w	d0,tcie_SustainEnd(a1)
	move.l	tcie_NodePoints(a1),a5
	move.l	tcie_Data(a1),a1
ConvertEnvelopeData:	move.b	(a0)+,d1
	sub.b	d6,d1
	ext.w	d1
	muls.w	#$7fff,d1
	asr.l	#5,d1
	move.w	(a0)+,d0
	rol.w	#8,d0
	move.w	d0,(a5)+
	move.b	(a0),d4
	sub.b	d6,d4
	ext.w	d4
	muls.w	#$7fff,d4
	asr.l	#5,d4
	move.w	1(a0),d3
	rol.w	#8,d3
	bne.s	NotNullLastVol
	move.w	d0,d3
	addq.w	#1,d3
NotNullLastVol:	sub.w	d0,d3
	bls.s	NotNullLastVol2
	sub.l	d1,d4
	divs.w	d3,d4
	moveq	#0,d5
	move.w	d3,d0
	cmp.b	#1,d2
	bne.s	AddEnvelopeData
	addq.w	#1,d0
AddEnvelopeData:	move.w	d1,(a1)+
	add.w	d4,d1
	swap	d4
	add.w	d4,d5
	bpl.s	NotSubEnvData
	add.w	d3,d5
	subq.w	#1,d1
NotSubEnvData:	cmp.w	d3,d5
	bcs.s	NotAddEnvData
	sub.w	d3,d5
	addq.w	#1,d1
NotAddEnvData:	swap	d4
	subq.w	#1,d0
	bne.s	AddEnvelopeData
NotNullLastVol2:	subq.b	#1,d2
	bne.s	ConvertEnvelopeData
	move.l	tci_VolumeEnvelope(a4),a0
	jsr	_LVOValidateEnvNodes(a6)
NotConvertVolEnvData:	btst	#3,d7
	beq	NotConvertPanEnvData
	moveq	#0,d0
	moveq	#0,d1
	lea	386+1(sp),a0
	move.b	(a0),d1
	beq	NotConvertPanEnvData
	move.l	d1,d4
	subq.b	#1,d1
	beq	NotConvertPanEnvData
	move.b	d1,d2
	mulu.w	#3,d1
ConvertPanGetHighest:	move.w	6(a0,d1.w),d3
	rol.w	#8,d3
	addq.l	#1,d3
	cmp.w	d3,d0
	bhs.s	ConvertPanIsHighest
	move.w	d3,d0
ConvertPanIsHighest:	subq.w	#3,d1
	bcc.s	ConvertPanGetHighest
	moveq	#ENVL_EMPTY,d1
	moveq	#0,d3
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,tci_PanningEnvelope(a4)
	beq	ExternalLoadErr
	lea	386(sp),a0
	move.l	d0,a1
	moveq	#0,d0
	btst	#2,(a0)
	beq.s	NotPanSustainEnv
	addq.b	#TCIEF_Sustain,d0
NotPanSustainEnv:	btst	#1,(a0)
	beq.s	NotLoopPanEnv
	addq.b	#TCIEF_Loop,d0
NotLoopPanEnv:	move.b	d0,tcie_Flags+1(a1)
	moveq	#0,d1
	moveq	#3,d3
	addq.l	#2,a0
	move.b	(a0)+,d1
	mulu.w	d3,d1
	move.w	4(a0,d1.w),d0
	rol.w	#8,d0
	move.w	d0,tcie_LoopStart(a1)
	move.b	(a0)+,d1
	mulu.w	d3,d1
	move.w	4-1(a0,d1.w),d0
	rol.w	#8,d0
	move.w	d0,tcie_LoopEnd(a1)
	move.b	(a0)+,d1
	mulu.w	d3,d1
	move.w	4-2(a0,d1.w),d0
	rol.w	#8,d0
	move.w	d0,tcie_SustainStart(a1)
	move.b	(a0)+,d1
	mulu.w	d3,d1
	move.w	4-3(a0,d1.w),d0
	rol.w	#8,d0
	move.w	d0,tcie_SustainEnd(a1)
	move.l	tcie_NodePoints(a1),a5
	move.l	tcie_Data(a1),a1
ConvertPanEnvelopeData:	move.b	(a0)+,d1
	ext.w	d1
	muls.w	#$7fff,d1
	asr.l	#5,d1
	move.w	(a0)+,d0
	rol.w	#8,d0
	move.w	d0,(a5)+
	move.b	(a0),d4
	ext.w	d4
	muls.w	#$7fff,d4
	asr.l	#5,d4
	move.w	1(a0),d3
	rol.w	#8,d3
	bne.s	NotNullLastPan
	move.w	d0,d3
	addq.w	#1,d3
NotNullLastPan:	sub.w	d0,d3
	bls.s	NotNullLastPan2
	sub.l	d1,d4
	divs.w	d3,d4
	moveq	#0,d5
	move.w	d3,d0
	cmp.b	#1,d2
	bne.s	AddPanEnvelopeData
	addq.w	#1,d0
AddPanEnvelopeData:	move.w	d1,(a1)+
	add.w	d4,d1
	swap	d4
	add.w	d4,d5
	bpl.s	NotSubPanEnvData
	add.w	d3,d5
	subq.w	#1,d1
NotSubPanEnvData:	cmp.w	d3,d5
	bcs.s	NotAddPanEnvData
	sub.w	d3,d5
	addq.w	#1,d1
NotAddPanEnvData:	swap	d4
	subq.w	#1,d0
	bne.s	AddPanEnvelopeData
NotNullLastPan2:	subq.b	#1,d2
	bne.s	ConvertPanEnvelopeData
	move.l	tci_PanningEnvelope(a4),a0
	jsr	_LVOValidateEnvNodes(a6)
NotConvertPanEnvData:	moveq	#0,d0
	btst	#4,d7
	beq	NotConvertPitchEnvData
	moveq	#0,d1
	lea	468(sp),a0
	tst.b	(a0)+
	bmi	NotConvertPitchEnvData
	move.b	(a0),d1
	beq	NotConvertPitchEnvData
	move.l	d1,d4
	subq.b	#1,d1
	beq	NotConvertPitchEnvData
	move.b	d1,d2
	mulu.w	#3,d1
ConvertPitchGetHighest:	move.w	6(a0,d1.w),d3
	rol.w	#8,d3
	addq.l	#1,d3
	cmp.w	d3,d0
	bhs.s	ConvertPitchIsHighest
	move.w	d3,d0
ConvertPitchIsHighest:	subq.w	#3,d1
	bcc.s	ConvertPitchGetHighest
	moveq	#ENVL_EMPTY,d1
	moveq	#0,d3
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,tci_SlideEnvelope(a4)
	beq	ExternalLoadErr
	lea	468(sp),a0
	move.l	d0,a1
	moveq	#0,d0
	btst	#2,(a0)
	beq.s	NotPitchSustainEnv
	addq.b	#TCIEF_Sustain,d0
NotPitchSustainEnv:	btst	#1,(a0)
	beq.s	NotLoopPitchEnv
	addq.b	#TCIEF_Loop,d0
NotLoopPitchEnv:	move.b	d0,tcie_Flags+1(a1)
	moveq	#0,d1
	moveq	#3,d3
	addq.l	#2,a0
	move.b	(a0)+,d1
	mulu.w	d3,d1
	move.w	4(a0,d1.w),d0
	rol.w	#8,d0
	move.w	d0,tcie_LoopStart(a1)
	move.b	(a0)+,d1
	mulu.w	d3,d1
	move.w	4-1(a0,d1.w),d0
	rol.w	#8,d0
	move.w	d0,tcie_LoopEnd(a1)
	move.b	(a0)+,d1
	mulu.w	d3,d1
	move.w	4-2(a0,d1.w),d0
	rol.w	#8,d0
	move.w	d0,tcie_SustainStart(a1)
	move.b	(a0)+,d1
	mulu.w	d3,d1
	move.w	4-3(a0,d1.w),d0
	rol.w	#8,d0
	move.w	d0,tcie_SustainEnd(a1)
	move.l	tcie_NodePoints(a1),a5
	move.l	tcie_Data(a1),a1
ConvertPitchEnvelopeData:	move.b	(a0)+,d1
	ext.w	d1
	asl.w	#7,d1
	move.w	(a0)+,d0
	rol.w	#8,d0
	move.w	d0,(a5)+
	move.b	(a0),d4
	ext.w	d4
	asl.w	#7,d4
	move.w	1(a0),d3
	rol.w	#8,d3
	bne.s	NotNullLastPitch
	move.w	d0,d3
	addq.w	#1,d3
NotNullLastPitch:	sub.w	d0,d3
	bls.s	NotNullLastPitch2
	sub.w	d1,d4
	ext.l	d4
	divs.w	d3,d4
	moveq	#0,d5
	move.w	d3,d0
	cmp.b	#1,d2
	bne.s	AddPitchEnvelopeData
	addq.w	#1,d0
AddPitchEnvelopeData:	move.w	d1,d6
	move.w	d6,(a1)+
	add.w	d4,d1
	swap	d4
	add.w	d4,d5
	bpl.s	NotSubPitchEnvData
	add.w	d3,d5
	subq.w	#1,d1
NotSubPitchEnvData:	cmp.w	d3,d5
	bcs.s	NotAddPitchEnvData
	sub.w	d3,d5
	addq.w	#1,d1
NotAddPitchEnvData:	swap	d4
	subq.w	#1,d0
	bne.s	AddPitchEnvelopeData
NotNullLastPitch2:	subq.b	#1,d2
	bne.s	ConvertPitchEnvelopeData
	move.l	tci_SlideEnvelope(a4),a0
	jsr	_LVOValidateEnvNodes(a6)
NotConvertPitchEnvData:	move.l	(sp),a5
	lea	17(sp),a0
	move.b	(a0)+,tci_NNA(a4)
	moveq	#0,d1
	move.b	(a0)+,d0
	beq.s	LoadDCT
	moveq	#DCTF_InstrNoteOR|DCTF_InstrAND,d1
	subq.b	#1,d0
	beq.s	LoadDCT
	moveq	#-256+(DCTF_InstrOR|DCTF_SampleAND),d1
	subq.b	#1,d0
	beq.s	LoadDCT
	moveq	#DCTF_InstrOR,d1
	subq.b	#1,d0
	bne.s	NotLoadDCT
LoadDCT:	move.b	d1,tci_DCT(a4)
NotLoadDCT:	move.b	(a0)+,tci_DNA(a4)
	move.w	(a0)+,d0
	rol.w	#8,d0
	lsl.w	#6,d0
	bcc.s	LoadFadeOk
	moveq	#-1,d0
LoadFadeOk:	move.w	d0,tci_FadeOut(a4)
	move.b	(a0)+,d1
	ext.w	d1
	asl.w	#7,d1
	move.w	d1,tci_PitchPanSeparation(a4)
	move.b	(a0)+,tci_PitchPanCenter(a4)
	moveq	#0,d0
	move.b	(a0)+,d0
	btst	#9,d7
	beq.s	Bit6GlobalVolume
	add.b	d0,d0
	bcc.s	LoadGlobalVolume
	st	d0
	bra.s	LoadGlobalVolume
Bit6GlobalVolume:	addq.w	#1,d0
	lsr.w	#1,d0
LoadGlobalVolume:	move.b	d0,tci_GlobalVolume(a4)
	move.b	(a0)+,d0
	bclr	#7,d0
	bne.s	NotInstPan
	bset	#TCIB_DefaultPanning,tci_Flags(a4)
NotInstPan:	lsl.b	#2,d0
	bcc.s	NotDefPanMax
	st	d0
NotDefPanMax:	move.b	d0,tci_DefaultPanning(a4)
	move.b	(a0)+,d0
	lsl.w	#8,d0
	divu.w	#100,d0
	move.w	d0,tci_VolumeSwing(a4)
	move.b	(a0),d1
	lsl.b	#2,d1
	bcc.s	NotFullPanSwing
	moveq	#-1,d1
NotFullPanSwing:	move.b	d1,tci_PanningSwing+1(a4)
	move.w	60(sp),tci_MIDICh(a4)
CopyIdentical:	lea	tci_FileName(a4),a0
	lea	4(sp),a1
	jsr	_LVOSetString(a6)
	lea	32(sp),a1
	lea	58(sp),a0
	clr.b	(a0)
FindInstNameNonNull:	cmp.l	a0,a1
	beq.s	FindInstNameDone
	tst.b	-(a0)
	beq.s	FindInstNameNonNull
ReplaceInstNameNulls:	cmp.l	a0,a1
	beq.s	FindInstNameOk
	tst.b	-(a0)
	bne.s	ReplaceInstNameNulls
	move.b	#" ",(a0)
	bra.s	ReplaceInstNameNulls
FindInstNameOk:	lea	tci_Name(a4),a0
	jsr	_LVOSetString(a6)
FindInstNameDone:	moveq	#120-1,d0
	moveq	#1,d1
	lea	64(sp),a0
CheckLoadKeyboard:	cmp.w	(a0)+,d1
	bne.s	LoadKeyboard
	add.w	#$0100,d1
	dbra	d0,CheckLoadKeyboard
	bra.s	NotLoadKeyboard
LoadKeyboard:	jsr	_LVOAllocKeyboard(a6)
	move.l	d0,tci_KeyboardDefs(a4)
	beq	ExternalLoadErr
	lea	64(sp),a0
	move.l	d0,a1
	moveq	#120-1,d0
	addq.l	#MLN_SIZE,a1
ConvertIMPIKeyboard:	moveq	#0,d1
	move.b	(a0)+,d1
	divu.w	#12,d1
	move.b	d1,2(a1)
	swap	d1
	addq.b	#1,d1
	move.b	d1,3(a1)
	move.b	(a0)+,d1
	move.w	d1,(a1)
	addq.l	#4,a1
	dbra	d0,ConvertIMPIKeyboard
NotLoadKeyboard:	move.l	#$80000080,d2
	moveq	#DEFAULT_ENVNODES,d4
	btst	#5,d7
	beq.s	NotLoadVibrato
	moveq	#0,d0
	move.w	d2,d0
	moveq	#ENVL_SINE,d1
	moveq	#0,d3
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,tci_VibratoEnvelope(a4)
	beq	ExternalLoadErr
NotLoadVibrato:	move.l	#$80000100,d2
	btst	#6,d7
	beq.s	NotLoadTremolo
	moveq	#$100/4,d0
	lsl.l	#2,d0
	moveq	#ENVL_SINE,d1
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,tci_TremoloEnvelope(a4)
	beq	ExternalLoadErr
NotLoadTremolo:	tst.b	d7
	bpl.s	NotLoadPannolo
	moveq	#$100/4,d0
	lsl.l	#2,d0
	moveq	#ENVL_SINE,d1
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,tci_PannoloEnvelope(a4)
	beq	ExternalLoadErr
NotLoadPannolo:	btst	#0,d7
	beq	NoLoadSamples
	move.l	554(sp),a0
	moveq	#120-1,d0
	move.w	(a0),d2
	lea	64(sp),a0
	lea	128(sp),a1
	clr.b	(a1)
GetKeyboardSamples:	move.w	(a0)+,d1
	tst.b	d1
	beq.s	NoKeySample
	cmp.b	d1,d2
	bcs.s	NoKeySample
	lea	128(sp),a5
CheckKeySamples:	cmp.l	a5,a1
	beq.s	CheckKeySmpDone
	cmp.b	(a5)+,d1
	beq.s	NoKeySample
	bra.s	CheckKeySamples
CheckKeySmpDone:	move.b	d1,(a1)+
	clr.b	(a1)
NoKeySample:	dbra	d0,GetKeyboardSamples
	move.l	tci_KeyboardDefs(a4),d0
	beq.s	NotReMapKeyboard
	move.l	d0,a1
	addq.l	#MLN_SIZE,a1
	moveq	#120-1,d0
ReMapKeyboardLoop:	moveq	#-1,d1
	move.b	1(a1),d2
	addq.b	#1,d2
	beq.s	CheckNextReMap
	lea	128(sp),a0
FindReMapSmp:	addq.b	#1,d1
	cmp.b	(a0)+,d2
	bne.s	FindReMapSmp
	move.b	d1,1(a1)
CheckNextReMap:	addq.l	#4,a1
	dbra	d0,ReMapKeyboardLoop
NotReMapKeyboard:	lea	128(sp),a0
	move.l	a0,d4
LoadSamples:	move.l	d4,a0
	moveq	#0,d0
	move.b	(a0)+,d0
	beq	LoadSamplesDone
	move.l	a0,d4
	move.l	a2,d1
	move.l	554(sp),a0
	move.l	2-4(a0,d0.w*4),d2
	rol.w	#8,d2
	swap	d2
	rol.w	#8,d2
	moveq	#OFFSET_BEGINNING,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalLoadError
	move.l	a2,d1
	move.l	sp,d2
	moveq	#80,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadError
	move.l	48(sp),d0
	rol.w	#8,d0
	swap	d0
	rol.w	#8,d0
	btst	#1,18(sp)
	beq.s	SampleOk
	add.l	d0,d0
SampleOk:	sub.l	a0,a0
	jsr	_LVOAllocSample(a6)
	move.l	d0,d6
	beq	ExternalLoadErr
	move.l	d6,a1
	lea	tcs_FileName(a1),a0
	lea	4(sp),a1
	jsr	_LVOSetString(a6)
	move.l	d6,a1
	lea	46(sp),a0
	move.b	(a0),tcs_CompFlags(a1)
	clr.b	(a0)
	lea	20(sp),a1
FindSmpNameNonNull:	cmp.l	a0,a1
	beq.s	FindSmpNameDone
	tst.b	-(a0)
	beq.s	FindSmpNameNonNull
ReplaceSmpNameNulls:	cmp.l	a0,a1
	beq.s	FindSmpNameOk
	tst.b	-(a0)
	bne.s	ReplaceSmpNameNulls
	move.b	#" ",(a0)
	bra.s	ReplaceSmpNameNulls
FindSmpNameOk:	move.l	d6,a0
	lea	tcs_Name(a0),a0
	jsr	_LVOSetString(a6)
FindSmpNameDone:	move.l	d6,a1
	move.b	17(sp),d0
	btst	#9,d7
	beq.s	NotConvSmpGlobVol
	lsl.b	#2,d0
	bcc.s	NotConvSmpGlobVol
	moveq	#-1,d0
NotConvSmpGlobVol:	move.b	d0,tcs_GlobalVolume(a1)
	move.b	19(sp),d0
	btst	#9,d7
	beq.s	NotConvSmpLoadVol
	lsl.b	#2,d0
	bcc.s	NotConvSmpLoadVol
	moveq	#-1,d0
NotConvSmpLoadVol:	move.b	d0,tcs_Volume(a1)
	move.b	18(sp),d0
	moveq	#0,d1
	btst	#4,d0
	beq.s	NotUseLoop
	addq.b	#TCSF_Loop,d1
NotUseLoop:	btst	#5,d0
	beq.s	NotUseSusLoop
	addq.b	#TCSF_SustainLoop,d1
NotUseSusLoop:	btst	#6,d0
	beq.s	NotPingpongLoop
	move.b	#TCSRF_Pingpong,tcs_RepMode(a1)
NotPingpongLoop:	tst.b	d0
	bpl.s	NotPingpongSusLoop
	move.b	#TCSRF_Pingpong,tcs_SustainRepMode(a1)
NotPingpongSusLoop:	move.b	47(sp),d0
	bclr	#7,d0
	beq.s	NotUseSmpPanning
	addq.b	#TCSF_SmpPanning,d1
NotUseSmpPanning:	move.b	d1,tcs_Flags(a1)
	lsl.b	#2,d0
	bcc.s	InsPanningOk
	moveq	#-1,d0
InsPanningOk:	move.b	d0,tcs_Panning(a1)
	movem.l	52(sp),d0-d3/d5-d6
	rol.w	#8,d0
	rol.w	#8,d1
	rol.w	#8,d2
	rol.w	#8,d3
	rol.w	#8,d5
	rol.w	#8,d6
	swap	d0
	swap	d1
	swap	d2
	swap	d3
	swap	d5
	swap	d6
	rol.w	#8,d0
	rol.w	#8,d1
	rol.w	#8,d2
	rol.w	#8,d3
	rol.w	#8,d5
	rol.w	#8,d6
	sub.l	d0,d1
	movem.l	d0-d1,tcs_Repeat(a1)
	move.l	d2,tcs_Rate(a1)
	sub.l	d3,d5
	movem.l	d3/d5,tcs_SustainRepeat(a1)
	move.l	d6,tcs_Synth(a1)
	btst	#10,d7
	beq.s	NotTranslateOctaves
	move.b	#-12,tcs_Transpose(a1)
NotTranslateOctaves:	move.b	#TCSEPF_LinearAutoVib,tcs_EnvProcFlags(a1)
	move.l	a1,d6
	move.l	a4,a0
	jsr	_LVOAddSample(a6)
	move.l	d6,a1
	btst	#8,d7
	beq.s	NoAutoVibrato
	lea	76(sp),a0
	move.b	(a0)+,tcs_VibratoRate(a1)
	move.b	(a0)+,tcs_VibratoDepth(a1)
	move.b	(a0),tcs_VibratoSweep+1(a1)
	lea	76(sp),a0
	tst.w	(a0)+
	beq.s	NoAutoVibrato
	tst.b	(a0)+
	beq.s	NoAutoVibrato
	move.b	(a0),d0
	moveq	#ENVL_SINE,d1
	subq.b	#1,d0
	bne.s	NotRampWave
	moveq	#ENVL_RAMP,d1
NotRampWave:	subq.b	#1,d0
	bne.s	NotSquareWave
	moveq	#ENVL_SQUARE,d1
NotSquareWave:	subq.b	#1,d0
	bne.s	NotRandomWave
	move.b	#TCSERF_RandomAVibEnv,tcs_EnvRandomFlags(a1)
NotRandomWave:	moveq	#64,d0
	lsl.w	#2,d0
	moveq	#64,d2
	add.l	d2,d2
	moveq	#0,d3
	moveq	#DEFAULT_ENVNODES,d4
	move.l	a1,a5
	jsr	_LVOCreateEnvelope(a6)
	move.l	a5,a1
	move.l	d6,a0
	move.l	d0,tcs_AutoVibratoEnv(a0)
	beq	ExternalLoadErr
	move.l	d0,a0
	bset	#TCIEB_Loop,tcie_Flags+1(a0)
	move.w	tcie_NumPoints(a0),tcie_LoopEnd(a0)
	subq.w	#1,tcie_LoopEnd(a0)
NoAutoVibrato:	btst	#1,18(sp)
	beq.s	Not16BitSample
	moveq	#16,d0
	moveq	#CBF_ChangeOnly,d1
	move.l	d6,a0
	jsr	_LVOConvertBits(a6)
Not16BitSample:	bra	LoadSamples
LoadSamplesDone:	lea	tci_Samples(a4),a5
LoadSampleData:	move.l	(a5),a5
	tst.l	(a5)
	beq	NoLoadSamples
	move.l	a2,d1
	move.l	tcs_Synth(a5),d2
	clr.l	tcs_Synth(a5)
	btst	#0,18(sp)
	beq.s	LoadSampleData
	moveq	#OFFSET_BEGINNING,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalLoadErr
	btst	#3,18(sp)
	beq	NotDecompressSample
	movem.l	d4/d7,560(sp)
	move.l	d4,a0
	move.l	tcs_Data(a0),a1
	move.l	tcs_Samples(a0),568(sp)
	btst	#1,18(sp)
	bne	Decompress16BitLoop2
	bra.s	Decompress8BitLoop2
Decompress8BitLoop:	move.l	a1,-(sp)
	movem.l	4(sp),d0/a1
	exg	d0,a1
	jsr	_LVOFreePMem(a6)
	move.l	(sp)+,a1
	sub.l	d5,568(sp)
	bls	DecompressDone
Decompress8BitLoop2:	bsr	ReadBlock
	moveq	#0,d2
	moveq	#0,d3
	moveq	#9,d4
	moveq	#1,d5
	ror.w	#1,d5
	cmp.l	568(sp),d5
	blo.s	NotDecompress8Max
	move.l	568(sp),d5
NotDecompress8Max:	clr.l	572(sp)
Decompress8BitBlock:	cmp.l	572(sp),d5
	bls.s	Decompress8BitLoop
	move.l	d4,d0
	bsr	ReadBits
	cmp.b	#7,d4
	bhs.s	Not8Method1
	moveq	#1,d0
	move.b	d4,d1
	subq.b	#1,d1
	lsl.b	d1,d0
	cmp.b	d7,d0
	bne.s	Not8Method3
	moveq	#3,d0
	bsr	ReadBits
	move.l	d7,d1
	addq.b	#1,d1
	cmp.b	d4,d1
	blo.s	Not8Method1Add
	addq.b	#1,d1
Not8Method1Add:	move.b	d1,d4
	bra.s	Decompress8BitBlock
Not8Method1:	cmp.b	#9,d4
	bhs.s	Not8Method2
	moveq	#-1,d0
	moveq	#9,d1
	sub.b	d4,d1
	lsr.b	d1,d0
	subq.b	#4,d0
	cmp.b	d7,d0
	bhs.s	Not8Method3
	addq.b	#8,d0
	cmp.b	d7,d0
	blo.s	Not8Method3
	subq.b	#8,d0
	sub.b	d0,d7
	cmp.b	d4,d7
	blo.s	Not8Method2Add
	addq.b	#1,d7
Not8Method2Add:	move.b	d7,d4
	bra.s	Decompress8BitBlock
Not8Method2:	bne	ExternalLoadErr26
	btst	#8,d7
	beq.s	Not8Method3
	move.b	d7,d4
	addq.b	#1,d4
	bra.s	Decompress8BitBlock
Not8Method3:	move.l	d3,-(sp)
	moveq	#8,d1
	cmp.b	d1,d4
	blo.s	Not8Method31
	move.b	d7,d3
	bra.s	Not8Method32
Not8Method31:	sub.b	d4,d1
	move.b	d7,d3
	asl.b	d1,d3
	asr.b	d1,d3
Not8Method32:	add.b	d3,d2
	move.l	(sp)+,d3
	add.b	d2,d3
	move.b	d2,d0
	tst.b	558(sp)
	beq.s	Not8IT215Decompress
	move.b	d3,d0
Not8IT215Decompress:	addq.l	#1,572(sp)
	move.b	d0,(a1)+
	bra	Decompress8BitBlock
Decompress16BitLoop:	move.l	a1,-(sp)
	movem.l	4(sp),d0/a1
	exg	d0,a1
	jsr	_LVOFreePMem(a6)
	move.l	(sp)+,a1
	sub.l	d5,558(sp)
	bls	DecompressDone
Decompress16BitLoop2:	bsr	ReadBlock
	moveq	#0,d2
	moveq	#0,d3
	moveq	#17,d4
	moveq	#1,d5
	ror.w	#2,d5
	cmp.l	568(sp),d5
	blo.s	NotDecompress16Max
	move.l	568(sp),d5
NotDecompress16Max:	clr.l	572(sp)
Decompress16BitBlock:	cmp.l	572(sp),d5
	bls.s	Decompress16BitLoop
	move.l	d4,d0
	bsr	ReadBits
	cmp.b	#7,d4
	bhs.s	Not16Method1
	moveq	#1,d0
	move.b	d4,d1
	subq.b	#1,d1
	lsl.b	d1,d0
	cmp.b	d7,d0
	bne.s	Not16Method3
	moveq	#4,d0
	bsr	ReadBits
	move.l	d7,d1
	addq.b	#1,d1
	cmp.b	d4,d1
	blo.s	Not16Method1Add
	addq.b	#1,d1
Not16Method1Add:	move.b	d1,d4
	bra.s	Decompress16BitBlock
Not16Method1:	cmp.b	#17,d4
	bhs.s	Not16Method2
	moveq	#-1,d0
	moveq	#17,d1
	sub.b	d4,d1
	lsr.w	d1,d0
	subq.w	#8,d0
	cmp.w	d7,d0
	bhs.s	Not16Method3
	moveq	#16,d1
	add.w	d1,d0
	cmp.w	d7,d0
	blo.s	Not16Method3
	sub.w	d1,d0
	sub.w	d0,d7
	cmp.w	d4,d7
	blo.s	Not16Method2Add
	addq.w	#1,d7
Not16Method2Add:	move.w	d7,d4
	bra.s	Decompress16BitBlock
Not16Method2:	bne	ExternalLoadErr26
	btst	#16,d7
	beq.s	Not16Method3
	move.b	d7,d4
	addq.b	#1,d4
	bra.s	Decompress16BitBlock
Not16Method3:	move.l	d3,-(sp)
	moveq	#16,d1
	cmp.b	d1,d4
	blo.s	Not16Method31
	move.w	d7,d3
	bra.s	Not16Method32
Not16Method31:	sub.b	d4,d1
	move.w	d7,d3
	asl.w	d1,d3
	asr.w	d1,d3
Not16Method32:	add.w	d3,d2
	move.l	(sp)+,d3
	add.w	d2,d3
	move.w	d2,d0
	tst.b	558(sp)
	beq.s	Not16IT215Decompress
	move.w	d3,d0
Not16IT215Decompress:	addq.l	#1,572(sp)
	move.w	d0,(a1)+
	bra	Decompress16BitBlock
DecompressDone:	movem.l	560(sp),d4/d7
	bra.s	SignedSamples
NotDecompressSample:	move.l	a2,d1
	movem.l	tcs_Data(a5),d2-d3
	jsr	_LVOCRead(a6)
	addq.l	#1,d0
	beq	ExternalLoadErr
	cmp.b	#16,tcs_BitDepth(a5)
	bne.s	NotIntelOrder
	move.l	a5,a0
	jsr	_LVOConvertWord(a6)
NotIntelOrder:	btst	#0,tcs_CompFlags(a5)
	bne.s	SignedSamples
	move.l	a5,a0
	jsr	_LVOConvertSigned(a6)
SignedSamples:	move.b	#TCSCF_VolumeOnly|TCSCF_AffectChanPan|TCSCF_StartTonePorta|TCSCF_PlayBegin,tcs_CompFlags(a5)
	bra	LoadSampleData
NoLoadSamples:	btst	#0,304(sp)
	bne.s	VolEnvelopeUsed
	move.l	tci_VolumeEnvelope(a4),a0
	clr.l	tci_VolumeEnvelope(a4)
	jsr	_LVOFreeEnvelope(a6)
VolEnvelopeUsed:	btst	#0,386(sp)
	bne.s	PanEnvelopeUsed
	move.l	tci_PanningEnvelope(a4),a0
	clr.l	tci_PanningEnvelope(a4)
	jsr	_LVOFreeEnvelope(a6)
PanEnvelopeUsed:	btst	#0,468(sp)
	bne.s	PitchEnvelopeUsed
	move.l	tci_SlideEnvelope(a4),a0
	clr.l	tci_SlideEnvelope(a4)
	jsr	_LVOFreeEnvelope(a6)
PitchEnvelopeUsed:	move.l	a3,d0
	bne.s	InstrAllocated
	move.l	a4,a3
InstrAllocated:	move.l	a4,a0
	move.l	a3,a1
	jsr	_LVOReMapInstr(a6)
	move.l	a3,a0
	move.b	d7,d0
	not.b	d0
	lsl.b	#6,d0
	lsr.b	#7,d0
	jsr	_LVOAddInstrEnvelopes(a6)
ExternalLoadOk:	move.l	554(sp),a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
ExternalLoadDone:	move.l	a3,d0
	lea	576(sp),sp
	movem.l	(sp)+,d2-d7/a2-a6
	rts
ExternalLoadErr:	move.l	tci_VolumeEnvelope(a4),a0
	jsr	_LVOFreeEnvelope(a6)
	move.l	tci_PanningEnvelope(a4),a0
	jsr	_LVOFreeEnvelope(a6)
	move.l	tci_SlideEnvelope(a4),a0
	jsr	_LVOFreeEnvelope(a6)
	move.l	tci_VibratoEnvelope(a4),a0
	jsr	_LVOFreeEnvelope(a6)
	move.l	tci_TremoloEnvelope(a4),a0
	jsr	_LVOFreeEnvelope(a6)
	move.l	tci_PannoloEnvelope(a4),a0
	jsr	_LVOFreeEnvelope(a6)
	lea	tci_Samples(a4),a3
FreeSmpEnvLoop:	move.l	(a3),a3
	tst.l	(a3)
	beq.s	FreeSmpEnvDone
	move.l	tcs_AutoVibratoEnv(a3),a0
	jsr	_LVOFreeEnvelope(a6)
	bra.s	FreeSmpEnvLoop
FreeSmpEnvDone:	move.l	tci_KeyboardDefs(a4),a0
	jsr	_LVOFreeKeyboard(a6)
	move.l	a4,a0
	jsr	_LVOFreeInstr(a6)
ExternalLoadError:	move.l	554(sp),a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
ExternalLoadFault:	sub.l	a3,a3
	bra.s	ExternalLoadDone
ExternalLoadWrongVersion:	moveq	#255-ERROR_ACTION_NOT_KNOWN,d1
	not.b	d1
	move.l	tcb_DOSBase(a6),a6
	jsr	_LVOSetIoErr(a6)
	bra.s	ExternalLoadError
ExternalLoadErr28:	movem.l	8(sp),d0/a1
	exg	d0,a1
	jsr	_LVOFreePMem(a6)
ExternalLoadErr27:	addq.l	#8,sp
	bra.s	ExternalLoadErr25
ExternalLoadErr26:	movem.l	(sp),d0/a1
	exg	d0,a1
	jsr	_LVOFreePMem(a6)
ExternalLoadErr25:	movem.l	560(sp),d4/d7
	bra	ExternalLoadErr
ReadBlock:	move.l	a1,-(sp)
	move.l	a2,d1
	move.l	sp,d2
	addq.l	#8,d2
	moveq	#2,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalLoadErr27
	move.w	8(sp),d0
	rol.w	#8,d0
	move.l	d0,d3
	addq.l	#8-1,d0
	and.b	#-8,d0
	addq.l	#8,d0
	move.l	d0,12(sp)
	jsr	_LVOAllocPMem(a6)
	move.l	d0,8(sp)
	beq.s	ExternalLoadErr27
	move.l	a2,d1
	move.l	d0,d2
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalLoadErr28
	move.l	d2,a0
	move.l	d3,d0
	addq.l	#8-1,d0
	lsr.l	#3,d0
IntelLoop:	move.l	(a0),d1
	rol.w	#8,d1
	swap	d1
	rol.w	#8,d1
	move.l	d1,(a0)+
	move.l	(a0),d1
	rol.w	#8,d1
	swap	d1
	rol.w	#8,d1
	move.l	d1,(a0)+
	subq.l	#1,d0
	bne.s	IntelLoop
	moveq	#32,d6
	move.l	d2,a0
	move.l	(sp)+,a1
	rts
ReadBits:	cmp.b	d0,d6
	blo.s	ReadBitsNew
	move.l	(a0),d7
	moveq	#1,d1
	lsl.l	d0,d1
	subq.l	#1,d1
	and.l	d1,d7
	move.l	(a0),d1
	lsr.l	d0,d1
	move.l	d1,(a0)
	sub.b	d0,d6
	rts
ReadBitsNew:	movem.l	d2-d3,-(sp)
	move.b	d0,d2
	sub.b	d6,d2
	move.l	(a0)+,d7
	move.l	(a0),d3
	moveq	#1,d1
	lsl.l	d2,d1
	subq.l	#1,d1
	and.l	d1,d3
	lsl.l	d6,d3
	or.l	d3,d7
	move.l	(a0),d3
	lsr.l	d2,d3
	move.l	d3,(a0)
	moveq	#32,d6
	sub.b	d2,d6
	movem.l	(sp)+,d2-d3
	rts
AutoVibTab:	dc.b	ENVL_SINE,ENVL_SQUARE,ENVL_RAMP,0
;	INPUT
;	A0.L	=	APTR to cruncher file handle from where to get the info
;	A1.L	=	APTR to instrument info structure where to put information
;	D0.L	=	Number of instrument to be scanned (NULL is the first)
;	OUTPUT
;	D0.L	=	Any non-zero value for success, NULL for error.
ExternalInstrGetInfo:	movem.l	d2-d5/a2-a4/a6,-(sp)
	move.l	d0,d4
	move.l	a0,d1
	link	a5,#-558
	moveq	#192/2,d3
	add.l	d3,d3
	move.l	sp,d2
	move.l	d1,a2
	move.l	a1,a3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalGetInfoFault
	move.w	42(sp),d1
	rol.w	#8,d1
	cmp.w	#$0201,d1
	bcc	ExternalGetInfoWrongVersion
	move.b	41(sp),ii_Version(a3)
	move.b	40(sp),ii_Revision(a3)
	moveq	#0,d2
	move.w	36(sp),d2
	rol.w	#8,d2
	move.w	d2,d0
	lsl.l	#2,d0
	move.l	d0,d5
	addq.l	#2,d0
	moveq	#MEMF_PUBLIC,d1
	move.l	a6,a4
	move.l	4.w,a6
	jsr	_LVOAllocVec(a6)
	move.l	a4,a6
	move.l	d0,554(sp)
	beq	ExternalGetInfoFault
	move.l	d0,a0
	move.w	d2,(a0)
	move.l	a2,d1
	move.w	32(sp),d2
	rol.w	#8,d2
	move.w	34(sp),d3
	rol.w	#8,d3
	lsl.l	#2,d3
	add.l	d3,d2
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalGetInfoError
	move.l	a2,d1
	move.l	d5,d3
	add.l	d2,d5
	move.l	554(sp),d2
	addq.l	#2,d2
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalGetInfoError
	moveq	#0,d2
	move.w	34(sp),d2
	rol.w	#8,d2
	cmp.l	d2,d4
	bcc	ExternalGetInfoError
	move.w	32(sp),d2
	rol.w	#8,d2
	lsl.l	#2,d4
	add.l	d4,d2
	sub.l	d5,d2
	move.l	a2,d1
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalGetInfoError
	move.l	a2,d1
	move.l	sp,d2
	moveq	#4,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalGetInfoError
	move.l	(sp),d2
	move.l	a2,d1
	rol.w	#8,d2
	swap	d2
	rol.w	#8,d2
	moveq	#OFFSET_BEGINNING,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalGetInfoError
	move.w	42(sp),d4
	rol.w	#8,d4
	move.l	a2,d1
	move.l	sp,d2
	move.l	#554,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalGetInfoError
	cmp.w	#$0200,d4
	bcc.s	GetNewIMPIInfo
	lea	24(sp),a0
	move.w	(a0)+,d0
	rol.w	#8,d0
	lsl.w	#7,d0
	bcc.s	OldGetFadeOk
	moveq	#-1,d0
OldGetFadeOk:	move.w	d0,ii_FadeOut(a3)
	move.b	(a0)+,ii_NNA(a3)
	move.b	(a0)+,ii_DCT(a3)
	st	ii_GlobalVolume(a3)
	move.b	#DEFAULTPITCHPANCENTER,ii_PitchPanCenter(a3)
	move.b	#DEFAULTSAMPLEPANNING,ii_DefaultPanning(a3)
	bra	GetIdenticalInfo
GetNewIMPIInfo:	lea	17(sp),a0
	move.b	(a0)+,ii_NNA(a3)
	moveq	#0,d1
	move.b	(a0)+,d0
	beq.s	NoDCT
	moveq	#DCTF_InstrNoteOR|DCTF_InstrAND,d1
	subq.b	#1,d0
	beq.s	PutDCT
	moveq	#-256+(DCTF_InstrOR|DCTF_SampleAND),d1
	subq.b	#1,d0
	beq.s	PutDCT
	moveq	#DCTF_InstrOR,d1
	subq.b	#1,d0
	bne.s	NoDCT
PutDCT:	move.b	d1,ii_DCT(a3)
NoDCT:	move.b	(a0)+,ii_DNA(a3)
	move.w	(a0)+,d0
	rol.w	#8,d0
	lsl.w	#6,d0
	bcc.s	FadeOutOk
	moveq	#-1,d0
FadeOutOk:	move.w	d0,ii_FadeOut(a3)
	move.b	(a0)+,d1
	ext.w	d1
	asl.w	#7,d1
	move.w	d1,ii_PitchPanSeparation(a3)
	move.b	(a0)+,ii_PitchPanCenter(a3)
	move.b	(a0)+,d0
	add.b	d0,d0
	bcc.s	PutGlobalVolume
	moveq	#-1,d0
PutGlobalVolume:	move.b	d0,ii_GlobalVolume(a3)
	move.b	(a0)+,d0
	bclr	#7,d0
	bne.s	PutDefaultPan
	bset	#TCIB_DefaultPanning,ii_Flags(a3)
PutDefaultPan:	move.b	d0,tci_DefaultPanning(a3)
	moveq	#0,d0
	move.b	(a0)+,d0
	lsl.w	#8,d0
	divu.w	#100,d0
	move.w	d0,ii_VolumeSwing(a3)
	move.b	(a0)+,d1
	lsl.b	#2,d1
	bcc.s	NotFullPanSwing2
	st	d1
NotFullPanSwing2:	move.w	d1,ii_PanningSwing(a3)
	lea	304+1(sp),a0
	moveq	#0,d0
	move.b	(a0),d0
	mulu.w	#3,d0
	move.w	6-3(a0,d0.w),d1
	rol.w	#8,d1
	addq.w	#1,d1
	move.w	d1,ii_VolumeEnvelope(a3)
	moveq	#0,d0
	move.b	82(a0),d0
	mulu.w	#3,d0
	move.w	82+6-3(a0,d0.w),d1
	rol.w	#8,d1
	addq.w	#1,d1
	move.w	d1,ii_PanningEnvelope(a3)
	lea	468+1(sp),a0
	moveq	#0,d0
	move.b	(a0),d0
	mulu.w	#3,d0
	move.w	6-3(a0,d0.w),d1
	rol.w	#8,d1
	addq.w	#1,d1
	move.w	d1,ii_SlideEnvelope(a3)
	move.w	60(sp),ii_MIDICh(a3)
GetIdenticalInfo:	move.w	#256,d0
	move.w	d0,ii_VibratoEnvelope(a3)
	move.w	d0,ii_TremoloEnvelope(a3)
	move.w	#~(TCIEPF_ProcVolumeEnv|TCIEPF_ProcPanningEnv|TCIEPF_ProcSlideEnv|$8000),ii_EnvProcFlags(a3)
	moveq	#120-1,d0
	moveq	#0,d1
	lea	64(sp),a0
CheckKeyboardTable:	cmp.w	(a0)+,d1
	bne.s	KeyboardRequired
	add.w	#$0100,d1
	dbra	d0,CheckKeyboardTable
	bra.s	NoKeyboardRequired
KeyboardRequired:	move.w	#120,ii_KeyboardDefs(a3)
NoKeyboardRequired:	move.l	a3,a0
	lea	4(sp),a1
	jsr	_LVOSetString(a6)
	lea	32(sp),a1
	lea	58(sp),a0
	clr.b	(a0)
GetInstNameNonNull:	cmp.l	a0,a1
	beq.s	GetInstNameDone
	tst.b	-(a0)
	beq.s	GetInstNameNonNull
ReplaceGetInstNameNulls:	cmp.l	a0,a1
	beq.s	GetInstNameOk
	tst.b	-(a0)
	bne.s	ReplaceGetInstNameNulls
	move.b	#" ",(a0)
	bra.s	ReplaceGetInstNameNulls
GetInstNameOk:	lea	ii_Name(a3),a0
	jsr	_LVOSetString(a6)
GetInstNameDone:	move.l	554(sp),a0
	moveq	#120-1,d0
	move.w	(a0),d2
	lea	64(sp),a0
	move.l	a0,a1
	clr.b	(a1)
GetKeyboardInfoSamples:	move.w	(a0)+,d1
	tst.b	d1
	beq.s	NoKeyInfoSample
	cmp.b	d2,d1
	bcc.s	NoKeyInfoSample
	lea	64(sp),a4
CheckKeyInfoSamples:	cmp.l	a4,a1
	beq.s	CheckKeyInfoSmpDone
	cmp.b	(a4)+,d1
	beq.s	NoKeyInfoSample
	bra.s	CheckKeyInfoSamples
CheckKeyInfoSmpDone:	move.b	d1,(a1)+
	clr.b	(a1)
	addq.b	#1,ii_NumSamples(a3)
NoKeyInfoSample:	dbra	d0,GetKeyboardInfoSamples
	move.l	554(sp),a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
	move.l	a3,d0
ExternalGetInfoDone:	unlk	a5
	movem.l	(sp)+,d2-d5/a2-a4/a6
	rts
ExternalGetInfoError:	move.l	554(sp),a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
ExternalGetInfoFault:	moveq	#0,d0
	bra.s	ExternalGetInfoDone
ExternalGetInfoWrongVersion:	moveq	#255-ERROR_ACTION_NOT_KNOWN,d1
	not.b	d1
	move.l	tcb_DOSBase(a6),a6
	jsr	_LVOSetIoErr(a6)
	bra.s	ExternalGetInfoError
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	Number of instruments found or NULL on any error
ExternalInstrGetNums:	move.l	a6,-(sp)
	link	a5,#-44
	move.l	a0,d1
	move.l	sp,d2
	moveq	#44,d3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalGetNumError
	move.w	42(sp),d0
	rol.w	#8,d0
	cmp.w	#$0201,d0
	bcc.s	ExternalGetNumWrongVersion
	move.w	34(sp),d0
	rol.w	#8,d0
ExternalGetNumsDone:	unlk	a5
	move.l	(sp)+,a6
	rts
ExternalGetNumError:	moveq	#0,d0
	bra.s	ExternalGetNumsDone
ExternalGetNumWrongVersion:	moveq	#255-ERROR_ACTION_NOT_KNOWN,d1
	not.b	d1
	move.l	tcb_DOSBase(a6),a6
	jsr	_LVOSetIoErr(a6)
	bra.s	ExternalGetNumError

	cnop	0,4

ExtInstrLibBase:	dc.l	0

LoadFlags:	dc.w	11
	dc.w	LoadFlagSize
	dc.l	LoadText0
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0	
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText1
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText2
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText3
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText4
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText5
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	LoadText6
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	LoadText7
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	LoadText8
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	LoadText9
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText10
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
LoadText0:	dc.b	'Load samples',0
LoadText1:	dc.b	'Add envelopes to beginning',0
LoadText2:	dc.b	'Create volume envelope',0
LoadText3:	dc.b	'Create panning envelope',0
LoadText4:	dc.b	'Create slide envelope',0
LoadText5:	dc.b	'Create vibrato envelope',0
LoadText6:	dc.b	'Create tremolo envelope',0
LoadText7:	dc.b	'Create pannolo envelope',0
LoadText8:	dc.b	'Create auto vibrato envelope',0
LoadText9:	dc.b	'Convert volumes',0
LoadText10:	dc.b	'Translate octaves',0
	even
LoadFlagSize:	equ	*-LoadFlags
LoadDescript:	dc.b	'ImpulseTracker Module (IT)',0
