*********************************************************
***    TuComposer External Track Library for IT       ***
***       1996-97 by The united Coders (TuC)         ***
***                Main code: Basty/TuC               ***
*** This is an IT track loader (loads the tracks from ***
***           ImpulseTracker I & ][ modules)          ***
*********************************************************

	IFND	_G2
	MACHINE	MC68020
	OPT NODEBUG,NOLINE
	ENDC

	include	"exec/types.i"
	include	"exec/execbase.i"
	include	"exec/exec_lib.i"
	include	"exec/initializers.i"
	include	"exec/memory.i"
	include	"exec/resident.i"
	include	"exec/libraries.i"
	include	"libraries/dos_lib.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/track.i"
	include	"tucomposer/external/external.i"
	include	"tucomposer/external/external_lib.i"
	include	"tucomposer/external/track.i"
	include	"tucomposer/external/track_lib.i"

	moveq	#-1,d0
	rts
ResidentStruct:	dc.w	RTC_MATCHWORD
	dc.l	ResidentStruct
	dc.l	0
	dc.b	RTF_AUTOINIT
	dc.b	EXTLIB_TRACK_VERSION
	dc.b	NT_LIBRARY
	dc.b	0
	dc.l	LibName
	dc.l	LibID
	dc.l	Init
LibName:	dc.b	'itt.library',0
LibID:	dc.b	'TuComposer External Track Loader Version 1.00 (v31) for IT (68020+, OS2.0+) (3 Mar 97) by Basty/TuC.',0
TuComposerName:	dc.b	'tucomposer.library',0
	even
Init:	dc.l	trkl_SIZEOF
	dc.l	FuncTab
	dc.l	DataTab
	dc.l	PrepareLibrary

FuncTab:	dc.w	-1
	dc.w	Open-FuncTab
	dc.w	Close-FuncTab
	dc.w	Expunge-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalInitialize-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalTrackIdentify-FuncTab
	dc.w	ExternalTrackLoad-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalTrackGetInfo-FuncTab
	dc.w	ExternalTrackGetNums-FuncTab
	dc.w	-1

DataTab:	INITLONG	LN_NAME,LibName
	INITBYTE	LIB_FLAGS,LIBF_CHANGED|LIBF_SUMUSED
	INITWORD	LIB_VERSION,EXTLIB_TRACK_VERSION
	INITWORD	LIB_REVISION,EXTLIB_REVISION
	INITLONG	LIB_IDSTRING,LibID
	dc.l	0

PrepareLibrary:	btst	#AFB_68020,AttnFlags+1(a6)
	beq.s	ExtLib
	cmp.w	#36,LIB_VERSION(a6)
	blt.s	ExtLib
	move.l	a2,-(sp)
	move.l	d0,a2
	move.l	a0,extb_SegList(a2)
	moveq	#31,d0
	lea	TuComposerName(pc),a1
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,extb_TuComposerBase(a2)
	beq.s	NoTuCLib
	lea	ExtTrackLibBase(pc),a0
	move.l	a2,(a0)
	move.l	a2,d0
NoTuCLib:	move.l	(sp)+,a2
	rts
Open:	addq.w	#1,LIB_OPENCNT(a6)
	move.l	a6,d0
	rts
Close:	subq.w	#1,LIB_OPENCNT(a6)
	bne.s	ExtLib
	btst	#LIBB_DELEXP,LIB_FLAGS(a6)
	bne.s	Expunge
ExtLib:	moveq	#0,d0
	rts
Expunge:	bset	#LIBB_DELEXP,LIB_FLAGS(a6)
	tst.w	LIB_OPENCNT(a6)
	bne.s	ExtLib
	movem.l	d2/a5-a6,-(sp)
	move.l	extb_ExtLibList(a6),d0
	beq.s	NoExtLibList
	move.l	d0,a0
	clr.l	extl_LibBase(a0)
NoExtLibList:	move.l	extb_TuComposerBase(a6),a1
	move.l	a6,a5
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
	move.l	extb_SegList(a5),d2
	move.l	a5,a1
	jsr	_LVORemove(a6)
	move.l	a5,a1
	moveq	#0,d0
	moveq	#0,d1
	move.w	LIB_NEGSIZE(a5),d1
	sub.l	d1,a1
	move.w	LIB_POSSIZE(a5),d0
	add.l	d1,d0
	jsr	_LVOFreeMem(a6)
	move.l	d2,d0
	movem.l	(sp)+,d2/a5-a6
	rts
;	INPUT
;	A0.L	=	APTR to track external list structure to be initialized
;	OUTPUT
;	D0.L	=	What type of external library is it or NULL if error
ExternalInitialize:	move.l	extb_TuComposerBase(a6),a1
	movem.l	a2/a6,-(sp)
	move.l	a0,d0
	beq.s	ExternalInitDone
	move.l	a1,a6
	move.b	#EXTLF_Loader,extl_Flags(a0)
	move.l	a0,a2
	lea	extl_Descriptor(a0),a0
	lea	LoadDescript(pc),a1
	jsr	_LVOSetString(a6)
	tst.l	d0
	beq.s	ExternalInitDone
	lea	LoadFlags(pc),a0
	jsr	_LVOAllocFlagStr(a6)
	move.l	d0,extl_LoadFlagStr(a2)
	beq.s	ExternalInitDone
	moveq	#EXTTYPE_TRACK,d0
ExternalInitDone:	movem.l	(sp)+,a2/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	If failed NULL else any non-zero value
ExternalTrackIdentify:	movem.l	d2-d3/a6,-(sp)
	move.l	a0,d1
	subq.l	#4,sp
	move.l	sp,d2
	moveq	#4,d3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalTrackIdDone
	cmp.l	#"IMPM",(sp)
	beq.s	ExternalTrackIdOk
ExternalTrackIdDone:	moveq	#0,d0
ExternalTrackIdOk:	addq.l	#4,sp
	movem.l	(sp)+,d2-d3/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be loaded
;	A1.L	=	APTR to target track structure or NULL to create a new one
;	A2.L	=	APTR to loading flag pass structure (Loader specific)
;	D0.L	=	Number of track of be loaded (NULL is the first)
;	OUTPUT
;	D0.L	=	APTR to track structure where loaded track data
ExternalTrackLoad:	movem.l	d2-d7/a2-a6,-(sp)
	moveq	#255-192,d3
	not.b	d3
	sub.l	d3,sp
	move.l	sp,d2
	move.l	d0,d6
	tst.l	(a2)+
	sne	d7
	extb.l	d7
	tst.l	(a2)
	sne	d7
	move.l	a0,d1
	move.l	d1,a2
	move.l	a1,a3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalTrackLoadErr
	move.w	42(sp),d0
	rol.w	#8,d0
	cmp.w	#$0201,d0
	bcc	ExternalTrackWrongVersion
	moveq	#0,d1
	move.w	38(sp),d1
	rol.w	#8,d1
	lsl.l	#6,d1
	moveq	#64,d0
	cmp.l	d1,d6
	bcc	ExternalTrackLoadErr
	divul.l	d0,d5:d6
	lea	32(sp),a0
	moveq	#0,d2
	move.w	(a0)+,d2
	rol.w	#8,d2
	move.w	(a0)+,d1
	rol.w	#8,d1
	lsl.l	#2,d1
	add.l	d1,d2
	moveq	#0,d1
	move.w	(a0)+,d1
	rol.w	#8,d1
	lsl.l	#2,d1
	add.l	d1,d2
	lsl.l	#2,d6
	add.l	d6,d2
	move.l	a2,d1
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalTrackLoadDone
	move.l	a2,d1
	move.l	sp,d2
	moveq	#4,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalTrackLoadErr
	moveq	#64,d4
	move.l	(sp),d2
	beq.s	ExternalTrackEmpty
	move.l	a2,d1
	rol.w	#8,d2
	swap	d2
	rol.w	#8,d2
	moveq	#OFFSET_BEGINNING,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalTrackLoadDone
	move.l	a2,d1
	lea	56(sp),a0
	move.l	a0,d2
	moveq	#8,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalTrackLoadErr
	move.w	56(sp),d0
	rol.w	#8,d0
	move.l	d0,d3
	jsr	_LVOAllocPMem(a6)
	move.l	a6,a5
	move.l	a2,d1
	move.l	d0,d2
	beq	ExternalTrackLoadDone
	jsr	_LVOCRead(a6)
	move.l	d3,60(sp)
	cmp.l	d3,d0
	bne	ExternalTrackLoadError
	move.w	56+2(sp),d4
	rol.w	#8,d4
ExternalTrackEmpty:	move.l	a3,d0
	bne.s	TrackAllocated
	move.l	d4,d0
	jsr	_LVOAllocTrack(a6)
TrackAllocated:	move.l	d0,d1
	beq	ExternalTrackLoadError
	move.l	d0,a3
	move.l	d4,d0
	move.l	a3,a0
	jsr	_LVOReSizeTrack(a6)
	tst.l	d0
	bne	ExternalTrackLoadError
	move.l	a3,a0
	jsr	_LVOClearTrack(a6)
	move.l	d2,a2
	clr.b	30(sp)
	move.l	sp,a0
	addq.l	#4,a0
	jsr	_LVOAllocNameStr(a6)
	move.l	d0,tct_Name(a3)
	move.b	(128.w,sp,d5.w),d0
	lsl.b	#2,d0
	bcc.s	GlobalLoadVolOk
	subq.b	#1,d0
GlobalLoadVolOk:	move.b	d0,tct_Volume(a3)
	move.b	50(sp),tct_Frames+1(a3)
	move.b	51(sp),tct_BPMSpeed+1(a3)
	moveq	#255-128,d1
	not.b	d1
	move.b	64(sp,d5.w),d0
	bclr	#7,d0
	cmp.b	#100,d0
	beq.s	GetLRLoadPanInfoOk
	move.b	d0,d1
	lsl.b	#2,d1
	bcc.s	GetLRLoadPanInfoOk
	moveq	#-1,d1
GetLRLoadPanInfoOk:	move.b	d1,tct_Panning(a3)
	cmp.b	#100,d0
	bne.s	NotSurroundTrack
	move.b	#TCTF_SurPan,tct_Flags(a3)
NotSurroundTrack:	moveq	#TCTCF_Slide,d0
	btst	#4,45(sp)
	bne.s	ITOldEffects
	addq.b	#TCTCF_SOffset,d0
ITOldEffects:	btst	#5,45(sp)
	beq.s	NotLinkGsMemory
	addq.b	#TCTCF_TPorta,d0
NotLinkGsMemory:	move.b	d0,tct_CompFlags(a3)
	tst.l	d2
	beq	DecrunchDone
	move.l	tct_Data(a3),a4
	move.l	#$0000ff00,16(sp)
	clr.w	16+4(sp)
	moveq	#(64/4)-1,d0
	lea	64(sp),a0
ClearStackLoop:	clr.l	(a0)+
	dbra	d0,ClearStackLoop
DecrunchPattern:	move.l	#$0000ff00,(sp)
	clr.w	4(sp)
	move.b	(a2)+,d0
	bne.s	NotNextRow
	lea	tctd_NextRow(a4),a4
	subq.w	#1,d4
	bne.s	DecrunchPattern
	bra	DecrunchDone
NotNextRow:	subq.b	#1,d0
	and.w	#63,d0
	move.b	64(sp,d0.w),d1
	tst.b	-1(a2)
	bpl.s	NotNewMask
	move.b	(a2)+,d1
	move.b	d1,64(sp,d0.w)
NotNewMask:	btst	#0,d1
	beq.s	NotNote
	move.b	(a2)+,(sp)
	st	3(sp)
NotNote:	btst	#1,d1
	beq.s	NotInstr
	move.b	(a2)+,1(sp)
NotInstr:	btst	#2,d1
	beq.s	NotVolCol
	move.b	(a2)+,2(sp)
NotVolCol:	btst	#3,d1
	beq.s	NotFX
	move.w	(a2)+,4(sp)
NotFX:	cmp.b	d5,d0
	bne.s	DecrunchPattern
	lsr.b	#1,d1
	bcc.s	NotCorNote
	move.b	(sp),16(sp)
	move.b	3(sp),16+3(sp)
NotCorNote:	lsr.b	#1,d1
	bcc.s	NotCorInst
	move.b	1(sp),16+1(sp)
NotCorInst:	lsr.b	#1,d1
	bcc.s	NotCorVolCol
	move.b	2(sp),16+2(sp)
NotCorVolCol:	lsr.b	#1,d1
	bcc.s	NotCorFX
	move.w	4(sp),16+4(sp)
NotCorFX:	lsr.b	#1,d1
	bcc.s	NotLastNote
	move.b	16(sp),(sp)
	move.b	16+3(sp),3(sp)
NotLastNote:	lsr.b	#1,d1
	bcc.s	NotLastInstr
	move.b	16+1(sp),1(sp)
NotLastInstr:	lsr.b	#1,d1
	bcc.s	NotLastVolCol
	move.b	16+2(sp),2(sp)
NotLastVolCol:	lsr.b	#1,d1
	bcc.s	NotLastFX
	move.w	16+4(sp),4(sp)
NotLastFX:	move.l	sp,a1
	moveq	#0,d0
	move.b	(a1)+,d0
	tst.b	2(a1)
	beq.s	NoNote
	cmp.b	#254,d0
	beq.s	NoteCut
	cmp.b	#255,d0
	bne.s	NotKeyoff
	moveq	#255-NOTE_KEYOFF,d0
SpecialNote:	not.b	d0
NoNote:	move.w	d0,(a4)+
	bra.s	NoteDone
NoteCut:	moveq	#255-NOTE_KILL,d0
	bra.s	SpecialNote
NotKeyoff:	cmp.b	#120,d0
	bcs.s	NormalNote
	moveq	#255-NOTE_FADE,d0
	bra.s	NoNote
NormalNote:	moveq	#12,d1
	tst.l	d7
	bpl.s	NotConvertOctaves
	sub.b	d1,d0
	bcc.s	NotConvertOctaves
	add.b	d1,d0
NotConvertOctaves:	divu.w	d1,d0
	move.b	d0,(a4)+
	swap	d0
	addq.b	#1,d0
	move.b	d0,(a4)+
NoteDone:	moveq	#0,d0
	move.b	(a1)+,d0
	move.w	d0,(a4)+
	moveq	#0,d6
	move.b	(a1)+,d6
	cmp.b	#65,d6
	bcc.s	NotSetVolume
	moveq	#FX_SET_VOLUME,d0
ProcessVolCol:	tst.b	d7
	beq.s	NotVolFF
	lsl.b	#2,d6
	bcc.s	NotVolFF
	moveq	#-1,d6
NotVolFF:	bra	SetVolCol
NotSetVolume:	moveq	#10,d1
	sub.b	#75,d6
	bcc.s	NotFineVolUp
	moveq	#FX_F_VOLSL_UP,d0
ProcessVolSlide:	add.b	d1,d6
	bra.s	ProcessVolCol
NotFineVolUp:	sub.b	d1,d6
	bcc.s	NotFineVolDn
	moveq	#FX_F_VOLSL_DOWN,d0
	bra.s	ProcessVolSlide
NotFineVolDn:	sub.b	d1,d6
	bcc.s	NotVolSlUp
	moveq	#FX_VOL_SLD_UP,d0
	bra.s	ProcessVolSlide
NotVolSlUp:	sub.b	d1,d6
	bcc.s	NotVolSlDn
	moveq	#FX_VOL_SLD_DOWN,d0
	bra.s	ProcessVolSlide
NotVolSlDn:	sub.b	d1,d6
	bcc.s	NotPortaUp
	add.b	d1,d6
	moveq	#FX_PORTA_UP,d0
	bra.s	SetVolCol
NotPortaUp:	sub.b	d1,d6
	bcc.s	NotPortaDn
	add.b	d1,d6
	moveq	#FX_PORTA_DOWN,d0
	bra.s	SetVolCol
NotPortaDn:	cmp.b	#193-125,d6
	bcc.s	NotPanning
	subq.b	#128-125,d6
	bcs.s	NoVolumeColumn
	lsl.b	#2,d6
	bcc.s	NotRightVolPan
	moveq	#-1,d6
NotRightVolPan:	moveq	#FX_SET_PANNING,d0
	bra.s	SetVolCol
NotPanning:	sub.b	#203-125,d6
	bcc.s	NotTonePorta
	moveq	#FX_TONE_PORTA,d0
	add.b	d1,d6
	bra.s	SetVolCol
NotTonePorta:	sub.b	d1,d6
	bcc.s	NoVolumeColumn
	add.b	d1,d6
	add.b	d6,d6
	btst	#4,45(sp)
	bne.s	SetVibrato
	lsr.b	#1,d6
	neg.b	d6
	moveq	#FX_EXECUTE_FX,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	SetVibrato
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
SetVibrato:	moveq	#FX_VIBRATO,d0
	bra.s	SetVibDepth
SetVolCol:	lsl.w	#8,d6
SetVibDepth:	move.w	d6,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	NoVolumeColumn
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
NoVolumeColumn:	moveq	#0,d0
	move.b	4(sp),d0
	beq.s	NoEffect
	moveq	#0,d6
	move.b	5(sp),d6
	cmp.b	#26,d0
	bcc.s	NoEffect
	cmp.b	#15,d0
	bne.s	NotSmpOffset
	tst.w	tctd_Octave-tctd_Effects(a4)
	beq.s	NoEffect
NotSmpOffset:	movem.w	ProcessFXTable-4(pc,d0.w*4),d0-d1
	lea	ProcessFXTable(pc),a0
	add.l	d1,a0
	move.w	d6,d1
	jsr	(a0)
	move.w	d6,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	NoEffect
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
NoEffect:	subq.l	#tctd_Effects,a4
	bra	DecrunchPattern
DecrunchDone:	move.l	d2,a1
	move.l	60(sp),d0
	move.l	a5,a6
	jsr	_LVOFreePMem(a6)
	move.l	a3,d0
ExternalTrackLoadDone:	lea	192(sp),sp
	movem.l	(sp)+,d2-d7/a2-a6
	rts
ExternalTrackLoadError:	move.l	d2,a1
	move.l	60(sp),d0
	move.l	a5,a6
	jsr	_LVOFreePMem(a6)
ExternalTrackLoadErr:	moveq	#0,d0
	bra.s	ExternalTrackLoadDone
ExternalTrackWrongVersion:	moveq	#255-ERROR_ACTION_NOT_KNOWN,d1
	not.b	d1
	move.l	tcb_DOSBase(a6),a6
	jsr	_LVOSetIoErr(a6)
	bra.s	ExternalTrackLoadErr
ProcessFXTable:	dc.w	FX_SET_TEMPO,SetTempo-ProcessFXTable
	dc.w	FX_POS_JUMP,PosJump-ProcessFXTable
	dc.w	FX_PATT_BREAK,PosJump-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,SmpVolumeSlide-ProcessFXTable
	dc.w	FX_PORTA_DOWN,Porta-ProcessFXTable
	dc.w	FX_PORTA_UP,Porta-ProcessFXTable
	dc.w	FX_TONE_PORTA,TonePorta-ProcessFXTable
	dc.w	FX_VIBRATO,Vibrato-ProcessFXTable
	dc.w	FX_TREMOR,Tremor-ProcessFXTable
	dc.w	FX_ARPEGGIO,Arpeggio-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,VibFade-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,ToneFade-ProcessFXTable
	dc.w	FX_SET_TRK_VOL,SetVolume-ProcessFXTable
	dc.w	FX_TVOL_SL_UP,VolumeSlide-ProcessFXTable
	dc.w	FX_SMP_OFF_LOW,TonePorta-ProcessFXTable
	dc.w	FX_PAN_SL_LEFT,PanningSlide-ProcessFXTable
	dc.w	FX_MULTI_RETRIG,MultiRetrig-ProcessFXTable
	dc.w	FX_TREMOLO,Tremolo-ProcessFXTable
	dc.w	0,Extended-ProcessFXTable
	dc.w	FX_SET_SPEED,SetBPM-ProcessFXTable
	dc.w	FX_FINE_VIBRATO,Vibrato-ProcessFXTable
	dc.w	FX_SET_G_VOLUME,SetGVolume-ProcessFXTable
	dc.w	FX_G_VOLSL_UP,GVolumeSlide-ProcessFXTable
	dc.w	FX_SET_PANNING,TonePorta-ProcessFXTable
	dc.w	FX_PANNOLO,Pannolo-ProcessFXTable
ExtendedFXTable:	dc.w	0,NoFX-ExtendedFXTable
	dc.w	FX_EXTEND_CTRL,GlissCtrl-ExtendedFXTable
	dc.w	FX_SET_TRANSP,SetFineTune-ExtendedFXTable
	dc.w	$0302,EnvCtrl-ExtendedFXTable
	dc.w	$0402,EnvCtrl-ExtendedFXTable
	dc.w	$0502,EnvCtrl-ExtendedFXTable
	dc.w	FX_F_PATT_DELAY,PosJump-ExtendedFXTable
	dc.w	FX_ENV_CONTROL,SpecialIT-ExtendedFXTable
	dc.w	FX_SET_PANNING,SetPanning-ExtendedFXTable
	dc.w	FX_CHANNEL_CTRL,SetSurround-ExtendedFXTable
	dc.w	FX_SMP_OFF_HIGH,PosJump-ExtendedFXTable
	dc.w	FX_PATT_LOOP,PosJump-ExtendedFXTable
	dc.w	FX_NOTE_CUT,PosJump-ExtendedFXTable
	dc.w	FX_NOTE_DELAY,PosJump-ExtendedFXTable
	dc.w	FX_PATT_DELAY,PosJump-ExtendedFXTable
	dc.w	0,NoFX-ExtendedFXTable
SetTempo:	tst.b	d6
	beq	NoFX
	rts
Porta:	lsr.b	#4,d1
	cmp.b	#$f,d1
	bne.s	NotFineSlide
	addq.b	#4,d0
	and.b	#$f,d6
	beq	NoFX
NotFineSlide:	cmp.b	#$e,d1
	bne.s	TonePorta
	addq.b	#4+2,d0
	and.b	#$f,d6
	beq	NoFX
	lsl.w	#2,d6
TonePorta:	lsl.w	#8,d6
	rts
ToneFade:	movem.w	d0-d1,-(sp)
	moveq	#FX_TONE_PORTA,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	ToneFadeDone
AddFadeFX:	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
ToneFadeDone:	movem.w	(sp)+,d0-d1
	bra	VolumeSlide
VibFade:	movem.w	d0-d1,-(sp)
	btst	#4,45+8(sp)
	bne.s	OldVibFade
	moveq	#FX_EXECUTE_FX,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	ToneFadeDone
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
OldVibFade:	moveq	#FX_VIBRATO,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	ToneFadeDone
	btst	#4,45+8(sp)
	move.l	d0,a1
	bne.s	AddFadeFX
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
	moveq	#FX_EXECUTE_FX,d0
	moveq	#1,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	ToneFadeDone
	bra.s	AddFadeFX
GVolumeSlide:	bsr.s	VolumeSlide
	lsr.w	#8,d6
	lsr.b	#1,d6
	bcc.s	Not6BitGVolSlide
	addq.b	#1,d6
Not6BitGVolSlide:	lsl.w	#8,d6
	rts
SmpVolumeSlide:	cmp.b	#$f0,d6
	beq.s	FastVolSlide
	cmp.b	#$0f,d6
	bne.s	VolumeSlide
FastVolSlide:	movem.l	d0-d1,-(sp)
	moveq	#FX_EXECUTE_FX,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	DoFastVolDone
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
DoFastVolDone:	movem.l	(sp)+,d0-d1
VolumeSlide:	cmp.b	#$f0,d6
	beq.s	VolSlideUp
	cmp.b	#$0f,d6
	beq.s	VolSlideDown
	cmp.b	#$ff,d6
	beq.s	VolSlideUp
CheckVolSlide:	and.b	#$f,d1
	cmp.b	#$f,d1
	beq.s	FineVolSlideUp
	move.b	d6,d1
	lsr.b	#4,d1
	cmp.b	#$f,d1
	beq.s	FineVolSlideDown
	tst.b	d1
	bne.s	VolSlideUp
	bra.s	VolSlideDown
NotFineVolSlide:	tst.b	d7
	beq.s	SetVolOk
	moveq	#8+2,d1
	lsl.w	d1,d6
	rts
FineVolSlideUp:	addq.b	#2,d0
VolSlideUp:	lsr.b	#4,d6
	bra.s	NotFineVolSlide
FineVolSlideDown:	addq.b	#2,d0
VolSlideDown:	addq.b	#1,d0
	and.b	#$f,d6
	bra.s	NotFineVolSlide
PanningSlide:	cmp.b	#$f0,d6
	beq.s	PanSlideLeft
	cmp.b	#$0f,d6
	beq.s	PanSlideRight
	cmp.b	#$ff,d6
	beq.s	PanSlideLeft
CheckPanSlide:	and.b	#$f,d1
	cmp.b	#$f,d1
	beq.s	FinePanSlideLeft
	move.b	d6,d1
	lsr.b	#4,d1
	cmp.b	#$f,d1
	beq.s	FinePanSlideRight
	tst.b	d1
	bne.s	PanSlideLeft
	bra.s	PanSlideRight
NotFinePanSlide:	moveq	#8+2,d1
	lsl.w	d1,d6
	rts
FinePanSlideLeft:	addq.b	#2,d0
PanSlideLeft:	lsr.b	#4,d6
	bra.s	NotFinePanSlide
FinePanSlideRight:	addq.b	#2,d0
PanSlideRight:	addq.b	#1,d0
	and.b	#$f,d6
	bra.s	NotFinePanSlide
SetGVolume:	add.b	d6,d6
	bcc.s	GVolumeOk
	st	d6
GVolumeOk:	tst.b	d7
	bne.s	SetVolOk
	lsr.b	#1,d6
	bcc.s	SetVolOk
	addq.b	#1,d6
	bra.s	SetVolOk
SetVolume:	tst.b	d7
	beq.s	SetVolOk
	lsl.b	#2,d6
	bcc.s	SetVolOk
	moveq	#-1,d6
SetVolOk:	lsl.w	#8,d6
	rts
Extended:	lea	ExtendedFXTable(pc),a0
	lsr.b	#4,d1
	movem.w	(a0,d1.w*4),d0-d1
	add.l	d1,a0
	move.w	d6,d1
	lsr.b	#4,d1
	and.b	#$f,d6
	jmp	(a0)
NoFX:	addq.l	#4,sp
	bra	NoEffect
Tremor:	beq.s	TremorDone
	btst	#4,45+4(sp)
	beq.s	Arpeggio
	unpk	d6,d6,#$0101
TremorDone:	rts
Arpeggio:	lsl.w	#4,d6
	lsr.b	#4,d6
	rts
BPMSlideDown:	moveq	#FX_SPD_SLD_SLOW,d0
	rts
SetBPM:	lsr.b	#4,d1
	beq.s	BPMSlideDown
	cmp.b	#$2,d1
	bcc	PosJump
	and.b	#$f,d6
	moveq	#FX_SPD_SLD_FAST,d0
	rts
Pannolo:	bsr.s	Arpeggio
	bsr.s	Panbrello
	lsl.b	#3,d6
	rts
Tremolo:	bsr.s	Vibrato
	add.b	d6,d6
	btst	#2,d7
	beq.s	PosJump
	lsl.b	#2,d6
	rts
Vibrato:	ror.b	#4,d6
	lsl.w	#4,d6
	lsr.b	#4,d6
	lsl.b	#2,d6
	rol.w	#8,d6
	btst	#4,45+4(sp)
	bne.s	ChkVib
	cmp.b	#$20,d0
	bcc.s	Panbrello
	neg.b	d6
Panbrello:	move.l	d0,d3
	moveq	#FX_EXECUTE_FX,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	VibDone
	move.l	d0,d1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
VibDone:	move.l	d3,d0
	rts
MultiRetrig:	and.b	#$f,d1
	lsl.w	#8,d1
	or.w	d1,d6
	lsr.b	#4,d6
	beq.s	MulRetrigNoVol
	cmp.b	#8,d6
	beq.s	MulRetrigNoVol
	cmp.b	#6,d6
	bcc.s	MulRetrig
	move.b	d6,d1
	moveq	#1,d6
	lsl.b	d1,d6
	lsr.b	#1,d6
	add.b	#$C0-1,d6
	clr.b	d1
	or.w	d1,d6
PosJump:	rts
ChkVib:	cmp.b	#$20,d0
	bcc.s	PosJump
	add.b	d6,d6
	rts
MulRetrigNoVol:	move.b	#$10,d6
	rts
MulRetrig:	subq.b	#6,d6
	bne.s	MulRetr1
	move.b	#$23,d6
	rts
MulRetr1:	subq.b	#2,d6
	bcc.s	AddRetrig
	move.b	#$12,d6
	rts
AddRetrig:	cmp.b	#$6,d6
	beq.s	DivRetr1
	cmp.b	#$7,d6
	beq.s	DivRetr2
	move.b	d6,d1
	moveq	#1,d6
	lsl.b	d1,d6
	lsr.b	#1,d6
	add.b	#$80-1,d6
	clr.b	d1
	or.w	d1,d6
	rts
DivRetr1:	move.b	#$32,d6
	rts
DivRetr2:	move.b	#$21,d6
	rts
SetNNAMode:	moveq	#FX_NNA_CONTROL,d0
	subq.b	#3,d6
	cmp.b	#1,d6
	beq.s	SetNNACont
	cmp.b	#2,d6
	bne.s	PosJump
	moveq	#1,d6
	rts
SetNNACont:	moveq	#2,d6
	rts
SetFineTune:	lsl.b	#4,d6
	rts
SpecialIT:	cmp.b	#$3,d6
	bcs.s	PastNoteCut
	cmp.b	#$7,d6
	bcs.s	SetNNAMode
	cmp.b	#$d,d6
	bcc	NoFX
	moveq	#0,d3
	subq.b	#7,d6
	lsr.b	#1,d6
	bcc.s	TurnEnvOn
	moveq	#1,d3
TurnEnvOn:	lsl.w	#8,d6
	addq.b	#5,d6
	moveq	#FX_ENV_CONTROL,d0
	move.l	d6,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	EnvOnDone
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
	move.w	d3,d6
EnvOnDone:	moveq	#FX_SET_ENV_VAL,d0
	rts
PastNoteCut:	moveq	#FX_EXTEND_CTRL,d0
	move.b	PastNNATab(pc,d6.w),d6
	addq.b	#3,d6
	moveq	#12,d1
	lsl.w	d1,d6
	rts
PastNNATab:	dc.b	0,2,1
	even
ExtendControl:	bset	#12,d6
	rts
GlissCtrl:	tst.b	d6
	beq.s	ExtendControl
	move.w	#$1001,d6
	rts
SetPanning:	move.b	d6,d1
	lsl.b	#4,d1
	or.b	d1,d6
	lsl.w	#8,d6
	rts
SetSurround:	subq.b	#1,d6
	bne	NoFX
	move.w	#$1001,d6
	rts
EnvCtrl:	move.w	d0,d3
	moveq	#FX_ENV_CONTROL,d0
	moveq	#tcte_SIZEOF,d0
	cmp.b	#4,d6
	blo.s	NotRetrigEnvSet
	moveq	#0,d6
NotRetrigEnvSet:	cmp.b	#3,d6
	bne.s	NotRandomEnv
	or.b	#$10,d3
NotRandomEnv:	move.w	d3,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	EnvCtrlDone
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
	moveq	#FX_ENV_CONTROL,d0
	clr.b	d3
	move.w	d3,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	EnvCtrlDone
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
	cmp.w	#$0400,d3
	bne.s	EnvCtrlDone
	addq.b	#3,d6
EnvCtrlDone:	moveq	#FX_SET_ENV_VAL,d0
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle from where to get the info
;	A1.L	=	APTR to track info structure where to put information
;	D0.L	=	Number of track to be scanned (NULL is the first)
;	OUTPUT
;	D0.L	=	A non-zero value if success else NULL.
ExternalTrackGetInfo:	movem.l	d2-d5/a2-a3/a6,-(sp)
	link	a5,#-192
	move.l	a0,d1
	move.l	sp,d2
	moveq	#255-192,d3
	not.b	d3
	move.l	d0,d5
	move.l	d1,a2
	move.l	a1,a3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalGetInfoError
	move.w	42(sp),d0
	rol.w	#8,d0
	cmp.w	#$0201,d0
	bcc	ExternalGetInfoWrongVersion
	moveq	#TCTCF_Slide,d0
	btst	#4,45(sp)
	bne.s	ITOldGetEffects
	addq.b	#TCTCF_SOffset,d0
ITOldGetEffects:	btst	#5,45(sp)
	beq.s	NotLinkGsGetMemory
	addq.b	#TCTCF_TPorta,d0
NotLinkGsGetMemory:	move.b	d0,trki_CompFlags(a3)
	move.b	41(sp),trki_Version(a3)
	move.b	40(sp),trki_Revision(a3)
	move.b	50(sp),trki_Frames+1(a3)
	move.b	51(sp),trki_BPMSpeed+1(a3)
	move.l	#(DEFAULTTRACKSPDSPEED<<16)|(DEFAULTTRACKBPMTEMPO),trki_SPDSpeed(a3)
	clr.b	30(sp)
	move.l	sp,a0
	addq.l	#4,a0
	jsr	_LVOAllocNameStr(a6)
	move.l	d0,trki_Name(a3)
	moveq	#0,d0
	move.w	38(sp),d0
	rol.w	#8,d0
	lsl.l	#6,d0
	cmp.l	d0,d5
	bcc	ExternalGetInfoError
	moveq	#64,d0
	divul.l	d0,d4:d5
	move.b	64(sp,d4.w),d0
	bclr	#7,d0
	moveq	#$7f,d1
	not.b	d1
	cmp.b	#100,d0
	bne.s	NotSurPan
	move.b	#TCTF_SurPan,trki_Flags(a3)
	bra.s	NotRightPan
NotSurPan:	move.b	d0,d1
	lsl.b	#2,d1
	bcc.s	NotRightPan
	moveq	#-1,d1
NotRightPan:	move.b	d1,trki_Panning(a3)
	move.b	(128.w,sp,d4.w),d0
	lsl.b	#2,d0
	bcc.s	NotFullVol
	moveq	#-1,d0
NotFullVol:	move.b	d0,trki_Volume(a3)
	moveq	#0,d1
	moveq	#0,d2
	lea	32(sp),a0
	move.w	(a0)+,d2
	rol.w	#8,d2
	move.w	(a0)+,d1
	rol.w	#8,d1
	lsl.l	#2,d1
	add.l	d1,d2
	moveq	#0,d1
	move.w	(a0)+,d1
	rol.w	#8,d1
	lsl.l	#2,d1
	add.l	d1,d2
	lsl.l	#2,d5
	add.l	d5,d2
	move.l	a2,d1
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq.s	ExternalGetInfoDone
	move.l	a2,d1
	move.l	sp,d2
	moveq	#4,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalGetInfoError
	moveq	#64,d4
	move.l	(sp),d2
	beq.s	ExternalGetInfoOk
	move.l	a2,d1
	rol.w	#8,d2
	swap	d2
	rol.w	#8,d2
	moveq	#OFFSET_BEGINNING,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq.s	ExternalGetInfoDone
	move.l	a2,d1
	move.l	sp,d2
	moveq	#4,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalGetInfoError
	move.w	2(sp),d4
	rol.w	#8,d4
ExternalGetInfoOk:	move.w	d4,trki_Length(a3)
	move.l	a3,d0
ExternalGetInfoDone:	unlk	a5
	movem.l	(sp)+,d2-d5/a2-a3/a6
	rts
ExternalGetInfoError:	moveq	#0,d0
	bra.s	ExternalGetInfoDone
ExternalGetInfoWrongVersion:	moveq	#255-ERROR_ACTION_NOT_KNOWN,d1
	not.b	d1
	move.l	tcb_DOSBase(a6),a6
	jsr	_LVOSetIoErr(a6)
	bra.s	ExternalGetInfoError
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	Number of tracks found or NULL on any error
ExternalTrackGetNums:	move.l	a6,-(sp)
	link	a5,#-44
	move.l	a0,d1
	move.l	sp,d2
	moveq	#44,d3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalGetNumError
	move.w	42(sp),d0
	rol.w	#8,d0
	cmp.w	#$0201,d0
	bcc.s	ExternalGetNumWrongVersion
	move.w	38(sp),d0
	rol.w	#8,d0
	lsl.l	#6,d0
ExternalGetNumsDone:	unlk	a5
	move.l	(sp)+,a6
	rts
ExternalGetNumError:	moveq	#0,d0
	bra.s	ExternalGetNumsDone
ExternalGetNumWrongVersion:	moveq	#255-ERROR_ACTION_NOT_KNOWN,d1
	not.b	d1
	move.l	tcb_DOSBase(a6),a6
	jsr	_LVOSetIoErr(a6)
	bra.s	ExternalGetNumError

	cnop	0,4

ExtTrackLibBase:	dc.l	0

LoadFlags:	dc.w	2
	dc.w	LoadFlagSize
	dc.l	LoadText0
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText1
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
LoadText0:	dc.b	'Translate octaves',0
LoadText1:	dc.b	'Convert volumes',0
LoadFlagSize:	equ	*-LoadFlags
LoadDescript:	dc.b	'ImpulseTracker Module (IT)',0
