*****************************************************
***  TuComposer External Module Library for MOD   ***
***        1997 by The united Coders (TuC)       ***
***               Main code: Basty/TuC            ***
***    This is a MOD module loader. It loads      ***
*** Pro/Noise/Fast/Take/Star/SoundTracker modules ***
*****************************************************

	IFND	_G2
	MACHINE	MC68020
	OPT NODEBUG,NOLINE
	ENDC

	include	"exec/types.i"
	include	"exec/execbase.i"
	include	"exec/exec_lib.i"
	include	"exec/initializers.i"
	include	"exec/memory.i"
	include	"exec/resident.i"
	include	"exec/libraries.i"
	include	"libraries/dos_lib.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/module.i"
	include	"tucomposer/song.i"
	include	"tucomposer/position.i"
	include	"tucomposer/track.i"
	include	"tucomposer/instr.i"
	include	"tucomposer/sample.i"
	include	"tucomposer/external/external.i"
	include	"tucomposer/external/external_lib.i"
	include	"tucomposer/external/module.i"
	include	"tucomposer/external/module_lib.i"

	moveq	#-1,d0
	rts
ResidentStruct:	dc.w	RTC_MATCHWORD
	dc.l	ResidentStruct
	dc.l	0
	dc.b	RTF_AUTOINIT
	dc.b	EXTLIB_MODULE_VERSION
	dc.b	NT_LIBRARY
	dc.b	0
	dc.l	LibName
	dc.l	LibID
	dc.l	Init
LibName:	dc.b	'mod.library',0
LibID:	dc.b	'TuComposer External Module Loader Version 1.00 (v31) for MOD (68020+, OS2.0+) (10 Jun 97) by Basty/TuC.',0
TuComposerName:	dc.b	'tucomposer.library',0
	even
Init:	dc.l	modl_SIZEOF
	dc.l	FuncTab
	dc.l	DataTab
	dc.l	PrepareLibrary

FuncTab:	dc.w	-1
	dc.w	Open-FuncTab
	dc.w	Close-FuncTab
	dc.w	Expunge-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalInitialize-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalModuleIdentify-FuncTab
	dc.w	ExternalModuleLoad-FuncTab
	dc.w	ExternalModuleSave-FuncTab
	dc.w	ExternalModuleGetInfo-FuncTab
	dc.w	ExternalModuleGetNums-FuncTab
	dc.w	-1

DataTab:	INITLONG	LN_NAME,LibName
	INITBYTE	LIB_FLAGS,LIBF_CHANGED|LIBF_SUMUSED
	INITWORD	LIB_VERSION,EXTLIB_MODULE_VERSION
	INITWORD	LIB_REVISION,EXTLIB_REVISION
	INITLONG	LIB_IDSTRING,LibID
	dc.l	0

PrepareLibrary:	btst	#AFB_68020,AttnFlags+1(a6)	
	beq.s	ExtLib
	cmp.w	#37,LIB_VERSION(a6)
	blt.s	ExtLib
	move.l	a2,-(sp)
	move.l	d0,a2
	move.l	a0,extb_SegList(a2)
	moveq	#31,d0
	lea	TuComposerName(pc),a1
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,extb_TuComposerBase(a2)
	beq.s	NoTuCLib
	lea	ExtModuleLibBase(pc),a0
	move.l	a2,(a0)
	move.l	a2,d0
NoTuCLib:	move.l	(sp)+,a2
	rts
Open:	addq.w	#1,LIB_OPENCNT(a6)
	move.l	a6,d0
	rts
Close:	subq.w	#1,LIB_OPENCNT(a6)
	bne.s	ExtLib
	btst	#LIBB_DELEXP,LIB_FLAGS(a6)
	bne.s	Expunge
ExtLib:	moveq	#0,d0
	rts
Expunge:	bset	#LIBB_DELEXP,LIB_FLAGS(a6)
	tst.w	LIB_OPENCNT(a6)
	bne.s	ExtLib
	movem.l	d2/a5-a6,-(sp)
	move.l	extb_ExtLibList(a6),d0
	beq.s	NoExtLibList
	move.l	d0,a0
	clr.l	extl_LibBase(a0)
NoExtLibList:	move.l	extb_TuComposerBase(a6),a1
	move.l	a6,a5
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
	move.l	extb_SegList(a5),d2
	move.l	a5,a1
	jsr	_LVORemove(a6)
	move.l	a5,a1
	moveq	#0,d0
	moveq	#0,d1
	move.w	LIB_NEGSIZE(a5),d1
	sub.l	d1,a1
	move.w	LIB_POSSIZE(a5),d0
	add.l	d1,d0
	jsr	_LVOFreeMem(a6)
	move.l	d2,d0
	movem.l	(sp)+,d2/a5-a6
	rts
;	INPUT
;	A0.L	=	APTR to track external list structure to be initialized
;	OUTPUT
;	D0.L	=	What type of external library is it or NULL if error
ExternalInitialize:	move.l	extb_TuComposerBase(a6),a1
	movem.l	a2/a6,-(sp)
	move.l	a0,d0
	beq.s	ExternalInitDone
	move.l	a1,a6
	move.b	#EXTLF_Loader|EXTLF_Saver,extl_Flags(a0)
	move.l	a0,a2
	lea	extl_Descriptor(a0),a0
	lea	LoadDescript(pc),a1
	jsr	_LVOSetString(a6)
	tst.l	d0
	beq.s	ExternalInitDone
	lea	LoadFlags(pc),a0
	jsr	_LVOAllocFlagStr(a6)
	move.l	d0,extl_LoadFlagStr(a2)
	beq.s	ExternalInitDone
	move.b	#-10,extl_Pri(a2)
	moveq	#EXTTYPE_MODULE,d0
ExternalInitDone:	movem.l	(sp)+,a2/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	If failed NULL else any non-zero value
ExternalModuleIdentify:	movem.l	d2-d6/a2/a6,-(sp)
	bsr	GetNumChannels
	movem.l	(sp)+,d2-d6/a2/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be loaded
;	A1.L	=	APTR to target module structure or NULL to create a new one
;	A2.L	=	APTR to loading flag pass structure (Loader specific)
;	D0.L	=	Number of module of be loaded (NULL is the first)
;	OUTPUT
;	D0.L	=	APTR to module structure where loaded track data is
ExternalModuleLoad:	movem.l	d2-d7/a2-a6,-(sp)
	lea	-284(sp),sp
	moveq	#11-1,d0
	moveq	#0,d1
	moveq	#-1,d2
	movem.l	d1-d2,264(sp)
	moveq	#0,d7
CreateBitTable:	tst.l	(a2)+
	beq.s	BitNotSet
	bset	d1,d7
BitNotSet:	addq.b	#1,d1
	dbra	d0,CreateBitTable
	move.l	(a2)+,272(sp)
	move.l	(a2)+,276(sp)
	move.l	(a2),260(sp)
	move.l	a1,a3
	bsr	GetNumChannels
	beq	ExternalLoadDone
	move.l	272(sp),d0
	subq.l	#1,d0
	bne.s	ChkPAL
	cmp.w	#4,d5
	bne.s	IsNTSC
	cmp.l	#"TDZ4",d4
	beq.s	IsNTSC
	cmp.l	#"4CHN",d4
	beq.s	IsNTSC
ChkPAL:	subq.l	#2,d0
	bra.s	FreqOk
IsNTSC:	moveq	#0,d0
FreqOk:	move.l	d0,272(sp)
	move.l	(a2),d1
	move.l	sp,d2
	move.l	a6,a5
	move.l	tcb_DOSBase(a5),a6
	jsr	_LVOExamineFH(a6)
	move.l	#1084,d3
	cmp.l	#"ST31",d4
	bne.s	NoModId
	subq.l	#1084-1080,d3
NoModId:	cmp.l	#"ST15",d4
	bne.s	Not15Instr
	move.w	#600,d3
Not15Instr:	move.l	d3,d0
	moveq	#MEMF_PUBLIC,d1
	move.l	4.w,a6
	jsr	_LVOAllocVec(a6)
	move.l	d0,4(sp)
	beq	ExternalLoadErr5
	move.l	d3,d6
	move.l	a2,d1
	moveq	#0,d2
	moveq	#OFFSET_BEGINNING,d3
	move.l	a5,a6
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalLoadErr4
	move.l	a2,d1
	move.l	4(sp),d2
	move.l	d6,d3
	jsr	_LVOCRead(a6)
	addq.l	#1,d0
	beq	ExternalLoadErr4
	move.l	4(sp),a0
	lea	-128(a0,d6.w),a0
	cmp.l	#"ST31",d4
	beq.s	NoModIdOrder
	cmp.l	#"ST15",d4
	beq.s	NoModIdOrder
	subq.l	#4,a0
NoModIdOrder:	moveq	#0,d1
	moveq	#128-1,d2
	move.l	a0,d6
	moveq	#0,d0
	move.b	-2(a0),d0
	btst	#6,d7
	beq.s	NotMKVibrato
	cmp.l	#"M&K!",d4
	bne.s	NotMKVibrato
	bset	#31,d7
NotMKVibrato:	clr.w	52(sp)
	move.b	-1(a0),d3
	cmp.l	#"M.K.",d4
	bne.s	CheckRepStart
	cmp.b	#$78,d3
	beq.s	CheckLoadLoop
	cmp.b	#$7f,d3
	beq.s	CheckLoadLoop
CheckRepStart:	cmp.b	d0,d3
	blo.s	RepStartOk
	moveq	#0,d3
RepStartOk:	move.b	d3,52+1(sp)
	btst	#6,d7
	beq.s	CheckLoadLoop
	cmp.l	#"M.K.",d4
	bne.s	CheckLoadLoop
	bset	#31,d7
CheckLoadLoop:	move.l	d1,d3
	subq.w	#1,d2
CheckLoadLoop2:	move.b	(a0)+,d1
	cmp.b	d3,d1
	bgt.s	CheckLoadLoop
	dbra	d2,CheckLoadLoop2
	cmp.l	#"FLT8",d4
	bne.s	NotFLT8Sub
	subq.b	#1,d0
	lsr.w	#1,d3
NotFLT8Sub:	addq.w	#1,d3
	movem.w	d3/d5,8(sp)
	move.w	d0,64(sp)
	mulu.w	d5,d0
	add.l	d0,d0
	moveq	#MEMF_PUBLIC,d1
	move.l	4.w,a6
	jsr	_LVOAllocVec(a6)
	move.l	a5,a6
	move.l	d0,12(sp)
	beq	ExternalLoadErr4
	move.l	d5,d0
	jsr	_LVOAllocTCModule(a6)
	move.l	d0,d1
	beq	ExternalLoadErr3
	move.l	d0,a4
	lea	tcm_Name(a4),a0
	move.l	4(sp),a1
	move.b	20(a1),d2
	clr.b	20(a1)
	jsr	_LVOSetString(a6)
	move.l	4(sp),a1
	move.b	d2,20(a1)
	lea	tcm_BeginDate(a4),a0
	lea	fib_DateStamp(sp),a1
	jsr	_LVOStamp2Date(a6)
	lea	tcm_EndDate(a4),a0
	lea	fib_DateStamp(sp),a1
	jsr	_LVOStamp2Date(a6)
	btst	#8,d7
	beq.s	NotUseAmigaFreq
	move.w	#4181,266(sp)
	move.l	#31574,268(sp)
NotUseAmigaFreq:	move.l	d5,d0
	moveq	#1,d1
	moveq	#1,d2
	jsr	_LVOAllocSong(a6)
	move.l	d0,d1
	beq	ExternalLoadErr2
	move.l	d0,a1
	moveq	#TCSOCF_Sync,d0
	btst	#2,d7
	bne.s	UseOldVolumes
	addq.b	#TCSOCF_OldVolumes,d0
UseOldVolumes:	move.b	d0,tcso_CompFlags(a1)
	move.l	276(sp),d0
	subq.l	#1,d0
	bne.s	ChkPALSpd
	btst	#5,d7
	beq.s	ChkPALSpd
	cmp.w	#4,d5
	bne.s	ChkPALSpd
	cmp.l	#"TDZ4",d4
	beq.s	ChkPALSpd
	cmp.l	#"4CHN",d4
	beq.s	ChkPALSpd
	tst.l	272(sp)
	beq.s	IsNTSCSpd
ChkPALSpd:	subq.l	#2,d0
	bra.s	SpdOk
IsNTSCSpd:	moveq	#0,d0
SpdOk:	move.l	d0,276(sp)
	bne.s	PALSpdCorrect
	move.w	#150,tcso_BPMSpeed(a1)
PALSpdCorrect:	move.l	a4,a0
	jsr	_LVOAddSong(a6)
	lea	([tcm_SongList.w,a4],tcso_Name.w),a0
	move.l	tcm_Name(a4),a1
	jsr	_LVOSetString(a6)
	move.l	tcm_SongList(a4),a1
	lea	([tcm_SongList.w,a4],tcso_BeginDate.w),a0
	lea	fib_DateStamp(sp),a1
	jsr	_LVOStamp2Date(a6)
	lea	([tcm_SongList.w,a4],tcso_EndDate.w),a0
	lea	fib_DateStamp(sp),a1
	jsr	_LVOStamp2Date(a6)
	move.l	d6,a0
	move.w	64(sp),d0
	move.w	10(sp),d2
	move.l	12(sp),a1
	moveq	#0,d5
GetTrackReMapNums:	moveq	#0,d1
	move.b	(a0)+,d1
	cmp.l	#"FLT8",d4
	bne.s	NotHalveOrderList
	lsr.b	#1,d1
NotHalveOrderList:	move.w	d2,d3
	mulu.w	d3,d1
GetTrackReMapLoop:	move.w	d1,(a1)+
	addq.w	#1,d1
	subq.w	#1,d3
	bne.s	GetTrackReMapLoop
NextOrderEntry:	subq.w	#1,d0
	bne.s	GetTrackReMapNums
	move.w	8(sp),d5
	move.l	a4,16(sp)
DecrunchPatternLoop:	move.w	#$100,d3
	mulu.w	10(sp),d3
	move.l	d3,d0
	cmp.l	#"FLT8",d4
	bne.s	NotFLT8Add
	add.l	d0,d0
NotFLT8Add:	moveq	#MEMF_PUBLIC,d1
	move.l	4.w,a6
	jsr	_LVOAllocVec(a6)
	move.l	d0,d2
	beq	ExternalLoadErr2
	move.l	a2,d1
	move.l	a5,a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadError
	move.w	10(sp),d3
	cmp.l	#"FLT8",d4
	bne.s	AllocTrackLoop
	moveq	#64-1,d0
	move.l	d2,a0
	lea	2048(a0),a1
CopyFLT8BufLoop:	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	dbra	d0,CopyFLT8BufLoop
	moveq	#64-1,d0
	move.l	a2,d1
	lea	1024(a0),a2
	move.l	d2,a1
ConvFLT8BufLoop:	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a2)+,(a1)+
	move.l	(a2)+,(a1)+
	move.l	(a2)+,(a1)+
	move.l	(a2)+,(a1)+
	dbra	d0,ConvFLT8BufLoop
	move.l	d1,a2
AllocTrackLoop:	moveq	#64,d0
	jsr	_LVOAllocTrack(a6)
	move.l	d0,d1
	beq	ExternalLoadError
	move.l	d0,a1
	move.l	tcm_SongList(a4),a0
	move.b	#TCTCF_OpSlide,tct_CompFlags(a1)
	jsr	_LVOAddTrack(a6)
	subq.w	#1,d3
	bne.s	AllocTrackLoop
	movem.l	d4-d6/a2-a4/a6,20(sp)
	moveq	#0,d5
	moveq	#64-1,d6
	move.l	d2,a2
GetNextRow:	move.w	10(sp),d1
	move.l	16(sp),a4
	move.l	tcm_SongList(a4),a3
	lea	tcso_TrackList+MLH_TAIL(a3),a3
FindCorrectTrack:	move.l	MLN_PRED(a3),a3
	dbra	d1,FindCorrectTrack
NotNextRow:	move.l	(a3),a3
	tst.l	(a3)
	beq	ProcNextRow
	move.l	tct_Data(a3),a4
	add.l	d5,a4
	move.l	(a2)+,d0
	clr.b	(sp)
	move.l	d0,d1
	swap	d1
	and.w	#$fff,d1
	beq.s	NoNote
	moveq	#NOTE_A_-1-1,d4
	lea	PeriodTable(pc),a0
FindCorrectNote:	addq.w	#1,d4
	cmp.w	(a0)+,d1
	blt.s	FindCorrectNote
	move.b	d4,(sp)
NoNote:	move.l	d0,d1
	swap	d1
	rol.w	#4,d1
	rol.l	#4,d1
	move.b	d1,1(sp)
	move.b	d0,3(sp)
	and.w	#$fff,d0
	lsr.w	#8,d0
	move.b	d0,2(sp)
	move.l	sp,a1
	moveq	#0,d0
	move.b	(a1)+,d0
	bne.s	NoteOk
	move.w	d0,(a4)+
	bra.s	NoteDone
ProcessFXTable:	dc.w	FX_ARPEGGIO,AbsArp-ProcessFXTable
	dc.w	FX_PORTA_UP,Porta-ProcessFXTable
	dc.w	FX_PORTA_DOWN,Porta-ProcessFXTable
	dc.w	FX_TONE_PORTA,Porta-ProcessFXTable
	dc.w	FX_VIBRATO,Vibrato-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,ToneFade-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,VibFade-ProcessFXTable
	dc.w	FX_TREMOLO,Tremolo-ProcessFXTable
	dc.w	FX_SET_PANNING,SetPanning-ProcessFXTable
	dc.w	FX_SMP_OFF_LOW,PortaSlide-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,VolumeSlide-ProcessFXTable
	dc.w	FX_POS_JUMP,PosJump-ProcessFXTable
	dc.w	FX_SET_VOLUME,SetVolume-ProcessFXTable
	dc.w	FX_PATT_BREAK,PattBreak-ProcessFXTable
	dc.w	0,Extended-ProcessFXTable
	dc.w	FX_SET_TEMPO,Tempo-ProcessFXTable
NoteOk:	divu.w	#12,d0
	move.b	d0,(a4)+
	swap	d0
	addq.b	#1,d0
	move.b	d0,(a4)+
NoteDone:	move.b	(a1)+,d0
	move.w	d0,(a4)+
	moveq	#0,d0
	move.b	(a1)+,d0
	moveq	#0,d4
	move.b	(a1),d4
	cmp.b	#9,d0
	bne.s	NotSmpOffset
	tst.w	tctd_Octave-tctd_Effects(a4)
	beq.s	NoEffect
NotSmpOffset:	movem.w	ProcessFXTable(pc,d0.w*4),d0-d1
	lea	ProcessFXTable(pc),a0
	add.l	d1,a0
	move.w	d4,d1
	jsr	(a0)
	move.w	d4,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	NoEffect
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
NoEffect:	bra	NotNextRow
ProcNextRow:	addq.l	#tctd_NextRow/2,d5
	addq.l	#tctd_NextRow/2,d5
	dbra	d6,GetNextRow
	move.l	d2,a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
	movem.l	20(sp),d4-d6/a2-a4/a6
	move.l	tcm_SongList(a4),a4
	lea	tcso_TrackList(a4),a2
CmpMainLoop:	move.l	(a2),a2
	tst.l	(a2)
	beq.s	CmpAllDone
	lea	tcso_TrackList+MLH_TAIL(a4),a3
	move.w	10(sp),d0
FindPatternLoop:	move.l	MLN_PRED(a3),a3
	tst.l	MLN_PRED(a3)
	beq.s	CompareTracksLoop
	dbra	d0,FindPatternLoop
CompareTracksLoop:	move.l	(a3),a3
	tst.l	(a3)
	beq.s	CmpMainLoop
	cmp.l	a3,a2
	beq.s	CompareTracksLoop
	move.l	a3,a0
	move.l	a2,a1
	jsr	_LVOCmpTracks(a6)
	tst.l	d0
	bne.s	CompareTracksLoop
	move.l	a4,a0
	move.l	a3,a1
	jsr	_LVOGetTrackNum(a6)
	subq.w	#1,d0
	move.w	d0,d2
	move.l	a3,a0
	jsr	_LVOFreeTrack(a6)
	move.l	a4,a0
	move.l	a2,a1
	jsr	_LVOGetTrackNum(a6)
	subq.w	#1,d0
	move.w	64(sp),d1
	mulu.w	10(sp),d1
	move.l	12(sp),a0
ReMapOrderList:	cmp.w	(a0),d2
	bne.s	ReMapOrderEqual
	move.w	d0,(a0)
ReMapOrderEqual:	bhs.s	ReMapOrderNotSub
	subq.w	#1,(a0)
ReMapOrderNotSub:	addq.l	#2,a0
	subq.l	#1,d1
	bne.s	ReMapOrderList
	move.l	MLN_PRED(a2),a2
	bra.s	CmpMainLoop
CmpAllDone:	movem.l	32(sp),a2-a4
	subq.w	#1,d5
	bne	DecrunchPatternLoop
	move.w	64(sp),d2
	moveq	#0,d3
	move.w	10(sp),d6
	move.l	12(sp),a2
	move.l	tcm_SongList(a4),a4
	move.l	tcso_Position(a4),a3
SetOrderList:	moveq	#0,d5
SetPositions:	jsr	_LVOAllocPositionList(a6)
	move.l	d0,d1
	beq	ExternalLoadErr1
	move.l	d0,a1
	moveq	#0,d0
	move.l	a3,a0
	jsr	_LVOAddPositionList(a6)
	move.w	d5,d1
	mulu.w	d6,d1
	moveq	#0,d0
	move.w	(a2,d1.l*2),d0
	addq.l	#1,d0
	move.l	a4,a0
	jsr	_LVOGetTrackAddr(a6)
	move.l	MLH_TAILPRED(a3),a0
	move.l	d0,tcol_Track(a0)
	move.l	MLN_PRED(a0),a1
	tst.l	MLN_PRED(a1)
	beq.s	NotSetPrevOrder
	move.l	a1,tcol_PrevPos(a0)
	move.l	a0,tcol_NextPos(a1)
NotSetPrevOrder:	addq.w	#1,d5
	cmp.w	d5,d2
	bne.s	SetPositions
	move.l	MLH_TAILPRED(a3),a0
	move.l	(a3),a1
	move.l	a1,tcol_PrevPos(a1)
	move.l	a1,tcol_NextPos(a0)
	move.w	52(sp),tco_RepStart(a3)
	and.w	#3,d3
	moveq	#0,d1
	btst	#0,d3
	beq.s	NotRightDMPPan
	moveq	#-1,d1
NotRightDMPPan:	tst.b	d7
	bmi.s	DMPPanning
	move.b	(PanningTable.w,pc,d3.w),d1
DMPPanning:	move.b	d1,tco_Panning(a3)
	lea	tco_NextOrderx(a3),a3
	addq.l	#2,a2
	addq.w	#1,d3
	subq.w	#1,10(sp)
	bne	SetOrderList
	movem.l	32(sp),a2-a4
	moveq	#0,d3
	clr.l	44(sp)
	move.l	#$80000100,d2
	move.l	d4,(sp)
	moveq	#DEFAULT_ENVNODES,d4
	btst	#1,d7
	beq.s	NoVibratoEnvelopes
	moveq	#64,d0
	moveq	#ENVL_SINE,d1
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,44(sp)
	beq	ExternalLoadErr2
	move.l	d0,a1
	bset	#TCIEB_Loop,tcie_Flags+1(a1)
	move.w	tcie_NumPoints(a1),tcie_LoopEnd(a1)
	subq.w	#1,tcie_LoopEnd(a1)
	move.l	a4,a0
	jsr	_LVOAddEnvelope(a6)
	moveq	#64,d0
	moveq	#ENVL_RAMP,d1
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,d1
	beq	ExternalLoadErr2
	move.l	d0,a1
	bset	#TCIEB_Loop,tcie_Flags+1(a1)
	move.w	tcie_NumPoints(a1),tcie_LoopEnd(a1)
	subq.w	#1,tcie_LoopEnd(a1)
	move.l	a4,a0
	jsr	_LVOAddEnvelope(a6)
	moveq	#64,d0
	moveq	#ENVL_SQUARE,d1
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,d1
	beq	ExternalLoadErr2
	move.l	d0,a1
	bset	#TCIEB_Loop,tcie_Flags+1(a1)
	move.w	tcie_NumPoints(a1),tcie_LoopEnd(a1)
	subq.w	#1,tcie_LoopEnd(a1)
	move.l	a4,a0
	jsr	_LVOAddEnvelope(a6)
NoVibratoEnvelopes:	move.l	(sp),d4
	moveq	#31-1,d5
	cmp.l	#"ST15",d4
	bne.s	Not15InstrLoad
	moveq	#15-1,d5
Not15InstrLoad:	moveq	#0,d6
	clr.l	280(sp)
LoadSmpLoop:	moveq	#0,d0
	jsr	_LVOAllocInstr(a6)
	move.l	d0,d1
	beq	ExternalLoadErr2
	move.l	d0,a1
	move.l	a4,a0
	move.l	a1,a3
	jsr	_LVOAddInstr(a6)
	move.l	44(sp),d0
	move.b	#TCICF_LockInsWave,tci_CompFlags(a3)
	lea	tci_VibratoEnvelope(a3),a0
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)
	move.l	4(sp),a0
	lea	20(a0,d6.w),a1
	move.l	a1,48(sp)
	moveq	#0,d4
	btst	#0,d7
	beq.s	SampleOk
	move.w	22(a1),d4
	add.l	d4,d4
SampleOk:	lea	tci_Name(a3),a0
	clr.b	22(a1)
	jsr	_LVOSetString(a6)
	move.l	d4,d0
	sub.l	a0,a0
	jsr	_LVOAllocSample(a6)
	move.l	d0,d3
	beq	ExternalLoadErr2
	move.l	d3,a1
	move.l	a3,a0
	jsr	_LVOAddSample(a6)
	move.l	d3,a3
	tst.l	272(sp)
	beq.s	NTSCFreq
	move.l	#8287,tcs_Rate(a3)
NTSCFreq:	lea	tcs_Name(a3),a0
	move.l	48(sp),a1
	jsr	_LVOSetString(a6)
	move.l	48(sp),a1
	move.b	24(a1),d0
	lsl.b	#4,d0
	move.b	d0,tcs_FineTune(a3)
	move.b	25(a1),d0
	btst	#2,d7
	beq.s	NotConvSmpLoadVol
	lsl.b	#2,d0
	bcc.s	NotConvSmpLoadVol
	moveq	#-1,d0
NotConvSmpLoadVol:	move.b	d0,tcs_Volume(a3)
	moveq	#0,d0
	moveq	#0,d1
	move.w	26(a1),d0
	add.l	d0,d0
	move.w	28(a1),d1
	add.l	d1,d1
	move.l	d1,d2
	add.l	d0,d2
	cmp.l	d2,d4
	bcc.s	RepeatOk
	lsr.l	#1,d0
RepeatOk:	movem.l	d0-d1,tcs_Repeat(a3)
	moveq	#TCSF_Loop,d2
	tst.l	d0
	bne.s	SetLoop
	moveq	#2,d0
	cmp.l	d0,d1
	bhi.s	SetLoop
	moveq	#0,d2
SetLoop:	move.b	d2,tcs_Flags(a3)
	movem.l	264(sp),d0-d1
	movem.l	d0-d1,tcs_LowerRateLimit(a3)
	tst.l	tcs_Length(a3)
	beq	LoadNextSmp
	move.l	a2,d1
	movem.l	tcs_Data(a3),d2-d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	beq	LoadNextSmp
	addq.l	#1,d0
	beq	ExternalLoadErr2
	subq.l	#1,d0
	bne	LoadNextSmp
	tst.l	280(sp)
	bne	LoadNextSmp2
	move.l	260(sp),d1
	moveq	#ACCESS_READ,d2
	move.l	tcb_DOSBase(a5),a6
	jsr	_LVOLock(a6)
	move.l	a5,a6
	move.l	d0,d4
	beq	ExternalLoadErr2
	move.l	d4,d1
	move.l	tcb_DOSBase(a5),a6
	jsr	_LVOCurrentDir(a6)
	move.l	d0,56(sp)
	move.l	tcs_Name(a3),d1
	move.l	#MODE_OLDFILE,d2
	moveq	#0,d3
	move.l	a5,a6
	jsr	_LVOCOpen(a6)
	move.l	d0,a0
	beq	ExternalLoadErr15
	move.l	a0,60(sp)
	jsr	_LVOIdentifySample(a6)
	move.l	d0,d1
	beq.s	LoadRawSmpData
	move.l	d0,a2
	move.l	extl_LoadFlagStr(a2),a1
	moveq	#4,d0
	mulu.w	(a1),d0
	moveq	#MEMF_PUBLIC,d1
	move.l	4.w,a6
	jsr	_LVOAllocVec(a6)
	move.l	d0,d1
	beq	ExternalLoadErr16
	move.l	64(sp),a0
	move.l	d1,a1
	move.l	a3,36(sp)
	move.l	a1,a3
	move.l	extl_LoadFlagStr(a2),a0
	move.w	(a0),d0
FillFlagPass:	move.l	tefs_Flag0Default(a0),(a1)+
	lea	tefs_FlagxText-tefs_Flag0Text(a0),a0
	subq.w	#1,d0
	bne.s	FillFlagPass
	moveq	#0,d0
	move.l	60(sp),a0
	move.l	36(sp),a1
	move.l	a5,a6
	jsr	_LVOLoadSample(a6)
	move.l	a3,a1
	move.l	d0,d1
	beq	ExternalLoadErr17
	move.l	d0,a3
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
LoadDiskSmpOk:	move.l	60(sp),d1
	move.l	a5,a6
	jsr	_LVOCClose(a6)
	move.l	56(sp),d1
	move.l	tcb_DOSBase(a5),a6
	jsr	_LVOCurrentDir(a6)
	move.l	d4,d1
	jsr	_LVOUnLock(a6)
	move.l	32(sp),a2
	move.l	a5,a6
	bra.s	LoadNextSmp2
LoadRawSmpData:	move.l	60(sp),a0
	move.l	a3,a1
	move.l	tcs_Length(a3),d0
	jsr	_LVOLoadSampleData(a6)
	move.l	a3,a1
	move.l	d0,a3
	move.l	d0,d1
	bne.s	LoadDiskSmpOk
	bra	ExternalLoadErr16
LoadNextSmp:	st	280(sp)
LoadNextSmp2:	add.w	#30,d6
	dbra	d5,LoadSmpLoop
	movem.l	32(sp),a2-a4
	move.l	tcm_SongList(a4),a0
	lea	tcso_TrackList(a0),a0
	moveq	#0,d0
	move.l	(a0),a0
	tst.l	(a0)
	beq.s	ScanTrackNullDone
	move.l	a0,a1
	move.w	tct_Length(a1),d1
ScanTrackNullLoop:	addq.l	#1,d0
	move.l	(a0),a0
	tst.l	(a0)
	beq.s	ScanTrackNullDone
	cmp.w	tct_Length(a0),d1
	bne.s	ScanTrackNullLoop
	move.w	d1,d2
	move.l	tct_Data(a0),a2
CheckTrackEmptyLoop:	tst.l	(a2)+
	bne.s	ScanTrackNullLoop
	move.l	(a2),a2
	tst.l	(a2)
	bne.s	ScanTrackNullLoop
	addq.l	#tctd_Effects+MLH_TAIL,a2
	dbra	d2,CheckTrackEmptyLoop
	move.l	a0,a2
	jsr	_LVODeleteTrack(a6)
	move.l	tcm_SongList(a4),a0
	move.l	a2,a1
	sub.l	a2,a2
	jsr	_LVOInsertTrack(a6)
ScanTrackNullDone:	move.l	tcm_SongList(a4),a0
	jsr	_LVOGetOptimalChannels(a6)
	move.l	tcm_SongList(a4),a0
	jsr	_LVOSetSongChannels(a6)
	move.l	a4,a0
	jsr	_LVOGetOptimalVChannels(a6)
	move.l	a4,a0
	jsr	_LVOSetTCMChannels(a6)
	move.l	a3,d0
	bne.s	ModAllocated
	move.l	a4,a3
ModAllocated:	move.l	a4,a0
	move.l	a3,a1
	jsr	_LVOReMapTCModule(a6)
	move.l	12(sp),a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
	move.l	4(sp),a1
	jsr	_LVOFreeVec(a6)
ExternalLoadDone:	lea	284(sp),sp
	move.l	a3,d0
	movem.l	(sp)+,d2-d7/a2-a6
	rts
ExternalLoadErr17:	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
ExternalLoadErr16:	move.l	60(sp),d1
	move.l	a5,a6
	jsr	_LVOCClose(a6)
ExternalLoadErr15:	move.l	56(sp),d1
	move.l	tcb_DOSBase(a5),a6
	jsr	_LVOCurrentDir(a6)
	move.l	d4,d1
	jsr	_LVOUnLock(a6)
	move.l	a5,a6
	bra.s	ExternalLoadErr5
ExternalLoadError:	move.l	d2,a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
ExternalLoadErr1:	move.l	40(sp),a4
ExternalLoadErr2:	move.l	a4,a0
	move.l	a5,a6
	jsr	_LVOFreeTCModule(a6)
ExternalLoadErr3:	move.l	12(sp),a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
ExternalLoadErr4:	move.l	4(sp),a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
ExternalLoadErr5:	sub.l	a3,a3
	bra.s	ExternalLoadDone
ExtendedFXTable:	dc.w	0,NoFX-ExtendedFXTable
	dc.w	FX_O_PORTA_UP,Porta-ExtendedFXTable
	dc.w	FX_O_PORTA_DOWN,Porta-ExtendedFXTable
	dc.w	FX_EXTEND_CTRL,GlissCtrl-ExtendedFXTable
	dc.w	$0301,EnvCtrl-ExtendedFXTable
	dc.w	FX_SET_TRANSP,SetFineTune-ExtendedFXTable
	dc.w	FX_PATT_LOOP,PosJump-ExtendedFXTable
	dc.w	$0401,EnvCtrl-ExtendedFXTable
	dc.w	USER_EFFECTS,PosJump-ExtendedFXTable
	dc.w	FX_RETRIG_NOTE,PosJump-ExtendedFXTable
	dc.w	FX_F_VOLSL_UP,VolSlide-ExtendedFXTable
	dc.w	FX_F_VOLSL_DOWN,VolSlide-ExtendedFXTable
	dc.w	FX_NOTE_CUT,PosJump-ExtendedFXTable
	dc.w	FX_NOTE_DELAY,PosJump-ExtendedFXTable
	dc.w	FX_PATT_DELAY,PosJump-ExtendedFXTable
	dc.w	FX_INVERT_LOOP,PosJump-ExtendedFXTable
PattBreak:	lsr.b	#4,d4
	mulu.w	#10,d4
	and.b	#$f,d1
	add.b	d1,d4
	rts
ToneFade:	movem.w	d0-d1,-(sp)
	moveq	#FX_TONE_PORTA,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	ToneFadeDone
AddFadeFX:	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
ToneFadeDone:	movem.w	(sp)+,d0-d1
	bra.s	VolumeSlide
VibFade:	movem.w	d0-d1,-(sp)
	moveq	#FX_VIBRATO,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	ToneFadeDone
	bra.s	AddFadeFX
VolumeSlide:	btst	#3,d7
	beq.s	NotFastVolSlides
	movem.w	d0-d1,-(sp)
	moveq	#FX_EXECUTE_FX,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	DoFastVolDone
	move.l	d0,d1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
DoFastVolDone:	movem.w	(sp)+,d0-d1
NotFastVolSlides:	bsr.s	CheckNull
	lsr.b	#4,d4
	bne.s	VolSlideUp
	move.b	d1,d4
	and.b	#$f,d4
	addq.b	#1,d0
VolSlideUp:	btst	#2,d7
	beq.s	SetVolOk
	moveq	#8+2,d1
	lsl.w	d1,d4
	rts
AbsArp:	tst.w	d4
	beq.s	NoFX
Arpeggio:	lsl.w	#4,d4
	lsr.b	#4,d4
	rts
Vibrato:	tst.l	d7
	bpl.s	Arpeggio
	lsl.w	#4,d4
	lsr.b	#4,d4
	add.b	d4,d4
	rts
Tremolo:	bsr.s	Arpeggio
	btst	#2,d7
	beq.s	PosJump
	lsl.b	#2,d4
	rts
Porta:	btst	#9,d7
	bsr.s	CheckIt
PortaSlide:	lsl.w	#8,d4
NullOkay:	rts
CheckNull:	btst	#10,d7
CheckIt:	beq.s	NullOkay
	tst.b	d4
	bne.s	NullOkay
	addq.l	#4,sp
	bra.s	NoFX
SetPanning:	btst	#4,d7
	bne.s	Porta
	moveq	#USER_EFFECTS,d0
	rts
SetVolume:	btst	#2,d7
	beq.s	SetVolOk
	lsl.b	#2,d4
	bcc.s	SetVolOk
	moveq	#-1,d4
SetVolOk:	lsl.w	#8,d4
PosJump:	rts
Extended:	lea	ExtendedFXTable(pc),a0
	lsr.b	#4,d1
	movem.w	(a0,d1.w*4),d0-d1
	add.l	d1,a0
	move.w	d4,d1
	lsr.b	#4,d1
	and.b	#$f,d4
	jmp	(a0)
NoFX:	addq.l	#4,sp
	bra	NoEffect
Tempo:	cmp.b	#$20,d4
	bcs.s	PosJump
	btst	#5,d7
	bne.s	PosJump
	moveq	#FX_SET_SPEED,d0
	rts
SetFineTune:	lsl.b	#4,d4
	rts
ExtendControl:	bset	#12,d4
	rts
GlissCtrl:	tst.b	d4
	beq.s	ExtendControl
	move.w	#$1001,d4
	rts
VolSlide:	bsr.s	CheckNull
	btst	#2,d7
	beq.s	SetVolOk
	moveq	#8+2,d1
	lsl.w	d1,d4
	rts
EnvCtrl:	move.w	d0,d3
	moveq	#FX_ENV_CONTROL,d0
	cmp.b	#4,d4
	blo.s	NotRetrigEnvSet
	or.b	#$10,d3
NotRetrigEnvSet:	and.w	#3,d4
	cmp.w	#3,d4
	bne.s	NotSquareWave
	moveq	#2,d4
NotSquareWave:	move.w	d3,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	EnvCtrlDone
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
	moveq	#FX_ENV_CONTROL,d0
	clr.b	d3
	move.w	d3,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	EnvCtrlDone
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
EnvCtrlDone:	moveq	#FX_SET_ENV_VAL,d0
	rts
ExternalModuleSave:	
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle from where to get the info
;	A1.L	=	APTR to track info structure where to put information
;	D0.L	=	Number of track to be scanned (NULL is the first)
;	OUTPUT
;	D0.L	=	A non-zero value if success else NULL.
ExternalModuleGetInfo:	movem.l	d2-d4/a2-a3/a6,-(sp)
	movem.l	(sp)+,d2-d4/a2-a3/a6
	rts
GetNumChannels:	move.l	a0,d1
	subq.l	#4,sp
	move.l	d1,a2
	move.l	#1080,d2
	moveq	#OFFSET_CURRENT,d3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	GetNumChannelsErr
	move.l	a2,d1
	move.l	sp,d2
	moveq	#4,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	GetNumChannelsErr
	move.l	a2,d1
	moveq	#-4,d2
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	GetNumChannelsErr
	move.l	(sp),d3
	lea	MODCheck(pc),a0
CheckMODLoop:	move.l	(a0)+,d4
	beq.s	CheckMODFailed
	move.w	(a0)+,d0
	cmp.l	d3,d4
	beq	GetNumChannelsDone
	bra.s	CheckMODLoop
CheckMODFailed:	moveq	#10,d0
	moveq	#1,d1
	moveq	#90-1,d2
	move.l	#"10CH",d4
	moveq	#$10,d5
CheckxxMOD:	cmp.l	d3,d4
	beq	GetNumChannelsDone
	swap	d4
	addq.b	#1,d0
	abcd	d1,d5
	unpk	d5,d4,#"00"
	swap	d4
	dbra	d2,CheckxxMOD
	move.l	#"100C",d4
	move.w	#155-1,d2
	moveq	#0,d5
CheckxxxMOD:	cmp.l	d3,d4
	beq.s	GetNumChannelsDone
	ror.l	#8,d4
	addq.b	#1,d0
	abcd	d1,d5
	bcc.s	NotBCDCopy
	add.l	#$010000,d4
NotBCDCopy:	unpk	d5,d4,#"00"
	rol.l	#8,d4
	dbra	d2,CheckxxxMOD
	move.l	a2,d1
	move.l	#600-1080,d2
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq.s	GetNumChannelsErr
	moveq	#64,d0
	lsl.l	#4,d0
	jsr	_LVOAllocPMem(a6)
	move.l	d0,d5
	beq.s	GetNumChannelsErr
	move.l	#"ST15",d4
	bsr	CheckNoHeaderModule
	move.l	a2,d1
	moveq	#(1080-600)/4,d2
	lsl.l	#2,d2
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq.s	GetNumChannelsError
	move.l	#"ST31",d4
	bsr	CheckNoHeaderModule
GetNumChannelsError:	moveq	#64,d0
	lsl.l	#4,d0
	move.l	d5,a1
	jsr	_LVOFreePMem(a6)
GetNumChannelsErr:	moveq	#0,d0
GetNumChannelsDone:	move.l	d0,d5
	beq	NotCheckForWOW
	cmp.l	#"M.K.",d4
	bne	NotCheckForWOW
	move.l	a2,d1
	moveq	#0,d2
	moveq	#OFFSET_END,d3
	jsr	_LVOCSeek(a6)
	move.l	d0,d2
	addq.l	#1,d0
	beq.s	GetNumChannelsErr
	move.l	a2,d1
	move.l	#1080,d5
	sub.l	d5,d2
	moveq	#OFFSET_BEGINNING,d3
	jsr	_LVOCSeek(a6)
	move.l	d5,d3
	move.l	d0,d5
	addq.l	#1,d0
	beq.s	GetNumChannelsErr
	sub.l	d3,d5
	move.l	d3,d0
	jsr	_LVOAllocPMem(a6)
	move.l	d0,d2
	beq.s	GetNumChannelsErr
	move.l	a2,d1
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	beq.s	WOWReadOk
	move.l	d3,d0
	move.l	d2,a1
	jsr	_LVOFreePMem(a6)
	bra.s	GetNumChannelsErr
WOWReadOk:	moveq	#31-1,d0
	move.l	d2,a0
	lea	4.w,a1
WOWCountSmp:	moveq	#0,d1
	move.w	20+22(a0),d1
	add.l	d1,d1
	add.l	d1,a1
	lea	30(a0),a0
	dbra	d0,WOWCountSmp
	moveq	#128-1,d0
	moveq	#0,d6
	lea	20+2(a0),a0
CheckWOWLoop:	move.l	d6,d3
	subq.w	#1,d0
CheckWOWLoop2:	move.b	(a0)+,d6
	cmp.b	d3,d6
	bgt.s	CheckWOWLoop
	dbra	d0,CheckWOWLoop2
	addq.b	#1,d3
	moveq	#11,d6
	lsl.l	d6,d3
	add.l	a1,d3
	cmp.l	d3,d5
	beq.s	IsWOW
	moveq	#4,d5
	bra.s	CheckWOWDone
IsWOW:	moveq	#8,d5
	move.l	#"WOW8",d4
CheckWOWDone:	move.l	#1080,d0
	move.l	d2,a1
	jsr	_LVOFreePMem(a6)
NotCheckForWOW:	addq.l	#4,sp
	move.l	d5,d0
GetNoHeaderInvType:	rts
CheckNoHeaderModule:	move.l	d5,d2
	moveq	#64,d3
	lsl.l	#4,d3
	move.l	a2,d1
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	GetNoHeaderErr
	move.l	a2,d1
	move.l	d3,d2
	neg.l	d2
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq.s	GetNoHeaderErr
	moveq	#0,d0
	not.b	d0
	move.l	d5,a1
	move.l	d4,d2
CheckNextSTPattern:	lea	PeriodTable(pc),a0
CheckValidSTPattern:	move.l	(a1)+,d1
	swap	d1
	and.w	#$fff,d1
	beq.s	CheckSTPatternOk
CheckPerTableLoop:	move.w	(a0)+,d3
	beq.s	GetNoHeaderInvType
	cmp.w	d1,d3
	bne.s	CheckPerTableLoop
CheckSTPatternOk:	dbra	d0,CheckNextSTPattern
	moveq	#64,d0
	lsl.l	#4,d0
	move.l	d5,a1
	jsr	_LVOFreePMem(a6)
	addq.l	#4,sp
	moveq	#4,d0
	bra	GetNumChannelsDone
GetNoHeaderErr:	addq.l	#4,sp
	bra	GetNumChannelsError
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	Number of modules found or NULL on any error
ExternalModuleGetNums:	moveq	#1,d0
	rts
PanningTable:	dc.b	0,$ff,$ff,0
PeriodTable:	dc.w	4064,3840,3624	;	A-0, A#0, B-0
	dc.w	3424,3232,3048,2880,2712,2560,2416,2280,2152,2032,1920,1812 ; C-1 - B-1
	dc.w	1712,1616,1524,1440,1356,1280,1208,1140,1076,1016,960,906 ; C-2 - B-2
	dc.w	856,808,762,720,678,640,604,570,538,508,480,453 ; C-3 - B-3
	dc.w	428,404,381,360,339,320,302,285,269,254,240,226 ; C-4 - B-4
	dc.w	214,202,190,180,170,160,151,143,135,127,120,113 ; C-5 - B-5
	dc.w	107,101,95,90,85,80,75,71,67,63,60,56 ; C-6 - B-6
	dc.w	53,50,47,45,42,40,37,35,33,31,30,28,0 ; C-7 - B-7

	cnop	0,4

MODCheck:	dc.b	'TDZ1',0,1
	dc.b	'1CHN',0,1
	dc.b	'TDZ2',0,2
	dc.b	'2CHN',0,2
	dc.b	'TDZ3',0,3
	dc.b	'3CHN',0,3
	dc.b	'TDZ4',0,4
	dc.b	'4CHN',0,4
	dc.b	'M.K.',0,4
	dc.b	'M!K!',0,4
	dc.b	'M&K!',0,4
	dc.b	'FLT4',0,4
	dc.b	'EMW3',0,4
	dc.b	'TDZ5',0,5
	dc.b	'5CHN',0,5
	dc.b	'TDZ6',0,6
	dc.b	'6CHN',0,6
	dc.b	'TDZ7',0,7
	dc.b	'7CHN',0,7
	dc.b	'TDZ8',0,8
	dc.b	'8CHN',0,8
	dc.b	'FLT8',0,8
	dc.b	'TDZ9',0,9
	dc.b	'9CHN',0,9
	dc.l	0

ExtModuleLibBase:	dc.l	0

LoadFlags:	dc.w	14
	dc.w	LoadFlagSize
	dc.l	LoadText0
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText1
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText2
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText3
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	LoadText4
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	LoadText5
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	LoadText6
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText7
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	LoadText8
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	LoadText9
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText10
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText11
	dc.b	EXTFLAG_BUTTON
	dc.b	0
	dc.w	1+3
	dc.l	0
	dc.l	0
	dc.l	1
	dc.l	0
	dc.l	LoadText12
	dc.b	EXTFLAG_BUTTON
	dc.b	0
	dc.w	1+3
	dc.l	0
	dc.l	0
	dc.l	1
	dc.l	0
	dc.l	LoadText13
	dc.b	EXTFLAG_DIRECTORY
	dc.b	0
	dc.w	256
	dc.l	0
	dc.l	0
	dc.l	LoadDefault13
	dc.l	0
LoadText11:	dc.l	LoadText110
	dc.l	LoadText111
	dc.l	LoadText112
	dc.l	LoadText113
LoadText12:	dc.l	LoadText120
	dc.l	LoadText121
	dc.l	LoadText122
	dc.l	LoadText123
LoadText0:	dc.b	'Load samples',0
LoadText1:	dc.b	'Make vibrato envelopes',0
LoadText2:	dc.b	'Convert volumes',0
LoadText3:	dc.b	'Fast volume slides',0
LoadText4:	dc.b	'8xx is set panning',0
LoadText5:	dc.b	'Fxx is always tempo',0
LoadText6:	dc.b	'Check NoiseTracker vibrato',0
LoadText7:	dc.b	'DMP-like panning (L,R,L,R)',0
LoadText8:	dc.b	'Use Amiga frequency range',0
LoadText9:	dc.b	'Remove portamento 0 commands',0
LoadText10:	dc.b	'Remove volume slide 0 commands',0
LoadText110:	dc.b	'Frequency usage',0
LoadText111:	dc.b	'Auto detect',0
LoadText112:	dc.b	'Force PAL',0
LoadText113:	dc.b	'Force NTSC',0
LoadText120:	dc.b	'Initial speed',0
LoadText121:	dc.b	'Auto detect',0
LoadText122:	dc.b	'Force PAL (125 BpM)',0
LoadText123:	dc.b	'Force NTSC (150 BpM)',0
LoadText13:	dc.b	'Sample directory',0
LoadDefault13:	dc.b	'ST-00:Instruments',0
LoadFlagSize:	equ	*-LoadFlags
LoadDescript:	dc.b	'ProTracker Style Module (MOD)',0
