*********************************************************
***    TuComposer External Track Library for MOD      ***
***       1996-97 by The united Coders (TuC)         ***
***                Main code: Basty/TuC               ***
*** This is a MOD track loader (loads the tracks from ***
***              ProTracker style modules)            ***
*********************************************************

	IFND	_G2
	MACHINE	MC68020
	OPT NODEBUG,NOLINE
	ENDC

	include	"exec/types.i"
	include	"exec/execbase.i"
	include	"exec/exec_lib.i"
	include	"exec/initializers.i"
	include	"exec/memory.i"
	include	"exec/resident.i"
	include	"exec/libraries.i"
	include	"libraries/dos_lib.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/track.i"
	include	"tucomposer/external/external.i"
	include	"tucomposer/external/external_lib.i"
	include	"tucomposer/external/track.i"
	include	"tucomposer/external/track_lib.i"

	moveq	#-1,d0
	rts
ResidentStruct:	dc.w	RTC_MATCHWORD
	dc.l	ResidentStruct
	dc.l	0
	dc.b	RTF_AUTOINIT
	dc.b	EXTLIB_TRACK_VERSION
	dc.b	NT_LIBRARY
	dc.b	0
	dc.l	LibName
	dc.l	LibID
	dc.l	Init
LibName:	dc.b	'modt.library',0
LibID:	dc.b	'TuComposer External Track Loader Version 1.00 (v31) for MOD (68020+, OS2.0+) (10 Mar 97) by Basty/TuC.',0
TuComposerName:	dc.b	'tucomposer.library',0
	even
Init:	dc.l	trkl_SIZEOF
	dc.l	FuncTab
	dc.l	DataTab
	dc.l	PrepareLibrary

FuncTab:	dc.w	-1
	dc.w	Open-FuncTab
	dc.w	Close-FuncTab
	dc.w	Expunge-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalInitialize-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalTrackIdentify-FuncTab
	dc.w	ExternalTrackLoad-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalTrackGetInfo-FuncTab
	dc.w	ExternalTrackGetNums-FuncTab
	dc.w	-1

DataTab:	INITLONG	LN_NAME,LibName
	INITBYTE	LIB_FLAGS,LIBF_CHANGED|LIBF_SUMUSED
	INITWORD	LIB_VERSION,EXTLIB_TRACK_VERSION
	INITWORD	LIB_REVISION,EXTLIB_REVISION
	INITLONG	LIB_IDSTRING,LibID
	dc.l	0

PrepareLibrary:	btst	#AFB_68020,AttnFlags+1(a6)
	beq.s	ExtLib
	cmp.w	#36,LIB_VERSION(a6)
	blt.s	ExtLib
	move.l	a2,-(sp)
	move.l	d0,a2
	move.l	a0,extb_SegList(a2)
	moveq	#31,d0
	lea	TuComposerName(pc),a1
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,extb_TuComposerBase(a2)
	beq.s	NoTuCLib
	lea	ExtTrackLibBase(pc),a0
	move.l	a2,(a0)
	move.l	a2,d0
NoTuCLib:	move.l	(sp)+,a2
	rts
Open:	addq.w	#1,LIB_OPENCNT(a6)
	move.l	a6,d0
	rts
Close:	subq.w	#1,LIB_OPENCNT(a6)
	bne.s	ExtLib
	btst	#LIBB_DELEXP,LIB_FLAGS(a6)
	bne.s	Expunge
ExtLib:	moveq	#0,d0
	rts
Expunge:	bset	#LIBB_DELEXP,LIB_FLAGS(a6)
	tst.w	LIB_OPENCNT(a6)
	bne.s	ExtLib
	movem.l	d2/a5-a6,-(sp)
	move.l	extb_ExtLibList(a6),d0
	beq.s	NoExtLibList
	move.l	d0,a0
	clr.l	extl_LibBase(a0)
NoExtLibList:	move.l	extb_TuComposerBase(a6),a1
	move.l	a6,a5
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
	move.l	extb_SegList(a5),d2
	move.l	a5,a1
	jsr	_LVORemove(a6)
	move.l	a5,a1
	moveq	#0,d0
	moveq	#0,d1
	move.w	LIB_NEGSIZE(a5),d1
	sub.l	d1,a1
	move.w	LIB_POSSIZE(a5),d0
	add.l	d1,d0
	jsr	_LVOFreeMem(a6)
	move.l	d2,d0
	movem.l	(sp)+,d2/a5-a6
	rts
;	INPUT
;	A0.L	=	APTR to track external list structure to be initialized
;	OUTPUT
;	D0.L	=	What type of external library is it or NULL if error
ExternalInitialize:	move.l	extb_TuComposerBase(a6),a1
	movem.l	a2/a6,-(sp)
	move.l	a0,d0
	beq.s	ExternalInitDone
	move.l	a1,a6
	move.b	#EXTLF_Loader,extl_Flags(a0)
	move.l	a0,a2
	lea	extl_Descriptor(a0),a0
	lea	LoadDescript(pc),a1
	jsr	_LVOSetString(a6)
	tst.l	d0
	beq.s	ExternalInitDone
	lea	LoadFlags(pc),a0
	jsr	_LVOAllocFlagStr(a6)
	move.l	d0,extl_LoadFlagStr(a2)
	beq.s	ExternalInitDone
	move.b	#-10,extl_Pri(a2)
	moveq	#EXTTYPE_TRACK,d0
ExternalInitDone:	movem.l	(sp)+,a2/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	If failed NULL else any non-zero value
ExternalTrackIdentify:	movem.l	d2-d5/a2/a5-a6,-(sp)
	bsr	GetNumChannels
	movem.l	(sp)+,d2-d5/a2/a5-a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be loaded
;	A1.L	=	APTR to target track structure or NULL to create a new one
;	A2.L	=	APTR to loading flag pass structure (Loader specific)
;	D0.L	=	Number of track of be loaded (NULL is the first)
;	OUTPUT
;	D0.L	=	APTR to track structure where loaded track data
ExternalTrackLoad:	movem.l	d2-d7/a2-a6,-(sp)
	move.l	d0,d6
	moveq	#7,d0
	moveq	#0,d1
	moveq	#0,d7
CreateBitTable:	tst.l	(a2)+
	beq.s	BitNotSet
	bset	d1,d7
BitNotSet:	addq.b	#1,d1
	dbra	d0,CreateBitTable
	move.l	a1,a3
	bsr	GetNumChannels
	beq	ExternalTrackLoadRts
	move.l	a2,d1
	moveq	#-128,d2
	subq.b	#4,d2
	add.l	d2,sp
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalTrackLoadError
	move.l	a2,d1
	moveq	#255-132,d3
	not.b	d3
	move.l	sp,d2
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalTrackLoadErr
	moveq	#128-1,d2
	move.l	sp,a0
	addq.l	#4,a0
CheckLoadLoop:	move.l	d1,d0
	subq.w	#1,d2
CheckLoadLoop2:	move.b	(a0)+,d1
	cmp.b	d0,d1
	bgt.s	CheckLoadLoop
	dbra	d2,CheckLoadLoop2
	addq.w	#1,d0
	mulu.w	d5,d0
	cmp.l	d0,d6
	bcc	ExternalTrackLoadErr
	move.l	a2,d1
	move.l	d6,d2
	divul.l	d5,d6:d2
	moveq	#10,d0
	lsl.l	d0,d2
	cmp.l	#"ST15",d4
	beq.s	NoHeaderMOD
	cmp.l	#"ST31",d4
	beq.s	NoHeaderMOD
	addq.l	#4,d2
NoHeaderMOD:	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalTrackLoadDone
	move.l	d5,d0
	lsl.l	#8,d0
	move.l	d0,d3
	move.l	a6,a5
	move.l	4.w,a6
	jsr	_LVOAllocVec(a6)
	move.l	a5,a6
	move.l	a2,d1
	move.l	d0,d2
	beq	ExternalTrackLoadDone
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalTrackLoadError
	btst	#4,d7
	beq.s	NotNTVibrato
	cmp.l	#"M&K!",d4
	bne.s	NotMKVibrato
	bset	#31,d7
NotMKVibrato:	cmp.l	#"M.K.",d4
	bne.s	NotNTVibrato
	cmp.b	#$78,3(sp)
	beq.s	NotNTVibrato
	cmp.b	#$7f,3(sp)
	beq.s	NotNTVibrato
	bset	#31,d7
NotNTVibrato:	move.l	a2,d1
	move.l	d2,-(sp)
	moveq	#0,d2
	moveq	#OFFSET_BEGINNING,d3
	jsr	_LVOCSeek(a6)
	move.l	(sp)+,d2
	addq.l	#1,d0
	beq	ExternalTrackLoadError
	move.l	d2,-(sp)
	move.l	sp,d2
	addq.l	#4,d2
	move.l	a2,d1
	moveq	#20,d3
	jsr	_LVOCRead(a6)
	move.l	(sp)+,d2
	cmp.l	d3,d0
	bne	ExternalTrackLoadError
	move.l	a3,d0
	bne.s	TrackAllocated
	moveq	#64,d0
	jsr	_LVOAllocTrack(a6)
TrackAllocated:	move.l	d0,d1
	beq	ExternalTrackLoadError
	move.l	d0,a3
	moveq	#64,d0
	move.l	a3,a0
	jsr	_LVOReSizeTrack(a6)
	tst.l	d0
	bne	ExternalTrackLoadError
	move.l	a3,a0
	jsr	_LVOClearTrack(a6)
	move.l	d2,a2
	move.l	sp,a0
	clr.b	20(a0)
	jsr	_LVOAllocNameStr(a6)
	move.l	d0,tct_Name(a3)
	move.l	d6,d0
	and.w	#3,d0
	moveq	#0,d1
	btst	#0,d0
	beq.s	NotRightDMPPan
	moveq	#-1,d1
NotRightDMPPan:	btst	#5,d7
	beq.s	DMPPanning
	move.b	(PanningTable.w,pc,d0.w),d1
DMPPanning:	move.b	d1,tct_Panning(a3)
	move.b	#TCTCF_OpSlide,tct_CompFlags(a3)
	moveq	#64-1,d3
	move.l	d2,a2
	move.l	tct_Data(a3),a4
	cmp.l	#"FLT8",d4
	bne.s	ExternalTrackConvertLoop
	moveq	#4,d5
	cmp.w	d5,d6
	bcs.s	ExternalTrackConvertLoop
	subq.w	#4,d6
	lea	1024(a2),a2
ExternalTrackConvertLoop:	move.l	(a2,d6.w*4),d0
	lea	(a2,d5.w*4),a2
	clr.b	(sp)
	move.l	d0,d1
	swap	d1
	and.w	#$fff,d1
	beq.s	NoNote
	moveq	#NOTE_A_-1-1,d4
	lea	PeriodTable(pc),a0
FindCorrectNote:	addq.w	#1,d4
	cmp.w	(a0)+,d1
	blt.s	FindCorrectNote
	move.b	d4,(sp)
NoNote:	move.l	d0,d1
	swap	d1
	rol.w	#4,d1
	rol.l	#4,d1
	move.b	d1,1(sp)
	move.b	d0,3(sp)
	and.w	#$fff,d0
	lsr.w	#8,d0
	move.b	d0,2(sp)
	move.l	sp,a1
	moveq	#0,d0
	move.b	(a1)+,d0
	bne.s	NoteOk
	move.w	d0,(a4)+
	bra.s	NoteDone
NoteOk:	divu.w	#12,d0
	move.b	d0,(a4)+
	swap	d0
	addq.b	#1,d0
	move.b	d0,(a4)+
NoteDone:	move.b	(a1)+,d0
	move.w	d0,(a4)+
	moveq	#0,d0
	move.b	(a1)+,d0
	moveq	#0,d4
	move.b	(a1),d4
	cmp.b	#9,d0
	bne.s	NotSmpOffset
	tst.w	tctd_Octave-tctd_Effects(a4)
	beq.s	NoEffect
NotSmpOffset:	movem.w	ProcessFXTable(pc,d0.w*4),d0-d1
	lea	ProcessFXTable(pc),a0
	add.l	d1,a0
	move.w	d4,d1
	jsr	(a0)
	move.w	d4,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	NoEffect
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
NoEffect:	lea	MLH_SIZE(a4),a4
	dbra	d3,ExternalTrackConvertLoop
	move.l	d2,a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
	move.l	a3,d0
ExternalTrackLoadDone:	lea	128+4(sp),sp
ExternalTrackLoadRts:	movem.l	(sp)+,d2-d7/a2-a6
	rts
ExternalTrackLoadError:	move.l	d2,a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
ExternalTrackLoadErr:	moveq	#0,d0
	bra.s	ExternalTrackLoadDone
ProcessFXTable:	dc.w	FX_ARPEGGIO,AbsArp-ProcessFXTable
	dc.w	FX_PORTA_UP,Porta-ProcessFXTable
	dc.w	FX_PORTA_DOWN,Porta-ProcessFXTable
	dc.w	FX_TONE_PORTA,Porta-ProcessFXTable
	dc.w	FX_VIBRATO,Vibrato-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,ToneFade-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,VibFade-ProcessFXTable
	dc.w	FX_TREMOLO,Tremolo-ProcessFXTable
	dc.w	FX_SET_PANNING,SetPanning-ProcessFXTable
	dc.w	FX_SMP_OFF_LOW,Porta-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,VolumeSlide-ProcessFXTable
	dc.w	FX_POS_JUMP,PosJump-ProcessFXTable
	dc.w	FX_SET_VOLUME,SetVolume-ProcessFXTable
	dc.w	FX_PATT_BREAK,PattBreak-ProcessFXTable
	dc.w	0,Extended-ProcessFXTable
	dc.w	FX_SET_TEMPO,Tempo-ProcessFXTable
ExtendedFXTable:	dc.w	0,NoFX-ExtendedFXTable
	dc.w	FX_O_PORTA_UP,Porta-ExtendedFXTable
	dc.w	FX_O_PORTA_DOWN,Porta-ExtendedFXTable
	dc.w	FX_EXTEND_CTRL,GlissCtrl-ExtendedFXTable
	dc.w	$0301,EnvCtrl-ExtendedFXTable
	dc.w	FX_SET_TRANSP,SetFineTune-ExtendedFXTable
	dc.w	FX_PATT_LOOP,PosJump-ExtendedFXTable
	dc.w	$0401,EnvCtrl-ExtendedFXTable
	dc.w	USER_EFFECTS,PosJump-ExtendedFXTable
	dc.w	FX_RETRIG_NOTE,PosJump-ExtendedFXTable
	dc.w	FX_F_VOLSL_UP,VolSlide-ExtendedFXTable
	dc.w	FX_F_VOLSL_DOWN,VolSlide-ExtendedFXTable
	dc.w	FX_NOTE_CUT,PosJump-ExtendedFXTable
	dc.w	FX_NOTE_DELAY,PosJump-ExtendedFXTable
	dc.w	FX_PATT_DELAY,PosJump-ExtendedFXTable
	dc.w	FX_INVERT_LOOP,PosJump-ExtendedFXTable
PattBreak:	lsr.b	#4,d4
	mulu.w	#10,d4
	and.b	#$f,d1
	add.b	d1,d4
	rts
ToneFade:	movem.w	d0-d1,-(sp)
	moveq	#FX_TONE_PORTA,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	ToneFadeDone
AddFadeFX:	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
ToneFadeDone:	movem.w	(sp)+,d0-d1
	bra.s	VolumeSlide
VibFade:	movem.w	d0-d1,-(sp)
	moveq	#FX_VIBRATO,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	ToneFadeDone
	bra.s	AddFadeFX
VolumeSlide:	btst	#1,d7
	beq.s	NotFastVolSlides
	movem.w	d0-d1,-(sp)
	moveq	#FX_EXECUTE_FX,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	DoFastVolDone
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
DoFastVolDone:	movem.w	(sp)+,d0-d1
NotFastVolSlides:	bsr.s	CheckNull
	lsr.b	#4,d4
	bne.s	VolSlideUp
	move.b	d1,d4
	and.b	#$f,d4
	addq.b	#1,d0
VolSlideUp:	btst	#0,d7
	beq.s	SetVolOk
	moveq	#8+2,d1
	lsl.w	d1,d4
	rts
AbsArp:	tst.w	d4
	beq.s	NoFX
Arpeggio:	lsl.w	#4,d4
	lsr.b	#4,d4
	rts
Vibrato:	tst.l	d7
	bpl.s	Arpeggio
	lsl.w	#4,d4
	lsr.b	#4,d4
	add.b	d4,d4
	rts
Tremolo:	bsr.s	Arpeggio
	btst	#0,d7
	beq.s	PosJump
	lsl.b	#2,d4
	rts
Porta:	btst	#6,d7
	bsr.s	CheckIt
PortaSlide:	lsl.w	#8,d4
NullOkay:	rts
CheckNull:	btst	#7,d7
CheckIt:	beq.s	NullOkay
	tst.b	d4
	bne.s	NullOkay
	addq.l	#4,sp
	bra.s	NoFX
SetPanning:	btst	#2,d7
	bne.s	Porta
	moveq	#USER_EFFECTS,d0
	rts
SetVolume:	btst	#0,d7
	beq.s	SetVolOk
	lsl.b	#2,d4
	bcc.s	SetVolOk
	moveq	#-1,d4
SetVolOk:	lsl.w	#8,d4
PosJump:	rts
Extended:	lea	ExtendedFXTable(pc),a0
	lsr.b	#4,d1
	movem.w	(a0,d1.w*4),d0-d1
	add.l	d1,a0
	move.w	d4,d1
	lsr.b	#4,d1
	and.b	#$f,d4
	jmp	(a0)
NoFX:	addq.l	#4,sp
	bra	NoEffect
Tempo:	cmp.b	#$20,d4
	bcs.s	PosJump
	btst	#3,d7
	bne.s	PosJump
	moveq	#FX_SET_SPEED,d0
	rts
SetFineTune:	lsl.b	#4,d4
	rts
ExtendControl:	bset	#12,d4
	rts
GlissCtrl:	tst.b	d4
	beq.s	ExtendControl
	move.w	#$1001,d4
	rts
VolSlide:	bsr.s	CheckNull
	btst	#0,d7
	beq.s	SetVolOk
	moveq	#8+2,d1
	lsl.w	d1,d4
	rts
EnvCtrl:	move.w	d3,-(sp)
	move.w	d0,d3
	moveq	#FX_ENV_CONTROL,d0
	cmp.b	#4,d4
	blo.s	NotRetrigEnvSet
	or.b	#$10,d3
NotRetrigEnvSet:	and.w	#3,d4
	cmp.w	#3,d4
	bne.s	NotSquareWave
	moveq	#2,d4
NotSquareWave:	move.w	d3,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	EnvCtrlDone
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
	moveq	#FX_ENV_CONTROL,d0
	clr.b	d3
	move.w	d3,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	EnvCtrlDone
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
EnvCtrlDone:	move.w	(sp)+,d3
	moveq	#FX_SET_ENV_VAL,d0
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle from where to get the info
;	A1.L	=	APTR to track info structure where to put information
;	D0.L	=	Number of track to be scanned (NULL is the first)
;	OUTPUT
;	D0.L	=	A non-zero value if success else NULL.
ExternalTrackGetInfo:	movem.l	d2-d7/a2-a3/a6,-(sp)
	move.l	d0,d6
	move.l	a1,a3
	bsr	GetNumChannels
	beq	ExternalGetInfoError
	move.l	a2,d1
	moveq	#-128,d2
	subq.b	#4,d2
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalGetInfoError
	move.l	a2,d1
	moveq	#255-132,d3
	not.b	d3
	sub.l	d3,sp
	move.l	sp,d2
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalGetInfoErr
	moveq	#128-1,d2
	moveq	#0,d1
	move.l	sp,a0
	addq.l	#3,a0
	move.b	(a0)+,d7
CheckLoop:	move.l	d1,d0
	subq.w	#1,d2
CheckLoop2:	move.b	(a0)+,d1
	cmp.b	d0,d1
	bgt.s	CheckLoop
	dbra	d2,CheckLoop2
	add.l	d3,sp
	addq.w	#1,d0
	mulu.w	d5,d0
	cmp.l	d0,d6
	bcc	ExternalGetInfoError
	divul.l	d5,d1:d6
	and.w	#3,d1
	move.b	PanningTable(pc,d1.w),trki_Panning(a3)
	moveq	#1,d0
	moveq	#0,d1
	cmp.l	#"ST15",d4
	beq	StoreVersion
	moveq	#2,d0
	cmp.l	#"ST31",d4
	beq.s	StoreVersion
	moveq	#3,d0
	cmp.l	#"M&K!",d4
	beq.s	StoreVersion
	moveq	#2,d1
	cmp.l	#"FLT4",d4
	beq.s	StoreVersion
	moveq	#3,d1
	cmp.l	#"FLT8",d4
	beq.s	StoreVersion
	moveq	#4,d0
	moveq	#0,d1
	cmp.l	#"M.K.",d4
	bne.s	NotMK
	cmp.b	#$78,d7
	beq.s	StoreVersion
	cmp.b	#$7f,d7
	beq.s	StoreVersion
	moveq	#3,d0
	moveq	#1,d1
	bra.s	StoreVersion
PanningTable:	dc.b	0,$ff,$ff,0
NotMK:	moveq	#1,d1
	cmp.l	#"M!K!",d4
	beq.s	StoreVersion
	moveq	#2,d1
	cmp.l	#"EMW3",d4
	beq.s	StoreVersion
	moveq	#5,d0
	moveq	#0,d1
	cmp.l	#"WOW8",d4
	beq.s	StoreVersion
	moveq	#6,d0
	move.l	d5,d1
	lsr.l	#8,d4
	and.l	#$ffffff00,d4
	cmp.l	#"TDZ"<<8,d4
	beq.s	StoreVersion
	moveq	#7,d0
StoreVersion:	move.b	d0,trki_Version(a3)
	move.b	d1,trki_Revision(a3)
	move.w	#6,trki_Frames(a3)
	move.w	#125,trki_BPMSpeed(a3)
	move.w	#(DEFAULTTRACKVOLUME<<8),trki_Volume(a3)
	move.l	#(DEFAULTTRACKSPDSPEED<<16)|(DEFAULTTRACKBPMTEMPO),trki_SPDSpeed(a3)
	move.b	#TCTCF_OpSlide,trki_CompFlags(a3)
	move.w	#64,trki_Length(a3)
	move.l	a2,d1
	moveq	#0,d2
	moveq	#OFFSET_BEGINNING,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq.s	ExternalGetInfoError
	move.l	a2,d1
	moveq	#24,d3
	sub.l	d3,sp
	move.l	sp,d2
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalGetInfoErr
	clr.b	20(sp)
	move.l	sp,a0
	jsr	_LVOAllocNameStr(a6)
	move.l	d0,trki_Name(a3)
	add.l	d3,sp
	move.l	a3,d0
ExternalGetInfoDone:	movem.l	(sp)+,d2-d7/a2-a3/a6
	rts
ExternalGetInfoErr:	add.l	d3,sp
ExternalGetInfoError:	moveq	#0,d0
	bra.s	ExternalGetInfoDone
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	Number of tracks found or NULL on any error
ExternalTrackGetNums:	movem.l	d2-d5/a2/a5-a6,-(sp)
	bsr.s	GetNumChannels
	beq.s	ExternalGetNumError
	move.l	a2,d1
	moveq	#-128,d2
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq.s	ExternalGetNumError
	move.l	a2,d1
	moveq	#255-128,d3
	not.b	d3
	sub.l	d3,sp
	move.l	sp,d2
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalGetNumErr
	moveq	#128-1,d2
	moveq	#0,d1
	move.l	sp,a0
CheckNumLoop:	move.l	d1,d0
	subq.w	#1,d2
CheckNumLoop2:	move.b	(a0)+,d1
	cmp.b	d0,d1
	bgt.s	CheckNumLoop
	dbra	d2,CheckNumLoop2
	addq.w	#1,d0
	mulu.w	d5,d0
ExternalGetNumsDone:	add.l	d3,sp
	movem.l	(sp)+,d2-d5/a2/a5-a6
	rts
ExternalGetNumErr:	add.l	d3,sp
ExternalGetNumError:	moveq	#0,d0
	bra.s	ExternalGetNumsDone
ExternalGetNumWrongVersion:	moveq	#255-ERROR_ACTION_NOT_KNOWN,d1
	not.b	d1
	move.l	tcb_DOSBase(a6),a6
	jsr	_LVOSetIoErr(a6)
	bra.s	ExternalGetNumError
GetNumChannels:	move.l	a0,d1
	subq.l	#4,sp
	move.l	d1,a2
	move.l	#1080,d2
	moveq	#OFFSET_CURRENT,d3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	GetNumChannelsErr
	move.l	a2,d1
	move.l	sp,d2
	moveq	#4,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	GetNumChannelsErr
	move.l	a2,d1
	moveq	#-4,d2
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	GetNumChannelsErr
	move.l	(sp),d3
	lea	MODCheck(pc),a0
CheckMODLoop:	move.l	(a0)+,d4
	beq.s	CheckMODFailed
	move.w	(a0)+,d0
	cmp.l	d3,d4
	beq	GetNumChannelsDone
	bra.s	CheckMODLoop
CheckMODFailed:	moveq	#10,d0
	moveq	#1,d1
	moveq	#90-1,d2
	move.l	#"10CH",d4
	moveq	#$10,d5
CheckxxMOD:	cmp.l	d3,d4
	beq	GetNumChannelsDone
	swap	d4
	addq.b	#1,d0
	abcd	d1,d5
	unpk	d5,d4,#"00"
	swap	d4
	dbra	d2,CheckxxMOD
	move.l	#"100C",d4
	move.w	#155-1,d2
	moveq	#0,d5
CheckxxxMOD:	cmp.l	d3,d4
	beq.s	GetNumChannelsDone
	ror.l	#8,d4
	addq.b	#1,d0
	abcd	d1,d5
	bcc.s	NotBCDCopy
	add.l	#$010000,d4
NotBCDCopy:	unpk	d5,d4,#"00"
	rol.l	#8,d4
	dbra	d2,CheckxxxMOD
	move.l	a2,d1
	move.l	#600-1080,d2
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq.s	GetNumChannelsErr
	moveq	#64,d0
	lsl.l	#4,d0
	moveq	#MEMF_PUBLIC,d1
	move.l	a6,a5
	jsr	_LVOAllocPMem(a6)
	move.l	d0,d5
	beq.s	GetNumChannelsErr
	move.l	#"ST15",d4
	bsr	CheckNoHeaderModule
	move.l	a2,d1
	moveq	#(1080-600)/4,d2
	lsl.l	#2,d2
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq.s	GetNumChannelsError
	move.l	#"ST31",d4
	bsr	CheckNoHeaderModule
GetNumChannelsError:	move.l	d5,a1
	moveq	#64,d0
	lsl.l	#4,d0
	jsr	_LVOFreePMem(a6)
GetNumChannelsErr:	moveq	#0,d0
GetNumChannelsDone:	move.l	d0,d5
	beq	NotCheckForWOW
	cmp.l	#"M.K.",d4
	bne	NotCheckForWOW
	move.l	a2,d1
	moveq	#0,d2
	moveq	#OFFSET_END,d3
	jsr	_LVOCSeek(a6)
	move.l	d0,d2
	addq.l	#1,d0
	beq.s	GetNumChannelsErr
	move.l	a2,d1
	move.l	#1080,d5
	sub.l	d5,d2
	moveq	#OFFSET_BEGINNING,d3
	jsr	_LVOCSeek(a6)
	move.l	d5,d3
	move.l	d0,d5
	addq.l	#1,d0
	beq.s	GetNumChannelsErr
	sub.l	d3,d5
	move.l	d3,d0
	jsr	_LVOAllocPMem(a6)
	move.l	d0,d2
	beq.s	GetNumChannelsErr
	move.l	a2,d1
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	beq.s	WOWReadOk
	move.l	d3,d0
	move.l	d2,a1
	jsr	_LVOFreePMem(a6)
	bra.s	GetNumChannelsErr
WOWReadOk:	moveq	#31-1,d0
	move.l	d2,a0
	lea	4.w,a1
WOWCountSmp:	moveq	#0,d1
	move.w	20+22(a0),d1
	add.l	d1,d1
	add.l	d1,a1
	lea	30(a0),a0
	dbra	d0,WOWCountSmp
	moveq	#128-1,d0
	moveq	#0,d6
	lea	20+2(a0),a0
CheckWOWLoop:	move.l	d6,d3
	subq.w	#1,d0
CheckWOWLoop2:	move.b	(a0)+,d6
	cmp.b	d3,d6
	bgt.s	CheckWOWLoop
	dbra	d0,CheckWOWLoop2
	addq.b	#1,d3
	moveq	#11,d6
	lsl.l	d6,d3
	add.l	a1,d3
	cmp.l	d3,d5
	beq.s	IsWOW
	moveq	#4,d5
	bra.s	CheckWOWDone
IsWOW:	moveq	#8,d5
	move.l	#"WOW8",d4
CheckWOWDone:	move.l	#1080,d0
	move.l	d2,a1
	jsr	_LVOFreePMem(a6)
NotCheckForWOW:	addq.l	#4,sp
	move.l	d5,d0
GetNoHeaderInvType:	rts
CheckNoHeaderModule:	move.l	d5,d2
	moveq	#64,d3
	lsl.l	#4,d3
	move.l	a2,d1
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	GetNoHeaderErr
	move.l	a2,d1
	move.l	d3,d2
	neg.l	d2
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq.s	GetNoHeaderErr
	moveq	#0,d0
	not.b	d0
	move.l	d5,a1
	move.l	d4,d2
CheckNextSTPattern:	lea	PeriodTable(pc),a0
CheckValidSTPattern:	move.l	(a1)+,d1
	swap	d1
	and.w	#$fff,d1
	beq.s	CheckSTPatternOk
CheckPerTableLoop:	move.w	(a0)+,d3
	beq.s	GetNoHeaderInvType
	cmp.w	d1,d3
	bne.s	CheckPerTableLoop
CheckSTPatternOk:	dbra	d0,CheckNextSTPattern
	moveq	#64,d0
	lsl.l	#4,d0
	move.l	d5,a1
	jsr	_LVOFreePMem(a6)
	addq.l	#4,sp
	moveq	#4,d0
	bra	GetNumChannelsDone
GetNoHeaderErr:	addq.l	#4,sp
	bra	GetNumChannelsError
PeriodTable:	dc.w	4064,3840,3624	;	A-0, A#0, B-0
	dc.w	3424,3232,3048,2880,2712,2560,2416,2280,2152,2032,1920,1812 ; C-1 - B-1
	dc.w	1712,1616,1524,1440,1356,1280,1208,1140,1076,1016,960,906 ; C-2 - B-2
	dc.w	856,808,762,720,678,640,604,570,538,508,480,453 ; C-3 - B-3
	dc.w	428,404,381,360,339,320,302,285,269,254,240,226 ; C-4 - B-4
	dc.w	214,202,190,180,170,160,151,143,135,127,120,113 ; C-5 - B-5
	dc.w	107,101,95,90,85,80,75,71,67,63,60,56 ; C-6 - B-6
	dc.w	53,50,47,45,42,40,37,35,33,31,30,28,0 ; C-7 - B-7

	cnop	0,4

MODCheck:	dc.b	'TDZ1',0,1
	dc.b	'1CHN',0,1
	dc.b	'TDZ2',0,2
	dc.b	'2CHN',0,2
	dc.b	'TDZ3',0,3
	dc.b	'3CHN',0,3
	dc.b	'TDZ4',0,4
	dc.b	'4CHN',0,4
	dc.b	'M.K.',0,4
	dc.b	'M!K!',0,4
	dc.b	'M&K!',0,4
	dc.b	'EMW3',0,4
	dc.b	'FLT4',0,4
	dc.b	'TDZ5',0,5
	dc.b	'5CHN',0,5
	dc.b	'TDZ6',0,6
	dc.b	'6CHN',0,6
	dc.b	'TDZ7',0,7
	dc.b	'7CHN',0,7
	dc.b	'TDZ8',0,8
	dc.b	'8CHN',0,8
	dc.b	'FLT8',0,8
	dc.b	'TDZ9',0,9
	dc.b	'9CHN',0,9
	dc.l	0

ExtTrackLibBase:	dc.l	0

LoadFlags:	dc.w	8
	dc.w	LoadFlagSize
	dc.l	LoadText0
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText1
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	LoadText2
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	LoadText3
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	LoadText4
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText5
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	LoadText6
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText7
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
LoadText0:	dc.b	'Convert volumes',0
LoadText1:	dc.b	'Fast volume slides',0
LoadText2:	dc.b	'8xx is set panning',0
LoadText3:	dc.b	'Fxx is always tempo',0
LoadText4:	dc.b	"Check NoiseTracker vibrato",0
LoadText5:	dc.b	'DMP-like panning (L,R,L,R)',0
LoadText6:	dc.b	'Remove portamento 0 effects',0
LoadText7:	dc.b	'Remove volume slide 0 effects',0
LoadFlagSize:	equ	*-LoadFlags
LoadDescript:	dc.b	'ProTracker Style Module (MOD)',0
