*********************************************************
***   TuComposer External Module Library for S3M      ***
***         1997 by The united Coders (TuC)          ***
***                Main code: Basty/TuC               ***
***  This is a S3M module loader. It loads the great  ***
***  ScreamTracker ]I[ modules from the Future Crew.  ***
*********************************************************

	IFND	_G2
	MACHINE	MC68020
	OPT NODEBUG,NOLINE
	ENDC

	include	"exec/types.i"
	include	"exec/execbase.i"
	include	"exec/exec_lib.i"
	include	"exec/initializers.i"
	include	"exec/memory.i"
	include	"exec/resident.i"
	include	"exec/libraries.i"
	include	"libraries/dos_lib.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/module.i"
	include	"tucomposer/song.i"
	include	"tucomposer/position.i"
	include	"tucomposer/track.i"
	include	"tucomposer/instr.i"
	include	"tucomposer/sample.i"
	include	"tucomposer/external/external.i"
	include	"tucomposer/external/external_lib.i"
	include	"tucomposer/external/module.i"
	include	"tucomposer/external/module_lib.i"

	moveq	#-1,d0
	rts
ResidentStruct:	dc.w	RTC_MATCHWORD
	dc.l	ResidentStruct
	dc.l	0
	dc.b	RTF_AUTOINIT
	dc.b	EXTLIB_MODULE_VERSION
	dc.b	NT_LIBRARY
	dc.b	0
	dc.l	LibName
	dc.l	LibID
	dc.l	Init
LibName:	dc.b	's3m.library',0
LibID:	dc.b	'TuComposer External Module Loader Version 1.00 (v31) for S3M (68020+, OS2.0+) (27 May 97) by Basty/TuC.',0
TuComposerName:	dc.b	'tucomposer.library',0
	even
Init:	dc.l	modl_SIZEOF
	dc.l	FuncTab
	dc.l	DataTab
	dc.l	PrepareLibrary

FuncTab:	dc.w	-1
	dc.w	Open-FuncTab
	dc.w	Close-FuncTab
	dc.w	Expunge-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalInitialize-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalModuleIdentify-FuncTab
	dc.w	ExternalModuleLoad-FuncTab
	dc.w	ExternalModuleSave-FuncTab
	dc.w	ExternalModuleGetInfo-FuncTab
	dc.w	ExternalModuleGetNums-FuncTab
	dc.w	-1

DataTab:	INITLONG	LN_NAME,LibName
	INITBYTE	LIB_FLAGS,LIBF_CHANGED|LIBF_SUMUSED
	INITWORD	LIB_VERSION,EXTLIB_MODULE_VERSION
	INITWORD	LIB_REVISION,EXTLIB_REVISION
	INITLONG	LIB_IDSTRING,LibID
	dc.l	0

PrepareLibrary:	btst	#AFB_68020,AttnFlags+1(a6)	
	beq.s	ExtLib
	cmp.w	#37,LIB_VERSION(a6)
	blt.s	ExtLib
	move.l	a2,-(sp)
	move.l	d0,a2
	move.l	a0,extb_SegList(a2)
	moveq	#31,d0
	lea	TuComposerName(pc),a1
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,extb_TuComposerBase(a2)
	beq.s	NoTuCLib
	lea	ExtModuleLibBase(pc),a0
	move.l	a2,(a0)
	move.l	a2,d0
NoTuCLib:	move.l	(sp)+,a2
	rts
Open:	addq.w	#1,LIB_OPENCNT(a6)
	move.l	a6,d0
	rts
Close:	subq.w	#1,LIB_OPENCNT(a6)
	bne.s	ExtLib
	btst	#LIBB_DELEXP,LIB_FLAGS(a6)
	bne.s	Expunge
ExtLib:	moveq	#0,d0
	rts
Expunge:	bset	#LIBB_DELEXP,LIB_FLAGS(a6)
	tst.w	LIB_OPENCNT(a6)
	bne.s	ExtLib
	movem.l	d2/a5-a6,-(sp)
	move.l	extb_ExtLibList(a6),d0
	beq.s	NoExtLibList
	move.l	d0,a0
	clr.l	extl_LibBase(a0)
NoExtLibList:	move.l	extb_TuComposerBase(a6),a1
	move.l	a6,a5
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
	move.l	extb_SegList(a5),d2
	move.l	a5,a1
	jsr	_LVORemove(a6)
	move.l	a5,a1
	moveq	#0,d0
	moveq	#0,d1
	move.w	LIB_NEGSIZE(a5),d1
	sub.l	d1,a1
	move.w	LIB_POSSIZE(a5),d0
	add.l	d1,d0
	jsr	_LVOFreeMem(a6)
	move.l	d2,d0
	movem.l	(sp)+,d2/a5-a6
	rts
;	INPUT
;	A0.L	=	APTR to track external list structure to be initialized
;	OUTPUT
;	D0.L	=	What type of external library is it or NULL if error
ExternalInitialize:	move.l	extb_TuComposerBase(a6),a1
	movem.l	a2/a6,-(sp)
	move.l	a0,d0
	beq.s	ExternalInitDone
	move.l	a1,a6
	move.b	#EXTLF_Loader|EXTLF_Saver,extl_Flags(a0)
	move.l	a0,a2
	lea	extl_Descriptor(a0),a0
	lea	LoadDescript(pc),a1
	jsr	_LVOSetString(a6)
	tst.l	d0
	beq.s	ExternalInitDone
	lea	LoadFlags(pc),a0
	jsr	_LVOAllocFlagStr(a6)
	move.l	d0,extl_LoadFlagStr(a2)
	beq.s	ExternalInitDone
	moveq	#EXTTYPE_MODULE,d0
ExternalInitDone:	movem.l	(sp)+,a2/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	If failed NULL else any non-zero value
ExternalModuleIdentify:	movem.l	d2-d3/a6,-(sp)
	move.l	a0,d1
	link	a5,#-48
	move.l	sp,d2
	moveq	#48,d3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalModuleIdDone
	cmp.l	#"SCRM",44(sp)
	beq.s	ExternalModuleIdOk
ExternalModuleIdDone:	moveq	#0,d0
ExternalModuleIdOk:	unlk	a5
	movem.l	(sp)+,d2-d3/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be loaded
;	A1.L	=	APTR to target module structure or NULL to create a new one
;	A2.L	=	APTR to loading flag pass structure (Loader specific)
;	D0.L	=	Number of module of be loaded (NULL is the first)
;	OUTPUT
;	D0.L	=	APTR to module structure where loaded track data is
ExternalModuleLoad:	movem.l	d2-d7/a2-a6,-(sp)
	lea	-364(sp),sp
	move.l	sp,d2
	moveq	#96,d3
	moveq	#3,d0
	moveq	#0,d1
	moveq	#-1,d4
	movem.l	d1/d4,356(sp)
	moveq	#0,d7
CreateBitTable:	tst.l	(a2)+
	beq.s	BitNotSet
	bset	d1,d7
BitNotSet:	addq.b	#1,d1
	dbra	d0,CreateBitTable
	move.l	a0,d1
	move.l	d1,a2
	move.l	a1,a3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadErr4
	cmp.w	#$0013,40(sp)
	bne.s	NotBuggyST3
	bset	#6,38(sp)
NotBuggyST3:	lea	96(sp),a0
	move.l	(a2),d1
	move.l	a0,d2
	move.l	a6,a5
	move.l	tcb_DOSBase(a5),a6
	jsr	_LVOExamineFH(a6)
	moveq	#32,d0
	btst	#3,d7
	bne.s	UseAdLibChannels
	moveq	#16,d0
UseAdLibChannels:	lea	64(sp,d0.w),a0
DetectChannels:	tst.b	-(a0)
	bpl.s	ChannelsFound
	subq.w	#1,d0
	bne.s	DetectChannels
	bra	ExternalLoadErr4
ChannelsFound:	move.l	d0,192(sp)
NotDetectChannels:	move.w	32(sp),d0
	rol.w	#8,d0
	move.w	d0,32(sp)
	mulu.w	192+2(sp),d0
	add.l	d0,d0
	move.l	#MEMF_PUBLIC|MEMF_CLEAR,d1
	move.l	4.w,a6
	jsr	_LVOAllocVec(a6)
	move.l	a5,a6
	move.l	d0,196(sp)
	beq	ExternalLoadErr4
	move.l	192(sp),d0
	jsr	_LVOAllocTCModule(a6)
	move.l	d0,d1
	beq	ExternalLoadErr3
	move.l	d0,a4
	lea	tcm_Name(a4),a0
	move.l	sp,a1
	clr.b	28(a1)
	jsr	_LVOSetString(a6)
	lea	tcm_BeginDate(a4),a0
	lea	96+fib_DateStamp(sp),a1
	jsr	_LVOStamp2Date(a6)
	lea	tcm_EndDate(a4),a0
	lea	96+fib_DateStamp(sp),a1
	jsr	_LVOStamp2Date(a6)
	move.l	192(sp),d0
	moveq	#1,d1
	moveq	#1,d2
	jsr	_LVOAllocSong(a6)
	move.l	d0,d1
	beq	ExternalLoadErr2
	move.l	d0,a1
	moveq	#0,d0
	tst.b	51(sp)
	bmi.s	StereoS3M
	moveq	#TCSOF_Mono,d0
StereoS3M:	move.b	d0,tcso_Flags(a1)
	moveq	#TCSOCF_Sync|TCSOCF_GlobalLoop|TCSOCF_GlobalNewOnly,d0
	btst	#2,d7
	bne.s	UseOldVolumes
	addq.b	#TCSOCF_OldVolumes,d0
UseOldVolumes:	btst	#4,38(sp)
	beq.s	NoAmigaLimits
	move.w	#4181,358(sp)
	move.l	#31574,360(sp)
NoAmigaLimits:	move.b	d0,tcso_CompFlags(a1)
	lea	48(sp),a0
	move.b	(a0)+,d0
	btst	#2,d7
	beq.s	LoadGlobalVolume
	lsl.b	#2,d0
	bcc.s	LoadGlobalVolume
	moveq	#-1,d0
LoadGlobalVolume:	move.b	d0,tcso_GlobalVolume(a1)
	move.b	(a0)+,tcso_Frames+1(a1)
	move.b	(a0)+,tcso_BPMSpeed+1(a1)
	move.l	a4,a0
	jsr	_LVOAddSong(a6)
	lea	([tcm_SongList.w,a4],tcso_Name.w),a0
	move.l	tcm_Name(a4),a1
	jsr	_LVOSetString(a6)
	move.l	tcm_SongList(a4),a1
	lea	([tcm_SongList.w,a4],tcso_BeginDate.w),a0
	lea	96+fib_DateStamp(sp),a1
	jsr	_LVOStamp2Date(a6)
	lea	([tcm_SongList.w,a4],tcso_EndDate.w),a0
	lea	96+fib_DateStamp(sp),a1
	jsr	_LVOStamp2Date(a6)
	move.w	32(sp),d3
	move.l	d3,d0
	moveq	#MEMF_PUBLIC,d1
	move.l	4.w,a6
	jsr	_LVOAllocVec(a6)
	move.l	d0,d2
	beq	ExternalLoadErr2
	move.l	a2,d1
	move.l	a5,a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	beq.s	ReadOrderOk
	move.l	d2,a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
	move.l	a5,a6
	bra	ExternalLoadErr2
ReadOrderOk:	move.w	d3,d0
	movem.l	192(sp),d6/a1
	move.w	36(sp),d4
	rol.w	#8,d4
	move.w	d4,36(sp)
	moveq	#0,d5
	move.l	d2,a0
GetTrackReMapNums:	moveq	#0,d1
	move.b	(a0)+,d1
	cmp.b	#$fe,d1
	blo.s	NotSpecialOrder
	ext.w	d1
	move.w	d6,d3
CopySpecialOrderLoop:	move.w	d1,(a1)+
	subq.w	#1,d3
	bne.s	CopySpecialOrderLoop
	bra.s	NextOrderEntry
NotSpecialOrder:	cmp.w	d4,d1
	blo.s	NotMoreOrders
	move.w	d1,d4
	addq.w	#1,d4
NotMoreOrders:	move.w	d6,d3
	mulu.w	d3,d1
GetTrackReMapLoop:	move.w	d1,(a1)+
	addq.w	#1,d1
	subq.w	#1,d3
	bne.s	GetTrackReMapLoop
NextOrderEntry:	subq.w	#1,d0
	bne.s	GetTrackReMapNums
	move.l	d2,a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
	move.w	34(sp),d0
	rol.w	#8,d0
	move.w	d0,34(sp)
	bne.s	InvalidVal
	moveq	#1,d0
InvalidVal:	add.l	d0,d0
	moveq	#MEMF_PUBLIC,d1
	jsr	_LVOAllocVec(a6)
	move.l	d0,200(sp)
	beq	ExternalLoadErr2
	moveq	#0,d0
	move.w	36(sp),d0
	bne.s	InvalidVal2
	moveq	#1,d0
InvalidVal2:	add.l	d0,d0
	moveq	#MEMF_PUBLIC,d1
	jsr	_LVOAllocVec(a6)
	move.l	d0,204(sp)
	beq	ExternalLoadErr16
	move.l	a5,a6
	move.l	a2,d1
	move.l	200(sp),d2
	move.w	34(sp),d3
	add.l	d3,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadErr15
	move.l	a2,d1
	move.l	204(sp),d2
	moveq	#0,d3
	move.w	36(sp),d3
	add.l	d3,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadErr15
	move.l	a2,d1
	lea	96(sp),a0
	move.l	a0,d2
	moveq	#32,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadErr15
	move.l	a4,228(sp)
DecrunchPatternLoop:	move.w	#$4000,(sp)
	clr.l	236(sp)
	cmp.w	36(sp),d5
	bhs.s	LongEmptyPatt
	moveq	#0,d2
	move.l	204(sp),a0
	move.w	(a0,d5.w*2),d2
	beq.s	LongEmptyPatt
	move.l	d2,236(sp)
	move.l	a2,d1
	rol.w	#8,d2
	lsl.l	#4,d2
	moveq	#OFFSET_BEGINNING,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalLoadErr15
	move.l	a2,d1
	move.l	sp,d2
	moveq	#2,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadErr15
LongEmptyPatt:	moveq	#0,d3
	move.w	(sp),d3
	rol.w	#8,d3
	move.l	d3,d0
	move.l	#MEMF_PUBLIC|MEMF_CLEAR,d1
DoPatternAlloc:	move.l	4.w,a6
	jsr	_LVOAllocVec(a6)
	move.l	d0,d2
	beq	ExternalLoadErr15
	move.l	a5,a6
	tst.l	236(sp)
	beq.s	DePackPattern
	move.l	a2,d1
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadError
DePackPattern:	move.l	192(sp),d3
AllocTrackLoop:	moveq	#64,d0
	jsr	_LVOAllocTrack(a6)
	move.l	d0,d1
	beq	ExternalLoadError
	move.l	d0,a1
	move.l	tcm_SongList(a4),a0
	move.b	#TCTCF_Slide|TCTCF_VolSlide|TCTCF_VolPitch,tct_CompFlags(a1)
	jsr	_LVOAddTrack(a6)
	subq.w	#1,d3
	bne.s	AllocTrackLoop
	movem.l	d4-d6/a2-a4/a6,208(sp)
	moveq	#64-1,d4
	moveq	#0,d5
	move.l	d2,a2
GetNextRow:	move.l	192(sp),d1
	move.l	228(sp),a4
	move.l	tcm_SongList(a4),a3
	lea	tcso_TrackList+MLH_TAIL(a3),a3
FindCorrectTrack:	move.l	MLN_PRED(a3),a3
	dbra	d1,FindCorrectTrack
	move.l	#$ff00ff00,(sp)
	clr.b	4(sp)
	move.b	(a2)+,d0
	bne.s	NotNextRow
	addq.l	#tctd_NextRow/2,d5
	addq.l	#tctd_NextRow/2,d5
	dbra	d4,GetNextRow
	bra	DecrunchDone
NotNextRow:	btst	#5,d0
	beq.s	NotNote
	move.w	(a2)+,(sp)
NotNote:	btst	#6,d0
	beq.s	NotVolCol
	move.b	(a2)+,2(sp)
NotVolCol:	tst.b	d0
	bpl.s	NotFX
	move.w	(a2)+,3(sp)
NotFX:	and.w	#31,d0
FindChannel:	move.l	(a3),a3
	tst.l	(a3)
	beq.s	GetNextRow
	dbra	d0,FindChannel
	move.l	tct_Data(a3),a4
	add.l	d5,a4
	move.l	sp,a1
	moveq	#0,d0
	move.b	(a1)+,d0
	addq.b	#1,d0
	beq.s	NoteDone
	cmp.b	#-1,d0
	beq.s	NoteDone
	lsl.w	#4,d0
	lsr.b	#4,d0
NoteDone:	move.w	d0,(a4)+
	moveq	#0,d0
	move.b	(a1)+,d0
	move.w	d0,(a4)+
	moveq	#0,d6
	move.b	(a1)+,d6
	cmp.b	#-1,d6
	beq.s	NoVolumeColumn
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d3
	beq.s	NoVolumeColumn
	btst	#2,d7
	beq.s	NotVolFF
	lsl.b	#2,d6
	bcc.s	NotVolFF
	moveq	#-1,d6
NotVolFF:	lsl.w	#8,d6
	move.l	d3,a1
	move.b	#FX_SET_VOLUME,tcte_EffectByte(a1)
	move.w	d6,tcte_DataWord(a1)
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
NoVolumeColumn:	moveq	#0,d0
	lea	3(sp),a1
	move.b	(a1)+,d0
	beq.s	NoEffect
	moveq	#0,d6
	move.b	(a1)+,d6
	cmp.b	#25,d0
	bcc.s	NoEffect
	cmp.b	#15,d0
	bne.s	NotSmpOffset
	tst.w	tctd_Octave-tctd_Effects(a4)
	beq.s	NoEffect
NotSmpOffset:	movem.w	ProcessFXTable-4(pc,d0.w*4),d0-d1
	lea	ProcessFXTable(pc),a0
	add.l	d1,a0
	move.w	d6,d1
	jsr	(a0)
	move.w	d6,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	NoEffect
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
NoEffect:	bra	GetNextRow
ProcessFXTable:	dc.w	FX_SET_TEMPO,SetTempo-ProcessFXTable
	dc.w	FX_POS_JUMP,PosJump-ProcessFXTable
	dc.w	FX_PATT_BREAK,PosJump-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,VolumeSlide-ProcessFXTable
	dc.w	FX_PORTA_DOWN,Porta-ProcessFXTable
	dc.w	FX_PORTA_UP,Porta-ProcessFXTable
	dc.w	FX_TONE_PORTA,TonePorta-ProcessFXTable
	dc.w	FX_VIBRATO,Arpeggio-ProcessFXTable
	dc.w	FX_TREMOR,Tremor-ProcessFXTable
	dc.w	FX_ARPEGGIO,Arpeggio-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,VibFade-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,ToneFade-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	FX_SMP_OFF_LOW,TonePorta-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	FX_MULTI_RETRIG,MultiRetrig-ProcessFXTable
	dc.w	FX_TREMOLO,Tremolo-ProcessFXTable
	dc.w	0,Extended-ProcessFXTable
	dc.w	FX_SET_SPEED,PosJump-ProcessFXTable
	dc.w	FX_FINE_VIBRATO,Arpeggio-ProcessFXTable
	dc.w	FX_SET_G_VOLUME,SetVolume-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	USER_EFFECTS,PosJump-ProcessFXTable
DecrunchDone:	move.l	d2,a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
	movem.l	208(sp),d4-d6/a2-a4/a6
	move.l	tcm_SongList(a4),a4
	lea	tcso_TrackList(a4),a2
CmpMainLoop:	move.l	(a2),a2
	tst.l	(a2)
	beq.s	CmpAllDone
	lea	tcso_TrackList+MLH_TAIL(a4),a3
	move.l	192(sp),d0
FindPatternLoop:	move.l	MLN_PRED(a3),a3
	tst.l	MLN_PRED(a3)
	beq.s	CompareTracksLoop
	dbra	d0,FindPatternLoop
CompareTracksLoop:	move.l	(a3),a3
	tst.l	(a3)
	beq.s	CmpMainLoop
	cmp.l	a3,a2
	beq.s	CompareTracksLoop
	move.l	a3,a0
	move.l	a2,a1
	jsr	_LVOCmpTracks(a6)
	tst.l	d0
	bne.s	CompareTracksLoop
	move.l	a4,a0
	move.l	a3,a1
	jsr	_LVOGetTrackNum(a6)
	subq.w	#1,d0
	move.w	d0,d2
	move.l	a3,a0
	jsr	_LVOFreeTrack(a6)
	move.l	a4,a0
	move.l	a2,a1
	jsr	_LVOGetTrackNum(a6)
	subq.w	#1,d0
	move.w	32(sp),d1
	mulu.w	192+2(sp),d1
	move.l	196(sp),a0
ReMapOrderList:	cmp.w	#$fffe,(a0)
	bhs.s	ReMapOrderNotSub
	cmp.w	(a0),d2
	bne.s	ReMapOrderEqual
	move.w	d0,(a0)
ReMapOrderEqual:	bhs.s	ReMapOrderNotSub
	subq.w	#1,(a0)
ReMapOrderNotSub:	addq.l	#2,a0
	subq.l	#1,d1
	bne.s	ReMapOrderList
	move.l	MLN_PRED(a2),a2
	bra.s	CmpMainLoop
CmpAllDone:	movem.l	220(sp),a2-a4
	addq.w	#1,d5
	cmp.w	d5,d4
	bne	DecrunchPatternLoop
	move.w	32(sp),d2
	moveq	#0,d3
	movem.l	192(sp),d4/a2
	move.w	d4,d6
	subq.l	#1,d4
	move.l	tcm_SongList(a4),a4
	move.l	tcso_Position(a4),a3
SetOrderList:	moveq	#0,d5
SetPositions:	jsr	_LVOAllocPositionList(a6)
	move.l	d0,d1
	beq	ExternalLoadErr1
	move.l	d0,a1
	moveq	#0,d0
	move.l	a3,a0
	jsr	_LVOAddPositionList(a6)
	move.w	d5,d1
	mulu.w	d6,d1
	moveq	#0,d0
	move.w	(a2,d1.l*2),d0
	cmp.w	#$fffe,d0
	beq.s	NotSetNextOrder
	cmp.w	#$ffff,d0
	bne.s	NotSongEnd
	move.l	MLH_TAILPRED(a3),a0
	move.b	#TCOLF_EndOrder,tcol_Flags(a0)
	bra.s	NotSetNextOrder
NotSongEnd:	addq.l	#1,d0
	move.l	a4,a0
	jsr	_LVOGetTrackAddr(a6)
	move.l	MLH_TAILPRED(a3),a0
	move.l	d0,tcol_Track(a0)
NotSetNextOrder:	move.l	MLN_PRED(a0),a1
	tst.l	MLN_PRED(a1)
	beq.s	NotSetPrevOrder
	move.l	a1,tcol_PrevPos(a0)
	move.l	a0,tcol_NextPos(a1)
NotSetPrevOrder:	addq.w	#1,d5
	cmp.w	d5,d2
	bne.s	SetPositions
	move.l	MLH_TAILPRED(a3),a0
	move.l	(a3),a1
	move.l	a1,tcol_PrevPos(a1)
	move.l	a1,tcol_NextPos(a0)
	lea	64(sp,d3.w),a0
	move.b	(a0),d0
	move.b	#$80,d1
	cmp.b	#255,d0
	beq.s	GetLRLoadPanInfoOk
	bclr	#7,d0
	cmp.b	#16,d0
	bcc.s	GetLRLoadPanInfoOk
	st	d1
	cmp.b	#8,d0
	bcc.s	GetLRLoadPanInfoOk
	moveq	#0,d1
GetLRLoadPanInfoOk:	cmp.b	#$80,d1
	beq.s	NotUseLoadDefPan
	cmp.b	#252,53(sp)
	bne.s	NotUseLoadDefPan
	move.b	d1,d0
	moveq	#$33,d1
	addq.b	#1,d0
	bne.s	DefLoadPanningOk
	not.b	d1
DefLoadPanningOk:	move.b	32(a0),d0
	btst	#5,d0
	beq.s	NotUseLoadDefPan
	and.b	#$f,d0
	move.b	d0,d1
	lsl.b	#4,d0
	or.b	d0,d1
NotUseLoadDefPan:	move.b	d1,tco_Panning(a3)
	move.b	64(sp,d3.w),d0
	bclr	#7,d0
	beq.s	NotMuted
	move.b	#TCOF_Muted,tco_Flags(a3)
NotMuted:	btst	#2,d7
	bne.s	NotOrderMaxVol
	move.b	#64,tco_Volume(a3)
NotOrderMaxVol:	cmp.b	#$ff,64(sp,d3.w)
	bne.s	NotChMuted
	move.b	#TCOF_Muted,tco_Flags(a3)
NotChMuted:	lea	tco_NextOrderx(a3),a3
	addq.l	#2,a2
	addq.w	#1,d3
	dbra	d4,SetOrderList
	movem.l	220(sp),a2-a4
	moveq	#0,d3
	clr.l	236(sp)
	move.l	#$80000100,d2
	moveq	#DEFAULT_ENVNODES,d4
	btst	#1,d7
	beq.s	NoVibratoEnvelopes
	moveq	#64,d0
	moveq	#ENVL_SINE,d1
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,236(sp)
	beq	ExternalLoadErr2
	move.l	d0,a1
	bset	#TCIEB_Loop,tcie_Flags+1(a1)
	move.w	tcie_NumPoints(a1),tcie_LoopEnd(a1)
	subq.w	#1,tcie_LoopEnd(a1)
	move.l	a4,a0
	jsr	_LVOAddEnvelope(a6)
	moveq	#64,d0
	moveq	#ENVL_RAMP,d1
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,d1
	beq	ExternalLoadErr2
	move.l	d0,a1
	bset	#TCIEB_Loop,tcie_Flags+1(a1)
	move.w	tcie_NumPoints(a1),tcie_LoopEnd(a1)
	subq.w	#1,tcie_LoopEnd(a1)
	move.l	a4,a0
	jsr	_LVOAddEnvelope(a6)
	moveq	#64,d0
	moveq	#ENVL_SQUARE,d1
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,d1
	beq	ExternalLoadErr2
	move.l	d0,a1
	bset	#TCIEB_Loop,tcie_Flags+1(a1)
	move.w	tcie_NumPoints(a1),tcie_LoopEnd(a1)
	subq.w	#1,tcie_LoopEnd(a1)
	move.l	a4,a0
	jsr	_LVOAddEnvelope(a6)
NoVibratoEnvelopes:	move.w	34(sp),d5
	beq	NoSamples
	subq.w	#1,d5
	moveq	#0,d6
	move.w	42(sp),80(sp)
LoadSmpLoop:	move.l	200(sp),a0
	move.l	a2,d1
	moveq	#0,d2
	move.w	(a0,d6.w*2),d2
	rol.w	#8,d2
	lsl.l	#4,d2
	moveq	#OFFSET_BEGINNING,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalLoadErr2
	move.l	a2,d1
	move.l	sp,d2
	moveq	#80,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadErr2
	moveq	#0,d0
	jsr	_LVOAllocInstr(a6)
	move.l	d0,d1
	beq	ExternalLoadErr2
	move.l	d0,a1
	move.l	a4,a0
	move.l	a1,a3
	jsr	_LVOAddInstr(a6)
	move.l	236(sp),d0
	lea	tci_VibratoEnvelope(a3),a0
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)
	moveq	#0,d4
	btst	#0,d7
	beq.s	SampleOk
	cmp.l	#"SCRS",76(sp)
	bne	NotLoadSmpType
	move.l	16(sp),d4
	rol.w	#8,d4
	swap	d4
	rol.w	#8,d4
	btst	#2,31(sp)
	beq.s	SampleOk
	add.l	d4,d4
SampleOk:	lea	tci_FileName(a3),a0
	move.l	sp,a1
	addq.l	#1,a1
	moveq	#0,d2
	move.b	13(sp),d2
	swap	d2
	move.w	14(sp),d2
	rol.w	#8,d2
	lsl.l	#4,d2
	clr.b	12(a1)
	jsr	_LVOSetString(a6)
	lea	tci_Name(a3),a0
	lea	48(sp),a1
	clr.b	28(a1)
	jsr	_LVOSetString(a6)
	move.l	d4,d0
	sub.l	a0,a0
	jsr	_LVOAllocSample(a6)
	move.l	d0,d3
	beq	ExternalLoadErr2
	move.l	d3,a1
	move.l	a3,a0
	jsr	_LVOAddSample(a6)
	move.l	d3,a3
	lea	tcs_FileName(a3),a0
	move.l	sp,a1
	addq.l	#1,a1
	jsr	_LVOSetString(a6)
	lea	tcs_Name(a3),a0
	lea	48(sp),a1
	jsr	_LVOSetString(a6)
	move.l	d2,tcs_Synth(a3)
	move.b	28(sp),d0
	btst	#2,d7
	beq.s	NotConvSmpLoadVol
	lsl.b	#2,d0
	bcc.s	NotConvSmpLoadVol
	moveq	#-1,d0
NotConvSmpLoadVol:	move.b	d0,tcs_Volume(a3)
	moveq	#0,d1
	btst	#0,31(sp)
	beq.s	NotUseLoop
	addq.b	#TCSF_Loop,d1
NotUseLoop:	move.b	d1,tcs_Flags(a3)
	movem.l	20(sp),d0-d3
	rol.w	#8,d0
	rol.w	#8,d1
	rol.w	#8,d3
	swap	d0
	swap	d1
	swap	d3
	rol.w	#8,d0
	rol.w	#8,d1
	rol.w	#8,d3
	sub.l	d0,d1
	movem.l	d0-d1,tcs_Repeat(a3)
	move.l	d3,tcs_Rate(a3)
	movem.l	356(sp),d0-d1
	movem.l	d0-d1,tcs_LowerRateLimit(a3)
	move.l	a2,d1
	move.l	tcs_Synth(a3),d2
	clr.l	tcs_Synth(a3)
	tst.l	tcs_Length(a3)
	beq.s	SignedSamples
	moveq	#OFFSET_BEGINNING,d3
	jsr	_LVOCSeek(a6)
	btst	#2,31(sp)
	beq.s	Not16BitSample
	moveq	#16,d0
	moveq	#CBF_ChangeOnly,d1
	move.l	a3,a0
	jsr	_LVOConvertBits(a6)
Not16BitSample:	move.l	a2,d1
	movem.l	tcs_Data(a3),d2-d3
	jsr	_LVOCRead(a6)
	addq.l	#1,d0
	beq	ExternalLoadErr2
	cmp.b	#16,tcs_BitDepth(a3)
	bne.s	NotIntelOrder
	move.l	a3,a0
	jsr	_LVOConvertWord(a6)
NotIntelOrder:	move.l	a3,a0
	cmp.w	#$100,80(sp)
	beq.s	SignedSamples
	jsr	_LVOConvertSigned(a6)
SignedSamples:	move.b	#TCSCF_StartTonePorta,tcs_CompFlags(a3)
NotLoadSmpType:	addq.w	#1,d6
	dbra	d5,LoadSmpLoop
NoSamples:	movem.l	220(sp),a2-a4
	move.l	tcm_SongList(a4),a0
	lea	tcso_TrackList(a0),a0
	moveq	#0,d0
	move.l	(a0),a0
	tst.l	(a0)
	beq.s	ScanTrackNullDone
	move.l	a0,a1
	move.w	tct_Length(a1),d1
ScanTrackNullLoop:	addq.l	#1,d0
	move.l	(a0),a0
	tst.l	(a0)
	beq.s	ScanTrackNullDone
	cmp.w	tct_Length(a0),d1
	bne.s	ScanTrackNullLoop
	move.w	d1,d2
	move.l	tct_Data(a0),a2
CheckTrackEmptyLoop:	tst.l	(a2)+
	bne.s	ScanTrackNullLoop
	move.l	(a2),a2
	tst.l	(a2)
	bne.s	ScanTrackNullLoop
	addq.l	#tctd_Effects+MLH_TAIL,a2
	dbra	d2,CheckTrackEmptyLoop
	move.l	a0,a2
	jsr	_LVODeleteTrack(a6)
	move.l	tcm_SongList(a4),a0
	move.l	a2,a1
	sub.l	a2,a2
	jsr	_LVOInsertTrack(a6)
ScanTrackNullDone:	move.l	tcm_SongList(a4),a0
	jsr	_LVOGetOptimalChannels(a6)
	move.l	tcm_SongList(a4),a0
	jsr	_LVOSetSongChannels(a6)
	move.l	a4,a0
	jsr	_LVOGetOptimalVChannels(a6)
	move.l	a4,a0
	jsr	_LVOSetTCMChannels(a6)
	move.l	a3,d0
	bne.s	ModAllocated
	move.l	a4,a3
ModAllocated:	move.l	a4,a0
	move.l	a3,a1
	jsr	_LVOReMapTCModule(a6)
	move.l	204(sp),a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
	move.l	200(sp),a1
	jsr	_LVOFreeVec(a6)
	move.l	196(sp),a1
	jsr	_LVOFreeVec(a6)
ExternalLoadDone:	lea	364(sp),sp
	move.l	a3,d0
	movem.l	(sp)+,d2-d7/a2-a6
	rts
ExternalLoadError:	move.l	d2,a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
ExternalLoadErr1:	move.l	228(sp),a4
ExternalLoadErr15:	move.l	204(sp),a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
ExternalLoadErr16:	move.l	200(sp),a1
	jsr	_LVOFreeVec(a6)
ExternalLoadErr2:	move.l	a4,a0
	move.l	a5,a6
	jsr	_LVOFreeTCModule(a6)
ExternalLoadErr3:	move.l	196(sp),a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
ExternalLoadErr4:	sub.l	a3,a3
	bra.s	ExternalLoadDone
ExtendedFXTable:	dc.w	0,NoFX-ExtendedFXTable
	dc.w	FX_EXTEND_CTRL,GlissCtrl-ExtendedFXTable
	dc.w	FX_SET_TRANSP,SetFineTune-ExtendedFXTable
	dc.w	$0301,EnvCtrl-ExtendedFXTable
	dc.w	$0401,EnvCtrl-ExtendedFXTable
	dc.w	0,NoFX-ExtendedFXTable
	dc.w	0,NoFX-ExtendedFXTable
	dc.w	0,NoFX-ExtendedFXTable
	dc.w	FX_SET_PANNING,SetPanning-ExtendedFXTable
	dc.w	0,NoFX-ExtendedFXTable
	dc.w	FX_SET_PANNING,SetPanning-ExtendedFXTable
	dc.w	FX_PATT_LOOP,PosJump-ExtendedFXTable
	dc.w	FX_NOTE_CUT,PosJump-ExtendedFXTable
	dc.w	FX_NOTE_DELAY,PosJump-ExtendedFXTable
	dc.w	FX_PATT_DELAY,PosJump-ExtendedFXTable
	dc.w	FX_INVERT_LOOP,PosJump-ExtendedFXTable
SetTempo:	tst.b	d6
	beq	NoFX
	rts
Porta:	lsr.b	#4,d1
	cmp.b	#$f,d1
	bne.s	NotFineSlide
	addq.b	#4,d0
	and.b	#$f,d6
	beq	NoFX
NotFineSlide:	cmp.b	#$e,d1
	bne.s	TonePorta
	addq.b	#4+2,d0
	and.b	#$f,d6
	beq	NoFX
	lsl.b	#2,d6
TonePorta:	lsl.w	#8,d6
	rts
Tremor:	beq.s	TremorDone
	unpk	d6,d6,#$0101
TremorDone:	rts
ToneFade:	movem.w	d0-d1,-(sp)
	moveq	#FX_TONE_PORTA,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	ToneFadeDone
AddFadeFX:	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
ToneFadeDone:	movem.w	(sp)+,d0-d1
	bra.s	VolumeSlide
VibFade:	movem.w	d0-d1,-(sp)
	moveq	#FX_VIBRATO,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	ToneFadeDone
	bra.s	AddFadeFX
VolumeSlide:	cmp.b	#$f0,d6
	beq.s	FastVolSlide
	cmp.b	#$0f,d6
	beq.s	FastVolSlide
	btst	#6,38+4(sp)
	beq.s	DoVolumeSlide
FastVolSlide:	movem.l	d0-d1,-(sp)
	moveq	#FX_EXECUTE_FX,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	DoFastVolDone
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
DoFastVolDone:	movem.l	(sp)+,d0-d1
DoVolumeSlide:	cmp.b	#$f0,d6
	beq.s	VolSlideUp
	cmp.b	#$0f,d6
	beq.s	VolSlideDown
	cmp.b	#$ff,d6
	beq.s	VolSlideUp
CheckVolSlide:	and.b	#$f,d1
	cmp.b	#$f,d1
	beq.s	FineVolSlideUp
	move.b	d6,d1
	lsr.b	#4,d1
	cmp.b	#$f,d1
	beq.s	FineVolSlideDown
	tst.b	d1
	bne.s	VolSlideUp
	bra.s	VolSlideDown
NotFineVolSlide:	btst	#2,d7
	beq.s	SetVolOk
	moveq	#8+2,d1
	lsl.w	d1,d6
	rts
FineVolSlideUp:	addq.b	#2,d0
VolSlideUp:	lsr.b	#4,d6
	bra.s	NotFineVolSlide
FineVolSlideDown:	addq.b	#2,d0
VolSlideDown:	addq.b	#1,d0
	and.b	#$f,d6
	bra.s	NotFineVolSlide
Arpeggio:	lsl.w	#4,d6
	lsr.b	#4,d6
	rts
Tremolo:	bsr.s	Arpeggio
	btst	#2,d7
	beq.s	PosJump
	lsl.b	#2,d6
	rts
SetVolume:	btst	#2,d7
	beq.s	SetVolOk
	lsl.b	#2,d6
	bcc.s	SetVolOk
	moveq	#-1,d6
SetVolOk:	lsl.w	#8,d6
	rts
Extended:	lea	ExtendedFXTable(pc),a0
	lsr.b	#4,d1
	movem.w	(a0,d1.w*4),d0-d1
	add.l	d1,a0
	move.w	d6,d1
	lsr.b	#4,d1
	and.b	#$f,d6
	jmp	(a0)
NoFX:	addq.l	#4,sp
	bra	NoEffect
MultiRetrig:	and.b	#$f,d1
	lsl.w	#8,d1
	or.w	d1,d6
	lsr.b	#4,d6
	beq.s	MulRetrigNoVol
	cmp.b	#8,d6
	beq.s	MulRetrigNoVol
	cmp.b	#6,d6
	bcc.s	MulRetrig
	move.b	d6,d1
	moveq	#1,d6
	lsl.b	d1,d6
	lsr.b	#1,d6
	add.b	#$C0-1,d6
	clr.b	d1
	or.w	d1,d6
PosJump:	rts
MulRetrigNoVol:	move.b	#$10,d6
	rts
MulRetrig:	subq.b	#6,d6
	bne.s	MulRetr1
	move.b	#$23,d6
	rts
MulRetr1:	subq.b	#2,d6
	bcc.s	AddRetrig
	move.b	#$12,d6
	rts
AddRetrig:	cmp.b	#$6,d6
	beq.s	DivRetr1
	cmp.b	#$7,d6
	beq.s	DivRetr2
	move.b	d6,d1
	moveq	#1,d6
	lsl.b	d1,d6
	lsr.b	#1,d6
	add.b	#$80-1,d6
	clr.b	d1
	or.w	d1,d6
	rts
DivRetr1:	move.b	#$32,d6
	rts
DivRetr2:	move.b	#$21,d6
	rts
SetFineTune:	lsl.b	#4,d6
	rts
ExtendControl:	bset	#12,d6
	rts
GlissCtrl:	tst.b	d6
	beq.s	ExtendControl
	move.w	#$1001,d6
	rts
SetPanning:	move.b	d6,d1
	lsl.b	#4,d1
	or.b	d1,d6
	lsl.w	#8,d6
	rts
EnvCtrl:	move.w	d0,d3
	moveq	#FX_ENV_CONTROL,d0
	cmp.b	#4,d6
	blo.s	NotRetrigEnvSet
	or.b	#$10,d3
NotRetrigEnvSet:	and.w	#3,d6
	move.w	d3,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	EnvCtrlDone
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
	moveq	#FX_ENV_CONTROL,d0
	and.b	#$f0,d3
	or.b	#2,d3
	move.w	d3,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	EnvCtrlDone
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
	moveq	#FX_ENV_CONTROL,d0
	clr.b	d3
	move.w	d3,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	EnvCtrlDone
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
EnvCtrlDone:	moveq	#FX_SET_ENV_VAL,d0
	rts
ExternalModuleSave:	
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle from where to get the info
;	A1.L	=	APTR to track info structure where to put information
;	D0.L	=	Number of track to be scanned (NULL is the first)
;	OUTPUT
;	D0.L	=	A non-zero value if success else NULL.
ExternalModuleGetInfo:	movem.l	d2-d4/a2-a3/a6,-(sp)
	movem.l	(sp)+,d2-d4/a2-a3/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	Number of modules found or NULL on any error
ExternalModuleGetNums:	moveq	#1,d0
	rts

	cnop	0,4

ExtModuleLibBase:	dc.l	0

LoadFlags:	dc.w	4
	dc.w	LoadFlagSize
	dc.l	LoadText0
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText1
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText2
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText3
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
LoadText0:	dc.b	'Load samples',0
LoadText1:	dc.b	'Make vibrato envelopes',0
LoadText2:	dc.b	'Convert volumes',0
LoadText3:	dc.b	'Load AdLib channels',0
LoadFlagSize:	equ	*-LoadFlags
LoadDescript:	dc.b	'ScreamTracker ]I[ Module (S3M)',0
