*********************************************************
***    TuComposer External Track Library for S3M      ***
***       1996-97 by The united Coders (TuC)         ***
***                Main code: Basty/TuC               ***
*** This is a S3M track loader (loads the tracks from ***
***           the ScreamTracker ]I[ modules)          ***
*********************************************************

	IFND	_G2
	MACHINE	MC68020
	OPT NODEBUG,NOLINE
	ENDC

	include	"exec/types.i"
	include	"exec/execbase.i"
	include	"exec/exec_lib.i"
	include	"exec/initializers.i"
	include	"exec/memory.i"
	include	"exec/resident.i"
	include	"exec/libraries.i"
	include	"libraries/dos_lib.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/track.i"
	include	"tucomposer/external/external.i"
	include	"tucomposer/external/external_lib.i"
	include	"tucomposer/external/track.i"
	include	"tucomposer/external/track_lib.i"

	moveq	#-1,d0
	rts
ResidentStruct:	dc.w	RTC_MATCHWORD
	dc.l	ResidentStruct
	dc.l	0
	dc.b	RTF_AUTOINIT
	dc.b	EXTLIB_TRACK_VERSION
	dc.b	NT_LIBRARY
	dc.b	0
	dc.l	LibName
	dc.l	LibID
	dc.l	Init
LibName:	dc.b	's3mt.library',0
LibID:	dc.b	'TuComposer External Track Loader Version 1.00 (v31) for S3M (v31) (68020+, OS2.0+) (3 Mar 97) by Basty/TuC.',0
TuComposerName:	dc.b	'tucomposer.library',0
	even
Init:	dc.l	trkl_SIZEOF
	dc.l	FuncTab
	dc.l	DataTab
	dc.l	PrepareLibrary

FuncTab:	dc.w	-1
	dc.w	Open-FuncTab
	dc.w	Close-FuncTab
	dc.w	Expunge-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalInitialize-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalTrackIdentify-FuncTab
	dc.w	ExternalTrackLoad-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalTrackGetInfo-FuncTab
	dc.w	ExternalTrackGetNums-FuncTab
	dc.w	-1

DataTab:	INITLONG	LN_NAME,LibName
	INITBYTE	LIB_FLAGS,LIBF_CHANGED|LIBF_SUMUSED
	INITWORD	LIB_VERSION,EXTLIB_TRACK_VERSION
	INITWORD	LIB_REVISION,EXTLIB_REVISION
	INITLONG	LIB_IDSTRING,LibID
	dc.l	0

PrepareLibrary:	btst	#AFB_68020,AttnFlags+1(a6)
	beq.s	ExtLib
	cmp.w	#36,LIB_VERSION(a6)
	blt.s	ExtLib
	move.l	a2,-(sp)
	move.l	d0,a2
	move.l	a0,extb_SegList(a2)
	moveq	#31,d0
	lea	TuComposerName(pc),a1
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,extb_TuComposerBase(a2)
	beq.s	NoTuCLib
	lea	ExtTrackLibBase(pc),a0
	move.l	a2,(a0)
	move.l	a2,d0
NoTuCLib:	move.l	(sp)+,a2
	rts
Open:	addq.w	#1,LIB_OPENCNT(a6)
	move.l	a6,d0
	rts
Close:	subq.w	#1,LIB_OPENCNT(a6)
	bne.s	ExtLib
	btst	#LIBB_DELEXP,LIB_FLAGS(a6)
	bne.s	Expunge
ExtLib:	moveq	#0,d0
	rts
Expunge:	bset	#LIBB_DELEXP,LIB_FLAGS(a6)
	tst.w	LIB_OPENCNT(a6)
	bne.s	ExtLib
	movem.l	d2/a5-a6,-(sp)
	move.l	extb_ExtLibList(a6),d0
	beq.s	NoExtLibList
	move.l	d0,a0
	clr.l	extl_LibBase(a0)
NoExtLibList:	move.l	extb_TuComposerBase(a6),a1
	move.l	a6,a5
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
	move.l	extb_SegList(a5),d2
	move.l	a5,a1
	jsr	_LVORemove(a6)
	move.l	a5,a1
	moveq	#0,d0
	moveq	#0,d1
	move.w	LIB_NEGSIZE(a5),d1
	sub.l	d1,a1
	move.w	LIB_POSSIZE(a5),d0
	add.l	d1,d0
	jsr	_LVOFreeMem(a6)
	move.l	d2,d0
	movem.l	(sp)+,d2/a5-a6
	rts
;	INPUT
;	A0.L	=	APTR to track external list structure to be initialized
;	OUTPUT
;	D0.L	=	What type of external library is it or NULL if error
ExternalInitialize:	move.l	extb_TuComposerBase(a6),a1
	movem.l	a2/a6,-(sp)
	move.l	a0,d0
	beq.s	ExternalInitDone
	move.l	a1,a6
	move.b	#EXTLF_Loader|EXTLF_Saver,extl_Flags(a0)
	move.l	a0,a2
	lea	extl_Descriptor(a0),a0
	lea	LoadDescript(pc),a1
	jsr	_LVOSetString(a6)
	tst.l	d0
	beq.s	ExternalInitDone
	lea	LoadFlags(pc),a0
	jsr	_LVOAllocFlagStr(a6)
	move.l	d0,extl_LoadFlagStr(a2)
	beq.s	ExternalInitDone
	moveq	#EXTTYPE_TRACK,d0
ExternalInitDone:	movem.l	(sp)+,a2/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	If failed NULL else any non-zero value
ExternalTrackIdentify:	movem.l	d2-d3/a6,-(sp)
	move.l	a0,d1
	link	a5,#-48
	move.l	sp,d2
	moveq	#48,d3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalTrackIdDone
	cmp.l	#"SCRM",44(sp)
	beq.s	ExternalTrackIdOk
ExternalTrackIdDone:	moveq	#0,d0
ExternalTrackIdOk:	unlk	a5
	movem.l	(sp)+,d2-d3/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be loaded
;	A1.L	=	APTR to target track structure or NULL to create a new one
;	A2.L	=	APTR to loading flag pass structure (Loader specific)
;	D0.L	=	Number of track of be loaded (NULL is the first)
;	OUTPUT
;	D0.L	=	APTR to track structure where loaded track data is
ExternalTrackLoad:	movem.l	d2-d7/a2-a6,-(sp)
	lea	-96(sp),sp
	move.l	sp,d2
	moveq	#96,d3
	move.l	d0,d6
	move.l	(a2),d7
	move.l	a0,d1
	move.l	d1,a2
	move.l	a1,a3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalTrackLoadErr
	cmp.w	#$0013,40(sp)
	bne.s	NotBuggyST3
	bset	#6,38(sp)
NotBuggyST3:	moveq	#0,d1
	move.w	36(sp),d1
	rol.w	#8,d1
	lsl.l	#5,d1
	moveq	#32,d0
	cmp.l	d1,d6
	bcc	ExternalTrackLoadErr
	divul.l	d0,d5:d6
	move.b	64(sp,d5.w),d0
	move.b	#$80,d4
	tst.b	51(sp)
	bpl.s	GetLRLoadPanInfoOk
	cmp.b	#255,d0
	beq.s	GetLRLoadPanInfoOk
	bclr	#7,d0
	cmp.b	#16,d0
	bcc.s	GetLRLoadPanInfoOk
	st	d4
	cmp.b	#8,d0
	bcc.s	GetLRLoadPanInfoOk
	moveq	#0,d4
GetLRLoadPanInfoOk:	move.l	a2,d1
	moveq	#0,d2
	move.w	32(sp),d2
	rol.w	#8,d2
	move.w	34(sp),d0
	rol.w	#8,d0
	add.l	d0,d2
	add.l	d0,d2
	add.l	d6,d2
	add.l	d6,d2
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalTrackLoadDone
	move.l	a2,d1
	lea	62(sp),a4
	move.l	a4,d2
	moveq	#2,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalTrackLoadErr
	cmp.b	#$80,d4
	beq.s	NotUseLoadDefPan
	cmp.b	#252,53(sp)
	bne.s	NotUseLoadDefPan
	lea	32(sp),a0
	moveq	#96,d2
	move.w	(a0)+,d1
	rol.w	#8,d1
	add.l	d1,d2
	move.w	(a0)+,d1
	rol.w	#8,d1
	add.l	d1,d2
	add.l	d1,d2
	move.w	(a0),d1
	rol.w	#8,d1
	add.l	d1,d2
	add.l	d1,d2
	move.l	a2,d1
	moveq	#OFFSET_BEGINNING,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalTrackLoadDone
	move.l	a2,d1
	lea	64(sp),a0
	move.l	a0,d2
	moveq	#32,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalTrackLoadErr
	move.b	d4,d0
	moveq	#$33,d4
	addq.b	#1,d0
	beq.s	DefLeftPan
	not.b	d4
DefLeftPan:	move.b	64(sp,d5.w),d0
	btst	#5,d0
	beq.s	NotUseLoadDefPan
	and.b	#$f,d0
	move.b	d0,d4
	lsl.b	#4,d0
	or.b	d0,d4
NotUseLoadDefPan:	move.l	a2,d1
	moveq	#0,d2
	move.w	(a4),d2
	beq.s	ExternalTrackEmpty
	rol.w	#8,d2
	lsl.l	#4,d2
	moveq	#OFFSET_BEGINNING,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalTrackLoadDone
	move.l	a2,d1
	move.l	a4,d2
	moveq	#2,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalTrackLoadErr
	move.w	(a4),d3
	rol.w	#8,d3
	move.l	d3,d0
	move.l	a6,a5
	jsr	_LVOAllocPMem(a6)
	move.l	a2,d1
	move.l	d3,60(sp)
	move.l	d0,d2
	beq	ExternalTrackLoadDone
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalTrackLoadError
ExternalTrackEmpty:	move.l	a3,d0
	bne.s	TrackAllocated
	moveq	#64,d0
	jsr	_LVOAllocTrack(a6)
TrackAllocated:	move.l	d0,d1
	beq	ExternalTrackLoadError
	move.l	d0,a3
	moveq	#64,d0
	move.l	a3,a0
	jsr	_LVOReSizeTrack(a6)
	tst.l	d0
	bne	ExternalTrackLoadError
	move.l	a3,a0
	jsr	_LVOClearTrack(a6)
	move.l	d2,a2
	clr.b	28(sp)
	move.l	sp,a0
	jsr	_LVOAllocNameStr(a6)
	move.l	d0,tct_Name(a3)
	lea	48(sp),a0
	move.b	(a0)+,d0
	lsl.b	#2,d0
	bcc.s	GlobalLoadVolOk
	subq.b	#1,d0
GlobalLoadVolOk:	move.b	d0,tct_Volume(a3)
	move.b	(a0)+,tct_Frames+1(a3)
	move.b	(a0),tct_BPMSpeed+1(a3)
	move.b	d4,tct_Panning(a3)
	move.b	#TCTCF_Slide|TCTCF_VolSlide|TCTCF_VolPitch,tct_CompFlags(a3)
	tst.l	d2
	beq	DecrunchDone
	moveq	#64-1,d3
	move.l	tct_Data(a3),a4
DecrunchPattern:	move.l	#$ff00ff00,(sp)
	clr.b	4(sp)
	move.b	(a2)+,d0
	bne.s	NotNextRow
	lea	tctd_NextRow(a4),a4
	dbra	d3,DecrunchPattern
	bra	DecrunchDone
NotNextRow:	btst	#5,d0
	beq.s	NotNote
	move.w	(a2)+,(sp)
NotNote:	btst	#6,d0
	beq.s	NotVolCol
	move.b	(a2)+,2(sp)
NotVolCol:	tst.b	d0
	bpl.s	NotFX
	move.w	(a2)+,3(sp)
NotFX:	and.b	#31,d0
	cmp.b	d5,d0
	bne.s	DecrunchPattern
	move.l	sp,a1
	moveq	#0,d0
	move.b	(a1)+,d0
	addq.b	#1,d0
	beq.s	NoteDone
	cmp.b	#-1,d0
	beq.s	NoteDone
	lsl.w	#4,d0
	lsr.b	#4,d0
NoteDone:	move.w	d0,(a4)+
	moveq	#0,d0
	move.b	(a1)+,d0
	move.w	d0,(a4)+
	moveq	#0,d6
	move.b	(a1)+,d6
	cmp.b	#-1,d6
	beq.s	NoVolumeColumn
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d4
	beq.s	NoVolumeColumn
	tst.l	d7
	beq.s	NotVolFF
	lsl.b	#2,d6
	bcc.s	NotVolFF
	moveq	#-1,d6
NotVolFF:	lsl.w	#8,d6
	move.l	d4,a1
	move.b	#FX_SET_VOLUME,tcte_EffectByte(a1)
	move.w	d6,tcte_DataWord(a1)
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
NoVolumeColumn:	moveq	#0,d0
	lea	3(sp),a1
	move.b	(a1)+,d0
	beq.s	NoEffect
	moveq	#0,d6
	move.b	(a1)+,d6
	cmp.b	#25,d0
	bcc.s	NoEffect
	cmp.b	#15,d0
	bne.s	NotSmpOffset
	tst.w	tctd_Octave-tctd_Effects(a4)
	beq.s	NoEffect
NotSmpOffset:	movem.w	ProcessFXTable-4(pc,d0.w*4),d0-d1
	lea	ProcessFXTable(pc),a0
	add.l	d1,a0
	move.w	d6,d1
	jsr	(a0)
	move.w	d6,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	NoEffect
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
NoEffect:	subq.l	#tctd_Effects,a4
	bra	DecrunchPattern
DecrunchDone:	move.l	d2,a1
	move.l	60(sp),d0
	move.l	a5,a6
	jsr	_LVOFreePMem(a6)
	move.l	a3,d0
ExternalTrackLoadDone:	lea	96(sp),sp
	movem.l	(sp)+,d2-d7/a2-a6
	rts
ExternalTrackLoadError:	move.l	d2,a1
	move.l	60(sp),d0
	move.l	a5,a6
	jsr	_LVOFreePMem(a6)
ExternalTrackLoadErr:	moveq	#0,d0
	bra.s	ExternalTrackLoadDone
ProcessFXTable:	dc.w	FX_SET_TEMPO,SetTempo-ProcessFXTable
	dc.w	FX_POS_JUMP,PosJump-ProcessFXTable
	dc.w	FX_PATT_BREAK,PosJump-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,VolumeSlide-ProcessFXTable
	dc.w	FX_PORTA_DOWN,Porta-ProcessFXTable
	dc.w	FX_PORTA_UP,Porta-ProcessFXTable
	dc.w	FX_TONE_PORTA,TonePorta-ProcessFXTable
	dc.w	FX_VIBRATO,Arpeggio-ProcessFXTable
	dc.w	FX_TREMOR,Tremor-ProcessFXTable
	dc.w	FX_ARPEGGIO,Arpeggio-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,VibFade-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,ToneFade-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	FX_SMP_OFF_LOW,TonePorta-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	FX_MULTI_RETRIG,MultiRetrig-ProcessFXTable
	dc.w	FX_TREMOLO,Tremolo-ProcessFXTable
	dc.w	0,Extended-ProcessFXTable
	dc.w	FX_SET_SPEED,PosJump-ProcessFXTable
	dc.w	FX_FINE_VIBRATO,Arpeggio-ProcessFXTable
	dc.w	FX_SET_G_VOLUME,SetVolume-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	USER_EFFECTS,PosJump-ProcessFXTable
ExtendedFXTable:	dc.w	0,NoFX-ExtendedFXTable
	dc.w	FX_EXTEND_CTRL,GlissCtrl-ExtendedFXTable
	dc.w	FX_SET_TRANSP,SetFineTune-ExtendedFXTable
	dc.w	$0301,EnvCtrl-ExtendedFXTable
	dc.w	$0401,EnvCtrl-ExtendedFXTable
	dc.w	0,NoFX-ExtendedFXTable
	dc.w	0,NoFX-ExtendedFXTable
	dc.w	0,NoFX-ExtendedFXTable
	dc.w	FX_SET_PANNING,SetPanning-ExtendedFXTable
	dc.w	0,NoFX-ExtendedFXTable
	dc.w	FX_SET_PANNING,SetPanning-ExtendedFXTable
	dc.w	FX_PATT_LOOP,PosJump-ExtendedFXTable
	dc.w	FX_NOTE_CUT,PosJump-ExtendedFXTable
	dc.w	FX_NOTE_DELAY,PosJump-ExtendedFXTable
	dc.w	FX_PATT_DELAY,PosJump-ExtendedFXTable
	dc.w	FX_INVERT_LOOP,PosJump-ExtendedFXTable
SetTempo:	tst.b	d6
	beq	NoFX
	rts
Porta:	lsr.b	#4,d1
	cmp.b	#$f,d1
	bne.s	NotFineSlide
	addq.b	#4,d0
	and.b	#$f,d6
	beq	NoFX
NotFineSlide:	cmp.b	#$e,d1
	bne.s	TonePorta
	addq.b	#4+2,d0
	and.b	#$f,d6
	beq	NoFX
	lsl.b	#2,d6
TonePorta:	lsl.w	#8,d6
	rts
Tremor:	beq.s	TremorDone
	unpk	d6,d6,#$0101
TremorDone:	rts
ToneFade:	movem.w	d0-d1,-(sp)
	moveq	#FX_TONE_PORTA,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	ToneFadeDone
AddFadeFX:	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
ToneFadeDone:	movem.w	(sp)+,d0-d1
	bra.s	VolumeSlide
VibFade:	movem.w	d0-d1,-(sp)
	moveq	#FX_VIBRATO,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	ToneFadeDone
	bra.s	AddFadeFX
VolumeSlide:	cmp.b	#$f0,d6
	beq.s	FastVolSlide
	cmp.b	#$0f,d6
	beq.s	FastVolSlide
	btst	#6,38+4(sp)
	beq.s	DoVolumeSlide
FastVolSlide:	movem.l	d0-d1,-(sp)
	moveq	#FX_EXECUTE_FX,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	DoFastVolDone
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
DoFastVolDone:	movem.l	(sp)+,d0-d1
DoVolumeSlide:	cmp.b	#$f0,d6
	beq.s	VolSlideUp
	cmp.b	#$0f,d6
	beq.s	VolSlideDown
	cmp.b	#$ff,d6
	beq.s	VolSlideUp
CheckVolSlide:	and.b	#$f,d1
	cmp.b	#$f,d1
	beq.s	FineVolSlideUp
	move.b	d6,d1
	lsr.b	#4,d1
	cmp.b	#$f,d1
	beq.s	FineVolSlideDown
	tst.b	d1
	bne.s	VolSlideUp
	bra.s	VolSlideDown
NotFineVolSlide:	tst.l	d7
	beq.s	SetVolOk
	moveq	#8+2,d1
	lsl.w	d1,d6
	rts
FineVolSlideUp:	addq.b	#2,d0
VolSlideUp:	lsr.b	#4,d6
	bra.s	NotFineVolSlide
FineVolSlideDown:	addq.b	#2,d0
VolSlideDown:	addq.b	#1,d0
	and.b	#$f,d6
	bra.s	NotFineVolSlide
Arpeggio:	lsl.w	#4,d6
	lsr.b	#4,d6
	rts
Tremolo:	bsr.s	Arpeggio
	tst.l	d7
	beq.s	PosJump
	lsl.b	#2,d6
	rts
SetVolume:	tst.l	d7
	beq.s	SetVolOk
	lsl.b	#2,d6
	bcc.s	SetVolOk
	moveq	#-1,d6
SetVolOk:	lsl.w	#8,d6
	rts
Extended:	lea	ExtendedFXTable(pc),a0
	lsr.b	#4,d1
	movem.w	(a0,d1.w*4),d0-d1
	add.l	d1,a0
	move.w	d6,d1
	lsr.b	#4,d1
	and.b	#$f,d6
	jmp	(a0)
NoFX:	addq.l	#4,sp
	bra	NoEffect
MultiRetrig:	and.b	#$f,d1
	lsl.w	#8,d1
	or.w	d1,d6
	lsr.b	#4,d6
	beq.s	MulRetrigNoVol
	cmp.b	#8,d6
	beq.s	MulRetrigNoVol
	cmp.b	#6,d6
	bcc.s	MulRetrig
	move.b	d6,d1
	moveq	#1,d6
	lsl.b	d1,d6
	lsr.b	#1,d6
	add.b	#$C0-1,d6
	clr.b	d1
	or.w	d1,d6
PosJump:	rts
MulRetrigNoVol:	move.b	#$10,d6
	rts
MulRetrig:	subq.b	#6,d6
	bne.s	MulRetr1
	move.b	#$23,d6
	rts
MulRetr1:	subq.b	#2,d6
	bcc.s	AddRetrig
	move.b	#$12,d6
	rts
AddRetrig:	cmp.b	#$6,d6
	beq.s	DivRetr1
	cmp.b	#$7,d6
	beq.s	DivRetr2
	move.b	d6,d1
	moveq	#1,d6
	lsl.b	d1,d6
	lsr.b	#1,d6
	add.b	#$80-1,d6
	clr.b	d1
	or.w	d1,d6
	rts
DivRetr1:	move.b	#$32,d6
	rts
DivRetr2:	move.b	#$21,d6
	rts
SetFineTune:	lsl.b	#4,d6
	rts
ExtendControl:	bset	#12,d6
	rts
GlissCtrl:	tst.b	d6
	beq.s	ExtendControl
	move.w	#$1001,d6
	rts
SetPanning:	move.b	d6,d1
	lsl.b	#4,d1
	or.b	d1,d6
	lsl.w	#8,d6
	rts
EnvCtrl:	move.w	d0,d3
	moveq	#FX_ENV_CONTROL,d0
	cmp.b	#4,d6
	blo.s	NotRetrigEnvSet
	or.b	#$10,d3
NotRetrigEnvSet:	and.w	#3,d6
	move.w	d3,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	EnvCtrlDone
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
	moveq	#FX_ENV_CONTROL,d0
	and.b	#$f0,d3
	or.b	#2,d3
	move.w	d3,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	EnvCtrlDone
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
	moveq	#FX_ENV_CONTROL,d0
	clr.b	d3
	move.w	d3,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	EnvCtrlDone
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
EnvCtrlDone:	moveq	#FX_SET_ENV_VAL,d0
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle from where to get the info
;	A1.L	=	APTR to track info structure where to put information
;	D0.L	=	Number of track to be scanned (NULL is the first)
;	OUTPUT
;	D0.L	=	A non-zero value if success else NULL.
ExternalTrackGetInfo:	movem.l	d2-d4/a2-a3/a6,-(sp)
	link	a5,#-96
	move.l	a0,d1
	move.l	sp,d2
	moveq	#96,d3
	move.l	d0,d4
	move.l	d1,a2
	move.l	a1,a3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalGetInfoError
	move.b	#TCTCF_Slide|TCTCF_VolSlide|TCTCF_VolPitch,trki_CompFlags(a3)
	move.b	41(sp),trki_Version(a3)
	move.b	40(sp),trki_Revision(a3)
	move.w	#64,trki_Length(a3)
	lea	48(sp),a0
	move.b	(a0)+,d0
	lsl.b	#2,d0
	bcc.s	GlobalVolOk
	subq.b	#1,d0
GlobalVolOk:	move.b	d0,trki_Volume(a3)
	move.b	(a0)+,trki_Frames+1(a3)
	move.b	(a0),trki_BPMSpeed+1(a3)
	move.l	#(DEFAULTTRACKSPDSPEED<<16)|(DEFAULTTRACKBPMTEMPO),trki_SPDSpeed(a3)
	clr.b	28(sp)
	move.l	sp,a0
	jsr	_LVOAllocNameStr(a6)
	move.l	d0,trki_Name(a3)
	moveq	#0,d0
	move.w	36(sp),d0
	rol.w	#8,d0
	lsl.l	#5,d0
	cmp.l	d0,d4
	bcc	ExternalGetInfoError
	and.w	#31,d4
	move.b	64(sp,d4.w),d0
	move.b	#$80,d1
	cmp.b	#255,d0
	beq.s	GetLRPanInfoOk
	bclr	#7,d0
	cmp.b	#16,d0
	bcc.s	GetLRPanInfoOk
	st	d1
	cmp.b	#8,d0
	bcc.s	GetLRPanInfoOk
	moveq	#0,d1
GetLRPanInfoOk:	move.b	d1,trki_Panning(a3)
	cmp.b	#$80,d1
	bne.s	NotUseDefPan
	tst.b	51(sp)
	bpl.s	NotUseDefPan
	cmp.b	#252,53(sp)
	bne.s	NotUseDefPan
	lea	32(sp),a0
	moveq	#0,d2
	move.w	(a0)+,d2
	rol.w	#8,d2
	move.w	(a0)+,d1
	rol.w	#8,d1
	add.l	d1,d2
	add.l	d1,d2
	move.w	(a0),d1
	rol.w	#8,d1
	add.l	d1,d2
	add.l	d1,d2
	move.l	a2,d1
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq.s	ExternalGetInfoDone
	move.l	a2,d1
	move.l	sp,d2
	moveq	#32,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalGetInfoError
	move.b	trki_Panning(a3),d0
	moveq	#$33,d1
	addq.b	#1,d0
	beq.s	DefLeftScanPan
	not.b	d1
DefLeftScanPan:	move.b	(sp,d4.w),d0
	btst	#5,d0
	beq.s	NotUseDefPan
	and.b	#$f,d0
	move.b	d0,d1
	lsl.b	#4,d0
	or.b	d0,d1
NotUseDefPan:	move.b	d1,trki_Panning(a3)
	move.l	a3,d0
ExternalGetInfoDone:	unlk	a5
	movem.l	(sp)+,d2-d4/a2-a3/a6
	rts
ExternalGetInfoError:	moveq	#0,d0
	bra.s	ExternalGetInfoDone
ExternalGetInfoWrongVersion:	moveq	#255-ERROR_ACTION_NOT_KNOWN,d1
	not.b	d1
	move.l	tcb_DOSBase(a6),a6
	jsr	_LVOSetIoErr(a6)
	bra.s	ExternalGetInfoError
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	Number of tracks found or NULL on any error
ExternalTrackGetNums:	move.l	a6,-(sp)
	link	a5,#-38
	move.l	a0,d1
	move.l	sp,d2
	moveq	#38,d3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalGetNumError
	move.w	36(sp),d0
	rol.w	#8,d0
	lsl.l	#5,d0
ExternalGetNumsDone:	unlk	a5
	move.l	(sp)+,a6
	rts
ExternalGetNumError:	moveq	#0,d0
	bra.s	ExternalGetNumsDone

	cnop	0,4

ExtTrackLibBase:	dc.l	0

LoadFlags:	dc.w	1
	dc.w	LoadFlagSize
	dc.l	LoadText0
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
LoadText0:	dc.b	'Convert volumes',0
LoadFlagSize:	equ	*-LoadFlags
LoadDescript:	dc.b	'ScreamTracker ]I[ Module (S3M)',0
