*******************************************************************
***         TuComposer External Instrument Library for XI       ***
***                 1997 by The united Coders (TuC)            ***
***                       Main code: Basty/TuC                  ***
*** This is a XI instrument loader (FastTracker ][ instruments) ***
*******************************************************************

	IFND	_G2
	MACHINE	MC68020
	OPT	NODEBUG,NOLINE
	ENDC

	include	"exec/types.i"
	include	"exec/execbase.i"
	include	"exec/exec_lib.i"
	include	"exec/initializers.i"
	include	"exec/resident.i"
	include	"exec/libraries.i"
	include	"libraries/dos_lib.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/module.i"
	include	"tucomposer/instr.i"
	include	"tucomposer/sample.i"
	include	"tucomposer/external/external.i"
	include	"tucomposer/external/external_lib.i"
	include	"tucomposer/external/instr.i"
	include	"tucomposer/external/instr_lib.i"

	moveq	#-1,d0
	rts
ResidentStruct:	dc.w	RTC_MATCHWORD
	dc.l	ResidentStruct
	dc.l	0
	dc.b	RTF_AUTOINIT
	dc.b	EXTLIB_INSTR_VERSION
	dc.b	NT_LIBRARY
	dc.b	0
	dc.l	LibName
	dc.l	LibID
	dc.l	Init
LibName:	dc.b	'xi.library',0
LibID:	dc.b	'TuComposer External Instrument Loader Version 1.00 (v31) for XI (68020+, OS2.0+) (16 Mar 97) by Basty/TuC.',0
TuComposerName:	dc.b	'tucomposer.library',0
	even
Init:	dc.l	insl_SIZEOF
	dc.l	FuncTab
	dc.l	DataTab
	dc.l	PrepareLibrary

FuncTab:	dc.w	-1
	dc.w	Open-FuncTab
	dc.w	Close-FuncTab
	dc.w	Expunge-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalInitialize-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalInstrIdentify-FuncTab
	dc.w	ExternalInstrLoad-FuncTab
	dc.w	ExternalInstrSave-FuncTab
	dc.w	ExternalInstrGetInfo-FuncTab
	dc.w	ExternalInstrGetNums-FuncTab
	dc.w	-1

DataTab:	INITLONG	LN_NAME,LibName
	INITBYTE	LIB_FLAGS,LIBF_CHANGED|LIBF_SUMUSED
	INITWORD	LIB_VERSION,EXTLIB_INSTR_VERSION
	INITWORD	LIB_REVISION,EXTLIB_REVISION
	INITLONG	LIB_IDSTRING,LibID
	dc.l	0

PrepareLibrary:	btst	#AFB_68020,AttnFlags+1(a6)	
	beq.s	ExtLib
	cmp.w	#37,LIB_VERSION(a6)
	blt.s	ExtLib
	move.l	a2,-(sp)
	move.l	d0,a2
	move.l	a0,extb_SegList(a2)
	moveq	#31,d0
	lea	TuComposerName(pc),a1
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,extb_TuComposerBase(a2)
	beq.s	NoTuCLib
	lea	ExtInstrLibBase(pc),a0
	move.l	a2,(a0)
	move.l	a2,d0
NoTuCLib:	move.l	(sp)+,a2
	rts
Open:	addq.w	#1,LIB_OPENCNT(a6)
	move.l	a6,d0
	rts
Close:	subq.w	#1,LIB_OPENCNT(a6)
	bne.s	ExtLib
	btst	#LIBB_DELEXP,LIB_FLAGS(a6)
	bne.s	Expunge
ExtLib:	moveq	#0,d0
	rts
Expunge:	bset	#LIBB_DELEXP,LIB_FLAGS(a6)
	tst.w	LIB_OPENCNT(a6)
	bne.s	ExtLib
	movem.l	d2/a5-a6,-(sp)
	move.l	extb_ExtLibList(a6),d0
	beq.s	NoExtLibList
	move.l	d0,a0
	clr.l	extl_LibBase(a0)
NoExtLibList:	move.l	extb_TuComposerBase(a6),a1
	move.l	a6,a5
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
	move.l	extb_SegList(a5),d2
	move.l	a5,a1
	jsr	_LVORemove(a6)
	move.l	a5,a1
	moveq	#0,d0
	moveq	#0,d1
	move.w	LIB_NEGSIZE(a5),d1
	sub.l	d1,a1
	move.w	LIB_POSSIZE(a5),d0
	add.l	d1,d0
	jsr	_LVOFreeMem(a6)
	move.l	d2,d0
	movem.l	(sp)+,d2/a5-a6
	rts
;	INPUT
;	A0.L	=	APTR to instrument external list structure to be initialized
;	OUTPUT
;	D0.L	=	What type of external library is it or NULL if error
ExternalInitialize:	move.l	extb_TuComposerBase(a6),a1
	movem.l	a2/a6,-(sp)
	move.l	a0,d0
	beq.s	ExternalInitDone
	move.l	a1,a6
	move.b	#EXTLF_Loader|EXTLF_Saver,extl_Flags(a0)
	move.l	a0,a2
	lea	extl_Descriptor(a0),a0
	lea	LoadDescript(pc),a1
	jsr	_LVOSetString(a6)
	tst.l	d0
	beq.s	ExternalInitDone
	lea	LoadFlags(pc),a0
	jsr	_LVOAllocFlagStr(a6)
	move.l	d0,extl_LoadFlagStr(a2)
	beq.s	ExternalInitDone
	lea	SaveFlags(pc),a0
	jsr	_LVOAllocFlagStr(a6)
	move.l	d0,extl_SaveFlagStr(a2)
	beq.s	ExternalInitDone
	moveq	#EXTTYPE_INSTR,d0
ExternalInitDone:	movem.l	(sp)+,a2/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	If failed NULL else any non-zero value
ExternalInstrIdentify:	movem.l	d2-d3/a6,-(sp)
	move.l	a0,d1
	link	a5,#-44
	move.l	sp,d2
	moveq	#44,d3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalInstrIdDone
	cmp.b	#26,43(sp)
	bne.s	ExternalInstrIdDone
	moveq	#FastTrackerId-XIId-1,d1
	lea	XIId(pc),a0
	move.l	sp,a1
IdentifyInstrLoop:	cmp.b	(a0)+,(a1)+
	dbne	d1,IdentifyInstrLoop
	beq.s	ExternalInstrIdOk
ExternalInstrIdDone:	moveq	#0,d0
ExternalInstrIdOk:	unlk	a5
	movem.l	(sp)+,d2-d3/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be loaded
;	A1.L	=	APTR to target instrument structure or NULL to create new
;	A2.L	=	APTR to loading flag pass structure (Loader specific)
;	D0.L	=	Number of instrument to be loaded (NULL is the first)
;	OUTPUT
;	D0.L	=	APTR to instrument structure where loaded instrument data is
ExternalInstrLoad:	movem.l	d2-d7/a2-a6,-(sp)
	moveq	#7,d0
	moveq	#0,d1
	moveq	#0,d7
CreateBitTable:	tst.l	(a2)+
	beq.s	BitNotSet
	bset	d1,d7
BitNotSet:	addq.b	#1,d1
	dbra	d0,CreateBitTable
	move.l	a0,d1
	move.l	#306,d3
	sub.l	d3,sp
	move.l	sp,d2
	move.l	d1,a2
	move.l	a1,a3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadError
	cmp.w	#$0201,64(sp)
	bne	ExternalLoadWrongVersion
	moveq	#0,d0
	jsr	_LVOAllocInstr(a6)
	move.l	d0,d1
	beq	ExternalLoadError
	move.l	d0,a4
	moveq	#32,d6
	move.l	a5,(sp)
	btst	#2,d7
	beq	NotConvertVolEnvData
	btst	#0,266(sp)
	bne.s	NotEmptyVolEnvData
	move.b	#2,258(sp)
	move.l	#$00004000,162(sp)
	move.l	#$01000000,165(sp)
	clr.w	260(sp)
	clr.b	262(sp)
NotEmptyVolEnvData:	moveq	#0,d0
	moveq	#0,d1
	move.b	258(sp),d1
	beq	NotConvertVolEnvData
	move.l	d1,d4
	subq.b	#1,d1
	beq	NotConvertVolEnvData
	move.b	d1,d2
ConvertVolGetHighest:	move.w	(162.w,sp,d1.w*4),d3
	rol.w	#8,d3
	addq.l	#1,d3
	cmp.w	d3,d0
	bhs.s	ConvertVolIsHighest
	move.w	d3,d0
ConvertVolIsHighest:	dbra	d1,ConvertVolGetHighest
	moveq	#ENVL_EMPTY,d1
	moveq	#0,d3
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,tci_VolumeEnvelope(a4)
	beq	ExternalLoadErr
	lea	162(sp),a0
	move.l	d0,a1
	moveq	#TCIEF_Sustain,d0
	btst	#0,266(sp)
	beq.s	NotLoopEnv
	moveq	#TCIEF_Loop|TCIEF_Sustain,d0
	btst	#1,266(sp)
	beq.s	NotSusLoopEnv
	btst	#2,266(sp)
	beq.s	SetEnvNoSusLoop
	bra.s	NotLoopEnv
NotSusLoopEnv:	moveq	#TCIEF_Loop,d0
	btst	#2,266(sp)
	bne.s	NotLoopEnv
SetEnvNoSusLoop:	move.b	d2,261(sp)
	move.b	d2,262(sp)
NotLoopEnv:	move.b	d0,tcie_Flags+1(a1)
	moveq	#0,d1
	move.b	260(sp),d1
	move.w	(a0,d1.w*4),d0
	rol.w	#8,d0
	move.w	d0,tcie_SustainStart(a1)
	move.w	d0,tcie_SustainEnd(a1)
	move.b	261(sp),d1
	move.w	(a0,d1.w*4),d0
	rol.w	#8,d0
	move.w	d0,tcie_LoopStart(a1)
	move.b	262(sp),d1
	move.w	(a0,d1.w*4),d0
	rol.w	#8,d0
	move.w	d0,tcie_LoopEnd(a1)
	move.l	tcie_NodePoints(a1),a5
	move.l	tcie_Data(a1),a1
ConvertEnvelopeData:	move.w	(a0)+,d0
	rol.w	#8,d0
	move.w	d0,(a5)+
	move.w	(a0)+,d1
	rol.w	#8,d1
	sub.w	d6,d1
	muls.w	#$7fff,d1
	asr.l	#5,d1
	move.w	(a0),d3
	rol.w	#8,d3
	bne.s	NotNullLastVol
	move.w	d0,d3
	addq.w	#1,d3
NotNullLastVol:	move.w	2(a0),d4
	rol.w	#8,d4
	sub.w	d6,d4
	muls.w	#$7fff,d4
	asr.l	#5,d4
	sub.w	d0,d3
	bls.s	NotNullLastVol2
	sub.l	d1,d4
	divs.w	d3,d4
	moveq	#0,d5
	move.w	d3,d0
	cmp.b	#1,d2
	bne.s	AddEnvelopeData
	addq.w	#1,d0
AddEnvelopeData:	move.w	d1,(a1)+
	add.w	d4,d1
	swap	d4
	add.w	d4,d5
	bpl.s	NotSubEnvData
	add.w	d3,d5
	subq.w	#1,d1
NotSubEnvData:	cmp.w	d3,d5
	bcs.s	NotAddEnvData
	sub.w	d3,d5
	addq.w	#1,d1
NotAddEnvData:	swap	d4
	subq.w	#1,d0
	bne.s	AddEnvelopeData
NotNullLastVol2:	subq.b	#1,d2
	bne.s	ConvertEnvelopeData
	move.l	tci_VolumeEnvelope(a4),a0
	jsr	_LVOValidateEnvNodes(a6)
NotConvertVolEnvData:	moveq	#0,d0
	btst	#3,d7
	beq	NotConvertPanEnvData
	btst	#0,267(sp)
	beq	NotConvertPanEnvData
	moveq	#0,d1
	move.b	259(sp),d1
	beq	NotConvertPanEnvData
	move.l	d1,d4
	subq.b	#1,d1
	beq	NotConvertPanEnvData
	move.b	d1,d2
ConvertPanGetHighest:	move.w	(210.w,sp,d1.w*4),d3
	rol.w	#8,d3
	addq.l	#1,d3
	cmp.w	d3,d0
	bhs.s	ConvertPanIsHighest
	move.w	d3,d0
ConvertPanIsHighest:	dbra	d1,ConvertPanGetHighest
	moveq	#ENVL_EMPTY,d1
	moveq	#0,d3
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,tci_PanningEnvelope(a4)
	beq	ExternalLoadErr
	lea	210(sp),a0
	move.l	d0,a1
	moveq	#0,d0
	btst	#1,267(sp)
	beq.s	NotSustainPanEnv
	addq.b	#TCIEF_Sustain,d0
NotSustainPanEnv:	btst	#2,267(sp)
	beq.s	NotLoopPanEnv
	addq.b	#TCIEF_Loop,d0
NotLoopPanEnv:	move.b	d0,tcie_Flags+1(a1)
	moveq	#0,d1
	move.b	263(sp),d1
	move.w	(a0,d1.w*4),d0
	rol.w	#8,d0
	move.w	d0,tcie_SustainStart(a1)
	move.w	d0,tcie_SustainEnd(a1)
	move.b	264(sp),d1
	move.w	(a0,d1.w*4),d0
	rol.w	#8,d0
	move.w	d0,tcie_LoopStart(a1)
	move.b	265(sp),d1
	move.w	(a0,d1.w*4),d0
	rol.w	#8,d0
	move.w	d0,tcie_LoopEnd(a1)
	move.l	tcie_NodePoints(a1),a5
	move.l	tcie_Data(a1),a1
ConvertPanEnvData:	move.w	(a0)+,d0
	rol.w	#8,d0
	move.w	d0,(a5)+
	move.w	(a0)+,d1
	rol.w	#8,d1
	sub.w	d6,d1
	muls.w	#$7fff,d1
	asr.l	#5,d1
	move.w	(a0),d3
	rol.w	#8,d3
	bne.s	NotNullLastPan
	move.w	d0,d3
	addq.w	#1,d3
NotNullLastPan:	move.w	2(a0),d4
	rol.w	#8,d4
	sub.w	d6,d4
	muls.w	#$7fff,d4
	asr.l	#5,d4
	sub.w	d0,d3
	bls.s	NotNullLastPan2
	sub.l	d1,d4
	divs.w	d3,d4
	moveq	#0,d5
	move.w	d3,d0
	cmp.b	#1,d2
	bne.s	AddPanEnvData
	addq.w	#1,d0
AddPanEnvData:	move.w	d1,(a1)+
	add.w	d4,d1
	swap	d4
	add.w	d4,d5
	bpl.s	NotSubPanEnvData
	add.w	d3,d5
	subq.w	#1,d1
NotSubPanEnvData:	cmp.w	d3,d5
	bcs.s	NotAddPanEnvData
	sub.w	d3,d5
	addq.w	#1,d1
NotAddPanEnvData:	swap	d4
	subq.w	#1,d0
	bne.s	AddPanEnvData
NotNullLastPan2:	subq.b	#1,d2
	bne.s	ConvertPanEnvData
	move.l	tci_PanningEnvelope(a4),a0
	jsr	_LVOValidateEnvNodes(a6)
NotConvertPanEnvData:	move.l	(sp),a5
	btst	#6,d7
	beq.s	NoAutoVibrato
	move.b	268(sp),d0
	cmp.b	#4,d0
	bcc.s	NoAutoVibrato
	move.l	#$80000080,d2
	moveq	#DEFAULT_ENVNODES,d4
	move.b	(AutoVibTab.w,pc,d0.w),d1
	bne.s	NoInvertRamp
	moveq	#ENVL_RAMP,d1
	bclr	#31,d2
NoInvertRamp:	moveq	#64,d0
	lsl.w	#2,d0
	moveq	#0,d3
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,298(sp)
	beq	ExternalLoadErr
	move.l	d0,a1
	bset	#TCIEB_Loop,tcie_Flags+1(a1)
	move.w	tcie_NumPoints(a1),tcie_LoopEnd(a1)
	subq.w	#1,tcie_LoopEnd(a1)
NoAutoVibrato:	lea	269(sp),a0
	moveq	#0,d0
	move.b	(a0)+,d0
	neg.b	d0
	bne.s	VibSweepOk
	move.w	#$100,d0
VibSweepOk:	moveq	#0,d1
	move.b	(a0)+,d1
	mulu.w	d1,d0
	move.w	d0,302(sp)
	lsl.b	#2,d1
	move.b	d1,304(sp)
	move.b	(a0)+,305(sp)
	move.w	(a0),d0
	rol.w	#8,d0
	move.w	d0,tci_FadeOut(a4)
	moveq	#0,d3
	btst	#4,d7
	beq.s	NoVibratoEnvelope
	moveq	#32,d0
	moveq	#ENVL_SINE,d1
	moveq	#127,d2
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,tci_VibratoEnvelope(a4)
	beq	ExternalLoadErr
NoVibratoEnvelope:	btst	#5,d7
	beq.s	NoTremoloEnvelope
	moveq	#32,d0
	moveq	#ENVL_SINE,d1
	move.w	#$3fff,d2
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,tci_TremoloEnvelope(a4)
	beq	ExternalLoadErr
NoTremoloEnvelope:	lea	21(sp),a1
	lea	22(a1),a0
	clr.b	(a0)
FindNotSpc:	cmp.l	a1,a0
	beq.s	FindSpcDone
	cmp.b	#" ",-(a0)
	bne.s	FindSpcDone
	clr.b	(a0)
	bra.s	FindNotSpc
FindSpcDone:	lea	tci_Name(a4),a0
	jsr	_LVOSetString(a6)
	tst.b	d7
	bmi.s	NotOldGlobalVolume
	move.b	#64,tci_GlobalVolume(a4)
NotOldGlobalVolume:	btst	#0,d7
	beq	NoLoadSamples
	move.b	296(sp),d4
	beq	NoLoadSamples
LoadSamples:	move.l	a2,d1
	move.l	sp,d2
	moveq	#40,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadErr
	move.l	(sp),d0
	rol.w	#8,d0
	swap	d0
	rol.w	#8,d0
	sub.l	a0,a0
	jsr	_LVOAllocSample(a6)
	move.l	d0,d6
	beq	ExternalLoadErr
	lea	18(sp),a1
	lea	22(a1),a0
	clr.b	(a0)
FindNotSmpSpc:	cmp.l	a1,a0
	beq.s	FindSmpSpcDone
	cmp.b	#" ",-(a0)
	bne.s	FindSmpSpcDone
	clr.b	(a0)
	bra.s	FindNotSmpSpc
FindSmpSpcDone:	move.l	d6,a0
	lea	tcs_Name(a0),a0
	jsr	_LVOSetString(a6)
	move.l	d6,a1
	lea	12(sp),a0
	move.b	(a0)+,d0
	tst.b	d7
	bpl.s	NotConvSmpLoadVol
	lsl.b	#2,d0
	bcc.s	NotConvSmpLoadVol
	moveq	#-1,d0
NotConvSmpLoadVol:	move.b	d0,tcs_Volume(a1)
	movem.l	4(sp),d0-d1
	rol.w	#8,d0
	swap	d0
	rol.w	#8,d0
	btst	#4,14(sp)
	beq.s	Not16BitRepeat
	lsr.l	#1,d0
Not16BitRepeat:	rol.w	#8,d1
	swap	d1
	rol.w	#8,d1
	btst	#4,14(sp)
	beq.s	Not16BitRepLen
	lsr.l	#1,d1
Not16BitRepLen:	movem.l	d0-d1,tcs_Repeat(a1)
	moveq	#TCSF_SmpPanning,d1
	move.b	(a0)+,tcs_FineTune(a1)
	move.b	(a0)+,d0
	and.b	#3,d0
	beq.s	NoForwardLoop
	addq.b	#TCSF_Loop,d1
NoForwardLoop:	move.b	d1,tcs_Flags(a1)
	subq.b	#2,d0
	bne.s	NoPingpongLoop
	move.b	#TCSRF_Pingpong,tcs_RepMode(a1)
NoPingpongLoop:	move.b	(a0)+,tcs_Panning(a1)
	move.b	(a0),tcs_Transpose(a1)
	lea	298(sp),a0
	move.l	(a0)+,tcs_AutoVibratoEnv(a1)
	move.w	(a0)+,tcs_VibratoSweep(a1)
	move.w	(a0),tcs_VibratoDepth(a1)
	move.l	a1,d5
	btst	#4,14+128(sp)
	beq.s	Not16BitSmp
	moveq	#16,d0
	moveq	#CBF_ChangeOnly,d1
	move.l	d5,a0
	jsr	_LVOConvertBits(a6)
Not16BitSmp:	move.l	a4,a0
	move.l	d5,a1
	jsr	_LVOAddSample(a6)
	subq.b	#1,d4
	bne	LoadSamples
	lea	tci_Samples(a4),a5
LoadSampleData:	move.l	(a5),a5
	tst.l	(a5)
	beq.s	NoLoadSamples
	move.l	a2,d1
	movem.l	tcs_Data(a5),d2-d3
	jsr	_LVOCRead(a6)
	addq.l	#1,d0
	beq.s	ExternalLoadErr
	cmp.b	#16,tcs_BitDepth(a5)
	bne.s	NotIntelOrder
	move.l	a5,a0
	jsr	_LVOConvertWord(a6)
NotIntelOrder:	moveq	#0,d0
	move.l	a5,a0
	jsr	_LVODecrunchSample(a6)
	bra.s	LoadSampleData
NoLoadSamples:	moveq	#96-1,d0
	lea	66(sp),a0
CheckLoadKeyboardTable:	tst.b	(a0)+
	dbne	d0,CheckLoadKeyboardTable
	beq.s	NotLoadKeyboard
	jsr	_LVOAllocKeyboard(a6)
	move.l	d0,tci_KeyboardDefs(a4)
	beq.s	ExternalLoadErr
	lea	66(sp),a0
	move.l	d0,a1
	moveq	#96-1,d0
	addq.l	#MLN_SIZE,a1
ConvertXIKeyboard:	move.b	(a0)+,1(a1)
	addq.l	#4,a1
	dbra	d0,ConvertXIKeyboard
NotLoadKeyboard:	move.l	a3,d0
	bne.s	InstrAllocated
	move.l	a4,a3
InstrAllocated:	move.l	a4,a0
	move.l	a3,a1
	jsr	_LVOReMapInstr(a6)
	move.l	a3,a0
	move.b	d7,d0
	not.b	d0
	lsl.b	#6,d0
	lsr.b	#7,d0
	jsr	_LVOAddInstrEnvelopes(a6)
ExternalLoadDone:	move.l	a3,d0
	lea	306(sp),sp
	movem.l	(sp)+,d2-d7/a2-a6
	rts
ExternalLoadErr:	move.l	tci_VolumeEnvelope(a4),a0
	jsr	_LVOFreeEnvelope(a6)
	move.l	tci_PanningEnvelope(a4),a0
	jsr	_LVOFreeEnvelope(a6)
	move.l	tci_VibratoEnvelope(a4),a0
	jsr	_LVOFreeEnvelope(a6)
	move.l	tci_TremoloEnvelope(a4),a0
	jsr	_LVOFreeEnvelope(a6)
	move.l	tci_Samples(a4),a0
	tst.l	(a0)
	beq.s	NoFreeAutoVibEnv
	move.l	tcs_AutoVibratoEnv(a0),a0
	jsr	_LVOFreeEnvelope(a6)
NoFreeAutoVibEnv:	move.l	tci_KeyboardDefs(a4),a0
	jsr	_LVOFreeKeyboard(a6)
	move.l	a4,a0
	jsr	_LVOFreeInstr(a6)
ExternalLoadError:	sub.l	a3,a3
	bra.s	ExternalLoadDone
ExternalLoadWrongVersion:	moveq	#255-ERROR_ACTION_NOT_KNOWN,d1
	not.b	d1
	move.l	tcb_DOSBase(a6),a6
	jsr	_LVOSetIoErr(a6)
	bra.s	ExternalLoadError
AutoVibTab:	dc.b	ENVL_SINE,ENVL_SQUARE,0,ENVL_RAMP
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be loaded
;	A1.L	=	APTR to instrument structure to be saved
;	A2.L	=	APTR to saving flag pass structure (Saver specific)
;	OUTPUT
;	D0.L	=	NULL if saved successfully else one of the libs error codes
ExternalInstrSave:	movem.l	d2-d7/a2-a6,-(sp)
	moveq	#2,d0
	moveq	#0,d1
	moveq	#0,d7
CreateSaveBitTable:	tst.l	(a2)+
	beq.s	SaveBitNotSet
	bset	d1,d7
SaveBitNotSet:	addq.b	#1,d1
	dbra	d0,CreateSaveBitTable
	lea	-298(sp),sp
	move.l	a0,a2
	move.l	a1,a3
	moveq	#FastTrackerId-XIId-1,d0
	lea	XIId(pc),a0
	move.l	sp,a1
SaveXIIdLoop:	move.b	(a0)+,(a1)+
	dbra	d0,SaveXIIdLoop
	move.l	a1,a0
	moveq	#(43-21)-1,d0
StoreSpaces:	move.b	#" ",(a0)+
	dbra	d0,StoreSpaces
	move.b	#26,(a0)+
	moveq	#(TuComposerId-FastTrackerId)>>2-1,d0
	lea	TuComposerId(pc),a4
	btst	#2,d7
	beq.s	CopyTCNameLoop
	lea	FastTrackerId(pc),a4
CopyTCNameLoop:	move.l	(a4)+,(a0)+
	dbra	d0,CopyTCNameLoop
	move.w	#$0201,(a0)+
	moveq	#96-1,d1
	move.l	tci_KeyboardDefs(a3),d0
	beq.s	ClearKeyboardLoop
	move.l	d0,a4
	addq.l	#8,a4
SaveKeyboardLoop:	move.b	1(a4),(a0)+
	addq.l	#4,a4
	dbra	d1,SaveKeyboardLoop
	bra.s	SaveKeyboardDone
ClearKeyboardLoop:	clr.b	(a0)+
	dbra	d1,ClearKeyboardLoop
SaveKeyboardDone:	lea	258(sp),a4
	move.w	#$0606,(a4)+
	move.l	#$02030502,(a4)+
	move.l	#$03050000,(a4)
	move.l	tci_VolumeEnvelope(a3),d0
	beq	SaveDefaultVolEnv
	move.l	d0,a4
	moveq	#0,d0
	move.w	tcie_NumPoints(a4),d0
	moveq	#12,d1
	cmp.w	d1,d0
	bcc.s	Div12Env
	move.w	d0,d1
Div12Env:	move.b	d1,258(sp)
	move.w	tcie_SustainEnd(a4),d6
	mulu.w	d1,d6
	divu.w	d0,d6
	move.b	d6,260(sp)
	move.w	tcie_LoopStart(a4),d6
	mulu.w	d1,d6
	divu.w	d0,d6
	move.b	d6,261(sp)
	move.w	tcie_LoopEnd(a4),d6
	mulu.w	d1,d6
	divu.w	d0,d6
	move.b	d6,262(sp)
	moveq	#1,d6
	btst	#TCIEB_Loop,tcie_Flags+1(a4)
	beq.s	NotVolEnvLoop
	addq.b	#4,d6
NotVolEnvLoop:	btst	#TCIEB_Sustain,tcie_Flags+1(a4)
	beq.s	NotVolEnvSustain
	addq.b	#2,d6
NotVolEnvSustain:	move.b	d6,266(sp)
	divu.w	d1,d0
	move.l	d1,d2
	move.w	d0,d4
	moveq	#0,d5
	swap	d0
	sub.l	a5,a5
	move.l	tcie_Data(a4),a4
ConvertVolEnvLoop:	move.w	d5,d3
	move.w	a5,d6
	beq.s	NotNextVol
	addq.w	#1,d3
NotNextVol:	move.w	(a4,d3.w*2),d6
	ext.l	d6
	divs.w	#$7fff/32,d6
	add.w	#32,d6
	rol.w	#8,d3
	rol.w	#8,d6
	move.w	d3,(a0)+
	move.w	d6,(a0)+
	add.w	d4,d5
	add.w	d0,a5
	cmp.w	d1,a5
	bcs.s	NotIncVolEnv
	addq.w	#1,d5
	sub.w	d1,a5
NotIncVolEnv:	subq.w	#1,d2
	bne.s	ConvertVolEnvLoop
	moveq	#12,d2
	sub.w	d1,d2
ClearRemainVol:	subq.w	#1,d2
	bcs.s	SaveVolEnvDone
	move.w	d3,(a0)+
	move.w	d6,(a0)+
	bra.s	ClearRemainVol
SaveDefaultVolEnv:	moveq	#12-1,d0
	lea	DefaultVolEnv(pc),a4
SaveDefaultVolEnvLoop:	move.l	(a4)+,(a0)+
	dbra	d0,SaveDefaultVolEnvLoop
SaveVolEnvDone:	move.l	tci_PanningEnvelope(a3),d0
	beq	SaveDefaultPanEnv
	move.l	d0,a4
	moveq	#0,d0
	move.w	tcie_NumPoints(a4),d0
	moveq	#12,d1
	cmp.w	d1,d0
	bcc.s	Div12PanEnv
	move.w	d0,d1
Div12PanEnv:	move.b	d1,259(sp)
	move.w	tcie_SustainEnd(a4),d6
	mulu.w	d1,d6
	divu.w	d0,d6
	move.b	d6,263(sp)
	move.w	tcie_LoopStart(a4),d6
	mulu.w	d1,d6
	divu.w	d0,d6
	move.b	d6,264(sp)
	move.w	tcie_LoopEnd(a4),d6
	mulu.w	d1,d6
	divu.w	d0,d6
	move.b	d6,265(sp)
	moveq	#1,d6
	btst	#TCIEB_Loop,tcie_Flags+1(a4)
	beq.s	NotPanEnvLoop
	addq.b	#4,d6
NotPanEnvLoop:	btst	#TCIEB_Sustain,tcie_Flags+1(a4)
	beq.s	NotPanEnvSustain
	addq.b	#2,d6
NotPanEnvSustain:	move.b	d6,267(sp)
	divu.w	d1,d0
	move.l	d1,d2
	move.w	d0,d4
	moveq	#0,d5
	swap	d0
	sub.l	a5,a5
	move.l	tcie_Data(a4),a4
ConvertPanEnvLoop:	move.w	d5,d3
	move.w	a5,d6
	beq.s	NotNextPan
	addq.w	#1,d3
NotNextPan:	move.w	(a4,d3.w*2),d6
	ext.l	d6
	divs.w	#$7fff/32,d6
	add.w	#32,d6
	bpl.s	ResultOk
	moveq	#0,d6
ResultOk:	cmp.w	#64,d6
	bcs.s	MaxPanOk
	moveq	#64,d6
MaxPanOk:	rol.w	#8,d3
	rol.w	#8,d6
	move.w	d3,(a0)+
	move.w	d6,(a0)+
	add.w	d4,d5
	add.w	d0,a5
	cmp.w	d1,a5
	bcs.s	NotIncPanEnv
	addq.w	#1,d5
	sub.w	d1,a5
NotIncPanEnv:	subq.w	#1,d2
	bne.s	ConvertPanEnvLoop
	moveq	#12,d2
	sub.w	d1,d2
ClearRemainPan:	subq.w	#1,d2
	bcs.s	SavePanEnvDone
	move.w	d3,(a0)+
	move.w	d6,(a0)+
	bra.s	ClearRemainPan
SaveDefaultPanEnv:	moveq	#12-1,d0
	lea	DefaultPanEnv(pc),a4
SaveDefaultPanEnvLoop:	move.l	(a4)+,(a0)+
	dbra	d0,SaveDefaultPanEnvLoop
SavePanEnvDone:	move.l	tci_Name(a3),d0
	beq.s	SaveInstNameDone
	moveq	#(43-21)-1,d1
	move.l	d0,a0
SaveInstNameLoop:	move.b	(a0)+,d0
	beq.s	SaveInstNameDone
	move.b	d0,(a1)+
	dbra	d1,SaveInstNameLoop
SaveInstNameDone:	moveq	#0,d0
	lea	tci_Samples(a3),a4
	move.l	(a4),a0
	tst.l	(a0)
	beq.s	NotSaveAutoVibAtAll
	lea	268(sp),a0
	clr.l	(a0)
	move.l	tcs_AutoVibratoEnv(a0),d1
	beq.s	NotSaveAutoVibrato
	move.l	d1,a1
	move.l	tcie_Data(a1),a1
	moveq	#1,d0
	cmp.l	#$0000000f,(a1)
	beq.s	NotSaveAutoVibrato
	moveq	#3,d0
	cmp.l	#$ff81ff81,(a1)
	beq.s	NotSaveAutoVibrato
	moveq	#2,d0
	cmp.l	#$007f007f,(a1)
	beq.s	NotSaveAutoVibrato
	moveq	#0,d0
NotSaveAutoVibrato:	move.l	(a4),a1
	move.b	d0,(a0)+
	move.b	tcs_VibratoSweep(a1),(a0)+
	move.b	tcs_VibratoDepth(a1),d0
	addq.w	#2,d0
	lsr.w	#2,d0
	move.b	d0,(a0)+
	move.b	tcs_VibratoRate(a1),(a0)+
NotSaveAutoVibAtAll:	move.w	tci_FadeOut(a3),d0
	rol.w	#8,d0
	move.w	d0,(a0)+
	moveq	#(296-274)/2-1,d0
ClearReserved:	clr.w	(a0)+
	dbra	d0,ClearReserved
	clr.w	(a0)
	move.b	tci_NumSamples(a3),(a0)
	move.l	a2,d1
	move.l	sp,d2
	move.l	extb_TuComposerBase(a6),a6
	move.l	#298,d3
	jsr	_LVOCWrite(a6)
	cmp.l	d3,d0
	bne	ExternalSaveErr
SaveSamplesLoop:	move.l	(a4),a4
	tst.l	(a4)
	beq	SaveSampleData
	moveq	#0,d3
	move.b	tcs_BitDepth(a4),d3
	addq.b	#7,d3
	and.b	#$f8,d3
	btst	#1,d7
	beq.s	NotForce8Bit
	moveq	#16,d3
	cmp.b	tcs_BitDepth(a4),d3
	beq.s	NotForce8Bit
	moveq	#8,d3
NotForce8Bit:	lsr.b	#3,d3
	move.l	sp,a0
	move.l	tcs_Samples(a4),d0
	mulu.l	d3,d0
	rol.w	#8,d0
	swap	d0
	rol.w	#8,d0
	move.l	d0,(a0)+
	movem.l	tcs_Repeat(a4),d0-d1
	mulu.l	d3,d0
	mulu.w	d3,d1
	rol.w	#8,d0
	rol.w	#8,d1
	swap	d0
	swap	d1
	rol.w	#8,d0
	rol.w	#8,d1
	move.l	d0,(a0)+
	move.l	d1,(a0)+
	moveq	#0,d0
	move.b	tcs_Volume(a4),d0
	btst	#0,d7
	beq.s	NotConvertSmpVol
	addq.w	#2,d0
	lsr.w	#2,d0
NotConvertSmpVol:	move.b	d0,(a0)+
	move.l	tcs_Rate(a4),d0
	move.l	#8363,d4
	cmp.l	d4,d0
	bcc.s	MoreC4Pitch
	moveq	#13,d1
	move.l	d0,d2
LoopLessPitchC4:	add.l	d2,d2
	sub.b	#12,d1
	cmp.l	d4,d2
	bcs.s	LoopLessPitchC4
	moveq	#-1,d4
	bra.s	FindNotePitch
MoreC4Pitch:	moveq	#-13,d1
LoopPitchC4:	move.l	d0,d2
	lsr.l	#1,d0
	bcc.s	CarryOk
	addq.l	#1,d0
CarryOk:	add.b	#12,d1
	cmp.l	d4,d0
	bcc.s	LoopPitchC4
	moveq	#1,d4
FindNotePitch:	lea	PitchTable(pc),a1
MatchNote:	add.b	d4,d1
	cmp.w	(a1)+,d2
	bgt.s	MatchNote
	move.w	-(a1),d4
	sub.w	d4,d2
	ext.l	d2
	asl.l	#7,d2
	sub.w	-(a1),d4
	divs.w	d4,d2
	add.b	tcs_FineTune(a4),d2
	bvc.s	NotCarryFT
	addq.b	#1,d0
	sub.b	#128,d2
NotCarryFT:	move.b	d2,(a0)+
	moveq	#16,d0
	subq.b	#2,d3
	beq.s	Save16BitSample
	moveq	#0,d0
Save16BitSample:	btst	#TCSB_Loop,tcs_Flags(a4)
	beq.s	SaveNoLoop
	addq.b	#1,d0
	btst	#TCSRB_Pingpong,tcs_RepMode(a4)
	beq.s	SaveNoLoop
	addq.b	#1,d0
SaveNoLoop:	move.b	d0,(a0)+
	move.b	tcs_Panning(a4),(a0)+
	add.b	tcs_Transpose(a4),d1
	move.b	d1,(a0)+
	clr.b	(a0)+
	moveq	#22-1,d1
	move.l	tcs_Name(a4),d0
	beq.s	SaveSampleNameDone
	move.l	d0,a1
SaveSampleName:	move.b	(a1)+,d0
	beq.s	SaveSampleNameDone
	move.b	d0,(a0)+
	dbra	d1,SaveSampleName
	bra.s	SaveNextSample
SaveSampleNameDone:	clr.b	(a0)+
	dbra	d1,SaveSampleNameDone
SaveNextSample:	move.l	a2,d1
	move.l	sp,d2
	moveq	#40,d3
	jsr	_LVOCWrite(a6)
	cmp.l	d3,d0
	bne	ExternalSaveErr
	bra	SaveSamplesLoop
SaveSampleData:	lea	tci_Samples(a3),a4
SaveSampleDataLoop:	move.l	(a4),a4
	move.l	(a4),d0
	beq	ExternalSaveDone
	move.l	a4,a0
	jsr	_LVODupSample(a6)
	move.l	d0,d1
	beq	ExternalSaveNoMem
	move.l	d0,a5
	moveq	#0,d3
	move.b	tcs_BitDepth(a5),d3
	addq.b	#7,d3
	and.b	#$f8,d3
	btst	#1,d3
	beq.s	NotForce8BitData
	moveq	#16,d3
	cmp.b	tcs_BitDepth(a5),d3
	beq.s	NotForce8BitData
	moveq	#8,d3
NotForce8BitData:	move.l	d3,d0
	moveq	#0,d1
	move.l	a5,a0
	jsr	_LVOConvertBits(a6)
	tst.l	d0
	bne.s	ExternalSaveKeepErr
	move.l	tcs_Samples(a5),d0
	moveq	#0,d4
	move.l	tcs_Data(a5),d2
	move.l	d2,a0
	subq.b	#8,d3
	bne.s	Delta16BitSmp
Delta8BitSmp:	move.b	(a0),d1
	sub.b	d4,d1
	move.b	d1,(a0)+
	add.b	d1,d4
	subq.l	#1,d0
	bne.s	Delta8BitSmp
DeltaDone:	tst.b	d3
	beq.s	NotConvertToIntel
	move.l	a5,a0
	jsr	_LVOConvertWord(a6)
NotConvertToIntel:	move.l	a2,d1
	move.l	tcs_Length(a5),d3
	jsr	_LVOCWrite(a6)
	cmp.l	d3,d0
	bne.s	ExternalSaveIoErr
	move.l	a5,a0
	jsr	_LVOFreeSample(a6)
	bra.s	SaveSampleDataLoop
Delta16BitSmp:	move.w	(a0),d1
	sub.w	d4,d1
	move.w	d1,(a0)+
	add.w	d1,d4
	subq.l	#1,d0
	bne.s	Delta16BitSmp
	bra.s	DeltaDone
ExternalSaveDone:	lea	298(sp),sp
	movem.l	(sp)+,d2-d7/a2-a6
	rts
ExternalSaveKeepErr:	move.l	d0,d2
	move.l	a5,a0
	jsr	_LVOFreeSample(a6)
	move.l	d2,d0
	bra.s	ExternalSaveDone
ExternalSaveIoErr:	move.l	a5,a0
	jsr	_LVOFreeSample(a6)
ExternalSaveErr:	moveq	#ERROR_INSTR_IOERR,d0
	bra.s	ExternalSaveDone
ExternalSaveNoMem:	moveq	#ERROR_INSTR_NOMEM,d0
	bra.s	ExternalSaveDone
;	INPUT
;	A0.L	=	APTR to cruncher file handle from where to get the info
;	A1.L	=	APTR to instrument info structure where to put information
;	D0.L	=	Number of instrument to be scanned (NULL is the first)
;	OUTPUT
;	D0.L	=	Any non-zero value for success, NULL for error.
ExternalInstrGetInfo:	movem.l	d2-d3/a2/a6,-(sp)
	move.l	a0,d1
	move.l	#298,d3
	sub.l	d3,sp
	move.l	sp,d2
	move.l	a1,a2
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalGetInfoError
	cmp.w	#$0201,64(sp)
	bne	ExternalGetInfoWrongVersion
	moveq	#0,d0
	move.b	65(sp),ii_Version(a2)
	move.b	64(sp),ii_Revision(a2)
	move.b	258(sp),d0
	move.w	(162-4.w,sp,d0.w*4),d1
	rol.w	#8,d1
	move.w	d1,ii_VolumeEnvelope(a2)
	move.b	259(sp),d0
	move.w	(210-4.w,sp,d0.w*4),d1
	rol.w	#8,d1
	move.w	d1,ii_PanningEnvelope(a2)
	move.b	296(sp),ii_NumSamples(a2)
	move.w	272(sp),d0
	rol.w	#8,d0
	move.w	d0,ii_FadeOut(a2)
	st	ii_GlobalVolume(a2)
	move.b	#DEFAULTPITCHPANCENTER,ii_PitchPanCenter(a2)
	move.b	#DEFAULTSAMPLEPANNING,ii_DefaultPanning(a2)
	moveq	#64,d0
	move.w	d0,ii_VibratoEnvelope(a2)
	move.w	d0,ii_TremoloEnvelope(a2)
	moveq	#96-1,d0
	lea	66(sp),a0
CheckKeyboardTable:	tst.b	(a0)+
	dbne	d0,CheckKeyboardTable
	beq.s	NoKeyboardRequired
	move.w	#120,ii_KeyboardDefs(a2)
NoKeyboardRequired:	lea	21(sp),a1
	lea	22(a1),a0
	clr.b	(a0)
FindNotGetSpc:	cmp.l	a1,a0
	beq.s	FindGetSpcDone
	cmp.b	#" ",-(a0)
	bne.s	FindGetSpcDone
	clr.b	(a0)
	bra.s	FindNotGetSpc
FindGetSpcDone:	lea	ii_Name(a2),a0
	jsr	_LVOSetString(a6)
	move.l	a2,d0
ExternalGetInfoDone:	add.l	d3,sp
	movem.l	(sp)+,d2-d3/a2/a6
	rts
ExternalGetInfoError:	moveq	#0,d0
	bra.s	ExternalGetInfoDone
ExternalGetInfoWrongVersion:	moveq	#255-ERROR_ACTION_NOT_KNOWN,d1
	not.b	d1
	move.l	tcb_DOSBase(a6),a6
	jsr	_LVOSetIoErr(a6)
	bra.s	ExternalGetInfoError
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	Number of instruments found or NULL on any error
ExternalInstrGetNums:	moveq	#1,d0
	rts
PitchTable:	dc.w	8363,8860,9395,9943,10559,11186,11852,12559,13306,14092,14914,15786,16726

	cnop	0,4

DefaultVolEnv:	dc.l	$00003000,$04004000,$08002c00,$0e000800
	dc.l	$18001600,$20000800,$3c000000,$46000000
	dc.l	$50000000,$5a000000,$64000000,$6e000000
DefaultPanEnv:	dc.l	$00002000,$0a002800,$1e001800,$32002000
	dc.l	$3c002000,$46002000,$50002000,$5a002000
	dc.l	$64002000,$6e002000,$78002000,$82002000

ExtInstrLibBase:	dc.l	0

LoadFlags:	dc.w	8
	dc.w	LoadFlagSize
	dc.l	LoadText0
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0	
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText1
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText2
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText3
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText4
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	LoadText5
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	LoadText6
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	LoadText7
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
LoadText0:	dc.b	'Load samples',0
LoadText1:	dc.b	'Add envelopes to beginning',0
LoadText2:	dc.b	'Create volume envelope',0
LoadText3:	dc.b	'Create panning envelope',0
LoadText4:	dc.b	'Create vibrato envelope',0
LoadText5:	dc.b	'Create tremolo envelope',0
LoadText6:	dc.b	'Create auto vibrato envelope',0
LoadText7:	dc.b	'Convert volumes',0
	even
LoadFlagSize:	equ	*-LoadFlags
SaveFlags:	dc.w	3
	dc.w	SaveFlagSize
	dc.l	SaveText0
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0	
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	SaveText1
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0	
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	SaveText2
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0	
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
SaveText0:	dc.b	'Convert volumes',0
SaveText1:	dc.b	'Save non-16 bit samples as 8 bit',0
SaveText2:	dc.b	'Save FastTracker v2.00 ID',0
SaveFlagSize:	equ	*-SaveFlags
LoadDescript:	dc.b	'FastTracker ][ Instrument (XI)',0
XIId:	dc.b	'Extended Instrument: '
FastTrackerId:	dc.b	'FastTracker v2.00   '
TuComposerId:	dc.b	'TuComposer v1.00    '
