*************************************************************
***      TuComposer External Module Library for XM        ***
***           1997 by The united Coders (TuC)            ***
***                 Main code: Basty/TuC                  ***
***    This is a XM module loader. It loads the famous    ***
***        FastTracker ][ Modules into TuComposer.        ***
*************************************************************

	IFND	_G2
	MACHINE	MC68020
	OPT	NODEBUG,NOLINE
	ENDC

	include	"exec/types.i"
	include	"exec/execbase.i"
	include	"exec/exec_lib.i"
	include	"exec/initializers.i"
	include	"exec/memory.i"
	include	"exec/resident.i"
	include	"exec/libraries.i"
	include	"libraries/dos.i"
	include	"libraries/dos_lib.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/module.i"
	include	"tucomposer/song.i"
	include	"tucomposer/position.i"
	include	"tucomposer/track.i"
	include	"tucomposer/instr.i"
	include	"tucomposer/sample.i"
	include	"tucomposer/external/external.i"
	include	"tucomposer/external/external_lib.i"
	include	"tucomposer/external/module.i"
	include	"tucomposer/external/module_lib.i"

	moveq	#-1,d0
	rts
ResidentStruct:	dc.w	RTC_MATCHWORD
	dc.l	ResidentStruct
	dc.l	0
	dc.b	RTF_AUTOINIT
	dc.b	EXTLIB_MODULE_VERSION
	dc.b	NT_LIBRARY
	dc.b	0
	dc.l	LibName
	dc.l	LibID
	dc.l	Init
LibName:	dc.b	'xm.library',0
LibID:	dc.b	'TuComposer External Module Loader Version 1.00 (v31) for XM (68020+, OS2.0+) (05 May 97) by Basty/TuC.',0
TuComposerName:	dc.b	'tucomposer.library',0
	even
Init:	dc.l	extb_SIZEOF
	dc.l	FuncTab
	dc.l	DataTab
	dc.l	PrepareLibrary

FuncTab:	dc.w	-1
	dc.w	Open-FuncTab
	dc.w	Close-FuncTab
	dc.w	Expunge-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalInitialize-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalModuleIdentify-FuncTab
	dc.w	ExternalModuleLoad-FuncTab
	dc.w	ExternalModuleSave-FuncTab
	dc.w	ExternalModuleGetInfo-FuncTab
	dc.w	ExternalModuleGetNums-FuncTab
	dc.w	-1

DataTab:	INITLONG	LN_NAME,LibName
	INITBYTE	LIB_FLAGS,LIBF_CHANGED|LIBF_SUMUSED
	INITWORD	LIB_VERSION,EXTLIB_MODULE_VERSION
	INITWORD	LIB_REVISION,EXTLIB_REVISION
	INITLONG	LIB_IDSTRING,LibID
	dc.l	0

PrepareLibrary:	btst	#AFB_68020,AttnFlags+1(a6)	
	beq.s	ExtLib
	cmp.w	#37,LIB_VERSION(a6)
	blt.s	ExtLib
	move.l	a2,-(sp)
	move.l	d0,a2
	move.l	a0,extb_SegList(a2)
	moveq	#31,d0
	lea	TuComposerName(pc),a1
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,extb_TuComposerBase(a2)
	beq.s	NoTuCLib
	lea	ExtModuleLibBase(pc),a0
	move.l	a2,(a0)
	move.l	a2,d0
NoTuCLib:	move.l	(sp)+,a2
	rts
Open:	addq.w	#1,LIB_OPENCNT(a6)
	move.l	a6,d0
	rts
Close:	subq.w	#1,LIB_OPENCNT(a6)
	bne.s	ExtLib
	btst	#LIBB_DELEXP,LIB_FLAGS(a6)
	bne.s	Expunge
ExtLib:	moveq	#0,d0
	rts
Expunge:	bset	#LIBB_DELEXP,LIB_FLAGS(a6)
	tst.w	LIB_OPENCNT(a6)
	bne.s	ExtLib
	movem.l	d2/a5-a6,-(sp)
	move.l	extb_ExtLibList(a6),d0
	beq.s	NoExtLibList
	move.l	d0,a0
	clr.l	extl_LibBase(a0)
NoExtLibList:	move.l	extb_TuComposerBase(a6),a1
	move.l	a6,a5
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
	move.l	extb_SegList(a5),d2
	move.l	a5,a1
	jsr	_LVORemove(a6)
	move.l	a5,a1
	moveq	#0,d0
	moveq	#0,d1
	move.w	LIB_NEGSIZE(a5),d1
	sub.l	d1,a1
	move.w	LIB_POSSIZE(a5),d0
	add.l	d1,d0
	jsr	_LVOFreeMem(a6)
	move.l	d2,d0
	movem.l	(sp)+,d2/a5-a6
	rts
;	INPUT
;	A0.L	=	APTR to module external list structure to be initialized
;	OUTPUT
;	D0.L	=	What type of external library is it or NULL if error
ExternalInitialize:	move.l	extb_TuComposerBase(a6),a1
	movem.l	a2/a6,-(sp)
	move.l	a0,d0
	beq.s	ExternalInitDone
	move.l	a1,a6
	move.b	#EXTLF_Loader,extl_Flags(a0)
	move.l	a0,a2
	lea	extl_Descriptor(a0),a0
	lea	LoadDescript(pc),a1
	jsr	_LVOSetString(a6)
	tst.l	d0
	beq.s	ExternalInitDone
	lea	LoadFlags(pc),a0
	jsr	_LVOAllocFlagStr(a6)
	move.l	d0,extl_LoadFlagStr(a2)
	beq.s	ExternalInitDone
	moveq	#EXTTYPE_MODULE,d0
ExternalInitDone:	movem.l	(sp)+,a2/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	If failed NULL else any non-zero value
ExternalModuleIdentify:	movem.l	d2-d3/a6,-(sp)
	move.l	a0,d1
	link	a5,#-38
	move.l	sp,d2
	moveq	#38,d3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalModuleIdDone
	cmp.b	#26,37(sp)
	bne.s	ExternalModuleIdDone
	moveq	#FastTrackerId-XMId-1,d1
	lea	XMId(pc),a0
	move.l	sp,a1
IdentifyModuleLoop:	cmp.b	(a0)+,(a1)+
	dbne	d1,IdentifyModuleLoop
	beq.s	ExternalModuleIdOk
ExternalModuleIdDone:	moveq	#0,d0
ExternalModuleIdOk:	unlk	a5
	movem.l	(sp)+,d2-d3/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be loaded
;	A1.L	=	APTR to target module structure or NULL to create new
;	A2.L	=	APTR to loading flag pass structure (Loader specific)
;	D0.L	=	Number of module to be loaded (NULL is the first)
;	OUTPUT
;	D0.L	=	APTR to module structure where loaded module data is
ExternalModuleLoad:	movem.l	d2-d7/a2-a6,-(sp)
	moveq	#4,d0
	moveq	#0,d1
	moveq	#0,d7
CreateBitTable:	tst.l	(a2)+
	beq.s	BitNotSet
	bset	d1,d7
BitNotSet:	addq.b	#1,d1
	dbra	d0,CreateBitTable
	move.l	a0,d1
	lea	-348(sp),sp
	moveq	#80,d3
	move.l	sp,d2
	move.l	d1,a2
	move.l	a1,a3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadErr4
	cmp.w	#$0401,58(sp)
	bne	ExternalLoadWrongVersion
	moveq	#(14-4)/2-1,d0
	lea	60+4(sp),a0
PrepareIntel:	move.w	(a0),d1
	rol.w	#8,d1
	move.w	d1,(a0)+
	dbra	d0,PrepareIntel
	lea	80(sp),a0
	move.l	(a2),d1
	move.l	a0,d2
	move.l	a6,a5
	move.l	tcb_DOSBase(a5),a6
	jsr	_LVOExamineFH(a6)
	move.w	60+4(sp),d0
	mulu.w	60+8(sp),d0
	add.l	d0,d0
	move.l	#MEMF_PUBLIC|MEMF_CLEAR,d1
	move.l	4.w,a6
	jsr	_LVOAllocVec(a6)
	move.l	a5,a6
	move.l	d0,336(sp)
	beq	ExternalLoadErr4
	moveq	#0,d0
	move.w	60+8(sp),d0
	jsr	_LVOAllocTCModule(a6)
	move.l	d0,d1
	beq	ExternalLoadErr3
	move.l	d0,a4
	lea	17(sp),a1
	lea	20(a1),a0
	clr.b	(a0)
FindNotSpc:	cmp.l	a1,a0
	beq.s	FindSpcDone
	cmp.b	#" ",-(a0)
	bne.s	FindSpcDone
	clr.b	(a0)
	bra.s	FindNotSpc
FindSpcDone:	lea	tcm_Name(a4),a0
	jsr	_LVOSetString(a6)
	lea	tcm_BeginDate(a4),a0
	lea	80+fib_DateStamp(sp),a1
	jsr	_LVOStamp2Date(a6)
	lea	tcm_EndDate(a4),a0
	lea	80+fib_DateStamp(sp),a1
	jsr	_LVOStamp2Date(a6)
	moveq	#0,d0
	move.w	60+8(sp),d0
	moveq	#1,d1
	moveq	#1,d2
	jsr	_LVOAllocSong(a6)
	move.l	d0,d1
	beq	ExternalLoadErr2
	move.l	d0,a1
	moveq	#0,d0
	btst	#0,60+14(sp)
	beq.s	AmigaFreqTable
	moveq	#TCSOF_LinearFreqTable,d0
AmigaFreqTable:	move.b	d0,tcso_Flags(a1)
	moveq	#TCSOCF_Sync,d0
	btst	#2,d7
	bne.s	UseOldVolumes
	addq.b	#TCSOCF_OldVolumes,d0
UseOldVolumes:	move.b	d0,tcso_CompFlags(a1)
	movem.w	60+16(sp),d0-d1
	rol.w	#8,d0
	bne.s	DefTempoOk
	moveq	#6,d0
DefTempoOk:	move.w	d0,tcso_Frames(a1)
	rol.w	#8,d1
	move.w	d1,tcso_BPMSpeed(a1)
	move.l	a4,a0
	jsr	_LVOAddSong(a6)
	lea	([tcm_SongList.w,a4],tcso_Name.w),a0
	move.l	tcm_Name(a4),a1
	jsr	_LVOSetString(a6)
	lea	([tcm_SongList.w,a4],tcso_BeginDate.w),a0
	lea	80+fib_DateStamp(sp),a1
	jsr	_LVOStamp2Date(a6)
	lea	([tcm_SongList.w,a4],tcso_EndDate.w),a0
	lea	80+fib_DateStamp(sp),a1
	jsr	_LVOStamp2Date(a6)
	move.l	a2,d1
	lea	80(sp),a0
	move.l	a0,d2
	move.w	#256,d3
	jsr	_LVOCRead(a6)
	move.w	60+4(sp),d0
	move.w	60+8(sp),d2
	move.w	60+10(sp),d4
	moveq	#0,d5
	lea	80(sp),a0
	move.l	336(sp),a1
GetTrackReMapNums:	moveq	#0,d1
	move.b	(a0)+,d1
	cmp.w	d4,d1
	blo.s	NotMoreOrders
	move.w	d1,d4
	addq.w	#1,d4
NotMoreOrders:	move.w	d2,d3
	mulu.w	d3,d1
GetTrackReMapLoop:	move.w	d1,(a1)+
	addq.w	#1,d1
	subq.w	#1,d3
	bne.s	GetTrackReMapLoop
	subq.w	#1,d0
	bne.s	GetTrackReMapNums
	move.l	a4,28(sp)
	move.l	#-(256+20),d2
	move.l	60(sp),d3
	rol.w	#8,d3
	swap	d3
	rol.w	#8,d3
	add.l	d3,d2
	beq.s	DecrunchPatternLoop
	move.l	a2,d1
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalLoadErr2
DecrunchPatternLoop:	move.w	#64,5(sp)
	moveq	#0,d6
	cmp.w	60+10(sp),d5
	bhs.s	IsEmptyPattern
	move.l	a2,d1
	move.l	sp,d2
	moveq	#9,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadErr2
	moveq	#-9,d2
	move.l	(sp),d3
	rol.w	#8,d3
	swap	d3
	rol.w	#8,d3
	add.l	d3,d2
	beq.s	NotSeekToPattData
	move.l	a2,d1
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalLoadErr2
NotSeekToPattData:	move.w	5(sp),d0
	rol.w	#8,d0
	move.w	d0,5(sp)
	move.w	7(sp),d6
	rol.w	#8,d6
	move.l	d6,d0
	bne.s	NotEmptyPattern
IsEmptyPattern:	move.w	60+8(sp),d0
	mulu.w	5(sp),d0
	moveq	#MEMF_PUBLIC,d1
	move.l	4.w,a6
	jsr	_LVOAllocVec(a6)
	move.l	a5,a6
	move.l	d0,d2
	beq	ExternalLoadErr2
	move.l	d2,a1
	move.w	60+8(sp),d0
	mulu.w	5(sp),d0
MakeEmptyPattern:	move.b	#$80,(a1)+
	subq.w	#1,d0
	bne.s	MakeEmptyPattern
	bra.s	DePackPattern
NotEmptyPattern:	moveq	#MEMF_PUBLIC,d1
	move.l	4.w,a6
	jsr	_LVOAllocVec(a6)
	move.l	a5,a6
	move.l	d0,d2
	beq	ExternalLoadErr2
DePackPattern:	move.l	a2,d1
	move.l	d6,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadError
	move.w	60+8(sp),d3
AllocTrackLoop:	moveq	#0,d0
	move.w	5(sp),d0
	jsr	_LVOAllocTrack(a6)
	move.l	d0,d1
	beq	ExternalLoadError
	move.l	d0,a1
	move.l	tcm_SongList(a4),a0
	move.b	#TCTCF_Slide|TCTCF_OpSlide|TCTCF_VolSlide,tct_CompFlags(a1)
	jsr	_LVOAddTrack(a6)
	subq.w	#1,d3
	bne.s	AllocTrackLoop
	movem.l	d4-d6/a2-a4/a6,8(sp)
	move.w	5(sp),d4
	moveq	#0,d5
	move.l	d2,a2
	move.l	tcm_SongList(a4),a3
	lea	tcso_TrackList+MLH_TAIL(a3),a3
GetNextRow:	move.w	60+8(sp),d0
FindCorrectTrack:	move.l	MLN_PRED(a3),a3
	dbra	d0,FindCorrectTrack
DecrunchNextChannel:	move.l	(a3),a3
	tst.l	(a3)
	bne	NotGetNextRow
	addq.l	#tctd_NextRow/2,d5
	addq.l	#tctd_NextRow/2,d5
	subq.w	#1,d4
	bne.s	GetNextRow
	move.l	d2,a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
	movem.l	8(sp),d4-d6/a2-a4/a6
	move.l	tcm_SongList(a4),a4
	lea	tcso_TrackList(a4),a2
CmpMainLoop:	move.l	(a2),a2
	tst.l	(a2)
	beq.s	CmpAllDone
	lea	tcso_TrackList+MLH_TAIL(a4),a3
	move.w	60+8(sp),d0
FindPatternLoop:	move.l	MLN_PRED(a3),a3
	tst.l	MLN_PRED(a3)
	beq.s	CompareTracksLoop
	dbra	d0,FindPatternLoop
CompareTracksLoop:	move.l	(a3),a3
	tst.l	(a3)
	beq.s	CmpMainLoop
	cmp.l	a3,a2
	beq.s	CompareTracksLoop
	move.l	a3,a0
	move.l	a2,a1
	jsr	_LVOCmpTracks(a6)
	tst.l	d0
	bne.s	CompareTracksLoop
	move.l	a4,a0
	move.l	a3,a1
	jsr	_LVOGetTrackNum(a6)
	subq.w	#1,d0
	move.w	d0,d2
	move.l	a3,a0
	jsr	_LVOFreeTrack(a6)
	move.l	a4,a0
	move.l	a2,a1
	jsr	_LVOGetTrackNum(a6)
	subq.w	#1,d0
	move.w	60+4(sp),d1
	mulu.w	60+8(sp),d1
	move.l	336(sp),a0
ReMapOrderList:	cmp.w	(a0),d2
	bne.s	ReMapOrderEqual
	move.w	d0,(a0)
ReMapOrderEqual:	bhs.s	ReMapOrderNotSub
	subq.w	#1,(a0)
ReMapOrderNotSub:	addq.l	#2,a0
	subq.l	#1,d1
	bne.s	ReMapOrderList
	move.l	MLN_PRED(a2),a2
	bra.s	CmpMainLoop
CmpAllDone:	movem.l	20(sp),a2-a4
	addq.w	#1,d5
	cmp.w	d5,d4
	bne	DecrunchPatternLoop
	bra	DecrunchPatternDone
NotGetNextRow:	move.l	tct_Data(a3),a4
	add.l	d5,a4
	clr.l	(sp)
	clr.b	4(sp)
	move.b	(a2)+,d1
	bmi.s	ExternalTrackCompressed
	move.b	d1,(sp)
	move.l	(a2)+,1(sp)
	bra.s	EvaluateTrackData
ExternalTrackCompressed:	lsr.b	#1,d1
	bcc.s	NotNote
	move.b	(a2)+,(sp)
NotNote:	lsr.b	#1,d1
	bcc.s	NotInstr
	move.b	(a2)+,1(sp)
NotInstr:	lsr.b	#1,d1
	bcc.s	NotVolCol
	move.b	(a2)+,2(sp)
NotVolCol:	lsr.b	#1,d1
	bcc.s	NotEffByte
	move.b	(a2)+,3(sp)
NotEffByte:	lsr.b	#1,d1
	bcc.s	EvaluateTrackData
	move.b	(a2)+,4(sp)
EvaluateTrackData:	tst.b	(sp)
	bne.s	InstrOk
	clr.b	1(sp)
InstrOk:	move.l	sp,a1
	moveq	#0,d0
	move.b	(a1)+,d0
	beq.s	NoNote
	cmp.b	#$61,d0
	bne.s	NotKeyoff
	moveq	#255-NOTE_KEYOFF,d0
	not.b	d0
NoNote:	move.w	d0,(a4)+
	bra.s	NoteDone
NotKeyoff:	subq.b	#1,d0
	divu.w	#12,d0
	move.b	d0,(a4)+
	swap	d0
	addq.b	#1,d0
	move.b	d0,(a4)+
NoteDone:	move.b	(a1)+,d0
	move.w	d0,(a4)+
	moveq	#0,d6
	move.b	(a1)+,d6
	sub.b	#$10,d6
	bcs.s	NoVolumeColumn
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d3
	beq.s	NoVolumeColumn
	cmp.b	#$41,d6
	bcc.s	NotSetVolume
	btst	#2,d7
	beq.s	NotVolFF
	lsl.b	#2,d6
	bcc.s	NotVolFF
	moveq	#-1,d6
NotVolFF:	moveq	#FX_SET_VOLUME,d0
	lsl.w	#8,d6
	bra.s	SetVolumeColumn
SpecialVolColExec:	dc.b	FX_VOL_SLD_DOWN,VolSlide-SpecialVolColExec
	dc.b	FX_VOL_SLD_UP,VolSlide-SpecialVolColExec
	dc.b	FX_F_VOLSL_DOWN,VolSlide-SpecialVolColExec
	dc.b	FX_F_VOLSL_UP,VolSlide-SpecialVolColExec
	dc.b	FX_VIBRATO,Vibrato-SpecialVolColExec
	dc.b	FX_VIBRATO,VibRate-SpecialVolColExec
	dc.b	FX_SET_PANNING,Panning-SpecialVolColExec
	dc.b	FX_PAN_SL_LEFT,VibRate-SpecialVolColExec
	dc.b	FX_PAN_SL_RIGHT,VibRate-SpecialVolColExec
	dc.b	FX_TONE_PORTA,VibRate-SpecialVolColExec
VolSlide:	btst	#2,d7
	beq.s	VibRate
	moveq	#8+2,d1
	lsl.w	d1,d6
	rts
Panning:	move.b	d6,d1
	lsl.b	#4,d1
	or.b	d1,d6
VibRate:	lsl.w	#8,d6
Vibrato:	rts
NotSetVolume:	lea	SpecialVolColExec-5*2(pc),a0
	move.l	d6,d1
	lsr.b	#4,d1
	add.l	d1,a0
	add.l	d1,a0
	move.b	(a0)+,d0
	move.b	(a0)+,d1
	ext.w	d1
	and.b	#$f,d6
	jsr	SpecialVolColExec(pc,d1.w)
SetVolumeColumn:	move.l	d3,a1
	move.b	d0,tcte_EffectByte(a1)
	move.w	d6,tcte_DataWord(a1)
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
NoVolumeColumn:	moveq	#0,d0
	lea	3(sp),a1
	move.b	(a1)+,d0
	moveq	#0,d6
	move.b	(a1)+,d6
	cmp.b	#$22,d0
	bcc.s	NoEffect
	cmp.b	#9,d0
	bne.s	NotSmpOffset
	tst.w	tctd_Octave-tctd_Effects(a4)
	beq.s	NoEffect
NotSmpOffset:	movem.w	ProcessFXTable(pc,d0.w*4),d0-d1
	lea	ProcessFXTable(pc),a0
	add.l	d1,a0
	move.w	d6,d1
	jsr	(a0)
	move.w	d6,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	NoEffect
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
NoEffect:	bra	DecrunchNextChannel
ProcessFXTable:	dc.w	FX_ARPEGGIO,AbsArp-ProcessFXTable
	dc.w	FX_PORTA_UP,Porta-ProcessFXTable
	dc.w	FX_PORTA_DOWN,Porta-ProcessFXTable
	dc.w	FX_TONE_PORTA,Porta-ProcessFXTable
	dc.w	FX_VIBRATO,Arpeggio-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,ToneFade-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,VibFade-ProcessFXTable
	dc.w	FX_TREMOLO,Tremolo-ProcessFXTable
	dc.w	FX_SET_PANNING,Porta-ProcessFXTable
	dc.w	FX_SMP_OFF_LOW,Porta-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,VolumeSlide-ProcessFXTable
	dc.w	FX_POS_JUMP,PosJump-ProcessFXTable
	dc.w	FX_SET_VOLUME,SetVolume-ProcessFXTable
	dc.w	FX_PATT_BREAK,PosJump-ProcessFXTable
	dc.w	0,Extended-ProcessFXTable
	dc.w	FX_SET_TEMPO,Tempo-ProcessFXTable
	dc.w	FX_SET_G_VOLUME,SetVolume-ProcessFXTable
	dc.w	FX_G_VOLSL_UP,VolumeSlide-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	FX_DO_KEYOFF,PosJump-ProcessFXTable
	dc.w	$0014,EnvCtrl-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	FX_PAN_SL_RIGHT,PanSlide-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	FX_MULTI_RETRIG,MultiRetrig-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	FX_TREMOR,Tremor-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	FX_OFPORTA_UP-1,XFinePorta-ProcessFXTable
ExtendedFXTable:	dc.w	0,NoFX-ExtendedFXTable
	dc.w	FX_O_PORTA_UP,Porta-ExtendedFXTable
	dc.w	FX_O_PORTA_DOWN,Porta-ExtendedFXTable
	dc.w	FX_EXTEND_CTRL,GlissCtrl-ExtendedFXTable
	dc.w	$0301,EnvCtrl-ExtendedFXTable
	dc.w	FX_SET_TRANSP,SetFineTune-ExtendedFXTable
	dc.w	FX_PATT_LOOP,PosJump-ExtendedFXTable
	dc.w	$0401,EnvCtrl-ExtendedFXTable
	dc.w	USER_EFFECTS,PosJump-ExtendedFXTable
	dc.w	FX_RETRIG_NOTE,PosJump-ExtendedFXTable
	dc.w	FX_F_VOLSL_UP,VolSlide-ExtendedFXTable
	dc.w	FX_F_VOLSL_DOWN,VolSlide-ExtendedFXTable
	dc.w	FX_NOTE_CUT,PosJump-ExtendedFXTable
	dc.w	FX_NOTE_DELAY,PosJump-ExtendedFXTable
	dc.w	FX_PATT_DELAY,PosJump-ExtendedFXTable
	dc.w	FX_INVERT_LOOP,PosJump-ExtendedFXTable
DecrunchPatternDone:	movem.w	60+4(sp),d2-d4
	move.w	d4,d6
	move.l	336(sp),a2
	move.l	tcm_SongList(a4),a4
	move.l	tcso_Position(a4),a3
SetOrderList:	moveq	#0,d5
SetPositions:	jsr	_LVOAllocPositionList(a6)
	move.l	d0,d1
	beq	ExternalLoadErr1
	move.l	d0,a1
	moveq	#0,d0
	move.l	a3,a0
	jsr	_LVOAddPositionList(a6)
	move.w	d5,d1
	mulu.w	d6,d1
	moveq	#0,d0
	move.w	(a2,d1.l*2),d0
	addq.l	#1,d0
	move.l	a4,a0
	jsr	_LVOGetTrackAddr(a6)
	move.l	MLH_TAILPRED(a3),a0
	move.l	d0,tcol_Track(a0)
NotSetNextOrder:	move.l	MLN_PRED(a0),a1
	tst.l	MLN_PRED(a1)
	beq.s	NotSetPrevOrder
	move.l	a1,tcol_PrevPos(a0)
	move.l	a0,tcol_NextPos(a1)
NotSetPrevOrder:	addq.w	#1,d5
	cmp.w	d5,d2
	bne.s	SetPositions
	move.l	MLH_TAILPRED(a3),a0
	move.l	(a3),a1
	move.l	a1,tcol_PrevPos(a1)
	move.l	a1,tcol_NextPos(a0)
	move.w	d3,tco_RepStart(a3)
	lea	tco_NextOrderx(a3),a3
	addq.l	#2,a2
	subq.w	#1,d4
	bne.s	SetOrderList
	movem.l	20(sp),a2-a4
	moveq	#0,d3
	clr.l	320(sp)
	move.l	#$80000100,d2
	moveq	#DEFAULT_ENVNODES,d4
	btst	#1,d7
	beq.s	NoVibratoEnvelopes
	moveq	#64,d0
	moveq	#ENVL_SINE,d1
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,320(sp)
	beq	ExternalLoadErr2
	move.l	d0,a1
	bset	#TCIEB_Loop,tcie_Flags+1(a1)
	move.w	tcie_NumPoints(a1),tcie_LoopEnd(a1)
	subq.w	#1,tcie_LoopEnd(a1)
	move.l	a4,a0
	jsr	_LVOAddEnvelope(a6)
	moveq	#64,d0
	moveq	#ENVL_RAMP,d1
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,d1
	beq	ExternalLoadErr2
	move.l	d0,a1
	bset	#TCIEB_Loop,tcie_Flags+1(a1)
	move.w	tcie_NumPoints(a1),tcie_LoopEnd(a1)
	subq.w	#1,tcie_LoopEnd(a1)
	move.l	a4,a0
	jsr	_LVOAddEnvelope(a6)
	moveq	#64,d0
	moveq	#ENVL_SQUARE,d1
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,d1
	beq	ExternalLoadErr2
	move.l	d0,a1
	bset	#TCIEB_Loop,tcie_Flags+1(a1)
	move.w	tcie_NumPoints(a1),tcie_LoopEnd(a1)
	subq.w	#1,tcie_LoopEnd(a1)
	move.l	a4,a0
	jsr	_LVOAddEnvelope(a6)
NoVibratoEnvelopes:		movem.l	a2-a4,324(sp)
	move.w	60+12(sp),318(sp)
	beq	LoadInstrDone
LoadInstrLoop:	move.l	a2,d1
	move.l	sp,d2
	moveq	#29,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadErr2
	moveq	#0,d0
	jsr	_LVOAllocInstr(a6)
	move.l	d0,d1
	beq	ExternalLoadErr2
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddInstr(a6)
	move.l	tcm_InstrList+MLH_TAILPRED(a4),a3
	lea	tci_Name(a3),a0
	lea	4(sp),a1
	jsr	_LVOSetString(a6)
	moveq	#-29,d2
	tst.w	27(sp)
	beq	SkipInstrHeader
	move.l	a2,d1
	lea	29(sp),a0
	move.l	a0,d2
	move.w	#241-29,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadErr2
	move.l	#-241,d2
	move.l	(sp),d3
	rol.w	#8,d3
	swap	d3
	rol.w	#8,d3
	add.l	d3,d2
	beq.s	NoSkipInstrSeek
	move.l	a2,d1
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalLoadErr2
NoSkipInstrSeek:	move.l	320(sp),d0
	lea	tci_VibratoEnvelope(a3),a0
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)
	btst	#0,233(sp)
	bne.s	NotEmptyVolEnvData
	move.b	#2,225(sp)
	move.l	#$00004000,129(sp)
	move.l	#$01000000,133(sp)
	clr.b	227(sp)
	clr.w	228(sp)
NotEmptyVolEnvData:	moveq	#0,d0
	moveq	#0,d1
	moveq	#32,d6
	move.l	a5,(sp)
	move.b	225(sp),d1
	beq	NotConvertVolEnvData
	move.l	d1,d4
	subq.b	#1,d1
	beq	NotConvertVolEnvData
	move.b	d1,d2
ConvertVolGetHighest:	move.w	(129.w,sp,d1.w*4),d3
	rol.w	#8,d3
	addq.l	#1,d3
	cmp.w	d3,d0
	bhs.s	ConvertVolIsHighest
	move.w	d3,d0
ConvertVolIsHighest:	dbra	d1,ConvertVolGetHighest
	moveq	#ENVL_EMPTY,d1
	moveq	#0,d3
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,tci_VolumeEnvelope(a3)
	beq	ExternalLoadErr2
	move.l	d0,a1
	move.l	332(sp),a0
	jsr	_LVOAddEnvelope(a6)
	lea	129(sp),a0
	move.l	tci_VolumeEnvelope(a3),a1
	moveq	#TCIEF_Sustain,d0
	btst	#0,233(sp)
	beq.s	NotLoopEnv
	moveq	#TCIEF_Loop|TCIEF_Sustain,d0
	btst	#1,233(sp)
	beq.s	NotSusLoopEnv
	btst	#2,233(sp)
	beq.s	SetEnvNoSusLoop
	bra.s	NotLoopEnv
NotSusLoopEnv:	moveq	#TCIEF_Loop,d0
	btst	#2,233(sp)
	bne.s	NotLoopEnv
SetEnvNoSusLoop:	move.b	d2,228(sp)
	move.b	d2,229(sp)
NotLoopEnv:	move.b	d0,tcie_Flags+1(a1)
	moveq	#0,d1
	move.b	227(sp),d1
	move.w	(a0,d1.w*4),d0
	rol.w	#8,d0
	move.w	d0,tcie_SustainStart(a1)
	move.w	d0,tcie_SustainEnd(a1)
	move.b	228(sp),d1
	move.w	(a0,d1.w*4),d0
	rol.w	#8,d0
	move.w	d0,tcie_LoopStart(a1)
	move.b	229(sp),d1
	move.w	(a0,d1.w*4),d0
	rol.w	#8,d0
	move.w	d0,tcie_LoopEnd(a1)
	move.l	tcie_NodePoints(a1),a5
	move.l	tcie_Data(a1),a1
ConvertEnvelopeData:	move.w	(a0)+,d0
	rol.w	#8,d0
	move.w	d0,(a5)+
	move.w	(a0)+,d1
	rol.w	#8,d1
	sub.w	d6,d1
	muls.w	#$7fff,d1
	asr.l	#5,d1
	move.w	(a0),d3
	rol.w	#8,d3
	bne.s	NotNullLastVol
	move.w	d0,d3
	addq.w	#1,d3
NotNullLastVol:	move.w	2(a0),d4
	rol.w	#8,d4
	sub.w	d6,d4
	muls.w	#$7fff,d4
	asr.l	#5,d4
	sub.w	d0,d3
	bls.s	NotNullLastVol2
	sub.l	d1,d4
	divs.w	d3,d4
	move.w	d3,d0
	moveq	#0,d5
	cmp.b	#1,d2
	bne.s	AddEnvelopeData
	addq.w	#1,d0
AddEnvelopeData:	move.w	d1,(a1)+
	add.w	d4,d1
	swap	d4
	add.w	d4,d5
	bpl.s	NotSubEnvData
	add.w	d3,d5
	subq.w	#1,d1
NotSubEnvData:	cmp.w	d3,d5
	bcs.s	NotAddEnvData
	sub.w	d3,d5
	addq.w	#1,d1
NotAddEnvData:	swap	d4
	subq.w	#1,d0
	bne.s	AddEnvelopeData
NotNullLastVol2:	subq.b	#1,d2
	bne.s	ConvertEnvelopeData
	move.l	tci_VolumeEnvelope(a3),a0
	jsr	_LVOValidateEnvNodes(a6)
NotConvertVolEnvData:	moveq	#0,d0
	btst	#0,234(sp)
	beq	NotConvertPanEnvData
	moveq	#0,d1
	move.b	226(sp),d1
	beq	NotConvertPanEnvData
	move.l	d1,d4
	subq.b	#1,d1
	beq	NotConvertPanEnvData
	move.b	d1,d2
ConvertPanGetHighest:	move.w	(177.w,sp,d1.w*4),d3
	rol.w	#8,d3
	addq.l	#1,d3
	cmp.w	d3,d0
	bhs.s	ConvertPanIsHighest
	move.w	d3,d0
ConvertPanIsHighest:	dbra	d1,ConvertPanGetHighest
	moveq	#ENVL_EMPTY,d1
	moveq	#0,d3
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,tci_PanningEnvelope(a3)
	beq	ExternalLoadErr2
	move.l	d0,a1
	move.l	332(sp),a0
	jsr	_LVOAddEnvelope(a6)
	lea	177(sp),a0
	move.l	tci_PanningEnvelope(a3),a1
	moveq	#0,d0
	btst	#1,234(sp)
	beq.s	NotSustainPanEnv
	addq.b	#TCIEF_Sustain,d0
NotSustainPanEnv:	btst	#2,234(sp)
	beq.s	NotLoopPanEnv
	addq.b	#TCIEF_Loop,d0
NotLoopPanEnv:	move.b	d0,tcie_Flags+1(a1)
	moveq	#0,d1
	move.b	230(sp),d1
	move.w	(a0,d1.w*4),d0
	rol.w	#8,d0
	move.w	d0,tcie_SustainStart(a1)
	move.w	d0,tcie_SustainEnd(a1)
	move.b	231(sp),d1
	move.w	(a0,d1.w*4),d0
	rol.w	#8,d0
	move.w	d0,tcie_LoopStart(a1)
	move.b	232(sp),d1
	move.w	(a0,d1.w*4),d0
	rol.w	#8,d0
	move.w	d0,tcie_LoopEnd(a1)
	move.l	tcie_NodePoints(a1),a5
	move.l	tcie_Data(a1),a1
ConvertPanEnvData:	move.w	(a0)+,d0
	rol.w	#8,d0
	move.w	d0,(a5)+
	move.w	(a0)+,d1
	rol.w	#8,d1
	sub.w	d6,d1
	muls.w	#$7fff,d1
	asr.l	#5,d1
	move.w	(a0),d3
	rol.w	#8,d3
	bne.s	NotNullLastPan
	move.w	d0,d3
	addq.w	#1,d3
NotNullLastPan:	move.w	2(a0),d4
	rol.w	#8,d4
	sub.w	d6,d4
	muls.w	#$7fff,d4
	asr.l	#5,d4
	sub.w	d0,d3
	bls.s	NotNullLastPan2
	sub.l	d1,d4
	divs.w	d3,d4
	move.w	d3,d0
	moveq	#0,d5
	cmp.b	#1,d2
	bne.s	AddPanEnvData
	addq.w	#1,d0
AddPanEnvData:	move.w	d1,(a1)+
	add.w	d4,d1
	swap	d4
	add.w	d4,d5
	bpl.s	NotSubPanEnvData
	add.w	d3,d5
	subq.w	#1,d1
NotSubPanEnvData:	cmp.w	d3,d5
	bcs.s	NotAddPanEnvData
	sub.w	d3,d5
	addq.w	#1,d1
NotAddPanEnvData:	swap	d4
	subq.w	#1,d0
	bne.s	AddPanEnvData
NotNullLastPan2:	subq.b	#1,d2
	bne.s	ConvertPanEnvData
	move.l	tci_PanningEnvelope(a3),a0
	jsr	_LVOValidateEnvNodes(a6)
NotConvertPanEnvData:	move.l	(sp),a5
	tst.b	236(sp)
	beq.s	NoAutoVibrato
	move.b	235(sp),d0
	cmp.b	#4,d0
	bcc.s	NoAutoVibrato
	move.l	#$80000080,d2
	moveq	#DEFAULT_ENVNODES,d4
	move.b	(AutoVibTab.w,pc,d0.w),d1
	bne.s	NoInvertRamp
	moveq	#ENVL_RAMP,d1
	bclr	#31,d2
NoInvertRamp:	moveq	#64,d0
	lsl.w	#2,d0
	moveq	#0,d3
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,340(sp)
	beq	ExternalLoadErr2
	move.l	d0,a1
	bset	#TCIEB_Loop,tcie_Flags+1(a1)
	move.w	tcie_NumPoints(a1),tcie_LoopEnd(a1)
	subq.w	#1,tcie_LoopEnd(a1)
	move.l	332(sp),a0
	jsr	_LVOAddEnvelope(a6)
NoAutoVibrato:	lea	236(sp),a0
	moveq	#0,d0
	move.b	(a0)+,d0
	neg.b	d0
	bne.s	VibSweepOk
	move.w	#$100,d0
VibSweepOk:	moveq	#0,d1
	move.b	(a0)+,d1
	mulu.w	d1,d0
	move.w	d0,344(sp)
	move.b	d1,346(sp)
	move.b	(a0)+,347(sp)
	move.w	(a0),d0
	rol.w	#8,d0
	move.w	d0,tci_FadeOut(a3)
	btst	#2,d7
	bne.s	NotOldGlobalVolume
	move.b	#64,tci_GlobalVolume(a3)
NotOldGlobalVolume:	moveq	#96-1,d0
	lea	33(sp),a0
CheckLoadKeyboardTable:	tst.b	(a0)+
	dbne	d0,CheckLoadKeyboardTable
	beq.s	NotLoadKeyboard
	jsr	_LVOAllocKeyboard(a6)
	move.l	d0,tci_KeyboardDefs(a3)
	beq	ExternalLoadErr2
	lea	33(sp),a0
	move.l	d0,a1
	moveq	#96-1,d0
	addq.l	#MLN_SIZE,a1
ConvertXIKeyboard:	move.b	(a0)+,d1
	addq.b	#1,d1
	move.b	d1,1(a1)
	addq.l	#4,a1
	dbra	d0,ConvertXIKeyboard
	move.l	a4,a0
	move.l	tci_KeyboardDefs(a3),a1
	jsr	_LVOAddKeyboard(a6)
NotLoadKeyboard:	btst	#0,d7
	beq	NoLoadSamples
	move.b	27(sp),d4
	beq	NoLoadSamples
LoadSamples:	move.l	a2,d1
	lea	128(sp),a0
	move.l	a0,d2
	moveq	#40,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadErr2
	move.l	29(sp),d0
	rol.w	#8,d0
	swap	d0
	rol.w	#8,d0
	moveq	#-40,d2
	add.l	d0,d2
	beq.s	LoadSampleHeaderOk
	moveq	#OFFSET_CURRENT,d3
	move.l	a2,d1
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalLoadErr2
LoadSampleHeaderOk:	moveq	#0,d0
	btst	#0,d7
	beq.s	SampleOk
	move.l	128(sp),d0
	rol.w	#8,d0
	swap	d0
	rol.w	#8,d0
SampleOk:	sub.l	a0,a0
	jsr	_LVOAllocSample(a6)
	move.l	d0,d6
	beq	ExternalLoadErr2
	lea	18+128(sp),a1
	lea	22(a1),a0
	clr.b	(a0)
FindNotSmpSpc:	cmp.l	a1,a0
	beq.s	FindSmpSpcDone
	cmp.b	#" ",-(a0)
	bne.s	FindSmpSpcDone
	clr.b	(a0)
	bra.s	FindNotSmpSpc
FindSmpSpcDone:	move.l	d6,a0
	lea	tcs_Name(a0),a0
	jsr	_LVOSetString(a6)
	move.l	d6,a1
	lea	12+128(sp),a0
	move.b	(a0)+,d0
	btst	#2,d7
	beq.s	NotConvSmpLoadVol
	lsl.b	#2,d0
	bcc.s	NotConvSmpLoadVol
	moveq	#-1,d0
NotConvSmpLoadVol:	move.b	d0,tcs_Volume(a1)
	movem.l	4+128(sp),d0-d1
	rol.w	#8,d0
	swap	d0
	rol.w	#8,d0
	btst	#4,14+128(sp)
	beq.s	Not16BitRepeat
	lsr.l	#1,d0
Not16BitRepeat:	rol.w	#8,d1
	swap	d1
	rol.w	#8,d1
	btst	#4,14+128(sp)
	beq.s	Not16BitRepLen
	lsr.l	#1,d1
Not16BitRepLen:	movem.l	d0-d1,tcs_Repeat(a1)
	moveq	#TCSF_SmpPanning,d1
	move.b	(a0)+,tcs_FineTune(a1)
	move.b	(a0)+,d0
	and.b	#3,d0
	beq.s	NoForwardLoop
	addq.b	#TCSF_Loop,d1
NoForwardLoop:	move.b	d1,tcs_Flags(a1)
	subq.b	#2,d0
	bne.s	NoPingpongLoop
	move.b	#TCSRF_Pingpong,tcs_RepMode(a1)
NoPingpongLoop:	move.b	(a0)+,tcs_Panning(a1)
	move.b	(a0),tcs_Transpose(a1)
	lea	340(sp),a0
	move.l	(a0)+,tcs_AutoVibratoEnv(a1)
	move.w	(a0)+,tcs_VibratoSweep(a1)
	move.w	(a0),tcs_VibratoDepth(a1)
	move.l	a1,d5
	btst	#4,14+128(sp)
	beq.s	Not16BitSmp
	moveq	#16,d0
	moveq	#CBF_ChangeOnly,d1
	move.l	d5,a0
	jsr	_LVOConvertBits(a6)
Not16BitSmp:	move.l	a3,a0
	move.l	d5,a1
	jsr	_LVOAddSample(a6)
	subq.b	#1,d4
	bne	LoadSamples
	lea	tci_Samples(a3),a3
LoadSampleData:	move.l	(a3),a3
	tst.l	(a3)
	beq.s	NoLoadSamples
	move.l	a2,d1
	movem.l	tcs_Data(a3),d2-d3
	jsr	_LVOCRead(a6)
	addq.l	#1,d0
	beq	ExternalLoadErr2
	cmp.b	#16,tcs_BitDepth(a3)
	bne.s	NotIntelOrder
	move.l	a3,a0
	jsr	_LVOConvertWord(a6)
NotIntelOrder:	moveq	#0,d0
	move.l	a3,a0
	jsr	_LVODecrunchSample(a6)
	bra.s	LoadSampleData
SkipInstrHeader:	move.l	(sp),d3
	rol.w	#8,d3
	swap	d3
	rol.w	#8,d3
	add.l	d3,d2
	beq.s	NoLoadSamples
	move.l	a2,d1
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalLoadErr2
NoLoadSamples:	movem.l	324(sp),a2-a4
	subq.w	#1,318(sp)
	bne	LoadInstrLoop
LoadInstrDone:	lea	tcm_Envelopes(a4),a2
CmpEnvMainLoop:	move.l	(a2),a2
	tst.l	(a2)
	beq.s	CmpEnvAllDone
	lea	tcm_Envelopes(a4),a5
CompareEnvsLoop:	move.l	(a5),a5
	tst.l	(a5)
	beq.s	CmpEnvMainLoop
	cmp.l	a5,a2
	beq.s	CompareEnvsLoop
	move.l	a5,a0
	move.l	a2,a1
	jsr	_LVOCmpEnvelopes(a6)
	tst.l	d0
	bne.s	CompareEnvsLoop
	lea	tcm_InstrList(a4),a0
ReplaceInstEnvLoop:	move.l	(a0),a0
	tst.l	(a0)
	beq.s	ReplaceInstEnvDone
	moveq	#(tci_ArpeggioStructure-tci_VolumeEnvelope)/4-1,d0
	lea	tci_VolumeEnvelope(a0),a1
ReMapInstEnvLoop:	cmp.l	(a1)+,a5
	bne.s	NoReMapInstEnv
	move.l	a2,-4(a1)
NoReMapInstEnv:	dbra	d0,ReMapInstEnvLoop
	move.l	a0,-(sp)
	lea	tci_Samples(a0),a0
ReMapInstSmpEnvLoop:	move.l	(a0),a0
	tst.l	(a0)
	beq.s	ReMapInstSmpEnvDone
	moveq	#(tcs_EnvUsageFlags-tcs_AutoVibratoEnv)/4-1,d0
	lea	tcs_AutoVibratoEnv(a0),a1
ReMapInstSmpEnvs:	cmp.l	(a1)+,a5
	bne.s	NoReMapInstSmpEnv
	move.l	a2,-4(a1)
NoReMapInstSmpEnv:	dbra	d0,ReMapInstSmpEnvs
	bra.s	ReMapInstSmpEnvLoop
ReMapInstSmpEnvDone:	move.l	(sp)+,a0
	bra.s	ReplaceInstEnvLoop
ReplaceInstEnvDone:	move.l	a5,a0
	jsr	_LVOFreeEnvelope(a6)
	move.l	MLN_PRED(a2),a2
	bra.s	CmpEnvMainLoop
CmpEnvAllDone:	lea	tcm_KeyboardDefs(a4),a2
CmpKeyMainLoop:	move.l	(a2),a2
	tst.l	(a2)
	beq.s	CmpKeyAllDone
	lea	tcm_KeyboardDefs(a4),a5
CompareKeysLoop:	move.l	(a5),a5
	tst.l	(a5)
	beq.s	CmpKeyMainLoop
	cmp.l	a5,a2
	beq.s	CompareKeysLoop
	move.l	a5,a0
	move.l	a2,a1
	jsr	_LVOCmpKeyboards(a6)
	tst.l	d0
	bne.s	CompareKeysLoop
	lea	tcm_InstrList(a4),a0
ReplaceInstKeyLoop:	move.l	(a0),a0
	tst.l	(a0)
	beq.s	ReplaceInstKeyDone
	cmp.l	tci_KeyboardDefs(a0),a5
	bne.s	ReplaceInstKeyLoop
	move.l	a2,tci_KeyboardDefs(a0)
	bra.s	ReplaceInstKeyLoop
ReplaceInstKeyDone:	move.l	a5,a0
	jsr	_LVOFreeKeyboard(a6)
	move.l	MLN_PRED(a2),a2
	bra.s	CmpKeyMainLoop
CmpKeyAllDone:	move.l	tcm_SongList(a4),a0
	lea	tcso_TrackList(a0),a0
	moveq	#0,d0
	move.l	(a0),a0
	tst.l	(a0)
	beq.s	ScanTrackNullDone
	move.l	a0,a1
	move.w	tct_Length(a1),d1
ScanTrackNullLoop:	addq.l	#1,d0
	move.l	(a0),a0
	tst.l	(a0)
	beq.s	ScanTrackNullDone
	cmp.w	tct_Length(a0),d1
	bne.s	ScanTrackNullLoop
	move.w	d1,d2
	move.l	tct_Data(a0),a2
CheckTrackEmptyLoop:	tst.l	(a2)+
	bne.s	ScanTrackNullLoop
	move.l	(a2),a2
	tst.l	(a2)
	bne.s	ScanTrackNullLoop
	addq.l	#tctd_Effects+MLH_TAIL,a2
	dbra	d2,CheckTrackEmptyLoop
	move.l	a0,a2
	jsr	_LVODeleteTrack(a6)
	move.l	tcm_SongList(a4),a0
	move.l	a2,a1
	sub.l	a2,a2
	jsr	_LVOInsertTrack(a6)
ScanTrackNullDone:	move.l	tcm_SongList(a4),a0
	jsr	_LVOGetOptimalChannels(a6)
	move.l	tcm_SongList(a4),a0
	jsr	_LVOSetSongChannels(a6)
	move.l	a4,a0
	jsr	_LVOGetOptimalVChannels(a6)
	move.l	a4,a0
	jsr	_LVOSetTCMChannels(a6)
	move.l	a3,d0
	bne.s	ModAllocated
	move.l	a4,a3
ModAllocated:	move.l	a4,a0
	move.l	a3,a1
	jsr	_LVOReMapTCModule(a6)
	move.l	336(sp),a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
ExternalLoadDone:	lea	348(sp),sp
	move.l	a3,d0
	movem.l	(sp)+,d2-d7/a2-a6
	rts
ExternalLoadError:	move.l	d2,a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
ExternalLoadErr1:	move.l	28(sp),a4
ExternalLoadErr2:	move.l	a4,a0
	move.l	a5,a6
	jsr	_LVOFreeTCModule(a6)
ExternalLoadErr3:	move.l	336(sp),a1
	move.l	4.w,a6
	jsr	_LVOFreeVec(a6)
ExternalLoadErr4:	sub.l	a3,a3
	bra.s	ExternalLoadDone
ExternalLoadWrongVersion:	moveq	#255-ERROR_ACTION_NOT_KNOWN,d1
	not.b	d1
	move.l	tcb_DOSBase(a5),a6
	jsr	_LVOSetIoErr(a6)
	bra.s	ExternalLoadErr4
Porta:	lsl.w	#8,d6
	rts
ToneFade:	movem.w	d0-d1,-(sp)
	moveq	#FX_TONE_PORTA,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	ToneFadeDone
AddFadeFX:	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
ToneFadeDone:	movem.w	(sp)+,d0-d1
	bra.s	VolumeSlide
VibFade:	movem.w	d0-d1,-(sp)
	moveq	#FX_VIBRATO,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	ToneFadeDone
	bra.s	AddFadeFX
VolumeSlide:	lsr.b	#4,d6
	bne.s	VolSlideUp
	move.b	d1,d6
	and.b	#$f,d6
	addq.b	#1,d0
VolSlideUp:	btst	#2,d7
	beq.s	SetVolOk
	moveq	#8+2,d1
	lsl.w	d1,d6
	rts
AbsArp:	tst.w	d6
	beq.s	NoFX
Arpeggio:	lsl.w	#4,d6
	lsr.b	#4,d6
	rts
Tremolo:	bsr.s	Arpeggio
	btst	#2,d7
	beq.s	PosJump
	lsl.b	#2,d6
	rts
SetVolume:	btst	#2,d7
	beq.s	SetVolOk
	lsl.b	#2,d6
	bcc.s	SetVolOk
	moveq	#-1,d6
SetVolOk:	lsl.w	#8,d6
	rts
Extended:	lea	ExtendedFXTable(pc),a0
	lsr.b	#4,d1
	movem.w	(a0,d1.w*4),d0-d1
	add.l	d1,a0
	move.w	d6,d1
	lsr.b	#4,d1
	and.b	#$f,d6
	jmp	(a0)
NoFX:	addq.l	#4,sp
	bra	NoEffect
Tempo:	cmp.b	#$20,d6
	bcs.s	PosJump
	moveq	#FX_SET_SPEED,d0
	rts
PanSlide:	lsr.b	#4,d6
	bne.s	PanSlideRight
	move.b	d1,d6
	and.b	#$f,d6
	subq.b	#1,d0
PanSlideRight:	lsl.w	#8,d6
	rts
MultiRetrig:	and.b	#$f,d1
	lsl.w	#8,d1
	or.w	d1,d6
	lsr.b	#4,d6
	beq.s	PosJump
	cmp.b	#8,d6
	beq.s	PosJump
	cmp.b	#6,d6
	bcc.s	MulRetrig
	move.b	d6,d1
	moveq	#1,d6
	lsl.b	d1,d6
	lsr.b	#1,d6
	add.b	#$C0-1,d6
	clr.b	d1
	or.w	d1,d6
PosJump:	rts
Tremor:	beq.s	PosJump
	unpk	d6,d6,#$0101
	rts
XFinePorta:	lsr.b	#4,d1
	beq.s	NoFX
	cmp.b	#$3,d1
	bcc.s	NoFX
	add.b	d1,d0
	and.b	#$f,d6
	moveq	#8+2,d1
	lsl.w	d1,d6
	rts
MulRetrig:	subq.b	#6,d6
	bne.s	MulRetr1
	move.b	#$23,d6
	rts
MulRetr1:	subq.b	#2,d6
	bcc.s	AddRetrig
	move.b	#$12,d6
	rts
AddRetrig:	cmp.b	#$6,d6
	beq.s	DivRetr1
	cmp.b	#$7,d6
	beq.s	DivRetr2
	move.b	d6,d1
	moveq	#1,d6
	lsl.b	d1,d6
	lsr.b	#1,d6
	add.b	#$80-1,d6
	clr.b	d1
	or.w	d1,d6
	rts
DivRetr1:	move.b	#$32,d6
	rts
DivRetr2:	move.b	#$21,d6
	rts
Retrig:	moveq	#FX_RETRIG_NOTE,d0
	move.w	d1,d6
	lsr.w	#8,d6
	rts
SetFineTune:	lsl.b	#4,d6
	rts
ExtendControl:	bset	#12,d6
	rts
GlissCtrl:	tst.b	d6
	beq.s	ExtendControl
	move.w	#$1001,d6
	rts
EnvCtrl:	move.w	d0,d3
	cmp.w	#$14,d3
	beq.s	EnvCtrlPos
	cmp.b	#4,d6
	blo.s	NotRetrigEnvSet
	or.b	#$10,d3
NotRetrigEnvSet:	and.w	#3,d6
	cmp.w	#3,d6
	bne.s	NotSquareWave
	moveq	#2,d6
NotSquareWave:	moveq	#FX_ENV_CONTROL,d0
	move.w	d3,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	EnvCtrlDone
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
	clr.b	d3
EnvCtrlPos:	moveq	#FX_ENV_CONTROL,d0
	move.w	d3,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	EnvCtrlDone
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
EnvCtrlDone:	moveq	#FX_SET_ENV_VAL,d0
	rts
ExternalModuleSave:	
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle from where to get the info
;	A1.L	=	APTR to module info structure where to put information
;	D0.L	=	Number of module to be scanned (NULL is the first)
;	OUTPUT
;	D0.L	=	Any non-zero value for success, NULL for error.
ExternalModuleGetInfo:	movem.l	d2-d6/a2-a4/a6,-(sp)
	movem.l	(sp)+,d2-d6/a2-a4/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	Number of modules found or NULL on any error
ExternalModuleGetNums:	moveq	#1,d0
	rts
AutoVibTab:	dc.b	ENVL_SINE,ENVL_SQUARE,0,ENVL_RAMP

	cnop	0,4

ExtModuleLibBase:	dc.l	0

LoadFlags:	dc.w	3
	dc.w	LoadFlagSize
	dc.l	LoadText0
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0	
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText1
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText2
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
LoadText0:	dc.b	'Load samples',0
LoadText1:	dc.b	'Make vibrato envelopes',0
LoadText2:	dc.b	'Convert volumes',0
	even
LoadFlagSize:	equ	*-LoadFlags
LoadDescript:	dc.b	'FastTracker ][ Module (XM)',0
XMId:	dc.b	'Extended Module: '
FastTrackerId:	dc.b	'FastTracker v2.00   '
TuComposerId:	dc.b	'TuComposer v1.00    '
