*******************************************************************
***         TuComposer External Instrument Library for XM       ***
***                 1997 by The united Coders (TuC)            ***
***                       Main code: Basty/TuC                  ***
*** This is a XM instrument loader (loads the instruments from) ***
***                    the FastTracker ][ modules               ***
*******************************************************************

	IFND	_G2
	MACHINE	MC68020
	OPT	NODEBUG,NOLINE
	ENDC

	include	"exec/types.i"
	include	"exec/execbase.i"
	include	"exec/exec_lib.i"
	include	"exec/initializers.i"
	include	"exec/resident.i"
	include	"exec/libraries.i"
	include	"libraries/dos_lib.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/module.i"
	include	"tucomposer/instr.i"
	include	"tucomposer/sample.i"
	include	"tucomposer/external/external.i"
	include	"tucomposer/external/external_lib.i"
	include	"tucomposer/external/instr.i"
	include	"tucomposer/external/instr_lib.i"

	moveq	#-1,d0
	rts
ResidentStruct:	dc.w	RTC_MATCHWORD
	dc.l	ResidentStruct
	dc.l	0
	dc.b	RTF_AUTOINIT
	dc.b	EXTLIB_INSTR_VERSION
	dc.b	NT_LIBRARY
	dc.b	0
	dc.l	LibName
	dc.l	LibID
	dc.l	Init
LibName:	dc.b	'xmi.library',0
LibID:	dc.b	'TuComposer External Instrument Loader Version v1.00 (v31) for XM (68020+, OS2.0+) (19 Mar 97) by Basty/TuC.',0
TuComposerName:	dc.b	'tucomposer.library',0
	even
Init:	dc.l	insl_SIZEOF
	dc.l	FuncTab
	dc.l	DataTab
	dc.l	PrepareLibrary

FuncTab:	dc.w	-1
	dc.w	Open-FuncTab
	dc.w	Close-FuncTab
	dc.w	Expunge-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalInitialize-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalInstrIdentify-FuncTab
	dc.w	ExternalInstrLoad-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalInstrGetInfo-FuncTab
	dc.w	ExternalInstrGetNums-FuncTab
	dc.w	-1

DataTab:	INITLONG	LN_NAME,LibName
	INITBYTE	LIB_FLAGS,LIBF_CHANGED|LIBF_SUMUSED
	INITWORD	LIB_VERSION,EXTLIB_INSTR_VERSION
	INITWORD	LIB_REVISION,EXTLIB_REVISION
	INITLONG	LIB_IDSTRING,LibID
	dc.l	0

PrepareLibrary:	btst	#AFB_68020,AttnFlags+1(a6)	
	beq.s	ExtLib
	cmp.w	#37,LIB_VERSION(a6)
	blt.s	ExtLib
	move.l	a2,-(sp)
	move.l	d0,a2
	move.l	a0,extb_SegList(a2)
	moveq	#31,d0
	lea	TuComposerName(pc),a1
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,extb_TuComposerBase(a2)
	beq.s	NoTuCLib
	lea	ExtInstrLibBase(pc),a0
	move.l	a2,(a0)
	move.l	a2,d0
NoTuCLib:	move.l	(sp)+,a2
	rts
Open:	addq.w	#1,LIB_OPENCNT(a6)
	move.l	a6,d0
	rts
Close:	subq.w	#1,LIB_OPENCNT(a6)
	bne.s	ExtLib
	btst	#LIBB_DELEXP,LIB_FLAGS(a6)
	bne.s	Expunge
ExtLib:	moveq	#0,d0
	rts
Expunge:	bset	#LIBB_DELEXP,LIB_FLAGS(a6)
	tst.w	LIB_OPENCNT(a6)
	bne.s	ExtLib
	movem.l	d2/a5-a6,-(sp)
	move.l	extb_ExtLibList(a6),d0
	beq.s	NoExtLibList
	move.l	d0,a0
	clr.l	extl_LibBase(a0)
NoExtLibList:	move.l	extb_TuComposerBase(a6),a1
	move.l	a6,a5
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
	move.l	extb_SegList(a5),d2
	move.l	a5,a1
	jsr	_LVORemove(a6)
	move.l	a5,a1
	moveq	#0,d0
	moveq	#0,d1
	move.w	LIB_NEGSIZE(a5),d1
	sub.l	d1,a1
	move.w	LIB_POSSIZE(a5),d0
	add.l	d1,d0
	jsr	_LVOFreeMem(a6)
	move.l	d2,d0
	movem.l	(sp)+,d2/a5-a6
	rts
;	INPUT
;	A0.L	=	APTR to instrument external list structure to be initialized
;	OUTPUT
;	D0.L	=	What type of external library is it or NULL if error
ExternalInitialize:	move.l	extb_TuComposerBase(a6),a1
	movem.l	a2/a6,-(sp)
	move.l	a0,d0
	beq.s	ExternalInitDone
	move.l	a1,a6
	move.b	#EXTLF_Loader,extl_Flags(a0)
	move.l	a0,a2
	lea	extl_Descriptor(a0),a0
	lea	LoadDescript(pc),a1
	jsr	_LVOSetString(a6)
	tst.l	d0
	beq.s	ExternalInitDone
	lea	LoadFlags(pc),a0
	jsr	_LVOAllocFlagStr(a6)
	move.l	d0,extl_LoadFlagStr(a2)
	beq.s	ExternalInitDone
	moveq	#EXTTYPE_INSTR,d0
ExternalInitDone:	movem.l	(sp)+,a2/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	If failed NULL else any non-zero value
ExternalInstrIdentify:	movem.l	d2-d3/a6,-(sp)
	move.l	a0,d1
	link	a5,#-38
	move.l	sp,d2
	moveq	#38,d3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalInstrIdDone
	cmp.b	#26,37(sp)
	bne.s	ExternalInstrIdDone
	moveq	#XMIdLen-XMId-1,d1
	lea	XMId(pc),a0
	move.l	sp,a1
IdentifyInstrLoop:	cmp.b	(a0)+,(a1)+
	dbne	d1,IdentifyInstrLoop
	beq.s	ExternalInstrIdOk
ExternalInstrIdDone:	moveq	#0,d0
ExternalInstrIdOk:	unlk	a5
	movem.l	(sp)+,d2-d3/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be loaded
;	A1.L	=	APTR to target instrument structure or NULL to create new
;	A2.L	=	APTR to loading flag pass structure (Loader specific)
;	D0.L	=	Number of instrument to be loaded (NULL is the first)
;	OUTPUT
;	D0.L	=	APTR to instrument structure where loaded instrument data is
ExternalInstrLoad:	movem.l	d2-d7/a2-a6,-(sp)
	move.l	d0,d6
	moveq	#7,d0
	moveq	#0,d1
	moveq	#0,d7
CreateBitTable:	tst.l	(a2)+
	beq.s	BitNotSet
	bset	d1,d7
BitNotSet:	addq.b	#1,d1
	dbra	d0,CreateBitTable
	move.l	a0,d1
	lea	-306(sp),sp
	moveq	#80,d3
	move.l	sp,d2
	move.l	d1,a2
	move.l	a1,a3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadError
	cmp.w	#$0401,58(sp)
	bne	ExternalLoadWrongVersion
	bsr	FindInstrument
	moveq	#0,d0
	jsr	_LVOAllocInstr(a6)
	move.l	d0,d1
	beq	ExternalLoadError
	move.l	d0,a4
	moveq	#32,d6
	move.l	a5,(sp)
	btst	#2,d7
	beq	NotConvertVolEnvData
	btst	#0,233(sp)
	bne.s	NotEmptyVolEnvData
	move.b	#2,225(sp)
	move.l	#$00004000,129(sp)
	move.l	#$01000000,133(sp)
	clr.b	227(sp)
	clr.w	228(sp)
NotEmptyVolEnvData:	moveq	#0,d0
	moveq	#0,d1
	move.b	225(sp),d1
	beq	NotConvertVolEnvData
	move.l	d1,d4
	subq.b	#1,d1
	beq	NotConvertVolEnvData
	move.b	d1,d2
ConvertVolGetHighest:	move.w	(129.w,sp,d1.w*4),d3
	rol.w	#8,d3
	addq.l	#1,d3
	cmp.w	d3,d0
	bhs.s	ConvertVolIsHighest
	move.w	d3,d0
ConvertVolIsHighest:	dbra	d1,ConvertVolGetHighest
	moveq	#ENVL_EMPTY,d1
	moveq	#0,d3
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,tci_VolumeEnvelope(a4)
	beq	ExternalLoadErr
	lea	129(sp),a0
	move.l	d0,a1
	moveq	#TCIEF_Sustain,d0
	btst	#0,233(sp)
	beq.s	NotLoopEnv
	moveq	#TCIEF_Loop|TCIEF_Sustain,d0
	btst	#1,233(sp)
	beq.s	NotSusLoopEnv
	btst	#2,233(sp)
	beq.s	SetEnvNoSusLoop
	bra.s	NotLoopEnv
NotSusLoopEnv:	moveq	#TCIEF_Loop,d0
	btst	#2,233(sp)
	bne.s	NotLoopEnv
SetEnvNoSusLoop:	move.b	d2,228(sp)
	move.b	d2,229(sp)
NotLoopEnv:	move.b	d0,tcie_Flags+1(a1)
	moveq	#0,d1
	move.b	227(sp),d1
	move.w	(a0,d1.w*4),d0
	rol.w	#8,d0
	move.w	d0,tcie_SustainStart(a1)
	move.w	d0,tcie_SustainEnd(a1)
	move.b	228(sp),d1
	move.w	(a0,d1.w*4),d0
	rol.w	#8,d0
	move.w	d0,tcie_LoopStart(a1)
	move.b	229(sp),d1
	move.w	(a0,d1.w*4),d0
	rol.w	#8,d0
	move.w	d0,tcie_LoopEnd(a1)
	move.l	tcie_NodePoints(a1),a5
	move.l	tcie_Data(a1),a1
ConvertEnvelopeData:	move.w	(a0)+,d0
	rol.w	#8,d0
	move.w	d0,(a5)+
	move.w	(a0)+,d1
	rol.w	#8,d1
	sub.w	d6,d1
	muls.w	#$7fff,d1
	asr.l	#5,d1
	move.w	(a0),d3
	rol.w	#8,d3
	bne.s	NotNullLastVol
	move.w	d0,d3
	addq.w	#1,d3
NotNullLastVol:	move.w	2(a0),d4
	rol.w	#8,d4
	sub.w	d6,d4
	muls.w	#$7fff,d4
	asr.l	#5,d4
	sub.w	d0,d3
	bls.s	NotNullLastVol2
	sub.l	d1,d4
	divs.w	d3,d4
	moveq	#0,d5
	move.w	d3,d0
	cmp.b	#1,d2
	bne.s	AddEnvelopeData
	addq.w	#1,d0
AddEnvelopeData:	move.w	d1,(a1)+
	add.w	d4,d1
	swap	d4
	add.w	d4,d5
	bpl.s	NotSubEnvData
	add.w	d3,d5
	subq.w	#1,d1
NotSubEnvData:	cmp.w	d3,d5
	bcs.s	NotAddEnvData
	sub.w	d3,d5
	addq.w	#1,d1
NotAddEnvData:	swap	d4
	subq.w	#1,d0
	bne.s	AddEnvelopeData
NotNullLastVol2:	subq.b	#1,d2
	bne.s	ConvertEnvelopeData
	move.l	tci_VolumeEnvelope(a4),a0
	jsr	_LVOValidateEnvNodes(a6)
NotConvertVolEnvData:	moveq	#0,d0
	btst	#3,d7
	beq	NotConvertPanEnvData
	btst	#0,267(sp)
	beq	NotConvertPanEnvData
	moveq	#0,d1
	move.b	226(sp),d1
	beq	NotConvertPanEnvData
	move.l	d1,d4
	subq.b	#1,d1
	beq	NotConvertPanEnvData
	move.b	d1,d2
ConvertPanGetHighest:	move.w	(177.w,sp,d1.w*4),d3
	rol.w	#8,d3
	addq.l	#1,d3
	cmp.w	d3,d0
	bhs.s	ConvertPanIsHighest
	move.w	d3,d0
ConvertPanIsHighest:	dbra	d1,ConvertPanGetHighest
	moveq	#ENVL_EMPTY,d1
	moveq	#0,d3
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,tci_PanningEnvelope(a4)
	beq	ExternalLoadErr
	lea	177(sp),a0
	move.l	d0,a1
	moveq	#0,d0
	btst	#1,234(sp)
	beq.s	NotSustainPanEnv
	addq.b	#TCIEF_Sustain,d0
NotSustainPanEnv:	btst	#2,234(sp)
	beq.s	NotLoopPanEnv
	addq.b	#TCIEF_Loop,d0
NotLoopPanEnv:	move.b	d0,tcie_Flags+1(a1)
	moveq	#0,d1
	move.b	230(sp),d1
	move.w	(a0,d1.w*4),d0
	rol.w	#8,d0
	move.w	d0,tcie_SustainStart(a1)
	move.w	d0,tcie_SustainEnd(a1)
	move.b	231(sp),d1
	move.w	(a0,d1.w*4),d0
	rol.w	#8,d0
	move.w	d0,tcie_LoopStart(a1)
	move.b	232(sp),d1
	move.w	(a0,d1.w*4),d0
	rol.w	#8,d0
	move.w	d0,tcie_LoopEnd(a1)
	move.l	tcie_NodePoints(a1),a5
	move.l	tcie_Data(a1),a1
ConvertPanEnvData:	move.w	(a0)+,d0
	rol.w	#8,d0
	move.w	d0,(a5)+
	move.w	(a0)+,d1
	rol.w	#8,d1
	sub.w	d6,d1
	muls.w	#$7fff,d1
	asr.l	#5,d1
	move.w	(a0),d3
	rol.w	#8,d3
	bne.s	NotNullLastPan
	move.w	d0,d3
	addq.w	#1,d3
NotNullLastPan:	move.w	2(a0),d4
	rol.w	#8,d4
	sub.w	d6,d4
	muls.w	#$7fff,d4
	asr.l	#5,d4
	sub.w	d0,d3
	bls.s	NotNullLastPan2
	sub.l	d1,d4
	divs.w	d3,d4
	moveq	#0,d5
	move.w	d3,d0
	cmp.b	#1,d2
	bne.s	AddPanEnvData
	addq.w	#1,d0
AddPanEnvData:	move.w	d1,(a1)+
	add.w	d4,d1
	swap	d4
	add.w	d4,d5
	bpl.s	NotSubPanEnvData
	add.w	d3,d5
	subq.w	#1,d1
NotSubPanEnvData:	cmp.w	d3,d5
	bcs.s	NotAddPanEnvData
	sub.w	d3,d5
	addq.w	#1,d1
NotAddPanEnvData:	swap	d4
	subq.w	#1,d0
	bne.s	AddPanEnvData
NotNullLastPan2:	subq.b	#1,d2
	bne.s	ConvertPanEnvData
	move.l	tci_PanningEnvelope(a4),a0
	jsr	_LVOValidateEnvNodes(a6)
NotConvertPanEnvData:	move.l	(sp),a5
	btst	#6,d7
	beq.s	NoAutoVibrato
	move.b	235(sp),d0
	cmp.b	#4,d0
	bcc.s	NoAutoVibrato
	move.l	#$80000080,d2
	moveq	#DEFAULT_ENVNODES,d4
	move.b	(AutoVibTab.w,pc,d0.w),d1
	bne.s	NoInvertRamp
	moveq	#ENVL_RAMP,d1
	bclr	#31,d2
NoInvertRamp:	moveq	#64,d0
	lsl.w	#2,d0
	moveq	#0,d3
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,298(sp)
	beq	ExternalLoadErr
	move.l	d0,a1
	bset	#TCIEB_Loop,tcie_Flags+1(a1)
	move.w	tcie_NumPoints(a1),tcie_LoopEnd(a1)
	subq.w	#1,tcie_LoopEnd(a1)
NoAutoVibrato:	lea	236(sp),a0
	moveq	#0,d0
	move.b	(a0)+,d0
	neg.b	d0
	bne.s	VibSweepOk
	move.w	#$100,d0
VibSweepOk:	moveq	#0,d1
	move.b	(a0)+,d1
	mulu.w	d1,d0
	lea	302(sp),a1
	move.w	d0,(a1)+
	move.b	d1,(a1)+
	move.b	(a0)+,(a1)
	move.w	(a0),d0
	rol.w	#8,d0
	move.w	d0,tci_FadeOut(a4)
	moveq	#0,d3
	btst	#4,d7
	beq.s	NoVibratoEnvelope
	moveq	#32,d0
	moveq	#ENVL_SINE,d1
	moveq	#127,d2
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,tci_VibratoEnvelope(a4)
	beq	ExternalLoadErr
NoVibratoEnvelope:	btst	#5,d7
	beq.s	NoTremoloEnvelope
	moveq	#32,d0
	moveq	#ENVL_SINE,d1
	move.w	#$3fff,d2
	jsr	_LVOCreateEnvelope(a6)
	move.l	d0,tci_TremoloEnvelope(a4)
	beq	ExternalLoadErr
NoTremoloEnvelope:	lea	tci_Name(a4),a0
	lea	4(sp),a1
	jsr	_LVOSetString(a6)
	tst.b	d7
	bmi.s	NotOldGlobalVolume
	move.b	#64,tci_GlobalVolume(a4)
NotOldGlobalVolume:	moveq	#96-1,d0
	lea	33(sp),a0
CheckLoadKeyboardTable:	tst.b	(a0)+
	dbne	d0,CheckLoadKeyboardTable
	beq.s	NotLoadKeyboard
	jsr	_LVOAllocKeyboard(a6)
	move.l	d0,tci_KeyboardDefs(a4)
	beq	ExternalLoadErr
	lea	33(sp),a0
	move.l	d0,a1
	moveq	#96-1,d0
	addq.l	#MLN_SIZE,a1
ConvertXIKeyboard:	move.b	(a0)+,1(a1)
	addq.l	#4,a1
	dbra	d0,ConvertXIKeyboard
NotLoadKeyboard:	btst	#0,d7
	beq	NoLoadSamples
	move.b	27(sp),d4
	beq	NoLoadSamples
LoadSamples:	move.l	a2,d1
	lea	128(sp),a0
	move.l	a0,d2
	moveq	#40,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalLoadErr
	move.l	29(sp),d0
	rol.w	#8,d0
	swap	d0
	rol.w	#8,d0
	moveq	#-40,d2
	add.l	d0,d2
	beq.s	LoadSampleHeaderOk
	moveq	#OFFSET_CURRENT,d3
	move.l	a2,d1
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalLoadErr
LoadSampleHeaderOk:	move.l	128(sp),d0
	rol.w	#8,d0
	swap	d0
	rol.w	#8,d0
	sub.l	a0,a0
	jsr	_LVOAllocSample(a6)
	move.l	d0,d6
	beq	ExternalLoadErr
	lea	18+128(sp),a1
	lea	22(a1),a0
	clr.b	(a0)
FindNotSmpSpc:	cmp.l	a1,a0
	beq.s	FindSmpSpcDone
	cmp.b	#" ",-(a0)
	bne.s	FindSmpSpcDone
	clr.b	(a0)
	bra.s	FindNotSmpSpc
FindSmpSpcDone:	move.l	d6,a0
	lea	tcs_Name(a0),a0
	jsr	_LVOSetString(a6)
	move.l	d6,a1
	lea	12+128(sp),a0
	move.b	(a0)+,d0
	tst.b	d7
	bpl.s	NotConvSmpLoadVol
	lsl.b	#2,d0
	bcc.s	NotConvSmpLoadVol
	moveq	#-1,d0
NotConvSmpLoadVol:	move.b	d0,tcs_Volume(a1)
	movem.l	4+128(sp),d0-d1
	rol.w	#8,d0
	swap	d0
	rol.w	#8,d0
	btst	#4,14+128(sp)
	beq.s	Not16BitRepeat
	lsr.l	#1,d0
Not16BitRepeat:	rol.w	#8,d1
	swap	d1
	rol.w	#8,d1
	btst	#4,14+128(sp)
	beq.s	Not16BitRepLen
	lsr.l	#1,d1
Not16BitRepLen:	movem.l	d0-d1,tcs_Repeat(a1)
	moveq	#TCSF_SmpPanning,d1
	move.b	(a0)+,tcs_FineTune(a1)
	move.b	(a0)+,d0
	and.b	#3,d0
	beq.s	NoForwardLoop
	addq.b	#TCSF_Loop,d1
NoForwardLoop:	move.b	d1,tcs_Flags(a1)
	subq.b	#2,d0
	bne.s	NoPingpongLoop
	move.b	#TCSRF_Pingpong,tcs_RepMode(a1)
NoPingpongLoop:	move.b	(a0)+,tcs_Panning(a1)
	move.b	(a0),tcs_Transpose(a1)
	lea	298(sp),a0
	move.l	(a0)+,tcs_AutoVibratoEnv(a1)
	move.w	(a0)+,tcs_VibratoSweep(a1)
	move.w	(a0),tcs_VibratoDepth(a1)
	move.l	a1,d5
	btst	#4,14+128(sp)
	beq.s	Not16BitSmp
	moveq	#16,d0
	moveq	#CBF_ChangeOnly,d1
	move.l	d5,a0
	jsr	_LVOConvertBits(a6)
Not16BitSmp:	move.l	a4,a0
	move.l	d5,a1
	jsr	_LVOAddSample(a6)
	subq.b	#1,d4
	bne	LoadSamples
	lea	tci_Samples(a4),a5
LoadSampleData:	move.l	(a5),a5
	tst.l	(a5)
	beq.s	NoLoadSamples
	move.l	a2,d1
	movem.l	tcs_Data(a5),d2-d3
	jsr	_LVOCRead(a6)
	addq.l	#1,d0
	beq.s	ExternalLoadErr
	cmp.b	#16,tcs_BitDepth(a5)
	bne.s	NotIntelOrder
	move.l	a5,a0
	jsr	_LVOConvertWord(a6)
NotIntelOrder:	moveq	#0,d0
	move.l	a5,a0
	jsr	_LVODecrunchSample(a6)
	bra.s	LoadSampleData
NoLoadSamples:	btst	#0,233(sp)
	bne.s	VolEnvelopeUsed
	move.l	tci_VolumeEnvelope(a4),a0
	clr.l	tci_VolumeEnvelope(a4)
	jsr	_LVOFreeEnvelope(a6)
VolEnvelopeUsed:	btst	#0,234(sp)
	bne.s	PanEnvelopeUsed
	move.l	tci_PanningEnvelope(a4),a0
	clr.l	tci_PanningEnvelope(a4)
	jsr	_LVOFreeEnvelope(a6)
PanEnvelopeUsed:	move.l	a3,d0
	bne.s	InstrAllocated
	move.l	a4,a3
InstrAllocated:	move.l	a4,a0
	move.l	a3,a1
	jsr	_LVOReMapInstr(a6)
	move.l	a3,a0
	move.b	d7,d0
	not.b	d0
	lsl.b	#6,d0
	lsr.b	#7,d0
	jsr	_LVOAddInstrEnvelopes(a6)
ExternalLoadDone:	move.l	a3,d0
	lea	306(sp),sp
	movem.l	(sp)+,d2-d7/a2-a6
	rts
ExternalLoadErr:	move.l	tci_VolumeEnvelope(a4),a0
	jsr	_LVOFreeEnvelope(a6)
	move.l	tci_PanningEnvelope(a4),a0
	jsr	_LVOFreeEnvelope(a6)
	move.l	tci_VibratoEnvelope(a4),a0
	jsr	_LVOFreeEnvelope(a6)
	move.l	tci_TremoloEnvelope(a4),a0
	jsr	_LVOFreeEnvelope(a6)
	move.l	tci_Samples(a4),a0
	tst.l	(a0)
	beq.s	NoFreeAutoVibEnv
	move.l	tcs_AutoVibratoEnv(a0),a0
	jsr	_LVOFreeEnvelope(a6)
NoFreeAutoVibEnv:	move.l	tci_KeyboardDefs(a4),a0
	jsr	_LVOFreeKeyboard(a6)
	move.l	a4,a0
	jsr	_LVOFreeInstr(a6)
ExternalLoadError:	sub.l	a3,a3
	bra.s	ExternalLoadDone
ExternalLoadWrongVersion:	moveq	#255-ERROR_ACTION_NOT_KNOWN,d1
	not.b	d1
	move.l	tcb_DOSBase(a6),a6
	jsr	_LVOSetIoErr(a6)
	bra.s	ExternalLoadError
FindInstrument:	move.l	a2,d1
	moveq	#-20,d2
	move.l	60+4(sp),d0
	rol.w	#8,d0
	swap	d0
	rol.w	#8,d0
	add.l	d0,d2
	moveq	#OFFSET_CURRENT,d3
	lea	4(sp),a4
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalGetInfoErrorA4
	move.w	60+10(a4),d4
	rol.w	#8,d4
	moveq	#0,d0
	move.w	60+12(a4),d0
	rol.w	#8,d0
	cmp.l	d0,d6
	bcc	ExternalGetInfoErrorA4
SkipInstrGetInfoPatterns:	move.l	a2,d1
	move.l	a4,d2
	moveq	#9,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalGetInfoErrorA4
	move.l	a2,d1
	move.l	(a4),d0
	rol.w	#8,d0
	swap	d0
	rol.w	#8,d0
	moveq	#-9,d2
	add.l	d0,d2
	move.l	a2,d1
	moveq	#0,d0
	move.w	7(a4),d0
	rol.w	#8,d0
	add.l	d0,d2
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalGetInfoErrorA4
	subq.w	#1,d4
	bne.s	SkipInstrGetInfoPatterns
FindInstrGetInfoInstr:	move.l	a2,d1
	move.l	a4,d2
	moveq	#29,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalGetInfoErrorA4
	move.l	a2,d1
	move.l	(a4),d5
	rol.w	#8,d5
	swap	d5
	rol.w	#8,d5
	move.w	27(a4),d4
	rol.w	#8,d4
	beq	NoSamplesToGet
	move.l	a4,d2
	add.l	d3,d2
	move.w	#241-29,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalGetInfoErrorA4
	move.l	a2,d1
	move.l	#-241,d2
	add.l	d5,d2
	beq.s	NotDoGetInfoSeekContents
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalGetInfoErrorA4
NotDoGetInfoSeekContents:	subq.w	#1,d6
	bcs.s	ScanGetInfoSamplesDone
	moveq	#0,d5
ScanGetInfoSamples:	move.l	a2,d1
	lea	241(a4),a0
	move.l	a0,d2
	moveq	#40,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalGetInfoErrorA4
	move.l	241(a4),d0
	rol.w	#8,d0
	swap	d0
	rol.w	#8,d0
	add.l	d0,d5
	move.l	29(a4),d0
	rol.w	#8,d0
	swap	d0
	rol.w	#8,d0
	moveq	#-40,d2
	add.l	d0,d2
	beq.s	NotDoGetInfoSeek
	move.l	a2,d1
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalGetInfoErrorA4
NotDoGetInfoSeek:	subq.w	#1,d4
	bne.s	ScanGetInfoSamples
	move.l	d5,d2
	beq.s	NoSkipSampleDataInfo
	move.l	a2,d1
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalGetInfoErrorA4
NoSkipSampleDataInfo:	bra	FindInstrGetInfoInstr
NoSamplesToGet:	moveq	#-29,d2
	add.l	d5,d2
	beq.s	NotDoGetInfoSeek
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	bne	FindInstrGetInfoInstr
	bra	ExternalGetInfoErrorA4
ScanGetInfoSamplesDone:	rts
AutoVibTab:	dc.b	ENVL_SINE,ENVL_SQUARE,0,ENVL_RAMP
;	INPUT
;	A0.L	=	APTR to cruncher file handle from where to get the info
;	A1.L	=	APTR to instrument info structure where to put information
;	D0.L	=	Number of instrument to be scanned (NULL is the first)
;	OUTPUT
;	D0.L	=	Any non-zero value for success, NULL for error.
ExternalInstrGetInfo:	movem.l	d2-d6/a2-a4/a6,-(sp)
	link	a5,#-246
	move.l	a0,d1
	move.l	sp,d2
	moveq	#80,d3
	move.l	d0,d6
	move.l	d1,a2
	move.l	a1,a3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalGetInfoError
	cmp.w	#$0401,58(sp)
	bne	ExternalGetInfoWrongVersion
	move.b	59(sp),ii_Version(a3)
	move.b	58(sp),ii_Revision(a3)
	bsr	FindInstrument
	moveq	#0,d0
	move.b	225(sp),d0
	move.w	(129-4.w,sp,d0.w*4),d1
	rol.w	#8,d1
	move.w	d1,ii_VolumeEnvelope(a3)
	move.b	226(sp),d0
	move.w	(177-4.w,sp,d0.w*4),d1
	rol.w	#8,d1
	move.w	d1,ii_PanningEnvelope(a3)
	move.b	27(sp),ii_NumSamples(a3)
	move.w	239(sp),d0
	rol.w	#8,d0
	move.w	d0,ii_FadeOut(a3)
	st	ii_GlobalVolume(a3)
	move.b	#DEFAULTPITCHPANCENTER,ii_PitchPanCenter(a3)
	move.b	#DEFAULTSAMPLEPANNING,ii_DefaultPanning(a3)
	moveq	#64,d0
	move.w	d0,ii_VibratoEnvelope(a3)
	move.w	d0,ii_TremoloEnvelope(a3)
	moveq	#96-1,d0
	lea	33(sp),a0
CheckKeyboardTable:	tst.b	(a0)+
	dbne	d0,CheckKeyboardTable
	beq.s	NoKeyboardRequired
	move.w	#120,ii_KeyboardDefs(a3)
NoKeyboardRequired:	lea	ii_Name(a3),a0
	lea	4(sp),a1
	clr.b	26(sp)
	jsr	_LVOSetString(a6)
	move.l	a3,d0
ExternalGetInfoDone:	unlk	a5
	movem.l	(sp)+,d2-d6/a2-a4/a6
	rts
ExternalGetInfoErrorA4:	addq.l	#4,sp
ExternalGetInfoError:	moveq	#0,d0
	bra.s	ExternalGetInfoDone
ExternalGetInfoWrongVersion:	moveq	#255-ERROR_ACTION_NOT_KNOWN,d1
	not.b	d1
	move.l	tcb_DOSBase(a6),a6
	jsr	_LVOSetIoErr(a6)
	bra.s	ExternalGetInfoError
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	Number of instruments found or NULL on any error
ExternalInstrGetNums:	move.l	a6,-(sp)
	link	a5,#-74
	move.l	a0,d1
	move.l	sp,d2
	moveq	#74,d3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalGetNumError
	cmp.w	#$0401,58(sp)
	bne.s	ExternalGetNumWrongVersion
	move.w	60+12(sp),d0
	rol.w	#8,d0
ExternalGetNumsDone:	unlk	a5
	move.l	(sp)+,a6
	rts
ExternalGetNumError:	moveq	#0,d0
	bra.s	ExternalGetNumsDone
ExternalGetNumWrongVersion:	moveq	#255-ERROR_ACTION_NOT_KNOWN,d1
	not.b	d1
	move.l	tcb_DOSBase(a6),a6
	jsr	_LVOSetIoErr(a6)
	bra.s	ExternalGetNumError

	cnop	0,4

ExtInstrLibBase:	dc.l	0

LoadFlags:	dc.w	8
	dc.w	LoadFlagSize
	dc.l	LoadText0
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0	
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText1
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText2
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText3
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LoadText4
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	LoadText5
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	LoadText6
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	LoadText7
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
LoadText0:	dc.b	'Load samples',0
LoadText1:	dc.b	'Add envelopes to beginning',0
LoadText2:	dc.b	'Create volume envelope',0
LoadText3:	dc.b	'Create panning envelope',0
LoadText4:	dc.b	'Create vibrato envelope',0
LoadText5:	dc.b	'Create tremolo envelope',0
LoadText6:	dc.b	'Create auto vibrato envelope',0
LoadText7:	dc.b	'Convert volumes',0
	even
LoadFlagSize:	equ	*-LoadFlags
LoadDescript:	dc.b	'FastTracker ][ Module (XM)',0
XMId:	dc.b	'Extended Module: '
XMIdLen: