*********************************************************
***    TuComposer External Track Library for XM       ***
***       1996-97 by The united Coders (TuC)         ***
***                Main code: Basty/TuC               ***
*** This is a XM track loader (loads the tracks from  ***
***             the FastTracker ][ modules)           ***
*********************************************************

	IFND	_G2
	MACHINE	MC68020
	OPT	NODEBUG,NOLINE
	ENDC

	include	"exec/types.i"
	include	"exec/execbase.i"
	include	"exec/exec_lib.i"
	include	"exec/initializers.i"
	include	"exec/memory.i"
	include	"exec/resident.i"
	include	"exec/libraries.i"
	include	"libraries/dos_lib.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/track.i"
	include	"tucomposer/external/external.i"
	include	"tucomposer/external/external_lib.i"
	include	"tucomposer/external/track.i"
	include	"tucomposer/external/track_lib.i"

	moveq	#-1,d0
	rts
ResidentStruct:	dc.w	RTC_MATCHWORD
	dc.l	ResidentStruct
	dc.l	0
	dc.b	RTF_AUTOINIT
	dc.b	EXTLIB_TRACK_VERSION
	dc.b	NT_LIBRARY
	dc.b	0
	dc.l	LibName
	dc.l	LibID
	dc.l	Init
LibName:	dc.b	'xmt.library',0
LibID:	dc.b	'TuComposer External Track Loader Version v1.00 (v31) for XM (68020+, OS2.0+) (3 Mar 97) by Basty/TuC.',0
TuComposerName:	dc.b	'tucomposer.library',0
	even
Init:	dc.l	trkl_SIZEOF
	dc.l	FuncTab
	dc.l	DataTab
	dc.l	PrepareLibrary

FuncTab:	dc.w	-1
	dc.w	Open-FuncTab
	dc.w	Close-FuncTab
	dc.w	Expunge-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalInitialize-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalTrackIdentify-FuncTab
	dc.w	ExternalTrackLoad-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalTrackGetInfo-FuncTab
	dc.w	ExternalTrackGetNums-FuncTab
	dc.w	-1

DataTab:	INITLONG	LN_NAME,LibName
	INITBYTE	LIB_FLAGS,LIBF_CHANGED|LIBF_SUMUSED
	INITWORD	LIB_VERSION,EXTLIB_TRACK_VERSION
	INITWORD	LIB_REVISION,EXTLIB_REVISION
	INITLONG	LIB_IDSTRING,LibID
	dc.l	0

PrepareLibrary:	btst	#AFB_68020,AttnFlags+1(a6)
	beq.s	ExtLib
	cmp.w	#36,LIB_VERSION(a6)
	blt.s	ExtLib
	move.l	a2,-(sp)
	move.l	d0,a2
	move.l	a0,extb_SegList(a2)
	moveq	#31,d0
	lea	TuComposerName(pc),a1
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,extb_TuComposerBase(a2)
	beq.s	NoTuCLib
	lea	ExtTrackLibBase(pc),a0
	move.l	a2,(a0)
	move.l	a2,d0
NoTuCLib:	move.l	(sp)+,a2
	rts
Open:	addq.w	#1,LIB_OPENCNT(a6)
	move.l	a6,d0
	rts
Close:	subq.w	#1,LIB_OPENCNT(a6)
	bne.s	ExtLib
	btst	#LIBB_DELEXP,LIB_FLAGS(a6)
	bne.s	Expunge
ExtLib:	moveq	#0,d0
	rts
Expunge:	bset	#LIBB_DELEXP,LIB_FLAGS(a6)
	tst.w	LIB_OPENCNT(a6)
	bne.s	ExtLib
	movem.l	d2/a5-a6,-(sp)
	move.l	extb_ExtLibList(a6),d0
	beq.s	NoExtLibList
	move.l	d0,a0
	clr.l	extl_LibBase(a0)
NoExtLibList:	move.l	extb_TuComposerBase(a6),a1
	move.l	a6,a5
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
	move.l	extb_SegList(a5),d2
	move.l	a5,a1
	jsr	_LVORemove(a6)
	move.l	a5,a1
	moveq	#0,d0
	moveq	#0,d1
	move.w	LIB_NEGSIZE(a5),d1
	sub.l	d1,a1
	move.w	LIB_POSSIZE(a5),d0
	add.l	d1,d0
	jsr	_LVOFreeMem(a6)
	move.l	d2,d0
	movem.l	(sp)+,d2/a5-a6
	rts
;	INPUT
;	A0.L	=	APTR to track external list structure to be initialized
;	A1.L	=	APTR to tucomposer.library base if you need it
;	OUTPUT
;	D0.L	=	What type of external library is it or NULL if error
ExternalInitialize:	move.l	extb_TuComposerBase(a6),a1
	movem.l	a2/a6,-(sp)
	move.l	a0,d0
	beq.s	ExternalInitDone
	move.l	a1,a6
	move.b	#EXTLF_Loader|EXTLF_Saver,extl_Flags(a0)
	move.l	a0,a2
	lea	extl_Descriptor(a0),a0
	lea	LoadDescript(pc),a1
	jsr	_LVOSetString(a6)
	tst.l	d0
	beq.s	ExternalInitDone
	lea	LoadFlags(pc),a0
	jsr	_LVOAllocFlagStr(a6)
	move.l	d0,extl_LoadFlagStr(a2)
	beq.s	ExternalInitDone
	moveq	#EXTTYPE_TRACK,d0
ExternalInitDone:	movem.l	(sp)+,a2/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	If failed NULL else any non-zero value
ExternalTrackIdentify:	movem.l	d2-d3/a6,-(sp)
	move.l	a0,d1
	link	a5,#-38
	move.l	sp,d2
	moveq	#38,d3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalTrackIdDone
	cmp.b	#26,37(sp)
	bne.s	ExternalTrackIdDone
	moveq	#XMIdLen-XMId-1,d1
	lea	XMId(pc),a0
	move.l	sp,a1
IdentifyTrackLoop:	cmp.b	(a0)+,(a1)+
	dbne	d1,IdentifyTrackLoop
	beq.s	ExternalTrackIdOk
ExternalTrackIdDone:	moveq	#0,d0
ExternalTrackIdOk:	unlk	a5
	movem.l	(sp)+,d2-d3/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be loaded
;	A1.L	=	APTR to target track structure or NULL to create a new one
;	A2.L	=	APTR to loading flag pass structure (Loader specific)
;	D0.L	=	Number of track of be loaded (NULL is the first)
;	OUTPUT
;	D0.L	=	APTR to track structure where loaded track data
ExternalTrackLoad:	movem.l	d2-d7/a2-a6,-(sp)
	lea	-80(sp),sp
	move.l	sp,d2
	moveq	#80,d3
	move.l	d0,d6
	move.l	(a2),d7
	move.l	a0,d1
	move.l	d1,a2
	move.l	a1,a3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalTrackLoadErr
	cmp.w	#$0401,58(sp)
	bne	ExternalTrackWrongVersion
	move.l	a2,d1
	moveq	#-20,d2
	move.l	60(sp),d0
	rol.w	#8,d0
	swap	d0
	rol.w	#8,d0
	add.l	d0,d2
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalTrackLoadDone
	moveq	#0,d4
	move.w	60+8(sp),d4
	rol.w	#8,d4
	moveq	#0,d1
	move.w	60+10(sp),d1
	rol.w	#8,d1
	mulu.w	d4,d1
	cmp.l	d1,d6
	bcc	ExternalTrackLoadErr
	divul.l	d4,d5:d6
FindTrackLoadPattern:	move.l	a2,d1
	move.l	sp,d2
	moveq	#9,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalTrackLoadErr
	move.l	a2,d1
	moveq	#-9,d2
	move.l	(sp),d0
	rol.w	#8,d0
	swap	d0
	rol.w	#8,d0
	add.l	d0,d2
	beq.s	NotDoSeek
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq	ExternalTrackLoadDone
NotDoSeek:	move.l	a2,d1
	moveq	#0,d2
	move.w	7(sp),d2
	rol.w	#8,d2
	subq.w	#1,d6
	bcs.s	FindTrackLoadPatternDone
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	bne.s	FindTrackLoadPattern
	bra	ExternalTrackLoadDone
ExternalTrackSkip:	clr.l	4(sp)
	clr.b	8(sp)
	move.b	(a2)+,d1
	bmi.s	ExternalTrackCompressed
	move.b	d1,4(sp)
	move.l	(a2)+,5(sp)
	bra.s	EvaluateTrackData
ExternalTrackCompressed:	lsr.b	#1,d1
	bcc.s	NotNote
	move.b	(a2)+,4(sp)
NotNote:	lsr.b	#1,d1
	bcc.s	NotInstr
	move.b	(a2)+,5(sp)
NotInstr:	lsr.b	#1,d1
	bcc.s	NotVolCol
	move.b	(a2)+,6(sp)
NotVolCol:	lsr.b	#1,d1
	bcc.s	NotEffByte
	move.b	(a2)+,7(sp)
NotEffByte:	lsr.b	#1,d1
	bcc.s	EvaluateTrackData
	move.b	(a2)+,8(sp)
EvaluateTrackData:	tst.b	(sp)
	bne.s	InstrOk
	clr.b	1(sp)
InstrOk:	subq.w	#1,d0
	bne.s	ExternalTrackSkip
	rts
FindTrackLoadPatternDone:	move.l	d2,d0
	move.l	a6,a5
	jsr	_LVOAllocPMem(a6)
	move.l	a2,d1
	move.l	d2,d3
	move.l	d3,60(sp)
	move.l	d0,d2
	beq	ExternalTrackLoadDone
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalTrackLoadError
	moveq	#0,d3
	move.w	5(sp),d3
	rol.w	#8,d3
	move.l	a3,d0
	bne.s	TrackAllocated
	move.l	d3,d0
	jsr	_LVOAllocTrack(a6)
TrackAllocated:	move.l	d0,d1
	beq	ExternalTrackLoadError
	move.l	d0,a3
	move.l	d3,d0
	move.l	a3,a0
	jsr	_LVOReSizeTrack(a6)
	tst.l	d0
	bne	ExternalTrackLoadError
	move.l	a3,a0
	jsr	_LVOClearTrack(a6)
	move.l	d2,a2
	lea	17(sp),a0
	lea	20(a0),a1
	clr.b	(a1)
FindNotSpc:	cmp.l	a1,a0
	beq.s	FindSpcDone
	cmp.b	#" ",-(a1)
	bne.s	FindSpcDone
	clr.b	(a1)
	bra.s	FindNotSpc
FindSpcDone:	jsr	_LVOAllocNameStr(a6)
	move.l	d0,tct_Name(a3)
	movem.w	60+16(sp),d0-d1
	rol.w	#8,d0
	move.w	d0,tct_Frames(a3)
	rol.w	#8,d1
	move.w	d1,tct_BPMSpeed(a3)
	move.b	#TCTCF_Slide|TCTCF_OpSlide|TCTCF_VolSlide,tct_CompFlags(a3)
	move.w	d5,d0
	addq.w	#1,d0
	bsr	ExternalTrackSkip
	move.l	tct_Data(a3),a4
	bra.s	ExternalNotTrigger
ExternalTrackConvertLoop:	move.w	d4,d0
	bsr	ExternalTrackSkip
ExternalNotTrigger:	move.l	sp,a1
	moveq	#0,d0
	move.b	(a1)+,d0
	beq.s	NoNote
	cmp.b	#$61,d0
	bne.s	NotKeyoff
	moveq	#255-NOTE_KEYOFF,d0
	not.b	d0
NoNote:	move.w	d0,(a4)+
	bra.s	NoteDone
NotKeyoff:	subq.b	#1,d0
	divu.w	#12,d0
	move.b	d0,(a4)+
	swap	d0
	addq.b	#1,d0
	move.b	d0,(a4)+
NoteDone:	move.b	(a1)+,d0
	move.w	d0,(a4)+
	moveq	#0,d6
	move.b	(a1)+,d6
	sub.b	#$10,d6
	bcs.s	NoVolumeColumn
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d5
	beq.s	NoVolumeColumn
	cmp.b	#$41,d6
	bcc.s	NotSetVolume
	tst.l	d7
	beq.s	NotVolFF
	lsl.b	#2,d6
	bcc.s	NotVolFF
	moveq	#-1,d6
NotVolFF:	moveq	#FX_SET_VOLUME,d0
	lsl.w	#8,d6
	bra.s	SetVolumeColumn
SpecialVolColExec:	dc.b	FX_VOL_SLD_DOWN,VolSlide-SpecialVolColExec
	dc.b	FX_VOL_SLD_UP,VolSlide-SpecialVolColExec
	dc.b	FX_F_VOLSL_DOWN,VolSlide-SpecialVolColExec
	dc.b	FX_F_VOLSL_UP,VolSlide-SpecialVolColExec
	dc.b	FX_VIBRATO,Vibrato-SpecialVolColExec
	dc.b	FX_VIBRATO,VibRate-SpecialVolColExec
	dc.b	FX_SET_PANNING,Panning-SpecialVolColExec
	dc.b	FX_PAN_SL_LEFT,VibRate-SpecialVolColExec
	dc.b	FX_PAN_SL_RIGHT,VibRate-SpecialVolColExec
	dc.b	FX_TONE_PORTA,VibRate-SpecialVolColExec
VolSlide:	tst.l	d7
	beq.s	VibRate
	moveq	#8+2,d1
	lsl.w	d1,d6
	rts
Panning:	move.b	d6,d1
	lsl.b	#4,d1
	or.b	d1,d6
VibRate:	lsl.w	#8,d6
Vibrato:	rts
NotSetVolume:	lea	SpecialVolColExec-5*2(pc),a0
	move.l	d6,d1
	lsr.b	#4,d1
	add.l	d1,a0
	add.l	d1,a0
	move.b	(a0)+,d0
	move.b	(a0)+,d1
	ext.w	d1
	and.b	#$f,d6
	jsr	SpecialVolColExec(pc,d1.w)
SetVolumeColumn:	move.l	d5,a1
	move.b	d0,tcte_EffectByte(a1)
	move.w	d6,tcte_DataWord(a1)
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
NoVolumeColumn:	moveq	#0,d0
	lea	3(sp),a1
	move.b	(a1)+,d0
	moveq	#0,d6
	move.b	(a1)+,d6
	cmp.b	#$22,d0
	bcc.s	NoEffect
	cmp.b	#9,d0
	bne.s	NotSmpOffset
	tst.w	tctd_Octave-tctd_Effects(a4)
	beq.s	NoEffect
NotSmpOffset:	movem.w	ProcessFXTable(pc,d0.w*4),d0-d1
	lea	ProcessFXTable(pc),a0
	add.l	d1,a0
	move.w	d6,d1
	jsr	(a0)
	move.w	d6,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	NoEffect
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
NoEffect:	lea	MLH_SIZE(a4),a4
	subq.w	#1,d3
	bne	ExternalTrackConvertLoop
	move.l	d2,a1
	move.l	60(sp),d0
	move.l	a5,a6
	jsr	_LVOFreePMem(a6)
	move.l	a3,d0
ExternalTrackLoadDone:	lea	80(sp),sp
	movem.l	(sp)+,d2-d7/a2-a6
	rts
ExternalTrackLoadError:	move.l	d2,a1
	move.l	60(sp),d0
	move.l	a5,a6
	jsr	_LVOFreePMem(a6)
ExternalTrackLoadErr:	moveq	#0,d0
	bra.s	ExternalTrackLoadDone
ExternalTrackWrongVersion:	moveq	#255-ERROR_ACTION_NOT_KNOWN,d1
	not.b	d1
	move.l	tcb_DOSBase(a6),a6
	jsr	_LVOSetIoErr(a6)
	bra.s	ExternalTrackLoadErr
ProcessFXTable:	dc.w	FX_ARPEGGIO,AbsArp-ProcessFXTable
	dc.w	FX_PORTA_UP,Porta-ProcessFXTable
	dc.w	FX_PORTA_DOWN,Porta-ProcessFXTable
	dc.w	FX_TONE_PORTA,Porta-ProcessFXTable
	dc.w	FX_VIBRATO,Arpeggio-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,ToneFade-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,VibFade-ProcessFXTable
	dc.w	FX_TREMOLO,Tremolo-ProcessFXTable
	dc.w	FX_SET_PANNING,Porta-ProcessFXTable
	dc.w	FX_SMP_OFF_LOW,Porta-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,VolumeSlide-ProcessFXTable
	dc.w	FX_POS_JUMP,PosJump-ProcessFXTable
	dc.w	FX_SET_VOLUME,SetVolume-ProcessFXTable
	dc.w	FX_PATT_BREAK,PosJump-ProcessFXTable
	dc.w	0,Extended-ProcessFXTable
	dc.w	FX_SET_TEMPO,Tempo-ProcessFXTable
	dc.w	FX_SET_G_VOLUME,SetVolume-ProcessFXTable
	dc.w	FX_G_VOLSL_UP,VolumeSlide-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	FX_DO_KEYOFF,PosJump-ProcessFXTable
	dc.w	$0014,EnvCtrl-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	FX_PAN_SL_RIGHT,PanSlide-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	FX_MULTI_RETRIG,MultiRetrig-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	FX_TREMOR,Tremor-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	FX_OFPORTA_UP-1,XFinePorta-ProcessFXTable
ExtendedFXTable:	dc.w	0,NoFX-ExtendedFXTable
	dc.w	FX_O_PORTA_UP,Porta-ExtendedFXTable
	dc.w	FX_O_PORTA_DOWN,Porta-ExtendedFXTable
	dc.w	FX_EXTEND_CTRL,GlissCtrl-ExtendedFXTable
	dc.w	$0301,EnvCtrl-ExtendedFXTable
	dc.w	FX_SET_TRANSP,SetFineTune-ExtendedFXTable
	dc.w	FX_PATT_LOOP,PosJump-ExtendedFXTable
	dc.w	$0401,EnvCtrl-ExtendedFXTable
	dc.w	USER_EFFECTS,PosJump-ExtendedFXTable
	dc.w	FX_RETRIG_NOTE,PosJump-ExtendedFXTable
	dc.w	FX_F_VOLSL_UP,VolSlide-ExtendedFXTable
	dc.w	FX_F_VOLSL_DOWN,VolSlide-ExtendedFXTable
	dc.w	FX_NOTE_CUT,PosJump-ExtendedFXTable
	dc.w	FX_NOTE_DELAY,PosJump-ExtendedFXTable
	dc.w	FX_PATT_DELAY,PosJump-ExtendedFXTable
	dc.w	FX_INVERT_LOOP,PosJump-ExtendedFXTable
Porta:	lsl.w	#8,d6
	rts
ToneFade:	movem.w	d0-d1,-(sp)
	moveq	#FX_TONE_PORTA,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	ToneFadeDone
AddFadeFX:	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
ToneFadeDone:	movem.w	(sp)+,d0-d1
	bra.s	VolumeSlide
VibFade:	movem.w	d0-d1,-(sp)
	moveq	#FX_VIBRATO,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	ToneFadeDone
	move.l	d0,a1
	bra.s	AddFadeFX
VolumeSlide:	lsr.b	#4,d6
	bne.s	VolSlideUp
	move.b	d1,d6
	and.b	#$f,d6
	addq.b	#1,d0
VolSlideUp:	tst.l	d7
	beq.s	SetVolOk
	moveq	#8+2,d1
	lsl.w	d1,d6
	rts
AbsArp:	tst.w	d6
	beq.s	NoFX
Arpeggio:	lsl.w	#4,d6
	lsr.b	#4,d6
	rts
Tremolo:	bsr.s	Arpeggio
	tst.l	d7
	beq.s	PosJump
	lsl.b	#2,d6
	rts
SetVolume:	tst.l	d7
	beq.s	SetVolOk
	lsl.b	#2,d6
	bcc.s	SetVolOk
	moveq	#-1,d6
SetVolOk:	lsl.w	#8,d6
	rts
Extended:	lea	ExtendedFXTable(pc),a0
	lsr.b	#4,d1
	movem.w	(a0,d1.w*4),d0-d1
	add.l	d1,a0
	move.w	d6,d1
	lsr.b	#4,d1
	and.b	#$f,d6
	jmp	(a0)
NoFX:	addq.l	#4,sp
	bra	NoEffect
Tempo:	cmp.b	#$20,d6
	bcs.s	PosJump
	moveq	#FX_SET_SPEED,d0
	rts
PanSlide:	lsr.b	#4,d6
	bne.s	PanSlideRight
	move.b	d1,d6
	and.b	#$f,d6
	subq.b	#1,d0
PanSlideRight:	lsl.w	#8,d6
	rts
MultiRetrig:	and.b	#$f,d1
	lsl.w	#8,d1
	or.w	d1,d6
	lsr.b	#4,d6
	beq.s	PosJump
	cmp.b	#8,d6
	beq.s	PosJump
	cmp.b	#6,d6
	bcc.s	MulRetrig
	move.b	d6,d1
	moveq	#1,d6
	lsl.b	d1,d6
	lsr.b	#1,d6
	add.b	#$C0-1,d6
	clr.b	d1
	or.w	d1,d6
PosJump:	rts
Tremor:	beq.s	PosJump
	unpk	d6,d6,#$0101
	rts
XFinePorta:	lsr.b	#4,d1
	beq.s	NoFX
	cmp.b	#$3,d1
	bcc.s	NoFX
	add.b	d1,d0
	and.b	#$f,d6
	moveq	#8+2,d1
	lsl.w	d1,d6
	rts
MulRetrig:	subq.b	#6,d6
	bne.s	MulRetr1
	move.b	#$23,d6
	rts
MulRetr1:	subq.b	#2,d6
	bcc.s	AddRetrig
	move.b	#$12,d6
	rts
AddRetrig:	cmp.b	#$6,d6
	beq.s	DivRetr1
	cmp.b	#$7,d6
	beq.s	DivRetr2
	move.b	d6,d1
	moveq	#1,d6
	lsl.b	d1,d6
	lsr.b	#1,d6
	add.b	#$80-1,d6
	clr.b	d1
	or.w	d1,d6
	rts
DivRetr1:	move.b	#$32,d6
	rts
DivRetr2:	move.b	#$21,d6
	rts
Retrig:	moveq	#FX_RETRIG_NOTE,d0
	move.w	d1,d6
	lsr.w	#8,d6
	rts
SetFineTune:	lsl.b	#4,d6
	rts
ExtendControl:	bset	#12,d6
	rts
GlissCtrl:	tst.b	d6
	beq.s	ExtendControl
	move.w	#$1001,d6
	rts
EnvCtrl:	move.w	d0,d5
	cmp.w	#$14,d5
	beq.s	EnvCtrlPos
	cmp.b	#4,d6
	blo.s	NotRetrigEnvSet
	or.b	#$10,d5
NotRetrigEnvSet:	and.w	#3,d6
	cmp.w	#3,d6
	bne.s	NotSquareWave
	moveq	#2,d6
NotSquareWave:	moveq	#FX_ENV_CONTROL,d0
	move.w	d5,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	EnvCtrlDone
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
	clr.b	d5
EnvCtrlPos:	moveq	#FX_ENV_CONTROL,d0
	move.w	d5,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	EnvCtrlDone
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
EnvCtrlDone:	moveq	#FX_SET_ENV_VAL,d0
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle from where to get the info
;	A1.L	=	APTR to track info structure where to put information
;	D0.L	=	Number of track to be scanned (NULL is the first)
;	OUTPUT
;	D0.L	=	A non-zero value if success else NULL.
ExternalTrackGetInfo:	movem.l	d2-d6/a2-a3/a6,-(sp)
	link	a5,#-80
	move.l	a0,d1
	move.l	sp,d2
	moveq	#80,d3
	move.l	d0,d6
	move.l	d1,a2
	move.l	a1,a3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalGetInfoError
	cmp.w	#$0401,58(sp)
	bne	ExternalGetInfoWrongVersion
	move.b	59(sp),trki_Version(a3)
	move.b	58(sp),trki_Revision(a3)
	movem.w	60+16(sp),d0-d1
	rol.w	#8,d0
	move.w	d0,trki_Frames(a3)
	rol.w	#8,d1
	move.w	d1,trki_BPMSpeed(a3)
	move.l	#(DEFAULTTRACKVOLUME<<24)|(DEFAULTTRACKPANNING<<8),trki_Volume(a3)
	move.l	#(DEFAULTTRACKSPDSPEED<<16)|(DEFAULTTRACKBPMTEMPO),trki_SPDSpeed(a3)
	move.b	#TCTCF_Slide|TCTCF_OpSlide|TCTCF_VolSlide,trki_CompFlags(a3)
	move.l	a2,d1
	moveq	#-20,d2
	move.l	60(sp),d0
	rol.w	#8,d0
	swap	d0
	rol.w	#8,d0
	add.l	d0,d2
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq.s	ExternalGetInfoDone
	moveq	#0,d4
	move.w	60+8(sp),d4
	rol.w	#8,d4
	moveq	#0,d1
	move.w	60+10(sp),d1
	rol.w	#8,d1
	mulu.w	d4,d1
	cmp.l	d1,d6
	bcc.s	ExternalGetInfoError
	divul.l	d4,d5:d6
FindTrackGetInfoPattern:	move.l	a2,d1
	move.l	sp,d2
	moveq	#9,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalGetInfoError
	move.l	a2,d1
	moveq	#-9,d2
	move.l	(sp),d0
	rol.w	#8,d0
	swap	d0
	rol.w	#8,d0
	add.l	d0,d2
	beq.s	NotDoGetInfoSeek
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq.s	ExternalGetInfoDone
NotDoGetInfoSeek:	move.l	a2,d1
	move.w	5(sp),d0
	rol.w	#8,d0
	move.w	d0,trki_Length(a3)
	move.l	a2,d1
	moveq	#0,d2
	move.w	7(sp),d2
	rol.w	#8,d2
	moveq	#OFFSET_CURRENT,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq.s	ExternalGetInfoDone
	subq.w	#1,d6
	bcc.s	FindTrackGetInfoPattern
	clr.b	37(sp)
	lea	17(sp),a0
	jsr	_LVOAllocNameStr(a6)
	move.l	d0,trki_Name(a3)
	move.l	a3,d0
ExternalGetInfoDone:	unlk	a5
	movem.l	(sp)+,d2-d6/a2-a3/a6
	rts
ExternalGetInfoError:	moveq	#0,d0
	bra.s	ExternalGetInfoDone
ExternalGetInfoWrongVersion:	moveq	#255-ERROR_ACTION_NOT_KNOWN,d1
	not.b	d1
	move.l	tcb_DOSBase(a6),a6
	jsr	_LVOSetIoErr(a6)
	bra.s	ExternalGetInfoError
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	Number of tracks found or NULL on any error
ExternalTrackGetNums:	move.l	a6,-(sp)
	link	a5,#-72
	move.l	a0,d1
	move.l	sp,d2
	moveq	#72,d3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalGetNumError
	cmp.w	#$0401,58(sp)
	bne.s	ExternalGetNumWrongVersion
	move.w	60+8(sp),d0
	rol.w	#8,d0
	move.w	60+10(sp),d1
	rol.w	#8,d1
	mulu.w	d1,d0
ExternalGetNumsDone:	unlk	a5
	move.l	(sp)+,a6
	rts
ExternalGetNumError:	moveq	#0,d0
	bra.s	ExternalGetNumsDone
ExternalGetNumWrongVersion:	moveq	#255-ERROR_ACTION_NOT_KNOWN,d1
	not.b	d1
	move.l	tcb_DOSBase(a6),a6
	jsr	_LVOSetIoErr(a6)
	bra.s	ExternalGetNumError

	cnop	0,4

ExtTrackLibBase:	dc.l	0

LoadFlags:	dc.w	1
	dc.w	LoadFlagSize
	dc.l	LoadText0
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
LoadText0:	dc.b	'Convert volumes',0
LoadFlagSize:	equ	*-LoadFlags
LoadDescript:	dc.b	'FastTracker ][ Module (XM)',0
XMId:	dc.b	'Extended Module: '
XMIdLen: