*********************************************************
***    TuComposer External Track Library for XT       ***
***       1996-97 by The united Coders (TuC)         ***
***                Main code: Basty/TuC               ***
*** This is a XT track loader (FastTracker ][ tracks) ***
*********************************************************

	IFND	_G2
	MACHINE	MC68020
	OPT	NODEBUG,NOLINE
	ENDC

	include	"exec/types.i"
	include	"exec/execbase.i"
	include	"exec/exec_lib.i"
	include	"exec/initializers.i"
	include	"exec/memory.i"
	include	"exec/resident.i"
	include	"exec/libraries.i"
	include	"libraries/dos_lib.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/track.i"
	include	"tucomposer/external/external.i"
	include	"tucomposer/external/external_lib.i"
	include	"tucomposer/external/track.i"
	include	"tucomposer/external/track_lib.i"

	moveq	#-1,d0
	rts
ResidentStruct:	dc.w	RTC_MATCHWORD
	dc.l	ResidentStruct
	dc.l	0
	dc.b	RTF_AUTOINIT
	dc.b	EXTLIB_TRACK_VERSION
	dc.b	NT_LIBRARY
	dc.b	0
	dc.l	LibName
	dc.l	LibID
	dc.l	Init
LibName:	dc.b	'xt.library',0
LibID:	dc.b	'TuComposer External Track Loader Version 1.00 (v31) for XT (68020+, OS2.0+) (3 Mar 97) by Basty/TuC.',0
TuComposerName:	dc.b	'tucomposer.library',0
	even
Init:	dc.l	trkl_SIZEOF
	dc.l	FuncTab
	dc.l	DataTab
	dc.l	PrepareLibrary

FuncTab:	dc.w	-1
	dc.w	Open-FuncTab
	dc.w	Close-FuncTab
	dc.w	Expunge-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalInitialize-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalTrackIdentify-FuncTab
	dc.w	ExternalTrackLoad-FuncTab
	dc.w	ExternalTrackSave-FuncTab
	dc.w	ExternalTrackGetInfo-FuncTab
	dc.w	ExternalTrackGetNums-FuncTab
	dc.w	-1

DataTab:	INITLONG	LN_NAME,LibName
	INITBYTE	LIB_FLAGS,LIBF_CHANGED|LIBF_SUMUSED
	INITWORD	LIB_VERSION,EXTLIB_TRACK_VERSION
	INITWORD	LIB_REVISION,EXTLIB_REVISION
	INITLONG	LIB_IDSTRING,LibID
	dc.l	0

PrepareLibrary:	btst	#AFB_68020,AttnFlags+1(a6)
	beq.s	ExtLib
	cmp.w	#36,LIB_VERSION(a6)
	blt.s	ExtLib
	move.l	a2,-(sp)
	move.l	d0,a2
	move.l	a0,extb_SegList(a2)
	moveq	#31,d0
	lea	TuComposerName(pc),a1
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,extb_TuComposerBase(a2)
	beq.s	NoTuCLib
	lea	ExtTrackLibBase(pc),a0
	move.l	a2,(a0)
	move.l	a2,d0
NoTuCLib:	move.l	(sp)+,a2
	rts
Open:	addq.w	#1,LIB_OPENCNT(a6)
	move.l	a6,d0
	rts
Close:	subq.w	#1,LIB_OPENCNT(a6)
	bne.s	ExtLib
	btst	#LIBB_DELEXP,LIB_FLAGS(a6)
	bne.s	Expunge
ExtLib:	moveq	#0,d0
	rts
Expunge:	bset	#LIBB_DELEXP,LIB_FLAGS(a6)
	tst.w	LIB_OPENCNT(a6)
	bne.s	ExtLib
	movem.l	d2/a5-a6,-(sp)
	move.l	extb_ExtLibList(a6),d0
	beq.s	NoExtLibList
	move.l	d0,a0
	clr.l	extl_LibBase(a0)
NoExtLibList:	move.l	extb_TuComposerBase(a6),a1
	move.l	a6,a5
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
	move.l	extb_SegList(a5),d2
	move.l	a5,a1
	jsr	_LVORemove(a6)
	move.l	a5,a1
	moveq	#0,d0
	moveq	#0,d1
	move.w	LIB_NEGSIZE(a5),d1
	sub.l	d1,a1
	move.w	LIB_POSSIZE(a5),d0
	add.l	d1,d0
	jsr	_LVOFreeMem(a6)
	move.l	d2,d0
	movem.l	(sp)+,d2/a5-a6
	rts
;	INPUT
;	A0.L	=	APTR to track external list structure to be initialized
;	OUTPUT
;	D0.L	=	What type of external library is it or NULL if error
ExternalInitialize:	move.l	extb_TuComposerBase(a6),a1
	movem.l	a2/a6,-(sp)
	move.l	a0,d0
	beq.s	ExternalInitDone
	move.l	a1,a6
	move.b	#EXTLF_Loader|EXTLF_Saver,extl_Flags(a0)
	move.l	a0,a2
	lea	extl_Descriptor(a0),a0
	lea	LoadDescript(pc),a1
	jsr	_LVOSetString(a6)
	tst.l	d0
	beq.s	ExternalInitDone
	lea	LoadFlags(pc),a0
	jsr	_LVOAllocFlagStr(a6)
	move.l	d0,extl_LoadFlagStr(a2)
	beq.s	ExternalInitDone
	move.l	d0,extl_SaveFlagStr(a2)
	moveq	#EXTTYPE_TRACK,d0
ExternalInitDone:	movem.l	(sp)+,a2/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	If failed NULL else any non-zero value
ExternalTrackIdentify:	movem.l	d2-d4/a2/a6,-(sp)
	move.l	a0,d1
	subq.l	#4,sp
	move.l	sp,d2
	moveq	#4,d3
	move.l	d1,a2
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	movem.w	(sp)+,d1/d4
	cmp.l	d3,d0
	bne.s	ExternalTrackIdDone
	rol.w	#8,d4
	mulu.w	#5,d4
	addq.l	#4+1,d4
	move.l	a2,d1
	moveq	#0,d2
	moveq	#OFFSET_END,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq.s	ExternalTrackIdDone
	move.l	a2,d1
	moveq	#0,d2
	moveq	#OFFSET_END,d3
	jsr	_LVOCSeek(a6)
	addq.l	#1,d0
	beq.s	ExternalTrackIdDone
	cmp.l	d0,d4
	beq.s	ExternalTrackIdOk
ExternalTrackIdDone:	moveq	#0,d0
ExternalTrackIdOk:	movem.l	(sp)+,d2-d4/a2/a6
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be loaded
;	A1.L	=	APTR to target track structure or NULL to create a new one
;	A2.L	=	APTR to loading flag pass structure (Loader specific)
;	D0.L	=	Number of track of be loaded (NULL is the first)
;	OUTPUT
;	D0.L	=	APTR to track structure where loaded track data
ExternalTrackLoad:	movem.l	d2-d7/a2-a6,-(sp)
	subq.l	#4,sp
	move.l	sp,d2
	moveq	#4,d3
	move.l	(a2),d7
	move.l	a0,d1
	move.l	d1,a2
	move.l	a1,a3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalTrackLoadErr
	move.l	a2,d1
	moveq	#0,d2
	moveq	#OFFSET_END,d3
	jsr	_LVOCSeek(a6)
	move.l	d0,d4
	addq.l	#1,d0
	beq	ExternalTrackLoadDone
	move.l	a2,d1
	move.l	d4,d2
	moveq	#OFFSET_BEGINNING,d3
	jsr	_LVOCSeek(a6)
	move.l	d0,d4
	addq.l	#1,d0
	beq	ExternalTrackLoadDone
	cmp.w	#$0100,(sp)
	bne	ExternalTrackWrongVersion
	move.l	d4,d0
	move.l	a6,a5
	jsr	_LVOAllocPMem(a6)
	move.l	a2,d1
	move.l	d0,d2
	beq	ExternalTrackLoadError
	move.l	d4,d3
	subq.l	#4,d3
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne	ExternalTrackLoadError
	moveq	#0,d3
	move.w	2(sp),d3
	rol.w	#8,d3
	move.l	a3,d0
	bne.s	TrackAllocated
	move.l	d3,d0
	jsr	_LVOAllocTrack(a6)
TrackAllocated:	move.l	d0,d1
	beq	ExternalTrackLoadError
	move.l	d0,a3
	move.l	d3,d0
	move.l	a3,a0
	jsr	_LVOReSizeTrack(a6)
	tst.l	d0
	bne	ExternalTrackLoadError
	move.l	a3,a0
	jsr	_LVOClearTrack(a6)
	move.l	d2,a2
	move.b	#TCTCF_Slide|TCTCF_OpSlide|TCTCF_VolSlide,tct_CompFlags(a3)
	move.l	tct_Data(a3),a4
ExternalTrackConvertLoop:	moveq	#0,d0
	move.b	(a2)+,d0
	bne.s	InstrOk
	clr.b	(a2)
	bra.s	NoNote
InstrOk:	cmp.b	#$61,d0
	bne.s	NotKeyoff
	moveq	#255-NOTE_KEYOFF,d0
	not.b	d0
NoNote:	move.w	d0,(a4)+
	bra.s	NoteDone
NotKeyoff:	subq.b	#1,d0
	divu.w	#12,d0
	move.b	d0,(a4)+
	swap	d0
	addq.b	#1,d0
	move.b	d0,(a4)+
NoteDone:	move.b	(a2)+,d0
	move.w	d0,(a4)+
	moveq	#0,d6
	move.b	(a2)+,d6
	sub.b	#$10,d6
	bcs.s	NoVolumeColumn
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d5
	beq.s	NoVolumeColumn
	cmp.b	#$41,d6
	bcc.s	NotSetVolume
	tst.l	d7
	beq.s	NotVolFF
	lsl.b	#2,d6
	bcc.s	NotVolFF
	moveq	#-1,d6
NotVolFF:	moveq	#FX_SET_VOLUME,d0
	lsl.w	#8,d6
	bra.s	SetVolumeColumn
SpecialVolColExec:	dc.b	FX_VOL_SLD_DOWN,VolSlide-SpecialVolColExec
	dc.b	FX_VOL_SLD_UP,VolSlide-SpecialVolColExec
	dc.b	FX_F_VOLSL_DOWN,VolSlide-SpecialVolColExec
	dc.b	FX_F_VOLSL_UP,VolSlide-SpecialVolColExec
	dc.b	FX_VIBRATO,Vibrato-SpecialVolColExec
	dc.b	FX_VIBRATO,VibRate-SpecialVolColExec
	dc.b	FX_SET_PANNING,Panning-SpecialVolColExec
	dc.b	FX_PAN_SL_LEFT,VibRate-SpecialVolColExec
	dc.b	FX_PAN_SL_RIGHT,VibRate-SpecialVolColExec
	dc.b	FX_TONE_PORTA,VibRate-SpecialVolColExec
VolSlide:	tst.l	d7
	beq.s	VibRate
	moveq	#8+2,d1
	lsl.w	d1,d6
	rts
Panning:	move.b	d6,d1
	lsl.b	#4,d1
	or.b	d1,d6
VibRate:	lsl.w	#8,d6
Vibrato:	rts
NotSetVolume:	lea	SpecialVolColExec-5*2(pc),a0
	move.l	d6,d1
	lsr.b	#4,d1
	add.l	d1,a0
	add.l	d1,a0
	move.b	(a0)+,d0
	move.b	(a0)+,d1
	ext.w	d1
	and.b	#$f,d6
	jsr	SpecialVolColExec(pc,d1.w)
SetVolumeColumn:	move.l	d5,a1
	move.b	d0,tcte_EffectByte(a1)
	move.w	d6,tcte_DataWord(a1)
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
NoVolumeColumn:	moveq	#0,d0
	move.b	(a2)+,d0
	moveq	#0,d6
	move.b	(a2)+,d6
	cmp.b	#$22,d0
	bcc.s	NoEffect
	cmp.b	#9,d0
	bne.s	NotSmpOffset
	tst.w	tctd_Octave-tctd_Effects(a4)
	beq.s	NoEffect
NotSmpOffset:	movem.w	ProcessFXTable(pc,d0.w*4),d0-d1
	lea	ProcessFXTable(pc),a0
	add.l	d1,a0
	move.w	d6,d1
	jsr	(a0)
	move.w	d6,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	NoEffect
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
NoEffect:	lea	MLH_SIZE(a4),a4
	subq.w	#1,d3
	bne	ExternalTrackConvertLoop
	move.l	d2,a1
	move.l	d4,d0
	move.l	a5,a6
	jsr	_LVOFreePMem(a6)
	move.l	a3,d0
ExternalTrackLoadDone:	movem.l	(sp)+,d1-d7/a2-a6
	rts
ExternalTrackLoadError:	move.l	d2,a1
	move.l	d4,d0
	move.l	a5,a6
	jsr	_LVOFreePMem(a6)
ExternalTrackLoadErr:	moveq	#0,d0
	bra.s	ExternalTrackLoadDone
ExternalTrackWrongVersion:	moveq	#255-ERROR_ACTION_NOT_KNOWN,d1
	not.b	d1
	move.l	tcb_DOSBase(a6),a6
	jsr	_LVOSetIoErr(a6)
	bra.s	ExternalTrackLoadErr
ProcessFXTable:	dc.w	FX_ARPEGGIO,AbsArp-ProcessFXTable
	dc.w	FX_PORTA_UP,Porta-ProcessFXTable
	dc.w	FX_PORTA_DOWN,Porta-ProcessFXTable
	dc.w	FX_TONE_PORTA,Porta-ProcessFXTable
	dc.w	FX_VIBRATO,Arpeggio-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,ToneFade-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,VibFade-ProcessFXTable
	dc.w	FX_TREMOLO,Tremolo-ProcessFXTable
	dc.w	FX_SET_PANNING,Porta-ProcessFXTable
	dc.w	FX_SMP_OFF_LOW,Porta-ProcessFXTable
	dc.w	FX_VOL_SLD_UP,VolumeSlide-ProcessFXTable
	dc.w	FX_POS_JUMP,PosJump-ProcessFXTable
	dc.w	FX_SET_VOLUME,SetVolume-ProcessFXTable
	dc.w	FX_PATT_BREAK,PosJump-ProcessFXTable
	dc.w	0,Extended-ProcessFXTable
	dc.w	FX_SET_TEMPO,Tempo-ProcessFXTable
	dc.w	FX_SET_G_VOLUME,SetVolume-ProcessFXTable
	dc.w	FX_G_VOLSL_UP,VolumeSlide-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	FX_DO_KEYOFF,PosJump-ProcessFXTable
	dc.w	$0014,EnvCtrl-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	FX_PAN_SL_RIGHT,PanSlide-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	FX_MULTI_RETRIG,MultiRetrig-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	FX_TREMOR,Tremor-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	0,NoFX-ProcessFXTable
	dc.w	FX_OFPORTA_UP-1,XFinePorta-ProcessFXTable
ExtendedFXTable:	dc.w	0,NoFX-ExtendedFXTable
	dc.w	FX_O_PORTA_UP,Porta-ExtendedFXTable
	dc.w	FX_O_PORTA_DOWN,Porta-ExtendedFXTable
	dc.w	FX_EXTEND_CTRL,GlissCtrl-ExtendedFXTable
	dc.w	$0301,EnvCtrl-ExtendedFXTable
	dc.w	FX_SET_TRANSP,SetFineTune-ExtendedFXTable
	dc.w	FX_PATT_LOOP,PosJump-ExtendedFXTable
	dc.w	$0401,EnvCtrl-ExtendedFXTable
	dc.w	USER_EFFECTS,PosJump-ExtendedFXTable
	dc.w	FX_RETRIG_NOTE,PosJump-ExtendedFXTable
	dc.w	FX_F_VOLSL_UP,VolSlide-ExtendedFXTable
	dc.w	FX_F_VOLSL_DOWN,VolSlide-ExtendedFXTable
	dc.w	FX_NOTE_CUT,PosJump-ExtendedFXTable
	dc.w	FX_NOTE_DELAY,PosJump-ExtendedFXTable
	dc.w	FX_PATT_DELAY,PosJump-ExtendedFXTable
	dc.w	FX_INVERT_LOOP,PosJump-ExtendedFXTable
Porta:	lsl.w	#8,d6
	rts
ToneFade:	movem.w	d0-d1,-(sp)
	moveq	#FX_TONE_PORTA,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	ToneFadeDone
AddFadeFX:	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
ToneFadeDone:	movem.w	(sp)+,d0-d1
	bra.s	VolumeSlide
VibFade:	movem.w	d0-d1,-(sp)
	moveq	#FX_VIBRATO,d0
	moveq	#0,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	ToneFadeDone
	move.l	d0,a1
	bra.s	AddFadeFX
VolumeSlide:	lsr.b	#4,d6
	bne.s	VolSlideUp
	move.b	d1,d6
	and.b	#$f,d6
	addq.b	#1,d0
VolSlideUp:	tst.l	d7
	beq.s	SetVolOk
	moveq	#8+2,d1
	lsl.w	d1,d6
	rts
AbsArp:	tst.w	d6
	beq.s	NoFX
Arpeggio:	lsl.w	#4,d6
	lsr.b	#4,d6
	rts
Tremolo:	bsr.s	Arpeggio
	tst.l	d7
	beq.s	PosJump
	lsl.b	#2,d6
	rts
SetVolume:	tst.l	d7
	beq.s	SetVolOk
	lsl.b	#2,d6
	bcc.s	SetVolOk
	moveq	#-1,d6
SetVolOk:	lsl.w	#8,d6
	rts
Extended:	lea	ExtendedFXTable(pc),a0
	lsr.b	#4,d1
	movem.w	(a0,d1.w*4),d0-d1
	add.l	d1,a0
	move.w	d6,d1
	lsr.b	#4,d1
	and.b	#$f,d6
	jmp	(a0)
NoFX:	addq.l	#4,sp
	bra	NoEffect
Tempo:	cmp.b	#$20,d6
	bcs.s	PosJump
	moveq	#FX_SET_SPEED,d0
	rts
PanSlide:	lsr.b	#4,d6
	bne.s	PanSlideRight
	move.b	d1,d6
	and.b	#$f,d6
	subq.b	#1,d0
PanSlideRight:	lsl.w	#8,d6
	rts
MultiRetrig:	and.b	#$f,d1
	lsl.w	#8,d1
	or.w	d1,d6
	lsr.b	#4,d6
	beq.s	Retrig2
	cmp.b	#8,d6
	beq.s	Retrig2
	cmp.b	#6,d6
	bcc.s	MulRetrig
	move.b	d6,d1
	moveq	#1,d6
	lsl.b	d1,d6
	lsr.b	#1,d6
	add.b	#$C0-1,d6
	clr.b	d1
	or.w	d1,d6
PosJump:	rts
Tremor:	beq.s	PosJump
	unpk	d6,d6,#$0101
	rts
XFinePorta:	lsr.b	#4,d1
	beq.s	NoFX
	cmp.b	#$3,d1
	bcc.s	NoFX
	add.b	d1,d0
	and.b	#$f,d6
	moveq	#8+2,d1
	lsl.w	d1,d6
	rts
MulRetrig:	subq.b	#6,d6
	bne.s	MulRetr1
	move.b	#$23,d6
	rts
MulRetr1:	subq.b	#2,d6
	bcc.s	AddRetrig
	move.b	#$12,d6
	rts
AddRetrig:	cmp.b	#$6,d6
	beq.s	DivRetr1
	cmp.b	#$7,d6
	beq.s	DivRetr2
	move.b	d6,d1
	moveq	#1,d6
	lsl.b	d1,d6
	lsr.b	#1,d6
	add.b	#$80-1,d6
	clr.b	d1
	or.w	d1,d6
	rts
DivRetr1:	move.b	#$32,d6
	rts
DivRetr2:	move.b	#$21,d6
	rts
Retrig2:	moveq	#FX_RETRIG_NOTE,d0
	move.w	d1,d6
	rts
Retrig:	moveq	#FX_RETRIG_NOTE,d0
	move.w	d1,d6
	lsr.w	#8,d6
	rts
SetFineTune:	lsl.b	#4,d6
	rts
ExtendControl:	bset	#12,d6
	rts
GlissCtrl:	tst.b	d6
	beq.s	ExtendControl
	move.w	#$1001,d6
	rts
EnvCtrl:	move.w	d0,d5
	cmp.w	#$14,d5
	beq.s	EnvCtrlPos
	cmp.b	#4,d6
	blo.s	NotRetrigEnvSet
	or.b	#$10,d5
NotRetrigEnvSet:	and.w	#3,d6
	cmp.w	#3,d6
	bne.s	NotSquareWave
	moveq	#2,d6
NotSquareWave:	moveq	#FX_ENV_CONTROL,d0
	move.w	d5,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	EnvCtrlDone
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
	clr.b	d5
EnvCtrlPos:	moveq	#FX_ENV_CONTROL,d0
	move.w	d5,d1
	move.l	a5,a6
	jsr	_LVOAllocEffect(a6)
	move.l	4.w,a6
	move.l	d0,d1
	beq.s	EnvCtrlDone
	move.l	d0,a1
	move.l	a4,a0
	jsr	_LVOAddTail(a6)
EnvCtrlDone:	moveq	#FX_SET_ENV_VAL,d0
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be loaded
;	A1.L	=	APTR to track structure to be saved
;	A2.L	=	APTR to saving flag pass structure (Saver specific)
;	OUTPUT
;	D0.L	=	FALSE if successful save, else one of the libs fault codes
ExternalTrackSave:	movem.l	d2-d7/a2-a6,-(sp)
	move.l	(a2),d5
	move.l	a0,a2
	move.l	a1,a3
	move.w	tct_Length(a3),d0
	addq.l	#1,d0
	move.l	d0,d2
	mulu.w	#5,d0
	addq.l	#4,d0
	move.l	d0,d3
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOAllocPMem(a6)
	move.l	d0,d1
	beq	ExternalTrackSaveMemErr
	move.l	d1,a0
	move.l	a0,a4
	move.w	#$0100,(a0)+
	rol.w	#8,d2
	move.w	d2,(a0)+
	rol.w	#8,d2
	move.l	tct_Data(a3),a1
ConvertToXTLoop:	move.b	(a1)+,d0
	move.b	(a1)+,d1
	cmp.b	#SPEC_NOTES,d1
	bcs.s	NotSpecialNotes
	moveq	#$61,d0
	addq.b	#3,d1
	bcs.s	PutXTNote
	moveq	#0,d0
	bra.s	PutXTNote
NotSpecialNotes:	cmp.b	#8,d0
	bcs.s	OctavesOk
	moveq	#7,d0
	moveq	#NOTE_B_,d1
OctavesOk:	mulu.w	#LASTNOTE,d0
	add.b	d1,d0
PutXTNote:	move.b	d0,(a0)+
	move.w	(a1)+,d0
	move.b	d0,(a0)+
	move.l	a1,d4
ScanVolFXLoop:	moveq	#0,d0
	move.l	(a1),a1
	tst.l	(a1)
	beq.s	ScanVolFXDone
	move.b	tcte_EffectByte(a1),d0
	move.w	tcte_DataWord(a1),d1
	moveq	#0,d6
	lea	SaveVolColTable-3(pc),a5
ScanVolColTable:	addq.l	#4-1,a5
	tst.l	(a5)
	beq.s	ScanVolFXLoop
	cmp.b	(a5)+,d0
	bne.s	ScanVolColTable
	move.l	a1,d6
	move.b	(a5)+,d0
	move.w	(a5),d7
	jsr	SaveVolColTable(pc,d7.w)
ScanVolFXDone:	move.b	d0,(a0)+
	move.l	d4,a1
ScanFXLoop:	moveq	#0,d0
	moveq	#0,d1
	move.l	(a1),a1
	tst.l	(a1)
	beq.s	ScanFXDone
	cmp.l	a1,d6
	beq.s	ScanFXLoop
	move.b	tcte_EffectByte(a1),d0
	move.w	tcte_DataWord(a1),d1
	lea	SaveFXTable-3(pc),a5
ScanFXTable:	addq.l	#4-1,a5
	tst.l	(a5)
	beq.s	ScanFXLoop
	cmp.b	(a5)+,d0
	bne.s	ScanFXTable
	move.b	(a5)+,d0
	move.w	(a5),d7
	jsr	SaveFXTable(pc,d7.w)
ScanFXDone:	move.b	d0,(a0)+
	move.b	d1,(a0)+
	move.l	d4,a1
	lea	MLH_SIZE(a1),a1
	subq.w	#1,d2
	bne	ConvertToXTLoop
	move.l	a2,d1
	move.l	a4,d2
	jsr	_LVOCWrite(a6)
	cmp.l	d3,d0
	bne.s	ExternalTrackWriteErr
	move.l	d3,d0
	move.l	a4,a1
	jsr	_LVOFreePMem(a6)
	moveq	#0,d0
ExternalTrackSaveDone:	movem.l	(sp)+,d2-d7/a2-a6
	rts
ExternalTrackSaveMemErr:	moveq	#ERROR_TRACK_IOERR,d0
	bra.s	ExternalTrackSaveDone
ExternalTrackWriteErr:	move.l	d3,d0
	move.l	a4,a1
	jsr	_LVOFreePMem(a6)
	moveq	#ERROR_TRACK_NOMEM,d0
	bra.s	ExternalTrackSaveDone
SaveVolColTable:	dc.w	(FX_SET_VOLUME<<8)|$10,SaveVolume-SaveVolColTable
	dc.w	(FX_VOL_SLD_DOWN<<8)|$60,SaveVolSlide-SaveVolColTable
	dc.w	(FX_VOL_SLD_UP<<8)|$70,SaveVolSlide-SaveVolColTable
	dc.w	(FX_F_VOLSL_DOWN<<8)|$80,SaveVolSlide-SaveVolColTable
	dc.w	(FX_F_VOLSL_UP<<8)|$90,SaveVolSlide-SaveVolColTable
	dc.w	(FX_VIBRATO<<8)|$A0,SaveVibrato-SaveVolColTable
	dc.w	(FX_SET_PANNING<<8)|$C0,SavePanning-SaveVolColTable
	dc.w	(FX_PAN_SL_LEFT<<8)|$D0,SavePanSlide-SaveVolColTable
	dc.w	(FX_PAN_SL_RIGHT<<8)|$E0,SavePanSlide-SaveVolColTable
	dc.w	(FX_TONE_PORTA<<8)|$F0,SavePanSlide-SaveVolColTable
	dc.l	0
SaveFXTable:	dc.w	(FX_ARPEGGIO<<8)|$00,SaveArpeggio-SaveFXTable
	dc.w	(FX_PORTA_UP<<8)|$01,SavePorta-SaveFXTable
	dc.w	(FX_PORTA_DOWN<<8)|$02,SavePorta-SaveFXTable
	dc.w	(FX_TONE_PORTA<<8)|$03,Save2FX-SaveFXTable
	dc.w	(FX_VIBRATO<<8)|$04,Save2FX-SaveFXTable
	dc.w	(FX_TREMOLO<<8)|$07,SaveTremolo-SaveFXTable
	dc.w	(FX_SET_PANNING<<8)|$08,SavePorta-SaveFXTable
	dc.w	(FX_SMP_OFF_LOW<<8)|$09,SavePorta-SaveFXTable
	dc.w	(FX_VOL_SLD_UP<<8)|$0A,SaveVolSlUp-SaveFXTable
	dc.w	(FX_VOL_SLD_DOWN<<8)|$0A,SaveVolSlDn-SaveFXTable
	dc.w	(FX_POS_JUMP<<8)|$0B,SavePosJump-SaveFXTable
	dc.w	(FX_SET_VOLUME<<8)|$0C,SaveVol-SaveFXTable
	dc.w	(FX_PATT_BREAK<<8)|$0D,SavePosJump-SaveFXTable
	dc.w	(FX_O_PORTA_UP<<8)|$10,SaveExtended-SaveFXTable
	dc.w	(FX_O_PORTA_DOWN<<8)|$20,SaveExtended-SaveFXTable
	dc.w	(FX_EXTEND_CTRL<<8)|$30,SaveExtended-SaveFXTable
	dc.w	(FX_SET_TRANSP<<8)|$50,SaveExtended-SaveFXTable
	dc.w	(FX_PATT_LOOP<<8)|$60,SaveExtended-SaveFXTable
	dc.w	(USER_EFFECTS<<8)|$80,SaveExtended-SaveFXTable
	dc.w	(FX_RETRIG_NOTE<<8)|$90,SaveExtended-SaveFXTable
	dc.w	(FX_F_VOLSL_UP<<8)|$A0,SaveExtended-SaveFXTable
	dc.w	(FX_F_VOLSL_DOWN<<8)|$B0,SaveExtended-SaveFXTable
	dc.w	(FX_NOTE_CUT<<8)|$C0,SaveExtended-SaveFXTable
	dc.w	(FX_NOTE_DELAY<<8)|$D0,SaveExtended-SaveFXTable
	dc.w	(FX_PATT_DELAY<<8)|$E0,SaveExtended-SaveFXTable
	dc.w	(FX_INVERT_LOOP<<8)|$F0,SaveExtended-SaveFXTable
	dc.w	(FX_SET_TEMPO<<8)|$0F,SavePosJump-SaveFXTable
	dc.w	(FX_SET_SPEED<<8)|$0F,SavePosJump-SaveFXTable
	dc.w	(FX_SET_G_VOLUME<<8)|$10,SaveVol-SaveFXTable
	dc.w	(FX_G_VOLSL_UP<<8)|$11,SaveVolSlUp-SaveFXTable
	dc.w	(FX_G_VOLSL_DOWN<<8)|$11,SaveVolSlDn-SaveFXTable
	dc.w	(FX_DO_KEYOFF<<8)|$14,SavePosJump-SaveFXTable
	dc.w	(FX_ENV_CONTROL<<8)|$15,SaveEnvCtrl-SaveFXTable
	dc.w	(FX_PAN_SL_LEFT<<8)|$19,SavePanSlLeft-SaveFXTable
	dc.w	(FX_PAN_SL_RIGHT<<8)|$19,SavePanSlRight-SaveFXTable
	dc.w	(FX_MULTI_RETRIG<<8)|$1B,SaveMultiRetrig-SaveFXTable
	dc.w	(FX_TREMOR<<8)|$1D,SaveArpeggio-SaveFXTable
	dc.w	(FX_OFPORTA_UP<<8)|$21,SaveXtraPortaUp-SaveFXTable
	dc.w	(FX_OFPORTA_DOWN<<8)|$21,SaveXtraPortaDn-SaveFXTable
	dc.l	0
SaveVolume:	lsr.w	#8,d1
	tst.l	d5
	beq.s	SaveNoConvVol
	addq.w	#2,d1
	lsr.w	#2,d1
SaveNoConvVol:	cmp.b	#$40,d1
	bcs.s	VolValOk
	moveq	#$40,d1
VolValOk:	add.b	d1,d0
	rts
SaveVolSlide:	lsr.w	#8,d1
	tst.l	d5
	beq.s	SaveNoConvVolSl
	addq.w	#2,d1
	lsr.w	#2,d1
SaveNoConvVolSl:	cmp.b	#$10,d1
	bcs.s	VolSlValOk
SaveVolFail:	moveq	#0,d0
	moveq	#0,d6
	rts
VolSlValOk:	or.b	d1,d0
	rts
SaveVibrato:	tst.b	d1
	bne.s	SaveVibrato2
	add.b	#$10,d0
	lsr.w	#8,d1
	bra.s	SaveNoConvVolSl
SaveVibrato2:	rol.w	#8,d1
	tst.b	d1
	bne.s	SaveVolFail
	lsr.w	#8,d1
	bra.s	SaveNoConvVolSl
SavePanning:	lsr.w	#8,d1
	move.b	d1,d7
	and.b	#$f,d7
	lsr.w	#4,d1
	cmp.b	d7,d1
	bne.s	SaveVolFail
	bra.s	VolSlValOk
SavePanSlide:	lsr.w	#8,d1
	bra.s	SaveNoConvVolSl
SaveArpeggio:	move.w	d1,d7
	lsr.w	#4,d7
	and.b	#$f,d1
	and.b	#$f0,d7
	or.b	d7,d1
	rts
SaveTremolo:	move.w	d1,d7
	lsr.w	#4,d7
	and.b	#$f0,d7
	lsr.b	#2,d1
	tst.l	d5
	beq.s	SaveTremoloNoConv
	lsr.b	#2,d1
SaveTremoloNoConv:	and.b	#$f,d1
	or.b	d7,d1
	rts
Save2FX:	move.l	a1,-(sp)
	tst.w	tcte_DataWord(a1)
	bne.s	FindVolSlideDone
	move.l	d4,a1
FindVolSlide:	move.l	(a1),a1
	tst.l	(a1)
	beq.s	FindVolSlideDone
	cmp.l	a1,d6
	beq.s	FindVolSlide
	cmp.b	#FX_VOL_SLD_DOWN,tcte_EffectByte(a1)
	beq.s	FindVolSlideDown
	cmp.b	#FX_VOL_SLD_UP,tcte_EffectByte(a1)
	bne.s	FindVolSlide
	lea	SaveVolSlUp(pc),a5
	bra.s	FindVolSlideOk
FindVolSlideDown:	lea	SaveVolSlDn(pc),a5
FindVolSlideOk:	addq.b	#2,d0
	move.w	tcte_DataWord(a1),d1
	move.l	(sp)+,a1
	jmp	(a5)
FindVolSlideDone:	move.l	(sp)+,a1
	cmp.b	#4,d0
	beq.s	SaveArpeggio
SavePorta:	lsr.w	#8,d1
	rts
FXAndFadeUp:	addq.b	#2,d0
	move.w	tcte_DataWord(a1),d1
	move.l	(sp)+,a1
SaveVolSlUp:	lsr.w	#8,d1
	tst.l	d5
	beq.s	NotConvSaveVolSlUp
	addq.w	#2,d1
	lsr.w	#2,d1
NotConvSaveVolSlUp:	cmp.b	#$f,d1
	bcs.s	SaveConvVolSlUpOk
	moveq	#$f,d1
SaveConvVolSlUpOk:	lsl.b	#4,d1
	rts
SaveVolSlDn:	lsr.w	#8,d1
	tst.l	d5
	beq.s	NotConvSaveVolSlDn
	addq.w	#2,d1
	lsr.w	#2,d1
NotConvSaveVolSlDn:	cmp.b	#$f,d1
	bcs.s	SavePosJump
	moveq	#$f,d1
SavePosJump:	rts
SaveVol:	lsr.w	#8,d1
	tst.l	d5
	beq.s	NotConvSaveVol
	addq.w	#2,d1
	lsr.w	#2,d1
NotConvSaveVol:	cmp.b	#$40,d1
	bcs.s	SavePosJump
	moveq	#$40,d1
	rts
SaveExtended:	move.w	d1,d7
	move.b	d0,d1
	lsr.b	#3,d0
	ext.w	d0
	lea	SaveExtendedFXTable(pc),a5
	add.w	(a5,d0.w),a5
	moveq	#$e,d0
	jsr	(a5)
	cmp.b	#$f,d7
	bcs.s	SaveExtendedOk
	moveq	#$f,d7
SaveExtendedOk:	or.b	d7,d1
	rts
SaveExtPorta:	lsr.w	#8,d7
	rts
SaveExtPosJump:	and.b	#$f,d7
	rts
SaveExtVolSlide:	lsr.w	#8,d7
	tst.l	d5
	beq.s	SavePosJump
	addq.w	#2,d7
	lsr.w	#2,d7
	rts
SavePanSlLeft:	lsr.w	#8,d1
	cmp.b	#$f,d1
	bcs.s	SavePosJump
	moveq	#$f,d1
	rts
SavePanSlRight:	clr.b	d1
	lsr.w	#4,d1
	cmp.b	#$f,d1
	bcs.s	SavePosJump
	moveq	#$f,d1
	rts
SaveExtGlissCtrl:	move.w	d7,d1
	clr.b	d1
	rol.w	#4,d1
	subq.b	#1,d1
	beq.s	SaveExtGlissOk
	moveq	#0,d0
	moveq	#0,d1
	moveq	#0,d7
SaveExtGlissOk:	moveq	#$30,d1
	rts
SaveExtFineTune:	lsr.b	#4,d7
	rts
SaveExtendedFXTable:	dc.w	0
	dc.w	SaveExtPorta-SaveExtendedFXTable
	dc.w	SaveExtPorta-SaveExtendedFXTable
	dc.w	SaveExtGlissCtrl-SaveExtendedFXTable
	dc.w	0
	dc.w	SaveExtFineTune-SaveExtendedFXTable
	dc.w	SaveExtPosJump-SaveExtendedFXTable
	dc.w	0
	dc.w	SaveExtPosJump-SaveExtendedFXTable
	dc.w	SaveExtPosJump-SaveExtendedFXTable
	dc.w	SaveExtVolSlide-SaveExtendedFXTable
	dc.w	SaveExtVolSlide-SaveExtendedFXTable
	dc.w	SaveExtPosJump-SaveExtendedFXTable
	dc.w	SaveExtPosJump-SaveExtendedFXTable
	dc.w	SaveExtPosJump-SaveExtendedFXTable
	dc.w	SaveExtPosJump-SaveExtendedFXTable
SaveMultiRetrig:	move.b	d1,d7
	clr.b	d1
	lsr.w	#4,d1
	tst.b	d7
	bmi.s	SaveAddMulti
	cmp.b	#$23,d7
	beq.s	SaveMul6
	cmp.b	#$46,d7
	beq.s	SaveMul6
	cmp.b	#$32,d7
	beq.s	SaveMulE
	cmp.b	#$64,d7
	beq.s	SaveMulE
	cmp.b	#$12,d7
	beq.s	SaveMul7
	cmp.b	#$24,d7
	beq.s	SaveMul7
	cmp.b	#$21,d7
	beq.s	SaveMulF
	cmp.b	#$42,d7
	beq.s	SaveMulF
	moveq	#$e,d0
	lsr.b	#4,d1
	or.b	#$90,d1
	rts
SaveMul6:	or.b	#$6,d1
	rts
SaveMul7:	or.b	#$7,d1
	rts
SaveMulE:	or.b	#$e,d1
	rts
SaveMulF:	or.b	#$f,d1
	rts
SaveAddMulti:	cmp.b	#$c0,d7
	bcc.s	SaveSubMulti
	or.b	#$d,d1
	cmp.b	#$8f,d7
	bcc.s	SaveMultiDone
	subq.b	#1,d1
	cmp.b	#$87,d7
	bcc.s	SaveMultiDone
	subq.b	#1,d1
	cmp.b	#$83,d7
	bcc.s	SaveMultiDone
	subq.b	#1,d1
	cmp.b	#$81,d7
	bcc.s	SaveMultiDone
	subq.b	#1,d1
SaveMultiDone:	rts
SaveSubMulti:	or.b	#$5,d1
	cmp.b	#$cf,d7
	bcc.s	SaveMultiDone
	subq.b	#1,d1
	cmp.b	#$c7,d7
	bcc.s	SaveMultiDone
	subq.b	#1,d1
	cmp.b	#$c3,d7
	bcc.s	SaveMultiDone
	subq.b	#1,d1
	cmp.b	#$c1,d7
	bcc.s	SaveMultiDone
	subq.b	#1,d1
	rts
SaveXtraPortaUp:	moveq	#$10,d7
SaveXtraPorta:	lsr.w	#8,d1
	addq.w	#2,d1
	lsr.w	#2,d1
	cmp.b	#$f,d1
	bcs.s	SaveXtraUpOk
	moveq	#$f,d1
SaveXtraUpOk:	or.b	d7,d1
	rts
SaveXtraPortaDn:	moveq	#$20,d7
	bra.s	SaveXtraPorta
SaveEnvCtrl:	cmp.w	#$0004,d1
	beq.s	SaveEnvCtrlVol
	moveq	#$e,d0
	moveq	#$30,d1
	cmp.w	#$0300,d1
	beq.s	SaveEnvCtrlVib
	moveq	#$70,d1
	cmp.w	#$0400,d1
	bne.s	SaveEnvCtrlFault
SaveEnvCtrlVib:	move.l	(a5),a5
	tst.l	(a5)
	beq.s	SaveEnvCtrlFault
	move.w	tcte_DataWord(a5),d7
	cmp.w	#$f,d7
	bcs.s	SaveEnvCtrlDone
	moveq	#$f,d7
SaveEnvCtrlDone:	or.b	d7,d1
	rts
SaveEnvCtrlVol:	move.l	(a5),a5
	tst.l	(a5)
	beq.s	SaveEnvCtrlFault
	move.w	tcte_DataWord(a5),d7
	cmp.w	#$ff,d7
	bcs.s	SaveEnvCtrlOk
	moveq	#-1,d7
SaveEnvCtrlOk:	move.b	d7,d1
	rts
SaveEnvCtrlFault:	moveq	#0,d0
	moveq	#0,d1
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle from where to get the info
;	A1.L	=	APTR to track info structure where to put information
;	D0.L	=	Number of track to be scanned (NULL is the first)
;	OUTPUT
;	D0.L	=	A non-zero value if success else NULL.
ExternalTrackGetInfo:	movem.l	d1-d3/a2/a6,-(sp)
	move.l	a0,d1
	move.l	sp,d2
	moveq	#4,d3
	move.l	a1,a2
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOCRead(a6)
	cmp.l	d3,d0
	bne.s	ExternalGetInfoError
	move.b	1(sp),trki_Version(a2)
	move.b	(sp),trki_Revision(a2)
	move.w	2(sp),d0
	rol.w	#8,d0
	subq.w	#1,d0
	move.w	d0,trki_Length(a2)
	move.b	#TCTCF_Slide|TCTCF_OpSlide|TCTCF_VolSlide,trki_CompFlags(a2)
	move.l	#(DEFAULTTRACKVOLUME<<24)|(DEFAULTTRACKPANNING<<8),trki_Volume(a2)
	move.w	#DEFAULTTRACKFRAMES,trki_Frames(a3)
	move.l	#(DEFAULTTRACKBPMTEMPO<<16)|(DEFAULTTRACKBPMSPEED),trki_BPMTempo(a2)
	move.l	a2,d0
ExternalGetInfoDone:	movem.l	(sp)+,d1-d3/a2/a6
	rts
ExternalGetInfoError:	moveq	#0,d0
	bra.s	ExternalGetInfoDone
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	Number of tracks found or NULL on any error
ExternalTrackGetNums:	moveq	#1,d0
	rts

	cnop	0,4

ExtTrackLibBase:	dc.l	0

LoadFlags:	dc.w	1
	dc.w	LoadFlagSize
	dc.l	LoadText0
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
LoadText0:	dc.b	'Convert volumes',0
LoadFlagSize:	equ	*-LoadFlags
LoadDescript:	dc.b	'FastTracker ][ Track (XT)',0
