********************************************************
***      TuComposer External AHI Device Player       ***
***         1998 by The united Coders (TuC)         ***
***                Main code: Basty/TuC              ***
***  This sound device driver allows you to output   ***
***   any sound TuComposer creates, through any AHI  ***
*** compatible device, i.e. any soundcard that owns  ***
*** an AHI driver will be supported with this driver ***
********************************************************

	IFND	_G2
	MACHINE	MC68020
	OPT	NODEBUG,NOLINE
	ENDC

	include	"exec/types.i"
	include	"exec/execbase.i"
	include	"exec/exec_lib.i"
	include	"exec/initializers.i"
	include	"exec/interrupts.i"
	include	"exec/resident.i"
	include	"exec/libraries.i"
	include	"exec/memory.i"
	include	"dos/dos_lib.i"
	include	"dos/dosextens.i"
	include	"dos/dostags.i"
	include	"hardware/custom.i"
	include	"hardware/dmabits.i"
	include	"hardware/intbits.i"
	include	"hardware/cia.i"
	include	"intuition/intuition_lib.i"
	include	"intuition/intuitionbase.i"
	include	"utility/hooks.i"
	include	"devices/ahi.i"
	include	"lvo/ahi_lib.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/external/external.i"
	include	"tucomposer/external/external_lib.i"
	include	"tucomposer/external/device.i"
	include	"tucomposer/external/device_lib.i"
	include	"tucomposer/external/mixer.i"
	include	"tucomposer/external/mixer_lib.i"

CUSTOM_BASE:	equ	$DFF000
CIAA_BASE:	equ	$BFE001

	moveq	#-1,d0
	rts
ResidentStruct:	dc.w	RTC_MATCHWORD
	dc.l	ResidentStruct
	dc.l	0
	dc.b	RTF_AUTOINIT
	dc.b	EXTLIB_DEVICE_VERSION
	dc.b	NT_LIBRARY
	dc.b	-5
	dc.l	LibName
	dc.l	LibID
	dc.l	Init
LibName:	dc.b	'ahidevice.library',0
LibID:	dc.b	'TuComposer External AHI Device Driver Version 1.00 (v31) (68020+, OS2.0+) (08 Apr 98) by Basty/CDGS.',0
TuComposerName:	dc.b	'tucomposer.library',0
	even
Init:	dc.l	sdi_SIZEOF
	dc.l	FuncTab
	dc.l	DataTab
	dc.l	PrepareLibrary

FuncTab:	dc.w	-1
	dc.w	Open-FuncTab
	dc.w	Close-FuncTab
	dc.w	Expunge-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalInitialize-FuncTab
	dc.w	ExternalUpdateFlags-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalDeviceAlloc-FuncTab
	dc.w	ExternalDeviceFree-FuncTab
	dc.w	ExternalDevicePlay-FuncTab
	dc.w	ExternalDeviceStop-FuncTab
	dc.w	ExternalDeviceCheckRate-FuncTab
	dc.w	ExternalDeviceCheckRateFraction-FuncTab
	dc.w	ExternalDeviceUpdateRate-FuncTab
	dc.w	-1

DataTab:	INITLONG	LN_NAME,LibName
	INITBYTE	LIB_FLAGS,LIBF_CHANGED|LIBF_SUMUSED
	INITWORD	LIB_VERSION,EXTLIB_DEVICE_VERSION
	INITWORD	LIB_REVISION,EXTLIB_REVISION
	INITLONG	LIB_IDSTRING,LibID
	INITBYTE	sdi_Flags,SDIF_Stereo
	INITLONG	sdi_LowFrequency,4000
	INITLONG	sdi_HighFrequency,256000
	dc.l	0

PrepareLibrary:	btst	#AFB_68020,AttnFlags+1(a6)
	beq.s	ExtLib
	cmp.w	#37,LIB_VERSION(a6)
	blt.s	ExtLib
	move.l	a2,-(sp)
	move.l	d0,a2
	move.l	a0,extb_SegList(a2)
	moveq	#31,d0
	lea	TuComposerName(pc),a1
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,extb_TuComposerBase(a2)
	beq.s	NoTuCLib
	lea	ExtDeviceLibBase(pc),a0
	move.l	a2,(a0)
	move.l	a2,d0
NoTuCLib:	move.l	(sp)+,a2
	rts
Open:	addq.w	#1,LIB_OPENCNT(a6)
	move.l	a6,d0
	rts
Close:	subq.w	#1,LIB_OPENCNT(a6)
	bne.s	ExtLib
	btst	#LIBB_DELEXP,LIB_FLAGS(a6)
	bne.s	Expunge
ExtLib:	moveq	#0,d0
	rts
Expunge:	bset	#LIBB_DELEXP,LIB_FLAGS(a6)
	tst.w	LIB_OPENCNT(a6)
	bne.s	ExtLib
	movem.l	d2/a5-a6,-(sp)
	move.l	extb_ExtLibList(a6),d0
	beq.s	NoExtLibList
	move.l	d0,a0
	clr.l	extl_LibBase(a0)
NoExtLibList:	move.l	extb_TuComposerBase(a6),a1
	move.l	a6,a5
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
	move.l	extb_SegList(a5),d2
	move.l	a5,a1
	jsr	_LVORemove(a6)
	move.l	a5,a1
	moveq	#0,d0
	moveq	#0,d1
	move.w	LIB_NEGSIZE(a5),d1
	sub.l	d1,a1
	move.w	LIB_POSSIZE(a5),d0
	add.l	d1,d0
	jsr	_LVOFreeMem(a6)
	move.l	d2,d0
	movem.l	(sp)+,d2/a5-a6
	rts
;	INPUT
;	A0.L	=	APTR to track external list structure to be initialized
;	OUTPUT
;	D0.L	=	What type of external library is it or NULL if error
ExternalInitialize:	move.l	extb_TuComposerBase(a6),a1
	movem.l	a2/a6,-(sp)
	move.l	a0,d0
	beq.s	ExternalInitDone
	move.l	a1,a6
	move.b	#EXTLF_Loader|EXTLF_Saver,extl_Flags(a0)
	move.l	a0,a2
	lea	extl_Descriptor(a0),a0
	lea	LoadDescript(pc),a1
	jsr	_LVOSetString(a6)
	tst.l	d0
	beq.s	ExternalInitDone
	lea	SaveFlags(pc),a0
	jsr	_LVOAllocFlagStr(a6)
	move.l	d0,extl_SaveFlagStr(a2)
	beq.s	ExternalInitDone
	moveq	#EXTTYPE_DEVICE,d0
ExternalInitDone:	movem.l	(sp)+,a2/a6
	rts
;	INPUT
;	A0.L	=	APTR to flag pass structure which was updated
;	D0.L	=	Type of flag pass structure (NULL = load, $00000001 = save)
;	D1.L	=	Flag number which was updated
;	OUTPUT
;	D0.L	=	NULL if changes were accepted, else APTR to text string why
;				not accepted (i.e. hardware not found)
ExternalUpdateFlags:	moveq	#0,d0
	tst.l	d1
	beq	SelectAudioMode
	subq.l	#1,d1
	beq.s	ChgMode
	subq.l	#1,d1
	beq.s	ChgStereoSwap
	subq.l	#6,d1
	bcc.s	DSPDone
	movem.l	d2-d4/a2/a6,-(sp)
	movem.l	AudioCtrl(pc),a2/a6
	move.l	a2,d0
	beq.s	AudioNotAlloc
	move.l	#AHIET_DSPECHO|AHIET_CANCEL,d0
	move.l	a0,a1
	lea	DSPEcho(pc),a0
	tst.l	12(a1)
	beq.s	DSPCancelled
	moveq	#AHIET_DSPECHO,d0
DSPCancelled:	move.l	d0,(a0)
	movem.l	16(a1),d1-d4
	moveq	#100,d0
	swap	d1
	divu.l	d0,d1
	move.l	d1,ahiede_Mix(a0)
	mulu.l	MixRate(pc),d1:d2
	divu.l	d0,d1:d2
	move.l	d2,ahiede_Delay(a0)
	swap	d3
	divu.l	d0,d3
	move.l	d3,ahiede_Feedback(a0)
	swap	d4
	divu.l	d0,d4
	move.l	d4,ahiede_Cross(a0)
	jsr	_LVOAHI_SetEffect(a6)
AudioNotAlloc:	movem.l	(sp)+,d2-d4/a2/a6
	moveq	#0,d0
DSPDone:	rts
ChgMode:	btst	#SDIB_Playing,sdi_Flags(a6)
	beq.s	ChgModeDone
	move.l	a0,a1
	move.l	MixLibBase(pc),a0
	bra	ExternalDevicePlay
ChgStereoSwap:	lea	SwapCh(pc),a1
	tst.l	8(a0)
	beq.s	StereoSwap
	st	(a1)
ChgModeDone:	rts
StereoSwap:	clr.b	(a1)
	rts
SelectAudioMode:	movem.l	d2-d3/a2-a4/a6,-(sp)
	move.l	a0,a2
	lea	AudioMemErr(pc),a3
	move.l	extb_TuComposerBase(a6),a4
	move.l	tcb_IntBase(a4),a6
	move.l	#AHIR_Screen,d2
	move.l	36(a2),d3
	move.l	32(a2),a0
	jsr	_LVOLockPubScreen(a6)
	move.l	d0,d4
	beq.s	PubScreenOk
	addq.l	#AHIR_PubScreenName-AHIR_Screen,d2
	move.l	d4,d3
PubScreenOk:	lea	AllocAudioTagList(pc),a0
	move.l	AllocTagList+4(pc),20(a0)
	move.l	AllocTagList+12(pc),28(a0)
	movem.l	d2-d3,(a0)
	move.l	AHIBase(pc),a6
	jsr	_LVOAHI_AllocAudioRequestA(a6)
	move.l	d0,d2
	beq.s	AllocAudioFailed
	move.l	d2,a0
	lea	AllocAudioTagList(pc),a1
	jsr	_LVOAHI_AudioRequestA(a6)
	tst.l	d0
	bne.s	AllocAudioOk
	move.l	tcb_DOSBase(a4),a6
	jsr	_LVOIoErr(a6)
	tst.l	d0
	beq.s	AllocAudioCancel
	moveq	#ERROR_NO_FREE_STORE,d1
	cmp.l	d1,d0
	beq.s	AllocAudioFailed
	lea	AudioInvType(pc),a3
	bra.s	AllocAudioFailed
AllocAudioOk:	move.l	d2,a0
	lea	AllocTagList+4(pc),a1
	move.l	(a0)+,(a1)
	move.l	(a0),8(a1)
AllocAudioCancel:	sub.l	a3,a3
AllocAudioFailed:	move.l	d2,a0
	jsr	_LVOAHI_FreeAudioRequest(a6)
	tst.l	d4
	beq.s	NotPubScreen
	move.l	32(a2),a0
	move.l	d4,a1
	move.l	extb_TuComposerBase(a4),a6
	move.l	tcb_IntBase(a6),a6
	jsr	_LVOUnlockPubScreen(a6)
NotPubScreen:	move.l	a3,d0
	movem.l	(sp)+,d2-d3/a2-a4/a6
	rts
;	INPUT
;	A0.L	=	APTR to loading flag pass structure (soundcard config)
;	OUTPUT
;	D0.L	=	If success NULL else one of the device error codes
ExternalDeviceAlloc:	moveq	#ERROR_EXTLIB_BUSY,d0
	bset	#SDIB_Allocated,sdi_Flags(a6)
	bne	AllocErr
	sub.l	a1,a1
	movem.l	d2/a2-a3/a6,-(sp)
	move.l	a6,a3
	move.l	4.w,a6
	jsr	_LVOFindTask(a6)
	move.l	d0,sdi_Task(a3)
	lea	AHI_Port(pc),a0
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)
	jsr	_LVOCreateMsgPort(a6)
	lea	AHI_Port(pc),a0
	move.l	d0,(a0)
	beq	AHI_Error
	move.l	d0,a0
	moveq	#AHIRequest_SIZEOF,d0
	jsr	_LVOCreateIORequest(a6)
	lea	AHI_IOR(pc),a0
	move.l	d0,(a0)
	beq	AHI_Error
	lea	AHI_Name(pc),a0
	move.l	d0,a1
	move.w	#4,ahir_Version(a1)
	moveq	#0,d0
	not.b	d0
	moveq	#0,d1
	jsr	_LVOOpenDevice(a6)
	lea	AHI_Device(pc),a0
	move.l	d0,(a0)
	bne.s	AHI_Error
	move.l	AHI_IOR(pc),a1
	move.l	IO_DEVICE(a1),a6
	move.l	a6,AHIBase-AHI_Device(a0)
	lea	AllocTagList(pc),a1
	jsr	_LVOAHI_AllocAudioA(a6)
	lea	AudioCtrl(pc),a0
	move.l	d0,(a0)
	beq.s	AHI_Error
	lea	GetRateTagList(pc),a1
	move.l	d0,a2
	jsr	_LVOAHI_ControlAudioA(a6)
	moveq	#0,d0
AllocDone:	movem.l	(sp)+,d2/a2-a3/a6
AllocErr:	rts
AHI_Error:	move.l	a3,a6
	bsr.s	ExternalDeviceFree
	moveq	#ERROR_EXTLIB_BUSY,d0
	bra.s	AllocDone
;	NO INPUTS
;	OUTPUT
;	D0.L	=	NULL if successful free, else one of the device error codes
ExternalDeviceFree:	moveq	#ERROR_EXTLIB_NOALLOC,d0
	btst	#SDIB_Allocated,sdi_Flags(a6)
	beq.s	AllocErr
	movem.l	a2/a6,-(sp)
	lea	AHI_Device(pc),a1
	tst.l	(a1)
	bne.s	AHI_NoDevice
	not.l	(a1)
	lea	AudioCtrl(pc),a0
	move.l	(a0),a2
	move.l	a2,d0
	beq.s	NotFreeAudio
	clr.l	(a0)+
	move.l	(a0),a6
	lea	DSPEcho(pc),a0
	move.l	#AHIET_DSPECHO|AHIET_CANCEL,(a0)
	jsr	_LVOAHI_SetEffect(a6)
	jsr	_LVOAHI_FreeAudio(a6)
NotFreeAudio:	move.l	AHI_IOR(pc),a1
	move.l	4.w,a6
	jsr	_LVOCloseDevice(a6)
	lea	AHI_IOR(pc),a1
	move.l	(a1),a0
	clr.l	(a1)
	jsr	_LVODeleteIORequest(a6)
AHI_NoDevice:	lea	AHI_Port(pc),a1
	move.l	(a1),a0
	clr.l	(a1)
	jsr	_LVODeleteMsgPort(a6)
	movem.l	(sp)+,a2/a6
	bclr	#SDIB_Allocated,sdi_Flags(a6)
	clr.l	sdi_Task(a6)
	moveq	#0,d0
	rts
;	INPUT
;	A0.L	=	APTR to mixer alloc structure as got by ExternalMixerAlloc()
;	A1.L	=	APTR to saving flag pass structure (Soundcard specific)
;	OUTPUT
;	D0.L	=	If playing started successfully, NULL, else one of the errors
ExternalDevicePlay:	movem.l	d2-d5/a2-a4/a6,-(sp)
	lea	PlayParams(pc),a4
	move.l	a1,d0
	beq.s	UsePrevValues
	movem.l	(a1),d0-d5/a2-a3
	movem.l	d0-d5/a2-a3,(a4)
UsePrevValues:	lea	MixLibBase(pc),a1
	move.l	a0,(a1)
	move.l	a6,a3
	btst	#SDIB_Playing,sdi_Flags(a6)
	beq.s	Playing
	bsr	ExternalDeviceStop
Playing:	bset	#SDIB_Playing,sdi_Flags(a3)
	move.l	MixLibBase(pc),a0
	bset	#MASB_Mixing,mas_Flags(a0)
	move.l	sdi_ChannelBufLen(a3),d0
	add.l	d0,d0
	move.l	4(a4),d1
	cmp.w	#2,d1
	blo.s	Not16BitPlay
	add.l	d0,d0
Not16BitPlay:	lea	ChBufLen(pc),a0
	move.l	d0,(a0)
	clr.b	SwapCh-ChBufLen(a0)
	tst.l	8(a4)
	beq.s	NotStereoSwap
	st	SwapCh-ChBufLen(a0)
NotStereoSwap:	moveq	#TAG_IGNORE,d2
	lea	AHIBuffer(pc),a2
	move.l	ChBufLen(pc),d0
	move.l	#MEMF_PUBLIC|MEMF_CLEAR,d1
	move.l	4.w,a6
	jsr	_LVOAllocMem(a6)
	move.l	d0,(a2)
	beq	AllocBufErr
	movem.l	sdi_ChannelBuf(a3),d0-d1
	lea	MixBuffer(pc),a0
	movem.l	d0-d1,(a0)
	move.l	sdi_ChannelBufLen(a3),d0
	move.l	d0,SmpInfo-MixBuffer+ahisi_Length(a0)
	moveq	#AHIST_M8S,d1
	moveq	#1-1,d5
	move.l	4(a4),d3
	cmp.w	#2,d3
	blo.s	Bit8Smp
	lsr.l	#1,d0
	moveq	#AHIST_M16S,d1
Bit8Smp:	lea	MixIRQTab(pc),a1
	lsr.l	#1,d0
	btst	#SDICB_Stereo,sdi_ChannelFlags(a3)
	beq.s	NotStereoTable
	addq.l	#2*4,a1
	addq.b	#AHIST_S8S-AHIST_M8S,d1
NotStereoTable:	move.l	d0,MixBufSize-MixBuffer(a0)
	move.l	d1,SmpInfo-MixBuffer(a0)
	move.l	-4(a1,d3.l*4),MixIRQ-MixBuffer+h_Entry(a0)
	movem.l	AudioCtrl(pc),a2/a6
LoadAHISndLoop:	moveq	#0,d0
	moveq	#AHIST_DYNAMICSAMPLE,d1
	lea	SmpInfo(pc),a0
	move.l	AHIBuffer(pc),ahisi_Address(a0)
	jsr	_LVOAHI_LoadSound(a6)
	move.l	d5,d0
	moveq	#0,d1
	moveq	#0,d2
	moveq	#0,d3
	moveq	#AHISF_IMM,d4
	jsr	_LVOAHI_SetSound(a6)
	move.l	d5,d0
	move.l	sdi_ChannelFreq(a3),d1
	moveq	#AHISF_IMM,d2
	jsr	_LVOAHI_SetFreq(a6)
	move.l	d5,d0
	moveq	#1,d1
	swap	d1
	moveq	#1,d2
	ror.w	#1,d2
	moveq	#AHISF_IMM,d3
	jsr	_LVOAHI_SetVol(a6)
	dbra	d5,LoadAHISndLoop
	move.l	#AHIET_DSPECHO|AHIET_CANCEL,d0
	lea	DSPEcho(pc),a0
	tst.l	12(a4)
	beq.s	NotUseEchoDSP
	moveq	#AHIET_DSPECHO,d0
NotUseEchoDSP:	move.l	d0,(a0)
	movem.l	16(a4),d1-d4
	moveq	#100,d0
	swap	d1
	divu.l	d0,d1
	move.l	d1,ahiede_Mix(a0)
	mulu.l	MixRate(pc),d1:d2
	divu.l	d0,d1:d2
	move.l	d2,ahiede_Delay(a0)
	swap	d3
	divu.l	d0,d3
	move.l	d3,ahiede_Feedback(a0)
	swap	d4
	divu.l	d0,d4
	move.l	d4,ahiede_Cross(a0)
	jsr	_LVOAHI_SetEffect(a6)
	moveq	#1,d0
	lea	StartTagList(pc),a1
	move.l	d0,4(a1)
	jsr	_LVOAHI_ControlAudioA(a6)
	moveq	#0,d0
AHIAllocErr:	movem.l	(sp)+,d2-d5/a2-a4/a6
	rts
MixIRQTab:	dc.l	AudI8m
	dc.l	AudI16m
	dc.l	AudI8s
	dc.l	AudI16s
AllocBufErr:	movem.l	(sp)+,d2-d5/a2-a4/a6
	bsr.s	ExternalDeviceStop
	moveq	#ERROR_EXTLIB_NOALLOC,d0
	rts
;	NO INPUTS
;	OUTPUT
;	D0.L	=	If stopping was successful, NULL, else one of the errors
ExternalDeviceStop:	movem.l	d2/a2-a3/a6,-(sp)
	moveq	#ERROR_EXTLIB_BUSY,d0
	bclr	#SDIB_Playing,sdi_Flags(a6)
	beq.s	AHIStopped
	move.l	MixLibBase(pc),a0
	bclr	#MASB_Mixing,mas_Flags(a0)
	lea	StartTagList(pc),a1
	clr.l	4(a1)
	move.l	a6,a3
	movem.l	AudioCtrl(pc),a2/a6
	jsr	_LVOAHI_ControlAudioA(a6)
	lea	AHIBuffer(pc),a2
	move.l	(a2),d0
	beq.s	NoAHIBuf
	move.l	d0,a1
	move.l	ChBufLen(pc),d0
	move.l	4.w,a6
	jsr	_LVOFreeMem(a6)
NoAHIBuf:	clr.l	(a2)
	moveq	#0,d0
AHIStopped:	movem.l	(sp)+,d2/a2-a3/a6
	rts
;	INPUT
;	D0.L	=	Mixrate to be used
;	OUTPUT
;	D0.L	=	The soundcard aware mixing rate

	cnop	0,4

ExternalDeviceCheckRate:	rts
;	INPUT
;	D0.L	=	Mixrate to be used
;	OUTPUT
;	D0.L	=	The mixing rate 32-bit fraction (tempo modifier, for Paula)

	cnop	0,4

ExternalDeviceCheckRateFraction:	moveq	#0,d0
	rts
;	INPUT
;	D0.L	=	New sample rate to be used
;	OUTPUT
;	D0.L	=	NULL if accepted else any of the error codes

	cnop	0,4

ExternalDeviceUpdateRate:	movem.l	d2/a2/a6,-(sp)
	move.l	d0,d1
	moveq	#0,d0
	moveq	#0,d2
	movem.l	AudioCtrl(pc),a2/a6
	jsr	_LVOAHI_SetFreq(a6)
	movem.l	(sp)+,d2/a2/a6
	moveq	#0,d0
	rts

	cnop	0,4

AudI8m:	tst.w	(a1)
	bne.s	AudI8mDone
	movem.l	a2/a6,-(sp)
	movem.l	MixLibBase(pc),a0/a2
	move.l	(a0),a6
	jsr	_LVOExternalMixerDoMix(a6)
	move.l	MixBufSize(pc),d0
	lsr.l	#1,d0
	subq.w	#1,d0
	move.l	AHIBuffer(pc),a1
CopyAHI8mBufLoop:	move.w	(a2),d1
	move.b	4(a2),d1
	addq.l	#8,a2
	move.w	d1,(a1)+
	move.w	(a2),d1
	move.b	4(a2),d1
	addq.l	#8,a2
	move.w	d1,(a1)+
	dbra	d0,CopyAHI8mBufLoop
	movem.l	(sp)+,a2/a6
AudI8mDone:	rts

	cnop	0,4

AudI16m:	tst.w	(a1)
	bne.s	AudI16mDone
	movem.l	a2/a6,-(sp)
	movem.l	MixLibBase(pc),a0/a2
	move.l	(a0),a6
	jsr	_LVOExternalMixerDoMix(a6)
	move.l	MixBufSize(pc),d0
	lsr.l	#1,d0
	subq.w	#1,d0
	move.l	AHIBuffer(pc),a1
CopyAHI16mBufLoop:	move.l	(a2)+,d1
	move.w	(a2),d1
	addq.l	#4,a2
	move.l	d1,(a1)+
	move.l	(a2)+,d1
	move.w	(a2),d1
	addq.l	#4,a2
	move.l	d1,(a1)+
	move.l	(a2)+,d1
	move.w	(a2),d1
	addq.l	#4,a2
	move.l	d1,(a1)+
	move.l	(a2)+,d1
	move.w	(a2),d1
	addq.l	#4,a2
	move.l	d1,(a1)+
	dbra	d0,CopyAHI16mBufLoop
	movem.l	(sp)+,a2/a6
AudI16mDone:	rts

	cnop	0,4

AudI8s:	tst.w	(a1)
	bne.s	AudI8sDone
	movem.l	a2/a6,-(sp)
	movem.l	MixLibBase(pc),a0/a2
	move.l	(a0),a6
	jsr	_LVOExternalMixerDoMix(a6)
	move.l	MixBufSize(pc),d0
	subq.w	#1,d0
	move.l	AHIBuffer(pc),a1
	move.b	SwapCh(pc),d1
	bne.s	Swap8s
CopyAHI8sBufLoop:	move.w	(a2),d1
	move.b	4(a2),d1
	addq.l	#8,a2
	move.w	d1,(a1)+
	move.w	(a2),d1
	move.b	4(a2),d1
	addq.l	#8,a2
	move.w	d1,(a1)+
	dbra	d0,CopyAHI8sBufLoop
	movem.l	(sp)+,a2/a6
AudI8sDone:	rts
Swap8s:	move.w	4(a2),d1
	move.b	(a2),d1
	addq.l	#8,a2
	move.w	d1,(a1)+
	move.w	4(a2),d1
	move.b	(a2),d1
	addq.l	#8,a2
	move.w	d1,(a1)+
	dbra	d0,Swap8s
	movem.l	(sp)+,a2/a6
	rts

	cnop	0,4

AudI16s:	movem.l	a2/a6,-(sp)
	move.l	MixLibBase(pc),a0
	lea	MixWhichBuf(pc),a2
	move.b	(a2),d0
	addq.b	#4,(a2)
	and.w	#7,d0
	move.l	(MixBuffer.w,pc,d0.w),a2
	move.l	(a0),a6
	jsr	_LVOExternalMixerDoMix(a6)
	move.l	MixBufSize(pc),d0
	subq.w	#1,d0
	move.l	AHIBuffer(pc),a1
	move.b	SwapCh(pc),d1
	bne.s	Swap16s
CopyAHI16sPBufLoop:	move.l	(a2)+,d1
	move.w	(a2),d1
	addq.l	#4,a2
	move.l	d1,(a1)+
	move.l	(a2)+,d1
	move.w	(a2),d1
	addq.l	#4,a2
	move.l	d1,(a1)+
	move.l	(a2)+,d1
	move.w	(a2),d1
	addq.l	#4,a2
	move.l	d1,(a1)+
	move.l	(a2)+,d1
	move.w	(a2),d1
	addq.l	#4,a2
	move.l	d1,(a1)+
	dbra	d0,CopyAHI16sPBufLoop
	movem.l	(sp)+,a2/a6
AudI16sDone:	rts
Swap16s:	move.l	(a2)+,d1
	move.w	(a2),d1
	addq.l	#4,a2
	swap	d1
	move.l	d1,(a1)+
	move.l	(a2)+,d1
	move.w	(a2),d1
	addq.l	#4,a2
	swap	d1
	move.l	d1,(a1)+
	move.l	(a2)+,d1
	move.w	(a2),d1
	addq.l	#4,a2
	swap	d1
	move.l	d1,(a1)+
	move.l	(a2)+,d1
	move.w	(a2),d1
	addq.l	#4,a2
	swap	d1
	move.l	d1,(a1)+
	dbra	d0,Swap16s
	movem.l	(sp)+,a2/a6
	rts

	cnop	0,4

ExtDeviceLibBase:	dc.l	0
MixBufSize:	ds.l	1
ChBufLen:	ds.l	1
MixRate:	ds.l	1
MixLibBase:	ds.l	1
MixBuffer:	ds.l	2
MixDestBuf:	ds.l	1
AudioCtrl:	dc.l	0
AHIBase:	dc.l	0
AHIBuffer:	dc.l	0
AHI_Port:	dc.l	0
AHI_IOR:	dc.l	0
AHI_Device:	dc.l	0
MixIRQ:	ds.l	2
	dc.l	AudI8m
PlayParams:	dc.l	0
	dc.l	3
	dc.l	0
	dc.l	0
	dc.l	100
	dc.l	2
	dc.l	88
	dc.l	50
SmpInfo:	dc.l	AHIST_S16S
	dc.l	0
	dc.l	$ffffffff
AllocAudioTagList:	dc.l	AHIR_Screen,0
	dc.l	AHIR_TitleText,PickAudioMode
	dc.l	AHIR_InitialAudioID,AHI_DEFAULT_ID
	dc.l	AHIR_InitialMixFreq,AHI_DEFAULT_FREQ
	dc.l	AHIR_DoMixFreq,1
	dc.l	AHIR_DoDefaultMode,1
	dc.l	TAG_DONE
AllocTagList:	dc.l	AHIA_AudioID,AHI_DEFAULT_ID
	dc.l	AHIA_MixFreq,AHI_DEFAULT_FREQ
	dc.l	AHIA_Channels,1
	dc.l	AHIA_Sounds,1
	dc.l	AHIA_SoundFunc,MixIRQ
	dc.l	TAG_DONE
GetRateTagList:	dc.l	AHIC_MixFreq_Query,MixRate
	dc.l	TAG_DONE
StartTagList:	dc.l	AHIC_Play,1
	dc.l	TAG_DONE
DSPEcho:	dc.l	AHIET_DSPECHO
	dc.l	44100*25/100
	dc.l	25*65536/100
	dc.l	50*65536/100
	dc.l	25*65536/100
SaveFlags:	dc.w	9
	dc.w	SaveFlagSize
	dc.l	SaveText0
	dc.b	EXTFLAG_TEXT
	dc.b	TEFSF_Update
	dc.w	64
	dc.l	0
	dc.l	0
	dc.l	DefaultText0
	dc.l	0
	dc.l	SaveButton1
	dc.b	EXTFLAG_CYCLE
	dc.b	TEFSF_Update
	dc.w	1+2
	dc.l	0
	dc.l	0
	dc.l	2
	dc.l	0
	dc.l	SaveText2
	dc.b	EXTFLAG_BOOLEAN
	dc.b	TEFSF_Update
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	SaveText3
	dc.b	EXTFLAG_BOOLEAN
	dc.b	TEFSF_Update
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	SaveText4
	dc.b	EXTFLAG_SLIDER
	dc.b	TEFSF_Update
	dc.w	0
	dc.l	0
	dc.l	100
	dc.l	50
	dc.l	0
	dc.l	SaveText5
	dc.b	EXTFLAG_SLIDER
	dc.b	TEFSF_Update
	dc.w	0
	dc.l	0
	dc.l	1000
	dc.l	25
	dc.l	0
	dc.l	SaveText6
	dc.b	EXTFLAG_SLIDER
	dc.b	TEFSF_Update
	dc.w	0
	dc.l	0
	dc.l	100
	dc.l	25
	dc.l	0
	dc.l	SaveText7
	dc.b	EXTFLAG_SLIDER
	dc.b	TEFSF_Update
	dc.w	0
	dc.l	0
	dc.l	100
	dc.l	25
	dc.l	0
	dc.l	SaveText8
	dc.b	EXTFLAG_STRING
	dc.b	0
	dc.w	64
	dc.l	0
	dc.l	0
	dc.l	DefaultText8
	dc.l	0
	dc.l	0
	dc.b	EXTFLAG_SCREEN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
SaveButton1:	dc.l	SaveText1
	dc.l	SaveText11
	dc.l	SaveText12
SaveText0:	dc.b	'Audio mode:',0
DefaultText0:	dc.b	'Default audio mode',0
SaveText1:	dc.b	'AHI output mode:',0
SaveText11:	dc.b	'8-bit',0
SaveText12:	dc.b	'16-bit',0
SaveText2:	dc.b	'Reverse stereo',0
SaveText3:	dc.b	'Use echo DSP',0
SaveText4:	dc.b	'Echo strength (in %):',0
SaveText5:	dc.b	'Echo delay (in ms):',0
SaveText6:	dc.b	'Echo feedback (in %):',0
SaveText7:	dc.b	'Echo cross (in %):',0
SaveText8:	dc.b	'Public screen:',0
DefaultText8:	dc.b	0
SaveFlagSize:	equ	*-SaveFlags
PickAudioMode:	dc.b	'Pick audio mode to be used within TuComposer:',0
AudioMemErr:	dc.b	'Not enough memory to pop up audio mode requester !',0
AudioInvType:	dc.b	'No compatible audio modes installed !',0
MixTaskName:	dc.b	'AHI Device Driver Mixer Task',0
LoadDescript:	dc.b	'AHI Device Driver',0
AHI_Name:	dc.b	'ahi.device',0
SwapCh:	dc.b	0
MixWhichBuf:	dc.b	0
