********************************************************
*** TuComposer External Device Library support v31.0 ***
***        1996-97 by The united Coders (TuC)       ***
***                Main code: Basty/TuC              ***
***     This is the header file for coding your      ***
***             external soundcard devices           ***
********************************************************

	include	"exec/types.i"
	include	"exec/execbase.i"
	include	"exec/exec_lib.i"
	include	"exec/initializers.i"
	include	"exec/resident.i"
	include	"exec/libraries.i"
	include	"exec/memory.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/external/external.i"
	include	"tucomposer/external/external_lib.i"
	include	"tucomposer/external/device.i"
	include	"tucomposer/external/device_lib.i"

	moveq	#-1,d0
	rts
ResidentStruct:	dc.w	RTC_MATCHWORD
	dc.l	ResidentStruct
	dc.l	0
	dc.b	RTF_AUTOINIT
	dc.b	EXTLIB_DEVICE_VERSION
	dc.b	NT_LIBRARY
	dc.b	0						; If ya soundcard is very popular and
									; has a good quality set the priority
									; somewhat high.
	dc.l	LibName
	dc.l	LibID
	dc.l	Init
LibName:	dc.b	'paula.library',0	; Just a example
LibID:	dc.b	'TuComposer External Paula Soundcard Driver Version 1.00 (v31) (68020+, OS2.0+) (22 Mar 97) by Basty/TuC.',0	; Another example.
TuComposerName:	dc.b	'tucomposer.library',0
	even
Init:	dc.l	sdi_SIZEOF
	dc.l	FuncTab
	dc.l	DataTab
	dc.l	PrepareLibrary

FuncTab:	dc.w	-1
	dc.w	Open-FuncTab
	dc.w	Close-FuncTab
	dc.w	Expunge-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalInitialize-FuncTab
	dc.w	ExternalUpdateFlags-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalDeviceAlloc-FuncTab
	dc.w	ExternalDeviceFree-FuncTab
	dc.w	ExternalDevicePlay-FuncTab
	dc.w	ExternalDeviceStop-FuncTab
	dc.w	ExternalDeviceCheckRate-FuncTab
	dc.w	ExternalDeviceCheckRateFraction-FuncTab
	dc.w	ExternalDeviceUpdateRate-FuncTab
	dc.w	-1

DataTab:	INITLONG	LN_NAME,LibName
	INITBYTE	LIB_FLAGS,LIBF_CHANGED|LIBF_SUMUSED
	INITWORD	LIB_VERSION,EXTLIB_DEVICE_VERSION
	INITWORD	LIB_REVISION,EXTLIB_REVISION
	INITLONG	LIB_IDSTRING,LibID
	INITBYTE	sdi_Flags,SDIF_Stereo
										; Flags (example for paula with 16
										; bit emulation (14 bit output)
	INITLONG	sdi_LowFrequency,1000	; Lowest freq. is 1000Hz (example)
	INITLONG	sdi_HighFrequency,44100	; Highest freq. is 44100Hz (example)
	dc.l	0

PrepareLibrary:	btst	#AFB_68020,AttnFlags+1(a6)	; If you want to make a
													; 68020+ version only.
	beq.s	ExtLib			; Just because there's always a moveq #0,d0:rts
	cmp.w	#37,LIB_VERSION(a6)	; If your library requires OS2.04+
	blt.s	ExtLib
	move.l	a2,-(sp)
	move.l	d0,a2
	move.l	a0,extb_SegList(a2)
	moveq	#31,d0				; TuComposer library required by loader
	lea	TuComposerName(pc),a1	; APTR to tucomposer.library name
	jsr	_LVOOpenLibrary(a6)		; Open tucomposer.library
	move.l	d0,extb_TuComposerBase(a2)	; Save base
	beq.s	NoTuCLib			; Open failed ?
	lea	ExtDeviceLibBase(pc),a0	; Get library base for C functions
	move.l	a2,(a0)				; Store the library base
	move.l	a2,d0
;	...							; Make your initialization stuff here.
NoTuCLib:	move.l	(sp)+,a2
	rts
Open:	addq.w	#1,LIB_OPENCNT(a6)
	move.l	a6,d0
	rts
Close:	subq.w	#1,LIB_OPENCNT(a6)
	bne.s	ExtLib
	btst	#LIBB_DELEXP,LIB_FLAGS(a6)
	bne.s	Expunge
ExtLib:	moveq	#0,d0
	rts
Expunge:	bset	#LIBB_DELEXP,LIB_FLAGS(a6)
	tst.w	LIB_OPENCNT(a6)
	bne.s	ExtLib
	movem.l	d2/a5-a6,-(sp)
	move.l	extb_ExtLibList(a6),d0	; THIS MUST ALWAYS BE DONE -----|
	beq.s	NoExtLibList	;										|
	move.l	d0,a0	;												|
	clr.l	extl_LibBase(a0)	;									|
NoExtLibList:	move.l	extb_TuComposerBase(a6),a1	;				|
	move.l	a6,a5	;												|
	move.l	4.w,a6	;												|
	jsr	_LVOCloseLibrary(a6)	;-----------------------------------|
	move.l	extb_SegList(a5),d2
	move.l	a5,a1
	jsr	_LVORemove(a6)
	move.l	a5,a1
	moveq	#0,d0
	moveq	#0,d1
	move.w	LIB_NEGSIZE(a5),d1
	sub.l	d1,a1
	move.w	LIB_POSSIZE(a5),d0
	add.l	d1,d0
	jsr	_LVOFreeMem(a6)
	move.l	d2,d0
	movem.l	(sp)+,d2/a5-a6
	rts
;	INPUT
;	A0.L	=	APTR to track external list structure to be initialized
;	OUTPUT
;	D0.L	=	What type of external library is it or NULL if error
ExternalInitialize:	move.l	extb_TuComposerBase(a6),a1
	movem.l	a2/a6,-(sp)
	move.l	a0,d0						; Just for case
	beq.s	ExternalInitDone			; Do not init and return NULL
	move.l	a1,a6
	move.b	#EXTLF_Saver,extl_Flags(a0)	; Saving flags
	move.l	a0,a2
	lea	extl_Descriptor(a0),a0			; Put descriptor ID into the
	lea	LoadDescript(pc),a1				; external library list structure
	jsr	_LVOSetString(a6)				; Allocate new string buffer. YOU
										; MUST DO THAT IN THIS WAY !!!!!!
	tst.l	d0							; Check if successful
	beq.s	ExternalInitDone
	lea	SaveFlags(pc),a0				; Following only if saving flags
	jsr	_LVOAllocFlagStr(a6)			; Now allocate save flag structures
	move.l	d0,extl_SaveFlagStr(a2)		; Store to the flag save structures
	beq.s	ExternalInitDone
;	Additional initializations are done here like priority. Use:
;	move.b	#-10,extl_Pri(a2)
;	to set the priority to -10.
	moveq	#EXTTYPE_DEVICE,d0
ExternalInitDone:	movem.l	(sp)+,a2/a6
	rts
;	INPUT
;	A0.L	=	APTR to flag pass structure which was updated
;	D0.L	=	Type of flag pass structure (NULL = load, $00000001 = save)
;	D1.L	=	Flag number which was updated
;	OUTPUT
;	D0.L	=	NULL if changes were accepted, else APTR to text string why
;				not accepted (i.e. hardware not found)

ExternalUpdateFlags:	
	rts
;	INPUT
;	A0.L	=	APTR to loading flag pass structure (soundcard config)
;	OUTPUT
;	D0.L	=	If success NULL else one of the device error codes
ExternalDeviceAlloc:	
	rts
;	NO INPUTS
;	OUTPUT
;	D0.L	=	NULL if successful free, else one of the device error codes
ExternalDeviceFree:	
	rts
;	INPUT
;	A0.L	=	APTR to mixer alloc structure as got by ExternalMixerAlloc()
;	A1.L	=	APTR to saving flag pass structure (Soundcard specific)
;	OUTPUT
;	D0.L	=	If playing started successfully, NULL, else one of the errors
ExternalDevicePlay:	
	rts
;	NO INPUTS
;	OUTPUT
;	D0.L	=	If stopping was successful, NULL, else one of the errors
ExternalDeviceStop:	
	rts
;	INPUT
;	D0.L	=	Mixrate to be used
;	OUTPUT
;	D0.L	=	The soundcard aware mixing rate

	cnop	0,4

ExternalDeviceCheckRate:	
	rts
;	INPUT
;	D0.L	=	Mixrate to be used
;	OUTPUT
;	D0.L	=	The mixing rate 32-bit fraction (tempo modifier, for Paula)

	cnop	0,4

ExternalDeviceCheckRateFraction:	
	rts
;	INPUT
;	D0.L	=	New sample rate to be used
;	OUTPUT
;	D0.L	=	NULL if accepted else any of the error codes

	cnop	0,4

ExternalDeviceUpdateRate:	
	rts

	cnop	0,4

ExtDeviceLibBase:	dc.l	0

SaveFlags:	dc.w	1					; 1 save flag (again a example)
	dc.w	SaveFlagSize				; Size of save flag structure
	dc.l	SaveText0
	dc.b	EXTFLAG_BOOLEAN
	dc.b	TEFSF_Update				; We want to be noticed when updated
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1							; We also want stereo output
	dc.l	0
SaveText0:	dc.b	'14-bit output',0	; Flag #0 is for enable 16-bit (this
										; text is displayed by the apps)
SaveFlagSize:	equ	*-SaveFlags			; Calculate size of save structure
LoadDescript:	dc.b	'Amiga Native Paula',0	; Just a example
