*******************************************************
***     TuComposer External High Quality Mixer      ***
***        1997 by The united Coders (TuC)         ***
***               Main code: Basty/TuC              ***
***     This is the high quality mixer for the      ***
***      disk writer supplied with TuComposer       ***
*******************************************************

	IFND	_G2
	MACHINE	MC68020
	OPT NODEBUG,NOLINE
	ENDC	

	include	"exec/types.i"
	include	"exec/execbase.i"
	include	"exec/exec_lib.i"
	include	"exec/initializers.i"
	include	"exec/memory.i"
	include	"exec/resident.i"
	include	"exec/libraries.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/external/external.i"
	include	"tucomposer/external/external_lib.i"
	include	"tucomposer/external/device.i"
	include	"tucomposer/external/device_lib.i"
	include	"tucomposer/external/mixer.i"
	include	"tucomposer/external/mixer_lib.i"
	include	"tucomposer/external/postproc.i"
	include	"tucomposer/external/postproc_lib.i"

	moveq	#-1,d0
	rts
ResidentStruct:	dc.w	RTC_MATCHWORD
	dc.l	ResidentStruct
	dc.l	0
	dc.b	RTF_AUTOINIT
	dc.b	EXTLIB_MIXER_VERSION
	dc.b	NT_LIBRARY
	dc.b	-2
	dc.l	LibName
	dc.l	LibID
	dc.l	Init
LibName:	dc.b	'hqmix.library',0
LibID:	dc.b	'TuComposer External High Quality Mixer Version 1.00 (v31) (68020+, OS2.0+) (22 Mar 97) by Basty/TuC.',0
TuComposerName:	dc.b	'tucomposer.library',0
	even
Init:	dc.l	mix_SIZEOF
	dc.l	FuncTab
	dc.l	DataTab
	dc.l	PrepareLibrary

FuncTab:	dc.w	-1
	dc.w	Open-FuncTab
	dc.w	Close-FuncTab
	dc.w	Expunge-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalInitialize-FuncTab
	dc.w	ExternalUpdateFlags-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalMixerAlloc-FuncTab
	dc.w	ExternalMixerFree-FuncTab
	dc.w	ExternalMixerInit-FuncTab
	dc.w	ExternalMixerChangeRate-FuncTab
	dc.w	ExternalMixerChangeTempo-FuncTab
	dc.w	ExternalMixerChangeVolTable-FuncTab
	dc.w	ExternalMixerGetChannel-FuncTab
	dc.w	ExternalMixerSetChannel-FuncTab
	dc.w	ExternalMixerSetChannelVolPanPitch-FuncTab
	dc.w	ExternalMixerSetChannelPosRepFlags-FuncTab
	dc.w	ExternalMixerDoMix-FuncTab
	dc.w	-1

DataTab:	INITLONG	LN_NAME,LibName
	INITBYTE	LIB_FLAGS,LIBF_CHANGED|LIBF_SUMUSED
	INITWORD	LIB_VERSION,EXTLIB_MIXER_VERSION
	INITWORD	LIB_REVISION,EXTLIB_REVISION
	INITLONG	LIB_IDSTRING,LibID
	INITBYTE	mix_Flags,MIF_StereoSupport|MIF_Surround|MIF_PostProcs
	INITLONG	mix_DefaultMixRate,44100
	INITLONG	mix_DefaultBufSize,256
	INITLONG	mix_DefaultBoost,65536
	INITLONG	mix_MinMixRate,1000
	INITLONG	mix_MaxMixRate,256000
	INITLONG	mix_MinBufSize,16
	INITLONG	mix_MaxBufSize,32768
	INITWORD	mix_MaxChannels,65535
	dc.l	0

PrepareLibrary:	btst	#AFB_68020,AttnFlags+1(a6)
	beq.s	ExtLib
	cmp.w	#37,LIB_VERSION(a6)
	blt.s	ExtLib
	move.l	a2,-(sp)
	move.l	d0,a2
	move.l	a0,extb_SegList(a2)
	moveq	#31,d0
	lea	TuComposerName(pc),a1
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,extb_TuComposerBase(a2)
	beq.s	NoTuCLib
	lea	ExtMixerLibBase(pc),a0
	move.l	a2,(a0)
	move.l	a2,d0
NoTuCLib:	move.l	(sp)+,a2
	rts
Open:	addq.w	#1,LIB_OPENCNT(a6)
	move.l	a6,d0
	rts
Close:	subq.w	#1,LIB_OPENCNT(a6)
	bne.s	ExtLib
	btst	#LIBB_DELEXP,LIB_FLAGS(a6)
	bne.s	Expunge
ExtLib:	moveq	#0,d0
	rts
Expunge:	bset	#LIBB_DELEXP,LIB_FLAGS(a6)
	tst.w	LIB_OPENCNT(a6)
	bne.s	ExtLib
	movem.l	d2/a5-a6,-(sp)
	move.l	extb_ExtLibList(a6),d0
	beq.s	NoExtLibList
	move.l	d0,a0
	clr.l	extl_LibBase(a0)
NoExtLibList:	move.l	extb_TuComposerBase(a6),a1
	move.l	a6,a5
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
	move.l	extb_SegList(a5),d2
	move.l	a5,a1
	jsr	_LVORemove(a6)
	move.l	a5,a1
	moveq	#0,d0
	moveq	#0,d1
	move.w	LIB_NEGSIZE(a5),d1
	sub.l	d1,a1
	move.w	LIB_POSSIZE(a5),d0
	add.l	d1,d0
	jsr	_LVOFreeMem(a6)
	move.l	d2,d0
	movem.l	(sp)+,d2/a5-a6
	rts
;	INPUT
;	A0.L	=	APTR to track external list structure to be initialized
;	OUTPUT
;	D0.L	=	What type of external library is it or NULL if error
ExternalInitialize:	move.l	extb_TuComposerBase(a6),a1
	movem.l	a2/a6,-(sp)
	move.l	a0,d0
	beq.s	ExternalInitDone
	move.l	a1,a6
	move.b	#EXTLF_Saver,extl_Flags(a0)
	move.l	a0,a2
	lea	extl_Descriptor(a0),a0
	lea	LoadDescript(pc),a1
	jsr	_LVOSetString(a6)
	tst.l	d0
	beq.s	ExternalInitDone
	lea	SaveFlags(pc),a0
	jsr	_LVOAllocFlagStr(a6)
	move.l	d0,extl_SaveFlagStr(a2)
	beq.s	ExternalInitDone
	moveq	#EXTTYPE_MIXER,d0
ExternalInitDone:	movem.l	(sp)+,a2/a6
	rts
;	INPUT
;	A0.L	=	APTR to flag pass structure which was updated
;	D0.L	=	Type of flag pass structure (NULL = load, $00000001 = save)
;	D1.L	=	Flag number which was updated
;	OUTPUT
;	D0.L	=	NULL if changes were accepted, else APTR to text string why
;				not accepted (i.e. hardware not found)

	cnop	0,4

ExternalUpdateFlags:	move.l	extb_TuComposerBase(a6),a0
	move.l	tcb_PlayMixerAlloc(a0),a0
	cmp.l	(a0),a6
	bne.s	HQUpdDone
	btst	#MASB_Mixing,mas_Flags(a0)
	beq.s	HQUpdDone
	move.l	mas_SoundDevLibBase(a0),a1
	move.l	a2,-(sp)
	sub.l	a2,a2
	jsr	_LVOExternalMixerInit(a6)
	move.l	(sp)+,a2
HQUpdDone:	rts
;	NO INPUTS
;	OUTPUT
;	D0.L	=	APTR to mixer alloc structure or NULL on error
ExternalMixerAlloc:	movem.l	a2/a6,-(sp)
	moveq	#hqmas_SIZEOF/2,d0
	add.l	d0,d0
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOAllocPMem(a6)
	tst.l	d0
	beq.s	AllocErr
	move.l	d0,a2
	move.l	4(sp),(a2)
	moveq	#4,d0
	swap	d0
	jsr	_LVOAllocPMem(a6)
	move.l	d0,hqmas_VolTable(a2)
	beq.s	AllocErr2
	sub.l	a1,a1
	move.l	4.w,a6
	jsr	_LVOFindTask(a6)
	move.l	d0,mas_Task(a2)
	lea	mas_PostProcs(a2),a0
	move.l	a0,(a0)
	move.l	a0,MLH_TAILPRED(a0)
	addq.l	#4,(a0)
	move.l	a2,d0
AllocErr:	movem.l	(sp)+,a2/a6
	rts
AllocErr2:	moveq	#hqmas_SIZEOF/2,d0
	add.l	d0,d0
	move.l	a2,a1
	jsr	_LVOFreePMem(a6)
	moveq	#0,d0
	bra.s	AllocErr
;	INPUT
;	A0.L	=	APTR to mixer alloc structure as got by ExternalMixerAlloc()
;	NO OUTPUT
ExternalMixerFree:	moveq	#ERROR_EXTLIB_MIXNOALLOC,d0
	movem.l	a2/a6,-(sp)
	move.l	a0,d0
	beq.s	AllocErr
	move.l	d0,a2
	move.l	hqmas_ChInfo(a2),d0
	beq.s	NoChInfo
	move.l	d0,a1
	move.w	mas_MaxChannels(a2),d0
	mulu.w	#chi_SIZEOF,d0
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOFreePMem(a6)
NoChInfo:	move.l	hqmas_MixBuffer(a2),d0
	beq.s	NoMixBuffers
	move.l	d0,a1
	move.l	hqmas_MixBufSize(a2),d0
	jsr	_LVOFreePMem(a6)
NoMixBuffers:	move.l	hqmas_VolTable(a2),d0
	beq.s	NoVolTable
	move.l	d0,a1
	moveq	#4,d0
	swap	d0
	jsr	_LVOFreePMem(a6)
NoVolTable:	moveq	#hqmas_SIZEOF/2,d0
	add.l	d0,d0
	move.l	a2,a1
	jsr	_LVOFreePMem(a6)
	moveq	#0,d0
	movem.l	(sp)+,a2/a6
	rts
;	INPUT
;	A0.L	=	APTR to mixer alloc structure as got by ExternalMixerAlloc()
;	A1.L	=	APTR to sound device structure
;	A2.L	=	APTR to saving flag pass structure (Mixer specific)
;	OUTPUT
;	D0.L	=	NULL if changes accepted else one of the error codes
ExternalMixerInit:	movem.l	d2-d7/a2-a6,-(sp)
	move.l	a0,a5
	move.l	4(a2),d6
	beq.s	ChgStereoOk
	btst	#SDIB_Stereo,sdi_Flags(a1)
	bne.s	ChgStereoOk
	moveq	#0,d6
ChgStereoOk:	move.l	a2,a4
	move.l	a1,a2
	move.l	a6,a3
	move.l	a2,a6
	cmp.l	mas_SoundDevLibBase(a5),a2
	beq.s	SameSoundDev
	move.l	a2,mas_SoundDevLibBase(a5)
	btst	#MASB_Mixing,mas_Flags(a5)
	beq.s	SameSoundDev
	jsr	_LVOExternalDeviceStop(a6)
SameSoundDev:	move.l	mas_MixRate(a5),d0
	move.l	d0,d2
	jsr	_LVOExternalDeviceCheckRate(a6)
	move.l	d0,mas_MixRate(a5)
	move.l	d2,d0
	jsr	_LVOExternalDeviceCheckRateFraction(a6)
	move.l	d0,hqmas_MixFract(a5)
	move.w	mas_MaxChannels(a5),d0
	cmp.w	hqmas_Channels(a5),d0
	bne.s	ChgNewVolTable
	move.l	mas_VolumeBoost(a5),d0
	cmp.l	hqmas_Amplify(a5),d0
	bne.s	ChgNewVolTable
	cmp.b	hqmas_Stereo(a5),d6
	beq.s	ChgVolTableEnd
ChgNewVolTable:	moveq	#0,d2
	move.w	mas_MaxChannels(a5),d2
	move.l	mas_VolumeBoost(a5),d7
	move.l	d7,hqmas_Amplify(a5)
	move.b	hqmas_Stereo(a5),hqmas_PrevStereo(a5)
	move.b	d6,hqmas_Stereo(a5)
	lsl.l	#8,d2
	move.l	hqmas_VolTable(a5),a0
	moveq	#0,d3
ChgVolTabOutLoop:	moveq	#0,d4
	move.l	d3,d5
	mulu.l	d7,d5
ChgVolTabInLoop:	move.l	d4,d0
	lsl.w	#8,d0
	ext.l	d0
	muls.l	d5,d1:d0
	divs.l	d2,d1:d0
	move.l	d0,(a0)+
	addq.b	#1,d4
	bcc.s	ChgVolTabInLoop
	addq.b	#1,d3
	bcc.s	ChgVolTabOutLoop
ChgVolTableEnd:	btst	#MASB_Mixing,mas_Flags(a5)
	beq.s	NoStopDevice
	jsr	_LVOExternalDeviceStop(a6)
NoStopDevice:	move.w	mas_MaxChannels(a5),d0
	move.l	extb_TuComposerBase(a6),a6
	tst.l	hqmas_ChInfo(a5)
	beq.s	ChgAllocNewChInfo
	cmp.w	hqmas_Channels(a5),d0
	beq.s	ChgNotAllocNewChInfo
ChgAllocNewChInfo:	move.w	d0,d4
	mulu.w	#chi_SIZEOF,d0
	jsr	_LVOAllocPMem(a6)
	move.l	d0,d2
	beq.s	ChgNotAllocNewChInfo
	move.w	d4,d5
	move.l	hqmas_ChInfo(a5),d0
	beq.s	NotChgFreeOldChInfo
	move.l	d0,a0
	move.l	d2,a1
	cmp.w	hqmas_Channels(a5),d5
	bcs.s	CopyChInfo
	move.w	hqmas_Channels(a5),d5
CopyChInfo:	mulu.w	#chi_SIZEOF/4,d5
CopyChInfoLoop:	move.l	(a0)+,(a1)+
	subq.l	#1,d5
	bne.s	CopyChInfoLoop
	move.w	hqmas_Channels(a5),d0
	mulu.w	#chi_SIZEOF,d0
	move.l	hqmas_ChInfo(a5),a1
	jsr	_LVOFreePMem(a6)
NotChgFreeOldChInfo:	move.l	d2,hqmas_ChInfo(a5)
	move.w	d4,hqmas_Channels(a5)
ChgNotAllocNewChInfo:	move.w	hqmas_Channels(a5),mas_MaxChannels(a5)
	move.l	mas_MixBufSize(a5),d2
	tst.l	hqmas_MixBuffer(a5)
	beq.s	ChgAllocNewChBuf
	cmp.l	hqmas_MixBufSize(a5),d2
	beq.s	ChgNotAllocNewChBuf
ChgAllocNewChBuf:	move.l	d2,d5
	lsl.l	#2,d2
	tst.l	d6
	beq.s	ChgNoStereo
	add.l	d2,d2
ChgNoStereo:	move.l	hqmas_MixBufSize(a5),d7
	move.l	d2,hqmas_MixBufSize(a5)
	move.l	d2,d0
	jsr	_LVOAllocPMem(a6)
	move.l	d0,d3
	beq.s	ChgNotAllocNewChBuf
	move.l	hqmas_MixBuffer(a5),d2
	movem.l	d3/d5,hqmas_MixBuffer(a5)
	move.l	d5,sdi_ChannelBufLen(a2)
	tst.l	d2
	beq.s	ChgNotAllocNewChBuf
	move.l	d7,d0
	move.l	d2,a1
	jsr	_LVOFreePMem(a6)
ChgNotAllocNewChBuf:	move.l	hqmas_BuffSize(a5),mas_MixBufSize(a5)
	move.l	hqmas_MixBuffer(a5),d0
	move.l	d0,sdi_ChannelBuf(a2)
	move.l	d0,mas_MixBuf(a5)
	move.l	mas_MixRate(a5),d0
	move.l	d0,hqmas_MixRate(a5)
	move.l	d0,sdi_ChannelFreq(a2)
	bfins	d6,sdi_ChannelFlags(a2){8-1-SDICB_Stereo:1}
	bfins	d6,mas_Flags(a5){8-1-MASB_Stereo:1}
	move.l	a2,mas_SoundDevLibBase(a5)
	move.l	d0,d1
	lsl.l	#3,d0
	add.l	d1,d0
	add.l	d1,d0
	move.l	hqmas_MixFract(a5),d1
	move.w	d0,d1
	clr.w	d0
	swap	d0
	swap	d1
	divu.l	mas_Tempo(a5),d0:d1
	move.l	d1,hqmas_PassLength(a5)
	moveq	#0,d1
	divu.l	mas_Tempo(a5),d0:d1
	move.l	d1,hqmas_PassFrac(a5)
	tst.l	(a4)
	seq	hqmas_Real16Bit+1(a5)
	move.w	hqmas_Channels(a5),d4
	move.l	hqmas_ChInfo(a5),a4
CorrectChInfo:	move.l	chi_SampleRate(a4),d0
	move.l	a4,a1
	bsr	SetSmpMixRate
	lea	chi_SIZEOF(a4),a4
	subq.w	#1,d4
	bne.s	CorrectChInfo
	btst	#MASB_Mixing,mas_Flags(a5)
	beq.s	MixChangeCmp
	move.l	extb_ExtLibList(a2),a0
	move.l	tcb_PlayMixerAlloc(a6),a1
	sub.l	a2,a2
	jsr	_LVOPlaySoundDevice(a6)
MixChangeCmp:	moveq	#0,d0
MixChangeDone:	movem.l	(sp)+,d2-d7/a2-a6
	rts
;	INPUT
;	A0.L	=	APTR to mixer alloc structure as got by ExternalMixerAlloc()
;	D0.L	=	New mixing rate in Hz to be used
;	OUTPUT
;	D0.L	=	NULL if changes accepted else any non-zero value

	cnop	0,4

ExternalMixerChangeRate:	move.l	d0,mas_MixRate(a0)
	movem.l	d2-d3/a2/a4-a6,-(sp)
	btst	#MASB_Mixing,mas_Flags(a0)
	beq	ChgRateDone
	move.l	a0,a5
	move.l	a6,a2
	move.l	mas_SoundDevLibBase(a5),a6
	move.l	d0,d2
	jsr	_LVOExternalDeviceCheckRate(a6)
	exg	d0,d2
	jsr	_LVOExternalDeviceCheckRateFraction(a6)
	move.l	d0,d3
	move.l	d2,d0
	jsr	_LVOExternalDeviceUpdateRate(a6)
	move.l	a2,a6
	tst.l	d0
	bne	SameRate
	cmp.l	hqmas_MixRate(a5),d2
	beq	SameRate
	movem.l	d2-d3,hqmas_MixRate(a5)
	move.l	a5,a0
	move.l	mas_Tempo(a5),d0
	move.l	(a5),a6
	jsr	_LVOExternalMixerChangeTempo(a6)
	move.w	hqmas_Channels(a5),d3
	move.l	hqmas_ChInfo(a5),a2
AdjustChInfo:	move.l	chi_SampleRate(a2),d0
	divul.l	d2,d1:d0
	cmp.l	#$10000,d0
	blo.s	AdjSmpRateOk
	moveq	#-1,d0
AdjSmpRateOk:	move.w	d0,chi_Advance+2(a2)
	moveq	#0,d0
	divu.l	d2,d1:d0
	swap	d0
	move.w	d0,chi_AdvFract+2(a2)
	move.l	chi_Advance(a2),d1
	moveq	#0,d0
	move.b	chi_BitDepth(a2),d0
	mulu.l	d0,d1
	move.l	d1,chi_RealAdv(a2)
	move.l	chi_NewSampleRate(a2),d0
	divul.l	d2,d1:d0
	cmp.l	#$10000,d0
	blo.s	AdjNewSmpRateOk
	moveq	#-1,d0
AdjNewSmpRateOk:	move.w	d0,chi_NewAdvance+2(a2)
	moveq	#0,d0
	divu.l	d2,d1:d0
	swap	d0
	move.w	d0,chi_NewAdvFract+2(a2)
	move.l	chi_NewAdvance(a2),d1
	moveq	#0,d0
	move.b	chi_NewBitDepth(a2),d0
	mulu.l	d0,d1
	move.l	d1,chi_NewRealAdv(a2)
	lea	chi_SIZEOF(a2),a2
	subq.w	#1,d3
	bne.s	AdjustChInfo
ChgRateDone:	lea	mas_PostProcs(a5),a4
ChgPostProcs:	move.l	(a4),a4
	tst.l	(a4)
	beq.s	ChgPostProcsDone
	btst	#PASB_Update,pas_Flags(a4)
	beq.s	ChgPostProcs
	move.l	a4,a0
	move.l	a5,a1
	move.l	pas_PostProcLibBase(a4),a6
	jsr	_LVOExternalPostProcDoMix(a6)
	bra.s	ChgPostProcs
ChgPostProcsDone:	moveq	#0,d0
SameRate:	movem.l	(sp)+,d2-d3/a2/a4-a6
NotMixing:	rts
;	INPUT
;	A0.L	=	APTR to mixer alloc structure as got by ExternalMixerAlloc()
;	D0.L	=	New tempo value to be used (for BpM use 65536*RpB*BpM)
;	OUTPUT
;	D0.L	=	NULL if changes accepted else any non-zero value

	cnop	0,4

ExternalMixerChangeTempo:	move.l	d0,mas_Tempo(a0)
	move.l	hqmas_MixRate(a0),d1
	move.l	d1,d0
	lsl.l	#3,d0
	add.l	d1,d0
	add.l	d1,d0
	move.l	hqmas_MixFract(a0),d1
	move.w	d0,d1
	clr.w	d0
	swap	d0
	swap	d1
	divu.l	mas_Tempo(a0),d0:d1
	move.l	d1,hqmas_PassLength(a0)
	moveq	#0,d1
	divu.l	mas_Tempo(a0),d0:d1
	move.l	d1,hqmas_PassFrac(a0)
	moveq	#0,d0
	rts
;	INPUT
;	A0.L	=	APTR to mixer alloc structure as got by ExternalMixerAlloc()
;	D0.L	=	New volume boost to be used
;	D1.L	=	New left volume to be used
;	D2.L	=	New right volume to be used
;	D3.L	=	New number of channels to be used
;	OUTPUT
;	D0.L	=	NULL if changes accepted else any non-zero value
ExternalMixerChangeVolTable:	movem.l	d2-d7/a2-a6,-(sp)
	move.l	d0,d7
	move.l	a0,a5
	move.l	d1,a4
	cmp.w	hqmas_Channels(a5),d3
	beq.s	NewNotAllocNewChInfo
	move.w	d0,d4
	mulu.w	#chi_SIZEOF,d0
	move.l	#MEMF_PUBLIC|MEMF_CLEAR,d1
	jsr	_LVOAllocPMem(a6)
	move.l	d0,d1
	beq	AllocChInfoErr
	exg	d1,a4
NewNotAllocNewChInfo:	move.l	d7,mas_VolumeBoost(a5)
	movem.w	d1-d2,mas_LeftVolume(a5)
	move.l	d3,d2
	move.w	d3,mas_MaxChannels(a5)
	cmp.w	hqmas_Channels(a5),d3
	bne.s	ChgNewMixVolTable
	cmp.l	hqmas_Amplify(a5),d7
	beq.s	ChgVolTableDone
ChgNewMixVolTable:	move.l	d7,hqmas_Amplify(a5)
	lsl.l	#8,d2
	moveq	#0,d3
	move.l	hqmas_VolTable(a5),a0
NewVolTabOutLoop:	moveq	#0,d4
	move.l	d3,d5
	mulu.l	d7,d5
NewVolTabInLoop:	move.l	d4,d0
	lsl.w	#8,d0
	ext.l	d0
	muls.l	d5,d6:d0
	divs.l	d2,d6:d0
	move.l	d0,(a0)+
	addq.b	#1,d4
	bcc.s	NewVolTabInLoop
	addq.b	#1,d3
	bcc.s	NewVolTabOutLoop
ChgVolTableDone:	move.l	extb_TuComposerBase(a6),a6
	move.l	a6,a3
	move.l	4(sp),d0
	cmp.w	hqmas_Channels(a5),d0
	beq.s	NewNotAllocNewChInfo2
	move.w	d4,d5
	move.l	4.w,a6
	jsr	_LVODisable(a6)
	move.l	hqmas_ChInfo(a5),a0
	move.l	a4,a1
	cmp.w	hqmas_Channels(a5),d5
	bcs.s	CopyNewChInfo
	move.w	hqmas_Channels(a5),d5
CopyNewChInfo:	mulu.w	#chi_SIZEOF/4,d5
CopyNewChInfoLoop:	move.l	(a0)+,(a1)+
	subq.l	#1,d5
	bne.s	CopyNewChInfoLoop
	move.w	hqmas_Channels(a5),d3
	mulu.w	#chi_SIZEOF,d3
	move.l	hqmas_ChInfo(a5),a2
	move.l	a4,hqmas_ChInfo(a5)
	move.w	d4,hqmas_Channels(a5)
	jsr	_LVOEnable(a6)
	move.l	d3,d0
	move.l	a2,a1
	move.l	a3,a6
	jsr	_LVOFreePMem(a6)
NewNotAllocNewChInfo2:	move.w	hqmas_Channels(a5),d4
	move.l	hqmas_ChInfo(a5),a2
	move.l	4.w,a6
	jsr	_LVODisable(a6)
CorrectNewChInfo:	move.l	chi_SampleRate(a2),d0
	move.l	a2,a1
	bsr	SetSmpMixRate
	lea	chi_SIZEOF(a2),a2
	subq.w	#1,d4
	bne.s	CorrectNewChInfo
	jsr	_LVOEnable(a6)
	moveq	#0,d0
	movem.l	(sp)+,d2-d7/a2-a6
	rts
AllocChInfoErr:	movem.l	(sp)+,d2-d7/a2-a6
	moveq	#ERROR_EXTLIB_MIXNOALLOC,d0
	rts
;	INPUT
;	A0.L	=	APTR to mixer structure where to get channel from
;	A1.L	=	APTR to mixer alloc structure as got by ExternalMixerAlloc()
;	D0.L	=	Number of channel to get
;	NO OUTPUT

	cnop	0,4

ExternalMixerGetChannel:	cmp.w	hqmas_Channels(a1),d0
	bhs.s	GetHQInvalid
	mulu.w	#chi_SIZEOF,d0
	move.l	hqmas_ChInfo(a1),a1
	add.l	d0,a1
	move.l	chi_Offset(a1),(a0)
	move.l	chi_BitDepth(a1),ms_BitDepth(a0)
	move.l	(a1),ms_SampleData(a0)
	move.l	chi_SampleLen(a1),ms_SampleLen(a0)
	movem.l	chi_Repeat(a1),d0-d1
	movem.l	d0-d1,ms_Repeat(a0)
	movem.l	chi_CountRestart(a1),d0-d1
	movem.l	d0-d1,ms_RepCount(a0)
	move.l	chi_SampleRate(a1),ms_SampleRate(a0)
GetHQInvalid:	rts
;	INPUT
;	A0.L	=	APTR to mixer structure where to set channel
;	A1.L	=	APTR to mixer alloc structure as got by ExternalMixerAlloc()
;	D0.L	=	Number of channel to set
;	OUTPUT
;	D0.L	=	FALSE if settings accepted else any other non-zero value

	cnop	0,4

ExternalMixerSetChannel:	cmp.w	hqmas_Channels(a1),d0
	bhs.s	GetHQInvalid
	move.l	a5,-(sp)
	move.l	a1,a5
	mulu.w	#chi_SIZEOF,d0
	move.l	hqmas_ChInfo(a1),a1
	add.l	d0,a1
SetHQCh:	move.b	ms_Flags(a0),d0
	clr.l	chi_NewSampleStartAdr(a1)
	btst	#MSB_Synth,d0
	beq.s	NotSetHQChSynth
	bset	#MSB_Synth,chi_Flags(a1)
	lea	chi_NewSampleStartAdr(a1),a1
NotSetHQChSynth:	move.l	(a0),chi_Offset(a1)
	clr.l	chi_Fraction(a1)
	move.l	ms_BitDepth(a0),chi_BitDepth(a1)
	move.l	ms_SampleData(a0),(a1)
	move.l	ms_SampleLen(a0),chi_SampleLen(a1)
	movem.l	ms_Repeat(a0),d0-d1
	movem.l	d0-d1,chi_Repeat(a1)
	btst	#MSB_Loop,chi_Flags(a1)
	bne.s	SetLoopCh
	move.l	ms_SampleLen(a0),d0
	moveq	#0,d1
SetLoopCh:	add.l	d1,d0
	btst	#MSB_Backwards,chi_Flags(a1)
	beq.s	NotBackwards
	sub.l	d1,d0
	btst	#MSB_Loop,chi_Flags(a1)
	bne.s	NotBackwards
	moveq	#-1,d0
NotBackwards:	movem.l	d0-d1,chi_EndOffset(a1)
	movem.l	ms_RepCount(a0),d0-d1
	movem.l	d0-d1,chi_CountRestart(a1)
	move.l	ms_SampleRate(a0),d0
SetSmpMixSave:	move.l	d0,chi_SampleRate(a1)
	move.l	hqmas_MixRate(a5),d1
	move.l	d2,-(sp)
	divul.l	d1,d2:d0
	cmp.l	#$10000,d0
	blo.s	SmpRateOk
	moveq	#-1,d0
SmpRateOk:	move.w	d0,chi_Advance+2(a1)
	moveq	#0,d0
	divu.l	d1,d2:d0
	move.l	(sp)+,d2
	swap	d0
	move.w	d0,chi_AdvFract+2(a1)
AdvOk:	move.l	chi_Advance(a1),d1
	moveq	#0,d0
	move.b	chi_BitDepth(a1),d0
	mulu.l	d0,d1
	move.l	d1,chi_RealAdv(a1)
	btst	#MSB_Muted,chi_Flags(a1)
	bne.s	ChannelMuted
Check0Vol:	move.b	chi_Volume(a1),d0
	bne.s	Not0Vol
ChannelMuted:	lea	Mixr_Skip(pc),a0
	bra.s	mstv_Set
SetSmpMixRate:	move.l	a5,-(sp)
	bra.s	SetSmpMixSave
Not0Vol:	tst.b	hqmas_Stereo(a5)
	bne.s	mstv_Stereo
	lea	Mixr_Mono(pc),a0
	bra.s	mstv_Set
mstv_Stereo:	btst	#MSB_Surround,chi_Flags(a1)
	beq.s	mstv_NoSurround
	move.b	#$80,d1
	move.w	mas_LeftVolume(a5),a0
	cmp.w	mas_RightVolume(a5),a0
	bne.s	mstv_NoCenter
	lea	Mixr_StereoSur(pc),a0
	bra.s	mstv_Set
mstv_NoSurround:	moveq	#0,d1
	move.b	chi_Panning(a1),d1
	bne.s	mstv_NoLeftPan
ChannelLeft:	lea	Mixr_StereoL(pc),a0
	tst.w	mas_LeftVolume(a5)
	beq.s	ChannelMuted
	bra.s	mstv_Set
mstv_NoLeftPan:	cmp.b	#$ff,d1
	bne.s	mstv_NoRightPan
ChannelRight:	lea	Mixr_StereoR(pc),a0
	tst.w	mas_RightVolume(a5)
	beq.s	ChannelMuted
	bra.s	mstv_Set
mstv_NoRightPan:	cmp.b	#$80,d1
	bne.s	mstv_NoCenter
	move.w	mas_LeftVolume(a5),a0
	cmp.w	mas_RightVolume(a5),a0
	bne.s	mstv_NoCenter
	lea	Mixr_StereoC(pc),a0
	bra.s	mstv_Set
mstv_NoCenter:	lea	Mixr_Stereo(pc),a0
mstv_Set:	cmp.b	#9,chi_BitDepth(a1)
	bcs.s	NoReal16Bit
	move.w	hqmas_Real16Bit(a5),ccr
	bne.s	DoReal16Bit
NoReal16Bit:	lea	Mixr_Skip168-Mixr_Skip(a0),a0
DoReal16Bit:	pea	PopHQStack(pc)
	cmp.b	#16,chi_BitDepth(a1)
	beq.s	mstv_Set16
	cmp.b	#8,chi_BitDepth(a1)
	bne.s	mstv_SetX
	btst	#MSB_Backwards,chi_Flags(a1)
	bne.s	mstv_Set8B
	move.l	8(a0),chi_MixRoutine(a1)
	move.l	20(a0),chi_AltMixRoutine(a1)
	move.l	(a0),a0
	jmp	(a0)
mstv_Set8B:	move.l	8(a0),chi_AltMixRoutine(a1)
	move.l	20(a0),chi_MixRoutine(a1)
	move.l	(a0),a0
	jmp	(a0)
mstv_Set16:	btst	#MSB_Backwards,chi_Flags(a1)
	bne.s	mstv_Set16B
	move.l	12(a0),chi_MixRoutine(a1)
	move.l	24(a0),chi_AltMixRoutine(a1)
	move.l	4(a0),a0
	jmp	(a0)
mstv_Set16B:	move.l	24(a0),chi_MixRoutine(a1)
	move.l	12(a0),chi_AltMixRoutine(a1)
	move.l	4(a0),a0
	jmp	(a0)
mstv_SetX:	btst	#MSB_Backwards,chi_Flags(a1)
	bne.s	mstv_SetXB
	move.l	16(a0),chi_MixRoutine(a1)
	move.l	28(a0),chi_AltMixRoutine(a1)
	move.l	4(a0),a0
	jmp	(a0)
mstv_SetXB:	move.l	28(a0),chi_MixRoutine(a1)
	move.l	16(a0),chi_AltMixRoutine(a1)
	move.l	4(a0),a0
	jmp	(a0)
PopHQStack:	move.l	(sp)+,a5
SetHQInvalid:	rts
;	INPUT
;	A0.L	=	APTR to mixer structure where to set channel
;	A1.L	=	APTR to mixer alloc structure as got by ExternalMixerAlloc()
;	D0.L	=	Number of channel to set
;	OUTPUT
;	D0.L	=	FALSE if settings accepted else any other non-zero value

	cnop	0,4

ExternalMixerSetChannelVolPanPitch:	cmp.w	hqmas_Channels(a1),d0
	bhs.s	SetHQInvalid
	mulu.w	#chi_SIZEOF,d0
	move.l	a5,-(sp)
	move.l	a1,a5
	move.l	hqmas_ChInfo(a1),a1
	add.l	d0,a1
	move.w	ms_Volume(a0),d0
	cmp.w	chi_Volume(a1),d0
	beq.s	NoVolChange
	move.w	d0,chi_Volume(a1)
	move.w	d0,chi_NewVolume(a1)
	move.l	ms_SampleRate(a0),d0
	move.l	d0,chi_SampleRate(a1)
	move.l	d0,chi_NewSampleRate(a1)
	move.l	hqmas_MixRate(a5),d1
	move.l	d2,-(sp)
	divul.l	d1,d2:d0
	move.w	d0,chi_Advance+2(a1)
	move.w	d0,chi_NewAdvance+2(a1)
	moveq	#0,d0
	divu.l	d1,d2:d0
	move.l	(sp)+,d2
	swap	d0
	move.w 	d0,chi_AdvFract+2(a1)
	move.w	d0,chi_NewAdvFract+2(a1)
	move.l	chi_Advance(a1),d1
	moveq	#0,d0
	move.b	chi_BitDepth(a1),d0
	mulu.l	d0,d1
	move.l	d1,chi_RealAdv(a1)
	move.l	d1,chi_NewRealAdv(a1)
	pea	AdvOk2(pc)
	move.l	a5,-(sp)
	bra	AdvOk
AdvOk2:	lea	chi_NewSampleStartAdr(a1),a1
	bra	AdvOk
NoVolChange:	move.l	ms_SampleRate(a0),d0
	move.l	d0,chi_SampleRate(a1)
	move.l	d0,chi_NewSampleRate(a1)
	move.l	hqmas_MixRate(a5),d1
	move.l	d2,-(sp)
	divul.l	d1,d2:d0
	move.w	d0,chi_Advance+2(a1)
	move.w	d0,chi_NewAdvance+2(a1)
	moveq	#0,d0
	divu.l	d1,d2:d0
	move.l	(sp)+,d2
	swap	d0
	move.w 	d0,chi_AdvFract+2(a1)
	move.w	d0,chi_NewAdvFract+2(a1)
	move.l	chi_Advance(a1),d1
	moveq	#0,d0
	move.b	chi_BitDepth(a1),d0
	mulu.l	d0,d1
	move.l	d1,chi_RealAdv(a1)
	move.l	d1,chi_NewRealAdv(a1)
	move.l	(sp)+,a5
SetHQInvalid2:	rts
;	INPUT
;	A0.L	=	APTR to mixer structure where to set channel
;	A1.L	=	APTR to mixer alloc structure as got by ExternalMixerAlloc()
;	D0.L	=	Number of channel to set
;	OUTPUT
;	D0.L	=	FALSE if settings accepted else any other non-zero value

	cnop	0,4

ExternalMixerSetChannelPosRepFlags:	cmp.w	hqmas_Channels(a1),d0
	bhs.s	SetHQInvalid2
	mulu.w	#chi_SIZEOF,d0
	move.l	a5,-(sp)
	move.l	a1,a5
	move.l	hqmas_ChInfo(a1),a1
	add.l	d0,a1
	move.b	ms_Flags(a0),d0
	cmp.b	chi_Flags(a1),d0
	beq.s	NoChangeFlags
	move.b	d0,chi_Flags(a1)
	move.l	(a0),d0
	cmp.l	chi_Offset(a1),d0
	beq.s	NotChgOffset
	move.l	d0,chi_Offset(a1)
	clr.l	chi_Fraction(a1)
NotChgOffset:	movem.l	ms_Repeat(a0),d0-d1
	movem.l	d0-d1,chi_Repeat(a1)
	btst	#MSB_Loop,chi_Flags(a1)
	bne.s	SetLoopCh2
	move.l	ms_SampleLen(a0),d0
	moveq	#0,d1
SetLoopCh2:	add.l	d1,d0
	btst	#MSB_Backwards,chi_Flags(a1)
	beq.s	NotBackwards2
	sub.l	d1,d0
	btst	#MSB_Loop,chi_Flags(a1)
	bne.s	NotBackwards2
	moveq	#-1,d0
NotBackwards2:	movem.l	d0-d1,chi_EndOffset(a1)
	movem.l	ms_RepCount(a0),d0-d1
	movem.l	d0-d1,chi_CountRestart(a1)
	bra	AdvOk
NoChangeFlags:	move.l	(a0),d0
	cmp.l	chi_Offset(a1),d0
	beq.s	NoChgNotChgOffset
	move.l	d0,chi_Offset(a1)
	clr.l	chi_Fraction(a1)
NoChgNotChgOffset:	movem.l	ms_Repeat(a0),d0-d1
	movem.l	d0-d1,chi_Repeat(a1)
	btst	#MSB_Loop,chi_Flags(a1)
	bne.s	NoChgSetLoopCh2
	move.l	ms_SampleLen(a0),d0
	moveq	#0,d1
NoChgSetLoopCh2:	add.l	d1,d0
	btst	#MSB_Backwards,chi_Flags(a1)
	beq.s	NoChgNotBackwards2
	sub.l	d1,d0
	btst	#MSB_Loop,chi_Flags(a1)
	bne.s	NoChgNotBackwards2
	moveq	#-1,d0
NoChgNotBackwards2:	movem.l	d0-d1,chi_EndOffset(a1)
	movem.l	ms_RepCount(a0),d0-d1
	movem.l	d0-d1,chi_CountRestart(a1)
	move.l	(sp)+,a5
	rts
;	INPUT
;	A0.L	=	APTR to mixer alloc structure as got by ExternalMixerAlloc()
;	A2.L	=	APTR to mixing buffer (this routine must be called from
;				your interrupt handler (it does the actual mixing))
;	NO OUTPUTS

	cnop	0,4

ExternalMixerDoMix:	move.l	extb_TuComposerBase(a6),d0
	movem.l	d0/d2-d5/a0/a2/a5-a6,-(sp)
	move.l	a0,a6
	btst	#MASB_Frozen,mas_Flags(a6)
	bne.s	MixerFrozen
	movem.l	hqmas_CurrLeft(a6),d3/d5
	move.l	hqmas_BuffSize(a6),d4
	move.l	d4,d0
	moveq	#0,d1
	move.l	a2,a0
	tst.b	hqmas_Stereo(a6)
	bne.s	ClearBuff
	lsr.l	#1,d0
	bcc.s	ClearBuff
	move.l	d1,(a0)+
ClrLoop:	move.l	d1,(a0)+
	move.l	d1,(a0)+
ClearBuff:	dbra	d0,ClrLoop
DM_Loop:	tst.l	d4
	beq.s	DM_Exit
	tst.l	d3
	beq.s	DM_NoMix
	move.l	d4,d2
	cmp.l	d3,d4
	bls.s	NoMin
	move.l	d3,d2
NoMin:	move.l	a2,a1
	sub.l	d2,d3
	sub.l	d2,d4
	bsr.s	MixSample
	tst.b	hqmas_Stereo(a6)
	beq.s	DM_Mono
	add.l	d2,d2
DM_Mono:	add.l	d2,d2
	add.l	d2,d2
	add.l	d2,a2
DM_NoMix:	tst.l	d3
	bne.s	DM_Loop
	move.l	(sp),a0
	jsr	_LVODoPlayerIRQ(a0)
	move.l	hqmas_PassLength(a6),d3
	add.l	hqmas_PassFrac(a6),d5
	bcc.s	DM_Loop
	addq.l	#1,d3
	bra.s	DM_Loop
DM_Exit:	movem.l	d3/d5,hqmas_CurrLeft(a6)
MixerFrozen:	lea	mas_PostProcs(a6),a5
CallPostProcs:	move.l	(a5),a5
	tst.l	(a5)
	beq.s	CallPostProcsDone
	move.l	a5,a0
	move.l	24(sp),a2
	move.l	pas_PostProcLibBase(a5),a6
	jsr	_LVOExternalPostProcDoMix(a6)
	bra.s	CallPostProcs
CallPostProcsDone:	movem.l	(sp)+,d0/d2-d5/a0/a2/a5-a6
	rts

	cnop	0,4

MixSample:	movem.l	d2-d7/a2-a6,-(sp)
	move.w	hqmas_Channels(a6),d7
	move.l	hqmas_ChInfo(a6),a5
	subq.w	#1,d7
MixSmp_ChLoop:	tst.b	chi_Flags(a5)
	bpl	MixSmp_ChLoopEnd
	movem.l	chi_MixRegs(a5),d2/d4-d6/a4
	move.l	(sp),d3
	move.l	a1,a2
	btst	#MSB_Backwards,chi_Flags(a5)
	bne	MixSmp_Backwards
MixSmp_Loop2:	move.l	d5,d1
	ext.l	d3
	swap	d1
	move.w	d6,d1
	mulu.l	d3,d0:d1
	add.l	d4,d1
	move.w	d0,d1
	swap	d1
	move.l	chi_EndOffset(a5),d0
	sub.l	d2,d0
	ble.s	MixSmp_SmpEnd
	cmp.l	d0,d1
	bhs.s	MixSmp_CalcSize
	move.w	d3,d0
	move.l	d6,a0
	jsr	(a4)
	move.w	a0,d6
	cmp.l	chi_EndOffset(a5),d2
	blo.s	MixSmp_SaveReg
	moveq	#0,d3
	bra.s	MixSmp_SmpEnd
MixSmp_CalcSize:	swap	d0
	clr.w	d0
	sub.l	d4,d0
	subq.l	#1,d0
	move.w	d5,d1
	swap	d1
	move.w	d6,d1
	divu.l	d1,d0
	addq.w	#1,d0
	sub.w	d0,d3
	move.l	d6,a0
	jsr	(a4)
	move.w	a0,d6
	cmp.l	chi_EndOffset(a5),d2
	bhs.s	MixSmp_SmpEnd
	tst.w	d3
	beq.s	MixSmp_SaveReg
MixSmp_SmpEnd:	btst	#MSB_Loop,chi_Flags(a5)
	beq.s	MixSmp_StopChan
	move.l	chi_Counted(a5),d0
	addq.l	#1,chi_Counted(a5)
	move.l	chi_CountRestart(a5),d1
	beq.s	MixSmp_NotCountRepeat
	cmp.l	d1,d0
	beq.s	MixSmp_CountRepeatDone
MixSmp_NotCountRepeat:	btst	#MSB_Pingpong,chi_Flags(a5)
	bne.s	MixSmp_Pingpong
	sub.l	chi_RestartOffset(a5),d2
	move.l	chi_NewSampleStartAdr(a5),d0
	beq.s	MixSmp_LoopEnd
MixSmp_Synth:	bsr	MixSmp_SetSynth
MixSmp_LoopEnd:	tst.w	d3
	bgt	MixSmp_Loop2
	bra.s	MixSmp_SaveReg
MixSmp_StopChan:	move.l	chi_NewSampleStartAdr(a5),d0
	bne.s	MixSmp_Synth
	bclr	#MSB_Play,chi_Flags(a5)
MixSmp_SaveReg:	movem.l	d2/d4,chi_MixRegs(a5)
MixSmp_ChLoopEnd:	lea	chi_SIZEOF(a5),a5
	dbra	d7,MixSmp_ChLoop
	movem.l	(sp)+,d2-d7/a2-a6
	rts
MixSmp_CountRepeatDone:	bclr	#MSB_Loop,chi_Flags(a5)
	move.l	chi_SampleLen(a5),chi_EndOffset(a5)
	bra.s	MixSmp_Synth
MixSmp_Pingpong:	move.l	chi_NewSampleStartAdr(a5),d0
	beq.s	MixSmp_NotNewWave
	bsr	MixSmp_SetSynth
MixSmp_NotNewWave:	move.l	chi_AltMixRoutine(a5),d0
	move.l	a4,chi_AltMixRoutine(a5)
	move.l	d0,a4
	move.l	d0,chi_MixRoutine(a5)
	bchg	#MSB_Backwards,chi_Flags(a5)
	move.l	chi_EndOffset(a5),d0
	sub.l	d0,d2
	neg.l	d2
	add.l	d0,d2
	sub.l	chi_RestartOffset(a5),d0
	move.l	d0,chi_EndOffset(a5)
	tst.w	d3
	beq.s	MixSmp_SaveReg
MixSmp_Backwards:	
MixSmpB_Loop2:	move.l	d5,d1
	ext.l	d3
	swap	d1
	move.w	d6,d1
	mulu.l	d3,d0:d1
	move.w	d0,d1
	swap	d1
	move.l	d2,d0
	sub.l	chi_EndOffset(a5),d0
	ble.s	MixSmpB_SmpEnd
	cmp.l	d0,d1
	bhs.s	MixSmpB_CalcSize
	move.w	d3,d0
	move.l	d6,a0
	jsr	(a4)
	move.w	a0,d6
	cmp.l	chi_EndOffset(a5),d2
	bgt.s	MixSmp_SaveReg
	moveq	#0,d3
	bra.s	MixSmpB_SmpEnd
MixSmpB_CalcSize:	swap	d0
	clr.w	d0
	sub.l	d4,d0
	subq.l	#1,d0
	move.w	d5,d1
	swap	d1
	move.w	d6,d1
	divu.l	d1,d0
	addq.w	#1,d0
	sub.w	d0,d3
	move.l	d6,a0
	jsr	(a4)
	move.w	a0,d6
	cmp.l	chi_EndOffset(a5),d2
	ble.s	MixSmpB_SmpEnd
	tst.w	d3
	beq	MixSmp_SaveReg
MixSmpB_SmpEnd:	btst	#MSB_Loop,chi_Flags(a5)
	beq	MixSmp_StopChan
	move.l	chi_Counted(a5),d1
	addq.l	#1,chi_Counted(a5)
	move.l	chi_CountRestart(a5),d0
	beq.s	MixSmpB_NotCountRepeat
	cmp.l	d1,d0
	beq.s	MixSmpB_CountRepeatDone
MixSmpB_NotCountRepeat:	btst	#MSB_Pingpong,chi_Flags(a5)
	bne.s	MixSmp_Pingpong2
	add.l	chi_RestartOffset(a5),d2
	move.l	chi_NewSampleStartAdr(a5),d0
	bne	MixSmp_Synth
MixSmpB_LoopEnd2:	tst.w	d3
	bgt	MixSmpB_Loop2
	bra	MixSmp_SaveReg
MixSmpB_CountRepeatDone:	bclr	#MSB_Loop,chi_Flags(a5)
	moveq	#-1,d0
	move.l	d0,chi_EndOffset(a5)
	bra	MixSmp_Synth
MixSmp_Pingpong2:	move.l	chi_NewSampleStartAdr(a5),d0
	beq.s	MixSmpB_NotNewWave
	bsr.s	MixSmp_SetSynth
MixSmpB_NotNewWave:	move.l	chi_AltMixRoutine(a5),d0
	move.l	a4,chi_AltMixRoutine(a5)
	move.l	d0,a4
	move.l	d0,chi_MixRoutine(a5)
	bchg	#MSB_Backwards,chi_Flags(a5)
	move.l	chi_EndOffset(a5),d0
	sub.l	d0,d2
	neg.l	d2
	add.l	d0,d2
	add.l	chi_RestartOffset(a5),d0
	move.l	d0,chi_EndOffset(a5)
	tst.w	d3
	bgt	MixSmp_Loop2
	bra	MixSmp_SaveReg
MixSmp_SetSynth:	move.l	a1,d0
	lea	chi_NewSampleStartAdr(a5),a0
	move.l	a5,a1
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0),(a1)
	move.l	d0,a1
	clr.l	chi_NewSampleStartAdr(a5)
	rts

	cnop	0,4

Skip:	move.w	d5,d1
	swap	d1
	move.w	d6,d1
	ext.l	d0
	mulu.l	d0,d0:d1
	add.w	d1,d4
	move.w	d0,d1
	swap	d1
	addx.l	d1,d2
	rts

	cnop	0,4

Skipb:	move.w	d5,d1
	swap	d1
	move.w	d6,d1
	ext.l	d0
	mulu.l	d0,d0:d1
	add.w	d1,d4
	move.w	d0,d1
	swap	d1
	subx.l	d1,d2
	rts

	cnop	0,4

	addq.l	#1,d2
	rts

GetNextSample:	move.l	chi_EndOffset(a5),d3
	subq.l	#1,d3
	cmp.l	d3,d2
	bhs.s	GNS_End
	moveq	#0,d3
	move.b	1(a6,d2.l),d3
	bra.s	GNS_NoLoop
GNS_End:	moveq	#0,d3
	btst	#MSB_Loop,chi_Flags(a5)
	beq.s	GNS_NoLoop
	move.l	d2,-(sp)
	sub.l	chi_RestartOffset(a5),d2
	tst.l	chi_NewSampleStartAdr(a5)
	beq.s	.1
	move.l	a6,-(sp)
	move.l	chi_NewSampleStartAdr(a5),a6
	add.l	chi_NewOffset(a5),d2
	move.b	1(a6,d2.l),d3
	move.l	(sp)+,a6
	bra.s	.2
.1:	move.b	1(a6,d2.l),d3
.2:	move.l	(sp)+,d2
GNS_NoLoop:	move.l	(a3,d3.l*4),d3
	tst.b	chi_MixRight(a5)
	bne.s	.1
	move.l	d3,chi_NextSample(a5)
	rts
.1:	move.l	d3,chi_NextSample_R(a5)
	rts

	cnop	0,4

	subq.l	#1,d2
	rts

GetNextSampleB:	move.l	chi_EndOffset(a5),d3
	addq.l	#1,d3
	cmp.l	d3,d2
	ble.s	GNSB_End
	moveq	#0,d3
	move.b	-1(a6,d2.l),d3
	bra.s	GNS_NoLoop
GNSB_End:	moveq	#0,d3
	btst	#MSB_Loop,chi_Flags(a5)
	beq.s	GNS_NoLoop
	move.l	d2,-(sp)
	add.l	chi_RestartOffset(a5),d2
	move.b	-1(a6,d2.l),d3
	move.l	(sp)+,d2
	bra.s	GNS_NoLoop

	cnop	0,4

	subq.l	#1,d2
	rts

GetNextSample_16B:	move.l	chi_EndOffset(a5),d3
	addq.l	#1,d3
	cmp.l	d3,d2
	ble.s	GNSB16_End
	move.w	-2(a6,d2.l*2),d3
	bra.s	GNS16_NoLoop
GNSB16_End:	moveq	#0,d3
	btst	#MSB_Loop,chi_Flags(a5)
	beq.s	GNS16_NoLoop
	move.l	d2,-(sp)
	add.l	chi_RestartOffset(a5),d2
	move.w	2(a6,d2.l*2),d3
	move.l	(sp)+,d2
	bra.s	GNS16_NoLoop

	cnop	0,4

	addq.l	#1,d2
	rts

GetNextSample_16:	move.l	chi_EndOffset(a5),d3
	subq.l	#1,d3
	cmp.l	d3,d2
	bhs.s	GNS16_End
	move.w	2(a6,d2.l*2),d3
	bra.s	GNS16_NoLoop
GNS16_End:	moveq	#0,d3
	btst	#MSB_Loop,chi_Flags(a5)
	beq.s	GNS16_NoLoop
	move.l	d2,-(sp)
	sub.l	chi_RestartOffset(a5),d2
	tst.l	chi_NewSampleStartAdr(a5)
	beq.s	.1
	move.l	a6,-(sp)
	move.l	chi_NewSampleStartAdr(a5),a6
	add.l	chi_NewOffset(a5),d2
	move.w	2(a6,d2.l*2),d3
	move.l	(sp)+,a6
	bra.s	.2
.1:	move.w	2(a6,d2.l*2),d3
.2:	move.l	(sp)+,d2
GNS16_NoLoop:	ext.l	d3
	muls.l	d7,d1:d3
	divs.l	chi_Divider(a5),d1:d3
	tst.b	chi_MixRight(a5)
	bne.s	.1
	move.l	d3,chi_NextSample(a5)
	rts
.1:	move.l	d3,chi_NextSample_R(a5)
	rts

	cnop	0,4

	addq.l	#1,d2
	rts

GetNextSample_X:	move.l	chi_EndOffset(a5),d3
	subq.l	#1,d3
	cmp.l	d3,d2
	bhs.s	GNSX_End
	movem.l	d2/d5,-(sp)
	moveq	#0,d5
	move.b	chi_BitDepth(a5),d5
	mulu.l	d5,d2
	add.l	d5,d2
	bfextu	(a6){d2:d5},d3
	ror.l	d5,d3
	movem.l	(sp)+,d2/d5
	bra.s	GNSX_NoLoop
GNSX_End:	moveq	#0,d3
	btst	#MSB_Loop,chi_Flags(a5)
	beq.s	GNSX_NoLoop
	movem.l	d2/d5,-(sp)
	sub.l	chi_RestartOffset(a5),d2
	moveq	#0,d5
	move.b	chi_BitDepth(a5),d5
	mulu.l	d5,d2
	add.l	d5,d2
	tst.l	chi_NewSampleStartAdr(a5)
	beq.s	.1
	move.l	a6,-(sp)
	move.l	chi_NewSampleStartAdr(a5),a6
	add.l	chi_NewOffset(a5),d2
	bfextu	(a6){d2:d5},d3
	ror.l	d5,d3
	move.l	(sp)+,a6
	bra.s	.2
.1:	bfextu	(a6){d2:d5},d3
	ror.l	d5,d3
.2:	movem.l	(sp)+,d2/d5
GNSX_NoLoop:	muls.l	d7,d1:d3
	divs.l	chi_Divider(a5),d1:d3
	tst.b	chi_MixRight(a5)
	bne.s	.1
	move.l	d3,chi_NextSample(a5)
	rts
.1:	move.l	d3,chi_NextSample_R(a5)
	rts

	cnop	0,4

	subq.l	#1,d2
	rts

GetNextSample_XB:	move.l	chi_EndOffset(a5),d3
	addq.l	#1,d3
	cmp.l	d3,d2
	ble.s	GNSBX_End
	movem.l	d2/d5,-(sp)
	moveq	#0,d5
	move.b	chi_BitDepth(a5),d5
	mulu.l	d5,d2
	sub.l	d5,d2
	bfextu	(a6){d2:d5},d3
	ror.l	d5,d3
	movem.l	(sp)+,d2/d5
	bra.s	GNSX_NoLoop
GNSBX_End:	moveq	#0,d3
	btst	#MSB_Loop,chi_Flags(a5)
	beq.s	GNSX_NoLoop
	movem.l	d2/d5,-(sp)
	add.l	chi_RestartOffset(a5),d2
	moveq	#0,d5
	move.b	chi_BitDepth(a5),d5
	mulu.l	d5,d2
	add.l	d5,d2
	bfextu	(a6){d2:d5},d3
	ror.l	d5,d3
	movem.l	(sp)+,d2/d5
	bra.s	GNSX_NoLoop

	cnop	0,4

	addq.l	#1,d2
	rts

GetNextSample_168:	move.l	chi_EndOffset(a5),d3
	subq.l	#1,d3
	cmp.l	d3,d2
	bhs.s	GNS168_End
	moveq	#0,d3
	move.b	2(a6,d2.l*2),d3
	bra.s	GNS168_NoLoop
GNS168_End:	moveq	#0,d3
	btst	#MSB_Loop,chi_Flags(a5)
	beq.s	GNS168_NoLoop
	move.l	d2,-(sp)
	sub.l	chi_RestartOffset(a5),d2
	tst.l	chi_NewSampleStartAdr(a5)
	beq.s	.1
	move.l	a6,-(sp)
	move.l	chi_NewSampleStartAdr(a5),a6
	add.l	chi_NewOffset(a5),d2
	move.b	2(a6,d2.l*2),d3
	move.l	(sp)+,a6
	bra.s	.2
.1:	move.b	2(a6,d2.l*2),d3
.2:	move.l	(sp)+,d2
GNS168_NoLoop:	move.l	(a3,d3.l*4),d3
	tst.b	chi_MixRight(a5)
	bne.s	.1
	move.l	d3,chi_NextSample(a5)
	rts
.1:	move.l	d3,chi_NextSample_R(a5)
	rts

	cnop	0,4

	subq.l	#1,d2
	rts

GetNextSample_168B:	move.l	chi_EndOffset(a5),d3
	addq.l	#1,d3
	cmp.l	d3,d2
	ble.s	GNS168B_End
	moveq	#0,d3
	move.b	-2(a6,d2.l*2),d3
	bra.s	GNS168_NoLoop
GNS168B_End:	moveq	#0,d3
	btst	#MSB_Loop,chi_Flags(a5)
	beq.s	GNS168_NoLoop
	move.l	d2,-(sp)
	add.l	chi_RestartOffset(a5),d2
	move.b	-2(a6,d2.l*2),d3
	move.l	(sp)+,d2
	bra.s	GNS168_NoLoop

	cnop	0,4

	addq.l	#1,d2
	rts

GetNextSample_X8:	move.l	chi_EndOffset(a5),d3
	subq.l	#1,d3
	cmp.l	d3,d2
	bhs.s	GNSX8_End
	move.l	d2,-(sp)
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	add.l	d6,d2
	bfextu	(a6){d2:d6},d3
	ror.l	d6,d3
	rol.l	#8,d3
	and.l	#$ff,d3
	move.l	(sp)+,d2
	bra.s	GNSX8_NoLoop
GNSX8_End:	moveq	#0,d3
	btst	#MSB_Loop,chi_Flags(a5)
	beq.s	GNSX8_NoLoop
	move.l	d2,-(sp)
	sub.l	chi_RestartOffset(a5),d2
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	add.l	d6,d2
	tst.l	chi_NewSampleStartAdr(a5)
	beq.s	.1
	move.l	a6,-(sp)
	move.l	chi_NewSampleStartAdr(a5),a6
	add.l	chi_NewOffset(a5),d2
	bfextu	(a6){d2:d6},d3
	ror.l	d6,d3
	rol.l	#8,d3
	and.l	#$ff,d3
	move.l	(sp)+,a6
	bra.s	.2
.1:	bfextu	(a6){d2:d6},d3
	ror.l	d6,d3
	rol.l	#8,d3
	and.l	#$ff,d3
.2:	move.l	(sp)+,d2
GNSX8_NoLoop:	move.l	(a3,d3.l*4),d3
	tst.b	chi_MixRight(a5)
	bne.s	.1
	move.l	d3,chi_NextSample(a5)
	rts
.1:	move.l	d3,chi_NextSample_R(a5)
	rts

	cnop	0,4

	subq.l	#1,d2
	rts

GetNextSample_X8B:	move.l	chi_EndOffset(a5),d3
	addq.l	#1,d3
	cmp.l	d3,d2
	ble.s	GNSX8B_End
	move.l	d2,-(sp)
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	sub.l	d6,d2
	bfextu	(a6){d2:d6},d3
	ror.l	d6,d3
	rol.l	#8,d3
	and.l	#$ff,d3
	move.l	(sp)+,d2
	bra.s	GNSX8_NoLoop
GNSX8B_End:	moveq	#0,d3
	btst	#MSB_Loop,chi_Flags(a5)
	beq.s	GNSX8_NoLoop
	move.l	d2,-(sp)
	add.l	chi_RestartOffset(a5),d2
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	sub.l	d6,d2
	bfextu	(a6){d2:d6},d3
	ror.l	d6,d3
	rol.l	#8,d3
	and.l	#$ff,d3
	move.l	(sp)+,d2
	bra.s	GNSX8_NoLoop

	cnop	0,4

sMIX_Mono8:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	sMIX_Avg
	movem.l	d3/d5/a4,-(sp)
	bsr	GetCurrS_8
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample(pc),a4
	bsr	sMIX_MonoLoop
	movem.l	(sp)+,d3/d5/a4
	rts
sMIX_Avg:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_8(pc),a1
	lea	GetS_1(pc),a4
	bsr	sMIX_AvgMono
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIXb_Mono8:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	sMIXb_Avg
	movem.l	d3/d5/a4,-(sp)
	bsr	GetCurrS_8
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSampleB(pc),a4
	bsr	sMIX_MonoLoop
	movem.l	(sp)+,d3/d5/a4
	rts
sMIXb_Avg:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_8(pc),a1
	lea	GetS_1b(pc),a4
	bsr	sMIX_AvgMono
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIX_Mono16:	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	sMIX_Avg16
	movem.l	d3/d5/d7/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	bsr	GetCurrS_16
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_16(pc),a4
	bsr	sMIX_MonoLoop
	movem.l	(sp)+,d3/d5/d7/a4
	rts
sMIX_Avg16:	movem.l	d7/a1/a4,-(sp)
	lea	GetS_1_16(pc),a4
	lea	GetCurrS_16(pc),a1
	move.l	chi_Multiply_L(a5),d7
	bsr	sMIX_AvgMono
	movem.l	(sp)+,d7/a1/a4
	rts

	cnop	0,4

sMIXb_Mono16:	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	sMIXb_Avg16
	movem.l	d3/d5/d7/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	bsr	GetCurrS_16
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_16B(pc),a4
	bsr	sMIX_MonoLoop
	movem.l	(sp)+,d3/d5/d7/a4
	rts
sMIXb_Avg16:	movem.l	d7/a1/a4,-(sp)
	lea	GetS_1_16b(pc),a4
	lea	GetCurrS_16(pc),a1
	move.l	chi_Multiply_L(a5),d7
	bsr	sMIX_AvgMono
	movem.l	(sp)+,d7/a1/a4
	rts

	cnop	0,4

sMIX_Mono168:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	sMIX_Avg168
	movem.l	d3/d5/a4,-(sp)
	bsr	GetCurrS_168
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_168(pc),a4
	bsr	sMIX_MonoLoop
	movem.l	(sp)+,d3/d5/a4
	rts
sMIX_Avg168:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_168(pc),a1
	lea	GetS_1_168(pc),a4
	bsr	sMIX_AvgMono
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIXb_Mono168:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	sMIXb_Avg168
	movem.l	d3/d5/a4,-(sp)
	bsr	GetCurrS_8
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_168B(pc),a4
	bsr	sMIX_MonoLoop
	movem.l	(sp)+,d3/d5/a4
	rts
sMIXb_Avg168:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_168(pc),a1
	lea	GetS_1_168b(pc),a4
	bsr	sMIX_AvgMono
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIX_MonoX:	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	sMIX_AvgX
	movem.l	d3/d5/d7/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	bsr	GetCurrS_X
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_X(pc),a4
	bsr	sMIX_MonoLoop
	movem.l	(sp)+,d3/d5/d7/a4
	rts
sMIX_AvgX:	movem.l	d7/a1/a4,-(sp)
	lea	GetS_1_X(pc),a4
	lea	GetCurrS_X(pc),a1
	move.l	chi_Multiply_L(a5),d7
	bsr	sMIX_AvgMono
	movem.l	(sp)+,d7/a1/a4
	rts

	cnop	0,4

sMIXb_MonoX:	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	sMIXb_AvgX
	movem.l	d3/d5/d7/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	bsr	GetCurrS_X
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_XB(pc),a4
	bsr	sMIX_MonoLoop
	movem.l	(sp)+,d3/d5/d7/a4
	rts
sMIXb_AvgX:	movem.l	d7/a1/a4,-(sp)
	lea	GetS_1_Xb(pc),a4
	lea	GetCurrS_X(pc),a1
	move.l	chi_Multiply_L(a5),d7
	bsr	sMIX_AvgMono
	movem.l	(sp)+,d7/a1/a4
	rts

	cnop	0,4

sMIX_MonoX8:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	sMIX_AvgX8
	movem.l	d3/a4,-(sp)
	bsr	GetCurrS_X8
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_X8(pc),a4
	bsr.s	sMIX_MonoLoop
	movem.l	(sp)+,d3/a4
	rts
sMIX_AvgX8:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_X8(pc),a1
	lea	GetS_1_X8(pc),a4
	bsr	sMIX_AvgMono
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIXb_MonoX8:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	sMIXb_AvgX8
	movem.l	d3/d5/a4,-(sp)
	bsr	GetCurrS_X8
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_X8B(pc),a4
	bsr.s	sMIX_MonoLoop
	movem.l	(sp)+,d3/d5/a4
	rts
sMIXb_AvgX8:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_X8(pc),a1
	lea	GetS_1_X8b(pc),a4
	bsr	sMIX_AvgMono
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIX_MonoLoop:	jsr	(a4)
.1:	move.l	chi_CurrSample(a5),d1
	move.l	chi_PrevSample(a5),d5
	sub.l	d1,d5
	neg.l	d5
	move.l	chi_NextSample(a5),d3
	sub.l	d1,d3
	sub.l	d5,d3
	asr.l	#2,d3
	lsr.w	#1,d4
	swap	d4
	muls.l	d4,d6:d3
	roxl.l	#1,d4
	asl.l	#2,d6
	add.l	d5,d6
	asr.l	#2,d6
	lsr.l	#1,d4
	muls.l	d4,d3:d6
	swap	d4
	roxl.w	#1,d4
	asl.l	#3,d3
	move.l	chi_PrevSample(a5),d5
	add.l	d5,d1
	asr.l	#1,d1
	add.l	d3,d1
	bvc.s	.2
	move.l	chi_CurrSample(a5),d1
.2:	add.l	d1,(a2)+
	add.w	a0,d4
	bcc.s	.4
	jsr	-4(a4)
	move.l	chi_CurrSample(a5),chi_PrevSample(a5)
	move.l	chi_NextSample(a5),chi_CurrSample(a5)
	jsr	(a4)
.4:	dbra	d0,.1
	rts

	cnop	0,4

GetCurrS_8:	moveq	#0,d1
	move.b	(a6,d2.l),d1
	move.l	(a3,d1.l*4),d1
	rts

	cnop	0,4

GetCurrS_16:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	muls.l	d7,d6:d1
	divs.l	chi_Divider(a5),d6:d1
	rts

	cnop	0,4

GetCurrS_168:	moveq	#0,d1
	move.b	(a6,d2.l*2),d1
	move.l	(a3,d1.l*4),d1
	rts

	cnop	0,4

GetCurrS_X:	move.l	d2,-(sp)
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	d7,d6:d1
	divs.l	chi_Divider(a5),d6:d1
	move.l	(sp)+,d2
	rts

	cnop	0,4

GetCurrS_X8:	moveq	#0,d1
	move.l	d2,-(sp)
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	#$ff,d1
	move.l	(a3,d1.l*4),d1
	move.l	(sp)+,d2
	rts

	cnop	0,4

sMIX_AvgMono:	move.l	d3,-(sp)
.1:	move.l	d4,d3
	not.w	d3
	jsr	(a1)
	lsr.w	#1,d3
	swap	d3
	muls.l	d1,d6:d3
	move.l	d6,d3
	asr.l	#7,d3
	move.w	d5,-(sp)
	move.l	d4,d6
	not.w	d6
	lsr.w	#8,d6
	add.l	-4(a4),d2
	subq.w	#2,d5
	bmi.s	.2
.3:	jsr	(a4)
	add.l	-4(a4),d2
	asr.l	#8,d1
	add.l	d1,d3
	dbra	d5,.3
.2:	add.w	a0,d4
	bcc.s	.4
	jsr	(a4)
	add.l	-4(a4),d2
	asr.l	#8,d1
	add.l	d1,d3
.4:	jsr	4(a4)
	move.l	d4,d5
	lsr.w	#8,d5
	add.w	d5,d6
	move.w	d4,d5
	lsr.w	#1,d5
	swap	d5
	muls.l	d5,d5:d1
	move.l	d5,d1
	asr.l	#7,d1
	add.l	d1,d3
	swap	d3
	move.w	d3,d5
	ext.l	d5
	clr.w	d3
	divs.l	d6,d5:d3
	move.w	(sp)+,d5
	add.l	d3,(a2)+
	dbra	d0,.1
	move.l	(sp)+,d3
	rts

	cnop	0,4

	dc.l	-1
GetS_1b:	add.w	#$100,d6
	moveq	#0,d1
	move.l	d6,-(sp)
	move.l	d2,d6
GetS_1b_Loop:	cmp.l	chi_EndOffset(a5),d6
	bhs.s	AAG_Ok
	btst	#MSB_Loop,chi_Flags(a5)
	beq.s	AAG_NoLoop
	add.l	chi_RestartOffset(a5),d6
	bra.s	GetS_1b_Loop

	cnop	0,4

	dc.l	1
GetS_1:	add.w	#$100,d6
	moveq	#0,d1
	move.l	d6,-(sp)
	move.l	d2,d6
GetS_1_Loop:	cmp.l	chi_EndOffset(a5),d6
	blo.s	AAG_Ok
	btst	#MSB_Loop,chi_Flags(a5)
	beq.s	AAG_NoLoop
	sub.l	chi_RestartOffset(a5),d6
	bra.s	GetS_1_Loop
AAG_Ok:	move.b	(a6,d6.l),d1
	move.l	(a3,d1.l*4),d1
AAG_NoLoop:	move.l	(sp)+,d6
	rts

	cnop	0,4

	dc.l	1
GetS_1_16:	add.w	#$100,d6
	moveq	#0,d1
	move.l	d6,-(sp)
	move.l	d2,d6
GetS_1_16_Loop:	cmp.l	chi_EndOffset(a5),d6
	blo.s	AAG16_Ok
	btst	#MSB_Loop,chi_Flags(a5)
	beq.s	AAG16_NoLoop
	sub.l	chi_RestartOffset(a5),d6
	bra.s	GetS_1_16_Loop
AAG16_Ok:	move.w	(a6,d6.l*2),d1
	ext.l	d1
	muls.l	d7,d6:d1
	divs.l	chi_Divider(a5),d6:d1
AAG16_NoLoop:	move.l	(sp)+,d6
	rts

	cnop	0,4

	dc.l	1
GetS_1_168:	add.w	#$100,d6
	moveq	#0,d1
	move.l	d6,-(sp)
	move.l	d2,d6
GetS_1_168_Loop:	cmp.l	chi_EndOffset(a5),d6
	blo.s	AAG168_Ok
	btst	#MSB_Loop,chi_Flags(a5)
	beq.s	AAG168_NoLoop
	sub.l	chi_RestartOffset(a5),d6
	bra.s	GetS_1_168_Loop
AAG168_Ok:	move.b	(a6,d6.l*2),d1
	move.l	(a3,d1.l*4),d1
AAG168_NoLoop:	move.l	(sp)+,d6
	rts

	cnop	0,4

	dc.l	-1
GetS_1_16b:	add.w	#$100,d6
	moveq	#0,d1
	move.l	d6,-(sp)
	move.l	d2,d6
GetS_1_16b_Loop:	cmp.l	chi_EndOffset(a5),d6
	bhs.s	AAG16_Ok
	btst	#MSB_Loop,chi_Flags(a5)
	beq.s	AAG16_NoLoop
	add.l	chi_RestartOffset(a5),d6
	bra.s	GetS_1_16b_Loop

	cnop	0,4

	dc.l	-1
GetS_1_168b:	add.w	#$100,d6
	moveq	#0,d1
	move.l	d6,-(sp)
	move.l	d2,d6
GetS_1_168b_Loop:	cmp.l	chi_EndOffset(a5),d6
	bhs.s	AAG168_Ok
	btst	#MSB_Loop,chi_Flags(a5)
	beq.s	AAG168_NoLoop
	add.l	chi_RestartOffset(a5),d6
	bra.s	GetS_1_168b_Loop

	cnop	0,4

	dc.l	1
GetS_1_X:	add.w	#$100,d6
	movem.l	d5-d6,-(sp)
	move.l	d2,d6
GetS_1_X_Loop:	cmp.l	chi_EndOffset(a5),d6
	blo.s	AAGX_Ok
	btst	#MSB_Loop,chi_Flags(a5)
	beq.s	AAGX_NoLoop
	sub.l	chi_RestartOffset(a5),d6
	bra.s	GetS_1_X_Loop
AAGX_Ok:	moveq	#0,d5
	move.b	chi_BitDepth(a5),d5
	mulu.l	d5,d6
	bfextu	(a6){d6:d5},d1
	ror.l	d5,d1
	muls.l	d7,d5:d1
	divs.l	chi_Divider(a5),d5:d1
AAGX_NoLoop:	movem.l	(sp)+,d5-d6
	rts

	cnop	0,4

	dc.l	-1
GetS_1_Xb:	add.w	#$100,d6
	movem.l	d5-d6,-(sp)
	move.l	d2,d6
GetS_1_XB_Loop:	cmp.l	chi_EndOffset(a5),d6
	bhs.s	AAGX_Ok
	btst	#MSB_Loop,chi_Flags(a5)
	beq.s	AAGX_NoLoop
	add.l	chi_RestartOffset(a5),d6
	bra.s	GetS_1_XB_Loop

	cnop	0,4

	dc.l	1
GetS_1_X8:	add.w	#$100,d6
	movem.l	d5-d6,-(sp)
	move.l	d2,d6
GetS_1_X8_Loop:	cmp.l	chi_EndOffset(a5),d6
	blo.s	AAGX8_Ok
	btst	#MSB_Loop,chi_Flags(a5)
	beq.s	AAGX8_NoLoop
	sub.l	chi_RestartOffset(a5),d6
	bra.s	GetS_1_X8_Loop
AAGX8_Ok:	moveq	#0,d5
	move.b	chi_BitDepth(a5),d5
	mulu.l	d5,d6
	bfextu	(a6){d6:d5},d1
	ror.l	d5,d1
	rol.l	#8,d1
	and.l	#$ff,d1
	move.l	(a3,d1.l*4),d1
AAGX8_NoLoop:	movem.l	(sp)+,d5-d6
	rts

	cnop	0,4

	dc.l	-1
GetS_1_X8b:	add.w	#$100,d6
	movem.l	d5-d6,-(sp)
	move.l	d2,d6
GetS_1_X8b_Loop:	cmp.l	chi_EndOffset(a5),d6
	bhs.s	AAGX8_Ok
	btst	#MSB_Loop,chi_Flags(a5)
	beq.s	AAGX8_NoLoop
	add.l	chi_RestartOffset(a5),d6
	bra.s	GetS_1_X8b_Loop
sMIX_Stereo8L:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	bsr	GetCurrS_8
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample(pc),a4
	bsr	sMIX_LeftLoop
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_8(pc),a1
	lea	GetS_1(pc),a4
	bsr	sMIX_AvgLeft
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIXb_Stereo8L:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	bsr	GetCurrS_8
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSampleB(pc),a4
	bsr	sMIX_LeftLoop
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_8(pc),a1
	lea	GetS_1b(pc),a4
	bsr	sMIX_AvgLeft
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIX_Stereo8R:	move.l	(a5),a6
	move.l	chi_VolTable_R(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	st	chi_MixRight(a5)
	bsr	GetCurrS_8
	move.l	d1,chi_CurrSample_R(a5)
	lea	GetNextSample(pc),a4
	bsr	sMIX_RightLoop
	clr.b	chi_MixRight(a5)
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_8(pc),a1
	lea	GetS_1(pc),a4
	bsr	sMIX_AvgRight
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIXb_Stereo8R:	move.l	(a5),a6
	move.l	chi_VolTable_R(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	st	chi_MixRight(a5)
	bsr	GetCurrS_8
	move.l	d1,chi_CurrSample_R(a5)
	lea	GetNextSampleB(pc),a4
	bsr	sMIX_RightLoop
	clr.b	chi_MixRight(a5)
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_8(pc),a1
	lea	GetS_1b(pc),a4
	bsr	sMIX_AvgRight
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIX_Stereo8C:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	bsr	GetCurrS_8
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample(pc),a4
	bsr	sMIX_CenterLoop
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_8(pc),a1
	lea	GetS_1(pc),a4
	bsr	sMIX_AvgCenter
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIXb_Stereo8C:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	bsr	GetCurrS_8
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSampleB(pc),a4
	bsr	sMIX_CenterLoop
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_8(pc),a1
	lea	GetS_1b(pc),a4
	bsr	sMIX_AvgCenter
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIX_Stereo8Sur:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	bsr	GetCurrS_8
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample(pc),a4
	bsr	sMIX_SurroundLoop
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_8(pc),a1
	lea	GetS_1(pc),a4
	bsr	sMIX_AvgSurround
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIXb_Stereo8Sur:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	bsr	GetCurrS_8
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSampleB(pc),a4
	bsr	sMIX_SurroundLoop
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_8(pc),a1
	lea	GetS_1b(pc),a4
	bsr	sMIX_AvgSurround
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIX_Stereo8:	move.l	chi_VolTable_L(a5),a3
	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	movem.l	d0/d2/d4/a2,-(sp)
	bsr	GetCurrS_8
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample(pc),a4
	bsr	sMIX_LeftLoop
	movem.l	(sp)+,d0/d2/d4/a2
	st	chi_MixRight(a5)
	move.l	chi_VolTable_R(a5),a3
	move.l	(a5),a6
	bsr	GetCurrS_8
	move.l	d1,chi_CurrSample_R(a5)
	bsr	sMIX_RightLoop
	clr.b	chi_MixRight(a5)
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_8(pc),a1
	lea	GetS_1(pc),a4
	movem.l	d0/d2/d4/a2,-(sp)
	bsr	sMIX_AvgLeft
	movem.l	(sp)+,d0/d2/d4/a2
	move.l	chi_VolTable_R(a5),a3
	bsr	sMIX_AvgRight
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIXb_Stereo8:	move.l	chi_VolTable_L(a5),a3
	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	movem.l	d0/d2/d4/a2,-(sp)
	bsr	GetCurrS_8
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSampleB(pc),a4
	bsr	sMIX_LeftLoop
	movem.l	(sp)+,d0/d2/d4/a2
	st	chi_MixRight(a5)
	move.l	chi_VolTable_R(a5),a3
	move.l	(a5),a6
	bsr	GetCurrS_8
	move.l	d1,chi_CurrSample_R(a5)
	bsr	sMIX_RightLoop
	clr.b	chi_MixRight(a5)
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_8(pc),a1
	lea	GetS_1b(pc),a4
	movem.l	d0/d2/d4/a2,-(sp)
	bsr	sMIX_AvgLeft
	movem.l	(sp)+,d0/d2/d4/a2
	move.l	chi_VolTable_R(a5),a3
	bsr	sMIX_AvgRight
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIX_Stereo168L:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	bsr	GetCurrS_168
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_168(pc),a4
	bsr	sMIX_LeftLoop
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_168(pc),a1
	lea	GetS_1_168(pc),a4
	bsr	sMIX_AvgLeft
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIXb_Stereo168L:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	bsr	GetCurrS_168
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_168B(pc),a4
	bsr	sMIX_LeftLoop
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_168(pc),a1
	lea	GetS_1_168b(pc),a4
	bsr	sMIX_AvgLeft
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIX_Stereo168R:	move.l	(a5),a6
	move.l	chi_VolTable_R(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	st	chi_MixRight(a5)
	bsr	GetCurrS_168
	move.l	d1,chi_CurrSample_R(a5)
	lea	GetNextSample_168(pc),a4
	bsr	sMIX_RightLoop
	clr.b	chi_MixRight(a5)
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_168(pc),a1
	lea	GetS_1_168(pc),a4
	bsr	sMIX_AvgRight
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIXb_Stereo168R:	move.l	(a5),a6
	move.l	chi_VolTable_R(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	st	chi_MixRight(a5)
	bsr	GetCurrS_168
	move.l	d1,chi_CurrSample_R(a5)
	lea	GetNextSample_168B(pc),a4
	bsr	sMIX_RightLoop
	clr.b	chi_MixRight(a5)
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_168(pc),a1
	lea	GetS_1_168b(pc),a4
	bsr	sMIX_AvgRight
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIX_Stereo168C:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	bsr	GetCurrS_168
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_168(pc),a4
	bsr	sMIX_CenterLoop
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_168(pc),a1
	lea	GetS_1_168(pc),a4
	bsr	sMIX_AvgCenter
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIXb_Stereo168C:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	bsr	GetCurrS_168
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_168B(pc),a4
	bsr	sMIX_CenterLoop
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_168(pc),a1
	lea	GetS_1_168b(pc),a4
	bsr	sMIX_AvgCenter
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIX_Stereo168Sur:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	bsr	GetCurrS_168
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_168(pc),a4
	bsr	sMIX_SurroundLoop
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_168(pc),a1
	lea	GetS_1_168(pc),a4
	bsr	sMIX_AvgSurround
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIXb_Stereo168Sur:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	bsr	GetCurrS_168
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_168B(pc),a4
	bsr	sMIX_SurroundLoop
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_168(pc),a1
	lea	GetS_1_168b(pc),a4
	bsr	sMIX_AvgSurround
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIX_Stereo168:	move.l	chi_VolTable_L(a5),a3
	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	movem.l	d0/d2/d4/a2,-(sp)
	bsr	GetCurrS_168
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_168(pc),a4
	bsr	sMIX_LeftLoop
	movem.l	(sp)+,d0/d2/d4/a2
	st	chi_MixRight(a5)
	move.l	chi_VolTable_R(a5),a3
	move.l	(a5),a6
	bsr	GetCurrS_168
	move.l	d1,chi_CurrSample_R(a5)
	bsr	sMIX_RightLoop
	clr.b	chi_MixRight(a5)
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_168(pc),a1
	lea	GetS_1_168(pc),a4
	movem.l	d0/d2/d4/a2,-(sp)
	bsr	sMIX_AvgLeft
	movem.l	(sp)+,d0/d2/d4/a2
	move.l	chi_VolTable_R(a5),a3
	bsr	sMIX_AvgRight
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIXb_Stereo168:	move.l	chi_VolTable_L(a5),a3
	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	movem.l	d0/d2/d4/a2,-(sp)
	bsr	GetCurrS_168
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_168B(pc),a4
	bsr	sMIX_LeftLoop
	movem.l	(sp)+,d0/d2/d4/a2
	st	chi_MixRight(a5)
	move.l	chi_VolTable_R(a5),a3
	move.l	(a5),a6
	bsr	GetCurrS_168
	move.l	d1,chi_CurrSample_R(a5)
	bsr	sMIX_RightLoop
	clr.b	chi_MixRight(a5)
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_168(pc),a1
	lea	GetS_1_168b(pc),a4
	movem.l	d0/d2/d4/a2,-(sp)
	bsr	sMIX_AvgLeft
	movem.l	(sp)+,d0/d2/d4/a2
	move.l	chi_VolTable_R(a5),a3
	bsr	sMIX_AvgRight
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIX_Stereo16L:	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/d7/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	bsr	GetCurrS_16
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_16(pc),a4
	bsr	sMIX_LeftLoop
	movem.l	(sp)+,d3/d5/d7/a4
	rts
.1:	movem.l	d7/a1/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	lea	GetCurrS_16(pc),a1
	lea	GetS_1_16(pc),a4
	bsr	sMIX_AvgLeft
	movem.l	(sp)+,d7/a1/a4
	rts

	cnop	0,4

sMIXb_Stereo16L:	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/d7/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	bsr	GetCurrS_16
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_16B(pc),a4
	bsr	sMIX_LeftLoop
	movem.l	(sp)+,d3/d5/d7/a4
	rts
.1:	movem.l	d7/a1/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	lea	GetCurrS_16(pc),a1
	lea	GetS_1_16b(pc),a4
	bsr	sMIX_AvgLeft
	movem.l	(sp)+,d7/a1/a4
	rts

	cnop	0,4

sMIX_Stereo16R:	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/d7/a4,-(sp)
	move.l	chi_Multiply_R(a5),d7
	st	chi_MixRight(a5)
	bsr	GetCurrS_16
	move.l	d1,chi_CurrSample_R(a5)
	lea	GetNextSample_16(pc),a4
	bsr	sMIX_RightLoop
	clr.b	chi_MixRight(a5)
	movem.l	(sp)+,d3/d5/d7/a4
	rts
.1:	movem.l	d7/a1/a4,-(sp)
	move.l	chi_Multiply_R(a5),d7
	lea	GetCurrS_16(pc),a1
	lea	GetS_1_16(pc),a4
	bsr	sMIX_AvgRight
	movem.l	(sp)+,d7/a1/a4
	rts

	cnop	0,4

sMIXb_Stereo16R:	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/d7/a4,-(sp)
	st	chi_MixRight(a5)
	move.l	chi_Multiply_R(a5),d7
	bsr	GetCurrS_16
	move.l	d1,chi_CurrSample_R(a5)
	lea	GetNextSample_16B(pc),a4
	bsr	sMIX_RightLoop
	clr.b	chi_MixRight(a5)
	movem.l	(sp)+,d3/d5/d7/a4
	rts
.1:	movem.l	d7/a1/a4,-(sp)
	move.l	chi_Multiply_R(a5),d7
	lea	GetCurrS_16(pc),a1
	lea	GetS_1_16b(pc),a4
	bsr	sMIX_AvgRight
	movem.l	(sp)+,d7/a1/a4
	rts

	cnop	0,4

sMIX_Stereo16C:	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/d7/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	bsr	GetCurrS_16
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_16(pc),a4
	bsr	sMIX_CenterLoop
	movem.l	(sp)+,d3/d5/d7/a4
	rts
.1:	movem.l	d7/a1/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	lea	GetCurrS_16(pc),a1
	lea	GetS_1_16(pc),a4
	bsr	sMIX_AvgCenter
	movem.l	(sp)+,d7/a1/a4
	rts

	cnop	0,4

sMIXb_Stereo16C:	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/d7/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	bsr	GetCurrS_16
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_16B(pc),a4
	bsr	sMIX_CenterLoop
	movem.l	(sp)+,d3/d5/d7/a4
	rts
.1:	movem.l	d7/a1/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	lea	GetCurrS_16(pc),a1
	lea	GetS_1_16b(pc),a4
	bsr	sMIX_AvgCenter
	movem.l	(sp)+,d7/a1/a4
	rts

	cnop	0,4

sMIX_Stereo16Sur:	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/d7/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	bsr	GetCurrS_16
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_16(pc),a4
	bsr	sMIX_SurroundLoop
	movem.l	(sp)+,d3/d5/d7/a4
	rts
.1:	movem.l	d7/a1/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	lea	GetCurrS_16(pc),a1
	lea	GetS_1_16(pc),a4
	bsr	sMIX_AvgSurround
	movem.l	(sp)+,d7/a1/a4
	rts

	cnop	0,4

sMIXb_Stereo16Sur:	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/d7/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	bsr	GetCurrS_16
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_16B(pc),a4
	bsr	sMIX_SurroundLoop
	movem.l	(sp)+,d3/d5/d7/a4
	rts
.1:	movem.l	d7/a1/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	lea	GetCurrS_16(pc),a1
	lea	GetS_1_16b(pc),a4
	bsr	sMIX_AvgSurround
	movem.l	(sp)+,d7/a1/a4
	rts

	cnop	0,4

sMIX_Stereo16:	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/d7/a4,-(sp)
	movem.l	d0/d2/d4/a2,-(sp)
	move.l	chi_Multiply_L(a5),d7
	bsr	GetCurrS_16
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_16(pc),a4
	bsr	sMIX_LeftLoop
	movem.l	(sp)+,d0/d2/d4/a2
	st	chi_MixRight(a5)
	move.l	chi_Multiply_R(a5),d7
	move.l	(a5),a6
	bsr	GetCurrS_16
	move.l	d1,chi_CurrSample_R(a5)
	bsr	sMIX_RightLoop
	clr.b	chi_MixRight(a5)
	movem.l	(sp)+,d3/d5/d7/a4
	rts
.1:	movem.l	d7/a1/a4,-(sp)
	lea	GetCurrS_16(pc),a1
	lea	GetS_1_16(pc),a4
	movem.l	d0/d2/d4/a2,-(sp)
	move.l	chi_Multiply_L(a5),d7
	bsr	sMIX_AvgLeft
	movem.l	(sp)+,d0/d2/d4/a2
	move.l	chi_Multiply_R(a5),d7
	bsr	sMIX_AvgRight
	movem.l	(sp)+,d7/a1/a4
	rts

	cnop	0,4

sMIXb_Stereo16:	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/d7/a4,-(sp)
	movem.l	d0/d2/d4/a2,-(sp)
	move.l	chi_Multiply_L(a5),d7
	bsr	GetCurrS_16
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_16B(pc),a4
	bsr	sMIX_LeftLoop
	movem.l	(sp)+,d0/d2/d4/a2
	st	chi_MixRight(a5)
	move.l	chi_Multiply_R(a5),d7
	move.l	(a5),a6
	bsr	GetCurrS_16
	move.l	d1,chi_CurrSample_R(a5)
	bsr	sMIX_RightLoop
	clr.b	chi_MixRight(a5)
	movem.l	(sp)+,d3/d5/d7/a4
	rts
.1:	movem.l	d7/a1/a4,-(sp)
	lea	GetCurrS_16(pc),a1
	lea	GetS_1_16b(pc),a4
	movem.l	d0/d2/d4/a2,-(sp)
	move.l	chi_Multiply_L(a5),d7
	bsr	sMIX_AvgLeft
	movem.l	(sp)+,d0/d2/d4/a2
	move.l	chi_Multiply_R(a5),d7
	bsr	sMIX_AvgRight
	movem.l	(sp)+,d7/a1/a4
	rts

	cnop	0,4

sMIX_StereoXL:	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/d7/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	bsr	GetCurrS_X
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_X(pc),a4
	bsr	sMIX_LeftLoop
	movem.l	(sp)+,d3/d5/d7/a4
	rts
.1:	movem.l	d7/a1/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	lea	GetCurrS_X(pc),a1
	lea	GetS_1_X(pc),a4
	bsr	sMIX_AvgLeft
	movem.l	(sp)+,d7/a1/a4
	rts

	cnop	0,4

sMIXb_StereoXL:	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/d7/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	bsr	GetCurrS_X
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_XB(pc),a4
	bsr	sMIX_LeftLoop
	movem.l	(sp)+,d3/d5/d7/a4
	rts
.1:	movem.l	d7/a1/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	lea	GetCurrS_X(pc),a1
	lea	GetS_1_Xb(pc),a4
	bsr	sMIX_AvgLeft
	movem.l	(sp)+,d7/a1/a4
	rts

	cnop	0,4

sMIX_StereoXR:	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/d7/a4,-(sp)
	move.l	chi_Multiply_R(a5),d7
	st	chi_MixRight(a5)
	bsr	GetCurrS_X
	move.l	d1,chi_CurrSample_R(a5)
	lea	GetNextSample_X(pc),a4
	bsr	sMIX_RightLoop
	clr.b	chi_MixRight(a5)
	movem.l	(sp)+,d3/d5/d7/a4
	rts
.1:	movem.l	d7/a1/a4,-(sp)
	move.l	chi_Multiply_R(a5),d7
	lea	GetCurrS_X(pc),a1
	lea	GetS_1_X(pc),a4
	bsr	sMIX_AvgRight
	movem.l	(sp)+,d7/a1/a4
	rts

	cnop	0,4

sMIXb_StereoXR:	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/d7/a4,-(sp)
	st	chi_MixRight(a5)
	move.l	chi_Multiply_R(a5),d7
	bsr	GetCurrS_X
	move.l	d1,chi_CurrSample_R(a5)
	lea	GetNextSample_XB(pc),a4
	bsr	sMIX_RightLoop
	clr.b	chi_MixRight(a5)
	movem.l	(sp)+,d3/d5/d7/a4
	rts
.1:	movem.l	d7/a1/a4,-(sp)
	move.l	chi_Multiply_R(a5),d7
	lea	GetCurrS_X(pc),a1
	lea	GetS_1_Xb(pc),a4
	bsr	sMIX_AvgRight
	movem.l	(sp)+,d7/a1/a4
	rts

	cnop	0,4

sMIX_StereoXC:	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/d7/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	bsr	GetCurrS_X
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_X(pc),a4
	bsr	sMIX_CenterLoop
	movem.l	(sp)+,d3/d5/d7/a4
	rts
.1:	movem.l	d7/a1/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	lea	GetCurrS_X(pc),a1
	lea	GetS_1_X(pc),a4
	bsr	sMIX_AvgCenter
	movem.l	(sp)+,d7/a1/a4
	rts

	cnop	0,4

sMIXb_StereoXC:	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/d7/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	bsr	GetCurrS_X
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_XB(pc),a4
	bsr	sMIX_CenterLoop
	movem.l	(sp)+,d3/d5/d7/a4
	rts
.1:	movem.l	d7/a1/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	lea	GetCurrS_X(pc),a1
	lea	GetS_1_Xb(pc),a4
	bsr	sMIX_AvgCenter
	movem.l	(sp)+,d7/a1/a4
	rts

	cnop	0,4

sMIX_StereoXSur:	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/d7/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	bsr	GetCurrS_X
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_X(pc),a4
	bsr	sMIX_SurroundLoop
	movem.l	(sp)+,d3/d5/d7/a4
	rts
.1:	movem.l	d7/a1/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	lea	GetCurrS_X(pc),a1
	lea	GetS_1_X(pc),a4
	bsr	sMIX_AvgSurround
	movem.l	(sp)+,d7/a1/a4
	rts

	cnop	0,4

sMIXb_StereoXSur:	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/d7/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	bsr	GetCurrS_X
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_XB(pc),a4
	bsr	sMIX_SurroundLoop
	movem.l	(sp)+,d3/d5/d7/a4
	rts
.1:	movem.l	d7/a1/a4,-(sp)
	move.l	chi_Multiply_L(a5),d7
	lea	GetCurrS_X(pc),a1
	lea	GetS_1_Xb(pc),a4
	bsr	sMIX_AvgSurround
	movem.l	(sp)+,d7/a1/a4
	rts

	cnop	0,4

sMIX_StereoX:	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/d7/a4,-(sp)
	movem.l	d0/d2/d4/a2,-(sp)
	move.l	chi_Multiply_L(a5),d7
	bsr	GetCurrS_X
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_X(pc),a4
	bsr	sMIX_LeftLoop
	movem.l	(sp)+,d0/d2/d4/a2
	st	chi_MixRight(a5)
	move.l	chi_Multiply_R(a5),d7
	move.l	(a5),a6
	bsr	GetCurrS_X
	move.l	d1,chi_CurrSample_R(a5)
	bsr	sMIX_RightLoop
	clr.b	chi_MixRight(a5)
	movem.l	(sp)+,d3/d5/d7/a4
	rts
.1:	movem.l	d7/a1/a4,-(sp)
	lea	GetCurrS_X(pc),a1
	lea	GetS_1_X(pc),a4
	movem.l	d0/d2/d4/a2,-(sp)
	move.l	chi_Multiply_L(a5),d7
	bsr	sMIX_AvgLeft
	movem.l	(sp)+,d0/d2/d4/a2
	move.l	chi_Multiply_R(a5),d7
	bsr	sMIX_AvgRight
	movem.l	(sp)+,d7/a1/a4
	rts

	cnop	0,4

sMIXb_StereoX:	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/d7/a4,-(sp)
	movem.l	d0/d2/d4/a2,-(sp)
	move.l	chi_Multiply_L(a5),d7
	bsr	GetCurrS_X
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_XB(pc),a4
	bsr	sMIX_LeftLoop
	movem.l	(sp)+,d0/d2/d4/a2
	st	chi_MixRight(a5)
	move.l	chi_Multiply_R(a5),d7
	move.l	(a5),a6
	bsr	GetCurrS_X
	move.l	d1,chi_CurrSample_R(a5)
	bsr	sMIX_RightLoop
	clr.b	chi_MixRight(a5)
	movem.l	(sp)+,d3/d5/d7/a4
	rts
.1:	movem.l	d7/a1/a4,-(sp)
	lea	GetCurrS_X(pc),a1
	lea	GetS_1_Xb(pc),a4
	movem.l	d0/d2/d4/a2,-(sp)
	move.l	chi_Multiply_L(a5),d7
	bsr	sMIX_AvgLeft
	movem.l	(sp)+,d0/d2/d4/a2
	move.l	chi_Multiply_R(a5),d7
	bsr	sMIX_AvgRight
	movem.l	(sp)+,d7/a1/a4
	rts

	cnop	0,4

sMIX_StereoX8L:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	bsr	GetCurrS_X8
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_X8(pc),a4
	bsr	sMIX_LeftLoop
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_X8(pc),a1
	lea	GetS_1_X8(pc),a4
	bsr	sMIX_AvgLeft
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIXb_StereoX8L:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	bsr	GetCurrS_X8
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_X8B(pc),a4
	bsr	sMIX_LeftLoop
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_X8(pc),a1
	lea	GetS_1_X8b(pc),a4
	bsr	sMIX_AvgLeft
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIX_StereoX8R:	move.l	(a5),a6
	move.l	chi_VolTable_R(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	st	chi_MixRight(a5)
	bsr	GetCurrS_X8
	move.l	d1,chi_CurrSample_R(a5)
	lea	GetNextSample_X8(pc),a4
	bsr	sMIX_RightLoop
	clr.b	chi_MixRight(a5)
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_X8(pc),a1
	lea	GetS_1_X8(pc),a4
	bsr	sMIX_AvgRight
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIXb_StereoX8R:	move.l	(a5),a6
	move.l	chi_VolTable_R(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	st	chi_MixRight(a5)
	bsr	GetCurrS_X8
	move.l	d1,chi_CurrSample_R(a5)
	lea	GetNextSample_X8B(pc),a4
	bsr	sMIX_RightLoop
	clr.b	chi_MixRight(a5)
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_X8(pc),a1
	lea	GetS_1_X8b(pc),a4
	bsr	sMIX_AvgRight
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIX_StereoX8C:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	bsr	GetCurrS_X8
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_X8(pc),a4
	bsr	sMIX_CenterLoop
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_X8(pc),a1
	lea	GetS_1_X8(pc),a4
	bsr	sMIX_AvgCenter
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIXb_StereoX8C:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	bsr	GetCurrS_X8
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_X8B(pc),a4
	bsr	sMIX_CenterLoop
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_X8(pc),a1
	lea	GetS_1_X8b(pc),a4
	bsr	sMIX_AvgCenter
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIX_StereoX8Sur:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	bsr	GetCurrS_X8
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_X8(pc),a4
	bsr	sMIX_SurroundLoop
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_X8(pc),a1
	lea	GetS_1_X8(pc),a4
	bsr	sMIX_AvgSurround
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIXb_StereoX8Sur:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a3
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	bsr	GetCurrS_X8
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_X8B(pc),a4
	bsr	sMIX_SurroundLoop
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_X8(pc),a1
	lea	GetS_1_X8b(pc),a4
	bsr	sMIX_AvgSurround
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIX_StereoX8:	move.l	chi_VolTable_L(a5),a3
	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	movem.l	d0/d2/d4/a2,-(sp)
	bsr	GetCurrS_X8
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_X8(pc),a4
	bsr	sMIX_LeftLoop
	movem.l	(sp)+,d0/d2/d4/a2
	st	chi_MixRight(a5)
	move.l	chi_VolTable_R(a5),a3
	move.l	(a5),a6
	bsr	GetCurrS_X8
	move.l	d1,chi_CurrSample_R(a5)
	bsr	sMIX_RightLoop
	clr.b	chi_MixRight(a5)
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_X8(pc),a1
	lea	GetS_1_X8(pc),a4
	movem.l	d0/d2/d4/a2,-(sp)
	bsr	sMIX_AvgLeft
	movem.l	(sp)+,d0/d2/d4/a2
	move.l	chi_VolTable_R(a5),a3
	bsr	sMIX_AvgRight
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIXb_StereoX8:	move.l	chi_VolTable_L(a5),a3
	move.l	(a5),a6
	subq.w	#1,d0
	tst.w	d5
	bne.s	.1
	movem.l	d3/d5/a4,-(sp)
	movem.l	d0/d2/d4/a2,-(sp)
	bsr	GetCurrS_8
	move.l	d1,chi_CurrSample(a5)
	lea	GetNextSample_X8B(pc),a4
	bsr.s	sMIX_LeftLoop
	movem.l	(sp)+,d0/d2/d4/a2
	st	chi_MixRight(a5)
	move.l	chi_VolTable_R(a5),a3
	move.l	(a5),a6
	bsr	GetCurrS_X8
	move.l	d1,chi_CurrSample_R(a5)
	bsr	sMIX_RightLoop
	clr.b	chi_MixRight(a5)
	movem.l	(sp)+,d3/d5/a4
	rts
.1:	movem.l	a1/a4,-(sp)
	lea	GetCurrS_X8(pc),a1
	lea	GetS_1_X8b(pc),a4
	movem.l	d0/d2/d4/a2,-(sp)
	bsr	sMIX_AvgLeft
	movem.l	(sp)+,d0/d2/d4/a2
	move.l	chi_VolTable_R(a5),a3
	bsr	sMIX_AvgRight
	movem.l	(sp)+,a1/a4
	rts

	cnop	0,4

sMIX_LeftLoop:	jsr	(a4)
.1:	move.l	chi_CurrSample(a5),d1
	move.l	chi_PrevSample(a5),d5
	sub.l	d1,d5
	neg.l	d5
	move.l	chi_NextSample(a5),d3
	sub.l	d1,d3
	sub.l	d5,d3
	asr.l	#2,d3
	lsr.w	#1,d4
	swap	d4
	muls.l	d4,d6:d3
	roxl.l	#1,d4
	asl.l	#2,d6
	add.l	d5,d6
	asr.l	#2,d6
	lsr.l	#1,d4
	muls.l	d4,d3:d6
	swap	d4
	roxl.w	#1,d4
	asl.l	#3,d3
	move.l	chi_PrevSample(a5),d5
	add.l	d5,d1
	asr.l	#1,d1
	add.l	d3,d1
	bvc.s	.2
	move.l	chi_CurrSample(a5),d1
.2:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a0,d4
	bcc.s	.4
	jsr	-4(a4)
	move.l	chi_CurrSample(a5),chi_PrevSample(a5)
	move.l	chi_NextSample(a5),chi_CurrSample(a5)
	jsr	(a4)
.4:	dbra	d0,.1
	rts

	cnop	0,4

sMIX_RightLoop:	jsr	(a4)
.1:	move.l	chi_CurrSample_R(a5),d1
	move.l	chi_PrevSample_R(a5),d5
	sub.l	d1,d5
	neg.l	d5
	move.l	chi_NextSample_R(a5),d3
	sub.l	d1,d3
	sub.l	d5,d3
	asr.l	#2,d3
	lsr.w	#1,d4
	swap	d4
	muls.l	d4,d6:d3
	roxl.l	#1,d4
	asl.l	#2,d6
	add.l	d5,d6
	asr.l	#2,d6
	lsr.l	#1,d4
	muls.l	d4,d3:d6
	swap	d4
	roxl.w	#1,d4
	asl.l	#3,d6
	move.l	chi_PrevSample_R(a5),d5
	add.l	d5,d1
	asr.l	#1,d1
	add.l	d3,d1
	bvc.s	.2
	move.l	chi_CurrSample_R(a5),d1
.2:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a0,d4
	bcc.s	.4
	jsr	-4(a4)
	move.l	chi_CurrSample_R(a5),chi_PrevSample_R(a5)
	move.l	chi_NextSample_R(a5),chi_CurrSample_R(a5)
	jsr	(a4)
.4:	dbra	d0,.1
	rts

	cnop	0,4

sMIX_CenterLoop:	jsr	(a4)
.1:	move.l	chi_CurrSample(a5),d1
	move.l	chi_PrevSample(a5),d5
	sub.l	d1,d5
	neg.l	d5
	move.l	chi_NextSample(a5),d3
	sub.l	d1,d3
	sub.l	d5,d3
	asr.l	#2,d3
	lsr.w	#1,d4
	swap	d4
	muls.l	d4,d6:d3
	roxl.l	#1,d4
	asl.l	#2,d6
	add.l	d5,d6
	asr.l	#2,d6
	lsr.l	#1,d4
	muls.l	d4,d3:d6
	swap	d4
	roxl.w	#1,d4
	asl.l	#3,d3
	move.l	chi_PrevSample(a5),d5
	add.l	d5,d1
	asr.l	#1,d1
	add.l	d3,d1
	bvc.s	.2
	move.l	chi_CurrSample(a5),d1
.2:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a0,d4
	bcc.s	.4
	jsr	-4(a4)
	move.l	chi_CurrSample(a5),chi_PrevSample(a5)
	move.l	chi_NextSample(a5),chi_CurrSample(a5)
	jsr	(a4)
.4:	dbra	d0,.1
	rts

	cnop	0,4

sMIX_SurroundLoop:	jsr	(a4)
.1:	move.l	chi_CurrSample(a5),d1
	move.l	chi_PrevSample(a5),d5
	sub.l	d1,d5
	neg.l	d5
	move.l	chi_NextSample(a5),d3
	sub.l	d1,d3
	sub.l	d5,d3
	asr.l	#2,d3
	lsr.w	#1,d4
	swap	d4
	muls.l	d4,d6:d3
	roxl.l	#1,d4
	asl.l	#2,d6
	add.l	d5,d6
	asr.l	#2,d6
	lsr.l	#1,d4
	muls.l	d4,d3:d6
	swap	d4
	roxl.w	#1,d4
	asl.l	#3,d3
	move.l	chi_PrevSample(a5),d5
	add.l	d5,d1
	asr.l	#1,d1
	add.l	d3,d1
	bvc.s	.2
	move.l	chi_CurrSample(a5),d1
.2:	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.w	a0,d4
	bcc.s	.4
	jsr	-4(a4)
	move.l	chi_CurrSample(a5),chi_PrevSample(a5)
	move.l	chi_NextSample(a5),chi_CurrSample(a5)
	jsr	(a4)
.4:	dbra	d0,.1
	rts

	cnop	0,4

sMIX_AvgLeft:	move.l	d3,-(sp)
.1:	move.l	d4,d3
	not.w	d3
	jsr	(a1)
	lsr.w	#1,d3
	swap	d3
	muls.l	d1,d6:d3
	move.l	d6,d3
	asr.l	#7,d3
	move.w	d5,-(sp)
	move.l	d4,d6
	not.w	d6
	lsr.w	#8,d6
	add.l	-4(a4),d2
	subq.w	#2,d5
	bmi.s	.2
.3:	jsr	(a4)
	add.l	-4(a4),d2
	asr.l	#8,d1
	add.l	d1,d3
	dbra	d5,.3
.2:	add.w	a0,d4
	bcc.s	.4
	jsr	(a4)
	add.l	-4(a4),d2
	asr.l	#8,d1
	add.l	d1,d3
.4:	jsr	4(a4)
	move.l	d4,d5
	lsr.w	#8,d5
	add.w	d5,d6
	move.w	d4,d5
	lsr.w	#1,d5
	swap	d5
	muls.l	d5,d5:d1
	move.l	d5,d1
	asr.l	#7,d1
	add.l	d1,d3
	swap	d3
	move.w	d3,d5
	ext.l	d5
	clr.w	d3
	divs.l	d6,d5:d3
	move.w	(sp)+,d5
	add.l	d3,(a2)
	addq.l	#8,a2
	dbra	d0,.1
	move.l	(sp)+,d3
	rts

	cnop	0,4

sMIX_AvgRight:	move.l	d3,-(sp)
.1:	move.l	d4,d3
	not.w	d3
	jsr	(a1)
	lsr.w	#1,d3
	swap	d3
	muls.l	d1,d6:d3
	move.l	d6,d3
	asr.l	#7,d3
	move.w	d5,-(sp)
	move.l	d4,d6
	not.w	d6
	lsr.w	#8,d6
	add.l	-4(a4),d2
	subq.w	#2,d5
	bmi.s	.2
.3:	jsr	(a4)
	add.l	-4(a4),d2
	asr.l	#8,d1
	add.l	d1,d3
	dbra	d5,.3
.2:	add.w	a0,d4
	bcc.s	.4
	jsr	(a4)
	add.l	-4(a4),d2
	asr.l	#8,d1
	add.l	d1,d3
.4:	jsr	4(a4)
	move.l	d4,d5
	lsr.w	#8,d5
	add.w	d5,d6
	move.w	d4,d5
	lsr.w	#1,d5
	swap	d5
	muls.l	d5,d5:d1
	move.l	d5,d1
	asr.l	#7,d1
	add.l	d1,d3
	swap	d3
	move.w	d3,d5
	ext.l	d5
	clr.w	d3
	divs.l	d6,d5:d3
	move.w	(sp)+,d5
	addq.l	#4,a2
	add.l	d3,(a2)+
	dbra	d0,.1
	move.l	(sp)+,d3
	rts

	cnop	0,4

sMIX_AvgCenter:	move.l	d3,-(sp)
.1:	move.l	d4,d3
	not.w	d3
	jsr	(a1)
	lsr.w	#1,d3
	swap	d3
	muls.l	d1,d6:d3
	move.l	d6,d3
	asr.l	#7,d3
	move.w	d5,-(sp)
	move.l	d4,d6
	not.w	d6
	lsr.w	#8,d6
	add.l	-4(a4),d2
	subq.w	#2,d5
	bmi.s	.2
.3:	jsr	(a4)
	add.l	-4(a4),d2
	asr.l	#8,d1
	add.l	d1,d3
	dbra	d5,.3
.2:	add.w	a0,d4
	bcc.s	.4
	jsr	(a4)
	add.l	-4(a4),d2
	asr.l	#8,d1
	add.l	d1,d3
.4:	jsr	4(a4)
	move.l	d4,d5
	lsr.w	#8,d5
	add.w	d5,d6
	move.w	d4,d5
	lsr.w	#1,d5
	swap	d5
	muls.l	d5,d5:d1
	move.l	d5,d1
	asr.l	#7,d1
	add.l	d1,d3
	swap	d3
	move.w	d3,d5
	ext.l	d5
	clr.w	d3
	divs.l	d6,d5:d3
	move.w	(sp)+,d5
	add.l	d3,(a2)+
	add.l	d3,(a2)+
	dbra	d0,.1
	move.l	(sp)+,d3
	rts

	cnop	0,4

sMIX_AvgSurround:	move.l	d3,-(sp)
.1:	move.l	d4,d3
	not.w	d3
	jsr	(a1)
	lsr.w	#1,d3
	swap	d3
	muls.l	d1,d6:d3
	move.l	d6,d3
	asr.l	#7,d3
	move.w	d5,-(sp)
	move.l	d4,d6
	not.w	d6
	lsr.w	#8,d6
	add.l	-4(a4),d2
	subq.w	#2,d5
	bmi.s	.2
.3:	jsr	(a4)
	add.l	-4(a4),d2
	asr.l	#8,d1
	add.l	d1,d3
	dbra	d5,.3
.2:	add.w	a0,d4
	bcc.s	.4
	jsr	(a4)
	add.l	-4(a4),d2
	asr.l	#8,d1
	add.l	d1,d3
.4:	jsr	4(a4)
	move.l	d4,d5
	lsr.w	#8,d5
	add.w	d5,d6
	move.w	d4,d5
	lsr.w	#1,d5
	swap	d5
	muls.l	d5,d5:d1
	move.l	d5,d1
	asr.l	#7,d1
	add.l	d1,d3
	swap	d3
	move.w	d3,d5
	ext.l	d5
	clr.w	d3
	divs.l	d6,d5:d3
	move.w	(sp)+,d5
	add.l	d3,(a2)+
	not.l	d3
	add.l	d3,(a2)+
	dbra	d0,.1
	move.l	(sp)+,d3
	rts

	cnop	0,4

mstv_Stereo8:	move.l	d2,-(sp)
	move.w	#255,d2
	sub.w	d1,d2
	mulu.w	mas_LeftVolume(a5),d2
	mulu.w	d0,d2
	lsr.l	#8,d2
	clr.b	d2
	add.l	d2,d2
	add.l	d2,d2
	move.l	hqmas_VolTable(a5),a0
	add.l	a0,d2
	move.l	d2,chi_VolTable_L(a1)
	mulu.w	mas_RightVolume(a5),d1
	mulu.w	d0,d1
	lsr.l	#8,d1
	clr.b	d1
	add.l	d1,d1
	add.l	d1,d1
	add.l	d1,a0
	move.l	a0,chi_VolTable_R(a1)
	move.l	(sp)+,d2
mstv_Skip:	rts

	cnop	0,4

mstv_Stereo8L:	mulu.w	mas_LeftVolume(a5),d0
	clr.b	d0
	move.l	hqmas_VolTable(a5),a0
	add.l	d0,d0
	add.l	d0,d0
	add.l	d0,a0
	move.l	a0,chi_VolTable_L(a1)
	rts

	cnop	0,4

mstv_Stereo8R:	mulu.w	mas_RightVolume(a5),d0
	clr.b	d0
	move.l	hqmas_VolTable(a5),a0
	add.l	d0,d0
	add.l	d0,d0
	add.l	d0,a0
	move.l	a0,chi_VolTable_R(a1)
	rts

	cnop	0,4

mstv_Stereo8C:	mulu.w	mas_LeftVolume(a5),d0
	lsr.w	#1,d0
	clr.b	d0
	move.l	hqmas_VolTable(a5),a0
	add.l	d0,d0
	add.l	d0,d0
	add.l	d0,a0
	move.l	a0,chi_VolTable_L(a1)
	rts

	cnop	0,4

mstv_Stereo16:	movem.l	d2-d3,-(sp)
	move.w	#255,d3
	sub.w	d1,d3
	mulu.w	mas_LeftVolume(a5),d3
	mulu.w	d0,d3
	clr.w	d3
	swap	d3
	mulu.l	hqmas_Amplify(a5),d3
	move.l	d3,chi_Multiply_L(a1)
	mulu.w	mas_RightVolume(a5),d1
	mulu.w	d0,d1
	clr.w	d1
	swap	d1
	mulu.l	hqmas_Amplify(a5),d1
	move.l	d1,chi_Multiply_R(a1)
	moveq	#0,d1
	move.w	hqmas_Channels(a5),d1
	lsl.l	#8,d1
	move.l	d1,chi_Divider(a1)
	movem.l	(sp)+,d2-d3
	rts

	cnop	0,4

mstv_Stereo16L:	mulu.w	mas_LeftVolume(a5),d0
	lsr.w	#8,d0
	mulu.l	hqmas_Amplify(a5),d0
	move.l	d0,chi_Multiply_L(a1)
	move.w	hqmas_Channels(a5),d1
	lsl.l	#8,d1
	move.l	d1,chi_Divider(a1)
	rts

	cnop	0,4

mstv_Stereo16R:	mulu.w	mas_RightVolume(a5),d0
	lsr.w	#8,d0
	mulu.l	hqmas_Amplify(a5),d0
	move.l	d0,chi_Multiply_R(a1)
	move.w	hqmas_Channels(a5),d1
	lsl.l	#8,d1
	move.l	d1,chi_Divider(a1)
	rts

	cnop	0,4

mstv_Stereo16C:	mulu.w	mas_LeftVolume(a5),d0
	moveq	#9,d1
	lsr.w	d1,d0
	mulu.l	hqmas_Amplify(a5),d0
	move.l	d0,chi_Multiply_L(a1)
	move.w	hqmas_Channels(a5),d1
	lsl.l	#8,d1
	move.l	d1,chi_Divider(a1)
	rts

	cnop	0,4
Mixr_Skip:	dc.l	mstv_Skip,mstv_Skip,Skip,Skip,Skip,Skipb,Skipb,Skipb
Mixr_Mono:	dc.l	mstv_Stereo8C,mstv_Stereo16C,sMIX_Mono8,sMIX_Mono16,sMIX_MonoX,sMIXb_Mono8,sMIXb_Mono16,sMIXb_MonoX
Mixr_Stereo:	dc.l	mstv_Stereo8,mstv_Stereo16,sMIX_Stereo8,sMIX_Stereo16,sMIX_StereoX,sMIXb_Stereo8,sMIXb_Stereo16,sMIXb_StereoX
Mixr_StereoL:	dc.l	mstv_Stereo8L,mstv_Stereo16L,sMIX_Stereo8L,sMIX_Stereo16L,sMIX_StereoXL,sMIXb_Stereo8L,sMIXb_Stereo16L,sMIXb_StereoXL
Mixr_StereoR:	dc.l	mstv_Stereo8R,mstv_Stereo16R,sMIX_Stereo8R,sMIX_Stereo16R,sMIX_StereoXR,sMIXb_Stereo8R,sMIXb_Stereo16R,sMIXb_StereoXR
Mixr_StereoC:	dc.l	mstv_Stereo8C,mstv_Stereo16C,sMIX_Stereo8C,sMIX_Stereo16C,sMIX_StereoXC,sMIXb_Stereo8C,sMIXb_Stereo16C,sMIXb_StereoXC
Mixr_StereoSur:	dc.l	mstv_Stereo8C,mstv_Stereo16C,sMIX_Stereo8Sur,sMIX_Stereo16Sur,sMIX_StereoXSur,sMIXb_Stereo8Sur,sMIXb_Stereo16Sur,sMIXb_StereoXSur
Mixr_Skip168:	dc.l	mstv_Skip,mstv_Skip,Skip,Skip,Skip,Skipb,Skipb,Skipb
Mixr_Mono168:	dc.l	mstv_Stereo8L,mstv_Stereo8L,sMIX_Mono8,sMIX_Mono168,sMIX_MonoX8,sMIXb_Mono8,sMIXb_Mono168,sMIXb_MonoX8
Mixr_Stereo168:	dc.l	mstv_Stereo8,mstv_Stereo8,sMIX_Stereo8,sMIX_Stereo168,sMIX_StereoX8,sMIXb_Stereo8,sMIXb_Stereo168,sMIXb_StereoX8
Mixr_StereoL168:	dc.l	mstv_Stereo8L,mstv_Stereo8L,sMIX_Stereo8L,sMIX_Stereo168L,sMIX_StereoX8L,sMIXb_Stereo8L,sMIXb_Stereo168L,sMIXb_StereoX8L
Mixr_StereoR168:	dc.l	mstv_Stereo8R,mstv_Stereo8R,sMIX_Stereo8R,sMIX_Stereo168R,sMIX_StereoX8R,sMIXb_Stereo8R,sMIXb_Stereo168R,sMIXb_StereoX8R
Mixr_StereoC168:	dc.l	mstv_Stereo8C,mstv_Stereo8C,sMIX_Stereo8C,sMIX_Stereo168C,sMIX_StereoX8C,sMIXb_Stereo8C,sMIXb_Stereo168C,sMIXb_StereoX8C
Mixr_StereoSur168:	dc.l	mstv_Stereo8C,mstv_Stereo8C,sMIX_Stereo8Sur,sMIX_Stereo168Sur,sMIX_StereoX8Sur,sMIXb_Stereo8Sur,sMIXb_Stereo168Sur,sMIXb_StereoX8Sur

ExtMixerLibBase:	dc.l	0

SaveFlags:	dc.w	2
	dc.w	SaveFlagSize
	dc.l	SaveText0
	dc.b	EXTFLAG_BOOLEAN
	dc.b	TEFSF_Update
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	SaveText1
	dc.b	EXTFLAG_BOOLEAN
	dc.b	TEFSF_Update
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
SaveText0:	dc.b	'True 16-bit mixing',0
SaveText1:	dc.b	'Stereo mixing',0
SaveFlagSize:	equ	*-SaveFlags
LoadDescript:	dc.b	'High Quality Mixer',0

	STRUCTURE	InternalHQMixAlloc,mas_SIZEOF
	APTR	hqmas_MixBuffer
	ULONG	hqmas_BuffSize
	ULONG	hqmas_MixBufSize
	APTR	hqmas_VolTable
	APTR	hqmas_ChInfo
	ULONG	hqmas_Amplify
	ULONG	hqmas_MixRate
	ULONG	hqmas_MixFract
	ULONG	hqmas_CurrLeft
	ULONG	hqmas_CurrLeftFrac
	ULONG	hqmas_PassLength
	ULONG	hqmas_PassFrac
	UWORD	hqmas_Channels
	UWORD	hqmas_Real16Bit
	UBYTE	hqmas_Stereo
	UBYTE	hqmas_PrevStereo
	LABEL	hqmas_SIZEOF

	rsset	0
chi_SampleStartAdr:	rs.l	1
chi_SampleLen:	rs.l	1
chi_MixRegs:	rs.l	0
chi_Offset:	rs.l	1
chi_Fraction:	rs.l	1
chi_Advance:	rs.l	1
chi_AdvFract:	rs.l	1
chi_MixRoutine:	rs.l	1
chi_EndOffset:	rs.l	1
chi_RestartOffset:	rs.l	1
chi_Repeat:	rs.l	1
chi_RepLen:	rs.l	1
chi_CountRestart:	rs.l	1
chi_Counted:	rs.l	1
chi_SampleRate:	rs.l	1
chi_RealAdv:	rs.l	1
chi_VolTable_L:	rs.l	1
chi_VolTable_R:	rs.l	1
chi_Multiply_L:	rs.l	1
chi_Divider:	rs.l	1
chi_Multiply_R:	rs.l	1
chi_AltMixRoutine:	rs.l	1
chi_BitDepth:	rs.b	1
chi_Flags:	rs.b	1
chi_Volume:	rs.b	1
chi_Panning:	rs.b	1
chi_NewSampleStartAdr:	rs.l	1
chi_NewSampleLen:	rs.l	1
chi_NewOffset:	rs.l	1
chi_NewFraction:	rs.l	1
chi_NewAdvance:	rs.l	1
chi_NewAdvFract:	rs.l	1
chi_NewMixRoutine:	rs.l	1
chi_NewEndOffset:	rs.l	1
chi_NewRestartOffset:	rs.l	1
chi_NewRepeat:	rs.l	1
chi_NewRepLen:	rs.l	1
chi_NewCountRestart:	rs.l	1
chi_NewCounted:	rs.l	1
chi_NewSampleRate:	rs.l	1
chi_NewRealAdv:	rs.l	1
chi_NewVolTable_L:	rs.l	1
chi_NewVolTable_R:	rs.l	1
chi_NewMultiply_L:	rs.l	1
chi_NewDivider:	rs.l	1
chi_NewMultiply_R:	rs.l	1
chi_NewAltMixRoutine:	rs.l	1
chi_NewBitDepth:	rs.b	1
chi_NewFlags:	rs.b	1
chi_NewVolume:	rs.b	1
chi_NewPanning:	rs.b	1
chi_PrevSample:	rs.l	1
chi_CurrSample:	rs.l	1
chi_NextSample:	rs.l	1
chi_PrevSample_R:	rs.l	1
chi_CurrSample_R:	rs.l	1
chi_NextSample_R:	rs.l	1
chi_MixRight:	rs.l	1
chi_SIZEOF:	rs.l	0
