*******************************************************
*** TuComposer External Mixer Library support v31.0 ***
***       1996-97 by The united Coders (TuC)       ***
***               Main code: Basty/TuC              ***
***     This is the header file for coding your     ***
***             external mixing devices             ***
*******************************************************

	include	"exec/types.i"
	include	"exec/execbase.i"
	include	"exec/exec_lib.i"
	include	"exec/initializers.i"
	include	"exec/resident.i"
	include	"exec/libraries.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/external/external.i"
	include	"tucomposer/external/external_lib.i"
	include	"tucomposer/external/mixer.i"
	include	"tucomposer/external/mixer_lib.i"

	moveq	#-1,d0
	rts
ResidentStruct:	dc.w	RTC_MATCHWORD
	dc.l	ResidentStruct
	dc.l	0
	dc.b	RTF_AUTOINIT
	dc.b	EXTLIB_MIXER_VERSION
	dc.b	NT_LIBRARY
	dc.b	0						; If ya mixer has a nice quality and
									; is VERY FAST you should set the
									; priority somewhat high.
	dc.l	LibName
	dc.l	LibID
	dc.l	Init
LibName:	dc.b	'lqmix.library',0	; Just a example
LibID:	dc.b	'TuComposer External Low Quality Mixer Version 1.00 (v31) (68020+, OS2.0+) (22 Mar 97) by Basty/TuC.',0	; Another example.
TuComposerName:	dc.b	'tucomposer.library',0
	even
Init:	dc.l	mix_SIZEOF
	dc.l	FuncTab
	dc.l	DataTab
	dc.l	PrepareLibrary

FuncTab:	dc.w	-1
	dc.w	Open-FuncTab
	dc.w	Close-FuncTab
	dc.w	Expunge-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalInitialize-FuncTab
	dc.w	ExternalUpdateFlags-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalMixerAlloc-FuncTab
	dc.w	ExternalMixerFree-FuncTab
	dc.w	ExternalMixerInit-FuncTab
	dc.w	ExternalMixerChangeRate-FuncTab
	dc.w	ExternalMixerChangeTempo-FuncTab
	dc.w	ExternalMixerChangeVolTable-FuncTab
	dc.w	ExternalMixerGetChannel-FuncTab
	dc.w	ExternalMixerSetChannel-FuncTab
	dc.w	ExternalMixerSetChannelVolPanPitch-FuncTab
	dc.w	ExternalMixerSetChannelPosRepFlags-FuncTab
	dc.w	ExternalMixerDoMix-FuncTab
	dc.w	-1

DataTab:	INITLONG	LN_NAME,LibName
	INITBYTE	LIB_FLAGS,LIBF_CHANGED|LIBF_SUMUSED
	INITWORD	LIB_VERSION,EXTLIB_MIXER_VERSION
	INITWORD	LIB_REVISION,EXTLIB_REVISION
	INITLONG	LIB_IDSTRING,LibID
	INITBYTE	mix_Flags,MIF_StereoSupport|MIF_Surround	; Mixer supports
										; stereo and surround sound
	INITLONG	mix_DefaultMixRate,15000	; Default mixing rate is 15.0 kHz
										; (all examples here !)
	INITLONG	mix_DefaultBufSize,256	; Use a 256 byte mixing buffer
	INITLONG	mix_DefaultBoost,65536	; Default volume boost 100%
	INITLONG	mix_MinMixRate,1000		; Lowest mix frequency is 1 kHz
	INITLONG	mix_MaxMixRate,256000	; Highest mix rate is 256 kHz
	INITLONG	mix_MinBufSize,16		; Smallest buffer size is 16 bytes
	INITLONG	mix_MaxBufSize,32768	; Biggest buffer size is 32 KB
	dc.l	0

PrepareLibrary:	btst	#AFB_68020,AttnFlags+1(a6)	; If you want to make a
													; 68020+ version only.
	beq.s	ExtLib			; Just because there's always a moveq #0,d0:rts
	cmp.w	#37,LIB_VERSION(a6)	; If your library requires OS2.04+
	blt.s	ExtLib
	move.l	a2,-(sp)
	move.l	d0,a2
	move.l	a0,extb_SegList(a2)
	moveq	#31,d0				; TuComposer library required by loader
	lea	TuComposerName(pc),a1	; APTR to tucomposer.library name
	jsr	_LVOOpenLibrary(a6)		; Open tucomposer.library
	move.l	d0,extb_TuComposerBase(a2)	; Save base
	beq.s	NoTuCLib			; Open failed ?
	lea	ExtMixerLibBase(pc),a0	; Get library base for C functions
	move.l	a2,(a0)				; Store the library base
	move.l	a2,d0
;	...							; Make your initialization stuff here.
NoTuCLib:	move.l	(sp)+,a2
	rts
Open:	addq.w	#1,LIB_OPENCNT(a6)
	move.l	a6,d0
	rts
Close:	subq.w	#1,LIB_OPENCNT(a6)
	bne.s	ExtLib
	btst	#LIBB_DELEXP,LIB_FLAGS(a6)
	bne.s	Expunge
ExtLib:	moveq	#0,d0
	rts
Expunge:	bset	#LIBB_DELEXP,LIB_FLAGS(a6)
	tst.w	LIB_OPENCNT(a6)
	bne.s	ExtLib
	movem.l	d2/a5-a6,-(sp)
	move.l	extb_ExtLibList(a6),d0	; THIS MUST ALWAYS BE DONE -----|
	beq.s	NoExtLibList	;										|
	move.l	d0,a0	;												|
	clr.l	extl_LibBase(a0)	;									|
NoExtLibList:	move.l	extb_TuComposerBase(a6),a1	;				|
	move.l	a6,a5	;												|
	move.l	4.w,a6	;												|
	jsr	_LVOCloseLibrary(a6)	;-----------------------------------|
	move.l	extb_SegList(a5),d2
	move.l	a5,a1
	jsr	_LVORemove(a6)
	move.l	a5,a1
	moveq	#0,d0
	moveq	#0,d1
	move.w	LIB_NEGSIZE(a5),d1
	sub.l	d1,a1
	move.w	LIB_POSSIZE(a5),d0
	add.l	d1,d0
	jsr	_LVOFreeMem(a6)
	move.l	d2,d0
	movem.l	(sp)+,d2/a5-a6
	rts
;	INPUT
;	A0.L	=	APTR to track external list structure to be initialized
;	OUTPUT
;	D0.L	=	What type of external library is it or NULL if error
ExternalInitialize:	move.l	extb_TuComposerBase(a6),a1
	movem.l	a2/a6,-(sp)
	move.l	a0,d0						; Just for case
	beq.s	ExternalInitDone			; Do not init and return NULL
	move.l	a1,a6
	move.b	#EXTLF_Saver,extl_Flags(a0)	; Saver only (or how a mixer can
	move.l	a0,a2						; do loading ???)
	lea	extl_Descriptor(a0),a0			; Put descriptor ID into the
	lea	LoadDescript(pc),a1				; external library list structure
	jsr	_LVOSetString(a6)				; Allocate new string buffer. YOU
										; MUST DO THAT IN THIS WAY !!!!!!
	tst.l	d0							; Check if successful
	beq.s	ExternalInitDone
	lea	SaveFlags(pc),a0				; Following only if saving flags
	jsr	_LVOAllocFlagStr(a6)			; Now allocate save flag structures
	move.l	d0,extl_SaveFlagStr(a2)		; Store to the flag save structures
	beq.s	ExternalInitDone
;	Additional initializations are done here like priority. Use:
;	move.b	#-10,extl_Pri(a2)
;	to set the priority to -10.
	moveq	#EXTTYPE_MIXER,d0
ExternalInitDone:	movem.l	(sp)+,a2/a6
	rts
;	INPUT
;	A0.L	=	APTR to flag pass structure which was updated
;	D0.L	=	Type of flag pass structure (NULL = load, $00000001 = save)
;	D1.L	=	Flag number which was updated
;	OUTPUT
;	D0.L	=	NULL if changes were accepted, else APTR to text string why
;				not accepted (i.e. hardware not found)

	cnop	0,4

ExternalUpdateFlags:	
	rts
;	NO INPUTS
;	OUTPUT
;	D0.L	=	APTR to mixer alloc structure or NULL on error
ExternalMixerAlloc:	
	rts
;	INPUT
;	A0.L	=	APTR to mixer alloc structure as got by ExternalMixerAlloc()
;	NO OUTPUT
ExternalMixerFree:	
	rts
;	INPUT
;	A0.L	=	APTR to mixer alloc structure as got by ExternalMixerAlloc()
;	A1.L	=	APTR to sound device structure
;	A2.L	=	APTR to saving flag pass structure (Mixer specific)
;	OUTPUT
;	D0.L	=	NULL if changes accepted else one of the error codes
ExternalMixerInit:	
	rts
;	INPUT
;	A0.L	=	APTR to mixer alloc structure as got by ExternalMixerAlloc()
;	D0.L	=	New mixing rate in Hz to be used
;	OUTPUT
;	D0.L	=	NULL if changes accepted else any non-zero value

	cnop	0,4

ExternalMixerChangeRate:	
	rts
;	INPUT
;	A0.L	=	APTR to mixer alloc structure as got by ExternalMixerAlloc()
;	D0.L	=	New tempo value to be used (for BpM use 65536*RpB*BpM)
;	OUTPUT
;	D0.L	=	NULL if changes accepted else any non-zero value

	cnop	0,4

ExternalMixerChangeTempo:	
	rts
;	INPUT
;	A0.L	=	APTR to mixer alloc structure as got by ExternalMixerAlloc()
;	D0.L	=	New volume boost to be used
;	D1.L	=	New left volume to be used
;	D2.L	=	New right volume to be used
;	D3.L	=	New number of channels to be used
;	OUTPUT
;	D0.L	=	NULL if changes accepted else any non-zero value

ExternalMixerChangeVolTable:	
	rts
;	INPUT
;	A0.L	=	APTR to mixer structure where to get channel from
;	A1.L	=	APTR to mixer alloc structure as got by ExternalMixerAlloc()
;	D0.L	=	Number of channel to get
;	NO OUTPUT

	cnop	0,4

ExternalMixerGetChannel:	
	rts
;	INPUT
;	A0.L	=	APTR to mixer structure where to set channel
;	A1.L	=	APTR to mixer alloc structure as got by ExternalMixerAlloc()
;	D0.L	=	Number of channel to set
;	OUTPUT
;	D0.L	=	FALSE if settings accepted else any other non-zero value

	cnop	0,4

ExternalMixerSetChannel:	
	rts
;	INPUT
;	A0.L	=	APTR to mixer structure where to set channel
;	A1.L	=	APTR to mixer alloc structure as got by ExternalMixerAlloc()
;	D0.L	=	Number of channel to set
;	OUTPUT
;	D0.L	=	FALSE if settings accepted else any other non-zero value

	cnop	0,4

ExternalMixerSetChannelVolPanPitch:	
	rts
;	INPUT
;	A0.L	=	APTR to mixer structure where to set channel
;	A1.L	=	APTR to mixer alloc structure as got by ExternalMixerAlloc()
;	D0.L	=	Number of channel to set
;	OUTPUT
;	D0.L	=	FALSE if settings accepted else any other non-zero value

	cnop	0,4

ExternalMixerSetChannelPosRepFlags:	
	rts
;	INPUT
;	A0.L	=	APTR to mixer alloc structure as got by ExternalMixerAlloc()
;	A2.L	=	APTR to mixing buffer (this routine must be called from
;				your interrupt handler (it does the actual mixing))
;	NO OUTPUTS

	cnop	0,4

ExternalMixerDoMix:	
	rts

	cnop	0,4

ExtMixerLibBase:	dc.l	0

SaveFlags:	dc.w	3					; 3 save flags (again example)
	dc.w	SaveFlagSize				; Size of save flag structure
	dc.l	SaveText0
	dc.b	EXTFLAG_BOOLEAN
	dc.b	TEFSF_Update				; We want to be noticed when updated
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1							; Do 16 bit mixing by default
	dc.l	0
	dc.l	SaveText1
	dc.b	EXTFLAG_BOOLEAN
	dc.b	TEFSF_Update				; Of course, stereo switch also
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1							; Stereo output also by default
	dc.l	0
	dc.l	SaveButton2					; APTR to Button array
	dc.b	EXTFLAG_BUTTON				; Now we have a button type flag
	dc.b	TEFSF_Update				; Yes, here also
	dc.w	1+4							; 4 buttons (and one heading text)
	dc.l	0
	dc.l	0
	dc.l	1							; We don't have interpolation by
										; default
	dc.l	0
SaveButton2:	dc.l	SaveText2		; Heading text
	dc.l	SaveText21					; Text for 1st button
	dc.l	SaveText22					; Text for 2nd button
	dc.l	SaveText23					; Text for 3rd button
	dc.l	SaveText24					; Text for 4th button
SaveText0:	dc.b	'True 16-bit mixing',0	; Flag #0 is for enable true 16
										; bit mixing (text is displayed by
										; the apps)
SaveText1:	dc.b	'Stereo output',0	; Bit #1 is for stereo
SaveText2:	dc.b	'Interpolation',0	; Bit #2 is enable interpolation
SaveText21:	dc.b	'Disabled',0		; Button #1 says, disabled inter-
										; polation
SaveText22:	dc.b	'Fast',0			; Button #2 says fast interpolation
SaveText23:	dc.b	'Effective',0		; Button #3 says effective inter-
										; polation (nice examples, eh?)
SaveText24:	dc.b	'Full',0			; Button #4 says best interpolation
SaveFlagSize:	equ	*-SaveFlags			; Calculate size of save structure
LoadDescript:	dc.b	'Low Quality Mixer',0	; Just a example
