********************************************************
*** TuComposer External Module Library support v31.0 ***
***           1997 by The united Coders (TuC)       ***
***                 Main code: Basty/TuC             ***
***     This is the header file for coding your      ***
***      external module (not songs !) loaders       ***
********************************************************

	include	"exec/types.i"
	include	"exec/execbase.i"
	include	"exec/exec_lib.i"
	include	"exec/initializers.i"
	include	"exec/resident.i"
	include	"exec/libraries.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/external/external.i"
	include	"tucomposer/external/external_lib.i"
	include	"tucomposer/external/module.i"
	include	"tucomposer/external/module_lib.i"
	moveq	#-1,d0
	rts
ResidentStruct:	dc.w	RTC_MATCHWORD
	dc.l	ResidentStruct
	dc.l	0
	dc.b	RTF_AUTOINIT
	dc.b	EXTLIB_MODULE_VERSION
	dc.b	NT_LIBRARY
	dc.b	0						; If ya loader handles all 100%,
									; enter a value high here, lower it as
									; less effects are handled by your
									; loader. Higher priority libraries are
									; handled first by the loader. Also lower
									; this if detection can't be done 100%
									; safely.
	dc.l	LibName
	dc.l	LibID
	dc.l	Init
LibName:	dc.b	'tcm.library',0	; Just a example
LibID:	dc.b	'TuComposer External Module Loader Version 1.00 (v31) for TCM (68020+, OS2.0+) (12 Mar 97) by Basty/TuC.',0	; Another example.
TuComposerName:	dc.b	'tucomposer.library',0
	even
Init:	dc.l	modl_SIZEOF
	dc.l	FuncTab
	dc.l	DataTab
	dc.l	PrepareLibrary

FuncTab:	dc.w	-1
	dc.w	Open-FuncTab
	dc.w	Close-FuncTab
	dc.w	Expunge-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalInitialize-FuncTab
	dc.w	ExternalUpdateFlags-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalModuleIdentify-FuncTab
	dc.w	ExternalModuleLoad-FuncTab
	dc.w	ExternalModuleSave-FuncTab
	dc.w	ExternalModuleGetInfo-FuncTab
	dc.w	ExternalModuleGetNums-FuncTab
	dc.w	-1

DataTab:	INITLONG	LN_NAME,LibName
	INITBYTE	LIB_FLAGS,LIBF_CHANGED|LIBF_SUMUSED
	INITWORD	LIB_VERSION,EXTLIB_MODULE_VERSION
	INITWORD	LIB_REVISION,EXTLIB_REVISION
	INITLONG	LIB_IDSTRING,LibID
	dc.l	0

PrepareLibrary:	btst	#AFB_68020,AttnFlags+1(a6)	; If you want to make a
													; 68020+ version only.
	beq.s	ExtLib			; Just because there's always a moveq #0,d0:rts
	cmp.w	#37,LIB_VERSION(a6)	; If your library requires OS2.04+
	blt.s	ExtLib
	move.l	a2,-(sp)
	move.l	d0,a2
	move.l	a0,extb_SegList(a2)
	moveq	#31,d0				; TuComposer library required by loader
	lea	TuComposerName(pc),a1	; APTR to tucomposer.library name
	jsr	_LVOOpenLibrary(a6)		; Open tucomposer.library
	move.l	d0,extb_TuComposerBase(a2)	; Save base
	beq.s	NoTuCLib			; Open failed ?
	lea	ExtModuleLibBase(pc),a0	; Get library base for C functions
	move.l	a2,(a0)				; Store the library base
	move.l	a2,d0
;	...							; Make your initialization stuff here.
NoTuCLib:	move.l	(sp)+,a2
	rts
Open:	addq.w	#1,LIB_OPENCNT(a6)
	move.l	a6,d0
	rts
Close:	subq.w	#1,LIB_OPENCNT(a6)
	bne.s	ExtLib
	btst	#LIBB_DELEXP,LIB_FLAGS(a6)
	bne.s	Expunge
ExtLib:	moveq	#0,d0
	rts
Expunge:	bset	#LIBB_DELEXP,LIB_FLAGS(a6)
	tst.w	LIB_OPENCNT(a6)
	bne.s	ExtLib
	movem.l	d2/a5-a6,-(sp)
	move.l	extb_ExtLibList(a6),d0	; THIS MUST ALWAYS BE DONE -----|
	beq.s	NoExtLibList	;										|
	move.l	d0,a0	;												|
	clr.l	extl_LibBase(a0)	;									|
NoExtLibList:	move.l	extb_TuComposerBase(a6),a1	;				|
	move.l	a6,a5	;												|
	move.l	4.w,a6	;												|
	jsr	_LVOCloseLibrary(a6)	;-----------------------------------|
	move.l	extb_SegList(a5),d2
	move.l	a5,a1
	jsr	_LVORemove(a6)
	move.l	a5,a1
	moveq	#0,d0
	moveq	#0,d1
	move.w	LIB_NEGSIZE(a5),d1
	sub.l	d1,a1
	move.w	LIB_POSSIZE(a5),d0
	add.l	d1,d0
	jsr	_LVOFreeMem(a6)
	move.l	d2,d0
	movem.l	(sp)+,d2/a5-a6
	rts
;	INPUT
;	A0.L	=	APTR to module external list structure to be initialized
;	OUTPUT
;	D0.L	=	What type of external library is it or NULL if error
ExternalInitialize:	move.l	extb_TuComposerBase(a6),a1
	movem.l	a2/a6,-(sp)
	move.l	a0,d0						; Just for case
	beq.s	ExternalInitDone			; Do not init and return NULL
	move.l	a1,a6
	move.b	#EXTLF_Loader|EXTLF_Saver,extl_Flags(a0)	; Loader & Saver
	move.l	a0,a2
	lea	extl_Descriptor(a0),a0			; Put descriptor ID into the
	lea	LoadDescript(pc),a1				; external library list structure
	jsr	_LVOSetString(a6)				; Allocate new string buffer. YOU
										; MUST DO THAT IN THIS WAY !!!!!!
	tst.l	d0							; Check if successful
	beq.s	ExternalInitDone
	lea	LoadFlags(pc),a0				; Following only if loading flags
	jsr	_LVOAllocFlagStr(a6)			; Allocate flag structures
	move.l	d0,extl_LoadFlagStr(a2)		; Store to the flag load structures
	beq.s	ExternalInitDone
	lea	SaveFlags(pc),a0				; Following only if saving flags
	jsr	_LVOAllocFlagStr(a6)			; Now allocate save flag structures
	move.l	d0,extl_SaveFlagStr(a2)		; Store to the flag save structures
	beq.s	ExternalInitDone
;	Additional initializations are done here like priority. Use:
;	move.b	#-10,extl_Pri(a2)
;	to set the priority to -10.
	moveq	#EXTTYPE_MODULE,d0
ExternalInitDone:	movem.l	(sp)+,a2/a6
	rts
;	INPUT
;	A0.L	=	APTR to flag pass structure which was updated
;	D0.L	=	Type of flag pass structure (NULL = load, $00000001 = save)
;	D1.L	=	Flag number which was updated
;	OUTPUT
;	D0.L	=	NULL if changes were accepted, else APTR to text string why
;				not accepted (i.e. hardware not found)
ExternalUpdateFlags:	
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	If failed NULL else any non-zero value
ExternalModuleIdentify:	
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be loaded
;	A1.L	=	APTR to module structure or NULL to create new
;	A2.L	=	APTR to loading flag pass structure (Loader specific)
;	D0.L	=	Number of module to be loaded (NULL is the first)
;	OUTPUT
;	D0.L	=	APTR to module structure where loaded module data is
ExternalModuleLoad:	
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be loaded
;	A1.L	=	APTR to module structure to be saved
;	A2.L	=	APTR to saving flag pass structure (Saver specific)
;	OUTPUT
;	D0.L	=	NULL if saved successfully else one of the libs error codes
ExternalModuleSave:	
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle from where to get the info
;	A1.L	=	APTR to module info structure where to put information
;	D0.L	=	Number of module to be scanned (NULL is the first)
;	OUTPUT
;	D0.L	=	Any non-zero value for success, NULL for error.
ExternalModuleGetInfo:	
	rts
;	INPUT
;	A0.L	=	APTR to cruncher file handle to be scanned
;	OUTPUT
;	D0.L	=	Number of modules found or NULL on any error
ExternalModuleGetNums:	
	rts

	cnop	0,4

ExtModuleLibBase:	dc.l	0

LoadFlags:	dc.w	3					; We have 3 flags (example)
	dc.w	LoadFlagSize				; Size of the load flags (total)
	dc.l	LoadText0					; Text for flag #0
	dc.b	EXTFLAG_BOOLEAN				; Flag #0 is boolean (example)
	dc.b	0							; No special flags for #0
	dc.w	0							; Not a integer/string gadget, so 0.
	dc.l	0							; No lowest value for booleans
	dc.l	0							; No highest value for booleans
	dc.l	-1							; Default is TRUE (load sample data)
	dc.l	LoadText1					; Text for flag #1
	dc.b	EXTFLAG_BOOLEAN				; Flag #1 also boolean
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	LoadText2					; Text for flag #2
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
LoadText0:	dc.b	'Load data',0		; Just a silly example
LoadText1:	dc.b	'Assign filename',0	; Assign file name to tcm_FileName
LoadText2:	dc.b	'Assign name',0		; Assign name to tcm_Name
	even								; To make that even
LoadFlagSize:	equ	*-LoadFlags			; Calculate size of structure
SaveFlags:	dc.w	2					; 2 save flags (again example)
	dc.w	SaveFlagSize				; Size of save flag structure
	dc.l	SaveText0
	dc.b	EXTFLAG_BOOLEAN
	dc.b	0
	dc.l	0
	dc.l	0
	dc.l	-1							; Pack data by default
	dc.l	0
	dc.l	SaveText1
	dc.b	EXTFLAG_DIRECTORY			; Now we have a directory
	dc.b	TEFSF_Update				; Updating required (in example,
										; checking the directory for exist-
										; ance and create if necessary)
	dc.w	255							; Up to 255 characters may be entered
	dc.l	0							; String gadgets don't have lowest
	dc.l	0							; and highest values, so 0
	dc.l	DefaultDir					; Default directory
	dc.l	0
SaveText0:	dc.b	'Pack data',0		; Flag #0 is for packing data (this
										; text is displayed by the apps)
SaveText1:	dc.b	'Instruments directory: ',0	; Example (instr directory)
DefaultDir:	dc.b	'st-00:Instruments',0	; PT-style example for default
SaveFlagSize:	equ	*-SaveFlags			; Calculate size of save structure
LoadDescript:	dc.b	'TuComposer Module (TCM)',0	; Just a example
