********************************************************
***         TuComposer External Disk Writer          ***
***         1997 by The united Coders (TuC)         ***
***                Main code: Basty/TuC              ***
*** This sound device driver allows you to write the ***
***  imcoming sound data directly to disk. That's a  ***
*** nice feature, if you have an relatively slow CPU ***
*** and have a module with many channels or just for ***
***   the High Quality Mixer. Also the mixing rate   ***
***        isn't limited to 44kHz or similar.        ***
********************************************************

	IFND	_G2
	MACHINE	MC68020
	OPT	NODEBUG,NOLINE
	ENDC

	include	"exec/types.i"
	include	"exec/execbase.i"
	include	"exec/exec_lib.i"
	include	"exec/initializers.i"
	include	"exec/interrupts.i"
	include	"exec/resident.i"
	include	"exec/libraries.i"
	include	"exec/memory.i"
	include	"dos/dos_lib.i"
	include	"dos/dostags.i"
	include	"hardware/custom.i"
	include	"hardware/dmabits.i"
	include	"hardware/intbits.i"
	include	"hardware/cia.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/external/external.i"
	include	"tucomposer/external/external_lib.i"
	include	"tucomposer/external/device.i"
	include	"tucomposer/external/device_lib.i"
	include	"tucomposer/external/mixer.i"
	include	"tucomposer/external/mixer_lib.i"

CUSTOM_BASE	equ	$DFF000
CIAA_BASE	equ	$BFE001

	moveq	#-1,d0
	rts
ResidentStruct:	dc.w	RTC_MATCHWORD
	dc.l	ResidentStruct
	dc.l	0
	dc.b	RTF_AUTOINIT
	dc.b	EXTLIB_DEVICE_VERSION
	dc.b	NT_LIBRARY
	dc.b	-5
	dc.l	LibName
	dc.l	LibID
	dc.l	Init
LibName:	dc.b	'diskwriter.library',0
LibID:	dc.b	'TuComposer External Disk Writer Driver Version 1.00 (v31) (68020+, OS2.0+) (22 Mar 97) by Basty/TuC.',0
TuComposerName:	dc.b	'tucomposer.library',0
	even
Init:	dc.l	sdi_SIZEOF
	dc.l	FuncTab
	dc.l	DataTab
	dc.l	PrepareLibrary

FuncTab:	dc.w	-1
	dc.w	Open-FuncTab
	dc.w	Close-FuncTab
	dc.w	Expunge-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalInitialize-FuncTab
	dc.w	ExternalUpdateFlags-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExtLib-FuncTab
	dc.w	ExternalDeviceAlloc-FuncTab
	dc.w	ExternalDeviceFree-FuncTab
	dc.w	ExternalDevicePlay-FuncTab
	dc.w	ExternalDeviceStop-FuncTab
	dc.w	ExternalDeviceCheckRate-FuncTab
	dc.w	ExternalDeviceCheckRateFraction-FuncTab
	dc.w	ExternalDeviceUpdateRate-FuncTab
	dc.w	-1

DataTab:	INITLONG	LN_NAME,LibName
	INITBYTE	LIB_FLAGS,LIBF_CHANGED|LIBF_SUMUSED
	INITWORD	LIB_VERSION,EXTLIB_DEVICE_VERSION
	INITWORD	LIB_REVISION,EXTLIB_REVISION
	INITLONG	LIB_IDSTRING,LibID
	INITBYTE	sdi_Flags,SDIF_Stereo
	INITLONG	sdi_LowFrequency,1000
	INITLONG	sdi_HighFrequency,256000
	dc.l	0

PrepareLibrary:	btst	#AFB_68020,AttnFlags+1(a6)
	beq.s	ExtLib
	cmp.w	#37,LIB_VERSION(a6)
	blt.s	ExtLib
	move.l	a2,-(sp)
	move.l	d0,a2
	move.l	a0,extb_SegList(a2)
	moveq	#31,d0
	lea	TuComposerName(pc),a1
	jsr	_LVOOpenLibrary(a6)
	move.l	d0,extb_TuComposerBase(a2)
	beq.s	NoTuCLib
	lea	ExtDeviceLibBase(pc),a0
	move.l	a2,(a0)
	move.l	a2,d0
NoTuCLib:	move.l	(sp)+,a2
	rts
Open:	addq.w	#1,LIB_OPENCNT(a6)
	move.l	a6,d0
	rts
Close:	subq.w	#1,LIB_OPENCNT(a6)
	bne.s	ExtLib
	btst	#LIBB_DELEXP,LIB_FLAGS(a6)
	bne.s	Expunge
ExtLib:	moveq	#0,d0
	rts
Expunge:	bset	#LIBB_DELEXP,LIB_FLAGS(a6)
	tst.w	LIB_OPENCNT(a6)
	bne.s	ExtLib
	movem.l	d2/a5-a6,-(sp)
	move.l	extb_ExtLibList(a6),d0
	beq.s	NoExtLibList
	move.l	d0,a0
	clr.l	extl_LibBase(a0)
NoExtLibList:	move.l	extb_TuComposerBase(a6),a1
	move.l	a6,a5
	move.l	4.w,a6
	jsr	_LVOCloseLibrary(a6)
	move.l	extb_SegList(a5),d2
	move.l	a5,a1
	jsr	_LVORemove(a6)
	move.l	a5,a1
	moveq	#0,d0
	moveq	#0,d1
	move.w	LIB_NEGSIZE(a5),d1
	sub.l	d1,a1
	move.w	LIB_POSSIZE(a5),d0
	add.l	d1,d0
	jsr	_LVOFreeMem(a6)
	move.l	d2,d0
	movem.l	(sp)+,d2/a5-a6
	rts
;	INPUT
;	A0.L	=	APTR to track external list structure to be initialized
;	OUTPUT
;	D0.L	=	What type of external library is it or NULL if error
ExternalInitialize:	move.l	extb_TuComposerBase(a6),a1
	movem.l	a2/a6,-(sp)
	move.l	a0,d0
	beq.s	ExternalInitDone
	move.l	a1,a6
	move.b	#EXTLF_Loader|EXTLF_Saver,extl_Flags(a0)
	move.l	a0,a2
	lea	extl_Descriptor(a0),a0
	lea	LoadDescript(pc),a1
	jsr	_LVOSetString(a6)
	tst.l	d0
	beq.s	ExternalInitDone
	lea	SaveFlags(pc),a0
	jsr	_LVOAllocFlagStr(a6)
	move.l	d0,extl_SaveFlagStr(a2)
	beq.s	ExternalInitDone
	moveq	#EXTTYPE_DEVICE,d0
ExternalInitDone:	movem.l	(sp)+,a2/a6
	rts
;	INPUT
;	A0.L	=	APTR to flag pass structure which was updated
;	D0.L	=	Type of flag pass structure (NULL = load, $00000001 = save)
;	D1.L	=	Flag number which was updated
;	OUTPUT
;	D0.L	=	NULL if changes were accepted, else APTR to text string why
;				not accepted (i.e. hardware not found)
ExternalUpdateFlags:	
	rts
;	INPUT
;	A0.L	=	APTR to loading flag pass structure (soundcard config)
;	OUTPUT
;	D0.L	=	If success NULL else one of the device error codes
ExternalDeviceAlloc:	moveq	#ERROR_EXTLIB_BUSY,d0
	bset	#SDIB_Allocated,sdi_Flags(a6)
	bne.s	AllocDone
	sub.l	a1,a1
	move.l	a6,-(sp)
	move.l	4.w,a6
	jsr	_LVOFindTask(a6)
	move.l	(sp)+,a6
	move.l	d0,sdi_Task(a6)
	moveq	#0,d0
AllocDone:	movem.l	(sp)+,d2-d3/a2-a3/a6
	rts
;	NO INPUTS
;	OUTPUT
;	D0.L	=	NULL if successful free, else one of the device error codes
ExternalDeviceFree:	moveq	#ERROR_EXTLIB_NOALLOC,d0
	btst	#SDIB_Allocated,sdi_Flags(a6)
	beq.s	AllocDone
	sub.l	a1,a1
	move.l	a6,-(sp)
	move.l	4.w,a6
	jsr	_LVOFindTask(a6)
	move.l	d0,d1
	moveq	#ERROR_EXTLIB_BUSY,d0
	move.l	(sp)+,a6
	cmp.l	sdi_Task(a6),d1
	bne.s	AllocDone
	bclr	#SDIB_Allocated,sdi_Flags(a6)
	clr.l	sdi_Task(a6)
	moveq	#0,d0
	bra.s	AllocDone
;	INPUT
;	A0.L	=	APTR to mixer alloc structure as got by ExternalMixerAlloc()
;	A1.L	=	APTR to saving flag pass structure (Soundcard specific)
;	OUTPUT
;	D0.L	=	If playing started successfully, NULL, else one of the errors
ExternalDevicePlay:	movem.l	d2-d3/a2-a4/a6,-(sp)
	lea	PlayParams(pc),a4
	move.l	a1,d0
	beq.s	UsePrevValues
	movem.l	(a1),d0-d2
	movem.l	d0-d2,(a4)
UsePrevValues:	lea	MixLibBase(pc),a1
	move.l	a0,(a1)
	btst	#SDIB_Playing,sdi_Flags(a6)
	beq.s	Playing
	bsr	ExternalDeviceStop
Playing:	bset	#SDIB_Playing,sdi_Flags(a6)
	move.l	MixLibBase(pc),a0
	bset	#MASB_Mixing,mas_Flags(a0)
	cmp.b	#2,4+3(a4)
	beq.s	AllocBufDone
	moveq	#2,d3
	btst	#SDICB_Stereo,sdi_ChannelFlags(a6)
	beq.s	NotStereoPlay
	add.l	d3,d3
NotStereoPlay:	cmp.b	#3,4+3(a4)
	bne.s	NotRealSurround
	add.l	d3,d3
NotRealSurround:	cmp.b	#4,4+3(a4)
	bne.s	Not14BitPlay
	add.l	d3,d3
Not14BitPlay:	lea	ChipBuffers(pc),a2
	move.l	a6,a3
	move.l	4.w,a6
AllocBufLoop:	move.l	sdi_ChannelBufLen(a3),d0
	move.l	#MEMF_PUBLIC|MEMF_CHIP|MEMF_CLEAR,d1
	jsr	_LVOAllocMem(a6)
	move.l	d0,(a2)+
	beq	ExternalDeviceStop
	subq.b	#1,d3
	bne.s	AllocBufLoop
AllocBufDone:	movem.l	sdi_ChannelBuf(a3),d0-d1
	lea	MixBuffer(pc),a0
	movem.l	d0-d1,(a0)
	move.l	sdi_ChannelBufLen(a3),d2
	btst	#SDICB_Stereo,sdi_ChannelFlags(a3)
	beq.s	NoWriteStereo
	add.l	d2,d2
NoWriteStereo:	cmp.b	#3,20+3(a4)
	beq.s	Write16Bit
	cmp.b	#6,20+3(a4)
	beq.s	Write16Bit
	cmp.b	#8,20+3(a4)
	bne.s	Write8Bit
Write16Bit:	add.l	d2,d2
Write8Bit:	move.l	d2,d0
	moveq	#MEMF_PUBLIC,d1
	jsr	_LVOAllocMem(a6)
	lea	WriteBuf(pc),a0
	move.l	d0,(a0)
	beq	ExternalDeviceStop
	move.l	d2,d0
	moveq	#MEMF_PUBLIC,d1
	jsr	_LVOAllocMem(a6)
	lea	WriteBuf+4(pc),a0
	move.l	d0,(a0)+
	move.l	d2,(a0)
	beq	ExternalDeviceStop
	cmp.b	#4,4+3(a4)
	bne.s	PaulaSurroundSound
	btst	#SDICB_Stereo,sdi_ChannelFlags(a3)
	bne.s	Paula14BitStereo
	lea	AudI14m(pc),a0
	lea	AudSI14m(pc),a1
	bra.s	StartIRQ
Paula14BitStereo:	lea	AudI14s(pc),a0
	lea	AudSI14s(pc),a1
	bra.s	StartIRQ
PaulaSurroundSound:	cmp.b	#3,4+3(a4)
	bne.s	Paula8BitSound
	btst	#SDICB_Stereo,sdi_ChannelFlags(a3)
	bne.s	SurroundStereo
	lea	AudISurroundm(pc),a0
	lea	AudSISurroundm(pc),a1
	bra.s	StartIRQ
SurroundStereo:	lea	AudISurrounds(pc),a0
	lea	AudSISurrounds(pc),a1
	bra.s	StartIRQ
Paula8BitSound:	cmp.b	#2,4+3(a4)
	bne	DoDiskWriteOnly
	btst	#SDICB_Stereo,sdi_ChannelFlags(a3)
	bne.s	Paula8BitStereo
	lea	AudI8m(pc),a0
	lea	AudSI8m(pc),a1
	bra.s	StartIRQ
Paula8BitStereo:	lea	AudI8s(pc),a0
	lea	AudSI8s(pc),a1
StartIRQ:	lea	MixIRQ(pc),a2
	move.l	a0,IS_CODE(a2)
	move.l	a1,MixSIRQ+IS_CODE-MixIRQ(a2)
	clr.b	MixWhichBuf-MixIRQ(a2)
	moveq	#INTB_AUD0,d0
	move.l	a2,a1
	move.l	4.w,a6
	jsr	_LVOSetIntVector(a6)
	lea	CUSTOM_BASE,a0
	move.l	#3579545,d0
	move.l	sdi_ChannelFreq(a3),d1
	divu.l	d1,d0
	move.l	sdi_ChannelBufLen(a3),d1
	lea	MixBufSize(pc),a1
	move.l	d1,(a1)
	lsr.l	#1,d1
	move.w	d1,aud0+ac_len(a0)
	move.w	d1,aud1+ac_len(a0)
	move.w	d1,aud2+ac_len(a0)
	move.w	d1,aud3+ac_len(a0)
	move.w	d0,aud0+ac_per(a0)
	move.w	d0,aud1+ac_per(a0)
	move.w	d0,aud2+ac_per(a0)
	move.w	d0,aud3+ac_per(a0)
	moveq	#64,d1
	move.w	d1,aud0+ac_vol(a0)
	move.w	d1,aud1+ac_vol(a0)
	cmp.b	#4,4+3(a4)
	bne.s	Not14BitVol
	moveq	#1,d1
Not14BitVol:	move.w	d1,aud2+ac_vol(a0)
	move.w	d1,aud3+ac_vol(a0)
	lea	ChipBuffers(pc),a1
	cmp.b	#3,4+3(a4)
	beq.s	Paula14Bit
	cmp.b	#4,4+3(a4)
	bne.s	Paula8BitData
Paula14Bit:	btst	#SDICB_Stereo,sdi_ChannelFlags(a3)
	beq.s	Paula14BitNoStereo
	tst.l	12(a4)
	bne.s	Paula14BitSwap
	move.l	(a1)+,aud0+ac_ptr(a0)
	move.l	(a1)+,aud3+ac_ptr(a0)
	move.l	(a1)+,aud1+ac_ptr(a0)
	move.l	(a1)+,aud2+ac_ptr(a0)
	clr.b	SwapCh-MixIRQ(a2)
	bra.s	PaulaStartDMA
Paula14BitSwap:	move.l	(a1)+,aud1+ac_ptr(a0)
	move.l	(a1)+,aud2+ac_ptr(a0)
	move.l	(a1)+,aud0+ac_ptr(a0)
	move.l	(a1)+,aud3+ac_ptr(a0)
	st	SwapCh-MixIRQ(a2)
	bra.s	PaulaStartDMA
Paula14BitNoStereo:	move.l	(a1),aud0+ac_ptr(a0)
	move.l	(a1)+,aud1+ac_ptr(a0)
	move.l	(a1),aud2+ac_ptr(a0)
	move.l	(a1),aud3+ac_ptr(a0)
	bra.s	PaulaStartDMA
Paula8BitData:	move.l	(a1)+,d0
	move.l	d0,aud0+ac_ptr(a0)
	move.l	d0,aud3+ac_ptr(a0)
	btst	#SDICB_Stereo,sdi_ChannelFlags(a3)
	beq.s	Paula8BitNoStereo
	tst.l	12(a4)
	bne.s	Paula8BitSwap
	move.l	(a1),d0
	move.l	d0,aud1+ac_ptr(a0)
	move.l	d0,aud2+ac_ptr(a0)
	clr.b	SwapCh-MixIRQ(a2)
	bra.s	PaulaStartDMA
Paula8BitSwap:	move.l	(a1),aud0+ac_ptr(a0)
	move.l	(a1),aud3+ac_ptr(a0)
	st	SwapCh-MixIRQ(a2)
Paula8BitNoStereo:	move.l	d0,aud1+ac_ptr(a0)
	move.l	d0,aud2+ac_ptr(a0)
PaulaStartDMA:	tst.l	8(a4)
	bne.s	PaulaFilterOn
	bset	#CIAB_LED,CIAA_BASE+ciapra
	bra.s	PaulaFilterOk
PaulaFilterOn:	bclr	#CIAB_LED,CIAA_BASE+ciapra
PaulaFilterOk:	move.w	#INTF_SETCLR|INTF_AUD0,intena(a0)
	move.w	#INTF_AUD0,intreq(a0)
	move.w	#DMAF_SETCLR|DMAF_AUDIO,dmacon(a0)
	movem.l	(sp)+,d2-d3/a2-a4/a6
	rts
DoDiskWriteOnly:	
;	NO INPUTS
;	OUTPUT
;	D0.L	=	If stopping was successful, NULL, else one of the errors
ExternalDeviceStop:	
;	INPUT
;	D0.L	=	Mixrate to be used
;	OUTPUT
;	D0.L	=	The soundcard aware mixing rate
ExternalDeviceCheckRate:	
	rts
;	INPUT
;	D0.L	=	Mixrate to be used
;	OUTPUT
;	D0.L	=	The mixing rate 32-bit fraction (tempo modifier, for Paula)
ExternalDeviceCheckRateFraction:	
	rts
;	INPUT
;	D0.L	=	New sample rate to be used
;	OUTPUT
;	D0.L	=	NULL if accepted else any of the error codes
ExternalDeviceUpdateRate:	
	rts
AudI8m:	move.w	#INTF_AUD0,intreq(a0)
	not.b	MixWhichBuf-AudI8m(a5)
	beq.s	AudI8mOther
	addq.l	#4,a1
AudI8mOther:	move.l	(a1),d0
	move.l	d0,aud0+ac_ptr(a0)
	move.l	d0,aud1+ac_ptr(a0)
	move.l	d0,aud2+ac_ptr(a0)
	move.l	d0,aud3+ac_ptr(a0)
	move.l	d0,MixDestBuf-AudI8m(a5)
	lea	MixSIRQ(pc),a1
	jmp	_LVOCause(a6)
AudSI8m:	move.l	a2,-(sp)
	move.l	(a1),a2
	move.l	MixLibBase(pc),a6
	jsr	_LVOExternalMixerDoMix(a6)
	move.l	MixDestBuf(pc),a0
	move.l	MixBufSize(pc),d0
	lsr.w	#1,d0
	subq.w	#1,d0
CopyI8mLoop:	move.w	(a2)+,d1
	move.b	(a2),d1
	addq.l	#2,a2
	move.w	d1,(a0)+
	dbra	d0,CopyI8mLoop
	movem.l	(sp)+,a2/a6
	rts
AudISurroundm:	move.w	#INTF_AUD0,intreq(a0)
	not.b	MixWhichBuf-AudISurroundm(a5)
	beq.s	AudISurroundmOther
	addq.l	#8,a1
AudISurroundmOther:	move.l	(a1)+,d0
	move.l	d0,aud0+ac_ptr(a0)
	move.l	d0,aud1+ac_ptr(a0)
	move.l	(a1),d1
	move.l	d0,aud2+ac_ptr(a0)
	move.l	d0,aud3+ac_ptr(a0)
	movem.l	d0-d1,MixDestBuf-AudISurroundm(a5)
	lea	MixSIRQ(pc),a1
	jmp	_LVOCause(a6)
AudSISurroundm:	movem.l	a2/a6,-(sp)
	move.l	(a1),a2
	move.l	MixLibBase(pc),a6
	jsr	_LVOExternalMixerDoMix(a6)
	movem.l	MixDestBuf(pc),a0-a1
	move.l	MixBufSize(pc),d0
	lsr.w	#1,d0
	subq.w	#1,d0
	move.l	d2,a5
CopyISurroundmLoop:	move.w	(a2)+,d1
	move.b	(a2),d1
	addq.l	#2,a2
	move.w	d1,(a0)+
	not.w	d1
	move.w	d1,(a1)+
	dbra	d0,CopyISurroundmLoop
	move.l	a5,d2
	movem.l	(sp)+,a2/a6
	rts
AudI14m:	move.w	#INTF_AUD0,intreq(a0)
	not.b	MixWhichBuf-AudI14m(a5)
	beq.s	AudI14mOther
	addq.l	#8,a1
AudI14mOther:	move.l	(a1)+,d0
	move.l	d0,aud0+ac_ptr(a0)
	move.l	d0,aud1+ac_ptr(a0)
	move.l	(a1),d1
	move.l	d0,aud2+ac_ptr(a0)
	move.l	d0,aud3+ac_ptr(a0)
	movem.l	d0-d1,MixDestBuf-AudI14m(a5)
	lea	MixSIRQ(pc),a1
	jmp	_LVOCause(a6)
AudSI14m:	movem.l	a2/a6,-(sp)
	move.l	(a1),a2
	move.l	MixLibBase(pc),a6
	jsr	_LVOExternalMixerDoMix(a6)
	movem.l	MixDestBuf(pc),a0-a1
	move.l	MixBufSize(pc),d0
	lsr.w	#1,d0
	subq.w	#1,d0
	move.l	d2,a5
CopyI14mLoop:	move.w	(a2)+,d1
	moveq	#0,d2
	move.b	d1,d2
	move.b	(a2)+,d1
	move.w	d1,(a0)+
	lsl.w	#6,d2
	move.b	(a2)+,d2
	lsr.b	#2,d2
	move.w	d2,(a1)+
	dbra	d0,CopyI14mLoop
	move.l	a5,d2
	movem.l	(sp)+,a2/a6
	rts
AudI8s:	move.w	#INTF_AUD0,intreq(a0)
	not.b	MixWhichBuf-AudI8s(a5)
	beq.s	AudI8sOther
	addq.l	#8,a1
AudI8sOther:	movem.l	(a1),d0-d1
	movem.l	d0-d1,MixDestBuf-AudI8s(a5)
	tst.b	SwapCh-AudI8s(a5)
	beq.s	AudI8sSwap
	exg	d0,d1
AudI8sSwap:	move.l	d0,aud0+ac_ptr(a0)
	move.l	d1,aud1+ac_ptr(a0)
	move.l	d1,aud2+ac_ptr(a0)
	move.l	d0,aud3+ac_ptr(a0)
	lea	MixSIRQ(pc),a1
	jmp	_LVOCause(a6)
AudSI8s:	movem.l	a2/a6,-(sp)
	move.l	(a1),a2
	move.l	MixLibBase(pc),a6
	jsr	_LVOExternalMixerDoMix(a6)
	movem.l	MixDestBuf(pc),a0-a1
	move.l	MixBufSize(pc),d0
	lsr.w	#1,d0
	subq.w	#1,d0
CopyI8sLoop:		move.w	(a2)+,d1
	move.b	2(a2),d1
	move.w	d1,(a0)+
	move.w	(a2),d1
	move.b	4(a2),d1
	move.w	d1,(a1)+
	addq.l	#6,a2
	dbra	d0,CopyI8sLoop
	movem.l	(sp)+,a2/a6
	rts
AudISurrounds:	move.w	#INTF_AUD0,intreq(a0)
	not.b	MixWhichBuf-AudISurrounds(a5)
	beq.s	AudSurroundsOther
	lea	16(a1),a1
AudSurroundsOther:	movem.l	(a1)+,d0-d1
	movem.l	d0-d1,MixDestBuf-AudISurrounds(a5)
	tst.b	SwapCh-AudISurrounds(a5)
	bne.s	AudISurroundsSwap
	move.l	d0,aud0+ac_ptr(a0)
	move.l	d1,aud3+ac_ptr(a0)
	movem.l	(a1),d0-d1
	movem.l	d0-d1,MixDestBuf+8-AudISurrounds(a5)
	move.l	d0,aud1+ac_ptr(a0)
	move.l	d1,aud2+ac_ptr(a0)
	lea	MixSIRQ(pc),a1
	jmp	_LVOCause(a6)
AudISurroundsSwap:	move.l	d0,aud1+ac_ptr(a0)
	move.l	d1,aud2+ac_ptr(a0)
	movem.l	(a1),d0-d1
	movem.l	d0-d1,MixDestBuf+8-AudISurrounds(a5)
	move.l	d0,aud0+ac_ptr(a0)
	move.l	d1,aud3+ac_ptr(a0)
	lea	MixSIRQ(pc),a1
	jmp	_LVOCause(a6)
AudSISurrounds:	movem.l	d2-d3/a2-a3/a6,-(sp)
	move.l	(a1),a2
	move.l	MixLibBase(pc),a6
	jsr	_LVOExternalMixerDoMix(a6)
	movem.l	MixDestBuf(pc),a0-a1/a3/a5
	move.l	MixBufSize(pc),d0
	lsr.w	#1,d0
	subq.w	#1,d0
CopyISurroundsLoop:	move.w	(a2)+,d1
	move.b	2(a2),d1
	move.w	d1,(a0)+
	not.w	d1
	move.w	d1,(a3)+
	move.w	(a2),d1
	move.b	4(a2),d1
	move.w	d1,(a1)+
	not.w	d1
	move.w	d1,(a5)+
	addq.l	#6,a2
	dbra	d0,CopyISurroundsLoop
	movem.l	(sp)+,d2-d3/a2-a3/a6
	rts
AudI14s:	move.w	#INTF_AUD0,intreq(a0)
	not.b	MixWhichBuf-AudI14s(a5)
	beq.s	Aud14sOther
	lea	16(a1),a1
Aud14sOther:	movem.l	(a1)+,d0-d1
	movem.l	d0-d1,MixDestBuf-AudI14s(a5)
	tst.b	SwapCh-AudI14s(a5)
	bne.s	AudI14sSwap
	move.l	d0,aud0+ac_ptr(a0)
	move.l	d1,aud3+ac_ptr(a0)
	movem.l	(a1),d0-d1
	movem.l	d0-d1,MixDestBuf+8-AudI14s(a5)
	move.l	d0,aud1+ac_ptr(a0)
	move.l	d1,aud2+ac_ptr(a0)
	lea	MixSIRQ(pc),a1
	jmp	_LVOCause(a6)
AudI14sSwap:	move.l	d0,aud1+ac_ptr(a0)
	move.l	d1,aud2+ac_ptr(a0)
	movem.l	(a1),d0-d1
	movem.l	d0-d1,MixDestBuf+8-AudI14s(a5)
	move.l	d0,aud1+ac_ptr(a0)
	move.l	d1,aud2+ac_ptr(a0)
	lea	MixSIRQ(pc),a1
	jmp	_LVOCause(a6)
AudSI14s:	movem.l	d2-d3/a2-a3/a6,-(sp)
	move.l	(a1),a2
	move.l	MixLibBase(pc),a6
	jsr	_LVOExternalMixerDoMix(a6)
	movem.l	MixDestBuf(pc),a0-a1/a3/a5
	move.l	MixBufSize(pc),d0
	lsr.w	#1,d0
	subq.w	#1,d0
CopyI14sLoop:	move.w	(a2)+,d1
	move.b	d1,d3
	move.w	(a2)+,d2
	move.b	(a2)+,d1
	move.w	d1,(a0)+
	moveq	#0,d1
	move.b	d3,d1
	lsl.w	#6,d1
	move.b	(a2)+,d1
	lsr.b	#2,d1
	move.w	d1,(a1)+
	move.w	d2,d1
	move.b	(a2)+,d1
	move.w	d1,(a3)+
	moveq	#0,d1
	move.b	d2,d1
	lsl.w	#6,d1
	move.b	(a2)+,d1
	lsr.b	#2,d1
	move.w	d1,(a5)+
	dbra	d0,CopyI14sLoop
	movem.l	(sp)+,d2-d3/a2-a3/a6
	rts

	cnop	0,4

ExtDeviceLibBase:	dc.l	0
AudioPort:	ds.l	2
	dc.b	NT_MSGPORT,0
	dc.l	0
	dc.b	0,0
	dc.l	0
	ds.l	3
	dc.b	NT_MESSAGE,0
AudioRequest:	ds.l	2
	dc.b	NT_UNKNOWN,127
	dc.l	0,AudioPort
	dc.w	68
	dc.l	0
	dc.l	0
	dc.w	0
	dc.b	0,0
	dc.w	0
	dc.l	ChAllocMask
	dc.l	1
	ds.w	3
	ds.l	5
MixIRQ:	ds.w	5
	dc.l	MixIRQName
	dc.l	ChipBuffers
	dc.l	AudI8m
MixSIRQ:	ds.w	5
	dc.l	MixSIRQName
	dc.l	MixBuffer
	dc.l	AudSI8m
MixBufSize:	ds.l	1
MixLibBase:	ds.l	1
MixBuffer:	ds.l	2
MixDestBuf:	ds.l	4
WriteBuf:	ds.l	2
WriteBufLen:	ds.l	1
ChipBuffers:	ds.l	8
PlayParams:	dc.l	0
	dc.l	0
	dc.l	3
SaveFlags:	dc.w	6
	dc.w	SaveFlagSize
	dc.l	SaveText0
	dc.b	EXTFLAG_SLIDER
	dc.b	0
	dc.w	0
	dc.l	256
	dc.l	524288
	dc.l	262144
	dc.l	0
	dc.l	SaveButton1
	dc.b	EXTFLAG_BUTTON
	dc.b	TEFSF_Update
	dc.w	1+4
	dc.l	0
	dc.l	0
	dc.l	1
	dc.l	0
	dc.l	SaveText2
	dc.b	EXTFLAG_BOOLEAN
	dc.b	TEFSF_Update
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	SaveText3
	dc.b	EXTFLAG_BOOLEAN
	dc.b	TEFSF_Update
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	SaveText4
	dc.b	EXTFLAG_SAVEFILE
	dc.b	0
	dc.w	256
	dc.l	0
	dc.l	0
	dc.l	SaveDefault4
	dc.l	0
	dc.l	SaveButton5
	dc.b	EXTFLAG_BUTTON
	dc.b	0
	dc.w	1+14
	dc.l	0
	dc.l	0
	dc.l	1
	dc.l	0
SaveButton1:	dc.l	SaveText1
	dc.l	SaveText11
	dc.l	SaveText12
	dc.l	SaveText13
	dc.l	SaveText14
SaveButton5:	dc.l	SaveText5
	dc.l	SaveText51
	dc.l	SaveText52
	dc.l	SaveText53
	dc.l	SaveText54
	dc.l	SaveText55
	dc.l	SaveText56
	dc.l	SaveText57
	dc.l	SaveText58
	dc.l	SaveText59
	dc.l	SaveText510
	dc.l	SaveText511
	dc.l	SaveText512
	dc.l	SaveText513
	dc.l	SaveText514
SaveText0:	dc.b	'Disk buffer',0
SaveText1:	dc.b	'Paula-Play mode',0
SaveText11:	dc.b	'None',0
SaveText12:	dc.b	'Normal',0
SaveText13:	dc.b	'Real surround',0
SaveText14:	dc.b	'14-bit',0
SaveText2:	dc.b	'Paula lowpass filter',0
SaveText3:	dc.b	'Paula reverse stereo',0
SaveText4:	dc.b	'Output file',0
SaveDefault4:	dc.b	'ModSmp1.IFF',0
SaveText5:	dc.b	'Save format',0
SaveText51:	dc.b	'IFF-8SVX (8-bit)',0
SaveText52:	dc.b	'RIFF-WAVE (8-bit)',0
SaveText53:	dc.b	'RIFF-WAVE (16-bit)',0
SaveText54:	dc.b	'RIFF-WAVE (24-bit)',0
SaveText55:	dc.b	'RIFF-WAVE (32-bit)',0
SaveText56:	dc.b	'VOC (8-bit)',0
SaveText57:	dc.b	'AIFF (8-bit)',0
SaveText58:	dc.b	'AIFF (16-bit)',0
SaveText59:	dc.b	'AIFF (24-bit)',0
SaveText510:	dc.b	'AIFF (32-bit)',0
SaveText511:	dc.b	'RAW Signed (8-bit)',0
SaveText512:	dc.b	'RAW Signed (16-bit)',0
SaveText513:	dc.b	'RAW Signed (24-bit)',0
SaveText514:	dc.b	'RAW Signed (32-bit)',0
SaveFlagSize:	equ	*-SaveFlags
LoadDescript:	dc.b	'Disk Writer',0
AudioName:	dc.b	'audio.device',0
MixIRQName:	dc.b	'TuComposer External Disk Writer IRQ',0
MixSIRQName:	dc.b	'TuComposer External Disk Writer Soft IRQ',0
ChAllocMask:	dc.b	1+2+4+8
MixWhichBuf:	dc.b	0
SwapCh:	dc.b	0