/* TuComposer OS independent code
**
** $VER: AllocFlagStr.c 31.22 (2.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerExtFlagStr *AllocFlagStr ( struct TuComposerExtFlagStr
    *FlagStr )
{
  struct TuComposerExtFlagStr *InitFlagStr;

  if ( (InitFlagStr = (struct TuComposerExtFlagStr *) AllocPMem ( FlagStr->tefs_StructSize )))
  {
    union FlagEntryStruct *FlagEntry = (union FlagEntryStruct *) &(InitFlagStr->tefs_Flag);
    STRPTR FlagTextReloc;
    ULONG i;
    UBYTE FlagType;

    memcpy ( InitFlagStr, FlagStr, FlagStr->tefs_StructSize );

    for (i = InitFlagStr->tefs_NumEntries; i > 0; i--)
    {
      FlagTextReloc = FlagEntry->tefs_FlagInteger.tefs_FlagText + ((UBYTE *) InitFlagStr - (UBYTE *) FlagStr);
      FlagEntry->tefs_FlagInteger.tefs_FlagText = FlagTextReloc;

      FlagType = FlagEntry->tefs_FlagInteger.tefs_FlagType;

      if ( (FlagType >= EXTFLAG_BUTTON) && (FlagType <= EXTFLAG_LISTVIEW) )
      {
        ULONG j;
        UBYTE **FlagArray = FlagEntry->tefs_FlagArray.tefs_FlagText;

        for (j = FlagEntry->tefs_FlagArray.tefs_FlagLen; j > 0; j--)
        {
          FlagTextReloc = *FlagArray + ((UBYTE *) InitFlagStr - (UBYTE *) FlagStr);
          *FlagArray++ = FlagTextReloc;
        }
      } else if ( (FlagType >= EXTFLAG_STRING) && (FlagType < EXTFLAG_BUTTON) )
      {
        FlagTextReloc = FlagEntry->tefs_FlagString.tefs_FlagDefault + ((UBYTE *) InitFlagStr - (UBYTE *) FlagStr);
        FlagEntry->tefs_FlagString.tefs_FlagDefault = FlagTextReloc;
      } else if ( (FlagType == EXTFLAG_SLIDER) && (FlagEntry->tefs_FlagSlider.tefs_FlagLen) )
      {
        FlagTextReloc = (UBYTE *) FlagEntry->tefs_FlagSlider.tefs_FlagValues + ((UBYTE *) InitFlagStr - (UBYTE *) FlagStr);
        FlagEntry->tefs_FlagSlider.tefs_FlagValues = (LONG *) FlagTextReloc;
      }

      FlagEntry++;
    }
  }

  return ( InitFlagStr );
}
