/* TuComposer OS independent code
**
** $VER: CGetInfo.c 31.22 (2.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <dos/dos.h>
#include <tucomposer/tucomposer.h>
#include <clib/dos_protos.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_cruncherbase_protos.h>

ULONG CGetInfo ( struct CFHandle *CFHandle, struct CruncherInfo *CInfoStr )
{
  if ( CFHandle )
  {
    struct FileInfoBlock FIB;
    struct TuComposerExtList *ExtLibStr;

    CInfoStr->cis_Size = 0L;
    CInfoStr->cis_PackedSize = 0L;
    FreeNameStr ( CInfoStr->cis_Comment );
    CInfoStr->cis_Comment = NULL;

    if ( (ExtLibStr = CFHandle->cfh_ExtLibStr ))
    {
      struct CruncherLibrary *ExtCruncherLibBase = (struct CruncherLibrary *) ExtLibStr->extl_LibBase;

      return ( ExternalCruncherGetInfoBase ( CFHandle, CInfoStr, ExtCruncherLibBase ));
    }

    if ( ExamineFH ( CFHandle->cfh_FHandle, (struct FileInfoBlock *) &(FIB) ))
    {
      ULONG Size;

      Stamp2Date ( &(CInfoStr->cis_Date), (struct DateStamp *) &(FIB.fib_Date) );

      Size = FIB.fib_Size;

      CInfoStr->cis_Size = Size;
      CInfoStr->cis_PackedSize = Size;

      if ( SetString ( (STRPTR *) &(CInfoStr->cis_Comment), (STRPTR) &(FIB.fib_Comment) ))
        return ( 0L );
    }
  }

  return ( ERROR_EXTLIB_NOOPEN );
}
