/* TuComposer OS independent code
**
** $VER: GetExternalLibs.c 31.22 (3.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <exec/execbase.h>
#include <dos/dosasl.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/dos_protos.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_base_protos.h>

void FreeFlagStr ( struct TuComposerExtList *ExtLibStr, struct TuComposerExtFlagStr *ExtFlagStr );

UBYTE ExtPat[] = "#?\0";

UBYTE ExtDir[] = "TuComposer\0";
UBYTE ExtDir2[] = "LIBS:TuComposer\0";
UBYTE ExtDirCruncher[] = "TuComposer/Crunchers\0";
UBYTE ExtDirCruncher2[] = "LIBS:TuComposer/Crunchers\0";
UBYTE ExtDirDevice[] = "TuComposer/Devices\0";
UBYTE ExtDirDevice2[] = "LIBS:TuComposer/Devices\0";
UBYTE ExtDirInstr[] = "TuComposer/Instrs\0";
UBYTE ExtDirInstr2[] = "LIBS:TuComposer/Instrs\0";
UBYTE ExtDirMixer[] = "TuComposer/Mixers\0";
UBYTE ExtDirMixer2[] = "LIBS:TuComposer/Mixers\0";
UBYTE ExtDirModule[] = "TuComposer/Modules\0";
UBYTE ExtDirModule2[] = "LIBS:TuComposer/Modules\0";
UBYTE ExtDirPostProc[] = "TuComposer/PostProcs\0";
UBYTE ExtDirPostProc2[] = "LIBS:TuComposer/PostProcs\0";
UBYTE ExtDirRecorder[] = "TuComposer/Recorders\0";
UBYTE ExtDirRecorder2[] = "LIBS:TuComposer/Recorders\0";
UBYTE ExtDirSample[] = "TuComposer/Samples\0";
UBYTE ExtDirSample2[] = "LIBS:TuComposer/Samples\0";
UBYTE ExtDirSong[] = "TuComposer/Songs\0";
UBYTE ExtDirSong2[] = "LIBS:TuComposer/Songs\0";
UBYTE ExtDirSynth[] = "TuComposer/Synths\0";
UBYTE ExtDirSynth2[] = "LIBS:TuComposer/Synths\0";
UBYTE ExtDirTrack[] = "TuComposer/Tracks\0";
UBYTE ExtDirTrack2[] = "LIBS:TuComposer/Tracks\0";

STRPTR ExtDirs[] = {
  ExtDir, ExtDir2,
  ExtDirCruncher, ExtDirCruncher2,
  ExtDirDevice, ExtDirDevice2,
  ExtDirInstr, ExtDirInstr2,
  ExtDirMixer, ExtDirMixer2,
  ExtDirModule, ExtDirModule2,
  ExtDirPostProc, ExtDirPostProc2,
  ExtDirRecorder, ExtDirRecorder2,
  ExtDirSample, ExtDirSample2,
  ExtDirSong, ExtDirSong2,
  ExtDirSynth, ExtDirSynth2,
  ExtDirTrack, ExtDirTrack2,
  NULL, NULL };

extern struct ExecBase *SysBase;
extern struct TuComposerBase *TuCBase;

ULONG GetExternalLibs ( STRPTR ExtLibPatStr )
{
  struct AnchorPath Anchor;
  UBYTE **CurrDir = (UBYTE **) &(ExtDirs);
  STRPTR NewDirName;
  BPTR OldDir;
  BPTR DirLock = NULL;
  ULONG NewLibs = 0L;

  memset ( &(Anchor), 0, sizeof (struct AnchorPath));

  if (!( ExtLibPatStr ))
    ExtLibPatStr = (STRPTR) &(ExtPat);

  ObtainSemaphore ( TuCBase->tcb_ExternalSigSem );

  OldDir = CurrentDir ( NULL );

  for (;;)
  {
    CurrentDir ( OldDir );

    UnLock ( DirLock );

    MatchEnd ( (struct AnchorPath *) &(Anchor));

    if (!( NewDirName = *CurrDir++ ))
      break;

    if (!( DirLock = Lock ( NewDirName, SHARED_LOCK )))
      continue;

    CurrentDir ( DirLock );

    if ( MatchFirst ( ExtLibPatStr, (struct AnchorPath *) &(Anchor)))
      continue;

    for (;;)
    {
      if (!( (Anchor.ap_Info.fib_DirEntryType >= 0) || (FindName ( (struct List *) &(SysBase->LibList), (UBYTE *) &(Anchor.ap_Info.fib_FileName)))))
      {
        struct TuComposerExtLibBase *ExtLibBase;

        if ( (ExtLibBase = (struct TuComposerExtLibBase *) OpenLibrary ( (STRPTR) &(Anchor.ap_Info.fib_FileName), EXTLIB_VERSION )))
        {
          struct TuComposerExtList *ExtLibStr;

          if ( (ExtLibStr = (struct TuComposerExtList *) AllocPMem ( sizeof (struct TuComposerExtList ))))
          {
            struct MinList *ExternalList = (struct MinList *) &(TuCBase->tcb_ExtCrunch);
            struct TuComposerExtList *ExtListScan;
            ULONG InitType;

            ExtLibStr->extl_Directory = NewDirName;
            ExtLibStr->extl_LibBase = ExtLibBase;

            InitType = ExternalInitializeBase ( ExtLibStr, ExtLibBase );

            if ( (InitType > 0) && (InitType < EXTTYPE_RESERVED) )
            {
              ExternalList += (InitType - 1);

              ExtListScan = (struct TuComposerExtList *) ExternalList;

              for (;;)
              {
                ExtListScan = (struct TuComposerExtList *) ExtListScan->extl_Node.mln_Succ;

                if (!( ExtListScan->extl_Node.mln_Succ ))
                  break;

                if (!( strcmp ( ExtLibBase->extb_LibNode.lib_Node.ln_Name, ExtListScan->extl_LibName )))
                  goto GetLibErr;
              }

              if (!( ExtLibStr->extl_LibName = AllocNameStr ( (STRPTR) &(Anchor.ap_Info.fib_FileName ))))
                goto GetLibErr;

              EnqueueNode ( (struct List *) ExternalList, (struct Node *) ExtLibStr );

              ExtLibBase->extb_ExtLibList = ExtLibStr;

              NewLibs++;
            } else
            {
GetLibErr:

              FreeNameStr ( ExtLibStr->extl_LibName );
              FreeNameStr ( ExtLibStr->extl_Descriptor );

              FreeFlagStr ( ExtLibStr, ExtLibStr->extl_LoadFlagStr );
              FreeFlagStr ( ExtLibStr, ExtLibStr->extl_SaveFlagStr );

              FreePMem ( ExtLibStr, sizeof (struct TuComposerExtList));
            }
          }

          CloseLibrary ( (struct Library *) ExtLibBase );
        }
      }

      if ( MatchNext ( (struct AnchorPath *) &(Anchor)))
        break;
    }
  }

  ReleaseSemaphore ( TuCBase->tcb_ExternalSigSem );

  return ( NewLibs );
}
