/* TuComposer OS independent code
**
** $VER: OpenExternalLib.c 31.22 (3.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/dos_protos.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_base_protos.h>

extern struct TuComposerBase *TuCBase;

struct TuComposerExtLibBase *OpenExternalLib ( struct TuComposerExtList
    *ExtLibStr )
{
  struct TuComposerExtLibBase *ExtLibBase = NULL;

  if ( ExtLibStr )
  {
    if (!( ExtLibStr->extl_Flags & EXTLF_Disabled ))
    {
      ObtainSemaphoreShared ( TuCBase->tcb_ExternalSigSem );

      if ( (ExtLibBase = ExtLibStr->extl_LibBase ))
      {
        ExtLibBase = ExtLibOpen ( ExtLibBase );
      } else
      {
        BPTR LibDir;
        BPTR OldDir;

        if ( (LibDir = Lock ( ExtLibStr->extl_Directory, SHARED_LOCK )))
        {
          OldDir = CurrentDir ( LibDir );

          ExtLibBase = (struct TuComposerExtLibBase *) OpenLibrary ( ExtLibStr->extl_LibName, EXTLIB_VERSION );

          CurrentDir ( OldDir );

          UnLock ( LibDir );

          if ( ExtLibBase )
          {
            ExtLibBase->extb_ExtLibList = ExtLibStr;
            ExtLibStr->extl_LibBase = ExtLibBase;
          }
        }
      }

      ReleaseSemaphore ( TuCBase->tcb_ExternalSigSem );
    }
  }

  return ( ExtLibBase );
}
