/* TuComposer OS independent code
**
** $VER: RemExternalLib.c 31.22 (3.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

void FreeFlagStr ( struct TuComposerExtList *ExtLibStr, struct TuComposerExtFlagStr *ExtFlagStr );

extern struct TuComposerBase *TuCBase;

struct TuComposerExtList *RemExternalLib ( struct TuComposerExtList
    *ExtLibStr )
{
  struct TuComposerExtList *NextExtLibStr = NULL;

  if ( ExtLibStr )
  {
    struct TuComposerExtLibBase *ExtLibBase;

    NextExtLibStr = (struct TuComposerExtList *) ExtLibStr->extl_Node.mln_Succ;

    ObtainSemaphore ( TuCBase->tcb_ExternalSigSem );

    if ( (ExtLibBase = ExtLibStr->extl_LibBase ))
      RemLibrary ( (struct Library *) ExtLibBase );

    if (!( ExtLibStr->extl_Flags & EXTLF_Intern ))
    {
      RemoveNode ( (struct Node *) ExtLibStr );

      FreeNameStr ( ExtLibStr->extl_LibName );
      FreeNameStr ( ExtLibStr->extl_Descriptor );

      FreeFlagStr ( ExtLibStr, ExtLibStr->extl_LoadFlagStr );
      FreeFlagStr ( ExtLibStr, ExtLibStr->extl_SaveFlagStr );

      FreePMem ( ExtLibStr, sizeof (struct TuComposerExtList));
    }

    ReleaseSemaphore ( TuCBase->tcb_ExternalSigSem );
  }

  return ( NextExtLibStr );
}

void FreeFlagStr ( struct TuComposerExtList *ExtLibStr, struct TuComposerExtFlagStr *ExtFlagStr )
{
  if ( ExtFlagStr )
  {
    if ( ExtFlagStr == ExtLibStr->extl_SaveFlagStr )
      ExtLibStr->extl_SaveFlagStr = NULL;

    FreePMem ( ExtFlagStr, ExtFlagStr->tefs_StructSize );
  }
}
