/* TuComposer OS independent code
**
** $VER: AddArpeggioTick.c 31.22 (28.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG AddArpeggioTick ( struct TuComposerInstrArpeggio *ArpStr,
    unsigned long Ticks )
{
  if ( ArpStr )
  {
    ULONG OldLength = ArpStr->tcia_Entries;
    ULONG Length = OldLength + Ticks;

    if ( Length < 0x10000 )
    {
      struct TuComposerInstrArpeggioData *NewArpData;

      if ( NewArpData = (struct TuComposerInstrArpeggioData *) AllocPMem ( Length * sizeof (struct TuComposerInstrArpeggioData )))
      {
        struct TuComposerInstrArpeggioData *ArpData = ArpStr->tcia_Data;

        memcpy ( NewArpData, ArpData, OldLength * sizeof (struct TuComposerInstrArpeggioData ));

        FreePMem ( ArpData, OldLength * sizeof (struct TuComposerInstrArpeggioData ));

        ArpStr->tcia_Entries = Length;
        ArpStr->tcia_Data = NewArpData;

        return ( 0L );
      }

      return ( ERROR_INSTR_ENVLMEM );
    }

    return ( ERROR_INSTR_ENVOVFL );
  }

  return ( ERROR_INSTR_NOENVL );
}

