/* TuComposer OS independent code
**
** $VER: AddEnvPoint.c 31.22 (28.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG AddEnvPoint ( struct TuComposerInstrEnvelope *EnvStr,
    unsigned long Points )
{
  if ( EnvStr )
  {
    ULONG OldLength = EnvStr->tcie_NumPoints;
    ULONG Length = OldLength + Points;

    if ( Length < 0x10000 )
    {
      WORD *NewEnvData;

      if ( NewEnvData = (WORD *) AllocPMem ( Length * sizeof (WORD)))
      {
        WORD *EnvData = EnvStr->tcie_Data;
        UWORD *EnvNode;

        memcpy ( NewEnvData, EnvData, OldLength * sizeof (WORD));

        FreePMem ( EnvData, OldLength * sizeof (WORD));

        EnvStr->tcie_NumPoints = Length;
        EnvStr->tcie_Data = NewEnvData;

        if ( (EnvNode = EnvStr->tcie_NodePoints ))
          EnvNode[EnvStr->tcie_NumNodes - 1] = Length - 1;

        return ( 0L );
      }

      return ( ERROR_INSTR_ENVLMEM );
    }

    return ( ERROR_INSTR_ENVOVFL );
  }

  return ( ERROR_INSTR_NOENVL );
}
