/* TuComposer OS independent code
**
** $VER: AddInstrEnvelopes.c 31.22 (28.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG AddInstrEnvelopes ( struct TuComposerInstr *InstrStr,
    unsigned long Flags )
{
  if ( InstrStr )
  {
    if ( InstrStr->tci_Node.mln_Pred )
    {
      void (*AddType)( struct List *NodeList, struct Node *Node );
      struct TuComposerModule *ModuleStr;
      struct TuComposerInstrEnvelope **Envelopes = (struct TuComposerInstrEnvelope **) &(InstrStr->tci_VolumeEnvelope);
      struct TuComposerSample *SampleStr;
      ULONG i;

      if ( Flags & ENVF_Tail )
      {
        AddType = &AddNodeTail;
      } else
      {
        AddType = &AddNodeHead;
      }

      ModuleStr = (struct TuComposerModule *) &(InstrStr->tci_Node.mln_Succ);

      for (;;)
      {
        ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

        if (!( ModuleStr->tcm_Node.mln_Pred ))
          break;
      }

      (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_InstrList );

      for (i = (offsetof (struct TuComposerInstr, tci_ArpeggioStructure) - offsetof (struct TuComposerInstr, tci_VolumeEnvelope )) / sizeof ( APTR ); i > 0; i--)
      {
        if ( *Envelopes )
        {
          struct TuComposerInstrEnvelope *EnvStr = (struct TuComposerInstrEnvelope *) &(ModuleStr->tcm_Envelopes);

          for (;;)
          {
            EnvStr = (struct TuComposerInstrEnvelope *) EnvStr->tcie_Node.mln_Succ;

            if (!( EnvStr->tcie_Node.mln_Succ ))
              break;

            if ( *Envelopes == EnvStr )
              goto NotAddEnvelope;
          }

          AddType ( (struct List *) &(ModuleStr->tcm_Envelopes), (struct Node *) *Envelopes );
          DeleteEnvelope ( (struct TuComposerInstrEnvelope *) *Envelopes );
        }

NotAddEnvelope:

        Envelopes++;
      }

      if ( *Envelopes )
      {
        struct TuComposerInstrArpeggio *ArpStr = (struct TuComposerInstrArpeggio *) &(ModuleStr->tcm_ArpEnvList);

        for (;;)
        {
          ArpStr = (struct TuComposerInstrArpeggio *) ArpStr->tcia_Node.mln_Succ;

          if (!( ArpStr->tcia_Node.mln_Succ ))
            break;

          if ( *Envelopes == (struct TuComposerInstrEnvelope *) ArpStr )
            goto NotAddArpeggio;
        }

        AddType ( (struct List *) &(ModuleStr->tcm_ArpEnvList), (struct Node *) *Envelopes );
        DeleteArpeggio ( (struct TuComposerInstrArpeggio *) *Envelopes );
      }

NotAddArpeggio:

      Envelopes++;

      if ( *Envelopes )
      {
        struct TuComposerInstrKeyboard *KeybrdStr = (struct TuComposerInstrKeyboard *) &(ModuleStr->tcm_KeyboardDefs);

        for (;;)
        {
          KeybrdStr = (struct TuComposerInstrKeyboard *) KeybrdStr->tcik_Node.mln_Succ;

          if (!( KeybrdStr->tcik_Node.mln_Succ ))
            break;

          if ( *Envelopes == (struct TuComposerInstrEnvelope *) KeybrdStr )
            goto NotAddKeyboard;
        }

        AddType ( (struct List *) &(ModuleStr->tcm_KeyboardDefs), (struct Node *) *Envelopes );
        DeleteKeyboard ( (struct TuComposerInstrKeyboard *) *Envelopes );
      }

NotAddKeyboard:

      SampleStr = (struct TuComposerSample *) &(InstrStr->tci_Samples);

      for (;;)
      {
        SampleStr = (struct TuComposerSample *) SampleStr->tcs_Node.mln_Succ;

        if (!( SampleStr->tcs_Node.mln_Succ ))
          break;

        Envelopes = (struct TuComposerInstrEnvelope **) &(SampleStr->tcs_AutoVibratoEnv);

        for (i = (offsetof (struct TuComposerSample, tcs_EnvUsageFlags) - offsetof (struct TuComposerSample, tcs_AutoVibratoEnv )) / sizeof ( APTR ); i > 0; i--)
        {
          if ( *Envelopes )
          {
            struct TuComposerInstrEnvelope *EnvStr = (struct TuComposerInstrEnvelope *) &(ModuleStr->tcm_Envelopes);

            for (;;)
            {
              EnvStr = (struct TuComposerInstrEnvelope *) EnvStr->tcie_Node.mln_Succ;

              if (!( EnvStr->tcie_Node.mln_Succ ))
                break;

              if ( *Envelopes == EnvStr )
                goto NotAddSmpEnvs;
            }

            AddType ( (struct List *) &(ModuleStr->tcm_Envelopes), (struct Node *) *Envelopes );
            DeleteEnvelope ( (struct TuComposerInstrEnvelope *) *Envelopes );
          }

NotAddSmpEnvs:

          Envelopes++;
        }
      }

      return ( 0L );
    }

    return ( ERROR_MODULE_NOGIVEN );
  }

  return ( ERROR_INSTR_NOGIVEN );
}
