/* TuComposer OS independent code
**
** $VER: AllocInstr.c 31.22 (28.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerInstr *AllocInstr ( unsigned long NumSamples )
{
  struct TuComposerInstr *InstrStr = NULL;

  if ( NumSamples < MAXSAMPLESPERINSTR )
  {
    if ( (InstrStr = (struct TuComposerInstr *) AllocPMem ( sizeof (struct TuComposerInstr ))))
    {
      InitNodeList ( (struct List *) &(InstrStr->tci_Samples ));

      InstrStr->tci_GlobalVolume = 0xFF;
      InstrStr->tci_DefaultPanning = DEFAULTSAMPLEPANNING;
      InstrStr->tci_PitchPanCenter = DEFAULTPITCHPANCENTER;
      InstrStr->tci_EnvUsageFlags = ~(TCIEUF_UseVolumeEnv | TCIEUF_UsePanningEnv | TCIEUF_UseSlideEnv | -0x1000);

      InitNodeList ( (struct List *) &(InstrStr->tci_UnknownChunks ));

      if ( NumSamples )
      {
        struct TuComposerSample *SampleStr;
        ULONG i;

        for (i = NumSamples; i > 0; i--)
        {
          if ( (SampleStr = AllocSample ( NULL, 0L )))
          {
            AddSample ( InstrStr, SampleStr );
          } else
          {
            ClearInstr ( InstrStr );

            FreePMem ( InstrStr, sizeof (struct TuComposerInstr ));

            return ( NULL );
          }
        }
      }
    }
  }

  return ( InstrStr );
}
