/* TuComposer OS independent code
**
** $VER: ClearEnvelope.c 31.22 (28.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

extern APTR EnvTypeTable;

ULONG ClearEnvelope ( struct TuComposerInstrEnvelope *EnvStr,
    unsigned long Type, unsigned long Scale, unsigned long YOffset )
{
  if (  EnvStr )
  {
    WORD *EnvData;

    if ( (EnvData = EnvStr->tcie_Data ))
    {
      struct UnknownChunk *UnknownChunkStr;
      struct UnknownChunk *FreeUnkChunk;
      ULONG ScaleType, NumNodes, NumPoints;
      void (**ClrEnvType)( WORD *EnvData, ULONG NumPoints, ULONG Scale, ULONG YOffset, ULONG ScaleType );

      ScaleType = Scale & SCALE_INVERT;
      Scale &= ~(SCALE_INVERT);

      if ( Scale > MAX_SCALE )
        Scale = MAX_SCALE;

      if ( Type > ENVL_LAST )
        Type = ENVL_EMPTY;

      EnvStr->tcie_Flags = 0;
      EnvStr->tcie_Tempo = DEFAULT_ENVTEMPO;

      memset ( &(EnvStr->tcie_SustainStart), 0, offsetof (struct TuComposerInstrEnvelope, tcie_UnknownChunks) - offsetof (struct TuComposerInstrEnvelope, tcie_SustainStart ));

      EnvStr->tcie_LowestValue = -Scale;
      EnvStr->tcie_HighestValue = Scale;

      NumPoints = EnvStr->tcie_NumPoints;

      (APTR) ClrEnvType = (APTR) &(EnvTypeTable);
      ClrEnvType[Type] ( EnvData, NumPoints, Scale, YOffset, ScaleType );

      if ( (NumNodes = EnvStr->tcie_NumNodes ))
      {
        UWORD *EnvNode = EnvStr->tcie_NodePoints;
        ULONG NodeDiv, NodeMod, NodeVal = 0L, NodeCnt = 0L, i;

        if ( NumNodes > NumPoints )
          NumNodes = NumPoints;

        NodeDiv = NumPoints / NumNodes;
        NodeMod = NumPoints % NumNodes;

        for (i = NumNodes; i > 0; i--)
        {
          *EnvNode++ = NodeVal;

          NodeVal += NodeDiv;
          NodeCnt += NodeMod;

          if ( NodeCnt >= NumNodes )
          {
            NodeCnt -= NumNodes;
            NodeVal++;
          }
        }

        *--EnvNode = NumPoints - 1;
      }

      UnknownChunkStr = (struct UnknownChunk *) &(EnvStr->tcie_UnknownChunks.mlh_Head);

      for (;;)
      {
        FreeUnkChunk = (struct UnknownChunk *) UnknownChunkStr->uc_Node.mln_Succ;

        if (!( (struct UnknownChunk *) FreeUnkChunk->uc_Node.mln_Succ ))
          break;

        FreeUnknownChunk ( FreeUnkChunk );
      }

      return ( 0L );
    }

    return ( ERROR_INSTR_ENVDATA );
  }

  return ( ERROR_INSTR_NOENVL );
}
