/* TuComposer OS independent code
**
** $VER: ClearInstr.c 31.22 (28.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ClearInstr ( struct TuComposerInstr *InstrStr )
{
  if ( InstrStr )
  {
    struct TuComposerSample *SampleStr;
    struct TuComposerSample *FreeSampleStr;
    struct UnknownChunk *UnknownChunkStr;
    struct UnknownChunk *FreeUnkChunk;

    FreeNameStr ( InstrStr->tci_FileName );
    InstrStr->tci_FileName = NULL;

    FreeNameStr ( InstrStr->tci_Name );
    InstrStr->tci_Name = NULL;

    SampleStr = (struct TuComposerSample *) &(InstrStr->tci_Samples.mlh_Head);

    for (;;)
    {
      FreeSampleStr = (struct TuComposerSample *) SampleStr->tcs_Node.mln_Succ;

      if (!( FreeSampleStr->tcs_Node.mln_Succ ))
        break;

      FreeSample ( FreeSampleStr );
    }

    memset ( &(InstrStr->tci_VolumeEnvelope), 0, offsetof (struct TuComposerInstr, tci_UnknownChunks) - offsetof (struct TuComposerInstr, tci_VolumeEnvelope ));

    InstrStr->tci_GlobalVolume = 0xFF;
    InstrStr->tci_DefaultPanning = DEFAULTSAMPLEPANNING;
    InstrStr->tci_PitchPanCenter = DEFAULTPITCHPANCENTER;
    InstrStr->tci_EnvUsageFlags = ~(TCIEUF_UseVolumeEnv | TCIEUF_UsePanningEnv | TCIEUF_UseSlideEnv | -0x1000);

    UnknownChunkStr = (struct UnknownChunk *) &(InstrStr->tci_UnknownChunks.mlh_Head);

    for (;;)
    {
      FreeUnkChunk = (struct UnknownChunk *) UnknownChunkStr->uc_Node.mln_Succ;

      if (!( (struct UnknownChunk *) FreeUnkChunk->uc_Node.mln_Succ ))
        break;

      FreeUnknownChunk ( FreeUnkChunk );
    }

    return ( 0L );
  }

  return ( ERROR_INSTR_NOGIVEN );
}
