/* TuComposer OS independent code
**
** $VER: CmpInstrs.c 31.22 (10.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

LONG CmpInstrs ( struct TuComposerInstr *SrcInstrStr,
    struct TuComposerInstr *DestInstrStr )
{
  if ( SrcInstrStr && DestInstrStr )
  {
    struct TuComposerSample *SrcSampleStr = (struct TuComposerSample *) &(SrcInstrStr->tci_Samples.mlh_Head);
    struct TuComposerSample *DestSampleStr = (struct TuComposerSample *) &(DestInstrStr->tci_Samples.mlh_Head);
    struct TuComposerInstrEnvelope **SrcEnvelopes = (struct TuComposerInstrEnvelope **) &(SrcInstrStr->tci_VolumeEnvelope);
    struct TuComposerInstrEnvelope **DestEnvelopes = (struct TuComposerInstrEnvelope **) &(DestInstrStr->tci_VolumeEnvelope);
    ULONG i;

    if ( SrcInstrStr == DestInstrStr )
      goto InstrsEqual;

    if ( SrcInstrStr->tci_FileName != DestInstrStr->tci_FileName )
    {
      if ( (SrcInstrStr->tci_FileName == NULL) || (DestInstrStr->tci_FileName == NULL) )
        goto InstrsNotEqual;

      if ( strcmp ( SrcInstrStr->tci_FileName, DestInstrStr->tci_FileName ))
        goto InstrsNotEqual;
    }

    if ( SrcInstrStr->tci_Name != DestInstrStr->tci_Name )
    {
      if ( (SrcInstrStr->tci_Name == NULL) || (DestInstrStr->tci_Name == NULL) )
        goto InstrsNotEqual;

      if ( strcmp ( SrcInstrStr->tci_Name, DestInstrStr->tci_Name ))
        goto InstrsNotEqual;
    }

    if ( memcmp ( &(SrcInstrStr->tci_NumSamples), &(DestInstrStr->tci_NumSamples), offsetof (struct TuComposerInstr, tci_UnknownChunks) - offsetof (struct TuComposerInstr, tci_NumSamples )))
      goto InstrsNotEqual;

    for (;;)
    {
      SrcSampleStr = (struct TuComposerSample *) SrcSampleStr->tcs_Node.mln_Succ;
      DestSampleStr = (struct TuComposerSample *) DestSampleStr->tcs_Node.mln_Succ;

      if (!( SrcSampleStr->tcs_Node.mln_Succ ))
        break;

      if (!( DestSampleStr->tcs_Node.mln_Succ ))
        goto InstrsNotEqual;

      if ( (CmpSamples ( SrcSampleStr, DestSampleStr )))
        goto InstrsNotEqual;
    }

    if ( DestSampleStr->tcs_Node.mln_Succ )
      goto InstrsNotEqual;

    for (i = (offsetof (struct TuComposerInstr, tci_ArpeggioStructure) - offsetof (struct TuComposerInstr, tci_VolumeEnvelope )) / sizeof ( APTR ); i > 0; i--)
    {
      if ( *SrcEnvelopes != *DestEnvelopes )
      {
        if ( ( *SrcEnvelopes == NULL) || ( *DestEnvelopes == NULL) )
          goto InstrsNotEqual;

        if ( (CmpEnvelopes ( *SrcEnvelopes, *DestEnvelopes )))
          goto InstrsNotEqual;
      }

      SrcEnvelopes++;
      DestEnvelopes++;
    }

    if ( *SrcEnvelopes != *DestEnvelopes )
    {
      if ( ( *SrcEnvelopes == NULL) || ( *DestEnvelopes == NULL) )
        goto InstrsNotEqual;

      if ( (CmpArpeggios ( (struct TuComposerInstrArpeggio *) *SrcEnvelopes, (struct TuComposerInstrArpeggio *) *DestEnvelopes )))
        goto InstrsNotEqual;
    }

    SrcEnvelopes++;
    DestEnvelopes++;

    if ( *SrcEnvelopes != *DestEnvelopes )
    {
      if ( ( *SrcEnvelopes == NULL) || ( *DestEnvelopes == NULL) )
        goto InstrsNotEqual;

      if ( (CmpKeyboards ( (struct TuComposerInstrKeyboard *) *SrcEnvelopes, (struct TuComposerInstrKeyboard *) *DestEnvelopes )))
        goto InstrsNotEqual;
    }

InstrsEqual:
    return ( 0L );

InstrsNotEqual:
    return ( 1L );

  }

  return ( ERROR_INSTR_NOGIVEN );
}
