/* TuComposer OS independent code
**
** $VER: DeleteArpeggioTick.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG DeleteArpeggioTick ( struct TuComposerInstrArpeggio *ArpStr,
    unsigned long Tick, unsigned long Ticks, unsigned long Flags )
{
  if ( ArpStr )
  {
    struct TuComposerInstrArpeggioData *ArpData = ArpStr->tcia_Data;
    struct TuComposerInstrArpeggioData *CopyData;
    ULONG ArpLen = ArpStr->tcia_Entries;
    ULONG NewLen, CopyDestNum;

    if (Tick >= ArpLen)
      return ( 0L );

    Ticks = ((Ticks + Tick) < ArpLen ? Ticks : ArpLen - Tick);
    CopyDestNum = (Tick + Ticks);

    if (Flags & ENVF_TicksOnly)
    {
      memmove ( ArpData + Tick, ArpData + CopyDestNum, Tick * sizeof (struct TuComposerInstrArpeggioData ));

      memset ( ArpData + CopyDestNum, 0, Ticks * sizeof (struct TuComposerInstrArpeggioData ));

      return ( 0L );
    }

    NewLen = ( CopyDestNum < ArpLen ? ArpLen - Ticks : Tick );

    if ( NewLen )
    {
      if ( CopyData = (struct TuComposerInstrArpeggioData *) AllocPMem ( NewLen * sizeof (struct TuComposerInstrArpeggioData )))
      {
        struct TuComposerInstrArpeggioData *SrcTmpData = ArpData;
        struct TuComposerInstrArpeggioData *CopyTmpData = CopyData;

        if ( Tick )
        {
          memcpy ( CopyTmpData, SrcTmpData, Tick * sizeof (struct TuComposerInstrArpeggioData ));

          SrcTmpData += Tick;
          CopyTmpData += Tick;
        }

        memcpy ( CopyTmpData, SrcTmpData + Ticks, ((ArpLen - Tick) - Ticks) * sizeof (struct TuComposerInstrArpeggioData ));

        FreePMem ( ArpData, ArpLen * sizeof (struct TuComposerInstrArpeggioData ));

        ArpStr->tcia_Data = CopyData;
        ArpStr->tcia_Entries = NewLen;

        return ( 0L );
      }

      return ( ERROR_INSTR_ENVLMEM );
    }

    return ( ERROR_INSTR_ENVLESS );
  }

  return ( ERROR_INSTR_NOENVL );
}
