/* TuComposer OS independent code
**
** $VER: DeleteEnvPoint.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG DeleteEnvPoint ( struct TuComposerInstrEnvelope *EnvStr,
    unsigned long Point, unsigned long Points, unsigned long Flags )
{
  if ( EnvStr )
  {
    UWORD *NodePoints = EnvStr->tcie_NodePoints;
    ULONG NumNodes = EnvStr->tcie_NumNodes;
    WORD *EnvData = EnvStr->tcie_Data;
    WORD *CopyData;
    ULONG EnvLen = EnvStr->tcie_NumPoints;
    ULONG NewLen, CopyDestNum;

    if ( Point >= EnvLen )
      return ( 0L );

    Points = ((Points + Point) < EnvLen ? Points : EnvLen - Point);
    CopyDestNum = (Point + Points);

    if (Flags & ENVF_PointsOnly)
    {
      memmove ( EnvData + Point, EnvData + CopyDestNum, Point * sizeof (WORD));

      memset ( EnvData + CopyDestNum, 0, Points * sizeof (WORD));

      if ( NumNodes )
      {
        ULONG i;
        UWORD NodeVal;

        for (i = NumNodes; i > 0; i--)
        {
          if ( (NodeVal = *NodePoints) >= Point )
            NodeVal -= Points;

          *NodePoints++ = NodeVal;
        }

        *--NodePoints = CopyDestNum - 1;
      }

      return ( 0L );
    }

    NewLen = ( CopyDestNum < EnvLen ? EnvLen - Points : Point );

    if ( NewLen )
    {
      if ( CopyData = (WORD *) AllocPMem ( NewLen * sizeof (WORD)))
      {
        WORD *SrcTmpData = EnvData;
        WORD *CopyTmpData = CopyData;

        if ( Point )
        {
          memcpy ( CopyTmpData, SrcTmpData, Point * sizeof (WORD));

          SrcTmpData += Point;
          CopyTmpData += Point;
        }

        memcpy ( CopyTmpData, SrcTmpData + Points, ((EnvLen - Point) - Points) * sizeof (WORD));

        FreePMem ( EnvData, EnvLen * sizeof (WORD));

        EnvStr->tcie_Data = CopyData;
        EnvStr->tcie_NumPoints = NewLen;

        if ( NumNodes )
        {
          ULONG i;
          UWORD NodeVal;

          for (i = NumNodes; i > 0; i--)
          {
            if ( (NodeVal = *NodePoints) >= Point )
              NodeVal -= Points;

            *NodePoints++ = NodeVal;
          }
        }

        return ( 0L );
      }

      return ( ERROR_INSTR_ENVLMEM );
    }

    return ( ERROR_INSTR_ENVLESS );
  }

  return ( ERROR_INSTR_NOENVL );
}
