/* TuComposer OS independent code
**
** $VER: DupEnvelope.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

#ifndef MOTOROLA
  ULONG ReadMLong ( UBYTE *Buffer );
#else
  #define ReadMLong( Buffer ) (*(ULONG *) (Buffer))
#endif

struct TuComposerInstrEnvelope *DupEnvelope ( struct TuComposerInstrEnvelope
    *EnvStr )
{
  struct TuComposerInstrEnvelope *CloneEnv = NULL;

  if ( EnvStr )
  {
    if ( (CloneEnv = (struct TuComposerInstrEnvelope *) AllocPMem ( sizeof (struct TuComposerInstrEnvelope ))))
    {
      struct UnknownChunk *EnvUnkChunk;
      struct UnknownChunk *CloneUnkChunk;
      WORD *CloneEnvData;
      ULONG EnvLen = EnvStr->tcie_NumPoints;

      if ( (CloneEnvData = (WORD *) AllocPMem ( EnvLen * sizeof (WORD))))
      {
        UWORD *CloneEnvNodes;
        ULONG EnvNodes = EnvStr->tcie_NumNodes;

        CloneEnv->tcie_Data = CloneEnvData;

        if ( EnvNodes )
        {
          if ( (CloneEnvNodes = (UWORD *) AllocPMem ( EnvNodes * sizeof (UWORD))))
          {
            CloneEnv->tcie_NodePoints = CloneEnvNodes;

            memcpy ( CloneEnvNodes, EnvStr->tcie_NodePoints, EnvNodes * sizeof (UWORD));
          } else
          {

DupEnvErr:

            FreeEnvelope ( CloneEnv );

            CloneEnv = NULL;
          }
        }

        if ( CloneEnv )
        {
          CloneEnv->tcie_Flags = EnvStr->tcie_Flags;
          memcpy ( &(CloneEnv->tcie_NumNodes), &(EnvStr->tcie_NumNodes), offsetof (struct TuComposerInstrEnvelope, tcie_UnknownChunks) - offsetof (struct TuComposerInstrEnvelope, tcie_NumNodes ));

          memcpy ( CloneEnvData, EnvStr->tcie_Data, EnvLen * sizeof (WORD));

          EnvUnkChunk = (struct UnknownChunk *) &(EnvStr->tcie_UnknownChunks.mlh_Head);

          for (;;)
          {
            EnvUnkChunk = (struct UnknownChunk *) EnvUnkChunk->uc_Node.mln_Succ;

            if (!( EnvUnkChunk->uc_Node.mln_Succ))
              break;

            if (!( CloneUnkChunk = AllocUnknownChunk ( (APTR) &(EnvUnkChunk->uc_Data), ReadMLong ( (UBYTE *) &(EnvUnkChunk->uc_Identifier[0])), ReadMLong ( (UBYTE *) &(EnvUnkChunk->uc_Length[0])) )))
              goto DupEnvErr;

            AddNodeTail ( (struct List *) &(CloneEnv->tcie_UnknownChunks), (struct Node *) CloneUnkChunk );
          }
        }
      } else
      {
        FreePMem ( CloneEnv, sizeof (WORD));

        CloneEnv = NULL;
      }
    }
  }

  return ( CloneEnv );
}
