/* TuComposer OS independent code
**
** $VER: DupInstr.c 31.22 (28.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerInstr *DoDupInstr ( struct TuComposerInstr *InstrStr, struct TuComposerInstr *CloneInstr );

#ifndef MOTOROLA
  ULONG ReadMLong ( UBYTE *Buffer );
#else
  #define ReadMLong( Buffer ) (*(ULONG *) (Buffer))
#endif

struct TuComposerInstr *DupInstr ( struct TuComposerInstr *InstrStr )
{
  return ( DoDupInstr ( InstrStr, NULL ));
}

struct TuComposerInstr *DoDupInstr ( struct TuComposerInstr *InstrStr, struct TuComposerInstr *CloneInstr )
{
  if ( InstrStr )
  {
    struct TuComposerSample *SampleStr;
    struct TuComposerSample *CloneSample;
    struct UnknownChunk *InstrUnkChunk;
    struct UnknownChunk *CloneUnkChunk;

    if (!( CloneInstr ))
      if (!( CloneInstr = AllocInstr ( NULL )))
        return ( NULL );

    if ( InstrStr->tci_FileName )
    {
      if (!( SetString ( (STRPTR *) &(CloneInstr->tci_FileName), InstrStr->tci_FileName )))
        goto DupInstrErr;
    }

    if ( InstrStr->tci_Name )
    {
      if (!( SetString ( (STRPTR *) &(CloneInstr->tci_Name), InstrStr->tci_Name )))
        goto DupInstrErr;
    }

    SampleStr = (struct TuComposerSample *) &(InstrStr->tci_Samples);

    for (;;)
    {
      SampleStr = (struct TuComposerSample *) SampleStr->tcs_Node.mln_Succ;

      if (!( SampleStr->tcs_Node.mln_Succ ))
        break;

      if (!( CloneSample = DupSample ( SampleStr )))
        goto DupInstrErr;

      AddSample ( CloneInstr, CloneSample );
    }

    memcpy ( &(CloneInstr->tci_VolumeEnvelope), &(InstrStr->tci_VolumeEnvelope), offsetof (struct TuComposerInstr, tci_UnknownChunks) - offsetof (struct TuComposerInstr, tci_VolumeEnvelope ));

    InstrUnkChunk = (struct UnknownChunk *) &(InstrStr->tci_UnknownChunks.mlh_Head);

    for (;;)
    {
      InstrUnkChunk = (struct UnknownChunk *) InstrUnkChunk->uc_Node.mln_Succ;

      if (!( InstrUnkChunk->uc_Node.mln_Succ))
        break;

      if (!( CloneUnkChunk = AllocUnknownChunk ( (APTR) &(InstrUnkChunk->uc_Data), ReadMLong ( (UBYTE *) &(InstrUnkChunk->uc_Identifier[0])), ReadMLong ( (UBYTE *) &(InstrUnkChunk->uc_Length[0])) )))
        goto DupInstrErr;

      AddNodeTail ( (struct List *) &(CloneInstr->tci_UnknownChunks), (struct Node *) CloneUnkChunk );
    }

    return ( CloneInstr );

DupInstrErr:
    FreeInstr ( CloneInstr );
  }

  return ( NULL );
}