/* TuComposer OS independent code
**
** $VER: ExpandEnvelope.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ExpandEnvelope ( struct TuComposerInstrEnvelope *EnvStr,
    unsigned long Scale )
{
  if ( EnvStr )
  {
    WORD *EnvData = EnvStr->tcie_Data;
    ULONG EnvLen;

    if ( Scale )
    {
      WORD *NewEnvData;
      ULONG NewLength;

      if ( Scale == 1)
        return ( 0L );

      EnvLen = EnvStr->tcie_NumPoints;

      if ((NewLength = (EnvLen * Scale)) > 0xFFFF )
        return ( ERROR_INSTR_ENVBIG );

      if (NewEnvData = (WORD *) AllocPMem ( NewLength * sizeof (WORD)))
      {
        WORD *SrcEnvData = EnvData;
        WORD *DestEnvData = NewEnvData;
        ULONG Pos, ScaleCnt, EnvNodes;
        WORD EnvValue;

        for (Pos = EnvLen; Pos > 0; Pos--)
        {
          EnvValue = *SrcEnvData++;

          for (ScaleCnt = Scale; ScaleCnt > 0; ScaleCnt--)
          {
            *DestEnvData++ = EnvValue;
          }
        }

        if ( (EnvNodes = EnvStr->tcie_NumNodes ))
        {
          UWORD *NodePoints = EnvStr->tcie_NodePoints;
          ULONG i;
          UWORD EnvNode;

          for (i = EnvNodes; i > 0; i--)
          {
            EnvNode = (*NodePoints * Scale);
            *NodePoints++ = EnvNode;
          }

          NodePoints--;
          *NodePoints = NewLength - 1;
        }

        FreePMem ( EnvData, EnvLen * sizeof (WORD));

        EnvStr->tcie_Data = NewEnvData;
        EnvStr->tcie_NumPoints = NewLength;
      }

      return ( ERROR_INSTR_ENVLMEM );
    }

    return ( ERROR_INSTR_ENVSCLR );
  }

  return( ERROR_INSTR_NOENVL );
}
