/* TuComposer OS independent code
**
** $VER: FlipArpeggio.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG FlipArpeggio ( struct TuComposerInstrArpeggio *ArpStr,
    unsigned long Scale, unsigned long StartTick, unsigned long EndTick )
{
  if ( ArpStr )
  {
    if ( Scale )
    {
      struct TuComposerInstrArpeggioData *ArpData = ArpStr->tcia_Data;
      struct TuComposerInstrArpeggioData *NewArpData;
      ULONG ArpLen = ArpStr->tcia_Entries;

      StartTick = (StartTick < ArpLen ? StartTick : ArpLen - 1);
      EndTick = (EndTick < ArpLen ? EndTick : ArpLen - 1);

      if (StartTick > EndTick)
      {
        ULONG TmpTick;
        TmpTick = StartTick;
        StartTick = EndTick;
        EndTick = TmpTick;
      }

      Scale = (((EndTick - StartTick) + 1) <= Scale ? 1 : Scale);

      if ((Scale >= ArpLen) || (StartTick == EndTick))
        return ( 0L );

      if ( NewArpData = (struct TuComposerInstrArpeggioData *) AllocPMem ( ArpLen * sizeof (struct TuComposerInstrArpeggioData )))
      {
        struct TuComposerInstrArpeggioData *SrcArpData;
        struct TuComposerInstrArpeggioData *DestArpData;
        ULONG Tick;
        ULONG ScaleCnt;

        if ( StartTick )
          memcpy ( NewArpData, ArpData, StartTick * sizeof (struct TuComposerInstrArpeggioData ));

        SrcArpData = ArpData + StartTick;
        DestArpData = NewArpData + (EndTick - Scale);

        for (Tick = (EndTick - StartTick) + 1 - Scale; Tick > 0;)
        {
          for (ScaleCnt = Scale; ScaleCnt > 0; ScaleCnt--)
          {
            memcpy ( DestArpData, SrcArpData, sizeof (struct TuComposerInstrArpeggioData ));

            Tick--;
            if (Tick == 0)
              break;

            SrcArpData++;
            DestArpData++;
          }

          DestArpData -= Scale * 2;
        }

        ScaleCnt = (EndTick - (((EndTick - StartTick) + 1) % Scale) + 1);

        if (ScaleCnt < ArpLen)
          memcpy ( NewArpData + ScaleCnt, ArpData + ScaleCnt, (ArpLen - ScaleCnt) * sizeof (struct TuComposerInstrArpeggioData ));

        FreePMem ( ArpData, ArpLen * sizeof (struct TuComposerInstrArpeggioData ));

        ArpStr->tcia_Data = NewArpData;

        return ( 0L );
      }

      return ( ERROR_INSTR_ENVLMEM );
    }

    return ( ERROR_INSTR_ENVSCLR );
  }

  return( ERROR_INSTR_NOENVL );
}
