/* TuComposer OS independent code
**
** $VER: FlipEnvelope.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG FlipEnvelope ( struct TuComposerInstrEnvelope *EnvStr,
    unsigned long Scale, unsigned long StartPoint, unsigned long EndPoint )
{
  if ( EnvStr )
  {
    if ( Scale )
    {
      WORD *EnvData = EnvStr->tcie_Data;
      WORD *NewEnvData;
      ULONG EnvLen = EnvStr->tcie_NumPoints;

      StartPoint = (StartPoint < EnvLen ? StartPoint : EnvLen - 1);
      EndPoint = (EndPoint < EnvLen ? EndPoint : EnvLen - 1);

      if (StartPoint > EndPoint)
      {
        ULONG TmpPoint;
        TmpPoint = StartPoint;
        StartPoint = EndPoint;
        EndPoint = TmpPoint;
      }

      Scale = (((EndPoint - StartPoint) + 1) <= Scale ? 1 : Scale);

      if ((Scale >= EnvLen) || (StartPoint == EndPoint))
        return ( 0L );

      if ( NewEnvData = (WORD *) AllocPMem ( EnvLen * sizeof (WORD)))
      {
        WORD *SrcEnvData;
        WORD *DestEnvData;
        ULONG Point;
        ULONG ScaleCnt;

        if ( StartPoint )
          memcpy ( NewEnvData, EnvData, StartPoint * sizeof (WORD));

        SrcEnvData = EnvData + StartPoint;
        DestEnvData = NewEnvData + (EndPoint - Scale);

        for (Point = (EndPoint - StartPoint) + 1 - Scale; Point > 0;)
        {
          for (ScaleCnt = Scale; ScaleCnt > 0; ScaleCnt--)
          {
            *DestEnvData = *SrcEnvData;

            Point--;
            if (Point == 0)
              break;

            SrcEnvData++;
            DestEnvData++;
          }

          DestEnvData -= Scale * 2;
        }

        ScaleCnt = (EndPoint - (((EndPoint - StartPoint) + 1) % Scale) + 1);

        if (ScaleCnt < EnvLen)
          memcpy ( NewEnvData + ScaleCnt, EnvData + ScaleCnt, (EnvLen - ScaleCnt) * sizeof (WORD));

        FreePMem ( EnvData, EnvLen * sizeof (WORD));

        EnvStr->tcie_Data = NewEnvData;

        return ( 0L );
      }

      return ( ERROR_INSTR_ENVLMEM );
    }

    return ( ERROR_INSTR_ENVSCLR );
  }

  return( ERROR_INSTR_NOENVL );
}
