/* TuComposer OS independent code
**
** $VER: FreeArpeggio.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG FreeArpeggio ( struct TuComposerInstrArpeggio *ArpStr )
{
  if ( ArpStr )
  {
    struct TuComposerModule *ModuleStr = (struct TuComposerModule *) &(ArpStr->tcia_Node.mln_Succ);
    struct TuComposerSong *SongStr;

    if ( ArpStr->tcia_Node.mln_Succ )
    {
      struct TuComposerInstr *InstrStr;

      for (;;)
      {
        ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

        if (!( ModuleStr->tcm_Node.mln_Pred ))
          break;
      }

      (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_ArpEnvList );

      InstrStr = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head);

      for (;;)
      {
        InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Succ;

        if (!( InstrStr->tci_Node.mln_Succ ))
          break;

        if ( InstrStr->tci_ArpeggioStructure == ArpStr )
        {
          struct TuComposerInstrArpeggio *ArpBuf = (struct TuComposerInstrArpeggio *) ArpStr->tcia_Node.mln_Succ;

          if ( ArpBuf->tcia_Node.mln_Succ )
          {
            InstrStr->tci_ArpeggioStructure = ArpBuf;
          } else
          {
            ArpBuf = (struct TuComposerInstrArpeggio *) ArpStr->tcia_Node.mln_Pred;

            if ( ArpBuf->tcia_Node.mln_Pred )
            {
              InstrStr->tci_ArpeggioStructure = ArpBuf;
            } else
            {
              InstrStr->tci_ArpeggioStructure = NULL;
            }
          }
        }
      }

      DeleteArpeggio ( ArpStr );
    }

    if ( (SongStr = TuCBase->tcb_PlaySong) )
    {
      struct PlayerHostChannel *PHCStr = SongStr->tcso_ChannelData;
      ULONG i;

      Disable ();

      for (i = SongStr->tcso_Channels; i > 0; i--)
      {
        if ( PHCStr->phc_ArpStructure.pes_EnvelopeStructure == (struct TuComposerInstrEnvelope *) ArpStr )
          PHCStr->phc_ArpStructure.pes_EnvelopeStructure = NULL;

        PHCStr++;
      }

      Enable ();
    }

    FreePMem ( ArpStr->tcia_Data, ArpStr->tcia_Entries * sizeof (struct TuComposerInstrArpeggioData ));

    FreePMem ( ArpStr, sizeof (struct TuComposerInstrArpeggio ));

    return ( 0L );
  }

  return ( ERROR_INSTR_NOENVL );
}
