/* TuComposer OS independent code
**
** $VER: FreeEnvelope.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG FreeEnvelope ( struct TuComposerInstrEnvelope *EnvStr )
{
  if ( EnvStr )
  {
    WORD *EnvPoints;
    UWORD *EnvNodes;
    struct TuComposerModule *ModuleStr = (struct TuComposerModule *) &(EnvStr->tcie_Node.mln_Succ);
    struct TuComposerSong *SongStr;
    struct UnknownChunk *EnvUnkChunk;
    struct UnknownChunk *FreeUnkChunk;

    if ( EnvStr->tcie_Node.mln_Succ )
    {
      struct TuComposerInstr *InstrStr;

      for (;;)
      {
        ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

        if (!( ModuleStr->tcm_Node.mln_Pred ))
          break;
      }

      (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_Envelopes );

      InstrStr = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head);

      for (;;)
      {
        struct TuComposerInstrEnvelope **Envelopes;
        struct TuComposerSample *SampleStr;
        ULONG i;

        InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Succ;

        if (!( InstrStr->tci_Node.mln_Succ ))
          break;

        Envelopes = (struct TuComposerInstrEnvelope **) &(InstrStr->tci_VolumeEnvelope);

        for (i = (offsetof (struct TuComposerInstr, tci_ArpeggioStructure) - offsetof (struct TuComposerInstr, tci_VolumeEnvelope )) / sizeof ( APTR ); i > 0; i--)
        {
          if ( *Envelopes == EnvStr )
          {
            struct TuComposerInstrEnvelope *EnvBuf = (struct TuComposerInstrEnvelope *) EnvStr->tcie_Node.mln_Succ;

            if ( EnvBuf->tcie_Node.mln_Succ )
            {
              *Envelopes = EnvBuf;
            } else
            {
              EnvBuf = (struct TuComposerInstrEnvelope *) EnvStr->tcie_Node.mln_Pred;

              if ( EnvBuf->tcie_Node.mln_Pred )
              {
                *Envelopes = EnvBuf;
              } else
              {
                *Envelopes = NULL;
              }
            }
          }

          Envelopes++;
        }

        SampleStr = (struct TuComposerSample *) &(InstrStr->tci_Samples.mlh_Head);

        for (;;)
        {
          SampleStr = (struct TuComposerSample *) SampleStr->tcs_Node.mln_Succ;

          if (!( SampleStr->tcs_Node.mln_Succ ))
            break;

          if ( SampleStr->tcs_AutoVibratoEnv == EnvStr )
          {
            struct TuComposerInstrEnvelope *EnvBuf = (struct TuComposerInstrEnvelope *) EnvStr->tcie_Node.mln_Succ;

            if ( EnvBuf->tcie_Node.mln_Succ )
            {
              SampleStr->tcs_AutoVibratoEnv = EnvBuf;
            } else
            {
              EnvBuf = (struct TuComposerInstrEnvelope *) EnvStr->tcie_Node.mln_Pred;

              if ( EnvBuf->tcie_Node.mln_Pred )
              {
                SampleStr->tcs_AutoVibratoEnv = EnvBuf;
              } else
              {
                SampleStr->tcs_AutoVibratoEnv = NULL;
              }
            }
          }

          if ( SampleStr->tcs_AutoTremoloEnv == EnvStr )
          {
            struct TuComposerInstrEnvelope *EnvBuf = (struct TuComposerInstrEnvelope *) EnvStr->tcie_Node.mln_Succ;

            if ( EnvBuf->tcie_Node.mln_Succ )
            {
              SampleStr->tcs_AutoTremoloEnv = EnvBuf;
            } else
            {
              EnvBuf = (struct TuComposerInstrEnvelope *) EnvStr->tcie_Node.mln_Pred;

              if ( EnvBuf->tcie_Node.mln_Pred )
              {
                SampleStr->tcs_AutoTremoloEnv = EnvBuf;
              } else
              {
                SampleStr->tcs_AutoTremoloEnv = NULL;
              }
            }
          }

          if ( SampleStr->tcs_AutoPannoloEnv == EnvStr )
          {
            struct TuComposerInstrEnvelope *EnvBuf = (struct TuComposerInstrEnvelope *) EnvStr->tcie_Node.mln_Succ;

            if ( EnvBuf->tcie_Node.mln_Succ )
            {
              SampleStr->tcs_AutoPannoloEnv = EnvBuf;
            } else
            {
              EnvBuf = (struct TuComposerInstrEnvelope *) EnvStr->tcie_Node.mln_Pred;

              if ( EnvBuf->tcie_Node.mln_Pred )
              {
                SampleStr->tcs_AutoPannoloEnv = EnvBuf;
              } else
              {
                SampleStr->tcs_AutoPannoloEnv = NULL;
              }
            }
          }
        }
      }

      DeleteEnvelope ( EnvStr );
    }

    if ( (SongStr = TuCBase->tcb_PlaySong) )
    {
      struct PlayerHostChannel *PHCStr = SongStr->tcso_ChannelData;
      ULONG i;

      Disable ();

      for (i = SongStr->tcso_Channels; i > 0; i--)
      {
        if ( PHCStr->phc_VibratoEnv.pes_EnvelopeStructure == EnvStr )
          PHCStr->phc_VibratoEnv.pes_EnvelopeStructure = NULL;

        if ( PHCStr->phc_TremoloEnv.pes_EnvelopeStructure == EnvStr )
          PHCStr->phc_TremoloEnv.pes_EnvelopeStructure = NULL;

        if ( PHCStr->phc_PannoloEnv.pes_EnvelopeStructure == EnvStr )
          PHCStr->phc_PannoloEnv.pes_EnvelopeStructure = NULL;

        if ( PHCStr->phc_ChannoloEnv.pes_EnvelopeStructure == EnvStr )
          PHCStr->phc_ChannoloEnv.pes_EnvelopeStructure = NULL;

        if ( PHCStr->phc_TrackTremEnv.pes_EnvelopeStructure == EnvStr )
          PHCStr->phc_TrackTremEnv.pes_EnvelopeStructure = NULL;

        if ( PHCStr->phc_TrackPanEnv.pes_EnvelopeStructure == EnvStr )
          PHCStr->phc_TrackPanEnv.pes_EnvelopeStructure = NULL;

        if ( PHCStr->phc_PrevVolumeEnv == EnvStr )
          PHCStr->phc_PrevVolumeEnv = NULL;

        if ( PHCStr->phc_PrevPanningEnv == EnvStr )
          PHCStr->phc_PrevPanningEnv = NULL;

        if ( PHCStr->phc_PrevSlideEnv == EnvStr )
          PHCStr->phc_PrevSlideEnv = NULL;

        if ( PHCStr->phc_PrevAutoVibEnv == EnvStr )
          PHCStr->phc_PrevAutoVibEnv = NULL;

        if ( PHCStr->phc_PrevAutoTremEnv == EnvStr )
          PHCStr->phc_PrevAutoTremEnv = NULL;

        if ( PHCStr->phc_PrevAutoPanEnv == EnvStr )
          PHCStr->phc_PrevAutoPanEnv = NULL;

        PHCStr++;
      }

      Enable ();
    }

    if ( (ModuleStr = TuCBase->tcb_PlayModule) )
    {
      struct PlayerChannel *PCStr = ModuleStr->tcm_ChannelData;
      ULONG i;

      Disable ();

      for (i = ModuleStr->tcm_Channels; i > 0; i--)
      {
        if ( PCStr->pc_VolEnvelope.pes_EnvelopeStructure == EnvStr )
          PCStr->pc_VolEnvelope.pes_EnvelopeStructure = NULL;

        if ( PCStr->pc_PanEnvelope.pes_EnvelopeStructure == EnvStr )
          PCStr->pc_PanEnvelope.pes_EnvelopeStructure = NULL;

        if ( PCStr->pc_SlideEnvelope.pes_EnvelopeStructure == EnvStr )
          PCStr->pc_SlideEnvelope.pes_EnvelopeStructure = NULL;

        if ( PCStr->pc_AutoVibEnv.pes_EnvelopeStructure == EnvStr )
          PCStr->pc_AutoVibEnv.pes_EnvelopeStructure = NULL;

        if ( PCStr->pc_AutoTremoEnv.pes_EnvelopeStructure == EnvStr )
          PCStr->pc_AutoTremoEnv.pes_EnvelopeStructure = NULL;

        if ( PCStr->pc_AutoPanEnv.pes_EnvelopeStructure == EnvStr )
          PCStr->pc_AutoPanEnv.pes_EnvelopeStructure = NULL;

        PCStr++;
      }

      Enable ();
    }

    if ( (EnvNodes = EnvStr->tcie_NodePoints ))
      FreePMem ( EnvNodes, EnvStr->tcie_NumNodes * sizeof (UWORD));

    if ( (EnvPoints = EnvStr->tcie_Data ))
      FreePMem ( EnvPoints, EnvStr->tcie_NumPoints * sizeof (WORD));

    EnvUnkChunk = (struct UnknownChunk *) &(EnvStr->tcie_UnknownChunks.mlh_Head);

    for (;;)
    {
      FreeUnkChunk = (struct UnknownChunk *) EnvUnkChunk->uc_Node.mln_Succ;
      if (!( (struct UnknownChunk *) FreeUnkChunk->uc_Node.mln_Succ ))
        break;

      FreeUnknownChunk ( FreeUnkChunk );
    }

    FreePMem ( EnvStr, sizeof (struct TuComposerInstrEnvelope ));

    return ( 0L );
  }

  return ( ERROR_INSTR_NOENVL );
}
