/* TuComposer OS independent code
**
** $VER: FreeInstr.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG FreeInstr ( struct TuComposerInstr *InstrStr )
{
  if ( InstrStr )
  {
    struct TuComposerModule *ModuleStr;
    struct TuComposerSong *SongStr;
    struct TuComposerSample *FreeSampleStr;
    struct UnknownChunk *InstrUnkChunk;
    struct UnknownChunk *FreeUnkChunk;

    if ( InstrStr->tci_Node.mln_Succ )
      DeleteInstr ( InstrStr );

    if ( (SongStr = TuCBase->tcb_PlaySong) )
    {
      struct PlayerHostChannel *PHCStr = SongStr->tcso_ChannelData;
      ULONG i;

      Disable ();

      for (i = SongStr->tcso_Channels; i > 0; i--)
      {
        if ( PHCStr->phc_Instrument == InstrStr )
          PHCStr->phc_Instrument = NULL;

        PHCStr++;
      }

      Enable ();
    }

    if ( (ModuleStr = TuCBase->tcb_PlayModule) )
    {
      struct PlayerChannel *PCStr = ModuleStr->tcm_ChannelData;
      ULONG i;

      Disable ();

      for (i = ModuleStr->tcm_Channels; i > 0; i--)
      {
        if ( PCStr->pc_Instrument == InstrStr )
          PCStr->pc_Instrument = NULL;

        PCStr++;
      }

      Enable ();
    }

    if ( InstrStr->tci_Samples.mlh_Head )
    {
      for (;;)
      {
        FreeSampleStr = (struct TuComposerSample *) InstrStr->tci_Samples.mlh_Head;

        if (!( FreeSampleStr->tcs_Node.mln_Succ ))
          break;

        FreeSample ( FreeSampleStr );
      }
    }

    FreeNameStr ( InstrStr->tci_FileName );
    FreeNameStr ( InstrStr->tci_Name );

    InstrUnkChunk = (struct UnknownChunk *) &(InstrStr->tci_UnknownChunks.mlh_Head);

    for (;;)
    {
      FreeUnkChunk = (struct UnknownChunk *) InstrUnkChunk->uc_Node.mln_Succ;
      if (!( (struct UnknownChunk *) FreeUnkChunk->uc_Node.mln_Succ ))
        break;

      FreeUnknownChunk ( FreeUnkChunk );
    }

    FreePMem ( InstrStr, sizeof (struct TuComposerInstr ));

    return ( 0L );
  }

  return ( ERROR_INSTR_NOGIVEN );
}
