/* TuComposer OS independent code
**
** $VER: GetInstrEnvelopes.c 31.22 (8.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG CheckEnvelope ( struct TuComposerInstrEnvelope **InstrEnvStr, struct TuComposerInstrEnvelope *EnvStr );

struct TuComposerInstrEnvelope **GetInstrEnvelopes ( struct TuComposerInstr *InstrStr )
{
  struct TuComposerInstrEnvelope **InstrEnvStr = NULL;
  struct TuComposerInstrEnvelope **EnvList;
  struct TuComposerSample **InstrSmpStr;
  ULONG Count = 1L, NumSamples = 0L;

  if ( InstrStr )
  {
    if ( (InstrSmpStr = GetInstrSamples ( InstrStr )))
    {
      struct TuComposerSample **SampleList = InstrSmpStr;

      for (;;)
      {
        if (!( *SampleList++ ))
          break;

        NumSamples++;
      }

      if ( (EnvList = (struct TuComposerInstrEnvelope **) AllocPMem ( (( NumSamples * 3) + 9) * sizeof (struct TuComposerInstrEnvelope *))))
      {
        struct TuComposerSample *SampleStr;

        Count += CheckEnvelope ( EnvList, InstrStr->tci_VolumeEnvelope );
        Count += CheckEnvelope ( EnvList, InstrStr->tci_PanningEnvelope );
        Count += CheckEnvelope ( EnvList, InstrStr->tci_SlideEnvelope );
        Count += CheckEnvelope ( EnvList, InstrStr->tci_VibratoEnvelope );
        Count += CheckEnvelope ( EnvList, InstrStr->tci_TremoloEnvelope );
        Count += CheckEnvelope ( EnvList, InstrStr->tci_PannoloEnvelope );
        Count += CheckEnvelope ( EnvList, InstrStr->tci_ChannoloEnvelope );
        Count += CheckEnvelope ( EnvList, InstrStr->tci_SpenoloEnvelope );

        SampleList = InstrSmpStr;

        for (;;)
        {
          if (!( SampleStr = *SampleList++ ))
            break;

          Count += CheckEnvelope ( EnvList, SampleStr->tcs_AutoVibratoEnv );
          Count += CheckEnvelope ( EnvList, SampleStr->tcs_AutoTremoloEnv );
          Count += CheckEnvelope ( EnvList, SampleStr->tcs_AutoPannoloEnv );
        }

        if ( (InstrEnvStr = AllocPMem ( Count * sizeof (struct TuComposerInstrEnvelope *))))
          memcpy ( InstrEnvStr, EnvList, Count * sizeof (struct TuComposerInstrEnvelope *));

        FreePMem ( EnvList, (( NumSamples * 3) + 9) * sizeof (struct TuComposerInstrEnvelope *));
      }

      FreeInstrSamples ( InstrSmpStr );
    }
  }

  return ( InstrEnvStr );
}

ULONG CheckEnvelope ( struct TuComposerInstrEnvelope **InstrEnvStr, struct TuComposerInstrEnvelope *EnvStr )
{
  if ( EnvStr )
  {
    for (;;)
    {
      if (!( *InstrEnvStr ))
        break;

      if ( *InstrEnvStr++ == EnvStr )
        return ( 0L );
    }

    *InstrEnvStr = EnvStr;

    return ( 1L );
  }

  return ( 0L );
}
