/* TuComposer OS independent code
**
** $VER: GetInstrInfo.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_instrbase_protos.h>

struct InstrInfo *GetInstrInfo ( struct CFHandle *CFHandle,
    struct TuComposerExtList *ExtLibStr, unsigned long NumInstr )
{
  struct InstrInfo *InstrInfoStr = NULL;

  if ( CFHandle )
  {
    if (!( ExtLibStr ))
      ExtLibStr = IdentifyInstr ( CFHandle );

    if ( ExtLibStr )
    {
      if ( (InstrInfoStr = (struct InstrInfo *) AllocPMem (sizeof (struct InstrInfo ))))
      {
        struct InstrLibrary *ExtInstrLibBase;

        if ( (ExtInstrLibBase = (struct InstrLibrary *) OpenExternalLib ( ExtLibStr )))
        {
          ULONG RC;

          RC = ExternalInstrGetInfoBase ( CFHandle, InstrInfoStr, NumInstr, ExtInstrLibBase );

          CloseExternalLib ( ExtLibStr );

          if (!( RC ))
          {
            FreeInstrInfo ( InstrInfoStr );

            InstrInfoStr = NULL;
          }
        } else
        {
          FreePMem ( InstrInfoStr, sizeof (struct InstrInfo ));

          InstrInfoStr = NULL;
        }
      }
    }
  }

  return ( InstrInfoStr );
}
