/* TuComposer OS independent code
**
** $VER: GetInstrKeyboard.c 31.22 (8.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerInstrKeyboard *GetInstrKeyboard ( struct TuComposerInstr *InstrStr )
{
  struct TuComposerInstrKeyboard *KeybrdStr;

  if ( InstrStr->tci_KeyboardDefs )
  {
    if ( KeybrdStr = DupKeyboard ( InstrStr->tci_KeyboardDefs ))
    {
      if ( InstrStr->tci_CompFlags & TCICF_SeparateSamples )
      {
        UWORD *SampleReMap;
        struct KeyboardEntry *KeybrdEntry = (struct KeyboardEntry *) &(KeybrdStr->tcik_NoteEntry[0]);
        ULONG Count = 0L, i;

        if (!( SampleReMap = (UWORD *) AllocPMem ( (NUMOCTAVES * NUMNOTES * sizeof (UWORD)))))
        {
          FreeKeyboard ( KeybrdStr );

          return ( NULL );
        }

        for (i = (NUMOCTAVES * NUMNOTES); i > 0; i--)
        {
          ULONG Sample = KeybrdEntry->tcik_Sample_C_0;

          if ( Sample-- )
          {
            if (!( SampleReMap[Sample] ))
              SampleReMap[Sample] = ++Count;
          }

          KeybrdEntry++;
        }

        KeybrdEntry = (struct KeyboardEntry *) &(KeybrdStr->tcik_NoteEntry[0]);

        for (i = (NUMOCTAVES * NUMNOTES); i > 0; i--)
        {
          ULONG Sample = KeybrdEntry->tcik_Sample_C_0;

          if ( Sample-- )
            KeybrdEntry->tcik_Sample_C_0 = SampleReMap[Sample];

          KeybrdEntry++;
        }

        FreePMem ( SampleReMap, ( NUMOCTAVES * NUMNOTES * sizeof (UWORD)));
      }
    }
  }

  return ( KeybrdStr );
}
