/* TuComposer OS independent code
**
** $VER: GetInstrSamples.c 31.22 (8.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSample **GetInstrSamples ( struct TuComposerInstr *InstrStr )
{
  struct TuComposerSample **InstrSmpStr = NULL;
  struct TuComposerModule *ModuleStr = (struct TuComposerModule *) &(InstrStr->tci_Node.mln_Succ);
  struct TuComposerSample **SampleList;
  struct KeyboardEntry *KeybrdEntry;
  struct TuComposerInstr *InstrScan;
  struct TuComposerSample *SampleScan;
  ULONG Count = 1L, i, j, Sample;

  if ( InstrStr )
  {
    if ( InstrStr->tci_CompFlags & TCICF_SeparateSamples )
    {
      if (!( InstrStr->tci_Node.mln_Pred ))
        goto InstrNotAdded;

      for (;;)
      {
        ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

        if (!( ModuleStr->tcm_Node.mln_Pred ))
          break;
      }

      (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_InstrList);

      if ( (SampleList = (struct TuComposerSample **) AllocPMem ( sizeof (struct TuComposerSample *) * ((NUMOCTAVES * NUMNOTES) + 1))))
      {
        if ( InstrStr->tci_KeyboardDefs )
        {
          KeybrdEntry = (struct KeyboardEntry *) &(InstrStr->tci_KeyboardDefs->tcik_NoteEntry[0]);

          for (i = (NUMOCTAVES * NUMNOTES); i > 0; i--)
          {
            if ( (Sample = KeybrdEntry->tcik_Sample_C_0 ))
            {
              InstrScan = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head);

              for (;;)
              {
                InstrScan = (struct TuComposerInstr *) InstrScan->tci_Node.mln_Succ;

                if (!( InstrScan->tci_Node.mln_Succ ))
                  break;

                if ( --Sample )
                {
                  SampleScan = (struct TuComposerSample *) InstrScan->tci_Samples.mlh_Head;

                  if ( SampleScan->tcs_Node.mln_Succ )
                  {
                    InstrSmpStr = SampleList;

                    for (j = (NUMOCTAVES * NUMNOTES); j > 0; j--)
                    {
                      if (!( *InstrSmpStr ))
                        break;

                      if ( *InstrSmpStr++ == SampleScan )
                        break;
                    }

                    if (!( *InstrSmpStr ))
                    {
                      *InstrSmpStr = SampleScan;

                      Count++;
                    }
                  }

                  break;
                }
              }
            }

            KeybrdEntry++;
          }
        } else
        {
          InstrScan = (struct TuComposerInstr *) ModuleStr->tcm_InstrList.mlh_Head;
          SampleScan = (struct TuComposerSample *) InstrScan->tci_Samples.mlh_Head;

          if ( SampleScan->tcs_Node.mln_Succ )
          {
            *SampleList = SampleScan;

            Count++;
          }
        }

        if ( (InstrSmpStr = AllocPMem ( Count * sizeof (struct TuComposerSample *))))
          memcpy ( InstrSmpStr, SampleList, ( Count * sizeof (struct TuComposerSample *)));

        FreePMem ( SampleList, ((NUMOCTAVES * NUMNOTES) + 1) * sizeof (struct TuComposerSample *));
      }
    } else
    {
InstrNotAdded:

      if ( InstrSmpStr = (struct TuComposerSample **) AllocPMem ( (GetNumSamples ( InstrStr ) + 1) * sizeof (struct TuComposerSample *)))
      {
        struct TuComposerSample *SampleStr = (struct TuComposerSample *) &(InstrStr->tci_Samples.mlh_Head);

        SampleList = InstrSmpStr;

        for (;;)
        {
          SampleStr = (struct TuComposerSample *) SampleStr->tcs_Node.mln_Succ;

          if (!( SampleStr->tcs_Node.mln_Succ ))
            break;

          *SampleList++ = SampleStr;
        }

        *SampleList = NULL;
      }
    }
  }

  return ( InstrSmpStr );
}
