/* TuComposer OS independent code
**
** $VER: InsertArpeggioTick.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG InsertArpeggioTick ( struct TuComposerInstrArpeggio *ArpStr,
    unsigned long Tick, unsigned long Ticks, unsigned long Flags )
{
  if ( ArpStr )
  {
    struct TuComposerInstrArpeggioData *ArpData = ArpStr->tcia_Data;

    if ( Ticks )
    {
      ULONG ArpLen = ArpStr->tcia_Entries, NewLen;

      if (Flags & ENVF_TicksOnly)
      {
        if ( Tick >= ArpLen )
          Tick = ArpLen - 1;

        if ( (Tick + Ticks) > ArpLen )
          Ticks = ArpLen - Tick;

        memcpy ( ArpData + Tick + Ticks, ArpData + Tick, ((ArpLen - Tick) - Ticks) * sizeof (struct TuComposerInstrArpeggioData ));
        memset ( ArpData + Tick, 0, Ticks * sizeof (struct TuComposerInstrArpeggioData ));

        return ( 0L );
      }

      if ( (NewLen = (ArpLen + Ticks)) < 0x10000 )
      {
        if ( Tick >= NewLen )
        {
          AddArpeggioTick ( ArpStr, Ticks );
        } else
        {
          struct TuComposerInstrArpeggioData *NewArpData;

          if (!( NewArpData = (struct TuComposerInstrArpeggioData *) AllocPMem ( NewLen * sizeof (struct TuComposerInstrArpeggioData ))))
            return ( ERROR_INSTR_ENVLMEM );

          if ( Tick )
            memcpy ( NewArpData, ArpData, Tick * sizeof (struct TuComposerInstrArpeggioData ));

          memcpy ( NewArpData + Tick + Ticks, ArpData + Tick, (ArpLen - (Tick + Ticks)) * sizeof (struct TuComposerInstrArpeggioData ));

          FreePMem ( ArpData, ArpLen * sizeof (struct TuComposerInstrArpeggioData ));

          ArpStr->tcia_Data = NewArpData;
          ArpStr->tcia_Entries = NewLen;
        }

        return ( 0L );
      }

      return ( ERROR_INSTR_ENVBIG );
    }

    return ( 0L );
  }

  return ( ERROR_INSTR_NOENVL );
}
