/* TuComposer OS independent code
**
** $VER: InsertEnvPoint.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG InsertEnvPoint ( struct TuComposerInstrEnvelope *EnvStr,
    unsigned long Point, unsigned long Points, unsigned long Flags )
{
  if ( EnvStr )
  {
    WORD *EnvData = EnvStr->tcie_Data;

    if ( Points )
    {
      ULONG EnvLen = EnvStr->tcie_NumPoints, NewLen;

      if (Flags & ENVF_PointsOnly)
      {
        if ( Point >= EnvLen )
          Point = EnvLen - 1;

        if ( (Point + Points) > EnvLen )
          Points = EnvLen - Point;

        memcpy ( EnvData + Point + Points, EnvData + Point, ((EnvLen - Point) - Points) * sizeof (WORD));
        memset ( EnvData + Point, 0, Points * sizeof (WORD));

        return ( 0L );
      }

      if ( (NewLen = (EnvLen + Points)) < 0x10000 )
      {
        if ( Point >= NewLen )
        {
          AddEnvPoint ( EnvStr, Points );
        } else
        {
          UWORD *NodePoints = EnvStr->tcie_NodePoints;
          WORD *NewEnvData;
          ULONG NumNodes = EnvStr->tcie_NumNodes;

          if (!( NewEnvData = (WORD *) AllocPMem ( NewLen * sizeof (WORD))))
            return ( ERROR_INSTR_ENVLMEM );

          if ( Point )
            memcpy ( NewEnvData, EnvData, Point * sizeof (WORD));

          memcpy ( NewEnvData + Point + Points, EnvData + Point, (EnvLen - (Point + Points)) * sizeof (WORD));

          FreePMem ( EnvData, EnvLen * sizeof (WORD));

          EnvStr->tcie_Data = NewEnvData;
          EnvStr->tcie_NumPoints = NewLen;

          if ( NumNodes )
          {
            ULONG i;
            UWORD NodeVal;

            for (i = NumNodes; i > 0; i--)
            {
              if ( (NodeVal = *NodePoints) >= Point )
                NodeVal += Points;

              *NodePoints++ = NodeVal;
            }
          }
        }

        return ( 0L );
      }

      return ( ERROR_INSTR_ENVBIG );
    }

    return ( 0L );
  }

  return ( ERROR_INSTR_NOENVL );
}
