/* TuComposer OS independent code
**
** $VER: InsertInstr.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG InsertInstr ( struct TuComposerModule *ModuleStr,
    struct TuComposerInstr *InstrStr, struct TuComposerInstr *InstrPos )
{
  if ( ModuleStr )
  {
    if ( InstrStr )
    {
      struct TuComposerSong *SongStr;
      struct TuComposerInstr *InstrScan;
      struct TuComposerInstrKeyboard *KeybrdStr;
      ULONG NumInstr;

      NumInstr = GetInstrNum ( ModuleStr, InstrPos );

      InstrScan = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head );

      for (;;)
      {
        InstrScan = (struct TuComposerInstr *) InstrScan->tci_Node.mln_Succ;

        if (!( InstrScan->tci_Node.mln_Succ ))
          break;

        if ( InstrScan->tci_CompFlags & TCICF_SeparateSamples )
        {
          KeybrdStr = InstrScan->tci_KeyboardDefs;

          if ( KeybrdStr )
          {
            struct KeyboardEntry *KeybrdEntry = (struct KeyboardEntry *) &(KeybrdStr->tcik_NoteEntry[0]);
            ULONG i;

            if (!( KeybrdEntry->tcik_Octave_C_0 & 0x80 ))
            {
              KeybrdEntry->tcik_Octave_C_0 |= 0x80;

              for (i = (NUMOCTAVES * NUMNOTES); i > 0; i--)
              {
                if ( KeybrdEntry->tcik_Sample_C_0 >= NumInstr )
                  KeybrdEntry->tcik_Sample_C_0++;

                KeybrdEntry++;
              }
            }
          }
        }

        KeybrdStr = (struct TuComposerInstrKeyboard *) &(ModuleStr->tcm_KeyboardDefs.mlh_Head);

        for (;;)
        {
          KeybrdStr = (struct TuComposerInstrKeyboard *) KeybrdStr->tcik_Node.mln_Succ;

          if (!( KeybrdStr->tcik_Node.mln_Succ ))
            break;

          KeybrdStr->tcik_NoteEntry[0].tcik_Octave_C_0 &= 0x7F;
        }

        SongStr = (struct TuComposerSong *) &(ModuleStr->tcm_SongList.mlh_Head);

        for (;;)
        {
          struct TuComposerTrack *TrackStr;

          SongStr = (struct TuComposerSong *) SongStr->tcso_Node.mln_Succ;

          if (!( SongStr->tcso_Node.mln_Succ ))
            break;

          TrackStr = (struct TuComposerTrack *) &(SongStr->tcso_TrackList.mlh_Head);

          for (;;)
          {
            struct TuComposerTrackData *TrackData;
            ULONG i;

            TrackStr = (struct TuComposerTrack *) TrackStr->tct_Node.mln_Succ;

            if (!( TrackStr->tct_Node.mln_Succ ))
              break;

            TrackData = TrackStr->tct_Data;

            for (i = (TrackStr->tct_Length + 1); i > 0; i--)
            {
              if ( TrackData->tctd_Instrument >= NumInstr )
                TrackData->tctd_Instrument++;

              TrackData++;
            }
          }
        }
      }

      InsertNode ( (struct List *) &(ModuleStr->tcm_InstrList), (struct Node *) InstrStr, (struct Node *) InstrPos);

      return ( 0L );
    }

    return ( ERROR_INSTR_NOGIVEN );
  }

  return ( ERROR_MODULE_NOGIVEN );
}
