/* TuComposer OS independent code
**
** $VER: InsertInstrUnknownChunk.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifndef MOTOROLA
  ULONG ReadMLong ( UBYTE *Buffer );
#else
  #define ReadMLong( Buffer ) (*(ULONG *) (Buffer))
#endif

#ifdef __cplusplus
}
#endif

ULONG InsertInstrUnknownChunk ( struct TuComposerInstr *InstrStr,
    struct UnknownChunk *UnknownChunkStr,
    struct UnknownChunk *UnknownChunkPos )
{
  if ( InstrStr )
  {
    if ( UnknownChunkStr )
    {
      struct UnknownChunk *ScanChunkStr;

      ScanChunkStr = (struct UnknownChunk *) &(InstrStr->tci_UnknownChunks);

      for (;;)
      {
        ScanChunkStr = (struct UnknownChunk *) ScanChunkStr->uc_Node.mln_Succ;

        if (!( ScanChunkStr->uc_Node.mln_Succ ))
          break;

        if ( *(ULONG *) &(ScanChunkStr->uc_Identifier[0]) == *(ULONG *) &(UnknownChunkStr->uc_Identifier[0]) )
        {
          if ( (ReadMLong ( (UBYTE *) &(ScanChunkStr->uc_Identifier[0]))) == 'FORM' )
          {
            if ( ScanChunkStr->uc_Data == UnknownChunkStr->uc_Data )
            {
              UnknownChunkPos = (struct UnknownChunk *) ScanChunkStr->uc_Node.mln_Succ;

              FreeUnknownChunk ( ScanChunkStr );
              break;
            }
          } else
          {
            UnknownChunkPos = (struct UnknownChunk *) ScanChunkStr->uc_Node.mln_Succ;

            FreeUnknownChunk ( ScanChunkStr );
            break;
          }
        }
      }

      InsertNode ( (struct List *) &(InstrStr->tci_UnknownChunks), (struct Node *) UnknownChunkStr, (struct Node *) UnknownChunkPos );

      return ( 0L );
    }

    return ( ERROR_INSTR_NODATA );
  }

  return ( ERROR_INSTR_NOGIVEN );
}
