/* TuComposer OS independent code
**
** $VER: JoinEnvelope.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG JoinEnvelope ( struct TuComposerInstrEnvelope *SrcEnvStr,
    struct TuComposerInstrEnvelope *DestEnvStr )
{
  if ( SrcEnvStr && DestEnvStr )
  {
    WORD *SrcEnvData;
    WORD *DestEnvData;
    ULONG SrcLen, DestLen, NewLen, RC;

    if ( (SrcEnvData = SrcEnvStr->tcie_Data ) && (DestEnvData = DestEnvStr->tcie_Data ))
    {
      SrcLen = SrcEnvStr->tcie_NumPoints;
      DestLen = DestEnvStr->tcie_NumPoints;

      if ( (NewLen = (SrcLen + DestLen)) < 0x10000 )
      {
        if (!( RC = AddEnvPoint ( SrcEnvStr, DestLen )))
        {
          memcpy ( SrcEnvStr->tcie_Data + SrcLen, DestEnvData, DestLen * sizeof (WORD));

          SrcLen = SrcEnvStr->tcie_NumNodes;
          DestLen = DestEnvStr->tcie_NumNodes;

          if ( (NewLen = (SrcLen + DestLen )))
          {
            UWORD *NodePoints;

            if ( (NodePoints = (UWORD *) AllocPMem ( NewLen * sizeof (UWORD))))
            {
              if ( SrcLen )
                memcpy ( NodePoints, SrcEnvStr->tcie_NodePoints, SrcLen * sizeof (UWORD));

              if ( DestLen )
                memcpy ( NodePoints + SrcLen, DestEnvStr->tcie_NodePoints, DestLen * sizeof (UWORD));

              FreePMem ( SrcEnvStr->tcie_NodePoints, SrcLen * sizeof (UWORD));

              SrcEnvStr->tcie_NodePoints = NodePoints;

              if ( SrcLen )
              {
                ULONG i;
                UWORD EnvNode;

                NodePoints += SrcLen;

                for (i = DestLen; i > 0; i--)
                {
                  EnvNode = *NodePoints;
                  *NodePoints++ = EnvNode + SrcLen;
                }
              }
            }

            return ( ERROR_INSTR_ENVLMEM );
          }
        }

        return ( RC );
      }

      return ( ERROR_INSTR_ENVBIG );
    }

    return ( ERROR_INSTR_ENVDATA );
  }

  return ( ERROR_INSTR_NOENVL );
}
