/* TuComposer OS independent code
**
** $VER: PlayInstr.c 31.22 (10.8.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

extern struct TuComposerBase *TuCBase;
extern struct SoundDeviceInfo *InternalSoundDeviceBase;

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

ULONG PlayInstr ( struct TuComposerInstr *InstrStr, union FlagPass *FlagPassStr,
    unsigned long Channel, unsigned long Note,
    unsigned long Volume )
{
  if ( InstrStr )
  {
    if ( TuCBase->tcb_PlayModule )
    {
      struct TuComposerSong *SongStr;

      if ( (SongStr = TuCBase->tcb_PlaySong) )
      {
        struct PlayerGlobals *PGStr = SongStr->tcso_GlobalData;
        struct PlayerHostChannel *PHCStr = SongStr->tcso_ChannelData;
        struct SoundDeviceInfo *ExtDeviceLibBase;

        if (!( ExtDeviceLibBase = TuCBase->tcb_PlaySoundDeviceBase ))
          ExtDeviceLibBase = (struct SoundDeviceInfo *) &(InternalSoundDeviceBase);

        TuCBase->tcb_PlaySoundDeviceBase = ExtDeviceLibBase;

        if ( Channel >= SongStr->tcso_Channels )
          return ( 0L );

        PHCStr += Channel;

        Disable ();

        PHCStr->phc_Flags &= ~PHCF_SetSample;
        PHCStr->phc_Flags |= PHCF_SetInstr;

        PHCStr->phc_Instrument = InstrStr;
        PHCStr->phc_InstrNote = Note;
        PHCStr->phc_SampleNote = Volume;

        if ( (!( PGStr->pg_PlayType & PTYPF_Song )) && (!( PGStr->pg_Flags & PGF_PlayPattern )) )
        {
          PGStr->pg_Flags |= PGF_NoProcPattern;

          Enable ();

          return ( PlaySoundDevice ( ExtDeviceLibBase->sdi_Library.extb_ExtLibList, TuCBase->tcb_PlayMixerAlloc, FlagPassStr ));
        }

        Enable ();

        return ( 0L );
      }

      return ( ERROR_SONG_NOGIVEN );
    }

    return ( ERROR_MODULE_NOGIVEN );
  }

  return ( ERROR_INSTR_NOGIVEN );
}
