/* TuComposer OS independent code
**
** $VER: ReMapArpeggio.c 31.22 (10.2.99)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG ReMapArpeggio ( struct TuComposerInstrArpeggio *ArpStr,
    struct TuComposerInstrArpeggio *NewArpStr )
{
  if ( ArpStr && NewArpStr )
  {
    if ( ArpStr != NewArpStr )
    {
      struct TuComposerInstrArpeggioData *ArpData;
      struct TuComposerModule *ModuleStr = (struct TuComposerModule *) &(ArpStr->tcia_Node.mln_Succ);
      struct TuComposerSong *SongStr;

      if ( ArpStr->tcia_Node.mln_Succ )
      {
        struct TuComposerInstr *InstrStr;

        for (;;)
        {
          ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

          if (!( ModuleStr->tcm_Node.mln_Pred ))
            break;
        }

        (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_ArpEnvList );

        InstrStr = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head);

        for (;;)
        {
          InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Succ;

          if (!( InstrStr->tci_Node.mln_Succ ))
            break;

          if ( InstrStr->tci_ArpeggioStructure == ArpStr )
            InstrStr->tci_ArpeggioStructure = NewArpStr;
        }

        DeleteArpeggio ( ArpStr );
      }

      if ( (SongStr = TuCBase->tcb_PlaySong) )
      {
        struct PlayerHostChannel *PHCStr = SongStr->tcso_ChannelData;
        ULONG i;

        Disable ();

        for (i = SongStr->tcso_Channels; i > 0; i--)
        {
          if ( PHCStr->phc_ArpStructure.pes_EnvelopeStructure == (struct TuComposerInstrEnvelope *) ArpStr )
            PHCStr->phc_ArpStructure.pes_EnvelopeStructure = (struct TuComposerInstrEnvelope *) NewArpStr;

          PHCStr++;
        }

        Enable ();
      }

      if ( (ArpData = ArpStr->tcia_Data ))
        FreePMem ( ArpData, ArpStr->tcia_Entries * sizeof (struct TuComposerInstrArpeggioData));

      memcpy ( &(NewArpStr->tcia_Flags), &(ArpStr->tcia_Flags), offsetof (struct TuComposerInstrArpeggio, tcia_Reserved) - offsetof (struct TuComposerInstrArpeggio, tcia_Flags ));

      FreePMem ( ArpStr, sizeof (struct TuComposerInstrArpeggio ));
    }

    return ( 0L );
  }

  return ( ERROR_INSTR_NOENVL );
}
