/* TuComposer OS independent code
**
** $VER: ReMapEnvelope.c 31.22 (10.2.99)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG ReMapEnvelope ( struct TuComposerInstrEnvelope *EnvStr,
    struct TuComposerInstrEnvelope *NewEnvStr )
{
  if ( EnvStr && NewEnvStr )
  {
    if ( EnvStr != NewEnvStr )
    {
      struct TuComposerModule *ModuleStr = (struct TuComposerModule *) &(EnvStr->tcie_Node.mln_Succ);
      struct TuComposerSong *SongStr;
      WORD *EnvPoints;
      UWORD *EnvNodes;

      if ( EnvStr->tcie_Node.mln_Succ )
      {
        struct TuComposerInstr *InstrStr;

        for (;;)
        {
          ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

          if (!( ModuleStr->tcm_Node.mln_Pred ))
            break;
        }

        (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_Envelopes );

        InstrStr = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head);

        for (;;)
        {
          struct TuComposerInstrEnvelope **Envelopes;
          struct TuComposerSample *SampleStr;
          ULONG i;

          InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Succ;

          if (!( InstrStr->tci_Node.mln_Succ ))
            break;

          Envelopes = (struct TuComposerInstrEnvelope **) &(InstrStr->tci_VolumeEnvelope);

          for (i = (offsetof (struct TuComposerInstr, tci_ArpeggioStructure) - offsetof (struct TuComposerInstr, tci_VolumeEnvelope )) / sizeof ( APTR ); i > 0; i--)
          {
            if ( *Envelopes == EnvStr )
              *Envelopes = NewEnvStr;

            Envelopes++;
          }

          SampleStr = (struct TuComposerSample *) &(InstrStr->tci_Samples.mlh_Head);

          for (;;)
          {
            SampleStr = (struct TuComposerSample *) SampleStr->tcs_Node.mln_Succ;

            if (!( SampleStr->tcs_Node.mln_Succ ))
              break;

            if ( SampleStr->tcs_AutoVibratoEnv == EnvStr )
              SampleStr->tcs_AutoVibratoEnv = NewEnvStr;

            if ( SampleStr->tcs_AutoTremoloEnv == EnvStr )
              SampleStr->tcs_AutoTremoloEnv = NewEnvStr;

            if ( SampleStr->tcs_AutoPannoloEnv == EnvStr )
              SampleStr->tcs_AutoPannoloEnv = NewEnvStr;
          }
        }

        DeleteEnvelope ( EnvStr );
      }

      if ( (SongStr = TuCBase->tcb_PlaySong) )
      {
        struct PlayerHostChannel *PHCStr = SongStr->tcso_ChannelData;
        ULONG i;

        Disable ();

        for (i = SongStr->tcso_Channels; i > 0; i--)
        {
          if ( PHCStr->phc_VibratoEnv.pes_EnvelopeStructure == EnvStr )
            PHCStr->phc_VibratoEnv.pes_EnvelopeStructure = NewEnvStr;

          if ( PHCStr->phc_TremoloEnv.pes_EnvelopeStructure == EnvStr )
            PHCStr->phc_TremoloEnv.pes_EnvelopeStructure = NewEnvStr;

          if ( PHCStr->phc_PannoloEnv.pes_EnvelopeStructure == EnvStr )
            PHCStr->phc_PannoloEnv.pes_EnvelopeStructure = NewEnvStr;

          if ( PHCStr->phc_ChannoloEnv.pes_EnvelopeStructure == EnvStr )
            PHCStr->phc_ChannoloEnv.pes_EnvelopeStructure = NewEnvStr;

          if ( PHCStr->phc_TrackTremEnv.pes_EnvelopeStructure == EnvStr )
            PHCStr->phc_TrackTremEnv.pes_EnvelopeStructure = NewEnvStr;

          if ( PHCStr->phc_TrackPanEnv.pes_EnvelopeStructure == EnvStr )
            PHCStr->phc_TrackPanEnv.pes_EnvelopeStructure = NewEnvStr;

          if ( PHCStr->phc_PrevVolumeEnv == EnvStr )
            PHCStr->phc_PrevVolumeEnv = NewEnvStr;

          if ( PHCStr->phc_PrevPanningEnv == EnvStr )
            PHCStr->phc_PrevPanningEnv = NewEnvStr;

          if ( PHCStr->phc_PrevSlideEnv == EnvStr )
            PHCStr->phc_PrevSlideEnv = NewEnvStr;

          if ( PHCStr->phc_PrevAutoVibEnv == EnvStr )
            PHCStr->phc_PrevAutoVibEnv = NewEnvStr;

          if ( PHCStr->phc_PrevAutoTremEnv == EnvStr )
            PHCStr->phc_PrevAutoTremEnv = NewEnvStr;

          if ( PHCStr->phc_PrevAutoPanEnv == EnvStr )
            PHCStr->phc_PrevAutoPanEnv = NewEnvStr;

          PHCStr++;
        }

        Enable ();
      }

      if ( (ModuleStr = TuCBase->tcb_PlayModule) )
      {
        struct PlayerChannel *PCStr = ModuleStr->tcm_ChannelData;
        ULONG i;

        Disable ();

        for (i = ModuleStr->tcm_Channels; i > 0; i--)
        {
          if ( PCStr->pc_VolEnvelope.pes_EnvelopeStructure == EnvStr )
            PCStr->pc_VolEnvelope.pes_EnvelopeStructure = NewEnvStr;

          if ( PCStr->pc_PanEnvelope.pes_EnvelopeStructure == EnvStr )
            PCStr->pc_PanEnvelope.pes_EnvelopeStructure = NewEnvStr;

          if ( PCStr->pc_SlideEnvelope.pes_EnvelopeStructure == EnvStr )
            PCStr->pc_SlideEnvelope.pes_EnvelopeStructure = NewEnvStr;

          if ( PCStr->pc_AutoVibEnv.pes_EnvelopeStructure == EnvStr )
            PCStr->pc_AutoVibEnv.pes_EnvelopeStructure = NewEnvStr;

          if ( PCStr->pc_AutoTremoEnv.pes_EnvelopeStructure == EnvStr )
            PCStr->pc_AutoTremoEnv.pes_EnvelopeStructure = NewEnvStr;

          if ( PCStr->pc_AutoPanEnv.pes_EnvelopeStructure == EnvStr )
            PCStr->pc_AutoPanEnv.pes_EnvelopeStructure = NewEnvStr;

          PCStr++;
        }

        Enable ();
      }

      ClearEnvelope ( NewEnvStr, ENVL_EMPTY, 0L, 0L );

      if ( (EnvNodes = EnvStr->tcie_NodePoints ))
        FreePMem ( EnvNodes, EnvStr->tcie_NumNodes * sizeof (UWORD));

      if ( (EnvPoints = EnvStr->tcie_Data ))
        FreePMem ( EnvPoints, EnvStr->tcie_NumPoints * sizeof (WORD));

      ReMapNodeList ( (struct List *) &(EnvStr->tcie_UnknownChunks), (struct List *) &(NewEnvStr->tcie_UnknownChunks));

      memcpy ( &(NewEnvStr->tcie_Flags), &(EnvStr->tcie_Flags), offsetof (struct TuComposerInstrEnvelope, tcie_UnknownChunks) - offsetof (struct TuComposerInstrEnvelope, tcie_Flags ));

      FreePMem ( EnvStr, sizeof (struct TuComposerInstrEnvelope ));
    }

    return ( 0L );
  }

  return ( ERROR_INSTR_NOENVL );
}
