/* TuComposer OS independent code
**
** $VER: ReMapKeyboard.c 31.22 (10.2.99)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ReMapKeyboard ( struct TuComposerInstrKeyboard *KeybrdStr,
    struct TuComposerInstrKeyboard *NewKeybrdStr )
{
  if ( KeybrdStr && NewKeybrdStr )
  {
    if ( KeybrdStr != NewKeybrdStr )
    {
      struct TuComposerModule *ModuleStr = (struct TuComposerModule *) &(KeybrdStr->tcik_Node.mln_Succ);

      if ( KeybrdStr->tcik_Node.mln_Succ )
      {
        struct TuComposerInstr *InstrStr;

        for (;;)
        {
          ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

          if (!( ModuleStr->tcm_Node.mln_Pred ))
            break;
        }

        (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_KeyboardDefs );

        InstrStr = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head);

        for (;;)
        {
          InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Succ;

          if (!( InstrStr->tci_Node.mln_Succ ))
            break;

          if ( InstrStr->tci_KeyboardDefs == KeybrdStr )
            InstrStr->tci_KeyboardDefs = NewKeybrdStr;
        }

        DeleteKeyboard ( KeybrdStr );
      }

      memcpy ( &(NewKeybrdStr->tcik_NoteEntry[0]), &(KeybrdStr->tcik_NoteEntry[0]), sizeof (struct TuComposerInstrKeyboard) - offsetof (struct TuComposerInstrKeyboard, tcik_NoteEntry ));

      FreePMem ( KeybrdStr, sizeof (struct TuComposerInstrKeyboard ));
    }

    return ( 0L );
  }

  return ( ERROR_INSTR_NOENVL );
}
