/* TuComposer OS independent code
**
** $VER: RemArpeggioTick.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG RemArpeggioTick ( struct TuComposerInstrArpeggio *ArpStr,
    unsigned long Ticks )
{
  if ( ArpStr )
  {
    ULONG OldLength;

    OldLength = ArpStr->tcia_Entries;

    if ( Ticks < OldLength )
    {
      struct TuComposerInstrArpeggioData *NewArpData;
      ULONG Length;

      Length = OldLength - Ticks;

      if ( NewArpData = (struct TuComposerInstrArpeggioData *) AllocPMem ( Length * sizeof (struct TuComposerInstrArpeggioData )))
      {
        ULONG LoopStart, LoopEnd;

        memcpy ( NewArpData, ArpStr->tcia_Data, Length * sizeof (struct TuComposerInstrArpeggioData ));

        FreePMem ( ArpStr->tcia_Data, OldLength * sizeof (struct TuComposerInstrArpeggioData ));

        ArpStr->tcia_Entries = Length;
        ArpStr->tcia_Data = NewArpData;

        if ( (LoopStart = ArpStr->tcia_SustainStart) >= Length )
        {
          LoopStart = Length - 1;
          ArpStr->tcia_SustainStart = LoopStart;
        }

        if ( (LoopEnd = ArpStr->tcia_SustainEnd) >= Length );
        {
          LoopEnd = Length - 1;
          ArpStr->tcia_SustainEnd = LoopEnd;
        }

        if ( LoopEnd < LoopStart )
          ArpStr->tcia_SustainEnd = LoopStart;

        if ( (LoopStart = ArpStr->tcia_LoopStart) >= Length )
        {
          LoopStart = Length - 1;
          ArpStr->tcia_LoopStart = LoopStart;
        }

        if ( (LoopEnd = ArpStr->tcia_LoopEnd) >= Length );
        {
          LoopEnd = Length - 1;
          ArpStr->tcia_LoopEnd = LoopEnd;
        }

        if ( LoopEnd < LoopStart )
          ArpStr->tcia_LoopEnd = LoopStart;

        return ( 0L );
      }

      return ( ERROR_INSTR_ENVLMEM );
    }

    return ( ERROR_INSTR_ENVLESS );
  }

  return ( ERROR_INSTR_NOENVL );
}
