/* TuComposer OS independent code
**
** $VER: RemEnvPoint.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG RemEnvPoint ( struct TuComposerInstrEnvelope *EnvStr,
    unsigned long Points )
{
  if ( EnvStr )
  {
    ULONG OldLength;

    OldLength = EnvStr->tcie_NumPoints;

    if ( Points < OldLength )
    {
      WORD *NewEnvData;
      ULONG Length;

      Length = OldLength - Points;

      if ( NewEnvData = (WORD *) AllocPMem ( Length * sizeof (WORD)))
      {
        UWORD *NodePoints;
        ULONG LoopStart, LoopEnd;

        memcpy ( NewEnvData, EnvStr->tcie_Data, Length * sizeof (WORD));

        FreePMem ( EnvStr->tcie_Data, OldLength * sizeof (WORD));

        EnvStr->tcie_NumPoints = Length;
        EnvStr->tcie_Data = NewEnvData;

        if ( (LoopStart = EnvStr->tcie_SustainStart) >= Length )
        {
          LoopStart = Length - 1;
          EnvStr->tcie_SustainStart = LoopStart;
        }

        if ( (LoopEnd = EnvStr->tcie_SustainEnd) >= Length );
        {
          LoopEnd = Length - 1;
          EnvStr->tcie_SustainEnd = LoopEnd;
        }

        if ( LoopEnd < LoopStart )
          EnvStr->tcie_SustainEnd = LoopStart;

        if ( (LoopStart = EnvStr->tcie_LoopStart) >= Length )
        {
          LoopStart = Length - 1;
          EnvStr->tcie_LoopStart = LoopStart;
        }

        if ( (LoopEnd = EnvStr->tcie_LoopEnd) >= Length );
        {
          LoopEnd = Length - 1;
          EnvStr->tcie_LoopEnd = LoopEnd;
        }

        if ( LoopEnd < LoopStart )
          EnvStr->tcie_LoopEnd = LoopStart;

        if ( (NodePoints = EnvStr->tcie_NodePoints ))
        {
          ULONG NumNodes = EnvStr->tcie_NumNodes, i, NewLen = 0L;
          UWORD EnvNode;

          for (i = NumNodes; i > 0; i--)
          {
            NewLen++;

            EnvNode = *NodePoints++;

            if ( EnvNode >= Length )
              break;
          }

          if ( i > 0L )
          {
            if ( NewLen == 1 )
              NewLen++;

            if ( (NodePoints = (UWORD *) AllocPMem ( NewLen * sizeof (UWORD))))
            {
              EnvStr->tcie_NumNodes = NewLen;

              NewLen--;

              memcpy ( NodePoints, EnvStr->tcie_NodePoints, NewLen * sizeof (WORD));

              NodePoints[NewLen] = Length - 1;
            }

            return ( ERROR_INSTR_ENVLMEM );
          }
        }

        return ( 0L );
      }

      return ( ERROR_INSTR_ENVLMEM );
    }

    return ( ERROR_INSTR_ENVLESS );
  }

  return ( ERROR_INSTR_NOENVL );
}
