/* TuComposer OS independent code
**
** $VER: RotateArpeggio.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG RotateArpeggio ( struct TuComposerInstrArpeggio *ArpStr, long Ticks,
    unsigned long StartTick, unsigned long EndTick )
{
  if ( ArpStr )
  {
    struct TuComposerInstrArpeggioData *ArpData = ArpStr->tcia_Data;
    struct TuComposerInstrArpeggioData *RotateData;
    struct TuComposerInstrArpeggioData *RotateBuf;
    struct TuComposerInstrArpeggioData *StartData;
    struct TuComposerInstrArpeggioData *EndData;
    struct TuComposerInstrArpeggioData *TmpData;
    ULONG Length, i;
    LONG TmpTick, RotateCnt;

    Length = ArpStr->tcia_Entries;

    if ( StartTick > EndTick )
    {
      TmpTick = StartTick;
      StartTick = EndTick;
      EndTick = TmpTick;
    }

    if ( StartTick >= Length )
      StartTick = Length - 1;

    if ( EndTick >= Length )
      EndTick = Length - 1;

    TmpTick = (EndTick - StartTick) + 1;

    if ( (RotateCnt = (Ticks % TmpTick)) )
    {
      if ( (RotateData = (struct TuComposerInstrArpeggioData *) AllocPMem ( TmpTick * sizeof (struct TuComposerInstrArpeggioData ))))
      {
        if ( RotateCnt > 0 )
        {
          RotateBuf = RotateData + RotateCnt;
          StartData = ArpData + StartTick;
          EndData = RotateData + TmpTick;

          for (i = TmpTick; i > 0; i--)
          {
            memcpy ( RotateBuf, StartData, sizeof (struct TuComposerInstrArpeggioData ));

            StartData++;
            RotateBuf++;

           if ( EndData == RotateBuf )
              RotateBuf = RotateData;
          }
        } else
        {
          RotateCnt = -RotateCnt;

          RotateBuf = RotateData;
          StartData = ArpData + StartTick;
          EndData = ArpData + (EndTick + 1);
          TmpData = StartData + RotateCnt;

          for (i = TmpTick; i > 0; i--)
          {
            memcpy ( RotateBuf, TmpData, sizeof (struct TuComposerInstrArpeggioData ));

            TmpData++;
            RotateBuf++;

            if ( EndData == TmpData )
              TmpData = StartData;
          }
        }

        ArpData += StartTick;
        RotateBuf = RotateData;

        for (i = TmpTick; i > 0; i--)
        {
          memcpy ( ArpData, RotateBuf, sizeof (struct TuComposerInstrArpeggioData ));

          ArpData++;
          RotateBuf++;
        }

        FreePMem ( RotateData, TmpTick * sizeof (struct TuComposerInstrArpeggioData ));

        return ( 0L );
      }

      return ( ERROR_INSTR_ENVLMEM );
    }

    return ( 0L );
  }

  return ( ERROR_INSTR_NOENVL );
}
