/* TuComposer OS independent code
**
** $VER: RotateEnvelope.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG RotateEnvelope ( struct TuComposerInstrEnvelope *EnvStr, long Points,
    unsigned long StartPoint, unsigned long EndPoint )
{
  if ( EnvStr )
  {
    WORD *EnvData;
    WORD *RotateData;
    WORD *RotateBuf;
    WORD *StartData;
    WORD *EndData;
    WORD *TmpData;
    ULONG Length, i;
    LONG TmpPoint, RotateCnt;

    if ( (EnvData = EnvStr->tcie_Data ))
    {
      Length = EnvStr->tcie_NumPoints;

      if ( StartPoint > EndPoint )
      {
        TmpPoint = StartPoint;
        StartPoint = EndPoint;
        EndPoint = TmpPoint;
      }

      if ( StartPoint >= Length )
        StartPoint = Length - 1;

      if ( EndPoint >= Length )
        EndPoint = Length - 1;

      TmpPoint = (EndPoint - StartPoint) + 1;

      if ( (RotateCnt = (Points % TmpPoint)) )
      {
        if ( (RotateData = (WORD *) AllocPMem ( TmpPoint * sizeof (WORD))))
        {
          if ( RotateCnt > 0 )
          {
            RotateBuf = RotateData + RotateCnt;
            StartData = EnvData + StartPoint;
            EndData = RotateData + TmpPoint;

            for (i = TmpPoint; i > 0; i--)
            {
              *RotateBuf++ = *StartData++;

             if ( EndData == RotateBuf )
                RotateBuf = RotateData;
            }
          } else
          {
            RotateCnt = -RotateCnt;

            RotateBuf = RotateData;
            StartData = EnvData + StartPoint;
            EndData = EnvData + (EndPoint + 1);
            TmpData = StartData + RotateCnt;

            for (i = TmpPoint; i > 0; i--)
            {
              *RotateBuf++ = *TmpData++;

              if ( EndData == TmpData )
                TmpData = StartData;
            }
          }

          memcpy ( EnvData + StartPoint, RotateData, TmpPoint * sizeof (WORD));

          FreePMem ( RotateData, TmpPoint * sizeof (WORD));

          return ( 0L );
        }

        return ( ERROR_INSTR_ENVLMEM );
      }

      return ( 0L );
    }

    return ( ERROR_INSTR_ENVDATA );
  }

  return ( ERROR_INSTR_NOENVL );
}
