/* TuComposer OS independent code
**
** $VER: ScrollArpeggio.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ScrollArpeggio ( struct TuComposerInstrArpeggio *ArpStr, long Ticks,
    unsigned long StartTick, unsigned long EndTick )
{
  if ( ArpStr )
  {
    struct TuComposerInstrArpeggioData *ArpData = ArpStr->tcia_Data;
    ULONG Length, TmpTick;

    Length = ArpStr->tcia_Entries;

    if ( StartTick > EndTick )
    {
      TmpTick = StartTick;
      StartTick = EndTick;
      EndTick = TmpTick;
    }

    if ( StartTick >= Length )
      StartTick = Length - 1;

    if ( EndTick >= Length )
      EndTick = Length - 1;

    if ( Ticks )
    {
      TmpTick = (EndTick - StartTick) + 1;

      if ( Ticks > 0 )
      {
        if ( TmpTick < Ticks )
          Ticks = TmpTick;

        if ( TmpTick > Ticks )
          memcpy ( ArpData + StartTick + Ticks, ArpData + StartTick, (TmpTick - Ticks) * sizeof (struct TuComposerInstrArpeggioData ));

        memset ( ArpData + StartTick, 0, Ticks * sizeof (struct TuComposerInstrArpeggioData ));
      } else
      {
        Ticks = -Ticks;

        if ( TmpTick < Ticks )
          Ticks = TmpTick;

        if ( TmpTick > Ticks )
          memcpy ( ArpData + StartTick, ArpData + StartTick + Ticks, (TmpTick - Ticks) * sizeof (struct TuComposerInstrArpeggioData ));

        memset ( ArpData + (EndTick - (Ticks - 1)), 0, Ticks * sizeof (struct TuComposerInstrArpeggioData ));
      }
    }

    return ( 0L );
  }

  return ( ERROR_INSTR_NOENVL );
}
