/* TuComposer OS independent code
**
** $VER: ScrollEnvelope.c 31.22 (19.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ScrollEnvelope ( struct TuComposerInstrEnvelope *EnvStr, long Points,
    unsigned long StartPoint, unsigned long EndPoint )
{
  if ( EnvStr )
  {
    WORD *EnvData;
    ULONG Length, TmpPoint;

    if ( (EnvData = EnvStr->tcie_Data ))
    {
      Length = EnvStr->tcie_NumPoints;

      if ( StartPoint > EndPoint )
      {
        TmpPoint = StartPoint;
        StartPoint = EndPoint;
        EndPoint = TmpPoint;
      }

      if ( StartPoint >= Length )
        StartPoint = Length - 1;

      if ( EndPoint >= Length )
        EndPoint = Length - 1;

      if ( Points )
      {
        TmpPoint = (EndPoint - StartPoint) + 1;

        if ( Points > 0 )
        {
          if ( TmpPoint < Points )
            Points = TmpPoint;

          if ( TmpPoint > Points )
            memcpy ( EnvData + StartPoint + Points, EnvData + StartPoint, (TmpPoint - Points) * sizeof (WORD));

          memset ( EnvData + StartPoint, 0, Points * sizeof (WORD));
        } else
        {
          Points = -Points;

          if ( TmpPoint < Points )
            Points = TmpPoint;

          if ( TmpPoint > Points )
            memcpy ( EnvData + StartPoint, EnvData + StartPoint + Points, (TmpPoint - Points) * sizeof (WORD));

          memset ( EnvData + (EndPoint - (Points - 1)), 0, Points * sizeof (WORD));
        }
      }

      return ( 0L );
    }

    return ( ERROR_INSTR_ENVDATA );
  }

  return ( ERROR_INSTR_NOENVL );
}
