/* TuComposer OS independent code
**
** $VER: SetKeyboard.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG SetKeyboard ( struct TuComposerInstrKeyboard *KeybrdStr,
    unsigned long SampleNum, unsigned long Octave, unsigned long Note,
    unsigned long NewOctave, unsigned long NewNote )
{
  if ( (Octave < NUMOCTAVES) && (NewOctave < NUMOCTAVES))
  {
    if ( ((Note > 0) && (Note <= LASTNOTE)) && ((NewNote > 0) && (NewNote <= LASTNOTE)))
    {
      Octave *= LASTNOTE;
      Octave += (Note - 1);

      KeybrdStr->tcik_NoteEntry[Octave].tcik_Sample_C_0 = SampleNum;
      KeybrdStr->tcik_NoteEntry[Octave].tcik_Octave_C_0 = NewOctave;
      KeybrdStr->tcik_NoteEntry[Octave].tcik_Note_C_0 = NewNote;

      return ( 0L );
    }

    return ( ERROR_MODULE_BADNOTE );
  }

  return ( ERROR_MODULE_BADOCTAVE );
}
