/* TuComposer OS independent code
**
** $VER: ShrinkArpeggio.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ShrinkArpeggio ( struct TuComposerInstrArpeggio *ArpStr,
    unsigned long Scale )
{
  if ( ArpStr )
  {
    struct TuComposerInstrArpeggioData *ArpData = ArpStr->tcia_Data;
    ULONG ArpLen;

    if ( Scale )
    {
      struct TuComposerInstrArpeggioData *NewArpData;
      ULONG NewLength;

      if ( Scale == 1)
        return ( 0L );

      ArpLen = ArpStr->tcia_Entries;

      if ((NewLength = (ArpLen / Scale)) == 0L)
        return ( ERROR_INSTR_ENVLESS );

      if (NewArpData = (struct TuComposerInstrArpeggioData *) AllocPMem ( NewLength * sizeof (struct TuComposerInstrArpeggioData )))
      {
        struct TuComposerInstrArpeggioData *SrcArpData;
        struct TuComposerInstrArpeggioData *DestArpData;
        ULONG Pos, ClrPos = 0L;

        SrcArpData = ArpData;
        DestArpData = NewArpData;

        for (Pos = ArpLen; Pos > 0; Pos--)
        {
          if ( ClrPos == NULL )
          {
            memcpy ( DestArpData, SrcArpData, sizeof (struct TuComposerInstrArpeggioData ));

            DestArpData++;
          }

          SrcArpData++;
          ClrPos++;

          if ( ClrPos == Scale )
            ClrPos = 0L;
        }

        FreePMem ( ArpData, ArpLen * sizeof (struct TuComposerInstrArpeggioData ));

        ArpStr->tcia_Data = NewArpData;
        ArpStr->tcia_Entries = NewLength;

        return ( 0L );
      }

      return ( ERROR_INSTR_ENVLMEM );
    }

    return ( ERROR_INSTR_ENVSCLR );
  }

  return( ERROR_INSTR_NOENVL );
}
