/* TuComposer OS independent code
**
** $VER: ShrinkEnvelope.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ShrinkEnvelope ( struct TuComposerInstrEnvelope *EnvStr,
    unsigned long Scale )
{
  if ( EnvStr )
  {
    WORD *EnvData;
    ULONG EnvLen;

    if ( (EnvData = EnvStr->tcie_Data ))
    {
      if ( Scale )
      {
        WORD *NewEnvData;
        ULONG NewLength;

        if ( Scale == 1)
          return ( 0L );

        EnvLen = EnvStr->tcie_NumPoints;

        if ((NewLength = (EnvLen / Scale)) == 0L)
          return ( ERROR_INSTR_ENVLESS );

        if (NewEnvData = (WORD *) AllocPMem ( NewLength * sizeof (WORD)))
        {
          UWORD *NodePoints;
          WORD *SrcEnvData;
          WORD *DestEnvData;
          ULONG Pos, ClrPos = 0L;

          SrcEnvData = EnvData;
          DestEnvData = NewEnvData;

          for (Pos = EnvLen; Pos > 0; Pos--)
          {
            if ( ClrPos == NULL )
              *DestEnvData++ = *SrcEnvData;

            SrcEnvData++;
            ClrPos++;

            if ( ClrPos == Scale )
              ClrPos = 0L;
          }

          FreePMem ( EnvData, EnvLen * sizeof (WORD));

          EnvStr->tcie_Data = NewEnvData;
          EnvStr->tcie_NumPoints = NewLength;

          if ( (NodePoints = EnvStr->tcie_NodePoints ))
          {
            ULONG NumNodes = EnvStr->tcie_NumNodes, i, NewLen = 0L;
            UWORD EnvNode, LastNode = 0xFFFF;

            for (i = NumNodes; i > 0; i--)
            {
              EnvNode = (*NodePoints / Scale);

              if ( i == 1 )
                EnvNode = NewLength - 1;

              if ( LastNode != EnvNode )
              {
                NewLen++;
                LastNode = EnvNode;
              }

              *NodePoints++ = EnvNode;
            }

            if ( NewLen < NumNodes )
            {
              if ( NewLen == 1 )
                NewLen++;

              if ( (NodePoints = (UWORD *) AllocPMem ( NewLen * sizeof (UWORD))))
              {
                UWORD *OldNodePtr = EnvStr->tcie_NodePoints;
                UWORD *OldNodeBuf = OldNodePtr;

                EnvStr->tcie_NodePoints = NodePoints;
                EnvStr->tcie_NumNodes = NewLen;

                for (i = NewLen; i > 0; i--)
                {
                  EnvNode = *OldNodeBuf++;
                  *NodePoints++ = EnvNode;

                  for (;;)
                  {
                    if ( (EnvNode != *OldNodeBuf++) )
                      break;
                  }

                  OldNodeBuf--;
                }

                NodePoints[-1] = NewLength - 1;

                FreePMem ( OldNodePtr, NumNodes * sizeof (WORD));

                return ( 0L );
              }

              return ( ERROR_INSTR_ENVLMEM );
            }
          }

          return ( 0L );
        }

        return ( ERROR_INSTR_ENVLMEM );
      }

      return ( ERROR_INSTR_ENVSCLR );
    }

    return ( ERROR_INSTR_ENVDATA );
  }

  return( ERROR_INSTR_NOENVL );
}
