/* TuComposer OS independent code
**
** $VER: SplitArpeggio.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerInstrArpeggio *SplitArpeggio (
    struct TuComposerInstrArpeggio *SrcArpStr,
    struct TuComposerInstrArpeggio *DestArpStr, unsigned long Tick )
{
  if ( SrcArpStr )
  {
    ULONG Length, SplitLen;

    Length = SrcArpStr->tcia_Entries;

    if ( (Tick >= Length) || (Tick == 0L) )
      return ( NULL );

    SplitLen = Length - Tick;

    if ( DestArpStr )
    {
      if ( ReSizeArpeggio ( DestArpStr, SplitLen ))
        return ( NULL );

    } else
    {
      if (!( DestArpStr = (struct TuComposerInstrArpeggio *) AllocArpeggio ( SplitLen )))
        return ( NULL );

    }

    memcpy ( DestArpStr->tcia_Data, SrcArpStr->tcia_Data + Tick, SplitLen * sizeof (struct TuComposerInstrArpeggioData ));

    ReSizeArpeggio ( SrcArpStr, Tick - 1);

    DestArpStr->tcia_Flags = SrcArpStr->tcia_Flags;
    memcpy ( &(SrcArpStr->tcia_SustainStart), &(DestArpStr->tcia_SustainStart), offsetof (struct TuComposerInstrArpeggio, tcia_Reserved) - offsetof (struct TuComposerInstrArpeggio, tcia_SustainStart));

    if ( (SrcArpStr->tcia_SustainStart >= Tick) || (SrcArpStr->tcia_SustainEnd >= Tick ))
    {
      SrcArpStr->tcia_SustainStart = 0;
      SrcArpStr->tcia_SustainEnd = 0;
      SrcArpStr->tcia_SustainCount = 0;
      SrcArpStr->tcia_Flags &= ~(TCIAF_Sustain|TCIAF_SustainPingpong);
    }

    if ( (SrcArpStr->tcia_LoopStart >= Tick) || (SrcArpStr->tcia_LoopEnd >= Tick ))
    {
      SrcArpStr->tcia_LoopStart = 0;
      SrcArpStr->tcia_LoopEnd = 0;
      SrcArpStr->tcia_LoopCount = 0;
      SrcArpStr->tcia_Flags &= ~(TCIAF_Loop|TCIAF_Pingpong);
    }

    if ( (DestArpStr->tcia_SustainStart < Tick) || (DestArpStr->tcia_SustainEnd < Tick ))
    {
      DestArpStr->tcia_SustainStart = 0;
      DestArpStr->tcia_SustainEnd = 0;
      DestArpStr->tcia_SustainCount = 0;
      DestArpStr->tcia_Flags &= ~(TCIAF_Sustain|TCIAF_SustainPingpong);
    }

    if ( (DestArpStr->tcia_LoopStart < Tick) || (DestArpStr->tcia_LoopEnd < Tick ))
    {
      DestArpStr->tcia_LoopStart = 0;
      DestArpStr->tcia_LoopEnd = 0;
      DestArpStr->tcia_LoopCount = 0;
      DestArpStr->tcia_Flags &= ~(TCIAF_Loop|TCIAF_Pingpong);
    }

    return ( DestArpStr );
  }

  return ( NULL );
}
