/* TuComposer OS independent code
**
** $VER: SwapArpeggioInModule.c 31.22 (12.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG SwapArpeggioInModule ( struct TuComposerInstrArpeggio *ArpBuf,
    struct TuComposerInstrArpeggio *ArpStr, unsigned long Flags )
{
  if ( ArpStr && ArpBuf )
  {
    if ( ArpStr != ArpBuf )
    {
      if ( Flags & SAIMF_Swap )
      {
        UBYTE *SrcBuf, *DestBuf;
        UBYTE TmpByte;
        ULONG i;

        SrcBuf = (UBYTE *) &(ArpStr->tcia_Flags);
        DestBuf = (UBYTE *) &(ArpBuf->tcia_Flags);

        for (i = (offsetof (struct TuComposerInstrArpeggio, tcia_Reserved) - offsetof (struct TuComposerInstrArpeggio, tcia_Flags)); i > 0; i--)
        {
          TmpByte = *DestBuf;
          *DestBuf++ = *SrcBuf;
          *SrcBuf++ = TmpByte;
        }
      }

      if ( Flags & SAIMF_Update )
      {
        struct TuComposerModule *ModuleStr = (struct TuComposerModule *) &(ArpStr->tcia_Node.mln_Succ);
        struct TuComposerInstr *InstrScan;

        for (;;)
        {
          ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

          if (!( ModuleStr->tcm_Node.mln_Pred ))
            break;
        }

        (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_ArpEnvList );

        InstrScan = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head );

        for (;;)
        {
          InstrScan = (struct TuComposerInstr *) InstrScan->tci_Node.mln_Succ;

          if (!( InstrScan->tci_Node.mln_Succ ))
            break;

          if ( InstrScan->tci_ArpeggioStructure == ArpStr )
          {
            InstrScan->tci_ArpeggioStructure = ArpBuf;
          } else if ( InstrScan->tci_ArpeggioStructure == ArpBuf )
          {
            InstrScan->tci_ArpeggioStructure = ArpStr;
          }
        }
      }
    }

    return ( 0L );
  }

  return ( ERROR_INSTR_NOENVL );
}
