/* TuComposer OS independent code
**
** $VER: SwapEnvelopeInModule.c 31.22 (12.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG SwapEnvelopeInModule ( struct TuComposerInstrEnvelope *EnvBuf,
    struct TuComposerInstrEnvelope *EnvStr, unsigned long Flags )
{
  if ( EnvStr && EnvBuf )
  {
    if ( EnvStr != EnvBuf )
    {
      if ( Flags & SEIMF_Swap )
      {
        struct MinList TmpUnkChunk;
        struct MinList SwapUnkChunk;
        UBYTE *SrcBuf, *DestBuf;
        UBYTE TmpByte;
        ULONG i;

        TmpUnkChunk = EnvBuf->tcie_UnknownChunks;
        ReMapNodeList ( (struct List *) &(EnvStr->tcie_UnknownChunks), (struct List *) &(EnvBuf->tcie_UnknownChunks));

        SwapUnkChunk = EnvBuf->tcie_UnknownChunks;
        EnvBuf->tcie_UnknownChunks = TmpUnkChunk;
        ReMapNodeList ( (struct List *) &(EnvBuf->tcie_UnknownChunks), (struct List *) &(EnvStr->tcie_UnknownChunks));

        EnvBuf->tcie_UnknownChunks = SwapUnkChunk;

        SrcBuf = (UBYTE *) &(EnvStr->tcie_Flags);
        DestBuf = (UBYTE *) &(EnvBuf->tcie_Flags);

        for (i = (offsetof (struct TuComposerInstrEnvelope, tcie_UnknownChunks) - offsetof (struct TuComposerInstrEnvelope, tcie_Flags)); i > 0; i--)
        {
          TmpByte = *DestBuf;
          *DestBuf++ = *SrcBuf;
          *SrcBuf++ = TmpByte;
        }
      }

      if ( Flags & SEIMF_Update )
      {
        struct TuComposerModule *ModuleStr = (struct TuComposerModule *) &(EnvStr->tcie_Node.mln_Succ);
        struct TuComposerInstr *InstrStr;

        for (;;)
        {
          ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

          if (!( ModuleStr->tcm_Node.mln_Pred ))
            break;
        }

        (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_Envelopes );

        InstrStr = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head);

        for (;;)
        {
          struct TuComposerInstrEnvelope **Envelopes;
          struct TuComposerSample *SampleStr;
          ULONG i;

          InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Succ;

          if (!( InstrStr->tci_Node.mln_Succ ))
            break;

          Envelopes = (struct TuComposerInstrEnvelope **) &(InstrStr->tci_VolumeEnvelope);

          for (i = (offsetof (struct TuComposerInstr, tci_ArpeggioStructure) - offsetof (struct TuComposerInstr, tci_VolumeEnvelope )) / sizeof ( APTR ); i > 0; i--)
          {
            if ( *Envelopes == EnvStr )
            {
              *Envelopes = EnvBuf;
            } else if ( *Envelopes == EnvBuf )
            {
              *Envelopes = EnvStr;
            }

            Envelopes++;
          }

          SampleStr = (struct TuComposerSample *) &(InstrStr->tci_Samples.mlh_Head);

          for (;;)
          {
            SampleStr = (struct TuComposerSample *) SampleStr->tcs_Node.mln_Succ;

            if (!( SampleStr->tcs_Node.mln_Succ ))
              break;

            if ( SampleStr->tcs_AutoVibratoEnv == EnvStr )
            {
              SampleStr->tcs_AutoVibratoEnv = EnvBuf;
            } else if ( SampleStr->tcs_AutoVibratoEnv == EnvBuf )
            {
              SampleStr->tcs_AutoVibratoEnv = EnvStr;
            }

            if ( SampleStr->tcs_AutoTremoloEnv == EnvStr )
            {
              SampleStr->tcs_AutoTremoloEnv = EnvBuf;
            } else if ( SampleStr->tcs_AutoTremoloEnv == EnvBuf )
            {
              SampleStr->tcs_AutoTremoloEnv = EnvStr;
            }

            if ( SampleStr->tcs_AutoPannoloEnv == EnvStr )
            {
              SampleStr->tcs_AutoPannoloEnv = EnvBuf;
            } else if ( SampleStr->tcs_AutoPannoloEnv == EnvBuf )
            {
              SampleStr->tcs_AutoPannoloEnv = EnvStr;
            }
          }
        }
      }
    }

    return ( 0L );
  }

  return ( ERROR_INSTR_NOENVL );
}
