/* TuComposer OS independent code
**
** $VER: SwapInstr.c 31.22 (29.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG SwapInstr ( struct TuComposerInstr *InstrBuf,
    struct TuComposerInstr *InstrStr )
{
  if ( InstrStr && InstrBuf )
  {
    if ( InstrStr != InstrBuf )
    {
      struct MinList TmpUnkChunk;
      struct MinList SwapUnkChunk;
      UBYTE *SrcBuf, *DestBuf;
      UBYTE TmpByte;
      ULONG i;

      ObtainSemaphore ( TuCBase->tcb_InstrSigSem );

      TmpUnkChunk = InstrBuf->tci_UnknownChunks;
      ReMapNodeList ( (struct List *) &(InstrStr->tci_UnknownChunks), (struct List *) &(InstrBuf->tci_UnknownChunks));

      SwapUnkChunk = InstrBuf->tci_UnknownChunks;
      InstrBuf->tci_UnknownChunks = TmpUnkChunk;
      ReMapNodeList ( (struct List *) &(InstrBuf->tci_UnknownChunks), (struct List *) &(InstrStr->tci_UnknownChunks));

      InstrBuf->tci_UnknownChunks = SwapUnkChunk;

      SrcBuf = (UBYTE *) &(InstrStr->tci_FileName);
      DestBuf = (UBYTE *) &(InstrBuf->tci_FileName);

      for (i = (offsetof (struct TuComposerInstr, tci_Samples) - offsetof (struct TuComposerInstr, tci_FileName)); i > 0; i--)
      {
        TmpByte = *DestBuf;
        *DestBuf++ = *SrcBuf;
        *SrcBuf++ = TmpByte;
      }

      TmpUnkChunk = InstrBuf->tci_Samples;
      ReMapNodeList ( (struct List *) &(InstrStr->tci_Samples), (struct List *) &(InstrBuf->tci_Samples));

      SwapUnkChunk = InstrBuf->tci_Samples;
      InstrBuf->tci_Samples = TmpUnkChunk;
      ReMapNodeList ( (struct List *) &(InstrBuf->tci_Samples), (struct List *) &(InstrStr->tci_Samples));

      InstrBuf->tci_Samples = SwapUnkChunk;

      SrcBuf = (UBYTE *) &(InstrStr->tci_VolumeEnvelope);
      DestBuf = (UBYTE *) &(InstrBuf->tci_VolumeEnvelope);

      for (i = (offsetof (struct TuComposerInstr, tci_UnknownChunks) - offsetof (struct TuComposerInstr, tci_VolumeEnvelope)); i > 0; i--)
      {
        TmpByte = *DestBuf;
        *DestBuf++ = *SrcBuf;
        *SrcBuf++ = TmpByte;
      }

      ReleaseSemaphore ( TuCBase->tcb_InstrSigSem );
    }

    return ( 0L );
  }

  return ( ERROR_INSTR_NOGIVEN );
}
