/* TuComposer OS independent code
**
** $VER: SwapInstrInModule.c 31.22 (12.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG SwapInstrInModule ( struct TuComposerInstr *InstrBuf,
    struct TuComposerInstr *InstrStr, unsigned long Flags )
{
  if ( InstrStr && InstrBuf )
  {
    if ( InstrStr != InstrBuf )
    {
      if ( Flags & SIIMF_Swap )
      {
        struct MinList TmpUnkChunk;
        struct MinList SwapUnkChunk;
        UBYTE *SrcBuf, *DestBuf;
        UBYTE TmpByte;
        ULONG i;

        TmpUnkChunk = InstrBuf->tci_UnknownChunks;
        ReMapNodeList ( (struct List *) &(InstrStr->tci_UnknownChunks), (struct List *) &(InstrBuf->tci_UnknownChunks));

        SwapUnkChunk = InstrBuf->tci_UnknownChunks;
        InstrBuf->tci_UnknownChunks = TmpUnkChunk;
        ReMapNodeList ( (struct List *) &(InstrBuf->tci_UnknownChunks), (struct List *) &(InstrStr->tci_UnknownChunks));

        InstrBuf->tci_UnknownChunks = SwapUnkChunk;

        SrcBuf = (UBYTE *) &(InstrStr->tci_FileName);
        DestBuf = (UBYTE *) &(InstrBuf->tci_FileName);

        for (i = (offsetof (struct TuComposerInstr, tci_Samples) - offsetof (struct TuComposerInstr, tci_FileName)); i > 0; i--)
        {
          TmpByte = *DestBuf;
          *DestBuf++ = *SrcBuf;
          *SrcBuf++ = TmpByte;
        }

        TmpUnkChunk = InstrBuf->tci_Samples;
        ReMapNodeList ( (struct List *) &(InstrStr->tci_Samples), (struct List *) &(InstrBuf->tci_Samples));

        SwapUnkChunk = InstrBuf->tci_Samples;
        InstrBuf->tci_Samples = TmpUnkChunk;
        ReMapNodeList ( (struct List *) &(InstrBuf->tci_Samples), (struct List *) &(InstrStr->tci_Samples));

        InstrBuf->tci_Samples = SwapUnkChunk;

        SrcBuf = (UBYTE *) &(InstrStr->tci_VolumeEnvelope);
        DestBuf = (UBYTE *) &(InstrBuf->tci_VolumeEnvelope);

        for (i = (offsetof (struct TuComposerInstr, tci_UnknownChunks) - offsetof (struct TuComposerInstr, tci_VolumeEnvelope)); i > 0; i--)
        {
          TmpByte = *DestBuf;
          *DestBuf++ = *SrcBuf;
          *SrcBuf++ = TmpByte;
        }
      }

      if ( Flags & SIIMF_Update )
      {
        struct TuComposerModule *ModuleStr = (struct TuComposerModule *) &(InstrStr->tci_Node.mln_Succ);
        struct TuComposerSong *SongStr;
        struct TuComposerInstr *InstrScan;
        struct TuComposerInstrKeyboard *KeybrdStr;
        ULONG NumInstr, NumSwapInstr;

        for (;;)
        {
          ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

          if (!( ModuleStr->tcm_Node.mln_Pred ))
            break;
        }

        (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_InstrList );

        NumInstr = GetInstrNum ( ModuleStr, InstrStr );
        NumSwapInstr = GetInstrNum ( ModuleStr, InstrBuf );

        InstrScan = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head );

        for (;;)
        {
          InstrScan = (struct TuComposerInstr *) InstrScan->tci_Node.mln_Succ;

          if (!( InstrScan->tci_Node.mln_Succ ))
            break;

          if ( InstrScan->tci_CompFlags & TCICF_SeparateSamples )
          {
            KeybrdStr = InstrScan->tci_KeyboardDefs;

            if ( KeybrdStr )
            {
              struct KeyboardEntry *KeybrdEntry = (struct KeyboardEntry *) &(KeybrdStr->tcik_NoteEntry[0]);
              ULONG i;

              if (!( KeybrdEntry->tcik_Octave_C_0 & 0x80 ))
              {
                KeybrdEntry->tcik_Octave_C_0 |= 0x80;

                for (i = (NUMOCTAVES * NUMNOTES); i > 0; i--)
                {
                  if ( KeybrdEntry->tcik_Sample_C_0 == NumInstr )
                  {
                    KeybrdEntry->tcik_Sample_C_0 = NumSwapInstr;
                  } else if ( KeybrdEntry->tcik_Sample_C_0 == NumSwapInstr )
                  {
                    KeybrdEntry->tcik_Sample_C_0 = NumInstr;
                  }

                  KeybrdEntry++;
                }
              }
            }
          }
        }

        KeybrdStr = (struct TuComposerInstrKeyboard *) &(ModuleStr->tcm_KeyboardDefs.mlh_Head);

        for (;;)
        {
          KeybrdStr = (struct TuComposerInstrKeyboard *) KeybrdStr->tcik_Node.mln_Succ;

          if (!( KeybrdStr->tcik_Node.mln_Succ ))
            break;

          KeybrdStr->tcik_NoteEntry[0].tcik_Octave_C_0 &= 0x7F;
        }

        SongStr = (struct TuComposerSong *) &(ModuleStr->tcm_SongList.mlh_Head);

        for (;;)
        {
          struct TuComposerTrack *TrackStr;

          SongStr = (struct TuComposerSong *) SongStr->tcso_Node.mln_Succ;

          if (!( SongStr->tcso_Node.mln_Succ ))
            break;

          TrackStr = (struct TuComposerTrack *) &(SongStr->tcso_TrackList.mlh_Head);

          for (;;)
          {
            struct TuComposerTrackData *TrackData;
            ULONG i;

            TrackStr = (struct TuComposerTrack *) TrackStr->tct_Node.mln_Succ;

            if (!( TrackStr->tct_Node.mln_Succ ))
              break;

            TrackData = TrackStr->tct_Data;

            for (i = (TrackStr->tct_Length + 1); i > 0; i--)
            {
              if ( TrackData->tctd_Instrument == NumInstr )
              {
                TrackData->tctd_Instrument = NumSwapInstr;
              } else if ( TrackData->tctd_Instrument == NumSwapInstr )
              {
                TrackData->tctd_Instrument = NumInstr;
              }

              TrackData++;
            }
          }
        }
      }
    }

    return ( 0L );
  }

  return ( ERROR_INSTR_NOGIVEN );
}
