/* TuComposer OS independent code
**
** $VER: SwapKeyboardInModule.c 31.22 (12.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG SwapKeyboardInModule ( struct TuComposerInstrKeyboard *KeybrdBuf,
    struct TuComposerInstrKeyboard *KeybrdStr, unsigned long Flags )
{
  if ( KeybrdStr && KeybrdBuf )
  {
    if ( KeybrdStr != KeybrdBuf )
    {
      if ( Flags & SKIMF_Swap )
      {
        UBYTE *SrcBuf, *DestBuf;
        UBYTE TmpByte;
        ULONG i;

        SrcBuf = (UBYTE *) &(KeybrdStr->tcik_NoteEntry[0]);
        DestBuf = (UBYTE *) &(KeybrdBuf->tcik_NoteEntry[0]);

        for (i = (sizeof (struct TuComposerInstrKeyboard) - offsetof (struct TuComposerInstrKeyboard, tcik_NoteEntry)); i > 0; i--)
        {
          TmpByte = *DestBuf;
          *DestBuf++ = *SrcBuf;
          *SrcBuf++ = TmpByte;
        }
      }

      if ( Flags & SKIMF_Update )
      {
        struct TuComposerModule *ModuleStr = (struct TuComposerModule *) &(KeybrdStr->tcik_Node.mln_Succ);
        struct TuComposerInstr *InstrScan;

        for (;;)
        {
          ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

          if (!( ModuleStr->tcm_Node.mln_Pred ))
            break;
        }

        (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_KeyboardDefs );

        InstrScan = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head );

        for (;;)
        {
          InstrScan = (struct TuComposerInstr *) InstrScan->tci_Node.mln_Succ;

          if (!( InstrScan->tci_Node.mln_Succ ))
            break;

          if ( InstrScan->tci_KeyboardDefs == KeybrdStr )
          {
            InstrScan->tci_KeyboardDefs = KeybrdBuf;
          } else if ( InstrScan->tci_KeyboardDefs == KeybrdBuf )
          {
            InstrScan->tci_KeyboardDefs = KeybrdStr;
          }
        }
      }
    }

    return ( 0L );
  }

  return ( ERROR_INSTR_NOENVL );
}
