/* TuComposer OS independent code
**
** $VER: ValidateEnvNodes.c 31.22 (22.4.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stdlib.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

int CmpEnvNode ( const void *Node1, const void *Node2 );

ULONG ValidateEnvNodes ( struct TuComposerInstrEnvelope *EnvStr )
{
  if ( EnvStr )
  {
    UWORD *EnvNode = EnvStr->tcie_NodePoints;

    if ( EnvNode )
    {
      UWORD *NodeScan;
      UWORD *TmpNode;
      ULONG Length = EnvStr->tcie_NumNodes, NewLength = 1L, i;

      if ( Length < 2 )
      {
        if (!( EnvNode = (UWORD *) AllocPMem ( 2L * sizeof (UWORD))))
          return ( ERROR_INSTR_ENVLMEM );

        EnvStr->tcie_NodePoints = EnvNode;
        EnvStr->tcie_NumNodes = 2L;

        FreePMem ( EnvNode, Length * sizeof (UWORD));

        Length = 2;
      }

      if (!( TmpNode = (UWORD *) AllocPMem ( Length * sizeof (UWORD))))
        return ( ERROR_INSTR_ENVLMEM );

      *EnvNode = 0;
      EnvNode[Length - 1] = EnvStr->tcie_NumPoints - 1;

      NodeScan = EnvNode;

      for (i =  Length; i > 0; i--)
      {
        UWORD *TmpScan = TmpNode;
        UWORD NodePoint = *NodeScan++;
        ULONG j;

        for (j = Length; j > 0; j--)
        {
          if ( ( NodePoint == *TmpScan++ ) || ( NodePoint >= EnvStr->tcie_NumPoints ) )
            break;
        }

        if (!( j ))
          TmpNode[NewLength++] = NodePoint;
      }

      if ( NewLength != Length )
      {
        UWORD *NewNode;

        if (!( NewNode = (UWORD *) AllocPMem ( NewLength * sizeof (UWORD))))
        {
          FreePMem ( TmpNode, Length * sizeof (UWORD));

          return ( ERROR_INSTR_ENVLMEM );
        }

        memcpy ( NewNode, TmpNode, NewLength * sizeof (UWORD));
        qsort ( NewNode, NewLength, sizeof (UWORD), CmpEnvNode );

        EnvStr->tcie_NodePoints = NewNode;
        EnvStr->tcie_NumNodes = NewLength;

        FreePMem ( EnvNode, Length * sizeof (UWORD));
      }

      FreePMem ( TmpNode, Length * sizeof (UWORD));
    }

    return ( 0L );
  }

  return ( ERROR_INSTR_NOENVL );
}

int CmpEnvNode ( const void *Node1, const void *Node2 )
{
  return ( *(UWORD *) Node1 - *(UWORD *) Node2 );
}
