/* TuComposer AmigaOS dependent code
**
** $VER: InternalPaula.c 31.00 (2.10.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <exec/execbase.h>
#include <exec/interrupts.h>
#include <exec/libraries.h>
#include <exec/lists.h>
#include <exec/memory.h>
#include <exec/nodes.h>
#include <devices/audio.h>
#include <dos/dos.h>
#include <hardware/cia.h>
#include <hardware/custom.h>
#include <hardware/dmabits.h>
#include <hardware/intbits.h>
#include <tucomposer/tucomposer.h>
#include <tucomposer/external/external.h>
#include <tucomposer/external/device.h>
#include <proto/exec.h>
#include <proto/tucomposer.h>
#include <clib/ext_mixerbase_protos.h>

#include "compiler.h"

#ifdef __cplusplus
extern "C" {
#endif

static struct TuComposerExtLibBase *InternalPaulaOpenExtLib ( void );
static BPTR InternalPaulaCloseExtLib ( void );
static BPTR ExtLib ( void );
static ULONG InternalPaulaUpdate ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum );
static ULONG InternalPaulaAlloc ( union FlagPass *FlagPassStr );
static ULONG InternalPaulaFree ( void );
static ULONG InternalPaulaPlay ( struct MixerAllocStruct *MixAllocStr,
    union FlagPass *FlagPassStr );
static ULONG InternalPaulaStop ( void );
static ULONG InternalPaulaCheckRate ( unsigned long SmpRate );
static ULONG InternalPaulaCheckRateFraction ( unsigned long SmpRate );
static ULONG InternalPaulaUpdateRate ( unsigned long SmpRate );

static void ASM AudI8m ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1));
static void ASM AudSI8m ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1));
static void ASM AudI8s ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1));
static void ASM AudSI8s ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1));
static void ASM AudISurroundm ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1));
static void ASM AudSISurroundm ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1));
static void ASM AudISurrounds ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1));
static void ASM AudSISurrounds ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1));
static void ASM AudI14m ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1));
static void ASM AudSI14m ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1));
static void ASM AudI14s ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1));
static void ASM AudSI14s ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1));
static void ASM AudSICal14m ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1));
static void ASM AudSICal14s ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1));

static void CreateCalTable ( WORD *CalibTable, BYTE *CalibArray );

#ifdef __cplusplus
}
#endif

extern struct ExecBase *SysBase;
extern struct SoundDeviceInfo InternalPaulaBase;
extern struct InternalPaulaFlagStr InternalPaulaSaveFlags;
extern UBYTE MixIRQName [];
extern UBYTE MixSIRQName [];
extern STRPTR SaveButton2 [];
extern STRPTR SaveButton3 [];
extern BYTE *ChipBuffers [];
extern LONG *MixBuffer;

static UBYTE InternalPaulaName[] = "internal_paula.library\0";
static UBYTE InternalPaulaLoadID[] = "Amiga Native Paula\0";
static UBYTE InternalPaulaIDString[] = "Internal Paula Lib Version 1.00 (v31) (02 Oct 99) by Basty/Seasons.\0";

static struct Interrupt MixIRQ =
{
  {NULL, NULL, 0, 0, (STRPTR) &MixIRQName},
  &ChipBuffers,
  (APTR) &AudI8m
};

static struct Interrupt MixSIRQ =
{
  {NULL, NULL, 0, 0, (STRPTR) &MixSIRQName},
  &MixBuffer,
  (APTR) &AudSI8m
};

static ULONG MixBufSize = 0L;
static struct MixerAllocStruct *MixLibBase = NULL;
static LONG *MixBuffer;
static BYTE *MixDestBuf[4];
static BYTE *ChipBuffers[8];
static ULONG PerFrequency = 0L;
static UWORD Period = 0;
static WORD Change = 0;
static WORD *CalibTable = NULL;
static BYTE CalibArray[256];
static union FlagPass PlayParams[4];

struct TuComposerExtList InternalPaula =
{
  {NULL, NULL},
  EXTLF_Intern|EXTLF_Saver, 0,
  (struct TuComposerExtLibBase *) &InternalPaulaBase,
  NULL,
  (STRPTR) &InternalPaulaName,
  (STRPTR) &InternalPaulaLoadID,
  NULL,
  (struct TuComposerExtFlagStr *) &InternalPaulaSaveFlags,
  0
};

#include "InternalPaula_library.h"

static UBYTE SaveText0[] = "Reverse stereo\0";
static UBYTE SaveText1[] = "Lowpass Filter\0";
static UBYTE SaveText2[] = "Output mode\0";
static UBYTE SaveText21[] = "Normal\0";
static UBYTE SaveText22[] = "Real surround\0";
static UBYTE SaveText23[] = "14-bit (non-calibrated)\0";
static UBYTE SaveText24[] = "14-bit (calibrated)\0";
static UBYTE SaveText3[] = "CPU overload action\0";
static UBYTE SaveText31[] = "Stop immediately\0";
static UBYTE SaveText32[] = "Fallback until 4 kHz\0";
static UBYTE SaveText33[] = "None\0";

static UBYTE MixIRQName[] = "TuComposer Internal Paula IRQ\0";
static UBYTE MixSIRQName[] = "TuComposer Internal Paula Soft IRQ\0";

static UBYTE ChAllocMask[] = {0xF, 0};
static BYTE MixWhichBuf = 0;
static BYTE SwapCh = 0;
static BYTE PaulaStopFlag = 0;

static struct InternalPaulaFlagStr {
  UWORD  tefs_NumEntries;
  UWORD  tefs_StructSize;
  union FlagEntryBooleanStruct tefs_Flag0;
  union FlagEntryBooleanStruct tefs_Flag1;
  union FlagEntryButtonStruct tefs_Flag2;
  union FlagEntryButtonStruct tefs_Flag3;
} InternalPaulaSaveFlags =
{
  4, sizeof (InternalPaulaSaveFlags),
  {(STRPTR) &SaveText0, EXTFLAG_BOOLEAN, TEFSF_Update, 0, 0L, 0L, 0L},
  {(STRPTR) &SaveText1, EXTFLAG_BOOLEAN, TEFSF_Update, 0, 0L, 0L, 0L},
  {(STRPTR *) &SaveButton2, EXTFLAG_BUTTON, TEFSF_Update, 1+4, 0L, 0L, 4L},
  {(STRPTR *) &SaveButton3, EXTFLAG_BUTTON, TEFSF_Update, 1+3, 0L, 0L, 1L}
};

static STRPTR SaveButton2[] =
{
  SaveText2,
  SaveText21,
  SaveText22,
  SaveText23,
  SaveText24
};

static STRPTR SaveButton3[] =
{
  SaveText3,
  SaveText31,
  SaveText32,
  SaveText33
};

static struct MsgPort AudioPort =
{
  {NULL, NULL, NT_MSGPORT, 0, NULL}, 0, 0, NULL,
  {NULL, NULL, NULL, NT_MESSAGE, 0}
};

static struct IOAudio AudioRequest =
{
  {{{NULL, NULL, NT_UNKNOWN, 127, NULL}, &AudioPort, 68},
  NULL, NULL, 0, 0, 0}, 0, (BYTE *) &ChAllocMask, 1, 0, 0, 0,
  {{NULL, NULL, 0, 0, NULL}, NULL, 0}
};

static struct TuComposerExtLibBase *InternalPaulaOpenExtLib ( void )
{
  PerFrequency = SysBase->ex_EClockFrequency * 5;

  InternalPaulaBase.sdi_Library.extb_LibNode.lib_OpenCnt++;

  return ( (struct TuComposerExtLibBase *) &InternalPaulaBase );
}

static BPTR InternalPaulaCloseExtLib ( void )
{
  InternalPaulaBase.sdi_Library.extb_LibNode.lib_OpenCnt--;

  return ( NULL );
}

static BPTR ExtLib ( void )
{
  return ( NULL );
}

static ULONG InternalPaulaUpdate ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum )
{
  struct CIA *CIABase = ( (struct CIA *) 0xBFE001 );

  switch ( FlagNum )
  {
    case 1 :
    {
      if ( (PlayParams[1].flg_Value = FlagPassStr[1].flg_Value ))
      {
        CIABase->ciapra &= ~(CIAF_LED);
      } else
      {
        CIABase->ciapra |= CIAF_LED;
      }

      break;
    }
    case 3 :
    {
      FlagPassType = FlagPassStr[3].flg_Value;

      PlayParams[3].flg_Value = FlagPassType;

      switch ( FlagPassType )
      {
        case 1 :
        {
          PaulaStopFlag = 1;

          break;
        }
        case 2 :
        {
          PaulaStopFlag = 0xFF;

          break;
        }
        case 3 :
        {
          PaulaStopFlag = 0;

          break;
        }
      }

      break;
    } default :
    {
      if ( InternalPaulaBase.sdi_Flags & SDIF_Playing )
        InternalPaulaPlay ( MixLibBase, FlagPassStr );
    }
  }

  return ( 0L );
}

static ULONG InternalPaulaAlloc ( union FlagPass *FlagPassStr )
{
  if (!( InternalPaulaBase.sdi_Flags & SDIF_Allocated ))
  {
    struct CFHandle *CalibFile;

    memset ( &CalibArray, 0x50, 255 );
    CalibArray[255] = 0x7F;

    if ( (CalibFile = COpen ( "ENV:CyberSound/SoundDrivers/14Bit_Calibration", MODE_OLDFILE, NULL )))
    {
      CRead ( CalibFile, &CalibArray, 256 );
    }

    CClose ( CalibFile );

    if ( (AudioPort.mp_SigBit = AllocSignal ( -1L )) != 255 )
    {
      AudioPort.mp_SigTask = FindTask ( NULL );

      InitNodeList ( (struct List *) &(AudioPort.mp_MsgList) );

      if ( OpenDevice ( "audio.device", 0L, (struct IORequest *) &AudioRequest, 0L ))
      {
        FreeSignal ( AudioPort.mp_SigBit );
      } else
      {
        InternalPaulaBase.sdi_Task = AudioPort.mp_SigTask;

        InternalPaulaBase.sdi_Flags |= SDIF_Allocated;

        return ( 0L );
      }
    }
  }

  return ( ERROR_EXTLIB_BUSY );
}

static ULONG InternalPaulaFree ( void )
{
  if ( (InternalPaulaBase.sdi_Flags & SDIF_Allocated ))
  {
    InternalPaulaBase.sdi_Task = NULL;

    FreeSignal ( AudioPort.mp_SigBit );

    CloseDevice ( (struct IORequest *) &AudioRequest );

    InternalPaulaBase.sdi_Flags &= ~(SDIF_Allocated);

    if ( CalibTable )
    {
      FreePMem ( CalibTable, 131072 );

      CalibTable = NULL;
    }

    return ( 0L );
  }

  return ( ERROR_EXTLIB_BUSY );
}

static ULONG InternalPaulaPlay ( struct MixerAllocStruct *MixAllocStr,
    union FlagPass *FlagPassStr )
{
  struct Custom *CustomBase;
  struct CIA *CIABase = ( (struct CIA *) 0xBFE001 );
  void (*AudIRQ)( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1));
  void (*AudSIRQ)( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1));

  BYTE **ChipBuf = (BYTE **) &ChipBuffers;
  BYTE *AllocBuf;
  ULONG NumBufs = 2L, i;

  if ( FlagPassStr )
    memcpy ( PlayParams, FlagPassStr, 4 * sizeof (union FlagPass) );

  MixLibBase = MixAllocStr;

  if ( InternalPaulaBase.sdi_Flags & SDIF_Playing )
    InternalPaulaStop ();

  InternalPaulaBase.sdi_Flags |= SDIF_Playing;

  MixAllocStr->mas_Flags |= MASF_Mixing;

  if ( InternalPaulaBase.sdi_ChannelFlags & SDICF_Stereo )
    NumBufs += NumBufs;

  if ( PlayParams[2].flg_Value != 1 )
    NumBufs += NumBufs;

  for (i = NumBufs; i > 0; i--)
  {
    if (!( AllocBuf = (BYTE *) AllocMem ( InternalPaulaBase.sdi_ChannelBufLen, MEMF_PUBLIC|MEMF_CHIP|MEMF_CLEAR )))
      goto PaulaBufErr;

    *ChipBuf++ = AllocBuf;
  }

  MixBuffer = InternalPaulaBase.sdi_ChannelBuf;

  if ( PlayParams[2].flg_Value == 4 )
  {
    if (!( CalibTable ))
    {
      if ( (CalibTable = (WORD *) AllocPMem ( 131072 )))
      {
        CreateCalTable ( CalibTable, &(CalibArray[128]) );

        if ( InternalPaulaBase.sdi_ChannelFlags & SDICF_Stereo )
        {
          (APTR) AudIRQ = (APTR) &AudI14s;
          (APTR) AudSIRQ = (APTR) &AudSICal14s;
        } else
        {
          (APTR) AudIRQ = (APTR) &AudI14m;
          (APTR) AudSIRQ = (APTR) &AudSICal14m;
        }

        goto StartIRQ;
      }
    }
  } else
  {
    if ( CalibTable )
    {
      FreePMem ( CalibTable, 131072 );

      CalibTable = NULL;
    }
  }

  if ( PlayParams[2].flg_Value >= 3 )
  {
    if ( InternalPaulaBase.sdi_ChannelFlags & SDICF_Stereo )
    {
      (APTR) AudIRQ = (APTR) &AudI14s;
      (APTR) AudSIRQ = (APTR) &AudSI14s;
    } else
    {
      (APTR) AudIRQ = (APTR) &AudI14m;
      (APTR) AudSIRQ = (APTR) &AudSI14m;
    }
  } else if ( PlayParams[2].flg_Value == 2 )
  {
    if ( InternalPaulaBase.sdi_ChannelFlags & SDICF_Stereo )
    {
      (APTR) AudIRQ = (APTR) &AudISurrounds;
      (APTR) AudSIRQ = (APTR) &AudSISurrounds;
    } else
    {
      (APTR) AudIRQ = (APTR) &AudISurroundm;
      (APTR) AudSIRQ = (APTR) &AudSISurroundm;
    }
  } else
  {
    if ( InternalPaulaBase.sdi_ChannelFlags & SDICF_Stereo )
    {
      (APTR) AudIRQ = (APTR) &AudI8s;
      (APTR) AudSIRQ = (APTR) &AudSI8s;
    } else
    {
      (APTR) AudIRQ = (APTR) &AudI8m;
      (APTR) AudSIRQ = (APTR) &AudSI8m;
    }
  }

StartIRQ:

  (APTR) MixIRQ.is_Code = (APTR) AudIRQ;
  (APTR) MixSIRQ.is_Code = (APTR) AudSIRQ;

  MixWhichBuf = 0;

  SetIntVector ( INTB_AUD0, (struct Interrupt *) &MixIRQ );

  CustomBase = (struct Custom *) 0xDFF000;

  NumBufs = PerFrequency / InternalPaulaBase.sdi_ChannelFreq;
  i = InternalPaulaBase.sdi_ChannelBufLen;

  MixBufSize = i;

  i >>= 1;

  CustomBase->aud[0].ac_len = i;
  CustomBase->aud[1].ac_len = i;
  CustomBase->aud[2].ac_len = i;
  CustomBase->aud[3].ac_len = i;

  CustomBase->aud[0].ac_per = NumBufs;
  CustomBase->aud[1].ac_per = NumBufs;
  CustomBase->aud[2].ac_per = NumBufs;
  CustomBase->aud[3].ac_per = NumBufs;
  Period = NumBufs;

  i = 64;

  CustomBase->aud[0].ac_vol = i;
  CustomBase->aud[1].ac_vol = i;

  if ( PlayParams[2].flg_Value >= 3 )
    i = 1;

  CustomBase->aud[2].ac_vol = i;
  CustomBase->aud[3].ac_vol = i;

  ChipBuf = (BYTE **) &ChipBuffers;

  if ( PlayParams[2].flg_Value == 1 )
  {
    AllocBuf = *ChipBuf++;

    CustomBase->aud[0].ac_ptr = (UWORD *) AllocBuf;
    CustomBase->aud[3].ac_ptr = (UWORD *) AllocBuf;

    if ( InternalPaulaBase.sdi_ChannelFlags & SDICF_Stereo )
    {
      if ( PlayParams[0].flg_Value )
      {
        CustomBase->aud[0].ac_ptr = (UWORD *) *ChipBuf;
        CustomBase->aud[3].ac_ptr = (UWORD *) *ChipBuf;
        CustomBase->aud[1].ac_ptr = (UWORD *) AllocBuf;
        CustomBase->aud[2].ac_ptr = (UWORD *) AllocBuf;

        SwapCh = 0xFF;
      } else
      {
        CustomBase->aud[1].ac_ptr = (UWORD *) *ChipBuf;
        CustomBase->aud[2].ac_ptr = (UWORD *) *ChipBuf;

        SwapCh = 0;
      }
    } else
    {
      CustomBase->aud[1].ac_ptr = (UWORD *) AllocBuf;
      CustomBase->aud[2].ac_ptr = (UWORD *) AllocBuf;
    }
  } else
  {
    if ( InternalPaulaBase.sdi_ChannelFlags & SDICF_Stereo )
    {
      if ( PlayParams[0].flg_Value )
      {
        CustomBase->aud[1].ac_ptr = (UWORD *) *ChipBuf++;
        CustomBase->aud[2].ac_ptr = (UWORD *) *ChipBuf++;
        CustomBase->aud[0].ac_ptr = (UWORD *) *ChipBuf++;
        CustomBase->aud[3].ac_ptr = (UWORD *) *ChipBuf;

        SwapCh = 0xFF;
      } else
      {
        CustomBase->aud[0].ac_ptr = (UWORD *) *ChipBuf++;
        CustomBase->aud[3].ac_ptr = (UWORD *) *ChipBuf++;
        CustomBase->aud[1].ac_ptr = (UWORD *) *ChipBuf++;
        CustomBase->aud[2].ac_ptr = (UWORD *) *ChipBuf;

        SwapCh = 0;
      }
    } else
    {
      if ( PlayParams[2].flg_Value == 2 )
      {
        CustomBase->aud[0].ac_ptr = (UWORD *) *ChipBuf;
        CustomBase->aud[3].ac_ptr = (UWORD *) *ChipBuf++;
        CustomBase->aud[1].ac_ptr = (UWORD *) *ChipBuf;
        CustomBase->aud[2].ac_ptr = (UWORD *) *ChipBuf;
      } else
      {
        CustomBase->aud[0].ac_ptr = (UWORD *) *ChipBuf;
        CustomBase->aud[1].ac_ptr = (UWORD *) *ChipBuf++;
        CustomBase->aud[2].ac_ptr = (UWORD *) *ChipBuf;
        CustomBase->aud[3].ac_ptr = (UWORD *) *ChipBuf;
      }
    }
  }

  if ( PlayParams[1].flg_Value )
  {
    CIABase->ciapra &= ~(CIAF_LED);
  } else
  {
    CIABase->ciapra |= CIAF_LED;
  }

  switch ( PlayParams[3].flg_Value )
  {
    case 1 :
    {
      PaulaStopFlag = 1;

      break;
    }

    case 2 :
    {
      PaulaStopFlag = 0xFF;

      break;
    }

    default :
    {
      PaulaStopFlag = 0x0;

      break;
    }
  }

  CustomBase->intena = INTF_SETCLR|INTF_AUD0;
  CustomBase->intreq = INTF_AUD0;
  CustomBase->dmacon = DMAF_SETCLR|DMAF_AUDIO;

  return ( 0L );

PaulaBufErr:

  InternalPaulaStop ();

  return ( ERROR_EXTLIB_NOALLOC );
}

static ULONG InternalPaulaStop ( void )
{
  if ( (InternalPaulaBase.sdi_Flags & SDIF_Playing ))
  {
    struct Custom *CustomBase = ( (struct Custom *) 0xDFF000 );
    BYTE **ChipBuf = (BYTE **) &ChipBuffers;
    APTR FreeBuf;
    ULONG i;

    InternalPaulaBase.sdi_Flags &= ~(SDIF_Playing);
    MixLibBase->mas_Flags &= ~(MASF_Mixing);

    CustomBase->intena = INTF_AUD0;
    CustomBase->dmacon = DMAF_AUDIO;

    for (i = 8; i > 0; i--)
    {
      if ( (FreeBuf = (BYTE *) *ChipBuf ))
        FreeMem ( FreeBuf, InternalPaulaBase.sdi_ChannelBufLen );

      *ChipBuf++ = NULL;
    }

    return ( 0L );
  }

  return ( ERROR_EXTLIB_BUSY );
}

static ULONG InternalPaulaCheckRate ( unsigned long SmpRate )
{
  ULONG CheckRate = PerFrequency / SmpRate;

  return ( PerFrequency / CheckRate );
}

static ULONG InternalPaulaCheckRateFraction ( unsigned long SmpRate )
{
  ULONG CheckRate;
  ULONG CheckFrac;

  SmpRate = PerFrequency / SmpRate;

  CheckRate = PerFrequency / SmpRate;
  CheckFrac = PerFrequency % SmpRate;

  return ( (unsigned long long) ((unsigned long long) CheckFrac << 32) / CheckRate );
}

static ULONG InternalPaulaUpdateRate ( unsigned long SmpRate )
{
  InternalPaulaBase.sdi_ChannelFreq = SmpRate;

  if ( InternalPaulaBase.sdi_Flags & SDIF_Playing )
  {
    Period = PerFrequency / SmpRate;
    Change++;
  }

  return ( 0L );
}

static void CreateCalTable ( WORD *CalibTable, BYTE *CalibArray )
{
  BYTE *CalibBuf = CalibArray;
  BYTE *CalibTabBuf = (BYTE *) CalibTable;
  UWORD i;
  WORD c1 = 0, c2 = 0, c3 = 0, c4;
  LONG CalibTotal = 0L, CurrCalib = 0x8000, CalibAdd = CurrCalib;

  for (i = 128; i > 0; i--)
  {
    CalibTotal += *CalibBuf++;
  }

  CalibBuf = CalibArray;

  i = 32768;

FetchNext2:

  c4 = *CalibBuf++;

  c3 += c4;

OuterLoop2:

  if ( c3 <= 0 )
  {
    c1++;
    c2 -= c4;

    goto FetchNext2;
  }

  *CalibTabBuf++ = c1;
  *CalibTabBuf++ = c2;

  if ( (CurrCalib -= CalibTotal) < 0)
  {
    CurrCalib += CalibAdd;
    c2++;
    c3--;
  }

  if ( --i )
    goto OuterLoop2;

  CalibTotal = 0L;

  for (i = 128; i > 0; i--)
  {
    CalibTotal += *--CalibBuf;
  }

  CurrCalib = CalibAdd;

  CalibTabBuf += (CalibAdd + CalibAdd);

  CalibBuf = CalibArray;

  i = 32768;

  c1 = -1;
  c2 = -1;
  c3 = 0;

FetchNext1:

  c4 = *--CalibBuf;

  c3 += c4;
  c2 += c4;

OuterLoop1:

  if ( c3 <= 0 )
  {
    c1--;

    goto FetchNext1;
  }

  *--CalibTabBuf = c2;
  *--CalibTabBuf = c1;

  if ( (CurrCalib -= CalibTotal) < 0)
  {
    CurrCalib += CalibAdd;
    c2--;
    c3--;
  }

  if ( --i )
    goto OuterLoop1;

  return;
}

static void ASM AudI8m ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1))
{
  struct SoundDeviceInfo *SoundDeviceBase;
  ULONG NewFrequency, NewPeriod;
  BYTE *ChipBuf;

  CustomBase->intreq = INTF_AUD0;

  if ( ( --Change ) < 0 )
  {
    Change = 0;

    CustomBase->aud[0].ac_per = Period;
    CustomBase->aud[1].ac_per = Period;
    CustomBase->aud[2].ac_per = Period;
    CustomBase->aud[3].ac_per = Period;
  }

  if ( ( MixSIRQ.is_Node.ln_Type == NT_SOFTINT ))
  {
    if ( PaulaStopFlag < 0 )
    {
      SoundDeviceBase = (struct SoundDeviceInfo *) &InternalPaulaBase;

      NewPeriod = (PerFrequency / SoundDeviceBase->sdi_ChannelFreq) + 32;
      NewFrequency = PerFrequency / NewPeriod;

      if ( NewFrequency < SoundDeviceBase->sdi_LowFrequency )
      {
        CustomBase->intena = INTF_AUD0;
        CustomBase->dmacon = DMAF_AUDIO;
      } else
      {
        CustomBase->aud[0].ac_per = NewPeriod;
        CustomBase->aud[1].ac_per = NewPeriod;
        CustomBase->aud[2].ac_per = NewPeriod;
        CustomBase->aud[3].ac_per = NewPeriod;
        Period = NewPeriod;

        ExternalMixerChangeRateBase ( MixLibBase, NewFrequency, MixLibBase->mas_MixLibBase );
      }
    } else if ( PaulaStopFlag > 0 )
    {
      CustomBase->intena = INTF_AUD0;
      CustomBase->dmacon = DMAF_AUDIO;
    }

    return;
  }

  if ( (MixWhichBuf = ~MixWhichBuf) )
    Data++;

  ChipBuf = (BYTE *) *Data;

  CustomBase->aud[0].ac_ptr = (UWORD *) ChipBuf;
  CustomBase->aud[1].ac_ptr = (UWORD *) ChipBuf;
  CustomBase->aud[2].ac_ptr = (UWORD *) ChipBuf;
  CustomBase->aud[3].ac_ptr = (UWORD *) ChipBuf;
  MixDestBuf[0] = ChipBuf;

  Cause ( (struct Interrupt *) &MixSIRQ );
}

static void ASM AudSI8m ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1))
{
  LONG *CopyMixBuf = *Data;
  BYTE *CopyChipBuf;
  struct MixerAllocStruct *MixerLibBase = MixLibBase;
  ULONG i;

  ExternalMixerDoMixBase ( MixerLibBase, CopyMixBuf, MixerLibBase->mas_MixLibBase );

  CopyChipBuf = (BYTE *) MixDestBuf[0];

  for (i = (MixBufSize >> 1); i > 0; i--)
  {
    *CopyChipBuf++ = *(BYTE *) CopyMixBuf;
    CopyMixBuf++;

    *CopyChipBuf++ = *(BYTE *) CopyMixBuf;
    CopyMixBuf++;
  }
}

static void ASM AudI8s ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1))
{
  struct SoundDeviceInfo *SoundDeviceBase;
  ULONG NewFrequency, NewPeriod;
  BYTE *ChipLeftBuf;
  BYTE *ChipRightBuf;

  CustomBase->intreq = INTF_AUD0;

  if ( ( --Change ) < 0 )
  {
    Change = 0;

    CustomBase->aud[0].ac_per = Period;
    CustomBase->aud[1].ac_per = Period;
    CustomBase->aud[2].ac_per = Period;
    CustomBase->aud[3].ac_per = Period;
  }

  if ( ( MixSIRQ.is_Node.ln_Type == NT_SOFTINT ))
  {
    if ( PaulaStopFlag < 0 )
    {
      SoundDeviceBase = (struct SoundDeviceInfo *) &InternalPaulaBase;

      NewPeriod = (PerFrequency / SoundDeviceBase->sdi_ChannelFreq) + 32;
      NewFrequency = PerFrequency / NewPeriod;

      if ( NewFrequency < SoundDeviceBase->sdi_LowFrequency )
      {
        CustomBase->intena = INTF_AUD0;
        CustomBase->dmacon = DMAF_AUDIO;
      } else
      {
        CustomBase->aud[0].ac_per = NewPeriod;
        CustomBase->aud[1].ac_per = NewPeriod;
        CustomBase->aud[2].ac_per = NewPeriod;
        CustomBase->aud[3].ac_per = NewPeriod;
        Period = NewPeriod;

        ExternalMixerChangeRateBase ( MixLibBase, NewFrequency, MixLibBase->mas_MixLibBase );
      }
    } else if ( PaulaStopFlag > 0 )
    {
      CustomBase->intena = INTF_AUD0;
      CustomBase->dmacon = DMAF_AUDIO;
    }

    return;
  }

  if ( (MixWhichBuf = ~MixWhichBuf) )
    Data += 2;

  ChipLeftBuf = (BYTE *) *Data++;
  ChipRightBuf = (BYTE *) *Data;

  MixDestBuf[0] = ChipLeftBuf;
  MixDestBuf[1] = ChipRightBuf;

  if ( SwapCh )
  {
    CustomBase->aud[0].ac_ptr = (UWORD *) ChipRightBuf;
    CustomBase->aud[1].ac_ptr = (UWORD *) ChipLeftBuf;
    CustomBase->aud[2].ac_ptr = (UWORD *) ChipLeftBuf;
    CustomBase->aud[3].ac_ptr = (UWORD *) ChipRightBuf;
  } else
  {
    CustomBase->aud[0].ac_ptr = (UWORD *) ChipLeftBuf;
    CustomBase->aud[1].ac_ptr = (UWORD *) ChipRightBuf;
    CustomBase->aud[2].ac_ptr = (UWORD *) ChipRightBuf;
    CustomBase->aud[3].ac_ptr = (UWORD *) ChipLeftBuf;
  }

  Cause ( (struct Interrupt *) &MixSIRQ );
}

static void ASM AudSI8s ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1))
{
  LONG *CopyMixBuf = *Data;
  BYTE *CopyLeftChipBuf;
  BYTE *CopyRightChipBuf;
  struct MixerAllocStruct *MixerLibBase = MixLibBase;
  ULONG i;

  ExternalMixerDoMixBase ( MixerLibBase, CopyMixBuf, MixerLibBase->mas_MixLibBase );

  CopyLeftChipBuf = (BYTE *) MixDestBuf[0];
  CopyRightChipBuf = (BYTE *) MixDestBuf[1];

  for (i = (MixBufSize >> 1); i > 0; i--)
  {
    *CopyLeftChipBuf++ = *(BYTE *) CopyMixBuf;
    CopyMixBuf++;

    *CopyRightChipBuf++ = *(BYTE *) CopyMixBuf;
    CopyMixBuf++;

    *CopyLeftChipBuf++ = *(BYTE *) CopyMixBuf;
    CopyMixBuf++;

    *CopyRightChipBuf++ = *(BYTE *) CopyMixBuf;
    CopyMixBuf++;
  }
}

static void ASM AudISurroundm ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1))
{
  struct SoundDeviceInfo *SoundDeviceBase;
  ULONG NewFrequency, NewPeriod;
  BYTE *ChipBuf;

  CustomBase->intreq = INTF_AUD0;

  if ( ( --Change ) < 0 )
  {
    Change = 0;

    CustomBase->aud[0].ac_per = Period;
    CustomBase->aud[1].ac_per = Period;
    CustomBase->aud[2].ac_per = Period;
    CustomBase->aud[3].ac_per = Period;
  }

  if ( ( MixSIRQ.is_Node.ln_Type == NT_SOFTINT ))
  {
    if ( PaulaStopFlag < 0 )
    {
      SoundDeviceBase = (struct SoundDeviceInfo *) &InternalPaulaBase;

      NewPeriod = (PerFrequency / SoundDeviceBase->sdi_ChannelFreq) + 32;
      NewFrequency = PerFrequency / NewPeriod;

      if ( NewFrequency < SoundDeviceBase->sdi_LowFrequency )
      {
        CustomBase->intena = INTF_AUD0;
        CustomBase->dmacon = DMAF_AUDIO;
      } else
      {
        CustomBase->aud[0].ac_per = NewPeriod;
        CustomBase->aud[1].ac_per = NewPeriod;
        CustomBase->aud[2].ac_per = NewPeriod;
        CustomBase->aud[3].ac_per = NewPeriod;
        Period = NewPeriod;

        ExternalMixerChangeRateBase ( MixLibBase, NewFrequency, MixLibBase->mas_MixLibBase );
      }
    } else if ( PaulaStopFlag > 0 )
    {
      CustomBase->intena = INTF_AUD0;
      CustomBase->dmacon = DMAF_AUDIO;
    }

    return;
  }

  if ( (MixWhichBuf = ~MixWhichBuf) )
    Data += 2;

  ChipBuf = (BYTE *) *Data++;

  CustomBase->aud[0].ac_ptr = (UWORD *) ChipBuf;
  CustomBase->aud[3].ac_ptr = (UWORD *) ChipBuf;

  MixDestBuf[0] = ChipBuf;

  ChipBuf = (BYTE *) *Data;

  CustomBase->aud[1].ac_ptr = (UWORD *) ChipBuf;
  CustomBase->aud[2].ac_ptr = (UWORD *) ChipBuf;

  MixDestBuf[1] = ChipBuf;

  Cause ( (struct Interrupt *) &MixSIRQ );
}

static void ASM AudSISurroundm ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1))
{
  LONG *CopyMixBuf = *Data;
  BYTE *CopyChipBuf;
  BYTE *CopySurChipBuf;
  struct MixerAllocStruct *MixerLibBase = MixLibBase;
  BYTE FirstSmp, SecondSmp;
  ULONG i;

  ExternalMixerDoMixBase ( MixerLibBase, CopyMixBuf, MixerLibBase->mas_MixLibBase );

  CopyChipBuf = (BYTE *) MixDestBuf[0];
  CopySurChipBuf = (BYTE *) MixDestBuf[1];

  for (i = (MixBufSize >> 1); i > 0; i--)
  {
    FirstSmp = *(BYTE *) CopyMixBuf;
    CopyMixBuf++;

    SecondSmp = *(BYTE *) CopyMixBuf;
    CopyMixBuf++;

    *CopyChipBuf++ = FirstSmp;
    *CopySurChipBuf++ = ~FirstSmp;

    *CopyChipBuf++ = SecondSmp;
    *CopySurChipBuf++ = ~SecondSmp;
  }
}

static void ASM AudISurrounds ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1))
{
  struct SoundDeviceInfo *SoundDeviceBase;
  ULONG NewFrequency, NewPeriod;
  BYTE *ChipLeftBuf;
  BYTE *ChipRightBuf;

  CustomBase->intreq = INTF_AUD0;

  if ( ( --Change ) < 0 )
  {
    Change = 0;

    CustomBase->aud[0].ac_per = Period;
    CustomBase->aud[1].ac_per = Period;
    CustomBase->aud[2].ac_per = Period;
    CustomBase->aud[3].ac_per = Period;
  }

  if ( ( MixSIRQ.is_Node.ln_Type == NT_SOFTINT ))
  {
    if ( PaulaStopFlag < 0 )
    {
      SoundDeviceBase = (struct SoundDeviceInfo *) &InternalPaulaBase;

      NewPeriod = (PerFrequency / SoundDeviceBase->sdi_ChannelFreq) + 32;
      NewFrequency = PerFrequency / NewPeriod;

      if ( NewFrequency < SoundDeviceBase->sdi_LowFrequency )
      {
        CustomBase->intena = INTF_AUD0;
        CustomBase->dmacon = DMAF_AUDIO;
      } else
      {
        CustomBase->aud[0].ac_per = NewPeriod;
        CustomBase->aud[1].ac_per = NewPeriod;
        CustomBase->aud[2].ac_per = NewPeriod;
        CustomBase->aud[3].ac_per = NewPeriod;
        Period = NewPeriod;

        ExternalMixerChangeRateBase ( MixLibBase, NewFrequency, MixLibBase->mas_MixLibBase );
      }
    } else if ( PaulaStopFlag > 0 )
    {
      CustomBase->intena = INTF_AUD0;
      CustomBase->dmacon = DMAF_AUDIO;
    }

    return;
  }

  if ( (MixWhichBuf = ~MixWhichBuf) )
    Data += 4;

  ChipLeftBuf = (BYTE *) *Data++;
  ChipRightBuf = (BYTE *) *Data++;

  MixDestBuf[0] = ChipLeftBuf;
  MixDestBuf[1] = ChipRightBuf;

  if ( SwapCh )
  {
    CustomBase->aud[0].ac_ptr = (UWORD *) ChipRightBuf;
    CustomBase->aud[1].ac_ptr = (UWORD *) ChipRightBuf;

    ChipLeftBuf = (BYTE *) *Data++;
    ChipRightBuf = (BYTE *) *Data;

    MixDestBuf[2] = ChipLeftBuf;
    MixDestBuf[3] = ChipRightBuf;

    CustomBase->aud[2].ac_ptr = (UWORD *) ChipLeftBuf;
    CustomBase->aud[3].ac_ptr = (UWORD *) ChipLeftBuf;
  } else
  {
    CustomBase->aud[0].ac_ptr = (UWORD *) ChipLeftBuf;
    CustomBase->aud[1].ac_ptr = (UWORD *) ChipLeftBuf;

    ChipLeftBuf = (BYTE *) *Data++;
    ChipRightBuf = (BYTE *) *Data;

    MixDestBuf[2] = ChipLeftBuf;
    MixDestBuf[3] = ChipRightBuf;

    CustomBase->aud[2].ac_ptr = (UWORD *) ChipRightBuf;
    CustomBase->aud[3].ac_ptr = (UWORD *) ChipRightBuf;
  }

  Cause ( (struct Interrupt *) &MixSIRQ );
}

static void ASM AudSISurrounds ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1))
{
  LONG *CopyMixBuf = *Data;
  BYTE *CopyLeftChipBuf;
  BYTE *CopyRightChipBuf;
  BYTE *CopyLeftSurChipBuf;
  BYTE *CopyRightSurChipBuf;
  struct MixerAllocStruct *MixerLibBase = MixLibBase;
  BYTE FirstLeftSmp, FirstRightSmp, SecondLeftSmp, SecondRightSmp;
  ULONG i;

  ExternalMixerDoMixBase ( MixerLibBase, CopyMixBuf, MixerLibBase->mas_MixLibBase );

  CopyLeftChipBuf = (BYTE *) MixDestBuf[0];
  CopyRightChipBuf = (BYTE *) MixDestBuf[1];
  CopyLeftSurChipBuf = (BYTE *) MixDestBuf[2];
  CopyRightSurChipBuf = (BYTE *) MixDestBuf[3];

  for (i = (MixBufSize >> 1); i > 0; i--)
  {
    FirstLeftSmp = *(BYTE *) CopyMixBuf;
    CopyMixBuf++;

    FirstRightSmp = *(BYTE *) CopyMixBuf;
    CopyMixBuf++;

    SecondLeftSmp = *(BYTE *) CopyMixBuf;
    CopyMixBuf++;

    SecondRightSmp = *(BYTE *) CopyMixBuf;
    CopyMixBuf++;

    *CopyLeftChipBuf++ = FirstLeftSmp;
    *CopyLeftSurChipBuf++ = ~FirstLeftSmp;

    *CopyRightChipBuf++ = FirstRightSmp;
    *CopyRightSurChipBuf++ = ~FirstRightSmp;

    *CopyLeftChipBuf++ = SecondLeftSmp;
    *CopyLeftSurChipBuf++ = ~SecondLeftSmp;

    *CopyRightChipBuf++ = SecondRightSmp;
    *CopyRightSurChipBuf++ = ~SecondRightSmp;
  }
}

static void ASM AudI14m ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1))
{
  struct SoundDeviceInfo *SoundDeviceBase;
  ULONG NewFrequency, NewPeriod;
  BYTE *ChipBuf;

  CustomBase->intreq = INTF_AUD0;

  if ( ( --Change ) < 0 )
  {
    Change = 0;

    CustomBase->aud[0].ac_per = Period;
    CustomBase->aud[1].ac_per = Period;
    CustomBase->aud[2].ac_per = Period;
    CustomBase->aud[3].ac_per = Period;
  }

  if ( ( MixSIRQ.is_Node.ln_Type == NT_SOFTINT ))
  {
    if ( PaulaStopFlag < 0 )
    {
      SoundDeviceBase = (struct SoundDeviceInfo *) &InternalPaulaBase;

      NewPeriod = (PerFrequency / SoundDeviceBase->sdi_ChannelFreq) + 32;
      NewFrequency = PerFrequency / NewPeriod;

      if ( NewFrequency < SoundDeviceBase->sdi_LowFrequency )
      {
        CustomBase->intena = INTF_AUD0;
        CustomBase->dmacon = DMAF_AUDIO;
      } else
      {
        CustomBase->aud[0].ac_per = NewPeriod;
        CustomBase->aud[1].ac_per = NewPeriod;
        CustomBase->aud[2].ac_per = NewPeriod;
        CustomBase->aud[3].ac_per = NewPeriod;
        Period = NewPeriod;

        ExternalMixerChangeRateBase ( MixLibBase, NewFrequency, MixLibBase->mas_MixLibBase );
      }
    } else if ( PaulaStopFlag > 0 )
    {
      CustomBase->intena = INTF_AUD0;
      CustomBase->dmacon = DMAF_AUDIO;
    }

    return;
  }

  if ( (MixWhichBuf = ~MixWhichBuf) )
    Data += 2;

  ChipBuf = (BYTE *) *Data++;

  CustomBase->aud[0].ac_ptr = (UWORD *) ChipBuf;
  CustomBase->aud[1].ac_ptr = (UWORD *) ChipBuf;

  MixDestBuf[0] = ChipBuf;

  ChipBuf = (BYTE *) *Data;

  CustomBase->aud[2].ac_ptr = (UWORD *) ChipBuf;
  CustomBase->aud[3].ac_ptr = (UWORD *) ChipBuf;

  MixDestBuf[1] = ChipBuf;

  Cause ( (struct Interrupt *) &MixSIRQ );
}

static void ASM AudSI14m ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1))
{
  BYTE *CopyMixBuf = (BYTE *) *Data;
  BYTE *CopyChipBuf;
  BYTE *Copy14ChipBuf;
  struct MixerAllocStruct *MixerLibBase = MixLibBase;
  ULONG i;

  ExternalMixerDoMixBase ( MixerLibBase, (LONG *) CopyMixBuf, MixerLibBase->mas_MixLibBase );

  CopyChipBuf = (BYTE *) MixDestBuf[0];
  Copy14ChipBuf = (BYTE *) MixDestBuf[1];

  for (i = (MixBufSize >> 1); i > 0; i--)
  {
    *CopyChipBuf++ = *CopyMixBuf++;
    *Copy14ChipBuf++ = *CopyMixBuf << 2;
    CopyMixBuf += 3;

    *CopyChipBuf++ = *CopyMixBuf++;
    *Copy14ChipBuf++ = *CopyMixBuf << 2;
    CopyMixBuf += 3;
  }
}

static void ASM AudI14s ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1))
{
  struct SoundDeviceInfo *SoundDeviceBase;
  ULONG NewFrequency, NewPeriod;
  BYTE *ChipLeftBuf;
  BYTE *ChipRightBuf;

  CustomBase->intreq = INTF_AUD0;

  if ( ( --Change ) < 0 )
  {
    Change = 0;

    CustomBase->aud[0].ac_per = Period;
    CustomBase->aud[1].ac_per = Period;
    CustomBase->aud[2].ac_per = Period;
    CustomBase->aud[3].ac_per = Period;
  }

  if ( ( MixSIRQ.is_Node.ln_Type == NT_SOFTINT ))
  {
    if ( PaulaStopFlag < 0 )
    {
      SoundDeviceBase = (struct SoundDeviceInfo *) &InternalPaulaBase;

      NewPeriod = (PerFrequency / SoundDeviceBase->sdi_ChannelFreq) + 32;
      NewFrequency = PerFrequency / NewPeriod;

      if ( NewFrequency < SoundDeviceBase->sdi_LowFrequency )
      {
        CustomBase->intena = INTF_AUD0;
        CustomBase->dmacon = DMAF_AUDIO;
      } else
      {
        CustomBase->aud[0].ac_per = NewPeriod;
        CustomBase->aud[1].ac_per = NewPeriod;
        CustomBase->aud[2].ac_per = NewPeriod;
        CustomBase->aud[3].ac_per = NewPeriod;
        Period = NewPeriod;

        ExternalMixerChangeRateBase ( MixLibBase, NewFrequency, MixLibBase->mas_MixLibBase );
      }
    } else if ( PaulaStopFlag > 0 )
    {
      CustomBase->intena = INTF_AUD0;
      CustomBase->dmacon = DMAF_AUDIO;
    }

    return;
  }

  if ( (MixWhichBuf = ~MixWhichBuf) )
    Data += 4;

  ChipLeftBuf = (BYTE *) *Data++;
  ChipRightBuf = (BYTE *) *Data++;

  MixDestBuf[0] = ChipLeftBuf;
  MixDestBuf[1] = ChipRightBuf;

  if ( SwapCh )
  {
    CustomBase->aud[1].ac_ptr = (UWORD *) ChipLeftBuf;
    CustomBase->aud[2].ac_ptr = (UWORD *) ChipRightBuf;

    ChipLeftBuf = (BYTE *) *Data++;
    ChipRightBuf = (BYTE *) *Data;

    MixDestBuf[2] = ChipLeftBuf;
    MixDestBuf[3] = ChipRightBuf;

    CustomBase->aud[0].ac_ptr = (UWORD *) ChipLeftBuf;
    CustomBase->aud[3].ac_ptr = (UWORD *) ChipRightBuf;
  } else
  {
    CustomBase->aud[0].ac_ptr = (UWORD *) ChipLeftBuf;
    CustomBase->aud[3].ac_ptr = (UWORD *) ChipRightBuf;

    ChipLeftBuf = (BYTE *) *Data++;
    ChipRightBuf = (BYTE *) *Data;

    MixDestBuf[2] = ChipLeftBuf;
    MixDestBuf[3] = ChipRightBuf;

    CustomBase->aud[1].ac_ptr = (UWORD *) ChipLeftBuf;
    CustomBase->aud[2].ac_ptr = (UWORD *) ChipRightBuf;
  }

  Cause ( (struct Interrupt *) &MixSIRQ );
}

static void ASM AudSI14s ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1))
{
  BYTE *CopyMixBuf = (BYTE *) *Data;
  BYTE *CopyLeftChipBuf;
  BYTE *CopyRightChipBuf;
  BYTE *CopyLeft14ChipBuf;
  BYTE *CopyRight14ChipBuf;
  struct MixerAllocStruct *MixerLibBase = MixLibBase;
  ULONG i;

  ExternalMixerDoMixBase ( MixerLibBase, (LONG *) CopyMixBuf, MixerLibBase->mas_MixLibBase );

  CopyLeftChipBuf = (BYTE *) MixDestBuf[0];
  CopyLeft14ChipBuf = (BYTE *) MixDestBuf[1];
  CopyRightChipBuf = (BYTE *) MixDestBuf[2];
  CopyRight14ChipBuf = (BYTE *) MixDestBuf[3];

  for (i = (MixBufSize >> 1); i > 0; i--)
  {
    *CopyLeftChipBuf++ = *CopyMixBuf++;
    *CopyLeft14ChipBuf++ = *CopyMixBuf << 2;
    CopyMixBuf += 3;

    *CopyRightChipBuf++ = *CopyMixBuf++;
    *CopyRight14ChipBuf++ = *CopyMixBuf << 2;
    CopyMixBuf += 3;

    *CopyLeftChipBuf++ = *CopyMixBuf++;
    *CopyLeft14ChipBuf++ = *CopyMixBuf << 2;
    CopyMixBuf += 3;

    *CopyRightChipBuf++ = *CopyMixBuf++;
    *CopyRight14ChipBuf++ = *CopyMixBuf << 2;
    CopyMixBuf += 3;
  }
}

static void ASM AudSICal14m ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1))
{
  LONG *CopyMixBuf = *Data;
  BYTE *CopyChipBuf;
  BYTE *Copy14ChipBuf;
  WORD *CalibTab = CalibTable;
  struct MixerAllocStruct *MixerLibBase = MixLibBase;
  UWORD Sample;
  ULONG i;

  ExternalMixerDoMixBase ( MixerLibBase, CopyMixBuf, MixerLibBase->mas_MixLibBase );

  CopyChipBuf = (BYTE *) MixDestBuf[0];
  Copy14ChipBuf = (BYTE *) MixDestBuf[1];

  for (i = (MixBufSize >> 1); i > 0; i--)
  {
    Sample = *(WORD *) CopyMixBuf;
    CopyMixBuf++;

    Sample = CalibTab[Sample];

    *CopyChipBuf++ = Sample >> 8;
    *Copy14ChipBuf++ = Sample;

    Sample = *(WORD *) CopyMixBuf;
    CopyMixBuf++;

    Sample = CalibTab[Sample];

    *CopyChipBuf++ = Sample >> 8;
    *Copy14ChipBuf++ = Sample;
  }
}

static void ASM AudSICal14s ( register __a0 struct Custom *CustomBase GNUCREG(a0), register __a1 LONG **Data GNUCREG(a1))
{
  LONG *CopyMixBuf = *Data;
  BYTE *CopyLeftChipBuf;
  BYTE *CopyRightChipBuf;
  BYTE *CopyLeft14ChipBuf;
  BYTE *CopyRight14ChipBuf;
  WORD *CalibTab = CalibTable;
  struct MixerAllocStruct *MixerLibBase = MixLibBase;
  UWORD Sample;
  ULONG i;

  ExternalMixerDoMixBase ( MixerLibBase, CopyMixBuf, MixerLibBase->mas_MixLibBase );

  CopyLeftChipBuf = (BYTE *) MixDestBuf[0];
  CopyLeft14ChipBuf = (BYTE *) MixDestBuf[1];
  CopyRightChipBuf = (BYTE *) MixDestBuf[2];
  CopyRight14ChipBuf = (BYTE *) MixDestBuf[3];

  for (i = (MixBufSize >> 1); i > 0; i--)
  {
    Sample = *(WORD *) CopyMixBuf;
    CopyMixBuf++;

    Sample = CalibTab[Sample];

    *CopyLeftChipBuf++ = Sample >> 8;
    *CopyLeft14ChipBuf++ = Sample;

    Sample = *(WORD *) CopyMixBuf;
    CopyMixBuf++;

    Sample = CalibTab[Sample];

    *CopyRightChipBuf++ = Sample >> 8;
    *CopyRight14ChipBuf++ = Sample;

    Sample = *(WORD *) CopyMixBuf;
    CopyMixBuf++;

    Sample = CalibTab[Sample];

    *CopyLeftChipBuf++ = Sample >> 8;
    *CopyLeft14ChipBuf++ = Sample;

    Sample = *(WORD *) CopyMixBuf;
    CopyMixBuf++;

    Sample = CalibTab[Sample];

    *CopyRightChipBuf++ = Sample >> 8;
    *CopyRight14ChipBuf++ = Sample;
  }
}
