/* TuComposer AmigaOS dependent code
**
** $VER: InternalPoostBoost.c 31.00 (5.3.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <exec/execbase.h>
#include <exec/libraries.h>
#include <tucomposer/tucomposer.h>
#include <tucomposer/external/external.h>
#include <tucomposer/external/postproc.h>
#include <proto/tucomposer.h>

#include "compiler.h"

#ifdef __cplusplus
extern "C" {
#endif

static struct TuComposerExtLibBase *InternalPostBoostOpenExtLib ( void );
static BPTR InternalPostBoostCloseExtLib ( void );
static BPTR ExtLib ( void );
static ULONG InternalPostBoostUpdate ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum );
static struct PostProcAllocStruct *InternalPostBoostAlloc ( struct MixerAllocStruct *MixAllocStr );
static ULONG InternalPostBoostFree ( struct PostProcAllocStruct *PostAllocStr );
static ULONG InternalPostBoostInit ( struct PostProcAllocStruct *PostAllocStr,
    struct MixerAllocStruct *MixAllocStr, union FlagPass *FlagPassStr );
static ULONG InternalPostBoostChange ( struct PostProcAllocStruct *PostAllocStr,
    struct MixerAllocStruct *MixAllocStr );
static void InternalPostBoostDoMix ( struct PostProcAllocStruct *PostAllocStr, long *MixBuffer );

#ifdef __cplusplus
}
#endif

extern struct ExecBase *SysBase;
extern struct PostProcInfo InternalPostProcBase;
extern struct InternalPostBoostFlagStr InternalPostBoostSaveFlags;

static UBYTE InternalPostBoostName[] = "internal_postboost.library\0";
static UBYTE InternalPostBoostLoadID[] = "Post volume booster\0";
static UBYTE InternalPostBoostIDString[] = "Internal Post Boost Lib Version 1.00 (v31) (05 Mar 00) by Basty/Seasons.\0";

static ULONG Amplify = 0x20000L;

struct TuComposerExtList InternalPostProc =
{
  {NULL, NULL},
  EXTLF_Intern|EXTLF_Saver, 0,
  (struct TuComposerExtLibBase *) &InternalPostProcBase,
  NULL,
  (STRPTR) &InternalPostBoostName,
  (STRPTR) &InternalPostBoostLoadID,
  NULL,
  (struct TuComposerExtFlagStr *) &InternalPostBoostSaveFlags,
  0
};

#include "InternalPostBoost_library.h"

static UBYTE SaveText0[] = "Amplify volume by\0";

static struct InternalPostBoostFlagStr {
  UWORD  tefs_NumEntries;
  UWORD  tefs_StructSize;
  union FlagEntrySliderStruct tefs_Flag0;
} InternalPostBoostSaveFlags =
{
  1, sizeof (InternalPostBoostSaveFlags),
  {(STRPTR) &SaveText0, EXTFLAG_SLIDER, TEFSF_Update|TEFSF_FixedValues, 0, 0L, 0x100000L, 0x20000L, NULL}
};

static struct TuComposerExtLibBase *InternalPostBoostOpenExtLib ( void )
{
  InternalPostProcBase.pop_Library.extb_LibNode.lib_OpenCnt++;

  return ( (struct TuComposerExtLibBase *) &InternalPostProcBase );
}

static BPTR InternalPostBoostCloseExtLib ( void )
{
  InternalPostProcBase.pop_Library.extb_LibNode.lib_OpenCnt--;

  return ( NULL );
}

static BPTR ExtLib ( void )
{
  return ( NULL );
}

static ULONG InternalPostBoostUpdate ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum )
{
  Amplify = FlagPassStr[0].flg_Value;

  return ( 0L );
}

static struct PostProcAllocStruct *InternalPostBoostAlloc ( struct MixerAllocStruct *MixAllocStr )
{
  struct PostProcAllocStruct *PostAllocStr;

  if ( ( PostAllocStr = (struct PostProcAllocStruct *) AllocPMem ( sizeof (struct PostProcAllocStruct))))
  {
    PostAllocStr->pas_PostProcLibBase = (struct PostProcInfo *) &(InternalPostProcBase);

    PostAllocStr->pas_MixAllocStr = MixAllocStr;
  }

  return ( PostAllocStr );
}

static ULONG InternalPostBoostFree ( struct PostProcAllocStruct *PostAllocStr )
{
  FreePMem ( PostAllocStr, sizeof (struct PostProcAllocStruct));

  return ( 0L );
}

static ULONG InternalPostBoostInit ( struct PostProcAllocStruct *PostAllocStr,
    struct MixerAllocStruct *MixAllocStr, union FlagPass *FlagPassStr )
{
  return ( 0L );
}

static ULONG InternalPostBoostChange ( struct PostProcAllocStruct *PostAllocStr,
    struct MixerAllocStruct *MixAllocStr )
{
  return ( 0L );
}

static void InternalPostBoostDoMix ( struct PostProcAllocStruct *PostAllocStr, long *MixBuffer )
{
  struct MixerAllocStruct *MixAllocStr = PostAllocStr->pas_MixAllocStr;
  ULONG i = MixAllocStr->mas_MixBufSize, AmpMul = Amplify;
  long long Sample;

  if ( MixAllocStr->mas_Flags & MASF_Stereo )
    i += i;

  i >>= 1UL;

  do
  {
    Sample = ((long long) *MixBuffer * AmpMul) >> 16LL;

    if ( Sample < -2147483648LL )
      Sample = -2147483648LL;

    if ( Sample > 2147483647LL )
      Sample = 2147483647LL;

    *MixBuffer++ = Sample;

    Sample = ((long long) *MixBuffer * AmpMul) >> 16LL;

    if ( Sample < -2147483648LL )
      Sample = -2147483648LL;

    if ( Sample > 2147483647LL )
      Sample = 2147483647LL;

    *MixBuffer++ = Sample;
  } while ( --i );
}
