/* TuComposer AmigaOS dependent code
**
** $VER: InternalQuiet.c 31.00 (3.3.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <exec/execbase.h>
#include <exec/interrupts.h>
#include <exec/libraries.h>
#include <exec/lists.h>
#include <exec/memory.h>
#include <exec/nodes.h>
#include <dos/dos.h>
#include <tucomposer/tucomposer.h>
#include <tucomposer/external/external.h>
#include <tucomposer/external/device.h>
#include <proto/exec.h>
#include <proto/tucomposer.h>

#include "compiler.h"

#ifdef __cplusplus
extern "C" {
#endif

static struct TuComposerExtLibBase *InternalQuietOpenExtLib ( void );
static BPTR InternalQuietCloseExtLib ( void );
static BPTR ExtLib ( void );
static ULONG InternalQuietUpdate ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum );
static ULONG InternalQuietAlloc ( union FlagPass *FlagPassStr );
static ULONG InternalQuietFree ( void );
static ULONG InternalQuietPlay ( struct MixerAllocStruct *MixAllocStr,
    union FlagPass *FlagPassStr );
static ULONG InternalQuietStop ( void );
static ULONG InternalQuietCheckRate ( unsigned long SmpRate );
static ULONG InternalQuietCheckRateFraction ( unsigned long SmpRate );
static ULONG InternalQuietUpdateRate ( unsigned long SmpRate );

#ifdef __cplusplus
}
#endif

extern struct ExecBase *SysBase;
extern struct SoundDeviceInfo InternalSoundDeviceBase;

static UBYTE InternalQuietName[] = "internal_quiet.library\0";
static UBYTE InternalQuietLoadID[] = "Eternal Quiet Device\0";
static UBYTE InternalQuietIDString[] = "Internal Quiet Lib Version 1.00 (v31) (03 Mar 00) by Basty/Seasons.\0";

struct TuComposerExtList InternalSoundDevice =
{
  {NULL, NULL},
  EXTLF_Intern, -128,
  (struct TuComposerExtLibBase *) &InternalSoundDeviceBase,
  NULL,
  (STRPTR) &InternalQuietName,
  (STRPTR) &InternalQuietLoadID,
  NULL,
  NULL,
  0
};

#include "InternalQuiet_library.h"

static struct TuComposerExtLibBase *InternalQuietOpenExtLib ( void )
{
  InternalSoundDeviceBase.sdi_Library.extb_LibNode.lib_OpenCnt++;

  return ( (struct TuComposerExtLibBase *) &InternalSoundDeviceBase );
}

static BPTR InternalQuietCloseExtLib ( void )
{
  InternalSoundDeviceBase.sdi_Library.extb_LibNode.lib_OpenCnt--;

  return ( NULL );
}

static BPTR ExtLib ( void )
{
  return ( NULL );
}

static ULONG InternalQuietUpdate ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum )
{
  return ( 0L );
}

static ULONG InternalQuietAlloc ( union FlagPass *FlagPassStr )
{
  if (!( InternalSoundDeviceBase.sdi_Flags & SDIF_Allocated ))
  {
    InternalSoundDeviceBase.sdi_Task = FindTask ( NULL );

    InternalSoundDeviceBase.sdi_Flags |= SDIF_Allocated;

    return ( 0L );
  }

  return ( ERROR_EXTLIB_BUSY );
}

static ULONG InternalQuietFree ( void )
{
  if ( (InternalSoundDeviceBase.sdi_Flags & SDIF_Allocated ))
  {
    InternalSoundDeviceBase.sdi_Task = NULL;

    InternalSoundDeviceBase.sdi_Flags &= ~(SDIF_Allocated);

    return ( 0L );
  }

  return ( ERROR_EXTLIB_BUSY );
}

static ULONG InternalQuietPlay ( struct MixerAllocStruct *MixAllocStr,
    union FlagPass *FlagPassStr )
{
  return ( 0L );
}

static ULONG InternalQuietStop ( void )
{
  if ( (InternalSoundDeviceBase.sdi_Flags & SDIF_Playing ))
  {
    return ( 0L );
  }

  return ( ERROR_EXTLIB_BUSY );
}

static ULONG InternalQuietCheckRate ( unsigned long SmpRate )
{
  return ( SmpRate );
}

static ULONG InternalQuietCheckRateFraction ( unsigned long SmpRate )
{
  return ( 0L );
}

static ULONG InternalQuietUpdateRate ( unsigned long SmpRate )
{
  InternalSoundDeviceBase.sdi_ChannelFreq = SmpRate;

  return ( 0L );
}
