/* TuComposer OS independent code
**
** $VER: InternalSoundDevice.c 31.22 (3.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <exec/libraries.h>
#include <tucomposer/tucomposer.h>
#include <tucomposer/external/device.h>
#include <clib/tucomposer_protos.h>

static struct TuComposerExtLibBase *OpenExtLib ( struct TuComposerExtLibBase *ExtLibBase );
static BPTR CloseExtLib ( struct TuComposerExtLibBase *ExtLibBase );
static BPTR ExtLib ( void );
static ULONG InternalSoundDeviceUpdate ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum );
static ULONG InternalSoundDeviceAlloc ( void );
static ULONG InternalSoundDeviceFree ( void );
static ULONG InternalSoundDevicePlay ( struct MixerAllocStruct *MixAllocStr,
    union FlagPass *FlagPassStr );
static ULONG InternalSoundDeviceStop ( void );
static ULONG InternalSoundDeviceCheckRate ( unsigned long SmpRate );
static ULONG InternalSoundDeviceCheckRateFraction ( unsigned long SmpRate );
static ULONG InternalSoundDeviceUpdateRate ( unsigned long SmpRate );

extern struct SoundDeviceInfo InternalSoundDeviceBase;
static struct InternalSoundDeviceFlagStr InternalSoundDeviceSaveFlags;
static APTR InternalSoundDeviceExtFuncList [];
static APTR InternalSoundDeviceFuncList [];

static UBYTE InternalSoundDeviceName[] = "internal_sounddevice.library\0";
static UBYTE InternalSoundDeviceLoadID[] = "Internal Sound Device\0";
static UBYTE InternalSoundDeviceIDString[] = "Internal Sound Device Lib v31.00 (03 Aug 99) by Basty/Seasons.\0";

struct TuComposerExtList InternalSoundDevice =
{
  {NULL, NULL},
  EXTLF_Intern|EXTLF_Loader|EXTLF_Saver, 0,
  (struct TuComposerExtLibBase *) &InternalSoundDeviceBase,
  NULL,
  (STRPTR) &InternalSoundDeviceName,
  (STRPTR) &InternalSoundDeviceLoadID,
  NULL,
  (struct TuComposerExtFlagStr *) &InternalSoundDeviceSaveFlags,
  0
};

struct SoundDeviceInfo InternalSoundDeviceBase =
{
  {{{NULL, NULL, NT_LIBRARY, 0, (STRPTR) &InternalSoundDeviceName},
      LIBF_SUMUSED, 0,
      0, sizeof (struct SoundDeviceInfo), /* NegSize, PosSize */
      EXTLIB_DEVICE_VERSION,
      EXTLIB_REVISION,
      (STRPTR) &InternalSoundDeviceIDString,
      NULL, 0},
    NULL,
    (struct ExtFuncList *) &InternalSoundDeviceExtFuncList,
    NULL,
    (struct TuComposerExtList *) &InternalSoundDevice},
  (struct SoundDeviceFunc *) &InternalSoundDeviceFuncList,
  SDIF_Stereo, 0,
  4000, 256000
};

static UBYTE SaveText0[] = "Checkmark button\0";

static struct InternalSoundDeviceFlagStr {
  UWORD  tefs_NumEntries;
  UWORD  tefs_StructSize;
  union FlagEntryStruct tefs_Flag0;
} InternalSoundDeviceSaveFlags =
{
  1, sizeof (InternalSoundDeviceSaveFlags),
  {(STRPTR) &SaveText0, EXTFLAG_BOOLEAN, TEFSF_Update, 0, 0L, 0L, 0xFFFFFFFFL}
};

static APTR InternalSoundDeviceExtFuncList[] =
{
  OpenExtLib,
  CloseExtLib,
  ExtLib,
  ExtLib,
  ExtLib,
  InternalSoundDeviceUpdate,
  ExtLib,
  ExtLib
};

static APTR InternalSoundDeviceFuncList[] =
{
  InternalSoundDeviceAlloc,
  InternalSoundDeviceFree,
  InternalSoundDevicePlay,
  InternalSoundDeviceStop,
  InternalSoundDeviceCheckRate,
  InternalSoundDeviceCheckRateFraction,
  InternalSoundDeviceUpdateRate
};

static struct TuComposerExtLibBase *OpenExtLib ( struct TuComposerExtLibBase *ExtLibBase )
{
  return ( NULL );
}

static BPTR CloseExtLib ( struct TuComposerExtLibBase *ExtLibBase )
{
  return ( NULL );
}

static BPTR ExtLib ( void )
{
  return ( NULL );
}

static ULONG InternalSoundDeviceUpdate ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum )
{
  return ( 0L );
}

static ULONG InternalSoundDeviceAlloc ( void )
{
  return ( 0L );
}

static ULONG InternalSoundDeviceFree ( void )
{
  return ( 0L );
}

static ULONG InternalSoundDevicePlay ( struct MixerAllocStruct *MixAllocStr,
    union FlagPass *FlagPassStr )
{
  return ( 0L );
}

static ULONG InternalSoundDeviceStop ( void )
{
  return ( 0L );
}

static ULONG InternalSoundDeviceCheckRate ( unsigned long SmpRate )
{
  return ( 0L );
}

static ULONG InternalSoundDeviceCheckRateFraction ( unsigned long SmpRate )
{
  return ( 0L );
}

static ULONG InternalSoundDeviceUpdateRate ( unsigned long SmpRate )
{
  return ( 0L );
}
