/* TuComposer OS independent code
**
** $VER: AllocSimulateMix.c 31.22 (1.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_mixerbase_protos.h>

struct ChannelInfo {
  struct ChannelBlock {
    WORD *chi_SampleStartAdr;
    ULONG chi_SampleLen;
    ULONG chi_Offset;
    ULONG chi_Fraction;
    ULONG chi_Advance;
    ULONG chi_AdvFract;
    void (*chi_MixRoutine)( UWORD Samples, ULONG Offset, ULONG Fraction, ULONG Advance, ULONG AdvFract );
    ULONG chi_EndOffset;
    ULONG chi_RestartOffset;
    ULONG chi_Repeat;
    ULONG chi_RepLen;
    ULONG chi_CountRestart;
    ULONG chi_Counted;
    ULONG chi_SampleRate;
    void (*chi_AltMixRoutine)( UWORD Samples, ULONG Offset, ULONG Fraction, ULONG Advance, ULONG AdvFract );
    UBYTE chi_BitDepth;
    UBYTE chi_Flags;
    UBYTE chi_Volume;
    UBYTE chi_Panning;
  } chi_Mix;
  struct ChannelBlock chi_New;
}; /* ChannelInfo */

struct CountMixerAllocStruct {
  struct MixerAllocStruct cntmas_AllocMixStruct;
  struct ChannelInfo *cntmas_ChInfo;
  ULONG  cntmas_Tempo;
  ULONG  cntmas_PassLength;
  ULONG  cntmas_PassFrac;
  ULONG  cntmas_CurrLeftFrac;
  UWORD  cntmas_Channels;
}; /* CountMixerAllocStruct */

extern struct TuComposerBase *TuCBase;
extern struct MixerInfo *CountMixLib;

struct TuComposerBase *AllocSimulateMix ( struct TuComposerSong *SongStr )
{
  struct TuComposerBase *PseudoTuCBase = NULL;

  if ( SongStr )
  {
    ULONG LibPosSize = TuCBase->tcb_LibNode.lib_PosSize, LibNegSize = TuCBase->tcb_LibNode.lib_NegSize;

    if ( (PseudoTuCBase = (struct TuComposerBase *) AllocPMem( LibPosSize + LibNegSize )))
    {
      struct TuComposerModule *ModuleStr;
      struct TuComposerModule *SimModuleStr;
      struct TuComposerSong *SimSongStr;
      struct TuComposerOrders *PosStr;
      struct CountMixerAllocStruct *CntMixAllocStr;

      memcpy ( PseudoTuCBase, (UBYTE *) TuCBase + (-LibNegSize), LibPosSize + LibNegSize );

      (UBYTE *) PseudoTuCBase += LibNegSize;

      ModuleStr = (struct TuComposerModule *) &(SongStr->tcso_Node.mln_Succ);

      for (;;)
      {
        ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

        if (!( ModuleStr->tcm_Node.mln_Pred ))
          break;
      }

      (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_SongList );

      if ( (SimModuleStr = AllocTCModule ( ModuleStr->tcm_Channels )))
      {
        if ( (SimSongStr = AllocSong ( SongStr->tcso_Channels, SongStr->tcso_GoSubStackSize, SongStr->tcso_LoopStackSize )))
        {
          AddSong ( SimModuleStr, SimSongStr );

          if ( (PosStr = DupPosition ( SongStr->tcso_Position, SongStr->tcso_Channels )))
          {
            SetPosition ( SimSongStr, PosStr );

            if ( (CntMixAllocStr = (struct CountMixerAllocStruct *) AllocPMem ( sizeof (struct CountMixerAllocStruct))))
            {
              CntMixAllocStr->cntmas_AllocMixStruct.mas_MixLibBase = (struct MixerInfo *) &(CountMixLib);
              PseudoTuCBase->tcb_PlayMixerAlloc = (struct MixerAllocStruct *) CntMixAllocStr;

              if ( (CntMixAllocStr->cntmas_ChInfo = (struct ChannelInfo *) AllocPMem ( ModuleStr->tcm_Channels * sizeof (struct ChannelInfo ))))
              {
                struct PlayerGlobals *PGStr;
                struct MixerInfo *ExtMixerLibBase;

                CntMixAllocStr->cntmas_Channels = ModuleStr->tcm_Channels;

                memcpy ( &(SimModuleStr->tcm_InstrList), &(ModuleStr->tcm_InstrList), offsetof (struct TuComposerModule, tcm_Channels) - offsetof (struct TuComposerModule, tcm_InstrList ));

                memcpy ( &(SimSongStr->tcso_CompFlags), &(SongStr->tcso_CompFlags), offsetof (struct TuComposerSong, tcso_UnknownChunks) - offsetof (struct TuComposerSong, tcso_CompFlags ));

                PseudoTuCBase->tcb_PlaySoundDeviceBase = NULL;

                PseudoTuCBase->tcb_PlayModule = SimModuleStr;
                PseudoTuCBase->tcb_PlaySong = SimSongStr;

                InitNodeList ( (struct List *) &(PseudoTuCBase->tcb_ModuleList) );
                InitNodeList ( (struct List *) &(PseudoTuCBase->tcb_ExecList) );

                AddNodeTail ( (struct List *) &(PseudoTuCBase->tcb_ModuleList), (struct Node *) SimModuleStr );

                PGStr = SimSongStr->tcso_GlobalData;

                PGStr->pg_Flags |= PGF_PlayOnce;
                PGStr->pg_RelativeSpeed = 0x10000;
                PGStr->pg_RelativePitch = 0x10000;

                memcpy ( &(SimSongStr->tcso_FramesLowerLimit), &(SongStr->tcso_FramesLowerLimit), offsetof (struct TuComposerSong, tcso_UnknownChunks) - offsetof (struct TuComposerSong, tcso_FramesLowerLimit ));

                ExtMixerLibBase = CntMixAllocStr->cntmas_AllocMixStruct.mas_MixLibBase;

                ExternalMixerChangeTempoBase ( (struct MixerAllocStruct *) CntMixAllocStr, CalcPlayerSpeed ( SimSongStr ), ExtMixerLibBase );

                ResetSong ( SimSongStr );

                PGStr->pg_PlayType = PTYPF_Song;

                return ( PseudoTuCBase );
              }

              FreePMem ( CntMixAllocStr, sizeof (struct CountMixerAllocStruct ));
            }
          }
        }

        FreeTCModule ( SimModuleStr );
      }

      FreePMem ( (UBYTE *) PseudoTuCBase + (-LibNegSize), LibPosSize + LibNegSize );

      PseudoTuCBase = NULL;
    }
  }

  return ( PseudoTuCBase );
}
