/* TuComposer OS independent code
**
** $VER: AllocUnknownChunk.c 31.22 (1.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifndef MOTOROLA
  ULONG ReadMLong ( UBYTE *Buffer );
  void WriteMLong ( UBYTE *Buffer, ULONG Value );
#else
  #define ReadMLong( Buffer ) (*(ULONG *) (Buffer))
  #define WriteMLong( Buffer, Value ) (*(ULONG *) (Buffer)) = Value
#endif

#ifdef __cplusplus
}
#endif

struct UnknownChunk *AllocUnknownChunk ( APTR PreFillData,
    unsigned long ChunkName, unsigned long ChunkLen )
{
  struct UnknownChunk *UnkChunk = NULL;

  if ( ChunkLen )
  {
    if ( UnkChunk = (struct UnknownChunk *) AllocPMem ( (sizeof (struct MinNode ) + offsetof (struct IFFChunk, iff_Data) + ChunkLen + 7 ) & 0xFFFFFFF8 ))
    {
      WriteMLong ( (UBYTE *) &(UnkChunk->uc_Identifier[0]), ChunkName );
      WriteMLong ( (UBYTE *) &(UnkChunk->uc_Length[0]), ChunkLen );

      if ( PreFillData )
        memcpy ( &(UnkChunk->uc_Data[0]), PreFillData, ChunkLen );
    }
  }

  return ( UnkChunk );
}
