/* TuComposer OS independent code
**
** $VER: DupNodeList.c 31.22 (6.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG DupNodeList ( struct MinList *SrcNodeList, struct MinList *DestNodeList,
    unsigned long NodeSize )
{
  struct MinNode *SrcNodePtr;
  struct MinNode *DestNodePtr;

  if (!(( NodeSize) && (SrcNodeList) && (DestNodeList)))
    return ( 0L );

  SrcNodePtr = (struct MinNode *) &(SrcNodeList->mlh_Head);

  for (;;)
  {
    SrcNodePtr = SrcNodePtr->mln_Succ;
    if (!( SrcNodePtr->mln_Succ))
      break;
    if (!( DestNodePtr = (struct MinNode *) AllocPMem ( NodeSize )))
    {

      DestNodePtr = (struct MinNode *) &(DestNodeList->mlh_Head);

      for (;;)
      {
        SrcNodePtr = DestNodePtr->mln_Succ;

        if (!( SrcNodePtr->mln_Succ))
          return ( 0L );

        RemNodeHead ( (struct List *) DestNodeList );
        FreePMem( SrcNodePtr, NodeSize );
      }
    }
    memcpy ( DestNodePtr + 1, SrcNodePtr + 1, NodeSize - sizeof (struct MinNode ));
    AddNodeTail ( (struct List *) DestNodeList, (struct Node *) DestNodePtr );
  }
  return ( -1L );
}
