/* TuComposer OS independent code
**
** $VER: FreeSimulateMix.c 31.22 (1.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct ChannelInfo {
  struct ChannelBlock {
    WORD *chi_SampleStartAdr;
    ULONG chi_SampleLen;
    ULONG chi_Offset;
    ULONG chi_Fraction;
    ULONG chi_Advance;
    ULONG chi_AdvFract;
    void (*chi_MixRoutine)( UWORD Samples, ULONG Offset, ULONG Fraction, ULONG Advance, ULONG AdvFract );
    ULONG chi_EndOffset;
    ULONG chi_RestartOffset;
    ULONG chi_Repeat;
    ULONG chi_RepLen;
    ULONG chi_CountRestart;
    ULONG chi_Counted;
    ULONG chi_SampleRate;
    void (*chi_AltMixRoutine)( UWORD Samples, ULONG Offset, ULONG Fraction, ULONG Advance, ULONG AdvFract );
    UBYTE chi_BitDepth;
    UBYTE chi_Flags;
    UBYTE chi_Volume;
    UBYTE chi_Panning;
  } chi_Mix;
  struct ChannelBlock chi_New;
}; /* ChannelInfo */

struct CountMixerAllocStruct {
  struct MixerAllocStruct cntmas_AllocMixStruct;
  struct ChannelInfo *cntmas_ChInfo;
  ULONG  cntmas_Tempo;
  ULONG  cntmas_PassLength;
  ULONG  cntmas_PassFrac;
  ULONG  cntmas_CurrLeftFrac;
  UWORD  cntmas_Channels;
}; /* CountMixerAllocStruct */

void FreeSimulateMix ( struct TuComposerBase *PseudoTuCBase )
{
  if ( PseudoTuCBase )
  {
    struct CountMixerAllocStruct *CntMixAllocStr = (struct CountMixerAllocStruct *) PseudoTuCBase->tcb_PlayMixerAlloc;
    struct TuComposerModule *ModuleStr = PseudoTuCBase->tcb_PlayModule;
    struct TuComposerSong *SongStr = (struct TuComposerSong *) ModuleStr->tcm_SongList.mlh_Head;
    ULONG LibNegSize = PseudoTuCBase->tcb_LibNode.lib_NegSize;

    FreePMem ( CntMixAllocStr->cntmas_ChInfo, CntMixAllocStr->cntmas_Channels * sizeof (struct ChannelInfo ));

    FreePMem ( CntMixAllocStr, sizeof (struct CountMixerAllocStruct ));

    InitNodeList ( (struct List *) &(ModuleStr->tcm_InstrList) );
    InitNodeList ( (struct List *) &(ModuleStr->tcm_Envelopes) );
    InitNodeList ( (struct List *) &(ModuleStr->tcm_KeyboardDefs) );
    InitNodeList ( (struct List *) &(ModuleStr->tcm_ArpEnvList) );

    InitNodeList ( (struct List *) &(SongStr->tcso_TrackList));

    FreeTCModule ( ModuleStr );

    FreePMem ( (UBYTE *) PseudoTuCBase + (-LibNegSize), PseudoTuCBase->tcb_LibNode.lib_PosSize + LibNegSize );
  }
}
