/* TuComposer AmigaOS dependent code
**
** $VER: Stamp2Date.c 31.22 (10.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/dos_protos.h>
#include <clib/tucomposer_protos.h>

WORD Months[] = {
  0, 31, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335, 1000
};

void Stamp2Date ( struct StampDate *StampDateStr,
    struct DateStamp *DateStampStr )
{
  struct DateStamp Stamp;
  LONG Days;
  WORD Year, Month = 0;
  WORD *MonthTab = &Months[1];

  if ( DateStampStr )
  {
    Stamp = *DateStampStr;
  } else
  {
    DateStamp ( (struct DateStamp *) &Stamp );
  }

  Days = Stamp.ds_Days + (365*4+1)*494+366+365;
  Year = (Days / (365*4+1));

  Days -= (Year * (365*4+1));

  Year <<= 2;

  if (Days > 366)
  {
    Days -= 366;
    Year += (Days / 365) + 1;
    Days %= 365;

    if ( Days > 31+27 )
      Days++;
  }

  do
  {
    Month++;
  } while ( Days >= *MonthTab++ );

  Days -= MonthTab[-2];

  StampDateStr->sds_Day = (Days + 1);
  StampDateStr->sds_Month = Month;
  StampDateStr->sds_Year = Year;

  StampDateStr->sds_TimeHours = Stamp.ds_Minute / 60;
  StampDateStr->sds_TimeMins = Stamp.ds_Minute % 60;
  StampDateStr->sds_TimeSecs = Stamp.ds_Tick / TICKS_PER_SECOND;
  StampDateStr->sds_TimeHundreds = (Stamp.ds_Tick % TICKS_PER_SECOND) * 100 / TICKS_PER_SECOND;
}
