/* TuComposer OS independent code
**
** $VER: AllocTCModule.c 31.22 (4.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

struct TuComposerModule *AllocTCModule ( unsigned long Channels )
{
  struct TuComposerModule *ModuleStr;

  if (!( Channels ))
    Channels = DEFAULTNNACHANNELS;

  if ( (ModuleStr = (struct TuComposerModule *) AllocPMem ( sizeof (struct TuComposerModule ))))
  {
    ModuleStr->tcm_Task = FindTask ( NULL );

    if ( (ModuleStr->tcm_ChannelData = (struct PlayerChannel *) AllocPMem ( Channels * sizeof (struct PlayerChannel ))))
    {
      Stamp2Date ( (struct StampDate *) &(ModuleStr->tcm_BeginDate), NULL );

      InitNodeList ( (struct List *) &(ModuleStr->tcm_SongList) );
      InitNodeList ( (struct List *) &(ModuleStr->tcm_InstrList) );
      InitNodeList ( (struct List *) &(ModuleStr->tcm_Envelopes) );
      InitNodeList ( (struct List *) &(ModuleStr->tcm_KeyboardDefs) );
      InitNodeList ( (struct List *) &(ModuleStr->tcm_ArpEnvList) );

      ModuleStr->tcm_Channels = Channels;

      InitNodeList ( (struct List *) &(ModuleStr->tcm_UnknownChunks) );
    } else
    {
      FreePMem ( ModuleStr, sizeof (struct TuComposerModule ));

      ModuleStr = NULL;
    }
  }

  return ( ModuleStr );
}
