/* TuComposer OS independent code
**
** $VER: CalcTCMPlayTime.c 31.22 (4.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

unsigned long long CalcSongPlayTimeULL ( struct TuComposerSong *SongStr, struct PlayExecHandler *PlayExecStr );

ULONG CalcTCMPlayTime ( struct TuComposerModule *ModuleStr,
    struct PlayExecHandler *PlayExecStr )
{
  struct TuComposerSong *SongStr;
  unsigned long long TotalTime = 0LL;
  ULONG PlayTime;
  LONG PlayTimeFrac;

  SongStr = (struct TuComposerSong *) &(ModuleStr->tcm_SongList.mlh_Head);

  for (;;)
  {
    SongStr = (struct TuComposerSong *) SongStr->tcso_Node.mln_Succ;

    if (!( SongStr->tcso_Node.mln_Succ ))
      break;

    TotalTime += CalcSongPlayTimeULL ( SongStr, PlayExecStr );
  }

  PlayTime = TotalTime >> 32;
  PlayTimeFrac = (ULONG) TotalTime;

  if ( PlayTimeFrac < 0 )
    PlayTime++;

  ModuleStr->tcm_PlayTimeHours = (PlayTime / 360000);
  ModuleStr->tcm_PlayTimeMins = (PlayTime / 6000) % 60;
  ModuleStr->tcm_PlayTimeSecs = (PlayTime / 100) % 60;
  ModuleStr->tcm_PlayTimeHundreds = PlayTime % 100;

  return ( PlayTime );
}
