/* TuComposer OS independent code
**
** $VER: FreeTCModule.c 31.22 (4.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG FreeTCModule ( struct TuComposerModule *ModuleStr )
{
  if ( ModuleStr )
  {
    struct TuComposerSong *SongStr;
    struct TuComposerSong *FreeSongStr;
    struct TuComposerInstr *InstrStr;
    struct TuComposerInstr *FreeInstrStr;
    struct TuComposerInstrEnvelope *EnvStr;
    struct TuComposerInstrEnvelope *FreeEnvStr;
    struct TuComposerInstrKeyboard *KeybrdStr;
    struct TuComposerInstrKeyboard *FreeKeybrdStr;
    struct TuComposerInstrArpeggio *ArpStr;
    struct TuComposerInstrArpeggio *FreeArpStr;
    struct UnknownChunk *UnknownChunkStr;
    struct UnknownChunk *FreeUnkChunk;

    if ( ModuleStr == TuCBase->tcb_PlayModule )
    {
      StopTCModule ();

      FreeSoundDevice ( TuCBase->tcb_PlaySoundDeviceBase->sdi_Library.extb_ExtLibList );
      FreeMixer ( TuCBase->tcb_PlayMixerAlloc );

      FreePlayTCModule ();
    }

    if ( ModuleStr->tcm_Node.mln_Succ )
      RemTCModule ( ModuleStr );

    FreeNameStr ( ModuleStr->tcm_FileName );
    FreeNameStr ( ModuleStr->tcm_Name );
    FreeNameStr ( ModuleStr->tcm_Message );
    FreeNameStr ( ModuleStr->tcm_Composer );
    FreeNameStr ( ModuleStr->tcm_Style );
    FreeNameStr ( ModuleStr->tcm_Comment );

    SongStr = (struct TuComposerSong *) &(ModuleStr->tcm_SongList.mlh_Head);

    for (;;)
    {
      FreeSongStr = (struct TuComposerSong *) SongStr->tcso_Node.mln_Succ;

      if (!( FreeSongStr->tcso_Node.mln_Succ ))
        break;

      FreeSong ( FreeSongStr );
    }

    InstrStr = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head);

    for (;;)
    {
      FreeInstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Succ;

      if (!( FreeInstrStr->tci_Node.mln_Succ ))
        break;

      FreeInstr ( FreeInstrStr );
    }

    EnvStr = (struct TuComposerInstrEnvelope *) &(ModuleStr->tcm_Envelopes.mlh_Head);

    for (;;)
    {
      FreeEnvStr = (struct TuComposerInstrEnvelope *) EnvStr->tcie_Node.mln_Succ;

      if (!( FreeEnvStr->tcie_Node.mln_Succ ))
        break;

      FreeEnvelope ( FreeEnvStr );
    }

    KeybrdStr = (struct TuComposerInstrKeyboard *) &(ModuleStr->tcm_KeyboardDefs.mlh_Head);

    for (;;)
    {
      FreeKeybrdStr = (struct TuComposerInstrKeyboard *) KeybrdStr->tcik_Node.mln_Succ;

      if (!( FreeKeybrdStr->tcik_Node.mln_Succ ))
        break;

      FreeKeyboard ( FreeKeybrdStr );
    }

    ArpStr = (struct TuComposerInstrArpeggio *) &(ModuleStr->tcm_ArpEnvList.mlh_Head);

    for (;;)
    {
      FreeArpStr = (struct TuComposerInstrArpeggio *) ArpStr->tcia_Node.mln_Succ;

      if (!( FreeArpStr->tcia_Node.mln_Succ ))
        break;

      FreeArpeggio ( FreeArpStr );
    }

    FreePMem ( ModuleStr->tcm_ChannelData, ModuleStr->tcm_Channels * sizeof (struct PlayerChannel ));

    UnknownChunkStr = (struct UnknownChunk *) &(ModuleStr->tcm_UnknownChunks.mlh_Head);

    for (;;)
    {
      FreeUnkChunk = (struct UnknownChunk *) UnknownChunkStr->uc_Node.mln_Succ;

      if (!( (struct UnknownChunk *) FreeUnkChunk->uc_Node.mln_Succ ))
        break;

      FreeUnknownChunk ( FreeUnkChunk );
    }

    FreePMem ( ModuleStr, sizeof (struct TuComposerModule ));

    return ( 0L );
  }

  return ( ERROR_MODULE_NOGIVEN );
}
