/* TuComposer OS independent code
**
** $VER: GetOptimalVChannels.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG GetOptimalVChannels ( struct TuComposerModule *ModuleStr )
{
  ULONG VChannels = 0L;

  if ( ModuleStr )
  {
    struct TuComposerInstr *InstrStr;
    struct TuComposerSong *SongStr;
    ULONG SongChannels;

    VChannels = ModuleStr->tcm_Channels;

    InstrStr = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head);

    for (;;)
    {
      InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Succ;

      if (!( InstrStr->tci_Node.mln_Succ ))
        break;

      if ( InstrStr->tci_NNA )
        return ( VChannels );
    }

    SongStr = (struct TuComposerSong *) &(ModuleStr->tcm_SongList.mlh_Head);

    for (;;)
    {
      SongStr = (struct TuComposerSong *) SongStr->tcso_Node.mln_Succ;

      if (!( SongStr->tcso_Node.mln_Succ ))
        break;

      if ( (SongChannels = SongStr->tcso_Channels) < VChannels )
        VChannels = SongChannels;
    }
  }

  return ( VChannels );
}
