/* TuComposer OS independent code
**
** $VER: GetTCModuleInfo.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_modulebase_protos.h>

struct ModuleInfo *GetTCModuleInfo ( struct CFHandle *CFHandle,
    struct TuComposerExtList *ExtLibStr, unsigned long NumModule)
{
  struct ModuleInfo *ModuleInfoStr = NULL;

  if ( CFHandle )
  {
    if (!( ExtLibStr ))
      ExtLibStr = IdentifyTCModule ( CFHandle );

    if ( ExtLibStr )
    {
      if ( (ModuleInfoStr = (struct ModuleInfo *) AllocPMem (sizeof (struct ModuleInfo ))))
      {
        struct ModuleLibrary *ExtModuleLibBase;

        if ( (ExtModuleLibBase = (struct ModuleLibrary *) OpenExternalLib ( ExtLibStr )))
        {
          ULONG RC;

          RC = ExternalModuleGetInfoBase ( CFHandle, ModuleInfoStr, NumModule, ExtModuleLibBase );

          CloseExternalLib ( ExtLibStr );

          if (!( RC ))
          {
            FreeTCModuleInfo ( ModuleInfoStr );

            ModuleInfoStr = NULL;
          }
        } else
        {
          FreePMem ( ModuleInfoStr, sizeof (struct ModuleInfo ));

          ModuleInfoStr = NULL;
        }
      }
    }
  }

  return ( ModuleInfoStr );
}
