/* TuComposer OS independent code
**
** $VER: PlayTCModule.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <tucomposer/external/external.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;
extern struct SoundDeviceInfo *InternalSoundDeviceBase;

ULONG PlayTCModule ( union FlagPass *FlagPassStr )
{
  if ( TuCBase->tcb_PlayModule )
  {
    struct TuComposerSong *SongStr;

    if ( (SongStr = TuCBase->tcb_PlaySong) )
    {
      struct PlayerGlobals *PGStr = SongStr->tcso_GlobalData;
      struct SoundDeviceInfo *ExtDeviceLibBase;

      if (!( ExtDeviceLibBase = TuCBase->tcb_PlaySoundDeviceBase ))
        ExtDeviceLibBase = (struct SoundDeviceInfo *) &(InternalSoundDeviceBase);

      TuCBase->tcb_PlaySoundDeviceBase = ExtDeviceLibBase;

      PGStr->pg_Flags &= ~(PGF_NoProcPattern|PGF_PlayPattern);
      PGStr->pg_PlayType = PTYPF_Song;

      return ( PlaySoundDevice ( ExtDeviceLibBase->sdi_Library.extb_ExtLibList, TuCBase->tcb_PlayMixerAlloc, FlagPassStr ));
    }

    return ( ERROR_SONG_NOGIVEN );
  }

  return ( ERROR_MODULE_NOGIVEN );
}
