/* TuComposer OS independent code
**
** $VER: ReMapTCModule.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG ReMapTCModule ( struct TuComposerModule *ModuleStr,
    struct TuComposerModule *NewModuleStr )
{
  if ( ModuleStr && NewModuleStr )
  {
    if ( ModuleStr != NewModuleStr )
    {
      if ( TuCBase->tcb_PlayModule == ModuleStr )
      {
        StopTCModule ();

        FreeSoundDevice ( TuCBase->tcb_PlaySoundDeviceBase->sdi_Library.extb_ExtLibList );
      }

      if ( TuCBase->tcb_PlayModule == NewModuleStr )
      {
        StopTCModule ();

        FreeSoundDevice ( TuCBase->tcb_PlaySoundDeviceBase->sdi_Library.extb_ExtLibList );
      }

      ClearTCModule ( NewModuleStr );

      ReMapNodeList ( (struct List *) &(ModuleStr->tcm_SongList), (struct List *) &(NewModuleStr->tcm_SongList) );
      ReMapNodeList ( (struct List *) &(ModuleStr->tcm_InstrList), (struct List *) &(NewModuleStr->tcm_InstrList) );
      ReMapNodeList ( (struct List *) &(ModuleStr->tcm_Envelopes), (struct List *) &(NewModuleStr->tcm_Envelopes) );
      ReMapNodeList ( (struct List *) &(ModuleStr->tcm_KeyboardDefs), (struct List *) &(NewModuleStr->tcm_KeyboardDefs) );
      ReMapNodeList ( (struct List *) &(ModuleStr->tcm_ArpEnvList), (struct List *) &(NewModuleStr->tcm_ArpEnvList) );

      FreePMem ( NewModuleStr->tcm_ChannelData, NewModuleStr->tcm_Channels * sizeof (struct PlayerChannel ));

      memcpy ( &(NewModuleStr->tcm_Task), &(ModuleStr->tcm_Task), offsetof (struct TuComposerModule, tcm_SongList) - offsetof (struct TuComposerModule, tcm_Task ));
      memcpy ( &(NewModuleStr->tcm_Channels), &(ModuleStr->tcm_Channels), offsetof (struct TuComposerModule, tcm_UnknownChunks) - offsetof (struct TuComposerModule, tcm_Channels ));

      ReMapNodeList ( (struct List *) &(ModuleStr->tcm_UnknownChunks), (struct List *) &(NewModuleStr->tcm_UnknownChunks) );

      if ( ModuleStr->tcm_Node.mln_Succ )
        RemTCModule ( ModuleStr );

      FreePMem ( ModuleStr, sizeof (struct TuComposerModule ));
    }

    return ( 0L );
  }

  return ( ERROR_MODULE_NOGIVEN );
}
