/* TuComposer OS independent code
**
** $VER: SetTCMChannels.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG SetTCMChannels ( struct TuComposerModule *ModuleStr,
    unsigned long Channels )
{
  if ( ModuleStr )
  {
    ULONG OldChannels = ModuleStr->tcm_Channels;

    if (!( Channels ))
      Channels = DEFAULTNNACHANNELS;

    if ( Channels != OldChannels )
    {
      struct PlayerChannel *PCStr;

      if ( (PCStr = (struct PlayerChannel *) AllocPMem ( Channels * sizeof (struct PlayerChannel ))))
      {
        struct TuComposerSong *SongStr;
        struct PlayerHostChannel *PHCStr;
        struct PlayerChannel *UpdPCStr;
        ULONG i, HostCh;

        if ( ModuleStr == TuCBase->tcb_PlayModule )
          StopSoundDevice ( TuCBase->tcb_PlaySoundDeviceBase->sdi_Library.extb_ExtLibList );

        memcpy ( PCStr, ModuleStr->tcm_ChannelData, ((Channels > OldChannels) ? OldChannels : Channels) * sizeof (struct PlayerChannel ));

        SongStr = (struct TuComposerSong *) &(ModuleStr->tcm_SongList.mlh_Head);

        for (;;)
        {
          SongStr = (struct TuComposerSong *) SongStr->tcso_Node.mln_Succ;

          if (!( SongStr->tcso_Node.mln_Succ ))
            break;

          HostCh = 0L;
          PHCStr = SongStr->tcso_ChannelData;

          for (i = SongStr->tcso_Channels; i > 0; i--)
          {
            if ( PHCStr->phc_VirtualChannel >= Channels )
            {
              ULONG j;

              PHCStr->phc_VirtualChannel = 0;
              PHCStr->phc_NumVirtual = 0;

              UpdPCStr = PCStr;

              for (j = Channels; j > 0; j--)
              {
                if ( UpdPCStr->pc_HostChannel == HostCh )
                  UpdPCStr->pc_ChannelData.ms_Flags = 0;

                UpdPCStr++;
              }
            }

            HostCh++;
            PHCStr++;
          }
        }

        UpdPCStr = ModuleStr->tcm_ChannelData;

        ModuleStr->tcm_ChannelData = PCStr;
        ModuleStr->tcm_Channels = Channels;

        if ( ModuleStr == TuCBase->tcb_PlayModule )
          PlayTCModule ( NULL );

        FreePMem ( UpdPCStr, OldChannels * sizeof (struct PlayerChannel ));
      } else
      {
        return ( ERROR_POSITION_NOMEM );
      }
    }

    return ( 0L );
  }

  return ( ERROR_MODULE_NOGIVEN );
}
