/* TuComposer OS independent code
**
** $VER: SwapTCModule.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG SwapTCModule ( struct TuComposerModule *ModuleBuf,
    struct TuComposerModule *ModuleStr )
{
 if ( ModuleStr && ModuleBuf )
  {
    if ( ModuleStr != ModuleBuf )
    {
      struct MinList TmpUnkChunk;
      struct MinList SwapUnkChunk;
      UBYTE *SrcBuf,*DestBuf;
      UBYTE TmpByte;
      ULONG i;

      ObtainSemaphore ( TuCBase->tcb_ModuleSigSem );

      TmpUnkChunk = ModuleBuf->tcm_UnknownChunks;
      ReMapNodeList ( (struct List *) &(ModuleStr->tcm_UnknownChunks), (struct List *) &(ModuleBuf->tcm_UnknownChunks));

      SwapUnkChunk = ModuleBuf->tcm_UnknownChunks;
      ModuleBuf->tcm_UnknownChunks = TmpUnkChunk;
      ReMapNodeList ( (struct List *) &(ModuleBuf->tcm_UnknownChunks), (struct List *) &(ModuleStr->tcm_UnknownChunks));

      ModuleBuf->tcm_UnknownChunks = SwapUnkChunk;

      TmpUnkChunk = ModuleBuf->tcm_SongList;
      ReMapNodeList ( (struct List *) &(ModuleStr->tcm_SongList), (struct List *) &(ModuleBuf->tcm_SongList));

      SwapUnkChunk = ModuleBuf->tcm_SongList;
      ModuleBuf->tcm_SongList = TmpUnkChunk;
      ReMapNodeList ( (struct List *) &(ModuleBuf->tcm_SongList), (struct List *) &(ModuleStr->tcm_SongList));

      ModuleBuf->tcm_SongList = SwapUnkChunk;

      TmpUnkChunk = ModuleBuf->tcm_InstrList;
      ReMapNodeList ( (struct List *) &(ModuleStr->tcm_InstrList), (struct List *) &(ModuleBuf->tcm_InstrList));

      SwapUnkChunk = ModuleBuf->tcm_InstrList;
      ModuleBuf->tcm_InstrList = TmpUnkChunk;
      ReMapNodeList ( (struct List *) &(ModuleBuf->tcm_InstrList), (struct List *) &(ModuleStr->tcm_InstrList));

      ModuleBuf->tcm_InstrList = SwapUnkChunk;

      TmpUnkChunk = ModuleBuf->tcm_Envelopes;
      ReMapNodeList ( (struct List *) &(ModuleStr->tcm_Envelopes), (struct List *) &(ModuleBuf->tcm_Envelopes));

      SwapUnkChunk = ModuleBuf->tcm_Envelopes;
      ModuleBuf->tcm_Envelopes = TmpUnkChunk;
      ReMapNodeList ( (struct List *) &(ModuleBuf->tcm_Envelopes), (struct List *) &(ModuleStr->tcm_Envelopes));

      ModuleBuf->tcm_Envelopes = SwapUnkChunk;

      TmpUnkChunk = ModuleBuf->tcm_KeyboardDefs;
      ReMapNodeList ( (struct List *) &(ModuleStr->tcm_KeyboardDefs), (struct List *) &(ModuleBuf->tcm_KeyboardDefs));

      SwapUnkChunk = ModuleBuf->tcm_KeyboardDefs;
      ModuleBuf->tcm_KeyboardDefs = TmpUnkChunk;
      ReMapNodeList ( (struct List *) &(ModuleBuf->tcm_KeyboardDefs), (struct List *) &(ModuleStr->tcm_KeyboardDefs));

      ModuleBuf->tcm_KeyboardDefs = SwapUnkChunk;

      TmpUnkChunk = ModuleBuf->tcm_ArpEnvList;
      ReMapNodeList ( (struct List *) &(ModuleStr->tcm_ArpEnvList), (struct List *) &(ModuleBuf->tcm_ArpEnvList));

      SwapUnkChunk = ModuleBuf->tcm_ArpEnvList;
      ModuleBuf->tcm_ArpEnvList = TmpUnkChunk;
      ReMapNodeList ( (struct List *) &(ModuleBuf->tcm_ArpEnvList), (struct List *) &(ModuleStr->tcm_ArpEnvList));

      ModuleBuf->tcm_ArpEnvList = SwapUnkChunk;

      SrcBuf = (UBYTE *) &(ModuleStr->tcm_Task);
      DestBuf = (UBYTE *) &(ModuleBuf->tcm_Task);

      for (i = (offsetof (struct TuComposerModule, tcm_SongList) - offsetof (struct TuComposerModule, tcm_Task)); i > 0; i--)
      {
        TmpByte = *DestBuf;
        *DestBuf++ = *SrcBuf;
        *SrcBuf++ = TmpByte;
      }

      SrcBuf = (UBYTE *) &(ModuleStr->tcm_Channels);
      DestBuf = (UBYTE *) &(ModuleBuf->tcm_Channels);

      for (i = (offsetof (struct TuComposerModule, tcm_UnknownChunks) - offsetof (struct TuComposerModule, tcm_Channels)); i > 0; i--)
      {
        TmpByte = *DestBuf;
        *DestBuf++ = *SrcBuf;
        *SrcBuf++ = TmpByte;
      }

      ReleaseSemaphore ( TuCBase->tcb_ModuleSigSem );
    }

    return ( 0L );
  }

  return ( ERROR_MODULE_NOGIVEN );
}
