/* Amiga OS dependent code
**
** $VER: AllocPMem.c 31.22 (29.1.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <exec/memory.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

APTR AllocPMem ( unsigned long byteSize )
{
  APTR memoryBlock = NULL;

  if ( byteSize )
  {
    if ( TuCBase->tcb_MemPool )
    {
      ObtainSemaphore ( TuCBase->tcb_MemSigSem );

      memoryBlock = AllocPooled ( TuCBase->tcb_MemPool, byteSize );

      ReleaseSemaphore ( TuCBase->tcb_MemSigSem );
    } else
    {
      memoryBlock = AllocMem ( byteSize, MEMF_PUBLIC|MEMF_CLEAR );
    }
  }

Error:
  return ( memoryBlock );
}
