/* Amiga OS dependent code
**
** $VER: FreePMem.c 31.22 (29.1.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

void FreePMem ( APTR memoryBlock, unsigned long byteSize )
{
  if (!( (byteSize) && memoryBlock ))
    return;

  if ( TuCBase->tcb_MemPool )
  {
    ObtainSemaphore ( TuCBase->tcb_MemSigSem );

    FreePooled ( TuCBase->tcb_MemPool, memoryBlock, byteSize );

    ReleaseSemaphore ( TuCBase->tcb_MemSigSem );
  } else
  {
    FreeMem ( memoryBlock, byteSize );
  }
}
