/* TuComposer Low Quality Mixer Amiga Shared-Library function prototypes.
**
** $VER: InternalLQMix_library.h 31.00 (30.11.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif /* EXEC_TYPES_H */

#include "compiler.h"

#ifdef __cplusplus
extern "C" {
#endif

static ULONG ASM libLQUpdate ( register __a0 union FlagPass *FlagPassStr GNUCREG(a0), register __d0 unsigned long FlagPassType GNUCREG(d0),
    register __d1 unsigned long FlagNum GNUCREG(d1));
static struct MixerAllocStruct * ASM libAllocLQMix ( void );
static ULONG ASM libFreeLQMix ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0));
static ULONG ASM libInitLQMix ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0), register __a1 struct SoundDeviceInfo *ExtSoundDevStr GNUCREG(a1),
    register __a2 union FlagPass *FlagPassStr GNUCREG(a2));
static ULONG ASM libChangeLQMixRate ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0), register __d0 unsigned long NewMixRate GNUCREG(d0));
static ULONG ASM libChangeLQMixTempo ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0), register __d0 unsigned long NewTempo GNUCREG(d0));
static ULONG ASM libChangeLQMixVol ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0), register __d0 unsigned long Amplify GNUCREG(d0),
    register __d1 unsigned long LeftVol GNUCREG(d1), register __d2 unsigned long RightVol GNUCREG(d2),
    register __d3 unsigned long NumChannels GNUCREG(d3));
static void ASM libGetLQChannel ( register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1), register __a0 struct MixerStruct *MixStr GNUCREG(a0),
    register __d0 unsigned long Channel GNUCREG(d0));
static void ASM libSetLQChannel ( register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1), register __a0 struct MixerStruct *MixStr GNUCREG(a0),
    register __d0 unsigned long Channel GNUCREG(d0));
static void ASM libSetLQChannelVol ( register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1), register __a0 struct MixerStruct *MixStr GNUCREG(a0),
    register __d0 unsigned long Channel GNUCREG(d0));
static void ASM libSetLQChannelPos ( register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1), register __a0 struct MixerStruct *MixStr GNUCREG(a0),
    register __d0 unsigned long Channel GNUCREG(d0));
static void ASM libDoLQMix ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0), register __a2 long *MixBuffer GNUCREG(a2));

#ifdef __cplusplus
}
#endif

static ULONG ASM libLQUpdate ( register __a0 union FlagPass *FlagPassStr GNUCREG(a0), register __d0 unsigned long FlagPassType GNUCREG(d0),
    register __d1 unsigned long FlagNum GNUCREG(d1))
{
  return ( InternalMixerUpdate ( FlagPassStr, FlagPassType, FlagNum ));
}

static struct MixerAllocStruct * ASM libAllocLQMix ( void )
{
  return ( InternalMixerAlloc ());
}

static ULONG ASM libFreeLQMix ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0))
{
  return ( InternalMixerFree ( MixAllocStr ));
}

static ULONG ASM libInitLQMix ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0), register __a1 struct SoundDeviceInfo *ExtSoundDevStr GNUCREG(a1),
    register __a2 union FlagPass *FlagPassStr GNUCREG(a2))
{
  return ( InternalMixerInit ( MixAllocStr, ExtSoundDevStr, FlagPassStr ));
}

static ULONG ASM libChangeLQMixRate ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0), register __d0 unsigned long NewMixRate GNUCREG(d0))
{
  return ( InternalMixerChangeRate ( MixAllocStr, NewMixRate ));
}

static ULONG ASM libChangeLQMixTempo ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0), register __d0 unsigned long NewTempo GNUCREG(d0))
{
  return ( InternalMixerChangeTempo ( MixAllocStr, NewTempo ));
}

static ULONG ASM libChangeLQMixVol ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0), register __d0 unsigned long Amplify GNUCREG(d0),
    register __d1 unsigned long LeftVol GNUCREG(d1), register __d2 unsigned long RightVol GNUCREG(d2),
    register __d3 unsigned long NumChannels GNUCREG(d3))
{
  return ( InternalMixerChangeVolTable ( MixAllocStr, Amplify, LeftVol, RightVol, NumChannels ));
}

static void ASM libGetLQChannel ( register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1), register __a0 struct MixerStruct *MixStr GNUCREG(a0),
    register __d0 unsigned long Channel GNUCREG(d0))
{
  InternalMixerGetChannel ( MixAllocStr, MixStr, Channel );
}

static void ASM libSetLQChannel ( register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1), register __a0 struct MixerStruct *MixStr GNUCREG(a0),
    register __d0 unsigned long Channel GNUCREG(d0))
{
  InternalMixerSetChannel ( MixAllocStr, MixStr, Channel );
}

static void ASM libSetLQChannelVol ( register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1), register __a0 struct MixerStruct *MixStr GNUCREG(a0),
    register __d0 unsigned long Channel GNUCREG(d0))
{
  InternalMixerSetChannelVolPanPitch ( MixAllocStr, MixStr, Channel );
}

static void ASM libSetLQChannelPos ( register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1), register __a0 struct MixerStruct *MixStr GNUCREG(a0),
    register __d0 unsigned long Channel GNUCREG(d0))
{
  InternalMixerSetChannelPosRepFlags ( MixAllocStr, MixStr, Channel );
}

static void ASM libDoLQMix ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0), register __a2 long *MixBuffer GNUCREG(a2))
{
  InternalMixerDoMix ( MixAllocStr, MixBuffer );
}

extern struct TuComposerBase *TuCBase;

static struct JumpTable {
  struct JumpEntry {
    UWORD JumpInst;
    APTR  JumpPtr;
  } Jump[32];
} InternalMixerJumpTable =
{
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, libDoLQMix,
  0x4EF9, libSetLQChannelPos,
  0x4EF9, libSetLQChannelVol,
  0x4EF9, libSetLQChannel,
  0x4EF9, libGetLQChannel,
  0x4EF9, libChangeLQMixVol,
  0x4EF9, libChangeLQMixTempo,
  0x4EF9, libChangeLQMixRate,
  0x4EF9, libInitLQMix,
  0x4EF9, libFreeLQMix,
  0x4EF9, libAllocLQMix,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, libLQUpdate,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, InternalLQMixCloseExtLib,
  0x4EF9, InternalLQMixOpenExtLib
};

struct MixerInfo InternalMixerBase =
{
  {{{NULL, NULL, NT_LIBRARY, 0, (STRPTR) &InternalMixerName},
      LIBF_SUMUSED, 0,
      sizeof ( InternalMixerJumpTable ), sizeof (struct MixerInfo),
      EXTLIB_MIXER_VERSION,
      EXTLIB_REVISION,
      (STRPTR) &InternalMixerIDString,
      NULL, 0},
    NULL,
    (struct TuComposerBase *) &TuCBase,
    (struct TuComposerExtList *) &InternalMixer},
  MIF_StereoSupport|MIF_Surround|MIF_PostProcs, 0,
  22050,
  512,
  65536,
  1000, 256000,
  16, 32768,
  65535
};
