/* TuComposer Paula Driver Amiga Shared-Library function prototypes.
**
** $VER: InternalPaula_library.h 31.00 (2.10.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif /* EXEC_TYPES_H */

#include "compiler.h"

#ifdef __cplusplus
extern "C" {
#endif

static ULONG ASM libPaulaAlloc ( register __a0 union FlagPass *FlagPassStr GNUCREG(a0));
static ULONG ASM libPaulaUpdate ( register __a0 union FlagPass *FlagPassStr GNUCREG(a0), register __d0 unsigned long FlagPassType GNUCREG(d0),
    register __d1 unsigned long FlagNum GNUCREG(d1));
static ULONG ASM libPaulaPlay ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0), register __a1 union FlagPass *FlagPassStr GNUCREG(a1));
static ULONG ASM libPaulaCheckRate ( register __d0 unsigned long SmpRate GNUCREG(d0));
static ULONG ASM libPaulaCheckRateFraction ( register __d0 unsigned long SmpRate GNUCREG(d0));
static ULONG ASM libPaulaUpdateRate ( register __d0 unsigned long SmpRate GNUCREG(d0));

#ifdef __cplusplus
}
#endif

static ULONG ASM libPaulaAlloc ( register __a0 union FlagPass *FlagPassStr GNUCREG(a0))
{
  return ( InternalPaulaAlloc ( FlagPassStr ));
}

static ULONG ASM libPaulaUpdate ( register __a0 union FlagPass *FlagPassStr GNUCREG(a0), register __d0 unsigned long FlagPassType GNUCREG(d0),
    register __d1 unsigned long FlagNum GNUCREG(d1))
{
  return ( InternalPaulaUpdate ( FlagPassStr, FlagPassType, FlagNum ));
}

static ULONG ASM libPaulaPlay ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0), register __a1 union FlagPass *FlagPassStr GNUCREG(a1))
{
  return ( InternalPaulaPlay ( MixAllocStr, FlagPassStr ));
}

static ULONG ASM libPaulaCheckRate ( register __d0 unsigned long SmpRate GNUCREG(d0))
{
  return ( InternalPaulaCheckRate ( SmpRate ));
}

static ULONG ASM libPaulaCheckRateFraction ( register __d0 unsigned long SmpRate GNUCREG(d0))
{
  return ( InternalPaulaCheckRateFraction ( SmpRate ));
}

static ULONG ASM libPaulaUpdateRate ( register __d0 unsigned long SmpRate GNUCREG(d0))
{
  return ( InternalPaulaUpdateRate ( SmpRate ));
}

extern struct TuComposerBase *TuCBase;

static struct JumpTable {
  struct JumpEntry {
    UWORD JumpInst;
    APTR  JumpPtr;
  } Jump[16];
} PaulaJumpTable =
{
  0x4EF9, ExtLib,
  0x4EF9, libPaulaUpdateRate,
  0x4EF9, libPaulaCheckRateFraction,
  0x4EF9, libPaulaCheckRate,
  0x4EF9, InternalPaulaStop,
  0x4EF9, libPaulaPlay,
  0x4EF9, InternalPaulaFree,
  0x4EF9, InternalPaulaAlloc,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, libPaulaUpdate,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, InternalPaulaCloseExtLib,
  0x4EF9, InternalPaulaOpenExtLib
};

struct SoundDeviceInfo InternalPaulaBase =
{
  {{{NULL, NULL, NT_LIBRARY, 0, (STRPTR) &InternalPaulaName},
      LIBF_SUMUSED, 0,
      sizeof ( PaulaJumpTable ), sizeof (struct SoundDeviceInfo),
      EXTLIB_DEVICE_VERSION,
      EXTLIB_REVISION,
      (STRPTR) &InternalPaulaIDString,
      NULL, 0},
    NULL,
    (struct TuComposerBase *) &TuCBase,
    (struct TuComposerExtList *) &InternalPaula},
  SDIF_Stereo|SDIF_Interrupt, 0,
  4000, 256000
};
