/* TuComposer post volume booster Amiga Shared-Library function prototypes.
**
** $VER: InternalPostBoost_library.h 31.00 (3.3.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif /* EXEC_TYPES_H */

#include "compiler.h"

#ifdef __cplusplus
extern "C" {
#endif

static ULONG ASM libPostBoostUpdate ( register __a0 union FlagPass *FlagPassStr GNUCREG(a0), register __d0 unsigned long FlagPassType GNUCREG(d0),
    register __d1 unsigned long FlagNum GNUCREG(d1));
static struct PostProcAllocStruct * ASM libPostBoostAlloc ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0));
static ULONG ASM libPostBoostFree ( register __a0 struct PostProcAllocStruct *PostAllocStr GNUCREG(a0));
static ULONG ASM libPostBoostInit ( register __a0 struct PostProcAllocStruct *PostAllocStr GNUCREG(a0),
    register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2));
static ULONG ASM libPostBoostChange ( register __a0 struct PostProcAllocStruct *PostAllocStr GNUCREG(a0),
    register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1));
static void ASM libPostBoostDoMix ( register __a0 struct PostProcAllocStruct *PostAllocStr GNUCREG(a0),
    register __a2 long *MixBuffer GNUCREG(a2));

#ifdef __cplusplus
}
#endif

static ULONG ASM libPostBoostUpdate ( register __a0 union FlagPass *FlagPassStr GNUCREG(a0), register __d0 unsigned long FlagPassType GNUCREG(d0),
    register __d1 unsigned long FlagNum GNUCREG(d1))
{
  return ( InternalPostBoostUpdate ( FlagPassStr, FlagPassType, FlagNum ));
}

static struct PostProcAllocStruct * ASM libPostBoostAlloc ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0))
{
  return ( InternalPostBoostAlloc ( MixAllocStr ));
}

static ULONG ASM libPostBoostFree ( register __a0 struct PostProcAllocStruct *PostAllocStr GNUCREG(a0))
{
  return ( InternalPostBoostFree ( PostAllocStr ));
}

static ULONG ASM libPostBoostInit ( register __a0 struct PostProcAllocStruct *PostAllocStr GNUCREG(a0),
    register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2))
{
  return ( InternalPostBoostInit ( PostAllocStr, MixAllocStr, FlagPassStr ));
}

static ULONG ASM libPostBoostChange ( register __a0 struct PostProcAllocStruct *PostAllocStr GNUCREG(a0),
    register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1))
{
  return ( InternalPostBoostChange ( PostAllocStr, MixAllocStr ));
}

static void ASM libPostBoostDoMix ( register __a0 struct PostProcAllocStruct *PostAllocStr GNUCREG(a0),
    register __a2 long *MixBuffer GNUCREG(a2))
{
  InternalPostBoostDoMix ( PostAllocStr, MixBuffer );
}

extern struct TuComposerBase *TuCBase;

static struct JumpTable {
  struct JumpEntry {
    UWORD JumpInst;
    APTR  JumpPtr;
  } Jump[16];
} InternalPostProcJumpTable =
{
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, libPostBoostDoMix,
  0x4EF9, libPostBoostChange,
  0x4EF9, libPostBoostInit,
  0x4EF9, libPostBoostFree,
  0x4EF9, libPostBoostAlloc,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, libPostBoostUpdate,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, InternalPostBoostCloseExtLib,
  0x4EF9, InternalPostBoostOpenExtLib
};

struct PostProcInfo InternalPostProcBase =
{
  {{{NULL, NULL, NT_LIBRARY, 0, (STRPTR) &InternalPostBoostName},
      LIBF_SUMUSED, 0,
      sizeof ( InternalPostProcJumpTable ), sizeof (struct PostProcInfo),
      EXTLIB_POSTPROC_VERSION,
      EXTLIB_REVISION,
      (STRPTR) &InternalPostBoostIDString,
      NULL, 0},
    NULL,
    (struct TuComposerBase *) &TuCBase,
    (struct TuComposerExtList *) &InternalPostProc},
  0
};
