/* TuComposer Quiet Driver Amiga Shared-Library function prototypes.
**
** $VER: InternalQuiet_library.h 31.00 (3.3.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif /* EXEC_TYPES_H */

#include "compiler.h"

#ifdef __cplusplus
extern "C" {
#endif

static ULONG ASM libQuietAlloc ( register __a0 union FlagPass *FlagPassStr GNUCREG(a0));
static ULONG ASM libQuietUpdate ( register __a0 union FlagPass *FlagPassStr GNUCREG(a0), register __d0 unsigned long FlagPassType GNUCREG(d0),
    register __d1 unsigned long FlagNum GNUCREG(d1));
static ULONG ASM libQuietPlay ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0), register __a1 union FlagPass *FlagPassStr GNUCREG(a1));
static ULONG ASM libQuietCheckRate ( register __d0 unsigned long SmpRate GNUCREG(d0));
static ULONG ASM libQuietCheckRateFraction ( register __d0 unsigned long SmpRate GNUCREG(d0));
static ULONG ASM libQuietUpdateRate ( register __d0 unsigned long SmpRate GNUCREG(d0));

#ifdef __cplusplus
}
#endif

static ULONG ASM libQuietAlloc ( register __a0 union FlagPass *FlagPassStr GNUCREG(a0))
{
  return ( InternalQuietAlloc ( FlagPassStr ));
}

static ULONG ASM libQuietUpdate ( register __a0 union FlagPass *FlagPassStr GNUCREG(a0), register __d0 unsigned long FlagPassType GNUCREG(d0),
    register __d1 unsigned long FlagNum GNUCREG(d1))
{
  return ( InternalQuietUpdate ( FlagPassStr, FlagPassType, FlagNum ));
}

static ULONG ASM libQuietPlay ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0), register __a1 union FlagPass *FlagPassStr GNUCREG(a1))
{
  return ( InternalQuietPlay ( MixAllocStr, FlagPassStr ));
}

static ULONG ASM libQuietCheckRate ( register __d0 unsigned long SmpRate GNUCREG(d0))
{
  return ( InternalQuietCheckRate ( SmpRate ));
}

static ULONG ASM libQuietCheckRateFraction ( register __d0 unsigned long SmpRate GNUCREG(d0))
{
  return ( InternalQuietCheckRateFraction ( SmpRate ));
}

static ULONG ASM libQuietUpdateRate ( register __d0 unsigned long SmpRate GNUCREG(d0))
{
  return ( InternalQuietUpdateRate ( SmpRate ));
}

extern struct TuComposerBase *TuCBase;

static struct JumpTable {
  struct JumpEntry {
    UWORD JumpInst;
    APTR  JumpPtr;
  } Jump[16];
} QuietJumpTable =
{
  0x4EF9, ExtLib,
  0x4EF9, libQuietUpdateRate,
  0x4EF9, libQuietCheckRateFraction,
  0x4EF9, libQuietCheckRate,
  0x4EF9, InternalQuietStop,
  0x4EF9, libQuietPlay,
  0x4EF9, InternalQuietFree,
  0x4EF9, InternalQuietAlloc,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, libQuietUpdate,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, InternalQuietCloseExtLib,
  0x4EF9, InternalQuietOpenExtLib
};

struct SoundDeviceInfo InternalSoundDeviceBase =
{
  {{{NULL, NULL, NT_LIBRARY, -128, (STRPTR) &InternalQuietName},
      LIBF_SUMUSED, 0,
      sizeof ( QuietJumpTable ), sizeof (struct SoundDeviceInfo),
      EXTLIB_DEVICE_VERSION,
      EXTLIB_REVISION,
      (STRPTR) &InternalQuietIDString,
      NULL, 0},
    NULL,
    (struct TuComposerBase *) &TuCBase,
    (struct TuComposerExtList *) &InternalSoundDevice},
  SDIF_Stereo|SDIF_Interrupt, 0,
  4000, 256000
};
