/* TuComposer Internal TCI Amiga Shared-Library function prototypes.
**
** $VER: InternalTCI_library.h 31.00 (7.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif /* EXEC_TYPES_H */

#include "compiler.h"

#ifdef __cplusplus
extern "C" {
#endif

static ULONG ASM libIdentifyTCI ( register __a0 struct CFHandle *CFHandle GNUCREG(a0));
static struct TuComposerInstr * ASM libLoadTCI ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerInstr *InstrStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2),
    register __d0 unsigned long NumInstr GNUCREG(d0));
static ULONG ASM libSaveTCI ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerInstr *InstrStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2));
static ULONG ASM libGetTCIInfo ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct InstrInfo *InstrInfo GNUCREG(a1), register __d0 unsigned long NumInstr GNUCREG(d0));
static ULONG ASM libGetNumTCIs ( register __a0 struct CFHandle *CFHandle GNUCREG(a0));

#ifdef __cplusplus
}
#endif

static ULONG ASM libIdentifyTCI ( register __a0 struct CFHandle *CFHandle GNUCREG(a0))
{
  return ( IdentifyTCI ( CFHandle ));
}

static struct TuComposerInstr * ASM libLoadTCI ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerInstr *InstrStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2),
    register __d0 unsigned long NumInstr GNUCREG(d0))
{
  return ( LoadTCI ( CFHandle, InstrStr, FlagPassStr, NumInstr ));
}

static ULONG ASM libSaveTCI ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerInstr *InstrStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2))
{
  return ( SaveTCI ( CFHandle, InstrStr, FlagPassStr ));
}

static ULONG ASM libGetTCIInfo ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct InstrInfo *InstrInfo GNUCREG(a1), register __d0 unsigned long NumInstr GNUCREG(d0))
{
  return ( GetTCIInfo ( CFHandle, InstrInfo, NumInstr ));
}

static ULONG ASM libGetNumTCIs ( register __a0 struct CFHandle *CFHandle GNUCREG(a0))
{
  return ( GetNumTCIs ( CFHandle ));
}

extern struct TuComposerBase *TuCBase;

static struct JumpTable {
  struct JumpEntry {
    UWORD JumpInst;
    APTR  JumpPtr;
  } Jump[16];
} TCIJumpTable =
{
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, libGetNumTCIs,
  0x4EF9, libGetTCIInfo,
  0x4EF9, libSaveTCI,
  0x4EF9, libLoadTCI,
  0x4EF9, libIdentifyTCI,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, InternalTCICloseExtLib,
  0x4EF9, InternalTCIOpenExtLib
};

struct InstrLibrary InternalTCIBase =
{
  {{{NULL, NULL, NT_LIBRARY, 0, (STRPTR) &InternalTCIName},
      LIBF_SUMUSED, 0,
      sizeof ( TCIJumpTable ), sizeof (struct InstrLibrary),
      EXTLIB_INSTR_VERSION,
      EXTLIB_REVISION,
      (STRPTR) &InternalTCIIDString,
      NULL, 0},
    NULL,
    (struct TuComposerBase *) &TuCBase,
    (struct TuComposerExtList *) &InternalTCI},
};
