/* TuComposer Internal TCM Amiga Shared-Library function prototypes.
**
** $VER: InternalTCM_library.h 31.00 (28.1.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif /* EXEC_TYPES_H */

#include "compiler.h"

#ifdef __cplusplus
extern "C" {
#endif

static ULONG ASM libIdentifyTCM ( register __a0 struct CFHandle *CFHandle GNUCREG(a0));
static struct TuComposerModule * ASM libLoadTCM ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerModule *ModuleStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2),
    register __d0 unsigned long NumModule GNUCREG(d0));
static ULONG ASM libSaveTCM ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerModule *ModuleStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2));
static ULONG ASM libGetTCMInfo ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct ModuleInfo *ModuleInfo GNUCREG(a1), register __d0 unsigned long NumModule GNUCREG(d0));
static ULONG ASM libGetNumTCMs ( register __a0 struct CFHandle *CFHandle GNUCREG(a0));

#ifdef __cplusplus
}
#endif

static ULONG ASM libIdentifyTCM ( register __a0 struct CFHandle *CFHandle GNUCREG(a0))
{
  return ( IdentifyTCM ( CFHandle ));
}

static struct TuComposerModule * ASM libLoadTCM ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerModule *ModuleStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2),
    register __d0 unsigned long NumModule GNUCREG(d0))
{
  return ( LoadTCM ( CFHandle, ModuleStr, FlagPassStr, NumModule ));
}

static ULONG ASM libSaveTCM ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerModule *ModuleStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2))
{
  return ( SaveTCM ( CFHandle, ModuleStr, FlagPassStr ));
}

static ULONG ASM libGetTCMInfo ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct ModuleInfo *ModuleInfo GNUCREG(a1), register __d0 unsigned long NumModule GNUCREG(d0))
{
  return ( GetTCMInfo ( CFHandle, ModuleInfo, NumModule ));
}

static ULONG ASM libGetNumTCMs ( register __a0 struct CFHandle *CFHandle GNUCREG(a0))
{
  return ( GetNumTCMs ( CFHandle ));
}

extern struct TuComposerBase *TuCBase;

static struct JumpTable {
  struct JumpEntry {
    UWORD JumpInst;
    APTR  JumpPtr;
  } Jump[16];
} TCMJumpTable =
{
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, libGetNumTCMs,
  0x4EF9, libGetTCMInfo,
  0x4EF9, libSaveTCM,
  0x4EF9, libLoadTCM,
  0x4EF9, libIdentifyTCM,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, InternalTCMCloseExtLib,
  0x4EF9, InternalTCMOpenExtLib
};

struct ModuleLibrary InternalTCMBase =
{
  {{{NULL, NULL, NT_LIBRARY, 0, (STRPTR) &InternalTCMName},
      LIBF_SUMUSED, 0,
      sizeof ( TCMJumpTable ), sizeof (struct ModuleLibrary),
      EXTLIB_MODULE_VERSION,
      EXTLIB_REVISION,
      (STRPTR) &InternalTCMIDString,
      NULL, 0},
    NULL,
    (struct TuComposerBase *) &TuCBase,
    (struct TuComposerExtList *) &InternalTCM},
};
