/* TuComposer Internal TCS Amiga Shared-Library function prototypes.
**
** $VER: InternalTCS_library.h 31.00 (10.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif /* EXEC_TYPES_H */

#include "compiler.h"

#ifdef __cplusplus
extern "C" {
#endif

static ULONG ASM libIdentifyTCS ( register __a0 struct CFHandle *CFHandle GNUCREG(a0));
static struct TuComposerSong * ASM libLoadTCS ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSong *SongStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2),
    register __d0 unsigned long NumSong GNUCREG(d0));
static ULONG ASM libSaveTCS ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSong *SongStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2));
static ULONG ASM libGetTCSInfo ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct SongInfo *SongInfo GNUCREG(a1), register __d0 unsigned long NumSong GNUCREG(d0));
static ULONG ASM libGetNumTCSs ( register __a0 struct CFHandle *CFHandle GNUCREG(a0));

#ifdef __cplusplus
}
#endif

static ULONG ASM libIdentifyTCS ( register __a0 struct CFHandle *CFHandle GNUCREG(a0))
{
  return ( IdentifyTCS ( CFHandle ));
}

static struct TuComposerSong * ASM libLoadTCS ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSong *SongStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2),
    register __d0 unsigned long NumSong GNUCREG(d0))
{
  return ( LoadTCS ( CFHandle, SongStr, FlagPassStr, NumSong ));
}

static ULONG ASM libSaveTCS ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSong *SongStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2))
{
  return ( SaveTCS ( CFHandle, SongStr, FlagPassStr ));
}

static ULONG ASM libGetTCSInfo ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct SongInfo *SongInfo GNUCREG(a1), register __d0 unsigned long NumSong GNUCREG(d0))
{
  return ( GetTCSInfo ( CFHandle, SongInfo, NumSong ));
}

static ULONG ASM libGetNumTCSs ( register __a0 struct CFHandle *CFHandle GNUCREG(a0))
{
  return ( GetNumTCSs ( CFHandle ));
}

extern struct TuComposerBase *TuCBase;

static struct JumpTable {
  struct JumpEntry {
    UWORD JumpInst;
    APTR  JumpPtr;
  } Jump[16];
} TCSJumpTable =
{
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, libGetNumTCSs,
  0x4EF9, libGetTCSInfo,
  0x4EF9, libSaveTCS,
  0x4EF9, libLoadTCS,
  0x4EF9, libIdentifyTCS,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, InternalTCSCloseExtLib,
  0x4EF9, InternalTCSOpenExtLib
};

struct SongLibrary InternalTCSBase =
{
  {{{NULL, NULL, NT_LIBRARY, 0, (STRPTR) &InternalTCSName},
      LIBF_SUMUSED, 0,
      sizeof ( TCSJumpTable ), sizeof (struct SongLibrary),
      EXTLIB_SONG_VERSION,
      EXTLIB_REVISION,
      (STRPTR) &InternalTCSIDString,
      NULL, 0},
    NULL,
    (struct TuComposerBase *) &TuCBase,
    (struct TuComposerExtList *) &InternalTCS},
};
