/* TuComposer Internal TCT Amiga Shared-Library function prototypes.
**
** $VER: InternalTCT_library.h 31.00 (8.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif /* EXEC_TYPES_H */

#include "compiler.h"

#ifdef __cplusplus
extern "C" {
#endif

static ULONG ASM libIdentifyTCT ( register __a0 struct CFHandle *CFHandle GNUCREG(a0));
static struct TuComposerTrack * ASM libLoadTCT ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2),
    register __d0 unsigned long NumTrack GNUCREG(d0));
static ULONG ASM libSaveTCT ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2));
static ULONG ASM libGetTCTInfo ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TrackInfo *TrackInfo GNUCREG(a1), register __d0 unsigned long NumTrack GNUCREG(d0));
static ULONG ASM libGetNumTCTs ( register __a0 struct CFHandle *CFHandle GNUCREG(a0));

#ifdef __cplusplus
}
#endif

static ULONG ASM libIdentifyTCT ( register __a0 struct CFHandle *CFHandle GNUCREG(a0))
{
  return ( IdentifyTCT ( CFHandle ));
}

static struct TuComposerTrack * ASM libLoadTCT ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2),
    register __d0 unsigned long NumTrack GNUCREG(d0))
{
  return ( LoadTCT ( CFHandle, TrackStr, FlagPassStr, NumTrack ));
}

static ULONG ASM libSaveTCT ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2))
{
  return ( SaveTCT ( CFHandle, TrackStr, FlagPassStr ));
}

static ULONG ASM libGetTCTInfo ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TrackInfo *TrackInfo GNUCREG(a1), register __d0 unsigned long NumTrack GNUCREG(d0))
{
  return ( GetTCTInfo ( CFHandle, TrackInfo, NumTrack ));
}

static ULONG ASM libGetNumTCTs ( register __a0 struct CFHandle *CFHandle GNUCREG(a0))
{
  return ( GetNumTCTs ( CFHandle ));
}

extern struct TuComposerBase *TuCBase;

static struct JumpTable {
  struct JumpEntry {
    UWORD JumpInst;
    APTR  JumpPtr;
  } Jump[16];
} TCTJumpTable =
{
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, libGetNumTCTs,
  0x4EF9, libGetTCTInfo,
  0x4EF9, libSaveTCT,
  0x4EF9, libLoadTCT,
  0x4EF9, libIdentifyTCT,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, InternalTCTCloseExtLib,
  0x4EF9, InternalTCTOpenExtLib
};

struct TrackLibrary InternalTCTBase =
{
  {{{NULL, NULL, NT_LIBRARY, 0, (STRPTR) &InternalTCTName},
      LIBF_SUMUSED, 0,
      sizeof ( TCTJumpTable ), sizeof (struct TrackLibrary),
      EXTLIB_TRACK_VERSION,
      EXTLIB_REVISION,
      (STRPTR) &InternalTCTIDString,
      NULL, 0},
    NULL,
    (struct TuComposerBase *) &TuCBase,
    (struct TuComposerExtList *) &InternalTCT},
};
