/* TuComposer Internal TCY Amiga Shared-Library function prototypes.
**
** $VER: InternalTCY_library.h 31.00 (7.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif /* EXEC_TYPES_H */

#include "compiler.h"

#ifdef __cplusplus
extern "C" {
#endif

static ULONG ASM libIdentifyTCY ( register __a0 struct CFHandle *CFHandle GNUCREG(a0));
static struct TuComposerSynth * ASM libLoadTCY ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2),
    register __d0 unsigned long NumSynth GNUCREG(d0));
static ULONG ASM libSaveTCY ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2));
static ULONG ASM libGetTCYInfo ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct SynthInfo *SynthInfo GNUCREG(a1), register __d0 unsigned long NumSynth GNUCREG(d0));
static ULONG ASM libGetNumTCYs ( register __a0 struct CFHandle *CFHandle GNUCREG(a0));

#ifdef __cplusplus
}
#endif

static ULONG ASM libIdentifyTCY ( register __a0 struct CFHandle *CFHandle GNUCREG(a0))
{
  return ( IdentifyTCY ( CFHandle ));
}

static struct TuComposerSynth * ASM libLoadTCY ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2),
    register __d0 unsigned long NumSynth GNUCREG(d0))
{
  return ( LoadTCY ( CFHandle, SynthStr, FlagPassStr, NumSynth ));
}

static ULONG ASM libSaveTCY ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2))
{
  return ( SaveTCY ( CFHandle, SynthStr, FlagPassStr ));
}

static ULONG ASM libGetTCYInfo ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct SynthInfo *SynthInfo GNUCREG(a1), register __d0 unsigned long NumSynth GNUCREG(d0))
{
  return ( GetTCYInfo ( CFHandle, SynthInfo, NumSynth ));
}

static ULONG ASM libGetNumTCYs ( register __a0 struct CFHandle *CFHandle GNUCREG(a0))
{
  return ( GetNumTCYs ( CFHandle ));
}

extern struct TuComposerBase *TuCBase;

static struct JumpTable {
  struct JumpEntry {
    UWORD JumpInst;
    APTR  JumpPtr;
  } Jump[16];
} TCYJumpTable =
{
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, libGetNumTCYs,
  0x4EF9, libGetTCYInfo,
  0x4EF9, libSaveTCY,
  0x4EF9, libLoadTCY,
  0x4EF9, libIdentifyTCY,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, ExtLib,
  0x4EF9, InternalTCYCloseExtLib,
  0x4EF9, InternalTCYOpenExtLib
};

struct SynthLibrary InternalTCYBase =
{
  {{{NULL, NULL, NT_LIBRARY, 0, (STRPTR) &InternalTCYName},
      LIBF_SUMUSED, 0,
      sizeof ( TCYJumpTable ), sizeof (struct SynthLibrary),
      EXTLIB_SYNTH_VERSION,
      EXTLIB_REVISION,
      (STRPTR) &InternalTCYIDString,
      NULL, 0},
    NULL,
    (struct TuComposerBase *) &TuCBase,
    (struct TuComposerExtList *) &InternalTCY},
};
