/*
**      $VER: LibInit.c 37.32 (2.3.99)
**
**      Library initializers and functions to be called by StartUp.c
**
**      (C) Copyright 1996-99 Andreas R. Kleinert
**      All Rights Reserved.
*/

#define __USE_SYSBASE        /* perhaps only recognized by SAS/C */

#include <exec/types.h>
#include <exec/memory.h>
#include <exec/libraries.h>
#include <exec/execbase.h>
#include <exec/resident.h>
#include <exec/initializers.h>
#include <tucomposer/tucomposer.h>

#ifdef __MAXON__
#include <clib/exec_protos.h>
#else
#include <proto/exec.h>
#endif

#include "compiler.h"

struct InternalInit {
  struct TuComposerExtList *inti_InternalInit;
  ULONG inti_InternalInitType;
};

extern APTR FuncTab;

extern struct TuComposerBase * __saveds ASM PrepareLibrary ( register __a6 struct ExecBase *SysBase GNUCREG(a6),
    register __a0 SEGLISTPTR SegList GNUCREG(a0),
    register __d0 struct TuComposerBase *TuCBase GNUCREG(d0));

extern struct TuComposerBase *Initialize ( struct TuComposerBase *TuCBase );

struct ExecBase      *SysBase       = NULL;
struct DosLibrary    *DOSBase       = NULL;
struct IntuitionBase *IntBase       = NULL;
struct GfxBase       *GfxBase       = NULL;
struct TuComposerBase *TuCBase      = NULL;

struct TuComposerBase * __saveds ASM libInit ( register __a0 SEGLISTPTR SegList GNUCREG(a0));

char __aligned LibName [] = "tucomposer.library";
char __aligned LibID [] = "TuComposer Version 1.00 (v31) (68020+, OS2.04+) (27 Oct 96) by Basty/Seasons.";

char __aligned WrongCPU_OSMsg [] = "\0\130\020This version of the TuComposer.Library (v31.00) requires:\
\0\377\0\204\032-68020 or better processor\
\0\377\0\204\044- Version 2.04 (v37) of the operating system\0\0";

/* ----------------------------------------------------------------------------------------
   ! ROMTag and Library inilitalization structure:
   !
   ! Below you find the ROMTag, which is the most important "magic" part of a library
   ! (as for any other resident module). You should not need to modify any of the
   ! structures directly, since all the data is referenced from constants from somewhere else.
   !
   ! You may place the ROMTag directly after the LibStart (-> StartUp.c) function as well.
   !
   ! Note, that the data initialization structure may be somewhat redundant - it's
   ! for demonstration purposes.
   !
   ! EndResident can be placed somewhere else - but it must follow the ROMTag and
   ! it must not be placed in a different SECTION.
   ---------------------------------------------------------------------------------------- */

extern ULONG InitTab[];
extern APTR EndResident; /* below */

extern struct TuComposerExtList *InternalPaula;
extern struct TuComposerExtList *InternalSoundDevice;
extern struct TuComposerExtList *InternalMixer;
extern struct TuComposerExtList *InternalPostProc;
extern struct TuComposerExtList *InternalTCM;
extern struct TuComposerExtList *InternalTCS;
extern struct TuComposerExtList *InternalTCT;
extern struct TuComposerExtList *InternalTCI;
extern struct TuComposerExtList *InternalTCY;

struct Resident __aligned ROMTag =     /* do not change */
{
 RTC_MATCHWORD,
 &ROMTag,
 &EndResident,
 0,
 TuCVer,
 NT_LIBRARY,
 0,
 &LibName[0],
 &LibID[0],
 libInit
};

APTR EndResident;

struct MyDataInit                      /* do not change */
{
 UWORD ln_Type_Init;      UWORD ln_Type_Offset;      UWORD ln_Type_Content;
 UBYTE ln_Name_Init;      UBYTE ln_Name_Offset;      ULONG ln_Name_Content;
 UWORD lib_Flags_Init;    UWORD lib_Flags_Offset;    UWORD lib_Flags_Content;
 UWORD lib_Version_Init;  UWORD lib_Version_Offset;  UWORD lib_Version_Content;
 UWORD lib_Revision_Init; UWORD lib_Revision_Offset; UWORD lib_Revision_Content;
 UBYTE lib_IdString_Init; UBYTE lib_IdString_Offset; ULONG lib_IdString_Content;
 ULONG ENDMARK;
} DataTab =
#ifdef VBCC
{
        0xe000,8,NT_LIBRARY,
        0x0080,10,(ULONG) &LibName[0],
        0xe000,LIBF_SUMUSED|LIBF_CHANGED,
        0xd000,TuCVer,VERSION,
        0xd000,TuCRev,REVISION,
        0x80,24,(ULONG) &LibID[0],
        (ULONG) 0
};
#else
{
 INITBYTE(OFFSET(Node,         ln_Type),      NT_LIBRARY),
 0x80, (UBYTE) OFFSET(Node,    ln_Name),      (ULONG) &LibName[0],
 INITBYTE(OFFSET(Library,      lib_Flags),    LIBF_SUMUSED|LIBF_CHANGED),
 INITWORD(OFFSET(Library,      lib_Version),  TuCVer),
 INITWORD(OFFSET(Library,      lib_Revision), TuCRev),
 0x80, (UBYTE) OFFSET(Library, lib_IdString), (ULONG) &LibID[0],
 (ULONG) 0
};
#endif

struct {
  struct InternalInit inti_InitLib0;
  struct InternalInit inti_InitLib1;
  struct InternalInit inti_InitLib2;
  struct InternalInit inti_InitLib3;
  struct InternalInit inti_InitLib4;
  struct InternalInit inti_InitLib5;
  struct InternalInit inti_InitLib6;
  struct InternalInit inti_InitLib7;
  struct InternalInit inti_InitLib8;
  APTR inti_Terminator;
} InternalInitTable =
{
  {(struct TuComposerExtList *) &InternalPaula, EXTTYPE_DEVICE},
  {(struct TuComposerExtList *) &InternalSoundDevice, EXTTYPE_DEVICE},
  {(struct TuComposerExtList *) &InternalMixer, EXTTYPE_MIXER},
  {(struct TuComposerExtList *) &InternalPostProc, EXTTYPE_POSTPROC},
  {(struct TuComposerExtList *) &InternalTCM, EXTTYPE_MODULE},
  {(struct TuComposerExtList *) &InternalTCS, EXTTYPE_SONG},
  {(struct TuComposerExtList *) &InternalTCT, EXTTYPE_TRACK},
  {(struct TuComposerExtList *) &InternalTCI, EXTTYPE_INSTR},
  {(struct TuComposerExtList *) &InternalTCY, EXTTYPE_SYNTH},
  NULL
};

struct TuComposerBase * __saveds ASM libInit ( register __a0 SEGLISTPTR SegList GNUCREG(a0))
{
  SysBase = (*((struct ExecBase **) 4));

  #ifdef __MAXON__
    GetBaseReg();
    InitModules();
  #endif

  if (!(TuCBase = (struct TuComposerBase *) MakeLibrary ( &FuncTab, &DataTab, (APTR) &PrepareLibrary, sizeof (struct TuComposerBase), SegList)))
    return( NULL );

  AddLibrary ( (struct Library *) TuCBase );

  return ( Initialize ( TuCBase ));
}
