/*
**      $VER: StartUp.c 37.31 (18.3.98)
**
**      Library startup-code and function table definition
**
**      (C) Copyright 1996-98 Andreas R. Kleinert
**      All Rights Reserved.
**
**      StormC add-ons and some small bug fixes by Basty/Seasons.
*/

#define __USE_SYSBASE        /* perhaps only recognized by SAS/C */

#include <exec/types.h>
#include <exec/memory.h>
#include <exec/libraries.h>
#include <exec/execbase.h>
#include <exec/resident.h>
#include <exec/initializers.h>

#ifdef __MAXON__
#include <pragma/exec_lib.h>
#include <pragma/intuition_lib.h>
#include <linkerfunc.h>
#else
#include <proto/exec.h>    /* all other compilers */
#include <proto/intuition.h>
#endif

#include "compiler.h"
#include "library.h"

extern struct DosLibrary *DOSBase;
extern struct IntuitionBase *IntBase;
extern struct TuComposerBase *TuCBase;
extern char *WrongCPU_OSMsg;

extern ULONG __saveds ASM libInit ( SEGLISTPTR SegList );

struct TuComposerBase * __saveds ASM PrepareLibrary ( register __a6 struct ExecBase *SysBase GNUCREG(a6),
    register __a0 SEGLISTPTR SegList GNUCREG(a0),
    register __d0 struct TuComposerBase *TuCBase GNUCREG(d0));

struct TuComposerBase * __saveds ASM libOpen ( register __a6 struct TuComposerBase *TuCBase GNUCREG(a6));
SEGLISTPTR __saveds ASM libClose ( register __a6 struct TuComposerBase *TuCBase GNUCREG(a6));
SEGLISTPTR __saveds ASM libExpunge ( register __a6 struct TuComposerBase *TuCBase GNUCREG(a6));
ULONG ASM libExtLib ( void );

/* ----------------------------------------------------------------------------------------
   ! Function and Data Tables:
   !
   ! The function and data tables have been placed here for traditional reasons.
   ! Placing the RomTag structure before (-> LibInit.c) would also be a good idea,
   ! but it depends on whether you would like to keep the "version" stuff separately.
   ---------------------------------------------------------------------------------------- */

extern APTR FuncTab [];
/*  extern struct MyDataInit DataTab;  */
extern DataTab; /* DICE fix */
                                  /* Instead you may place ROMTag + Datatab directly, here */
                                  /* (see LibInit.c). This may fix "Installer" version     */
                                  /* checking problems, too - try it.                      */

APTR FuncTab [] =
{
  libOpen,
  libClose,
  libExpunge,
  libExtLib,

  libAllocPMem,
  libFreePMem,
  libInitNodeList,
  libInsertNode,
  libAddNodeHead,
  libAddNodeTail,
  libRemoveNode,
  libRemNodeHead,
  libRemNodeTail,
  libEnqueueNode,
  libDupNodeList,
  libReMapNodeList,
  libAllocNameStr,
  libFreeNameStr,
  libSetString,
  libSetNameStr,
  libSin,
  libCos,
  libTan,
  libDoPlayerIRQ,
  libAddPlayExecHandler,
  libRemPlayExecHandler,
  libSetPlayExecHandlerPri,
  libStamp2Date,
  libAllocSimulateMix,
  libFreeSimulateMix,
  libAllocUnknownChunk,
  libFreeUnknownChunk,
  libDeleteUnknownChunk,
  libRandomize,
  libRnd,
  libAllocSoundDevice,
  libFreeSoundDevice,
  libPlaySoundDevice,
  libStopSoundDevice,
  libCheckSoundDeviceRate,
  libCheckSoundDeviceRateFraction,
  libUpdateSoundDeviceRate,
  libAllocMixer,
  libFreeMixer,
  libInitMixer,
  libChangeMixerRate,
  libChangeMixerTempo,
  libChangeMixerVolTable,
  libGetMixChannel,
  libSetMixChannel,
  libSetMixChannelVolPanPitch,
  libSetMixChannelPosRepFlags,
  libDoMix,
  libAllocPostProcessor,
  libFreePostProcessor,
  libInitPostProcessor,
  libChangePostProcessor,
  libDoPostProcessorMix,
  libAddPostProcessor,
  libRemPostProcessor,
  libSetPostProcessorPri,
  libAllocTCModule,
  libFreeTCModule,
  libAddTCModule,
  libRemTCModule,
  libDupTCModule,
  libReMapTCModule,
  libLoadTCModule,
  libSaveTCModule,
  libIdentifyTCModule,
  libGetTCModuleInfo,
  libFreeTCModuleInfo,
  libGetTCModules,
  libPushTCModule,
  libPopTCModule,
  libCutTCModule,
  libCopyTCModule,
  libPasteTCModule,
  libSwapTCModule,
  libClearTCModule,
  libAddTCModuleUnknownChunk,
  libRemTCModuleUnknownChunk,
  libInsertTCModuleUnknownChunk,
  libAllocPlayTCModule,
  libFreePlayTCModule,
  libPlayTCModule,
  libStopTCModule,
  libSetTCMChannels,
  libCalcTCMPlayTime,
  libGetOptimalVChannels,
  libAllocSong,
  libFreeSong,
  libAddSong,
  libRemSong,
  libInsertSong,
  libDeleteSong,
  libDupSong,
  libReMapSong,
  libGetNumSongs,
  libGetSongNum,
  libGetSongAddr,
  libLoadSong,
  libSaveSong,
  libIdentifySong,
  libGetSongInfo,
  libFreeSongInfo,
  libGetSongs,
  libPushSong,
  libPopSong,
  libCutSong,
  libCopySong,
  libPasteSong,
  libSwapSong,
  libClearSong,
  libAddSongUnknownChunk,
  libRemSongUnknownChunk,
  libInsertSongUnknownChunk,
  libGetSongInstrs,
  libFreeSongInstrs,
  libGetSongEnvelopes,
  libFreeSongEnvelopes,
  libGetSongKeyboards,
  libFreeSongKeyboards,
  libGetSongArpeggios,
  libFreeSongArpeggios,
  libReMapSongInstrs,
  libSetBaseSongInstrs,
  libSetSongChannels,
  libSetStack,
  libCalcSongPlayTime,
  libGetOptimalChannels,
  libResetSong,
  libCalcPlayerSpeed,
  libAllocPosition,
  libFreePosition,
  libSwapPosition,
  libSetPosition,
  libDupPosition,
  libGetPositionNum,
  libGetPositionAddr,
  libClearPosition,
  libPlayPosition,
  libDupPositionChannel,
  libClearPositionChannel,
  libAllocPositionList,
  libFreePositionList,
  libAddPositionList,
  libRemPositionList,
  libInsertPositionList,
  libDeletePositionList,
  libDupPositionList,
  libSwapPositionList,
  libClearPositionList,
  libAllocTrack,
  libFreeTrack,
  libAddTrack,
  libRemTrack,
  libInsertTrack,
  libDeleteTrack,
  libClearTrack,
  libDupTrack,
  libReMapTrack,
  libReSizeTrack,
  libAddTrackUnknownChunk,
  libRemTrackUnknownChunk,
  libInsertTrackUnknownChunk,
  libGetNumTracks,
  libGetTrackNum,
  libGetTrackAddr,
  libGetNoteStr,
  libGetIndexNoteStr,
  libNoteToIndex,
  libIndexToNote,
  libGetTrackRowStr,
  libAllocEffect,
  libFreeEffect,
  libAddEffect,
  libRemEffect,
  libInsertEffect,
  libDeleteEffect,
  libClearEffects,
  libReMapEffects,
  libAllocTrackData,
  libFreeTrackData,
  libAddRows,
  libRemRows,
  libInsertRows,
  libDeleteRows,
  libClearRows,
  libReMapRows,
  libCopyRows,
  libSwapRows,
  libPlayRow,
  libCmpTracks,
  libPackTrack,
  libUnPackTrack,
  libFreePackedTrack,
  libLoadTrack,
  libSaveTrack,
  libIdentifyTrack,
  libGetTrackInfo,
  libFreeTrackInfo,
  libGetTracks,
  libPushTrack,
  libPopTrack,
  libCutTrack,
  libCopyTrack,
  libPasteTrack,
  libSwapTrack,
  libSwapTrackInSong,
  libShrinkTrack,
  libExpandTrack,
  libHalveTrack,
  libDoubleTrack,
  libSplitTrack,
  libJoinTrack,
  libPlayTrack,
  libTrackNoteShift,
  libScrollTrack,
  libRotateTrack,
  libFlipTrack,
  libAllocInstr,
  libFreeInstr,
  libAddInstr,
  libRemInstr,
  libInsertInstr,
  libDeleteInstr,
  libClearInstr,
  libDupInstr,
  libReMapInstr,
  libAddInstrUnknownChunk,
  libRemInstrUnknownChunk,
  libInsertInstrUnknownChunk,
  libGetNumInstrs,
  libGetInstrNum,
  libGetInstrAddr,
  libLoadInstr,
  libSaveInstr,
  libIdentifyInstr,
  libGetInstrInfo,
  libFreeInstrInfo,
  libGetInstrs,
  libPushInstr,
  libPopInstr,
  libCutInstr,
  libCopyInstr,
  libPasteInstr,
  libSwapInstr,
  libSwapInstrInModule,
  libPlayInstr,
  libCmpInstrs,
  libGetInstrEnvelopes,
  libFreeInstrEnvelopes,
  libAddInstrEnvelopes,
  libGetInstrKeyboard,
  libGetInstrSamples,
  libFreeInstrSamples,
  libCreateEnvelope,
  libFreeEnvelope,
  libAddEnvelope,
  libRemEnvelope,
  libInsertEnvelope,
  libDeleteEnvelope,
  libClearEnvelope,
  libDupEnvelope,
  libReMapEnvelope,
  libReSizeEnvelope,
  libValidateEnvNodes,
  libAddEnvelopeUnknownChunk,
  libRemEnvelopeUnknownChunk,
  libInsertEnvelopeUnknownChunk,
  libGetNumEnvelopes,
  libGetEnvelopeNum,
  libGetEnvelopeAddr,
  libSwapEnvelopeInModule,
  libLoadEnvelope,
  libSaveEnvelope,
  libShrinkEnvelope,
  libExpandEnvelope,
  libHalveEnvelope,
  libDoubleEnvelope,
  libSplitEnvelope,
  libJoinEnvelope,
  libScrollEnvelope,
  libRotateEnvelope,
  libFlipEnvelope,
  libAddEnvPoint,
  libRemEnvPoint,
  libInsertEnvPoint,
  libDeleteEnvPoint,
  libCmpEnvelopes,
  libAllocKeyboard,
  libFreeKeyboard,
  libAddKeyboard,
  libRemKeyboard,
  libInsertKeyboard,
  libDeleteKeyboard,
  libClearKeyboard,
  libDupKeyboard,
  libReMapKeyboard,
  libGetNumKeyboards,
  libGetKeyboardNum,
  libGetKeyboardAddr,
  libSwapKeyboardInModule,
  libSetKeyboard,
  libCheckKeyboard,
  libCmpKeyboards,
  libAllocArpeggio,
  libFreeArpeggio,
  libAddArpeggio,
  libRemArpeggio,
  libInsertArpeggio,
  libDeleteArpeggio,
  libClearArpeggio,
  libDupArpeggio,
  libReMapArpeggio,
  libReSizeArpeggio,
  libGetNumArpeggios,
  libGetArpeggioNum,
  libGetArpeggioAddr,
  libSwapArpeggioInModule,
  libShrinkArpeggio,
  libExpandArpeggio,
  libHalveArpeggio,
  libDoubleArpeggio,
  libSplitArpeggio,
  libJoinArpeggio,
  libScrollArpeggio,
  libRotateArpeggio,
  libFlipArpeggio,
  libAddArpeggioTick,
  libRemArpeggioTick,
  libInsertArpeggioTick,
  libDeleteArpeggioTick,
  libCmpArpeggios,
  libAllocSample,
  libFreeSample,
  libAddSample,
  libRemSample,
  libInsertSample,
  libDeleteSample,
  libClearSample,
  libDupSample,
  libReSizeSample,
  libAddSampleUnknownChunk,
  libRemSampleUnknownChunk,
  libInsertSampleUnknownChunk,
  libGetNumSamples,
  libGetSampleNum,
  libGetSampleAddr,
  libPushSample,
  libPopSample,
  libCutSample,
  libCopySample,
  libPasteSample,
  libSwapSample,
  libSwapSampleInInstr,
  libPlaySample,
  libLoadSample,
  libSaveSample,
  libIdentifySample,
  libGetSampleInfo,
  libFreeSampleInfo,
  libGetSamples,
  libCalcSamplePlayFreq,
  libCalcFineTune,
  libConvertSampleFrequency,
  libCalcLinearFrequency,
  libAllocSampleData,
  libFreeSampleData,
  libSetSampleData,
  libAddSampleData,
  libRemSampleData,
  libInsertSampleData,
  libDeleteSampleData,
  libClearSampleData,
  libDupSampleData,
  libCutSampleData,
  libCopySampleData,
  libPasteSampleData,
  libCropSampleData,
  libLoadSampleData,
  libSaveSampleData,
  libConvertBits,
  libGetOptimalBits,
  libConvertSigned,
  libConvertWord,
  libDecrunchSample,
  libBackwards,
  libMixSamples,
  libSample,
  libOctaveUp,
  libOctaveDown,
  libReSample,
  libInvertSample,
  libXFadeSample,
  libAmplifySample,
  libGetBiggestAmplify,
  libGetLowestAmplify,
  libCreateEcho,
  libBoostSample,
  libFilterSample,
  libMorphSamples,
  libMinimizeSample,
  libFindOriginSample,
  libGetSampleValue,
  libGetSampleValueArray,
  libCmpSamples,
  libAllocSynth,
  libFreeSynth,
  libAssignSynth,
  libClearSynth,
  libDupSynth,
  libReMapSynth,
  libAddSynthUnknownChunk,
  libRemSynthUnknownChunk,
  libInsertSynthUnknownChunk,
  libGetNumSynths,
  libGetSynthNum,
  libGetSynthAddr,
  libPushSynth,
  libPopSynth,
  libCutSynth,
  libCopySynth,
  libPasteSynth,
  libSwapSynth,
  libLoadSynth,
  libSaveSynth,
  libIdentifySynth,
  libGetSynthInfo,
  libFreeSynthInfo,
  libGetSynths,
  libCmpSynths,
  libAllocWaveform,
  libFreeWaveform,
  libAddWaveform,
  libRemWaveform,
  libInsertWaveform,
  libDeleteWaveform,
  libClearWaveform,
  libDupWaveform,
  libReSizeWaveform,
  libGetNumWaveforms,
  libGetWaveformNum,
  libGetWaveformAddr,
  libPushWaveform,
  libPopWaveform,
  libCutWaveform,
  libCopyWaveform,
  libPasteWaveform,
  libSwapWaveform,
  libSwapWaveformInSynth,
  libLoadWaveform,
  libSaveWaveform,
  libPlayWaveform,
  libAddWaveformPoint,
  libRemWaveformPoint,
  libInsertWaveformPoint,
  libDeleteWaveformPoint,
  libFillWaveform,
  libConvertWaveform,
  libConvertWaveformSigned,
  libConvertWaveformWord,
  libBackwardsWaveform,
  libMixWaveforms,
  libHalveWaveform,
  libDoubleWaveform,
  libScaleWaveformSize,
  libInvertWaveform,
  libAmplifyWaveform,
  libGetMaxWaveformAmplify,
  libGetMinWaveformAmplify,
  libCopySample2Waveform,
  libCopyWaveform2Sample,
  libCopyEnvelope2Waveform,
  libCopyWaveform2Envelope,
  libTransformWaveform,
  libCmpWaveforms,
  libAllocSynthCode,
  libFreeSynthCode,
  libAssignSynthCode,
  libClearSynthCode,
  libDupSynthCode,
  libReSizeSynthCode,
  libPushSynthCode,
  libPopSynthCode,
  libCutSynthCode,
  libCopySynthCode,
  libPasteSynthCode,
  libSwapSynthCode,
  libAddSynthCodeLine,
  libRemSynthCodeLine,
  libInsertSynthCodeLine,
  libDeleteSynthCodeLine,
  libGetSynthCodeParams,
  libAssembleCodeLine,
  libDisassembleCodeLine,
  libAllocSymbol,
  libFreeSymbol,
  libAssignSymbol,
  libDupSymbol,
  libAddSymbol,
  libRemSymbol,
  libInsertSymbol,
  libDeleteSymbol,
  libGetNumSymbols,
  libGetSymbolNum,
  libGetSymbolAddr,
  libMatchSymbol,
  libAddExternalLib,
  libRemExternalLib,
  libOpenExternalLib,
  libCloseExternalLib,
  libGetExternalLibs,
  libAllocFlagStr,
  libCIdentify,
  libCOpen,
  libCClose,
  libCRead,
  libCWrite,
  libCSeek,
  libCGetInfo,

  (APTR) -1
};

UBYTE Is68060;

/* ----------------------------------------------------------------------------------------
   ! PrepareLibrary:
   !
   ! This one is single-threaded by the Ramlib process. Theoretically you can do, what
   ! you like here, since you have full exclusive control over all the library code and data.
   ! But due to some bugs in Ramlib V37-40, you can easily cause a deadlock when opening
   ! certain libraries here (which open other libraries, that open other libraries, that...)
   !
   ---------------------------------------------------------------------------------------- */

struct TuComposerBase * __saveds ASM PrepareLibrary ( register __a6 struct ExecBase *SysBase GNUCREG(a6),
    register __a0 SEGLISTPTR SegList GNUCREG(a0),
    register __d0 struct TuComposerBase *TuCBase GNUCREG(d0))
{
  TuCBase->tcb_SegList = SegList;

  IntBase = (struct IntuitionBase *) OpenLibrary ( "intuition.library", 0L);
  TuCBase->tcb_IntBase = IntBase;

  if (!( SysBase->AttnFlags & AFF_68020 ))
    goto WrongCPU_OS;

  Is68060 = 0;

  if ( SysBase->AttnFlags & 128 )
    Is68060 = 0xFF;

  if ( SysBase->LibNode.lib_Version < 37)
    goto WrongCPU_OS;

  if ( SysBase->LibNode.lib_Version >= 39)
  {
    if (!( TuCBase->tcb_MemPool = CreatePool ( MEMF_PUBLIC|MEMF_CLEAR, 32768, 4096 )))
      goto NotCreatePool;

    if (!( TuCBase->tcb_MemSigSem = (struct SignalSemaphore *) AllocPooled ( TuCBase->tcb_MemPool, sizeof ( struct SignalSemaphore ))))
    {
       DeletePool ( TuCBase->tcb_MemPool );

       TuCBase->tcb_MemPool = NULL;
    } else
    {
      InitSemaphore ( TuCBase->tcb_MemSigSem );
    }
  }

NotCreatePool:

  DOSBase = (struct DosLibrary *) OpenLibrary ( "dos.library", 37L );

  TuCBase->tcb_DOSBase = DOSBase;

  return ( TuCBase );

WrongCPU_OS:

  DisplayAlert ( NULL, WrongCPU_OSMsg, 50L-1 );

  CloseLibrary ( (struct Library *) TuCBase->tcb_IntBase );

  return ( NULL );
}

/* ----------------------------------------------------------------------------------------
   ! libOpen:
   !
   ! This one is enclosed within a Forbid/Permit pair by Exec V37-40. Since a Wait() call
   ! would break this Forbid/Permit(), you are not allowed to start any operations that
   ! may cause a Wait() during their processing. It's possible, that future OS versions
   ! won't turn the multi-tasking off, but instead use semaphore protection for this
   ! function.
   !
   ! Currently you only can bypass this restriction by supplying your own semaphore
   ! mechanism.
   ---------------------------------------------------------------------------------------- */

struct TuComposerBase * __saveds ASM libOpen ( register __a6 struct TuComposerBase *TuCBase GNUCREG(a6))
{
  TuCBase->tcb_LibNode.lib_OpenCnt++;

  return ( TuCBase );
}

/* ----------------------------------------------------------------------------------------
   ! libClose:
   !
   ! This one is enclosed within a Forbid/Permit pair by Exec V37-40. Since a Wait() call
   ! would break this Forbid/Permit(), you are not allowed to start any operations that
   ! may cause a Wait() during their processing. It's possible, that future OS versions
   ! won't turn the multi-tasking off, but instead use semaphore protection for this
   ! function.
   !
   ! Currently you only can bypass this restriction by supplying your own semaphore
   ! mechanism.
   ---------------------------------------------------------------------------------------- */

SEGLISTPTR __saveds ASM libClose ( register __a6 struct TuComposerBase *TuCBase GNUCREG(a6))
{
  if (!( --TuCBase->tcb_LibNode.lib_OpenCnt ))
  {
    if ( TuCBase->tcb_LibNode.lib_Flags & LIBF_DELEXP )
      return ( libExpunge ( TuCBase ));
  }

  return ( NULL );
}

/* ----------------------------------------------------------------------------------------
   ! libExpunge:
   !
   ! This one is enclosed within a Forbid/Permit pair by Exec V37-40. Since a Wait() call
   ! would break this Forbid/Permit(), you are not allowed to start any operations that
   ! may cause a Wait() during their processing. It's possible, that future OS versions
   ! won't turn the multi-tasking off, but instead use semaphore protection for this
   ! function.
   !
   ! Currently you only could bypass this restriction by supplying your own semaphore
   ! mechanism - but since expunging can't be done twice, one should avoid it here.
   ---------------------------------------------------------------------------------------- */

SEGLISTPTR __saveds ASM libExpunge ( register __a6 struct TuComposerBase *TuCBase GNUCREG(a6))
{
  struct MinList *ExpungeExtLibPtr;
  struct TuComposerBase *TuComposerBase = TuCBase;
  SEGLISTPTR SegList;
  ULONG i;

  if ( (SegList = TuComposerBase->tcb_SegList ))
  {
    TuComposerBase->tcb_SegList = NULL;

    ExpungeExtLibPtr = (struct MinList *) &(TuComposerBase->tcb_ExtCrunch);

    for (i = EXTTYPE_RESERVED - 1; i > 0; i--)
    {
      struct TuComposerExtList *ExtListFree = (struct TuComposerExtList *) ExpungeExtLibPtr->mlh_Head;

      for (;;)
      {
        if (!( ExtListFree->extl_Node.mln_Succ ))
          break;

        ExtListFree = RemExternalLib ( ExtListFree );
      }

      ExpungeExtLibPtr++;
    }

    TuComposerBase->tcb_LibNode.lib_Flags |= LIBF_DELEXP;

    if (!TuComposerBase->tcb_LibNode.lib_OpenCnt)
    {
      ULONG NegSize, PosSize, FullSize;
      UBYTE *NegPtr = (UBYTE *) TuComposerBase;

      ExpungeExtLibPtr = (struct MinList *) &(TuComposerBase->tcb_ExtCrunch);

      Forbid();

      for (i = EXTTYPE_RESERVED - 1; i > 0; i--)
      {
        struct TuComposerExtList *ExtListFree = (struct TuComposerExtList *) &(ExpungeExtLibPtr->mlh_Head);

        for (;;)
        {
          struct TuComposerExtLibBase *ExtLibBase;

          ExtListFree = (struct TuComposerExtList *) ExtListFree->extl_Node.mln_Succ;

          if (!( ExtListFree->extl_Node.mln_Succ ))
            break;

          ExtLibBase = ExtListFree->extl_LibBase;

          if ( ExtLibBase->extb_LibNode.lib_OpenCnt )
          {
            Permit();

            TuComposerBase->tcb_SegList = SegList;

            return ( NULL );
          }

          Remove ( (struct Node *) ExtLibBase );
        }

        ExpungeExtLibPtr++;
      }

      Permit();

      FreePMem ( TuComposerBase->tcb_ExternalSigSem, sizeof ( struct SignalSemaphore ));
      FreePMem ( TuComposerBase->tcb_WavesSigSem, sizeof ( struct SignalSemaphore ));
      FreePMem ( TuComposerBase->tcb_SynthSigSem, sizeof ( struct SignalSemaphore ));
      FreePMem ( TuComposerBase->tcb_SampleSigSem, sizeof ( struct SignalSemaphore ));
      FreePMem ( TuComposerBase->tcb_InstrSigSem, sizeof ( struct SignalSemaphore ));
      FreePMem ( TuComposerBase->tcb_TrackSigSem, sizeof ( struct SignalSemaphore ));
      FreePMem ( TuComposerBase->tcb_SongSigSem, sizeof ( struct SignalSemaphore ));
      FreePMem ( TuComposerBase->tcb_ModuleSigSem, sizeof ( struct SignalSemaphore ));
      FreePMem ( TuComposerBase->tcb_PlaySigSem, sizeof ( struct SignalSemaphore ));
      FreePMem ( TuComposerBase->tcb_ModuleListSigSem, sizeof ( struct SignalSemaphore ));
      if ( TuComposerBase->tcb_MemPool )
        DeletePool ( TuComposerBase->tcb_MemPool );

      Remove( (struct Node *) TuComposerBase);

      NegSize  = TuComposerBase->tcb_LibNode.lib_NegSize;
      PosSize  = TuComposerBase->tcb_LibNode.lib_PosSize;
      FullSize = NegSize + PosSize;
      NegPtr  -= NegSize;

      FreeMem ( NegPtr, FullSize );

      #ifdef __MAXON__
      CleanupModules();
      #endif

      return ( SegList );
    }

    TuComposerBase->tcb_SegList = SegList;
  }

  return ( NULL );
}

/* ----------------------------------------------------------------------------------------
   ! libExtLib:
   !
   ! This one is enclosed within a Forbid/Permit pair by Exec V37-40. Since a Wait() call
   ! would break this Forbid/Permit(), you are not allowed to start any operations that
   ! may cause a Wait() during their processing. It's possible, that future OS versions
   ! won't turn the multi-tasking off, but instead use semaphore protection for this
   ! function.
   !
   ! Currently you only can bypass this restriction by supplying your own semaphore
   ! mechanism - but since this function currently is unused, you should not touch
   ! it, either.
   ---------------------------------------------------------------------------------------- */

ULONG ASM libExtLib (void)
{
 return ( NULL ) ;
}

/* ----------------------------------------------------------------------------------------
   ! __SASC stuff:
   !
   ! This is only for SAS/C - its intention is to turn off internal CTRL-C handling
   ! for standard C functions and to avoid calls to exit() et al.
   ---------------------------------------------------------------------------------------- */

#ifdef __SASC

#ifdef ARK_OLD_STDIO_FIX

ULONG XCEXIT       = NULL; /* These symbols may be referenced by    */
ULONG _XCEXIT      = NULL; /* some functions of sc.lib, but should  */
ULONG ONBREAK      = NULL; /* never be used inside a shared library */
ULONG _ONBREAK     = NULL;
ULONG base         = NULL; /* Note, that XCEXIT/ONBREAK actually    */
ULONG _base        = NULL; /* should have been defined as functions */
ULONG ProgramName  = NULL; /* and not as ULONGs...                  */
ULONG _ProgramName = NULL;
ULONG StackPtr     = NULL;
ULONG _StackPtr    = NULL;
ULONG oserr        = NULL;
ULONG _oserr       = NULL;
ULONG OSERR        = NULL;
ULONG _OSERR       = NULL;

#endif /* ARK_OLD_STDIO_FIX */

void __regargs __chkabort(void) { }  /* a shared library cannot be    */
void __regargs _CXBRK(void)     { }  /* CTRL-C aborted when doing I/O */

#endif /* __SASC */
