/* TuComposer OS independent code
**
** $VER: ClearPositionChannel.c 31.22 (29.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG ClearPositionChannel ( struct TuComposerOrders *PosStr,
    unsigned long Channel )
{
  if ( PosStr )
  {
    struct TuComposerOrderList *PosListStr;

    if ( PosStr == TuCBase->tcb_PlaySong->tcso_Position )
    {
      StopTCModule ();
      FreeSoundDevice ( TuCBase->tcb_PlaySoundDeviceBase->sdi_Library.extb_ExtLibList );
    }

    PosStr += Channel;

    PosListStr = (struct TuComposerOrderList *) &(PosStr->tco_OrderData.mlh_Head);

    for (;;)
    {
      PosListStr = (struct TuComposerOrderList *) PosListStr->tcol_Node.mln_Succ;

      if (!( (struct TuComposerOrderList *) PosListStr->tcol_Node.mln_Succ ))
        break;

      FreePositionList ( PosListStr );
    }

    PosStr->tco_Length = 0;
    PosStr->tco_RepStart = 0;
    PosStr->tco_Volume = DEFAULTPOSVOLUME;
    PosStr->tco_SubVol = 0;
    PosStr->tco_TrackPanning = 0;
    PosStr->tco_TrackSubPan = 0;
    PosStr->tco_Panning = DEFAULTPOSPANNING;
    PosStr->tco_SubPan = 0;
    PosStr->tco_CompFlags = 0;
    PosStr->tco_Flags = 0;

    memset ( &(PosStr->tco_Reserved), 0, sizeof ( PosStr->tco_Reserved ));

    return ( 0L );
  }

  return ( ERROR_POSITION_NOGIVEN );
}
