/* TuComposer OS independent code
**
** $VER: DupPositionChannel.c 31.22 (29.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG DupPositionChannel ( struct TuComposerOrders *SrcPosStr,
    struct TuComposerOrders *DestPosStr, unsigned long SrcChannel,
    unsigned long DestChannel )
{
  if ( SrcPosStr )
  {
    struct TuComposerOrderList *PosListBuf;
    struct TuComposerOrderList *PosListStr;
    struct TuComposerOrderList *NextPosList;
    struct TuComposerOrderList *ReMapPosList;
    ULONG NumReMap, i;

    if (!( DestPosStr ))
      DestPosStr = SrcPosStr;

    if ( DestPosStr == SrcPosStr )
    {
      if ( SrcChannel == DestChannel )
        return ( 0L );
    }

    SrcPosStr += SrcChannel;
    DestPosStr += DestChannel;

    ClearPositionChannel ( DestPosStr, 0L );

    PosListBuf = (struct TuComposerOrderList *) &(SrcPosStr->tco_OrderData.mlh_Head);

    for (;;)
    {
      PosListBuf = (struct TuComposerOrderList *) PosListBuf->tcol_Node.mln_Succ;

      if (!( PosListBuf->tcol_Node.mln_Succ ))
        break;

      if (!( PosListStr = DupPositionList ( PosListBuf )))
        return ( ERROR_POSITION_NOMEM );

      AddPositionList ( DestPosStr, PosListStr, 0L );
    }

    PosListStr = (struct TuComposerOrderList *) &(SrcPosStr->tco_OrderData.mlh_Head);
    PosListBuf = (struct TuComposerOrderList *) &(DestPosStr->tco_OrderData.mlh_Head);

    for (;;)
    {
      PosListStr = (struct TuComposerOrderList *) PosListStr->tcol_Node.mln_Succ;

      if (!( PosListStr->tcol_Node.mln_Succ ))
        break;

      PosListBuf = (struct TuComposerOrderList *) PosListBuf->tcol_Node.mln_Succ;

      if ( ( NextPosList = PosListStr->tcol_NextPos ))
      {
        NumReMap = 0L;
        ReMapPosList = (struct TuComposerOrderList *) &(SrcPosStr->tco_OrderData.mlh_Head);

        for (;;)
        {
          NumReMap++;
          ReMapPosList = (struct TuComposerOrderList *) ReMapPosList->tcol_Node.mln_Succ;

          if ( ReMapPosList == NextPosList )
            break;
        }

        ReMapPosList = (struct TuComposerOrderList *) &(DestPosStr->tco_OrderData.mlh_Head);

        for (i = NumReMap; i > 0; i--)
          ReMapPosList = (struct TuComposerOrderList *) ReMapPosList->tcol_Node.mln_Succ;

        PosListBuf->tcol_NextPos = ReMapPosList;
      }

      if ( ( NextPosList = PosListStr->tcol_PrevPos ))
      {
        NumReMap = 0L;
        ReMapPosList = (struct TuComposerOrderList *) &(SrcPosStr->tco_OrderData.mlh_Head);

        for (;;)
        {
          NumReMap++;
          ReMapPosList = (struct TuComposerOrderList *) ReMapPosList->tcol_Node.mln_Succ;

          if ( ReMapPosList == NextPosList )
            break;
        }

        ReMapPosList = (struct TuComposerOrderList *) &(DestPosStr->tco_OrderData.mlh_Head);

        for (i = NumReMap; i > 0; i--)
          ReMapPosList = (struct TuComposerOrderList *) ReMapPosList->tcol_Node.mln_Succ;

        PosListBuf->tcol_PrevPos = ReMapPosList;
      }
    }

    memcpy ( &(DestPosStr->tco_Length), &(SrcPosStr->tco_Length), sizeof (struct TuComposerOrders) - offsetof (struct TuComposerOrders, tco_Length ));

    return ( 0L );
  }

  return ( ERROR_POSITION_NOGIVEN );
}
