/* TuComposer OS independent code
**
** $VER: FreePositionList.c 31.22 (29.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG FreePositionList ( struct TuComposerOrderList *PosListStr )
{
  if ( PosListStr )
  {
    struct TuComposerSong *SongStr;

    if ( PosListStr->tcol_Node.mln_Succ )
      DeletePositionList ( PosListStr );

    if ( (SongStr = TuCBase->tcb_PlaySong) )
    {
      struct PlayerHostChannel *PHCStr = SongStr->tcso_ChannelData;
      ULONG i;

      Disable ();

      for (i = SongStr->tcso_Channels; i > 0; i--)
      {
        if ( PHCStr->phc_Order == PosListStr )
        {
          struct TuComposerOrderList *PosListBuf = (struct TuComposerOrderList *) PosListStr->tcol_Node.mln_Succ;

          if ( PosListBuf->tcol_Node.mln_Succ )
          {
            PHCStr->phc_Order = PosListBuf;
          } else
          {
            PosListBuf = (struct TuComposerOrderList *) PosListStr->tcol_Node.mln_Pred;

            if ( PosListBuf->tcol_Node.mln_Pred )
            {
              PHCStr->phc_Order = PosListBuf;
            } else
            {
              PHCStr->phc_Order = NULL;
            }
          }
        }

        PHCStr++;
      }

      Enable ();
    }

    FreePMem ( PosListStr, sizeof (struct TuComposerOrderList ));

    return ( 0L );
  }

  return ( ERROR_POSLIST_NOGIVEN );
}
