/* TuComposer OS independent code
**
** $VER: PlayPosition.c 31.22 (11.8.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

extern struct TuComposerBase *TuCBase;
extern struct SoundDeviceInfo *InternalSoundDeviceBase;

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

ULONG PlayPosition ( struct TuComposerOrders *PosStr,
    union FlagPass *FlagPassStr, unsigned long Order,
    unsigned long Row )
{
  if ( PosStr )
  {
    if ( TuCBase->tcb_PlayModule )
    {
      struct TuComposerSong *SongStr;

      if ( (SongStr = TuCBase->tcb_PlaySong) )
      {
        struct PlayerGlobals *PGStr = SongStr->tcso_GlobalData;
        struct PlayerHostChannel *PHCStr = SongStr->tcso_ChannelData;
        struct SoundDeviceInfo *ExtDeviceLibBase;
        ULONG i;

        if (!( ExtDeviceLibBase = TuCBase->tcb_PlaySoundDeviceBase ))
          ExtDeviceLibBase = (struct SoundDeviceInfo *) &(InternalSoundDeviceBase);

        TuCBase->tcb_PlaySoundDeviceBase = ExtDeviceLibBase;

        Order++;

        Disable ();

        for (i = 0; i < SongStr->tcso_Channels; i++)
        {
          struct TuComposerOrderList *PosListStr = GetPositionAddr ( PosStr, i, Order );

          if ( PosListStr )
          {
            PHCStr->phc_Flags |= PHCF_SetInstr|PHCF_SetSample;

            PHCStr->phc_Instrument = (struct TuComposerInstr *) PosListStr->tcol_Track;
            *(ULONG *) &(PHCStr->phc_Sample) = Row;
          }

          PHCStr++;
        }

        if ( (!( PGStr->pg_PlayType & PTYPF_Song )) && (!( PGStr->pg_Flags & PGF_PlayPattern )) )
        {
          Enable ();

          PGStr->pg_Flags |= PGF_NoProcPattern;

          return ( PlaySoundDevice ( ExtDeviceLibBase->sdi_Library.extb_ExtLibList, TuCBase->tcb_PlayMixerAlloc, FlagPassStr ));
        }

        Enable ();

        return ( 0L );
      }

      return ( ERROR_SONG_NOGIVEN );
    }

    return ( ERROR_MODULE_NOGIVEN );
  }

  return ( ERROR_POSITION_NOGIVEN );
}
