/* TuComposer OS independent code
**
** $VER: SwapPosition.c 31.22 (29.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG SwapPosition ( struct TuComposerOrders *PosStr,
    unsigned long Channel, unsigned long SwapChannel )
{
  if ( PosStr )
  {
    if ( Channel != SwapChannel )
    {
      struct MinList TmpPosList;
      struct MinList SwapPosList;
      struct TuComposerOrders *PosBuf;
      UBYTE *SrcBuf,*DestBuf;
      UBYTE TmpByte;
      ULONG i;

      if ( PosStr == TuCBase->tcb_PlaySong->tcso_Position )
      {
        StopTCModule ();
        FreeSoundDevice ( TuCBase->tcb_PlaySoundDeviceBase->sdi_Library.extb_ExtLibList );
      }

      PosBuf = PosStr + SwapChannel;
      PosStr += Channel;

      TmpPosList = PosBuf->tco_OrderData;

      ReMapNodeList ( (struct List *) &(PosStr->tco_OrderData), (struct List *) &(PosBuf->tco_OrderData));

      SwapPosList = PosBuf->tco_OrderData;
      PosBuf->tco_OrderData = TmpPosList;

      ReMapNodeList ( (struct List *) &(PosBuf->tco_OrderData), (struct List *) &(PosStr->tco_OrderData));

      PosBuf->tco_OrderData = SwapPosList;

      SrcBuf = (UBYTE *) &(PosStr->tco_Length);
      DestBuf = (UBYTE *) &(PosBuf->tco_Length);

      for (i = (sizeof (struct TuComposerOrders) - offsetof (struct TuComposerOrders, tco_Length)); i > 0; i--)
      {
        TmpByte = *DestBuf;
        *DestBuf++ = *SrcBuf;
        *SrcBuf++ = TmpByte;
      }
    }

    return ( 0L );
  }

  return ( ERROR_POSITION_NOGIVEN );
}
