/* TuComposer OS independent code
**
** $VER: AddSampleData.c 31.22 (21.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG AddSampleData ( struct TuComposerSample *SampleStr,
    unsigned long NumSamples )
{
  if ( SampleStr )
  {
    ULONG NewSamples, NewBuffers, Buffers;
    WORD *SampleData;
    WORD *NewSampleData;

    NewSamples = NumSamples + SampleStr->tcs_Samples;

    if ( NewSamples < SampleStr->tcs_Samples )
      return ( ERROR_SAMPLE_TOOBIG );

    NewBuffers = (( NewSamples * SampleStr->tcs_BitDepth) + SMP_BLOCKMASK) / SMP_BLOCKSIZE;

    if ( SampleStr->tcs_Flags & TCSF_Redirect )
    {
      struct TuComposerSample *OrigSampleStr = FindOriginSample ( SampleStr );

      if ( NewSamples > OrigSampleStr->tcs_Samples )
        NewSamples = OrigSampleStr->tcs_Samples;

      NewBuffers = (( NewSamples * SampleStr->tcs_BitDepth) + SMP_BLOCKMASK) / SMP_BLOCKSIZE;

      SampleStr->tcs_Samples = NewSamples;
      SampleStr->tcs_Length = NewBuffers;

      return ( 0L );
    } else
    {
      if ( (NewSampleData = (WORD *) AllocSampleData ( NewBuffers )))
      {
        Buffers = (SampleStr->tcs_Length + SMP_BLOCKMASK) / SMP_BLOCKSIZE;

        if ( Buffers )
        {
          if ( (SampleData = SampleStr->tcs_Data ))
          {
            memcpy ( NewSampleData, SampleData, Buffers << 3 );

            FreeSampleData ( SampleData, SampleStr->tcs_Length );
          }
        }

        SampleStr->tcs_Data = NewSampleData;
        SampleStr->tcs_Samples = NewSamples;
        SampleStr->tcs_Length = NewBuffers;

        return ( 0L );
      }

      return ( ERROR_SAMPLE_NOMEM );
    }
  }

  return ( ERROR_SAMPLE_NOGIVEN );
}
