/* TuComposer OS independent code
**
** $VER: CalcLinearFrequency.c 31.22 (22.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG CalcLinearFrequency ( unsigned long SampleFreq, long SlideValue )
{
  LONG SlideValueMul, SlideValueMod;
  unsigned long long LinearVal = 0x10000LL;

  SlideValueMul = SlideValue / 3072;
  SlideValueMod = SlideValue % 3072;

  if ( (SlideValueMul < 0) || (SlideValueMod < 0) )
  {
    SlideValueMul = -SlideValueMul;

    if ( SlideValueMod == 0L )
      LinearVal += LinearVal;

    SlideValueMod += 3072;

    LinearVal += TuCBase->tcb_LinearFreqTable[SlideValueMod];
    LinearVal *= SampleFreq;
    LinearVal >>= (17 + (ULONG) SlideValueMul);
  } else
  {
    LinearVal += TuCBase->tcb_LinearFreqTable[SlideValueMod];
    LinearVal <<= SlideValueMul;
    LinearVal *= SampleFreq;
    LinearVal >>= 16;
  }

  return ( LinearVal );
}
