/* TuComposer OS independent code
**
** $VER: CalcSamplePlayFreq.c 31.22 (4.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG CalcSamplePlayFreq ( struct TuComposerSample *SampleStr,
    unsigned long Octave, unsigned long Note )
{
  unsigned long long Frequency = 0LL;

  if ( SampleStr )
  {
    ULONG *FreqTable;
    WORD FineTune;
    ULONG IndexNote, TmpFreq;

    IndexNote = NoteToIndex ( Octave, Note ) + SampleStr->tcs_Transpose;

    Octave = (LONG) IndexNote / 12;
    Note = (LONG) IndexNote % 12;

    if ( Note < 0 )
    {
      Octave--;
      Note += 12;
    }

    if ( (FineTune = SampleStr->tcs_FineTune ) < 0 )
    {
      FineTune += 0x80;
      Note--;
    }

    FreqTable = &(TuCBase->tcb_FrequencyTable[Note]);

    TmpFreq = *FreqTable++;
    Frequency = TmpFreq + ( (LONG) (*FreqTable - TmpFreq) * (LONG) FineTune >> 7);

    TmpFreq = 0x10000;

    if ( (LONG) (Octave -= 4) < 0 )
    {
      Frequency *= SampleStr->tcs_Rate;
      Frequency /= TmpFreq << -Octave;
    } else
    {
      Frequency <<= Octave;
      Frequency *= SampleStr->tcs_Rate;
      Frequency /= TmpFreq;
    }
  }

  return ( Frequency );
}
