/* TuComposer OS independent code
**
** $VER: ClearSample.c 31.22 (4.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ClearSample ( struct TuComposerSample *SampleStr )
{
  if ( SampleStr )
  {
    struct UnknownChunk *UnknownChunkStr;
    struct UnknownChunk *FreeUnkChunk;
    WORD *SampleData;
    ULONG SampleLen;

    if ( ((SampleStr->tcs_Flags & TCSF_Redirect) == 0) && (SampleLen = SampleStr->tcs_Length) && (SampleData = SampleStr->tcs_Data ))
      FreePMem ( SampleData, SampleLen );

    ClearSynth ( SampleStr->tcs_Synth );

    FreeNameStr ( SampleStr->tcs_FileName );
    FreeNameStr ( SampleStr->tcs_Name );

    memset ( &(SampleStr->tcs_FileName), 0, offsetof (struct TuComposerSample, tcs_AutoVibratoEnv ) - offsetof (struct TuComposerSample, tcs_FileName ));

    SampleStr->tcs_BitDepth = DEFAULTSAMPLEBITDEPTH;
    SampleStr->tcs_Rate = DEFAULTSAMPLERATE;
    SampleStr->tcs_GlobalVolume = DEFAULTSAMPLEVOLUME;
    SampleStr->tcs_Volume = DEFAULTSAMPLEVOLUME;
    SampleStr->tcs_Panning = DEFAULTSAMPLEPANNING;

    InitNodeList ( (struct List *) &(SampleStr->tcs_AutoVibratoEnv ));
    InitNodeList ( (struct List *) &(SampleStr->tcs_AutoTremoloEnv ));
    InitNodeList ( (struct List *) &(SampleStr->tcs_AutoPannoloEnv ));

    memset ( &(SampleStr->tcs_EnvUsageFlags), 0, offsetof (struct TuComposerSample, tcs_UnknownChunks ) - offsetof (struct TuComposerSample, tcs_EnvUsageFlags ));

    UnknownChunkStr = (struct UnknownChunk *) &(SampleStr->tcs_UnknownChunks.mlh_Head);

    for (;;)
    {
      FreeUnkChunk = (struct UnknownChunk *) UnknownChunkStr->uc_Node.mln_Succ;

      if (!( (struct UnknownChunk *) FreeUnkChunk->uc_Node.mln_Succ ))
        break;

      FreeUnknownChunk ( FreeUnkChunk );
    }

    return ( 0L );
  }

  return ( ERROR_SAMPLE_NOGIVEN );
}
