/* TuComposer OS independent code
**
** $VER: CmpSamples.c 31.22 (10.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

LONG CmpSamples ( struct TuComposerSample *SrcSampleStr,
    struct TuComposerSample *DestSampleStr )
{
  if ( SrcSampleStr && DestSampleStr )
  {
    if ( SrcSampleStr == DestSampleStr )
      goto SamplesEqual;

    if ( SrcSampleStr->tcs_FileName != DestSampleStr->tcs_FileName )
    {
      if ( (SrcSampleStr->tcs_FileName == NULL) || (DestSampleStr->tcs_FileName == NULL) )
        goto SamplesNotEqual;

      if ( strcmp ( SrcSampleStr->tcs_FileName, DestSampleStr->tcs_FileName ))
        goto SamplesNotEqual;
    }

    if ( SrcSampleStr->tcs_Name != DestSampleStr->tcs_Name )
    {
      if ( (SrcSampleStr->tcs_Name == NULL) || (DestSampleStr->tcs_Name == NULL) )
        goto SamplesNotEqual;

      if ( strcmp ( SrcSampleStr->tcs_Name, DestSampleStr->tcs_Name ))
        goto SamplesNotEqual;
    }

    if ( memcmp ( &(SrcSampleStr->tcs_Length), &(DestSampleStr->tcs_Length), offsetof (struct TuComposerSample, tcs_AutoVibratoEnv) - offsetof (struct TuComposerSample, tcs_Length )))
      goto SamplesNotEqual;

    if ( memcmp ( &(SrcSampleStr->tcs_EnvUsageFlags), &(DestSampleStr->tcs_EnvUsageFlags), offsetof (struct TuComposerSample, tcs_UnknownChunks) - offsetof (struct TuComposerSample, tcs_EnvUsageFlags )))
      goto SamplesNotEqual;

    if ( SrcSampleStr->tcs_Data != DestSampleStr->tcs_Data )
    {
      if ( ( SrcSampleStr->tcs_Data == NULL) || ( DestSampleStr->tcs_Data == NULL) )
        goto SamplesNotEqual;

      if ( memcmp ( SrcSampleStr->tcs_Data, DestSampleStr->tcs_Data, SrcSampleStr->tcs_Length ))
        goto SamplesNotEqual;
    }

    if ( SrcSampleStr->tcs_AutoVibratoEnv != DestSampleStr->tcs_AutoVibratoEnv )
    {
      if ( ( SrcSampleStr->tcs_AutoVibratoEnv == NULL) || ( DestSampleStr->tcs_AutoVibratoEnv == NULL) )
        goto SamplesNotEqual;

      if ( (CmpEnvelopes ( SrcSampleStr->tcs_AutoVibratoEnv, DestSampleStr->tcs_AutoVibratoEnv )))
        goto SamplesNotEqual;
    }

    if ( SrcSampleStr->tcs_AutoTremoloEnv != DestSampleStr->tcs_AutoTremoloEnv )
    {
      if ( ( SrcSampleStr->tcs_AutoTremoloEnv == NULL) || ( DestSampleStr->tcs_AutoTremoloEnv == NULL) )
        goto SamplesNotEqual;

      if ( (CmpEnvelopes ( SrcSampleStr->tcs_AutoTremoloEnv, DestSampleStr->tcs_AutoTremoloEnv )))
        goto SamplesNotEqual;
    }

    if ( SrcSampleStr->tcs_AutoPannoloEnv != DestSampleStr->tcs_AutoPannoloEnv )
    {
      if ( ( SrcSampleStr->tcs_AutoPannoloEnv == NULL) || ( DestSampleStr->tcs_AutoPannoloEnv == NULL) )
        goto SamplesNotEqual;

      if ( (CmpEnvelopes ( SrcSampleStr->tcs_AutoPannoloEnv, DestSampleStr->tcs_AutoPannoloEnv )))
        goto SamplesNotEqual;
    }

    if ( SrcSampleStr->tcs_Synth != DestSampleStr->tcs_Synth )
    {
      if ( ( SrcSampleStr->tcs_Synth == NULL) || ( DestSampleStr->tcs_Synth == NULL) )
        goto SamplesNotEqual;

      if ( (CmpSynths ( SrcSampleStr->tcs_Synth, DestSampleStr->tcs_Synth )))
        goto SamplesNotEqual;
    }

SamplesEqual:
    return ( 0L );

SamplesNotEqual:
    return ( 1L );

  }

  return ( ERROR_SAMPLE_NOGIVEN );
}
