/* TuComposer OS independent code
**
** $VER: CutSampleData.c 31.22 (27.4.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

#ifdef __cplusplus
extern "C" {
#endif

void CopySampleDataX ( LONG *SampleData, LONG *NewSampleData, ULONG SrcSamplePos, ULONG DestSamplePos, ULONG NumSamples, UBYTE BitDepth );

#ifdef __cplusplus
}
#endif

struct TuComposerSample *DoDupSample ( struct TuComposerSample *SampleStr, struct TuComposerSample *CloneSample );

extern struct TuComposerBase *TuCBase;

struct TuComposerSample *CutSampleData ( struct TuComposerSample *SampleStr,
    struct TuComposerSample *SampleBuf,
    unsigned long FirstSmp, unsigned long LastSmp )
{
  struct TuComposerSample *SampleGiven = SampleBuf;
  ULONG SmpSize;

  if ( FirstSmp >= SampleStr->tcs_Samples )
    FirstSmp = SampleStr->tcs_Samples - 1;

  if ( LastSmp >= SampleStr->tcs_Samples )
    LastSmp = SampleStr->tcs_Samples - 1;

  if ( FirstSmp > LastSmp )
  {
    ULONG TmpSmp = FirstSmp;

    FirstSmp = LastSmp;
    LastSmp = TmpSmp;
  }

  SmpSize = (LastSmp - FirstSmp) + 1;

  if (!( SampleBuf ))
    SampleBuf = PushSample ( SampleStr );

  if ( SampleBuf )
  {
    ObtainSemaphore ( TuCBase->tcb_SampleSigSem );

    if (!( ReSizeSample ( SampleBuf, SmpSize )))
    {
      ClearSample ( SampleBuf );

      if (!( SampleBuf = DoDupSample ( SampleStr, SampleBuf )))
        goto CutSampleDataErr;

      switch ( SampleStr->tcs_BitDepth )
      {
        case 8 :
        {
          memcpy ( (BYTE *) SampleBuf->tcs_Data, (BYTE *) SampleStr->tcs_Data + FirstSmp, SmpSize );

          break;
        }
        case 16 :
        {
          memcpy ( SampleBuf->tcs_Data, SampleStr->tcs_Data + FirstSmp, SmpSize * sizeof (WORD));

          break;
        }
        case 32 :
        {
          memcpy ( (LONG *) SampleBuf->tcs_Data, (LONG *) SampleStr->tcs_Data + FirstSmp, SmpSize * sizeof (LONG));

          break;
        }
        default :
        {
          CopySampleDataX ( (LONG *) SampleStr->tcs_Data, (LONG *) SampleBuf->tcs_Data, FirstSmp, 0L, SmpSize, SampleStr->tcs_BitDepth );

          break;
        }
      }

      if ( DeleteSampleData ( SampleStr, FirstSmp, SmpSize ))
        goto CutSampleDataErr;

      ReleaseSemaphore ( TuCBase->tcb_SampleSigSem );

      return ( SampleBuf );
    }

CutSampleDataErr:

    if (!( SampleGiven ))
      PopSample ( SampleBuf );

    ReleaseSemaphore ( TuCBase->tcb_SampleSigSem );

    return ( NULL );
  }
}
