/* TuComposer OS independent code
**
** $VER: DecrunchSample.c 31.22 (25.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

#ifdef __cplusplus
extern "C" {
#endif

void DecrunchSample8 ( BYTE *SampleData, ULONG Length );
void DecrunchSample16 ( WORD *SampleData, ULONG Length );
void DecrunchSample32 ( LONG *SampleData, ULONG Length );
void DecrunchSampleX ( LONG *SampleData, ULONG Samples, UBYTE BitDepth );

#ifdef __cplusplus
}
#endif

ULONG DecrunchSample ( struct TuComposerSample *SampleStr,
    unsigned long DeltaBitDepth )
{
  if ( SampleStr = FindOriginSample ( SampleStr ))
  {
    WORD *SampleData;

    if ( (SampleData = SampleStr->tcs_Data ))
    {
      ULONG Length;

      if ( DeltaBitDepth == 0L )
        DeltaBitDepth = SampleStr->tcs_BitDepth;

      Length = (SampleStr->tcs_Length + SMP_BLOCKMASK) / SMP_BLOCKSIZE;

      switch ( DeltaBitDepth )
      {
        case 8 :
        {
          DecrunchSample8 ( (BYTE *) SampleData, Length );

          break;
        }
        case 16 :
        {
          DecrunchSample16 ( SampleData, Length );

          break;
        }
        case 32 :
        {
          DecrunchSample32 ( (LONG *) SampleData, Length );

          break;
        }
        default :
        {
          DecrunchSampleX ( (LONG *) SampleData, SampleStr->tcs_Samples, DeltaBitDepth );

          break;
        }
      }

      return ( 0L );
    }

    return ( ERROR_SAMPLE_NODATA );
  }

  return ( ERROR_SAMPLE_NOGIVEN );
}

void DecrunchSample8 ( BYTE *SampleData, ULONG Length )
{
  ULONG i;
  BYTE Sample = 0;

  for (i = Length; i > 0; i--)
  {
    Sample += *SampleData;
    *SampleData++ = Sample;
    Sample += *SampleData;
    *SampleData++ = Sample;
    Sample += *SampleData;
    *SampleData++ = Sample;
    Sample += *SampleData;
    *SampleData++ = Sample;
    Sample += *SampleData;
    *SampleData++ = Sample;
    Sample += *SampleData;
    *SampleData++ = Sample;
    Sample += *SampleData;
    *SampleData++ = Sample;
    Sample += *SampleData;
    *SampleData++ = Sample;
  }
}

void DecrunchSample16 ( WORD *SampleData, ULONG Length )
{
  ULONG i;
  WORD Sample = 0;

  for (i = Length; i > 0; i--)
  {
    Sample += *SampleData;
    *SampleData++ = Sample;
    Sample += *SampleData;
    *SampleData++ = Sample;
    Sample += *SampleData;
    *SampleData++ = Sample;
    Sample += *SampleData;
    *SampleData++ = Sample;
  }
}

void DecrunchSample32 ( LONG *SampleData, ULONG Length )
{
  ULONG i;
  LONG Sample = 0;

  for (i = Length; i > 0; i--)
  {
    Sample += *SampleData;
    *SampleData++ = Sample;
    Sample += *SampleData;
    *SampleData++ = Sample;
  }
}

void DecrunchSampleX ( LONG *SampleData, ULONG Samples, UBYTE BitDepth )
{
  ULONG i, Bit = 0L;
  ULONG Sample = 0L, TmpSample;

  for (i = Samples; i > 0; i--)
  {
    if ( (Bit + BitDepth) < 32 )
    {
      TmpSample = (*SampleData << Bit) & ~((1UL << (32UL - BitDepth)) - 1UL);
    } else
    {
      TmpSample = *SampleData << Bit;
      TmpSample |= (*(SampleData + 1) & ~((1UL << (64UL - (Bit + BitDepth))) - 1UL)) >> (32UL - Bit);
    }

    Sample += TmpSample;

    TmpSample = Sample;
    TmpSample &= ~((1UL << (32UL - BitDepth)) - 1UL );

    if ( (Bit + BitDepth) < 32 )
    {
      *SampleData &= ~((1UL << (32UL - Bit)) - (1UL << (32UL - BitDepth - Bit)));
      *SampleData |= (TmpSample >> Bit);
    } else
    {
      *SampleData &= ~((1UL << (32UL - Bit)) - 1UL);
      *SampleData |= (TmpSample >> Bit);
      SampleData++;
      *SampleData &= ((1UL << (64UL - (Bit + BitDepth))) - 1UL);
      *SampleData |= (TmpSample << (32UL - Bit));

      Bit -= 32;
    }

    Bit += BitDepth;
  }
}
