/* TuComposer OS independent code
**
** $VER: DeleteSample.c 31.22 (25.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG DeleteSample ( struct TuComposerSample *SampleStr )
{
  if ( SampleStr )
  {
    struct TuComposerModule *ModuleStr;
    struct TuComposerInstr *InstrStr;
    struct TuComposerInstr *InstrScan;
    struct TuComposerInstrKeyboard *KeybrdStr;
    ULONG NumSample;

    if ( SampleStr->tcs_Node.mln_Succ )
    {
      InstrStr = (struct TuComposerInstr *) &(SampleStr->tcs_Node.mln_Succ);

      for (;;)
      {
        InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Pred;

        if (!( InstrStr->tci_Node.mln_Pred ))
          break;
      }

      (UBYTE *) InstrStr += -offsetof (struct TuComposerInstr, tci_Samples );

      InstrStr->tci_NumSamples--;

      if ( InstrStr->tci_Node.mln_Succ )
      {
        ModuleStr = (struct TuComposerModule *) &(InstrStr->tci_Node.mln_Succ);

        for (;;)
        {
          ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

          if (!( ModuleStr->tcm_Node.mln_Pred ))
            break;
        }

        (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_InstrList );

        NumSample = GetSampleNum ( InstrStr, SampleStr );

        InstrScan = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head );

        for (;;)
        {
          InstrScan = (struct TuComposerInstr *) InstrScan->tci_Node.mln_Succ;

          if (!( InstrScan->tci_Node.mln_Succ ))
            break;

          if (!( InstrScan->tci_CompFlags & TCICF_SeparateSamples ))
          {
            KeybrdStr = InstrScan->tci_KeyboardDefs;

            if ( KeybrdStr )
            {
              struct KeyboardEntry *KeybrdEntry = (struct KeyboardEntry *) &(KeybrdStr->tcik_NoteEntry[0]);
              ULONG i;

              if (!( KeybrdEntry->tcik_Octave_C_0 & 0x80 ))
              {
                KeybrdEntry->tcik_Octave_C_0 |= 0x80;

                for (i = (NUMOCTAVES * NUMNOTES); i > 0; i--)
                {
                  if ( KeybrdEntry->tcik_Sample_C_0 > NumSample )
                    KeybrdEntry->tcik_Sample_C_0--;

                  KeybrdEntry++;
                }
              }
            }
          }
        }

        KeybrdStr = (struct TuComposerInstrKeyboard *) &(ModuleStr->tcm_KeyboardDefs.mlh_Head);

        for (;;)
        {
          KeybrdStr = (struct TuComposerInstrKeyboard *) KeybrdStr->tcik_Node.mln_Succ;

          if (!( KeybrdStr->tcik_Node.mln_Succ ))
            break;

          KeybrdStr->tcik_NoteEntry[0].tcik_Octave_C_0 &= 0x7F;
        }
      }
    }

    RemoveNode ( (struct Node *) SampleStr );

    SampleStr->tcs_Node.mln_Succ = NULL;
    SampleStr->tcs_Node.mln_Pred = NULL;

    return ( 0L );
  }

  return ( ERROR_SAMPLE_NOGIVEN );
}
