/* TuComposer OS independent code
**
** $VER: DeleteSampleData.c 31.22 (24.4.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

#ifdef __cplusplus
extern "C" {
#endif

void DeleteSampleDataX ( LONG *SampleData, LONG *NewSampleData, ULONG NewSamples, ULONG SamplePos, ULONG NumSamples, UBYTE BitDepth );

#ifdef __cplusplus
}
#endif

ULONG DeleteSampleData ( struct TuComposerSample *SampleStr,
    unsigned long SamplePos, unsigned long NumSamples )
{
  if ( SampleStr )
  {
    ULONG SmpLen = SampleStr->tcs_Samples, NewSamples, NewBuffers, Repeat;
    ULONG CopyDestNum;
    WORD *SampleData;
    WORD *NewSampleData;

    if ( SamplePos >= SmpLen )
      return ( 0L );

    NumSamples = ((NumSamples + SamplePos) < SmpLen ? NumSamples : SmpLen - SamplePos);
    CopyDestNum = (SamplePos + NumSamples);

    NewSamples = ( CopyDestNum < SmpLen ? SmpLen - NumSamples : SamplePos );

    if ( NewSamples )
    {
      NewBuffers = (( NewSamples * SampleStr->tcs_BitDepth) + SMP_BLOCKMASK) / SMP_BLOCKSIZE;

      if ( NewBuffers )
      {
        if ( SampleStr->tcs_Flags & TCSF_Redirect )
        {
          SampleStr->tcs_Samples = NewSamples;
          SampleStr->tcs_Length = NewBuffers;

          Repeat = SampleStr->tcs_Repeat;

          if ( Repeat >= NewSamples )
          {
            Repeat = NewSamples - 1;
            SampleStr->tcs_Repeat = Repeat;
          }

          Repeat += SampleStr->tcs_RepLen;

          if ( Repeat > NewSamples )
          {
            Repeat = NewSamples - SampleStr->tcs_Repeat;
            SampleStr->tcs_RepLen = Repeat;
          }

          Repeat = SampleStr->tcs_SustainRepeat;

          if ( Repeat >= NewSamples )
          {
            Repeat = NewSamples - 1;
            SampleStr->tcs_SustainRepeat = Repeat;
          }

          Repeat += SampleStr->tcs_SustainRepLen;

          if ( Repeat > NewSamples )
          {
            Repeat = NewSamples - SampleStr->tcs_SustainRepeat;
            SampleStr->tcs_SustainRepLen = Repeat;
          }
        } else
        {
          if ( (NewSampleData = (WORD *) AllocSampleData ( NewBuffers )))
          {
            struct TuComposerModule *ModuleStr;
            struct TuComposerInstr *InstrStr;
            struct TuComposerSample *OrigSampleStr;
            WORD *SrcTmpData = SampleData;
            WORD *CopyTmpData = NewSampleData;
            ULONG OldLength;

            OldLength = SampleStr->tcs_Length;
            SampleData = SampleStr->tcs_Data;

            switch ( SampleStr->tcs_BitDepth )
            {
              case 8 :
              {
                if ( SamplePos )
                {
                  memcpy ( (BYTE *) CopyTmpData, (BYTE *) SrcTmpData, SamplePos );

                  (BYTE *) SrcTmpData += SamplePos;
                  (BYTE *) CopyTmpData += SamplePos;
                }

                memcpy ( (BYTE *) CopyTmpData, (BYTE *) SrcTmpData + NumSamples, ((SmpLen - SamplePos) - NumSamples));

                break;
              }
              case 16 :
              {
                if ( SamplePos )
                {
                  memcpy ( CopyTmpData, SrcTmpData, SamplePos * sizeof (WORD));

                  SrcTmpData += SamplePos;
                  CopyTmpData += SamplePos;
                }

                memcpy ( CopyTmpData, SrcTmpData + NumSamples, ((SmpLen - SamplePos) - NumSamples) * sizeof (WORD));

                break;
              }
              case 32 :
              {
                if ( SamplePos )
                {
                  memcpy ( (LONG *) CopyTmpData, (LONG *) SrcTmpData, SamplePos * sizeof (LONG));

                  (LONG *) SrcTmpData += SamplePos;
                  (LONG *) CopyTmpData += SamplePos;
                }

                memcpy ( (LONG *) CopyTmpData, (LONG *) SrcTmpData + NumSamples, ((SmpLen - SamplePos) - NumSamples) * sizeof (LONG));

                break;
              }
              default :
              {
                DeleteSampleDataX ( (LONG *) SrcTmpData, (LONG *) CopyTmpData, SmpLen, SamplePos, NumSamples, SampleStr->tcs_BitDepth );

                break;
              }
            }

            SampleStr->tcs_Data = NewSampleData;
            SampleStr->tcs_Samples = NewSamples;
            SampleStr->tcs_Length = NewBuffers;

            Repeat = SampleStr->tcs_Repeat;

            if ( Repeat >= NewSamples )
            {
              Repeat = NewSamples - 1;
              SampleStr->tcs_Repeat = Repeat;
            }

            Repeat += SampleStr->tcs_RepLen;

            if ( Repeat > NewSamples )
            {
              Repeat = NewSamples - SampleStr->tcs_Repeat;
              SampleStr->tcs_RepLen = Repeat;
            }

            Repeat = SampleStr->tcs_SustainRepeat;

            if ( Repeat >= NewSamples )
            {
              Repeat = NewSamples - 1;
              SampleStr->tcs_SustainRepeat = Repeat;
            }

            Repeat += SampleStr->tcs_SustainRepLen;

            if ( Repeat > NewSamples )
            {
              Repeat = NewSamples - SampleStr->tcs_SustainRepeat;
              SampleStr->tcs_SustainRepLen = Repeat;
            }

            if ( SampleStr->tcs_Node.mln_Succ )
            {
              InstrStr = (struct TuComposerInstr *) &(SampleStr->tcs_Node.mln_Succ);

              for (;;)
              {
                InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Pred;

                if (!( InstrStr->tci_Node.mln_Pred ))
                  break;
              }

              (UBYTE *) InstrStr += -offsetof (struct TuComposerInstr, tci_Samples );

              if ( InstrStr->tci_Node.mln_Succ )
              {
                ModuleStr = (struct TuComposerModule *) &(InstrStr->tci_Node.mln_Succ);

                for (;;)
                {
                  ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

                  if (!( ModuleStr->tcm_Node.mln_Pred ))
                    break;
                }

                (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_InstrList );

                InstrStr = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head);

                for (;;)
                {
                  InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Succ;

                  if (!( InstrStr->tci_Node.mln_Succ ))
                    break;

                  OrigSampleStr = (struct TuComposerSample *) &(InstrStr->tci_Samples.mlh_Head);

                  for (;;)
                  {
                    OrigSampleStr = (struct TuComposerSample *) OrigSampleStr->tcs_Node.mln_Succ;

                    if (!( OrigSampleStr->tcs_Node.mln_Succ ))
                      break;

                    if ( OrigSampleStr->tcs_Flags & TCSF_Redirect )
                      continue;

                    if ( OrigSampleStr->tcs_Data == SampleData )
                    {
                      OrigSampleStr->tcs_Data = NewSampleData;

                      NewSamples = OrigSampleStr->tcs_Samples;

                      if ( NewSamples > SampleStr->tcs_Samples )
                        NewSamples = SampleStr->tcs_Samples;

                      SampleStr->tcs_Samples = NewSamples;
                      SampleStr->tcs_Length = ((NewSamples * SampleStr->tcs_BitDepth) + SMP_BLOCKMASK) / SMP_BLOCKSIZE;

                      Repeat = SampleStr->tcs_Repeat;

                      if ( Repeat >= NewSamples )
                      {
                        Repeat = NewSamples - 1;
                        SampleStr->tcs_Repeat = Repeat;
                      }

                      Repeat += SampleStr->tcs_RepLen;

                      if ( Repeat > NewSamples )
                      {
                        Repeat = NewSamples - SampleStr->tcs_Repeat;
                        SampleStr->tcs_RepLen = Repeat;
                      }

                      Repeat = SampleStr->tcs_SustainRepeat;

                      if ( Repeat >= NewSamples )
                      {
                        Repeat = NewSamples - 1;
                        SampleStr->tcs_SustainRepeat = Repeat;
                      }

                      Repeat += SampleStr->tcs_SustainRepLen;

                      if ( Repeat > NewSamples )
                      {
                        Repeat = NewSamples - SampleStr->tcs_SustainRepeat;
                        SampleStr->tcs_SustainRepLen = Repeat;
                      }
                    }
                  }
                }
              }
            }

            FreeSampleData ( SampleData, OldLength );

            return ( 0L );
          }
        }
      }
    } else
    {
      FreeSampleData ( SampleStr->tcs_Data, SampleStr->tcs_Length );

      memset ( &(SampleStr->tcs_Data), 0, offsetof (struct TuComposerSample, tcs_GlobalVolume ) - offsetof (struct TuComposerSample, tcs_Data ));

      return ( 0L );
    }

    return ( ERROR_SAMPLE_NOMEM );
  }

  return ( ERROR_SAMPLE_NOGIVEN );
}

void DeleteSampleDataX ( LONG *SampleData, LONG *NewSampleData, ULONG NewSamples, ULONG SamplePos, ULONG NumSamples, UBYTE BitDepth )
{
  LONG *SrcSampleData;
  LONG *DestSampleData;
  ULONG i, SrcBit = 0L, DestBit = 0L;
  ULONG Sample = 0L;

  if ( SamplePos )
  {
    SrcSampleData = SampleData;
    DestSampleData = NewSampleData;

    for (i = SamplePos; i > 0; i--)
    {
      if ( (SrcBit + BitDepth) < 32 )
      {
        Sample = (*SrcSampleData << SrcBit) & ~((1UL << (32UL - BitDepth)) - 1UL);
      } else
      {
        Sample = *SrcSampleData++ << SrcBit;
        Sample |= (*SrcSampleData & ~((1UL << (64UL - (SrcBit + BitDepth))) - 1UL)) >> (32 - SrcBit);

        SrcBit -= 32;
      }

      SrcBit += BitDepth;

      Sample &= ~((1UL << (32UL - BitDepth)) - 1UL );

      if ( (DestBit + BitDepth) < 32UL )
      {
        *DestSampleData &= ~((1UL << (32UL - DestBit)) - (1UL << (32UL - BitDepth - DestBit)));
        *DestSampleData |= (Sample >> DestBit);
      } else
      {
        *DestSampleData &= ~((1UL << (32UL - DestBit)) - 1UL);
        *DestSampleData |= (Sample >> DestBit);
        DestSampleData++;
        *DestSampleData &= ((1UL << (64UL - (DestBit + BitDepth))) - 1UL);
        *DestSampleData |= (Sample << (32UL - DestBit));

        DestBit -= 32;
      }

      DestBit += BitDepth;
    }

    Sample = SamplePos;
  }

  SampleData += ((Sample + NumSamples) * BitDepth) / 32;
  NewSampleData += (Sample * BitDepth) / 32;

  SrcBit = ((Sample + NumSamples) * BitDepth) % 32;
  DestBit = (Sample * BitDepth) % 32;

  for (i = ((NewSamples - SamplePos) - NumSamples); i > 0; i--)
  {
    if ( (SrcBit + BitDepth) < 32 )
    {
      Sample = (*SampleData << SrcBit) & ~((1UL << (32UL - BitDepth)) - 1UL);
    } else
    {
      Sample = *SampleData++ << SrcBit;
      Sample |= (*SampleData & ~((1UL << (64UL - (SrcBit + BitDepth))) - 1UL)) >> (32 - SrcBit);

      SrcBit -= 32;
    }

    SrcBit += BitDepth;

    Sample &= ~((1UL << (32UL - BitDepth)) - 1UL );

    if ( (DestBit + BitDepth) < 32UL )
    {
      *NewSampleData &= ~((1UL << (32UL - DestBit)) - (1UL << (32UL - BitDepth - DestBit)));
      *NewSampleData |= (Sample >> DestBit);
    } else
    {
      *NewSampleData &= ~((1UL << (32UL - DestBit)) - 1UL);
      *NewSampleData |= (Sample >> DestBit);
      NewSampleData++;
      *NewSampleData &= ((1UL << (64UL - (DestBit + BitDepth))) - 1UL);
      *NewSampleData |= (Sample << (32UL - DestBit));

      DestBit -= 32;
    }

    DestBit += BitDepth;
  }
}
