/* TuComposer OS independent code
**
** $VER: DupSample.c 31.22 (25.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSample *DoDupSample ( struct TuComposerSample *SampleStr, struct TuComposerSample *CloneSample );

#ifdef __cplusplus
extern "C" {
#endif

#ifndef MOTOROLA
  ULONG ReadMLong ( UBYTE *Buffer );
#else
  #define ReadMLong( Buffer ) (*(ULONG *) (Buffer))
#endif

#ifdef __cplusplus
}
#endif

struct TuComposerSample *DupSample ( struct TuComposerSample *SampleStr )
{
  return ( DoDupSample ( SampleStr, NULL ));
}

struct TuComposerSample *DoDupSample ( struct TuComposerSample *SampleStr, struct TuComposerSample *CloneSample )
{
  struct TuComposerSynth *SynthStr;
  struct UnknownChunk *SampleUnkChunk;
  struct UnknownChunk *CloneUnkChunk;

  if ( SampleStr )
  {
    if (!( CloneSample ))
    {
      if (!( CloneSample = AllocSample ( NULL, SampleStr->tcs_Length )))
        return ( NULL );
    }

    if ( SampleStr->tcs_FileName )
    {
      if (!( SetString ( (STRPTR *) &(CloneSample->tcs_FileName), SampleStr->tcs_FileName )))
        goto DupSampleErr;
    }

    if ( SampleStr->tcs_Name )
    {
      if (!( SetString ( (STRPTR *) &(CloneSample->tcs_Name), SampleStr->tcs_Name )))
        goto DupSampleErr;
    }

    memcpy ( &(CloneSample->tcs_Samples), &(SampleStr->tcs_Samples), offsetof(struct TuComposerSample, tcs_UnknownChunks) - offsetof(struct TuComposerSample, tcs_Samples));

    CloneSample->tcs_Samples &= ~(TCSF_Redirect);

    if ( CloneSample->tcs_Samples < SampleStr->tcs_Samples )
    {
      memcpy ( CloneSample->tcs_Data, SampleStr->tcs_Data, (CloneSample->tcs_Length + SMP_BLOCKMASK) / SMP_BLOCKSIZE );
    } else
    {
      memcpy ( CloneSample->tcs_Data, SampleStr->tcs_Data, (SampleStr->tcs_Length + SMP_BLOCKMASK) / SMP_BLOCKSIZE );
    }

    if ( (SynthStr = SampleStr->tcs_Synth ))
    {
      if (!( CloneSample->tcs_Synth = DupSynth ( SynthStr )))
        goto DupSampleErr;
    }

    SampleUnkChunk = (struct UnknownChunk *) &(SampleStr->tcs_UnknownChunks.mlh_Head);

    for (;;)
    {
      SampleUnkChunk = (struct UnknownChunk *) SampleUnkChunk->uc_Node.mln_Succ;

      if (!( SampleUnkChunk->uc_Node.mln_Succ))
        break;

      if (!( CloneUnkChunk = AllocUnknownChunk ( (APTR) &(SampleUnkChunk->uc_Data), ReadMLong ( (UBYTE *) &(SampleUnkChunk->uc_Identifier[0])), ReadMLong ( (UBYTE *) &(SampleUnkChunk->uc_Length[0])) )))
        goto DupSampleErr;

      AddNodeTail ( (struct List *) &(CloneSample->tcs_UnknownChunks), (struct Node *) CloneUnkChunk );
    }

    return ( CloneSample );

DupSampleErr:
    FreeSample ( CloneSample );
  }

  return ( NULL );
}
