/* TuComposer OS independent code
**
** $VER: FreeSample.c 31.22 (24.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_mixerbase_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG FreeSample ( struct TuComposerSample *SampleStr )
{
  if ( SampleStr )
  {
    struct TuComposerModule *ModuleStr;
    struct TuComposerSong *SongStr;
    struct UnknownChunk *SampleUnkChunk;
    struct UnknownChunk *FreeUnkChunk;

    if ( SampleStr->tcs_Node.mln_Succ )
      DeleteSample ( SampleStr );

    if ( (SongStr = TuCBase->tcb_PlaySong) )
    {
      struct PlayerHostChannel *PHCStr = SongStr->tcso_ChannelData;
      ULONG i;

      Disable ();

      for (i = SongStr->tcso_Channels; i > 0; i--)
      {
        if ( PHCStr->phc_Sample == SampleStr )
          PHCStr->phc_Sample = NULL;

        PHCStr++;
      }

      Enable ();
    }

    if ( (ModuleStr = TuCBase->tcb_PlayModule) )
    {
      struct PlayerChannel *PCStr = ModuleStr->tcm_ChannelData;
      ULONG Channel = 0L, i;

      Disable ();

      for (i = ModuleStr->tcm_Channels; i > 0; i--)
      {
        if ( PCStr->pc_Sample == SampleStr )
        {
          PCStr->pc_Sample = NULL;

          memset ( &(PCStr->pc_ChannelData), 0, sizeof (struct MixerStruct));

          ExternalMixerSetChannelPosRepFlagsBase ( TuCBase->tcb_PlayMixerAlloc, (struct MixerStruct *) &(PCStr->pc_ChannelData), Channel, TuCBase->tcb_PlayMixerAlloc->mas_MixLibBase );
        }

        Channel++;
        PCStr++;
      }

      Enable ();
    }


    FreeNameStr ( SampleStr->tcs_FileName );
    FreeNameStr ( SampleStr->tcs_Name );

    FreeSynth ( SampleStr->tcs_Synth );

    FreeSampleData ( SampleStr->tcs_Data, SampleStr->tcs_Length );

    SampleUnkChunk = (struct UnknownChunk *) &(SampleStr->tcs_UnknownChunks.mlh_Head);

    for (;;)
    {
      FreeUnkChunk = (struct UnknownChunk *) SampleUnkChunk->uc_Node.mln_Succ;
      if (!( (struct UnknownChunk *) FreeUnkChunk->uc_Node.mln_Succ ))
        break;

      FreeUnknownChunk ( FreeUnkChunk );
    }

    FreePMem ( SampleStr, sizeof (struct TuComposerSample ));
  }

  return ( ERROR_SAMPLE_NOGIVEN );
}
