/* TuComposer OS independent code
**
** $VER: GetSampleInfo.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_samplebase_protos.h>

struct SampleInfo *GetSampleInfo ( struct CFHandle *CFHandle,
    struct TuComposerExtList *ExtLibStr, unsigned long NumSample )
{
  struct SampleInfo *SampleInfoStr = NULL;

  if ( CFHandle )
  {
    if (!( ExtLibStr ))
      ExtLibStr = IdentifySample ( CFHandle );

    if ( ExtLibStr )
    {
      if ( (SampleInfoStr = (struct SampleInfo *) AllocPMem (sizeof (struct SampleInfo ))))
      {
        struct SampleLibrary *ExtSampleLibBase;

        if ( (ExtSampleLibBase = (struct SampleLibrary *) OpenExternalLib ( ExtLibStr )))
        {
          ULONG RC;

          RC = ExternalSampleGetInfoBase ( CFHandle, SampleInfoStr, NumSample, ExtSampleLibBase );

          CloseExternalLib ( ExtLibStr );

          if (!( RC ))
          {
            FreeSampleInfo ( SampleInfoStr );

            SampleInfoStr = NULL;
          }
        } else
        {
          FreePMem ( SampleInfoStr, sizeof (struct SampleInfo ));

          SampleInfoStr = NULL;
        }
      }
    }
  }

  return ( SampleInfoStr );
}
