/* TuComposer OS independent code
**
** $VER: GetSampleValue.c 31.22 (25.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

LONG GetSampleValue ( struct TuComposerSample *SampleStr,
    unsigned long Sample )
{
  LONG SampleVal = 0L;

  if ( SampleStr )
  {
    LONG *SampleData;

    if ( (SampleData = (LONG *) SampleStr->tcs_Data ))
    {
      if ( Sample < SampleStr->tcs_Samples )
      {
        ULONG Bit;
        UBYTE BitDepth = SampleStr->tcs_BitDepth;

        SampleData += (Sample * BitDepth) / 32;
        Bit = (Sample * BitDepth) % 32;

        if ( (Bit + BitDepth) < 32 )
        {
          SampleVal = (*SampleData << Bit) & ~((1UL << (32UL - BitDepth)) - 1UL);
        } else
        {
          SampleVal = *SampleData++ << Bit;
          SampleVal |= (*SampleData & ~((1UL << (64UL - (Bit + BitDepth))) - 1UL)) >> (32UL - Bit);
        }
      }
    }
  }

  return ( SampleVal );
}
