/* TuComposer OS independent code
**
** $VER: IdentifySample.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_samplebase_protos.h>

extern struct TuComposerBase *TuCBase;

struct TuComposerExtList *IdentifySample ( struct CFHandle *CFHandle )
{
  struct TuComposerExtList *ExtLibStr = NULL;

  if ( CFHandle )
  {
    ULONG CurrPos;

    ObtainSemaphoreShared ( TuCBase->tcb_ExternalSigSem );

    if ( (CurrPos = CSeek ( CFHandle, 0L, OFFSET_CURRENT )) != -1L )
    {
      ExtLibStr = (struct TuComposerExtList *) &(TuCBase->tcb_ExtSample);

      for (;;)
      {
        ExtLibStr = (struct TuComposerExtList *) ExtLibStr->extl_Node.mln_Succ;

        if (!( ExtLibStr->extl_Node.mln_Succ ))
        {
          ExtLibStr = NULL;

          break;
        }

        if ( ExtLibStr->extl_Flags & EXTLF_Loader )
        {
          struct SampleLibrary *ExtSampleLibBase;

          if ( (ExtSampleLibBase = (struct SampleLibrary *) OpenExternalLib ( ExtLibStr ) ))
          {
            ULONG RC;

            RC = ExternalSampleIdentifyBase ( CFHandle, ExtSampleLibBase );

            CloseExternalLib ( ExtLibStr );

            if ( ( CSeek ( CFHandle, CurrPos, OFFSET_BEGINNING )) == -1L )
            {
              ExtLibStr = NULL;

              break;
            }

            if ( RC )
              break;
          }
        }
      }
    }

    ReleaseSemaphore ( TuCBase->tcb_ExternalSigSem );
  }

  return ( ExtLibStr );
}
