/* TuComposer OS independent code
**
** $VER: InsertSample.c 31.22 (25.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG InsertSample ( struct TuComposerInstr *InstrStr,
    struct TuComposerSample *SampleStr,
    struct TuComposerSample *SamplePos )
{
  if ( InstrStr )
  {
    if ( SampleStr )
    {
      if ( InstrStr->tci_NumSamples < LASTSAMPLEPERINSTR )
      {
        struct TuComposerModule *ModuleStr = (struct TuComposerModule *) &(InstrStr->tci_Node.mln_Succ);
        struct TuComposerInstr *InstrScan;
        struct TuComposerInstrKeyboard *KeybrdStr;
        ULONG NumSample;

        for (;;)
        {
          ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

          if (!( ModuleStr->tcm_Node.mln_Pred ))
            break;
        }

        (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_InstrList );

        NumSample = GetSampleNum ( InstrStr, SamplePos );

        InstrScan = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head );

        for (;;)
        {
          InstrScan = (struct TuComposerInstr *) InstrScan->tci_Node.mln_Succ;

          if (!( InstrScan->tci_Node.mln_Succ ))
            break;

          if (!( InstrScan->tci_CompFlags & TCICF_SeparateSamples ))
          {
            KeybrdStr = InstrScan->tci_KeyboardDefs;

            if ( KeybrdStr )
            {
              struct KeyboardEntry *KeybrdEntry = (struct KeyboardEntry *) &(KeybrdStr->tcik_NoteEntry[0]);
              ULONG i;

              if (!( KeybrdEntry->tcik_Octave_C_0 & 0x80 ))
              {
                KeybrdEntry->tcik_Octave_C_0 |= 0x80;

                for (i = (NUMOCTAVES * NUMNOTES); i > 0; i--)
                {
                  if ( KeybrdEntry->tcik_Sample_C_0 >= NumSample )
                    KeybrdEntry->tcik_Sample_C_0++;

                  KeybrdEntry++;
                }
              }
            }
          }

          KeybrdStr = (struct TuComposerInstrKeyboard *) &(ModuleStr->tcm_KeyboardDefs.mlh_Head);

          for (;;)
          {
            KeybrdStr = (struct TuComposerInstrKeyboard *) KeybrdStr->tcik_Node.mln_Succ;

            if (!( KeybrdStr->tcik_Node.mln_Succ ))
              break;

            KeybrdStr->tcik_NoteEntry[0].tcik_Octave_C_0 &= 0x7F;
          }
        }

        InstrStr->tci_NumSamples++;

        InsertNode ( (struct List *) &(InstrStr->tci_Samples), (struct Node *) SampleStr, (struct Node *) SamplePos);

        return ( 0L );
      }

      return ( ERROR_SAMPLE_TOOMANY );
    }

    return ( ERROR_SAMPLE_NODATA );
  }

  return( ERROR_SAMPLE_NOGIVEN );
}
