/* TuComposer OS independent code
**
** $VER: LoadSampleData.c 31.22 (25.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSample *LoadSampleData ( struct CFHandle *CFHandle,
    struct TuComposerSample *SampleStr, unsigned long NumBytes )
{
  struct TuComposerSample *GivenSample;

  GivenSample = SampleStr;

  if ( SampleStr == NULL )
    SampleStr = AllocSample ( NULL, NumBytes );

  if ( SampleStr )
  {
    UBYTE BitDepth;

    BitDepth = SampleStr->tcs_BitDepth;

    if (!( ReSizeSample ( SampleStr, ((NumBytes * 8) + (BitDepth - 1)) / BitDepth )))
    {
      ULONG Really;

      if ( (Really = CRead ( CFHandle, SampleStr->tcs_Data, NumBytes ) == 0xFFFFFFFF ))
      {
LoadSampleDataErr:

        ClearSample ( SampleStr );

        if ( GivenSample == NULL )
          FreeSample ( SampleStr );

        SampleStr = NULL;
      } else
      {
        if ( ReSizeSample ( SampleStr, ((Really * 8) + (BitDepth - 1)) / BitDepth ))
          goto LoadSampleDataErr;
      }
    }
  }

  return ( SampleStr );
}
