/* TuComposer OS independent code
**
** $VER: MinimizeSample.c 31.22 (25.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG MinimizeSample ( struct TuComposerSample *SampleStr )
{
  ULONG MinSize = 0L;

  if ( SampleStr = FindOriginSample ( SampleStr ))
  {
    if ( SampleStr->tcs_Data )
    {
      MinSize = SampleStr->tcs_Samples;

      if ( SampleStr->tcs_Flags & TCSF_Loop )
      {
        if ( SampleStr->tcs_RepCount )
          goto MinSampleDone;

        MinSize = SampleStr->tcs_Repeat + SampleStr->tcs_RepLen;
      }

      if ( SampleStr->tcs_Flags & TCSF_SustainLoop )
      {
        ULONG SusSize;

        if ( SampleStr->tcs_SustainRepCount )
          goto MinSampleDone;

        SusSize = SampleStr->tcs_SustainRepeat + SampleStr->tcs_SustainRepLen;

        if ( SusSize > MinSize )
          MinSize = SusSize;
      }
    }
  }

MinSampleDone:

  if ( SampleStr->tcs_Node.mln_Succ )
  {
    struct TuComposerInstr *InstrStr = (struct TuComposerInstr *) &(SampleStr->tcs_Node.mln_Succ);

    for (;;)
    {
      InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Pred;

      if (!( InstrStr->tci_Node.mln_Pred ))
        break;
    }

    (UBYTE *) InstrStr += -offsetof (struct TuComposerInstr, tci_Samples );

    if ( InstrStr->tci_Node.mln_Succ )
    {
      struct TuComposerModule *ModuleStr = (struct TuComposerModule *) &(InstrStr->tci_Node.mln_Succ);

      for (;;)
      {
        ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

        if (!( ModuleStr->tcm_Node.mln_Pred ))
          break;
      }

      (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_InstrList );

      InstrStr = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head);

      for (;;)
      {
        struct TuComposerSample *OrigSampleStr;

        InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Succ;

        if (!( InstrStr->tci_Node.mln_Succ ))
          break;

        OrigSampleStr = (struct TuComposerSample *) &(InstrStr->tci_Samples.mlh_Head);

        for (;;)
        {
          OrigSampleStr = (struct TuComposerSample *) OrigSampleStr->tcs_Node.mln_Succ;

          if (!( OrigSampleStr->tcs_Node.mln_Succ ))
            break;

          if ( (OrigSampleStr->tcs_Flags & TCSF_Redirect) && (OrigSampleStr->tcs_Data == SampleStr->tcs_Data) )
          {
            ULONG MinSize2 = OrigSampleStr->tcs_Samples;

            if ( OrigSampleStr->tcs_Flags & TCSF_Loop )
            {
              if ( OrigSampleStr->tcs_RepCount )
                goto MinSampleDone2;

              MinSize2 = OrigSampleStr->tcs_Repeat + OrigSampleStr->tcs_RepLen;
            }

            if ( OrigSampleStr->tcs_Flags & TCSF_SustainLoop )
            {
               ULONG SusSize;

               if ( OrigSampleStr->tcs_SustainRepCount )
                 goto MinSampleDone2;

               SusSize = OrigSampleStr->tcs_SustainRepeat + OrigSampleStr->tcs_SustainRepLen;

               if ( SusSize > MinSize2 )
                 MinSize2 = SusSize;
            }

MinSampleDone2:

            if ( MinSize2 > MinSize )
              MinSize = MinSize2;
          }
        }
      }
    }
  }

  return ( MinSize );
}
