/* TuComposer OS independent code
**
** $VER: MixSamples.c 31.22 (25.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

#ifdef __cplusplus
extern "C" {
#endif

void MixSamples88 ( BYTE *SrcSampleData, BYTE *DestSampleData, ULONG SrcStartSmp, ULONG NumSamples, ULONG DestStartSmp );
void MixSamples816 ( BYTE *SrcSampleData, WORD *DestSampleData, ULONG SrcStartSmp, ULONG NumSamples, ULONG DestStartSmp );
void MixSamples832 ( BYTE *SrcSampleData, LONG *DestSampleData, ULONG SrcStartSmp, ULONG NumSamples, ULONG DestStartSmp );
void MixSamples168 ( WORD *SrcSampleData, BYTE *DestSampleData, ULONG SrcStartSmp, ULONG NumSamples, ULONG DestStartSmp );
void MixSamples1616 ( WORD *SrcSampleData, WORD *DestSampleData, ULONG SrcStartSmp, ULONG NumSamples, ULONG DestStartSmp );
void MixSamples1632 ( WORD *SrcSampleData, LONG *DestSampleData, ULONG SrcStartSmp, ULONG NumSamples, ULONG DestStartSmp );
void MixSamples328 ( LONG *SrcSampleData, BYTE *DestSampleData, ULONG SrcStartSmp, ULONG NumSamples, ULONG DestStartSmp );
void MixSamples3216 ( LONG *SrcSampleData, WORD *DestSampleData, ULONG SrcStartSmp, ULONG NumSamples, ULONG DestStartSmp );
void MixSamples3232 ( LONG *SrcSampleData, LONG *DestSampleData, ULONG SrcStartSmp, ULONG NumSamples, ULONG DestStartSmp );
void MixSamplesXY ( LONG *SrcSampleData, LONG *DestSampleData, ULONG SrcStartSmp, ULONG NumSamples, ULONG DestStartSmp, UBYTE SrcBitDepth, UBYTE DestBitDepth );

#ifdef __cplusplus
}
#endif

ULONG MixSamples ( struct TuComposerSample *SrcSampleStr,
    struct TuComposerSample *DestSampleStr, unsigned long SrcStartSmp,
    unsigned long SrcLastSmp, unsigned long DestStartSmp )
{
  if ( SrcSampleStr && DestSampleStr )
  {
    WORD *SrcSampleData;
    WORD *DestSampleData;

    if ( (SrcSampleData = SrcSampleStr->tcs_Data ))
    {
      ULONG SrcSamples, DestSamples, NumSamples, DestSample, ReSizeErr;
      UBYTE SrcBitDepth, DestBitDepth;

      SrcSamples = SrcSampleStr->tcs_Samples;
      DestSamples = DestSampleStr->tcs_Samples;

      if ( SrcStartSmp >= SrcSamples )
        SrcStartSmp = SrcSamples - 1;

      if ( SrcLastSmp >= SrcSamples )
        SrcLastSmp = SrcSamples - 1;

      if ( DestStartSmp >= DestSamples )
        DestStartSmp = DestSamples - 1;

      if ( SrcStartSmp > SrcLastSmp )
      {
        NumSamples = SrcLastSmp;
        SrcLastSmp = SrcStartSmp;
        SrcStartSmp = NumSamples;
      }

      NumSamples = (SrcLastSmp - SrcStartSmp) + 1;

      DestSample = DestStartSmp + NumSamples;

      if ( DestSample < DestSamples )
        DestSample = DestSamples;

      if ( (ReSizeErr = ReSizeSample ( DestSampleStr, DestSample )))
        return ( ReSizeErr );

      DestSampleData = DestSampleStr->tcs_Data;

      SrcBitDepth = SrcSampleStr->tcs_BitDepth;
      DestBitDepth = DestSampleStr->tcs_BitDepth;

      switch ( SrcBitDepth )
      {
        case 8 :
        {
          switch ( DestBitDepth )
          {
            case 8 :
            {
              MixSamples88 ( (BYTE *) SrcSampleData, (BYTE *) DestSampleData, SrcStartSmp, NumSamples, DestStartSmp );
              break;
            }
            case 16 :
            {
              MixSamples816 ( (BYTE *) SrcSampleData, DestSampleData, SrcStartSmp, NumSamples, DestStartSmp );
              break;
            }
            case 32 :
            {
              MixSamples832 ( (BYTE *) SrcSampleData, (LONG *) DestSampleData, SrcStartSmp, NumSamples, DestStartSmp );
              break;
            }
            default :
              goto OtherBits;
          }

          break;
        }
        case 16 :
        {
          switch ( DestBitDepth )
          {
            case 8 :
            {
              MixSamples168 ( SrcSampleData, (BYTE *) DestSampleData, SrcStartSmp, NumSamples, DestStartSmp );
              break;
            }
            case 16 :
            {
              MixSamples1616 ( SrcSampleData, DestSampleData, SrcStartSmp, NumSamples, DestStartSmp );
              break;
            }
            case 32 :
            {
              MixSamples1632 ( SrcSampleData, (LONG *) DestSampleData, SrcStartSmp, NumSamples, DestStartSmp );
              break;
            }
            default :
              goto OtherBits;
          }

          break;
        }
        case 32 :
        {
          switch ( DestBitDepth )
          {
            case 8 :
            {
              MixSamples328 ( (LONG *) SrcSampleData, (BYTE *) DestSampleData, SrcStartSmp, NumSamples, DestStartSmp );
              break;
            }
            case 16 :
            {
              MixSamples3216 ( (LONG *) SrcSampleData, DestSampleData, SrcStartSmp, NumSamples, DestStartSmp );
              break;
            }
            case 32 :
            {
              MixSamples3232 ( (LONG *) SrcSampleData, (LONG *) DestSampleData, SrcStartSmp, NumSamples, DestStartSmp );
              break;
            }
            default :
              goto OtherBits;
          }

          break;
        }
        default :
        {

OtherBits:
          MixSamplesXY ( (LONG *) SrcSampleData, (LONG *) DestSampleData, SrcStartSmp, NumSamples, DestStartSmp, SrcBitDepth, DestBitDepth );

          break;
        }
      }
    }

    return ( ERROR_SAMPLE_NODATA );
  }

  return ( ERROR_SAMPLE_NOGIVEN );
}

void MixSamples88 ( BYTE *SrcSampleData, BYTE *DestSampleData, ULONG SrcStartSmp, ULONG NumSamples, ULONG DestStartSmp )
{
  ULONG i;
  WORD Sample;

  SrcSampleData += SrcStartSmp;
  DestSampleData += DestStartSmp;

  for (i = NumSamples; i > 0; i--)
  {
    Sample = ((*SrcSampleData++) + *DestSampleData) >> 1;
    *DestSampleData++ = Sample;
  }
}

void MixSamples816 ( BYTE *SrcSampleData, WORD *DestSampleData, ULONG SrcStartSmp, ULONG NumSamples, ULONG DestStartSmp )
{
  ULONG i;
  LONG Sample;

  SrcSampleData += SrcStartSmp;
  DestSampleData += DestStartSmp;

  for (i = NumSamples; i > 0; i--)
  {
    Sample = ((*SrcSampleData++ << 8) + *DestSampleData) >> 1;
    *DestSampleData++ = Sample;
  }
}

void MixSamples832 ( BYTE *SrcSampleData, LONG *DestSampleData, ULONG SrcStartSmp, ULONG NumSamples, ULONG DestStartSmp )
{
  ULONG i;
  long long Sample;

  SrcSampleData += SrcStartSmp;
  DestSampleData += DestStartSmp;

  for (i = NumSamples; i > 0; i--)
  {
    Sample = ((long long) (*SrcSampleData++ << 24) + *DestSampleData) >> 1;
    *DestSampleData++ = Sample;
  }
}

void MixSamples168 ( WORD *SrcSampleData, BYTE *DestSampleData, ULONG SrcStartSmp, ULONG NumSamples, ULONG DestStartSmp )
{
  ULONG i;
  LONG Sample;

  SrcSampleData += SrcStartSmp;
  DestSampleData += DestStartSmp;

  for (i = NumSamples; i > 0; i--)
  {
    Sample = ((*SrcSampleData++) + (*DestSampleData << 8)) >> 9;
    *DestSampleData++ = Sample;
  }
}

void MixSamples1616 ( WORD *SrcSampleData, WORD *DestSampleData, ULONG SrcStartSmp, ULONG NumSamples, ULONG DestStartSmp )
{
  ULONG i;
  LONG Sample;

  SrcSampleData += SrcStartSmp;
  DestSampleData += DestStartSmp;

  for (i = NumSamples; i > 0; i--)
  {
    Sample = ((*SrcSampleData++) + *DestSampleData) >> 1;
    *DestSampleData++ = Sample;
  }
}

void MixSamples1632 ( WORD *SrcSampleData, LONG *DestSampleData, ULONG SrcStartSmp, ULONG NumSamples, ULONG DestStartSmp )
{
  ULONG i;
  long long Sample;

  SrcSampleData += SrcStartSmp;
  DestSampleData += DestStartSmp;

  for (i = NumSamples; i > 0; i--)
  {
    Sample = ((long long) (*SrcSampleData++ << 16) + *DestSampleData) >> 1;
    *DestSampleData++ = Sample;
  }
}

void MixSamples328 ( LONG *SrcSampleData, BYTE *DestSampleData, ULONG SrcStartSmp, ULONG NumSamples, ULONG DestStartSmp )
{
  ULONG i;
  long long Sample;

  SrcSampleData += SrcStartSmp;
  DestSampleData += DestStartSmp;

  for (i = NumSamples; i > 0; i--)
  {
    Sample = ((long long) (*SrcSampleData++) + (*DestSampleData << 24)) >> 25;
    *DestSampleData++ = Sample;
  }
}

void MixSamples3216 ( LONG *SrcSampleData, WORD *DestSampleData, ULONG SrcStartSmp, ULONG NumSamples, ULONG DestStartSmp )
{
  ULONG i;
  long long Sample;

  SrcSampleData += SrcStartSmp;
  DestSampleData += DestStartSmp;

  for (i = NumSamples; i > 0; i--)
  {
    Sample = ((long long) (*SrcSampleData++) + (*DestSampleData << 16)) >> 17;
    *DestSampleData++ = Sample;
  }
}

void MixSamples3232 ( LONG *SrcSampleData, LONG *DestSampleData, ULONG SrcStartSmp, ULONG NumSamples, ULONG DestStartSmp )
{
  ULONG i;
  long long Sample;

  SrcSampleData += SrcStartSmp;
  DestSampleData += DestStartSmp;

  for (i = NumSamples; i > 0; i--)
  {
    Sample = ((long long) (*SrcSampleData++) + *DestSampleData) >> 1;
    *DestSampleData++ = Sample;
  }
}

void MixSamplesXY ( LONG *SrcSampleData, LONG *DestSampleData, ULONG SrcStartSmp, ULONG NumSamples, ULONG DestStartSmp, UBYTE SrcBitDepth, UBYTE DestBitDepth )
{
  ULONG i, SrcBit, DestBit;
  ULONG SrcSample, DestSample;
  long long Sample;

  SrcSampleData += (SrcStartSmp * SrcBitDepth) / 32;
  DestSampleData += (DestStartSmp * DestBitDepth) / 32;

  SrcBit = (SrcStartSmp * SrcBitDepth) % 32;
  DestBit = (DestStartSmp * DestBitDepth) % 32;

  for (i = NumSamples; i > 0; i--)
  {
    if ( (SrcBit + SrcBitDepth) < 32 )
    {
      SrcSample = (*SrcSampleData << SrcBit) & ~((1UL << (32UL - SrcBitDepth)) - 1UL);
    } else
    {
      SrcSample = *SrcSampleData++ << SrcBit;
      SrcSample |= (*SrcSampleData & ~((1UL << (64UL - (SrcBit + SrcBitDepth))) - 1UL)) >> (32 - SrcBit);

      SrcBit -= 32;
    }

    SrcBit += SrcBitDepth;

    if ( (DestBit + DestBitDepth) < 32 )
    {
      DestSample = (*DestSampleData << DestBit) & ~((1UL << (32UL - DestBitDepth)) - 1UL);
    } else
    {
      DestSample = *DestSampleData << DestBit;
      DestSample |= (*(DestSampleData + 1) & ~((1UL << (64UL - (DestBit + DestBitDepth))) - 1UL)) >> (32UL - DestBit);
    }

    Sample = ((long long) SrcSample + DestSample) >> 1;

    DestSample = Sample;

    DestSample &= ~((1UL << (32UL - DestBitDepth)) - 1UL );

    if ( (DestBit + DestBitDepth) < 32UL )
    {
      *DestSampleData &= ~((1UL << (32UL - DestBit)) - (1UL << (32UL - DestBitDepth - DestBit)));
      *DestSampleData |= (DestSample >> DestBit);
    } else
    {
      *DestSampleData &= ~((1UL << (32UL - DestBit)) - 1UL);
      *DestSampleData |= (DestSample >> DestBit);
      DestSampleData++;
      *DestSampleData &= ((1UL << (64UL - (DestBit + DestBitDepth))) - 1UL);
      *DestSampleData |= (DestSample << (32UL - DestBit));

      DestBit -= 32;
    }

    DestBit += DestBitDepth;
  }
}
