/* TuComposer OS independent code
**
** $VER: PasteSampleData.c 31.22 (27.4.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

#ifdef __cplusplus
extern "C" {
#endif

void CopySampleDataX ( LONG *SampleData, LONG *NewSampleData, ULONG SrcSamplePos, ULONG DestSamplePos, ULONG NumSamples, UBYTE BitDepth );

#ifdef __cplusplus
}
#endif

struct TuComposerSample *DoDupSample ( struct TuComposerSample *SampleStr, struct TuComposerSample *CloneSample );

extern struct TuComposerBase *TuCBase;

struct TuComposerSample *PasteSampleData ( struct TuComposerSample
    *SampleBuf, struct TuComposerSample *SampleStr,
    unsigned long PasteSmp, unsigned long Flags )
{
  struct TuComposerSample *SampleGiven = SampleStr;

  if (!( SampleStr ))
    SampleStr = AllocSample ( NULL, 0L );

  if ( PasteSmp > SampleStr->tcs_Samples )
    PasteSmp = SampleStr->tcs_Samples;

  if ( SampleStr )
  {
    ObtainSemaphore ( TuCBase->tcb_SampleSigSem );

    if (!( InsertSampleData ( SampleStr, PasteSmp, SampleBuf->tcs_Samples )))
    {
      if (!( SampleGiven ))
      {
        if (!( SampleStr = DoDupSample ( SampleBuf, SampleStr )))
          goto PasteSampleDataErr;
      }

      switch ( SampleStr->tcs_BitDepth )
      {
        case 8 :
        {
          memcpy ( (BYTE *) SampleStr->tcs_Data + PasteSmp, (BYTE *) SampleBuf->tcs_Data, SampleBuf->tcs_Samples );

          break;
        }
        case 16 :
        {
          memcpy ( SampleStr->tcs_Data + PasteSmp, SampleBuf->tcs_Data, SampleBuf->tcs_Samples * sizeof (WORD));

          break;
        }
        case 32 :
        {
          memcpy ( (LONG *) SampleStr->tcs_Data + PasteSmp, (LONG *) SampleBuf->tcs_Data, SampleBuf->tcs_Samples * sizeof (LONG));

          break;
        }
        default :
        {
          CopySampleDataX ( (LONG *) SampleBuf->tcs_Data, (LONG *) SampleStr->tcs_Data, 0L, PasteSmp, SampleBuf->tcs_Samples, SampleStr->tcs_BitDepth );

          break;
        }
      }

      ReleaseSemaphore ( TuCBase->tcb_SampleSigSem );

      return ( SampleStr );
    }

PasteSampleDataErr:

    if (!( SampleGiven ))
      FreeSample ( SampleBuf );

    ReleaseSemaphore ( TuCBase->tcb_SampleSigSem );
  }

  return ( NULL );
}
