/* TuComposer OS independent code
**
** $VER: ReSizeSample.c 31.22 (25.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ReSizeSample ( struct TuComposerSample *SampleStr,
    unsigned long NewSamples )
{
  if ( SampleStr )
  {
    ULONG RC = 0L;

    if ( NewSamples )
    {
      ULONG Samples = SampleStr->tcs_Samples;

      if ( NewSamples < Samples )
      {
        RC = RemSampleData ( SampleStr, Samples - NewSamples );
      } else if ( NewSamples > Samples )
      {
        RC = AddSampleData ( SampleStr, NewSamples - Samples );
      }
    } else
    {
      FreeSampleData ( SampleStr->tcs_Data, SampleStr->tcs_Length );

      memset ( &(SampleStr->tcs_Data), 0, offsetof (struct TuComposerSample, tcs_GlobalVolume) - offsetof (struct TuComposerSample, tcs_Data ));
    }

    return ( RC );
  }

  return ( ERROR_SAMPLE_NOGIVEN );
}
