/* TuComposer OS independent code
**
** $VER: RemSampleData.c 31.22 (25.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG RemSampleData ( struct TuComposerSample *SampleStr,
    unsigned long NumSamples )
{
  if ( SampleStr )
  {
    ULONG NewSamples, NewBuffers, Repeat;
    WORD *SampleData;
    WORD *NewSampleData;

    NewSamples = NumSamples - SampleStr->tcs_Samples;

    if ( NewSamples > SampleStr->tcs_Samples )
      return ( ERROR_SAMPLE_TOOSMALL );

    NewBuffers = (( NewSamples * SampleStr->tcs_BitDepth) + SMP_BLOCKMASK) / SMP_BLOCKSIZE;

    if ( NewBuffers )
    {
      if ( SampleStr->tcs_Flags & TCSF_Redirect )
      {
        SampleStr->tcs_Samples = NewSamples;
        SampleStr->tcs_Length = NewBuffers;

        Repeat = SampleStr->tcs_Repeat;

        if ( Repeat >= NewSamples )
        {
          Repeat = NewSamples - 1;
          SampleStr->tcs_Repeat = Repeat;
        }

        Repeat += SampleStr->tcs_RepLen;

        if ( Repeat > NewSamples )
        {
          Repeat = NewSamples - SampleStr->tcs_Repeat;
          SampleStr->tcs_RepLen = Repeat;
        }

        Repeat = SampleStr->tcs_SustainRepeat;

        if ( Repeat >= NewSamples )
        {
          Repeat = NewSamples - 1;
          SampleStr->tcs_SustainRepeat = Repeat;
        }

        Repeat += SampleStr->tcs_SustainRepLen;

        if ( Repeat > NewSamples )
        {
          Repeat = NewSamples - SampleStr->tcs_SustainRepeat;
          SampleStr->tcs_SustainRepLen = Repeat;
        }
      } else
      {
        if ( (NewSampleData = (WORD *) AllocSampleData ( NewBuffers )))
        {
          struct TuComposerModule *ModuleStr;
          struct TuComposerInstr *InstrStr;
          struct TuComposerSample *OrigSampleStr;
          ULONG OldLength;

          OldLength = SampleStr->tcs_Length;
          SampleData = SampleStr->tcs_Data;

          memcpy ( NewSampleData, SampleData, NewBuffers << 3 );

          SampleStr->tcs_Data = NewSampleData;
          SampleStr->tcs_Samples = NewSamples;
          SampleStr->tcs_Length = NewBuffers;

          Repeat = SampleStr->tcs_Repeat;

          if ( Repeat >= NewSamples )
          {
            Repeat = NewSamples - 1;
            SampleStr->tcs_Repeat = Repeat;
          }

          Repeat += SampleStr->tcs_RepLen;

          if ( Repeat > NewSamples )
          {
            Repeat = NewSamples - SampleStr->tcs_Repeat;
            SampleStr->tcs_RepLen = Repeat;
          }

          Repeat = SampleStr->tcs_SustainRepeat;

          if ( Repeat >= NewSamples )
          {
            Repeat = NewSamples - 1;
            SampleStr->tcs_SustainRepeat = Repeat;
          }

          Repeat += SampleStr->tcs_SustainRepLen;

          if ( Repeat > NewSamples )
          {
            Repeat = NewSamples - SampleStr->tcs_SustainRepeat;
            SampleStr->tcs_SustainRepLen = Repeat;
          }

          if ( SampleStr->tcs_Node.mln_Succ )
          {
            InstrStr = (struct TuComposerInstr *) &(SampleStr->tcs_Node.mln_Succ);

            for (;;)
            {
              InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Pred;

              if (!( InstrStr->tci_Node.mln_Pred ))
                break;
            }

            (UBYTE *) InstrStr += -offsetof (struct TuComposerInstr, tci_Samples );

            if ( InstrStr->tci_Node.mln_Succ )
            {
              ModuleStr = (struct TuComposerModule *) &(InstrStr->tci_Node.mln_Succ);

              for (;;)
              {
                ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

                if (!( ModuleStr->tcm_Node.mln_Pred ))
                  break;
              }

              (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_InstrList );

              InstrStr = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head);

              for (;;)
              {
                InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Succ;

                if (!( InstrStr->tci_Node.mln_Succ ))
                  break;

                OrigSampleStr = (struct TuComposerSample *) &(InstrStr->tci_Samples.mlh_Head);

                for (;;)
                {
                  OrigSampleStr = (struct TuComposerSample *) OrigSampleStr->tcs_Node.mln_Succ;

                  if (!( OrigSampleStr->tcs_Node.mln_Succ ))
                    break;

                  if ( OrigSampleStr->tcs_Flags & TCSF_Redirect )
                    continue;

                  if ( OrigSampleStr->tcs_Data == SampleData )
                  {
                    OrigSampleStr->tcs_Data = NewSampleData;

                    NewSamples = OrigSampleStr->tcs_Samples;

                    if ( NewSamples > SampleStr->tcs_Samples )
                      NewSamples = SampleStr->tcs_Samples;

                    SampleStr->tcs_Samples = NewSamples;
                    SampleStr->tcs_Length = ((NewSamples * SampleStr->tcs_BitDepth) + SMP_BLOCKMASK) / SMP_BLOCKSIZE;

                    Repeat = SampleStr->tcs_Repeat;

                    if ( Repeat >= NewSamples )
                    {
                      Repeat = NewSamples - 1;
                      SampleStr->tcs_Repeat = Repeat;
                    }

                    Repeat += SampleStr->tcs_RepLen;

                    if ( Repeat > NewSamples )
                    {
                      Repeat = NewSamples - SampleStr->tcs_Repeat;
                      SampleStr->tcs_RepLen = Repeat;
                    }

                    Repeat = SampleStr->tcs_SustainRepeat;

                    if ( Repeat >= NewSamples )
                    {
                      Repeat = NewSamples - 1;
                      SampleStr->tcs_SustainRepeat = Repeat;
                    }

                    Repeat += SampleStr->tcs_SustainRepLen;

                    if ( Repeat > NewSamples )
                    {
                      Repeat = NewSamples - SampleStr->tcs_SustainRepeat;
                      SampleStr->tcs_SustainRepLen = Repeat;
                    }
                  }
                }
              }
            }
          }

          FreeSampleData ( SampleData, OldLength );

          return ( 0L );
        }
      }
    } else
    {
      FreeSampleData ( SampleStr->tcs_Data, SampleStr->tcs_Length );

      memset ( &(SampleStr->tcs_Data), 0, offsetof (struct TuComposerSample, tcs_GlobalVolume ) - offsetof (struct TuComposerSample, tcs_Data ));

      return ( 0L );
    }

    return ( ERROR_SAMPLE_NOMEM );
  }

  return ( ERROR_SAMPLE_NOGIVEN );
}
