/* TuComposer OS independent code
**
** $VER: SaveSampleData.c 31.22 (26.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG SaveSampleDataX ( struct CFHandle *CFHandle, struct TuComposerSample *SampleStr, LONG *SampleData, ULONG FirstSmp, ULONG NumSamples );

ULONG SaveSampleData ( struct CFHandle *CFHandle,
    struct TuComposerSample *SampleStr, unsigned long FirstSmp,
    unsigned long LastSmp )
{
  if ( CFHandle )
  {
    if ( SampleStr )
    {
      WORD *SampleData;

      if ( ( SampleData = SampleStr->tcs_Data ))
      {
        ULONG Samples, NumSamples;

        Samples = SampleStr->tcs_Samples;

        if ( FirstSmp >= Samples )
          FirstSmp = Samples - 1;

        if ( LastSmp >= Samples )
          LastSmp = Samples - 1;

        if ( FirstSmp > LastSmp )
        {
          NumSamples = LastSmp;
          LastSmp = FirstSmp;
          FirstSmp = NumSamples;
        }

        NumSamples = (LastSmp - FirstSmp) + 1;

        switch ( SampleStr->tcs_BitDepth )
        {
          case 8 :
          {
            if ( CWrite ( CFHandle, (BYTE *) SampleData + FirstSmp, NumSamples ) != NumSamples )
              return ( ERROR_SAMPLE_IOERR );

            break;
          }
          case 16 :
          {
            if ( CWrite ( CFHandle, SampleData + FirstSmp, NumSamples ) != NumSamples )
              return ( ERROR_SAMPLE_IOERR );

            break;
          }
          case 32 :
          {
            if ( CWrite ( CFHandle, (LONG *) SampleData + FirstSmp, NumSamples ) != NumSamples )
              return ( ERROR_SAMPLE_IOERR );

            break;
          }
          default :
          {
            return ( SaveSampleDataX ( CFHandle, SampleStr, (LONG *) SampleData, FirstSmp, NumSamples ));

            break;
          }
        }

        return ( 0L );
      }

      return ( ERROR_SAMPLE_NODATA );
    }

    return ( ERROR_SAMPLE_NOGIVEN );
  }

  return ( ERROR_SAMPLE_NOFILE );
}

ULONG SaveSampleDataX ( struct CFHandle *CFHandle, struct TuComposerSample *SampleStr, LONG *SampleData, ULONG FirstSmp, ULONG NumSamples )
{
  LONG *TmpMem;
  LONG *TmpBuf;
  ULONG i, TmpSize, WriteLeft = NumSamples, WriteSize, Samples = 4096L, SrcBit, DestBit;
  LONG Sample;
  UBYTE BitDepth = SampleStr->tcs_BitDepth;

  TmpSize = (4096 / 8) * BitDepth;
  WriteSize = TmpSize;

  SampleData += (FirstSmp * BitDepth) / 32;
  SrcBit = (FirstSmp * BitDepth) % 32;

  if ( (TmpMem = (LONG *) AllocPMem ( TmpSize )))
  {
    for (;;)
    {
      if ( WriteLeft == 0L )
        break;

      WriteLeft -= 4096;

      if ( (WriteLeft + 4096) < WriteLeft )
      {
        Samples = WriteLeft;
        WriteSize = ((WriteLeft * BitDepth) + 7) / 8;

        WriteLeft = 0L;
      }

      DestBit = 0L;

      TmpBuf = TmpMem;

      for (i = Samples; i > 0; i--)
      {
        if ( (SrcBit + BitDepth) < 32 )
        {
          Sample = (*SampleData << SrcBit) & ~((1L << (32 - BitDepth)) - 1);
        } else
        {
          Sample = (*SampleData++) << SrcBit;
          Sample |= (*SampleData & ~((1L << (64 - (SrcBit + BitDepth))) - 1)) >> (32 - SrcBit);

          SrcBit -= 32;
        }

        SrcBit += BitDepth;

        *TmpBuf |= (Sample >> DestBit);

        if ( (DestBit + BitDepth) >= 32 )
        {
          TmpBuf++;
          *TmpBuf = (Sample << (32 - DestBit));

          DestBit -= 32;
        }

        DestBit += BitDepth;
      }

      if ( CWrite ( CFHandle, TmpMem, WriteSize ) != WriteSize )
      {
        FreePMem ( TmpMem, TmpSize );

        return ( ERROR_SAMPLE_IOERR );
      }

      memset ( TmpMem, 0, TmpSize );
    }

    FreePMem ( TmpMem, TmpSize );

    return ( 0L );
  }

  return ( ERROR_SAMPLE_NOMEM );
}
