/* TuComposer OS independent code
**
** $VER: SetSampleData.c 31.22 (24.4.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG SetSampleData ( struct TuComposerSample *SampleStr, WORD *SampleData,
    unsigned long Length )
{

  if ( SampleStr )
  {
    struct TuComposerModule *ModuleStr;
    struct TuComposerInstr *InstrStr;
    struct TuComposerSample *OrigSampleStr = SampleStr;
    WORD *OldSampleData;
    ULONG OldLength;

    if (!( SampleData && Length ))
    {
      SampleData = NULL;
      Length = 0L;
    }

    if ( SampleStr->tcs_Flags & TCSF_Redirect )
    {
      if ( SampleData == SampleStr->tcs_Data )
      {
        OrigSampleStr = FindOriginSample ( SampleStr );

        if ( Length > OrigSampleStr->tcs_Samples )
          Length = OrigSampleStr->tcs_Samples;
      } else
      {
        SampleStr->tcs_Flags &= ~TCSF_Redirect;

        if ( SampleStr->tcs_Node.mln_Succ )
        {
          InstrStr = (struct TuComposerInstr *) &(SampleStr->tcs_Node.mln_Succ);

          for (;;)
          {
            InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Pred;

            if (!( InstrStr->tci_Node.mln_Pred ))
              break;
          }

          (UBYTE *) InstrStr += -offsetof (struct TuComposerInstr, tci_Samples );

          if ( InstrStr->tci_Node.mln_Succ )
          {
            ModuleStr = (struct TuComposerModule *) &(InstrStr->tci_Node.mln_Succ);

            for (;;)
            {
              ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

              if (!( ModuleStr->tcm_Node.mln_Pred ))
                break;
            }

            (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_InstrList );

            InstrStr = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head);

            for (;;)
            {
              InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Succ;

              if (!( InstrStr->tci_Node.mln_Succ ))
                break;

              OrigSampleStr = (struct TuComposerSample *) &(InstrStr->tci_Samples.mlh_Head);

              for (;;)
              {
                OrigSampleStr = (struct TuComposerSample *) OrigSampleStr->tcs_Node.mln_Succ;

                if (!( OrigSampleStr->tcs_Node.mln_Succ ))
                  break;

                if ( OrigSampleStr->tcs_Flags & TCSF_Redirect )
                  continue;

                if ( OrigSampleStr->tcs_Data == SampleData )
                  SampleStr->tcs_Flags |= TCSF_Redirect;
              }
            }
          }
        }
      }
    }

    OldSampleData = SampleStr->tcs_Data;
    OldLength = SampleStr->tcs_Length;

    SampleStr->tcs_Data = SampleData;
    SampleStr->tcs_Samples = Length;
    SampleStr->tcs_Length = ((Length * SampleStr->tcs_BitDepth) + SMP_BLOCKMASK) / SMP_BLOCKSIZE;

    InstrStr = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head);

    for (;;)
    {
      InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Succ;

      if (!( InstrStr->tci_Node.mln_Succ ))
        break;

      OrigSampleStr = (struct TuComposerSample *) &(InstrStr->tci_Samples.mlh_Head);

      for (;;)
      {
        OrigSampleStr = (struct TuComposerSample *) OrigSampleStr->tcs_Node.mln_Succ;

        if (!( OrigSampleStr->tcs_Node.mln_Succ ))
          break;

        if ( OrigSampleStr->tcs_Data == SampleData )
        {
          if ( OrigSampleStr->tcs_Samples > Length )
            ReSizeSample ( OrigSampleStr, Length );
        }
      }
    }

    if (!( OrigSampleStr->tcs_Samples ))
      FreeSampleData ( OldSampleData, OldLength );

    return ( 0L );
  }

  return ( ERROR_SAMPLE_NOGIVEN );
}
