/* TuComposer OS independent code
**
** $VER: SwapSample.c 31.22 (26.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG SwapSample ( struct TuComposerSample *SampleBuf,
    struct TuComposerSample *SampleStr )
{
  if ( SampleStr && SampleBuf )
  {
    if ( SampleStr != SampleBuf )
    {
      struct MinList TmpUnkChunk;
      struct MinList SwapUnkChunk;
      UBYTE *SrcBuf,*DestBuf;
      UBYTE TmpByte;
      ULONG i;

      ObtainSemaphore ( TuCBase->tcb_SampleSigSem );

      SrcBuf = (UBYTE *) &(SampleStr->tcs_FileName);
      DestBuf = (UBYTE *) &(SampleBuf->tcs_FileName);

      for (i = (offsetof (struct TuComposerSample, tcs_UnknownChunks) - offsetof (struct TuComposerSample, tcs_FileName)); i > 0; i--)
      {
        TmpByte = *DestBuf;
        *DestBuf++ = *SrcBuf;
        *SrcBuf++ = TmpByte;
      }

      TmpUnkChunk = SampleBuf->tcs_UnknownChunks;
      ReMapNodeList ( (struct List *) &(SampleStr->tcs_UnknownChunks), (struct List *) &(SampleBuf->tcs_UnknownChunks));

      SwapUnkChunk = SampleBuf->tcs_UnknownChunks;
      SampleBuf->tcs_UnknownChunks = TmpUnkChunk;
      ReMapNodeList ( (struct List *) &(SampleBuf->tcs_UnknownChunks), (struct List *) &(SampleStr->tcs_UnknownChunks));

      SampleBuf->tcs_UnknownChunks = SwapUnkChunk;

      ReleaseSemaphore ( TuCBase->tcb_SampleSigSem );
    }

    return ( 0L );
  }

  return ( ERROR_SAMPLE_NOGIVEN );
}
