/* TuComposer OS independent code
**
** $VER: SwapSampleInInstr.c 31.22 (12.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG SwapSampleInInstr ( struct TuComposerSample *SampleBuf,
    struct TuComposerSample *SampleStr, unsigned long Flags )
{
  if ( SampleStr && SampleBuf )
  {
    if ( SampleStr != SampleBuf )
    {
      if ( Flags & SSIIF_Swap )
      {
        struct MinList TmpUnkChunk;
        struct MinList SwapUnkChunk;
        UBYTE *SrcBuf,*DestBuf;
        UBYTE TmpByte;
        ULONG i;

        SrcBuf = (UBYTE *) &(SampleStr->tcs_FileName);
        DestBuf = (UBYTE *) &(SampleBuf->tcs_FileName);

        for (i = (offsetof (struct TuComposerSample, tcs_UnknownChunks) - offsetof (struct TuComposerSample, tcs_FileName)); i > 0; i--)
        {
          TmpByte = *DestBuf;
          *DestBuf++ = *SrcBuf;
          *SrcBuf++ = TmpByte;
        }

        TmpUnkChunk = SampleBuf->tcs_UnknownChunks;
        ReMapNodeList ( (struct List *) &(SampleStr->tcs_UnknownChunks), (struct List *) &(SampleBuf->tcs_UnknownChunks));

        SwapUnkChunk = SampleBuf->tcs_UnknownChunks;
        SampleBuf->tcs_UnknownChunks = TmpUnkChunk;
        ReMapNodeList ( (struct List *) &(SampleBuf->tcs_UnknownChunks), (struct List *) &(SampleStr->tcs_UnknownChunks));

        SampleBuf->tcs_UnknownChunks = SwapUnkChunk;
      }

      if ( Flags & SSIIF_Update )
      {
        struct TuComposerModule *ModuleStr;
        struct TuComposerInstr *InstrStr = (struct TuComposerInstr *) &(SampleStr->tcs_Node.mln_Succ);
        struct TuComposerInstr *InstrScan;
        struct TuComposerInstrKeyboard *KeybrdStr;
        ULONG NumSample, NumSwapSample;

        for (;;)
        {
          InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Pred;

          if (!( InstrStr->tci_Node.mln_Pred ))
            break;
        }

        (UBYTE *) InstrStr += -offsetof (struct TuComposerInstr, tci_Samples );

        ModuleStr = (struct TuComposerModule *) &(InstrStr->tci_Node.mln_Succ);

        for (;;)
        {
          ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

          if (!( ModuleStr->tcm_Node.mln_Pred ))
            break;
        }

        (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_InstrList );

        NumSample = GetSampleNum ( InstrStr, SampleStr );
        NumSwapSample = GetSampleNum ( InstrStr, SampleBuf );

        InstrScan = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head );

        for (;;)
        {
          InstrScan = (struct TuComposerInstr *) InstrScan->tci_Node.mln_Succ;

          if (!( InstrScan->tci_Node.mln_Succ ))
            break;

          if (!( InstrScan->tci_CompFlags & TCICF_SeparateSamples ))
          {
            KeybrdStr = InstrScan->tci_KeyboardDefs;

            if ( KeybrdStr )
            {
              struct KeyboardEntry *KeybrdEntry = (struct KeyboardEntry *) &(KeybrdStr->tcik_NoteEntry[0]);
              ULONG i;

              if (!( KeybrdEntry->tcik_Octave_C_0 & 0x80 ))
              {
                KeybrdEntry->tcik_Octave_C_0 |= 0x80;

                for (i = (NUMOCTAVES * NUMNOTES); i > 0; i--)
                {
                  if ( KeybrdEntry->tcik_Sample_C_0 == NumSample )
                  {
                    KeybrdEntry->tcik_Sample_C_0 = NumSwapSample;
                  } else if ( KeybrdEntry->tcik_Sample_C_0 == NumSwapSample )
                  {
                    KeybrdEntry->tcik_Sample_C_0 = NumSample;
                  }
                }

                KeybrdEntry++;
              }
            }
          }
        }

        KeybrdStr = (struct TuComposerInstrKeyboard *) &(ModuleStr->tcm_KeyboardDefs.mlh_Head);

        for (;;)
        {
          KeybrdStr = (struct TuComposerInstrKeyboard *) KeybrdStr->tcik_Node.mln_Succ;

          if (!( KeybrdStr->tcik_Node.mln_Succ ))
            break;

          KeybrdStr->tcik_NoteEntry[0].tcik_Octave_C_0 &= 0x7F;
        }
      }
    }

    return ( 0L );
  }

  return ( ERROR_SAMPLE_NOGIVEN );
}
