/* TuComposer OS independent code
**
** $VER: AllocSong.c 31.22 (19.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSong *AllocSong ( unsigned long Channels,
    unsigned long GoSubStack, unsigned long LoopStack )
{
  struct TuComposerSong *SongStr;
  struct TuComposerOrders *PosStr;

  if ( Channels == 0L )
    Channels = DEFAULTSONGCHANNELS;

  if ( Channels > MAXSONGCHANNELS )
    Channels = MAXSONGCHANNELS;

  if ( GoSubStack == 0L )
    GoSubStack = DEFAULTGOSUBSTACK;

  if ( LoopStack == 0L )
    LoopStack = DEFAULTPATTERNLOOPSTACK;

  if ( (SongStr = (struct TuComposerSong *) AllocPMem ( sizeof (struct TuComposerSong ))))
  {
    SongStr->tcso_GoSubStackSize = GoSubStack;
    SongStr->tcso_LoopStackSize = LoopStack;
    SongStr->tcso_Channels = Channels;
    SongStr->tcso_Frames = DEFAULTSONGTEMPO;
    SongStr->tcso_SPDSpeed = DEFAULTSONGSPDSPEED;
    SongStr->tcso_BPMTempo = DEFAULTSONGBPMTEMPO;
    SongStr->tcso_BPMSpeed = DEFAULTSONGBPMSPEED;
    SongStr->tcso_FramesLowerLimit = 1;
    SongStr->tcso_FramesUpperLimit = 0xFFFF;
    SongStr->tcso_SPDLowerLimit = 1;
    SongStr->tcso_SPDUpperLimit = 0xFFFF;
    SongStr->tcso_BPMTempoLowerLimit = 1;
    SongStr->tcso_BPMTempoUpperLimit = 0xFFFF;
    SongStr->tcso_BPMSpeedLowerLimit = 1;
    SongStr->tcso_BPMSpeedUpperLimit = 0xFFFF;
    SongStr->tcso_GlobalVolume = DEFAULTSONGVOLUME;

    InitNodeList ( (struct List *) &(SongStr->tcso_TrackList) );

    Stamp2Date ( &(SongStr->tcso_BeginDate), NULL );

    if (!( PosStr = AllocPosition ( Channels )))
      goto AllocSongErr;

    SetPosition ( SongStr, PosStr );

    if (!( SongStr->tcso_GlobalData = (struct PlayerGlobals *) AllocPMem (sizeof (struct PlayerGlobals ))))
      goto AllocSongErr;

    if (!( SongStr->tcso_ChannelData = (struct PlayerHostChannel *) AllocPMem ( Channels * sizeof (struct PlayerHostChannel ))))
      goto AllocSongErr;

    if (!( SongStr->tcso_GoSubStackPtr = (UWORD *) AllocPMem ( GoSubStack * Channels * 4 )))
      goto AllocSongErr;

    if (!( SongStr->tcso_LoopStackPtr = (UWORD *) AllocPMem ( LoopStack * Channels * 4 )))
      goto AllocSongErr;

    InitNodeList ( (struct List *) &(SongStr->tcso_UnknownChunks) );
  }

  return ( SongStr );

AllocSongErr:

  FreeSong ( SongStr );

  return ( NULL );
}
