/* TuComposer OS independent code
**
** $VER: CalcPlayerSpeed.c 31.22 (19.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG CalcPlayerSpeed ( struct TuComposerSong *SongStr )
{
  unsigned long long Tempo = 0LL;
  UWORD Speed;
  UBYTE SpeedMul;

  if ( SongStr )
  {
    struct PlayerGlobals *PGStr = SongStr->tcso_GlobalData;

    if ( SongStr->tcso_Flags & TCSOF_UseSPD )
    {
      PGStr->pg_Flags |= PGF_SPD;

      if ( (Speed = SongStr->tcso_SPDSpeed) > 10 )
      {
        Tempo = (ULONG) 989156 * Speed;

        if ( (SpeedMul = SongStr->tcso_SpeedMul ))
          Tempo *= SpeedMul;

        if ( (SpeedMul = SongStr->tcso_SpeedDiv ))
          Tempo /= SpeedMul;
      } else
      {
        Tempo = TuCBase->tcb_OldSTTable[Speed];
      }
    } else
    {
      PGStr->pg_Flags &= ~PGF_SPD;

      Tempo = (SongStr->tcso_BPMSpeed) * (SongStr->tcso_BPMTempo) << 16;

      if ( (SpeedMul = SongStr->tcso_SpeedMul ))
        Tempo *= SpeedMul;

      if ( (SpeedMul = SongStr->tcso_SpeedDiv ))
        Tempo /= SpeedMul;
    }

    PGStr->pg_SpeedMul = SongStr->tcso_SpeedMul;
    PGStr->pg_SpeedDiv = SongStr->tcso_SpeedDiv;
    PGStr->pg_SPDSpeed = SongStr->tcso_SPDSpeed;
    PGStr->pg_BPMTempo = SongStr->tcso_BPMTempo;
    PGStr->pg_BPMSpeed = SongStr->tcso_BPMSpeed;
    PGStr->pg_Tempo = Tempo;

    Tempo *= PGStr->pg_RelativeSpeed;
    Tempo >>= 16;
  }

  return ( Tempo );
}
