/* TuComposer OS independent code
**
** $VER: ClearSong.c 31.22 (20.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG ClearSong ( struct TuComposerSong *SongStr )
{
  if ( SongStr )
  {
    struct TuComposerTrack *TrackStr;
    struct TuComposerTrack *FreeTrackStr;
    struct UnknownChunk *UnknownChunkStr;
    struct UnknownChunk *FreeUnkChunk;

    if ( SongStr == TuCBase->tcb_PlaySong )
    {
      StopTCModule ();
      FreeSoundDevice ( TuCBase->tcb_PlaySoundDeviceBase->sdi_Library.extb_ExtLibList );
    }

    FreeNameStr ( SongStr->tcso_FileName );
    FreeNameStr ( SongStr->tcso_Name );
    FreeNameStr ( SongStr->tcso_Message );
    FreeNameStr ( SongStr->tcso_Composer );
    FreeNameStr ( SongStr->tcso_Style );
    FreeNameStr ( SongStr->tcso_Comment );

    TrackStr = (struct TuComposerTrack *) &(SongStr->tcso_TrackList);

    if ( TrackStr->tct_Node.mln_Succ )
    {
      for (;;)
      {
        FreeTrackStr = (struct TuComposerTrack *) TrackStr->tct_Node.mln_Succ;

        if (!( FreeTrackStr->tct_Node.mln_Succ ))
          break;

        FreeTrack ( FreeTrackStr );
      }
    }

    memset ( &(SongStr->tcso_FileName), 0, offsetof (struct TuComposerSong, tcso_GlobalData ) - offsetof (struct TuComposerSong, tcso_FileName ));
    memset ( &(SongStr->tcso_EndDate), 0, offsetof (struct TuComposerSong, tcso_Position ) - offsetof (struct TuComposerSong, tcso_EndDate ));

    ClearPosition ( SongStr->tcso_Position, SongStr->tcso_Channels );

    Stamp2Date ( &(SongStr->tcso_BeginDate), NULL );

    SongStr->tcso_CompFlags = 0;
    SongStr->tcso_Flags = 0;

    memset ( &(SongStr->tcso_Frames), 0, offsetof (struct TuComposerSong, tcso_UnknownChunks ) - offsetof (struct TuComposerSong, tcso_Frames ));

    SongStr->tcso_Frames = DEFAULTSONGTEMPO;
    SongStr->tcso_SPDSpeed = DEFAULTSONGSPDSPEED;
    SongStr->tcso_BPMTempo = DEFAULTSONGBPMTEMPO;
    SongStr->tcso_BPMSpeed = DEFAULTSONGBPMSPEED;
    SongStr->tcso_FramesLowerLimit = 1;
    SongStr->tcso_FramesUpperLimit = 0xFFFF;
    SongStr->tcso_SPDLowerLimit = 1;
    SongStr->tcso_SPDUpperLimit = 0xFFFF;
    SongStr->tcso_BPMTempoLowerLimit = 1;
    SongStr->tcso_BPMTempoUpperLimit = 0xFFFF;
    SongStr->tcso_BPMSpeedLowerLimit = 1;
    SongStr->tcso_BPMSpeedUpperLimit = 0xFFFF;
    SongStr->tcso_GlobalVolume = DEFAULTSONGVOLUME;

    memset ( SongStr->tcso_GlobalData, 0, sizeof (struct PlayerGlobals ));

    memset ( SongStr->tcso_ChannelData, 0, SongStr->tcso_Channels * sizeof (struct PlayerHostChannel ));

    UnknownChunkStr = (struct UnknownChunk *) &(SongStr->tcso_UnknownChunks.mlh_Head);

    for (;;)
    {
      FreeUnkChunk = (struct UnknownChunk *) UnknownChunkStr->uc_Node.mln_Succ;

      if (!( (struct UnknownChunk *) FreeUnkChunk->uc_Node.mln_Succ ))
        break;

      FreeUnknownChunk ( FreeUnkChunk );
    }

    return ( 0L );
  }

  return ( ERROR_SONG_NOGIVEN );
}
