/* TuComposer OS independent code
**
** $VER: DupSong.c 31.22 (20.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSong *DoDupSong ( struct TuComposerSong *SongStr, struct TuComposerSong *CloneSong );

#ifndef MOTOROLA
  ULONG ReadMLong ( UBYTE *Buffer );
#else
  #define ReadMLong( Buffer ) (*(ULONG *) (Buffer))
#endif

struct TuComposerSong *DupSong ( struct TuComposerSong *SongStr)
{
  return ( DoDupSong ( SongStr, NULL ));
}

struct TuComposerSong *DoDupSong ( struct TuComposerSong *SongStr, struct TuComposerSong *CloneSong )
{
  if ( SongStr )
  {
    if ( CloneSong == NULL )
      CloneSong = AllocSong ( SongStr->tcso_Channels, SongStr->tcso_GoSubStackSize, SongStr->tcso_LoopStackSize );

    if ( CloneSong )
    {
      struct TuComposerTrack *TrackStr;
      struct TuComposerTrack *CloneTrack;
      struct TuComposerOrders *PosStr;
      struct UnknownChunk *SongUnkChunk;
      struct UnknownChunk *CloneUnkChunk;

      if ( SongStr->tcso_FileName )
      {
        if (!( SetString ( (STRPTR *) &(CloneSong->tcso_FileName), SongStr->tcso_FileName )))
          goto DupSongErr;
      }

      if ( SongStr->tcso_Name )
      {
        if (!( SetString ( (STRPTR *) &(CloneSong->tcso_Name), SongStr->tcso_Name )))
          goto DupSongErr;
      }

      if ( SongStr->tcso_Message )
      {
        if (!( SetString ( (STRPTR *) &(CloneSong->tcso_Message), SongStr->tcso_Message )))
          goto DupSongErr;
      }

      if ( SongStr->tcso_Composer )
      {
        if (!( SetString ( (STRPTR *) &(CloneSong->tcso_Composer), SongStr->tcso_Composer )))
          goto DupSongErr;
      }

      if ( SongStr->tcso_Style )
      {
        if (!( SetString ( (STRPTR *) &(CloneSong->tcso_Style), SongStr->tcso_Style )))
          goto DupSongErr;
      }

      if ( SongStr->tcso_Comment )
      {
        if (!( SetString ( (STRPTR *) &(CloneSong->tcso_Comment), SongStr->tcso_Comment )))
          goto DupSongErr;
      }

      TrackStr = (struct TuComposerTrack *) &(SongStr->tcso_TrackList.mlh_Head);

      for (;;)
      {
        TrackStr = (struct TuComposerTrack *) TrackStr->tct_Node.mln_Succ;

        if (!( TrackStr->tct_Node.mln_Succ))
          break;

        if (!( CloneTrack = DupTrack ( TrackStr )))
          goto DupSongErr;

        AddTrack ( CloneSong, CloneTrack );
      }

      if ( SetSongChannels ( CloneSong, SongStr->tcso_Channels ))
        goto DupSongErr;

      if ( SetStack ( CloneSong, SongStr->tcso_GoSubStackSize, SongStr->tcso_LoopStackSize ))
        goto DupSongErr;

      memcpy ( &(CloneSong->tcso_BeginDate), &(SongStr->tcso_BeginDate), offsetof(struct TuComposerSong, tcso_Position) - offsetof(struct TuComposerSong, tcso_BeginDate));

      if (!( PosStr = DupPosition ( SongStr->tcso_Position, SongStr->tcso_Channels )))
        goto DupSongErr;

      SetPosition ( CloneSong, PosStr );

      TrackStr = (struct TuComposerTrack *) &(CloneSong->tcso_TrackList.mlh_Head);
      CloneTrack = (struct TuComposerTrack *) &(SongStr->tcso_TrackList.mlh_Head);

      for (;;)
      {
        CloneTrack = (struct TuComposerTrack *) CloneTrack->tct_Node.mln_Succ;

        if (!( CloneTrack->tct_Node.mln_Succ ))
          break;

        TrackStr = (struct TuComposerTrack *) TrackStr->tct_Node.mln_Succ;

        ReMapTrack ( CloneSong, TrackStr, CloneTrack );
      }

      memcpy ( &(CloneSong->tcso_LoopStackSize), &(SongStr->tcso_LoopStackSize), offsetof(struct TuComposerSong, tcso_UnknownChunks) - offsetof(struct TuComposerSong, tcso_LoopStackSize));

      SongUnkChunk = (struct UnknownChunk *) &(SongStr->tcso_UnknownChunks.mlh_Head);

      for (;;)
      {
        SongUnkChunk = (struct UnknownChunk *) SongUnkChunk->uc_Node.mln_Succ;

        if (!( SongUnkChunk->uc_Node.mln_Succ))
          break;

        if (!( CloneUnkChunk = AllocUnknownChunk ( (APTR) &(SongUnkChunk->uc_Data), ReadMLong ( (UBYTE *) &(SongUnkChunk->uc_Identifier[0])), ReadMLong ( (UBYTE *) &(SongUnkChunk->uc_Length[0])) )))
          goto DupSongErr;

        AddNodeTail ( (struct List *) &(CloneSong->tcso_UnknownChunks), (struct Node *) CloneUnkChunk );
      }
    }
  } else
  {
    CloneSong = NULL;
  }

  return ( CloneSong );

DupSongErr:

  FreeSong ( CloneSong );

  return ( NULL );
}
