/* TuComposer OS independent code
**
** $VER: FreeSong.c 31.22 (20.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG FreeSong ( struct TuComposerSong *SongStr )
{
  if ( SongStr )
  {
    struct TuComposerTrack *FreeTrackStr;
    struct UnknownChunk *SongUnkChunk;
    struct UnknownChunk *FreeUnkChunk;

    if ( SongStr == TuCBase->tcb_PlaySong )
    {
      StopTCModule ();

      FreeSoundDevice ( TuCBase->tcb_PlaySoundDeviceBase->sdi_Library.extb_ExtLibList );
      FreeMixer ( TuCBase->tcb_PlayMixerAlloc );

      FreePlayTCModule ();
    }

    if ( SongStr->tcso_Node.mln_Succ )
      DeleteSong ( SongStr );

    if ( SongStr->tcso_GlobalData )
      FreePMem ( SongStr->tcso_GlobalData, sizeof (struct PlayerGlobals ));

    if ( SongStr->tcso_ChannelData )
      FreePMem ( SongStr->tcso_ChannelData, SongStr->tcso_Channels * sizeof (struct PlayerHostChannel ));

    if ( SongStr->tcso_LoopStackPtr )
      FreePMem ( SongStr->tcso_LoopStackPtr, SongStr->tcso_Channels * SongStr->tcso_LoopStackSize * 4 );

    if ( SongStr->tcso_GoSubStackPtr )
      FreePMem ( SongStr->tcso_GoSubStackPtr, SongStr->tcso_Channels * SongStr->tcso_GoSubStackSize * 4 );

    FreePosition ( SongStr->tcso_Position, SongStr->tcso_Channels );

    for (;;)
    {
      FreeTrackStr = (struct TuComposerTrack *) SongStr->tcso_TrackList.mlh_Head;

      if (!( FreeTrackStr->tct_Node.mln_Succ ))
        break;

      FreeTrack ( FreeTrackStr );
    }

    FreeNameStr ( SongStr->tcso_FileName );
    FreeNameStr ( SongStr->tcso_Name );
    FreeNameStr ( SongStr->tcso_Message );
    FreeNameStr ( SongStr->tcso_Composer );
    FreeNameStr ( SongStr->tcso_Style );
    FreeNameStr ( SongStr->tcso_Comment );

    SongUnkChunk = (struct UnknownChunk *) &(SongStr->tcso_UnknownChunks.mlh_Head);

    for (;;)
    {
      FreeUnkChunk = (struct UnknownChunk *) SongUnkChunk->uc_Node.mln_Succ;
      if (!( (struct UnknownChunk *) FreeUnkChunk->uc_Node.mln_Succ ))
        break;

      FreeUnknownChunk ( FreeUnkChunk );
    }

    FreePMem ( SongStr, sizeof (struct TuComposerSong ));

    return ( 0L );
  }

  return ( ERROR_SONG_NOGIVEN );
}
