/* TuComposer OS independent code
**
** $VER: GetOptimalChannels.c 31.22 (20.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG GetOptimalChannels ( struct TuComposerSong *SongStr )
{
  ULONG Channels = 0L;

  if ( SongStr )
  {
    struct TuComposerOrders *PosStr;
    struct TuComposerOrderList *PosListStr;
    struct TuComposerTrack *TrackStr;
    struct TuComposerTrackData *TrackData;
    struct TuComposerTrackEffect *TrackFX;
    ULONG i, j;

    PosStr = SongStr->tcso_Position;

    if ( (Channels = SongStr->tcso_Channels) > 1 )
    {
      PosStr += Channels - 1;

      for (i = Channels - 1; i > 0; i--)
      {
        PosListStr = (struct TuComposerOrderList *) &(PosStr->tco_OrderData.mlh_Head);

        for (;;)
        {
          PosListStr = (struct TuComposerOrderList *) PosListStr->tcol_Node.mln_Succ;

          if (!( PosListStr->tcol_Node.mln_Succ ))
            break;

          if ( (TrackStr = PosListStr->tcol_Track) )
          {
            TrackData = TrackStr->tct_Data;

            for (j = (TrackStr->tct_Length) + 1; j > 0; j--)
            {
              if ( (TrackData->tctd_Octave != 0) || (TrackData->tctd_Note != 0) || (TrackData->tctd_Instrument != 0) )
                goto ScanOptChDone;

              TrackFX = (struct TuComposerTrackEffect *) TrackData->tctd_Effects.mlh_Head;

              if ( TrackFX->tcte_Node.mln_Succ )
                goto ScanOptChDone;

              TrackData++;
            }
          }
        }

        Channels--;
        PosStr--;
      }
    }
  }

ScanOptChDone:

  return ( Channels );
}
