/* TuComposer OS independent code
**
** $VER: GetSongArpeggios.c 31.22 (12.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerInstrArpeggio **GetSongArpeggios ( struct TuComposerSong *SongStr )
{
  struct TuComposerInstrArpeggio **ArpList = NULL;
  struct TuComposerInstr **InstrList;

  if ( (InstrList = GetSongInstrs ( SongStr )))
  {
    struct TuComposerModule *ModuleStr = (struct TuComposerModule *) &(SongStr->tcso_Node.mln_Succ);
    struct TuComposerInstrArpeggio **ArpTmp;
    ULONG NumArpeggios;

    for (;;)
    {
      ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

      if (!( ModuleStr->tcm_Node.mln_Pred ))
        break;
    }

    (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_SongList );

    NumArpeggios = GetNumArpeggios ( ModuleStr ) + 1;

    if ( ArpTmp = (struct TuComposerInstrArpeggio **) AllocPMem ( NumArpeggios * sizeof ( struct TuComposerInstrArpeggio *)))
    {
      struct TuComposerInstr **InstrScan = InstrList;
      ULONG Count = 1L;

      for (;;)
      {
        struct TuComposerInstr *CurrInstr;
        struct TuComposerInstrArpeggio *CurrArp;
        struct TuComposerInstrArpeggio **ArpScan = ArpTmp;

        if (!( CurrInstr = *InstrScan ))
          break;

        if ( (CurrArp = CurrInstr->tci_ArpeggioStructure ))
        {
          for (;;)
          {
            if (!( *ArpScan ))
            {
              *ArpScan = CurrArp;
              Count++;

              break;
            }

            if ( *ArpScan == CurrArp )
              break;
          }
        }

        InstrScan++;
      }

      if ( (ArpList = AllocPMem ( Count * sizeof (struct TuComposerInstrArpeggio *))))
        memcpy ( ArpList, ArpTmp, Count * sizeof (struct TuComposerInstrArpeggio *));

      FreePMem ( ArpTmp, NumArpeggios * sizeof (struct TuComposerInstrArpeggio *));
    }

    FreeSongInstrs ( InstrList );
  }

  return ( ArpList );
}
