/* TuComposer OS independent code
**
** $VER: GetSongEnvelopes.c 31.22 (12.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG CheckEnvelope ( struct TuComposerInstrEnvelope **InstrEnvStr, struct TuComposerInstrEnvelope *EnvStr );

struct TuComposerInstrEnvelope **GetSongEnvelopes ( struct TuComposerSong *SongStr )
{
  struct TuComposerInstrEnvelope **EnvList = NULL;
  struct TuComposerInstr **InstrList;

  if ( (InstrList = GetSongInstrs ( SongStr )))
  {
    struct TuComposerModule *ModuleStr = (struct TuComposerModule *) &(SongStr->tcso_Node.mln_Succ);
    struct TuComposerInstrEnvelope **EnvTmp;
    ULONG NumEnvelopes;

    for (;;)
    {
      ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

      if (!( ModuleStr->tcm_Node.mln_Pred ))
        break;
    }

    (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_SongList );

    NumEnvelopes = GetNumEnvelopes ( ModuleStr ) + 1;

    if ( EnvTmp = (struct TuComposerInstrEnvelope **) AllocPMem ( NumEnvelopes * sizeof ( struct TuComposerInstrEnvelope *)))
    {
      struct TuComposerInstr **InstrScan = InstrList;
      ULONG Count = 1L;

      for (;;)
      {
        struct TuComposerInstr *CurrInstr;
        struct TuComposerSample **InstrSmpStr;
        struct TuComposerSample **SampleList;

        if (!( CurrInstr = *InstrScan ))
          break;

        Count += CheckEnvelope ( EnvTmp, CurrInstr->tci_VolumeEnvelope );
        Count += CheckEnvelope ( EnvTmp, CurrInstr->tci_PanningEnvelope );
        Count += CheckEnvelope ( EnvTmp, CurrInstr->tci_SlideEnvelope );
        Count += CheckEnvelope ( EnvTmp, CurrInstr->tci_VibratoEnvelope );
        Count += CheckEnvelope ( EnvTmp, CurrInstr->tci_TremoloEnvelope );
        Count += CheckEnvelope ( EnvTmp, CurrInstr->tci_PannoloEnvelope );
        Count += CheckEnvelope ( EnvTmp, CurrInstr->tci_ChannoloEnvelope );
        Count += CheckEnvelope ( EnvTmp, CurrInstr->tci_SpenoloEnvelope );

        if (!( InstrSmpStr = GetInstrSamples ( CurrInstr )))
          goto ErrorOutOfMemory;

        SampleList = InstrSmpStr;

        for (;;)
        {
          struct TuComposerSample *SampleStr;

          if (!( SampleStr = *SampleList++ ))
            break;

          Count += CheckEnvelope ( EnvTmp, SampleStr->tcs_AutoVibratoEnv );
          Count += CheckEnvelope ( EnvTmp, SampleStr->tcs_AutoTremoloEnv );
          Count += CheckEnvelope ( EnvTmp, SampleStr->tcs_AutoPannoloEnv );
        }

        FreeInstrSamples ( InstrSmpStr );

        InstrScan++;
      }

      if ( (EnvList = AllocPMem ( Count * sizeof (struct TuComposerInstrEnvelope *))))
        memcpy ( EnvList, EnvTmp, Count * sizeof (struct TuComposerInstrEnvelope *));

ErrorOutOfMemory:

      FreePMem ( EnvTmp, NumEnvelopes * sizeof (struct TuComposerInstrEnvelope *));
    }

    FreeSongInstrs ( InstrList );
  }

  return ( EnvList );
}
