/* TuComposer OS independent code
**
** $VER: GetSongInfo.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_songbase_protos.h>

struct SongInfo *GetSongInfo ( struct CFHandle *CFHandle,
    struct TuComposerExtList *ExtLibStr, unsigned long NumSong )
{
  struct SongInfo *SongInfoStr = NULL;

  if ( CFHandle )
  {
    if (!( ExtLibStr ))
      ExtLibStr = IdentifySong ( CFHandle );

    if ( ExtLibStr )
    {
      if ( (SongInfoStr = (struct SongInfo *) AllocPMem (sizeof (struct SongInfo ))))
      {
        struct SongLibrary *ExtSongLibBase;

        if ( (ExtSongLibBase = (struct SongLibrary *) OpenExternalLib ( ExtLibStr )))
        {
          ULONG RC;

          RC = ExternalSongGetInfoBase ( CFHandle, SongInfoStr, NumSong, ExtSongLibBase );

          CloseExternalLib ( ExtLibStr );

          if (!( RC ))
          {
            FreeSongInfo ( SongInfoStr );

            SongInfoStr = NULL;
          }
        } else
        {
          FreePMem ( SongInfoStr, sizeof (struct SongInfo ));

          SongInfoStr = NULL;
        }
      }
    }
  }

  return ( SongInfoStr );
}
