/* TuComposer OS independent code
**
** $VER: GetSongKeyboards.c 31.22 (12.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerInstrKeyboard **GetSongKeyboards ( struct TuComposerSong *SongStr )
{
  struct TuComposerInstrKeyboard **KeybrdList = NULL;
  struct TuComposerInstr **InstrList;

  if ( (InstrList = GetSongInstrs ( SongStr )))
  {
    struct TuComposerModule *ModuleStr = (struct TuComposerModule *) &(SongStr->tcso_Node.mln_Succ);
    struct TuComposerInstrKeyboard **KeybrdTmp;
    ULONG NumKeyboards;

    for (;;)
    {
      ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

      if (!( ModuleStr->tcm_Node.mln_Pred ))
        break;
    }

    (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_SongList );

    NumKeyboards = GetNumKeyboards ( ModuleStr ) + 1;

    if ( KeybrdTmp = (struct TuComposerInstrKeyboard **) AllocPMem ( NumKeyboards * sizeof ( struct TuComposerInstrKeyboard *)))
    {
      struct TuComposerInstr **InstrScan = InstrList;
      ULONG Count = 1L;

      for (;;)
      {
        struct TuComposerInstr *CurrInstr;
        struct TuComposerInstrKeyboard *CurrKeybrd;
        struct TuComposerInstrKeyboard **KeybrdScan = KeybrdTmp;

        if (!( CurrInstr = *InstrScan ))
          break;

        if ( (CurrKeybrd = CurrInstr->tci_KeyboardDefs ))
        {
          for (;;)
          {
            if (!( *KeybrdScan ))
            {
              *KeybrdScan = CurrKeybrd;
              Count++;

              break;
            }

            if ( *KeybrdScan == CurrKeybrd )
              break;
          }
        }

        InstrScan++;
      }

      if ( (KeybrdList = AllocPMem ( Count * sizeof (struct TuComposerInstrKeyboard *))))
        memcpy ( KeybrdList, KeybrdTmp, Count * sizeof (struct TuComposerInstrKeyboard *));

      FreePMem ( KeybrdTmp, NumKeyboards * sizeof (struct TuComposerInstrKeyboard *));
    }

    FreeSongInstrs ( InstrList );
  }

  return ( KeybrdList );
}
