/* TuComposer OS independent code
**
** $VER: ReMapSong.c 31.22 (10.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG ReMapSong ( struct TuComposerSong *SongStr,
    struct TuComposerSong *NewSongStr )
{
  if ( SongStr && NewSongStr )
  {
    if ( SongStr != NewSongStr )
    {
      if ( TuCBase->tcb_PlaySong == SongStr )
      {
        StopTCModule ();

        FreeSoundDevice ( TuCBase->tcb_PlaySoundDeviceBase->sdi_Library.extb_ExtLibList );
      }

      if ( TuCBase->tcb_PlaySong == NewSongStr )
      {
        StopTCModule ();

        FreeSoundDevice ( TuCBase->tcb_PlaySoundDeviceBase->sdi_Library.extb_ExtLibList );
      }

      ClearSong ( NewSongStr );

      ReMapNodeList ( (struct List *) &(SongStr->tcso_TrackList), (struct List *) &(NewSongStr->tcso_TrackList) );

      memcpy ( NewSongStr->tcso_GlobalData, SongStr->tcso_GlobalData, sizeof (struct PlayerGlobals ));

      FreePMem ( NewSongStr->tcso_ChannelData, NewSongStr->tcso_Channels * sizeof (struct PlayerHostChannel ));
      FreePMem ( NewSongStr->tcso_LoopStackPtr, NewSongStr->tcso_Channels * NewSongStr->tcso_LoopStackSize * 4 );
      FreePMem ( NewSongStr->tcso_GoSubStackPtr, NewSongStr->tcso_Channels * NewSongStr->tcso_GoSubStackSize * 4 );

      FreePosition ( NewSongStr->tcso_Position, NewSongStr->tcso_Channels );

      memcpy ( &(NewSongStr->tcso_FileName), &(SongStr->tcso_FileName), offsetof (struct TuComposerSong, tcso_GlobalData) - offsetof (struct TuComposerSong, tcso_FileName ));
      memcpy ( &(NewSongStr->tcso_ChannelData), &(SongStr->tcso_ChannelData), offsetof (struct TuComposerSong, tcso_TrackList) - offsetof (struct TuComposerSong, tcso_ChannelData ));
      memcpy ( &(NewSongStr->tcso_GoSubStackPtr), &(SongStr->tcso_GoSubStackPtr), offsetof (struct TuComposerSong, tcso_UnknownChunks) - offsetof (struct TuComposerSong, tcso_GoSubStackPtr ));

      ReMapNodeList ( (struct List *) &(SongStr->tcso_UnknownChunks), (struct List *) &(NewSongStr->tcso_UnknownChunks) );

      if ( SongStr->tcso_Node.mln_Succ )
        DeleteSong ( SongStr );

      FreePMem ( SongStr, sizeof (struct TuComposerSong ));
    }

    return ( 0L );
  }

  return ( ERROR_SONG_NOGIVEN );
}
