/* TuComposer OS independent code
**
** $VER: ReMapSongInstrs.c 31.22 (20.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerTrack *ReMapSongInstrs ( struct TuComposerSong *SongStr,
    struct TuComposerTrack *TrackStr, struct TuComposerInstr **InstrList )
{
  struct TuComposerTrack *TrackBuf = NULL;

  if ( SongStr && TrackStr )
  {
    if ( (TrackBuf = DupTrack ( TrackStr )))
    {
      struct TuComposerModule *ModuleStr = (struct TuComposerModule *) &(SongStr->tcso_Node.mln_Succ);
      struct TuComposerTrackData *TrackData = TrackBuf->tct_Data;
      ULONG i;

      for (;;)
      {
        ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

        if (!( ModuleStr->tcm_Node.mln_Pred ))
          break;
      }

      (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_SongList );

      for (i = (TrackStr->tct_Length + 1); i > 0; i--)
      {
        if ( TrackData->tctd_Instrument )
        {
          struct TuComposerInstr **InstrScan = InstrList;
          struct TuComposerInstr *CurrInstr = GetInstrAddr ( ModuleStr, TrackData->tctd_Instrument );
          ULONG ReMapInstr = 0L;

          for (;;)
          {
            ReMapInstr++;

            if (!( *InstrScan ))
              break;

            if ( *InstrScan = CurrInstr )
              break;

            InstrScan++;
          }

          TrackData->tctd_Instrument = ReMapInstr;
        }

        TrackData++;
      }
    }
  }

  return ( TrackBuf );
}
