/* TuComposer OS independent code
**
** $VER: ResetSong.c 31.22 (20.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_mixerbase_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG ResetSong ( struct TuComposerSong *SongStr )
{
  if ( SongStr )
  {
    struct TuComposerModule *ModuleStr;
    struct TuComposerOrders *PosStr;
    struct TuComposerOrderList *PosListStr;
    struct PlayerGlobals *PGStr;
    struct PlayerHostChannel *PHCStr;
    ULONG i;
    UWORD Frames;

    if ( SongStr == TuCBase->tcb_PlaySong )
      StopTCModule ();

    PGStr = SongStr->tcso_GlobalData;

    memset ( &(PGStr->pg_PlayTime), 0, offsetof (struct PlayerGlobals, pg_Reserved ) - offsetof (struct PlayerGlobals, pg_PlayTime));

    PGStr->pg_Flags &= PGF_PlayOnce|PGF_NoProcPattern|PGF_PlayPattern;
    PGStr->pg_SpeedSlideToValue = 0;

    ModuleStr = (struct TuComposerModule *) &(SongStr->tcso_Node.mln_Succ);

    for (;;)
    {
      ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

      if (!( ModuleStr->tcm_Node.mln_Pred ))
        break;
    }

    (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_SongList );

    memset ( ModuleStr->tcm_ChannelData, 0, ModuleStr->tcm_Channels * sizeof (struct PlayerChannel ));

    if ( TuCBase->tcb_PlaySong == SongStr )
    {
      ULONG Channel = 0L;

      for (i = ModuleStr->tcm_Channels; i > 0; i--)
      {
        ExternalMixerSetChannelPosRepFlagsBase ( TuCBase->tcb_PlayMixerAlloc, (struct MixerStruct *) &(ModuleStr->tcm_ChannelData->pc_ChannelData), Channel, TuCBase->tcb_PlayMixerAlloc->mas_MixLibBase );

        Channel++;
      }
    }

    memset ( SongStr->tcso_ChannelData, 0, SongStr->tcso_Channels * sizeof (struct PlayerHostChannel ));

    PGStr->pg_GlobalVolume = SongStr->tcso_GlobalVolume;
    PGStr->pg_GlobalSubVol = SongStr->tcso_GlobalSubVol;
    PGStr->pg_GlobalPanning = SongStr->tcso_GlobalPanning;
    PGStr->pg_GlobalSubPan = SongStr->tcso_GlobalSubPan;

    if ( SongStr->tcso_Flags & TCSOF_Surround )
      PGStr->pg_Flags |= PGF_Surround;

    PHCStr = SongStr->tcso_ChannelData;
    Frames = SongStr->tcso_Frames;
    PosStr = SongStr->tcso_Position;

    for (i = SongStr->tcso_Channels; i > 0; i--)
    {
      PHCStr->phc_Tempo = Frames;
      PHCStr->phc_Order = (struct TuComposerOrderList *) PosStr;
      PHCStr->phc_MultiRetrigScale = 4;
      PHCStr->phc_TempoCounter = 0xFFFFFFFE;
      PHCStr->phc_TrackVolume = PosStr->tco_Volume;
      PHCStr->phc_TrackSubVol = PosStr->tco_SubVol;
      PHCStr->phc_TrackPanning = PosStr->tco_Panning;
      PHCStr->phc_TrackSubPan = PosStr->tco_SubPan;
      PHCStr->phc_TrackNotePan = PosStr->tco_Panning;
      PHCStr->phc_TrackNoteSubPan = PosStr->tco_SubPan;
      PHCStr->phc_Flags = PHCF_AffectChanPan;

      if ( PosStr->tco_Flags & TCOF_Surround )
        PHCStr->phc_Flags |= PHCF_TrackSurPan;

      if ( SongStr->tcso_Flags & TCSOF_LinearFreqTable )
        PHCStr->phc_Flags |= PHCF_LinearFreq;

      PHCStr->phc_ChControlType = CH_CTRL_GLOBAL;
      PHCStr->phc_ChControlAffect = PCAF_NoNotes;

      PosListStr = (struct TuComposerOrderList *) &(PosStr->tco_OrderData.mlh_Head);

      for (;;)
      {
        PosListStr = (struct TuComposerOrderList *) PosListStr->tcol_Node.mln_Succ;

        if (!( PosListStr->tcol_Node.mln_Succ ))
          break;

        PosListStr->tcol_Played = 0;
      }

      PosStr++;
      PHCStr++;
    }

    CalcPlayerSpeed ( SongStr );

    return ( 0L );
  }

  return ( ERROR_SONG_NOGIVEN );
}
