/* TuComposer OS independent code
**
** $VER: SetSongChannels.c 31.22 (20.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

ULONG SetStackNewCh ( struct TuComposerSong *SongStr, unsigned long GoSubStack, unsigned long LoopStack, unsigned long Channels );

extern struct TuComposerBase *TuCBase;

ULONG SetSongChannels ( struct TuComposerSong *SongStr,
    unsigned long Channels )
{
  struct TuComposerModule *ModuleStr;
  struct TuComposerOrders *PosStr;
  struct PlayerGlobals *PGStr;
  struct PlayerChannel *PCStr;
  struct TuComposerOrders *NewPosStr;
  struct PlayerHostChannel *NewPHCStr;
  ULONG UpdateCh, i;

  if ( SongStr )
  {
    if ( Channels == 0L )
      Channels = DEFAULTSONGCHANNELS;

    if ( Channels > MAXSONGCHANNELS )
      Channels = MAXSONGCHANNELS;

    if ( Channels != SongStr->tcso_Channels )
    {
      if (!( NewPosStr = AllocPosition ( Channels )))
        goto SetSongChErr;

      if (!( NewPHCStr = (struct PlayerHostChannel *) AllocPMem ( Channels * sizeof (struct PlayerHostChannel ))))
        goto SetSongChErr2;

      if ( SongStr == TuCBase->tcb_PlaySong )
        StopSoundDevice ( TuCBase->tcb_PlaySoundDeviceBase->sdi_Library.extb_ExtLibList );

      if ( SetStackNewCh ( SongStr, SongStr->tcso_GoSubStackSize, SongStr->tcso_LoopStackSize, Channels ))
        goto SetSongChErr3;

      PosStr = SongStr->tcso_Position;
      SongStr->tcso_Position = NULL;

      UpdateCh = Channels;

      if ( UpdateCh > SongStr->tcso_Channels )
        UpdateCh = SongStr->tcso_Channels;

      for (i = 0; i < UpdateCh; i++)
      {
        DupPositionChannel ( PosStr, NewPosStr, i, i );
      }

      SetPosition ( SongStr, NewPosStr );

      memcpy ( NewPHCStr, SongStr->tcso_ChannelData, UpdateCh * sizeof (struct PlayerHostChannel ));

      ModuleStr = (struct TuComposerModule *) &(SongStr->tcso_Node.mln_Succ);

      for (;;)
      {
        ModuleStr = (struct TuComposerModule *) ModuleStr->tcm_Node.mln_Pred;

        if (!( ModuleStr->tcm_Node.mln_Pred ))
          break;
      }

      (UBYTE *) ModuleStr += -offsetof (struct TuComposerModule, tcm_SongList );

      PGStr = SongStr->tcso_GlobalData;
      PCStr = ModuleStr->tcm_ChannelData;

      for (i = ModuleStr->tcm_Channels; i > 0; i--)
      {
        if ( PCStr->pc_HostChannel >= Channels )
        {
          PCStr->pc_ChannelData.ms_Flags = 0;
          PGStr->pg_Channels--;
        }

        PCStr++;
      }

      FreePosition ( PosStr, SongStr->tcso_Channels );

      FreePMem ( SongStr->tcso_ChannelData, SongStr->tcso_Channels * sizeof (struct PlayerHostChannel));

      SongStr->tcso_Channels = Channels;
      SongStr->tcso_ChannelData = NewPHCStr;

      if ( SongStr == TuCBase->tcb_PlaySong )
        PlayTCModule ( NULL );
    }

    return ( 0L );
  }

  return ( ERROR_SONG_NOGIVEN );

SetSongChErr3:

  FreePMem ( NewPHCStr, Channels * sizeof (struct PlayerHostChannel ));

SetSongChErr2:

  FreePosition ( NewPosStr, Channels );

SetSongChErr:

  return ( ERROR_SONG_NOMEM );

}
