/* TuComposer OS independent code
**
** $VER: SetStack.c 31.22 (20.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG SetStackNewCh ( struct TuComposerSong *SongStr, unsigned long GoSubStack, unsigned long LoopStack, unsigned long Channels );

extern struct TuComposerBase *TuCBase;

ULONG SetStack ( struct TuComposerSong *SongStr, unsigned long GoSubStack,
    unsigned long LoopStack )
{
  ULONG rc;

  rc = ERROR_SONG_NOGIVEN;

  if ( SongStr )
  {
    if ( SongStr == TuCBase->tcb_PlaySong )
      StopSoundDevice ( TuCBase->tcb_PlaySoundDeviceBase->sdi_Library.extb_ExtLibList );

    rc = SetStackNewCh ( SongStr, GoSubStack, LoopStack, SongStr->tcso_Channels );

    if ( SongStr == TuCBase->tcb_PlaySong )
      PlayTCModule ( NULL );
  }

  return ( rc );
}

ULONG SetStackNewCh ( struct TuComposerSong *SongStr, unsigned long GoSubStack,
    unsigned long LoopStack, unsigned long Channels )
{
  UWORD *NewGoSubStack = NULL;
  UWORD *NewLoopStack = NULL;
  ULONG *ProcStack;
  ULONG *ProcNewStack;
  UWORD SkipOvrCh, SkipOvrStack, SkipNewStack, SkipOldStack, i, j;

  if ( (Channels != SongStr->tcso_Channels) || (GoSubStack != SongStr->tcso_GoSubStackSize) )
  {
    if (!( NewGoSubStack = (UWORD *) AllocPMem ( Channels * GoSubStack * 4 )))
      goto SetStackErr;
  }

  if ( (Channels != SongStr->tcso_Channels) || (LoopStack != SongStr->tcso_LoopStackSize) )
  {
    if (!( NewLoopStack = (UWORD *) AllocPMem ( Channels * LoopStack * 4 )))
      goto SetStackErr2;
  }

  if ( NewGoSubStack )
  {
    SkipOvrCh = Channels;

    if ( SongStr->tcso_Channels < SkipOvrCh )
      SkipOvrCh = SongStr->tcso_Channels;

    SkipOvrStack = GoSubStack;

    if ( SongStr->tcso_GoSubStackSize < SkipOvrStack )
      SkipOvrStack = SongStr->tcso_GoSubStackSize;

    ProcStack = (ULONG *) SongStr->tcso_GoSubStackPtr;
    ProcNewStack = (ULONG *) NewGoSubStack;

    for (i = SkipOvrCh; i > 0; i--)
    {
      SkipNewStack = GoSubStack;
      SkipOldStack = SongStr->tcso_GoSubStackSize;

      for (j = SkipOvrStack; j > 0; j--)
      {
        *ProcNewStack++ = *ProcStack++;

        SkipNewStack--;
        SkipOldStack--;
      }

      ProcStack += SkipOldStack;
      ProcNewStack += SkipNewStack;
    }

    FreePMem ( SongStr->tcso_GoSubStackPtr, SongStr->tcso_Channels * SongStr->tcso_GoSubStackSize * 4 );

    SongStr->tcso_GoSubStackPtr = NewGoSubStack;
    SongStr->tcso_GoSubStackSize = GoSubStack;
  }

  if ( NewLoopStack )
  {
    SkipOvrCh = Channels;

    if ( SongStr->tcso_Channels < SkipOvrCh )
      SkipOvrCh = SongStr->tcso_Channels;

    SkipOvrStack = LoopStack;

    if ( SongStr->tcso_LoopStackSize < SkipOvrStack )
      SkipOvrStack = SongStr->tcso_LoopStackSize;

    ProcStack = (ULONG *) SongStr->tcso_LoopStackPtr;
    ProcNewStack = (ULONG *) NewLoopStack;

    for (i = SkipOvrCh; i > 0; i--)
    {
      SkipNewStack = LoopStack;
      SkipOldStack = SongStr->tcso_LoopStackSize;

      for (j = SkipOvrStack; j > 0; j--)
      {
        *ProcNewStack++ = *ProcStack++;

        SkipNewStack--;
        SkipOldStack--;
      }

      ProcStack += SkipOldStack;
      ProcNewStack += SkipNewStack;
    }

    FreePMem ( SongStr->tcso_LoopStackPtr, SongStr->tcso_Channels * SongStr->tcso_LoopStackSize * 4 );

    SongStr->tcso_LoopStackPtr = NewLoopStack;
    SongStr->tcso_LoopStackSize = LoopStack;
  }

  return ( 0L );

SetStackErr2:

  FreePMem ( NewGoSubStack, Channels * GoSubStack * 4);

SetStackErr:

  return ( ERROR_SONG_NOMEM );

}