/* TuComposer OS independent code
**
** $VER: SwapSong.c 31.22 (20.7.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG SwapSong ( struct TuComposerSong *SongBuf,
    struct TuComposerSong *SongStr )
{
  if ( SongStr && SongBuf )
  {
    if ( SongStr != SongBuf )
    {
      struct MinList TmpUnkChunk;
      struct MinList SwapUnkChunk;
      UBYTE *SrcBuf,*DestBuf;
      UBYTE TmpByte;
      ULONG i;

      ObtainSemaphore ( TuCBase->tcb_SongSigSem );

      TmpUnkChunk = SongBuf->tcso_UnknownChunks;
      ReMapNodeList ( (struct List *) &(SongStr->tcso_UnknownChunks), (struct List *) &(SongBuf->tcso_UnknownChunks));

      SwapUnkChunk = SongBuf->tcso_UnknownChunks;
      SongBuf->tcso_UnknownChunks = TmpUnkChunk;
      ReMapNodeList ( (struct List *) &(SongBuf->tcso_UnknownChunks), (struct List *) &(SongStr->tcso_UnknownChunks));

      SongBuf->tcso_UnknownChunks = SwapUnkChunk;

      SrcBuf = (UBYTE *) &(SongStr->tcso_FileName);
      DestBuf = (UBYTE *) &(SongBuf->tcso_FileName);

      for (i = (offsetof (struct TuComposerSong, tcso_TrackList) - offsetof (struct TuComposerSong, tcso_FileName)); i > 0; i--)
      {
        TmpByte = *DestBuf;
        *DestBuf++ = *SrcBuf;
        *SrcBuf++ = TmpByte;
      }

      TmpUnkChunk = SongBuf->tcso_TrackList;
      ReMapNodeList ( (struct List *) &(SongStr->tcso_TrackList), (struct List *) &(SongBuf->tcso_TrackList));

      SwapUnkChunk = SongBuf->tcso_TrackList;
      SongBuf->tcso_TrackList = TmpUnkChunk;
      ReMapNodeList ( (struct List *) &(SongBuf->tcso_TrackList), (struct List *) &(SongStr->tcso_TrackList));

      SongBuf->tcso_TrackList = SwapUnkChunk;

      SrcBuf = (UBYTE *) &(SongStr->tcso_GoSubStackPtr);
      DestBuf = (UBYTE *) &(SongBuf->tcso_GoSubStackPtr);

      for (i = (offsetof (struct TuComposerSong, tcso_UnknownChunks) - offsetof (struct TuComposerSong, tcso_GoSubStackPtr)); i > 0; i--)
      {
        TmpByte = *DestBuf;
        *DestBuf++ = *SrcBuf;
        *SrcBuf++ = TmpByte;
      }

      ReleaseSemaphore ( TuCBase->tcb_SongSigSem );
    }

    return ( 0L );
  }

  return ( ERROR_SONG_NOGIVEN );
}
