/* TuComposer OS independent code
**
** $VER: AddSynthCodeLine.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG AddSynthCodeLine ( struct TuComposerSynth *SynthStr,
    unsigned long Lines )
{
  if ( SynthStr )
  {
    ULONG OldLength = SynthStr->tcy_CodeEntries;
    ULONG Length = OldLength + Lines;

    if ( Length < 0x10000 )
    {
      struct TuComposerSynthCode *NewSynthCodeStr;

      if ( NewSynthCodeStr = (struct TuComposerSynthCode *) AllocPMem ( Length * sizeof (struct TuComposerSynthCode )))
      {
        struct TuComposerSynthCode *SynthCodeStr = SynthStr->tcy_SynthCode;

        memcpy ( NewSynthCodeStr, SynthCodeStr, OldLength * sizeof (struct TuComposerSynthCode ));

        FreePMem ( SynthCodeStr, OldLength * sizeof (struct TuComposerSynthCode ));

        SynthStr->tcy_CodeEntries = Length;
        SynthStr->tcy_SynthCode = NewSynthCodeStr;

        return ( 0L );
      }

      return ( ERROR_SYNTH_NOMEM );
    }

    return ( ERROR_SYNTH_TOOBIG );
  }

  return ( ERROR_SYNTH_NOGIVEN );
}
