/* TuComposer OS independent code
**
** $VER: AddSynthUnknownChunk.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifndef MOTOROLA
  ULONG ReadMLong ( UBYTE *Buffer );
#else
  #define ReadMLong( Buffer ) (*(ULONG *) (Buffer))
#endif

#ifdef __cplusplus
}
#endif

ULONG AddSynthUnknownChunk ( struct TuComposerSynth *SynthStr,
    struct UnknownChunk *UnknownChunkStr )
{
  if ( SynthStr )
  {
    if ( UnknownChunkStr )
    {
      struct UnknownChunk *ScanChunkStr;

      ScanChunkStr = (struct UnknownChunk *) &(SynthStr->tcy_UnknownChunks);

      for (;;)
      {
        ScanChunkStr = (struct UnknownChunk *) ScanChunkStr->uc_Node.mln_Succ;

        if (!( ScanChunkStr->uc_Node.mln_Succ ))
          break;

        if ( *(ULONG *) &(ScanChunkStr->uc_Identifier[0]) == *(ULONG *) &(UnknownChunkStr->uc_Identifier[0]) )
        {
          if ( (ReadMLong ( (UBYTE *) &(ScanChunkStr->uc_Identifier[0]))) == 'FORM' )
          {
            if ( *(ULONG *) &(ScanChunkStr->uc_Data[0]) == *(ULONG *) &(UnknownChunkStr->uc_Data[0]) )
            {
              FreeUnknownChunk ( ScanChunkStr );
              break;
            }
          } else
          {
            FreeUnknownChunk ( ScanChunkStr );
            break;
          }
        }
      }

      AddNodeTail ( (struct List *) &(SynthStr->tcy_UnknownChunks), (struct Node *) UnknownChunkStr );

      return ( 0L );
    }

    return ( ERROR_SYNTH_NODATA );
  }

  return ( ERROR_SYNTH_NOGIVEN );
}
