/* TuComposer OS independent code
**
** $VER: AddWaveformPoint.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG AddWaveformPoint ( struct TuComposerSynthWave * WaveformStr,
    unsigned long Points )
{
  if ( WaveformStr )
  {
    ULONG OldSamples = WaveformStr->tcyw_Samples;
    ULONG Samples = OldSamples + Points;

    if ( Samples > OldSamples )
    {
      BYTE *NewWaveData;
      ULONG OldLength = OldSamples, Length = Samples;

      if (!( WaveformStr->tcyw_Flags & TCYWF_8Bit ))
      {
        OldLength += OldLength;
        Length += Length;
      }

      if ( NewWaveData = (BYTE *) AllocPMem ( Length ))
      {
        BYTE *WaveData = (BYTE *) WaveformStr->tcyw_WaveData;

        memcpy ( NewWaveData, WaveData, OldLength );

        FreePMem ( WaveData, OldLength );

        WaveformStr->tcyw_Samples = Samples;
        WaveformStr->tcyw_Length = Length;
        WaveformStr->tcyw_WaveData = (WORD *) NewWaveData;

        return ( 0L );
      }

      return ( ERROR_SYNTH_NOMEM );
    }

    return ( ERROR_SYNTH_TOOBIG );
  }

  return ( ERROR_SYNTH_NOGIVEN );
}
