/* TuComposer OS independent code
**
** $VER: AllocSynth.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSynth *AllocSynth ( unsigned long CodeLen,
    unsigned long Waveforms, unsigned long WaveLen )
{
  struct TuComposerSynth *SynthStr = NULL;

  if (!( CodeLen ))
    CodeLen = DEFAULTSYNTHCODELINES;

  if (!( WaveLen ))
    WaveLen = DEFAULTSYNTHWAVELENGTH;

  if ( (CodeLen < 0x10000) && (Waveforms <= MAXWAVEFORMSPERSYNTH) )
  {
    if ( (SynthStr = (struct TuComposerSynth *) AllocPMem ( sizeof (struct TuComposerSynth ))))
    {
      struct TuComposerSynthWave *WaveformStr;
      ULONG i;

      InitNodeList ( (struct List *) &(SynthStr->tcy_Waves) );
      InitNodeList ( (struct List *) &(SynthStr->tcy_Symbol) );

      InitNodeList ( (struct List *) &(SynthStr->tcy_UnknownChunks) );

      if ( (SynthStr->tcy_SynthCode = AllocSynthCode ( CodeLen )))
      {
        SynthStr->tcy_CodeEntries = CodeLen;

        if ( Waveforms )
        {
          for (i = Waveforms; i > 0; i--)
          {
            if (!( WaveformStr = AllocWaveform ( WaveLen )))
              goto AllocSynthErr;

            AddWaveform ( SynthStr, WaveformStr );
          }
        }
      } else
      {

AllocSynthErr:

        FreeSynth ( SynthStr );

        SynthStr = NULL;
      }
    }
  }

  return ( SynthStr );
}
