/* TuComposer OS independent code
**
** $VER: AssembleCodeLine.c 31.22 (9.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <ctype.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

STRPTR AssembleCodeLine ( STRPTR AsmBuf, struct TuComposerSynth *SynthStr,
    unsigned long CodeLine, unsigned long Flags )
{
  struct TuComposerSynthCode *SynthCodeStr;
  struct TuComposerSynthSymbolTable *SymbolStr = (struct TuComposerSynthSymbolTable *) &(SynthStr->tcy_Symbol.mlh_Head);
  struct TuComposerSynthSymbolTable *NewSymbolStr;
  struct TuComposerSynthSymbolTable *LastSymbolStr = (struct TuComposerSynthSymbolTable *) SynthStr->tcy_Symbol.mlh_TailPred;
  struct TuComposerSynthSymbolTable *DelSymbolStr = NULL;
  struct SynthTable *SynthTable = TuCBase->tcb_SynthInstrTable;
  STRPTR TmpPos, ScanPos;
  LONG i, InstFlags;
  BYTE Instruction = 0, SrcVar = 0, DestVar = 0;
  UBYTE TmpChar, SignFlag;
  WORD InstData = 0, SrcFlag = 0, TmpBuf;

  if ( AsmBuf && SynthStr )
  {
    if ( CodeLine > 0xFFFF )
      return ( "Too many lines !" );

    if ( (TmpPos = strpbrk ( AsmBuf, "\r\n" )))
      *TmpPos = 0;

    AsmBuf += strspn ( AsmBuf, "\t " );

    if ( *AsmBuf == 0 )
      return ( "Unexpected end of line !" );

    if (!( TmpPos = strpbrk ( AsmBuf, "\t :" )))
      TmpPos = strchr ( AsmBuf, 0 );

    if ( *TmpPos == ':' )
    {
      *TmpPos = 0;

      if ( (NewSymbolStr = MatchSymbol ( SymbolStr, AsmBuf, CodeLine, SYMBOL_LABELDBL )))
      {
        *TmpPos = ':';

        if (!( Flags & ASCF_AllowDupLabel ))
          return ( "Label defined twice !" );

        NewSymbolStr->tsst_FirstLine = 0;
        NewSymbolStr->tsst_LastLine = 0xFFFF;
        NewSymbolStr->tsst_Flags = 0;
        NewSymbolStr->tsst_SymbolValue = CodeLine;
      } else
      {
        if ( (NewSymbolStr = MatchSymbol ( SymbolStr, AsmBuf, CodeLine, SYMBOL_LABELLINE )))
        {
          *TmpPos = ':';

          NewSymbolStr->tsst_Flags = 0;
          NewSymbolStr->tsst_SymbolValue = CodeLine;

          DelSymbolStr = SymbolStr;

          for (;;)
          {
            DelSymbolStr = (struct TuComposerSynthSymbolTable *) DelSymbolStr->tsst_Node.mln_Succ;

            if (!( DelSymbolStr->tsst_Node.mln_Succ ))
            {
              DelSymbolStr = NULL;

              break;
            }

            if ( DelSymbolStr->tsst_Type == SYMBOL_LABEL )
            {
              if ( (DelSymbolStr->tsst_FirstLine <= CodeLine) && (DelSymbolStr->tsst_LastLine >= CodeLine) )
              {
                if ( (DelSymbolStr->tsst_SymbolValue == CodeLine) && (DelSymbolStr == NewSymbolStr) )
                  break;
              }
            }
          }
        } else
        {
          if (!( Flags & ASCF_GenLabels ))
          {
            *TmpPos = ':';

            return ( "Can't create label !" );
          }

          NewSymbolStr = AllocSymbol ( AsmBuf );

          *TmpPos = ':';

          if (!( NewSymbolStr ))
            return ( "Label contains invalid characters !" );

          NewSymbolStr->tsst_Type = SYMBOL_LABEL;
          NewSymbolStr->tsst_SymbolValue = CodeLine;

          AddSymbol ( SynthStr, NewSymbolStr );

          NewSymbolStr = SymbolStr;

          for (;;)
          {
            NewSymbolStr = (struct TuComposerSynthSymbolTable *) NewSymbolStr->tsst_Node.mln_Succ;

            if ( NewSymbolStr == (struct TuComposerSynthSymbolTable *) SynthStr->tcy_Symbol.mlh_TailPred )
              break;

            if ( NewSymbolStr->tsst_Type == SYMBOL_LABEL )
            {
              if ( (NewSymbolStr->tsst_FirstLine <= CodeLine) && (NewSymbolStr->tsst_LastLine >= CodeLine) )
              {
                if ( NewSymbolStr->tsst_SymbolValue == CodeLine )
                  DelSymbolStr = NewSymbolStr;
              }
            }
          }
        }
      }

      AsmBuf = TmpPos + 1;
    } else
    {
      if ( Flags & ASCF_GenLabels )
      {
        NewSymbolStr = SymbolStr;

        for (;;)
        {
          NewSymbolStr = (struct TuComposerSynthSymbolTable *) NewSymbolStr->tsst_Node.mln_Succ;

          if (!( NewSymbolStr->tsst_Node.mln_Succ ))
            break;

          if ( NewSymbolStr->tsst_Type == SYMBOL_LABEL )
          {
            if ( (NewSymbolStr->tsst_FirstLine <= CodeLine) && (NewSymbolStr->tsst_LastLine >= CodeLine) )
            {
              if ( NewSymbolStr->tsst_SymbolValue == CodeLine )
                DelSymbolStr = NewSymbolStr;
            }
          }
        }
      }
    }

    AsmBuf += strspn ( AsmBuf, "\t " );

    if ( *AsmBuf == 0 )
    {
AsmCodeErr:

      TmpPos = "Unexpected end of line !";

      goto AssembleError;
    }

    for (i = 4; i >= 0; i--)
    {
      if (!( TmpChar = AsmBuf[i] ))
        break;

      TmpChar &= (~32);

      if ( TmpChar != SetFXInst[i] )
        break;
    }

    if ( i >= 0 )
    {
      for (;;)
      {
        if (!( SynthTable->stab_InstName[0] ))
          goto CheckInstrErr;

        ScanPos = (STRPTR) &(SynthTable->stab_InstName);
        TmpPos = AsmBuf;

        for (;;)
        {
          if (!( TmpChar = *ScanPos++ ))
            break;

          if ( *TmpPos == 0 )
            break;

          if ( toupper ( *TmpPos++ ) != TmpChar )
            break;
        }

        if (!( TmpChar ))
        {
          TmpChar = *TmpPos++;

          if ( (TmpChar == 0) || (TmpChar == ' ') || (TmpChar == 9) )
            break;
        }

        SynthTable++;
      }

      AsmBuf = TmpPos;

      Instruction = SynthTable->stab_InstCode;

      InstFlags = SynthTable->stab_InstFlags;
    } else
    {
      AsmBuf += 5;

      TmpChar = *AsmBuf++;

      if ( TmpChar == 0 )
        goto AsmCodeErr;

      if ( (TmpChar < '0') || (TmpChar > '7') )
      {
CheckInstrErr:

         TmpPos = "Unknown instruction !";

         goto AssembleError;
      }

      Instruction = (TmpChar - '0') << 4;

      TmpChar = toupper ( *AsmBuf++ );

      if ( TmpChar == 0 )
        goto AsmCodeErr;

      if ( ((TmpChar >= '0') && (TmpChar <= '9')) || ((TmpChar >= 'A') && (TmpChar <= 'F')) )
      {
        if ( TmpChar > '9' )
          TmpChar -= ('A' - '9' - 1);

        Instruction |= (TmpChar - '0');
        Instruction = ~Instruction;

        InstFlags = STABF_Source|STABF_NoSrcV0;
      } else
      {
        goto CheckInstrErr;
      }
    }

    if ( InstFlags & STABF_Source )
    {
      for (;;)
      {
        AsmBuf += strspn ( AsmBuf, "\t " );

        if (!( TmpChar = toupper ( *AsmBuf )))
          break;

        AsmBuf++;

        if ( TmpChar == ',' )
          break;

        if ( TmpChar == 'V' )
        {
          TmpPos = AsmBuf;

          if (!( TmpChar = *TmpPos++ ))
            goto CheckSrcSymbol;

          if ( (TmpChar < '0') || (TmpChar > '9') )
            goto CheckSrcSymbol;

          TmpBuf = TmpChar - '0';

          TmpChar = *TmpPos++;

          if ( (TmpChar >= '0') && (TmpChar <= '9') )
          {
            TmpBuf *= 10;
            TmpBuf += (TmpChar - '0');

            TmpChar = *TmpPos++;
          }

          if ( (TmpBuf > 15) || ((TmpChar != 0) && (TmpChar != 9) && (TmpChar != ' ') && (TmpChar != '+') && (TmpChar != '-') && (TmpChar != ',')) )
            goto CheckSrcSymbol;

          TmpPos--;

IsSrcVar:
          AsmBuf = TmpPos;

          if ( SrcFlag & 0xFF )
          {
CheckSrcParamErr:

            TmpPos = "Source parameter malformed !";

            goto AssembleError;
          }

          SrcVar = TmpBuf;

          SrcFlag |= 0xFF;
        } else if ( (TmpChar == '#') || (TmpChar == '$') || (TmpChar == '%') || (TmpChar == '+') || (TmpChar == '-') || ((TmpChar >= '0') && (TmpChar <= '9')) || ((TmpChar >= 'A') && (TmpChar <= 'F')) )
        {
          SignFlag = 0;

          TmpPos = AsmBuf + strspn ( AsmBuf, "\t " );

          if ( (TmpChar == '#') || (TmpChar == '$') || (TmpChar == '%') )
          {
            if ( *TmpPos == 0 )
              goto AsmCodeErr;

            AsmBuf--;
          } else if ( (TmpChar == '+') || (TmpChar == '-') )
          {
            TmpBuf = *TmpPos++;

            if ( TmpChar == '-' )
              SignFlag = ~SignFlag;

            if ( (TmpBuf == '#') || (TmpBuf == '$') || (TmpBuf == '%') )
            {
              TmpChar = TmpBuf;

              AsmBuf = TmpPos - 1;
            } else
            {
              AsmBuf = TmpPos;

              TmpPos--;
            }
          } else
          {
            TmpPos--;
          }

          TmpPos += strspn ( TmpPos, "\t " );

          for (;;)
          {
            if (!( TmpBuf = *TmpPos++ ))
              goto AsmCodeErr;

            if ( TmpBuf == '-' )
              SignFlag = ~SignFlag;

            if ( (TmpBuf != '+') && (TmpBuf != '-') )
              break;
          }

          TmpPos--;
          TmpPos += strspn ( TmpPos, "\t " );

          i = 0L;

          switch ( TmpChar )
          {
            case '#' :
            {
              for (;;)
              {
                TmpChar = *TmpPos++;

                if ( (TmpChar == 0) || (TmpChar == 9) || (TmpChar == ' ') || (TmpChar == '+') || (TmpChar == ',') )
                  break;

                if ( (TmpChar < '0') || (TmpChar > '9') )
                  goto CheckSrcParamErr;

                i *= 10;
                i += (TmpChar - '0');

                if ( i > 0xFFFF )
                  goto CheckSrcParamErr;
              }

              break;
            }
            case '%' :
            {
              for (;;)
              {
                TmpChar = *TmpPos++;

                if ( (TmpChar == 0) || (TmpChar == 9) || (TmpChar == ' ') || (TmpChar == '+') || (TmpChar == ',') )
                  break;

                if ( (TmpChar < '0') || (TmpChar > '1') )
                  goto CheckSrcParamErr;

                i += i;
                i += (TmpChar - '0');

                if ( i > 0xFFFF )
                  goto CheckSrcParamErr;
              }

              break;
            }
            default :
            {
              for (;;)
              {
                TmpChar = toupper ( *TmpPos++ );

                if ( (TmpChar == 0) || (TmpChar == 9) || (TmpChar == ' ') || (TmpChar == '+') || (TmpChar == ',') )
                  break;

                if ( ((TmpChar >= '0') && (TmpChar <= '9')) || ((TmpChar >= 'A') && (TmpChar <= 'F')) )
                {
                  i <<= 4;

                  if ( TmpChar > '9' )
                    TmpChar -= ('A' - '9' - 1);

                  i += (TmpChar - '0');
                } else
                {
                  if ( *AsmBuf != '$' )
                    goto CheckSrcSymbol;

                  i = -1L;
                }

                if ( (ULONG) i > 0xFFFF )
                  goto CheckSrcParamErr;
              }

              break;
            }
          }

          TmpPos--;

          TmpPos += strspn ( TmpPos, "\t " );

          if ( (TmpChar = *TmpPos++) == '+' )
            TmpPos++;

          AsmBuf = TmpPos - 1;

          if ( SrcFlag < 0 )
            goto CheckSrcParamErr;

          SrcFlag |= 0xFF00;

          if ( SignFlag )
            i = -i;

          InstData = i;
        } else
        {
CheckSrcSymbol:
          AsmBuf--;

          AsmBuf += strspn ( AsmBuf, "\t " );

          if (!( TmpPos = strpbrk ( AsmBuf, "\t #$%+-," )))
            TmpPos = strchr (AsmBuf, 0 );

          SignFlag = *TmpPos;
          *TmpPos = 0;

          if (!( NewSymbolStr = MatchSymbol ( SymbolStr, AsmBuf, CodeLine, SYMBOL_ANY )))
          {
InvSymbolErr:

            *TmpPos = SignFlag;

            TmpPos = "Symbol not defined !";

            goto AssembleError;
          }

          *TmpPos = SignFlag;

          TmpBuf = NewSymbolStr->tsst_SymbolValue;

          if ( (NewSymbolStr->tsst_Type == SYMBOL_SRC_VAR) || (NewSymbolStr->tsst_Type == SYMBOL_VARIABLE) )
            goto IsSrcVar;

          if (!( (NewSymbolStr->tsst_Type == SYMBOL_LABEL) && (InstFlags & STABF_SrcLine) ))
          {
            if ( NewSymbolStr->tsst_Type )
              goto InvSymbolErr;
          }

          if ( SrcFlag < 0 )
            goto CheckSrcParamErr;

          SrcFlag |= 0xFF00;

          AsmBuf = TmpPos + strspn ( TmpPos, "\t " );

          if ( (*AsmBuf == '+') || (*AsmBuf == '-') )
            AsmBuf++;

          InstData = TmpBuf;
        }
      }

      if (!(( SrcFlag ) || ( InstFlags & STABF_SrcNotReq )) )
      {
        if ( TmpChar == 0 )
          goto AsmCodeErr;

        TmpPos = "Source parameter required !";

        goto AssembleError;
      }
    }

    if ( InstFlags & STABF_Dest )
    {
      AsmBuf += strspn ( AsmBuf, "\t " );

      if (!( TmpChar = *AsmBuf) )
        goto AsmCodeErr;

      if ( TmpChar == 'v' || TmpChar == 'V' )
      {
        TmpPos = AsmBuf;
        TmpPos++;

        if (!( TmpChar = *TmpPos++ ))
          goto CheckDestSymbol;

        if ( (TmpChar < '0') || (TmpChar > '9') )
          goto CheckDestSymbol;

        TmpBuf = TmpChar - '0';

        TmpChar = *TmpPos++;

        if ( (TmpChar >= '0') && (TmpChar <= '9') )
        {
          TmpBuf *= 10;
          TmpBuf += (TmpChar - '0');

          TmpChar = *TmpPos++;
        }

        if ( (TmpBuf > 15) || ((TmpChar != 0) && (TmpChar != 9) && (TmpChar != ' ') && (TmpChar != ':')) )
          goto CheckDestSymbol;

        TmpPos--;

IsDestVar:
        AsmBuf = TmpPos;

        DestVar = TmpBuf;
      } else
      {
CheckDestSymbol:

        AsmBuf += strspn ( AsmBuf, "\t " );

        if (!( TmpPos = strpbrk ( AsmBuf, "\t :" )))
            TmpPos = strchr (AsmBuf, 0 );

        SignFlag = *TmpPos;
        *TmpPos = 0;

        if (!( NewSymbolStr = MatchSymbol ( SymbolStr, AsmBuf, CodeLine, SYMBOL_ANY )))
          goto InvSymbolErr;

        *TmpPos = SignFlag;

        TmpBuf = NewSymbolStr->tsst_SymbolValue;

        if ( (NewSymbolStr->tsst_Type == SYMBOL_DEST_VAR) || (NewSymbolStr->tsst_Type == SYMBOL_VARIABLE) )
          goto IsDestVar;

        goto InvSymbolErr;
      }

      if ( (InstFlags & STABF_DestDbl) && (DestVar < 15) )
      {
        AsmBuf += strspn ( AsmBuf, "\t " );

        if ( *AsmBuf++ != ':' )
        {
          TmpPos = "Double variable instruction !";

          goto AssembleError;
        }

        AsmBuf += strspn ( AsmBuf, "\t " );

        if (!( TmpChar = *AsmBuf) )
          goto AsmCodeErr;

        if ( TmpChar == 'v' || TmpChar == 'V' )
        {
          TmpPos = AsmBuf;
          TmpPos++;

          if (!( TmpChar = *TmpPos++ ))
            goto CheckDestDblSymbol;

          if ( (TmpChar < '0') || (TmpChar > '9') )
            goto CheckDestDblSymbol;

          TmpBuf = TmpChar - '0';

          TmpChar = *TmpPos++;

          if ( (TmpChar >= '0') && (TmpChar <= '9') )
          {
            TmpBuf *= 10;
            TmpBuf += (TmpChar - '0');

            TmpChar = *TmpPos++;
          }

          if ( (TmpBuf > 15) || ((TmpChar != 0) && (TmpChar != 9) && (TmpChar != ' ')) )
            goto CheckDestDblSymbol;

          TmpPos--;

IsDestDblVar:
          AsmBuf = TmpPos;

          if ( (DestVar + 1) != TmpBuf )
          {
            TmpPos = "Invalid double variable specified !";

            goto AssembleError;
          }
        } else
        {
CheckDestDblSymbol:

          AsmBuf += strspn ( AsmBuf, "\t " );

          if (!( TmpPos = strpbrk ( AsmBuf, "\t " )))
            TmpPos = strchr (AsmBuf, 0 );

          SignFlag = *TmpPos;
          *TmpPos = 0;

          if (!( NewSymbolStr = MatchSymbol ( SymbolStr, AsmBuf, CodeLine, SYMBOL_ANY )))
            goto InvSymbolErr;

          *TmpPos = SignFlag;

          TmpBuf = NewSymbolStr->tsst_SymbolValue;

          if ( (NewSymbolStr->tsst_Type == SYMBOL_DEST_VAR) || (NewSymbolStr->tsst_Type == SYMBOL_VARIABLE) )
            goto IsDestDblVar;

          goto InvSymbolErr;
        }
      }
    }

    AsmBuf += strspn ( AsmBuf, "\t " );

    if ( *AsmBuf )
    {
      TmpPos = "Too many parameters !";

      goto AssembleError;
    }

    if ( CodeLine >= SynthStr->tcy_CodeEntries )
    {
      if ( ReSizeSynthCode ( SynthStr, CodeLine + 1 ))
      {
        TmpPos = "Out of memory !";

        goto AssembleError;
      }
    }

    SynthCodeStr = (SynthStr->tcy_SynthCode) + CodeLine;

    SynthCodeStr->tcyc_Instruction = Instruction;
    SynthCodeStr->tcyc_SrcDestVar = (SrcVar << 4) + DestVar;
    SynthCodeStr->tcyc_InstData = InstData;

    FreeSymbol ( DelSymbolStr );
  }

  return ( NULL );

AssembleError:

  if ( LastSymbolStr != (struct TuComposerSynthSymbolTable *) SynthStr->tcy_Symbol.mlh_TailPred )
    FreeSymbol ( (struct TuComposerSynthSymbolTable *) SynthStr->tcy_Symbol.mlh_TailPred );

  return ( TmpPos );
}
