/* TuComposer OS independent code
**
** $VER: ClearSynth.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ClearSynth ( struct TuComposerSynth *SynthStr )
{
  if ( SynthStr )
  {
    struct TuComposerSynthWave *WaveformStr;
    struct TuComposerSynthWave *FreeWaveformStr;
    struct TuComposerSynthSymbolTable *SymbolStr;
    struct TuComposerSynthSymbolTable *FreeSymbolStr;
    struct TuComposerSynthCode *SynthCodeStr;
    struct UnknownChunk *UnknownChunkStr;
    struct UnknownChunk *FreeUnkChunk;

    FreeNameStr ( SynthStr->tcy_FileName );
    SynthStr->tcy_FileName = NULL;

    FreeNameStr ( SynthStr->tcy_Name );
    SynthStr->tcy_Name = NULL;

    WaveformStr = (struct TuComposerSynthWave *) &(SynthStr->tcy_Waves.mlh_Head);

    for (;;)
    {
      FreeWaveformStr = (struct TuComposerSynthWave *) WaveformStr->tcyw_Node.mln_Succ;

      if (!( FreeWaveformStr->tcyw_Node.mln_Succ ))
        break;

      FreeWaveform ( FreeWaveformStr );
    }

    SymbolStr = (struct TuComposerSynthSymbolTable *) &(SynthStr->tcy_Symbol.mlh_Head);

    for (;;)
    {
      FreeSymbolStr = (struct TuComposerSynthSymbolTable *) SymbolStr->tsst_Node.mln_Succ;

      if (!( FreeSymbolStr->tsst_Node.mln_Succ ))
        break;

      FreeSymbol ( FreeSymbolStr );
    }

    if ( (SynthCodeStr = AllocSynthCode ( DEFAULTSYNTHCODELINES )))
      AssignSynthCode ( SynthStr, SynthCodeStr, DEFAULTSYNTHCODELINES );

    memset ( &(SynthStr->tcy_VolumePos), 0, offsetof (struct TuComposerSynth, tcy_UnknownChunks) - offsetof (struct TuComposerSynth, tcy_VolumePos ));

    UnknownChunkStr = (struct UnknownChunk *) &(SynthStr->tcy_UnknownChunks.mlh_Head);

    for (;;)
    {
      FreeUnkChunk = (struct UnknownChunk *) UnknownChunkStr->uc_Node.mln_Succ;

      if (!( (struct UnknownChunk *) FreeUnkChunk->uc_Node.mln_Succ ))
        break;

      FreeUnknownChunk ( FreeUnkChunk );
    }

    return ( 0L );
  }

  return ( ERROR_SYNTH_NOGIVEN );
}
