/* TuComposer OS independent code
**
** $VER: CmpWaveforms.c 31.22 (10.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

LONG CmpWaveforms ( struct TuComposerSynthWave *SrcWaveformStr,
    struct TuComposerSynthWave *DestWaveformStr )
{
  if ( SrcWaveformStr && DestWaveformStr )
  {
    if ( SrcWaveformStr == DestWaveformStr )
      goto WaveformsEqual;

    if ( SrcWaveformStr->tcyw_FileName != DestWaveformStr->tcyw_FileName )
    {
      if ( (SrcWaveformStr->tcyw_FileName == NULL) || (DestWaveformStr->tcyw_FileName == NULL) )
        goto WaveformsNotEqual;

      if ( strcmp ( SrcWaveformStr->tcyw_FileName, DestWaveformStr->tcyw_FileName ))
        goto WaveformsNotEqual;
    }

    if ( SrcWaveformStr->tcyw_Name != DestWaveformStr->tcyw_Name )
    {
      if ( (SrcWaveformStr->tcyw_Name == NULL) || (DestWaveformStr->tcyw_Name == NULL) )
        goto WaveformsNotEqual;

      if ( strcmp ( SrcWaveformStr->tcyw_Name, DestWaveformStr->tcyw_Name ))
        goto WaveformsNotEqual;
    }

    if ( memcmp ( &(SrcWaveformStr->tcyw_Length), &(DestWaveformStr->tcyw_Length), offsetof (struct TuComposerSynthWave, tcyw_Reserved) - offsetof (struct TuComposerSynthWave, tcyw_Length )))
      goto WaveformsNotEqual;

    if ( SrcWaveformStr->tcyw_WaveData != DestWaveformStr->tcyw_WaveData )
    {
      if ( ( SrcWaveformStr->tcyw_WaveData == NULL) || ( DestWaveformStr->tcyw_WaveData == NULL) )
        goto WaveformsNotEqual;

      if ( memcmp ( SrcWaveformStr->tcyw_WaveData, DestWaveformStr->tcyw_WaveData, SrcWaveformStr->tcyw_Length ))
        goto WaveformsNotEqual;
    }

WaveformsEqual:
    return ( 0L );

WaveformsNotEqual:
    return ( 1L );

  }

  return ( ERROR_SYNTH_NODATA );
}
