/* TuComposer OS independent code
**
** $VER: CopyWaveform.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSynthWave *DoDupWaveform ( struct TuComposerSynthWave *WaveformStr, struct TuComposerSynthWave *CloneWaveform );

extern struct TuComposerBase *TuCBase;

struct TuComposerSynthWave *CopyWaveform ( struct TuComposerSynthWave
    *WaveformStr, struct TuComposerSynthWave *WaveformBuf )
{
  if ( WaveformBuf )
  {
    ObtainSemaphore ( TuCBase->tcb_WavesSigSem );

    if (!( ReSizeWaveform ( WaveformBuf, WaveformStr->tcyw_Samples )))
    {
      ClearWaveform ( WaveformBuf );
      WaveformBuf = DoDupWaveform ( WaveformStr, WaveformBuf );

      ReleaseSemaphore ( TuCBase->tcb_WavesSigSem );

      return ( WaveformBuf );
    }

    ReleaseSemaphore ( TuCBase->tcb_WavesSigSem );

    return ( NULL );
  }

  return ( PushWaveform ( WaveformStr ));
}
