/* TuComposer OS independent code
**
** $VER: DeleteSynthCodeLine.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG DeleteSynthCodeLine ( struct TuComposerSynth *SynthStr,
    unsigned long Line, unsigned long Lines, unsigned long Flags )
{
  if ( SynthStr )
  {
    struct TuComposerSynthCode *SynthCodeStr = SynthStr->tcy_SynthCode;
    struct TuComposerSynthCode *CopySynthCode;
    struct TuComposerSynthSymbolTable *SymbolStr = (struct TuComposerSynthSymbolTable *) &(SynthStr->tcy_Symbol.mlh_Head);
    ULONG SynthCodeLen = SynthStr->tcy_CodeEntries;
    ULONG NewLen, CopyDestNum;

    if (Line >= SynthCodeLen)
      return ( 0L );

    Lines = ((Lines + Line) < SynthCodeLen ? Lines : SynthCodeLen - Line);
    CopyDestNum = (Line + Lines);

    if (Flags & CODF_LinesOnly)
    {
      memmove ( SynthCodeStr + Line, SynthCodeStr + CopyDestNum, Line * sizeof (struct TuComposerSynthCode ));

      memset ( SynthCodeStr + CopyDestNum, 0, Lines * sizeof (struct TuComposerSynthCode ));

      if ( (SymbolStr->tsst_Type == SYMBOL_LABEL) && (SymbolStr->tsst_FirstLine <= Line) && (SymbolStr->tsst_LastLine >= Line) )
      {
        if ( SymbolStr->tsst_SymbolValue >= Line )
          SymbolStr->tsst_SymbolValue -= Lines;

        SymbolStr->tsst_LastLine = (( (LONG) ( SymbolStr->tsst_LastLine - Lines) >= (LONG) Line) ? SymbolStr->tsst_LastLine - Line : Line);
      }

      return ( 0L );
    }

    NewLen = ( CopyDestNum < SynthCodeLen ? SynthCodeLen - Lines : Line );

    if ( NewLen )
    {
      if ( CopySynthCode = (struct TuComposerSynthCode *) AllocPMem ( NewLen * sizeof (struct TuComposerSynthCode )))
      {
        struct TuComposerSynthCode *SrcTmpData = SynthCodeStr;
        struct TuComposerSynthCode *CopyTmpData = CopySynthCode;

        if ( Line )
        {
          memcpy ( CopyTmpData, SrcTmpData, Line * sizeof (struct TuComposerSynthCode ));

          SrcTmpData += Line;
          CopyTmpData += Line;
        }

        memcpy ( CopyTmpData, SrcTmpData + Lines, ((SynthCodeLen - Line) - Lines) * sizeof (struct TuComposerSynthCode ));

        FreePMem ( SynthCodeStr, SynthCodeLen * sizeof (struct TuComposerSynthCode ));

        SynthStr->tcy_SynthCode = CopySynthCode;
        SynthStr->tcy_CodeEntries = SynthCodeLen;

        for (;;)
        {
          SymbolStr = (struct TuComposerSynthSymbolTable *) SymbolStr->tsst_Node.mln_Succ;

          if (!( SymbolStr->tsst_Node.mln_Succ ))
            break;

          if ( (SymbolStr->tsst_Type == SYMBOL_LABEL) && (SymbolStr->tsst_FirstLine <= Line) && (SymbolStr->tsst_LastLine >= Line) )
          {
            if ( SymbolStr->tsst_SymbolValue >= Line )
              SymbolStr->tsst_SymbolValue -= Lines;

            SymbolStr->tsst_LastLine = (( (LONG) ( SymbolStr->tsst_LastLine - Lines) >= (LONG) Line) ? SymbolStr->tsst_LastLine - Line : Line);
          }
        }

        return ( 0L );
      }

      return ( ERROR_SYNTH_NOMEM );
    }

    return ( ERROR_SYNTH_TOOSMALL );
  }

  return ( ERROR_SYNTH_NOGIVEN );
}
