/* TuComposer OS independent code
**
** $VER: DeleteWaveformPoint.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG DeleteWaveformPoint ( struct TuComposerSynthWave *WaveformStr,
    unsigned long Point, unsigned long Points, unsigned long Flags )
{
  if ( WaveformStr )
  {
    BYTE *WaveData = (BYTE *) WaveformStr->tcyw_WaveData;
    BYTE *CopyData;
    ULONG WaveLen = WaveformStr->tcyw_Samples;
    ULONG NewLen, CopyDestNum;

    if (Point >= WaveLen)
      return ( 0L );

    Points = ((Points + Point) < WaveLen ? Points : WaveLen - Point);
    CopyDestNum = (Point + Points);

    if (Flags & WAVF_PointsOnly)
    {
      if (!( WaveformStr->tcyw_Flags & TCYWF_8Bit ))
      {
        Point += Point;
        Points += Points;
        CopyDestNum += CopyDestNum;
      }

      memmove ( WaveData + Point, WaveData + CopyDestNum, Point );

      memset ( WaveData + CopyDestNum, 0, Points );

      return ( 0L );
    }

    NewLen = ( CopyDestNum < WaveLen ? WaveLen - Points : Point );

    if ( NewLen )
    {
      if (!( WaveformStr->tcyw_Flags & TCYWF_8Bit ))
      {
        Point += Point;
        Points += Points;
        CopyDestNum += CopyDestNum;
        NewLen += NewLen;
        WaveLen += WaveLen;
      }

      if ( (CopyData = (BYTE *) AllocPMem ( NewLen )))
      {
        BYTE *SrcTmpData = WaveData;
        BYTE *CopyTmpData = CopyData;

        if ( Point )
        {
          memcpy ( CopyTmpData, SrcTmpData, Point );

          SrcTmpData += Point;
          CopyTmpData += Point;
        }

        memcpy ( CopyTmpData, SrcTmpData + Points, ((WaveLen - Point) - Points));

        FreePMem ( WaveData, WaveLen );

        WaveformStr->tcyw_WaveData = (WORD *) CopyData;
        WaveformStr->tcyw_Length = NewLen;
        WaveformStr->tcyw_Samples = NewLen;

        if (!( WaveformStr->tcyw_Flags & TCYWF_8Bit ))
        {
          NewLen /= 2;

          WaveformStr->tcyw_Samples = NewLen;
        }

        if ( WaveformStr->tcyw_Repeat >= NewLen )
          WaveformStr->tcyw_Repeat = NewLen - 1;

        if ( (WaveformStr->tcyw_Repeat + WaveformStr->tcyw_RepLen) > NewLen )
          WaveformStr->tcyw_RepLen = NewLen - WaveformStr->tcyw_Repeat;

        return ( 0L );
      }

      return ( ERROR_SYNTH_NOMEM );
    }

    return ( ERROR_SYNTH_TOOSMALL );
  }

  return ( ERROR_SYNTH_NODATA );
}
