/* TuComposer OS independent code
**
** $VER: DisassembleCodeLine.c 31.22 (8.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <ctype.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;
extern UBYTE UCHexConvTable[];
extern UBYTE LCHexConvTable[];

ULONG DisassembleCodeLine ( STRPTR AsmBuf, struct TuComposerSynth *SynthStr,
    unsigned long CodeLine, unsigned long Flags )
{
  if ( AsmBuf )
  {
    *AsmBuf = 0;

    if ( SynthStr )
    {
      ULONG LargestSymbol = 0L, SymbolLen, InstFlags;
      BYTE Instruction, SrcVar, DestVar;
      UBYTE InstName[9] = "\0\0\0\0\0\0\0 \0";
      WORD SrcFlag = 0;
      UWORD InstData;
      struct TuComposerSynthCode *SynthCodeStr;
      struct TuComposerSynthSymbolTable *SymbolStr = (struct TuComposerSynthSymbolTable *) &(SynthStr->tcy_Symbol.mlh_Head);

      if ( SynthStr->tcy_CodeEntries <= CodeLine )
        return ( ERROR_SYNTH_TOOSMALL );

      if (!( Flags & DASCF_NotEvalSyms ))
      {
        for (;;)
        {
          SymbolStr = (struct TuComposerSynthSymbolTable *) SymbolStr->tsst_Node.mln_Succ;

          if (!( SymbolStr->tsst_Node.mln_Succ ))
            break;

          if ( (SymbolStr->tsst_Flags & TCYSTF_Unused) || (SymbolStr->tsst_Type != SYMBOL_LABEL) )
            continue;

          if ( (SymbolLen = strlen ( SymbolStr->tsst_SymbolName ) + 2) > LargestSymbol )
            LargestSymbol = SymbolLen;
        }

        SymbolStr = (struct TuComposerSynthSymbolTable *) &(SynthStr->tcy_Symbol.mlh_Head);

        for (;;)
        {
          SymbolStr = (struct TuComposerSynthSymbolTable *) SymbolStr->tsst_Node.mln_Succ;

          if (!( SymbolStr->tsst_Node.mln_Succ ))
            break;

          if ( (SymbolStr->tsst_Flags & TCYSTF_Unused) || (SymbolStr->tsst_Type != SYMBOL_LABEL) )
            continue;

          if ( SymbolStr->tsst_SymbolValue == CodeLine )
          {
            strncat ( AsmBuf, SymbolStr->tsst_SymbolName, 256 );
            strncat ( AsmBuf, ":", 256 );

            LargestSymbol -= strlen ( SymbolStr->tsst_SymbolName ) + 1;

            break;
          }
        }
      }

      if ( LargestSymbol )
      {
        ULONG i;

        for (i = LargestSymbol; i > 0; i--)
        {
          strncat ( AsmBuf, " ", 256 );
        }
      }

      SynthCodeStr = SynthStr->tcy_SynthCode + CodeLine;

      Instruction = SynthCodeStr->tcyc_Instruction;
      SrcVar = SynthCodeStr->tcyc_SrcDestVar >> 4;
      DestVar = SynthCodeStr->tcyc_SrcDestVar & 0xF;
      InstData = SynthCodeStr->tcyc_InstData;

      if ( Instruction < 0 )
      {
        Instruction = ~Instruction;

        strcpy ( InstName, SetFXInst );

        InstName[5] = UCHexConvTable [Instruction >> 4];
        InstName[6] = UCHexConvTable [Instruction & 0xF];

        InstFlags = STABF_Source|STABF_NoSrcV0;
      } else
      {
        struct SynthTable *SynthTable = TuCBase->tcb_SynthInstrTable;

        for (;;)
        {
          if (!( SynthTable->stab_InstName[0] ))
          {
            strcpy ( InstName, InstrInst );

            InstName[5] = UCHexConvTable [Instruction >> 4];
            InstName[6] = UCHexConvTable [Instruction & 0xF];

            InstFlags = 0;

            break;
          }

          if ( SynthTable->stab_InstCode == Instruction )
          {
            ULONG i;

            switch ( Instruction )
            {
              case TCYINST_STOP :
              {
                if ( Flags & DASCF_StopIsEnd )
                  SynthTable++;

                break;
              }
              case TCYINST_JUMPCC :
              {
                if ( Flags & DASCF_JmpCCIsJmpHS )
                  SynthTable++;

                break;
              }
              case TCYINST_JUMPCS :
              {
                if ( Flags & DASCF_JmpCSIsJmpLO )
                  SynthTable++;

                break;
              }
            }

            strcpy ( InstName, (STRPTR) &(SynthTable->stab_InstName) );

            for (i = (8 - strlen ( (STRPTR) &(SynthTable->stab_InstName))); i > 0; i--)
            {
              strcat ( InstName, " " );
            }

            InstFlags = SynthTable->stab_InstFlags;

            break;
          }

          SynthTable++;
        }
      }

      if ( Flags & DASCF_LowerCase )
      {
        LONG i;

        for (i = 7; i >= 0; i--)
        {
          InstName[i] = tolower ( InstName[i] );
        }
      }

      strncat ( AsmBuf, InstName, 256 );

      if ( InstFlags & STABF_Source )
      {
        if ( (SrcVar) || (Flags & DASCF_AlwaysSrcV0) || (!(InstFlags & STABF_NoSrcV0)) || ((InstFlags & STABF_NoSrcData) && (!(InstFlags & STABF_SrcNotReq)) && (InstFlags & STABF_VarPri) ))
        {
          SrcFlag = 0xFF;

          SymbolStr = (struct TuComposerSynthSymbolTable *) &(SynthStr->tcy_Symbol.mlh_Head);

          for (;;)
          {
            SymbolStr = (struct TuComposerSynthSymbolTable *) SymbolStr->tsst_Node.mln_Succ;

            if ((!( SymbolStr->tsst_Node.mln_Succ )) || (Flags & DASCF_NotEvalSyms))
            {
              InstName[0] = 'v';

              if ( Flags & DASCF_VarUpperCase )
                InstName[0] = 'V';

              if ( SrcVar < 10 )
              {
                InstName[1] = SrcVar + '0';
                InstName[2] = 0;
              } else
              {
                InstName[1] = (SrcVar / 10) + '0';
                InstName[2] = (SrcVar % 10) + '0';
                InstName[3] = 0;
              }

              strncat ( AsmBuf, InstName, 256 );

              break;
            }

            if ( (SymbolStr->tsst_Flags & TCYSTF_Unused) || (SymbolStr->tsst_Type != SYMBOL_LABEL) )
              continue;

            if ( (SymbolStr->tsst_SymbolValue & 0xF) == SrcVar )
            {
              if ( (SymbolStr->tsst_Type == SYMBOL_SRC_VAR) || (SymbolStr->tsst_Type == SYMBOL_VARIABLE) )
              {
                if ( (SymbolStr->tsst_FirstLine <= CodeLine) && (SymbolStr->tsst_LastLine >= CodeLine) )
                {
                  strncat ( AsmBuf, SymbolStr->tsst_SymbolName, 256 );

                  break;
                }
              }
            }
          }
        }

        if ( (InstData) || (Flags & DASCF_AlwaysSrcPar) || (!( InstFlags & STABF_NoSrcData )) || ((!(InstFlags & STABF_SrcNotReq)) && (!(InstFlags & STABF_VarPri)) && (SrcFlag == 0)) )
        {
          SrcFlag |= 0xFF00;

          SymbolStr = (struct TuComposerSynthSymbolTable *) &(SynthStr->tcy_Symbol.mlh_Head);

          for (;;)
          {
            SymbolStr = (struct TuComposerSynthSymbolTable *) SymbolStr->tsst_Node.mln_Succ;

            if ((!( SymbolStr->tsst_Node.mln_Succ )) || (Flags & DASCF_NotEvalSyms))
            {
              ULONG i = 1L;

              InstName[0] = '+';

              if ( (Flags & DASCF_SrcParSigned) && ((WORD) InstData < 0) )
              {
                InstData = -InstData;

                InstName[0] = '-';
              } else if (!( SrcFlag & 0xFF ))
              {
                i = 0L;
              }

              if ( Flags & DASCF_Decimal )
              {
                InstName[i++] = '#';

                if ( InstData >= 10000 )
                  InstName[i++] = (InstData / 10000) + '0';

                if ( InstData >= 1000 )
                  InstName[i++] = ((InstData / 1000) % 10) + '0';

                if ( InstData >= 100 )
                  InstName[i++] = ((InstData / 100) % 10) + '0';

                if ( InstData >= 10 )
                  InstName[i++] = ((InstData / 10) % 10) + '0';

                InstName[i++] = (InstData % 10) + '0';
              } else
              {
                if ( Flags & DASCF_LowerCase )
                {
                  InstName[i++] = LCHexConvTable [InstData >> 12];
                  InstName[i++] = LCHexConvTable [(InstData >> 8) & 0xF];
                  InstName[i++] = LCHexConvTable [(InstData >> 4) & 0xF];
                  InstName[i++] = LCHexConvTable [InstData & 0xF];
                } else
                {
                  InstName[i++] = UCHexConvTable [InstData >> 12];
                  InstName[i++] = UCHexConvTable [(InstData >> 8) & 0xF];
                  InstName[i++] = UCHexConvTable [(InstData >> 4) & 0xF];
                  InstName[i++] = UCHexConvTable [InstData & 0xF];
                }
              }

              InstName[i] = 0;

              strncat ( AsmBuf, InstName, 256 );

              break;
            }

            if ( (SymbolStr->tsst_Flags & TCYSTF_Unused) || (SymbolStr->tsst_Type != SYMBOL_LABEL) )
              continue;

            if ( ((InstFlags & STABF_SrcLine) && (SymbolStr->tsst_Type == SYMBOL_LABEL) && (SymbolStr->tsst_SymbolValue == InstData)) || ((!(InstFlags & STABF_SrcLine)) && (SymbolStr->tsst_Type == SYMBOL_PARAMETER)) )
            {
              if ( (SymbolStr->tsst_FirstLine <= InstData) && (SymbolStr->tsst_LastLine >= InstData) )
              {
                if ( SrcFlag & 0xFF )
                  strncat ( AsmBuf, "+", 256 );

                strncat ( AsmBuf, SymbolStr->tsst_SymbolName, 256 );

                break;
              }
            }
          }
        }
      }

      if ( InstFlags & STABF_Dest )
      {
        if ( SrcFlag )
          strncat ( AsmBuf, ",", 256 );

        SymbolStr = (struct TuComposerSynthSymbolTable *) &(SynthStr->tcy_Symbol.mlh_Head);

        for (;;)
        {
          SymbolStr = (struct TuComposerSynthSymbolTable *) SymbolStr->tsst_Node.mln_Succ;

          if ((!( SymbolStr->tsst_Node.mln_Succ )) || (Flags & DASCF_NotEvalSyms))
          {
            InstName[0] = 'v';

            if ( Flags & DASCF_VarUpperCase )
              InstName[0] = 'V';

            if ( DestVar < 10 )
            {
              InstName[1] = DestVar + '0';
              InstName[2] = 0;
            } else
            {
              InstName[1] = (DestVar / 10) + '0';
              InstName[2] = (DestVar % 10) + '0';
              InstName[3] = 0;
            }

            strncat ( AsmBuf, InstName, 256 );

            break;
          }

          if ( (SymbolStr->tsst_Flags & TCYSTF_Unused) || (SymbolStr->tsst_Type != SYMBOL_LABEL) )
            continue;

          if ( (SymbolStr->tsst_SymbolValue & 0xF) == DestVar )
          {
            if ( (SymbolStr->tsst_Type == SYMBOL_DEST_VAR) || (SymbolStr->tsst_Type == SYMBOL_VARIABLE) )
            {
              if ( (SymbolStr->tsst_FirstLine <= CodeLine) && (SymbolStr->tsst_LastLine >= CodeLine) )
              {
                strncat ( AsmBuf, SymbolStr->tsst_SymbolName, 256 );

                break;
              }
            }
          }
        }

        if ( (DestVar < 15) && (InstFlags & STABF_DestDbl) )
        {
          strncat ( AsmBuf, ":", 256 );

          DestVar++;

          SymbolStr = (struct TuComposerSynthSymbolTable *) &(SynthStr->tcy_Symbol.mlh_Head);

          for (;;)
          {
            SymbolStr = (struct TuComposerSynthSymbolTable *) SymbolStr->tsst_Node.mln_Succ;

            if ((!( SymbolStr->tsst_Node.mln_Succ )) || (Flags & DASCF_NotEvalSyms))
            {
              InstName[0] = 'v';

              if ( Flags & DASCF_VarUpperCase )
                InstName[0] = 'V';

              if ( DestVar < 10 )
              {
                InstName[1] = DestVar + '0';
                InstName[2] = 0;
              } else
              {
                InstName[1] = (DestVar / 10) + '0';
                InstName[2] = (DestVar % 10) + '0';
                InstName[3] = 0;
              }

              strncat ( AsmBuf, InstName, 256 );

              break;
            }

            if ( (SymbolStr->tsst_Flags & TCYSTF_Unused) || (SymbolStr->tsst_Type != SYMBOL_LABEL) )
              continue;

            if ( (SymbolStr->tsst_SymbolValue & 0xF) == DestVar )
            {
              if ( (SymbolStr->tsst_Type == SYMBOL_DEST_VAR) || (SymbolStr->tsst_Type == SYMBOL_VARIABLE) )
              {
                if ( (SymbolStr->tsst_FirstLine <= CodeLine) && (SymbolStr->tsst_LastLine >= CodeLine) )
                {
                  strncat ( AsmBuf, SymbolStr->tsst_SymbolName, 256 );

                  break;
                }
              }
            }
          }
        }
      }

      AsmBuf = strrchr ( AsmBuf, ' ' );

      AsmBuf++;

      if ( *AsmBuf == 0 )
      {
        while (*--AsmBuf == ' ')
        {
          *AsmBuf = 0;
        }
      }

      return ( 0L );
    }

    return ( ERROR_SYNTH_NOGIVEN );
  }

  return ( ERROR_SYNTH_NODATA );
}

UBYTE UCHexConvTable[] = "0123456789ABCDEF";
UBYTE LCHexConvTable[] = "0123456789abcdef";
