/* TuComposer OS independent code
**
** $VER: DupWaveform.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSynthWave *DoDupWaveform ( struct TuComposerSynthWave *WaveformStr, struct TuComposerSynthWave *CloneWaveform );

struct TuComposerSynthWave *DupWaveform ( struct TuComposerSynthWave
    *WaveformStr )
{
  return ( DoDupWaveform ( WaveformStr, NULL ));
}

struct TuComposerSynthWave *DoDupWaveform ( struct TuComposerSynthWave *WaveformStr, struct TuComposerSynthWave *CloneWaveform )
{
  if ( WaveformStr )
  {
    if ( CloneWaveform == NULL )
      CloneWaveform = (struct TuComposerSynthWave *) AllocPMem ( sizeof (struct TuComposerSynthWave ));

    if ( CloneWaveform )
    {
      if ( WaveformStr->tcyw_FileName )
      {
        if (!( SetString ( (STRPTR *) &(CloneWaveform->tcyw_FileName), WaveformStr->tcyw_FileName )))
          goto DupWaveErr;
      }

      if ( WaveformStr->tcyw_Name )
      {
        if (!( SetString ( (STRPTR *) &(CloneWaveform->tcyw_Name), WaveformStr->tcyw_Name )))
          goto DupWaveErr;
      }

      memcpy ( CloneWaveform->tcyw_WaveData, WaveformStr->tcyw_WaveData, WaveformStr->tcyw_Length );

      memcpy ( &(CloneWaveform->tcyw_Repeat), &(WaveformStr->tcyw_Repeat), offsetof (struct TuComposerSynthWave, tcyw_Reserved) - offsetof (struct TuComposerSynthWave, tcyw_Repeat ));
    }
  } else
  {
    CloneWaveform = NULL;
  }

  return ( CloneWaveform );

DupWaveErr:

  FreeWaveform ( CloneWaveform );

  return ( NULL );
}