/* TuComposer OS independent code
**
** $VER: GetSynthInfo.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_synthbase_protos.h>

struct SynthInfo *GetSynthInfo ( struct CFHandle *CFHandle,
    struct TuComposerExtList *ExtLibStr, unsigned long NumSynth )
{
  struct SynthInfo *SynthInfoStr = NULL;

  if ( CFHandle )
  {
    if (!( ExtLibStr ))
      ExtLibStr = IdentifySynth ( CFHandle );

    if ( ExtLibStr )
    {
      if ( (SynthInfoStr = (struct SynthInfo *) AllocPMem (sizeof (struct SynthInfo ))))
      {
        struct SynthLibrary *ExtSynthLibBase;

        if ( (ExtSynthLibBase = (struct SynthLibrary *) OpenExternalLib ( ExtLibStr )))
        {
          ULONG RC;

          RC = ExternalSynthGetInfoBase ( CFHandle, SynthInfoStr, NumSynth, ExtSynthLibBase );

          CloseExternalLib ( ExtLibStr );

          if (!( RC ))
          {
            FreeSynthInfo ( SynthInfoStr );

            SynthInfoStr = NULL;
          }
        } else
        {
          FreePMem ( SynthInfoStr, sizeof (struct SynthInfo ));

          SynthInfoStr = NULL;
        }
      }
    }
  }

  return ( SynthInfoStr );
}
