/* TuComposer OS independent code
**
** $VER: GetSynthNum.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG GetSynthNum ( struct TuComposerModule *ModuleStr,
    struct TuComposerSynth *SynthStr )
{
  ULONG SynthNum = 0L;

  if ( ModuleStr && SynthStr )
  {
    struct TuComposerInstr *InstrStr = (struct TuComposerInstr *) &(ModuleStr->tcm_InstrList.mlh_Head);
    struct TuComposerSample *SampleStr;
    struct TuComposerSynth *SynthScan;

    for (;;)
    {
      InstrStr = (struct TuComposerInstr *) InstrStr->tci_Node.mln_Succ;

      if (!( InstrStr->tci_Node.mln_Succ ))
        break;

      SampleStr = (struct TuComposerSample *) &(InstrStr->tci_Samples.mlh_Head);

      for (;;)
      {
        SampleStr = (struct TuComposerSample *) SampleStr->tcs_Node.mln_Succ;

        if (!( SampleStr->tcs_Node.mln_Succ ))
          break;

        if ( (SynthScan = SampleStr->tcs_Synth ))
        {
          SynthNum++;

          if ( SynthStr == SynthScan )
            return ( SynthNum );
        }
      }
    }
  }

  return ( 0L );
}
