/* TuComposer OS independent code
**
** $VER: InsertSynthCodeLine.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG InsertSynthCodeLine ( struct TuComposerSynth *SynthStr,
    unsigned long Line, unsigned long Lines, unsigned long Flags )
{
  if ( SynthStr )
  {
    struct TuComposerSynthCode *SynthCodeStr = SynthStr->tcy_SynthCode;
    struct TuComposerSynthSymbolTable *SymbolStr = (struct TuComposerSynthSymbolTable *) &(SynthStr->tcy_Symbol.mlh_Head);

    if ( Lines )
    {
      ULONG SynthCodeLen = SynthStr->tcy_CodeEntries, NewLen;

      if (Flags & CODF_LinesOnly)
      {
        if ( Line >= SynthCodeLen )
          Line = SynthCodeLen - 1;

        if ( (Line + Lines) > SynthCodeLen )
          Lines = SynthCodeLen - Line;

        memcpy ( SynthCodeStr + Line + Lines, SynthCodeStr + Line, ((SynthCodeLen - Line) - Lines) * sizeof (struct TuComposerSynthCode ));
        memset ( SynthCodeStr + Line, 0, Lines * sizeof (struct TuComposerSynthCode ));

        for (;;)
        {
          SymbolStr = (struct TuComposerSynthSymbolTable *) SymbolStr->tsst_Node.mln_Succ;

          if (!( SymbolStr->tsst_Node.mln_Succ ))
            break;

          if ( (SymbolStr->tsst_Type == SYMBOL_LABEL) && (SymbolStr->tsst_FirstLine <= Line) && (SymbolStr->tsst_LastLine >= Line) )
          {
            if ( SymbolStr->tsst_SymbolValue >= Line )
              SymbolStr->tsst_SymbolValue += Lines;

            SymbolStr->tsst_LastLine = (((SymbolStr->tsst_LastLine + Lines) < 0xFFFF) ? SymbolStr->tsst_LastLine + Lines : 0xFFFF);
          }
        }

        return ( 0L );
      }

      if ( (NewLen = (SynthCodeLen + Lines)) < 0x10000 )
      {
        if ( Line >= NewLen )
        {
          AddSynthCodeLine ( SynthStr, Lines );
        } else
        {
          struct TuComposerSynthCode *NewSynthCodeStr;

          if (!( NewSynthCodeStr = (struct TuComposerSynthCode *) AllocPMem ( NewLen * sizeof (struct TuComposerSynthCode ))))
            return ( ERROR_SYNTH_NOMEM );

          if ( Line )
            memcpy ( NewSynthCodeStr, SynthCodeStr, Line * sizeof (struct TuComposerSynthCode ));

          memcpy ( NewSynthCodeStr + Line + Lines, SynthCodeStr + Line, (SynthCodeLen - (Line + Lines)) * sizeof (struct TuComposerSynthCode ));

          FreePMem ( SynthCodeStr, SynthCodeLen * sizeof (struct TuComposerSynthCode ));

          SynthStr->tcy_SynthCode = NewSynthCodeStr;
          SynthStr->tcy_CodeEntries = NewLen;

          for (;;)
          {
            SymbolStr = (struct TuComposerSynthSymbolTable *) SymbolStr->tsst_Node.mln_Succ;

            if (!( SymbolStr->tsst_Node.mln_Succ ))
              break;

            if ( (SymbolStr->tsst_Type == SYMBOL_LABEL) && (SymbolStr->tsst_FirstLine <= Line) && (SymbolStr->tsst_LastLine >= Line) )
            {
              if ( SymbolStr->tsst_SymbolValue >= Line )
                SymbolStr->tsst_SymbolValue += Lines;

              SymbolStr->tsst_LastLine = (((SymbolStr->tsst_LastLine + Lines) < 0xFFFF) ? SymbolStr->tsst_LastLine + Lines : 0xFFFF);
            }
          }
        }

        return ( 0L );
      }

      return ( ERROR_SYNTH_TOOBIG );
    }

    return ( 0L );
  }

  return ( ERROR_SYNTH_NOGIVEN );
}
