/* TuComposer OS independent code
**
** $VER: InsertWaveformPoint.c 31.22 (8.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG InsertWaveformPoint ( struct TuComposerSynthWave *WaveformStr,
    unsigned long Point, unsigned long Points, unsigned long Flags )
{
  if ( WaveformStr )
  {
    BYTE *WaveData = (BYTE *) WaveformStr->tcyw_WaveData;

    if ( Points )
    {
      ULONG WaveLen = WaveformStr->tcyw_Samples, NewLen;

      if (Flags & WAVF_PointsOnly)
      {
        if ( Point >= WaveLen )
          Point = WaveLen - 1;

        if ( (Point + Points) > WaveLen )
          Points = WaveLen - Point;

        if (!( WaveformStr->tcyw_Flags & TCYWF_8Bit ))
        {
          WaveLen += WaveLen;
          Point += Point;
          Points += Points;
        }

        memcpy ( WaveData + Point + Points, WaveData + Point, ((WaveLen - Point) - Points));
        memset ( WaveData + Point, 0, Points );

        return ( 0L );
      }

      if ( (NewLen = (WaveLen + Points)) < 0x10000 )
      {
        if ( Point >= NewLen )
        {
          AddWaveformPoint ( WaveformStr, Points );
        } else
        {
          BYTE *NewWaveData;

          if (!( WaveformStr->tcyw_Flags & TCYWF_8Bit ))
          {
            WaveLen += WaveLen;
            NewLen += NewLen;
            Point += Point;
            Points += Points;
          }

          if (!( NewWaveData = (BYTE *) AllocPMem ( NewLen )))
            return ( ERROR_SYNTH_NOMEM );

          if ( Point )
            memcpy ( NewWaveData, WaveData, Point );

          memcpy ( NewWaveData + Point + Points, WaveData + Point, (WaveLen - (Point + Points)));

          FreePMem ( WaveData, WaveLen );

          WaveformStr->tcyw_WaveData = (WORD *) NewWaveData;
          WaveformStr->tcyw_Length = NewLen;
          WaveformStr->tcyw_Samples = NewLen;

          if (!( WaveformStr->tcyw_Flags & TCYWF_8Bit ))
            WaveformStr->tcyw_Samples /= 2;
        }

        return ( 0L );
      }

      return ( ERROR_SYNTH_TOOBIG );
    }

    return ( 0L );
  }

  return ( ERROR_SYNTH_NODATA );
}
