/* TuComposer OS independent code
**
** $VER: MatchSymbol.c 31.22 (7.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSynthSymbolTable *MatchSymbol (
    struct TuComposerSynthSymbolTable *SymbolStr, STRPTR Name,
    unsigned long Line, unsigned long Type )
{
  struct TuComposerSynthSymbolTable *MatchSymbolStr = NULL;

  if ( SymbolStr && Name )
  {
    for (;;)
    {
      SymbolStr = (struct TuComposerSynthSymbolTable *) SymbolStr->tsst_Node.mln_Succ;

      if (!( SymbolStr->tsst_Node.mln_Succ ))
        break;

      if ( SymbolStr->tsst_Flags & TCYSTF_Unused )
        continue;

      switch ( Type )
      {
        case SYMBOL_ANY :
        {
          if ( (SymbolStr->tsst_FirstLine <= Line) && (SymbolStr->tsst_LastLine >= Line) )
          {
            if (!( strcmp ( SymbolStr->tsst_SymbolName, Name )))
              MatchSymbolStr = SymbolStr;
          }

          break;
        }
        case SYMBOL_NAME :
        {
         if (!( strcmp ( SymbolStr->tsst_SymbolName, Name )))
            MatchSymbolStr = SymbolStr;

          break;
        }
        case SYMBOL_LABELID :
        {
          if ( SymbolStr->tsst_Type == SYMBOL_LABEL )
          {
            if (!( strcmp ( SymbolStr->tsst_SymbolName, Name )))
              MatchSymbolStr = SymbolStr;
          }

          break;
        }
        case SYMBOL_LABELLINE :
        {
          if ( SymbolStr->tsst_Type == SYMBOL_LABEL )
          {
            if ( SymbolStr->tsst_SymbolValue == Line )
            {
              if (!( strcmp ( SymbolStr->tsst_SymbolName, Name )))
                MatchSymbolStr = SymbolStr;
            }
          }

          break;
        }
        case SYMBOL_LABELDBL :
        {
          if ( SymbolStr->tsst_Type == SYMBOL_LABEL )
          {
            if ( SymbolStr->tsst_SymbolValue != Line )
            {
              if (!( strcmp ( SymbolStr->tsst_SymbolName, Name )))
                MatchSymbolStr = SymbolStr;
            }
          }

          break;
        }
        default :
        {
          if ( SymbolStr->tsst_Type == Type )
          {
            if ( (SymbolStr->tsst_FirstLine <= Line) && (SymbolStr->tsst_LastLine >= Line) )
            {
              if (!( strcmp ( SymbolStr->tsst_SymbolName, Name )))
                MatchSymbolStr = SymbolStr;
            }
          }

          break;
        }
      }

      if ( MatchSymbolStr )
        break;
    }
  }

  return ( MatchSymbolStr );
}
