/* TuComposer OS independent code
**
** $VER: PasteSynthCode.c 31.22 (8.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

struct TuComposerSynth *PasteSynthCode ( struct TuComposerSynth *SynthBuf,
    struct TuComposerSynth *SynthStr )
{
  struct TuComposerSynth *PassedSynthStr = SynthStr;
  struct TuComposerSynthCode *SynthCodeStr;

  if (!( SynthStr ))
  {
    if (!( SynthStr = AllocSynth ( 1L, 0L, 0L )))
      return ( NULL );
  }

  ObtainSemaphoreShared ( TuCBase->tcb_SynthSigSem );

  if ( (SynthCodeStr = DupSynthCode ( SynthBuf )))
  {
    AssignSynthCode ( SynthStr, SynthCodeStr, SynthBuf->tcy_CodeEntries );
  } else
  {
    if (!( PassedSynthStr ))
      FreeSynth ( SynthStr );

    SynthStr = NULL;
  }

  ReleaseSemaphore ( TuCBase->tcb_SynthSigSem );

  return ( SynthStr );
}
