/* TuComposer OS independent code
**
** $VER: PasteWaveform.c 31.22 (8.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

struct TuComposerSynthWave *DoDupWaveform ( struct TuComposerSynthWave *WaveformStr, struct TuComposerSynthWave *CloneWaveform );

extern struct TuComposerBase *TuCBase;

struct TuComposerSynthWave *PasteWaveform ( struct TuComposerSynthWave
    *WaveformBuf, struct TuComposerSynthWave *WaveformStr )
{
  ObtainSemaphoreShared ( TuCBase->tcb_WavesSigSem );

  if ( WaveformStr )
  {
    if ( ReSizeWaveform ( WaveformBuf, WaveformBuf->tcyw_Samples ))
    {
      WaveformStr = NULL;
      goto PasteWaveDone;
    }

    ClearWaveform ( WaveformStr );
  }

  WaveformStr = DoDupWaveform ( WaveformBuf, WaveformStr );

PasteWaveDone:

  ReleaseSemaphore ( TuCBase->tcb_WavesSigSem );

  return ( WaveformStr );
}
