/* TuComposer OS independent code
**
** $VER: PushSynthCode.c 31.22 (8.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

struct TuComposerSynth *PushSynthCode ( struct TuComposerSynth *SynthStr )
{
  struct TuComposerSynthCode *SynthCodeStr;
  ULONG SynthCodeLen = DEFAULTSYNTHCODELINES;

  if ( SynthStr )
  {
    SynthCodeStr = DupSynthCode ( SynthStr );

    SynthCodeLen = SynthStr->tcy_CodeEntries;
  } else
  {
    SynthCodeStr = AllocSynthCode ( 0L );
  }

  if ( (SynthStr = AllocSynth ( 1L, 0L, 0L )))
  {
    AssignSynthCode ( SynthStr, SynthCodeStr, SynthCodeLen );

    ObtainSemaphore ( TuCBase->tcb_SynthSigSem );

    AddNodeHead ( (struct List *) &(TuCBase->tcb_SynthBuf), (struct Node *) &(SynthStr->tcy_Node) );

    ReleaseSemaphore ( TuCBase->tcb_SynthSigSem );
  } else
  {
    FreeSynthCode ( SynthCodeStr, SynthCodeLen );
  }

  return ( SynthStr );
}
