/* TuComposer OS independent code
**
** $VER: ReMapSynth.c 31.22 (8.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ReMapSynth ( struct TuComposerSynth *SynthStr,
    struct TuComposerSynth *NewSynthStr )
{
  if ( SynthStr && NewSynthStr )
  {
    if ( SynthStr != NewSynthStr )
    {
      ClearSynth ( NewSynthStr );

      ReMapNodeList ( (struct List *) &(SynthStr->tcy_Waves), (struct List *) &(NewSynthStr->tcy_Waves));
      ReMapNodeList ( (struct List *) &(SynthStr->tcy_Symbol), (struct List *) &(NewSynthStr->tcy_Symbol));

      ReMapNodeList ( (struct List *) &(SynthStr->tcy_UnknownChunks), (struct List *) &(NewSynthStr->tcy_UnknownChunks));

      NewSynthStr->tcy_FileName = SynthStr->tcy_FileName;
      NewSynthStr->tcy_Name = SynthStr->tcy_Name;

      memcpy ( &(NewSynthStr->tcy_SynthCode), &(SynthStr->tcy_SynthCode), offsetof (struct TuComposerSynth, tcy_UnknownChunks) - offsetof (struct TuComposerSynth, tcy_SynthCode ));

      FreePMem ( SynthStr, sizeof (struct TuComposerSynth ));
    }

    return ( 0L );
  }

  return ( ERROR_SYNTH_NOGIVEN );
}
