/* TuComposer OS independent code
**
** $VER: ReSizeSynthCode.c 31.22 (8.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ReSizeSynthCode ( struct TuComposerSynth *SynthStr,
    unsigned long NewLen )
{
  if ( SynthStr )
  {
    if ( NewLen == NULL )
      NewLen = DEFAULTSYNTHCODELINES;

    if ( NewLen < 0x10000 )
    {
      ULONG Length = SynthStr->tcy_CodeEntries, RC = 0L;

      if ( NewLen < Length )
      {
        RC = RemSynthCodeLine ( SynthStr, Length - NewLen );
      } else if ( NewLen > Length )
      {
        RC = AddSynthCodeLine ( SynthStr, NewLen - Length );
      }

      return ( RC );
    }

    return ( ERROR_SYNTH_TOOBIG );
  }

  return ( ERROR_SYNTH_NOGIVEN );
}
