/* TuComposer OS independent code
**
** $VER: ReSizeWaveform.c 31.22 (8.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ReSizeWaveform ( struct TuComposerSynthWave *WaveformStr,
    unsigned long NewLen )
{
  if ( WaveformStr )
  {
    ULONG Length = WaveformStr->tcyw_Samples, RC = 0L;

    if ( NewLen == NULL )
      NewLen = DEFAULTSYNTHWAVELENGTH;

    if ( NewLen < Length )
    {
      RC = RemWaveformPoint ( WaveformStr, Length - NewLen );
    } else if ( NewLen > Length )
    {
      RC = AddWaveformPoint ( WaveformStr, NewLen - Length );
    }

    return ( RC );
  }

  return ( ERROR_SYNTH_NOGIVEN );
}
