/* TuComposer OS independent code
**
** $VER: RemSynthCodeLine.c 31.22 (8.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG RemSynthCodeLine ( struct TuComposerSynth *SynthStr,
    unsigned long Lines )
{
  if ( SynthStr )
  {
    ULONG OldLength;

    OldLength = SynthStr->tcy_CodeEntries;

    if ( Lines < OldLength )
    {
      struct TuComposerSynthCode *NewSynthCodeStr;
      ULONG Length;

      Length = OldLength - Lines;

      if ( NewSynthCodeStr = (struct TuComposerSynthCode *) AllocPMem ( Length * sizeof (struct TuComposerSynthCode )))
      {
        memcpy ( NewSynthCodeStr, SynthStr->tcy_SynthCode, Length * sizeof (struct TuComposerSynthCode ));

        FreePMem ( SynthStr->tcy_SynthCode, OldLength * sizeof (struct TuComposerSynthCode ));

        SynthStr->tcy_CodeEntries = Length;
        SynthStr->tcy_SynthCode = NewSynthCodeStr;

        return ( 0L );
      }

      return ( ERROR_SYNTH_NOMEM );
    }

    return ( ERROR_SYNTH_TOOSMALL );
  }

  return ( ERROR_SYNTH_NOGIVEN );
}
