/* TuComposer OS independent code
**
** $VER: RemWaveformPoint.c 31.22 (8.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG RemWaveformPoint ( struct TuComposerSynthWave *WaveformStr,
    unsigned long Points )
{
  if ( WaveformStr )
  {
    ULONG OldLength;

    OldLength = WaveformStr->tcyw_Samples;

    if ( Points < OldLength )
    {
      BYTE *NewWaveData;
      ULONG Length;

      Length = OldLength - Points;

      if (!( WaveformStr->tcyw_Flags & TCYWF_8Bit ))
      {
        Length += Length;
        OldLength += OldLength;
        Points += Points;
      }

      if ( (NewWaveData = (BYTE *) AllocPMem ( Length )))
      {
        ULONG Repeat;

        memcpy ( NewWaveData, WaveformStr->tcyw_WaveData, Length );

        FreePMem ( WaveformStr->tcyw_WaveData, OldLength );

        WaveformStr->tcyw_WaveData = (WORD *) NewWaveData;
        WaveformStr->tcyw_Length = Length;
        WaveformStr->tcyw_Samples = Length;

        if (!( WaveformStr->tcyw_Flags & TCYWF_8Bit ))
        {
          Length /= 2;

          WaveformStr->tcyw_Samples = Length;
        }

        Repeat = WaveformStr->tcyw_Repeat;

        if ( Repeat >= Length )
        {
          Repeat = Length - 1;
          WaveformStr->tcyw_Repeat = Repeat;
        }

        Repeat += WaveformStr->tcyw_RepLen;

        if ( Repeat > Length )
        {
          Repeat = Length - WaveformStr->tcyw_Repeat;
          WaveformStr->tcyw_RepLen = Repeat;
        }

        return ( 0L );
      }

      return ( ERROR_SYNTH_NOMEM );
    }

    return ( ERROR_SYNTH_TOOSMALL );
  }

  return ( ERROR_SYNTH_NODATA );
}
