/* TuComposer OS independent code
**
** $VER: SwapSynth.c 31.22 (8.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG SwapSynth ( struct TuComposerSynth *SynthBuf,
    struct TuComposerSynth *SynthStr )
{
  if ( SynthStr && SynthBuf )
  {
    if ( SynthStr != SynthBuf )
    {
      struct MinList TmpUnkChunk;
      struct MinList SwapUnkChunk;
      UBYTE *SrcBuf,*DestBuf;
      UBYTE TmpByte;
      ULONG i;

      ObtainSemaphore ( TuCBase->tcb_SynthSigSem );

      TmpUnkChunk = SynthBuf->tcy_UnknownChunks;
      ReMapNodeList ( (struct List *) &(SynthStr->tcy_UnknownChunks), (struct List *) &(SynthBuf->tcy_UnknownChunks));

      SwapUnkChunk = SynthBuf->tcy_UnknownChunks;
      SynthBuf->tcy_UnknownChunks = TmpUnkChunk;
      ReMapNodeList ( (struct List *) &(SynthBuf->tcy_UnknownChunks), (struct List *) &(SynthStr->tcy_UnknownChunks));

      SynthBuf->tcy_UnknownChunks = SwapUnkChunk;

      SrcBuf = (UBYTE *) &(SynthStr->tcy_FileName);
      DestBuf = (UBYTE *) &(SynthBuf->tcy_FileName);

      for (i = (offsetof (struct TuComposerSynth, tcy_Waves) - offsetof (struct TuComposerSynth, tcy_FileName)); i > 0; i--)
      {
        TmpByte = *DestBuf;
        *DestBuf++ = *SrcBuf;
        *SrcBuf++ = TmpByte;
      }

      TmpUnkChunk = SynthBuf->tcy_Waves;
      ReMapNodeList ( (struct List *) &(SynthStr->tcy_Waves), (struct List *) &(SynthBuf->tcy_Waves));

      SwapUnkChunk = SynthBuf->tcy_Waves;
      SynthBuf->tcy_Waves = TmpUnkChunk;
      ReMapNodeList ( (struct List *) &(SynthBuf->tcy_Waves), (struct List *) &(SynthStr->tcy_Waves));

      SynthBuf->tcy_Waves = SwapUnkChunk;

      TmpUnkChunk = SynthBuf->tcy_Symbol;
      ReMapNodeList ( (struct List *) &(SynthStr->tcy_Symbol), (struct List *) &(SynthBuf->tcy_Symbol));

      SwapUnkChunk = SynthBuf->tcy_Symbol;
      SynthBuf->tcy_Symbol = TmpUnkChunk;
      ReMapNodeList ( (struct List *) &(SynthBuf->tcy_Symbol), (struct List *) &(SynthStr->tcy_Symbol));

      SynthBuf->tcy_Symbol = SwapUnkChunk;

      SrcBuf = (UBYTE *) &(SynthStr->tcy_SynthCode);
      DestBuf = (UBYTE *) &(SynthBuf->tcy_SynthCode);

      for (i = (offsetof (struct TuComposerSynth, tcy_UnknownChunks) - offsetof (struct TuComposerSynth, tcy_SynthCode)); i > 0; i--)
      {
        TmpByte = *DestBuf;
        *DestBuf++ = *SrcBuf;
        *SrcBuf++ = TmpByte;
      }

      ReleaseSemaphore ( TuCBase->tcb_SynthSigSem );
    }

    return ( 0L );
  }

  return ( ERROR_SYNTH_NOGIVEN );
}
