/* TuComposer OS independent code
**
** $VER: SwapSynthCode.c 31.22 (8.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG SwapSynthCode ( struct TuComposerSynth *SynthBuf,
    struct TuComposerSynth *SynthStr )
{
  if ( SynthStr && SynthBuf )
  {
    if ( SynthStr != SynthBuf )
    {
      struct TuComposerSynthCode *SynthCodeStr;
      ULONG SynthCodeLen;

      ObtainSemaphore ( TuCBase->tcb_SynthSigSem );

      SynthCodeStr = SynthBuf->tcy_SynthCode;
      SynthBuf->tcy_SynthCode = SynthStr->tcy_SynthCode;
      SynthStr->tcy_SynthCode = SynthCodeStr;

      SynthCodeLen = SynthBuf->tcy_CodeEntries;
      SynthBuf->tcy_CodeEntries = SynthStr->tcy_CodeEntries;
      SynthStr->tcy_CodeEntries = SynthCodeLen;

      ReleaseSemaphore ( TuCBase->tcb_SynthSigSem );
    }

    return ( 0L );
  }

  return ( ERROR_SYNTH_NOGIVEN );
}
