/* TuComposer OS independent code
**
** $VER: SwapWaveform.c 31.22 (8.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG SwapWaveform ( struct TuComposerSynthWave *WaveformBuf,
    struct TuComposerSynthWave *WaveformStr )
{
  if ( WaveformStr && WaveformBuf )
  {
    if ( WaveformStr != WaveformBuf )
    {
      UBYTE *SrcBuf,*DestBuf;
      UBYTE TmpByte;
      ULONG i;

      ObtainSemaphore ( TuCBase->tcb_WavesSigSem );

      SrcBuf = (UBYTE *) &(WaveformStr->tcyw_FileName);
      DestBuf = (UBYTE *) &(WaveformBuf->tcyw_FileName);

      for (i = (offsetof (struct TuComposerSynthWave, tcyw_Reserved) - offsetof (struct TuComposerSynthWave, tcyw_FileName)); i > 0; i--)
      {
        TmpByte = *DestBuf;
        *DestBuf++ = *SrcBuf;
        *SrcBuf++ = TmpByte;
      }

      ReleaseSemaphore ( TuCBase->tcb_WavesSigSem );
    }

    return ( 0L );
  }

  return ( ERROR_SYNTH_NODATA );
}
