/* TuComposer OS independent code
**
** $VER: AddRows.c 31.22 (10.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG AddRows ( struct TuComposerTrack *TrackStr, unsigned long NumRows )
{
  if ( TrackStr )
  {
    ULONG OldLength = (TrackStr->tct_Length) + 1;
    ULONG Length = OldLength + NumRows;

    if ( Length <= MAXTRACKROWS )
    {
      struct TuComposerTrackData *NewTrackData;

      if ( NewTrackData = (struct TuComposerTrackData *) AllocPMem ( Length * sizeof (struct TuComposerTrackData )))
      {
        struct TuComposerSong *SongStr;
        struct TuComposerTrackData *TrackData = TrackStr->tct_Data;
        struct TuComposerTrackData *InitTrackData = NewTrackData;
        ULONG ReMapRows;

        TrackStr->tct_Length = (Length - 1);

        for (ReMapRows = OldLength; ReMapRows > 0; ReMapRows--)
        {
          ReMapNodeList ( (struct List *) &(TrackData->tctd_Effects), (struct List *) &(InitTrackData->tctd_Effects));

          TrackData++;
          InitTrackData++;
        }

        for (ReMapRows = (Length - OldLength); ReMapRows > 0; ReMapRows--)
        {
          InitNodeList ( (struct List *) InitTrackData++);
        }

        if ( (SongStr = TuCBase->tcb_PlaySong) )
        {
          struct PlayerHostChannel *PHCStr = SongStr->tcso_ChannelData;
          ULONG i;

          Disable ();

          for (i = SongStr->tcso_Channels; i > 0; i--)
          {
            if ( PHCStr->phc_Track == TrackStr )
              PHCStr->phc_MaxRow += NumRows;

            PHCStr++;
          }

          Enable ();
        }

        FreePMem ( TrackStr->tct_Data, OldLength * sizeof (struct TuComposerTrackData ));

        TrackStr->tct_Data = NewTrackData;

        return ( 0L );
      }

      return ( ERROR_TRACK_NOMEM );
    }

    return ( ERROR_TRACK_TOO_BIG );
  }

  return ( ERROR_TRACK_NOGIVEN );
}
