/* TuComposer OS independent code
**
** $VER: AddTrackUnknownChunk.c 31.22 (10.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include "exec/types.h"
#include "tucomposer/tucomposer.h"
#include "clib/tucomposer_protos.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef MOTOROLA
  ULONG ReadMLong ( UBYTE *Buffer );
#else
  #define ReadMLong( Buffer ) (*(ULONG *) (Buffer))
#endif

#ifdef __cplusplus
}
#endif

ULONG AddTrackUnknownChunk ( struct TuComposerTrack *TrackStr,
    struct UnknownChunk *UnknownChunkStr )
{
  if ( TrackStr )
  {
    if ( UnknownChunkStr )
    {
      struct UnknownChunk *ScanChunkStr;

      ScanChunkStr = (struct UnknownChunk *) &(TrackStr->tct_UnknownChunks);

      for (;;)
      {
        ScanChunkStr = (struct UnknownChunk *) ScanChunkStr->uc_Node.mln_Succ;

        if (!( ScanChunkStr->uc_Node.mln_Succ ))
          break;

        if ( *(ULONG *) &(ScanChunkStr->uc_Identifier[0]) == *(ULONG *) &(UnknownChunkStr->uc_Identifier[0]) )
        {
          if ( (ReadMLong ( (UBYTE *) &(ScanChunkStr->uc_Identifier[0]))) == 'FORM' )
          {
            if ( *(ULONG *) &(ScanChunkStr->uc_Data[0]) == *(ULONG *) &(UnknownChunkStr->uc_Data[0]) )
            {
              FreeUnknownChunk ( ScanChunkStr );
              break;
            }
          } else
          {
            FreeUnknownChunk ( ScanChunkStr );
            break;
          }
        }
      }

      AddNodeTail ( (struct List *) &(TrackStr->tct_UnknownChunks), (struct Node *) UnknownChunkStr );

      return ( 0L );
    }

    return ( ERROR_TRACK_NODATA );
  }

  return ( ERROR_TRACK_NOGIVEN );
}
