/* TuComposer OS independent code
**
** $VER: AllocTrack.c 31.22 (8.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerTrack *AllocTrack ( unsigned long DefLength )
{
  struct TuComposerTrack *Track = NULL;

  DefLength = (DefLength == 0 ? DEFAULTTRACKROWS : DefLength );

  if (DefLength > MAXTRACKROWS)
    goto Error;

  if ( Track = (struct TuComposerTrack *) AllocPMem ( sizeof (struct TuComposerTrack )))
  {
    Track->tct_Length = (DefLength - 1);
    Track->tct_Volume = DEFAULTTRACKVOLUME;
    Track->tct_Panning = DEFAULTTRACKPANNING;
    Track->tct_Frames = DEFAULTTRACKFRAMES;
    Track->tct_SpeedMul = DEFAULTTRACKSPEEDMUL;
    Track->tct_SpeedDiv = DEFAULTTRACKSPEEDDIV;
    Track->tct_SPDSpeed = DEFAULTTRACKSPDSPEED;
    Track->tct_BPMTempo = DEFAULTTRACKBPMTEMPO;
    Track->tct_BPMSpeed = DEFAULTTRACKBPMSPEED;

    InitNodeList ( (struct List *) &(Track->tct_UnknownChunks) );

    if (!( Track->tct_Data = (struct TuComposerTrackData *) AllocTrackData ( DefLength )))
    {
      FreePMem ( Track, sizeof (struct TuComposerTrack ) );

      Track = NULL;
    }
  }

Error:

  return ( Track );
}
