/* TuComposer OS independent code
**
** $VER: ClearRows.c 31.22 (10.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ClearRows ( struct TuComposerTrack *TrackStr, unsigned long Row,
    unsigned long NumRows )
{
  if ( TrackStr )
  {
    struct TuComposerTrackData *TrackData;

    if ( TrackData = TrackStr->tct_Data )
    {
      struct TuComposerTrackEffect *FXData;
      ULONG ClrRows;

      TrackData += Row;

      for ( ClrRows = NumRows; ClrRows > 0; ClrRows--)
      {

        TrackData->tctd_Octave = 0;
        TrackData->tctd_Note = 0;
        TrackData->tctd_Instrument = 0;

        FXData = (struct TuComposerTrackEffect *) &(TrackData->tctd_Effects.mlh_Head);

        if ( FXData->tcte_Node.mln_Succ )
        {
          struct TuComposerTrackEffect *FreeData;

          for (;;)
          {
            FreeData = (struct TuComposerTrackEffect *) FXData->tcte_Node.mln_Succ;

            if (!( (struct TuComposerTrackEffect *) FreeData->tcte_Node.mln_Succ ))
              break;

            DeleteEffect ( FreeData );
            FreeEffect ( FreeData );
          }

          TrackData++;
        }

        InitNodeList ( (struct List *) &(TrackData->tctd_Effects));
      }

      return ( 0L );
    }

    return ( ERROR_TRACK_NODATA );
  }

  return ( ERROR_TRACK_NOGIVEN );
}
