/* TuComposer OS independent code
**
** $VER: ClearTrack.c 31.22 (10.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ClearTrack ( struct TuComposerTrack *TrackStr )
{
  if ( TrackStr )
  {

    if ( TrackStr->tct_Data )
    {
      struct UnknownChunk *UnknownChunkStr;
      struct UnknownChunk *FreeUnkChunk;

      FreeNameStr ( TrackStr->tct_FileName );
      FreeNameStr ( TrackStr->tct_Name );

      UnknownChunkStr = (struct UnknownChunk *) &(TrackStr->tct_UnknownChunks.mlh_Head);

      for (;;)
      {
        FreeUnkChunk = (struct UnknownChunk *) UnknownChunkStr->uc_Node.mln_Succ;

        if (!( FreeUnkChunk->uc_Node.mln_Succ ))
          break;

        FreeUnknownChunk ( FreeUnkChunk );
      }

      TrackStr->tct_FileName = NULL;
      TrackStr->tct_Name = NULL;

      TrackStr->tct_Volume = DEFAULTTRACKVOLUME;
      TrackStr->tct_SubVolume = 0;

      TrackStr->tct_Panning = DEFAULTTRACKPANNING;
      TrackStr->tct_SubPanning = 0;

      TrackStr->tct_Transpose = DEFAULTTRACKTRANSPOSE;

      TrackStr->tct_CompFlags = 0;
      TrackStr->tct_Flags = 0;

      TrackStr->tct_Frames = DEFAULTTRACKFRAMES;

      TrackStr->tct_SpeedMul = DEFAULTTRACKSPEEDMUL;
      TrackStr->tct_SpeedDiv = DEFAULTTRACKSPEEDDIV;

      TrackStr->tct_SPDSpeed = DEFAULTTRACKSPDSPEED;

      TrackStr->tct_BPMTempo = DEFAULTTRACKBPMTEMPO;
      TrackStr->tct_BPMSpeed = DEFAULTTRACKBPMSPEED;

      ClearRows ( TrackStr, 0L, (TrackStr->tct_Length) + 1);

      return ( 0L );
    }

    return ( ERROR_TRACK_NODATA );
  }

  return ( ERROR_TRACK_NOGIVEN );
}
