/* TuComposer OS independent code
**
** $VER: CmpTracks.c 31.22 (10.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

LONG CmpTracks ( struct TuComposerTrack *SrcTrackStr,
   struct TuComposerTrack *DestTrackStr )
{
  if ( SrcTrackStr && DestTrackStr )
  {
    struct TuComposerTrackData *SrcTrackData = SrcTrackStr->tct_Data;
    struct TuComposerTrackData *DestTrackData = DestTrackStr->tct_Data;
    struct TuComposerTrackEffect *SrcFX;
    struct TuComposerTrackEffect *DestFX;
    ULONG CmpLen;
    ULONG Length = (SrcTrackStr->tct_Length + 1);

    if ( SrcTrackStr == DestTrackStr )
      goto TracksEqual;

    if ( SrcTrackStr->tct_FileName != DestTrackStr->tct_FileName )
    {
      if ( (SrcTrackStr->tct_FileName == NULL) || (DestTrackStr->tct_FileName == NULL) )
        goto TracksNotEqual;

      if ( strcmp ( SrcTrackStr->tct_FileName, DestTrackStr->tct_FileName ))
        goto TracksNotEqual;
    }

    if ( SrcTrackStr->tct_Name != DestTrackStr->tct_Name )
    {
      if ( (SrcTrackStr->tct_Name == NULL) || (DestTrackStr->tct_Name == NULL) )
        goto TracksNotEqual;

      if ( strcmp ( SrcTrackStr->tct_Name, DestTrackStr->tct_Name ))
        goto TracksNotEqual;
    }

    if ( memcmp ( &(SrcTrackStr->tct_Length), &(DestTrackStr->tct_Length), offsetof (struct TuComposerTrack, tct_UnknownChunks) - offsetof (struct TuComposerTrack, tct_Length )))
      goto TracksNotEqual;

    for (CmpLen = Length; CmpLen > 0; CmpLen--)
    {
      if ( SrcTrackData->tctd_Octave != DestTrackData->tctd_Octave )
        goto TracksNotEqual;

      if ( SrcTrackData->tctd_Note != DestTrackData->tctd_Note )
        goto TracksNotEqual;

      if ( SrcTrackData->tctd_Instrument != DestTrackData->tctd_Instrument )
        goto TracksNotEqual;

      SrcFX = (struct TuComposerTrackEffect *) &(SrcTrackData->tctd_Effects.mlh_Head);
      DestFX = (struct TuComposerTrackEffect *) &(DestTrackData->tctd_Effects.mlh_Head);

      for (;;)
      {
        SrcFX = (struct TuComposerTrackEffect *) SrcFX->tcte_Node.mln_Succ;
        DestFX = (struct TuComposerTrackEffect *) DestFX->tcte_Node.mln_Succ;

        if (!( (struct TuComposerTrackEffect *) SrcFX->tcte_Node.mln_Succ ))
          break;

        if (!( (struct TuComposerTrackEffect *) DestFX->tcte_Node.mln_Succ ))
          goto TracksNotEqual;

        if ( SrcFX->tcte_EffectByte != DestFX->tcte_EffectByte )
          goto TracksNotEqual;

        if ( SrcFX->tcte_DataWord != DestFX->tcte_DataWord )
          goto TracksNotEqual;
      }

      if ( (struct TuComposerTrackEffect *) DestFX->tcte_Node.mln_Succ )
        goto TracksNotEqual;

      SrcTrackData++;
      DestTrackData++;

    }

TracksEqual:
      return ( 0L );

TracksNotEqual:
    return ( 1L );

  }

  return ( ERROR_TRACK_NOGIVEN );
}
