/* TuComposer OS independent code
**
** $VER: CopyRows.c 31.22 (11.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG CopyRows ( struct TuComposerTrack *SrcTrackStr,
    struct TuComposerTrack *DestTrackStr, unsigned long SrcRow,
    unsigned long DestRow, unsigned long NumRows )
{
  if ( SrcTrackStr && DestTrackStr)
  {
    struct TuComposerTrackData *SrcTrackData;
    struct TuComposerTrackData *DestTrackData;

    if (( SrcTrackData = SrcTrackStr->tct_Data) && ( DestTrackData = DestTrackStr->tct_Data ))
    {
      struct TuComposerTrackData *SrcTmpCopy;
      struct TuComposerTrackData *TmpTrackData;
      struct TuComposerTrackData *TmpCopy;
      struct TuComposerTrackEffect *FXData;
      struct TuComposerTrackEffect *FreeData;
      ULONG CopyRows;
      ULONG SrcTrackLen = (SrcTrackStr->tct_Length + 1);
      ULONG TrackLen = (DestTrackStr->tct_Length + 1);

      if ( SrcRow >= SrcTrackLen || DestRow >= TrackLen )
        return ( 0L );

      if (!( TmpTrackData = AllocTrackData ( TrackLen )))
        return ( ERROR_TRACK_NOMEM );

      SrcTmpCopy = DestTrackData;
      TmpCopy = TmpTrackData;

      for (CopyRows = TrackLen; CopyRows > 0; CopyRows--)
      {
        if (!( DupNodeList ( (struct MinList *) &(SrcTmpCopy->tctd_Effects), (struct MinList *) &(TmpCopy->tctd_Effects), sizeof (struct TuComposerTrackEffect ))))
        {
          FreeTrackData ( TmpTrackData, TrackLen );
          return ( ERROR_TRACK_NOMEM );
        }

        TmpCopy->tctd_Octave =SrcTmpCopy->tctd_Octave;
        TmpCopy->tctd_Note = SrcTmpCopy->tctd_Note;
        TmpCopy->tctd_Instrument = SrcTmpCopy->tctd_Instrument;

        SrcTmpCopy++;
        TmpCopy++;
      }

      NumRows = (((NumRows + SrcRow) < SrcTrackLen) ? NumRows : SrcTrackLen - SrcRow);
      NumRows = (((NumRows + DestRow) < TrackLen) ? NumRows : TrackLen - DestRow);

      SrcTrackData += SrcRow;
      TmpCopy = TmpTrackData + DestRow;

      for (CopyRows = NumRows; CopyRows > 0; CopyRows--)
      {
        TmpCopy->tctd_Octave = SrcTrackData->tctd_Octave;
        TmpCopy->tctd_Note = SrcTrackData->tctd_Note;
        TmpCopy->tctd_Instrument = SrcTrackData->tctd_Instrument;

        FXData = (struct TuComposerTrackEffect *) &(TmpCopy->tctd_Effects.mlh_Head);

        for (;;)
        {

          FreeData = (struct TuComposerTrackEffect *) FXData->tcte_Node.mln_Succ;

          if (!( (struct TuComposerTrackEffect *) FreeData->tcte_Node.mln_Succ ))
            break;

          DeleteEffect ( FreeData );
          FreeEffect ( FreeData );
        }

        if (!( DupNodeList ( (struct MinList *) &(SrcTrackData->tctd_Effects), (struct MinList *) &(TmpCopy->tctd_Effects), sizeof(struct TuComposerTrackEffect ))))
        {
          FreeTrackData ( TmpTrackData, TrackLen );
          return ( ERROR_TRACK_NOMEM );
        }

        SrcTrackData++;
        TmpCopy++;
      }

      FreeTrackData ( DestTrackData, TrackLen );
      DestTrackStr->tct_Data = TmpTrackData;

      return ( 0L );
    }

    return ( ERROR_TRACK_NODATA );
  }

  return ( ERROR_TRACK_NOGIVEN );
}
