/* TuComposer OS independent code
**
** $VER: DeleteRows.c 31.22 (11.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG DeleteRows ( struct TuComposerTrack *TrackStr, unsigned long Row,
    unsigned long NumRows, unsigned long Flags )
{
  if ( TrackStr )
  {
    struct TuComposerTrackData *TrackData;

    if ( TrackData = TrackStr->tct_Data )
    {
      struct TuComposerTrackData *CopyData;
      ULONG TrackLen = (TrackStr->tct_Length) + 1;
      ULONG CopyDestNum;
      ULONG NewLen;
      UWORD CopyNum;

      if (Row >= TrackLen)
        return ( 0L );

      NumRows = ((NumRows + Row) < TrackLen ? NumRows : TrackLen - Row);
      CopyDestNum = (Row + NumRows);

      if (Flags & ROWF_NotesOnly)
      {
        struct TuComposerTrackEffect *FreeData;
        struct TuComposerTrackEffect *FXData;

        TrackData += Row;
        CopyData = TrackData + NumRows;

        for (CopyNum = (TrackLen - Row) - NumRows; CopyNum > 0; CopyNum--)
        {
          FXData = (struct TuComposerTrackEffect *) &(TrackData->tctd_Effects.mlh_Head);

          for (;;)
          {
            FreeData = (struct TuComposerTrackEffect *) FXData->tcte_Node.mln_Succ;

            if (!( (struct TuComposerTrackEffect *) FreeData->tcte_Node.mln_Succ ))
              break;

            DeleteEffect ( FreeData );
            FreeEffect ( FreeData );
          }

          ReMapNodeList ( (struct List *) &(CopyData->tctd_Effects), (struct List *) &(TrackData->tctd_Effects) );

          TrackData->tctd_Octave = CopyData->tctd_Octave;
          TrackData->tctd_Note = CopyData->tctd_Note;
          TrackData->tctd_Instrument = CopyData->tctd_Instrument;

          FXData = (struct TuComposerTrackEffect *) &(CopyData->tctd_Effects.mlh_Head);

          for (;;)
          {
            FreeData = (struct TuComposerTrackEffect *) FXData->tcte_Node.mln_Succ;

            if (!( (struct TuComposerTrackEffect *) FreeData->tcte_Node.mln_Succ ))
              break;

            DeleteEffect ( FreeData );
            FreeEffect ( FreeData );
          }

          CopyData->tctd_Octave = 0;
          CopyData->tctd_Note = 0;
          CopyData->tctd_Instrument = 0;

          TrackData++;
          CopyData++;
        }

        for (CopyNum = NumRows; CopyNum > 0; CopyNum--)
        {
          FXData = (struct TuComposerTrackEffect *) &(TrackData->tctd_Effects.mlh_Head);

          for (;;)
          {
            FreeData = (struct TuComposerTrackEffect *) FXData->tcte_Node.mln_Succ;

            if (!( (struct TuComposerTrackEffect *) FreeData->tcte_Node.mln_Succ ))
              break;

            DeleteEffect ( FreeData );
            FreeEffect ( FreeData );
          }

          TrackData->tctd_Octave = 0;
          TrackData->tctd_Note = 0;
          TrackData->tctd_Instrument = 0;

          TrackData++;
        }

        return ( 0L );
      }

      NewLen = ( CopyDestNum < TrackLen ? TrackLen - NumRows : Row );

      if ( NewLen )
      {
        if ( CopyData = AllocTrackData ( NewLen ))
        {
          struct TuComposerSong *SongStr;
          struct TuComposerTrackData *SrcTmpData = TrackData;
          struct TuComposerTrackData *CopyTmpData = CopyData;

          if ( Row )
          {
            for (CopyNum = Row; CopyNum > 0; CopyNum--)
            {
              ReMapNodeList ( (struct List *) &(SrcTmpData->tctd_Effects), (struct List *) &(CopyTmpData->tctd_Effects) );

              CopyTmpData->tctd_Octave = SrcTmpData->tctd_Octave;
              CopyTmpData->tctd_Note = SrcTmpData->tctd_Note;
              CopyTmpData->tctd_Instrument = SrcTmpData->tctd_Instrument;

              SrcTmpData++;
              CopyTmpData++;
            }
          }

          SrcTmpData += NumRows;

          for (CopyNum = (TrackLen - Row) - NumRows; CopyNum > 0; CopyNum--)
          {
            ReMapNodeList ( (struct List *) &(SrcTmpData->tctd_Effects), (struct List *) &(CopyTmpData->tctd_Effects) );

            CopyTmpData->tctd_Octave = SrcTmpData->tctd_Octave;
            CopyTmpData->tctd_Note = SrcTmpData->tctd_Note;
            CopyTmpData->tctd_Instrument = SrcTmpData->tctd_Instrument;

            SrcTmpData++;
            CopyTmpData++;
          }

          if ( (SongStr = TuCBase->tcb_PlaySong) )
          {
            struct PlayerHostChannel *PHCStr = SongStr->tcso_ChannelData;
            ULONG i;

            Disable ();

            for (i = SongStr->tcso_Channels; i > 0; i--)
            {
              if ( PHCStr->phc_Track == TrackStr )
              {
                if ( PHCStr->phc_Row >= (Row + NumRows) )
                  PHCStr->phc_Row -= NumRows;

                if ( PHCStr->phc_MaxRow < NumRows )
                {
                  PHCStr->phc_MaxRow = 0L;
                } else
                {
                  PHCStr->phc_MaxRow -= NumRows;
                }
              }

              PHCStr++;
            }

            Enable ();
          }

          FreePMem ( TrackData, TrackLen * sizeof (struct TuComposerTrackData ));

          TrackStr->tct_Data = CopyData;
          TrackStr->tct_Length = NewLen;

          return ( 0L );
        }

        return ( ERROR_TRACK_NOMEM );
      }

      return ( ERROR_TRACK_TOO_LOW );
    }

    return ( ERROR_TRACK_NODATA );
  }

  return ( ERROR_TRACK_NOGIVEN );
}
