/* TuComposer OS independent code
**
** $VER: DeleteTrack.c 31.22 (8.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG DeleteTrack ( struct TuComposerTrack *TrackStr )
{
  struct TuComposerModule *ModuleList;
  struct TuComposerSong *SongList;

  if ( TrackStr )
  {
    ObtainSemaphoreShared ( TuCBase->tcb_ModuleListSigSem );

    ModuleList = (struct TuComposerModule *) &(TuCBase->tcb_ModuleList.mlh_Head);

    for (;;)
    {
      ModuleList = (struct TuComposerModule *) ModuleList->tcm_Node.mln_Succ;

      if (!( ModuleList->tcm_Node.mln_Succ ))
        break;

      SongList = (struct TuComposerSong *) &(ModuleList->tcm_SongList.mlh_Head);

      for (;;)
      {
        struct TuComposerTrack *ReMapTrackStr;

        SongList = (struct TuComposerSong *) SongList->tcso_Node.mln_Succ;

        if (!( SongList->tcso_Node.mln_Succ ))
          break;

        ReMapTrackStr = (struct TuComposerTrack *) TrackStr->tct_Node.mln_Succ;

        if (!( ReMapTrackStr->tct_Node.mln_Succ ))
        {
          ReMapTrackStr = (struct TuComposerTrack *) TrackStr->tct_Node.mln_Pred;

          if (!( ReMapTrackStr->tct_Node.mln_Pred ))
            ReMapTrackStr = NULL;
        }

        ReMapTrack ( SongList, TrackStr, ReMapTrackStr );
      }
    }

    RemoveNode ( (struct Node *) TrackStr );

    ReleaseSemaphore ( TuCBase->tcb_ModuleListSigSem );

    TrackStr->tct_Node.mln_Succ = NULL;
    TrackStr->tct_Node.mln_Pred = NULL;

    return ( 0L );
  }

  return ( ERROR_TRACK_NOGIVEN );
}
