/* TuComposer OS independent code
**
** $VER: DupTrack.c 31.22 (8.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerTrack *DoDupTrack ( struct TuComposerTrack *TrackStr, struct TuComposerTrack *CloneTrack );

#ifndef MOTOROLA
  ULONG ReadMLong ( UBYTE *Buffer );
#else
  #define ReadMLong( Buffer ) (*(ULONG *) (Buffer))
#endif

struct TuComposerTrack *DupTrack ( struct TuComposerTrack *TrackStr )
{
  return ( DoDupTrack ( TrackStr, NULL ));
}

struct TuComposerTrack *DoDupTrack ( struct TuComposerTrack *TrackStr, struct TuComposerTrack *CloneTrack )
{
  ULONG Length, i;
  struct TuComposerTrackData *SrcData;
  struct TuComposerTrackData *DestData;
  struct UnknownChunk *TrackUnkChunk;
  struct UnknownChunk *CloneUnkChunk;

  if ( TrackStr )
  {
    if (!( CloneTrack ))
    {
      if (!( CloneTrack = AllocTrack ( (TrackStr->tct_Length) + 1 )))
        return ( NULL );
    }

    if ( TrackStr->tct_FileName )
    {
      if (!( SetString ( (STRPTR *) &(CloneTrack->tct_FileName), TrackStr->tct_FileName )))
        goto DupTrackErr;
    }

    if ( TrackStr->tct_Name )
    {
      if (!( SetString ( (STRPTR *) &(CloneTrack->tct_Name), TrackStr->tct_Name )))
        goto DupTrackErr;
    }

    memcpy ( &(CloneTrack->tct_Volume), &(TrackStr->tct_Volume), offsetof(struct TuComposerTrack, tct_UnknownChunks) - offsetof(struct TuComposerTrack, tct_Volume));

    Length = (TrackStr->tct_Length) + 1;
    SrcData = TrackStr->tct_Data;
    DestData = CloneTrack->tct_Data;

    for (i = Length; i > 0; i--)
    {
      DestData->tctd_Octave = SrcData->tctd_Octave;
      DestData->tctd_Note = SrcData->tctd_Note;
      DestData->tctd_Instrument = SrcData->tctd_Instrument;

      if (!( DupNodeList ( (struct MinList *) &(SrcData->tctd_Effects), (struct MinList *) &(DestData->tctd_Effects), sizeof (struct TuComposerTrackEffect) )))
        goto DupTrackErr;

      SrcData++;
      DestData++;
    }

    TrackUnkChunk = (struct UnknownChunk *) &(TrackStr->tct_UnknownChunks.mlh_Head);

    for (;;)
    {
      TrackUnkChunk = (struct UnknownChunk *) TrackUnkChunk->uc_Node.mln_Succ;

      if (!( TrackUnkChunk->uc_Node.mln_Succ))
        break;

      if (!( CloneUnkChunk = AllocUnknownChunk ( (APTR) &(TrackUnkChunk->uc_Data), ReadMLong ( (UBYTE *) &(TrackUnkChunk->uc_Identifier[0])), ReadMLong ( (UBYTE *) &(TrackUnkChunk->uc_Length[0])) )))
        goto DupTrackErr;

      AddNodeTail ( (struct List *) &(CloneTrack->tct_UnknownChunks), (struct Node *) CloneUnkChunk );
    }

    return ( CloneTrack );

DupTrackErr:
    FreeTrack ( CloneTrack );
  }

  return ( NULL );
}
