/* TuComposer OS independent code
**
** $VER: ExpandTrack.c 31.22 (23.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ExpandTrack ( struct TuComposerTrack *TrackStr, unsigned long Scale )
{
  if ( TrackStr )
  {
    struct TuComposerTrackData *TrackData;
    ULONG TrackLen;

    if ( TrackData = TrackStr->tct_Data )
    {
      if ( Scale )
      {
        struct TuComposerTrackData *NewTrackData;
        ULONG NewLength;

        if ( Scale == 1)
          return ( 0L );

        TrackLen = (TrackStr->tct_Length) + 1;

        if ((NewLength = (TrackLen * Scale)) > MAXTRACKROWS)
          return ( ERROR_TRACK_TOO_BIG );

        if (NewTrackData = AllocTrackData ( NewLength ))
        {
          struct TuComposerTrackData *SrcTrackData = TrackData;
          struct TuComposerTrackData *DestTrackData = NewTrackData;
          ULONG Pos;

          for (Pos = TrackLen; Pos > 0; Pos--)
          {
            DestTrackData->tctd_Octave = SrcTrackData->tctd_Octave;
            DestTrackData->tctd_Note = SrcTrackData->tctd_Note;
            DestTrackData->tctd_Instrument = SrcTrackData->tctd_Instrument;

            ReMapNodeList ( (struct List *) &(SrcTrackData->tctd_Effects), (struct List *) &(DestTrackData->tctd_Effects));

            InitNodeList ( (struct List *) &(SrcTrackData->tctd_Effects));

            SrcTrackData++;
            DestTrackData += Scale;
          }

          FreeTrackData ( TrackData, TrackLen );

          TrackStr->tct_Data = NewTrackData;
          TrackStr->tct_Length = (NewLength - 1);
        }

        return ( ERROR_TRACK_NOMEM );
      }

      return ( ERROR_TRACK_NOSCALE );
    }

    return ( ERROR_TRACK_NODATA );
  }

  return( ERROR_TRACK_NOGIVEN );
}
