/* TuComposer OS independent code
**
** $VER: FreePackedTrack.c 31.22 (25.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

void FreePackedTrack ( struct TuComposerPacked *PackedTrackStr )
{
  struct UnknownChunk *TrackUnkChunk;
  struct UnknownChunk *FreeUnkChunk;
  UBYTE *PackedStr;
  ULONG PackedLen;

  if ( PackedLen = PackedTrackStr->tcp_PackLength )
  {
    if ( PackedStr = PackedTrackStr->tcp_Data )
      FreePMem ( PackedStr, PackedLen + 1 );
  }

  FreeNameStr ( PackedTrackStr->tcp_FileName );
  FreeNameStr ( PackedTrackStr->tcp_Name );

  TrackUnkChunk = (struct UnknownChunk *) &(PackedTrackStr->tcp_UnknownChunks.mlh_Head);

  for (;;)
  {
    FreeUnkChunk = (struct UnknownChunk *) TrackUnkChunk->uc_Node.mln_Succ;
    if (!( (struct UnknownChunk *) FreeUnkChunk->uc_Node.mln_Succ ))
      break;

    FreeUnknownChunk ( FreeUnkChunk );
  }

  FreePMem ( PackedTrackStr, sizeof (struct TuComposerPacked ));
}
