/* TuComposer OS independent code
**
** $VER: FreeTrack.c 31.22 (8.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG FreeTrack ( struct TuComposerTrack *TrackStr )
{
  struct UnknownChunk *TrackUnkChunk;
  struct UnknownChunk *FreeUnkChunk;

  if ( TrackStr )
  {
    if ( TrackStr->tct_Node.mln_Succ )
    {
      struct TuComposerSong *SongStr;
      struct TuComposerOrders *PosStr;
      ULONG i;

      SongStr = (struct TuComposerSong *) &(TrackStr->tct_Node.mln_Succ);

      for (;;)
      {
        SongStr = (struct TuComposerSong *) SongStr->tcso_Node.mln_Pred;

        if (!( SongStr->tcso_Node.mln_Pred ))
          break;
      }

      (UBYTE *) SongStr += -offsetof (struct TuComposerSong, tcso_TrackList );

      PosStr = SongStr->tcso_Position;

      for ( i = SongStr->tcso_Channels; i > 0; i--)
      {
        struct TuComposerOrderList *PosListStr = (struct TuComposerOrderList *) &(PosStr->tco_OrderData.mlh_Head);

        for (;;)
        {
          PosListStr = (struct TuComposerOrderList *) PosListStr->tcol_Node.mln_Succ;

          if (!( PosListStr->tcol_Node.mln_Succ ))
            break;

          if ( TrackStr == PosListStr->tcol_Track )
          {
            struct TuComposerTrack *TrackBuf = (struct TuComposerTrack *) TrackStr->tct_Node.mln_Succ;

            if ( TrackBuf->tct_Node.mln_Succ )
            {
              PosListStr->tcol_Track = TrackBuf;
            } else
            {
              TrackBuf = (struct TuComposerTrack *) TrackStr->tct_Node.mln_Pred;

              if ( TrackBuf->tct_Node.mln_Pred )
              {
                PosListStr->tcol_Track = TrackBuf;
              } else
              {
                PosListStr->tcol_Track = NULL;
              }
            }
          }
        }

        PosStr++;
      }

      DeleteTrack ( TrackStr );

      if ( (SongStr = TuCBase->tcb_PlaySong) )
      {
        struct PlayerHostChannel *PHCStr;

        PHCStr = SongStr->tcso_ChannelData;

        Disable ();

        for ( i = SongStr->tcso_Channels; i > 0; i--)
        {
          if ( TrackStr == PHCStr->phc_Track )
          {
            PHCStr->phc_TempoCounter = 0xFFFFFFFE;
            PHCStr->phc_Flags &= ~(PHCF_PattLoop);
            PHCStr->phc_Flags |= PHCF_PatternBreak;
          }

          PHCStr++;
        }

        Enable ();
      }
    }

    FreeTrackData ( TrackStr->tct_Data, (TrackStr->tct_Length) + 1 );

    FreeNameStr ( TrackStr->tct_FileName );
    FreeNameStr ( TrackStr->tct_Name );

    TrackUnkChunk = (struct UnknownChunk *) &(TrackStr->tct_UnknownChunks.mlh_Head);

    for (;;)
    {
      FreeUnkChunk = (struct UnknownChunk *) TrackUnkChunk->uc_Node.mln_Succ;

      if (!( (struct UnknownChunk *) FreeUnkChunk->uc_Node.mln_Succ ))
        break;

      FreeUnknownChunk ( FreeUnkChunk );
    }

    FreePMem ( TrackStr, sizeof (struct TuComposerTrack ));

    return ( 0L );
  }

  return ( ERROR_TRACK_NOGIVEN );
}
