/* TuComposer OS independent code
**
** $VER: FreeTrackData.c 31.22 (4.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG FreeTrackData ( struct TuComposerTrackData *TrackData,
    unsigned long Length )
{
  struct TuComposerTrackData *TrackCnt;
  struct TuComposerTrackEffect *TrackFX;
  struct TuComposerTrackEffect *FreeFX;

  ULONG i;

  if ( TrackData )
  {

    TrackCnt = TrackData;

    for (i = Length; i > 0; i--)
    {
      TrackCnt->tctd_Octave = 0;
      TrackCnt->tctd_Note = 0;
      TrackCnt->tctd_Instrument = 0;

      TrackFX = (struct TuComposerTrackEffect *) &(TrackCnt->tctd_Effects.mlh_Head);

      for (;;)
      {
        FreeFX = (struct TuComposerTrackEffect *) TrackFX->tcte_Node.mln_Succ;

        if (!( (struct TuComposerTrackEffect *) FreeFX->tcte_Node.mln_Succ ))
          break;

        RemoveNode ( (struct Node *) FreeFX );

        FreeEffect ( FreeFX );
      }

      TrackCnt++;
    }

    FreePMem ( (APTR) TrackData, Length * sizeof (struct TuComposerTrackData ));

    return ( 0L );
  }

  return ( ERROR_TRACK_NODATA );
}
