/* TuComposer OS independent code
**
** $VER: GetNoteStr.c 31.22 (25.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct NoteNames {
  UBYTE NoteName[4];
};

struct NoteNames NotesSharp[] =
{
  "C-",
  "C#",
  "D-",
  "D#",
  "E-",
  "F-",
  "F#",
  "G-",
  "G#",
  "A-",
  "A#",
  "B-"
};

struct NoteNames Notes_b[] =
{
  "C-",
  "Db",
  "D-",
  "Eb",
  "E-",
  "F-",
  "Gb",
  "G-",
  "Ab",
  "A-",
  "Bb",
  "B-"
};

struct NoteNames SpecialNotes[] =
{
  "^^^",           /* Note kill */
  "^^-",           /* Note cut */
  "===",           /* Note off */
  "-|-",           /* Hold delay */
  "-\\-",           /* Note fade */
  "---",           /* Not defined yet */
  "---",           /* Not defined yet */
  "---",           /* Not defined yet */
  "---",           /* Not defined yet */
  "---",           /* Not defined yet */
  "---",           /* Not defined yet */
  "---",           /* Not defined yet */
  "---",           /* Not defined yet */
  "---",           /* Not defined yet */
  "END",           /* Pattern end marker */
  0
};

void GetNoteStr ( STRPTR StrBuf, unsigned long Octave, unsigned long Note,
    unsigned long Flags )
{
  if ( Note )
  {
    UBYTE NotePos = Note;
    struct NoteNames *SpecTmp = SpecialNotes;
    struct NoteNames *NoteTable = NotesSharp;

    for (;;)
    {
      NotePos++;
      if ( NotePos == 0 )
      {
        StrBuf[0] = SpecTmp->NoteName[0];
        StrBuf[1] = SpecTmp->NoteName[1];
        StrBuf[2] = SpecTmp->NoteName[2];

        return;
      }

      SpecTmp++;

      if (SpecTmp->NoteName[0] == 0)
      {
        break;
      }
    }

    if ( Flags & NSF_bSharp )
      NoteTable = Notes_b;

    if ( (Octave > LASTOCTAVE) || (Note > LASTNOTE))
    {
      StrBuf[0] = '?';
      StrBuf[1] = '?';
      StrBuf[2] = '?';
    } else
    {
      StrBuf[0] = Octave+'0';
      NoteTable += Note - 1;
      StrBuf[1] = NoteTable->NoteName[0];

      if ( Flags & NSF_HDisplay )
      {
        if ( NoteTable->NoteName[0] == 'B' )
          StrBuf[1] = 'H';
      }

      StrBuf[2] = NoteTable->NoteName[1];
    }
  } else
  {
    StrBuf[0] = '-';
    StrBuf[1] = '-';
    StrBuf[2] = '-';
  }
}
