/* TuComposer OS independent code
**
** $VER: GetTrackInfo.c 31.22 (5.8.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>
#include <clib/ext_trackbase_protos.h>

struct TrackInfo *GetTrackInfo ( struct CFHandle *CFHandle,
    struct TuComposerExtList *ExtLibStr, unsigned long NumTrack )
{
  struct TrackInfo *TrackInfoStr = NULL;

  if ( CFHandle )
  {
    if (!( ExtLibStr ))
      ExtLibStr = IdentifyTrack ( CFHandle );

    if ( ExtLibStr )
    {
      if ( (TrackInfoStr = (struct TrackInfo *) AllocPMem (sizeof (struct TrackInfo ))))
      {
        struct TrackLibrary *ExtTrackLibBase;

        if ( (ExtTrackLibBase = (struct TrackLibrary *) OpenExternalLib ( ExtLibStr )))
        {
          ULONG RC;

          RC = ExternalTrackGetInfoBase ( CFHandle, TrackInfoStr, NumTrack, ExtTrackLibBase );

          CloseExternalLib ( ExtLibStr );

          if (!( RC ))
          {
            FreeTrackInfo ( TrackInfoStr );

            TrackInfoStr = NULL;
          }
        } else
        {
          FreePMem ( TrackInfoStr, sizeof (struct TrackInfo ));

          TrackInfoStr = NULL;
        }
      }
    }
  }

  return ( TrackInfoStr );
}
