/* TuComposer OS independent code
**
** $VER: InsertRows.c 31.22 (18.5.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG InsertRows ( struct TuComposerTrack *TrackStr, unsigned long Row,
    unsigned long NumRows, unsigned long Flags )
{
  if ( TrackStr )
  {
    struct TuComposerTrackData *TrackData;

    if ( (TrackData = TrackStr->tct_Data ))
    {
      if ( NumRows )
      {
        ULONG TrackLen, NewLen;

        TrackLen = ( TrackStr->tct_Length ) + 1;

        if (Flags & ROWF_NotesOnly)
        {
          struct TuComposerTrackData *CopyData;
          struct TuComposerTrackEffect *FreeData;
          struct TuComposerTrackEffect *FXData;
          ULONG CopyNum;

          if ( Row >= TrackLen )
            Row = TrackLen - 1;

          if ( (Row + NumRows) > TrackLen )
            NumRows = TrackLen - Row;

          TrackData += Row;
          CopyData = TrackData + NumRows;

          if ( TrackLen > (Row + NumRows))
          {
            for (CopyNum = (TrackLen - Row) - NumRows; CopyNum > 0; CopyNum--)
            {
              FXData = (struct TuComposerTrackEffect *) &(CopyData->tctd_Effects.mlh_Head);

              for (;;)
              {
                FreeData = (struct TuComposerTrackEffect *) FXData->tcte_Node.mln_Succ;

                if (!( (struct TuComposerTrackEffect *) FreeData->tcte_Node.mln_Succ ))
                  break;

                DeleteEffect ( FreeData );
                FreeEffect ( FreeData );
              }

              ReMapNodeList ( (struct List *) &(TrackData->tctd_Effects), (struct List *) &(CopyData->tctd_Effects) );

              CopyData->tctd_Octave = TrackData->tctd_Octave;
              CopyData->tctd_Note = TrackData->tctd_Note;
              CopyData->tctd_Instrument = TrackData->tctd_Instrument;

              TrackData++;
              CopyData++;
            }
          }

          TrackData = (TrackStr->tct_Data + Row);

          for (CopyNum = NumRows; CopyNum > 0; CopyNum--)
          {
            FXData = (struct TuComposerTrackEffect *) &(TrackData->tctd_Effects.mlh_Head);

            for (;;)
            {
              FreeData = (struct TuComposerTrackEffect *) FXData->tcte_Node.mln_Succ;

              if (!( (struct TuComposerTrackEffect *) FreeData->tcte_Node.mln_Succ ))
                break;

              DeleteEffect ( FreeData );
              FreeEffect ( FreeData );
            }

            TrackData->tctd_Octave = 0;
            TrackData->tctd_Note = 0;
            TrackData->tctd_Instrument = 0;

            TrackData++;
          }

          return ( 0L );
        }

        if ( (NewLen = (TrackLen + NumRows)) <= MAXTRACKROWS )
        {
          if ( Row >= NewLen )
          {
            AddRows ( TrackStr, NumRows );
          } else
          {
            struct TuComposerSong *SongStr;
            struct TuComposerTrackData *NewTrackData;
            struct TuComposerTrackData *CopyTrackData;
            ULONG i;

            if (!( NewTrackData = AllocTrackData ( NewLen )))
              return ( ERROR_TRACK_NOMEM );

            CopyTrackData = NewTrackData;

            if ( Row )
            {
              for (i = Row; i > 0; i--)
              {
                CopyTrackData->tctd_Octave = TrackData->tctd_Octave;
                CopyTrackData->tctd_Note = TrackData->tctd_Note;
                CopyTrackData->tctd_Instrument = TrackData->tctd_Instrument;

                ReMapNodeList ( (struct List *) &(TrackData->tctd_Effects), (struct List *) &(CopyTrackData->tctd_Effects) );

                TrackData++;
                CopyTrackData++;
              }
            }

            CopyTrackData += NumRows;

            for (i = TrackLen - (Row + NumRows); i > 0; i--)
            {
              CopyTrackData->tctd_Octave = TrackData->tctd_Octave;
              CopyTrackData->tctd_Note = TrackData->tctd_Note;
              CopyTrackData->tctd_Instrument = TrackData->tctd_Instrument;

              ReMapNodeList ( (struct List *) &(TrackData->tctd_Effects), (struct List *) &(CopyTrackData->tctd_Effects) );

              TrackData++;
              CopyTrackData++;
            }

            if ( (SongStr = TuCBase->tcb_PlaySong) )
            {
              struct PlayerHostChannel *PHCStr = SongStr->tcso_ChannelData;
              ULONG i;

              Disable ();

              for (i = SongStr->tcso_Channels; i > 0; i--)
              {
                if ( PHCStr->phc_Track == TrackStr )
                {
                  if ( PHCStr->phc_Row >= Row )
                    PHCStr->phc_Row += NumRows;

                  PHCStr->phc_MaxRow += NumRows;
                }

                PHCStr++;
              }

              Enable ();
            }

            FreeTrackData ( TrackStr->tct_Data, TrackLen );

            TrackStr->tct_Data = NewTrackData;
            TrackStr->tct_Length = NewLen - 1;
          }

          return ( 0L );
        }

        return ( ERROR_TRACK_TOO_BIG );
      }

      return ( 0L );
    }

    return ( ERROR_TRACK_NODATA );
  }

  return ( ERROR_TRACK_NOGIVEN );
}
