/* TuComposer OS independent code
**
** $VER: JoinTrack.c 31.22 (18.5.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG JoinTrack ( struct TuComposerTrack *SrcTrackStr,
    struct TuComposerTrack *DestTrackStr )
{
  if ( SrcTrackStr && DestTrackStr )
  {
    struct TuComposerTrackData *SrcTrackData;
    struct TuComposerTrackData *DestTrackData;

    if ( (SrcTrackData = SrcTrackStr->tct_Data ) && (DestTrackData = DestTrackStr->tct_Data ))
    {
      ULONG SrcLen,DestLen,NewLen,RC,i;

      SrcLen = (SrcTrackStr->tct_Length + 1);
      DestLen = (DestTrackStr->tct_Length + 1);
      if ( (NewLen = (SrcLen + DestLen)) < MAXTRACKROWS )
      {
        if (!( RC = AddRows ( SrcTrackStr, DestLen )))
        {
          SrcTrackData = (SrcTrackStr->tct_Data) + SrcLen;

          for (i = DestLen; i > 0; i--)
          {
            SrcTrackData->tctd_Octave = DestTrackData->tctd_Octave;
            SrcTrackData->tctd_Note = DestTrackData->tctd_Note;
            SrcTrackData->tctd_Instrument = DestTrackData->tctd_Instrument;

            ReMapNodeList ( (struct List *) &(DestTrackData->tctd_Effects), (struct List *) &(SrcTrackData->tctd_Effects));

            SrcTrackData++;
            DestTrackData++;
          }
        }

        return ( RC );
      }

      return ( ERROR_TRACK_TOO_BIG );
    }

    return ( ERROR_TRACK_NODATA );
  }

  return ( ERROR_TRACK_NOGIVEN );
}
