/* TuComposer OS independent code
**
** $VER: PlayTrack.c 31.22 (10.8.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;
extern struct SoundDeviceInfo *InternalSoundDeviceBase;

ULONG PlayTrack ( union FlagPass *FlagPassStr,
    unsigned long Order, unsigned long Channel,
    unsigned long Row )
{
  if ( TuCBase->tcb_PlayModule )
  {
    struct TuComposerSong *SongStr;

    if ( (SongStr = TuCBase->tcb_PlaySong) )
    {
      struct PlayerGlobals *PGStr = SongStr->tcso_GlobalData;
      struct PlayerHostChannel *PHCStr = SongStr->tcso_ChannelData;
      struct SoundDeviceInfo *ExtDeviceLibBase;
      ULONG i;

      if (!( ExtDeviceLibBase = TuCBase->tcb_PlaySoundDeviceBase ))
        ExtDeviceLibBase = (struct SoundDeviceInfo *) &(InternalSoundDeviceBase);

      TuCBase->tcb_PlaySoundDeviceBase = ExtDeviceLibBase;

      Disable ();

      PGStr->pg_Flags &= ~PGF_NoProcPattern;

      PGStr->pg_PlayTime = 0L;
      PGStr->pg_PlayTimeFrac = 0L;
      PGStr->pg_PlayTics = 0L;
      PGStr->pg_PlayTicsFrac = 0L;

      if ( PGStr->pg_Flags & PGF_PlayPattern )
      {
        Order++;

        PGStr->pg_PlayType &= ~PTYPF_Song;
      } else
      {
        PGStr->pg_PlayType |= PTYPF_Song;
      }

      for (i = 0; i < SongStr->tcso_Channels; i++)
      {
        if ( (Channel == 0xFFFFFFFF) || (i == Channel) )
        {
          PHCStr->phc_Flags |= PHCF_PatternBreak;
          PHCStr->phc_BreakRow = Row;
          PHCStr->phc_TempoCounter = 0xFFFFFFFE;

          if (!( PHCStr->phc_Tempo ))
            PHCStr->phc_Tempo = SongStr->tcso_Frames;

          PHCStr->phc_Order = GetPositionAddr ( SongStr->tcso_Position, i, Order );
        } else
        {
          PHCStr->phc_Tempo = 0;
        }

        PHCStr++;
      }

      Enable ();

      return ( PlaySoundDevice ( ExtDeviceLibBase->sdi_Library.extb_ExtLibList, TuCBase->tcb_PlayMixerAlloc, FlagPassStr ));
    }

    return ( ERROR_SONG_NOGIVEN );
  }

  return ( ERROR_MODULE_NOGIVEN );
}
