/* TuComposer OS independent code
**
** $VER: ReMapEffects.c 31.22 (13.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ReMapEffects ( struct TuComposerTrack *SrcTrackStr,
    struct TuComposerTrack *DestTrackStr, unsigned long SrcRow,
    unsigned long DestRow, unsigned long NumRows )
{
  if ( SrcTrackStr && DestTrackStr )
  {
    struct TuComposerTrackData *SrcTrackData;
    struct TuComposerTrackData *DestTrackData;
    ULONG SrcRows, DestRows, i;

    SrcRows = (SrcTrackStr->tct_Length) + 1;
    DestRows = (DestTrackStr->tct_Length) + 1;

    if ( (SrcTrackData = SrcTrackStr->tct_Data) && (DestTrackData = DestTrackStr->tct_Data))
    {
      if ( SrcRow >= SrcRows )
        SrcRow = SrcRows - 1;

      if ( DestRow >= DestRows )
        DestRow = DestRows - 1;

      if ( (SrcRow + NumRows) > SrcRows )
        NumRows = SrcRows - SrcRow;

      if ( (DestRow + NumRows) > DestRows )
        NumRows = DestRows - DestRow;

      SrcTrackData += SrcRow;
      DestTrackData += DestRow;

      if ( SrcTrackStr == DestTrackStr )
      {
        if ( SrcRow == DestRow )
          return ( 0L );

        if ( SrcRow < DestRow )
        {
          SrcTrackData += NumRows;
          DestTrackData += NumRows;

          for (i = NumRows; i > 0; i--)
          {
            SrcTrackData--;
            DestTrackData--;

            ReMapNodeList ( (struct List *) &(SrcTrackData->tctd_Effects), (struct List *) &(DestTrackData->tctd_Effects));
          }

          return ( 0L );
        }
      }

      for (i = NumRows; i > 0; i--)
      {
        ReMapNodeList ( (struct List *) &(SrcTrackData->tctd_Effects), (struct List *) &(DestTrackData->tctd_Effects));

        SrcTrackData++;
        DestTrackData++;
      }

      return ( 0L );
    }

    return ( ERROR_TRACK_NODATA );
  }

  return ( ERROR_TRACK_NOGIVEN );
}
