/* TuComposer OS independent code
**
** $VER: ReMapRows.c 31.22 (13.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ReMapRows (  struct TuComposerTrack *SrcTrackStr,
    struct TuComposerTrack *DestTrackStr, unsigned long SrcRow,
    unsigned long DestRow, unsigned long NumRows )
{
  if ( SrcTrackStr && DestTrackStr )
  {
    struct TuComposerTrackData *SrcTrackData;
    struct TuComposerTrackData *DestTrackData;
    struct TuComposerTrackEffect *FXData;
    struct TuComposerTrackEffect *FreeData;
    ULONG SrcRows, DestRows, i, Direction;

    SrcRows = (SrcTrackStr->tct_Length) + 1;
    DestRows = (DestTrackStr->tct_Length) + 1;

    if ( (SrcTrackData = SrcTrackStr->tct_Data) && (DestTrackData = DestTrackStr->tct_Data))
    {
      if ( SrcRow >= SrcRows )
        SrcRow = SrcRows - 1;

      if ( DestRow >= DestRows )
        DestRow = DestRows - 1;

      if ( (SrcRow + NumRows) > SrcRows )
        NumRows = SrcRows - SrcRow;

      if ( (DestRow + NumRows) > DestRows )
        NumRows = DestRows - DestRow;

      SrcTrackData += SrcRow;
      DestTrackData += DestRow;

      Direction = 1;

      if ( SrcTrackStr == DestTrackStr )
      {
        if ( SrcRow == DestRow )
          return ( 0L );

        if ( SrcRow < DestRow )
        {
          SrcTrackData += (NumRows - 1);
          DestTrackData += (NumRows - 1);

          Direction = -1;
        }
      }

      for (i = NumRows; i > 0; i--)
      {
        DestTrackData->tctd_Octave = SrcTrackData->tctd_Octave;
        DestTrackData->tctd_Note = SrcTrackData->tctd_Note;
        DestTrackData->tctd_Instrument = SrcTrackData->tctd_Instrument;

        FXData = (struct TuComposerTrackEffect *) &(DestTrackData->tctd_Effects.mlh_Head);

        if ( FXData->tcte_Node.mln_Succ )
        {
          for (;;)
          {
            FreeData = (struct TuComposerTrackEffect *) FXData->tcte_Node.mln_Succ;

            if (!( (struct TuComposerTrackEffect *) FreeData->tcte_Node.mln_Succ ))
              break;

            DeleteEffect ( FreeData );
            FreeEffect ( FreeData );
          }
        }

        InitNodeList ( (struct List *) &(DestTrackData->tctd_Effects));

        ReMapNodeList ( (struct List *) &(SrcTrackData->tctd_Effects), (struct List *) &(DestTrackData->tctd_Effects));

        InitNodeList ( (struct List *) &(SrcTrackData->tctd_Effects));

        SrcTrackData += Direction;
        DestTrackData += Direction;
      }

      return ( 0L );
    }

    return ( ERROR_TRACK_NODATA );
  }

  return ( ERROR_TRACK_NOGIVEN );
}
