/* TuComposer OS independent code
**
** $VER: RemRows.c 31.22 (13.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG RemRows ( struct TuComposerTrack *TrackStr, unsigned long NumRows )
{
  if ( TrackStr )
  {
    ULONG OldLength;

    OldLength = (TrackStr->tct_Length) + 1;

    if ( NumRows < OldLength )
    {
      struct TuComposerTrackData *NewTrackData;
      ULONG Length;

      Length = OldLength - NumRows;

      if ( NewTrackData = (struct TuComposerTrackData *) AllocPMem ( Length * sizeof (struct TuComposerTrackData )))
      {
        struct TuComposerSong *SongStr;
        struct TuComposerTrackData *TrackData = TrackStr->tct_Data;
        struct TuComposerTrackData *InitTrackData = NewTrackData;
        ULONG ReMapRows;

        TrackStr->tct_Length = (Length - 1);

        for (ReMapRows = Length; ReMapRows > 0; ReMapRows--)
        {
          ReMapNodeList ( (struct List *) &(TrackData->tctd_Effects), (struct List *) &(InitTrackData->tctd_Effects));

          InitNodeList ( (struct List *) &(TrackData->tctd_Effects));

          TrackData++;
          InitTrackData++;
        }

        if ( (SongStr = TuCBase->tcb_PlaySong) )
        {
          struct PlayerHostChannel *PHCStr = SongStr->tcso_ChannelData;
          ULONG i;

          Disable ();

          for (i = SongStr->tcso_Channels; i > 0; i--)
          {
            if ( PHCStr->phc_Track == TrackStr )
            {
              if ( PHCStr->phc_MaxRow < NumRows )
              {
                PHCStr->phc_MaxRow = 0L;
              } else
              {
                PHCStr->phc_MaxRow -= NumRows;
              }
            }

            PHCStr++;
          }

          Enable ();
        }

        FreeTrackData ( TrackStr->tct_Data, OldLength );

        TrackStr->tct_Data = NewTrackData;

        return ( 0L );
      }

      return ( ERROR_TRACK_NOMEM );
    }

    return ( ERROR_TRACK_TOO_LOW );
  }

  return ( ERROR_TRACK_NOGIVEN );
}
