/* TuComposer OS independent code
**
** $VER: RotateTrack.c 31.22 (14.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG RotateTrack ( struct TuComposerTrack *TrackStr, long Rows,
    unsigned long StartRow, unsigned long EndRow )
{
  if ( TrackStr )
  {
    struct TuComposerTrackData *TrackData;
    struct TuComposerTrackData *RotateData;
    struct TuComposerTrackData *RotateBuf;
    struct TuComposerTrackData *StartData;
    struct TuComposerTrackData *EndData;
    struct TuComposerTrackData *TmpData;
    ULONG Length, i;
    LONG TmpRow, RotateCnt;

    if ( (TrackData = TrackStr->tct_Data) )
    {
      Length = (TrackStr->tct_Length) + 1;

      if ( StartRow > EndRow )
      {
        TmpRow = StartRow;
        StartRow = EndRow;
        EndRow = TmpRow;
      }

      if ( StartRow >= Length )
        StartRow = Length - 1;

      if ( EndRow >= Length )
        EndRow = Length - 1;

      TmpRow = (EndRow - StartRow) + 1;

      if ( (RotateCnt = (Rows % TmpRow)) )
      {
        if ( (RotateData = AllocTrackData ( TmpRow )))
        {
          if ( RotateCnt > 0 )
          {
            RotateBuf = RotateData + RotateCnt;
            StartData = TrackData + StartRow;
            EndData = RotateData + TmpRow;

            for (i = TmpRow; i > 0; i--)
            {
              RotateBuf->tctd_Octave = StartData->tctd_Octave;
              RotateBuf->tctd_Note = StartData->tctd_Note;
              RotateBuf->tctd_Instrument = StartData->tctd_Instrument;

              ReMapNodeList ( (struct List *) &(StartData->tctd_Effects), (struct List *) &(RotateBuf->tctd_Effects));

              InitNodeList ( (struct List *) &(StartData->tctd_Effects));

              StartData++;
              RotateBuf++;

              if ( EndData == RotateBuf )
                RotateBuf = RotateData;
            }
          } else
          {
            RotateCnt = -RotateCnt;

            RotateBuf = RotateData;
            StartData = TrackData + StartRow;
            EndData = TrackData + (EndRow + 1);
            TmpData = StartData + RotateCnt;

            for (i = TmpRow; i > 0; i--)
            {
              RotateBuf->tctd_Octave = TmpData->tctd_Octave;
              RotateBuf->tctd_Note = TmpData->tctd_Note;
              RotateBuf->tctd_Instrument = TmpData->tctd_Instrument;

              ReMapNodeList ( (struct List *) &(TmpData->tctd_Effects), (struct List *) &(RotateBuf->tctd_Effects));

              InitNodeList ( (struct List *) &(TmpData->tctd_Effects));

              TmpData++;
              RotateBuf++;

              if ( EndData == TmpData )
                TmpData = StartData;
            }
          }

          TrackData += StartRow;
          RotateBuf = RotateData;

          for (i = TmpRow; i > 0; i--)
          {
            TrackData->tctd_Octave = RotateBuf->tctd_Octave;
            TrackData->tctd_Note = RotateBuf->tctd_Note;
            TrackData->tctd_Instrument = RotateBuf->tctd_Instrument;

            ReMapNodeList ( (struct List *) &(RotateBuf->tctd_Effects), (struct List *) &(TrackData->tctd_Effects));

            InitNodeList ( (struct List *) &(RotateBuf->tctd_Effects));

            TrackData++;
            RotateBuf++;
          }

          FreeTrackData ( RotateData, TmpRow );

          return ( 0L );
        }

        return ( ERROR_TRACK_NOMEM );
      }

      return ( 0L );
    }

    return ( ERROR_TRACK_NODATA );
  }

  return ( ERROR_TRACK_NOGIVEN );
}
