/* TuComposer OS independent code
**
** $VER: ScrollTrack.c 31.22 (14.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ScrollTrack ( struct TuComposerTrack *TrackStr, long Rows,
    unsigned long StartRow, unsigned long EndRow )
{
  if ( TrackStr )
  {
    struct TuComposerTrackData *TrackData;
    ULONG Length, TmpRow;

    if ( (TrackData = TrackStr->tct_Data) )
    {
      Length = (TrackStr->tct_Length) + 1;

      if ( StartRow > EndRow )
      {
        TmpRow = StartRow;
        StartRow = EndRow;
        EndRow = TmpRow;
      }

      if ( StartRow >= Length )
        StartRow = Length - 1;

      if ( EndRow >= Length )
        EndRow = Length - 1;

      if ( Rows )
      {
        TmpRow = (EndRow - StartRow) + 1;

        if ( Rows > 0 )
        {
          if ( TmpRow < Rows )
            Rows = TmpRow;

          if ( TmpRow > Rows )
            ReMapRows ( TrackStr, TrackStr, StartRow, StartRow + Rows, TmpRow - Rows );

          ClearRows ( TrackStr, StartRow, Rows );
        } else
        {
          Rows = -Rows;

          if ( TmpRow < Rows )
            Rows = TmpRow;

          if ( TmpRow > Rows )
            ReMapRows ( TrackStr, TrackStr, StartRow + Rows, StartRow, TmpRow - Rows );

          ClearRows ( TrackStr, EndRow - (Rows - 1), Rows );
        }
      }

      return ( 0L );
    }

    return ( ERROR_TRACK_NODATA );
  }

  return ( ERROR_TRACK_NOGIVEN );
}
