/* TuComposer OS independent code
**
** $VER: ShrinkTrack.c 31.22 (26.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG ShrinkTrack ( struct TuComposerTrack *TrackStr, unsigned long Scale )
{
  if ( TrackStr )
  {
    struct TuComposerTrackData *TrackData;
    ULONG TrackLen;

    if ( TrackData = TrackStr->tct_Data )
    {
      if ( Scale )
      {
        struct TuComposerTrackData *NewTrackData;
        ULONG NewLength;

        if ( Scale == 1)
          return ( 0L );

        TrackLen = (TrackStr->tct_Length) + 1;

        if ((NewLength = (TrackLen / Scale)) == 0L)
          return ( ERROR_TRACK_TOO_LOW );

        if (NewTrackData = AllocTrackData ( NewLength ))
        {
          struct TuComposerTrackData *SrcTrackData;
          struct TuComposerTrackData *DestTrackData;
          ULONG Pos, ClrPos = 0L;

          SrcTrackData = TrackData;
          DestTrackData = NewTrackData;

          for (Pos = TrackLen; Pos > 0; Pos--)
          {
            if ( ClrPos == NULL )
            {
              DestTrackData->tctd_Octave = SrcTrackData->tctd_Octave;
              DestTrackData->tctd_Note = SrcTrackData->tctd_Note;
              DestTrackData->tctd_Instrument = SrcTrackData->tctd_Instrument;

              ReMapNodeList ( (struct List *) &(SrcTrackData->tctd_Effects), (struct List *) &(DestTrackData->tctd_Effects));

              InitNodeList ( (struct List *) &(SrcTrackData->tctd_Effects));

              DestTrackData++;
            }

            SrcTrackData++;
            ClrPos++;

            if ( ClrPos == Scale )
              ClrPos = 0L;
          }

          FreeTrackData ( TrackData, TrackLen );

          TrackStr->tct_Data = NewTrackData;
          TrackStr->tct_Length = (NewLength - 1);

          return ( 0L );
        }

        return ( ERROR_TRACK_NOMEM );
      }

      return ( ERROR_TRACK_NOSCALE );
    }

    return ( ERROR_TRACK_NODATA );
  }

  return( ERROR_TRACK_NOGIVEN );
}
