/* TuComposer OS independent code
**
** $VER: SplitTrack.c 31.22 (26.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <string.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

struct TuComposerTrack *SplitTrack ( struct TuComposerTrack *SrcTrackStr,
     struct TuComposerTrack *DestTrackStr, unsigned long Row )
{
  if ( SrcTrackStr )
  {
    ULONG Length, SplitLen;

    Length = (SrcTrackStr->tct_Length) + 1;

    if ( (Row >= Length) || (Row == 0L) )
      return ( NULL );

    SplitLen = Length - Row;

    if ( DestTrackStr )
    {
      if ( ReSizeTrack ( DestTrackStr, SplitLen ))
        return ( NULL );

    } else
    {
      if (!( DestTrackStr = (struct TuComposerTrack *) AllocTrack ( SplitLen )))
        return ( NULL );

    }

    CopyRows ( SrcTrackStr, DestTrackStr, Row, 0L, SplitLen );

    ReSizeTrack ( SrcTrackStr, Row - 1);

    memcpy ( &(SrcTrackStr->tct_Volume), &(DestTrackStr->tct_Volume), offsetof (struct TuComposerTrack, tct_UnknownChunks) - offsetof (struct TuComposerTrack, tct_Volume));

    return ( DestTrackStr );
  }

  return ( NULL );
}
