/* TuComposer OS independent code
**
** $VER: SwapRows.c 31.22 (26.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG SwapRows ( struct TuComposerTrack *SrcTrackStr,
    struct TuComposerTrack *DestTrackStr, unsigned long SrcRow,
    unsigned long DestRow, unsigned long NumRows )
{
  if ( SrcTrackStr && DestTrackStr )
  {
    struct TuComposerTrackData *SrcTrackData;
    struct TuComposerTrackData *DestTrackData;
    struct MinList TmpTrackData;
    struct MinList SwapTrackData;
    ULONG SrcLen, DestLen, i, TmpBuf, Direction;

    if ( (SrcTrackData = SrcTrackStr->tct_Data) && (DestTrackData = DestTrackStr->tct_Data ))
    {
      SrcLen = (SrcTrackStr->tct_Length) + 1;
      DestLen = (DestTrackStr->tct_Length) + 1;

      if ( SrcRow >= SrcLen )
        SrcRow = SrcLen - 1;

      if ( DestRow >= DestLen )
        DestRow = DestLen - 1;

      if ( (SrcRow + NumRows) > SrcLen )
        NumRows = SrcLen - SrcRow;

      if ( (DestRow + NumRows) > DestLen )
        NumRows = DestLen - DestRow;

      if ( (SrcRow == 0L) && (DestRow == 0L) && (SrcLen == NumRows) && (DestLen == NumRows) )
      {
        SrcTrackStr->tct_Data = DestTrackData;
        DestTrackStr->tct_Data = SrcTrackData;
      } else
      {
        SrcTrackData += SrcRow;
        DestTrackData += DestRow;

        Direction = 1;

        if ( SrcTrackStr == DestTrackStr )
        {
          if ( SrcLen == DestLen )
            return ( 0L );

          if ( SrcLen < DestLen )
          {
            SrcTrackData += (NumRows - 1);
            DestTrackData += (NumRows - 1);

            Direction = -1;
          }
        }

        for (i = NumRows; i > 0; i--)
        {
          TmpBuf = DestTrackData->tctd_Octave;
          DestTrackData->tctd_Octave = SrcTrackData->tctd_Octave;
          SrcTrackData->tctd_Octave = TmpBuf;

          TmpBuf = DestTrackData->tctd_Note;
          DestTrackData->tctd_Note = SrcTrackData->tctd_Note;
          SrcTrackData->tctd_Note = TmpBuf;

          TmpBuf = DestTrackData->tctd_Instrument;
          DestTrackData->tctd_Instrument = SrcTrackData->tctd_Instrument;
          SrcTrackData->tctd_Instrument = TmpBuf;

          TmpTrackData = DestTrackData->tctd_Effects;
          ReMapNodeList ( (struct List *) &(SrcTrackData->tctd_Effects), (struct List *) &(DestTrackData->tctd_Effects));

          SwapTrackData = DestTrackData->tctd_Effects;
          DestTrackData->tctd_Effects = TmpTrackData;
          ReMapNodeList ( (struct List *) &(DestTrackData->tctd_Effects), (struct List *) &(SrcTrackData->tctd_Effects));

          DestTrackData->tctd_Effects = SwapTrackData;

          SrcTrackData += Direction;
          DestTrackData += Direction;
        }
      }

      return ( 0L );
    }

    return ( ERROR_TRACK_NODATA );
  }

  return ( ERROR_TRACK_NOGIVEN );
}
