/* TuComposer OS independent code
**
** $VER: SwapTrack.c 31.22 (26.6.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/exec_protos.h>
#include <clib/tucomposer_protos.h>

extern struct TuComposerBase *TuCBase;

ULONG SwapTrack ( struct TuComposerTrack *TrackStr,
     struct TuComposerTrack *TrackBuf )
{
  if ( TrackStr && TrackBuf )
  {
    if ( TrackStr != TrackBuf )
    {
      struct MinList TmpUnkChunk;
      struct MinList SwapUnkChunk;
      UBYTE *SrcBuf,*DestBuf;
      UBYTE TmpByte;
      ULONG i;

      ObtainSemaphore ( TuCBase->tcb_TrackSigSem );

      SrcBuf = (UBYTE *) &(TrackStr->tct_FileName);
      DestBuf = (UBYTE *) &(TrackBuf->tct_FileName);

      for (i = (offsetof (struct TuComposerTrack, tct_UnknownChunks) - offsetof (struct TuComposerTrack, tct_Volume)); i > 0; i--)
      {
        TmpByte = *DestBuf;
        *DestBuf++ = *SrcBuf;
        *SrcBuf++ = TmpByte;
      }

      TmpUnkChunk = TrackBuf->tct_UnknownChunks;
      ReMapNodeList ( (struct List *) &(TrackStr->tct_UnknownChunks), (struct List *) &(TrackBuf->tct_UnknownChunks));

      SwapUnkChunk = TrackBuf->tct_UnknownChunks;
      TrackBuf->tct_UnknownChunks = TmpUnkChunk;
      ReMapNodeList ( (struct List *) &(TrackBuf->tct_UnknownChunks), (struct List *) &(TrackStr->tct_UnknownChunks));

      TrackBuf->tct_UnknownChunks = SwapUnkChunk;

      ReleaseSemaphore ( TuCBase->tcb_TrackSigSem );
    }

    return ( 0L );
  }

  return ( ERROR_TRACK_NOGIVEN );
}
