/* TuComposer OS independent code
**
** $VER: SwapTrackInSong.c 31.22 (12.2.00)
**
** (C) 2000 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <stddef.h>
#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG SwapTrackInSong ( struct TuComposerTrack *TrackBuf,
     struct TuComposerTrack *TrackStr, unsigned long Flags )
{
  if ( TrackStr && TrackBuf )
  {
    if ( TrackStr != TrackBuf )
    {
      if ( Flags & STISF_Swap )
      {
        struct MinList TmpUnkChunk;
        struct MinList SwapUnkChunk;
        UBYTE *SrcBuf,*DestBuf;
        UBYTE TmpByte;
        ULONG i;

        SrcBuf = (UBYTE *) &(TrackStr->tct_FileName);
        DestBuf = (UBYTE *) &(TrackBuf->tct_FileName);

        for (i = (offsetof (struct TuComposerTrack, tct_UnknownChunks) - offsetof (struct TuComposerTrack, tct_Volume)); i > 0; i--)
        {
          TmpByte = *DestBuf;
          *DestBuf++ = *SrcBuf;
          *SrcBuf++ = TmpByte;
        }

        TmpUnkChunk = TrackBuf->tct_UnknownChunks;
        ReMapNodeList ( (struct List *) &(TrackStr->tct_UnknownChunks), (struct List *) &(TrackBuf->tct_UnknownChunks));

        SwapUnkChunk = TrackBuf->tct_UnknownChunks;
        TrackBuf->tct_UnknownChunks = TmpUnkChunk;
        ReMapNodeList ( (struct List *) &(TrackBuf->tct_UnknownChunks), (struct List *) &(TrackStr->tct_UnknownChunks));

        TrackBuf->tct_UnknownChunks = SwapUnkChunk;
      }

      if ( Flags & STISF_Update )
      {
        struct TuComposerSong *SongStr = (struct TuComposerSong *) &(TrackStr->tct_Node.mln_Succ);
        struct TuComposerOrders *PosStr;
        ULONG i;

        for (;;)
        {
          SongStr = (struct TuComposerSong *) SongStr->tcso_Node.mln_Pred;

          if (!( SongStr->tcso_Node.mln_Pred ))
            break;
        }

        (UBYTE *) SongStr += -offsetof (struct TuComposerSong, tcso_TrackList );

        PosStr = SongStr->tcso_Position;

        for (i = SongStr->tcso_Channels; i > 0; i--)
        {
          struct TuComposerOrderList *PosListStr = (struct TuComposerOrderList *) &(PosStr->tco_OrderData.mlh_Head);

          for (;;)
          {
            PosListStr = (struct TuComposerOrderList *) PosListStr->tcol_Node.mln_Succ;

            if (!( PosListStr->tcol_Node.mln_Succ ))
              break;

            if ( PosListStr->tcol_Track == TrackStr )
            {
              PosListStr->tcol_Track = TrackBuf;
            } else if ( PosListStr->tcol_Track == TrackBuf )
            {
              PosListStr->tcol_Track = TrackStr;
            }
          }

          PosStr++;
        }
      }
    }

    return ( 0L );
  }

  return ( ERROR_TRACK_NOGIVEN );
}
