/* TuComposer OS independent code
**
** $VER: TrackNoteShift.c 31.22 (4.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#include <exec/types.h>
#include <tucomposer/tucomposer.h>
#include <clib/tucomposer_protos.h>

ULONG TrackNoteShift ( struct TuComposerTrack *TrackStr,
    long HalfNotes, unsigned long StartRow, unsigned long EndRow )
{
  if ( TrackStr )
  {
    struct TuComposerTrackData *TrackData;

    if ( (TrackData = (TrackStr->tct_Data)))
    {
      ULONG TrackLen, i;
      LONG IndexNote;

      TrackLen = TrackStr->tct_Length;

      if ( StartRow > TrackLen )
        StartRow = TrackLen;

      if ( EndRow > TrackLen )
        EndRow = TrackLen;

      if ( StartRow > EndRow )
      {
        i = StartRow;
        StartRow = EndRow;
        EndRow = i;
      }

      TrackData += StartRow;

      for (i = (EndRow - StartRow) + 1; i > 0; i--)
      {
        IndexNote = (((TrackData->tctd_Octave) * NUMNOTES) + (TrackData->tctd_Note) - 1);

        if ( IndexNote < SPEC_NOTES )
        {
          if ( IndexNote < 0 )
          {
            IndexNote = 0;
          } else if ( IndexNote > 119 )
          {
            IndexNote = 119;
          }

          TrackData->tctd_Octave = IndexNote / 12;
          TrackData->tctd_Note = (IndexNote % 12) + 1;
        }

        TrackData++;
      }

      return ( 0L );
    }

    return ( ERROR_TRACK_NODATA );
  }

  return ( ERROR_TRACK_NOGIVEN );
}
