#ifndef  CLIB_EXT_CRUNCHER_PROTOS_H
#define  CLIB_EXT_CRUNCHER_PROTOS_H

/*
**	$VER: ext_cruncher_protos.h 31.00 (1.8.99)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 1999 Basty/Seasons.
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif /* EXEC_TYPES_H */

#ifndef LIBRARIES_DOS_H
#include "libraries/dos.h"
#endif /* LIBRARIES_DOS_H */

#ifndef  TUCOMPOSER_TUCOMPOSER_H
#include "tucomposer/tucomposer.h"
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef  TUCOMPOSER_EXTERNAL_EXTERNAL_H
#include "tucomposer/external/external.h"
#endif /* TUCOMPOSER_EXTERNAL_EXTERNAL_H */

#ifndef  TUCOMPOSER_EXTERNAL_CRUNCHER_H
#include "tucomposer/external/cruncher.h"
#endif /* TUCOMPOSER_EXTERNAL_CRUNCHER_H */

#ifdef __cplusplus
extern "C" {
#endif

/* External library functions (in each external library) */

ULONG ExternalCruncherInitialize ( struct TuComposerExtList *ExtLibStr );
ULONG ExternalCruncherUpdateFlags ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum );
void ExternalCruncherReserved0 ( void );
void ExternalCruncherReserved1 ( void );

/* Specific external cruncher support functions */

ULONG ExternalCruncherIdentify ( BPTR FHandle );
ULONG ExternalCruncherOpen ( struct CFHandle *CFHandle );
void ExternalCruncherClose ( struct CFHandle *CFHandle );
ULONG ExternalCruncherRead ( struct CFHandle *CFHandle, APTR Buffer,
    unsigned long Length );
ULONG ExternalCruncherWrite ( struct CFHandle *CFHandle, APTR Buffer,
    unsigned long Length );
ULONG ExternalCruncherSeek ( struct CFHandle *CFHandle,
    unsigned long Position, long Offset );
ULONG ExternalCruncherGetInfo ( struct CFHandle *CFHandle,
    struct CruncherInfo *CInfoStr );

#ifdef __cplusplus
}
#endif

#endif /* CLIB_EXT_CRUNCHER_PROTOS_H */
