#ifndef  CLIB_EXT_CRUNCHER_PROTOS_H
#define  CLIB_EXT_CRUNCHER_PROTOS_H

/*
**	$VER: ext_cruncherbase_protos.h 31.00 (6.11.01)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 2001 Basty/CDGS.
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif /* EXEC_TYPES_H */

#ifndef LIBRARIES_DOS_H
#include "libraries/dos.h"
#endif /* LIBRARIES_DOS_H */

#ifndef  TUCOMPOSER_TUCOMPOSER_H
#include "tucomposer/tucomposer.h"
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef  TUCOMPOSER_EXTERNAL_EXTERNAL_H
#include "tucomposer/external/external.h"
#endif /* TUCOMPOSER_EXTERNAL_EXTERNAL_H */

#ifndef  TUCOMPOSER_EXTERNAL_CRUNCHER_H
#include "tucomposer/external/cruncher.h"
#endif /* TUCOMPOSER_EXTERNAL_CRUNCHER_H */

#ifdef __cplusplus
extern "C" {
#endif

/* External library functions (in each external library) */

ULONG ExternalCruncherInitializeBase ( struct TuComposerExtList *ExtLibStr, struct CruncherLibrary *CruncherLibBase );
ULONG ExternalCruncherUpdateFlagsBase ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum, struct CruncherLibrary *CruncherLibBase );

/* Specific external cruncher support functions */

ULONG ExternalCruncherIdentifyBase ( BPTR FHandle, struct CruncherLibrary *CruncherLibBase );
ULONG ExternalCruncherOpenBase ( struct CFHandle *CFHandle, struct CruncherLibrary *CruncherLibBase );
void ExternalCruncherCloseBase ( struct CFHandle *CFHandle, struct CruncherLibrary *CruncherLibBase );
ULONG ExternalCruncherReadBase ( struct CFHandle *CFHandle, APTR Buffer,
    unsigned long Length, struct CruncherLibrary *CruncherLibBase );
ULONG ExternalCruncherWriteBase ( struct CFHandle *CFHandle, APTR Buffer,
    unsigned long Length, struct CruncherLibrary *CruncherLibBase );
ULONG ExternalCruncherSeekBase ( struct CFHandle *CFHandle,
    unsigned long Position, long Offset, struct CruncherLibrary *CruncherLibBase );
ULONG ExternalCruncherGetInfoBase ( struct CFHandle *CFHandle,
    struct CruncherInfo *CInfoStr, struct CruncherLibrary *CruncherLibBase );

#ifdef __cplusplus
}
#endif

#endif /* CLIB_EXT_CRUNCHER_PROTOS_H */
