#ifndef  CLIB_EXT_DEVICE_PROTOS_H
#define  CLIB_EXT_DEVICE_PROTOS_H

/*
**	$VER: ext_devicebase_protos.h 31.00 (6.11.01)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 2001 Basty/CDGS.
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif /* EXEC_TYPES_H */

#ifndef  TUCOMPOSER_TUCOMPOSER_H
#include "tucomposer/tucomposer.h"
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef  TUCOMPOSER_EXTERNAL_EXTERNAL_H
#include "tucomposer/external/external.h"
#endif /* TUCOMPOSER_EXTERNAL_EXTERNAL_H */

#ifndef  TUCOMPOSER_EXTERNAL_DEVICE_H
#include "tucomposer/external/device.h"
#endif /* TUCOMPOSER_EXTERNAL_DEVICE_H */

#ifndef  TUCOMPOSER_EXTERNAL_MIXER_H
#include "tucomposer/external/mixer.h"
#endif /* TUCOMPOSER_EXTERNAL_MIXER_H */

#ifdef __cplusplus
extern "C" {
#endif

/* External library functions (in each external library) */

ULONG ExternalDeviceInitializeBase ( struct TuComposerExtList *ExtLibStr, struct SoundDeviceInfo *SoundDeviceBase );
ULONG ExternalDeviceUpdateFlagsBase ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum, struct SoundDeviceInfo *SoundDeviceBase );

/* Specific external sound device support functions */

ULONG ExternalDeviceAllocBase ( union FlagPass *FlagPassStr, struct SoundDeviceInfo *SoundDeviceBase );
ULONG ExternalDeviceFreeBase ( struct SoundDeviceInfo *SoundDeviceBase );
ULONG ExternalDevicePlayBase ( struct MixerAllocStruct *MixAllocStr,
    union FlagPass *FlagPassStr, struct SoundDeviceInfo *SoundDeviceBase );
ULONG ExternalDeviceStopBase ( struct SoundDeviceInfo *SoundDeviceBase );
ULONG ExternalDeviceCheckRateBase ( unsigned long SmpRate, struct SoundDeviceInfo *SoundDeviceBase );
ULONG ExternalDeviceCheckRateFractionBase ( unsigned long SmpRate, struct SoundDeviceInfo *SoundDeviceBase );
ULONG ExternalDeviceUpdateRateBase ( unsigned long SmpRate, struct SoundDeviceInfo *SoundDeviceBase );

#ifdef __cplusplus
}
#endif

#endif /* CLIB_EXT_DEVICE_PROTOS_H */
