#ifndef  CLIB_EXT_INSTR_PROTOS_H
#define  CLIB_EXT_INSTR_PROTOS_H

/*
**	$VER: ext_instr_protos.h 31.00 (6.11.01)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 2001 Basty/CDGS.
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif /* EXEC_TYPES_H */

#ifndef  TUCOMPOSER_TUCOMPOSER_H
#include "tucomposer/tucomposer.h"
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef  TUCOMPOSER_EXTERNAL_EXTERNAL_H
#include "tucomposer/external/external.h"
#endif /* TUCOMPOSER_EXTERNAL_EXTERNAL_H */

#ifndef  TUCOMPOSER_EXTERNAL_CRUNCHER_H
#include "tucomposer/external/cruncher.h"
#endif /* TUCOMPOSER_EXTERNAL_CRUNCHER_H */

#ifndef  TUCOMPOSER_EXTERNAL_INSTR_H
#include "tucomposer/external/instr.h"
#endif /* TUCOMPOSER_EXTERNAL_INSTR_H */

#ifndef  TUCOMPOSER_INSTR_H
#include "tucomposer/instr.h"
#endif /* TUCOMPOSER_INSTR_H */

#ifdef __cplusplus
extern "C" {
#endif

/* External library functions (in each external library) */

ULONG ExternalInstrInitializeBase ( struct TuComposerExtList *ExtLibStr, struct InstrLibrary *InstrBase );
ULONG ExternalInstrUpdateFlagsBase ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum, struct InstrLibrary *InstrBase );

/* Specific external instrument loading/saving functions */

ULONG ExternalInstrIdentifyBase ( struct CFHandle *CFHandle, struct InstrLibrary *InstrBase );
struct TuComposerInstr *ExternalInstrLoadBase ( struct CFHandle *CFHandle,
    struct TuComposerInstr *InstrStr, union FlagPass *FlagPassStr,
    unsigned long NumInstr, struct InstrLibrary *InstrBase );
ULONG ExternalInstrSaveBase ( struct CFHandle *CFHandle,
    struct TuComposerInstr *InstrStr, union FlagPass *FlagPassStr, struct InstrLibrary *InstrBase );
ULONG ExternalInstrGetInfoBase ( struct CFHandle *CFHandle,
    struct InstrInfo *InstrInfo, unsigned long NumInstr, struct InstrLibrary *InstrBase );
ULONG ExternalInstrGetNumsBase ( struct CFHandle *CFHandle, struct InstrLibrary *InstrBase );

#ifdef __cplusplus
}
#endif

#endif /* CLIB_EXT_INSTR_PROTOS_H */
