#ifndef  CLIB_EXT_MIXER_PROTOS_H
#define  CLIB_EXT_MIXER_PROTOS_H

/*
**	$VER: ext_mixer_protos.h 31.00 (1.8.99)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 1999 Basty/Seasons.
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif /* EXEC_TYPES_H */

#ifndef  TUCOMPOSER_TUCOMPOSER_H
#include "tucomposer/tucomposer.h"
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef  TUCOMPOSER_EXTERNAL_EXTERNAL_H
#include "tucomposer/external/external.h"
#endif /* TUCOMPOSER_EXTERNAL_EXTERNAL_H */

#ifndef  TUCOMPOSER_EXTERNAL_MIXER_H
#include "tucomposer/external/mixer.h"
#endif /* TUCOMPOSER_EXTERNAL_MIXER_H */

#ifndef  TUCOMPOSER_EXTERNAL_DEVICE_H
#include "tucomposer/external/device.h"
#endif /* TUCOMPOSER_EXTERNAL_DEVICE_H */

#ifdef __cplusplus
extern "C" {
#endif

/* External library functions (in each external library) */

ULONG ExternalMixerInitialize ( struct TuComposerExtList *ExtLibStr );
ULONG ExternalMixerUpdateFlags ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum );
void ExternalMixerReserved0 ( void );
void ExternalMixerReserved1 ( void );

/* Specific external mixer support functions */

struct MixerAllocStruct *ExternalMixerAlloc ( void );
ULONG ExternalMixerFree ( struct MixerAllocStruct *MixAllocStr );
ULONG ExternalMixerInit ( struct MixerAllocStruct *MixAllocStr,
    struct SoundDeviceInfo *ExtSoundDevStr, union FlagPass *FlagPassStr );
ULONG ExternalMixerChangeRate ( struct MixerAllocStruct *MixAllocStr,
    unsigned long NewMixRate );
ULONG ExternalMixerChangeTempo ( struct MixerAllocStruct *MixAllocStr,
    unsigned long NewTempo );
ULONG ExternalMixerChangeVolTable ( struct MixerAllocStruct *MixAllocStr,
    unsigned long Amplify, unsigned long LeftVol, unsigned long RightVol,
    unsigned long NumChannels );
void ExternalMixerGetChannel ( struct MixerAllocStruct *MixAllocStr,
    struct MixerStruct *MixStr, unsigned long Channel );
void ExternalMixerSetChannel ( struct MixerAllocStruct *MixAllocStr,
    struct MixerStruct *MixStr, unsigned long Channel );
void ExternalMixerSetChannelVolPanPitch ( struct MixerAllocStruct
    *MixAllocStr, struct MixerStruct *MixStr, unsigned long Channel );
void ExternalMixerSetChannelPosRepFlags ( struct MixerAllocStruct
    *MixAllocStr, struct MixerStruct *MixStr, unsigned long Channel );
void ExternalMixerDoMix ( struct MixerAllocStruct *MixAllocStr,
    long *MixBuffer );

#ifdef __cplusplus
}
#endif

#endif /* CLIB_EXT_MIXER_PROTOS_H */
