#ifndef  CLIB_EXT_MIXER_PROTOS_H
#define  CLIB_EXT_MIXER_PROTOS_H

/*
**	$VER: ext_mixerbase_protos.h 31.00 (6.11.01)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 2001 Basty/CDGS.
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif /* EXEC_TYPES_H */

#ifndef  TUCOMPOSER_TUCOMPOSER_H
#include "tucomposer/tucomposer.h"
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef  TUCOMPOSER_EXTERNAL_EXTERNAL_H
#include "tucomposer/external/external.h"
#endif /* TUCOMPOSER_EXTERNAL_EXTERNAL_H */

#ifndef  TUCOMPOSER_EXTERNAL_MIXER_H
#include "tucomposer/external/mixer.h"
#endif /* TUCOMPOSER_EXTERNAL_MIXER_H */

#ifndef  TUCOMPOSER_EXTERNAL_DEVICE_H
#include "tucomposer/external/device.h"
#endif /* TUCOMPOSER_EXTERNAL_DEVICE_H */

#ifdef __cplusplus
extern "C" {
#endif

/* External library functions (in each external library) */

ULONG ExternalMixerInitializeBase ( struct TuComposerExtList *ExtLibStr, struct MixerInfo *MixerBase );
ULONG ExternalMixerUpdateFlagsBase ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum, struct MixerInfo *MixerBase );

/* Specific external mixer support functions */

struct MixerAllocStruct *ExternalMixerAllocBase ( struct MixerInfo *MixerBase );
ULONG ExternalMixerFreeBase ( struct MixerAllocStruct *MixAllocStr, struct MixerInfo *MixerBase );
ULONG ExternalMixerInitBase ( struct MixerAllocStruct *MixAllocStr,
    struct SoundDeviceInfo *ExtSoundDevStr, union FlagPass *FlagPassStr, struct MixerInfo *MixerBase );
ULONG ExternalMixerChangeRateBase ( struct MixerAllocStruct *MixAllocStr,
    unsigned long NewMixRate, struct MixerInfo *MixerBase );
ULONG ExternalMixerChangeTempoBase ( struct MixerAllocStruct *MixAllocStr,
    unsigned long NewTempo, struct MixerInfo *MixerBase );
ULONG ExternalMixerChangeVolTableBase ( struct MixerAllocStruct *MixAllocStr,
    unsigned long Amplify, unsigned long LeftVol, unsigned long RightVol,
    unsigned long NumChannels, struct MixerInfo *MixerBase );
void ExternalMixerGetChannelBase ( struct MixerAllocStruct *MixAllocStr,
    struct MixerStruct *MixStr, unsigned long Channel, struct MixerInfo *MixerBase );
void ExternalMixerSetChannelBase ( struct MixerAllocStruct *MixAllocStr,
    struct MixerStruct *MixStr, unsigned long Channel, struct MixerInfo *MixerBase );
void ExternalMixerSetChannelVolPanPitchBase ( struct MixerAllocStruct
    *MixAllocStr, struct MixerStruct *MixStr, unsigned long Channel, struct MixerInfo *MixerBase );
void ExternalMixerSetChannelPosRepFlagsBase ( struct MixerAllocStruct
    *MixAllocStr, struct MixerStruct *MixStr, unsigned long Channel, struct MixerInfo *MixerBase );
void ExternalMixerDoMixBase ( struct MixerAllocStruct *MixAllocStr,
    long *MixBuffer, struct MixerInfo *MixerBase );

#ifdef __cplusplus
}
#endif

#endif /* CLIB_EXT_MIXER_PROTOS_H */
