#ifndef  CLIB_EXT_POSTPROC_PROTOS_H
#define  CLIB_EXT_POSTPROC_PROTOS_H

/*
**	$VER: ext_postproc_protos.h 31.00 (1.3.00)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 2000 Basty/Seasons.
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif /* EXEC_TYPES_H */

#ifndef  TUCOMPOSER_TUCOMPOSER_H
#include "tucomposer/tucomposer.h"
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef  TUCOMPOSER_EXTERNAL_EXTERNAL_H
#include "tucomposer/external/external.h"
#endif /* TUCOMPOSER_EXTERNAL_EXTERNAL_H */

#ifndef  TUCOMPOSER_EXTERNAL_POSTPROC_H
#include "tucomposer/external/postproc.h"
#endif /* TUCOMPOSER_EXTERNAL_POSTPROC_H */

#ifndef  TUCOMPOSER_EXTERNAL_MIXER_H
#include "tucomposer/external/mixer.h"
#endif /* TUCOMPOSER_EXTERNAL_MIXER_H */

#ifdef __cplusplus
extern "C" {
#endif

/* External library functions (in each external library) */

ULONG ExternalPostProcInitialize ( struct TuComposerExtList *ExtLibStr );
ULONG ExternalPostProcUpdateFlags ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum );
void ExternalPostProcReserved0 ( void );
void ExternalPostProcReserved1 ( void );

/* Specific external post processor support functions */

struct PostProcAllocStruct *ExternalPostProcAlloc ( struct MixerAllocStruct *MixAllocStr );
ULONG ExternalPostProcFree ( struct PostProcAllocStruct *PostAllocStr );
ULONG ExternalPostProcInit ( struct PostProcAllocStruct *PostAllocStr,
    struct MixerAllocStruct *MixAllocStr, union FlagPass *FlagPassStr );
ULONG ExternalPostProcChange ( struct PostProcAllocStruct *PostAllocStr,
    struct MixerAllocStruct *MixAllocStr );
void ExternalPostProcDoMix ( struct PostProcAllocStruct *PostAllocStr,
    long *MixBuffer );

#ifdef __cplusplus
}
#endif

#endif /* CLIB_EXT_POSTPROC_PROTOS_H */
