#ifndef  CLIB_EXT_RECORDER_PROTOS_H
#define  CLIB_EXT_RECORDER_PROTOS_H

/*
**	$VER: ext_recorder_protos.h 31.00 (1.8.99)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 1999 Basty/Seasons.
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif /* EXEC_TYPES_H */

#ifndef  TUCOMPOSER_TUCOMPOSER_H
#include "tucomposer/tucomposer.h"
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef  TUCOMPOSER_EXTERNAL_EXTERNAL_H
#include "tucomposer/external/external.h"
#endif /* TUCOMPOSER_EXTERNAL_EXTERNAL_H */

#ifndef  TUCOMPOSER_EXTERNAL_CRUNCHER_H
#include "tucomposer/external/cruncher.h"
#endif /* TUCOMPOSER_EXTERNAL_CRUNCHER_H */

#ifndef  TUCOMPOSER_EXTERNAL_RECORDER_H
#include "tucomposer/external/recorder.h"
#endif /* TUCOMPOSER_EXTERNAL_RECORDER_H */

#ifndef  TUCOMPOSER_INSTR_H
#include "tucomposer/instr.h"
#endif /* TUCOMPOSER_INSTR_H */

#ifdef __cplusplus
extern "C" {
#endif

/* External library functions (in each external library) */

ULONG ExternalRecorderInitialize ( struct TuComposerExtList *ExtLibStr );
ULONG ExternalRecorderUpdateFlags ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum );
void ExternalRecorderReserved0 ( void );
void ExternalRecorderReserved1 ( void );

/* Specific external recorder loading/saving functions */

ULONG ExternalRecorderIdentify ( struct CFHandle *CFHandle );
struct TuComposerRecorder *ExternalRecorderLoad ( struct CFHandle *CFHandle,
    struct TuComposerRecorder *RecorderStr, union FlagPass *FlagPassStr,
    unsigned long NumRecorder );
ULONG ExternalRecorderSave ( struct CFHandle *CFHandle,
    struct TuComposerRecorder *RecorderStr, union FlagPass *FlagPassStr );
ULONG ExternalRecorderGetInfo ( struct CFHandle *CFHandle,
    struct RecorderInfo *RecorderInfo, unsigned long NumRecorder );
ULONG ExternalRecorderGetNums ( struct CFHandle *CFHandle );

#ifdef __cplusplus
}
#endif

#endif /* CLIB_EXT_RECORDER_PROTOS_H */
