#ifndef  CLIB_EXT_RECORDER_PROTOS_H
#define  CLIB_EXT_RECORDER_PROTOS_H

/*
**	$VER: ext_recorderbase_protos.h 31.00 (6.11.01)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 2001 Basty/CDGS.
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif /* EXEC_TYPES_H */

#ifndef  TUCOMPOSER_TUCOMPOSER_H
#include "tucomposer/tucomposer.h"
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef  TUCOMPOSER_EXTERNAL_EXTERNAL_H
#include "tucomposer/external/external.h"
#endif /* TUCOMPOSER_EXTERNAL_EXTERNAL_H */

#ifndef  TUCOMPOSER_EXTERNAL_CRUNCHER_H
#include "tucomposer/external/cruncher.h"
#endif /* TUCOMPOSER_EXTERNAL_CRUNCHER_H */

#ifndef  TUCOMPOSER_EXTERNAL_RECORDER_H
#include "tucomposer/external/recorder.h"
#endif /* TUCOMPOSER_EXTERNAL_RECORDER_H */

#ifndef  TUCOMPOSER_INSTR_H
#include "tucomposer/instr.h"
#endif /* TUCOMPOSER_INSTR_H */

#ifdef __cplusplus
extern "C" {
#endif

/* External library functions (in each external library) */

ULONG ExternalRecorderInitializeBase ( struct TuComposerExtList *ExtLibStr, struct RecorderLibrary *RecorderBase );
ULONG ExternalRecorderUpdateFlagsBase ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum, struct RecorderLibrary *RecorderBase );

/* Specific external recorder loading/saving functions */

ULONG ExternalRecorderIdentifyBase ( struct CFHandle *CFHandle, struct RecorderLibrary *RecorderBase );
struct TuComposerRecorder *ExternalRecorderLoadBase ( struct CFHandle *CFHandle,
    struct TuComposerRecorder *RecorderStr, union FlagPass *FlagPassStr,
    unsigned long NumRecorder, struct RecorderLibrary *RecorderBase );
ULONG ExternalRecorderSaveBase ( struct CFHandle *CFHandle,
    struct TuComposerRecorder *RecorderStr, union FlagPass *FlagPassStr, struct RecorderLibrary *RecorderBase );
ULONG ExternalRecorderGetInfoBase ( struct CFHandle *CFHandle,
    struct RecorderInfo *RecorderInfo, unsigned long NumRecorder, struct RecorderLibrary *RecorderBase );
ULONG ExternalRecorderGetNumsBase ( struct CFHandle *CFHandle, struct RecorderLibrary *RecorderBase );

#ifdef __cplusplus
}
#endif

#endif /* CLIB_EXT_RECORDER_PROTOS_H */
