#ifndef  CLIB_EXT_SYNTH_PROTOS_H
#define  CLIB_EXT_SYNTH_PROTOS_H

/*
**	$VER: ext_synth_protos.h 31.00 (1.8.99)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 1999 Basty/Seasons.
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif /* EXEC_TYPES_H */

#ifndef  TUCOMPOSER_TUCOMPOSER_H
#include "tucomposer/tucomposer.h"
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef  TUCOMPOSER_EXTERNAL_EXTERNAL_H
#include "tucomposer/external/external.h"
#endif /* TUCOMPOSER_EXTERNAL_EXTERNAL_H */

#ifndef  TUCOMPOSER_EXTERNAL_CRUNCHER_H
#include "tucomposer/external/cruncher.h"
#endif /* TUCOMPOSER_EXTERNAL_CRUNCHER_H */

#ifndef  TUCOMPOSER_EXTERNAL_SYNTH_H
#include "tucomposer/external/synth.h"
#endif /* TUCOMPOSER_EXTERNAL_SYNTH_H */

#ifndef  TUCOMPOSER_INSTR_H
#include "tucomposer/instr.h"
#endif /* TUCOMPOSER_INSTR_H */

#ifdef __cplusplus
extern "C" {
#endif

/* External library functions (in each external library) */

ULONG ExternalSynthInitialize ( struct TuComposerExtList *ExtLibStr );
ULONG ExternalSynthUpdateFlags ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum );
void ExternalSynthReserved0 ( void );
void ExternalSynthReserved1 ( void );

/* Specific external synth loading/saving functions */

ULONG ExternalSynthIdentify ( struct CFHandle *CFHandle );
struct TuComposerSynth *ExternalSynthLoad ( struct CFHandle *CFHandle,
    struct TuComposerSynth *SynthStr, union FlagPass *FlagPassStr,
    unsigned long NumSynth );
ULONG ExternalSynthSave ( struct CFHandle *CFHandle,
    struct TuComposerSynth *SynthStr, union FlagPass *FlagPassStr );
ULONG ExternalSynthGetInfo ( struct CFHandle *CFHandle,
    struct SynthInfo *SynthInfo, unsigned long NumSynth );
ULONG ExternalSynthGetNums ( struct CFHandle *CFHandle );

#ifdef __cplusplus
}
#endif

#endif /* CLIB_EXT_SYNTH_PROTOS_H */
