#ifndef  CLIB_EXT_SYNTH_PROTOS_H
#define  CLIB_EXT_SYNTH_PROTOS_H

/*
**	$VER: ext_synthbase_protos.h 31.00 (6.11.01)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 2001 Basty/CDGS.
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif /* EXEC_TYPES_H */

#ifndef  TUCOMPOSER_TUCOMPOSER_H
#include "tucomposer/tucomposer.h"
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef  TUCOMPOSER_EXTERNAL_EXTERNAL_H
#include "tucomposer/external/external.h"
#endif /* TUCOMPOSER_EXTERNAL_EXTERNAL_H */

#ifndef  TUCOMPOSER_EXTERNAL_CRUNCHER_H
#include "tucomposer/external/cruncher.h"
#endif /* TUCOMPOSER_EXTERNAL_CRUNCHER_H */

#ifndef  TUCOMPOSER_EXTERNAL_SYNTH_H
#include "tucomposer/external/synth.h"
#endif /* TUCOMPOSER_EXTERNAL_SYNTH_H */

#ifndef  TUCOMPOSER_INSTR_H
#include "tucomposer/instr.h"
#endif /* TUCOMPOSER_INSTR_H */

#ifdef __cplusplus
extern "C" {
#endif

/* External library functions (in each external library) */

ULONG ExternalSynthInitializeBase ( struct TuComposerExtList *ExtLibStr, struct SynthLibrary *SynthBase );
ULONG ExternalSynthUpdateFlagsBase ( union FlagPass *FlagPassStr,
    unsigned long FlagPassType, unsigned long FlagNum, struct SynthLibrary *SynthBase );

/* Specific external synth loading/saving functions */

ULONG ExternalSynthIdentifyBase ( struct CFHandle *CFHandle, struct SynthLibrary *SynthBase );
struct TuComposerSynth *ExternalSynthLoadBase ( struct CFHandle *CFHandle,
    struct TuComposerSynth *SynthStr, union FlagPass *FlagPassStr,
    unsigned long NumSynth, struct SynthLibrary *SynthBase );
ULONG ExternalSynthSaveBase ( struct CFHandle *CFHandle,
    struct TuComposerSynth *SynthStr, union FlagPass *FlagPassStr, struct SynthLibrary *SynthBase );
ULONG ExternalSynthGetInfoBase ( struct CFHandle *CFHandle,
    struct SynthInfo *SynthInfo, unsigned long NumSynth, struct SynthLibrary *SynthBase );
ULONG ExternalSynthGetNumsBase ( struct CFHandle *CFHandle, struct SynthLibrary *SynthBase );

#ifdef __cplusplus
}
#endif

#endif /* CLIB_EXT_SYNTH_PROTOS_H */
