#ifndef  CLIB_TUCOMPOSER_PROTOS_H
#define  CLIB_TUCOMPOSER_PROTOS_H

/*
**	$VER: tucomposer_protos.h 31.00 (16.3.99)
**
**	C prototypes. For use with 32 bit integers only.
**
**	(C) Copyright 1999 Basty/Seasons.
**	    All Rights Reserved
*/

#ifndef  EXEC_TYPES_H
#include "exec/types.h"
#endif /* EXEC_TYPES_H */

#ifndef EXEC_LISTS_H
#include "exec/lists.h"
#endif /* EXEC_LISTS_H */

#ifndef LIBRARIES_DOS_H
#include "libraries/dos.h"
#endif /* LIBRARIES_DOS_H */

#ifndef  TUCOMPOSER_TUCOMPOSER_H
#include "tucomposer/tucomposer.h"
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef TUCOMPOSER_MODULE_H
#include "tucomposer/module.h"
#endif /* TUCOMPOSER_MODULE_H */

#ifndef TUCOMPOSER_SONG_H
#include "tucomposer/song.h"
#endif /* TUCOMPOSER_SONG_H */

#ifndef TUCOMPOSER_EXTERNAL_H
#include "tucomposer/external.h"
#endif /* TUCOMPOSER_EXTERNAL_H */

#ifdef __cplusplus
extern "C" {
#endif

/* Miscellanous functions (mainly for coder support) */
APTR AllocPMem ( unsigned long byteSize );
void FreePMem ( APTR memoryBlock, unsigned long byteSize );
void InitNodeList ( struct List *NodeList );
void InsertNode ( struct List *NodeList, struct Node *Node,
    struct Node *PredNode );
void AddNodeHead ( struct List *NodeList, struct Node *Node );
void AddNodeTail ( struct List *NodeList, struct Node *Node );
void RemoveNode ( struct Node *Node );
void RemNodeHead ( struct List *NodeList );
void RemNodeTail ( struct List *NodeList );
void EnqueueNode ( struct List *NodeList, struct Node *Node );
ULONG DupNodeList ( struct MinList *SrcNodeList,
    struct MinList *DestNodeList, unsigned long NodeSize );
void ReMapNodeList ( struct List *SrcNodeList, struct List *DestNodeList );
STRPTR AllocNameStr ( STRPTR CStr );
ULONG FreeNameStr ( STRPTR NameStr );
STRPTR SetString ( STRPTR *StructPos, STRPTR CStr );
STRPTR SetNameStr ( STRPTR *StructPos, STRPTR NameStr );
LONG Sin ( long Degrees, long Amplify );
LONG Cos ( long Degrees, long Amplify );
LONG Tan ( long Degrees, long Amplify );
void DoPlayerIRQ ( struct TuComposerBase *TuCBase );
struct PlayExecHandler *AddPlayExecHandler ( struct PlayExecHandler
    *PlayExecStr );
void RemPlayExecHandler ( struct PlayExecHandler *PlayExecStr );
void SetPlayExecHandlerPri ( struct PlayExecHandler *PlayExecStr,
    long Pri );
void Stamp2Date ( struct StampDate *StampDateStr,
    struct DateStamp *DateStampStr);
struct TuComposerBase *AllocSimulateMix ( struct TuComposerSong *SongStr );
void FreeSimulateMix ( struct TuComposerBase *PseudoTuCBase );
struct UnknownChunk *AllocUnknownChunk ( APTR PreFillData,
    unsigned long ChunkName, unsigned long ChunkLen );
void FreeUnknownChunk ( struct UnknownChunk *UnknownChunkStr );
void DeleteUnknownChunk ( struct UnknownChunk *UnknownChunkStr );
ULONG Randomize ( unsigned long Seed );
ULONG Rnd ( unsigned long UpperBound );

/* Sound device related functions */

ULONG AllocSoundDevice ( struct TuComposerExtList *ExtLibStr,
    union FlagPass *FlagPassStr );
ULONG FreeSoundDevice ( struct TuComposerExtList *ExtLibStr );
ULONG PlaySoundDevice ( struct TuComposerExtList *ExtLibStr,
    struct MixerAllocStruct *MixAllocStr, union FlagPass *FlagPassStr );
ULONG StopSoundDevice ( struct TuComposerExtList *ExtLibStr );
ULONG CheckSoundDeviceRate ( struct TuComposerExtList *ExtLibStr,
    unsigned long SmpRate );
ULONG CheckSoundDeviceRateFraction ( struct TuComposerExtList
    *ExtLibStr, unsigned long SmpRate );
void UpdateSoundDeviceRate ( struct TuComposerExtList *ExtLibStr,
    unsigned long SmpRate );

/* Mixing device related functions */

struct MixerAllocStruct *AllocMixer ( struct TuComposerExtList *ExtLibStr );
ULONG FreeMixer ( struct MixerAllocStruct *MixAllocStr );
ULONG InitMixer ( struct MixerAllocStruct *MixAllocStr,
    struct SoundDeviceInfo *ExtSoundDevStr, union FlagPass *FlagPassStr );
ULONG ChangeMixerRate ( struct MixerAllocStruct *MixAllocStr,
    unsigned long NewMixRate );
ULONG ChangeMixerTempo ( struct MixerAllocStruct *MixAllocStr,
    unsigned long NewTempo );
ULONG ChangeMixerVolTable ( struct MixerAllocStruct *MixAllocStr,
    unsigned long Amplify, unsigned long LeftVol, unsigned long RightVol,
    unsigned long NumChannels );
void GetMixChannel ( struct MixerAllocStruct *MixAllocStr,
    struct MixerStruct *MixStr, unsigned long Channel );
void SetMixChannel ( struct MixerAllocStruct *MixAllocStr,
    struct MixerStruct *MixStr, unsigned long Channel );
void SetMixChannelVolPanPitch ( struct MixerAllocStruct *MixAllocStr,
    struct MixerStruct *MixStr, unsigned long Channel );
void SetMixChannelPosRepFlags ( struct MixerAllocStruct *MixAllocStr,
    struct MixerStruct *MixStr, unsigned long Channel );
void DoMix ( struct MixerAllocStruct *MixAllocStr, long *MixBuffer );

/* Post processor device related functions */

struct PostProcAllocStruct *AllocPostProcessor ( struct TuComposerExtList *ExtLibStr,
    struct MixerAllocStruct *MixAllocStr );
ULONG FreePostProcessor ( struct PostProcAllocStruct *PostAllocStr );
ULONG InitPostProcessor ( struct PostProcAllocStruct *PostAllocStr,
    struct MixerAllocStruct *MixAllocStr, union FlagPass *FlagPassStr );
ULONG ChangePostProcessor ( struct PostProcAllocStruct *PostAllocStr,
    struct MixerAllocStruct *MixAllocStr );
void DoPostProcessorMix ( struct PostProcAllocStruct *PostAllocStr,
    long *MixBuffer );
struct PostProcAllocStruct *AddPostProcessor ( struct MixerAllocStruct
    *MixAllocStr, struct PostProcAllocStruct *PostAllocStr );
void RemPostProcessor ( struct PostProcAllocStruct *PostAllocStr );
void SetPostProcessorPri ( struct PostProcAllocStruct *PostAllocStr,
    long Pri );

/* Module related functions */

struct TuComposerModule *AllocTCModule ( unsigned long Channels );
ULONG FreeTCModule ( struct TuComposerModule *ModuleStr );
ULONG AddTCModule ( struct TuComposerModule *ModuleStr );
ULONG RemTCModule ( struct TuComposerModule *ModuleStr );
struct TuComposerModule *DupTCModule ( struct TuComposerModule *ModuleStr );
ULONG ReMapTCModule ( struct TuComposerModule *ModuleStr,
    struct TuComposerModule *NewModuleStr );
struct TuComposerModule *LoadTCModule ( struct CFHandle *CFHandle,
    struct TuComposerModule *ModuleStr,
    struct TuComposerExtList *ExtLibStr, union FlagPass *FlagPassStr,
    unsigned long NumModule );
ULONG SaveTCModule ( struct CFHandle *CFHandle,
    struct TuComposerModule *ModuleStr,
    struct TuComposerExtList *ExtLibStr, union FlagPass *FlagPassStr );
struct TuComposerExtList *IdentifyTCModule ( struct CFHandle *CFHandle );
struct ModuleInfo *GetTCModuleInfo ( struct CFHandle *CFHandle,
    struct TuComposerExtList *ExtLibStr, unsigned long NumModule);
ULONG FreeTCModuleInfo ( struct ModuleInfo *ModuleInfoStr );
ULONG GetTCModules ( struct CFHandle *CFHandle,
    struct TuComposerExtList *ExtLibStr );
struct TuComposerModule *PushTCModule ( struct TuComposerModule *ModuleStr );
ULONG PopTCModule ( struct TuComposerModule *ModuleBuf );
struct TuComposerModule *CutTCModule ( struct TuComposerModule *ModuleStr,
    struct TuComposerModule *ModuleBuf );
struct TuComposerModule *CopyTCModule ( struct TuComposerModule *ModuleStr,
    struct TuComposerModule *ModuleBuf );
struct TuComposerModule *PasteTCModule ( struct TuComposerModule *ModuleBuf,
    struct TuComposerModule *ModuleStr );
ULONG SwapTCModule ( struct TuComposerModule *ModuleBuf,
    struct TuComposerModule *ModuleStr );
ULONG ClearTCModule ( struct TuComposerModule *ModuleStr );
ULONG AddTCModuleUnknownChunk ( struct TuComposerModule *ModuleStr,
    struct UnknownChunk *UnknownChunkStr );
ULONG RemTCModuleUnknownChunk ( struct TuComposerModule *ModuleStr );
ULONG InsertTCModuleUnknownChunk ( struct TuComposerModule
    *ModuleStr, struct UnknownChunk *UnknownChunkStr,
    struct UnknownChunk *UnknownChunkPos );
ULONG AllocPlayTCModule ( void );
void FreePlayTCModule ( void );
ULONG PlayTCModule ( union FlagPass *FlagPassStr );
ULONG StopTCModule ( void );
ULONG SetTCMChannels ( struct TuComposerModule *ModuleStr,
    unsigned long Channels );
ULONG CalcTCMPlayTime ( struct TuComposerModule *ModuleStr,
    struct PlayExecHandler *PlayExecStr );
ULONG GetOptimalVChannels ( struct TuComposerModule *ModuleStr );

/* Song related functions */

struct TuComposerSong *AllocSong ( unsigned long Channels,
    unsigned long GoSubStack, unsigned long LoopStack );
ULONG FreeSong ( struct TuComposerSong *SongStr );
ULONG AddSong ( struct TuComposerModule *ModuleStr,
    struct TuComposerSong *SongStr );
ULONG RemSong ( struct TuComposerModule *ModuleStr );
ULONG InsertSong ( struct TuComposerModule *ModuleStr,
    struct TuComposerSong *SongStr, struct TuComposerSong *SongPos );
ULONG DeleteSong ( struct TuComposerSong *SongStr );
struct TuComposerSong *DupSong ( struct TuComposerSong *SongStr);
ULONG ReMapSong ( struct TuComposerSong *SongStr,
    struct TuComposerSong *NewSongStr );
ULONG GetNumSongs ( struct TuComposerModule *ModuleStr );
ULONG GetSongNum ( struct TuComposerModule *ModuleStr,
    struct TuComposerSong *SongStr );
struct TuComposerSong *GetSongAddr ( struct TuComposerModule *ModuleStr,
    unsigned long Num );
struct TuComposerSong *LoadSong ( struct CFHandle *CFHandle,
    struct TuComposerSong *SongStr, struct TuComposerExtList *ExtLibStr,
    union FlagPass *FlagPassStr, unsigned long NumSong );
ULONG SaveSong ( struct CFHandle *CFHandle, struct TuComposerSong *SongStr,
    struct TuComposerExtList *ExtLibStr, union FlagPass *FlagPassStr );
struct TuComposerExtList *IdentifySong ( struct CFHandle *CFHandle );
struct SongInfo *GetSongInfo ( struct CFHandle *CFHandle,
    struct TuComposerExtList *ExtLibStr, unsigned long NumSong );
ULONG FreeSongInfo ( struct SongInfo *SongInfoStr );
ULONG GetSongs ( struct CFHandle *CFHandle,
    struct TuComposerExtList *ExtLibStr );
struct TuComposerSong *PushSong ( struct TuComposerSong *SongStr );
ULONG PopSong ( struct TuComposerSong *SongBuf );
struct TuComposerSong *CutSong ( struct TuComposerSong *SongStr,
    struct TuComposerSong *SongBuf );
struct TuComposerSong *CopySong ( struct TuComposerSong *SongStr,
    struct TuComposerSong *SongBuf );
struct TuComposerSong *PasteSong ( struct TuComposerSong *SongBuf,
    struct TuComposerSong *SongStr );
ULONG SwapSong ( struct TuComposerSong *SongBuf,
    struct TuComposerSong *SongStr );
ULONG ClearSong ( struct TuComposerSong *SongStr );
ULONG AddSongUnknownChunk ( struct TuComposerSong *SongStr,
    struct UnknownChunk *UnknownChunkStr );
ULONG RemSongUnknownChunk ( struct TuComposerSong *SongStr );
ULONG InsertSongUnknownChunk ( struct TuComposerSong *SongStr,
    struct UnknownChunk *UnknownChunkStr,
    struct UnknownChunk *UnknownChunkPos );
struct TuComposerInstr **GetSongInstrs ( struct TuComposerSong *SongStr );
ULONG FreeSongInstrs ( struct TuComposerInstr **InstrList );
struct TuComposerInstrEnvelope **GetSongEnvelopes ( struct TuComposerSong *SongStr );
ULONG FreeSongEnvelopes ( struct TuComposerInstrEnvelope **EnvList );
struct TuComposerInstrKeyboard **GetSongKeyboards ( struct TuComposerSong *SongStr );
ULONG FreeSongKeyboards ( struct TuComposerInstrKeyboard **KeybrdList );
struct TuComposerInstrArpeggio **GetSongArpeggios ( struct TuComposerSong *SongStr );
ULONG FreeSongArpeggios ( struct TuComposerInstrArpeggio **ArpList );
struct TuComposerTrack *ReMapSongInstrs ( struct TuComposerSong *SongStr,
    struct TuComposerTrack *TrackStr, struct TuComposerInstr **InstrList );
ULONG SetBaseSongInstrs ( struct TuComposerSong *SongStr,
    struct TuComposerTrack *TrackStr, unsigned long FirstInsNum );
ULONG SetSongChannels ( struct TuComposerSong *SongStr,
    unsigned long Channels );
ULONG SetStack ( struct TuComposerSong *SongStr, unsigned long GoSubStack,
    unsigned long LoopStack );
ULONG CalcSongPlayTime ( struct TuComposerSong *SongStr,
    struct PlayExecHandler *PlayExecStr );
ULONG GetOptimalChannels ( struct TuComposerSong *SongStr );
ULONG ResetSong ( struct TuComposerSong *SongStr );
ULONG CalcPlayerSpeed ( struct TuComposerSong *SongStr );

/* Position/order list related functions */

struct TuComposerOrders *AllocPosition ( unsigned long Channels );
ULONG FreePosition ( struct TuComposerOrders *PosStr,
    unsigned long Channels );
ULONG SwapPosition ( struct TuComposerOrders *PosStr,
    unsigned long Channel, unsigned long SwapChannel );
ULONG SetPosition ( struct TuComposerSong *SongStr,
    struct TuComposerOrders *PosStr );
struct TuComposerOrders *DupPosition ( struct TuComposerOrders *PosStr,
    unsigned long Channels );
ULONG GetPositionNum ( struct TuComposerOrders *PosStr,
   struct TuComposerOrderList *PosListStr, unsigned long Channel );
struct TuComposerOrderList *GetPositionAddr ( struct TuComposerOrders
    *PosStr, unsigned long Channel, unsigned long Num );
ULONG ClearPosition ( struct TuComposerOrders *PosStr,
    unsigned long Channels );
ULONG PlayPosition ( struct TuComposerOrders *PosStr,
    union FlagPass *FlagPassStr, unsigned long Order,
    unsigned long Row );
ULONG DupPositionChannel ( struct TuComposerOrders *SrcPosStr,
    struct TuComposerOrders *DestPosStr, unsigned long SrcChannel,
    unsigned long DestChannel );
ULONG ClearPositionChannel ( struct TuComposerOrders *PosStr,
    unsigned long Channel );
struct TuComposerOrderList *AllocPositionList ( void );
ULONG FreePositionList ( struct TuComposerOrderList *PosListStr );
ULONG AddPositionList ( struct TuComposerOrders *PosStr,
    struct TuComposerOrderList *PosListStr, unsigned long Channel );
ULONG RemPositionList ( struct TuComposerOrders *PosStr,
    unsigned long Channel );
ULONG InsertPositionList ( struct TuComposerOrders *PosStr,
    struct TuComposerOrderList *PosListStr,
    struct TuComposerOrderList *PosListPos, unsigned long Channel );
ULONG DeletePositionList ( struct TuComposerOrderList *PosListStr );
struct TuComposerOrderList *DupPositionList ( struct TuComposerOrderList
    *PosListStr );
ULONG SwapPositionList ( struct TuComposerOrderList *PosListStr,
    struct TuComposerOrderList *SwapPosListStr );
ULONG ClearPositionList ( struct TuComposerOrderList *PosListStr );

/* Pattern/Track related functions */

struct TuComposerTrack *AllocTrack ( unsigned long DefLength );
ULONG FreeTrack ( struct TuComposerTrack *TrackStr );
ULONG AddTrack ( struct TuComposerSong *SongStr,
    struct TuComposerTrack *TrackStr );
ULONG RemTrack ( struct TuComposerSong *SongStr );
ULONG InsertTrack ( struct TuComposerSong *SongStr,
    struct TuComposerTrack *TrackStr, struct TuComposerTrack *TrackPos );
ULONG DeleteTrack ( struct TuComposerTrack *TrackStr );
ULONG ClearTrack ( struct TuComposerTrack *TrackStr );
struct TuComposerTrack *DupTrack ( struct TuComposerTrack *TrackStr );
ULONG ReMapTrack ( struct TuComposerSong *SongStr,
    struct TuComposerTrack *TrackStr, struct TuComposerTrack *NewTrackStr );
ULONG ReSizeTrack ( struct TuComposerTrack *TrackStr, unsigned long NewLen );
ULONG AddTrackUnknownChunk ( struct TuComposerTrack *TrackStr,
    struct UnknownChunk *UnknownChunkStr );
ULONG RemTrackUnknownChunk ( struct TuComposerTrack *TrackStr );
ULONG InsertTrackUnknownChunk ( struct TuComposerTrack *TrackStr,
    struct UnknownChunk *UnknownChunkStr,
    struct UnknownChunk *UnknownChunkPos );
ULONG GetNumTracks ( struct TuComposerSong *SongStr );
ULONG GetTrackNum ( struct TuComposerSong *SongStr,
   struct TuComposerTrack *TrackStr );
struct TuComposerTrack *GetTrackAddr ( struct TuComposerSong *SongStr,
    unsigned long Num );
void GetNoteStr ( STRPTR StrBuf, unsigned long Octave, unsigned long Note,
    unsigned long Flags );
void GetIndexNoteStr ( STRPTR StrBuf, unsigned long IndexNote,
    unsigned long Flags );
ULONG NoteToIndex ( unsigned long Octave, unsigned long Note );
ULONG IndexToNote ( unsigned long IndexNote );
ULONG GetTrackRowStr ( struct TuComposerTrack *TrackStr, STRPTR StrBuf,
    struct TuComposerTrackEffect *EffStr, unsigned long Row,
    unsigned long Flags, unsigned long SpcChar );
struct TuComposerTrackEffect *AllocEffect ( unsigned long EffectByte,
    unsigned long DataWord );
ULONG FreeEffect ( struct TuComposerTrackEffect *EffStr );
ULONG AddEffect ( struct TuComposerTrack *TrackStr,
    struct TuComposerTrackEffect *EffStr, unsigned long Row );
ULONG RemEffect ( struct TuComposerTrack *TrackStr, unsigned long Row );
ULONG InsertEffect ( struct TuComposerTrack *TrackStr,
    struct TuComposerTrackEffect *EffStr,
    struct TuComposerTrackEffect *EffPos, unsigned long Row );
ULONG DeleteEffect ( struct TuComposerTrackEffect *EffStr );
ULONG ClearEffects ( struct TuComposerTrack *TrackStr, unsigned long Row,
    unsigned long NumRows );
ULONG ReMapEffects ( struct TuComposerTrack *SrcTrackStr,
    struct TuComposerTrack *DestTrackStr, unsigned long SrcRow,
    unsigned long DestRow, unsigned long NumRows );
struct TuComposerTrackData *AllocTrackData ( unsigned long Length );
ULONG FreeTrackData ( struct TuComposerTrackData *TrackData,
    unsigned long Length );
ULONG AddRows ( struct TuComposerTrack *TrackStr, unsigned long NumRows );
ULONG RemRows ( struct TuComposerTrack *TrackStr, unsigned long NumRows );
ULONG InsertRows ( struct TuComposerTrack *TrackStr, unsigned long Row,
    unsigned long NumRows, unsigned long Flags );
ULONG DeleteRows ( struct TuComposerTrack *TrackStr, unsigned long Row,
    unsigned long NumRows, unsigned long Flags );
ULONG ClearRows ( struct TuComposerTrack *TrackStr, unsigned long Row,
    unsigned long NumRows );
ULONG ReMapRows (  struct TuComposerTrack *SrcTrackStr,
    struct TuComposerTrack *DestTrackStr, unsigned long SrcRow,
    unsigned long DestRow, unsigned long NumRows );
ULONG CopyRows ( struct TuComposerTrack *SrcTrackStr,
    struct TuComposerTrack *DestTrackStr, unsigned long SrcRow,
    unsigned long DestRow, unsigned long NumRows );
ULONG SwapRows ( struct TuComposerTrack *SrcTrackStr,
    struct TuComposerTrack *DestTrackStr, unsigned long SrcRow,
    unsigned long DestRow, unsigned long NumRows );
ULONG PlayRow ( struct TuComposerTrack *TrackStr,
    union FlagPass *FlagPassStr,
    unsigned long Row, unsigned long Channel );
LONG CmpTracks ( struct TuComposerTrack *SrcTrackStr,
   struct TuComposerTrack *DestTrackStr );
struct TuComposerPacked *PackTrack ( struct TuComposerTrack *TrackStr );
struct TuComposerTrack *UnPackTrack ( struct TuComposerPacked *PackedTrackStr,
     struct TuComposerTrack *TrackStr );
void FreePackedTrack ( struct TuComposerPacked *PackedTrackStr );
struct TuComposerTrack *LoadTrack ( struct CFHandle *CFHandle,
    struct TuComposerTrack *TrackStr, struct TuComposerExtList *ExtLibStr,
    union FlagPass *FlagPassStr, unsigned long NumTrack );
ULONG SaveTrack ( struct CFHandle *CFHandle,
    struct TuComposerTrack *TrackStr, struct TuComposerExtList *ExtLibStr,
    union FlagPass *FlagPassStr );
struct TuComposerExtList *IdentifyTrack ( struct CFHandle *CFHandle );
struct TrackInfo *GetTrackInfo ( struct CFHandle *CFHandle,
    struct TuComposerExtList *ExtLibStr, unsigned long NumTrack );
ULONG FreeTrackInfo ( struct TrackInfo *TrackInfoStr );
ULONG GetTracks ( struct CFHandle *CFHandle,
    struct TuComposerExtList *ExtLibStr );
struct TuComposerTrack *PushTrack ( struct TuComposerTrack *TrackStr );
ULONG PopTrack ( struct TuComposerTrack *TrackBuf );
struct TuComposerTrack *CutTrack ( struct TuComposerTrack *TrackStr,
    struct TuComposerTrack *TrackBuf );
struct TuComposerTrack *CopyTrack ( struct TuComposerTrack *TrackStr,
    struct TuComposerTrack *TrackBuf );
struct TuComposerTrack *PasteTrack (  struct TuComposerTrack *TrackBuf,
    struct TuComposerTrack *TrackStr );
ULONG SwapTrack ( struct TuComposerTrack *TrackBuf,
     struct TuComposerTrack *TrackStr );
ULONG SwapTrackInSong ( struct TuComposerTrack *TrackBuf,
     struct TuComposerTrack *TrackStr, unsigned long Flags );
ULONG ShrinkTrack ( struct TuComposerTrack *TrackStr, unsigned long Scale );
ULONG ExpandTrack ( struct TuComposerTrack *TrackStr, unsigned long Scale );
ULONG HalveTrack ( struct TuComposerTrack *TrackStr, unsigned long Scale );
ULONG DoubleTrack ( struct TuComposerTrack *TrackStr, unsigned long Scale );
struct TuComposerTrack *SplitTrack ( struct TuComposerTrack *SrcTrackStr,
     struct TuComposerTrack *DestTrackStr, unsigned long Row );
ULONG JoinTrack ( struct TuComposerTrack *SrcTrackStr,
    struct TuComposerTrack *DestTrackStr );
ULONG PlayTrack ( union FlagPass *FlagPassStr,
    unsigned long Order, unsigned long Channel,
    unsigned long Row );
ULONG TrackNoteShift ( struct TuComposerTrack *TrackStr,
   long HalfNotes, unsigned long StartRow, unsigned long EndRow );
ULONG ScrollTrack ( struct TuComposerTrack *TrackStr, long Rows,
    unsigned long StartRow, unsigned long EndRow );
ULONG RotateTrack ( struct TuComposerTrack *TrackStr, long Rows,
    unsigned long StartRow, unsigned long EndRow );
ULONG FlipTrack ( struct TuComposerTrack *TrackStr, unsigned long Scale,
    unsigned long StartRow, unsigned long EndRow );

/* Instrument related functions */

struct TuComposerInstr *AllocInstr ( unsigned long NumSamples );
ULONG FreeInstr ( struct TuComposerInstr *InstrStr );
ULONG AddInstr ( struct TuComposerModule *ModuleStr,
    struct TuComposerInstr *InstrStr );
ULONG RemInstr ( struct TuComposerModule *ModuleStr );
ULONG InsertInstr ( struct TuComposerModule *ModuleStr,
    struct TuComposerInstr *InstrStr, struct TuComposerInstr *InstrPos );
ULONG DeleteInstr ( struct TuComposerInstr *InstrStr );
ULONG ClearInstr ( struct TuComposerInstr *InstrStr );
struct TuComposerInstr *DupInstr ( struct TuComposerInstr *InstrStr );
ULONG ReMapInstr ( struct TuComposerInstr *InstrStr,
    struct TuComposerInstr *NewInstrStr );
ULONG AddInstrUnknownChunk ( struct TuComposerInstr *InstrStr,
    struct UnknownChunk *UnknownChunkStr );
ULONG RemInstrUnknownChunk ( struct TuComposerInstr *InstrStr );
ULONG InsertInstrUnknownChunk ( struct TuComposerInstr *InstrStr,
    struct UnknownChunk *UnknownChunkStr,
    struct UnknownChunk *UnknownChunkPos );
ULONG GetNumInstrs ( struct TuComposerModule *ModuleStr );
ULONG GetInstrNum ( struct TuComposerModule *ModuleStr,
    struct TuComposerInstr *InstrStr );
struct TuComposerInstr *GetInstrAddr ( struct TuComposerModule *ModuleStr,
    unsigned long Num );
struct TuComposerInstr *LoadInstr ( struct CFHandle *CFHandle,
    struct TuComposerInstr *InstrStr, struct TuComposerExtList *ExtLibStr,
    union FlagPass *FlagPassStr, unsigned long NumInstr );
ULONG SaveInstr ( struct CFHandle *CFHandle,
    struct TuComposerInstr *InstrStr, struct TuComposerExtList *ExtLibStr,
    union FlagPass *FlagPassStr );
struct TuComposerExtList *IdentifyInstr ( struct CFHandle *CFHandle );
struct InstrInfo *GetInstrInfo ( struct CFHandle *CFHandle,
    struct TuComposerExtList *ExtLibStr, unsigned long NumInstr );
ULONG FreeInstrInfo ( struct InstrInfo *InstrInfoStr );
ULONG GetInstrs ( struct CFHandle *CFHandle,
    struct TuComposerExtList *ExtLibStr );
struct TuComposerInstr *PushInstr ( struct TuComposerInstr *InstrStr );
ULONG PopInstr ( struct TuComposerInstr *InstrBuf );
struct TuComposerInstr *CutInstr ( struct TuComposerInstr *InstrStr,
    struct TuComposerInstr *InstrBuf );
struct TuComposerInstr *CopyInstr ( struct TuComposerInstr *InstrStr,
    struct TuComposerInstr *InstrBuf );
struct TuComposerInstr *PasteInstr ( struct TuComposerInstr *InstrBuf,
    struct TuComposerInstr *InstrStr );
ULONG SwapInstr ( struct TuComposerInstr *InstrBuf,
    struct TuComposerInstr *InstrStr );
ULONG SwapInstrInModule ( struct TuComposerInstr *InstrBuf,
    struct TuComposerInstr *InstrStr, unsigned long Flags );
ULONG PlayInstr ( struct TuComposerInstr *InstrStr,
    union FlagPass *FlagPassStr, unsigned long Channel,
    unsigned long Note, unsigned long Volume );
LONG CmpInstrs ( struct TuComposerInstr *SrcInstrStr,
    struct TuComposerInstr *DestInstrStr );
struct TuComposerInstrEnvelope **GetInstrEnvelopes ( struct TuComposerInstr *InstrStr );
ULONG FreeInstrEnvelopes ( struct TuComposerInstrEnvelope **InstrEnvStr );
ULONG AddInstrEnvelopes ( struct TuComposerInstr *InstrStr,
    unsigned long Flags );
struct TuComposerInstrKeyboard *GetInstrKeyboard ( struct TuComposerInstr *InstrStr );
struct TuComposerSample **GetInstrSamples ( struct TuComposerInstr *InstrStr );
ULONG FreeInstrSamples ( struct TuComposerSample **InstrSmpStr );

/* Envelope (volume, panning, vibrato, arpeggio, etc.) related functions */

struct TuComposerInstrEnvelope *CreateEnvelope ( unsigned long NumPoints,
    unsigned long Type, unsigned long Scale, long YOffset,
    unsigned long Nodes );
ULONG FreeEnvelope ( struct TuComposerInstrEnvelope *EnvStr );
ULONG AddEnvelope ( struct TuComposerModule *ModuleStr,
     struct TuComposerInstrEnvelope *EnvStr );
ULONG RemEnvelope ( struct TuComposerModule *ModuleStr );
ULONG InsertEnvelope ( struct TuComposerModule *ModuleStr,
     struct TuComposerInstrEnvelope *EnvStr,
     struct TuComposerInstrEnvelope *EnvPos );
ULONG DeleteEnvelope ( struct TuComposerInstrEnvelope *EnvStr );
ULONG ClearEnvelope ( struct TuComposerInstrEnvelope *EnvStr,
    unsigned long Type, unsigned long Scale, unsigned long YOffset );
struct TuComposerInstrEnvelope *DupEnvelope ( struct TuComposerInstrEnvelope
    *EnvStr );
ULONG ReMapEnvelope ( struct TuComposerInstrEnvelope *EnvStr,
    struct TuComposerInstrEnvelope *NewEnvStr );
ULONG ReSizeEnvelope ( struct TuComposerInstrEnvelope *EnvStr,
    unsigned long Entries );
ULONG ValidateEnvNodes ( struct TuComposerInstrEnvelope *EnvStr );
ULONG AddEnvelopeUnknownChunk ( struct TuComposerInstrEnvelope *EnvStr,
    struct UnknownChunk *UnknownChunkStr );
ULONG RemEnvelopeUnknownChunk ( struct TuComposerInstrEnvelope *EnvStr );
ULONG InsertEnvelopeUnknownChunk ( struct TuComposerInstrEnvelope *EnvStr,
    struct UnknownChunk *UnknownChunkStr,
    struct UnknownChunk *UnknownChunkPos );
ULONG GetNumEnvelopes ( struct TuComposerModule *ModuleStr );
ULONG GetEnvelopeNum ( struct TuComposerModule *ModuleStr,
    struct TuComposerInstrEnvelope *EnvStr );
struct TuComposerInstrEnvelope *GetEnvelopeAddr ( struct TuComposerModule
    *ModuleStr, unsigned long Num );
ULONG SwapEnvelopeInModule ( struct TuComposerInstrEnvelope *EnvBuf,
    struct TuComposerInstrEnvelope *EnvStr, unsigned long Flags );
struct TuComposerInstrEnvelope *LoadEnvelope ( struct CFHandle *CFHandle,
    struct TuComposerInstrEnvelope *EnvStr, unsigned long NumEnv );
ULONG SaveEnvelope ( struct CFHandle *CFHandle,
    struct TuComposerInstrEnvelope *EnvStr );
ULONG ShrinkEnvelope ( struct TuComposerInstrEnvelope *EnvStr,
    unsigned long Scale );
ULONG ExpandEnvelope ( struct TuComposerInstrEnvelope *EnvStr,
    unsigned long Scale );
ULONG HalveEnvelope ( struct TuComposerInstrEnvelope *EnvStr,
    unsigned long Scale );
ULONG DoubleEnvelope ( struct TuComposerInstrEnvelope *EnvStr,
    unsigned long Scale );
struct TuComposerInstrEnvelope *SplitEnvelope (
    struct TuComposerInstrEnvelope *SrcEnvStr,
    struct TuComposerInstrEnvelope *DestEnvStr, unsigned long Point );
ULONG JoinEnvelope ( struct TuComposerInstrEnvelope *SrcEnvStr,
    struct TuComposerInstrEnvelope *DestEnvStr );
ULONG ScrollEnvelope ( struct TuComposerInstrEnvelope *EnvStr, long Points,
    unsigned long StartPoint, unsigned long EndPoint );
ULONG RotateEnvelope ( struct TuComposerInstrEnvelope *EnvStr, long Points,
    unsigned long StartPoint, unsigned long EndPoint );
ULONG FlipEnvelope ( struct TuComposerInstrEnvelope *EnvStr,
    unsigned long Scale, unsigned long StartPoint, unsigned long EndPoint );
ULONG AddEnvPoint ( struct TuComposerInstrEnvelope *EnvStr,
    unsigned long Points );
ULONG RemEnvPoint ( struct TuComposerInstrEnvelope *EnvStr,
    unsigned long Points );
ULONG InsertEnvPoint ( struct TuComposerInstrEnvelope *EnvStr,
    unsigned long Point, unsigned long Points, unsigned long Flags );
ULONG DeleteEnvPoint ( struct TuComposerInstrEnvelope *EnvStr,
    unsigned long Point, unsigned long Points, unsigned long Flags );
LONG CmpEnvelopes ( struct TuComposerInstrEnvelope *SrcEnvStr,
    struct TuComposerInstrEnvelope *DestEnvStr );

/* Keyboard definitions related functions */

struct TuComposerInstrKeyboard *AllocKeyboard ( void );
ULONG FreeKeyboard ( struct TuComposerInstrKeyboard *KeybrdStr );
ULONG AddKeyboard ( struct TuComposerModule *ModuleStr,
    struct TuComposerInstrKeyboard *KeybrdStr );
ULONG RemKeyboard ( struct TuComposerModule *ModuleStr );
ULONG InsertKeyboard ( struct TuComposerModule *ModuleStr,
    struct TuComposerInstrKeyboard *KeybrdStr,
    struct TuComposerInstrKeyboard *KeybrdPos );
ULONG DeleteKeyboard ( struct TuComposerInstrKeyboard *KeybrdStr );
ULONG ClearKeyboard ( struct TuComposerInstrKeyboard *KeybrdStr );
struct TuComposerInstrKeyboard *DupKeyboard ( struct TuComposerInstrKeyboard
    *KeybrdStr );
ULONG ReMapKeyboard ( struct TuComposerInstrKeyboard *KeybrdStr,
    struct TuComposerInstrKeyboard *NewKeybrdStr );
ULONG GetNumKeyboards ( struct TuComposerModule *ModuleStr );
ULONG GetKeyboardNum ( struct TuComposerModule *ModuleStr,
    struct TuComposerInstrKeyboard *KeybrdStr );
struct TuComposerInstrKeyboard *GetKeyboardAddr (
    struct TuComposerModule *ModuleStr, unsigned long Num );
ULONG SwapKeyboardInModule ( struct TuComposerInstrKeyboard *KeybrdBuf,
    struct TuComposerInstrKeyboard *KeybrdStr, unsigned long Flags );
ULONG SetKeyboard ( struct TuComposerInstrKeyboard *KeybrdStr,
    unsigned long SampleNum, unsigned long Octave, unsigned long Note,
    unsigned long NewOctave, unsigned long NewNote );
LONG CheckKeyboard ( struct TuComposerInstrKeyboard *KeybrdStr );
LONG CmpKeyboards ( struct TuComposerInstrKeyboard *SrcKeybrdStr,
    struct TuComposerInstrKeyboard *DestKeybrdStr );

/* Arpeggio editing related functions */

struct TuComposerInstrArpeggio *AllocArpeggio ( unsigned long NumEntries );
ULONG FreeArpeggio ( struct TuComposerInstrArpeggio *ArpStr );
ULONG AddArpeggio ( struct TuComposerModule *ModuleStr,
    struct TuComposerInstrArpeggio *ArpStr );
ULONG RemArpeggio ( struct TuComposerModule *ModuleStr );
ULONG InsertArpeggio ( struct TuComposerModule *ModuleStr,
    struct TuComposerInstrArpeggio *ArpStr,
    struct TuComposerInstrArpeggio *ArpPos );
ULONG DeleteArpeggio ( struct TuComposerInstrArpeggio *ArpStr );
ULONG ClearArpeggio ( struct TuComposerInstrArpeggio *ArpStr );
struct TuComposerInstrArpeggio *DupArpeggio ( struct TuComposerInstrArpeggio
    *ArpStr );
ULONG ReMapArpeggio ( struct TuComposerInstrArpeggio *ArpStr,
    struct TuComposerInstrArpeggio *NewArpStr );
ULONG ReSizeArpeggio ( struct TuComposerInstrArpeggio *ArpStr,
    unsigned long Entries );
ULONG GetNumArpeggios ( struct TuComposerModule *ModuleStr );
ULONG GetArpeggioNum ( struct TuComposerModule *ModuleStr,
    struct TuComposerInstrArpeggio *ArpStr );
struct TuComposerInstrArpeggio *GetArpeggioAddr ( struct TuComposerModule
    *ModuleStr, unsigned long Num );
ULONG SwapArpeggioInModule ( struct TuComposerInstrArpeggio *ArpBuf,
    struct TuComposerInstrArpeggio *ArpStr, unsigned long Flags );
ULONG ShrinkArpeggio ( struct TuComposerInstrArpeggio *ArpStr,
    unsigned long Scale );
ULONG ExpandArpeggio ( struct TuComposerInstrArpeggio *ArpStr,
    unsigned long Scale );
ULONG HalveArpeggio ( struct TuComposerInstrArpeggio *ArpStr,
    unsigned long Scale );
ULONG DoubleArpeggio ( struct TuComposerInstrArpeggio *ArpStr,
    unsigned long Scale );
struct TuComposerInstrArpeggio *SplitArpeggio (
    struct TuComposerInstrArpeggio *SrcArpStr,
    struct TuComposerInstrArpeggio *DestArpStr, unsigned long Tick );
ULONG JoinArpeggio ( struct TuComposerInstrArpeggio *SrcArpStr,
    struct TuComposerInstrArpeggio *DestArpStr );
ULONG ScrollArpeggio ( struct TuComposerInstrArpeggio *ArpStr, long Ticks,
    unsigned long StartTick, unsigned long EndTick );
ULONG RotateArpeggio ( struct TuComposerInstrArpeggio *ArpStr, long Ticks,
    unsigned long StartTick, unsigned long EndTick );
ULONG FlipArpeggio ( struct TuComposerInstrArpeggio *ArpStr,
    unsigned long Scale, unsigned long StartTick, unsigned long EndTick );
ULONG AddArpeggioTick ( struct TuComposerInstrArpeggio *ArpStr,
    unsigned long Ticks );
ULONG RemArpeggioTick ( struct TuComposerInstrArpeggio *ArpStr,
    unsigned long Ticks );
ULONG InsertArpeggioTick ( struct TuComposerInstrArpeggio *ArpStr,
    unsigned long Tick, unsigned long Ticks, unsigned long Flags );
ULONG DeleteArpeggioTick ( struct TuComposerInstrArpeggio *ArpStr,
    unsigned long Tick, unsigned long Ticks, unsigned long Flags );
LONG CmpArpeggios ( struct TuComposerInstrArpeggio *SrcArpStr,
    struct TuComposerInstrArpeggio *DestArpStr );

/* Sample/Sampler related functions */

struct TuComposerSample *AllocSample ( WORD *SampleData,
    unsigned long Length );
ULONG FreeSample ( struct TuComposerSample *SampleStr );
ULONG AddSample ( struct TuComposerInstr *InstrStr,
    struct TuComposerSample *SampleStr );
ULONG RemSample ( struct TuComposerInstr *InstrStr );
ULONG InsertSample ( struct TuComposerInstr *InstrStr,
    struct TuComposerSample *SampleStr,
    struct TuComposerSample *SamplePos );
ULONG DeleteSample ( struct TuComposerSample *SampleStr );
ULONG ClearSample ( struct TuComposerSample *SampleStr );
struct TuComposerSample *DupSample ( struct TuComposerSample *SampleStr );
ULONG ReSizeSample ( struct TuComposerSample *SampleStr,
    unsigned long NewSamples );
ULONG AddSampleUnknownChunk ( struct TuComposerSample *SampleStr,
    struct UnknownChunk *UnknownChunkStr );
ULONG RemSampleUnknownChunk ( struct TuComposerSample *SampleStr );
ULONG InsertSampleUnknownChunk ( struct TuComposerSample *SampleStr,
    struct UnknownChunk *UnknownChunkStr,
    struct UnknownChunk *UnknownChunkPos );
ULONG GetNumSamples ( struct TuComposerInstr *InstrStr );
ULONG GetSampleNum ( struct TuComposerInstr *InstrStr,
    struct TuComposerSample *SampleStr );
struct TuComposerSample *GetSampleAddr ( struct TuComposerInstr *InstrStr,
    unsigned long Num );
struct TuComposerSample *PushSample ( struct TuComposerSample *SampleStr );
ULONG PopSample ( struct TuComposerSample *SampleBuf );
struct TuComposerSample *CutSample ( struct TuComposerSample *SampleStr,
    struct TuComposerSample *SampleBuf );
struct TuComposerSample *CopySample ( struct TuComposerSample *SampleStr,
    struct TuComposerSample *SampleBuf );
struct TuComposerSample *PasteSample ( struct TuComposerSample *SampleBuf,
    struct TuComposerSample *SampleStr );
ULONG SwapSample ( struct TuComposerSample *SampleBuf,
    struct TuComposerSample *SampleStr );
ULONG SwapSampleInInstr ( struct TuComposerSample *SampleBuf,
    struct TuComposerSample *SampleStr, unsigned long Flags );
ULONG PlaySample ( struct TuComposerSample *SampleStr,
    union FlagPass *FlagPassStr, unsigned long Channel,
    unsigned long Frequency, unsigned long Volume );
struct TuComposerSample *LoadSample ( struct CFHandle *CFHandle,
    struct TuComposerSample *SampleStr, struct TuComposerExtList *ExtLibStr,
    union FlagPass *FlagPassStr, unsigned long NumSample );
ULONG SaveSample ( struct CFHandle *CFHandle,
    struct TuComposerSample *SampleStr, struct TuComposerExtList *ExtLibStr,
    union FlagPass *FlagPassStr );
struct TuComposerExtList *IdentifySample ( struct CFHandle *CFHandle );
struct SampleInfo *GetSampleInfo ( struct CFHandle *CFHandle,
    struct TuComposerExtList *ExtLibStr, unsigned long NumSample );
ULONG FreeSampleInfo ( struct SampleInfo *SampleInfoStr );
ULONG GetSamples ( struct CFHandle *CFHandle,
    struct TuComposerExtList *ExtLibStr );
ULONG CalcSamplePlayFreq ( struct TuComposerSample *SampleStr,
    unsigned long Octave, unsigned long Note );
ULONG CalcFineTune ( unsigned long Note, long FineTune );
ULONG ConvertSampleFrequency ( unsigned long Period );
ULONG CalcLinearFrequency ( unsigned long SampleFreq, long SlideValue );
WORD *AllocSampleData ( unsigned long Length );
ULONG FreeSampleData ( WORD *SampleData, unsigned long Length );
ULONG SetSampleData ( struct TuComposerSample *SampleStr, WORD *SampleData,
    unsigned long Length );
ULONG AddSampleData ( struct TuComposerSample *SampleStr,
    unsigned long NumSamples );
ULONG RemSampleData ( struct TuComposerSample *SampleStr,
    unsigned long NumSamples );
ULONG InsertSampleData ( struct TuComposerSample *SampleStr,
    unsigned long SamplePos, unsigned long NumSamples );
ULONG DeleteSampleData ( struct TuComposerSample *SampleStr,
    unsigned long SamplePos, unsigned long NumSamples );
ULONG ClearSampleData ( struct TuComposerSample *SampleStr,
    unsigned long FirstSmp, unsigned long LastSmp );
WORD *DupSampleData ( struct TuComposerSample *SampleStr );
struct TuComposerSample *CutSampleData ( struct TuComposerSample *SampleStr,
    struct TuComposerSample *SampleBuf,
    unsigned long FirstSmp, unsigned long LastSmp );
struct TuComposerSample *CopySampleData ( struct TuComposerSample *SampleStr,
    struct TuComposerSample *SampleBuf,
    unsigned long FirstSmp, unsigned long LastSmp );
struct TuComposerSample *PasteSampleData ( struct TuComposerSample
    *SampleBuf, struct TuComposerSample *SampleStr,
    unsigned long PasteSmp, unsigned long Flags );
struct TuComposerSample *CropSampleData ( struct TuComposerSample *SampleStr,
    struct TuComposerSample *SampleBuf,
    unsigned long FirstSmp, unsigned long LastSmp );
struct TuComposerSample *LoadSampleData ( struct CFHandle *CFHandle,
    struct TuComposerSample *SampleStr, unsigned long NumBytes );
ULONG SaveSampleData ( struct CFHandle *CFHandle,
    struct TuComposerSample *SampleStr, unsigned long FirstSmp,
    unsigned long LastSmp );
ULONG ConvertBits ( struct TuComposerSample *SampleStr,
    unsigned long DestBitDepth, unsigned long Flags );
ULONG GetOptimalBits ( struct TuComposerSample *SampleStr,
    unsigned long Flags );
ULONG ConvertSigned ( struct TuComposerSample *SampleStr );
ULONG ConvertWord ( struct TuComposerSample *SampleStr );
ULONG DecrunchSample ( struct TuComposerSample *SampleStr,
    unsigned long DeltaBitDepth );
ULONG Backwards ( struct TuComposerSample *SampleStr, unsigned long StartSmp,
    unsigned long LastSmp );
ULONG MixSamples ( struct TuComposerSample *SrcSampleStr,
    struct TuComposerSample *DestSampleStr, unsigned long SrcStartSmp,
    unsigned long SrcLastSmp, unsigned long DestStartSmp );
struct TuComposerSample *Sample ( struct TuComposerSample *SampleStr,
    struct TuComposerExtList *InpDevStr, WORD *Buffer,
    unsigned long Frequency, unsigned long BitDepth, unsigned long BufLen,
    unsigned long Flags );
ULONG OctaveUp ( struct TuComposerSample *SampleStr );
ULONG OctaveDown ( struct TuComposerSample *SampleStr );
ULONG ReSample ( struct TuComposerSample *SampleStr,
    unsigned long NewFrequency, unsigned long OldFrequency,
    unsigned long Flags );
ULONG InvertSample ( struct TuComposerSample *SampleStr );
ULONG XFadeSample ( struct TuComposerSample *SampleStr );
ULONG AmplifySample ( struct TuComposerSample *SampleStr,
    unsigned long StartAmplify, unsigned long EndAmplify,
    unsigned long StartSmp, unsigned long LastSmp );
ULONG GetBiggestAmplify ( struct TuComposerSample *SampleStr,
    unsigned long StartSmp, unsigned long LastSmp );
ULONG GetLowestAmplify ( struct TuComposerSample *SampleStr,
    unsigned long StartSmp, unsigned long LastSmp );
ULONG CreateEcho ( struct TuComposerSample *SampleStr );
ULONG BoostSample ( struct TuComposerSample *SampleStr );
ULONG FilterSample ( struct TuComposerSample *SampleStr );
ULONG MorphSamples ( struct TuComposerSample *SampleStr );
ULONG MinimizeSample ( struct TuComposerSample *SampleStr );
struct TuComposerSample *FindOriginSample ( struct TuComposerSample *SampleStr );
LONG GetSampleValue ( struct TuComposerSample *SampleStr,
    unsigned long Sample );
ULONG GetSampleValueArray ( struct TuComposerSample *SampleStr,
    LONG *ArrayPtr, unsigned long StartSmp, unsigned long ArrayEntries );
LONG CmpSamples ( struct TuComposerSample *SrcSampleStr,
    struct TuComposerSample *DestSampleStr );

/* Synth/Hybrid related functions */

struct TuComposerSynth *AllocSynth ( unsigned long CodeLen,
    unsigned long Waveforms, unsigned long WaveLen );
ULONG FreeSynth ( struct TuComposerSynth *SynthStr );
ULONG AssignSynth ( struct TuComposerSample *SampleStr,
    struct TuComposerSynth *SynthStr );
ULONG ClearSynth ( struct TuComposerSynth *SynthStr );
struct TuComposerSynth *DupSynth ( struct TuComposerSynth *SynthStr );
ULONG ReMapSynth ( struct TuComposerSynth *SynthStr,
    struct TuComposerSynth *NewSynthStr );
ULONG AddSynthUnknownChunk ( struct TuComposerSynth *SynthStr,
    struct UnknownChunk *UnknownChunkStr );
ULONG RemSynthUnknownChunk ( struct TuComposerSynth *SynthStr );
ULONG InsertSynthUnknownChunk ( struct TuComposerSynth *SynthStr,
    struct UnknownChunk *UnknownChunkStr,
    struct UnknownChunk *UnknownChunkPos );
ULONG GetNumSynths ( struct TuComposerModule *ModuleStr );
ULONG GetSynthNum ( struct TuComposerModule *ModuleStr,
    struct TuComposerSynth *SynthStr );
struct TuComposerSynth *GetSynthAddr ( struct TuComposerModule *ModuleStr,
    unsigned long SynthNum );
struct TuComposerSynth *PushSynth ( struct TuComposerSynth *SynthStr );
ULONG PopSynth ( struct TuComposerSynth *SynthBuf );
struct TuComposerSynth *CutSynth ( struct TuComposerSynth *SynthStr,
    struct TuComposerSynth *SynthBuf );
struct TuComposerSynth *CopySynth ( struct TuComposerSynth *SynthStr,
    struct TuComposerSynth *SynthBuf );
struct TuComposerSynth *PasteSynth ( struct TuComposerSynth *SynthBuf,
    struct TuComposerSynth *SynthStr );
ULONG SwapSynth ( struct TuComposerSynth *SynthBuf,
    struct TuComposerSynth *SynthStr );
struct TuComposerSynth *LoadSynth ( struct CFHandle *CFHandle,
    struct TuComposerSynth *SynthStr,  struct TuComposerExtList *ExtLibStr,
    union FlagPass *FlagPassStr, unsigned long NumSynth );
ULONG SaveSynth ( struct CFHandle *CFHandle,
    struct TuComposerSynth *SynthStr, struct TuComposerExtList *ExtLibStr,
    union FlagPass *FlagPassStr );
struct TuComposerExtList *IdentifySynth ( struct CFHandle *CFHandle );
struct SynthInfo *GetSynthInfo ( struct CFHandle *CFHandle,
    struct TuComposerExtList *ExtLibStr, unsigned long NumSynth );
ULONG FreeSynthInfo ( struct SynthInfo *SynthInfoStr );
ULONG GetSynths ( struct CFHandle *CFHandle, struct TuComposerExtList
    *ExtLibStr );
LONG CmpSynths ( struct TuComposerSynth *SrcSynthStr,
    struct TuComposerSynth *DestSynthStr );

/* Synthetic waveform related functions */

struct TuComposerSynthWave *AllocWaveform ( unsigned long WaveLength );
ULONG FreeWaveform ( struct TuComposerSynthWave *WaveformStr );
ULONG AddWaveform ( struct TuComposerSynth *SynthStr,
    struct TuComposerSynthWave *WaveformStr );
ULONG RemWaveform ( struct TuComposerSynth *SynthStr );
ULONG InsertWaveform ( struct TuComposerSynth *SynthStr,
    struct TuComposerSynthWave *WaveformStr,
    struct TuComposerSynthWave *WaveformPos );
ULONG DeleteWaveform ( struct TuComposerSynthWave *WaveformStr );
ULONG ClearWaveform ( struct TuComposerSynthWave *WaveformStr );
struct TuComposerSynthWave *DupWaveform ( struct TuComposerSynthWave
    *WaveformStr );
ULONG ReSizeWaveform ( struct TuComposerSynthWave *WaveformStr,
    unsigned long NewLen );
ULONG GetNumWaveforms ( struct TuComposerSynth *SynthStr );
ULONG GetWaveformNum ( struct TuComposerSynth *SynthStr,
    struct TuComposerSynthWave *WaveformStr );
struct TuComposerSynthWave *GetWaveformAddr ( struct TuComposerSynth
    *SynthStr, unsigned long WaveformNum );
struct TuComposerSynthWave *PushWaveform ( struct TuComposerSynthWave
    *WaveformStr );
ULONG PopWaveform ( struct TuComposerSynthWave *WaveformBuf );
struct TuComposerSynthWave *CutWaveform ( struct TuComposerSynthWave
    *WaveformStr, struct TuComposerSynthWave *WaveformBuf );
struct TuComposerSynthWave *CopyWaveform ( struct TuComposerSynthWave
    *WaveformStr, struct TuComposerSynthWave *WaveformBuf );
struct TuComposerSynthWave *PasteWaveform ( struct TuComposerSynthWave
    *WaveformBuf, struct TuComposerSynthWave *WaveformStr );
ULONG SwapWaveform ( struct TuComposerSynthWave *WaveformBuf,
    struct TuComposerSynthWave *WaveformStr );
ULONG SwapWaveformInSynth ( struct TuComposerSynthWave *WaveformBuf,
    struct TuComposerSynthWave *WaveformStr );
struct TuComposerSynthWave *LoadWaveform ( struct CFHandle *CFHandle,
    struct TuComposerSynthWave *WaveformStr, unsigned long NumBytes );
ULONG SaveWaveform ( struct CFHandle *CFHandle,
    struct TuComposerSynthWave *WaveformStr, unsigned long FirstSmp,
    unsigned long LastSmp );
ULONG PlayWaveform ( struct TuComposerSynthWave *WaveformStr,
    union FlagPass *FlagPassStr, unsigned long Frequency );
ULONG AddWaveformPoint ( struct TuComposerSynthWave * WaveformStr,
    unsigned long Points );
ULONG RemWaveformPoint ( struct TuComposerSynthWave *WaveformStr,
    unsigned long Points );
ULONG InsertWaveformPoint ( struct TuComposerSynthWave *WaveformStr,
    unsigned long Point, unsigned long Points, unsigned long Flags );
ULONG DeleteWaveformPoint ( struct TuComposerSynthWave *WaveformStr,
    unsigned long Point, unsigned long Points, unsigned long Flags );
ULONG FillWaveform ( struct TuComposerSynthWave *WaveformStr,
    unsigned long RepLen, unsigned long Type, unsigned long Scale,
    long YOffset );
ULONG ConvertWaveform ( struct TuComposerSynthWave *WaveformStr,
    unsigned long DestBitDepth, unsigned long Flags );
ULONG ConvertWaveformSigned ( struct TuComposerSynthWave *WaveformStr );
ULONG ConvertWaveformWord ( struct TuComposerSynthWave *WaveformStr );
ULONG BackwardsWaveform ( struct TuComposerSynthWave *WaveformStr );
ULONG MixWaveforms ( struct TuComposerSynthWave *SrcWaveformStr,
    struct TuComposerSynthWave *DestWaveformStr );
ULONG HalveWaveform ( struct TuComposerSynthWave *WaveformStr );
ULONG DoubleWaveform ( struct TuComposerSynthWave *WaveformStr );
ULONG ScaleWaveformSize ( struct TuComposerSynthWave *WaveformStr,
    unsigned long NewLength, unsigned long OldLength, unsigned long Flags );
ULONG InvertWaveform ( struct TuComposerSynthWave *WaveformStr );
ULONG AmplifyWaveform ( struct TuComposerSynthWave *WaveformStr,
    unsigned long Amplify );
ULONG GetMaxWaveformAmplify ( struct TuComposerSynthWave *WaveformStr );
ULONG GetMinWaveformAmplify ( struct TuComposerSynthWave *WaveformStr );
ULONG CopySample2Waveform ( struct TuComposerSample *SampleStr,
    struct TuComposerSynthWave *WaveformStr );
ULONG CopyWaveform2Sample ( struct TuComposerSynthWave *WaveformStr,
    struct TuComposerSample *SampleStr );
ULONG CopyEnvelope2Waveform ( struct TuComposerInstrEnvelope *EnvStr,
    struct TuComposerSynthWave *WaveformStr );
ULONG CopyWaveform2Envelope ( struct TuComposerSynthWave *WaveformStr,
    struct TuComposerInstrEnvelope *EnvStr );
ULONG TransformWaveform ( struct TuComposerSynthWave *SrcWaveformStr,
    struct TuComposerSynthWave *DestWaveformStr );
LONG CmpWaveforms ( struct TuComposerSynthWave *SrcWaveformStr,
    struct TuComposerSynthWave *DestWaveformStr );

/* Synth programming related functions */

struct TuComposerSynthCode *AllocSynthCode ( unsigned long Lines );
ULONG FreeSynthCode ( struct TuComposerSynthCode *SynthCodeStr,
    unsigned long Lines );
ULONG AssignSynthCode ( struct TuComposerSynth *SynthStr,
    struct TuComposerSynthCode *SynthCodeStr, unsigned long Lines );
ULONG ClearSynthCode ( struct TuComposerSynth *SynthStr );
struct TuComposerSynthCode *DupSynthCode ( struct TuComposerSynth
    *SynthStr );
ULONG ReSizeSynthCode ( struct TuComposerSynth *SynthStr,
    unsigned long NewLen );
struct TuComposerSynth *PushSynthCode ( struct TuComposerSynth *SynthStr );
ULONG PopSynthCode ( struct TuComposerSynth *SynthBuf );
struct TuComposerSynth *CutSynthCode ( struct TuComposerSynth *SynthStr,
    struct TuComposerSynth *SynthBuf );
struct TuComposerSynth *CopySynthCode ( struct TuComposerSynth *SynthStr,
    struct TuComposerSynth *SynthBuf );
struct TuComposerSynth *PasteSynthCode ( struct TuComposerSynth *SynthBuf,
    struct TuComposerSynth *SynthStr );
ULONG SwapSynthCode ( struct TuComposerSynth *SynthBuf,
    struct TuComposerSynth *SynthStr );
ULONG AddSynthCodeLine ( struct TuComposerSynth *SynthStr,
    unsigned long Lines );
ULONG RemSynthCodeLine ( struct TuComposerSynth *SynthStr,
    unsigned long Lines );
ULONG InsertSynthCodeLine ( struct TuComposerSynth *SynthStr,
    unsigned long Line, unsigned long Lines, unsigned long Flags );
ULONG DeleteSynthCodeLine ( struct TuComposerSynth *SynthStr,
    unsigned long Line, unsigned long Lines, unsigned long Flags );
ULONG GetSynthCodeParams ( unsigned long Code );
STRPTR AssembleCodeLine ( STRPTR AsmBuf, struct TuComposerSynth *SynthStr,
    unsigned long CodeLine, unsigned long Flags );
ULONG DisassembleCodeLine ( STRPTR AsmBuf, struct TuComposerSynth *SynthStr,
    unsigned long CodeLine, unsigned long Flags );

/* Synth symbol support functions */

struct TuComposerSynthSymbolTable *AllocSymbol ( STRPTR Name );
ULONG FreeSymbol ( struct TuComposerSynthSymbolTable *SymbolStr );
ULONG AssignSymbol ( struct TuComposerSynthSymbolTable *SymbolStr,
    STRPTR Name );
struct TuComposerSynthSymbolTable *DupSymbol (
    struct TuComposerSynthSymbolTable *SymbolStr );
ULONG AddSymbol ( struct TuComposerSynth *SynthStr,
    struct TuComposerSynthSymbolTable *SymbolStr );
ULONG RemSymbol ( struct TuComposerSynth *SynthStr );
ULONG InsertSymbol ( struct TuComposerSynth *SynthStr,
    struct TuComposerSynthSymbolTable *SymbolStr,
    struct TuComposerSynthSymbolTable *SymbolPos );
ULONG DeleteSymbol ( struct TuComposerSynthSymbolTable *SymbolStr );
ULONG GetNumSymbols ( struct TuComposerSynth *SynthStr );
ULONG GetSymbolNum ( struct TuComposerSynth *SynthStr,
    struct TuComposerSynthSymbolTable *SymbolStr );
struct TuComposerSynthSymbolTable *GetSymbolAddr (
    struct TuComposerSynth *SynthStr, unsigned long SymbolNum );
struct TuComposerSynthSymbolTable *MatchSymbol (
    struct TuComposerSynthSymbolTable *SymbolStr, STRPTR Name,
    unsigned long Line, unsigned long Type );

/* External library support functions */

ULONG AddExternalLib ( struct TuComposerExtList *ExtLibStr,
    unsigned long Type );
struct TuComposerExtList *RemExternalLib ( struct TuComposerExtList
    *ExtLibStr );
struct TuComposerExtLibBase *OpenExternalLib ( struct TuComposerExtList
    *ExtLibStr );
struct TuComposerExtList *CloseExternalLib ( struct TuComposerExtList
    *ExtLibStr );
ULONG GetExternalLibs ( STRPTR ExtLibPatStr );
struct TuComposerExtFlagStr *AllocFlagStr ( struct TuComposerExtFlagStr
    *FlagStr );
struct TuComposerExtList *CIdentify ( STRPTR FileName );
struct CFHandle *COpen ( STRPTR FileName, unsigned long Mode,
    struct TuComposerExtList *ExtLibStr );
ULONG CClose ( struct CFHandle *CFHandle );
ULONG CRead ( struct CFHandle *CFHandle, APTR Buffer, unsigned long Length );
ULONG CWrite ( struct CFHandle *CFHandle, APTR Buffer,
    unsigned long Length );
ULONG CSeek ( struct CFHandle *CFHandle, unsigned long Position,
    unsigned long Relative );
ULONG CGetInfo ( struct CFHandle *CFHandle, struct CruncherInfo *CInfoStr );

#ifdef __cplusplus
}
#endif

#endif /* CLIB_TUCOMPOSER_PROTOS_H */
