#ifndef _INLINE_TUCOMPOSER_H
#define _INLINE_TUCOMPOSER_H

#ifndef __INLINE_MACROS_H
#include <inline/macros.h>
#endif

#ifndef TUCOMPOSER_BASE_NAME
#define TUCOMPOSER_BASE_NAME TuCBase
#endif

#define AllocPMem(byteSize) \
	LP1(0x1E, APTR, AllocPMem, unsigned long, byteSize, d0, \
	, TUCOMPOSER_BASE_NAME)

#define FreePMem(memoryBlock, byteSize) \
	LP2NR(0x24, FreePMem, APTR, memoryBlock, a1, unsigned long, byteSize, d0, \
	, TUCOMPOSER_BASE_NAME)

#define InitNodeList(NodeList) \
	LP1NR(0x2A, InitNodeList, struct List *, NodeList, a0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertNode(NodeList, Node, PredNode) \
	LP3NR(0x30, InsertNode, struct List *, NodeList, a0, struct Node *, Node, a1, struct Node *, PredNode, a2, \
	, TUCOMPOSER_BASE_NAME)

#define AddNodeHead(NodeList, Node) \
	LP2NR(0x36, AddNodeHead, struct List *, NodeList, a0, struct Node *, Node, a1, \
	, TUCOMPOSER_BASE_NAME)

#define AddNodeTail(NodeList, Node) \
	LP2NR(0x3C, AddNodeTail, struct List *, NodeList, a0, struct Node *, Node, a1, \
	, TUCOMPOSER_BASE_NAME)

#define RemoveNode(Node) \
	LP1NR(0x42, RemoveNode, struct Node *, Node, a1, \
	, TUCOMPOSER_BASE_NAME)

#define RemNodeHead(NodeList) \
	LP1NR(0x48, RemNodeHead, struct List *, NodeList, a0, \
	, TUCOMPOSER_BASE_NAME)

#define RemNodeTail(NodeList) \
	LP1NR(0x4E, RemNodeTail, struct List *, NodeList, a0, \
	, TUCOMPOSER_BASE_NAME)

#define EnqueueNode(NodeList, Node) \
	LP2NR(0x54, EnqueueNode, struct List *, NodeList, a0, struct Node *, Node, a1, \
	, TUCOMPOSER_BASE_NAME)

#define DupNodeList(SrcNodeList, DestNodeList, NodeSize) \
	LP3(0x5A, ULONG, DupNodeList, struct MinList *, SrcNodeList, a0, struct MinList *, DestNodeList, a1, unsigned long, NodeSize, d0, \
	, TUCOMPOSER_BASE_NAME)

#define ReMapNodeList(SrcNodeList, DestNodeList) \
	LP2NR(0x60, ReMapNodeList, struct List *, SrcNodeList, a0, struct List *, DestNodeList, a1, \
	, TUCOMPOSER_BASE_NAME)

#define AllocNameStr(CStr) \
	LP1(0x66, STRPTR, AllocNameStr, STRPTR, CStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeNameStr(NameStr) \
	LP1(0x6C, ULONG, FreeNameStr, STRPTR, NameStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define SetString(StructPos, CStr) \
	LP2(0x72, STRPTR, SetString, STRPTR *, StructPos, a0, STRPTR, CStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define SetNameStr(StructPos, NameStr) \
	LP2(0x78, STRPTR, SetNameStr, STRPTR *, StructPos, a0, STRPTR, NameStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define Sin(Degrees, Amplify) \
	LP2(0x7E, LONG, Sin, long, Degrees, d0, long, Amplify, d1, \
	, TUCOMPOSER_BASE_NAME)

#define Cos(Degrees, Amplify) \
	LP2(0x84, LONG, Cos, long, Degrees, d0, long, Amplify, d1, \
	, TUCOMPOSER_BASE_NAME)

#define Tan(Degrees, Amplify) \
	LP2(0x8A, LONG, Tan, long, Degrees, d0, long, Amplify, d1, \
	, TUCOMPOSER_BASE_NAME)

#define DoPlayerIRQ(TuCBase) \
	LP1NR(0x90, DoPlayerIRQ, struct TuComposerBase *, TuCBase, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AddPlayExecHandler(PlayExecStr) \
	LP1(0x96, struct PlayExecHandler *, AddPlayExecHandler, struct PlayExecHandler, PlayExecStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define RemPlayExecHandler(PlayExecStr) \
	LP1NR(0x9C, RemPlayExecHandler, struct PlayExecHandler *, PlayExecStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define SetPlayExecHandlerPri(PlayExecStr, Pri) \
	LP2NR(0xA2, SetPlayExecHandlerPri, struct PlayExecHandler *, PlayExecStr, a0, long, Pri, d0, \
	, TUCOMPOSER_BASE_NAME)

#define Stamp2Date(StampDateStr, DateStamp) \
	LP2NR(0xA8, Stamp2Date, struct StampDate *, StampDateStr, a0, struct DateStamp *, DateStamp, a1, \
	, TUCOMPOSER_BASE_NAME)

#define AllocSimulateMix(SongStr) \
	LP1(0xAE, struct TuComposerBase *, AllocSimulateMix, struct TuComposerSong *, SongStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeSimulateMix(PseudoTuCBase) \
	LP1NR(0xB4, FreeSimulateMix, struct TuComposerBase *, PseudoTuCBase, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AllocUnknownChunk(PreFillData, ChunkName, ChunkLen) \
	LP3(0xBA, struct UnknownChunk *, AllocUnknownChunk, APTR, PreFillData, a0, unsigned long, ChunkName, d0, unsigned long, ChunkLen, d1, \
	, TUCOMPOSER_BASE_NAME)

#define FreeUnknownChunk(UnknownChunkStr) \
	LP1NR(0xC0, FreeUnknownChunk, struct UnknownChunk *, UnknownChunkStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define DeleteUnknownChunk(UnknownChunkStr) \
	LP1NR(0xC6, DeleteUnknownChunk, struct UnknownChunk *, UnknownChunkStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define Randomize(Seed) \
	LP1(0xCC, ULONG, Randomize, unsigned long, Seed, d0, \
	, TUCOMPOSER_BASE_NAME)

#define Rnd(UpperBound) \
	LP1(0xD2, ULONG, Rnd, unsigned long, UpperBound, d0, \
	, TUCOMPOSER_BASE_NAME)

#define AllocSoundDevice(ExtLibStr, FlagPassStr) \
	LP2(0xD8, ULONG, AllocSoundDevice, struct TuComposerExtList *, ExtLibStr, a0, union FlagPass *, FlagPassStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define FreeSoundDevice(ExtLibStr) \
	LP1(0xDE, ULONG, FreeSoundDevice, struct TuComposerExtList *, ExtLibStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define PlaySoundDevice(ExtLibStr, MixAllocStr, FlagPassStr) \
	LP3(0xE4, ULONG, PlaySoundDevice, struct TuComposerExtList *, ExtLibStr, a0, struct MixerAllocStruct *, MixAllocStr, a1, union FlagPass *, FlagPassStr, a2, \
	, TUCOMPOSER_BASE_NAME)

#define StopSoundDevice(ExtLibStr) \
	LP1(0xEA, ULONG, StopSoundDevice, struct TuComposerExtList *, ExtLibStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define CheckSoundDeviceRate(ExtLibStr, SmpRate) \
	LP2(0xF0, ULONG, CheckSoundDeviceRate, struct TuComposerExtList *, ExtLibStr, a0, unsigned long, SmpRate, d0, \
	, TUCOMPOSER_BASE_NAME)

#define CheckSoundDeviceRateFraction(ExtLibStr, SmpRate) \
	LP2(0xF6, ULONG, CheckSoundDeviceRateFraction, struct TuComposerExtList, ExtLibStr, a0, unsigned long, SmpRate, d0, \
	, TUCOMPOSER_BASE_NAME)

#define UpdateSoundDeviceRate(ExtLibStr, SmpRate) \
	LP2NR(0xFC, UpdateSoundDeviceRate, struct TuComposerExtList *, ExtLibStr, a0, unsigned long, SmpRate, d0, \
	, TUCOMPOSER_BASE_NAME)

#define AllocMixer(ExtLibStr) \
	LP1(0x102, struct MixerAllocStruct *, AllocMixer, struct TuComposerExtList *, ExtLibStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeMixer(MixAllocStr) \
	LP1(0x108, ULONG, FreeMixer, struct MixerAllocStruct *, MixAllocStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define InitMixer(MixAllocStr, ExtSoundDevStr, FlagPassStr) \
	LP3(0x10E, ULONG, InitMixer, struct MixerAllocStruct *, MixAllocStr, a0, struct SoundDeviceInfo *, ExtSoundDevStr, a1, union FlagPass *, FlagPassStr, a2, \
	, TUCOMPOSER_BASE_NAME)

#define ChangeMixerRate(MixAllocStr, NewMixRate) \
	LP2(0x114, ULONG, ChangeMixerRate, struct MixerAllocStruct *, MixAllocStr, a0, unsigned long, NewMixRate, d0, \
	, TUCOMPOSER_BASE_NAME)

#define ChangeMixerTempo(MixAllocStr, NewTempo) \
	LP2(0x11A, ULONG, ChangeMixerTempo, struct MixerAllocStruct *, MixAllocStr, a0, unsigned long, NewTempo, d0, \
	, TUCOMPOSER_BASE_NAME)

#define ChangeMixerVolTable(MixAllocStr, Amplify, LeftVol, RightVol, NumChannels) \
	LP5(0x120, ULONG, ChangeMixerVolTable, struct MixerAllocStruct *, MixAllocStr, a0, unsigned long, Amplify, d0, unsigned long, LeftVol, d1, unsigned long, RightVol, d2, unsigned long, NumChannels, d3, \
	, TUCOMPOSER_BASE_NAME)

#define GetMixChannel(MixAllocStr, MixStr, Channel) \
	LP3NR(0x126, GetMixChannel, struct MixerAllocStruct *, MixAllocStr, a1, struct MixerStruct *, MixStr, a0, unsigned long, Channel, d0, \
	, TUCOMPOSER_BASE_NAME)

#define SetMixChannel(MixAllocStr, MixStr, Channel) \
	LP3NR(0x12C, SetMixChannel, struct MixerAllocStruct *, MixAllocStr, a1, struct MixerStruct *, MixStr, a0, unsigned long, Channel, d0, \
	, TUCOMPOSER_BASE_NAME)

#define SetMixChannelVolPanPitch(MixAllocStr, MixStr, Channel) \
	LP3NR(0x132, SetMixChannelVolPanPitch, struct MixerAllocStruct *, MixAllocStr, a1, struct MixerStruct *, MixStr, a0, unsigned long, Channel, d0, \
	, TUCOMPOSER_BASE_NAME)

#define SetMixChannelPosRepFlags(MixAllocStr, MixStr, Channel) \
	LP3NR(0x138, SetMixChannelPosRepFlags, struct MixerAllocStruct *, MixAllocStr, a1, struct MixerStruct *, MixStr, a0, unsigned long, Channel, d0, \
	, TUCOMPOSER_BASE_NAME)

#define DoMix(MixAllocStr, MixBuffer) \
	LP2NR(0x13E, DoMix, struct MixerAllocStruct *, MixAllocStr, a0, long *, MixBuffer, a1, \
	, TUCOMPOSER_BASE_NAME)

#define AllocPostProcessor(ExtLibStr, MixAllocStr) \
	LP2(0x144, struct PostProcAllocStruct *, AllocPostProcessor, struct TuComposerExtList *, ExtLibStr, a0, struct MixerAllocStruct *, MixAllocStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define FreePostProcessor(PostAllocStr) \
	LP1(0x14A, ULONG, FreePostProcessor, struct PostProcAllocStruct *, PostAllocStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define InitPostProcessor(PostAllocStr, MixAllocStr, FlagPassStr) \
	LP3(0x150, ULONG, InitPostProcessor, struct PostProcAllocStruct *, PostAllocStr, a0, struct MixerAllocStruct *, MixAllocStr, a1, union FlagPass *, FlagPassStr, a2, \
	, TUCOMPOSER_BASE_NAME)

#define ChangePostProcessor(PostAllocStr, MixAllocStr) \
	LP2(0x156, ULONG, ChangePostProcessor, struct PostProcAllocStruct *, PostAllocStr, a0, struct MixerAllocStruct *, MixAllocStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define DoPostProcessorMix(PostAllocStr, MixBuffer) \
	LP2NR(0x15C, DoPostProcessorMix, struct PostProcAllocStruct *, PostAllocStr, a0, long *, MixBuffer, a2, \
	, TUCOMPOSER_BASE_NAME)

#define AddPostProcessor(MixAllocStr, PostAllocStr) \
	LP2(0x162, struct PostProcAllocStruct *, AddPostProcessor, struct MixerAllocStruct, MixAllocStr, a0, struct PostProcAllocStruct *, PostAllocStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define RemPostProcessor(PostAllocStr) \
	LP1NR(0x168, RemPostProcessor, struct PostProcAllocStruct *, PostAllocStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define SetPostProcessorPri(PostAllocStr, Pri) \
	LP2NR(0x16E, SetPostProcessorPri, struct PostProcAllocStruct *, PostAllocStr, a0, long, Pri, d0, \
	, TUCOMPOSER_BASE_NAME)

#define AllocTCModule(Channels) \
	LP1(0x174, struct TuComposerModule *, AllocTCModule, unsigned long, Channels, d0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeTCModule(ModuleStr) \
	LP1(0x17A, ULONG, FreeTCModule, struct TuComposerModule *, ModuleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AddTCModule(ModuleStr) \
	LP1(0x180, ULONG, AddTCModule, struct TuComposerModule *, ModuleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define RemTCModule(ModuleStr) \
	LP1(0x186, ULONG, RemTCModule, struct TuComposerModule *, ModuleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define DupTCModule(ModuleStr) \
	LP1(0x18C, struct TuComposerModule *, DupTCModule, struct TuComposerModule *, ModuleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ReMapTCModule(ModuleStr, NewModuleStr) \
	LP2(0x192, ULONG, ReMapTCModule, struct TuComposerModule *, ModuleStr, a0, struct TuComposerModule *, NewModuleStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define LoadTCModule(CFHandle, ModuleStr, ExtLibStr, FlagPassStr, NumModule) \
	LP5(0x198, struct TuComposerModule *, LoadTCModule, struct CFHandle *, CFHandle, a0, struct TuComposerModule *, ModuleStr, a1, struct TuComposerExtList *, ExtLibStr, a2, union FlagPass *, FlagPassStr, a3, unsigned long, NumModule, d0, \
	, TUCOMPOSER_BASE_NAME)

#define SaveTCModule(CFHandle, ModuleStr, ExtLibStr, FlagPassStr) \
	LP4(0x19E, ULONG, SaveTCModule, struct CFHandle *, CFHandle, a0, struct TuComposerModule *, ModuleStr, a1, struct TuComposerExtList *, ExtLibStr, a2, union FlagPass *, FlagPassStr, a3, \
	, TUCOMPOSER_BASE_NAME)

#define IdentifyTCModule(CFHandle) \
	LP1(0x1A4, struct TuComposerExtList *, IdentifyTCModule, struct CFHandle *, CFHandle, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetTCModuleInfo(CFHandle, ExtLibStr, NumModule) \
	LP3(0x1AA, struct ModuleInfo *, GetTCModuleInfo, struct CFHandle *, CFHandle, a0, struct TuComposerExtList *, ExtLibStr, a1, unsigned long, NumModule, d0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeTCModuleInfo(ModuleInfoStr) \
	LP1(0x1B0, ULONG, FreeTCModuleInfo, struct ModuleInfo *, ModuleInfoStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetTCModules(CFHandle, ExtLibStr) \
	LP2(0x1B6, ULONG, GetTCModules, struct CFHandle *, CFHandle, a0, struct TuComposerExtList *, ExtLibStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define PushTCModule(ModuleStr) \
	LP1(0x1BC, struct TuComposerModule *, PushTCModule, struct TuComposerModule *, ModuleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define PopTCModule(ModuleBuf) \
	LP1(0x1C2, ULONG, PopTCModule, struct TuComposerModule *, ModuleBuf, a0, \
	, TUCOMPOSER_BASE_NAME)

#define CutTCModule(ModuleStr, ModuleBuf) \
	LP2(0x1C8, struct TuComposerModule *, CutTCModule, struct TuComposerModule *, ModuleStr, a0, struct TuComposerModule *, ModuleBuf, a1, \
	, TUCOMPOSER_BASE_NAME)

#define CopyTCModule(ModuleStr, ModuleBuf) \
	LP2(0x1CE, struct TuComposerModule *, CopyTCModule, struct TuComposerModule *, ModuleStr, a0, struct TuComposerModule *, ModuleBuf, a1, \
	, TUCOMPOSER_BASE_NAME)

#define PasteTCModule(ModuleBuf, ModuleStr) \
	LP2(0x1D4, struct TuComposerModule *, PasteTCModule, struct TuComposerModule *, ModuleBuf, a0, struct TuComposerModule *, ModuleStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define SwapTCModule(ModuleBuf, ModuleStr) \
	LP2(0x1DA, ULONG, SwapTCModule, struct TuComposerModule *, ModuleBuf, a0, struct TuComposerModule *, ModuleStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define ClearTCModule(ModuleStr) \
	LP1(0x1E0, ULONG, ClearTCModule, struct TuComposerModule *, ModuleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AddTCModuleUnknownChunk(ModuleStr, UnknownChunkStr) \
	LP2(0x1E6, ULONG, AddTCModuleUnknownChunk, struct TuComposerModule *, ModuleStr, a0, struct UnknownChunk *, UnknownChunkStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define RemTCModuleUnknownChunk(ModuleStr) \
	LP1(0x1EC, ULONG, RemTCModuleUnknownChunk, struct TuComposerModule *, ModuleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertTCModuleUnknownChunk(ModuleStr, UnknownChunkStr, UnknownChunkPos) \
	LP3(0x1F2, ULONG, InsertTCModuleUnknownChunk, struct TuComposerModule, ModuleStr, a0, struct UnknownChunk *, UnknownChunkStr, a1, struct UnknownChunk *, UnknownChunkPos, a2, \
	, TUCOMPOSER_BASE_NAME)

#define AllocPlayTCModule() \
	LP0(0x1F8, ULONG, AllocPlayTCModule, \
	, TUCOMPOSER_BASE_NAME)

#define FreePlayTCModule() \
	LP0NR(0x1FE, FreePlayTCModule, \
	, TUCOMPOSER_BASE_NAME)

#define PlayTCModule(FlagPassStr) \
	LP1(0x204, ULONG, PlayTCModule, union FlagPass *, FlagPassStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define StopTCModule() \
	LP0(0x20A, ULONG, StopTCModule, \
	, TUCOMPOSER_BASE_NAME)

#define SetTCMChannels(ModuleStr, Channels) \
	LP2(0x210, ULONG, SetTCMChannels, struct TuComposerModule *, ModuleStr, a0, unsigned long, Channels, d0, \
	, TUCOMPOSER_BASE_NAME)

#define CalcTCMPlayTime(ModuleStr, PlayExecStr) \
	LP2(0x216, ULONG, CalcTCMPlayTime, struct TuComposerModule *, ModuleStr, a0, struct PlayExecHandler *, PlayExecStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define GetOptimalVChannels(ModuleStr) \
	LP1(0x21C, ULONG, GetOptimalVChannels, struct TuComposerModule *, ModuleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AllocSong(Channels, GoSubStack, LoopStack) \
	LP3(0x222, struct TuComposerSong *, AllocSong, unsigned long, Channels, d0, unsigned long, GoSubStack, d1, unsigned long, LoopStack, d2, \
	, TUCOMPOSER_BASE_NAME)

#define FreeSong(SongStr) \
	LP1(0x228, ULONG, FreeSong, struct TuComposerSong *, SongStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AddSong(ModuleStr, SongStr) \
	LP2(0x22E, ULONG, AddSong, struct TuComposerModule *, ModuleStr, a0, struct TuComposerSong *, SongStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define RemSong(ModuleStr) \
	LP1(0x234, ULONG, RemSong, struct TuComposerModule *, ModuleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertSong(ModuleStr, SongStr, SongPos) \
	LP3(0x23A, ULONG, InsertSong, struct TuComposerModule *, ModuleStr, a0, struct TuComposerSong *, SongStr, a1, struct TuComposerSong *, SongPos, a2, \
	, TUCOMPOSER_BASE_NAME)

#define DeleteSong(SongStr) \
	LP1(0x240, ULONG, DeleteSong, struct TuComposerSong *, SongStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define DupSong(SongStr) \
	LP1(0x246, struct TuComposerSong *, DupSong, struct TuComposerSong *, SongStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ReMapSong(SongStr, NewSongStr) \
	LP2(0x24C, ULONG, ReMapSong, struct TuComposerSong *, SongStr, a0, struct TuComposerSong *, NewSongStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define GetNumSongs(ModuleStr) \
	LP1(0x252, ULONG, GetNumSongs, struct TuComposerModule *, ModuleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetSongNum(ModuleStr, SongStr) \
	LP2(0x258, ULONG, GetSongNum, struct TuComposerModule *, ModuleStr, a0, struct TuComposerSong *, SongStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define GetSongAddr(ModuleStr, Num) \
	LP2(0x25E, struct TuComposerSong *, GetSongAddr, struct TuComposerModule *, ModuleStr, a0, unsigned long, Num, d0, \
	, TUCOMPOSER_BASE_NAME)

#define LoadSong(CFHandle, SongStr, ExtLibStr, FlagPassStr, NumSong) \
	LP5(0x264, struct TuComposerSong *, LoadSong, struct CFHandle *, CFHandle, a0, struct TuComposerSong *, SongStr, a1, struct TuComposerExtList *, ExtLibStr, a2, union FlagPass *, FlagPassStr, a3, unsigned long, NumSong, d0, \
	, TUCOMPOSER_BASE_NAME)

#define SaveSong(CFHandle, SongStr, ExtLibStr, FlagPassStr) \
	LP4(0x26A, ULONG, SaveSong, struct CFHandle *, CFHandle, a0, struct TuComposerSong *, SongStr, a1, struct TuComposerExtList *, ExtLibStr, a2, union FlagPass *, FlagPassStr, a3, \
	, TUCOMPOSER_BASE_NAME)

#define IdentifySong(CFHandle) \
	LP1(0x270, struct TuComposerExtList *, IdentifySong, struct CFHandle *, CFHandle, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetSongInfo(CFHandle, ExtLibStr, NumSong) \
	LP3(0x276, struct SongInfo *, GetSongInfo, struct CFHandle *, CFHandle, a0, struct TuComposerExtList *, ExtLibStr, a1, unsigned long, NumSong, d0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeSongInfo(SongInfoStr) \
	LP1(0x27C, ULONG, FreeSongInfo, struct SongInfo *, SongInfoStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetSongs(CFHandle, ExtLibStr) \
	LP2(0x282, ULONG, GetSongs, struct CFHandle *, CFHandle, a0, struct TuComposerExtList *, ExtLibStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define PushSong(SongStr) \
	LP1(0x288, struct TuComposerSong *, PushSong, struct TuComposerSong *, SongStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define PopSong(SongBuf) \
	LP1(0x28E, ULONG, PopSong, struct TuComposerSong *, SongBuf, a0, \
	, TUCOMPOSER_BASE_NAME)

#define CutSong(SongStr, SongBuf) \
	LP2(0x294, struct TuComposerSong *, CutSong, struct TuComposerSong *, SongStr, a0, struct TuComposerSong *, SongBuf, a1, \
	, TUCOMPOSER_BASE_NAME)

#define CopySong(SongStr, SongBuf) \
	LP2(0x29A, struct TuComposerSong *, CopySong, struct TuComposerSong *, SongStr, a0, struct TuComposerSong *, SongBuf, a1, \
	, TUCOMPOSER_BASE_NAME)

#define PasteSong(SongBuf, SongStr) \
	LP2(0x2A0, struct TuComposerSong *, PasteSong, struct TuComposerSong *, SongBuf, a0, struct TuComposerSong *, SongStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define SwapSong(SongBuf, SongStr) \
	LP2(0x2A6, ULONG, SwapSong, struct TuComposerSong *, SongBuf, a0, struct TuComposerSong *, SongStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define ClearSong(SongStr) \
	LP1(0x2AC, ULONG, ClearSong, struct TuComposerSong *, SongStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AddSongUnknownChunk(SongStr, UnknownChunkStr) \
	LP2(0x2B2, ULONG, AddSongUnknownChunk, struct TuComposerSong *, SongStr, a0, struct UnknownChunk *, UnknownChunkStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define RemSongUnknownChunk(SongStr) \
	LP1(0x2B8, ULONG, RemSongUnknownChunk, struct TuComposerSong *, SongStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertSongUnknownChunk(SongStr, UnknownChunkStr, UnknownChunkPos) \
	LP3(0x2BE, ULONG, InsertSongUnknownChunk, struct TuComposerSong *, SongStr, a0, struct UnknownChunk *, UnknownChunkStr, a1, struct UnknownChunk *, UnknownChunkPos, a2, \
	, TUCOMPOSER_BASE_NAME)

#define GetSongInstrs(SongStr) \
	LP1(0x2C4, struct TuComposerInstr **, GetSongInstrs, struct TuComposerSong *, SongStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeSongInstrs(InstrList) \
	LP1(0x2CA, ULONG, FreeSongInstrs, struct TuComposerInstr **, InstrList, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetSongEnvelopes(SongStr) \
	LP1(0x2D0, struct TuComposerInstrEnvelope **, GetSongEnvelopes, struct TuComposerSong *, SongStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeSongEnvelopes(EnvList) \
	LP1(0x2D6, ULONG, FreeSongEnvelopes, struct TuComposerInstrEnvelope **, EnvList, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetSongKeyboards(SongStr) \
	LP1(0x2DC, struct TuComposerInstrKeyboard **, GetSongKeyboards, struct TuComposerSong *, SongStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeSongKeyboards(KeybrdList) \
	LP1(0x2E2, ULONG, FreeSongKeyboards, struct TuComposerInstrKeyboard **, KeybrdList, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetSongArpeggios(SongStr) \
	LP1(0x2E8, struct TuComposerInstrArpeggio **, GetSongArpeggios, struct TuComposerSong *, SongStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeSongArpeggios(ArpList) \
	LP1(0x2EE, ULONG, FreeSongArpeggios, struct TuComposerInstrArpeggio **, ArpList, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ReMapSongInstrs(SongStr, TrackStr, InstrList) \
	LP3(0x2F4, struct TuComposerTrack *, ReMapSongInstrs, struct TuComposerSong *, SongStr, a0, struct TuComposerTrack *, TrackStr, a1, struct TuComposerInstr **, InstrList, a2, \
	, TUCOMPOSER_BASE_NAME)

#define SetBaseSongInstrs(SongStr, TrackStr, FirstInsNum) \
	LP3(0x2FA, ULONG, SetBaseSongInstrs, struct TuComposerSong *, SongStr, a0, struct TuComposerTrack *, TrackStr, a1, unsigned long, FirstInsNum, d0, \
	, TUCOMPOSER_BASE_NAME)

#define SetSongChannels(SongStr, Channels) \
	LP2(0x300, ULONG, SetSongChannels, struct TuComposerSong *, SongStr, a0, unsigned long, Channels, d0, \
	, TUCOMPOSER_BASE_NAME)

#define SetStack(SongStr, GoSubStack, LoopStack) \
	LP3(0x306, ULONG, SetStack, struct TuComposerSong *, SongStr, a0, unsigned long, GoSubStack, d0, unsigned long, LoopStack, d1, \
	, TUCOMPOSER_BASE_NAME)

#define CalcSongPlayTime(SongStr, PlayExecStr) \
	LP2(0x30C, ULONG, CalcSongPlayTime, struct TuComposerSong *, SongStr, a0, struct PlayExecHandler *, PlayExecStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define GetOptimalChannels(SongStr) \
	LP1(0x312, ULONG, GetOptimalChannels, struct TuComposerSong *, SongStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ResetSong(SongStr) \
	LP1(0x318, ULONG, ResetSong, struct TuComposerSong *, SongStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define CalcPlayerSpeed(SongStr) \
	LP1(0x31E, ULONG, CalcPlayerSpeed, struct TuComposerSong *, SongStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AllocPosition(Channels) \
	LP1(0x324, struct TuComposerOrders *, AllocPosition, unsigned long, Channels, d0, \
	, TUCOMPOSER_BASE_NAME)

#define FreePosition(PosStr, Channels) \
	LP2(0x32A, ULONG, FreePosition, struct TuComposerOrders *, PosStr, a0, unsigned long, Channels, d0, \
	, TUCOMPOSER_BASE_NAME)

#define SwapPosition(PosStr, Channel, SwapChannel) \
	LP3(0x330, ULONG, SwapPosition, struct TuComposerOrders *, PosStr, a0, unsigned long, Channel, d0, unsigned long, SwapChannel, d1, \
	, TUCOMPOSER_BASE_NAME)

#define SetPosition(SongStr, PosStr) \
	LP2(0x336, ULONG, SetPosition, struct TuComposerSong *, SongStr, a0, struct TuComposerOrders *, PosStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define DupPosition(PosStr, Channels) \
	LP2(0x33C, struct TuComposerOrders *, DupPosition, struct TuComposerOrders *, PosStr, a0, unsigned long, Channels, d0, \
	, TUCOMPOSER_BASE_NAME)

#define GetPositionNum(PosStr, PosListStr, Channel) \
	LP3(0x342, ULONG, GetPositionNum, struct TuComposerOrders *, PosStr, a0, struct TuComposerOrderList *, PosListStr, a1, unsigned long, Channel, d0, \
	, TUCOMPOSER_BASE_NAME)

#define GetPositionAddr(PosStr, Channel, Num) \
	LP3(0x348, struct TuComposerOrderList *, GetPositionAddr, struct TuComposerOrders, PosStr, a0, unsigned long, Channel, d0, unsigned long, Num, d1, \
	, TUCOMPOSER_BASE_NAME)

#define ClearPosition(PosStr, Channels) \
	LP2(0x34E, ULONG, ClearPosition, struct TuComposerOrders *, PosStr, a0, unsigned long, Channels, d0, \
	, TUCOMPOSER_BASE_NAME)

#define PlayPosition(PosStr, FlagPassStr, Order, Row) \
	LP4(0x354, ULONG, PlayPosition, struct TuComposerOrders *, PosStr, a0, union FlagPass *, FlagPassStr, a1, unsigned long, Order, d0, unsigned long, Row, d1, \
	, TUCOMPOSER_BASE_NAME)

#define DupPositionChannel(SrcPosStr, DestPosStr, SrcChannel, DestChannel) \
	LP4(0x35A, ULONG, DupPositionChannel, struct TuComposerOrders *, SrcPosStr, a0, struct TuComposerOrders *, DestPosStr, a1, unsigned long, SrcChannel, d0, unsigned long, DestChannel, d1, \
	, TUCOMPOSER_BASE_NAME)

#define ClearPositionChannel(PosStr, Channel) \
	LP2(0x360, ULONG, ClearPositionChannel, struct TuComposerOrders *, PosStr, a0, unsigned long, Channel, d0, \
	, TUCOMPOSER_BASE_NAME)

#define AllocPositionList() \
	LP0(0x366, struct TuComposerOrderList *, AllocPositionList, \
	, TUCOMPOSER_BASE_NAME)

#define FreePositionList(PosListStr) \
	LP1(0x36C, ULONG, FreePositionList, struct TuComposerOrderList *, PosListStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AddPositionList(PosStr, PosListStr, Channel) \
	LP3(0x372, ULONG, AddPositionList, struct TuComposerOrders *, PosStr, a0, struct TuComposerOrderList *, PosListStr, a1, unsigned long, Channel, d0, \
	, TUCOMPOSER_BASE_NAME)

#define RemPositionList(PosStr, Channel) \
	LP2(0x378, ULONG, RemPositionList, struct TuComposerOrders *, PosStr, a0, unsigned long, Channel, d0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertPositionList(PosStr, PosListStr, PosListPos, Channel) \
	LP4(0x37E, ULONG, InsertPositionList, struct TuComposerOrders *, PosStr, a0, struct TuComposerOrderList *, PosListStr, a1, struct TuComposerOrderList *, PosListPos, a2, unsigned long, Channel, d0, \
	, TUCOMPOSER_BASE_NAME)

#define DeletePositionList(PosListStr) \
	LP1(0x384, ULONG, DeletePositionList, struct TuComposerOrderList *, PosListStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define DupPositionList(PosListStr) \
	LP1(0x38A, struct TuComposerOrderList *, DupPositionList, struct TuComposerOrderList, PosListStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define SwapPositionList(PosListStr, SwapPosListStr) \
	LP2(0x390, ULONG, SwapPositionList, struct TuComposerOrderList *, PosListStr, a0, struct TuComposerOrderList *, SwapPosListStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define ClearPositionList(PosListStr) \
	LP1(0x396, ULONG, ClearPositionList, struct TuComposerOrderList *, PosListStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AllocTrack(DefLength) \
	LP1(0x39C, struct TuComposerTrack *, AllocTrack, unsigned long, DefLength, d0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeTrack(TrackStr) \
	LP1(0x3A2, ULONG, FreeTrack, struct TuComposerTrack *, TrackStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AddTrack(SongStr, TrackStr) \
	LP2(0x3A8, ULONG, AddTrack, struct TuComposerSong *, SongStr, a0, struct TuComposerTrack *, TrackStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define RemTrack(SongStr) \
	LP1(0x3AE, ULONG, RemTrack, struct TuComposerSong *, SongStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertTrack(SongStr, TrackStr, TrackPos) \
	LP3(0x3B4, ULONG, InsertTrack, struct TuComposerSong *, SongStr, a0, struct TuComposerTrack *, TrackStr, a1, struct TuComposerTrack *, TrackPos, a2, \
	, TUCOMPOSER_BASE_NAME)

#define DeleteTrack(TrackStr) \
	LP1(0x3BA, ULONG, DeleteTrack, struct TuComposerTrack *, TrackStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ClearTrack(TrackStr) \
	LP1(0x3C0, ULONG, ClearTrack, struct TuComposerTrack *, TrackStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define DupTrack(TrackStr) \
	LP1(0x3C6, struct TuComposerTrack *, DupTrack, struct TuComposerTrack *, TrackStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ReMapTrack(SongStr, TrackStr, NewTrackStr) \
	LP3(0x3CC, ULONG, ReMapTrack, struct TuComposerSong *, SongStr, a0, struct TuComposerTrack *, TrackStr, a1, struct TuComposerTrack *, NewTrackStr, a2, \
	, TUCOMPOSER_BASE_NAME)

#define ReSizeTrack(TrackStr, NewLen) \
	LP2(0x3D2, ULONG, ReSizeTrack, struct TuComposerTrack *, TrackStr, a0, unsigned long, NewLen, d0, \
	, TUCOMPOSER_BASE_NAME)

#define AddTrackUnknownChunk(TrackStr, UnknownChunkStr) \
	LP2(0x3D8, ULONG, AddTrackUnknownChunk, struct TuComposerTrack *, TrackStr, a0, struct UnknownChunk *, UnknownChunkStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define RemTrackUnknownChunk(TrackStr) \
	LP1(0x3DE, ULONG, RemTrackUnknownChunk, struct TuComposerTrack *, TrackStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertTrackUnknownChunk(TrackStr, UnknownChunkStr, UnknownChunkPos) \
	LP3(0x3E4, ULONG, InsertTrackUnknownChunk, struct TuComposerTrack *, TrackStr, a0, struct UnknownChunk *, UnknownChunkStr, a1, struct UnknownChunk *, UnknownChunkPos, a2, \
	, TUCOMPOSER_BASE_NAME)

#define GetNumTracks(SongStr) \
	LP1(0x3EA, ULONG, GetNumTracks, struct TuComposerSong *, SongStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetTrackNum(SongStr, TrackStr) \
	LP2(0x3F0, ULONG, GetTrackNum, struct TuComposerSong *, SongStr, a0, struct TuComposerTrack *, TrackStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define GetTrackAddr(SongStr, Num) \
	LP2(0x3F6, struct TuComposerTrack *, GetTrackAddr, struct TuComposerSong *, SongStr, a0, unsigned long, Num, d0, \
	, TUCOMPOSER_BASE_NAME)

#define GetNoteStr(StrBuf, Octave, Note, Flags) \
	LP4NR(0x3FC, GetNoteStr, STRPTR, StrBuf, a0, unsigned long, Octave, d0, unsigned long, Note, d1, unsigned long, Flags, d2, \
	, TUCOMPOSER_BASE_NAME)

#define GetIndexNoteStr(StrBuf, IndexNote, Flags) \
	LP3NR(0x402, GetIndexNoteStr, STRPTR, StrBuf, a0, unsigned long, IndexNote, d0, unsigned long, Flags, d1, \
	, TUCOMPOSER_BASE_NAME)

#define NoteToIndex(Octave, Note) \
	LP2(0x408, ULONG, NoteToIndex, unsigned long, Octave, d0, unsigned long, Note, d1, \
	, TUCOMPOSER_BASE_NAME)

#define IndexToNote(IndexNote) \
	LP1(0x40E, ULONG, IndexToNote, unsigned long, IndexNote, d0, \
	, TUCOMPOSER_BASE_NAME)

#define GetTrackRowStr(TrackStr, StrBuf, EffStr, Row, Flags, SpcChar) \
	LP6(0x414, ULONG, GetTrackRowStr, struct TuComposerTrack *, TrackStr, a0, STRPTR, StrBuf, a1, struct TuComposerTrackEffect *, EffStr, a2, unsigned long, Row, d0, unsigned long, Flags, d1, unsigned long, SpcChar, d2, \
	, TUCOMPOSER_BASE_NAME)

#define AllocEffect(EffectByte, DataWord) \
	LP2(0x41A, struct TuComposerTrackEffect *, AllocEffect, unsigned long, EffectByte, d0, unsigned long, DataWord, d1, \
	, TUCOMPOSER_BASE_NAME)

#define FreeEffect(EffStr) \
	LP1(0x420, ULONG, FreeEffect, struct TuComposerTrackEffect *, EffStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AddEffect(TrackStr, EffStr, Row) \
	LP3(0x426, ULONG, AddEffect, struct TuComposerTrack *, TrackStr, a0, struct TuComposerTrackEffect *, EffStr, a1, unsigned long, Row, d0, \
	, TUCOMPOSER_BASE_NAME)

#define RemEffect(TrackStr, Row) \
	LP2(0x42C, ULONG, RemEffect, struct TuComposerTrack *, TrackStr, a0, unsigned long, Row, d0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertEffect(TrackStr, EffStr, EffPos, Row) \
	LP4(0x432, ULONG, InsertEffect, struct TuComposerTrack *, TrackStr, a0, struct TuComposerTrackEffect *, EffStr, a1, struct TuComposerTrackEffect *, EffPos, a2, unsigned long, Row, d0, \
	, TUCOMPOSER_BASE_NAME)

#define DeleteEffect(EffStr) \
	LP1(0x438, ULONG, DeleteEffect, struct TuComposerTrackEffect *, EffStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ClearEffects(TrackStr, Row, NumRows) \
	LP3(0x43E, ULONG, ClearEffects, struct TuComposerTrack *, TrackStr, a0, unsigned long, Row, d0, unsigned long, NumRows, d1, \
	, TUCOMPOSER_BASE_NAME)

#define ReMapEffects(SrcTrackStr, DestTrackStr, SrcRow, DestRow, NumRows) \
	LP5(0x444, ULONG, ReMapEffects, struct TuComposerTrack *, SrcTrackStr, a0, struct TuComposerTrack *, DestTrackStr, a1, unsigned long, SrcRow, d0, unsigned long, DestRow, d1, unsigned long, NumRows, d2, \
	, TUCOMPOSER_BASE_NAME)

#define AllocTrackData(Length) \
	LP1(0x44A, struct TuComposerTrackData *, AllocTrackData, unsigned long, Length, d0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeTrackData(TrackData, Length) \
	LP2(0x450, ULONG, FreeTrackData, struct TuComposerTrackData *, TrackData, a0, unsigned long, Length, d0, \
	, TUCOMPOSER_BASE_NAME)

#define AddRows(TrackStr, NumRows) \
	LP2(0x456, ULONG, AddRows, struct TuComposerTrack *, TrackStr, a0, unsigned long, NumRows, d0, \
	, TUCOMPOSER_BASE_NAME)

#define RemRows(TrackStr, NumRows) \
	LP2(0x45C, ULONG, RemRows, struct TuComposerTrack *, TrackStr, a0, unsigned long, NumRows, d0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertRows(TrackStr, Row, NumRows, Flags) \
	LP4(0x462, ULONG, InsertRows, struct TuComposerTrack *, TrackStr, a0, unsigned long, Row, d0, unsigned long, NumRows, d1, unsigned long, Flags, d2, \
	, TUCOMPOSER_BASE_NAME)

#define DeleteRows(TrackStr, Row, NumRows, Flags) \
	LP4(0x468, ULONG, DeleteRows, struct TuComposerTrack *, TrackStr, a0, unsigned long, Row, d0, unsigned long, NumRows, d1, unsigned long, Flags, d2, \
	, TUCOMPOSER_BASE_NAME)

#define ClearRows(TrackStr, Row, NumRows) \
	LP3(0x46E, ULONG, ClearRows, struct TuComposerTrack *, TrackStr, a0, unsigned long, Row, d0, unsigned long, NumRows, d1, \
	, TUCOMPOSER_BASE_NAME)

#define ReMapRows(SrcTrackStr, DestTrackStr, SrcRow, DestRow, NumRows) \
	LP5(0x474, ULONG, ReMapRows, struct TuComposerTrack *, SrcTrackStr, a0, struct TuComposerTrack *, DestTrackStr, a1, unsigned long, SrcRow, d0, unsigned long, DestRow, d1, unsigned long, NumRows, d2, \
	, TUCOMPOSER_BASE_NAME)

#define CopyRows(SrcTrackStr, DestTrackStr, SrcRow, DestRow, NumRows) \
	LP5(0x47A, ULONG, CopyRows, struct TuComposerTrack *, SrcTrackStr, a0, struct TuComposerTrack *, DestTrackStr, a1, unsigned long, SrcRow, d0, unsigned long, DestRow, d1, unsigned long, NumRows, d2, \
	, TUCOMPOSER_BASE_NAME)

#define SwapRows(SrcTrackStr, DestTrackStr, SrcRow, DestRow, NumRows) \
	LP5(0x480, ULONG, SwapRows, struct TuComposerTrack *, SrcTrackStr, a0, struct TuComposerTrack *, DestTrackStr, a1, unsigned long, SrcRow, d0, unsigned long, DestRow, d1, unsigned long, NumRows, d2, \
	, TUCOMPOSER_BASE_NAME)

#define PlayRow(TrackStr, FlagPassStr, Row, Channel) \
	LP4(0x486, ULONG, PlayRow, struct TuComposerTrack *, TrackStr, a0, union FlagPass *, FlagPassStr, a1, unsigned long, Row, d0, unsigned long, Channel, d1, \
	, TUCOMPOSER_BASE_NAME)

#define CmpTracks(SrcTrackStr, DestTrackStr) \
	LP2(0x48C, LONG, CmpTracks, struct TuComposerTrack *, SrcTrackStr, a0, struct TuComposerTrack *, DestTrackStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define PackTrack(TrackStr) \
	LP1(0x492, struct TuComposerPacked *, PackTrack, struct TuComposerTrack *, TrackStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define UnPackTrack(PackedTrackStr, TrackStr) \
	LP2(0x498, struct TuComposerTrack *, UnPackTrack, struct TuComposerPacked *, PackedTrackStr, a0, struct TuComposerTrack *, TrackStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define FreePackedTrack(PackedTrackStr) \
	LP1NR(0x49E, FreePackedTrack, struct TuComposerPacked *, PackedTrackStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define LoadTrack(CFHandle, TrackStr, ExtLibStr, FlagPassStr, NumTrack) \
	LP5(0x4A4, struct TuComposerTrack *, LoadTrack, struct CFHandle *, CFHandle, a0, struct TuComposerTrack *, TrackStr, a1, struct TuComposerExtList *, ExtLibStr, a2, union FlagPass *, FlagPassStr, a3, unsigned long, NumTrack, d0, \
	, TUCOMPOSER_BASE_NAME)

#define SaveTrack(CFHandle, TrackStr, ExtLibStr, FlagPassStr) \
	LP4(0x4AA, ULONG, SaveTrack, struct CFHandle *, CFHandle, a0, struct TuComposerTrack *, TrackStr, a1, struct TuComposerExtList *, ExtLibStr, a2, union FlagPass *, FlagPassStr, a3, \
	, TUCOMPOSER_BASE_NAME)

#define IdentifyTrack(CFHandle) \
	LP1(0x4B0, struct TuComposerExtList *, IdentifyTrack, struct CFHandle *, CFHandle, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetTrackInfo(CFHandle, ExtLibStr, NumTrack) \
	LP3(0x4B6, struct TrackInfo *, GetTrackInfo, struct CFHandle *, CFHandle, a0, struct TuComposerExtList *, ExtLibStr, a1, unsigned long, NumTrack, d0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeTrackInfo(TrackInfoStr) \
	LP1(0x4BC, ULONG, FreeTrackInfo, struct TrackInfo *, TrackInfoStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetTracks(CFHandle, ExtLibStr) \
	LP2(0x4C2, ULONG, GetTracks, struct CFHandle *, CFHandle, a0, struct TuComposerExtList *, ExtLibStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define PushTrack(TrackStr) \
	LP1(0x4C8, struct TuComposerTrack *, PushTrack, struct TuComposerTrack *, TrackStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define PopTrack(TrackBuf) \
	LP1(0x4CE, ULONG, PopTrack, struct TuComposerTrack *, TrackBuf, a0, \
	, TUCOMPOSER_BASE_NAME)

#define CutTrack(TrackStr, TrackBuf) \
	LP2(0x4D4, struct TuComposerTrack *, CutTrack, struct TuComposerTrack *, TrackStr, a0, struct TuComposerTrack *, TrackBuf, a1, \
	, TUCOMPOSER_BASE_NAME)

#define CopyTrack(TrackStr, TrackBuf) \
	LP2(0x4DA, struct TuComposerTrack *, CopyTrack, struct TuComposerTrack *, TrackStr, a0, struct TuComposerTrack *, TrackBuf, a1, \
	, TUCOMPOSER_BASE_NAME)

#define PasteTrack(TrackBuf, TrackStr) \
	LP2(0x4E0, struct TuComposerTrack *, PasteTrack, struct TuComposerTrack *, TrackBuf, a0, struct TuComposerTrack *, TrackStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define SwapTrack(TrackBuf, TrackStr) \
	LP2(0x4E6, ULONG, SwapTrack, struct TuComposerTrack *, TrackBuf, a0, struct TuComposerTrack *, TrackStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define SwapTrackInSong(TrackBuf, TrackStr, Flags) \
	LP3(0x4EC, ULONG, SwapTrackInSong, struct TuComposerTrack *, TrackBuf, a0, struct TuComposerTrack *, TrackStr, a1, unsigned long, Flags, d0, \
	, TUCOMPOSER_BASE_NAME)

#define ShrinkTrack(TrackStr, Scale) \
	LP2(0x4F2, ULONG, ShrinkTrack, struct TuComposerTrack *, TrackStr, a0, unsigned long, Scale, d0, \
	, TUCOMPOSER_BASE_NAME)

#define ExpandTrack(TrackStr, Scale) \
	LP2(0x4F8, ULONG, ExpandTrack, struct TuComposerTrack *, TrackStr, a0, unsigned long, Scale, d0, \
	, TUCOMPOSER_BASE_NAME)

#define HalveTrack(TrackStr, Scale) \
	LP2(0x4FE, ULONG, HalveTrack, struct TuComposerTrack *, TrackStr, a0, unsigned long, Scale, d0, \
	, TUCOMPOSER_BASE_NAME)

#define DoubleTrack(TrackStr, Scale) \
	LP2(0x504, ULONG, DoubleTrack, struct TuComposerTrack *, TrackStr, a0, unsigned long, Scale, d0, \
	, TUCOMPOSER_BASE_NAME)

#define SplitTrack(SrcTrackStr, DestTrackStr, Row) \
	LP3(0x50A, struct TuComposerTrack *, SplitTrack, struct TuComposerTrack *, SrcTrackStr, a0, struct TuComposerTrack *, DestTrackStr, a1, unsigned long, Row, d0, \
	, TUCOMPOSER_BASE_NAME)

#define JoinTrack(SrcTrackStr, DestTrackStr) \
	LP2(0x510, ULONG, JoinTrack, struct TuComposerTrack *, SrcTrackStr, a0, struct TuComposerTrack *, DestTrackStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define PlayTrack(FlagPassStr, Order, Channel, Row) \
	LP4(0x516, ULONG, PlayTrack, union FlagPass *, FlagPassStr, a0, unsigned long, Order, d0, unsigned long, Channel, d1, unsigned long, Row, d2, \
	, TUCOMPOSER_BASE_NAME)

#define TrackNoteShift(TrackStr, HalfNotes, StartRow, EndRow) \
	LP4(0x51C, ULONG, TrackNoteShift, struct TuComposerTrack *, TrackStr, a0, long, HalfNotes, d0, unsigned long, StartRow, d1, unsigned long, EndRow, d2, \
	, TUCOMPOSER_BASE_NAME)

#define ScrollTrack(TrackStr, Rows, StartRow, EndRow) \
	LP4(0x522, ULONG, ScrollTrack, struct TuComposerTrack *, TrackStr, a0, long, Rows, d0, unsigned long, StartRow, d1, unsigned long, EndRow, d2, \
	, TUCOMPOSER_BASE_NAME)

#define RotateTrack(TrackStr, Rows, StartRow, EndRow) \
	LP4(0x528, ULONG, RotateTrack, struct TuComposerTrack *, TrackStr, a0, long, Rows, d0, unsigned long, StartRow, d1, unsigned long, EndRow, d2, \
	, TUCOMPOSER_BASE_NAME)

#define FlipTrack(TrackStr, Scale, StartRow, EndRow) \
	LP4(0x52E, ULONG, FlipTrack, struct TuComposerTrack *, TrackStr, a0, unsigned long, Scale, d0, unsigned long, StartRow, d1, unsigned long, EndRow, d2, \
	, TUCOMPOSER_BASE_NAME)

#define AllocInstr(NumSamples) \
	LP1(0x534, struct TuComposerInstr *, AllocInstr, unsigned long, NumSamples, d0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeInstr(InstrStr) \
	LP1(0x53A, ULONG, FreeInstr, struct TuComposerInstr *, InstrStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AddInstr(ModuleStr, InstrStr) \
	LP2(0x540, ULONG, AddInstr, struct TuComposerModule *, ModuleStr, a0, struct TuComposerInstr *, InstrStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define RemInstr(ModuleStr) \
	LP1(0x546, ULONG, RemInstr, struct TuComposerModule *, ModuleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertInstr(ModuleStr, InstrStr, InstrPos) \
	LP3(0x54C, ULONG, InsertInstr, struct TuComposerModule *, ModuleStr, a0, struct TuComposerInstr *, InstrStr, a1, struct TuComposerInstr *, InstrPos, a2, \
	, TUCOMPOSER_BASE_NAME)

#define DeleteInstr(InstrStr) \
	LP1(0x552, ULONG, DeleteInstr, struct TuComposerInstr *, InstrStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ClearInstr(InstrStr) \
	LP1(0x558, ULONG, ClearInstr, struct TuComposerInstr *, InstrStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define DupInstr(InstrStr) \
	LP1(0x55E, struct TuComposerInstr *, DupInstr, struct TuComposerInstr *, InstrStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ReMapInstr(InstrStr, NewInstrStr) \
	LP2(0x564, ULONG, ReMapInstr, struct TuComposerInstr *, InstrStr, a0, struct TuComposerInstr *, NewInstrStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define AddInstrUnknownChunk(InstrStr, UnknownChunkStr) \
	LP2(0x56A, ULONG, AddInstrUnknownChunk, struct TuComposerInstr *, InstrStr, a0, struct UnknownChunk *, UnknownChunkStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define RemInstrUnknownChunk(InstrStr) \
	LP1(0x570, ULONG, RemInstrUnknownChunk, struct TuComposerInstr *, InstrStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertInstrUnknownChunk(InstrStr, UnknownChunkStr, UnknownChunkPos) \
	LP3(0x576, ULONG, InsertInstrUnknownChunk, struct TuComposerInstr *, InstrStr, a0, struct UnknownChunk *, UnknownChunkStr, a1, struct UnknownChunk *, UnknownChunkPos, a2, \
	, TUCOMPOSER_BASE_NAME)

#define GetNumInstrs(ModuleStr) \
	LP1(0x57C, ULONG, GetNumInstrs, struct TuComposerModule *, ModuleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetInstrNum(ModuleStr, InstrStr) \
	LP2(0x582, ULONG, GetInstrNum, struct TuComposerModule *, ModuleStr, a0, struct TuComposerInstr *, InstrStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define GetInstrAddr(ModuleStr, Num) \
	LP2(0x588, struct TuComposerInstr *, GetInstrAddr, struct TuComposerModule *, ModuleStr, a0, unsigned long, Num, d0, \
	, TUCOMPOSER_BASE_NAME)

#define LoadInstr(CFHandle, InstrStr, ExtLibStr, FlagPassStr, NumInstr) \
	LP5(0x58E, struct TuComposerInstr *, LoadInstr, struct CFHandle *, CFHandle, a0, struct TuComposerInstr *, InstrStr, a1, struct TuComposerExtList *, ExtLibStr, a2, union FlagPass *, FlagPassStr, a3, unsigned long, NumInstr, d0, \
	, TUCOMPOSER_BASE_NAME)

#define SaveInstr(CFHandle, InstrStr, ExtLibStr, FlagPassStr) \
	LP4(0x594, ULONG, SaveInstr, struct CFHandle *, CFHandle, a0, struct TuComposerInstr *, InstrStr, a1, struct TuComposerExtList *, ExtLibStr, a2, union FlagPass *, FlagPassStr, a3, \
	, TUCOMPOSER_BASE_NAME)

#define IdentifyInstr(CFHandle) \
	LP1(0x59A, struct TuComposerExtList *, IdentifyInstr, struct CFHandle *, CFHandle, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetInstrInfo(CFHandle, ExtLibStr, NumInstr) \
	LP3(0x5A0, struct InstrInfo *, GetInstrInfo, struct CFHandle *, CFHandle, a0, struct TuComposerExtList *, ExtLibStr, a1, unsigned long, NumInstr, d0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeInstrInfo(InstrInfoStr) \
	LP1(0x5A6, ULONG, FreeInstrInfo, struct InstrInfo *, InstrInfoStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetInstrs(CFHandle, ExtLibStr) \
	LP2(0x5AC, ULONG, GetInstrs, struct CFHandle *, CFHandle, a0, struct TuComposerExtList *, ExtLibStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define PushInstr(InstrStr) \
	LP1(0x5B2, struct TuComposerInstr *, PushInstr, struct TuComposerInstr *, InstrStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define PopInstr(InstrBuf) \
	LP1(0x5B8, ULONG, PopInstr, struct TuComposerInstr *, InstrBuf, a0, \
	, TUCOMPOSER_BASE_NAME)

#define CutInstr(InstrStr, InstrBuf) \
	LP2(0x5BE, struct TuComposerInstr *, CutInstr, struct TuComposerInstr *, InstrStr, a0, struct TuComposerInstr *, InstrBuf, a1, \
	, TUCOMPOSER_BASE_NAME)

#define CopyInstr(InstrStr, InstrBuf) \
	LP2(0x5C4, struct TuComposerInstr *, CopyInstr, struct TuComposerInstr *, InstrStr, a0, struct TuComposerInstr *, InstrBuf, a1, \
	, TUCOMPOSER_BASE_NAME)

#define PasteInstr(InstrBuf, InstrStr) \
	LP2(0x5CA, struct TuComposerInstr *, PasteInstr, struct TuComposerInstr *, InstrBuf, a0, struct TuComposerInstr *, InstrStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define SwapInstr(InstrBuf, InstrStr) \
	LP2(0x5D0, ULONG, SwapInstr, struct TuComposerInstr *, InstrBuf, a0, struct TuComposerInstr *, InstrStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define SwapInstrInModule(InstrBuf, InstrStr, Flags) \
	LP3(0x5D6, ULONG, SwapInstrInModule, struct TuComposerInstr *, InstrBuf, a0, struct TuComposerInstr *, InstrStr, a1, unsigned long, Flags, d0, \
	, TUCOMPOSER_BASE_NAME)

#define PlayInstr(InstrStr, FlagPassStr, Channel, Note, Volume) \
	LP5(0x5DC, ULONG, PlayInstr, struct TuComposerInstr *, InstrStr, a0, union FlagPass *, FlagPassStr, a1, unsigned long, Channel, d0, unsigned long, Note, d1, unsigned long, Volume, d2, \
	, TUCOMPOSER_BASE_NAME)

#define CmpInstrs(SrcInstrStr, DestInstrStr) \
	LP2(0x5E2, LONG, CmpInstrs, struct TuComposerInstr *, SrcInstrStr, a0, struct TuComposerInstr *, DestInstrStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define GetInstrEnvelopes(InstrStr) \
	LP1(0x5E8, struct TuComposerInstrEnvelope **, GetInstrEnvelopes, struct TuComposerInstr *, InstrStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeInstrEnvelopes(InstrEnvStr) \
	LP1(0x5EE, ULONG, FreeInstrEnvelopes, struct TuComposerInstrEnvelope **, InstrEnvStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AddInstrEnvelopes(InstrStr, Flags) \
	LP2(0x5F4, ULONG, AddInstrEnvelopes, struct TuComposerInstr *, InstrStr, a0, unsigned long, Flags, d0, \
	, TUCOMPOSER_BASE_NAME)

#define GetInstrKeyboard(InstrStr) \
	LP1(0x5FA, struct TuComposerInstrKeyboard *, GetInstrKeyboard, struct TuComposerInstr *, InstrStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetInstrSamples(InstrStr) \
	LP1(0x600, struct TuComposerSample **, GetInstrSamples, struct TuComposerInstr *, InstrStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeInstrSamples(InstrSmpStr) \
	LP1(0x606, ULONG, FreeInstrSamples, struct TuComposerSample **, InstrSmpStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define CreateEnvelope(NumPoints, Type, Scale, YOffset, Nodes) \
	LP5(0x60C, struct TuComposerInstrEnvelope *, CreateEnvelope, unsigned long, NumPoints, d0, unsigned long, Type, d1, unsigned long, Scale, d2, long, YOffset, d3, unsigned long, Nodes, d4, \
	, TUCOMPOSER_BASE_NAME)

#define FreeEnvelope(EnvStr) \
	LP1(0x612, ULONG, FreeEnvelope, struct TuComposerInstrEnvelope *, EnvStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AddEnvelope(ModuleStr, EnvStr) \
	LP2(0x618, ULONG, AddEnvelope, struct TuComposerModule *, ModuleStr, a0, struct TuComposerInstrEnvelope *, EnvStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define RemEnvelope(ModuleStr) \
	LP1(0x61E, ULONG, RemEnvelope, struct TuComposerModule *, ModuleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertEnvelope(ModuleStr, EnvStr, EnvPos) \
	LP3(0x624, ULONG, InsertEnvelope, struct TuComposerModule *, ModuleStr, a0, struct TuComposerInstrEnvelope *, EnvStr, a1, struct TuComposerInstrEnvelope *, EnvPos, a2, \
	, TUCOMPOSER_BASE_NAME)

#define DeleteEnvelope(EnvStr) \
	LP1(0x62A, ULONG, DeleteEnvelope, struct TuComposerInstrEnvelope *, EnvStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ClearEnvelope(EnvStr, Type, Scale, YOffset) \
	LP4(0x630, ULONG, ClearEnvelope, struct TuComposerInstrEnvelope *, EnvStr, a0, unsigned long, Type, d0, unsigned long, Scale, d1, unsigned long, YOffset, d2, \
	, TUCOMPOSER_BASE_NAME)

#define DupEnvelope(EnvStr) \
	LP1(0x636, struct TuComposerInstrEnvelope *, DupEnvelope, struct TuComposerInstrEnvelope, EnvStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ReMapEnvelope(EnvStr, NewEnvStr) \
	LP2(0x63C, ULONG, ReMapEnvelope, struct TuComposerInstrEnvelope *, EnvStr, a0, struct TuComposerInstrEnvelope *, NewEnvStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define ReSizeEnvelope(EnvStr, Entries) \
	LP2(0x642, ULONG, ReSizeEnvelope, struct TuComposerInstrEnvelope *, EnvStr, a0, unsigned long, Entries, d0, \
	, TUCOMPOSER_BASE_NAME)

#define ValidateEnvNodes(EnvStr) \
	LP1(0x648, ULONG, ValidateEnvNodes, struct TuComposerInstrEnvelope *, EnvStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AddEnvelopeUnknownChunk(EnvStr, UnknownChunkStr) \
	LP2(0x64E, ULONG, AddEnvelopeUnknownChunk, struct TuComposerInstrEnvelope *, EnvStr, a0, struct UnknownChunk *, UnknownChunkStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define RemEnvelopeUnknownChunk(EnvStr) \
	LP1(0x654, ULONG, RemEnvelopeUnknownChunk, struct TuComposerInstrEnvelope *, EnvStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertEnvelopeUnknownChunk(EnvStr, UnknownChunkStr, UnknownChunkPos) \
	LP3(0x65A, ULONG, InsertEnvelopeUnknownChunk, struct TuComposerInstrEnvelope *, EnvStr, a0, struct UnknownChunk *, UnknownChunkStr, a1, struct UnknownChunk *, UnknownChunkPos, a2, \
	, TUCOMPOSER_BASE_NAME)

#define GetNumEnvelopes(ModuleStr) \
	LP1(0x660, ULONG, GetNumEnvelopes, struct TuComposerModule *, ModuleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetEnvelopeNum(ModuleStr, EnvStr) \
	LP2(0x666, ULONG, GetEnvelopeNum, struct TuComposerModule *, ModuleStr, a0, struct TuComposerInstrEnvelope *, EnvStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define GetEnvelopeAddr(ModuleStr, Num) \
	LP2(0x66C, struct TuComposerInstrEnvelope *, GetEnvelopeAddr, struct TuComposerModule, ModuleStr, a0, unsigned long, Num, d0, \
	, TUCOMPOSER_BASE_NAME)

#define SwapEnvelopeInModule(EnvBuf, EnvStr, Flags) \
	LP3(0x672, ULONG, SwapEnvelopeInModule, struct TuComposerInstrEnvelope *, EnvBuf, a0, struct TuComposerInstrEnvelope *, EnvStr, a1, unsigned long, Flags, d0, \
	, TUCOMPOSER_BASE_NAME)

#define LoadEnvelope(CFHandle, EnvStr, NumEnv) \
	LP3(0x678, struct TuComposerInstrEnvelope *, LoadEnvelope, struct CFHandle *, CFHandle, a0, struct TuComposerInstrEnvelope *, EnvStr, a1, unsigned long, NumEnv, d0, \
	, TUCOMPOSER_BASE_NAME)

#define SaveEnvelope(CFHandle, EnvStr) \
	LP2(0x67E, ULONG, SaveEnvelope, struct CFHandle *, CFHandle, a0, struct TuComposerInstrEnvelope *, EnvStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define ShrinkEnvelope(EnvStr, Scale) \
	LP2(0x684, ULONG, ShrinkEnvelope, struct TuComposerInstrEnvelope *, EnvStr, a0, unsigned long, Scale, d0, \
	, TUCOMPOSER_BASE_NAME)

#define ExpandEnvelope(EnvStr, Scale) \
	LP2(0x68A, ULONG, ExpandEnvelope, struct TuComposerInstrEnvelope *, EnvStr, a0, unsigned long, Scale, d0, \
	, TUCOMPOSER_BASE_NAME)

#define HalveEnvelope(EnvStr, Scale) \
	LP2(0x690, ULONG, HalveEnvelope, struct TuComposerInstrEnvelope *, EnvStr, a0, unsigned long, Scale, d0, \
	, TUCOMPOSER_BASE_NAME)

#define DoubleEnvelope(EnvStr, Scale) \
	LP2(0x696, ULONG, DoubleEnvelope, struct TuComposerInstrEnvelope *, EnvStr, a0, unsigned long, Scale, d0, \
	, TUCOMPOSER_BASE_NAME)

#define SplitEnvelope(SrcEnvStr, DestEnvStr, Point) \
	LP3(0x69C, struct TuComposerInstrEnvelope *, SplitEnvelope, struct TuComposerInstrEnvelope *, SrcEnvStr, a0, struct TuComposerInstrEnvelope *, DestEnvStr, a1, unsigned long, Point, d0, \
	, TUCOMPOSER_BASE_NAME)

#define JoinEnvelope(SrcEnvStr, DestEnvStr) \
	LP2(0x6A2, ULONG, JoinEnvelope, struct TuComposerInstrEnvelope *, SrcEnvStr, a0, struct TuComposerInstrEnvelope *, DestEnvStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define ScrollEnvelope(EnvStr, Points, StartPoint, EndPoint) \
	LP4(0x6A8, ULONG, ScrollEnvelope, struct TuComposerInstrEnvelope *, EnvStr, a0, long, Points, d0, unsigned long, StartPoint, d1, unsigned long, EndPoint, d2, \
	, TUCOMPOSER_BASE_NAME)

#define RotateEnvelope(EnvStr, Points, StartPoint, EndPoint) \
	LP4(0x6AE, ULONG, RotateEnvelope, struct TuComposerInstrEnvelope *, EnvStr, a0, long, Points, d0, unsigned long, StartPoint, d1, unsigned long, EndPoint, d2, \
	, TUCOMPOSER_BASE_NAME)

#define FlipEnvelope(EnvStr, Scale, StartPoint, EndPoint) \
	LP4(0x6B4, ULONG, FlipEnvelope, struct TuComposerInstrEnvelope *, EnvStr, a0, unsigned long, Scale, d0, unsigned long, StartPoint, d1, unsigned long, EndPoint, d2, \
	, TUCOMPOSER_BASE_NAME)

#define AddEnvPoint(EnvStr, Points) \
	LP2(0x6BA, ULONG, AddEnvPoint, struct TuComposerInstrEnvelope *, EnvStr, a0, unsigned long, Points, d0, \
	, TUCOMPOSER_BASE_NAME)

#define RemEnvPoint(EnvStr, Points) \
	LP2(0x6C0, ULONG, RemEnvPoint, struct TuComposerInstrEnvelope *, EnvStr, a0, unsigned long, Points, d0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertEnvPoint(EnvStr, Point, Points, Flags) \
	LP4(0x6C6, ULONG, InsertEnvPoint, struct TuComposerInstrEnvelope *, EnvStr, a0, unsigned long, Point, d0, unsigned long, Points, d1, unsigned long, Flags, d2, \
	, TUCOMPOSER_BASE_NAME)

#define DeleteEnvPoint(EnvStr, Point, Points, Flags) \
	LP4(0x6CC, ULONG, DeleteEnvPoint, struct TuComposerInstrEnvelope *, EnvStr, a0, unsigned long, Point, d0, unsigned long, Points, d1, unsigned long, Flags, d2, \
	, TUCOMPOSER_BASE_NAME)

#define CmpEnvelopes(SrcEnvStr, DestEnvStr) \
	LP2(0x6D2, LONG, CmpEnvelopes, struct TuComposerInstrEnvelope *, SrcEnvStr, a0, struct TuComposerInstrEnvelope *, DestEnvStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define AllocKeyboard() \
	LP0(0x6D8, struct TuComposerInstrKeyboard *, AllocKeyboard, \
	, TUCOMPOSER_BASE_NAME)

#define FreeKeyboard(KeybrdStr) \
	LP1(0x6DE, ULONG, FreeKeyboard, struct TuComposerInstrKeyboard *, KeybrdStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AddKeyboard(ModuleStr, KeybrdStr) \
	LP2(0x6E4, ULONG, AddKeyboard, struct TuComposerModule *, ModuleStr, a0, struct TuComposerInstrKeyboard *, KeybrdStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define RemKeyboard(ModuleStr) \
	LP1(0x6EA, ULONG, RemKeyboard, struct TuComposerModule *, ModuleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertKeyboard(ModuleStr, KeybrdStr, KeybrdPos) \
	LP3(0x6F0, ULONG, InsertKeyboard, struct TuComposerModule *, ModuleStr, a0, struct TuComposerInstrKeyboard *, KeybrdStr, a1, struct TuComposerInstrKeyboard *, KeybrdPos, a2, \
	, TUCOMPOSER_BASE_NAME)

#define DeleteKeyboard(KeybrdStr) \
	LP1(0x6F6, ULONG, DeleteKeyboard, struct TuComposerInstrKeyboard *, KeybrdStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ClearKeyboard(KeybrdStr) \
	LP1(0x6FC, ULONG, ClearKeyboard, struct TuComposerInstrKeyboard *, KeybrdStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define DupKeyboard(KeybrdStr) \
	LP1(0x702, struct TuComposerInstrKeyboard *, DupKeyboard, struct TuComposerInstrKeyboard, KeybrdStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ReMapKeyboard(KeybrdStr, NewKeybrdStr) \
	LP2(0x708, ULONG, ReMapKeyboard, struct TuComposerInstrKeyboard *, KeybrdStr, a0, struct TuComposerInstrKeyboard *, NewKeybrdStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define GetNumKeyboards(ModuleStr) \
	LP1(0x70E, ULONG, GetNumKeyboards, struct TuComposerModule *, ModuleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetKeyboardNum(ModuleStr, KeybrdStr) \
	LP2(0x714, ULONG, GetKeyboardNum, struct TuComposerModule *, ModuleStr, a0, struct TuComposerInstrKeyboard *, KeybrdStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define GetKeyboardAddr(ModuleStr, Num) \
	LP2(0x71A, struct TuComposerInstrKeyboard *, GetKeyboardAddr, struct TuComposerModule *, ModuleStr, a0, unsigned long, Num, d0, \
	, TUCOMPOSER_BASE_NAME)

#define SwapKeyboardInModule(KeybrdBuf, KeybrdStr, Flags) \
	LP3(0x720, ULONG, SwapKeyboardInModule, struct TuComposerInstrKeyboard *, KeybrdBuf, a0, struct TuComposerInstrKeyboard *, KeybrdStr, a1, unsigned long, Flags, d0, \
	, TUCOMPOSER_BASE_NAME)

#define SetKeyboard(KeybrdStr, SampleNum, Octave, Note, NewOctave, NewNote) \
	LP6(0x726, ULONG, SetKeyboard, struct TuComposerInstrKeyboard *, KeybrdStr, a0, unsigned long, SampleNum, d0, unsigned long, Octave, d1, unsigned long, Note, d2, unsigned long, NewOctave, d3, unsigned long, NewNote, d4, \
	, TUCOMPOSER_BASE_NAME)

#define CheckKeyboard(KeybrdStr) \
	LP1(0x72C, LONG, CheckKeyboard, struct TuComposerInstrKeyboard *, KeybrdStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define CmpKeyboards(SrcKeybrdStr, DestKeybrdStr) \
	LP2(0x732, LONG, CmpKeyboards, struct TuComposerInstrKeyboard *, SrcKeybrdStr, a0, struct TuComposerInstrKeyboard *, DestKeybrdStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define AllocArpeggio(NumEntries) \
	LP1(0x738, struct TuComposerInstrArpeggio *, AllocArpeggio, unsigned long, NumEntries, d0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeArpeggio(ArpStr) \
	LP1(0x73E, ULONG, FreeArpeggio, struct TuComposerInstrArpeggio *, ArpStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AddArpeggio(ModuleStr, ArpStr) \
	LP2(0x744, ULONG, AddArpeggio, struct TuComposerModule *, ModuleStr, a0, struct TuComposerInstrArpeggio *, ArpStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define RemArpeggio(ModuleStr) \
	LP1(0x74A, ULONG, RemArpeggio, struct TuComposerModule *, ModuleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertArpeggio(ModuleStr, ArpStr, ArpPos) \
	LP3(0x750, ULONG, InsertArpeggio, struct TuComposerModule *, ModuleStr, a0, struct TuComposerInstrArpeggio *, ArpStr, a1, struct TuComposerInstrArpeggio *, ArpPos, a2, \
	, TUCOMPOSER_BASE_NAME)

#define DeleteArpeggio(ArpStr) \
	LP1(0x756, ULONG, DeleteArpeggio, struct TuComposerInstrArpeggio *, ArpStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ClearArpeggio(ArpStr) \
	LP1(0x75C, ULONG, ClearArpeggio, struct TuComposerInstrArpeggio *, ArpStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define DupArpeggio(ArpStr) \
	LP1(0x762, struct TuComposerInstrArpeggio *, DupArpeggio, struct TuComposerInstrArpeggio, ArpStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ReMapArpeggio(ArpStr, NewArpStr) \
	LP2(0x768, ULONG, ReMapArpeggio, struct TuComposerInstrArpeggio *, ArpStr, a0, struct TuComposerInstrArpeggio *, NewArpStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define ReSizeArpeggio(ArpStr, Entries) \
	LP2(0x76E, ULONG, ReSizeArpeggio, struct TuComposerInstrArpeggio *, ArpStr, a0, unsigned long, Entries, d0, \
	, TUCOMPOSER_BASE_NAME)

#define GetNumArpeggios(ModuleStr) \
	LP1(0x774, ULONG, GetNumArpeggios, struct TuComposerModule *, ModuleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetArpeggioNum(ModuleStr, ArpStr) \
	LP2(0x77A, ULONG, GetArpeggioNum, struct TuComposerModule *, ModuleStr, a0, struct TuComposerInstrArpeggio *, ArpStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define GetArpeggioAddr(ModuleStr, Num) \
	LP2(0x780, struct TuComposerInstrArpeggio *, GetArpeggioAddr, struct TuComposerModule, ModuleStr, a0, unsigned long, Num, d0, \
	, TUCOMPOSER_BASE_NAME)

#define SwapArpeggioInModule(ArpBuf, ArpStr, Flags) \
	LP3(0x786, ULONG, SwapArpeggioInModule, struct TuComposerInstrArpeggio *, ArpBuf, a0, struct TuComposerInstrArpeggio *, ArpStr, a1, unsigned long, Flags, d0, \
	, TUCOMPOSER_BASE_NAME)

#define ShrinkArpeggio(ArpStr, Scale) \
	LP2(0x78C, ULONG, ShrinkArpeggio, struct TuComposerInstrArpeggio *, ArpStr, a0, unsigned long, Scale, d0, \
	, TUCOMPOSER_BASE_NAME)

#define ExpandArpeggio(ArpStr, Scale) \
	LP2(0x792, ULONG, ExpandArpeggio, struct TuComposerInstrArpeggio *, ArpStr, a0, unsigned long, Scale, d0, \
	, TUCOMPOSER_BASE_NAME)

#define HalveArpeggio(ArpStr, Scale) \
	LP2(0x798, ULONG, HalveArpeggio, struct TuComposerInstrArpeggio *, ArpStr, a0, unsigned long, Scale, d0, \
	, TUCOMPOSER_BASE_NAME)

#define DoubleArpeggio(ArpStr, Scale) \
	LP2(0x79E, ULONG, DoubleArpeggio, struct TuComposerInstrArpeggio *, ArpStr, a0, unsigned long, Scale, d0, \
	, TUCOMPOSER_BASE_NAME)

#define SplitArpeggio(SrcArpStr, DestArpStr, Tick) \
	LP3(0x7A4, struct TuComposerInstrArpeggio *, SplitArpeggio, struct TuComposerInstrArpeggio *, SrcArpStr, a0, struct TuComposerInstrArpeggio *, DestArpStr, a1, unsigned long, Tick, d0, \
	, TUCOMPOSER_BASE_NAME)

#define JoinArpeggio(SrcArpStr, DestArpStr) \
	LP2(0x7AA, ULONG, JoinArpeggio, struct TuComposerInstrArpeggio *, SrcArpStr, a0, struct TuComposerInstrArpeggio *, DestArpStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define ScrollArpeggio(ArpStr, Ticks, StartTick, EndTick) \
	LP4(0x7B0, ULONG, ScrollArpeggio, struct TuComposerInstrArpeggio *, ArpStr, a0, long, Ticks, d0, unsigned long, StartTick, d1, unsigned long, EndTick, d2, \
	, TUCOMPOSER_BASE_NAME)

#define RotateArpeggio(ArpStr, Ticks, StartTick, EndTick) \
	LP4(0x7B6, ULONG, RotateArpeggio, struct TuComposerInstrArpeggio *, ArpStr, a0, long, Ticks, d0, unsigned long, StartTick, d1, unsigned long, EndTick, d2, \
	, TUCOMPOSER_BASE_NAME)

#define FlipArpeggio(ArpStr, Scale, StartTick, EndTick) \
	LP4(0x7BC, ULONG, FlipArpeggio, struct TuComposerInstrArpeggio *, ArpStr, a0, unsigned long, Scale, d0, unsigned long, StartTick, d1, unsigned long, EndTick, d2, \
	, TUCOMPOSER_BASE_NAME)

#define AddArpeggioTick(ArpStr, Ticks) \
	LP2(0x7C2, ULONG, AddArpeggioTick, struct TuComposerInstrArpeggio *, ArpStr, a0, unsigned long, Ticks, d0, \
	, TUCOMPOSER_BASE_NAME)

#define RemArpeggioTick(ArpStr, Ticks) \
	LP2(0x7C8, ULONG, RemArpeggioTick, struct TuComposerInstrArpeggio *, ArpStr, a0, unsigned long, Ticks, d0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertArpeggioTick(ArpStr, Tick, Ticks, Flags) \
	LP4(0x7CE, ULONG, InsertArpeggioTick, struct TuComposerInstrArpeggio *, ArpStr, a0, unsigned long, Tick, d0, unsigned long, Ticks, d1, unsigned long, Flags, d2, \
	, TUCOMPOSER_BASE_NAME)

#define DeleteArpeggioTick(ArpStr, Tick, Ticks, Flags) \
	LP4(0x7D4, ULONG, DeleteArpeggioTick, struct TuComposerInstrArpeggio *, ArpStr, a0, unsigned long, Tick, d0, unsigned long, Ticks, d1, unsigned long, Flags, d2, \
	, TUCOMPOSER_BASE_NAME)

#define CmpArpeggios(SrcArpStr, DestArpStr) \
	LP2(0x7DA, LONG, CmpArpeggios, struct TuComposerInstrArpeggio *, SrcArpStr, a0, struct TuComposerInstrArpeggio *, DestArpStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define AllocSample(SampleData, Length) \
	LP2(0x7E0, struct TuComposerSample *, AllocSample, WORD *, SampleData, a0, unsigned long, Length, d0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeSample(SampleStr) \
	LP1(0x7E6, ULONG, FreeSample, struct TuComposerSample *, SampleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AddSample(InstrStr, SampleStr) \
	LP2(0x7EC, ULONG, AddSample, struct TuComposerInstr *, InstrStr, a0, struct TuComposerSample *, SampleStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define RemSample(InstrStr) \
	LP1(0x7F2, ULONG, RemSample, struct TuComposerInstr *, InstrStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertSample(InstrStr, SampleStr, SamplePos) \
	LP3(0x7F8, ULONG, InsertSample, struct TuComposerInstr *, InstrStr, a0, struct TuComposerSample *, SampleStr, a1, struct TuComposerSample *, SamplePos, a2, \
	, TUCOMPOSER_BASE_NAME)

#define DeleteSample(SampleStr) \
	LP1(0x7FE, ULONG, DeleteSample, struct TuComposerSample *, SampleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ClearSample(SampleStr) \
	LP1(0x804, ULONG, ClearSample, struct TuComposerSample *, SampleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define DupSample(SampleStr) \
	LP1(0x80A, struct TuComposerSample *, DupSample, struct TuComposerSample *, SampleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ReSizeSample(SampleStr, NewSamples) \
	LP2(0x810, ULONG, ReSizeSample, struct TuComposerSample *, SampleStr, a0, unsigned long, NewSamples, d0, \
	, TUCOMPOSER_BASE_NAME)

#define AddSampleUnknownChunk(SampleStr, UnknownChunkStr) \
	LP2(0x816, ULONG, AddSampleUnknownChunk, struct TuComposerSample *, SampleStr, a0, struct UnknownChunk *, UnknownChunkStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define RemSampleUnknownChunk(SampleStr) \
	LP1(0x81C, ULONG, RemSampleUnknownChunk, struct TuComposerSample *, SampleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertSampleUnknownChunk(SampleStr, UnknownChunkStr, UnknownChunkPos) \
	LP3(0x822, ULONG, InsertSampleUnknownChunk, struct TuComposerSample *, SampleStr, a0, struct UnknownChunk *, UnknownChunkStr, a1, struct UnknownChunk *, UnknownChunkPos, a2, \
	, TUCOMPOSER_BASE_NAME)

#define GetNumSamples(InstrStr) \
	LP1(0x828, ULONG, GetNumSamples, struct TuComposerInstr *, InstrStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetSampleNum(InstrStr, SampleStr) \
	LP2(0x82E, ULONG, GetSampleNum, struct TuComposerInstr *, InstrStr, a0, struct TuComposerSample *, SampleStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define GetSampleAddr(InstrStr, Num) \
	LP2(0x834, struct TuComposerSample *, GetSampleAddr, struct TuComposerInstr *, InstrStr, a0, unsigned long, Num, d0, \
	, TUCOMPOSER_BASE_NAME)

#define PushSample(SampleStr) \
	LP1(0x83A, struct TuComposerSample *, PushSample, struct TuComposerSample *, SampleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define PopSample(SampleBuf) \
	LP1(0x840, ULONG, PopSample, struct TuComposerSample *, SampleBuf, a0, \
	, TUCOMPOSER_BASE_NAME)

#define CutSample(SampleStr, SampleBuf) \
	LP2(0x846, struct TuComposerSample *, CutSample, struct TuComposerSample *, SampleStr, a0, struct TuComposerSample *, SampleBuf, a1, \
	, TUCOMPOSER_BASE_NAME)

#define CopySample(SampleStr, SampleBuf) \
	LP2(0x84C, struct TuComposerSample *, CopySample, struct TuComposerSample *, SampleStr, a0, struct TuComposerSample *, SampleBuf, a1, \
	, TUCOMPOSER_BASE_NAME)

#define PasteSample(SampleBuf, SampleStr) \
	LP2(0x852, struct TuComposerSample *, PasteSample, struct TuComposerSample *, SampleBuf, a0, struct TuComposerSample *, SampleStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define SwapSample(SampleBuf, SampleStr) \
	LP2(0x858, ULONG, SwapSample, struct TuComposerSample *, SampleBuf, a0, struct TuComposerSample *, SampleStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define SwapSampleInInstr(SampleBuf, SampleStr, Flags) \
	LP3(0x85E, ULONG, SwapSampleInInstr, struct TuComposerSample *, SampleBuf, a0, struct TuComposerSample *, SampleStr, a1, unsigned long, Flags, d0, \
	, TUCOMPOSER_BASE_NAME)

#define PlaySample(SampleStr, FlagPassStr, Channel, Frequency, Volume) \
	LP5(0x864, ULONG, PlaySample, struct TuComposerSample *, SampleStr, a0, union FlagPass *, FlagPassStr, a1, unsigned long, Channel, d0, unsigned long, Frequency, d1, unsigned long, Volume, d2, \
	, TUCOMPOSER_BASE_NAME)

#define LoadSample(CFHandle, SampleStr, ExtLibStr, FlagPassStr, NumSample) \
	LP5(0x86A, struct TuComposerSample *, LoadSample, struct CFHandle *, CFHandle, a0, struct TuComposerSample *, SampleStr, a1, struct TuComposerExtList *, ExtLibStr, a2, union FlagPass *, FlagPassStr, a3, unsigned long, NumSample, d0, \
	, TUCOMPOSER_BASE_NAME)

#define SaveSample(CFHandle, SampleStr, ExtLibStr, FlagPassStr) \
	LP4(0x870, ULONG, SaveSample, struct CFHandle *, CFHandle, a0, struct TuComposerSample *, SampleStr, a1, struct TuComposerExtList *, ExtLibStr, a2, union FlagPass *, FlagPassStr, a3, \
	, TUCOMPOSER_BASE_NAME)

#define IdentifySample(CFHandle) \
	LP1(0x876, struct TuComposerExtList *, IdentifySample, struct CFHandle *, CFHandle, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetSampleInfo(CFHandle, ExtLibStr, NumSample) \
	LP3(0x87C, struct SampleInfo *, GetSampleInfo, struct CFHandle *, CFHandle, a0, struct TuComposerExtList *, ExtLibStr, a1, unsigned long, NumSample, d0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeSampleInfo(SampleInfoStr) \
	LP1(0x882, ULONG, FreeSampleInfo, struct SampleInfo *, SampleInfoStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetSamples(CFHandle, ExtLibStr) \
	LP2(0x888, ULONG, GetSamples, struct CFHandle *, CFHandle, a0, struct TuComposerExtList *, ExtLibStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define CalcSamplePlayFreq(SampleStr, Octave, Note) \
	LP3(0x88E, ULONG, CalcSamplePlayFreq, struct TuComposerSample *, SampleStr, a0, unsigned long, Octave, d0, unsigned long, Note, d1, \
	, TUCOMPOSER_BASE_NAME)

#define CalcFineTune(Note, FineTune) \
	LP2(0x894, ULONG, CalcFineTune, unsigned long, Note, d0, long, FineTune, d1, \
	, TUCOMPOSER_BASE_NAME)

#define ConvertSampleFrequency(Period) \
	LP1(0x89A, ULONG, ConvertSampleFrequency, unsigned long, Period, d0, \
	, TUCOMPOSER_BASE_NAME)

#define CalcLinearFrequency(SampleFreq, SlideValue) \
	LP2(0x8A0, ULONG, CalcLinearFrequency, unsigned long, SampleFreq, d0, long, SlideValue, d1, \
	, TUCOMPOSER_BASE_NAME)

#define AllocSampleData(Length) \
	LP1(0x8A6, WORD *, AllocSampleData, unsigned long, Length, d0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeSampleData(SampleData, Length) \
	LP2(0x8AC, ULONG, FreeSampleData, WORD *, SampleData, a0, unsigned long, Length, d0, \
	, TUCOMPOSER_BASE_NAME)

#define SetSampleData(SampleStr, SampleData, Length) \
	LP3(0x8B2, ULONG, SetSampleData, struct TuComposerSample *, SampleStr, a0, WORD *, SampleData, a1, unsigned long, Length, d0, \
	, TUCOMPOSER_BASE_NAME)

#define AddSampleData(SampleStr, NumSamples) \
	LP2(0x8B8, ULONG, AddSampleData, struct TuComposerSample *, SampleStr, a0, unsigned long, NumSamples, d0, \
	, TUCOMPOSER_BASE_NAME)

#define RemSampleData(SampleStr, NumSamples) \
	LP2(0x8BE, ULONG, RemSampleData, struct TuComposerSample *, SampleStr, a0, unsigned long, NumSamples, d0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertSampleData(SampleStr, SamplePos, NumSamples) \
	LP3(0x8C4, ULONG, InsertSampleData, struct TuComposerSample *, SampleStr, a0, unsigned long, SamplePos, d0, unsigned long, NumSamples, d1, \
	, TUCOMPOSER_BASE_NAME)

#define DeleteSampleData(SampleStr, SamplePos, NumSamples) \
	LP3(0x8CA, ULONG, DeleteSampleData, struct TuComposerSample *, SampleStr, a0, unsigned long, SamplePos, d0, unsigned long, NumSamples, d1, \
	, TUCOMPOSER_BASE_NAME)

#define ClearSampleData(SampleStr, FirstSmp, LastSmp) \
	LP3(0x8D0, ULONG, ClearSampleData, struct TuComposerSample *, SampleStr, a0, unsigned long, FirstSmp, d0, unsigned long, LastSmp, d1, \
	, TUCOMPOSER_BASE_NAME)

#define DupSampleData(SampleStr) \
	LP1(0x8D6, WORD *, DupSampleData, struct TuComposerSample *, SampleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define CutSampleData(SampleStr, SampleBuf, FirstSmp, LastSmp) \
	LP4(0x8DC, struct TuComposerSample *, CutSampleData, struct TuComposerSample *, SampleStr, a0, struct TuComposerSample *, SampleBuf, a1, unsigned long, FirstSmp, d0, unsigned long, LastSmp, d1, \
	, TUCOMPOSER_BASE_NAME)

#define CopySampleData(SampleStr, SampleBuf, FirstSmp, LastSmp) \
	LP4(0x8E2, struct TuComposerSample *, CopySampleData, struct TuComposerSample *, SampleStr, a0, struct TuComposerSample *, SampleBuf, a1, unsigned long, FirstSmp, d0, unsigned long, LastSmp, d1, \
	, TUCOMPOSER_BASE_NAME)

#define PasteSampleData(SampleBuf, SampleStr, PasteSmp, Flags) \
	LP4(0x8E8, struct TuComposerSample *, PasteSampleData, struct TuComposerSample, SampleBuf, a0, struct TuComposerSample *, SampleStr, a1, unsigned long, PasteSmp, d0, unsigned long, Flags, d1, \
	, TUCOMPOSER_BASE_NAME)

#define CropSampleData(SampleStr, SampleBuf, FirstSmp, LastSmp) \
	LP4(0x8EE, struct TuComposerSample *, CropSampleData, struct TuComposerSample *, SampleStr, a0, struct TuComposerSample *, SampleBuf, a1, unsigned long, FirstSmp, d0, unsigned long, LastSmp, d1, \
	, TUCOMPOSER_BASE_NAME)

#define LoadSampleData(CFHandle, SampleStr, NumBytes) \
	LP3(0x8F4, struct TuComposerSample *, LoadSampleData, struct CFHandle *, CFHandle, a0, struct TuComposerSample *, SampleStr, a1, unsigned long, NumBytes, d0, \
	, TUCOMPOSER_BASE_NAME)

#define SaveSampleData(CFHandle, SampleStr, FirstSmp, LastSmp) \
	LP4(0x8FA, ULONG, SaveSampleData, struct CFHandle *, CFHandle, a0, struct TuComposerSample *, SampleStr, a1, unsigned long, FirstSmp, d0, unsigned long, LastSmp, d1, \
	, TUCOMPOSER_BASE_NAME)

#define ConvertBits(SampleStr, DestBitDepth, Flags) \
	LP3(0x900, ULONG, ConvertBits, struct TuComposerSample *, SampleStr, a0, unsigned long, DestBitDepth, d0, unsigned long, Flags, d1, \
	, TUCOMPOSER_BASE_NAME)

#define GetOptimalBits(SampleStr, Flags) \
	LP2(0x906, ULONG, GetOptimalBits, struct TuComposerSample *, SampleStr, a0, unsigned long, Flags, d0, \
	, TUCOMPOSER_BASE_NAME)

#define ConvertSigned(SampleStr) \
	LP1(0x90C, ULONG, ConvertSigned, struct TuComposerSample *, SampleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ConvertWord(SampleStr) \
	LP1(0x912, ULONG, ConvertWord, struct TuComposerSample *, SampleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define DecrunchSample(SampleStr, DeltaBitDepth) \
	LP2(0x918, ULONG, DecrunchSample, struct TuComposerSample *, SampleStr, a0, unsigned long, DeltaBitDepth, d0, \
	, TUCOMPOSER_BASE_NAME)

#define Backwards(SampleStr, StartSmp, LastSmp) \
	LP3(0x91E, ULONG, Backwards, struct TuComposerSample *, SampleStr, a0, unsigned long, StartSmp, d0, unsigned long, LastSmp, d1, \
	, TUCOMPOSER_BASE_NAME)

#define MixSamples(SrcSampleStr, DestSampleStr, SrcStartSmp, SrcLastSmp, DestStartSmp) \
	LP5(0x924, ULONG, MixSamples, struct TuComposerSample *, SrcSampleStr, a0, struct TuComposerSample *, DestSampleStr, a1, unsigned long, SrcStartSmp, d0, unsigned long, SrcLastSmp, d1, unsigned long, DestStartSmp, d2, \
	, TUCOMPOSER_BASE_NAME)

#define Sample(SampleStr, InpDevStr, Buffer, Frequency, BitDepth, BufLen, Flags) \
	LP7(0x92A, struct TuComposerSample *, Sample, struct TuComposerSample *, SampleStr, a0, struct TuComposerExtList *, InpDevStr, a1, WORD *, Buffer, a2, unsigned long, Frequency, d0, unsigned long, BitDepth, d1, unsigned long, BufLen, d2, unsigned long, Flags, d3, \
	, TUCOMPOSER_BASE_NAME)

#define OctaveUp(SampleStr) \
	LP1(0x930, ULONG, OctaveUp, struct TuComposerSample *, SampleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define OctaveDown(SampleStr) \
	LP1(0x936, ULONG, OctaveDown, struct TuComposerSample *, SampleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ReSample(SampleStr, NewFrequency, OldFrequency, Flags) \
	LP4(0x93C, ULONG, ReSample, struct TuComposerSample *, SampleStr, a0, unsigned long, NewFrequency, d0, unsigned long, OldFrequency, d1, unsigned long, Flags, d2, \
	, TUCOMPOSER_BASE_NAME)

#define InvertSample(SampleStr) \
	LP1(0x942, ULONG, InvertSample, struct TuComposerSample *, SampleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define XFadeSample(SampleStr) \
	LP1(0x948, ULONG, XFadeSample, struct TuComposerSample *, SampleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AmplifySample(SampleStr, StartAmplify, EndAmplify, StartSmp, LastSmp) \
	LP5(0x94E, ULONG, AmplifySample, struct TuComposerSample *, SampleStr, a0, unsigned long, StartAmplify, d0, unsigned long, EndAmplify, d1, unsigned long, StartSmp, d2, unsigned long, LastSmp, d3, \
	, TUCOMPOSER_BASE_NAME)

#define GetBiggestAmplify(SampleStr, StartSmp, LastSmp) \
	LP3(0x954, ULONG, GetBiggestAmplify, struct TuComposerSample *, SampleStr, a0, unsigned long, StartSmp, d0, unsigned long, LastSmp, d1, \
	, TUCOMPOSER_BASE_NAME)

#define GetLowestAmplify(SampleStr, StartSmp, LastSmp) \
	LP3(0x95A, ULONG, GetLowestAmplify, struct TuComposerSample *, SampleStr, a0, unsigned long, StartSmp, d0, unsigned long, LastSmp, d1, \
	, TUCOMPOSER_BASE_NAME)

#define CreateEcho(SampleStr) \
	LP1(0x960, ULONG, CreateEcho, struct TuComposerSample *, SampleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define BoostSample(SampleStr) \
	LP1(0x966, ULONG, BoostSample, struct TuComposerSample *, SampleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define FilterSample(SampleStr) \
	LP1(0x96C, ULONG, FilterSample, struct TuComposerSample *, SampleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define MorphSamples(SampleStr) \
	LP1(0x972, ULONG, MorphSamples, struct TuComposerSample *, SampleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define MinimizeSample(SampleStr) \
	LP1(0x978, ULONG, MinimizeSample, struct TuComposerSample *, SampleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define FindOriginSample(SampleStr) \
	LP1(0x97E, struct TuComposerSample *, FindOriginSample, struct TuComposerSample *, SampleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetSampleValue(SampleStr, Sample) \
	LP2(0x984, LONG, GetSampleValue, struct TuComposerSample *, SampleStr, a0, unsigned long, Sample, d0, \
	, TUCOMPOSER_BASE_NAME)

#define GetSampleValueArray(SampleStr, ArrayPtr, StartSmp, ArrrayEntries) \
	LP4(0x98A, ULONG, GetSampleValueArray, struct TuComposerSample *, SampleStr, a0, LONG *, ArrayPtr, a1, unsigned long, StartSmp, d0, unsigned long, ArrrayEntries, d1, \
	, TUCOMPOSER_BASE_NAME)

#define CmpSamples(SrcSampleStr, DestSampleStr) \
	LP2(0x990, LONG, CmpSamples, struct TuComposerSample *, SrcSampleStr, a0, struct TuComposerSample *, DestSampleStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define AllocSynth(CodeLen, Waveforms, WaveLen) \
	LP3(0x996, struct TuComposerSynth *, AllocSynth, unsigned long, CodeLen, d0, unsigned long, Waveforms, d1, unsigned long, WaveLen, d2, \
	, TUCOMPOSER_BASE_NAME)

#define FreeSynth(SynthStr) \
	LP1(0x99C, ULONG, FreeSynth, struct TuComposerSynth *, SynthStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AssignSynth(SampleStr, SynthStr) \
	LP2(0x9A2, ULONG, AssignSynth, struct TuComposerSample *, SampleStr, a0, struct TuComposerSynth *, SynthStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define ClearSynth(SynthStr) \
	LP1(0x9A8, ULONG, ClearSynth, struct TuComposerSynth *, SynthStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define DupSynth(SynthStr) \
	LP1(0x9AE, struct TuComposerSynth *, DupSynth, struct TuComposerSynth *, SynthStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ReMapSynth(SynthStr, NewSynthStr) \
	LP2(0x9B4, ULONG, ReMapSynth, struct TuComposerSynth *, SynthStr, a0, struct TuComposerSynth *, NewSynthStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define AddSynthUnknownChunk(SynthStr, UnknownChunkStr) \
	LP2(0x9BA, ULONG, AddSynthUnknownChunk, struct TuComposerSynth *, SynthStr, a0, struct UnknownChunk *, UnknownChunkStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define RemSynthUnknownChunk(SynthStr) \
	LP1(0x9C0, ULONG, RemSynthUnknownChunk, struct TuComposerSynth *, SynthStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertSynthUnknownChunk(SynthStr, UnknownChunkStr, UnknownChunkPos) \
	LP3(0x9C6, ULONG, InsertSynthUnknownChunk, struct TuComposerSynth *, SynthStr, a0, struct UnknownChunk *, UnknownChunkStr, a1, struct UnknownChunk *, UnknownChunkPos, a2, \
	, TUCOMPOSER_BASE_NAME)

#define GetNumSynths(ModuleStr) \
	LP1(0x9CC, ULONG, GetNumSynths, struct TuComposerModule *, ModuleStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetSynthNum(ModuleStr, SynthStr) \
	LP2(0x9D2, ULONG, GetSynthNum, struct TuComposerModule *, ModuleStr, a0, struct TuComposerSynth *, SynthStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define GetSynthAddr(ModuleStr, SynthNum) \
	LP2(0x9D8, struct TuComposerSynth *, GetSynthAddr, struct TuComposerModule *, ModuleStr, a0, unsigned long, SynthNum, d0, \
	, TUCOMPOSER_BASE_NAME)

#define PushSynth(SynthStr) \
	LP1(0x9DE, struct TuComposerSynth *, PushSynth, struct TuComposerSynth *, SynthStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define PopSynth(SynthBuf) \
	LP1(0x9E4, ULONG, PopSynth, struct TuComposerSynth *, SynthBuf, a0, \
	, TUCOMPOSER_BASE_NAME)

#define CutSynth(SynthStr, SynthBuf) \
	LP2(0x9EA, struct TuComposerSynth *, CutSynth, struct TuComposerSynth *, SynthStr, a0, struct TuComposerSynth *, SynthBuf, a1, \
	, TUCOMPOSER_BASE_NAME)

#define CopySynth(SynthStr, SynthBuf) \
	LP2(0x9F0, struct TuComposerSynth *, CopySynth, struct TuComposerSynth *, SynthStr, a0, struct TuComposerSynth *, SynthBuf, a1, \
	, TUCOMPOSER_BASE_NAME)

#define PasteSynth(SynthBuf, SynthStr) \
	LP2(0x9F6, struct TuComposerSynth *, PasteSynth, struct TuComposerSynth *, SynthBuf, a0, struct TuComposerSynth *, SynthStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define SwapSynth(SynthBuf, SynthStr) \
	LP2(0x9FC, ULONG, SwapSynth, struct TuComposerSynth *, SynthBuf, a0, struct TuComposerSynth *, SynthStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define LoadSynth(CFHandle, SynthStr, ExtLibStr, FlagPassStr, NumSynth) \
	LP5(0xA02, struct TuComposerSynth *, LoadSynth, struct CFHandle *, CFHandle, a0, struct TuComposerSynth *, SynthStr, a1, struct TuComposerExtList *, ExtLibStr, a2, union FlagPass *, FlagPassStr, a3, unsigned long, NumSynth, d0, \
	, TUCOMPOSER_BASE_NAME)

#define SaveSynth(CFHandle, SynthStr, ExtLibStr, FlagPassStr) \
	LP4(0xA08, ULONG, SaveSynth, struct CFHandle *, CFHandle, a0, struct TuComposerSynth *, SynthStr, a1, struct TuComposerExtList *, ExtLibStr, a2, union FlagPass *, FlagPassStr, a3, \
	, TUCOMPOSER_BASE_NAME)

#define IdentifySynth(CFHandle) \
	LP1(0xA0E, struct TuComposerExtList *, IdentifySynth, struct CFHandle *, CFHandle, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetSynthInfo(CFHandle, ExtLibStr, NumSynth) \
	LP3(0xA14, struct SynthInfo *, GetSynthInfo, struct CFHandle *, CFHandle, a0, struct TuComposerExtList *, ExtLibStr, a1, unsigned long, NumSynth, d0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeSynthInfo(SynthInfoStr) \
	LP1(0xA1A, ULONG, FreeSynthInfo, struct SynthInfo *, SynthInfoStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetSynths(CFHandle, ExtLibStr) \
	LP2(0xA20, ULONG, GetSynths, struct CFHandle *, CFHandle, a0, struct TuComposerExtList, ExtLibStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define CmpSynths(SrcSynthStr, DestSynthStr) \
	LP2(0xA26, LONG, CmpSynths, struct TuComposerSynth *, SrcSynthStr, a0, struct TuComposerSynth *, DestSynthStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define AllocWaveform(WaveLength) \
	LP1(0xA2C, struct TuComposerSynthWave *, AllocWaveform, unsigned long, WaveLength, d0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeWaveform(WaveformStr) \
	LP1(0xA32, ULONG, FreeWaveform, struct TuComposerSynthWave *, WaveformStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AddWaveform(SynthStr, WaveformStr) \
	LP2(0xA38, ULONG, AddWaveform, struct TuComposerSynth *, SynthStr, a0, struct TuComposerSynthWave *, WaveformStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define RemWaveform(SynthStr) \
	LP1(0xA3E, ULONG, RemWaveform, struct TuComposerSynth *, SynthStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertWaveform(SynthStr, WaveformStr, WaveformPos) \
	LP3(0xA44, ULONG, InsertWaveform, struct TuComposerSynth *, SynthStr, a0, struct TuComposerSynthWave *, WaveformStr, a1, struct TuComposerSynthWave *, WaveformPos, a2, \
	, TUCOMPOSER_BASE_NAME)

#define DeleteWaveform(WaveformStr) \
	LP1(0xA4A, ULONG, DeleteWaveform, struct TuComposerSynthWave *, WaveformStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ClearWaveform(WaveformStr) \
	LP1(0xA50, ULONG, ClearWaveform, struct TuComposerSynthWave *, WaveformStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define DupWaveform(WaveformStr) \
	LP1(0xA56, struct TuComposerSynthWave *, DupWaveform, struct TuComposerSynthWave, WaveformStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ReSizeWaveform(WaveformStr, NewLen) \
	LP2(0xA5C, ULONG, ReSizeWaveform, struct TuComposerSynthWave *, WaveformStr, a0, unsigned long, NewLen, d0, \
	, TUCOMPOSER_BASE_NAME)

#define GetNumWaveforms(SynthStr) \
	LP1(0xA62, ULONG, GetNumWaveforms, struct TuComposerSynth *, SynthStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetWaveformNum(SynthStr, WaveformStr) \
	LP2(0xA68, ULONG, GetWaveformNum, struct TuComposerSynth *, SynthStr, a0, struct TuComposerSynthWave *, WaveformStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define GetWaveformAddr(SynthStr, WaveformNum) \
	LP2(0xA6E, struct TuComposerSynthWave *, GetWaveformAddr, struct TuComposerSynth, SynthStr, a0, unsigned long, WaveformNum, d0, \
	, TUCOMPOSER_BASE_NAME)

#define PushWaveform(WaveformStr) \
	LP1(0xA74, struct TuComposerSynthWave *, PushWaveform, struct TuComposerSynthWave, WaveformStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define PopWaveform(WaveformBuf) \
	LP1(0xA7A, ULONG, PopWaveform, struct TuComposerSynthWave *, WaveformBuf, a0, \
	, TUCOMPOSER_BASE_NAME)

#define CutWaveform(WaveformStr, WaveformBuf) \
	LP2(0xA80, struct TuComposerSynthWave *, CutWaveform, struct TuComposerSynthWave, WaveformStr, a0, struct TuComposerSynthWave *, WaveformBuf, a1, \
	, TUCOMPOSER_BASE_NAME)

#define CopyWaveform(WaveformStr, WaveformBuf) \
	LP2(0xA86, struct TuComposerSynthWave *, CopyWaveform, struct TuComposerSynthWave, WaveformStr, a0, struct TuComposerSynthWave *, WaveformBuf, a1, \
	, TUCOMPOSER_BASE_NAME)

#define PasteWaveform(WaveformBuf, WaveformStr) \
	LP2(0xA8C, struct TuComposerSynthWave *, PasteWaveform, struct TuComposerSynthWave, WaveformBuf, a0, struct TuComposerSynthWave *, WaveformStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define SwapWaveform(WaveformBuf, WaveformStr) \
	LP2(0xA92, ULONG, SwapWaveform, struct TuComposerSynthWave *, WaveformBuf, a0, struct TuComposerSynthWave *, WaveformStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define SwapWaveformInSynth(WaveformBuf, WaveformStr) \
	LP2(0xA98, ULONG, SwapWaveformInSynth, struct TuComposerSynthWave *, WaveformBuf, a0, struct TuComposerSynthWave *, WaveformStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define LoadWaveform(CFHandle, WaveformStr, NumBytes) \
	LP3(0xA9E, struct TuComposerSynthWave *, LoadWaveform, struct CFHandle *, CFHandle, a0, struct TuComposerSynthWave *, WaveformStr, a1, unsigned long, NumBytes, d0, \
	, TUCOMPOSER_BASE_NAME)

#define SaveWaveform(CFHandle, WaveformStr, FirstSmp, LastSmp) \
	LP4(0xAA4, ULONG, SaveWaveform, struct CFHandle *, CFHandle, a0, struct TuComposerSynthWave *, WaveformStr, a1, unsigned long, FirstSmp, d0, unsigned long, LastSmp, d1, \
	, TUCOMPOSER_BASE_NAME)

#define PlayWaveform(WaveformStr, FlagPassStr, Frequency) \
	LP3(0xAAA, ULONG, PlayWaveform, struct TuComposerSynthWave *, WaveformStr, a0, union FlagPass *, FlagPassStr, a1, unsigned long, Frequency, d0, \
	, TUCOMPOSER_BASE_NAME)

#define AddWaveformPoint(WaveformStr, Points) \
	LP2(0xAB0, ULONG, AddWaveformPoint, struct TuComposerSynthWave *, WaveformStr, a0, unsigned long, Points, d0, \
	, TUCOMPOSER_BASE_NAME)

#define RemWaveformPoint(WaveformStr, Points) \
	LP2(0xAB6, ULONG, RemWaveformPoint, struct TuComposerSynthWave *, WaveformStr, a0, unsigned long, Points, d0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertWaveformPoint(WaveformStr, Point, Points, Flags) \
	LP4(0xABC, ULONG, InsertWaveformPoint, struct TuComposerSynthWave *, WaveformStr, a0, unsigned long, Point, d0, unsigned long, Points, d1, unsigned long, Flags, d2, \
	, TUCOMPOSER_BASE_NAME)

#define DeleteWaveformPoint(WaveformStr, Point, Points, Flags) \
	LP4(0xAC2, ULONG, DeleteWaveformPoint, struct TuComposerSynthWave *, WaveformStr, a0, unsigned long, Point, d0, unsigned long, Points, d1, unsigned long, Flags, d2, \
	, TUCOMPOSER_BASE_NAME)

#define FillWaveform(WaveformStr, RepLen, Type, Scale, YOffset) \
	LP5(0xAC8, ULONG, FillWaveform, struct TuComposerSynthWave *, WaveformStr, a0, unsigned long, RepLen, d0, unsigned long, Type, d1, unsigned long, Scale, d2, long, YOffset, d3, \
	, TUCOMPOSER_BASE_NAME)

#define ConvertWaveform(WaveformStr, DestBitDepth, Flags) \
	LP3(0xACE, ULONG, ConvertWaveform, struct TuComposerSynthWave *, WaveformStr, a0, unsigned long, DestBitDepth, d0, unsigned long, Flags, d1, \
	, TUCOMPOSER_BASE_NAME)

#define ConvertWaveformSigned(WaveformStr) \
	LP1(0xAD4, ULONG, ConvertWaveformSigned, struct TuComposerSynthWave *, WaveformStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ConvertWaveformWord(WaveformStr) \
	LP1(0xADA, ULONG, ConvertWaveformWord, struct TuComposerSynthWave *, WaveformStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define BackwardsWaveform(WaveformStr) \
	LP1(0xAE0, ULONG, BackwardsWaveform, struct TuComposerSynthWave *, WaveformStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define MixWaveforms(SrcWaveformStr, DestWaveformStr) \
	LP2(0xAE6, ULONG, MixWaveforms, struct TuComposerSynthWave *, SrcWaveformStr, a0, struct TuComposerSynthWave *, DestWaveformStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define HalveWaveform(WaveformStr) \
	LP1(0xAEC, ULONG, HalveWaveform, struct TuComposerSynthWave *, WaveformStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define DoubleWaveform(WaveformStr) \
	LP1(0xAF2, ULONG, DoubleWaveform, struct TuComposerSynthWave *, WaveformStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ScaleWaveformSize(WaveformStr, NewLength, OldLength, Flags) \
	LP4(0xAF8, ULONG, ScaleWaveformSize, struct TuComposerSynthWave *, WaveformStr, a0, unsigned long, NewLength, d0, unsigned long, OldLength, d1, unsigned long, Flags, d2, \
	, TUCOMPOSER_BASE_NAME)

#define InvertWaveform(WaveformStr) \
	LP1(0xAFE, ULONG, InvertWaveform, struct TuComposerSynthWave *, WaveformStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AmplifyWaveform(WaveformStr, Amplify) \
	LP2(0xB04, ULONG, AmplifyWaveform, struct TuComposerSynthWave *, WaveformStr, a0, unsigned long, Amplify, d0, \
	, TUCOMPOSER_BASE_NAME)

#define GetMaxWaveformAmplify(WaveformStr) \
	LP1(0xB0A, ULONG, GetMaxWaveformAmplify, struct TuComposerSynthWave *, WaveformStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetMinWaveformAmplify(WaveformStr) \
	LP1(0xB10, ULONG, GetMinWaveformAmplify, struct TuComposerSynthWave *, WaveformStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define CopySample2Waveform(SampleStr, WaveformStr) \
	LP2(0xB16, ULONG, CopySample2Waveform, struct TuComposerSample *, SampleStr, a0, struct TuComposerSynthWave *, WaveformStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define CopyWaveform2Sample(WaveformStr, SampleStr) \
	LP2(0xB1C, ULONG, CopyWaveform2Sample, struct TuComposerSynthWave *, WaveformStr, a0, struct TuComposerSample *, SampleStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define CopyEnvelope2Waveform(EnvelopeStr, WaveformStr) \
	LP2(0xB22, ULONG, CopyEnvelope2Waveform, struct TuComposerInstrEnvelope *, EnvelopeStr, a0, struct TuComposerSynthWave *, WaveformStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define CopyWaveform2Envelope(WaveformStr, EnvelopeStr) \
	LP2(0xB28, ULONG, CopyWaveform2Envelope, struct TuComposerSynthWave *, WaveformStr, a0, struct TuComposerInstrEnvelope *, EnvelopeStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define TransformWaveform(SrcWaveformStr, DestWaveformStr) \
	LP2(0xB2E, ULONG, TransformWaveform, struct TuComposerSynthWave *, SrcWaveformStr, a0, struct TuComposerSynthWave *, DestWaveformStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define CmpWaveforms(SrcWaveformStr, DestWaveformStr) \
	LP2(0xB34, LONG, CmpWaveforms, struct TuComposerSynthWave *, SrcWaveformStr, a0, struct TuComposerSynthWave *, DestWaveformStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define AllocSynthCode(Lines) \
	LP1(0xB3A, struct TuComposerSynthCode *, AllocSynthCode, unsigned long, Lines, d0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeSynthCode(SynthCodeStr, Lines) \
	LP2(0xB40, ULONG, FreeSynthCode, struct TuComposerSynthCode *, SynthCodeStr, a0, unsigned long, Lines, d0, \
	, TUCOMPOSER_BASE_NAME)

#define AssignSynthCode(SynthStr, SynthCodeStr, Lines) \
	LP3(0xB46, ULONG, AssignSynthCode, struct TuComposerSynth *, SynthStr, a0, struct TuComposerSynthCode *, SynthCodeStr, a1, unsigned long, Lines, d0, \
	, TUCOMPOSER_BASE_NAME)

#define ClearSynthCode(SynthStr) \
	LP1(0xB4C, ULONG, ClearSynthCode, struct TuComposerSynth *, SynthStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define DupSynthCode(SynthStr) \
	LP1(0xB52, struct TuComposerSynthCode *, DupSynthCode, struct TuComposerSynth, SynthStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define ReSizeSynthCode(SynthStr, NewLen) \
	LP2(0xB58, ULONG, ReSizeSynthCode, struct TuComposerSynth *, SynthStr, a0, unsigned long, NewLen, d0, \
	, TUCOMPOSER_BASE_NAME)

#define PushSynthCode(SynthStr) \
	LP1(0xB5E, struct TuComposerSynth *, PushSynthCode, struct TuComposerSynth *, SynthStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define PopSynthCode(SynthBuf) \
	LP1(0xB64, ULONG, PopSynthCode, struct TuComposerSynth *, SynthBuf, a0, \
	, TUCOMPOSER_BASE_NAME)

#define CutSynthCode(SynthStr, SynthBuf) \
	LP2(0xB6A, struct TuComposerSynth *, CutSynthCode, struct TuComposerSynth *, SynthStr, a0, struct TuComposerSynth *, SynthBuf, a1, \
	, TUCOMPOSER_BASE_NAME)

#define CopySynthCode(SynthStr, SynthBuf) \
	LP2(0xB70, struct TuComposerSynth *, CopySynthCode, struct TuComposerSynth *, SynthStr, a0, struct TuComposerSynth *, SynthBuf, a1, \
	, TUCOMPOSER_BASE_NAME)

#define PasteSynthCode(SynthBuf, SynthStr) \
	LP2(0xB76, struct TuComposerSynth *, PasteSynthCode, struct TuComposerSynth *, SynthBuf, a0, struct TuComposerSynth *, SynthStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define SwapSynthCode(SynthBuf, SynthStr) \
	LP2(0xB7C, ULONG, SwapSynthCode, struct TuComposerSynth *, SynthBuf, a0, struct TuComposerSynth *, SynthStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define AddSynthCodeLine(SynthStr, Lines) \
	LP2(0xB82, ULONG, AddSynthCodeLine, struct TuComposerSynth *, SynthStr, a0, unsigned long, Lines, d0, \
	, TUCOMPOSER_BASE_NAME)

#define RemSynthCodeLine(SynthStr, Lines) \
	LP2(0xB88, ULONG, RemSynthCodeLine, struct TuComposerSynth *, SynthStr, a0, unsigned long, Lines, d0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertSynthCodeLine(SynthStr, Line, Lines, Flags) \
	LP4(0xB8E, ULONG, InsertSynthCodeLine, struct TuComposerSynth *, SynthStr, a0, unsigned long, Line, d0, unsigned long, Lines, d1, unsigned long, Flags, d2, \
	, TUCOMPOSER_BASE_NAME)

#define DeleteSynthCodeLine(SynthStr, Line, Lines, Flags) \
	LP4(0xB94, ULONG, DeleteSynthCodeLine, struct TuComposerSynth *, SynthStr, a0, unsigned long, Line, d0, unsigned long, Lines, d1, unsigned long, Flags, d2, \
	, TUCOMPOSER_BASE_NAME)

#define GetSynthCodeParams(Code) \
	LP1(0xB9A, ULONG, GetSynthCodeParams, unsigned long, Code, d0, \
	, TUCOMPOSER_BASE_NAME)

#define AssembleCodeLine(AsmBuf, SynthStr, CodeLine, Flags) \
	LP4(0xBA0, STRPTR, AssembleCodeLine, STRPTR, AsmBuf, a0, struct TuComposerSynth *, SynthStr, a1, unsigned long, CodeLine, d0, unsigned long, Flags, d1, \
	, TUCOMPOSER_BASE_NAME)

#define DisassembleCodeLine(AsmBuf, SynthStr, CodeLine, Flags) \
	LP4(0xBA6, ULONG, DisassembleCodeLine, STRPTR, AsmBuf, a0, struct TuComposerSynth *, SynthStr, a1, unsigned long, CodeLine, d0, unsigned long, Flags, d1, \
	, TUCOMPOSER_BASE_NAME)

#define AllocSymbol(Name) \
	LP1(0xBAC, struct TuComposerSynthSymbolTable *, AllocSymbol, STRPTR, Name, a0, \
	, TUCOMPOSER_BASE_NAME)

#define FreeSymbol(SymbolStr) \
	LP1(0xBB2, ULONG, FreeSymbol, struct TuComposerSynthSymbolTable *, SymbolStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AssignSymbol(SymbolStr, Name) \
	LP2(0xBB8, ULONG, AssignSymbol, struct TuComposerSynthSymbolTable *, SymbolStr, a0, STRPTR, Name, a1, \
	, TUCOMPOSER_BASE_NAME)

#define DupSymbol(SymbolStr) \
	LP1(0xBBE, struct TuComposerSynthSymbolTable *, DupSymbol, struct TuComposerSynthSymbolTable *, SymbolStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AddSymbol(SynthStr, SymbolStr) \
	LP2(0xBC4, ULONG, AddSymbol, struct TuComposerSynth *, SynthStr, a0, struct TuComposerSynthSymbolTable *, SymbolStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define RemSymbol(SynthStr) \
	LP1(0xBCA, ULONG, RemSymbol, struct TuComposerSynth *, SynthStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define InsertSymbol(SynthStr, SymbolStr, SymbolPos) \
	LP3(0xBD0, ULONG, InsertSymbol, struct TuComposerSynth *, SynthStr, a0, struct TuComposerSynthSymbolTable *, SymbolStr, a1, struct TuComposerSynthSymbolTable *, SymbolPos, a2, \
	, TUCOMPOSER_BASE_NAME)

#define DeleteSymbol(SymbolStr) \
	LP1(0xBD6, ULONG, DeleteSymbol, struct TuComposerSynthSymbolTable *, SymbolStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetNumSymbols(SynthStr) \
	LP1(0xBDC, ULONG, GetNumSymbols, struct TuComposerSynth *, SynthStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetSymbolNum(SynthStr, SymbolStr) \
	LP2(0xBE2, ULONG, GetSymbolNum, struct TuComposerSynth *, SynthStr, a0, struct TuComposerSynthSymbolTable *, SymbolStr, a1, \
	, TUCOMPOSER_BASE_NAME)

#define GetSymbolAddr(SynthStr, SymbolNum) \
	LP2(0xBE8, struct TuComposerSynthSymbolTable *, GetSymbolAddr, struct TuComposerSynth *, SynthStr, a0, unsigned long, SymbolNum, d0, \
	, TUCOMPOSER_BASE_NAME)

#define MatchSymbol(SymbolStr, Name, Line, Type) \
	LP4(0xBEE, struct TuComposerSynthSymbolTable *, MatchSymbol, struct TuComposerSynthSymbolTable *, SymbolStr, a0, STRPTR, Name, a1, unsigned long, Line, d0, unsigned long, Type, d1, \
	, TUCOMPOSER_BASE_NAME)

#define AddExternalLib(ExtLibStr, Type) \
	LP2(0xBF4, ULONG, AddExternalLib, struct TuComposerExtList *, ExtLibStr, a0, unsigned long, Type, d0, \
	, TUCOMPOSER_BASE_NAME)

#define RemExternalLib(ExtLibStr) \
	LP1(0xBFA, struct TuComposerExtList *, RemExternalLib, struct TuComposerExtList, ExtLibStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define OpenExternalLib(ExtLibStr) \
	LP1(0xC00, struct TuComposerExtLibBase *, OpenExternalLib, struct TuComposerExtList, ExtLibStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define CloseExternalLib(ExtLibStr) \
	LP1(0xC06, struct TuComposerExtList *, CloseExternalLib, struct TuComposerExtList, ExtLibStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define GetExternalLibs(ExtLibPatStr) \
	LP1(0xC0C, ULONG, GetExternalLibs, STRPTR, ExtLibPatStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define AllocFlagStr(FlagStr) \
	LP1(0xC12, struct TuComposerExtFlagStr *, AllocFlagStr, struct TuComposerExtFlagStr, FlagStr, a0, \
	, TUCOMPOSER_BASE_NAME)

#define CIdentify(FileName) \
	LP1(0xC18, struct TuComposerExtList *, CIdentify, STRPTR, FileName, d1, \
	, TUCOMPOSER_BASE_NAME)

#define COpen(FileName, Mode, ExtLibStr) \
	LP3(0xC1E, struct CFHandle *, COpen, STRPTR, FileName, d1, unsigned long, Mode, d2, struct TuComposerExtList *, ExtLibStr, d3, \
	, TUCOMPOSER_BASE_NAME)

#define CClose(CFHandle) \
	LP1(0xC24, ULONG, CClose, struct CFHandle *, CFHandle, d1, \
	, TUCOMPOSER_BASE_NAME)

#define CRead(CFHandle, Buffer, Length) \
	LP3(0xC2A, ULONG, CRead, struct CFHandle *, CFHandle, d1, APTR, Buffer, d2, unsigned long, Length, d3, \
	, TUCOMPOSER_BASE_NAME)

#define CWrite(CFHandle, Buffer, Length) \
	LP3(0xC30, ULONG, CWrite, struct CFHandle *, CFHandle, d1, APTR, Buffer, d2, unsigned long, Length, d3, \
	, TUCOMPOSER_BASE_NAME)

#define CSeek(CFHandle, Position, Relative) \
	LP3(0xC36, ULONG, CSeek, struct CFHandle *, CFHandle, d1, unsigned long, Position, d2, unsigned long, Relative, d3, \
	, TUCOMPOSER_BASE_NAME)

#define CGetInfo(CFHandle, CInfoStr) \
	LP2(0xC3C, ULONG, CGetInfo, struct CFHandle *, CFHandle, d1, struct CruncherInfo *, CInfoStr, d2, \
	, TUCOMPOSER_BASE_NAME)

#endif /*  _INLINE_TUCOMPOSER_H  */
