#ifndef TUCOMPOSER_EXTERNAL_CRUNCHER_H
#define TUCOMPOSER_EXTERNAL_CRUNCHER_H
/*
**  $VER: cruncher.h 31.22 (3.4.99)
**
**  Standard C header for tucomposer.library
**
**  (C) Copyright 1999 by Basty/Seasons
**      All Rights Reserved
*/

#include <stdio.h>

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif /* EXEC_TYPES_H */

#ifndef EXEC_LIBRARIES_H
#include <exec/libraries.h>
#endif /* EXEC_LIBRARIES_H */

#ifndef TUCOMPOSER_TUCOMPOSER_H
#include <tucomposer/tucomposer.h>
#endif /* TUCOMPOSER_TUCOMPOSER_H */

/* This is the external cruncher structure. It is used to decrunch/decode
   any compressed/encoded data (e.g. XPK/XFD/PP/IMP!/etc.) */

/* Cruncher file handle structure used by COpen(), CRead() & co. */
struct CFHandle {
  BPTR   cfh_FHandle;              /* BPTR to the normal DOS file handle */
  struct TuComposerExtList *cfh_ExtLibStr; /* External cruncher used */
  ULONG  cfh_Compressor[4];        /* Cruncher specified data. Not touch ! */
  UBYTE  cfh_Reserved[8];          /* Reserved for future expansion */
}; /* CFHandle */

/* Cruncher info structure used by CGetInfo() */
struct CruncherInfo {
  ULONG   cis_Size;                /* Decompressed file size in bytes */
  ULONG   cis_PackedSize;          /* Compressed file size in bytes */
  struct  StampDate cis_Date;      /* File date of last write access */
  STRPTR  cis_Comment;             /* File comment if that's somehow
                                      supported by the target OS */
  UBYTE   cis_Reserved[16];        /* Reserved for future expansions */
}; /* CruncherInfo */

/* Cruncher library structure (after library structure): */
struct CruncherLibrary {
  struct TuComposerExtLibBase crnl_Library;
}; /* CruncherLibrary */

#endif /* TUCOMPOSER_EXTERNAL_CRUNCHER_H */
