	IFND	TUCOMPOSER_EXTERNAL_EXTERNAL_I
TUCOMPOSER_EXTERNAL_EXTERNAL_I	SET	1
**
**	$Filename: tucomposer/external/external.i $
**	$Release : 31.22 $
**
**
**
**	(C) Copyright 1996-98 by The united Coders (TuC)
**		Main code: Basty/TuC
**		All Rights Reserved
**

		IFND	EXEC_TYPES_I
		include	"exec/types.i"
		ENDC	; EXEC_TYPES_I

		IFND	EXEC_LIBRARIES_I
		include	"exec/libraries.i"
		ENDC	; EXEC_LIBRARIES_I

		IFND	EXEC_LISTS_I
		include	"exec/lists.i"
		ENDC	; EXEC_LISTS_I

		IFND	LIBRARIES_DOS_I
		include	"libraries/dos.i"
		ENDC	; LIBRARIES_DOS_I

		IFND	TUCOMPOSER_TUCOMPOSER_I
		include	"tucomposer/tucomposer.i"
		ENDC	; TUCOMPOSER_TUCOMPOSER_I

* The external libraries ables tucomposer.library to load alien modules,
* tracks, samples, instruments, etc. So you can use an XM-loader, for
* example to import/export FastTracker ][ (from PC, but a great program !!!)
* XM modules. So tucomposer.library can act like a module converter, just
* add some external loaders, load the modules, and save them in an other
* format. Because TuComposer is much more powerful than any other trackers
* I know of, it shouldn't be a problem to import FastTracker ][,
* ScreamTracker ]I[, TFMX, StoneTracker, etc. modules. When exporting,
* don't forget the restrictions of some formats (e.g. ScreamTracker can't
* handle 8-bit panning, for example) and none of the above doesn't support
* 8-bit volumes (maybe TFMX can do, as I don't know about the abilities of
* this format), and ProTracker (clones) just handle octaves 3-5 and only
* 4 channels, while the others can handle up to 32. All except StoneTracker
* (and maybe TFMX) don't support track ordering, they use all pattern
* ordering, which is very unflexible compared to TCM. The hardest thing to
* do, is to import from TCM and export to ProTracker.

* extl_Flags field:
	BITDEF	EXTL,Intern,0		* If bit is set, this is a internal library
	BITDEF	EXTL,Disabled,1		* If bit is set, library has been disabled
	BITDEF	EXTL,Loader,2		* If bit is set, this is a loader
	BITDEF	EXTL,Saver,3		* If bit is set, this is a saver

* tefs_FlagxFlags field:
	BITDEF	TEFS,Update,0		* If set, app must call ExternalUpdateFlags()
								* on flag change
	BITDEF	TEFS,Hidden,1		* Entering data is hidden (e.g. passwords)
	BITDEF	TEFS,FixedValues,2	* Integer values are fixed 16.16 integers,
								* i.e. integers with 1/65536th accuracy.
	BITDEF	TEFS,Disabled,7		* Disabled function. Allows you to code
								* limited shareware versions, or if it's
								* not possible to set this (e.g. because you
								* don't have the hardware)

* Flag structure. Types are usually represented by the desired intuition
* gadgets. It is on you to display these properly. I suggest you using
* MUI, because it does almost all for you.
	STRUCTURE	TuComposerExtFlagStr,0
	UWORD	tefs_NumEntries		* Number of flags
	UWORD	tefs_StructSize		* Size of the structure (for FreeMem())
	APTR	tefs_Flag0Text		* Flag 0 description text
	UBYTE	tefs_Flag0Type		* Type of this flag
	UBYTE	tefs_Flag0Flags		* Flag 0 special flags (look below)
	UWORD	tefs_Flag0Len		* Flag 0 Length of integer/string/file/etc.
								* flag types. If 0 it's just a view gadget,
								* except for EXTFLAG_SLIDER, if it's not zero
								* in this case, tefs_Flag0Values points to
								* an array of tefs_Flag0Len entries with the
								* selectable values, e.g. a frequency slider
								* allowing only 11, 22 and 44kHz.
	LONG	tefs_Flag0Lowest	* Flag 0 lowest value (integer/slider types)
	LONG	tefs_Flag0Highest	* Flag 0 highest value (integer/slider types)
	APTR	tefs_Flag0Default	* Flag 0 default value (string, etc.)
	APTR	tefs_Flag0Values	* Flag 0 slider values (LONG's)
	LABEL	tefs_FlagxText		* Flag x description text
	LABEL	tefs_SIZEOF

* Flag pass structure. This structure is used when you pass the parameters
* to the function.
	STRUCTURE	FlagPass,0
	APTR	flg_Value0			* Flag 0 contents. If this is a integer flag,
								* this is a ULONG with the integer value ent-
								* ered here. If it's a boolean, here will be
								* a -1 or a 0 depending on selection
								* Buttons, cycles and listviews return the
								* number of the array (1 is the first).
	LABEL	flg_Valuex			* Flag x contents. Same rules as for flag 0
	LABEL	flg_SIZEOF

* External library list base structure. Use this structure to access the
* External (and internal) libraries.
	STRUCTURE	TuComposerExtList,MLN_SIZE
	UBYTE	extl_Flags			* Flags (look bitdefs upward)
	BYTE	extl_Pri			* Priority (for sorting)
	APTR	extl_LibBase		* APTR to external library base
	APTR	extl_Directory		* Directory where external lib is placed
	APTR	extl_LibName		* APTR to external library name
	APTR	extl_Descriptor		* Loader descriptor (e.g. for FastTracker ][
								* instruments: "FastTracker ][ Instrument")
	APTR	extl_LoadFlagStr	* List to flag structure for use with your
								* applications, allowing to configure your
								* external loaders or NULL if you don't have
								* any load flags
	APTR	extl_SaveFlagStr	* Same as extl_LoadFlagStr except the
								* save flags
	STRUCT	extl_Reserved,8		* Reserved for future expansions
	LABEL	extl_SIZEOF

* Flag types
EXTFLAG_BOOLEAN		EQU	0		* Boolean (contains TRUE or FALSE)
EXTFLAG_TEXT		EQU	1		* A gadget which contains text in it's press-
								* able borders, which can change. This gadget
								* requires the TEFSF_Update bit to be set.
								* The flag pass structure must contain an
								* APTR to a buffer with a size of
								* tefs_Flag0Len bytes, in which the new text
								* will be stored. The buffer should initially
								* be filled with tefs_Flag0Default.
EXTFLAG_SCREEN		EQU	2		* This is just a signal that here's (in the
								* flag pass structure position) a screen
								* pointer needed. If it's a public screen,
								* you have to lock/unlock it yourself.
EXTFLAG_WINDOW		EQU	3		* This is just a signal that here's (flag
								* pass structure) a window pointer needed.
EXTFLAG_INTEGER		EQU	4		* Integer (contains integer value)
EXTFLAG_SLIDER		EQU	5		* An slider with an value range
EXTFLAG_STRING		EQU	6		* String (contains any legal string)
EXTFLAG_FILENAME	EQU	7		* File name string (read access)
EXTFLAG_DIRECTORY	EQU	8		* Directory name string
EXTFLAG_SAVEFILE	EQU	9		* File name string (write access)
EXTFLAG_BUTTON		EQU	10		* Button type (tefs_FlagText is an APTR-array
								* with tefs_Flag0Len entries). The first
								* entry is the heading text
EXTFLAG_CYCLE		EQU	11		* Cycling (tefs_FlagText is also an array)
EXTFLAG_LISTVIEW	EQU	12		* List view (tefs_FlagText is also an array)
EXTFLAG_RESERVED	EQU	13		* Reserved for future expansions

* The external library base structure. THESE MUST BE PRESENT IN EACH
* EXTERNAL LIBRARY !!!
	STRUCTURE	TuComposerExtLibBase,LIB_SIZE
	BPTR	extb_SegList		* BPTR to DOS segments to UnLoadSeg()
	APTR	extb_TuComposerBase	* APTR to tucomposer.library base
	APTR	extb_ExtLibList		* APTR to external library list
	LABEL	extb_SIZEOF

* Minium external library supported by TuComposer. Libraries below these
* will be ignored
EXTLIB_VERSION		EQU	31
EXTLIB_REVISION		EQU	0

* External types
EXTTYPE_CRUNCHER	EQU	1		* A file cruncher/decruncher (XPK, PP, etc.)
EXTTYPE_DEVICE		EQU	2		* A soundcard device (for Toccata, etc.)
EXTTYPE_RECORDER	EQU	3		* A recording device (Mic-In, MIDI, etc.)
EXTTYPE_MIXER		EQU	4		* A mixing device (High quality mixers, etc.)
EXTTYPE_POSTPROC	EQU 5		* Post processor for mixer (echoes, etc.)
EXTTYPE_MODULE		EQU	6		* A module loader (TCM, XM, S3M, MOD, etc.)
EXTTYPE_SONG		EQU	7		* A song loader (TCM, MED, IT, XM, MOD, etc.)
EXTTYPE_TRACK		EQU	8		* A track loader (TCT, XT, etc.)
EXTTYPE_INSTR		EQU	9		* An instrument loader (TCI, XI, ITI, etc.)
EXTTYPE_SAMPLE		EQU	10		* An sample loader (IFF, WAV, VOC, S3I, etc.)
EXTTYPE_SYNTH		EQU	11		* An synth loader (TCY, MED-Synth, etc.)
EXTTYPE_RESERVED	EQU	12		* Reserved for future expansions

* External library errors used by all external libraries
ERROR_EXTLIB_NOGIVEN	EQU	ERROR_EXTLIB+$0	* External library not given
ERROR_EXTLIB_NOOPEN		EQU	ERROR_EXTLIB+$1	* External library couldn't open
ERROR_EXTLIB_NOMEM		EQU	ERROR_EXTLIB+$2	* Not enough memory for any
											* reason.

	ENDC	; TUCOMPOSER_EXTERNAL_EXTERNAL_I
