	IFND	TUCOMPOSER_EXTERNAL_MIXER_I
TUCOMPOSER_EXTERNAL_MIXER_I	SET	1
**
**	$Filename: tucomposer/external/mixer.i $
**	$Release : 31.22 $
**
**
**
**	(C) Copyright 1997-98 by The united Coders (TuC)
**		Main code: Basty/TuC
**		All Rights Reserved
**

		IFND	EXEC_TYPES_I
		include	"exec/types.i"
		ENDC	; EXEC_TYPES_I

		IFND	EXEC_LIBRARIES_I
		include	"exec/libraries.i"
		ENDC	; EXEC_LIBRARIES_I

		IFND	EXEC_LISTS_I
		include	"exec/lists.i"
		ENDC	; EXEC_LISTS_I

		IFND	LIBRARIES_DOS_I
		include	"libraries/dos.i"
		ENDC	; LIBRARIES_DOS_I

		IFND	TUCOMPOSER_EXTERNAL_EXTERNAL_I
		include	"tucomposer/external/external.i"
		ENDC	; TUCOMPOSER_EXTERNAL_EXTERNAL_I

* Flags for Mixer info:
	BITDEF	MI,StereoSupport,3	* Mixer supports stereo mixing (readable)
	BITDEF	MI,Surround,4		* Mixer supports surround sound (readable)
	BITDEF	MI,PostProcs,5		* Mixer supports post processors

* Flags for Mixer allocation structure:

	BITDEF	MAS,Allocated,0		* Mixer is allocated
	BITDEF	MAS,Mixing,1		* Mixer is currently mixing (i.e. playing)
								* This bit must be set from the soundcard
								* driver when playing starts !
	BITDEF	MAS,Stereo,2		* Mixer is outputting in stereo
	BITDEF	MAS,Frozen,3		* Mixer is frozen (this was invented because
								* post processors, which may temporary
								* stop the mixing due to some delays
								* (e.g. disk writing)

* Flags for the Mixer structure (used by ExternalMixerxxxChannel()):
	BITDEF	MS,Muted,0			* Channel is muted (i.e. processed but not
								* outputted)
	BITDEF	MS,Synth,1			* Start synthetic waveform when old finished
	BITDEF	MS,Loop,2			* Loop being used
	BITDEF	MS,Pingpong,3		* Pingpong loop
	BITDEF	MS,Backwards,4		* Sample is currently playing backwards
	BITDEF	MS,BackLoop,5		* Backward looping
	BITDEF	MS,Surround,6		* Channel in surround mode
	BITDEF	MS,Play,7			* Sample currently playing

* The following structure is returned by AllocMixer() or
* ExternalMixerAlloc():

	STRUCTURE	MixerAllocStruct,0
	APTR	mas_MixLibBase		* APTR to external mixer library base
	APTR	mas_SoundDevLibBase	* APTR to sound device library base which
								* outputs the fuckin'sound !
	APTR	mas_Task			* APTR to task allocated the structure
    STRUCT	mas_PostProcs,MLH_SIZE	* Linked list of post processors
	ULONG	mas_MixRate			* Current mixing rate in Hz (must be set by
								* you before call init & change routines)
	APTR	mas_MixBuf			* APTR to mixing buffer
	ULONG	mas_MixBufSize		* Size of mix buffer(s) (must set by you)
	ULONG	mas_VolumeBoost		* Volume boost (65536 = 100%) (set by you)
	UWORD	mas_LeftVolume		* Left volume (256 = 100%) (set by you)
	UWORD	mas_RightVolume		* Right volume (256 = 100%) (set by you)
	ULONG	mas_Tempo			* Speed of player IRQ in 1/65536 seconds.
								* 131072 means to run the player twice a
								* second, and so on...For BpM you can use
								* the following formula (simple !):
								* 65536*RpB*BpM (RpB = Rows per Beat (4))
	UWORD	mas_MaxChannels		* Maximum number of channels selected
	UBYTE	mas_Flags			* Mixer information flags (only readable)
	UBYTE	mas_Pad				* To longword align the following
	STRUCT	mas_Reserved,16		* Reserved for use by TuComposer
	APTR	mas_UserData		* APTR to user data (for your own purposes)
	LABEL	mas_MixerData		* Mixer specific data follows here
	LABEL	mas_SIZEOF

* The following structure is returned by ExternalMixerGetChannel() and set
* by ExternalMixerSetChannel():
	STRUCTURE	MixerStruct,0
	ULONG	ms_SamplePos		* Current sample position (in samples)
	ULONG	ms_SampleLen		* Current sample length (in samples)
	APTR	ms_SampleData		* APTR to sample data currently playing
	ULONG	ms_SampleRate		* Sample rate of sample
	ULONG	ms_Repeat			* Repeat offset (in samples)
	ULONG	ms_RepLen			* Repeat length (in samples)
	ULONG	ms_RepCount			* Repeat counter (0 for unlimited)
	ULONG	ms_RepCounted		* Counted repeats
	UBYTE	ms_BitDepth			* The bit depth of the sample
	UBYTE	ms_Flags			* Special flags
	UBYTE	ms_Volume			* Volume of sample being playing (0 - $FF)
	UBYTE	ms_Panning			* Panning of sample being playing (0 - $FF)
	STRUCT	ms_Reserved,16		* Reserved for future expansions (resonance
								* filtering, ring modulation, etc.)
	LABEL	ms_SIZEOF

* Mixer library info structure (after library structure):
	STRUCTURE	MixerInfo,extb_SIZEOF
	UBYTE	mix_Flags			* Mixer information flags (only readable)
	UBYTE	mix_Pad				* To longword align the following
	ULONG	mix_DefaultMixRate	* Default mixing rate
	ULONG	mix_DefaultBufSize	* Default mixing buffer size
	ULONG	mix_DefaultBoost	* Default volume boost
	ULONG	mix_MinMixRate		* Lowest mixing rate supported by mixer
	ULONG	mix_MaxMixRate		* Highest mixing rate supported by mixer
	ULONG	mix_MinBufSize		* Smallest buffer size supported
	ULONG	mix_MaxBufSize		* Biggest buffer size supported
	UWORD	mix_MaxChannels		* Maximum number of channels allowed
	STRUCT	mix_Reserved,14		* Reserved ! Do not touch !
	LABEL	mix_SIZEOF			* All below this can be used by you !

* Error codes returned by mixers.

ERROR_EXTLIB_MIXNOALLOC	EQU	ERROR_EXTLIB+$8		* Mixer is not allocated

EXTLIB_MIXER_VERSION	EQU	31	* Current external mixer library version
EXTLIB_MIXER_REVISION	EQU	0	* Current external mixer library revision

	ENDC	; TUCOMPOSER_EXTERNAL_MIXER_I
