#ifndef TUCOMPOSER_EXTERNAL_MODULE_H
#define TUCOMPOSER_EXTERNAL_MODULE_H
/*
**  $VER: module.h 31.22 (3.4.99)
**
**  Standard C header for tucomposer.library
**
**  (C) Copyright 1999 by Basty/Seasons
**      All Rights Reserved
*/

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif /* EXEC_TYPES_H */

#ifndef EXEC_LIBRARIES_H
#include <exec/libraries.h>
#endif /* EXEC_LIBRARIES_H */

#ifndef EXEC_LISTS_H
#include <exec/lists.h>
#endif /* EXEC_LISTS_H */

#ifndef LIBRARIES_DOS_H
#include <libraries/dos.h>
#endif /* LIBRARIES_DOS_H */

#ifndef TUCOMPOSER_TUCOMPOSER_H
#include <tucomposer/tucomposer.h>
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef TUCOMPOSER_EXTERNAL_CRUNCHER_H
#include <tucomposer/external/cruncher.h>
#endif /* TUCOMPOSER_EXTERNAL_CRUNCHER_H */

/* ModuleInfo structure. Got by GetTCModuleInfo(). Version and revision will
   be the same as that of the library if the module doesn't support this. All
   values will be the same as the MHDR fields (i.e. Flags, etc.). */

struct ModuleInfo {
  STRPTR tcmi_FileName;              /* File name of this module */
  STRPTR tcmi_Name;                  /* Module name */
  STRPTR tcmi_Message;               /* Module message (may span multiple
                                        lines and contain ANSI sequences) */
  STRPTR tcmi_Composer;              /* Name of the composer */
  STRPTR tcmi_Style;                 /* APTR to style string (techno, rave,
                                        trance, pop, etc.) */
  STRPTR tcmi_Comment;               /* A short comment from the composer */
  UBYTE  tcmi_Version;               /* Version number of module */
  UBYTE  tcmi_Revision;              /* Revision number of module */
  struct StampDate tcmi_BeginDate;   /* Begin composing date */
  struct StampDate tcmi_EndDate;     /* End composing date */
  UBYTE  tcmi_PlayTimeHours;         /* Playing time of song in hours */
  UBYTE  tcmi_PlayTimeMins;          /* Playing time of song in mins */
  UBYTE  tcmi_PlayTimeSecs;          /* Playing time of song in secs */
  UBYTE  tcmi_PlayTimeHundreds;      /* Playing time of song in 1/100 secs */
  UWORD  tcmi_Songs;                 /* Number of songs in module */
  ULONG  tcmi_Tracks;                /* Number of total tracks */
  UWORD  tcmi_Instruments;           /* Number of instruments */
  ULONG  tcmi_Samples;               /* Number of total samples */
  ULONG  tcmi_Synths;                /* Number of total synths */
  UWORD  tcmi_Envelopes;             /* Number of envelopes */
  UWORD  tcmi_KeyboardDefs;          /* Number of keyboard definitions */
  UWORD  tcmi_ArpeggioDefs;          /* Number of arpeggio definitions */
  UWORD  tcmi_Channels;              /* Maximum number of channels allowed */
  UBYTE  tcmi_CompFlags;             /* Compatibility flags. See upwards */
  UBYTE  tcmi_Flags;                 /* Flags. */
}; /* ModuleInfo */

/* Module library structure (after library structure): */
struct ModuleLibrary {
  struct TuComposerExtLibBase modl_Library;
}; /* ModuleLibrary */

#define EXTLIB_MODULE_VERSION   31   /* Current external module library
                                        version */
#define EXTLIB_MODULE_REVISION   0   /* Current external module library
                                        revision */

#endif /* TUCOMPOSER_EXTERNAL_MODULE_H */
