#ifndef TUCOMPOSER_EXTERNAL_POSTPROC_H
#define TUCOMPOSER_EXTERNAL_POSTPROC_H
/*
**  $VER: postproc.h 31.22 (1.3.00)
**
**  Standard C header for tucomposer.library
**
**  (C) Copyright 2000 by Basty/Seasons
**      All Rights Reserved
*/

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif /* EXEC_TYPES_H */

#ifndef EXEC_LIBRARIES_H
#include <exec/libraries.h>
#endif /* EXEC_LIBRARIES_H */

#ifndef EXEC_LISTS_H
#include <exec/lists.h>
#endif /* EXEC_LISTS_H */

#ifndef LIBRARIES_DOS_H
#include <libraries/dos.h>
#endif /* LIBRARIES_DOS_H */

#ifndef TUCOMPOSER_EXTERNAL_EXTERNAL_H
#include <tucomposer/external/external.h>
#endif /* TUCOMPOSER_EXTERNAL_EXTERNAL_H */

#ifndef TUCOMPOSER_EXTERNAL_MIXER_H
#include <tucomposer/external/mixer.h>
#endif /* TUCOMPOSER_EXTERNAL_MIXER_H */

/* Flags for post processor info: */
#define PASB_Update         0   /* needs to call ChangePostProcessor()
                                   if mixing frequency changes. */

#define PASF_Update         (1<<PASB_Update)

/* The following structure is returned by AllocPostProcessor() or
   ExternalPostProcAlloc(): */

struct PostProcAllocStruct {
  struct MinNode pas_Node;
  UBYTE  pas_Flags;             /* Special flags (see above) */
  BYTE   pas_Pri;               /* Sorting priority */
  struct PostProcInfo *pas_PostProcLibBase; /* Ptr to external post processor
                                   library base */
  struct MixerAllocStruct *pas_MixAllocStr; /* Ptr to mixer alloc struct */
  UBYTE  pas_Reserved[16];      /* Reserved for use by TuComposer */
                                /* Post processor specific data follows
                                   here */
}; /* PostProcAllocStruct */

/* Post processor library info structure (after library structure): */
struct PostProcInfo {
  struct TuComposerExtLibBase pop_Library;
  UBYTE  pop_Flags;             /* Post processor information flags
                                   (only readable) */
  UBYTE  pop_Pad;               /* To longword align the following */
  UBYTE  pop_Reserved[14];      /* Reserved ! Do not touch ! */
}; /* PostProcInfo */

/* Error codes returned by post processors. */

#define ERROR_EXTLIB_POSTNOALLOC ERROR_EXTLIB+0xC /* Post processor is not
                                   allocated */
#define EXTLIB_POSTPROC_VERSION 31 /* Current external post processor
                                   library version */
#define EXTLIB_POSTPROC_REVISION 0 /* Current external post processor
                                   library revision */

#endif /* TUCOMPOSER_EXTERNAL_POSTPROC_H */
