#ifndef TUCOMPOSER_EXTERNAL_SONG_H
#define TUCOMPOSER_EXTERNAL_SONG_H
/*
**  $VER: song.h 31.22 (3.4.99)
**
**  Standard C header for tucomposer.library
**
**  (C) Copyright 1999 by Basty/Seasons
**      All Rights Reserved
*/

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif /* EXEC_TYPES_H */

#ifndef EXEC_LIBRARIES_H
#include <exec/libraries.h>
#endif /* EXEC_LIBRARIES_H */

#ifndef EXEC_LISTS_H
#include <exec/lists.h>
#endif /* EXEC_LISTS_H */

#ifndef LIBRARIES_DOS_H
#include <libraries/dos.h>
#endif /* LIBRARIES_DOS_H */

#ifndef TUCOMPOSER_TUCOMPOSER_H
#include <tucomposer/tucomposer.h>
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef TUCOMPOSER_EXTERNAL_CRUNCHER_H
#include <tucomposer/external/cruncher.h>
#endif /* TUCOMPOSER_EXTERNAL_CRUNCHER_H */

/* SongInfo structure. Got by GetSongInfo(). Version and revision will
   be the same as that of the library if the song doesn't support this. All
   values will be the same as the SHDR fields (i.e. Flags, etc.). */
struct SongInfo {
  STRPTR soi_FileName;              /* File name of this song */
  STRPTR soi_Name;                  /* Song name. */
  STRPTR soi_Message;               /* Song message (may span multiple
                                       lines and contain ANSI sequences) */
  STRPTR soi_Composer;              /* Name of the composer */
  STRPTR soi_Style;                 /* APTR to style string (techno, rave,
                                       trance, pop, etc.) */
  STRPTR soi_Comment;               /* A short comment from the composer */
  UBYTE  soi_Version;               /* Version of song */
  UBYTE  soi_Revision;              /* Revision of song */
  struct StampDate soi_BeginDate;   /* Begin composing date */
  struct StampDate soi_EndDate;     /* Finish composing date */
  UBYTE  soi_PlayTimeHours;         /* Playing time of song in hours */
  UBYTE  soi_PlayTimeMins;          /* Playing time of song in mins */
  UBYTE  soi_PlayTimeSecs;          /* Playing time of song in secs */
  UBYTE  soi_PlayTimeHundreds;      /* Playing time of song in 1/100 secs */
  UWORD  soi_Tracks;                /* Number of tracks assigned with song */
  UWORD  soi_Instruments;           /* Number of instruments */
  ULONG  soi_Samples;               /* Number of total samples */
  ULONG  soi_Synths;                /* Number of total synths */
  UWORD  soi_Envelopes;             /* Number of envelopes */
  UWORD  soi_KeyboardDefs;          /* Number of keyboard definitions */
  UWORD  soi_ArpeggioDefs;          /* Number of arpeggio definitions */
  UWORD  soi_GoSubStackSize;        /* Stack size for GoSub cmd */
  UWORD  soi_LoopStackSize;         /* Stack size for pattern loop cmd */
  UBYTE  soi_CompFlags;             /* Compatibility flags. See upwards */
  UBYTE  soi_Flags;                 /* Flags. */
  UWORD  soi_Channels;              /* Channels used */
  UWORD  soi_Frames;                /* Initial tempo */
  UBYTE  soi_SpeedMul;              /* Initial speed multiplier */
  UBYTE  soi_SpeedDiv;              /* Initial speed divider */
  UWORD  soi_SPDSpeed;              /* Initial SPD speed */
  UWORD  soi_BPMTempo;              /* Initial BPM tempo */
  UWORD  soi_BPMSpeed;              /* Initial BPM speed */
  UWORD  soi_FramesLowerLimit;      /* Frames lower limit */
  UWORD  soi_FramesUpperLimit;      /* Frames upper limit */
  UWORD  soi_SPDLowerLimit;         /* SPD lower limit */
  UWORD  soi_SPDUpperLimit;         /* SPD upper limit */
  UWORD  soi_BPMTempoLowerLimit;    /* BPM tempo lower limit */
  UWORD  soi_BPMTempoUpperLimit;    /* BPM tempo upper limit */
  UWORD  soi_BPMSpeedLowerLimit;    /* BPM speed lower limit */
  UWORD  soi_BPMSpeedUpperLimit;    /* BPM speed upper limit */
  UBYTE  soi_GlobalVolume;          /* Default global volume */
  UBYTE  soi_GlobalSubVol;          /* Default global sub volume */
  UBYTE  soi_GlobalPanning;         /* Default global panning */
  UBYTE  soi_GlobalSubPan;          /* Default global sub panning */
}; /* SongInfo */

/* Song library structure (after library structure): */
struct SongLibrary {
  struct TuComposerExtLibBase songl_Library;
}; /* SongLibrary */

#define EXTLIB_SONG_VERSION    31   /* Current external song library
                                       version */
#define EXTLIB_SONG_REVISION    0   /* Current external song library
                                       revision */

#endif /* TUCOMPOSER_EXTERNAL_SONG_H */
