#ifndef TUCOMPOSER_EXTERNAL_TRACK_H
#define TUCOMPOSER_EXTERNAL_TRACK_H
/*
**  $VER: track.h 31.22 (3.4.99)
**
**  Standard C header for tucomposer.library
**
**  (C) Copyright 1999 by Basty/Seasons
**      All Rights Reserved
*/

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif /* EXEC_TYPES_H */

#ifndef EXEC_LIBRARIES_H
#include <exec/libraries.h>
#endif /* EXEC_LIBRARIES_H */

#ifndef EXEC_LISTS_H
#include <exec/lists.h>
#endif /* EXEC_LISTS_H */

#ifndef LIBRARIES_DOS_H
#include <libraries/dos.h>
#endif /* LIBRARIES_DOS_H */

#ifndef TUCOMPOSER_TUCOMPOSER_H
#include <tucomposer/tucomposer.h>
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef TUCOMPOSER_EXTERNAL_CRUNCHER_H
#include <tucomposer/external/cruncher.h>
#endif /* TUCOMPOSER_EXTERNAL_CRUNCHER_H */

/* TrackInfo structure. Got by GetTrackInfo(). Version and revision will
   be the same as that of the library if the track doesn't support this. All
   values will be the same as the THDR fields (i.e. Flags, etc.). */

struct TrackInfo {
  STRPTR trki_FileName;      /* Track file name (if any) */
  STRPTR trki_Name;          /* Track name (if any) */
  UBYTE  trki_Version;       /* Version number */
  UBYTE  trki_Revision;      /* Revision number */
  UWORD  trki_Length;        /* Last row of track */
  UBYTE  trki_Volume;        /* Track global volume */
  UBYTE  trki_SubVolume;     /* Sub volume */
  BYTE   trki_Panning;       /* Track panning */
  UBYTE  trki_SubPanning;    /* Sub panning */
  BYTE   trki_Transpose;     /* Transposing of track */
  UBYTE  trki_CompFlags;     /* Compatibility flags */
  UWORD  trki_Flags;         /* Track flags, see bit defs */
  UWORD  trki_Frames;        /* Number of frames per row (default 6) */
  UBYTE  trki_SpeedMul;      /* Speed multiplier (allowing you e.g. 2/3) */
  UBYTE  trki_SpeedDiv;      /* Speed divider (for multiplier) */
  UWORD  trki_SPDSpeed;      /* Track SPD */
  UWORD  trki_BPMTempo;      /* Track BPM tempo (number of rows of a beat) */
  UWORD  trki_BPMSpeed;      /* Track BPM speed. */
}; /* TrackInfo */

/* Track library structure (after library structure): */
struct TrackLibrary {
  struct TuComposerExtLibBase trkl_Library;
}; /* TrackLibrary */

#define EXTLIB_TRACK_VERSION 31   /* Current external track library
                                     version */
#define EXTLIB_TRACK_REVISION 0   /* Current external track library
                                     revision */

#endif /* TUCOMPOSER_EXTERNAL_TRACK_H */
