	IFND	TUCOMPOSER_INSTR_I
TUCOMPOSER_INSTR_I	SET	1
**
**	$Filename: tucomposer/instr.i $
**	$Release : 31.22 $
**
**
**
**	(C) Copyright 1996-98 by The united Coders (TuC)
**      Main code: Basty/TuC
**		All Rights Reserved
**

		IFND	EXEC_TYPES_I
		include	"exec/types.i"
		ENDC	; EXEC_TYPES_I

		IFND	EXEC_NODES_I
		include	"exec/nodes.i"
		ENDC	; EXEC_NODES_I

		IFND	EXEC_LISTS_I
		include	"exec/lists.i"
		ENDC	; EXEC_LISTS_I

		IFND	TUCOMPOSER_TUCOMPOSER_I
		include	"tucomposer/tucomposer.i"
		ENDC	; TUCOMPOSER_TUCOMPOSER_I

* Bit definitions for tci_CompFlags:
	BITDEF	TCIC,LockInsWave,0		* Instrument wave is locked as in MOD,
									* but volume/panning/etc. is taken,
									* if both bits are clear it will handle
									* like S3M/IT, i.e. instrument is changed
	BITDEF	TCIC,AffectChanPan,1	* Instrument panning affects channel
									* panning (like IT does)
	BITDEF	TCIC,PrevSample,2		* If no sample is given in the keyboard
									* table, the previous one is used
	BITDEF	TCIC,SeparateSamples,3	* Samples are separate as in IT (else
									* handles like XM)

* Bit definitions for tci_Flags:
	BITDEF	TCI,NoTranspose,0		* If bit is set, the instrument can't
									* be transposed by the position list
	BITDEF	TCI,PortaSlideEnv,1		* If bit is set, the values in the
									* slide envelope will be portamento
									* slide values, else they will be a
									* transpose & finetune
	BITDEF	TCI,LinearSlideEnv,2	* If bit is set, use linear frequence
									* table for slide envelope if portamento
									* mode is activated
	BITDEF	TCI,DefaultPanning,4	* If bit is set, default instrument
									* panning is used and override any
									* sample settings.
	BITDEF	TCI,SurroundPanning,5	* If bit is set, default instr pan is
									* surround panning.
	BITDEF	TCI,NoInstrTranspose,6	* Instrument is not transposeable via
									* the order's instrument transpose.

* Bit definitions for tci_EnvUsageFlags:
	BITDEF	TCIEU,UseVolumeEnv,0	* Use (reload) volume envelope
	BITDEF	TCIEU,UsePanningEnv,1	* Use (reload) panning envelope
	BITDEF	TCIEU,UseSlideEnv,2		* Use (reload) slide envelope
	BITDEF	TCIEU,UseVibratoEnv,3	* Use (reload) vibrato envelope
	BITDEF	TCIEU,UseTremoloEnv,4	* Use (reload) tremolo envelope
	BITDEF	TCIEU,UsePannoloEnv,5	* Use (reload) pannolo envelope
	BITDEF	TCIEU,UseChannoloEnv,6	* Use (reload) channolo envelope
	BITDEF	TCIEU,UseSpenoloEnv,7	* Use (reload) spenolo envelope
	BITDEF	TCIEU,UseTTremolo,8		* Use (reload) track tremolo envelope
	BITDEF	TCIEU,UseTPannolo,9		* Use (reload) track pannolo envelope
	BITDEF	TCIEU,UseGTremolo,10	* Use (reload) global tremolo envelope
	BITDEF	TCIEU,UseGPannolo,11	* Use (reload) global pannolo envelope

* Bit definitions for tci_EnvProcFlags:
	BITDEF	TCIEP,ProcVolumeEnv,0	* Add first, then get volume env. value
	BITDEF	TCIEP,ProcPanningEnv,1	* Add first, then get panning env. value
	BITDEF	TCIEP,ProcSlideEnv,2	* Add first, then get slide env. value
	BITDEF	TCIEP,ProcVibratoEnv,3	* Add first, then get vibrato env. value
	BITDEF	TCIEP,ProcTremoloEnv,4	* Add first, then get tremolo env. value
	BITDEF	TCIEP,ProcPannoloEnv,5	* Add first, then get pannolo env. value
	BITDEF	TCIEP,ProcChannoloEnv,6	* Add first, then get channolo env. value
	BITDEF	TCIEP,ProcSpenoloEnv,7	* Add first, then get spenolo env. value
	BITDEF	TCIEP,ProcTTremolo,8	* Add first, then get track tremolo val
	BITDEF	TCIEP,ProcTPannolo,9	* Add first, then get track pannolo val
	BITDEF	TCIEP,ProcGTremolo,10	* Add first, then get global tremolo val
	BITDEF	TCIEP,ProcGPannolo,11	* Add first, then get global pannolo val

* Bit definitions for tci_EnvRetrigFlags:
	BITDEF	TCIER,NotRetrigVolEnv,0	* Not retrigger volume envelope
	BITDEF	TCIER,NotRetrigPanEnv,1	* Not retrigger panning envelope
	BITDEF	TCIER,NotRetrigSldEnv,2	* Not retrigger slide envelope
	BITDEF	TCIER,NotRetrigVibEnv,3	* Not retrigger vibrato envelope
	BITDEF	TCIER,NotRetrigTrmEnv,4	* Not retrigger tremolo envelope
	BITDEF	TCIER,NotRetrigPnoEnv,5	* Not retrigger pannolo envelope
	BITDEF	TCIER,NotRetrigChnEnv,6	* Not retrigger channolo envelope
	BITDEF	TCIER,NotRetrigSpnEnv,7	* Not retrigger spenolo envelope
	BITDEF	TCIER,NotRetrigTTrm,8	* Not retrigger track tremolo envelope
	BITDEF	TCIER,NotRetrigTPan,9	* Not retrigger track pannolo envelope
	BITDEF	TCIER,NotRetrigGTrm,10	* Not retrigger global tremolo envelope
	BITDEF	TCIER,NotRetrigGPan,11	* Not retrigger global pannolo envelope

* Bit definitions for tci_EnvRandomFlags:
	BITDEF	TCIER,RandomVolEnv,0	* Randomize volume envelope, if bit set
	BITDEF	TCIER,RandomPanEnv,1	* Randomize panning envelope, if bit set
	BITDEF	TCIER,RandomSlideEnv,2	* Randomize slide envelope, if bit set
	BITDEF	TCIER,RandomVibEnv,3	* Randomize vibrato envelope, if bit set
	BITDEF	TCIER,RandomTremEnv,4	* Randomize tremolo envelope, if bit set
	BITDEF	TCIER,RandomPannoEnv,5	* Randomize pannolo envelope, if bit set
	BITDEF	TCIER,RandomChanEnv,6	* Randomize channolo envelope, if bit set
	BITDEF	TCIER,RandomSpenEnv,7	* Randomize spenolo envelope, if bit set
	BITDEF	TCIER,RandomTTrmEnv,8	* Randomize track tremolo envelope
	BITDEF	TCIER,RandomTPanEnv,9	* Randomize track pannolo envelope
	BITDEF	TCIER,RandomGTrmEnv,10	* Randomize global tremolo envelope
	BITDEF	TCIER,RandomGPanEnv,11	* Randomize global pannolo envelope

* Bit definitions for tci_EnvRndDelayFlags:
	BITDEF	TCIER,RndDelayVolEnv,0	* Speed is delay randomize volume env.
	BITDEF	TCIER,RndDelayPanEnv,1	* Speed is delay randomize panning env.
	BITDEF	TCIER,RndDelaySldEnv,2	* Speed is delay randomize slide env.
	BITDEF	TCIER,RndDelayVibEnv,3	* Speed is delay randomize vibrato env.
	BITDEF	TCIER,RndDelayTremEnv,4	* Speed is delay randomize tremolo env.
	BITDEF	TCIER,RndDelayPanoEnv,5	* Speed is delay randomize pannolo env.
	BITDEF	TCIER,RndDelayChanEnv,6	* Speed is delay randomize channolo env.
	BITDEF	TCIER,RndDelaySpenEnv,7	* Speed is delay randomize spenolo env.
	BITDEF	TCIER,RndDelayTTrmEnv,8	* Speed is delay rand. track tremolo env.
	BITDEF	TCIER,RndDelayTPanEnv,9	* Speed is delay rand. track pannolo env.
	BITDEF	TCIER,RndDelayGTrEnv,10	* Speed is delay rand. global tremolo env.
	BITDEF	TCIER,RndDelayGPnEnv,11	* Speed is delay rand. global pannolo env.

* Bit definitions for tci_DCT:
	BITDEF	DCT,InstrNoteOR,0		* Check for duplicate OR instrument notes
	BITDEF	DCT,SampleNoteOR,1		* Check for duplicate OR sample notes
	BITDEF	DCT,InstrOR,2			* Check for duplicate OR instruments
	BITDEF	DCT,SampleOR,3			* Check for duplicate OR samples
	BITDEF	DCT,InstrNoteAND,4		* Check for duplicate AND instr notes
	BITDEF	DCT,SampleNoteAND,5		* Check for duplicate AND sample notes
	BITDEF	DCT,InstrAND,6			* Check for duplicate AND instruments
	BITDEF	DCT,SampleAND,7			* Check for duplicate AND samples

* Bit definitions for tci_MIDIFlags:
	BITDEF	MIDI,TickQuantize,0		* Tick quantize (insert note delays)
	BITDEF	MIDI,NoteOff,1			* Record Note-Off (keyoff note)
	BITDEF	MIDI,Velocity,2			* Record velocity
	BITDEF	MIDI,Aftertouch,3		* Record aftertouch
	BITDEF	MIDI,ExtSync,4			* External sync when recording
	BITDEF	MIDI,Enable,7			* MIDI enabled

* Bit definitions for SwapInstrInModule():
	BITDEF	STIM,Swap,0				* If bit set, swap instrument data
	BITDEF	STIM,Update,1			* If bit set, update tracks

* Bit definitions for tcie_Flags:
	BITDEF	TCIE,Loop,0				* If bit is set, envelope will be looped
	BITDEF	TCIE,Sustain,1			* If bit is set, envelope will have a
									* sustain point
	BITDEF	TCIE,Pingpong,2			* Loop in ping pong mode
	BITDEF	TCIE,SustainPingpong,3	* Sustain loop in ping pong mode

* Bit definitions for SwapEnvelopeInModule():
	BITDEF	SEIM,Swap,0				* If bit set, swap envelope data
	BITDEF	SEIM,Update,1			* If bit set, update instruments

* Bit definitions for SwapKeyboardInModule():
	BITDEF	SKIM,Swap,0				* If bit set, swap keyboard def data
	BITDEF	SKIM,Update,1			* If bit set, update instruments

* Bit definitions for tcia_Flags:
	BITDEF	TCIA,Loop,0				* If bit is set, arpeggio loop is used
	BITDEF	TCIA,Sustain,1			* If bit is set, sustain tick is used
	BITDEF	TCIA,Pingpong,2			* Arpeggio structure will be played in
									* ping pong mode (if loop enabled)
	BITDEF	TCIA,SustainPingpong,3	* If set, sustain ping pong is used

* Bit definitions for SwapArpeggioInModule():
	BITDEF	SAIM,Swap,0				* If bit set, swap arpeggio def data
	BITDEF	SAIM,Update,1			* If bit set, update instruments

* Bit definitions for InsertEnvPoint() and DeleteEnvPoint() flags
	BITDEF	ENV,PointsOnly,0		* If bit is set, only the points will be
									* affected, else the envelope's length
									* will be affected, too.

* Bit definitions for InsertArpeggioTick() and DeleteArpeggioTick() flags
	BITDEF	ENV,TicksOnly,0			* If bit is set, only the ticks will be
									* affected, else the arpeggio envelope's
									* length will also be affected.

* Bit definitions for AddInstrEnvelopes():
	BITDEF	ENV,Tail,0				* Append envelopes else insert them
									* at the beginning

* Envelope data structure, contains envelope coordinate data.
	STRUCTURE	TuComposerInstrEnvData,0
	WORD	tcied_Point0Y			* Value of envelope point 0
	LABEL	tcied_Points			* Position/Value of envelope point x
	LABEL	tcied_SIZEOF

* Envelope node structure, contains envelope node point data.
	STRUCTURE	TuComposerInstrEnvNode,0
	UWORD	tcien_Node0X			* Value of envelope node point 0
	LABEL	tcien_Nodes				* Value of envelope node point x
	LABEL	tcien_SIZEOF

* Envelope structure, all envelopes have this structure.
	STRUCTURE	TuComposerInstrEnvelope,MLN_SIZE
	UWORD	tcie_Flags				* Envelope Flags
	APTR	tcie_Data				* Pointer to envelope data
	APTR	tcie_NodePoints			* Pointer to nodes or NULL if none
	UWORD	tcie_NumNodes			* Number of node points
	UWORD	tcie_NumPoints			* Number of envelope points
	UWORD	tcie_Tempo				* Envelope tempo in ticks (default is 1)
	UWORD	tcie_SustainStart		* Sustain start point
	UWORD	tcie_SustainEnd			* Sustain end point
	UWORD	tcie_SustainCount		* Sustain loop counter
	UWORD	tcie_LoopStart			* Loop start point
	UWORD	tcie_LoopEnd			* Loop end point
	UWORD	tcie_LoopCount			* Loop counter
	WORD	tcie_LowestValue		* Lowest random value
	WORD	tcie_HighestValue		* Highest random value
	STRUCT	tcie_UnknownChunks,MLH_SIZE	* Linked list of unknown chunks
	STRUCT	tcie_Reserved,8			* Reserved for future expansions
	APTR	tcie_UserData			* For your own purposes
	LABEL	tcie_SIZEOF

* Default values for envelopes
DEFAULT_ENVPOINTS		EQU	64		* Default number of points is 64
DEFAULT_ENVTEMPO		EQU	1		* Default tempo is every tick
DEFAULT_VOLUMESCALE		EQU	$7FFF	* Default scale for volume envelope
DEFAULT_PANNINGSCALE	EQU	$1FFF	* Default scale for panning envelope
DEFAULT_SLIDESCALE		EQU	$0100	* Default scale for slide envelope
DEFAULT_VIBRATOSCALE	EQU	$0100	* Default scale for (auto) vibratos
DEFAULT_ENVNODES		EQU	12		* Defaults are 12 node points

* Waveform limitations
MAX_SCALE		EQU	$7FFF			* Maximum scale of waveform
SCALE_INVALID	EQU	MAX_SCALE+1		* Invalid scale values

* Waveform creations
SCALE_INVERT	EQU	$80000000		* If this is added, the outputted graph
									* will be inverted, e.g. $80000FFF will
									* create an inverted cosine wave, if
									* you would specify ENVL_COSINE

* Waveform (CreateEnvelope() & ClearEnvelope() & FillWaveform()) types
ENVL_EMPTY			EQU	0			* Create empty envelope
ENVL_SINE			EQU	1			* Create sine envelope
ENVL_COSINE			EQU	2			* Create cosine envelope
ENVL_RAMP			EQU	3			* Create ramping (down) envelope
ENVL_SQUARE			EQU	4			* Create square envelope
ENVL_TRIANGLE		EQU	5			* Create triangle envelope
ENVL_SAWTOOTH		EQU	6			* Create sawtooth envelope
ENVL_LAST			EQU	6			* Last valid number of envelope
ENVL_INVALID		EQU	ENVL_LAST+1	* Numbers below are invalid and entering
									* them cause an empty envelope to be
									* generated. However, in future versions
									* they may generate something.

* Keyboard definitions structure. C-0 is first entry. B-9 is 120th entry.
	STRUCTURE	TuComposerInstrKeyboard,MLN_SIZE
	UWORD	tcik_Sample_C_0			* Sample number for C-0
	UBYTE	tcik_Octave_C_0			* Octave number for C-0
	UBYTE	tcik_Note_C_0			* Note number for C-0
	UWORD	tcik_Sample_C_SHARP_0	* Sample number for C#0
	UBYTE	tcik_Octave_C_SHARP_0	* Octave number for C#0
	UBYTE	tcik_Note_C_SHARP_0		* Note number for C#0
	UWORD	tcik_Sample_D_0			* Sample number for D-0
	UBYTE	tcik_Octave_D_0			* Octave number for D-0
	UBYTE	tcik_Note_D_0			* Note number for D-0
	UWORD	tcik_Sample_D_SHARP_0	* Sample number for D#0
	UBYTE	tcik_Octave_D_SHARP_0	* Octave number for D#0
	UBYTE	tcik_Note_D_SHARP_0		* Note number for D#0
	UWORD	tcik_Sample_E_0			* Sample number for E-0
	UBYTE	tcik_Octave_E_0			* Octave number for E-0
	UBYTE	tcik_Note_E_0			* Note number for E-0
	UWORD	tcik_Sample_F_0			* Sample number for F-0
	UBYTE	tcik_Octave_F_0			* Octave number for F-0
	UBYTE	tcik_Note_F_0			* Note number for F-0
	UWORD	tcik_Sample_F_SHARP_0	* Sample number for F#0
	UBYTE	tcik_Octave_F_SHARP_0	* Octave number for F#0
	UBYTE	tcik_Note_F_SHARP_0		* Note number for F#0
	UWORD	tcik_Sample_G_0			* Sample number for G-0
	UBYTE	tcik_Octave_G_0			* Octave number for G-0
	UBYTE	tcik_Note_G_0			* Note number for G-0
	UWORD	tcik_Sample_G_SHARP_0	* Sample number for G#0
	UBYTE	tcik_Octave_G_SHARP_0	* Octave number for G#0
	UBYTE	tcik_Note_G_SHARP_0		* Note number for G#0
	UWORD	tcik_Sample_A_0			* Sample number for A-0
	UBYTE	tcik_Octave_A_0			* Octave number for A-0
	UBYTE	tcik_Note_A_0			* Note number for A-0
	UWORD	tcik_Sample_A_SHARP_0	* Sample number for A#0
	UBYTE	tcik_Octave_A_SHARP_0	* Octave number for A#0
	UBYTE	tcik_Note_A_SHARP_0		* Note number for A#0
	UWORD	tcik_Sample_B_0			* Sample number for B-0
	UBYTE	tcik_Octave_B_0			* Octave number for B-0
	UBYTE	tcik_Note_B_0			* Note number for B-0
	UWORD	tcik_Sample_C_1			* Sample number for C-1
	UBYTE	tcik_Octave_C_1			* Octave number for C-1
	UBYTE	tcik_Note_C_1			* Note number for C-1
	UWORD	tcik_Sample_C_SHARP_1	* Sample number for C#1
	UBYTE	tcik_Octave_C_SHARP_1	* Octave number for C#1
	UBYTE	tcik_Note_C_SHARP_1		* Note number for C#1
	UWORD	tcik_Sample_D_1			* Sample number for D-1
	UBYTE	tcik_Octave_D_1			* Octave number for D-1
	UBYTE	tcik_Note_D_1			* Note number for D-1
	UWORD	tcik_Sample_D_SHARP_1	* Sample number for D#1
	UBYTE	tcik_Octave_D_SHARP_1	* Octave number for D#1
	UBYTE	tcik_Note_D_SHARP_1		* Note number for D#1
	UWORD	tcik_Sample_E_1			* Sample number for E-1
	UBYTE	tcik_Octave_E_1			* Octave number for E-1
	UBYTE	tcik_Note_E_1			* Note number for E-1
	UWORD	tcik_Sample_F_1			* Sample number for F-1
	UBYTE	tcik_Octave_F_1			* Octave number for F-1
	UBYTE	tcik_Note_F_1			* Note number for F-1
	UWORD	tcik_Sample_F_SHARP_1	* Sample number for F#1
	UBYTE	tcik_Octave_F_SHARP_1	* Octave number for F#1
	UBYTE	tcik_Note_F_SHARP_1		* Note number for F#1
	UWORD	tcik_Sample_G_1			* Sample number for G-1
	UBYTE	tcik_Octave_G_1			* Octave number for G-1
	UBYTE	tcik_Note_G_1			* Note number for G-1
	UWORD	tcik_Sample_G_SHARP_1	* Sample number for G#1
	UBYTE	tcik_Octave_G_SHARP_1	* Octave number for G#1
	UBYTE	tcik_Note_G_SHARP_1		* Note number for G#1
	UWORD	tcik_Sample_A_1			* Sample number for A-1
	UBYTE	tcik_Octave_A_1			* Octave number for A-1
	UBYTE	tcik_Note_A_1			* Note number for A-1
	UWORD	tcik_Sample_A_SHARP_1	* Sample number for A#1
	UBYTE	tcik_Octave_A_SHARP_1	* Octave number for A#1
	UBYTE	tcik_Note_A_SHARP_1		* Note number for A#1
	UWORD	tcik_Sample_B_1			* Sample number for B-1
	UBYTE	tcik_Octave_B_1			* Octave number for B-1
	UBYTE	tcik_Note_B_1			* Note number for B-1
	UWORD	tcik_Sample_C_2			* Sample number for C-2
	UBYTE	tcik_Octave_C_2			* Octave number for C-2
	UBYTE	tcik_Note_C_2			* Note number for C-2
	UWORD	tcik_Sample_C_SHARP_2	* Sample number for C#2
	UBYTE	tcik_Octave_C_SHARP_2	* Octave number for C#2
	UBYTE	tcik_Note_C_SHARP_2		* Note number for C#2
	UWORD	tcik_Sample_D_2			* Sample number for D-2
	UBYTE	tcik_Octave_D_2			* Octave number for D-2
	UBYTE	tcik_Note_D_2			* Note number for D-2
	UWORD	tcik_Sample_D_SHARP_2	* Sample number for D#2
	UBYTE	tcik_Octave_D_SHARP_2	* Octave number for D#2
	UBYTE	tcik_Note_D_SHARP_2		* Note number for D#2
	UWORD	tcik_Sample_E_2			* Sample number for E-2
	UBYTE	tcik_Octave_E_2			* Octave number for E-2
	UBYTE	tcik_Note_E_2			* Note number for E-2
	UWORD	tcik_Sample_F_2			* Sample number for F-2
	UBYTE	tcik_Octave_F_2			* Octave number for F-2
	UBYTE	tcik_Note_F_2			* Note number for F-2
	UWORD	tcik_Sample_F_SHARP_2	* Sample number for F#2
	UBYTE	tcik_Octave_F_SHARP_2	* Octave number for F#2
	UBYTE	tcik_Note_F_SHARP_2		* Note number for F#2
	UWORD	tcik_Sample_G_2			* Sample number for G-2
	UBYTE	tcik_Octave_G_2			* Octave number for G-2
	UBYTE	tcik_Note_G_2			* Note number for G-2
	UWORD	tcik_Sample_G_SHARP_2	* Sample number for G#2
	UBYTE	tcik_Octave_G_SHARP_2	* Octave number for G#2
	UBYTE	tcik_Note_G_SHARP_2		* Note number for G#2
	UWORD	tcik_Sample_A_2			* Sample number for A-2
	UBYTE	tcik_Octave_A_2			* Octave number for A-2
	UBYTE	tcik_Note_A_2			* Note number for A-2
	UWORD	tcik_Sample_A_SHARP_2	* Sample number for A#2
	UBYTE	tcik_Octave_A_SHARP_2	* Octave number for A#2
	UBYTE	tcik_Note_A_SHARP_2		* Note number for A#2
	UWORD	tcik_Sample_B_2			* Sample number for B-2
	UBYTE	tcik_Octave_B_2			* Octave number for B-2
	UBYTE	tcik_Note_B_2			* Note number for B-2
	UWORD	tcik_Sample_C_3			* Sample number for C-3
	UBYTE	tcik_Octave_C_3			* Octave number for C-3
	UBYTE	tcik_Note_C_3			* Note number for C-3
	UWORD	tcik_Sample_C_SHARP_3	* Sample number for C#3
	UBYTE	tcik_Octave_C_SHARP_3	* Octave number for C#3
	UBYTE	tcik_Note_C_SHARP_3		* Note number for C#3
	UWORD	tcik_Sample_D_3			* Sample number for D-3
	UBYTE	tcik_Octave_D_3			* Octave number for D-3
	UBYTE	tcik_Note_D_3			* Note number for D-3
	UWORD	tcik_Sample_D_SHARP_3	* Sample number for D#3
	UBYTE	tcik_Octave_D_SHARP_3	* Octave number for D#3
	UBYTE	tcik_Note_D_SHARP_3		* Note number for D#3
	UWORD	tcik_Sample_E_3			* Sample number for E-3
	UBYTE	tcik_Octave_E_3			* Octave number for E-3
	UBYTE	tcik_Note_E_3			* Note number for E-3
	UWORD	tcik_Sample_F_3			* Sample number for F-3
	UBYTE	tcik_Octave_F_3			* Octave number for F-3
	UBYTE	tcik_Note_F_3			* Note number for F-3
	UWORD	tcik_Sample_F_SHARP_3	* Sample number for F#3
	UBYTE	tcik_Octave_F_SHARP_3	* Octave number for F#3
	UBYTE	tcik_Note_F_SHARP_3		* Note number for F#3
	UWORD	tcik_Sample_G_3			* Sample number for G-3
	UBYTE	tcik_Octave_G_3			* Octave number for G-3
	UBYTE	tcik_Note_G_3			* Note number for G-3
	UWORD	tcik_Sample_G_SHARP_3	* Sample number for G#3
	UBYTE	tcik_Octave_G_SHARP_3	* Octave number for G#3
	UBYTE	tcik_Note_G_SHARP_3		* Note number for G#3
	UWORD	tcik_Sample_A_3			* Sample number for A-3
	UBYTE	tcik_Octave_A_3			* Octave number for A-3
	UBYTE	tcik_Note_A_3			* Note number for A-3
	UWORD	tcik_Sample_A_SHARP_3	* Sample number for A#3
	UBYTE	tcik_Octave_A_SHARP_3	* Octave number for A#3
	UBYTE	tcik_Note_A_SHARP_3		* Note number for A#3
	UWORD	tcik_Sample_B_3			* Sample number for B-3
	UBYTE	tcik_Octave_B_3			* Octave number for B-3
	UBYTE	tcik_Note_B_3			* Note number for B-3
	UWORD	tcik_Sample_C_4			* Sample number for C-4
	UBYTE	tcik_Octave_C_4			* Octave number for C-4
	UBYTE	tcik_Note_C_4			* Note number for C-4
	UWORD	tcik_Sample_C_SHARP_4	* Sample number for C#4
	UBYTE	tcik_Octave_C_SHARP_4	* Octave number for C#4
	UBYTE	tcik_Note_C_SHARP_4		* Note number for C#4
	UWORD	tcik_Sample_D_4			* Sample number for D-4
	UBYTE	tcik_Octave_D_4			* Octave number for D-4
	UBYTE	tcik_Note_D_4			* Note number for D-4
	UWORD	tcik_Sample_D_SHARP_4	* Sample number for D#4
	UBYTE	tcik_Octave_D_SHARP_4	* Octave number for D#4
	UBYTE	tcik_Note_D_SHARP_4		* Note number for D#4
	UWORD	tcik_Sample_E_4			* Sample number for E-4
	UBYTE	tcik_Octave_E_4			* Octave number for E-4
	UBYTE	tcik_Note_E_4			* Note number for E-4
	UWORD	tcik_Sample_F_4			* Sample number for F-4
	UBYTE	tcik_Octave_F_4			* Octave number for F-4
	UBYTE	tcik_Note_F_4			* Note number for F-4
	UWORD	tcik_Sample_F_SHARP_4	* Sample number for F#4
	UBYTE	tcik_Octave_F_SHARP_4	* Octave number for F#4
	UBYTE	tcik_Note_F_SHARP_4		* Note number for F#4
	UWORD	tcik_Sample_G_4			* Sample number for G-4
	UBYTE	tcik_Octave_G_4			* Octave number for G-4
	UBYTE	tcik_Note_G_4			* Note number for G-4
	UWORD	tcik_Sample_G_SHARP_4	* Sample number for G#4
	UBYTE	tcik_Octave_G_SHARP_4	* Octave number for G#4
	UBYTE	tcik_Note_G_SHARP_4		* Note number for G#4
	UWORD	tcik_Sample_A_4			* Sample number for A-4
	UBYTE	tcik_Octave_A_4			* Octave number for A-4
	UBYTE	tcik_Note_A_4			* Note number for A-4
	UWORD	tcik_Sample_A_SHARP_4	* Sample number for A#4
	UBYTE	tcik_Octave_A_SHARP_4	* Octave number for A#4
	UBYTE	tcik_Note_A_SHARP_4		* Note number for A#4
	UWORD	tcik_Sample_B_4			* Sample number for B-4
	UBYTE	tcik_Octave_B_4			* Octave number for B-4
	UBYTE	tcik_Note_B_4			* Note number for B-4
	UWORD	tcik_Sample_C_5			* Sample number for C-5
	UBYTE	tcik_Octave_C_5			* Octave number for C-5
	UBYTE	tcik_Note_C_5			* Note number for C-5
	UWORD	tcik_Sample_C_SHARP_5	* Sample number for C#5
	UBYTE	tcik_Octave_C_SHARP_5	* Octave number for C#5
	UBYTE	tcik_Note_C_SHARP_5		* Note number for C#5
	UWORD	tcik_Sample_D_5			* Sample number for D-5
	UBYTE	tcik_Octave_D_5			* Octave number for D-5
	UBYTE	tcik_Note_D_5			* Note number for D-5
	UWORD	tcik_Sample_D_SHARP_5	* Sample number for D#5
	UBYTE	tcik_Octave_D_SHARP_5	* Octave number for D#5
	UBYTE	tcik_Note_D_SHARP_5		* Note number for D#5
	UWORD	tcik_Sample_E_5			* Sample number for E-5
	UBYTE	tcik_Octave_E_5			* Octave number for E-5
	UBYTE	tcik_Note_E_5			* Note number for E-5
	UWORD	tcik_Sample_F_5			* Sample number for F-5
	UBYTE	tcik_Octave_F_5			* Octave number for F-5
	UBYTE	tcik_Note_F_5			* Note number for F-5
	UWORD	tcik_Sample_F_SHARP_5	* Sample number for F#5
	UBYTE	tcik_Octave_F_SHARP_5	* Octave number for F#5
	UBYTE	tcik_Note_F_SHARP_5		* Note number for F#5
	UWORD	tcik_Sample_G_5			* Sample number for G-5
	UBYTE	tcik_Octave_G_5			* Octave number for G-5
	UBYTE	tcik_Note_G_5			* Note number for G-5
	UWORD	tcik_Sample_G_SHARP_5	* Sample number for G#5
	UBYTE	tcik_Octave_G_SHARP_5	* Octave number for G#5
	UBYTE	tcik_Note_G_SHARP_5		* Note number for G#5
	UWORD	tcik_Sample_A_5			* Sample number for A-5
	UBYTE	tcik_Octave_A_5			* Octave number for A-5
	UBYTE	tcik_Note_A_5			* Note number for A-5
	UWORD	tcik_Sample_A_SHARP_5	* Sample number for A#5
	UBYTE	tcik_Octave_A_SHARP_5	* Octave number for A#5
	UBYTE	tcik_Note_A_SHARP_5		* Note number for A#5
	UWORD	tcik_Sample_B_5			* Sample number for B-5
	UBYTE	tcik_Octave_B_5			* Octave number for B-5
	UBYTE	tcik_Note_B_5			* Note number for B-5
	UWORD	tcik_Sample_C_6			* Sample number for C-6
	UBYTE	tcik_Octave_C_6			* Octave number for C-6
	UBYTE	tcik_Note_C_6			* Note number for C-6
	UWORD	tcik_Sample_C_SHARP_6	* Sample number for C#6
	UBYTE	tcik_Octave_C_SHARP_6	* Octave number for C#6
	UBYTE	tcik_Note_C_SHARP_6		* Note number for C#6
	UWORD	tcik_Sample_D_6			* Sample number for D-6
	UBYTE	tcik_Octave_D_6			* Octave number for D-6
	UBYTE	tcik_Note_D_6			* Note number for D-6
	UWORD	tcik_Sample_D_SHARP_6	* Sample number for D#6
	UBYTE	tcik_Octave_D_SHARP_6	* Octave number for D#6
	UBYTE	tcik_Note_D_SHARP_6		* Note number for D#6
	UWORD	tcik_Sample_E_6			* Sample number for E-6
	UBYTE	tcik_Octave_E_6			* Octave number for E-6
	UBYTE	tcik_Note_E_6			* Note number for E-6
	UWORD	tcik_Sample_F_6			* Sample number for F-6
	UBYTE	tcik_Octave_F_6			* Octave number for F-6
	UBYTE	tcik_Note_F_6			* Note number for F-6
	UWORD	tcik_Sample_F_SHARP_6	* Sample number for F#6
	UBYTE	tcik_Octave_F_SHARP_6	* Octave number for F#6
	UBYTE	tcik_Note_F_SHARP_6		* Note number for F#6
	UWORD	tcik_Sample_G_6			* Sample number for G-6
	UBYTE	tcik_Octave_G_6			* Octave number for G-6
	UBYTE	tcik_Note_G_6			* Note number for G-6
	UWORD	tcik_Sample_G_SHARP_6	* Sample number for G#6
	UBYTE	tcik_Octave_G_SHARP_6	* Octave number for G#6
	UBYTE	tcik_Note_G_SHARP_6		* Note number for G#6
	UWORD	tcik_Sample_A_6			* Sample number for A-6
	UBYTE	tcik_Octave_A_6			* Octave number for A-6
	UBYTE	tcik_Note_A_6			* Note number for A-6
	UWORD	tcik_Sample_A_SHARP_6	* Sample number for A#6
	UBYTE	tcik_Octave_A_SHARP_6	* Octave number for A#6
	UBYTE	tcik_Note_A_SHARP_6		* Note number for A#6
	UWORD	tcik_Sample_B_6			* Sample number for B-6
	UBYTE	tcik_Octave_B_6			* Octave number for B-6
	UBYTE	tcik_Note_B_6			* Note number for B-6
	UWORD	tcik_Sample_C_7			* Sample number for C-7
	UBYTE	tcik_Octave_C_7			* Octave number for C-7
	UBYTE	tcik_Note_C_7			* Note number for C-7
	UWORD	tcik_Sample_C_SHARP_7	* Sample number for C#7
	UBYTE	tcik_Octave_C_SHARP_7	* Octave number for C#7
	UBYTE	tcik_Note_C_SHARP_7		* Note number for C#7
	UWORD	tcik_Sample_D_7			* Sample number for D-7
	UBYTE	tcik_Octave_D_7			* Octave number for D-7
	UBYTE	tcik_Note_D_7			* Note number for D-7
	UWORD	tcik_Sample_D_SHARP_7	* Sample number for D#7
	UBYTE	tcik_Octave_D_SHARP_7	* Octave number for D#7
	UBYTE	tcik_Note_D_SHARP_7		* Note number for D#7
	UWORD	tcik_Sample_E_7			* Sample number for E-7
	UBYTE	tcik_Octave_E_7			* Octave number for E-7
	UBYTE	tcik_Note_E_7			* Note number for E-7
	UWORD	tcik_Sample_F_7			* Sample number for F-7
	UBYTE	tcik_Octave_F_7			* Octave number for F-7
	UBYTE	tcik_Note_F_7			* Note number for F-7
	UWORD	tcik_Sample_F_SHARP_7	* Sample number for F#7
	UBYTE	tcik_Octave_F_SHARP_7	* Octave number for F#7
	UBYTE	tcik_Note_F_SHARP_7		* Note number for F#7
	UWORD	tcik_Sample_G_7			* Sample number for G-7
	UBYTE	tcik_Octave_G_7			* Octave number for G-7
	UBYTE	tcik_Note_G_7			* Note number for G-7
	UWORD	tcik_Sample_G_SHARP_7	* Sample number for G#7
	UBYTE	tcik_Octave_G_SHARP_7	* Octave number for G#7
	UBYTE	tcik_Note_G_SHARP_7		* Note number for G#7
	UWORD	tcik_Sample_A_7			* Sample number for A-7
	UBYTE	tcik_Octave_A_7			* Octave number for A-7
	UBYTE	tcik_Note_A_7			* Note number for A-7
	UWORD	tcik_Sample_A_SHARP_7	* Sample number for A#7
	UBYTE	tcik_Octave_A_SHARP_7	* Octave number for A#7
	UBYTE	tcik_Note_A_SHARP_7		* Note number for A#7
	UWORD	tcik_Sample_B_7			* Sample number for B-7
	UBYTE	tcik_Octave_B_7			* Octave number for B-7
	UBYTE	tcik_Note_B_7			* Note number for B-7
	UWORD	tcik_Sample_C_8			* Sample number for C-8
	UBYTE	tcik_Octave_C_8			* Octave number for C-8
	UBYTE	tcik_Note_C_8			* Note number for C-8
	UWORD	tcik_Sample_C_SHARP_8	* Sample number for C#8
	UBYTE	tcik_Octave_C_SHARP_8	* Octave number for C#8
	UBYTE	tcik_Note_C_SHARP_8		* Note number for C#8
	UWORD	tcik_Sample_D_8			* Sample number for D-8
	UBYTE	tcik_Octave_D_8			* Octave number for D-8
	UBYTE	tcik_Note_D_8			* Note number for D-8
	UWORD	tcik_Sample_D_SHARP_8	* Sample number for D#8
	UBYTE	tcik_Octave_D_SHARP_8	* Octave number for D#8
	UBYTE	tcik_Note_D_SHARP_8		* Note number for D#8
	UWORD	tcik_Sample_E_8			* Sample number for E-8
	UBYTE	tcik_Octave_E_8			* Octave number for E-8
	UBYTE	tcik_Note_E_8			* Note number for E-8
	UWORD	tcik_Sample_F_8			* Sample number for F-8
	UBYTE	tcik_Octave_F_8			* Octave number for F-8
	UBYTE	tcik_Note_F_8			* Note number for F-8
	UWORD	tcik_Sample_F_SHARP_8	* Sample number for F#8
	UBYTE	tcik_Octave_F_SHARP_8	* Octave number for F#8
	UBYTE	tcik_Note_F_SHARP_8		* Note number for F#8
	UWORD	tcik_Sample_G_8			* Sample number for G-8
	UBYTE	tcik_Octave_G_8			* Octave number for G-8
	UBYTE	tcik_Note_G_8			* Note number for G-8
	UWORD	tcik_Sample_G_SHARP_8	* Sample number for G#8
	UBYTE	tcik_Octave_G_SHARP_8	* Octave number for G#8
	UBYTE	tcik_Note_G_SHARP_8		* Note number for G#8
	UWORD	tcik_Sample_A_8			* Sample number for A-8
	UBYTE	tcik_Octave_A_8			* Octave number for A-8
	UBYTE	tcik_Note_A_8			* Note number for A-8
	UWORD	tcik_Sample_A_SHARP_8	* Sample number for A#8
	UBYTE	tcik_Octave_A_SHARP_8	* Octave number for A#8
	UBYTE	tcik_Note_A_SHARP_8		* Note number for A#8
	UWORD	tcik_Sample_B_8			* Sample number for B-8
	UBYTE	tcik_Octave_B_8			* Octave number for B-8
	UBYTE	tcik_Note_B_8			* Note number for B-8
	UWORD	tcik_Sample_C_9			* Sample number for C-9
	UBYTE	tcik_Octave_C_9			* Octave number for C-9
	UBYTE	tcik_Note_C_9			* Note number for C-9
	UWORD	tcik_Sample_C_SHARP_9	* Sample number for C#9
	UBYTE	tcik_Octave_C_SHARP_9	* Octave number for C#9
	UBYTE	tcik_Note_C_SHARP_9		* Note number for C#9
	UWORD	tcik_Sample_D_9			* Sample number for D-9
	UBYTE	tcik_Octave_D_9			* Octave number for D-9
	UBYTE	tcik_Note_D_9			* Note number for D-9
	UWORD	tcik_Sample_D_SHARP_9	* Sample number for D#9
	UBYTE	tcik_Octave_D_SHARP_9	* Octave number for D#9
	UBYTE	tcik_Note_D_SHARP_9		* Note number for D#9
	UWORD	tcik_Sample_E_9			* Sample number for E-9
	UBYTE	tcik_Octave_E_9			* Octave number for E-9
	UBYTE	tcik_Note_E_9			* Note number for E-9
	UWORD	tcik_Sample_F_9			* Sample number for F-9
	UBYTE	tcik_Octave_F_9			* Octave number for F-9
	UBYTE	tcik_Note_F_9			* Note number for F-9
	UWORD	tcik_Sample_F_SHARP_9	* Sample number for F#9
	UBYTE	tcik_Octave_F_SHARP_9	* Octave number for F#9
	UBYTE	tcik_Note_F_SHARP_9		* Note number for F#9
	UWORD	tcik_Sample_G_9			* Sample number for G-9
	UBYTE	tcik_Octave_G_9			* Octave number for G-9
	UBYTE	tcik_Note_G_9			* Note number for G-9
	UWORD	tcik_Sample_G_SHARP_9	* Sample number for G#9
	UBYTE	tcik_Octave_G_SHARP_9	* Octave number for G#9
	UBYTE	tcik_Note_G_SHARP_9		* Note number for G#9
	UWORD	tcik_Sample_A_9			* Sample number for A-9
	UBYTE	tcik_Octave_A_9			* Octave number for A-9
	UBYTE	tcik_Note_A_9			* Note number for A-9
	UWORD	tcik_Sample_A_SHARP_9	* Sample number for A#9
	UBYTE	tcik_Octave_A_SHARP_9	* Octave number for A#9
	UBYTE	tcik_Note_A_SHARP_9		* Note number for A#9
	UWORD	tcik_Sample_B_9			* Sample number for B-9
	UBYTE	tcik_Octave_B_9			* Octave number for B-9
	UBYTE	tcik_Note_B_9			* Note number for B-9
	LABEL	tcik_SIZEOF

* Apreggio data structure. Used by arpeggio only.
	STRUCTURE	TuComposerInstrArpeggioData,0
	UBYTE	tciad_Tone				* Packed note or NULL if arpeggio note
	BYTE	tciad_Transpose			* Transpose
	UWORD	tciad_Instrument		* Instrument number or NULL for arpeggio
									* instrument
	UBYTE	tciad_EffectByte		* First effect byte
	UBYTE	tciad_EffectByte2		* Second effect byte
	UBYTE	tciad_EffectByte3		* Third effect byte
	UBYTE	tciad_EffectByte4		* Fourth (last) effect byte
	UWORD	tciad_DataWord			* Data word (for set volume, etc.)
	UWORD	tciad_DataWord2			* The 2nd data word of this tick
	UWORD	tciad_DataWord3			* The 3rd data word of this tick
	UWORD	tciad_DataWord4			* The 4th data word of this tick
	LABEL	tciad_NextEntry			* Next entry
	LABEL	tciad_SIZEOF

* Arpeggio structure. Used by command arpeggio only.
	STRUCTURE	TuComposerInstrArpeggio,MLN_SIZE
	UWORD	tcia_Flags				* Special flags (look upwards)
	APTR	tcia_Data				* APTR to arpeggio data
	UWORD	tcia_Entries			* Number of entries
	UWORD	tcia_SustainStart		* Sustain start tick
	UWORD	tcia_SustainEnd			* Sustain end tick
	UWORD	tcia_SustainCount		* Sustain loop counter
	UWORD	tcia_LoopStart			* Loop start tick
	UWORD	tcia_LoopEnd			* Loop end tick
	UWORD	tcia_LoopCount			* Loop counter
	STRUCT	tcia_Reserved,8			* Reserved for future expansions
	APTR	tcia_UserData			* Just for you
	LABEL	tcia_SIZEOF

* Default values for arpeggio structures
DEFAULT_ARPPOINTS		EQU	3		* Default number of points is 3

* Instrument structure, used by all Instrument functions (e.g. AddInstr())
	STRUCTURE	TuComposerInstr,MLN_SIZE
	APTR	tci_FileName			* Pointer to sample file name
									* (e.g. C-Hihat.TCI).
									* Remember, that TuComposer is also
									* available for MS-DOS and other
									* platforms. So, please try to use the
									* limited 8x3 MS-DOS file/dir name
									* length.
	APTR	tci_Name				* Pointer to the instrument name
									* (e.g. Close-Hihat (Echo))
	STRUCT	tci_Samples,MLH_SIZE	* Linked list of samples
	APTR	tci_VolumeEnvelope		* APTR to volume envelope used
	APTR	tci_PanningEnvelope		* APTR to panning envelope used
	APTR	tci_SlideEnvelope		* APTR to slide envelope used
	APTR	tci_VibratoEnvelope		* APTR to default vibrato envelope
	APTR	tci_TremoloEnvelope		* APTR to default tremolo envelope
	APTR	tci_PannoloEnvelope		* APTR to default pannolo envelope
	APTR	tci_ChannoloEnvelope	* APTR to default channolo envelope
	APTR	tci_SpenoloEnvelope		* APTR to default spenolo envelope
	APTR	tci_ArpeggioStructure	* APTR to arpeggio structure used
	APTR	tci_KeyboardDefs		* Keyboard definitions data (as in IT)
	UBYTE	tci_NumSamples			* Number of samples
	UBYTE	tci_GlobalVolume		* Global volume for instrument samples
	UBYTE	tci_NNA					* New note action
	UBYTE	tci_NoteSwing			* Random note swing (semitones)
	UWORD	tci_VolumeSwing			* Volume swing (percentage, 256 = 100%)
	UWORD	tci_PanningSwing		* Panning swing
	ULONG	tci_PitchSwing			* Pitch swing (percentage, 65536 = 100%)
	WORD	tci_PitchPanSeparation	* Pitch panning separation
	UBYTE	tci_DefaultPanning		* Default panning for all samples
	UBYTE	tci_DefaultSubPan		* Default sub panning for all samples
	UBYTE	tci_DCT					* Duplicate note check type (see upwards)
	UBYTE	tci_DNA					* Duplicate note check action (see below)
	UBYTE	tci_CompFlags			* Flags for compatibility (see upwards)
	UBYTE	tci_Flags				* Special flags (see upwards)
	UWORD	tci_EnvUsageFlags		* Envelope usage flags
	UWORD	tci_EnvProcFlags		* Envelope processing flags
	UWORD	tci_EnvRetrigFlags		* Envelope retrigger flags
	UWORD	tci_EnvRandomFlags		* Envelope randomize flags
	UWORD	tci_EnvRndDelayFlags	* Envelope randomize speed is delay flag
	UWORD	tci_FadeOut				* Fade out value
	UWORD	tci_Hold				* Hold value
	UWORD	tci_Decay				* Decay value
	UBYTE	tci_DCA					* Decay action when decay is off
	UBYTE	tci_PitchPanCenter		* Pitch panning center (0 - C-0, etc.)
	UBYTE	tci_MIDICh				* MIDI channel
	UBYTE	tci_MIDIProgram			* MIDI program (instrument)
	UBYTE	tci_MIDIFlags			* MIDI flags (look upwards)
	BYTE	tci_MIDITranspose		* MIDI transpose (in halftones)
	UBYTE	tci_MIDIAftertouch		* MIDI aftertouch (percentage)
	UBYTE	tci_MIDIBender			* MIDI pitchbender (in halftones)
	STRUCT	tci_UnknownChunks,MLH_SIZE	* Linked list of unknown chunks
	STRUCT	tci_Reserved,8			* Reserved for future expansions
	APTR	tci_UserData			* Free for any user data.
	LABEL	tci_SIZEOF

* Instrument default volumes
DEFAULTPITCHPANCENTER	EQU	4*12	* Default pitch panning center is C-4

* tci_DNA definitions
DNA_NOTE_CUT		EQU	0			* Do note cut (as normal)
DNA_NOTE_OFF		EQU	1			* Perform keyoff
DNA_NOTE_FADE		EQU	2			* Fadeoff notes
DNA_NOTE_CONTINUE	EQU	3			* Do nothing (only useful for synth DNA)

* Fade out related definitions
FADE_OUT_START		EQU	65535		* Default is 65535 as in FT2.

* tci_NNA definitions
NNA_NOTE_CUT		EQU	0			* Cut note (as normal)
NNA_NOTE_CONTINUE	EQU	1			* Continue note (allocate new channel)
NNA_NOTE_OFF		EQU	2			* Perform keyoff note
NNA_NOTE_FADE		EQU	3			* Fade out note (uses tci_FadeOut)

ERROR_INSTR_NOGIVEN	EQU	ERROR_INSTR+$0	* Instrument not given
ERROR_INSTR_NODATA	EQU	ERROR_INSTR+$1	* Instrument contains no data
ERROR_INSTR_NOSMPL	EQU	ERROR_INSTR+$2	* Instrument contains no samples
ERROR_INSTR_NOMEM	EQU	ERROR_INSTR+$3	* No memory for operation
ERROR_INSTR_NOFILE	EQU	ERROR_INSTR+$4	* No file to be processed given
ERROR_INSTR_IOERR	EQU	ERROR_INSTR+$5	* I/O error occured while processing
ERROR_INSTR_BAD_IFF	EQU	ERROR_TRACK+$6	* TCI1-IFF-file damaged
* Because LoadInstr() returns NULL on error, use DOS IoErr() and check
* ERROR_INVALID_RESIDENT_LIBRARY for it.

ERROR_INSTR_BAD_VER	EQU	ERROR_INSTR+$7	* Incorrect instrument version
* Because LoadInstr() returns NULL on error, use DOS IoErr() and check
* ERROR_ACTION_NOT_KNOWN for it.

ERROR_INSTR_SAMPLES	EQU	ERROR_INSTR+$8	* Too many samples in IFF-TCI1 file
* Because LoadInstr() returns NULL on error, use DOS IoErr() and check
* ERROR_TOO_MANY_LEVELS for it.

ERROR_INSTR_NOENVL	EQU	ERROR_INSTR+$9	* Envelope not given
ERROR_INSTR_ENVDATA	EQU	ERROR_INSTR+$A	* Envelope contains no data
ERROR_INSTR_ENVLMEM	EQU	ERROR_INSTR+$B	* No memory for envelope operation
ERROR_INSTR_ENVOVFL	EQU	ERROR_INSTR+$C	* Envelope entry overflow
ERROR_INSTR_ENVLESS	EQU	ERROR_INSTR+$D	* Envelope is too small for operate
ERROR_INSTR_ENVBIG	EQU	ERROR_INSTR+$E	* Envelope is too big for operate
ERROR_INSTR_ENVSCLR	EQU	ERROR_INSTR+$F	* Bad envelope scaler

* IFF-TCM1 IHDR structure. Used by disk operations
* (e.g. by LoadTCModule() & SaveTCModule())

	STRUCTURE	MIFF_IHDR,iff_Data
	UWORD	mihdr_VolumeEnvNum		* Number of volume envelope (or 0)
	UWORD	mihdr_PanningEnvNum		* Number of panning envelope (or 0)
	UWORD	mihdr_SlideEnvNum		* Number of slide envelope (or 0)
	UWORD	mihdr_VibratoEnvNum		* Number of vibrato envelope (or 0)
	UWORD	mihdr_TremoloEnvNum		* Number of tremolo envelope (or 0)
	UWORD	mihdr_PannoloEnvNum		* Number of pannolo envelope (or 0)
	UWORD	mihdr_ChannoloEnvNum	* Number of channolo envelope (or 0)
	UWORD	mihdr_SpenoloEnvNum		* Number of spenolo envelope (or 0)
	UWORD	mihdr_ArpeggioDefNum	* Number of arpeggio definition (or 0)
	UWORD	mihdr_KeyboardDefNum	* Number of keyboard definition (or 0)
	UBYTE	mihdr_NumSamples		* Number of samples
	UBYTE	mihdr_GlobalVolume		* Global volume for instrument samples
	UBYTE	mihdr_NNA				* New note action
	UBYTE	mihdr_NoteSwing			* Random note swing (semitones)
	UWORD	mihdr_VolumeSwing		* Volume swing
	UWORD	mihdr_PanningSwing		* Panning swing
	ULONG	mihdr_PitchSwing		* Pitch swing
	WORD	mihdr_PitchPanSep		* Pitch panning separation
	UBYTE	mihdr_DefaultPanning	* Default panning for all samples
	UBYTE	mihdr_DefaultSubPan		* Default sub panning for all samples
	UBYTE	mihdr_DCT				* Duplicate note check type (see upwards)
	UBYTE	mihdr_DNA				* Duplicate note check action (see below)
	UBYTE	mihdr_CompFlags			* Flags for compatibility (see upwards)
	UBYTE	mihdr_Flags				* Special flags (see upwards)
	UWORD	mihdr_EnvUsageFlags		* Envelope usage flags
	UWORD	mihdr_EnvProcFlags		* Envelope processing flags
	UWORD	mihdr_EnvRetrigFlags	* Envelope retrigger flags
	UWORD	mihdr_EnvRandomFlags	* Envelope randomize flags
	UWORD	mihdr_EnvRndDelayFlags	* Envelope randomize speed is delay flags
	UWORD	mihdr_FadeOut			* Fade out value
	UWORD	mihdr_Hold				* Hold value
	UWORD	mihdr_Decay				* Decay value
	UBYTE	mihdr_DCA				* Decay action when decay is off
	UBYTE	mihdr_PitchPanCenter	* Pitch panning center (0 - C-0)
	UBYTE	mihdr_MIDICh			* MIDI channel
	UBYTE	mihdr_MIDIProgram		* MIDI program (instrument)
	UBYTE	mihdr_MIDIFlags			* MIDI flags (look upwards)
	BYTE	mihdr_MIDITranspose		* MIDI transpose (in halftones)
	UBYTE	mihdr_MIDIAftertouch	* MIDI aftertouch (percentage)
	UBYTE	mihdr_MIDIBender		* MIDI pitchbender (in halftones)
	LABEL	mihdr_SIZEOF			* This will increase in future. So
									* never assume that the IHDR chunk
									* is ihdr_SIZEOF bytes long.

* IFF-TCI1 IHDR structure. Used by disk operations
* (e.g. by LoadInstr() & SaveInstr())

	STRUCTURE	IFF_IHDR,iff_Data
	UBYTE	ihdr_Version			* Version number of TCI1 file
	UBYTE	ihdr_Revision			* Revision number of TCI1 file
	UWORD	ihdr_VolumeEnvNum		* Number of volume envelope (or 0)
	UWORD	ihdr_PanningEnvNum		* Number of panning envelope (or 0)
	UWORD	ihdr_SlideEnvNum		* Number of slide envelope (or 0)
	UWORD	ihdr_VibratoEnvNum		* Number of vibrato envelope (or 0)
	UWORD	ihdr_TremoloEnvNum		* Number of tremolo envelope (or 0)
	UWORD	ihdr_PannoloEnvNum		* Number of pannolo envelope (or 0)
	UWORD	ihdr_ChannoloEnvNum		* Number of channolo envelope (or 0)
	UWORD	ihdr_SpenoloEnvNum		* Number of spenolo envelope (or 0)
	UWORD	ihdr_ArpeggioDefNum		* Number of arpeggio definition (or 0)
	UWORD	ihdr_KeyboardDefNum		* Number of keyboard definition (or 0)
	UBYTE	ihdr_NumSamples			* Number of samples
	UBYTE	ihdr_GlobalVolume		* Global volume for instrument samples
	UBYTE	ihdr_NNA				* New note action
	UBYTE	ihdr_NoteSwing			* Random note swing (semitones)
	UWORD	ihdr_VolumeSwing		* Volume swing
	UWORD	ihdr_PanningSwing		* Panning swing
	ULONG	ihdr_PitchSwing			* Pitch swing
	WORD	ihdr_PitchPanSeparation	* Pitch panning separation
	UBYTE	ihdr_DefaultPanning		* Default panning for all samples
	UBYTE	ihdr_DefaultSubPan		* Default sub panning for all samples
	UBYTE	ihdr_DCT				* Duplicate note check type (see upwards)
	UBYTE	ihdr_DNA				* Duplicate note check action (see below)
	UBYTE	ihdr_CompFlags			* Flags for compatibility (see upwards)
	UBYTE	ihdr_Flags				* Special flags (see upwards)
	UWORD	ihdr_EnvUsageFlags		* Envelope usage flags
	UWORD	ihdr_EnvProcFlags		* Envelope processing flags
	UWORD	ihdr_EnvRetrigFlags		* Envelope retrigger flags
	UWORD	ihdr_EnvRandomFlags		* Envelope randomize flags
	UWORD	ihdr_EnvRndDelayFlags	* Envelope randomize speed is delay flags
	UWORD	ihdr_FadeOut			* Fade out value
	UWORD	ihdr_Hold				* Hold value
	UWORD	ihdr_Decay				* Decay value
	UBYTE	ihdr_DCA				* Decay action when decay is off
	UBYTE	ihdr_PitchPanCenter		* Pitch panning center (0 - C-0, etc.)
	UBYTE	ihdr_MIDICh				* MIDI channel
	UBYTE	ihdr_MIDIProgram		* MIDI program (instrument)
	UBYTE	ihdr_MIDIFlags			* MIDI flags (look upwards)
	BYTE	ihdr_MIDITranspose		* MIDI transpose (in halftones)
	UBYTE	ihdr_MIDIAftertouch		* MIDI aftertouch (percentage)
	UBYTE	ihdr_MIDIBender			* MIDI pitchbender (in halftones)
	LABEL	ihdr_SIZEOF				* This will increase in future. So
									* never assume that the IHDR chunk
									* is ihdr_SIZEOF bytes long.

* IFF-TCM1/IFF-TCI1 EHDR structure. Used by disk operations.
* (e.g. by LoadModule() & SaveModule())

	STRUCTURE	MIFF_EHDR,iff_Data
	UWORD	mehdr_Flags				* Envelope flags (see upwards)
	UWORD	mehdr_Tempo				* Envelope tempo in ticks (default 1)
	UWORD	mehdr_SustainStart		* Sustain start point
	UWORD	mehdr_SustainEnd		* Sustain end point
	UWORD	mehdr_SustainCount		* Sustain counter
	UWORD	mehdr_LoopStart			* Loop start point
	UWORD	mehdr_LoopEnd			* Loop end point
	UWORD	mehdr_LoopCount			* Loop counter
	WORD	mehdr_LowestValue		* Random lowest value
	WORD	mehdr_HighestValue		* Random highest value
	LABEL	mehdr_SIZEOF

* IFF-TCE1 EHDR structure. Used by disk operations.
* (e.g. by LoadEnvelope() & SaveEnvelope())

	STRUCTURE	IFF_EHDR,iff_Data
	UBYTE	ehdr_Version			* Version number (currently 1)
	UBYTE	ehdr_Revision			* Revision number (currently 0)
	UWORD	ehdr_Flags				* Envelope flags (see upwards)
	UWORD	ehdr_Tempo				* Envelope tempo in ticks (default 1)
	UWORD	ehdr_SustainStart		* Sustain start point
	UWORD	ehdr_SustainEnd			* Sustain end point
	UWORD	ehdr_SustainCount		* Sustain counter
	UWORD	ehdr_LoopStart			* Loop start point
	UWORD	ehdr_LoopEnd			* Loop end point
	UWORD	ehdr_LoopCount			* Loop counter
	WORD	ehdr_LowestValue		* Random lowest value
	WORD	ehdr_HighestValue		* Random highest value
	LABEL	ehdr_SIZEOF

* IFF-TCI1 KBRD structure. Used by disk operations.
* Here is stored the keyboard table (play at which note is which sample)

	STRUCTURE	IFF_KBRD,tcik_SIZEOF
	LABEL	kbrd_SIZEOF

* IFF-TCM1/IFF-TCI1 AHDR structure. Used by disk operations.
* (e.g. by LoadModule() & SaveModule())

	STRUCTURE	IFF_AHDR,iff_Data
	UWORD	ahdr_Length				* Number of arpeggio ticks
	UWORD	ahdr_Flags				* Special flags look upwards
	UWORD	ahdr_SustainStart		* Sustain start tick
	UWORD	ahdr_SustainEnd			* Sustain end tick
	UWORD	ahdr_SustainCount		* Sustain counter
	UWORD	ahdr_LoopStart			* Loop start tick
	UWORD	ahdr_LoopEnd			* Loop end tick
	UWORD	ahdr_LoopCount			* Loop counter
	LABEL	ahdr_SIZEOF				* This might increase !!! Do not assume
									* end here !

* IFF-TCM1/IFF-TCI1 ARPE structure. Used by disk operations.
* (e.g. by LoadModule() & SaveModule())

	STRUCTURE	IFF_ARPE,iff_Data
	UBYTE	arpe_Tone				* Packed note or NULL if arpeggio note
	BYTE	arpe_Transpose			* Transpose
	UWORD	arpe_Instrument			* Instrument number or NULL for arpeggio
									* instrument
	UBYTE	arpe_EffectByte			* First effect byte
	UBYTE	arpe_EffectByte2		* Second effect byte
	UBYTE	arpe_EffectByte3		* Third effect byte
	UBYTE	arpe_EffectByte4		* Fourth (last) effect byte
	UWORD	arpe_DataWord			* Data word (for set volume, etc.)
	UWORD	arpe_DataWord2			* The 2nd data word of this tick
	UWORD	arpe_DataWord3			* The 3rd data word of this tick
	UWORD	arpe_DataWord4			* The 4th data word of this tick
	LABEL	arpe_SIZEOF				* This might increase !!! Do not assume
									* end here !

TCI_NAME	EQU	(('T'<<24)!('C'<<16)!('I'<<8)!('1'))
INSL_NAME	EQU	(('I'<<24)!('N'<<16)!('S'<<8)!('L'))
INST_NAME	EQU	(('I'<<24)!('N'<<16)!('S'<<8)!('T'))
IHDR_NAME	EQU	(('I'<<24)!('H'<<16)!('D'<<8)!('R'))
ENVD_NAME	EQU	(('E'<<24)!('N'<<16)!('V'<<8)!('D'))
ENVL_NAME	EQU	(('E'<<24)!('N'<<16)!('V'<<8)!('L'))
NODE_NAME	EQU	(('N'<<24)!('O'<<16)!('D'<<8)!('E'))
KEYB_NAME	EQU	(('K'<<24)!('E'<<16)!('Y'<<8)!('B'))
KBRD_NAME	EQU	(('K'<<24)!('B'<<16)!('R'<<8)!('D'))
ARPL_NAME	EQU	(('A'<<24)!('R'<<16)!('P'<<8)!('L'))
ARPG_NAME	EQU	(('A'<<24)!('R'<<16)!('P'<<8)!('G'))
AHDR_NAME	EQU	(('A'<<24)!('H'<<16)!('D'<<8)!('R'))
ARPE_NAME	EQU	(('A'<<24)!('R'<<16)!('P'<<8)!('E'))
TCE_NAME	EQU	(('T'<<24)!('C'<<16)!('E'<<8)!('1'))
EHDR_NAME	EQU	(('E'<<24)!('H'<<16)!('D'<<8)!('R'))

IHDR_VERSION	EQU	1		* Current instr version: 1
IHDR_REVISION	EQU	0		* Current instr revision: 0
EHDR_VERSION	EQU	1		* Current envelope version: 1
EHDR_REVISION	EQU	0		* Current envelope revision: 0

C_TCI	MACRO
	dc.b	'TCI1'
	ENDM

TCI_CHUNK	MACRO	* Length
	FORM
	dc.l	\1
	TCI
	ENDM

C_INSL	MACRO		* Length
	dc.b	'INSL'
	ENDM

C_INSL_CHUNK	MACRO	* Length
	C_FORM
	dc.l	\1
	C_INSL
	ENDM

C_INST	MACRO		* Length
	dc.b	'INST'
	ENDM

INST_CHUNK	MACRO	* Length
	C_FORM
	dc.l	\1
	C_INST
	ENDM

C_IHDR	MACRO
	dc.b	'IHDR'
	ENDM

IHDR_CHUNK	MACRO	* Length
	C_IHDR
	dc.l	\1
	ENDM

C_ENVD	MACRO
	dc.b	'ENVD'
	ENDM

ENVD_CHUNK	MACRO	* Length
	C_FORM
	dc.l	\1
	C_ENVD
	ENDM

C_ENVL	MACRO
	dc.b	'ENVL'
	ENDM

ENVL_CHUNK	MACRO	* Length
	C_FORM
	dc.l	\1
	C_ENVL
	ENDM

C_NODE	MACRO
	dc.b	'NODE'
	ENDM

NODE_CHUNK	MACRO	* Length
	C_NODE
	dc.l	\1
	ENDM

C_KEYB	MACRO
	dc.b	'KEYB'
	ENDM

KEYB_CHUNK	MACRO	* Length
	C_FORM
	dc.l	\1
	C_KEYB
	ENDM

C_KBRD	MACRO
	dc.b	'KBRD'
	ENDM

KBRD_CHUNK	MACRO	* Length
	C_KBRD
	dc.l	\1
	ENDM

C_ARPL	MACRO
	dc.b	'ARPL'
	ENDM

ARPL_CHUNK	MACRO	* Length
	C_FORM
	dc.l	\1
	C_ARPL
	ENDM

C_ARPG	MACRO
	dc.b	'ARPG'
	ENDM

ARPG_CHUNK	MACRO	* Length
	C_FORM
	dc.l	\1
	C_ARPG
	ENDM

AHDR_CHUNK	MACRO	* Length
	C_AHDR
	dc.l	\1
	ENDM

C_AHDR	MACRO
	dc.b	'AHDR'
	ENDM

ARPE_CHUNK	MACRO	* Length,[FORMFlag]
	IFLT	NARG-2
		ARPE
		dc.l	\1
	ELSE
		C_FORM
		dc.l	\1
		C_ARPE
	ENDC
	ENDM

C_ARPE	MACRO
	dc.b	'ARPE'
	ENDM

TCE	MACRO
	dc.b	'TCE1'
	ENDM

TCE_CHUNK	MACRO	* Length
	C_FORM
	dc.l	\1
	C_TCE
	ENDM

C_EHDR	MACRO
	dc.b	'EHDR'
	ENDM

EHDR_CHUNK	MACRO	* Length
	C_EHDR
	dc.l	\1
	ENDM

	ENDC	; TUCOMPOSER_INSTR_I
