	IFND	TUCOMPOSER_MODULE_I
TUCOMPOSER_MODULE_I	SET	1
**
**	$Filename: tucomposer/module.i $
**	$Release : 31.22 $
**
**
**
**	(C) Copyright 1996-1997 by The united Coders (TuC)
**      Main code: Basty/TuC
**		All Rights Reserved
**

		IFND	EXEC_TYPES_I
		include	"exec/types.i"
		ENDC	; EXEC_TYPES_I

		IFND	EXEC_NODES_I
		include	"exec/nodes.i"
		ENDC	; EXEC_NODES_I

		IFND	EXEC_LISTS_I
		include	"exec/lists.i"
		ENDC	; EXEC_LISTS_I

		IFND	LIBRARIES_DOS_I
		include	"libraries/dos.i"
		ENDC	; LIBRARIES_DOS_I

		IFND	TUCOMPOSER_TUCOMPOSER_I
		include	"tucomposer/tucomposer.i"
		ENDC	; TUCOMPOSER_TUCOMPSER_I


* No bit definitions for tcm_CompFlags & tcm_Flags yet.

* Module structure, used by all modules functions (e.g. PlayTCModule())
	STRUCTURE	TuComposerModule,MLN_SIZE
	APTR	tcm_Task					* Owner task of this module
	APTR	tcm_FileName				* File name of current module
	APTR	tcm_Name					* Name of current module
	APTR	tcm_Message					* Message to the whole module (ANSI
										* & multiple lines allowed)
	APTR	tcm_Composer				* Module composer(s)
	APTR	tcm_Style					* Module style(s)
	APTR	tcm_Comment					* A short comment from the composer
										* to the whole module
	APTR	tcm_ChannelData				* APTR to virtual channel data
	STRUCT	tcm_BeginDate,sds_SIZEOF	* Begin date of composing
	STRUCT	tcm_EndDate,sds_SIZEOF		* Finish date of composing
	UBYTE	tcm_PlayTimeHours			* Play time of whole module in hours
	UBYTE	tcm_PlayTimeMins			* Play time of whole module in mins
	UBYTE	tcm_PlayTimeSecs			* Play time of whole module in secs
	UBYTE	tcm_PlayTimeHundreds		* Play time of module in 1/100 secs
	STRUCT	tcm_SongList,MLH_SIZE		* Song list of current module
	STRUCT	tcm_InstrList,MLH_SIZE		* Linked list of instruments in
										* the whole module
	STRUCT	tcm_Envelopes,MLH_SIZE		* Linked list of envelopes used
	STRUCT	tcm_KeyboardDefs,MLH_SIZE	* Linked list of keyboard defs
	STRUCT	tcm_ArpEnvList,MLH_SIZE		* Linked list of arpeggio envelopes
	UWORD	tcm_Channels				* Maximum channels (incl. NNA back-
										* ground channels) to be allocated
										* by the mix routine (default 16)
	UBYTE	tcm_CompFlags				* Compatiblity flags (see upwards)
	UBYTE	tcm_Flags					* Module flags (see upwards)
	STRUCT	tcm_UnknownChunks,MLH_SIZE	* Linked list of unknown chunks
	STRUCT	tcm_Reserved,8				* Reserved for future expansions.
	APTR	tcm_UserData				* This field is just for you !
	LABEL	tcm_SIZEOF

DEFAULTNNACHANNELS	EQU	16				* 16 channels are used by defaults

*	Module error codes
ERROR_MODULE_NOGIVEN	EQU	ERROR_MODULE+$0	* Is set if no module was given
ERROR_MODULE_NODATA	EQU	ERROR_MODULE+$1	* Module contains no data
ERROR_MODULE_NOMEM	EQU	ERROR_MODULE+$2	* Returned on mem fail
ERROR_MODULE_NOFILE	EQU	ERROR_MODULE+$4	* No file given
ERROR_MODULE_IOERR	EQU	ERROR_MODULE+$5	* I/O error occured on
ERROR_MODULE_BAD_IFF	EQU	ERROR_MODULE+$6	* TCM1-IFF-file damaged
* Because LoadTCModule() returns NULL on error, use DOS IoErr() and check
* ERROR_INVALID_RESIDENT_LIBRARY for it.

ERROR_MODULE_BAD_VER	EQU	ERROR_MODULE+$7	* Incorrect module version
ERROR_MODULE_NOKEYBOARD	EQU	ERROR_MODULE+$8	* If no keyboard definition was
											* set, this is returned
ERROR_MODULE_BADOCTAVE	EQU	ERROR_MODULE+$9	* Bad octave given to keyboard
											* function
ERROR_MODULE_BADNOTE	EQU	ERROR_MODULE+$A	* Bad note given to keyboard
											* function

* TuComposer Module Header. Used by disk operations
* (e.g. by LoadTCModule() & SaveTCModule())

	STRUCTURE	IFF_MHDR,iff_SIZEOF
	UBYTE	mhdr_Version				* Module version (currently 01)
	UBYTE	mhdr_Revision				* Module revision (currently 00)
	STRUCT	mhdr_BeginDate,sds_SIZEOF	* Begin date of composing
	STRUCT	mhdr_EndDate,sds_SIZEOF		* Finish date of composing
	UBYTE	mhdr_PlayTimeHours			* Play time of whole module in hours
	UBYTE	mhdr_PlayTimeMins			* Play time of whole module in mins
	UBYTE	mhdr_PlayTimeSecs			* Play time of whole module in secs
	UBYTE	mhdr_PlayTimeHundreds		* Play time of module in 1/100 secs
	UWORD	mhdr_Songs					* Number of songs in this module
	ULONG	mhdr_Tracks					* Number of total tracks
	UWORD	mhdr_Instruments			* Number of instruments
	ULONG	mhdr_Samples				* Number of total samples
	ULONG	mhdr_Synths					* Number of total synths
	UWORD	mhdr_Envelopes				* Number of envelopes
	UWORD	mhdr_KeyboardDefs			* Number of keyboard definitions
	UWORD	mhdr_ArpeggioDefs			* Number of arpeggio definitions
	UWORD	mhdr_Channels				* Maximum channels allowed
	UBYTE	mhdr_CompFlags				* Compatilibty flags (see upwards)
	UBYTE	mhdr_Flags					* Flags (see upwards)
	LABEL	mhdr_SIZEOF

TCM_NAME	EQU	(('T'<<24)!('C'<<16)!('M'<<8)!('1'))
MHDR_NAME	EQU	(('M'<<24)!('H'<<16)!('D'<<8)!('R'))
MMSG_NAME	EQU	(('M'<<24)!('M'<<16)!('S'<<8)!('G'))

C_TCM	MACRO
	dc.b	'TCM1'
	ENDM

TCM_CHUNK	MACRO	* Length
	C_FORM
	dc.l	\1
	C_TCM
	ENDM

C_MHDR	MACRO
	dc.b	'MHDR'
	ENDM

MHDR_CHUNK	MACRO	* Length
	C_MHDR
	dc.l	\1
	ENDM

C_MMSG	MACRO
	dc.b	'MMSG'
	ENDM

MMSG_CHUNK	MACRO	* Length
	C_MMSG
	dc.l	\1
	ENDM

CURRENT_VERSION		EQU	1				* Current version of module format.
CURRENT_REVISION	EQU	0				* Current revision of module format.

	ENDC	; TUCOMPOSER_MODULE_I
