	IFND	TUCOMPOSER_PLAYER_I
TUCOMPOSER_PLAYER_I	SET	1
**
**	$Filename: tucomposer/player.i $
**	$Release : 31.22 $
**
**
**
**	(C) Copyright 1997-98 by The united Coders (TuC)
**      Main code: Basty/TuC
**		All Rights Reserved
**

		IFND	EXEC_TYPES_I
		include	"exec/types.i"
		ENDC	; EXEC_TYPES_I

		IFND	EXEC_NODES_I
		include	"exec/nodes.i"
		ENDC	; EXEC_NODES_I

		IFND	EXEC_LISTS_I
		include	"exec/lists.i"
		ENDC	; EXEC_LISTS_I

		IFND	TUCOMPOSER_TUCOMPOSER_I
		include	"tucomposer/tucomposer.i"
		ENDC	; TUCOMPOSER_TUCOMPOSER_I

		IFND	TUCOMPOSER_EXTERNAL_EXTERNAL_I
		include	"tucomposer/external/external.i"
		ENDC	; TUCOMPOSER_EXTERNAL_EXTERNAL_I

		IFND	TUCOMPOSER_EXTERNAL_MIXER_I
		include	"tucomposer/external/mixer.i"
		ENDC	; TUCOMPOSER_EXTERNAL_MIXER_I

* Player envelope structure flags:
	BITDEF	PES,FirstAdd,0				* First add envelope then get value
	BITDEF	PES,NoRetrig,1				* Envelope won't be retriggered on
										* new note play
	BITDEF	PES,Random,2				* Envelope returns random values
	BITDEF	PES,RndDelay,3				* If random enabled, speed will be
										* interpreted as a delay
	BITDEF	PES,Backwards,4				* Playing currently backwards
	BITDEF	PES,Looping,5				* Currently looping (either sustain
										* or normal loop)
	BITDEF	PES,Pingpong,6				* Current loop is pingpong

* Player envelope structure repeat flags:
	BITDEF	PESR,Loop,0					* Loop points used
	BITDEF	PESR,Sustain,1				* Sustain points used
	BITDEF	PESR,Pingpong,2				* Ping pong loop
	BITDEF	PESR,SustainPingpong,3		* Sustain ping pong loop

* Player globals flags:
	BITDEF	PG,PlayOnce,0				* Play song in once mode, i.e.
										* stop after played it
	BITDEF	PG,NoProcPattern,1			* Don't process patterns (i.e.
										* process instrument data only)
	BITDEF	PG,PlayPattern,2			* Play pattern only (don't break)
	BITDEF	PG,Surround,3				* Global panning is surround pan
	BITDEF	PG,SongEnd,4				* Song end found. This bit is used
										* by the play exec handlers and the
										* play time calculation routine.
	BITDEF	PG,SPD,5					* SPD timing used
	BITDEF	PG,TraceMode,6				* Single step mode enabled

* Player host channel flags:
	BITDEF	PHC,LinearFreq,0			* Use linear frequence table
	BITDEF	PHC,Backwards,1				* Playing track backwards
	BITDEF	PHC,PatternBreak,2			* Pattern break
	BITDEF	PHC,SmpOffsetRel,3			* Sample offset relative
	BITDEF	PHC,TrackSurPan,4			* Track surround panning used
	BITDEF	PHC,AffectChanPan,5			* Channel panning is affected
	BITDEF	PHC,ChannelSurPan,6			* Channel surround panning used
	BITDEF	PHC,ExecFX,7				* Exec FX called
	BITDEF	PHC,TonePorta,8				* Tone portamento executed
	BITDEF	PHC,SetTranspose,9			* Set transpose/finetune executed
	BITDEF	PHC,SubSlideRetrig,10		* Allow sub-slides in multi retrig
	BITDEF	PHC,TremorExec,11			* Tremor executed (i.e. holded)
	BITDEF	PHC,TremorOff,12			* Tremor off bit
	BITDEF	PHC,RetrigNote,13			* Note retrig bit, set by a new note,
										* cleared by multi retrig and after
										* each row
	BITDEF	PHC,Vibrato,14				* Vibrato hold (i.e. executed)
	BITDEF	PHC,Tremolo,15				* Tremolo hold (i.e. executed)
	BITDEF	PHC,ChgPattern,16			* Pattern changed
	BITDEF	PHC,PattLoop,17				* Performing pattern loop
	BITDEF	PHC,PattLoopJmp,18			* Pattern loop jumped
	BITDEF	PHC,PattReset,19			* Pattern loop needs to be resetted
	BITDEF	PHC,SetInstr,20				* Flag set by PlayInstr(), cleared
										* afterwards. Instrument to be played
										* is put into phc_Instrument
	BITDEF	PHC,SetSample,21			* Flag set by PlaySample(), cleared
										* afterwards. Sample to be played
										* is put into phc_Sample. If this
                                        * and previous is set, the track
                                        * at phc_Instrument will be played
                                        * at row phc_Sample
	BITDEF	PHC,SongEnd,31				* Song end found for this channel

* Player fine slide flags:
	BITDEF	FS,FinePortaDown,0			* Fine portamento is directed down
	BITDEF	FS,PortaOnceDown,1			* Portamento once is directed down
	BITDEF	FS,FinePortaOnceDown,2		* Fine porta once is directed down
	BITDEF	FS,FinePorta,3				* Fine portamento used
	BITDEF	FS,PortaOnce,4				* Portamento once used
	BITDEF	FS,FineTonePorta,5			* Fine tone portamento used
	BITDEF	FS,TonePortaOnce,6			* Tone portamento once used
	BITDEF	FS,VolSlideDown,7			* Volume slide is directed downwards
	BITDEF	FS,FineVolSlideDown,8		* Fine volume slide is directed down
	BITDEF	FS,FineVolSlide,9			* Fine volume slide used
	BITDEF	FS,TrackVolSlideDown,10		* Track volume slide is directed down
	BITDEF	FS,FineTrackVolSlideDown,11	* Fine track vol slide is downwards
	BITDEF	FS,FineTrackVolSlide,12		* Fine track volume slide used
	BITDEF	FS,PanSlideRight,13			* Panning slide is directed right
	BITDEF	FS,FinePanSlideRight,14		* Fine pan slide is directed right
	BITDEF	FS,FinePanSlide,15			* Fine panning slide is used
	BITDEF	FS,TrackPanSlideRight,16	* Track panning slide is right
	BITDEF	FS,FineTrkPanSlideRight,17	* Fine track pan slide is right
	BITDEF	FS,FineTrackPanSlide,18		* Fine track panning slide is used
	BITDEF	FS,SpeedSlideSlower,19		* Speed slide is directed faster
	BITDEF	FS,FineSpeedSlideSlower,20	* Fine speed slide is directed faster
	BITDEF	FS,FineSpeedSlide,21		* Fine speed slide is used
	BITDEF	FS,GlobalVolSlideDown,22	* Global volume slide is downed
	BITDEF	FS,FineGVolSlideDown,23		* Fine global volume slide is downed
	BITDEF	FS,FineGlobalVolSlide,24	* Fine global volume slide is used
	BITDEF	FS,GlobalPanSlideRight,25	* Global panning slide is righted
	BITDEF	FS,FineGPanSlideRight,26	* Fine global pan slide is righted
	BITDEF	FS,FineGlobalPanSlide,27	* Fine global panning slide is used

* Player channel flags:
	BITDEF	PC,Sustain,0				* Sustain points released
	BITDEF	PC,Fading,1					* Fading out
	BITDEF	PC,Decay,2					* Decay running
	BITDEF	PC,TrackPan,3				* Channel uses track panning
	BITDEF	PC,SmpSurPan,4				* Sample panning is surround panning
	BITDEF	PC,GlobalSurPan,5			* Global panning is surround panning
	BITDEF	PC,Surround,6				* Surround output
	BITDEF	PC,Background,7				* Channel playing in background
	BITDEF	PC,PortaSlideEnv,8			* If bit is set, the values in the
										* slide envelope will be portamento
										* slide values, else they will be a
										* transpose & finetune
	BITDEF	PC,LinearSlideEnv,9			* If bit is set, use linear frequence
										* table for slide envelope if
										* portamento mode is activated
	BITDEF	PC,LinearFreqAutoVib,10		* If bit is set, linear frequence
										* table for auto vibrato will be used
	BITDEF	PC,Allocated,15				* Channel allocated but not playing

* Player channel synth flags:
	BITDEF	PCY,VolumeKill,0			* Volume handling code kill running
	BITDEF	PCY,PanningKill,1			* Panning handling code kill running
	BITDEF	PCY,SlideKill,2				* Slide handling code kill running
	BITDEF	PCY,SpecialKill,3			* Special handling code kill running

* Player channel control affect bits:
	BITDEF	PCA,Notes,0					* Affect note related effects
										* volume, panning, etc.
	BITDEF	PCA,NoNotes,1				* Affect non-note related effects
										* pattern loops, pattern break, etc.

* Play types as used by pg_PlayType:
	BITDEF	PTYP,Song,7					* Flag set by PlayTCModule() and
										* if PlayTrack() is in continous
										* mode to indicate that the whole
										* song is played. Disk writers can
										* check this bit in order to write
										* sample data only if the song is
										* being played

* Bit definitions of fx_Flags:
	BITDEF	FX,ExecWholeRow,7			* If set, the effect will be
										* executed the whole row, else
										* only once

* Player envelope structure. The player envelope routine evaluates this one
	STRUCTURE	Envelope,0
	APTR	pes_EnvelopeStructure		* APTR to envelope structure
	WORD	pes_EnvelopeValue			* Current envelope value
	UWORD	pes_EnvelopePos				* Envelope position (0 is first)
	UWORD	pes_EnvelopeRestart			* Envelope current loop restart point
	UWORD	pes_EnvelopeEnd				* Envelope current (loop) end point
	UWORD	pes_EnvelopeSustainCounted	* Envelope sustain counter counted
	UWORD	pes_EnvelopeLoopCounted		* Envelope loop counter counted
	UWORD	pes_EnvelopeTempoCount		* Envelope tempo counter
	UWORD	pes_EnvelopeTempo			* Envelope tempo
	UWORD	pes_EnvelopeSustainStart	* Envelope sustain start point
	UWORD	pes_EnvelopeSustainEnd		* Envelope sustain end point
	UWORD	pes_EnvelopeSustainCount	* Envelope sustain counter
	UWORD	pes_EnvelopeLoopStart		* Envelope loop start point
	UWORD	pes_EnvelopeLoopEnd			* Envelope loop end point
	UWORD	pes_EnvelopeLoopCount		* Envelope loop counter
	WORD	pes_EnvelopeLowestValue		* Data lowest value (used by random)
	WORD	pes_EnvelopeHighestValue	* Data highest value (used by random)
	UBYTE	pes_EnvelopeFlags			* Envelope flags (see upwards)
	UBYTE	pes_EnvelopeRepFlags		* Envelope repeat flags
	STRUCT	pes_Reserved,10				* Reserved for future expansions
	LABEL	pes_SIZEOF

* Player global structure (Player global settings, like BpM, etc.)
	STRUCTURE	PlayerGlobals,0
	UBYTE	pg_Flags					* Special flags
	UBYTE	pg_SpeedSlideToValue		* Speed slide to value
	UBYTE	pg_SpeedMul					* Speed multiplier (allowing you 2/3)
	UBYTE	pg_SpeedDiv					* Speed divider (divs the multiply)
	ULONG	pg_RelativeSpeed			* Relative speed (65536 is 100%)
	ULONG	pg_RelativePitch			* Relative pitch (65536 is 100%)
	ULONG	pg_PlayTime					* Playing time in 1/100 secs
	ULONG	pg_PlayTimeFrac				* Playing time 32-bit fraction
	ULONG	pg_PlayTics					* Playing tics in 1/100 secs. This
										* increases depending on pg_Tempo,
										* while pg_PlayTime depends on
										* pg_Tempo+pg_RelativeSpeed. This is
										* important if you want do things
										* like percentage display of played
										* module. Just use the formula
										* (pg_PlayTics/Duration of song)*100
	ULONG	pg_PlayTicsFrac				* Playing tics 32-bit fraction
	ULONG	pg_Tempo					* Current tempo in 1/655360 secs
	UWORD	pg_SPDSpeed					* Current SPD value
	UWORD	pg_BPMTempo					* Current BPM tempo (rows per beat)
	UWORD	pg_BPMSpeed					* Current BPM speed (default 125)
	UBYTE	pg_GlobalVolumeSlideToValue	* Global volume slide to value
	UBYTE	pg_GlobalPanSlideToValue	* Global panning slide to value
	UBYTE	pg_GlobalVolume				* Global volume
	UBYTE	pg_GlobalSubVol				* Global sub-volume
	UBYTE	pg_GlobalPanning			* Global panning
	UBYTE	pg_GlobalSubPan				* Global sub-panning
	UWORD	pg_SpeedSlideFasterValue	* Speed slide faster value
	UWORD	pg_SpeedSlideSlowerValue	* Speed slide slower value
	UWORD	pg_FineSpeedSlideFastValue	* Fine speed slide faster value
	UWORD	pg_FineSpeedSlideSlowValue	* Fine speed slide slower value
	UWORD	pg_SpeedSlideToSlide		* Speed slide to slide value
	UWORD	pg_SpeedSlideToSpeed		* Speed slide to speed
	WORD	pg_SpenoloSlideValue		* Spenolo relative slide value
	UBYTE	pg_SpenoloDepth				* Spenolo depth
	UBYTE	pg_SpenoloRate				* Spenolo rate
	UWORD	pg_GlobalVolSlideUpValue	* Global volume slide up value
	UWORD	pg_GlobalVolSlideDownValue	* Global volume slide down value
	UWORD	pg_FineGlobalVolSlUpValue	* Fine global volume slide up value
	UWORD	pg_FineGlobalVolSlDownValue	* Fine global volume slide down value
	UWORD	pg_GlobalVolumeSlideToSlide	* Global volume slide to slide value
	UBYTE	pg_GlobalVolumeSlToVolume	* Global volume slide to volume
	UBYTE	pg_GlobalVolumeSlToSubVol	* Global volume slide to sub volume
	WORD	pg_TremoloSlideValue		* Global tremolo relative slide value
	UBYTE	pg_TremoloDepth				* Global tremolo depth
	UBYTE	pg_TremoloRate				* Global tremolo rate
	UWORD	pg_GlobalPanSlideLeftValue	* Global panning slide left value
	UWORD	pg_GlobalPanSlideRightValue	* Global panning slide right value
	UWORD	pg_FineGlobalPanSlLeftValue	* Fine global pan slide left value
	UWORD	pg_FineGlobalPanSlRightVal	* Fine global pan slide right value
	UWORD	pg_GlobalPanSlideToSlide	* Global panning slide to slide value
	UBYTE	pg_GlobalPanSlideToPanning	* Global panning slide to panning
	UBYTE	pg_GlobalPanSlideToSubPan	* Global panning slide to sub panning
	WORD	pg_PannoloSlideValue		* Global pannolo relative slide value
	UBYTE	pg_PannoloDepth				* Global pannolo depth
	UBYTE	pg_PannoloRate				* Global pannolo rate
	UWORD	pg_Channels					* Channels currently active
	UWORD	pg_MaxChannels				* Highest number of channels played
	STRUCT	pg_SpenoloEnv,pes_SIZEOF	* Spenolo envelope
	STRUCT	pg_TremoloEnv,pes_SIZEOF	* Global tremolo envelope
	STRUCT	pg_PannoloEnv,pes_SIZEOF	* Global pannolo envelope
	UBYTE	pg_SpeedType				* Speed timing type (look Set Speed
										* (track.i) for details)
	UBYTE	pg_PlayType					* Play type. See above for details.
	UWORD	pg_TraceCount				* Trace counter
	STRUCT	pg_Reserved,12				* Reserved for future
	LABEL	pg_SIZEOF

* Host player channel structure (Used by player)
	STRUCTURE	PlayerHostChannel,0
	APTR	phc_Order					* APTR to order playing
	APTR	phc_Track					* APTR to track currently playing
	APTR	phc_Effect					* APTR to effect to be processed
	APTR	phc_Instrument				* APTR to current instrument
	APTR	phc_Sample					* APTR to current sample
	UWORD	phc_Row						* Row currently playing
	UWORD	phc_FinePatternDelay		* Fine pattern delay value
	ULONG	phc_TempoCounter			* Tempo counter (current tick)
	ULONG	phc_MaxRow					* Last row before new pattern
	ULONG	phc_Flags					* Track flags (look upwards)
	ULONG	phc_FineSlideFlags			* Fine slide flags (look upwards)
	UWORD	phc_Tempo					* Track tempo (in cycles)
	WORD	phc_FinalNote				* Final note playing (C-0 is 0)
	UBYTE	phc_InstrNote				* Current instrument note (C-0 is 1)
	UBYTE	phc_SampleNote				* Current sample note (C-0 is 1)
	UBYTE	phc_TrackVolume				* Track volume (or channel volume)
	UBYTE	phc_TrackSubVol				* Track sub-volume
	UBYTE	phc_TrackPanning			* Track panning position
	UBYTE	phc_TrackSubPan				* Track sub-panning position
	UBYTE	phc_TrackNotePan			* Track note panning
	UBYTE	phc_TrackNoteSubPan			* Track note sub-panning
	UBYTE	phc_ChannelPanning			* Track channel panning
	UBYTE	phc_ChannelSubPan			* Track channel sub-panning
	UBYTE	phc_FineTune				* Current sample finetune
	UBYTE	phc_ArpeggioTick			* Arpeggio tick
	LONG	phc_ArpeggioFrequency		* Arpeggio frequency
	BYTE	phc_ArpeggioFirst			* Arpeggio first value
	BYTE	phc_ArpeggioSecond			* Arpeggio second value
	UWORD	phc_SmpOffsetHI				* High 16 bits of sample offset cmd
	UBYTE	phc_FirstChannelSync		* 1st channel to be sync
	UBYTE	phc_SecondChannelSync		* 2nd channel to be sync
	UBYTE	phc_ThirdChannelSync		* 3rd channel to be sync
	UBYTE	phc_FourthChannelSync		* 4th channel to be sync
	UWORD	phc_PortaUpValue			* Portamento up slide value
	UWORD	phc_PortaDownValue			* Portamento down slide value
	UWORD	phc_FinePortaUpValue		* Fine portamento up slide value
	UWORD	phc_FinePortaDownValue		* Fine portamento down slide value
	UWORD	phc_PortaUpOnceValue		* Portamento up once slide value
	UWORD	phc_PortaDownOnceValue		* Portamento down once slide value
	UWORD	phc_FinePortaUpOnceValue	* Fine portamento up once slide value
	UWORD	phc_FinePortaDownOnceValue	* Fine porta down once slide value
	UWORD	phc_TonePortaValue			* Tone portamento slide value
	UWORD	phc_FineTonePortaValue		* Fine tone portamento value
	UWORD	phc_TonePortaOnceValue		* Tone portamento once slide value
	UWORD	phc_FineTonePortaOnceValue	* Fine tone porta once slide value
	ULONG	phc_TonePortaTargetPitch	* Tone portamento target pitch
	UBYTE	phc_SubSlideValue			* Current subslide (pitch) value
	UBYTE	phc_NoteSlideType			* Note slide type
	UBYTE	phc_NoteSlideValue			* Note slide value
	UBYTE	phc_GlissandoValue			* Glissando value
	LONG	phc_VibratoSlideValue		* Relative vibrato slide value
	UWORD	phc_VibratoRate				* Vibrato rate
	UWORD	phc_VibratoDepth			* Vibrato depth
	UWORD	phc_NoteDelay				* Note delay tick
	UBYTE	phc_TremorOnTicks			* Tremor on ticks
	UBYTE	phc_TremorOffTicks			* Tremor off ticks
	UBYTE	phc_TremorCount				* Tremor count
	UBYTE	phc_SubSlideBits			* Sub-slide bits
	UWORD	phc_RetrigTickCount			* Retrigger tick counter
	UBYTE	phc_MultiRetrigTick			* Multi retrigger tick
	UBYTE	phc_MultiRetrigVolChg		* Multi retrigger volume change
	UBYTE	phc_MultiRetrigScale		* Multi retrig scale (01-04)
	UBYTE	phc_InvertCount				* Invert loop count
	UWORD	phc_InvertSpeed				* Invert loop speed
	UWORD	phc_ExecFX					* Execute FX at tick
	UBYTE	phc_VolumeSlideToValue		* Volume slide to speed value
	UBYTE	phc_TrackVolSlideToValue	* Track volume slide to speed value
	UBYTE	phc_PanningSlideToValue		* Panning slide to speed value
	UBYTE	phc_TrackPanSlideToValue	* Track panning slide to speed value
	UWORD	phc_VolSlideUpValue			* Volume slide up value
	UWORD	phc_VolSlideDownValue		* Volume slide down value
	UWORD	phc_FineVolSlideUpValue		* Fine volume slide up value
	UWORD	phc_FineVolSlideDownValue	* Fine volume slide down value
	UWORD	phc_VolumeSlideToSlide		* Volume slide to slide value
	UBYTE	phc_VolumeSlideToVolume		* Volume slide to volume
	UBYTE	phc_VolumeSlideToSubVol		* Volume slide to sub volume
	WORD	phc_TremoloSlideValue		* Tremolo relative slide value
	UBYTE	phc_TremoloDepth			* Tremolo depth
	UBYTE	phc_TremoloRate				* Tremolo rate
	UWORD	phc_TrackVolSlideUpValue	* Track volume slide up value
	UWORD	phc_TrackVolSlideDownValue	* Track volume slide down value
	UWORD	phc_FineTrkVolSlideUpValue	* Fine track volume slide up value
	UWORD	phc_FineTrkVolSlideDnValue	* Fine track volume slide down value
	UWORD	phc_TrackVolSlideToSlide	* Track volume slide to slide value
	UBYTE	phc_TrackVolSlideToVolume	* Track volume slide to volume
	UBYTE	phc_TrackVolSlideToSubVol	* Track volume slide to sub volume
	WORD	phc_TrackTremSlideValue		* Track relative slide value
	UBYTE	phc_TrackTremDepth			* Track tremolo depth
	UBYTE	phc_TrackTremRate			* Track tremolo rate
	UWORD	phc_PanSlideLeftValue		* Panning slide left value
	UWORD	phc_PanSlideRightValue		* Panning slide right value
	UWORD	phc_FinePanSlideLeftValue	* Fine panning slide left value
	UWORD	phc_FinePanSlideRightValue	* Fine panning slide right value
	UWORD	phc_PanningSlideToSlide		* Panning slide to slide value
	UBYTE	phc_PanningSlideToPanning	* Panning slide to panning
	UBYTE	phc_PanningSlideToSubPan	* Panning slide to sub panning
	WORD	phc_PannoloSlideValue		* Pannolo relative slide value
	UBYTE	phc_PannoloDepth			* Pannolo depth
	UBYTE	phc_PannoloRate				* Pannolo rate
	UWORD	phc_TrackPanSlideLeftValue	* Track panning slide left value
	UWORD	phc_TrackPanSlideRightValue	* Track panning slide right value
	UWORD	phc_FineTrkPanSldLeftValue	* Fine track panning slide left value
	UWORD	phc_FineTrkPanSldRightValue	* Fine track pan slide right value
	UWORD	phc_TrackPanSlideToSlide	* Track panning slide to slide value
	UBYTE	phc_TrackPanSlideToPanning	* Track panning slide to panning
	UBYTE	phc_TrackPanSlideToSubPan	* Track panning slide to sub panning
	UWORD	phc_TrackPanSlideValue		* Track pannolo relative slide value
	UBYTE	phc_TrackPanDepth			* Track pannolo depth
	UBYTE	phc_TrackPanRate			* Track pannolo rate
	UWORD	phc_BreakRow				* Pattern break row
	UWORD	phc_PosJump					* Position to jump to
	UWORD	phc_ChgPattern				* Change pattern number
	UWORD	phc_PatternDelayCount		* Pattern delay current count
	UWORD	phc_PatternDelay			* Pattern delay (0 for nothing)
	UWORD	phc_PatternLoopDepth		* Pattern loop stack depth
	UWORD	phc_GoSub					* GoSub order number
	UWORD	phc_GoSubDepth				* GoSub stack depth
	UWORD	phc_VirtualChannel			* Number of virtual channel
	UWORD	phc_NumVirtual				* Virtual channels allocated
	UBYTE	phc_Transpose				* Set transpose
	BYTE	phc_TransFineTune			* Set transpose fine tune
	UBYTE	phc_EnvCtrlKind				* Kind of envelope to be changed
	UBYTE	phc_EnvCtrlChange			* Envelope control change
	UWORD	phc_EnvCtrlValue			* Envelope control value
	UBYTE	phc_SynthCtrlCount			* How many items to be changed
	UBYTE	phc_SynthCtrlChange			* Synth item to be changed
	UWORD	phc_SynthCtrlValue			* Synth control value
	UBYTE	phc_DCT						* Current Duplicate Check Type
	UBYTE	phc_DNA						* Current Duplicate Check Action
	UBYTE	phc_NNA						* Current New Note Action
	UBYTE	phc_ChControlFlags			* Channel control flags
	UBYTE	phc_ChControlType			* Channel control type (global, etc.)
	UBYTE	phc_ChControlMode			* Control mode (normal, a row, etc.)
	UBYTE	phc_ChControlAffect			* Control affect (notes, non-notes)
	UBYTE	phc_ChControlChannel		* Control channel (single type)
	UBYTE	phc_SlideFXChLeftValue		* Slide effect channel left value
	UBYTE	phc_SlideFXChRightValue		* Slide effect channel right value
	UBYTE	phc_FineSlideFXChLeftValue	* Fine slide effect chan. left value
	UBYTE	phc_FineSlideFXChRightValue	* Fine slide effect chan. right value
	UBYTE	phc_SlideFXChannelToValue	* Slide effect channel to value
	UBYTE	phc_SlideFXChannelToChannel	* Slide effect channel to channel
	WORD	phc_ChannoloChannel			* Channolo channel
	UBYTE	phc_ChannoloDepth			* Channolo depth
	UBYTE	phc_ChannoloRate			* Channolo rate
	STRUCT	phc_VibratoEnv,pes_SIZEOF	* Vibrato envelope
	STRUCT	phc_TremoloEnv,pes_SIZEOF	* Tremolo envelope
	STRUCT	phc_PannoloEnv,pes_SIZEOF	* Pannolo envelope
	STRUCT	phc_ChannoloEnv,pes_SIZEOF	* Channolo envelope
	STRUCT	phc_ArpStructure,pes_SIZEOF	* Arpeggio definition to be used
	STRUCT	phc_TrackTremEnv,pes_SIZEOF	* Track tremolo envelope
	STRUCT	phc_TrackPanEnv,pes_SIZEOF	* Track pannolo envelope
	APTR	phc_PrevVolumeEnv			* Previous volume envelope pointer
	APTR	phc_PrevPanningEnv			* Previous panning envelope pointer
	APTR	phc_PrevSlideEnv			* Previous slide envelope pointer
	APTR	phc_PrevAutoVibEnv			* Previous auto vibrato envelope ptr
	APTR	phc_PrevAutoTremEnv			* Previous auto tremolo envelope ptr
	APTR	phc_PrevAutoPanEnv			* Previous auto pannolo envelope ptr
	APTR	phc_WaveformList			* Pointer to linked list of waveforms
	APTR	phc_Synth					* Pointer to synth structure for
										* obtaining the synth code structure
	UWORD	phc_VolumePos				* Entry pos. of volume handling code
	UWORD	phc_PanningPos				* Entry pos. of panning handling code
	UWORD	phc_SlidePos				* Entry pos. of slide handling code
	UWORD	phc_SpecialPos				* Entry pos. of special handling code
	UWORD	phc_VolumeSusPos			* Entry pos. of sustain volume code
	UWORD	phc_PanningSusPos			* Entry pos. of sustain panning code
	UWORD	phc_SlideSusPos				* Entry pos. of sustain slide code
	UWORD	phc_SpecialSusPos			* Entry pos. of sustain special code
	UWORD	phc_VolNNAPos				* Position of volume handling code
										* when NNA has been triggered. This
										* allows custom NNA handling !
	UWORD	phc_PanNNAPos				* Pos. of panning handling NNA code
	UWORD	phc_SlideNNAPos				* Pos. of slide handling NNA code
	UWORD	phc_SpecialNNAPos			* Pos. of special NNA handling code
	UWORD	phc_VolDNAPos				* Position of volume handling code
										* when DNA has been triggered. This
										* allows custom DNA handling !
	UWORD	phc_PanDNAPos				* Pos. of panning handling DNA code
	UWORD	phc_SlideDNAPos				* Pos. of slide handling DNA code
	UWORD	phc_SpecialDNAPos			* Pos. of special DNA handling code
	UWORD	phc_Variable0				* Initial contents of variable 0
	UWORD	phc_Variable1				* Initial contents of variable 1
	UWORD	phc_Variable2				* Initial contents of variable 2
	UWORD	phc_Variable3				* Initial contents of variable 3
	UWORD	phc_Variable4				* Initial contents of variable 4
	UWORD	phc_Variable5				* Initial contents of variable 5
	UWORD	phc_Variable6				* Initial contents of variable 6
	UWORD	phc_Variable7				* Initial contents of variable 7
	UWORD	phc_Variable8				* Initial contents of variable 8
	UWORD	phc_Variable9				* Initial contents of variable 9
	UWORD	phc_VariableA				* Initial contents of variable 10
	UWORD	phc_VariableB				* Initial contents of variable 11
	UWORD	phc_VariableC				* Initial contents of variable 12
	UWORD	phc_VariableD				* Initial contents of variable 13
	UWORD	phc_VariableE				* Initial contents of variable 14
	UWORD	phc_VariableF				* Initial contents of variable 15
	UWORD	phc_VolConVar				* Contents of volume condition var.
	UWORD	phc_PanConVar				* Contents of panning condition var.
	UWORD	phc_SlideConVar				* Contents of slide condition var.
	UWORD	phc_SpecialConVar			* Contents of special condition var.
	STRUCT	phc_ControlChannels,(256/8)	* Bits for control channels 0-255
	STRUCT	phc_EffectsUsed,(128/8)		* Bits for used effects (0-7F)
	STRUCT	phc_Reserved,24				* Reserved for future versions !
	LABEL	phc_NextHostChannel			* Next host channel
	LABEL	phc_SIZEOF

* Channel control types
CH_CTRL_OFF		EQU	0					* Channel control turned off
CH_CTRL_NORMAL	EQU	1					* Channel control normal
CH_CTRL_MULTI	EQU	2					* Channel control multiple channels
CH_CTRL_GLOBAL	EQU	3					* Channel control all channels

* Channel control modes
CH_MODE_NORMAL	EQU	0					* Channel control mode one effect
CH_MODE_TICK	EQU	1					* Channel control one tick
CH_MODE_ROW		EQU	2					* Channel control one row
CH_MODE_TRACK	EQU	3					* Channel control one track
CH_MODE_SONG	EQU	4					* Channel control whole song

* Player channel structure (Used by player for NNAs mainly)
	STRUCTURE	PlayerChannel,0
	STRUCT	pc_ChannelData,ms_SIZEOF	* Play data for channel
	APTR	pc_Instrument				* APTR to instrument structure
	APTR	pc_Sample					* APTR to sample structure
	ULONG	pc_Frequency				* Output frequency in Hz
	UBYTE	pc_Volume					* Volume
	UBYTE	pc_SubVol					* Sub-volume
	UWORD	pc_InstrVolume				* Instrument/sample global volume
	UBYTE	pc_Panning					* Panning position
	UBYTE	pc_SubPan					* Sub-panning position
	UBYTE	pc_FinalVolume				* Final volume
	UBYTE	pc_FinalPanning				* Final panning
	UBYTE	pc_GlobalVolume				* Global volume
	UBYTE	pc_GlobalSubVol				* Global sub volume
	UBYTE	pc_GlobalPanning			* Global panning
	UBYTE	pc_GlobalSubPan				* Global sub panning
	UWORD	pc_VolumeSwing				* Current volume swing
	UWORD	pc_PanningSwing				* Current panning swing
	ULONG	pc_PitchSwing				* Current pitch swing
	UWORD	pc_HostChannel				* Host channel used (0 - 255)
	UWORD	pc_Flags					* Special flags (see upwards)
	STRUCT	pc_VolEnvelope,pes_SIZEOF	* Volume envelope
	STRUCT	pc_PanEnvelope,pes_SIZEOF	* Panning envelope
	STRUCT	pc_SlideEnvelope,pes_SIZEOF	* Slide envelope
	STRUCT	pc_AutoVibEnv,pes_SIZEOF	* Auto vibrato envelope
	STRUCT	pc_AutoTremoEnv,pes_SIZEOF	* Auto tremolo envelope
	STRUCT	pc_AutoPanEnv,pes_SIZEOF	* Auto pannolo envelope
	LONG	pc_SlideEnvelopeFrequency	* Slide envelope relative frequency
	LONG	pc_AutoVibFrequency			* Auto vibrato frequency
	WORD	pc_AutoTremoVolume			* Auto tremolo volume
	WORD	pc_AutoPanPanning			* Auto pannolo panning
	UWORD	pc_AutoVibCount				* Auto vibrato counter
	UWORD	pc_AutoTremoCount			* Auto tremolo counter
	UWORD	pc_AutoPanCount				* Auto pannolo counter
	UWORD	pc_FadeOut					* Fade out value
	UWORD	pc_FadeOutCount				* Current fade out count
	WORD	pc_PitchPanSeparation		* Current pitch panning separation
	UBYTE	pc_PitchPanCenter			* Current pitch panning center
	UBYTE	pc_DCA						* Decay action
	UWORD	pc_Hold						* Hold value
	UWORD	pc_Decay					* Decay value
	UWORD	pc_AutoVibSweep				* Auto vibrato sweep
	UWORD	pc_AutoTremoSweep			* Auto tremolo sweep
	UWORD	pc_AutoPanSweep				* Auto pannolo sweep
	UBYTE	pc_AutoVibDepth				* Auto vibrato depth
	UBYTE	pc_AutoVibRate				* Auto vibrato rate
	UBYTE	pc_AutoTremoDepth			* Auto tremolo depth
	UBYTE	pc_AutoTremoRate			* Auto tremolo rate
	UBYTE	pc_AutoPanDepth				* Auto pannolo depth
	UBYTE	pc_AutoPanRate				* Auto pannolo rate
	UBYTE	pc_InstrNote				* Instrument note (C-0 is 1)
	UBYTE	pc_SampleNote				* Sample note (C-0 is 1)
	APTR	pc_WaveformList				* APTR to waveform list
	APTR	pc_Synth					* APTR to synth structure for
										* obtaining the synth code structure
	APTR	pc_SampleWaveform			* APTR to sample waveform structure
	APTR	pc_VibratoWaveform			* APTR to vibrato waveform structure
	APTR	pc_TremoloWaveform			* APTR to tremolo waveform structure
	APTR	pc_PannoloWaveform			* APTR to pannolo waveform structure
	APTR	pc_ArpeggioWaveform			* APTR to arpeggio waveform structure
	UWORD	pc_VolumePos				* Current volume position (line)
	UWORD	pc_PanningPos				* Current panning position (line)
	UWORD	pc_SlidePos					* Current slide position (line)
	UWORD	pc_SpecialPos				* Current special position (line)
	UWORD	pc_VolumeSusPos				* Current volume sustain pos. entry
	UWORD	pc_PanningSusPos			* Current panning sustain pos. entry
	UWORD	pc_SlideSusPos				* Current slide sustain pos. entry
	UWORD	pc_SpecialSusPos			* Current special sustain pos. entry
	UWORD	pc_VolNNAPos				* Current NNA volume pos. trigger
	UWORD	pc_PanNNAPos				* Current NNA panning pos. trigger
	UWORD	pc_SlideNNAPos				* Current NNA slide pos. trigger
	UWORD	pc_SpecialNNAPos			* Current NNA special pos. trigger
	UWORD	pc_VolDNAPos				* Current DNA volume pos. trigger
	UWORD	pc_PanDNAPos				* Current DNA panning pos. trigger
	UWORD	pc_SlideDNAPos				* Current DNA slide pos. trigger
	UWORD	pc_SpecialDNAPos			* Current DNA special pos. trigger
	UWORD	pc_Variable0				* Current contents of variable 0
	UWORD	pc_Variable1				* Current contents of variable 1
	UWORD	pc_Variable2				* Current contents of variable 2
	UWORD	pc_Variable3				* Current contents of variable 3
	UWORD	pc_Variable4				* Current contents of variable 4
	UWORD	pc_Variable5				* Current contents of variable 5
	UWORD	pc_Variable6				* Current contents of variable 6
	UWORD	pc_Variable7				* Current contents of variable 7
	UWORD	pc_Variable8				* Current contents of variable 8
	UWORD	pc_Variable9				* Current contents of variable 9
	UWORD	pc_VariableA				* Current contents of variable 10
	UWORD	pc_VariableB				* Current contents of variable 11
	UWORD	pc_VariableC				* Current contents of variable 12
	UWORD	pc_VariableD				* Current contents of variable 13
	UWORD	pc_VariableE				* Current contents of variable 14
	UWORD	pc_VariableF				* Current contents of variable 15
	UWORD	pc_VolConVar				* Contents of volume condition var.
	UWORD	pc_PanConVar				* Contents of panning condition var.
	UWORD	pc_SlideConVar				* Contents of slide condition var.
	UWORD	pc_SpecialConVar			* Contents of special condition var.
	UBYTE	pc_UseNNAFlags				* Use NNA positions. See synth.i
	UBYTE	pc_UseSusFlags				* Use sustain flags. See synth.i
	WORD	pc_FinalNote				* Final note playing (C-0 is 0)
	BYTE	pc_FineTune					* Sample fine tune
	UBYTE	pc_StopForbidMask			* STOP forbid/permit mask
	UWORD	pc_VibratoPos				* Current vibrato waveform position
	UWORD	pc_TremoloPos				* Current tremolo waveform position
	UWORD	pc_PannoloPos				* Current pannolo waveform position
	UWORD	pc_ArpeggioPos				* Current arpeggio waveform position
	UWORD	pc_SynthFlags				* Synth flags. See above
	UWORD	pc_KillVolCount				* Current volume KILL count in ticks
	UWORD	pc_KillPanCount				* Current panning KILL count in ticks
	UWORD	pc_KillSldCount				* Current slide KILL count in ticks
	UWORD	pc_KillSpcCount				* Current special KILL count in ticks
	UWORD	pc_WaitVolCount				* Current volume WAIT count in ticks
	UWORD	pc_WaitPanCount				* Current panning WAIT count in ticks
	UWORD	pc_WaitSldCount				* Current slide WAIT count in ticks
	UWORD	pc_WaitSpcCount				* Current special WAIT count in ticks
	UWORD	pc_WaitVolLine				* Volume handling line to wait
	UWORD	pc_WaitPanLine				* Panning handling line for wait
	UWORD	pc_WaitSldLine				* Slide handling line for wait
	UWORD	pc_WaitSpcLine				* Special handling line for wait
	UBYTE	pc_WaitVolType				* Volume handling type to wait
										* (0 is WAITVOL, 1 is WAITPAN, 2 is
										* WAITSLD and 3 is WAITSPC)
	UBYTE	pc_WaitPanType				* Panning handling type to wait
	UBYTE	pc_WaitSldType				* Slide handling type to wait
	UBYTE	pc_WaitSpcType				* Special handling type to wait
	UWORD	pc_PortaUpValue				* PORTAUP memory
	UWORD	pc_PortaDnValue				* PORTADN memory
	LONG	pc_PortamentoValue			* PORTAUP/PORTADN total value
	LONG	pc_VibratoSlideValue		* VIBRATO relative slide value
	UWORD	pc_VibratoRate				* VIBRATO rate
	UWORD	pc_VibratoDepth				* VIBRATO depth
	LONG	pc_ArpeggioSlideValue		* ARPEGIO relative slide value
	UWORD	pc_ArpeggioSpeed			* ARPEGIO speed value
	BYTE	pc_ArpeggioTranspose		* APREGIO transpose
	UBYTE	pc_ArpeggioFineTune			* ARPEGIO fine tune
	UWORD	pc_VolSlUpValue				* VOLSLUP memory
	UWORD	pc_VolSlDnValue				* VOLSLDN memory
	WORD	pc_TremoloSlideValue		* TREMOLO relative slide value
	UWORD	pc_TremoloDepth				* TREMOLO depth
	UWORD	pc_TremoloRate				* TREMOLO rate
	UWORD	pc_PanSlLeftValue			* PANLEFT slide left value
	UWORD	pc_PanSlRightValue			* PANRGHT slide right value
	WORD	pc_PannoloSlideValue		* PANNOLO relative slide value
	UWORD	pc_PannoloDepth				* PANNOLO depth
	UWORD	pc_PannoloRate				* PANNOLO rate
	STRUCT	pc_Reserved,16				* Reserved for future versions
	LABEL	pc_PlayerChannelx			* Next channel
	LABEL	pc_SIZEOF

	ENDC	; TUCOMPOSER_PLAYER_I
