	IFND	TUCOMPOSER_POSITION_I
TUCOMPOSER_POSITION_I	SET	1
**
**	$Filename: tucomposer/position.i $
**	$Release : 31.22 $
**
**
**
**	(C) Copyright 1996-98 by The united Coders (TuC)
**      Main code: Basty/TuC
**		All Rights Reserved
**

		IFND	EXEC_TYPES_I
		include	"exec/types.i"
		ENDC	; EXEC_TYPES_I

		IFND	EXEC_NODES_I
		include	"exec/nodes.i"
		ENDC	; EXEC_NODES_I

		IFND	EXEC_LISTS_I
		include	"exec/lists.i"
		ENDC	; EXEC_LISTS_I

		IFND	TUCOMPOSER_TUCOMPOSER_I
		include	"tucomposer/tucomposer.i"
		ENDC	; TUCOMPOSER_TUCOMPSER_I

* No bits defined yet for tco_CompFlags

* Bit definitions for tco_Flags:
	BITDEF	TCO,Surround,0				* Default surround panning
	BITDEF	TCO,TrackSurround,1			* Default track surround panning
	BITDEF	TCO,Muted,2					* Channel initially muted

* Bit definitions for tcol_Flags:
	BITDEF	TCOL,EndOrder,0				* Position indicates end of order
	BITDEF	TCOL,EndSong,1				* Position indicates end of whole
										* song
	BITDEF	TCOL,NotInOnce,2			* If bit is set, this order entry
										* will be skipped if you're playing
										* the module in song once mode. If
										* clear, it will be played in once
										* mode.
	BITDEF	TCOL,NotInRepeat,3			* If this is set, the order entry
										* will be skipped if you're in
										* song repeat mode. If cleared, it
										* will be played in repeat mode.
										* NOTE: Setting TCOLB_NotInOnce, and
										* TCOLB_NotInRepeat at same time, is
										* a little bit silly :-). If both
										* are cleared, this entry will be
										* played in both cases, of course.
	BITDEF	TCOL,TrackSync,4			* If set, this order entry causes
										* to be synchronized with up to 4
										* others. tcol_StartRow and
										* tcol_EndRow decide up to 4 tracks
										* to be synchronized with
										* If tcol_StartRow and tcol_EndRow
										* are $0000, sync with all channels.
										* The hi-byte of tcol_StartRow is 1st
										* track to be sync, lo-byte the 2nd,
										* hi-byte tcol_EndRow is 3th track,
										* and the lo-byte the 4th track.
	BITDEF	TCOL,SetVolume,5			* Bit set takes advantage of the
										* position volume set

* Orders structure, used by all position functions (e.g. AddPosition())
	STRUCTURE	TuComposerOrders,0
	STRUCT	tco_OrderData,MLH_SIZE		* Order list data of channel 0
	UWORD	tco_Length					* Order list entries of channel 0
	UWORD	tco_RepStart				* Repeat start of channel 0
	UBYTE	tco_Volume					* Volume of channel 0
	UBYTE	tco_SubVol					* Sub volume of channel 0
	BYTE	tco_TrackPanning			* Track panning of channel 0
	UBYTE	tco_TrackSubPan				* Track sub panning of channel 0
	BYTE	tco_Panning					* Channel panning of channel 0
	UBYTE	tco_SubPan					* Channel sub panning of channel 0
	UBYTE	tco_CompFlags				* Compatilibity flags for channel 0
	UBYTE	tco_Flags					* Special flags for channel 0
	STRUCT	tco_Reserved,8				* Reserved for channel 0
	LABEL	tco_NextOrderx				* Linked list to channel x repeat
										* start and order list. This comes
										* as often as many channels are used
										* in the song.
	LABEL	tco_SIZEOF

* Order structure default values
DEFAULTPOSVOLUME	EQU	$FF				* Full volume by default
DEFAULTPOSSUBVOL	EQU	$0				* No sub volume by default
DEFAULTPOSPANNING	EQU	$80				* Full panning by default
DEFAULTPOSSUBPAN	EQU	$0				* No sub panning by default

* Position error codes

ERROR_POSITION_NOGIVEN	EQU	ERROR_POSITION		* If no position given
ERROR_POSITION_NOMEM	EQU	ERROR_POSITION+$1	* Returned on mem fail
ERROR_POSLIST_NOGIVEN	EQU	ERROR_POSITION+$8	* If no position list given

* Order List structure, this contains actual order list data.
	STRUCTURE	TuComposerOrderList,MLN_SIZE
	APTR	tcol_Track					* APTR to playing track.
	APTR	tcol_NextPos				* Next position pointer if you
										* skip forward in a player
	APTR	tcol_PrevPos				* Previous position pointer if you
										* skip backward in a player
	UWORD	tcol_NextRow				* Number of next row if you skip
										* forward in a module player
	UWORD	tcol_PrevRow				* Number of next row if you skip
										* backward in a module player
	UWORD	tcol_FirstRow				* Beginning row of this track.
	UWORD	tcol_LastRow				* Last row of this track. If set to
										* $FFFF this feature is disabled.
	UBYTE	tcol_Flags					* Special flags, see upwards.
	BYTE	tcol_Transpose				* Relative note transpose for
										* full track. Allows playing several
										* tracks some half-tones higher/lower
	WORD	tcol_InstrTranspose			* Instrument transpose. All
										* instruments will be mapped to this
										* if this is non-zero.
	UWORD	tcol_Tempo					* Tempo change or NULL to for keep
	UBYTE	tcol_Volume					* Track volume (this overrides
										* the track settings). To enable
										* this, bit TCOLB_Volume must be set.
	UBYTE	tcol_SubVol					* Track sub volume (this overrides
										* track).
	UWORD	tcol_Played					* Played nesting level (nesting
										* level is gosub depth)
	STRUCT	tcol_Reserved,8				* Reserved for future expansions
	APTR	tcol_UserData				* Extra for you !
	LABEL	tcol_SIZEOF

* TuComposer Position Header. Used by disk operations
* (e.g. by LoadTCModule() & SaveTCModule())

	STRUCTURE	IFF_PHDR,iff_SIZEOF
	UWORD	phdr_Length					* Order list entries
	UWORD	phdr_RepStart				* Repeat start
	UBYTE	phdr_Volume					* Channel volume
	UBYTE	phdr_SubVol					* Sub volume
	BYTE	phdr_TrackPanning			* Track panning
	UBYTE	phdr_TrackSubPan			* Track sub panning
	BYTE	phdr_Panning				* Channel panning
	UBYTE	phdr_SubPan					* Channel sub panning
	UBYTE	phdr_CompFlags				* Compatilibity flags
	UBYTE	phdr_Flags					* Special flags
	LABEL	phdr_SIZEOF

* TuComposer Position Data. Used by disk operations
* (e.g. by LoadTCModule() & SaveTCModule())

	STRUCTURE	IFF_PDAT,iff_SIZEOF
	UWORD	pdat_TrackNum				* Track number to be used
	UWORD	pdat_NextPos				* Next position number to be used
	UWORD	pdat_PrevPos				* Previous position to be used
	UWORD	pdat_NextRow				* Start row of next order entry
	UWORD	pdat_PrevRow				* Start row of previous order entry
	UWORD	pdat_FirstRow				* First row to play
	UWORD	pdat_LastRow				* Last row to play
	UBYTE	pdat_Flags					* Flags
	BYTE	pdat_Transpose				* Note transpose for full track
	WORD	pdat_InstrTranspose			* Instrument transpose for full track
	UWORD	pdat_Tempo					* Tempo change or NULL to for keep
	UBYTE	pdat_Volume					* Order volume (overrides track vol)
	UBYTE	pdat_SubVol					* Order sub volume
	LABEL	pdat_SIZEOF

POSI_NAME	EQU	(('P'<<24)!('O'<<16)!('S'<<8)!('I'))
POST_NAME	EQU	(('P'<<24)!('O'<<16)!('S'<<8)!('T'))
PHDR_NAME	EQU	(('P'<<24)!('H'<<16)!('D'<<8)!('R'))
POSL_NAME	EQU	(('P'<<24)!('O'<<16)!('S'<<8)!('L'))
PDAT_NAME	EQU	(('P'<<24)!('D'<<16)!('A'<<8)!('T'))

C_POSI	MACRO
	dc.b	'POSI'
	ENDM
POSI_CHUNK	MACRO	* Length
	C_FORM
	dc.l	\1
	C_POSI
	ENDM

C_POST	MACRO
	dc.b	'POST'
	ENDM
POST_CHUNK	MACRO	* Length
	C_FORM
	dc.l	\1
	C_POST
	ENDM

C_PHDR	MACRO
	dc.b	'PHDR'
	ENDM
PHDR_CHUNK	MACRO	* Length
	C_PHDR
	dc.l	\1
	ENDM

C_POSL	MACRO
	dc.b	'POSL'
	ENDM
POSL_CHUNK	MACRO	* Length
	C_FORM
	dc.l	\1
	C_POSL
	ENDM

PDAT	MACRO
	dc.b	'PDAT'
	ENDM
PDAT_CHUNK	MACRO	* Length
	C_FORM
	dc.l	\1
	C_PDAT
	ENDM

	ENDC	; TUCOMPOSER_POSITION_I
