	IFND	TUCOMPOSER_SAMPLE_I
TUCOMPOSER_SAMPLE_I	SET	1
**
**	$Filename: tucomposer/sample.i $
**	$Release : 31.22 $
**
**
**
**	(C) Copyright 1996-98 by The united Coders (TuC)
**      Main code: Basty/TuC
**		All Rights Reserved
**

		IFND	EXEC_TYPES_I
		include	"exec/types.i"
		ENDC	; EXEC_TYPES_I

		IFND	EXEC_NODES_I
		include	"exec/nodes.i"
		ENDC	; EXEC_NODES_I

		IFND	EXEC_LISTS_I
		include	"exec/lists.i"
		ENDC	; EXEC_LISTS_I

		IFND	TUCOMPOSER_TUCOMPOSER_I
		include	"tucomposer/tucomposer.i"
		ENDC	; TUCOMPOSER_TUCOMPSER_I

* Bit definitions for tcs_CompFlags:
	BITDEF	TCSC,AffectChanPan,0	* Sample panning affects channel panning
									* (like IT does)
	BITDEF	TCSC,VolumeOnly,1		* If a note without a sample is played,
									* only the sample volume will be left
									* unchanged
	BITDEF	TCSC,StartTonePorta,2	* If a tone porta with a note is executed
									* but no note is currently played, the
									* tone porta will be ignored and start
									* playing the note normally
	BITDEF	TCSC,PlayBegin,3		* If you change a sample within a tone
									* portamento the samples will be played
									* from it's beginning

* Bit definitions for tcs_Flags:
	BITDEF	TCS,Redirect,0		* If bit set, this is a redirection sample
	BITDEF	TCS,Loop,1			* If bit set, sample uses looping
	BITDEF	TCS,SustainLoop,2	* If bit set, sample uses sustain loop
	BITDEF	TCS,SmpPanning,3	* If bit set, sample panning will be
								* used
	BITDEF	TCS,SurroundPan,4	* If bit set, sample pan is surround panning
	BITDEF	TCS,Reverse,6		* If bit set, sample will be played
								* backwards initially

* Bit definitions for tcs_RepMode and tcs_SustainRepMode:
	BITDEF	TCSR,Backwards,0	* If set backward loop, else forward
	BITDEF	TCSR,Pingpong,1		* If set ping pong loop, else not

* Bit definitions for tcs_EnvUsageFlags:
	BITDEF	TCSEU,UseAutoVibEnv,0	* Use (reload) auto vibrato envelope
	BITDEF	TCSEU,UseAutoTremEnv,1	* Use (reload) auto tremolo envelope
	BITDEF	TCSEU,UseAutoPanEnv,2	* Use (reload) auto pannolo envelope

* Bit definitions for tcs_EnvProcFlags:
	BITDEF	TCSEP,ProcAutoVibEnv,0	* Add 1st, then get auto vib. env. value
	BITDEF	TCSEP,ProcAutoTremEnv,1	* Add 1st, then get auto trem. env. value
	BITDEF	TCSEP,ProcAutoPanEnv,2	* Add 1st, then get auto pan. env. value
	BITDEF	TCSEP,LinearAutoVib,7	* If bit is set, linear frequence table
									* for auto vibrato will be used

* Bit definitions for tcs_EnvRetrigFlags:
	BITDEF	TCSER,NotRetrigAVibEnv,0	* Not retrigger auto vibrato envelope
	BITDEF	TCSER,NotRetrigATremEnv,1	* Not retrigger auto tremolo envelope
	BITDEF	TCSER,NotRetrigAPanEnv,2	* Not retrigger auto pannolo envelope

* Bit definitions for tcs_EnvRandomFlags:
	BITDEF	TCSER,RandomAVibEnv,0	* Randomize auto vibrato envelope, if set
	BITDEF	TCSER,RandomATremEnv,1	* Randomize auto tremolo envelope, if set
	BITDEF	TCSER,RandomAPanEnv,2	* Randomize auto pannolo envelope, if set

* Bit definitions for smpl_Flags & smph_Flags:
	BITDEF	SMPL,Delta,0		* If bit is set, this is a delta sample.
								* All other bits are identically to
								* tcs_Flags.

* Bit definitions for SwapSampleInInstr():
	BITDEF	SSII,Swap,0			* If bit set, swap sample data
	BITDEF	SSII,Update,1		* If bit set, update keyboard defs

* Bit definitions for ConvertBits():
	BITDEF	CB,ChangeOnly,0		* If bit is set, change bit resolution only
								* and update tcs_Samples else do a sample
								* bit conversion.

* Bit definitions for GetOptimalBits():
	BITDEF	GOB,Check81632Only,0	* If bit is set, only 8, 16 and 32 bits
									* are checked.
	BITDEF	GOB,CheckOnce,1			* Do not find mininum but check instead
									* if the current bit depth can be
									* reduced further

* Bit definitions for ReSample():
	BITDEF	RS,Interpolation,0	* Resample with interpolation if set

* Sample structure, used by all Sample functions (e.g. SaveSampleRaw())
	STRUCTURE	TuComposerSample,MLN_SIZE
	APTR	tcs_FileName		* Pointer to sample file name
								* (e.g. C-Hihat.IFF). Remember
								* that TuComposer is also available for
								* MS-DOS and other platforms. So, please try
								* to use the limited 8x3 MS-DOS file/dir
								* name length.
	APTR	tcs_Name			* Pointer to sample name (e.g. Close Hihat)
	APTR	tcs_Synth			* APTR to synth structure if synth/hybrid,
								* else zero (look in synth.i for details).
	APTR	tcs_Data			* Pointer to raw sample data. If this is
								* a synth, this is zero.
	ULONG	tcs_Length			* Sample length (in bytes). If this is a
								* synth this is just zero.
	ULONG	tcs_Samples			* Number of samples (identical to tcs_Length
								* if 8 bit, and the halve if 16 bit)
	ULONG	tcs_Repeat			* Sample repeat
	ULONG	tcs_RepLen			* Sample repeat length
	ULONG	tcs_RepCount		* Sample count, NULL if no count
	ULONG	tcs_SustainRepeat	* Sample sustain repeat
	ULONG	tcs_SustainRepLen	* Sample sustain repeat length
	ULONG	tcs_SustainRepCount	* Sustain sample count, NULL if no count
	ULONG	tcs_Rate			* C-4 Sample frequency (in Hz)
	ULONG	tcs_StartOffset		* Start offset of playing (usually 0)
	ULONG	tcs_LowerRateLimit	* Lower sample rate limit (will not exceed
								* this during playing)
	ULONG	tcs_UpperRateLimit	* Upper sample rate limit (will not exceed
								* this during playing)
	UBYTE	tcs_BitDepth		* Sample bit resolution (currently 1 to 16
								* bit samples are supported)
	BYTE	tcs_Transpose		* Sample transpose
	BYTE	tcs_FineTune		* Sample fine tune value
	UBYTE	tcs_CompFlags		* Compatibility flags, see upwards.
	UBYTE	tcs_Flags			* Special flags, see upwards.
	UBYTE	tcs_RepMode			* Sample repeat mode (e.g. Pingpong mode)
	UBYTE	tcs_SustainRepMode	* Sample sustain loop mode (e.g. Pingpong)
	UBYTE	tcs_GlobalVolume	* 8-bit global volume of sample.
	UBYTE	tcs_Volume			* 8-bit default volume of sample.
	UBYTE	tcs_SubVol			* Sub volume (only used by vol-slide cmds)
	BYTE	tcs_Panning			* 8-bit panning of instr if TCSB_InsPanning
								* is set.
	UBYTE	tcs_SubPanning		* Sub panning (only used by pan-slide cmds)
	APTR	tcs_AutoVibratoEnv	* APTR to auto vibrato envelope (or zero)
	APTR	tcs_AutoTremoloEnv	* APTR to auto tremolo envelope (or zero)
	APTR	tcs_AutoPannoloEnv	* APTR to auto pannolo envelope (or zero)
	UBYTE	tcs_EnvUsageFlags	* Auto vibrato/tremolo/pannolo usage flags
	UBYTE	tcs_EnvProcFlags	* Auto vibrato/etc. processing flags
	UBYTE	tcs_EnvRetrigFlags	* Auto vibrato/etc. retrigger flags
	UBYTE	tcs_EnvRandomFlags	* Auto vibrato/etc. randomize flags
	UWORD	tcs_VibratoSweep	* Auto vibrato sweep
	UWORD	tcs_TremoloSweep	* Auto tremolo sweep
	UWORD	tcs_PannoloSweep	* Auto pannolo sweep
	UBYTE	tcs_VibratoDepth	* Auto vibrato depth
	UBYTE	tcs_VibratoRate		* Auto vibrato rate (speed)
	UBYTE	tcs_TremoloDepth	* Auto tremolo depth
	UBYTE	tcs_TremoloRate		* Auto tremolo rate (speed)
	UBYTE	tcs_PannoloDepth	* Auto pannolo depth
	UBYTE	tcs_PannoloRate		* Auto pannolo rate (speed)
	STRUCT	tcs_UnknownChunks,MLH_SIZE	* Linked list of unknown chunks
	STRUCT	tcs_Reserved,8		* Reserved for future expansions
	APTR	tcs_UserData		* Free for any user data.
	LABEL	tcs_SIZEOF

* Default settings for new sample.

DEFAULTSAMPLEBITDEPTH	EQU	8					* 8 bit sample by default
DEFAULTSAMPLERATE		EQU	8363				* Default sample rate (C-4)
DEFAULTSAMPLETRANSPOSE	EQU 0					* No default transpose
DEFAULTSAMPLEFINETUNE	EQU	0					* No default fine tune
DEFAULTSAMPLEVOLUME		EQU	$FF					* Full volume for default
DEFAULTSAMPLEPANNING	EQU	$80					* Middle panning

* Sample limitation definitions
MAXSAMPLESPERINSTR		EQU	256					* Maximum up to 256 samples
												* per instrument
LASTSAMPLEPERINSTR		EQU	MAXSAMPLESPERINSTR-1	* Last is the 255th
MINBITDEPTH				EQU	1					* The smallest bit depth is
												* 1 of a sample
MAXBITDEPTH				EQU	32					* Up to 32 bit samples are
												* supported by now

* Sample data allocation alignment rules
SMP_BLOCKSIZE			EQU	8					* The sample memory length
												* must be divideable through
												* 8 by now. This is for
												* faster processing within
												* some functions.
SMP_BLOCKMASK			EQU (SMP_BLOCKSIZE-1)	* Just for AND, OR, etc.

* Sample error codes

ERROR_SAMPLE_NOGIVEN	EQU	ERROR_SAMPLE+$0		* If no sample was given
ERROR_SAMPLE_NODATA		EQU	ERROR_SAMPLE+$1		* Sample contains no data
ERROR_SAMPLE_NOMEM		EQU	ERROR_SAMPLE+$2		* Returned on mem fail
ERROR_SAMPLE_TOOMANY	EQU	ERROR_SAMPLE+$3		* Too many samples (max. 255)
ERROR_SAMPLE_NOFILE		EQU	ERROR_SAMPLE+$4		* No filename specified
ERROR_SAMPLE_IOERR		EQU	ERROR_SAMPLE+$5		* I/O error occured
ERROR_SAMPLE_TOOSMALL	EQU	ERROR_SAMPLE+$8		* Sample too small
ERROR_SAMPLE_TOOBIG		EQU	ERROR_SAMPLE+$9		* Sample too big for operate
ERROR_SAMPLE_BITDEPTH	EQU	ERROR_SAMPLE+$A		* Bit resolution invalid
ERROR_SAMPLE_NO_LOOP	EQU	ERROR_SAMPLE+$B		* Returned if no loop
ERROR_SAMPLE_NOARRAY	EQU	ERROR_SAMPLE+$C		* No array given

* IFF-TCM1/IFF-TCI1 SMPH structure. Used by disk operations.
* (e.g. by LoadModule() & SaveModule())

	STRUCTURE	IFF_SMPH,iff_Data
	ULONG	smph_Samples			* Number of samples
	ULONG	smph_Repeat				* Sample repeat
	ULONG	smph_RepLen				* Sample repeat length
	ULONG	smph_RepCount			* Sample count, NULL if no count
	ULONG	smph_SustainRepeat		* Sample sustain repeat
	ULONG	smph_SustainRepLen		* Sample sustain repeat length
	ULONG	smph_SustainRepCount	* Sustain sample count, NULL if no count
	ULONG	smph_Rate				* C-4 Sample frequency (in Hz)
	ULONG	smph_StartOffset		* Start offset of playing (usually 0)
	ULONG	smph_LowerRateLimit		* Lower sample rate limit (will not
									* exceed this during playing)
	ULONG	smph_UpperRateLimit		* Upper sample rate limit (will not
									* exceed this during playing)
	UBYTE	smph_BitDepth			* Sample bit resolution (currently 1 to
									* 16 bit samples are supported)
	BYTE	smph_Transpose			* Sample transpose
	BYTE	smph_FineTune			* Sample fine tune value
	UBYTE	smph_CompFlags			* Compatibility flags, see upwards.
	UBYTE	smph_Flags				* Special flags, see upwards.
	UBYTE	smph_RepMode			* Sample repeat mode (e.g. Pingpong mode)
	UBYTE	smph_SustainRepMode		* Sample sustain repeat mode
	UBYTE	smph_GlobalVolume		* 8-bit global volume of sample.
	UBYTE	smph_Volume				* 8-bit default volume of sample.
	UBYTE	smph_SubVol				* Sub volume (used by vol-slide cmds)
	BYTE	smph_Panning			* 8-bit panning if TCSB_InsPanning is
									* is set.
	UBYTE	smph_SubPanning			* Sub panning (used by pan-slide cmds)
	UWORD	smph_AutoVibratoNum		* Number of auto vibrato envelope (or 0)
	UWORD	smph_AutoTremoloNum		* Number of auto tremolo envelope (or 0)
	UWORD	smph_AutoPannoloNum		* Number of auto pannolo envelope (or 0)
	UBYTE	smph_EnvUsageFlags		* Auto vibrato/tremolo/etc. usage flags
	UBYTE	smph_EnvProcFlags		* Auto vibrato/etc. processing flags
	UBYTE	smph_EnvRetrigFlags		* Auto vibrato/etc. retrigger flags
	UBYTE	smph_EnvRandomFlags		* Auto vibrato/etc. randomize flags
	UWORD	smph_VibratoSweep		* Auto vibrato sweep
	UWORD	smph_TremoloSweep		* Auto tremolo sweep
	UWORD	smph_PannoloSweep		* Auto pannolo sweep
	UBYTE	smph_VibratoDepth		* Auto vibrato depth
	UBYTE	smph_VibratoRate		* Auto vibrato rate (speed)
	UBYTE	smph_TremoloDepth		* Auto tremolo depth
	UBYTE	smph_TremoloRate		* Auto tremolo rate (speed)
	UBYTE	smph_PannoloDepth		* Auto pannolo depth
	UBYTE	smph_PannoloRate		* Auto pannolo rate (speed)
	LABEL	smph_SIZEOF

* IFF-TCM1 SMPR structure. Used by disk operations.
* (e.g. by LoadModule() & SaveModule())

	STRUCTURE	IFF_SMPR,iff_Data
	ULONG	smpr_SampleNum			* Sample number that contains the wave-
									* form (1 is the first). The number is
									* ABSOLUTE from the first sample of the
									* first instrument.
	LABEL	smpr_SIZEOF

SAMP_NAME	EQU	(('S'<<24)!('A'<<16)!('M'<<8)!('P'))
SMPL_NAME	EQU	(('S'<<24)!('M'<<16)!('P'<<8)!('L'))
SMPH_NAME	EQU	(('S'<<24)!('M'<<16)!('P'<<8)!('H'))
SMPR_NAME	EQU	(('S'<<24)!('M'<<16)!('P'<<8)!('R'))
SNTH_NAME	EQU	(('S'<<24)!('N'<<16)!('T'<<8)!('H'))

C_SAMP	MACRO
	dc.b	'SAMP'
	ENDM

SAMP_CHUNK	MACRO	* Length
	C_FORM
	dc.l	\1
	C_SAMP
	ENDM

C_SMPH	MACRO
	dc.b	'SMPH'
	ENDM

SMPH_CHUNK	MACRO	* Length
	C_SMPH
	dc.l	\1
	ENDM

C_SMPR	MACRO
	dc.b	'SMPR'
	ENDM

SMPR_CHUNK	MACRO	* Length
	C_SMPR
	dc.l	\1
	ENDM

C_SMPL	MACRO
	dc.b	'SMPL'
	ENDM

SMPL_CHUNK	MACRO	* Length
	C_FORM
	dc.l	\1
	C_SMPL
	ENDM

C_SNTH	MACRO
	dc.b	'SNTH'
	ENDM

SNTH_CHUNK	MACRO	* Length
	C_FORM
	dc.l	\1
	C_SNTH
	ENDM

	ENDC	; TUCOMPOSER_SAMPLE_I
