	IFND	TUCOMPOSER_SONG_I
TUCOMPOSER_SONG_I	SET	1
**
**	$Filename: tucomposer/song.i $
**	$Release : 31.22 $
**
**
**
**	(C) Copyright 1996-97 by The united Coders (TuC)
**      Main code: Basty/TuC
**		All Rights Reserved
**

		IFND	EXEC_TYPES_I
		include	"exec/types.i"
		ENDC	; EXEC_TYPES_I

		IFND	EXEC_NODES_I
		include	"exec/nodes.i"
		ENDC	; EXEC_NODES_I

		IFND	EXEC_LISTS_I
		include	"exec/lists.i"
		ENDC	; EXEC_LISTS_I

		IFND	TUCOMPOSER_TUCOMPOSER_I
		include	"tucomposer/tucomposer.i"
		ENDC	; TUCOMPOSER_TUCOMPOSER_I

* Bit definitions for tcso_CompFlags:
	BITDEF	TCSOC,Sync,0				* Tracks are synchronous, not
										* asynchronous (for MOD, S3M, etc.)
	BITDEF	TCSOC,GlobalLoop,1			* Global pattern loop memory
	BITDEF	TCSOC,AmigaLimits,2			* Flag indicates that the AMIGA
										* sound hardware is capable of
										* playback this song without mixing
	BITDEF	TCSOC,OldVolumes,3			* If set all volume related cmds are
										* handled as old volume cmds (i.e.
										* they range from 00-40, not 00-FF)
	BITDEF	TCSOC,GlobalNewOnly,4		* Global volume/panning changes
										* affect new notes only (as S3M)

* Bit definitions for tcso_Flags:
	BITDEF	TCSO,LinearFreqTable,0		* Bit set means, linear frequency
										* table is used, else Amiga freq
										* table is used.
	BITDEF	TCSO,UseSPD,1				* Use SPD timing instead BpM
	BITDEF	TCSO,Mono,2					* If bit is set, the song will be
										* played in mono, that means that
										* a stereo mix routine must set pan
										* always to middle or just activate
										* mono mixing (faster)
	BITDEF	TCSO,Surround,3				* Initial surround global panning

* Song structure, used by all song related functions (e.g. PlaySong())
	STRUCTURE	TuComposerSong,MLN_SIZE
	APTR	tcso_FileName				* File name of this song
	APTR	tcso_Name					* Song name.
	APTR	tcso_Message				* Song message (may span multiple
										* lines and contain ANSI sequences)
	APTR	tcso_Composer				* APTR to name of composer. If NULL
										* composer is same as tcm_Composer.
	APTR	tcso_Style					* APTR to style string (techno, rave,
										* trance, pop, etc.)
	APTR	tcso_Comment				* A short comment from the composer
	APTR	tcso_GlobalData				* APTR to chan. global data (player)
	APTR	tcso_ChannelData			* APTR to channel data (for player)
	STRUCT	tcso_BeginDate,sds_SIZEOF	* Begin composing date
	STRUCT	tcso_EndDate,sds_SIZEOF		* Finish composing date
	UBYTE	tcso_PlayTimeHours			* Playing time of song in hours
	UBYTE	tcso_PlayTimeMins			* Playing time of song in mins
	UBYTE	tcso_PlayTimeSecs			* Playing time of song in secs
	UBYTE	tcso_PlayTimeHundreds		* Playing time of song in 1/100 secs
	APTR	tcso_Position				* APTR to order structure.
	STRUCT	tcso_TrackList,MLH_SIZE		* Linked list of used tracks.
	APTR	tcso_GoSubStackPtr			* APTR to stack ptr for GoSub cmd
	APTR	tcso_LoopStackPtr			* Stack ptr for pattern loop cmd
	UWORD	tcso_GoSubStackSize			* Stack size for GoSub cmd
	UWORD	tcso_LoopStackSize			* Stack size for pattern loop cmd
	UBYTE	tcso_CompFlags				* Compatibility flags. See upwards
	UBYTE	tcso_Flags					* Flags. See upwards
	UWORD	tcso_Channels				* Channels used (default 8)
	UWORD	tcso_Frames					* Initial tempo (6)
	UBYTE	tcso_SpeedMul				* Initial speed multiplier (0)
	UBYTE	tcso_SpeedDiv				* Initial speed divider (0)
	UWORD	tcso_SPDSpeed				* Initial SPD speed (33)
	UWORD	tcso_BPMTempo				* Initial BPM tempo (4)
	UWORD	tcso_BPMSpeed				* Initial BPM speed (125)
	UWORD	tcso_FramesLowerLimit		* Frames lower limit
	UWORD	tcso_FramesUpperLimit		* Frames upper limit
	UWORD	tcso_SPDLowerLimit			* SPD lower limit
	UWORD	tcso_SPDUpperLimit			* SPD upper limit
	UWORD	tcso_BPMTempoLowerLimit		* BPM tempo lower limit
	UWORD	tcso_BPMTempoUpperLimit		* BPM tempo upper limit
	UWORD	tcso_BPMSpeedLowerLimit		* BPM speed lower limit
	UWORD	tcso_BPMSpeedUpperLimit		* BPM speed upper limit
	UBYTE	tcso_GlobalVolume			* Default global volume (255)
	UBYTE	tcso_GlobalSubVol			* Default global sub volume (0)
	UBYTE	tcso_GlobalPanning			* Default global panning (0)
	UBYTE	tcso_GlobalSubPan			* Default global sub panning (0)
	STRUCT	tcso_UnknownChunks,MLH_SIZE	* Linked list of unknown chunks
	STRUCT	tcso_Reserved,8				* Reserved for future expansions
	APTR	tcso_UserData				* This entry is for you !
	LABEL	tcso_SIZEOF

FIRSTSONGCHANNEL	EQU	0				* First channel is #0
LASTSONGCHANNEL	EQU	255					* Last channel is #255
MINSONGCHANNELS	EQU	FIRSTSONGCHANNEL+1	* Minium 1 channel is allowed
MAXSONGCHANNELS	EQU	LASTSONGCHANNEL+1	* Maximum allowed are 256 channels.
DEFAULTSONGCHANNELS	EQU	8				* 8 channels are used by defaults
DEFAULTGOSUBSTACK	EQU	4				* 4 gosubs can be stacked by default
DEFAULTPATTERNLOOPSTACK	EQU	1			* 1 pattern loop stacked by default
DEFAULTSONGVOLUME	EQU	$FF				* Default is is full global volume
DEFAULTSONGPANNING	EQU	$00				* Default is is left master panning
										* (full stereo separation)
DEFAULTSONGTEMPO	EQU	6				* Delay one row 6/50 secs.
DEFAULTSONGSPEEDMUL	EQU	0				* Disable multiplier and
DEFAULTSONGSPEEDDIV	EQU	0				* the divider
DEFAULTSONGSPDSPEED	EQU	33				* 33 as in OctaMED
DEFAULTSONGBPMTEMPO	EQU	4				* 4 rows are a beat.
DEFAULTSONGBPMSPEED	EQU	125				* Beats per minute (50 Hz)

* Song errors
ERROR_SONG_NOGIVEN	EQU	ERROR_SONG+$0	* If no song struct was given
ERROR_SONG_NODATA	EQU	ERROR_SONG+$1	* Song contains no data
ERROR_SONG_NOMEM	EQU	ERROR_SONG+$2	* Returned on mem fail
ERROR_SONG_NOFILE	EQU	ERROR_SONG+$4	* No file given
ERROR_SONG_IOERR	EQU	ERROR_SONG+$5	* I/O error occured on
ERROR_SONG_BAD_IFF	EQU	ERROR_SONG+$6	* TCM1-IFF-file damaged
* Because LoadSong() returns NULL on error, use DOS IoErr() and check
* ERROR_INVALID_RESIDENT_LIBRARY for it.

ERROR_SONG_BAD_VER	EQU	ERROR_SONG+$7	* Incorrect song version

* TuComposer Song Header. Used by disk operations
* (e.g. by LoadSong() & SaveSong())

	STRUCTURE	IFF_SHDR,iff_SIZEOF
	STRUCT	shdr_BeginDate,sds_SIZEOF	* Begin composing date
	STRUCT	shdr_EndDate,sds_SIZEOF		* Finish composing date
	UBYTE	shdr_PlayTimeHours			* Playing time of song in hours
	UBYTE	shdr_PlayTimeMins			* Playing time of song in mins
	UBYTE	shdr_PlayTimeSecs			* Playing time of song in secs
	UBYTE	shdr_PlayTimeHundreds		* Playing time of song in 1/100 secs
	UWORD	shdr_Tracks					* Number of tracks in this song
	UWORD	shdr_GoSubStackSize			* Stack size for GoSub cmd
	UWORD	shdr_LoopStackSize			* Stack size for pattern loop cmd
	UBYTE	shdr_CompFlags				* Compatibility flags. See upwards
	UBYTE	shdr_Flags					* Flags. See upwards
	UWORD	shdr_Channels				* Channels used (default 8)
	UWORD	shdr_Frames					* Initial tempo (6)
	UBYTE	shdr_SpeedMul				* Initial speed multiplier (0)
	UBYTE	shdr_SpeedDiv				* Initial speed divider (0)
	UWORD	shdr_SPDSpeed				* Initial SPD speed (33)
	UWORD	shdr_BPMTempo				* Initial BPM tempo (4)
	UWORD	shdr_BPMSpeed				* Initial BPM speed (125)
	UWORD	shdr_FramesLowerLimit		* Frames lower limit
	UWORD	shdr_FramesUpperLimit		* Frames upper limit
	UWORD	shdr_SPDLowerLimit			* SPD lower limit
	UWORD	shdr_SPDUpperLimit			* SPD upper limit
	UWORD	shdr_BPMTempoLowerLimit		* BPM tempo lower limit
	UWORD	shdr_BPMTempoUpperLimit		* BPM tempo upper limit
	UWORD	shdr_BPMSpeedLowerLimit		* BPM speed lower limit
	UWORD	shdr_BPMSpeedUpperLimit		* BPM speed upper limit
	UBYTE	shdr_GlobalVolume			* Default global volume (255)
	UBYTE	shdr_GlobalSubVol			* Default global sub volume (0)
	UBYTE	shdr_GlobalPanning			* Default global panning (0)
	UBYTE	shdr_GlobalSubPan			* Default global sub panning (0)
	LABEL	shdr_SIZEOF

SONG_NAME	EQU	(('S'<<24)!('O'<<16)!('N'<<8)!('G'))
SHDR_NAME	EQU	(('S'<<24)!('H'<<16)!('D'<<8)!('R'))
SMSG_NAME	EQU	(('S'<<24)!('M'<<16)!('S'<<8)!('G'))

C_SONG	MACRO
	dc.b	'SONG'
	ENDM
SONG_CHUNK	MACRO	* Length
	C_FORM
	dc.l	\1
	C_SONG
	ENDM

C_SHDR	MACRO
	dc.b	'SHDR'
	ENDM
SHDR_CHUNK	MACRO	* Length
	C_SHDR
	dc.l	\1
	ENDM

C_SMSG	MACRO
	dc.b	'SMSG'
	ENDM
	
SMSG_CHUNK	MACRO	* Length
	C_SMSG
	dc.l	\1
	ENDM

	ENDC	; TUCOMPOSER_SONG_I
