	IFND	TUCOMPOSER_SYNTH_I
TUCOMPOSER_SYNTH_I	EQU	1
**
**	$Filename: tucomposer/synth.i $
**	$Release : 31.22 $
**
**
**
**	(C) Copyright 1998 by The united Coders (TuC)
**      Main code: Basty/TuC
**		All Rights Reserved
**

		IFND	EXEC_TYPES_I
		include	"exec/types.i"
		ENDC	; EXEC_TYPES_I

		IFND	EXEC_NODES_I
		include	"exec/nodes.i"
		ENDC	; EXEC_NODES_I

		IFND	EXEC_LISTS_I
		include	"exec/lists.i"
		ENDC	; EXEC_LISTS_I

		IFND	TUCOMPOSER_TUCOMPOSER_I
		include	"tucomposer/tucomposer.i"
		ENDC	; TUCOMPOSER_TUCOMPSER_I

* Flags for synth table are:
	BITDEF	STAB,Source,0			* Source parameter required
	BITDEF	STAB,SrcLine,1			* Source parameter is line number
	BITDEF	STAB,NoSrcV0,2			* Don't display source variable if v0.
	BITDEF	STAB,NoSrcData,3		* Don't display source data if $0000.
	BITDEF	STAB,Dest,4				* Destination parameter required
	BITDEF	STAB,DestDbl,5			* Destination double register required
	BITDEF	STAB,VarPri,6			* If both variable is and data are zero,
									* the variable has higher priority of
									* being displayed
	BITDEF	STAB,SrcNotReq,7		* Source parameter needn't to be passed

* Bit definitions for tcy_VolConVar, tcy_PanConVar and tcy_xxxConVar:
	BITDEF	TCYC,Carry,0		* Carry. If set, e.g. JUMPCS jumps.
	BITDEF	TCYC,Overflow,1		* Overflow. If set, e.g. JUMPVS jumps.
	BITDEF	TCYC,Zero,2			* Zero. If set, e.g. JUMPEQ jumps.
	BITDEF	TCYC,Negative,3		* Negative. If set, e.g. JUMPMI jumps.
	BITDEF	TCYC,Extend,4		* Extend. Used by ADDX, SUBX and NEGX.

* Bit definitions for tcy_UseNNAFlags:
	BITDEF	TCYUN,VolNNA,0		* Use volume NNA trigger entry field
	BITDEF	TCYUN,PanNNA,1		* Use panning NNA trigger entry field
	BITDEF	TCYUN,SlideNNA,2	* Use slide NNA trigger entry field
	BITDEF	TCYUN,SpecialNNA,3	* Use special NNA trigger entry field
	BITDEF	TCYUN,VolDNA,4		* Use volume DNA trigger entry field
	BITDEF	TCYUN,PanDNA,5		* Use panning DNA trigger entry field
	BITDEF	TCYUN,SlideDNA,6	* Use slide DNA trigger entry field
	BITDEF	TCYUN,SpecialDNA,7	* Use special DNA trigger entry field

* Bit definitions for tcy_UseSusFlags:
	BITDEF	TCYS,VolSus,0		* Use sustain entry volume position field
	BITDEF	TCYS,PanSus,1		* Use sustain entry panning position field
	BITDEF	TCYS,SlideSus,2		* Use sustain entry slide position field
	BITDEF	TCYS,SpecialSus,3	* Use sustain entry special position field
	BITDEF	TCYS,VolSusKeep,4	* Keep sustain entry volume position
	BITDEF	TCYS,PanSusKeep,5	* Keep sustain entry panning position
	BITDEF	TCYS,SlideSusKeep,6	* Keep sustain entry slide position
	BITDEF	TCYS,SpecSusKeep,7	* Keep sustain entry special position

* Bit definitions for tcy_PosKeepMask:
	BITDEF	TCYP,Volume,0		* Keep volume position
	BITDEF	TCYP,Panning,1		* Keep panning position
	BITDEF	TCYP,Slide,2		* Keep slide position
	BITDEF	TCYP,Special,3		* Keep special position
	BITDEF	TCYP,Waveforms,6	* Keep synthetic waveforms
	BITDEF	TCYP,Code,7			* Keep synth programming code

* Bit definitions for tcy_NNAPosKeepMask:
	BITDEF	TCYN,VolNNA,0		* Keep volume NNA trigger position
	BITDEF	TCYN,PanNNA,1		* Keep panning NNA trigger position
	BITDEF	TCYN,SlideNNA,2		* Keep slide NNA trigger position
	BITDEF	TCYN,SpecialNNA,3	* Keep special NNA trigger position
	BITDEF	TCYN,VolDNA,4		* Keep volume DNA trigger position
	BITDEF	TCYN,PanDNA,5		* Keep panning DNA trigger position
	BITDEF	TCYN,SlideDNA,6		* Keep slide DNA trigger position
	BITDEF	TCYN,SpecialDNA,7	* Keep special DNA trigger position

* Bit definitions for tcyw_Flags:
	BITDEF	TCYW,8Bit,15		* If bit set, this is an 8-bit waveform,
								* else it's an 16-bit waveform. This is
								* only useful for sample using waveforms,
								* because the mixing routines handle 8-bit
								* sound faster than 16-bit ones. For some
								* waveform types it's also useful, e.g. for
								* Ramp up/down waves. The synth code GETxxxW
								* instructions always return an 16-bit value,
								* i.e. an 8-bit waveform will be shifted left
								* by 8 bits before passed to the destination
								* variable.
	BITDEF	TCYW,NoLoop,7		* If bit is set, no looping for waveform

* Bit definitions for tsst_Flags:
	BITDEF	TCYST,Unused,7		* If bit is set, symbol is unused currently,
								* i.e. not evaluated. This makes it possible
								* to temporary remove any symbols without
								* deleting them.

* Bit definitions for InsertWaveformPoint() and DeleteWaveformPoint() flags
	BITDEF	WAV,PointsOnly,0	* If bit is set, only the points will be
								* affected, else the waveform's length
								* will be affected, too.

* Bit definitions for ConvertWaveform():
	BITDEF	CW,ChangeOnly,0		* If bit is set, change bit resolution only
								* and update tcyw_Samples else do a waveform
								* bit conversion.

* Bit definitions for InsertSynthCodeLine() and DeleteSynthCodeLine() flags
	BITDEF	COD,LinesOnly,0		* If bit is set, only the lines will be
								* affected, else the code's length
								* will be affected, too.
	BITDEF	COD,CorrectRefs,1	* Correct line references, e.g. of JUMPs

* Bit definitions for AssembleSynthCodeLine()
	BITDEF	ASC,GenLabels,0		* Generate new defined labels if bit is set
	BITDEF	ASC,AllowDupLabel,1	* Allow duplicate label.

* Bit definitions for DisassembleSynthCodeLine()
	BITDEF	DASC,StopIsEnd,0	* Substitute STOP instruction with END
	BITDEF	DASC,JmpCCIsJmpHS,1	* Substitute JUMPCC with JUMPHS
	BITDEF	DASC,JmpCSIsJmpLO,2	* Substitute JUMPCS with JUMPLO
	BITDEF	DASC,Decimal,3		* Decimal source parameter, else hexadecimal
	BITDEF	DASC,LowerCase,4	* Instructions are lower case
	BITDEF	DASC,VarUpperCase,5	* Variables are upper case
	BITDEF	DASC,SrcParSigned,6	* Source parameter is a signed word
	BITDEF	DASC,NotEvalSyms,7	* Don't evaluate symbols
	BITDEF	DASC,AlwaysSrcV0,8	* Always display variable 0 in source
	BITDEF	DASC,AlwaysSrcPar,9	* Always display source parameter (even 0)

* Synth table. Used for both assembling and disassembling.
* Structure is build up as follows:

	STRUCTURE SynthTable,0
	STRUCT	stab_InstName,8			* Instruction name with trailing zero
	UBYTE	stab_InstCode			* Instruction code
	UBYTE	stab_InstFlags			* Instruction flags
	LABEL	stab_SIZEOF				* Length of one instruction

* Synth waveform structure, used by all synth waveform functions (e.g.
* AddSynthWaveform()).
	STRUCTURE	TuComposerSynthWave,MLN_SIZE
	APTR	tcyw_FileName		* File name of waveform (e.g. SineWave.TCW)
	APTR	tcyw_Name			* Name of waveform (e.g. Sine Wave)
	APTR	tcyw_WaveData		* APTR to waveform data. The waveforms are
								* an array of WORDs (i.e. they're threated
								* as signed 16-bit samples), in most cases.
	ULONG	tcyw_Length			* Length of waveform in bytes.
	ULONG	tcyw_Samples		* Length of waveform in samples.
	ULONG	tcyw_Repeat			* Repeat start of waveform
	ULONG	tcyw_RepLen			* Repeat length of waveform
	UWORD	tcyw_Flags			* Some flags. See below
	STRUCT	tcyw_Reserved,18	* Reserved for future expansions.
	APTR	tcyw_UserData		* Use for any data you like
	LABEL	tcyw_SIZEOF

* Synth programming code structure, used by all synth all synth programming
* functions (e.g. AddSynth())
	STRUCTURE	TuComposerSynthCode,0
	BYTE	tcyc_Instruction0	* Instruction to execute of line $0000. For
								* a list, see below. 
	UBYTE	tcyc_SrcDestVar0	* This are actually two nibbles. The higher
								* nibble is the source variable to take
								* value from. The lower nibble is the
								* destination variable where to put result.
	UWORD	tcyc_InstData0		* Instruction data. Instruction specific.
								* Please note that the effects receive this
								* value + the value of the source variable
								* (all except between NOT and SWAP) !
	LABEL	tcyc_Instructionx	* The same for code line $0001 - ....
	LABEL	tcyc_SIZEOF			* This repeats as often as given in
								* tcy_CodeEntries.

* Instruction list (positive numbers mean normal effect execution):
TCYINST_STOP	EQU	$00			* STOP or END: synth execution here !
								*              tcyc_InstData points to an
								*              external influence forbid
								*              mask, which is defined as
								*              following (can be combined):
								*              Mask | Meanings
								*              0001 | Forbid external JUMPVOL
								*              0002 | Forbid external JUMPPAN
								*              0004 | Forbid external JUMPSLD
								*              0008 | Forbid external JUMPSPC
								*              If bit 15 is set, the desired
								*              influence will be permitted.
TCYINST_END	EQU	TCYINST_STOP	* The same as above...
TCYINST_KILL	EQU	$01			* KILL: stop and free current channel, most
								*       used in xxxNNAPos code. tcyc_InstData
								*       is amount of ticks to wait before
								*       killing the channel. Synth code
								*       processing continues as normally
								*       until the wait counter has been
								*       reached. Please note that even with
								*       tcyc_InstData set to zero, all
								*       instructions executing in the same
								*       tick as the KILL instruction will
								*       continue do so. If you don't want
								*       this, just place a STOP instruction
								*       straight afterward.
TCYINST_WAIT	EQU	$02			* WAIT: Wait before going on. tcyc_InstData
								*       is amount of ticks to wait.
TCYINST_WAITVOL	EQU	$03			* WAITVOL: Waits until volume handling code
                                *          has reached line tcyc_InstData.
TCYINST_WAITPAN	EQU	$04			* WAITPAN: Same as WAITVOL but guards the
								*          panning handling code.
TCYINST_WAITSLD	EQU	$05			* WAITSLD: Same as WAITPAN but guards the
								*          slide handling code.
TCYINST_WAITSPC	EQU	$06			* WAITSLD: Same as WAITSLD but guards the
								*          slide handling code.
TCYINST_JUMP	EQU	$07			* JUMP: Jump to line tcyc_InstData.
TCYINST_JUMPEQ	EQU	$08			* JUMPEQ: Jump on zero to line tcyc_InstData.
TCYINST_JUMPNE	EQU	$09			* JUMPNE: Jump on not zero to line
								*         tcyc_InstData.
TCYINST_JUMPPL	EQU	$0A			* JUMPPL: Jump on positive to line
								*         tcyc_InstData.
TCYINST_JUMPMI	EQU	$0B			* JUMPPL: Jump on negative to line
								*         tcyc_InstData.
TCYINST_JUMPLT	EQU	$0C			* JUMPLT: Jump if signed less than to line
								*         tcyc_InstData.
TCYINST_JUMPLE	EQU	$0D			* JUMPLE: Jump if signed less or equal than
								*         to tcyc_InstData.
TCYINST_JUMPGT	EQU	$0E			* JUMPGT: Jump if signed greater than to line
								*         tcyc_InstData.
TCYINST_JUMPGE	EQU	$0F			* JUMPGE: Jump if signed greater or equal
								*         than to line tcyc_InstData.
TCYINST_JUMPVS	EQU	$10			* JUMPVS: Jump if signed overflow to line
								*         tcyc_InstData.
TCYINST_JUMPVC	EQU	$11			* JUMPVC: Jump if no signed overflow to line
								*         tcyc_InstData.
TCYINST_JUMPCS	EQU	$12			* JUMPCS or JUMPLO: Jump if carry generated
								*                   (unsigned lower than).
TCYINST_JUMPLO	EQU	TCYINST_JUMPCS	* The same as above...
TCYINST_JUMPCC	EQU	$13			* JUMPCC or JUMPHS: Jump if no carry caused
								*                   (unsigned higher or same).
TCYINST_JUMPHS	EQU	TCYINST_JUMPCC	* The same as above...
TCYINST_JUMPLS	EQU	$14			* JUMPLS: Jump if unsigned less or equal.
TCYINST_JUMPHI	EQU	$15			* JUMPHI: Jump if unsigned greater than.
TCYINST_JUMPVOL	EQU	$16			* JUMPVOL: Causes the volume handling code
								* to jump to the line tcyc_InstData.
TCYINST_JUMPPAN	EQU	$17			* JUMPPAN: Causes the panning handling code
								* to jump to the line tcyc_InstData.
TCYINST_JUMPSLD	EQU	$18			* JUMPSLD: Causes the slide handling code
								* to jump to the line tcyc_InstData.
TCYINST_JUMPSPC	EQU	$19			* JUMPSPC: Causes the special handling code
								* to jump to the line tcyc_InstData.
TCYINST_CALL	EQU	$1A			* CALL: Pushes current position to the
								*       destination variable and continues
								*       execution at tcyc_InstData.
TCYINST_RETURN	EQU	$1B			* RETURN: Pops position to jump to from the
								*         destination variable and adds
								*         tcyc_InstData to it.
TCYINST_POSVAR	EQU	$1C			* POSVAR: Pushes position + tcyc_InstData to
								*         the destination variable.
TCYINST_LOAD	EQU	$1D			* LOAD: Loads the destination variable with
								*       the source variable and adds
								*       tcyc_InstData (ABSOLUTE) to it.
TCYINST_ADD		EQU	$1E			* ADD: Adds tcyc_InstData to destination
								*      variable.
TCYINST_ADDX	EQU	$1F			* ADDX: Adds tcyc_InstData + extend flag
								*       to the destination variable.
TCYINST_SUB		EQU	$20			* SUB: Like ADD but subtracts instead.
TCYINST_SUBX	EQU	$21			* SUBX: Like ADDX but subtracts instead.
TCYINST_CMP		EQU	$22			* CMP: Like SUB but doesn't store it in
								*      the destination variable.
TCYINST_MULU	EQU	$23			* MULU: Multiplies tcyc_InstData with the
								*       destination variable (unsigned).
TCYINST_MULS	EQU	$24			* MULS: Like MULU but uses signed arithmetic.
TCYINST_DMULU	EQU	$25			* DMULU: Like MULU but places the upper word
								*        result in the destination variable
								*        the lower word result in the
								*        destination variable + 1 (or stores
								*        only the lower word if destination
								*        variable is 15)
TCYINST_DMULS	EQU	$26			* DMULS: Like DMULS but calculates signed.
TCYINST_DIVU	EQU	$27			* DIVU: Divides the destination variable
								*       with tcyc_InstData (unsigned).
TCYINST_DIVS	EQU	$28			* DIVS: Like DIVU but calculates signed.
TCYINST_MODU	EQU	$29			* MODU: Like DIVU but puts the remainder in
								*       in the destination register instead.
TCYINST_MODS	EQU	$2A			* MODS: Like MODU but calculates signed.
TCYINST_DDIVU	EQU	$2B			* DDIVU: Like DIVU but divides the longword
								*        destination variable + destination
								*        variable + 1 with tcyc_InstData. The
								*        quotient is stored in destination
								*        variable + 1 and the remainder in
								*        destination variable. If the
								*        destination variable is 15, the
								*        quotient will be placed at it.
TCYINST_DDIVS	EQU	$2C			* DDIVS: Like DDIVU but calculates signed.
TCYINST_ASHL	EQU	$2D			* ASHL: Arithmetical shifts left the dest.
								*       variable tcyc_InstData bits.
TCYINST_ASHR	EQU	$2E			* ASHR: Arithmetical shifts right the dest.
								*       variable tcyc_InstData bits.
TCYINST_LSHL	EQU	$2F			* LSHL: Like ASHL but logical shifts instead.
TCYINST_LSHR	EQU	$30			* LSHR: Like ASHR but logical shifts instead.
TCYINST_ROL		EQU	$31			* ROL: Like LSHL but rotates instead.
TCYINST_ROR		EQU	$32			* ROR: Like LSHR but rotates instead.
TCYINST_ROLX	EQU	$33			* ROLX: Like ROL but rotates with extend.
TCYINST_RORX	EQU	$34			* RORX: Like ROR but rotates with extend.
TCYINST_OR		EQU	$35			* OR: Logical OR tcyc_InstData with the
								*     destination variable.
TCYINST_AND		EQU	$36			* AND: Like OR but uses logical AND instead.
TCYINST_XOR		EQU	$37			* XOR: Like OR but uses eXclusive OR.
TCYINST_NOT		EQU	$38			* NOT: Inverts the destination variable and
								*      adds tcyc_InstData to it afterwards.
TCYINST_NEG		EQU	$39			* NEG: Negates the destination variable and
								*      adds tcyc_InstData to it afterwards.
TCYINST_NEGX	EQU	$3A			* NEGX: Subtracts the destination variable +
								*       the extend flag from zero and adds
								*       tcyc_InstData to it afterwards.
TCYINST_EXTB	EQU	$3B			* EXTB: Copies bit 7 to bit 8-15 in the
								*       the destination variable and adds
								*       tcyc_InstData to it afterwards.
TCYINST_EXT		EQU	$3C			* EXT: Copies bit 15 of destination variable
								*      + 1 to bits 0 - 15 of destination
								*      variable and adds tcyc_InstData to it
								*      afterwards.
TCYINST_XCHG	EQU	$3D			* XCHG: Exchanges the source variable with
								*       the destination variable and adds
								*       tcyc_InstData (ABSOLUTE) to it.
TCYINST_SWAP	EQU	$3E			* SWAP: Swaps the upper byte of the
								*       destination variable with the lower
								*       byte and adds tcyc_InstData to it.
TCYINST_GETWAVE	EQU	$3F			* GETWAVE: Gets the current sample waveform +
								*          tcyc_InstData to the destination
								*          variable.
TCYINST_GETWLEN	EQU	$40			* GETWLEN: Gets the current sample waveform
								*          length + tcyc_InstData to the
								*          destination variable.
TCYINST_GETWPOS	EQU	$41			* GETWPOS: Gets the current sample waveform
								*          position + tcyc_InstData to the
								*          destination variable.
TCYINST_GETCHAN	EQU	$42			* GETCHAN: Stores the current host channel +
								*          tcyc_InstData to the destination
								*          variable.
TCYINST_GETNOTE	EQU	$43			* GETNOTE: Store the current note playing +
								*          tcyc_InstData to the destination
								*          variable.
TCYINST_GETRANS	EQU	$44			* GETRANS: Like GETNOTE but stores the
								*          current sample transpose value
TCYINST_GETPTCH	EQU	$45			* GETPTCH: Stores the current frequency in
								*          the destination variable (upper
								*          word) and destination variable + 1
								*          (lower word). If the destination
								*          variable is 15 only the lower word
								*          will be stored.
TCYINST_GETPER	EQU	$46			* GETPER: Equal to GETPTCH except that the
								*         received value is the period value.
TCYINST_GETFX	EQU	$47			* GETFX: This effect stores the current
								*        effect's value given in the upper
								*        byte of tcyc_InstData in the
								*        destination variable. This is the
								*        value passed to the effect at last,
								*        e.g. GETFX with a upper byte value
								*        of 20 will return the current
								*        volume. If the effect memorizes his
								*        value somehow, this value will be
								*        returned. The result of GETFX is
								*        directly passable to SETFXxx.
TCYINST_GETARPW	EQU	$48			* GETARPW: Stores the arpeggio waveform
								*          + tcy_InstData to the destination.
TCYINST_GETARPV	EQU	$49			* GETARPV: Stores the arpeggio waveform value
								*          of tcy_InstData point
TCYINST_GETARPL	EQU	$4A			* GETARPL: Like GETARPW but stores the
								*          waveform length instead.
TCYINST_GETARPP	EQU	$4B			* GETARPP: Like GETARPW but stores the
								*          waveform position instead.
TCYINST_GETVIBW	EQU	$4C			* GETVIBW: Like GETARPW but stores vibrato
								*          waveform number instead.
TCYINST_GETVIBV	EQU	$4D			* GETVIBV: Like GETARPV but stores vibrato
								*          waveform value instead.
TCYINST_GETVIBL	EQU	$4E			* GETVIBL: Like GETARPL but stores
								*          vibrato length instead.
TCYINST_GETVIBP	EQU	$4F			* GETVIBP: Like GETARPP but stores current
								*          vibrato position instead.
TCYINST_GETTRMW	EQU	$50			* GETTRMW: Like GETVIBW but stores tremolo
								*          waveform number instead.
TCYINST_GETTRMV	EQU	$51			* GETTRMV: Like GETVIBV but stores tremolo
								*          waveform value instead.
TCYINST_GETTRML	EQU	$52			* GETTRML: Like GETVIBL but stores tremolo
								*          waveform length instead.
TCYINST_GETTRMP	EQU	$53			* GETTRMP: Like GETVIBP but stores current
								*          tremolo position instead.
TCYINST_GETPANW	EQU	$54			* GETPANW: Like GETTRMW but stores pannolo
								*          waveform number instead.
TCYINST_GETPANV	EQU	$55			* GETPANV: Like GETTRMV but stores pannolo
								*          waveform value instead.
TCYINST_GETPANL	EQU	$56			* GETPANL: Like GETTRML but stores tremolo
								*          waveform length instead.
TCYINST_GETPANP	EQU	$57			* GETPANP: Like GETTRMP but stores current
								*          pannolo position instead.
TCYINST_GETRND	EQU	$58			* GETRND: Gets a random value between 0 and
								*         tcyc_InstData.
TCYINST_GETSINE	EQU	$59			* GETSINE: Gets the sine of tcyc_InstData.
								*          The parameter are degrees. Use
								*          DMULS and DDIVS to scale to the
								*          required value.
TCYINST_PORTAUP	EQU	$5A			* PORTAUP: Slides the pitch up with the
								*          amount given in tcyc_InstData.
TCYINST_PORTADN	EQU	$5B			* PORTADN: Slides the pitch down with the
								*          amount given in tcyc_InstData.
TCYINST_VIBSPD	EQU	$5C			* VIBSPD: Sets vibrato speed to
								*         tcyc_InstData.
TCYINST_VIBDPTH	EQU	$5D			* VIBDPTH: Sets vibrato depth to
								*          tcyc_InstData.
TCYINST_VIBWAVE	EQU	$5E			* VIBWAVE: Sets vibrato waveform to
								*          tcyc_InstData.
TCYINST_VIBWAVP	EQU	$5F			* VIBWAVP: Sets vibrato position to
								*          tcyc_InstData.
TCYINST_VIBRATO	EQU	$60			* VIBRATO: Executes the vibrato. The upper
								*          byte contains the speed or NULL
								*          to use the previous values. The
								*          lower byte contains the depth or
								*          NULL for use the previous values.
TCYINST_VIBVAL	EQU	$61			* VIBVAL: Executes the vibrato with the
								*         given period in tcyc_InstData.
TCYINST_ARPSPD	EQU	$62			* ARPSPD: Sets arpeggio speed to
								*         tcyc_InstData.
TCYINST_ARPWAVE	EQU	$63			* ARPWAVE: Sets arpeggio waveform to
								*          tcyc_InstData.
TCYINST_ARPWAVP	EQU	$64			* ARPWAVP: Sets arpeggio position to
								*          tcyc_InstData.
TCYINST_ARPEGIO	EQU	$65			* ARPEGIO: Executes the arpeggio. The upper
								*          byte of tcyc_InstData contains
								*          the arpeggio speed and the low
								*          byte a finetune modifier.
TCYINST_ARPVAL	EQU	$66			* ARPVAL: Like ARPEGIO with the exception
								*         that the value is taken from
								*         tcyc_InstData (upper byte is
								*         transpose, lower byte is finetune)
TCYINST_SETWAVE	EQU	$67			* SETWAVE: Sets the sample waveform to src +
								*          tcyc_InstData. The current wave-
								*          form will finish playing.
TCYINST_ISETWAV	EQU	$68			* ISETWAV: Set the sample waveform to
								*          tcyc_InstData immediately.
TCYINST_SETWAVP	EQU	$69			* SETWAVP: Sets the sample waveform position
								*          to tcy_InstData.
TCYINST_SETRANS	EQU	$6A			* SETRANS: Sets the transpose number to
								*          tcyc_InstData. The current
								*          transpose will be overwritten.
TCYINST_SETNOTE	EQU	$6B			* SETNOTE: Sets note but doesn't update note
								*          field.
TCYINST_SETPTCH	EQU	$6C			* SETPTCH: Sets the current frequency taken
								*          from the destination variable
								*          (upper word) and the destination
								*          variable + 1 (lower word) and adds
								*          tcyc_InstData to it.
TCYINST_SETPER	EQU	$6D			* SETPER: Like SETPTCH with the exception
								*         that the destination will be
								*         period instead of frequency.
TCYINST_RESET	EQU	$6E			* RESET: Resets vibrato/tremolo/pannolo
								*        counters. tcyc_InstData is a mask
								*        which disables affection.
								*        Mask | Meanings
								*		 0001 | Disables arpeggio reset
								*        0002 | Disables vibrato reset
								*        0004 | Disables tremolo reset
								*        0008 | Disables pannolo reset
								*        0010 | Disables redo of portamento
								*        0020 | Disables portamento reset
TCYINST_VOLSLUP	EQU	$6F			* VOLSLUP: Slides volume up by tcyc_InstData.
TCYINST_VOLSLDN	EQU	$70			* VOLSLDN: Like VOLSLUP but slides down.
TCYINST_TRMSPD	EQU	$71			* TRMSPD: Like VIBSPD but for tremolo.
TCYINST_TRMDPTH	EQU	$72			* TRMDPTH: Like VIBDPTH but for tremolo.
TCYINST_TRMWAVE	EQU	$73			* TRMWAVE: Like VIBWAVE but for tremolo.
TCYINST_TRMWAVP	EQU	$74			* TRMWAVP: Like VIBWAVP but for tremolo.
TCYINST_TREMOLO	EQU	$75			* TREMOLO: Executes the tremolo (see VIBRATO
								*          for more informations).
TCYINST_TRMVAL	EQU	$76			* TRMVAL: Executes the tremolo with the given
								*         volume in source
TCYINST_PANLEFT	EQU	$77			* PANLEFT: Slides the panning left by
								*          tcyc_InstData.
TCYINST_PANRGHT	EQU	$78			* PANRGHT: Like PANLEFT but slides right.
TCYINST_PANSPD	EQU	$79			* PANSPD: Like TRMSPD but for pannolo.
TCYINST_PANDPTH	EQU	$7A			* PANDPTH: Like TRMDPTH but for pannolo.
TCYINST_PANWAVE	EQU	$7B			* PANWAVE: Like TRMWAVE but for pannolo.
TCYINST_PANWAVP	EQU	$7C			* PANWAVP: Like TRMWAVP but for pannolo.
TCYINST_PANNOLO	EQU	$7D			* PANNOLO: Executes the pannolo (see TREMOLO
								*          for more informations).
TCYINST_PANVAL	EQU	$7E			* PANVAL: Executes the pannolo with the given
								*         panning in source

* Synth code symbol table. It has the same purpose as a symbol table of a
* linker symbol table: It replaces values by symbols. This enhances the
* readability of complex synth codes.
	STRUCTURE	TuComposerSynthSymbolTable,MLN_SIZE
	APTR		tsst_SymbolName		* Name of symbol (e.g. MAXVOL)
	UWORD		tsst_SymbolValue	* Symbol value
	UWORD		tsst_FirstLine		* First code line the symbol affects
	UWORD		tsst_LastLine		* Last code line the symbol affects
	UBYTE		tsst_Type			* Symbol type. See below
	UBYTE		tsst_Flags			* Symbol flags. See upwards
	STRUCT		tsst_Reserved,16	* Never touch this !
	APTR		tsst_UserData		* Any user data
	LABEL		tsst_SIZEOF

* Symbol types
SYMBOL_PARAMETER	EQU	0					* Symbol is an ordinary
											* instruction parameter value.
											* tsst_SymbolValue points to the
											* value to be referenced.
SYMBOL_SRC_VAR		EQU 1					* Symbol is a source variable
											* reference. tsst_SymbolValue
											* points to variable number
											* to be referenced (0 - 15)
SYMBOL_DEST_VAR		EQU	2					* Symbol is a destination
											* variable reference.
											* tsst_SymbolValue is as above.
SYMBOL_VARIABLE		EQU	3					* Symbol is a variable reference
											* (both source and destination).
											* tsst_SymbolValue is as above.
SYMBOL_LABEL		EQU	4					* Symbol is a label reference.
											* tsst_SymbolValue points to the
											* line number to be referenced.
SYMBOL_ANY			EQU	-1					* Any symbol type (neg. values
											* only used by MatchSymbol())
SYMBOL_NAME			EQU	-2					* Just scan for symbol name
SYMBOL_LABELID		EQU	-4					* Search for label definition
SYMBOL_LABELLINE	EQU	-5					* Search for defined label on
											* specified line
SYMBOL_LABELDBL		EQU	-6					* Search for duplicate label def,
											* i.e. any matching line except
											* given will return label

* Synth structure, used by all Synth functions (e.g. AddSynth())
	STRUCTURE	TuComposerSynth,MLN_SIZE
	APTR	tcy_FileName		* File name of synth (e.g. SynPiano.TCY)
	APTR	tcy_Name			* Name of synth (e.g. Synth Piano)
	STRUCT	tcy_Waves,MLH_SIZE	* Linked list of waveforms or empty if hybrid
	STRUCT	tcy_Symbol,MLH_SIZE	* Linked list of symbols
	APTR	tcy_SynthCode		* APTR to synth programming code
	UWORD	tcy_NumWaves		* Number of waveforms (if 0 this is a hybrid)
	UWORD	tcy_CodeEntries		* Length of synth code in 2 UWORDs.
	UWORD	tcy_VolumePos		* Entry position of volume handling code
	UWORD	tcy_PanningPos		* Entry position of panning handling code
	UWORD	tcy_SlidePos		* Entry position of slide handling code
	UWORD	tcy_SpecialPos		* Entry position of special handling code
	UWORD	tcy_VolumeSusPos	* Entry position of sustain volume code
	UWORD	tcy_PanningSusPos	* Entry position of sustain panning code
	UWORD	tcy_SlideSusPos		* Entry position of sustain slide code
	UWORD	tcy_SpecialSusPos	* Entry position of sustain special code
	UWORD	tcy_VolNNAPos		* Position of volume handling code when NNA
								* has been triggered. This allows custom NNA
								* handling !
	UWORD	tcy_PanNNAPos		* Position of panning handling NNA code
	UWORD	tcy_SlideNNAPos		* Position of slide handling NNA code
	UWORD	tcy_SpecialNNAPos	* Position of special NNA handling code
	UWORD	tcy_VolDNAPos		* Position of volume handling code when DNA
								* has been triggered. This allows custom DNA
								* handling !
	UWORD	tcy_PanDNAPos		* Position of panning handling DNA code
	UWORD	tcy_SlideDNAPos		* Position of slide handling DNA code
	UWORD	tcy_SpecialDNAPos	* Position of special DNA handling code
	UWORD	tcy_Variable0		* Initial contents of variable 0
	UWORD	tcy_Variable1		* Initial contents of variable 1
	UWORD	tcy_Variable2		* Initial contents of variable 2
	UWORD	tcy_Variable3		* Initial contents of variable 3
	UWORD	tcy_Variable4		* Initial contents of variable 4
	UWORD	tcy_Variable5		* Initial contents of variable 5
	UWORD	tcy_Variable6		* Initial contents of variable 6
	UWORD	tcy_Variable7		* Initial contents of variable 7
	UWORD	tcy_Variable8		* Initial contents of variable 8
	UWORD	tcy_Variable9		* Initial contents of variable 9
	UWORD	tcy_VariableA		* Initial contents of variable 10
	UWORD	tcy_VariableB		* Initial contents of variable 11
	UWORD	tcy_VariableC		* Initial contents of variable 12
	UWORD	tcy_VariableD		* Initial contents of variable 13
	UWORD	tcy_VariableE		* Initial contents of variable 14
	UWORD	tcy_VariableF		* Initial contents of variable 15
	UWORD	tcy_VolConVar		* Initial contents of volume condition var.
	UWORD	tcy_PanConVar		* Initial contents of panning condition var.
	UWORD	tcy_SlideConVar		* Initial contents of slide condition var.
	UWORD	tcy_SpecialConVar	* Initial contents of special condition var.
	UBYTE	tcy_UseNNAFlags		* Use NNA positions. See bit defs above
	UBYTE	tcy_UseSusFlags		* Use sustain flags
	UBYTE	tcy_PosKeepMask		* Position keep mask. All initial entry
								* positions will be keeped. See bit defs
								* above.
	UBYTE	tcy_NNAPosKeepMask	* NNA trigger position keep mask. Nearly same
								* as tcy_PosKeepMask. Look there for details.
	UWORD	tcy_VarKeepMask		* Variable keep mask. All variables where bit
								* is set will be keeped (normally they will
								* be overwritten with the initial values),
								* e.g. bit 5 set will keep variable 5.
	STRUCT	tcy_UnknownChunks,MLH_SIZE	* Linked list of unknown chunks
	STRUCT	tcy_Reserved,18		* Reserved for future expansions
	APTR	tcy_UserData		* Use for any data you like
	LABEL	tcy_SIZEOF

* Default settings for new synth.

DEFAULTSYNTHBITDEPTH	EQU	16					* 16 bit waveforms by default
DEFAULTSYNTHWAVEFORMS	EQU	1					* Default is one waveform
DEFAULTSYNTHWAVELENGTH	EQU	64					* Default size is 64 WORDs.
DEFAULTSYNTHCODELINES	EQU 1					* Default is one line

* Synth limitation definitions
MAXWAVEFORMSPERSYNTH	EQU	65535				* Maximum up to 65535 wave-
												* forms per synth.

* Synth error codes

ERROR_SYNTH_NOGIVEN	EQU	ERROR_SYNTH+$0		* If no synth was given
ERROR_SYNTH_NODATA	EQU	ERROR_SYNTH+$1		* Synth contains no data
ERROR_SYNTH_NOMEM	EQU	ERROR_SYNTH+$2		* Out of memory
ERROR_SYNTH_TOOMANY	EQU	ERROR_SYNTH+$3		* Too many waveforms (max. 65535)
ERROR_SYNTH_NOFILE	EQU	ERROR_SYNTH+$4		* No filename specified
ERROR_SYNTH_IOERR	EQU	ERROR_SYNTH+$5		* I/O error occured
ERROR_SYNTH_TOOSMALL	EQU	ERROR_SYNTH+$8	* Synth waveform too small
ERROR_SYNTH_TOOBIG	EQU	ERROR_SYNTH+$9		* Synth waveform too big
ERROR_SYNTH_SIZE	EQU	ERROR_SYNTH+$A		* Selected waves are not equal in
											* size
ERROR_SYNTH_BADBITS	EQU	ERROR_SYNTH+$B		* ConvertWaveform() bit depth not
											* supported (currently only 8 and
											* 16-bit waveforms are supported)
ERROR_SYNTH_SYMNAME	EQU	ERROR_SYNTH+$C		* Invalid symbol name, returned
											* by AssignSynth(). Symbols
											* may not begin with a decimal
											* character. Otherwise the
											* only allowed characters are:
											* 0-9, A-Z, a-z, _, ., @.

* IFF-TCM1/IFF-TCI1 YHDR structure. Used by disk operations.
* (e.g. by LoadModule() & SaveModule())

	STRUCTURE	MIFF_YHDR,iff_Data
	UWORD	myhdr_NumWaves		* Number of waveforms (if 0 this is a hybrid)
	UWORD	myhdr_VolumePos		* Entry position of volume handling code
	UWORD	myhdr_PanningPos	* Entry position of panning handling code
	UWORD	myhdr_SlidePos		* Entry position of slide handling code
	UWORD	myhdr_SpecialPos	* Entry position of special handling code
	UWORD	myhdr_VolumeSusPos	* Entry position of sustain volume code
	UWORD	myhdr_PanningSusPos	* Entry position of sustain panning code
	UWORD	myhdr_SlideSusPos	* Entry position of sustain slide code
	UWORD	myhdr_SpecialSusPos	* Entry position of sustain special code
	UWORD	myhdr_VolNNAPos		* Position of volume handling code when NNA
								* has been triggered. This allows custom NNA
								* handling !
	UWORD	myhdr_PanNNAPos		* Position of panning handling NNA code
	UWORD	myhdr_SlideNNAPos	* Position of slide handling NNA code
	UWORD	myhdr_SpecialNNAPos	* Position of special NNA handling code
	UWORD	myhdr_VolDNAPos		* Position of volume handling code when DNA
								* has been triggered. This allows custom DNA
								* handling !
	UWORD	myhdr_PanDNAPos		* Position of panning handling DNA code
	UWORD	myhdr_SlideDNAPos	* Position of slide handling DNA code
	UWORD	myhdr_SpecialDNAPos	* Position of special DNA handling code
	UWORD	myhdr_Variable0		* Initial contents of variable 0
	UWORD	myhdr_Variable1		* Initial contents of variable 1
	UWORD	myhdr_Variable2		* Initial contents of variable 2
	UWORD	myhdr_Variable3		* Initial contents of variable 3
	UWORD	myhdr_Variable4		* Initial contents of variable 4
	UWORD	myhdr_Variable5		* Initial contents of variable 5
	UWORD	myhdr_Variable6		* Initial contents of variable 6
	UWORD	myhdr_Variable7		* Initial contents of variable 7
	UWORD	myhdr_Variable8		* Initial contents of variable 8
	UWORD	myhdr_Variable9		* Initial contents of variable 9
	UWORD	myhdr_VariableA		* Initial contents of variable 10
	UWORD	myhdr_VariableB		* Initial contents of variable 11
	UWORD	myhdr_VariableC		* Initial contents of variable 12
	UWORD	myhdr_VariableD		* Initial contents of variable 13
	UWORD	myhdr_VariableE		* Initial contents of variable 14
	UWORD	myhdr_VariableF		* Initial contents of variable 15
	UWORD	myhdr_VolConVar		* Initial contents of volume condition var.
	UWORD	myhdr_PanConVar		* Initial contents of panning condition var.
	UWORD	myhdr_SlideConVar	* Initial contents of slide condition var.
	UWORD	myhdr_SpecialConVar	* Initial contents of special condition var.
	UBYTE	myhdr_UseNNAFlags	* Use NNA positions. See bit defs above
	UBYTE	myhdr_UseSusFlags	* Use sustain flags
	UBYTE	myhdr_PosKeepMask	* Position keep mask. All initial entry
								* positions will be keeped. See bit defs
								* above.
	UBYTE	myhdr_NNAPosKeepMask	* NNA trigger position keep mask. Nearly
								* the same as myhdr_PosKeepMask.
	UWORD	myhdr_VarKeepMask	* Variable keep mask. All variables where bit
								* is set will be keeped (normally they will
								* be overwritten with the initial values),
								* e.g. bit 5 set will keep variable 5.
	LABEL	myhdr_SIZEOF

* IFF-TCY1 YHDR structure. Used by disk operations.
* (e.g. by LoadSynth() & SaveSynth())

	STRUCTURE	IFF_YHDR,iff_Data
	UBYTE	yhdr_Version		* Version number of TCY1 file
	UBYTE	yhdr_Revision		* Revision number of TCY1 file
	UWORD	yhdr_NumWaves		* Number of waveforms (if 0 this is a hybrid)
	UWORD	yhdr_VolumePos		* Entry position of volume handling code
	UWORD	yhdr_PanningPos		* Entry position of panning handling code
	UWORD	yhdr_SlidePos		* Entry position of slide handling code
	UWORD	yhdr_SpecialPos		* Entry position of special handling code
	UWORD	yhdr_VolumeSusPos	* Entry position of sustain volume code
	UWORD	yhdr_PanningSusPos	* Entry position of sustain panning code
	UWORD	yhdr_SlideSusPos	* Entry position of sustain slide code
	UWORD	yhdr_SpecialSusPos	* Entry position of sustain special code
	UWORD	yhdr_VolNNAPos		* Position of volume handling code when NNA
								* has been triggered. This allows custom NNA
								* handling !
	UWORD	yhdr_PanNNAPos		* Position of panning handling NNA code
	UWORD	yhdr_SlideNNAPos	* Position of slide handling NNA code
	UWORD	yhdr_SpecialNNAPos	* Position of special NNA handling code
	UWORD	yhdr_VolDNAPos		* Position of volume handling code when DNA
								* has been triggered. This allows custom DNA
								* handling !
	UWORD	yhdr_PanDNAPos		* Position of panning handling DNA code
	UWORD	yhdr_SlideDNAPos	* Position of slide handling DNA code
	UWORD	yhdr_SpecialDNAPos	* Position of special DNA handling code
	UWORD	yhdr_Variable0		* Initial contents of variable 0
	UWORD	yhdr_Variable1		* Initial contents of variable 1
	UWORD	yhdr_Variable2		* Initial contents of variable 2
	UWORD	yhdr_Variable3		* Initial contents of variable 3
	UWORD	yhdr_Variable4		* Initial contents of variable 4
	UWORD	yhdr_Variable5		* Initial contents of variable 5
	UWORD	yhdr_Variable6		* Initial contents of variable 6
	UWORD	yhdr_Variable7		* Initial contents of variable 7
	UWORD	yhdr_Variable8		* Initial contents of variable 8
	UWORD	yhdr_Variable9		* Initial contents of variable 9
	UWORD	yhdr_VariableA		* Initial contents of variable 10
	UWORD	yhdr_VariableB		* Initial contents of variable 11
	UWORD	yhdr_VariableC		* Initial contents of variable 12
	UWORD	yhdr_VariableD		* Initial contents of variable 13
	UWORD	yhdr_VariableE		* Initial contents of variable 14
	UWORD	yhdr_VariableF		* Initial contents of variable 15
	UWORD	yhdr_VolConVar		* Initial contents of volume condition var.
	UWORD	yhdr_PanConVar		* Initial contents of panning condition var.
	UWORD	yhdr_SlideConVar	* Initial contents of slide condition var.
	UWORD	yhdr_SpecialConVar	* Initial contents of special condition var.
	UBYTE	yhdr_UseNNAFlags	* Use NNA positions. See bit defs above
	UBYTE	yhdr_UseSusFlags	* Use sustain flags
	UBYTE	yhdr_PosKeepMask	* Position keep mask. All initial entry
								* positions will be keeped. See bit defs
								* above.
	UBYTE	yhdr_NNAPosKeepMask	* NNA trigger position keep mask. Nearly same
								* as yhdr_PosKeepMask. Look there for details.
	UWORD	yhdr_VarKeepMask	* Variable keep mask. All variables where bit
								* is set will be keeped (normally they will
								* be overwritten with the initial values),
								* e.g. bit 5 set will keep variable 5.
	LABEL	yhdr_SIZEOF

* IFF-TCM1/IFF-TCI1/IFF-TCY1 WHDR structure. Used by disk operations.
* (e.g. by LoadSynth() & SaveSynth())

	STRUCTURE	IFF_WHDR,iff_Data
	ULONG	whdr_Repeat			* Repeat start of waveform
	ULONG	whdr_RepLen			* Repeat length of waveform
	UWORD	whdr_Flags			* Some flags. See below
	LABEL	whdr_SIZEOF

* IFF-TCM1/IFF-TCI1/IFF-TCY1 SREF structure. Used by disk operations.
* (e.g. by LoadSynth() & SaveSynth())

	STRUCTURE	IFF_SREF,iff_Data
	UWORD	sref_SymbolValue	* Symbol value
	UWORD	sref_FirstLine		* First code line the symbol affects
	UWORD	sref_LastLine		* Last code line the symbol affects
	UBYTE	sref_Type			* Symbol type. See above
	UBYTE	sref_Flags			* Symbol flags. See upwards
	LABEL	sref_SIZEOF

YHDR_VERSION	EQU	1		* Current synth version: 1
YHDR_REVISION	EQU	0		* Current synth revision: 0

TCY_NAME	EQU	(('T'<<24)!('C'<<16)!('Y'<<8)!('1'))
YHDR_NAME	EQU	(('Y'<<24)!('H'<<16)!('D'<<8)!('R'))
WFRM_NAME	EQU	(('W'<<24)!('F'<<16)!('R'<<8)!('M'))
WAVE_NAME	EQU	(('W'<<24)!('A'<<16)!('V'<<8)!('E'))
WHDR_NAME	EQU	(('W'<<24)!('H'<<16)!('D'<<8)!('R'))
CODE_NAME	EQU	(('C'<<24)!('O'<<16)!('D'<<8)!('E'))
STAB_NAME	EQU	(('S'<<24)!('T'<<16)!('A'<<8)!('B'))
SMBL_NAME	EQU	(('S'<<24)!('M'<<16)!('B'<<8)!('L'))
SREF_NAME	EQU	(('S'<<24)!('R'<<16)!('E'<<8)!('F'))

C_YHDR	MACRO
	dc.b	'YHDR'
	ENDM

YHDR_CHUNK	MACRO	* Length
	C_YHDR
	dc.l	\1
	ENDM

C_WFRM	MACRO
	dc.b	'WFRM'
	ENDM

WFRM_CHUNK	MACRO	* Length
	C_FORM
	dc.l	\1
	C_WFRM
	ENDM

C_WAVE	MACRO
	dc.b	'WAVE'
	ENDM

WAVE_CHUNK	MACRO	* Length
	C_FORM
	dc.l	\1
	C_WAVE
	ENDM

C_WHDR	MACRO
	dc.b	'WHDR'
	ENDM
	
WHDR_CHUNK	MACRO	* Length
	C_WHDR
	dc.l	\1
	ENDM

C_CODE	MACRO
	dc.b	'CODE'
	ENDM

CODE_CHUNK	MACRO	* Length
	C_CODE
	dc.l	\1
	ENDM

C_STAB	MACRO
	dc.b	'STAB'
	ENDM

STAB_CHUNK	MACRO	* Length
	C_FORM
	dc.l	\1
	C_STAB
	ENDM

C_SMBL	MACRO
	dc.b	'SMBL'
	ENDM

SMBL_CHUNK	MACRO	* Length
	C_FORM
	dc.l	\1
	C_SMBL
	ENDM

C_SREF	MACRO
	dc.b	'SREF'
	ENDM

SREF_CHUNK	MACRO	* Length
	C_SREF
	dc.l	\1
	ENDM

	ENDC	; TUCOMPOSER_SYNTH_I
