	IFND	TUCOMPOSER_TRACK_I
TUCOMPOSER_TRACK_I	SET	1
**
**	$Filename: tucomposer/track.i $
**	$Release : 31.22 $
**
**
**
**	(C) Copyright 1996-98 by The united Coders (TuC)
**      Main code: Basty/TuC
**		All Rights Reserved
**

		IFND	EXEC_TYPES_I
		include	"exec/types.i"
		ENDC	; EXEC_TYPES_I

		IFND	EXEC_NODES_I
		include	"exec/nodes.i"
		ENDC	; EXEC_NODES_I

		IFND	EXEC_LISTS_I
		include	"exec/lists.i"
		ENDC	; EXEC_LISTS_I

		IFND	TUCOMPOSER_TUCOMPOSER_I
		include	"tucomposer/tucomposer.i"
		ENDC	; TUCOMPOSER_TUCOMPOSER_I

* Bit definitions for tct_CompFlags:
	BITDEF	TCTC,SOffset,0	* Sample offset beyond end of sample will be
							* ignored (IT compatibility)
	BITDEF	TCTC,TPorta,1	* Share tone porta memory with portamentoes
							* (again for IT compatibility), also unlocks tone
							* portamento samples and adjusts frequency to:
							* NewFrequency = Frequency * NewRate / OldRate
							* If an instrument number is given the envelope
							* will be retriggered
	BITDEF	TCTC,Slide,2	* Portamentoes of same type share the same memory
							* (e.g. porta up/fine porta up/etc.)
	BITDEF	TCTC,VolSlide,3	* All except portamento slides share the same
							* memory (e.g. volume/panning slides)
	BITDEF	TCTC,OpSlide,4	* Oppositional portamento directions don't share
							* the same memory (e.g. porta up/porta down)
	BITDEF	TCTC,OpVSlide,5	* Oppositional non-portamento slide directions
							* don't share the same memory
	BITDEF	TCTC,VolPitch,6	* Volume & Pitch slides share same memory
							* (for S3M compatibility)

* Bit definitions for tct_Flags
	BITDEF	TCT,UseTiming,1	* Bit set means, use track timing fields
	BITDEF	TCT,SPDTiming,2	* Bit set means, SPD speed timing else BPM
	BITDEF	TCT,TrackPan,3	* Bit set means, track panning will be used
	BITDEF	TCT,SurPan,4	* Bit set means, surround panning for track
	BITDEF	TCT,Reverse,5	* Bit set means, Track will be played backwards

* Bit definitions for SwapTrackInSong():
	BITDEF	STIS,Swap,0		* If bit set, swap track data
	BITDEF	STIS,Update,1	* If bit set, update order list entries.

* Bit definitions for GetNote...Str() flags
	BITDEF	NS,HDisplay,0	* If bit is set B- will be displayed as H-
	BITDEF	NS,bSharp,1		* If bit is set C# will be displayed as Db, etc.

* Bit definitions for InsertRow() and DeleteRow() flags
	BITDEF	ROW,NotesOnly,0	* If bit is set, only the notes will be affected,
							* else the track length will be affected, too.

* Bit definitions for packed tracks.
* To extract a packed track by hand, read a packed byte, check the table
* below, and read the desired bytes and assign them. If TCPB_RowHI, and
* TCPB_RowLO are clear the next row is assumed, else continue extracting at
* the given row. Example: If bits 2, 4, 5, and 7 are set, read note byte,
* then instr lo-byte (hi-byte isn't affected until new readed), then read
* effect byte,  and at last read data lo-byte (again clear hi-byte). All
* others are cleared. Do this until packed byte is $00 (The IFF-TCT1 (the
* others also) doesn't need this, so before call UnPackTrack(), clear the
* last byte or you may get garbage or even a system crash. The PackTrack()
* routine does this automatically when you pack but SaveTrack() drops the
* NULL-byte, so you have to add it yourself when loading a track by hand.

	BITDEF	TCP,RowHI,0		* Bit set, used row hi-byte follows, else next
							* one is supposed.
	BITDEF	TCP,RowLO,1		* Bit set, used row lo-byte follows, else next
							* one is supposed.
	BITDEF	TCP,Note,2		* Bit set, octave (hi-nibble), note (lo-nibble)
							* follows ($Fx are special notes (keyoff, etc.))
	BITDEF	TCP,InstrHI,3	* Bit set, hi-byte of instr follows
	BITDEF	TCP,InstrLO,4	* Bit set, lo-byte of instr follows
	BITDEF	TCP,Effect,5	* Bit set, first effect byte follows
	BITDEF	TCP,DataHI,6	* Bit set, first hi-byte of data word follows
	BITDEF	TCP,DataLO,7	* Bit set, first lo-byte of data word follows

	STRUCTURE	TuComposerTrackData,0
	UBYTE	tctd_Octave				* On which octave note should be played
									* NOTE: Do not check octave for keyoff,
									* etc. !
	BYTE	tctd_Note				* Note (0 is none, 1 is C-, 12 is B-,
									* $FD is keyoff).
	UWORD	tctd_Instrument			* Number of instrument to be played
	STRUCT	tctd_Effects,MLH_SIZE	* APTR to effect data
	LABEL	tctd_NextRow			* Now the same comes except for the next
									* row. This comes as often as track len.
	LABEL	tctd_SIZEOF

* Note names.

NOTE_NONE				EQU	0					* ---
NOTE_C_					EQU	1					* C-x
NOTE_C_SHARP			EQU	2					* C#x = Dbx
NOTE_D_					EQU	3					* D-x
NOTE_D_SHARP			EQU	4					* D#x = Ebx
NOTE_E_					EQU	5					* E-x
NOTE_F_					EQU	6					* F-x
NOTE_F_SHARP			EQU	7					* F#x = Gbx
NOTE_G_					EQU	8					* G-x
NOTE_G_SHARP			EQU	9					* G#x = Abx
NOTE_A_					EQU	10					* A-x
NOTE_A_SHARP			EQU	11					* A#x = Bbx
NOTE_B_					EQU	12					* B-x
NOTE_H_					EQU	NOTE_B_				* H-x
NOTE_END				EQU	$F0					* END (pattern end marker)
NOTE_FADE				EQU	$FB					* -\- (note fade)
NOTE_HOLD_DELAY			EQU	$FC					* -|- (hold delay)
NOTE_KEYOFF				EQU	$FD					* === (keyoff note)
NOTE_OFF				EQU	$FE					* ^^- (Note off)
NOTE_KILL				EQU	$FF					* ^^^ (Kill note)

* Default note, octave, tune.

DEFAULTOCTAVE			EQU	4					* Default octave is 4
DEFAULTNOTE				EQU NOTE_C_				* Default note is C-
DEFAULTTONE				EQU	4<<8|NOTE_C_		* Default tone is C-4

* Octave, note ranges

FIRSTOCTAVE	EQU	0								* First octave is 0, not 1
FIRSTNOTE	EQU	NOTE_C_							* First note is C-
LASTOCTAVE	EQU	9								* Octaves range from 0 to 9
LASTNOTE	EQU	NOTE_B_							* Notes range from C- to B-
NUMOCTAVES	EQU	LASTOCTAVE+1					* Number of octaves
NUMNOTES	EQU	NOTE_B_							* Number of notes
SPEC_NOTES	EQU	$F0								* All above this is reserved
												* for special notes (like
												* keyoff and similar)

* Track structure, used by all Track functions (e.g. SplitTrack())
	STRUCTURE	TuComposerTrack,MLN_SIZE
	APTR	tct_FileName	* Pointer to track file name
							* (e.g. MainPart.TRK). Remember
							* that TuComposer is also available for
							* MS-DOS and other platforms. So, please try
							* to use the limited 8x3 MS-DOS file/dir
							* name length.
	APTR	tct_Name		* Pointer to track info, e.g. (Main Part)
	APTR	tct_Data		* Pointer to track data
	UWORD	tct_Length		* Last row of track (default is 63 ($3F))
	UBYTE	tct_Volume		* Track global volume
	UBYTE	tct_SubVolume	* Sub volume (used when you slide)
	BYTE	tct_Panning		* Panning for track if ins panning is off
	UBYTE	tct_SubPanning	* Sub Panning (used when you slide)
	BYTE	tct_Transpose	* Track transpose
	UBYTE	tct_CompFlags	* Compatibility flags (look bit def table)
	UWORD	tct_Flags		* Track flags, see bit defs
	UWORD	tct_Frames		* Number of frames per row (default 6)
	UBYTE	tct_SpeedMul	* Speed multiplier (allowing you e.g. 2/3)
	UBYTE	tct_SpeedDiv	* Speed divider (the divider for the multiplier)
	UWORD	tct_SPDSpeed	* Track SPD
	UWORD	tct_BPMTempo	* Track BPM tempo (number of rows of a beat).
	UWORD	tct_BPMSpeed	* Track BPM speed.
	STRUCT	tct_UnknownChunks,MLH_SIZE	* Linked list of unknown chunks
	STRUCT	tct_Reserved,8	* Reserved for future expansions
	APTR	tct_UserData	* This field is ignored by TuComposer.Library.
	LABEL	tct_SIZEOF

DEFAULTTRACKROWS		EQU	$40					* Default rows of track (64)
DEFAULTTRACKLENGTH		EQU	DEFAULTTRACKROWS-1	* Length entry is -1
DEFAULTTRACKVOLUME		EQU	$FF					* Default is full volume
DEFAULTTRACKPANNING		EQU	$80					* Default is middle panning
DEFAULTTRACKTRANSPOSE	EQU	0					* No default transpose
DEFAULTTRACKFRAMES		EQU	6					* Delay one row 6/50 secs.
DEFAULTTRACKSPEEDMUL	EQU	0					* Disable multiplier and
DEFAULTTRACKSPEEDDIV	EQU	0					* the divider
DEFAULTTRACKSPDSPEED	EQU	33					* 33 as in OctaMED
DEFAULTTRACKBPMTEMPO	EQU	4					* 4 rows are a beat.
DEFAULTTRACKBPMSPEED	EQU	125					* Beats per minute (50 Hz)

* Maximum values

MAXTRACKROWS			EQU	$10000				* Maximum number of rows
												* possible
LASTTRACKROW			EQU	MAXTRACKROWS-1		* Last valid row to address

* Track error codes

ERROR_TRACK_NOGIVEN	EQU	ERROR_TRACK+$0			* If no track given
ERROR_TRACK_NODATA	EQU	ERROR_TRACK+$1			* Track contains no data
ERROR_TRACK_NOMEM	EQU	ERROR_TRACK+$2			* Returned on mem fail
ERROR_TRACK_NOFILE	EQU	ERROR_TRACK+$4			* No file given
ERROR_TRACK_IOERR	EQU	ERROR_TRACK+$5			* I/O error occured on
ERROR_TRACK_BAD_IFF	EQU	ERROR_TRACK+$6			* TCT1-IFF-file damaged
* Because LoadTrack() returns NULL on error, use DOS IoErr() and check
* ERROR_INVALID_RESIDENT_LIBRARY for it.

ERROR_TRACK_BAD_VER	EQU	ERROR_TRACK+$7			* Incorrect track version
* Because LoadTrack() returns NULL on error, use DOS IoErr() and check
* ERROR_ACTION_NOT_KNOWN for it.

ERROR_TRACK_TOO_BIG		EQU	ERROR_TRACK+$8		* Returned if rows > $10000
ERROR_TRACK_TOO_LOW		EQU	ERROR_TRACK+$9		* Returned if rows < $1
ERROR_TRACK_NOSCALE		EQU	ERROR_TRACK+$A		* Invalid scale value (=<0)
ERROR_TRACK_INVALID_OCTAVE	EQU	ERROR_TRACK+$B	* Too much octaves !
ERROR_TRACK_INVALID_NOTE	EQU	ERROR_TRACK+$C	* Invalid note entered !

	STRUCTURE	TuComposerTrackEffect,MLN_SIZE
	UBYTE	tcte_Reserved			* Unused now, leave it zero !
	UBYTE	tcte_EffectByte			* Effect byte, look table below
	UWORD	tcte_DataWord			* Data word, same as old PT data byte.
	LABEL	tcte_NextEffect			* Next effect, until it reaches zero
	LABEL	tcte_SIZEOF

* Effect types.

NOTE_EFFECTS	EQU	$00				* Note effects
VOLUME_EFFECTS	EQU	$20				* Volume related effects
PANNING_EFFECTS	EQU	$30				* Panning related effects
TRACK_EFFECTS	EQU	$40				* Track/Channel effects
INSTR_EFFECTS	EQU	$50				* Instrument related effects
GLOBAL_EFFECTS	EQU	$60				* Global effects
USER_EFFECTS	EQU	$7F				* User effect for demos, etc.

* Note effects:

FX_ARPEGGIO		EQU	$00				* Arpeggio. Data word = xxyy
FX_PORTA_UP		EQU	$01				* Portamento up. Data word = xxyy
FX_PORTA_DOWN	EQU	$02				* Portamento down. Data word = xxyy
FX_F_PORTA_UP	EQU	$03				* Fine portamento up. Data word = xxyy
FX_F_PORTA_DOWN	EQU	$04				* Fine portamento down. Data word = xxyy
FX_O_PORTA_UP	EQU	$05				* Portamento up once. Data word = xxyy
FX_O_PORTA_DOWN	EQU	$06				* Portamento down once. Data word = xxyy
FX_OFPORTA_UP	EQU	$07				* Fine portamento up once. Data word = xxyy
FX_OFPORTA_DOWN	EQU	$08				* Fine portamento down once. Data word = xxyy
FX_TONE_PORTA	EQU	$09				* Tone portamento. Data word = xxyy
FX_F_TONE_PORTA	EQU	$0A				* Fine tone portamento. Data word = xxyy
FX_O_TONE_PORTA	EQU	$0B				* Tone portamento once. Data word = xxyy
FX_OFTONE_PORTA	EQU	$0C				* Fine tone portamento once. Data word = xxyy
FX_NOTE_SLIDE	EQU	$0D				* (Fine) note slide up/down. Data word = xxyy
FX_VIBRATO		EQU	$0E				* Vibrato. Data word = xxyy
FX_FINE_VIBRATO	EQU	$0F				* Fine vibrato. Data word = xxyy
FX_VIBRATO_ONCE	EQU	$10				* Vibrato once. Data word = xxyy
FX_F_VIB_ONCE	EQU	$11				* Fine vibrato once. Data word = xxyy
FX_DO_KEYOFF	EQU	$12				* Do a keyoff. Data word = xxxx
FX_DO_HOLD		EQU	$13				* Do a hold delay. Data word = xxxx
FX_NOTE_FADE	EQU	$14				* Do a fadeout. Data word = xxxx
FX_NOTE_CUT		EQU	$15				* Note cut. Data word = xxyy
FX_NOTE_DELAY	EQU	$16				* Note delay. Data word = xxxx
FX_TREMOR		EQU	$17				* Tremor. Data word = xxyy
FX_RETRIG_NOTE	EQU	$18				* Note retrigger. Data word = xxxx
FX_MULTI_RETRIG	EQU	$19				* Multi retrig note. Data word = xxyz
FX_EXTEND_CTRL	EQU	$1A				* Extended control. Data word = xyyy
FX_INVERT_LOOP	EQU	$1B				* Invert loop. Data word = xxxx
FX_EXECUTE_FX	EQU	$1C				* Execute FX at Tick. Data word = xxxx
FX_STOP_FX		EQU	$1D				* Stop FX at Tick. Data word = xxyy

* Extended control x values

EXC_FREQ_TABLE	EQU	$0				* Set frequence table to use for slides
EXC_GLISS_CTRL	EQU	$1				* Glissando control
EXC_MULTI_CTRL	EQU	$2				* Multi retrig control
EXC_PAST_CUT	EQU	$3				* Past note cut
EXC_PAST_FADE	EQU	$4				* Past note fade out
EXC_PAST_OFF	EQU	$5				* Past note off

* Volume effects:

FX_SET_VOLUME	EQU	$20				* Set volume. Data word = xxyy
FX_VOL_SLD_UP	EQU	$21				* Volume slide up. Data word = xxyy
FX_VOL_SLD_DOWN	EQU	$22				* Volume slide down. Data word = xxyy
FX_F_VOLSL_UP	EQU	$23				* Fine volume slide up. Data word = xxyy
FX_F_VOLSL_DOWN	EQU	$24				* Fine volume slide down. Data word = xxyy
FX_VOL_SLD_TO	EQU	$25				* Volume slide to. Data word = xxyy
FX_TREMOLO		EQU	$26				* Tremolo. Data word = xxyy
FX_TREMOLO_ONCE	EQU	$27				* Tremolo once. Data word = xxyy
FX_SET_TRK_VOL	EQU	$28				* Set track volume. Data word = xxyy
FX_TVOL_SL_UP	EQU	$29				* Track volume slide up. Data word = xxyy
FX_TVOL_SL_DOWN	EQU	$2A				* Track volume slide down. Data word = xxyy
FX_F_TVOL_SL_UP	EQU	$2B				* Fine track volume slide up. Data word = xxyy
FX_F_TVOL_SL_DN	EQU	$2C				* Fine track volume slide down. Data word = xxyy
FX_TVOL_SLD_TO	EQU	$2D				* Track volume slide to. Data word = xxyy
FX_TRK_TREMOLO	EQU	$2E				* Track tremolo. Data word = xxyy
FX_T_TREMO_ONCE	EQU	$2F				* Track tremolo once. Data word = xxyy

* Panning effects:

FX_SET_PANNING	EQU	$30				* Set panning position. Data word = xxyy
FX_PAN_SL_LEFT	EQU	$31				* Panning slide left. Data word = xxyy
FX_PAN_SL_RIGHT	EQU	$32				* Panning slide right. Data word = xxyy
FX_F_P_SL_LEFT	EQU	$33				* Fine panning slide left. Data word = xxyy
FX_F_P_SL_RIGHT	EQU	$34				* Fine panning slide right. Data word = xxyy
FX_PAN_SLD_TO	EQU	$35				* Panning slide to. Data word = xxyy
FX_PANNOLO		EQU	$36				* Tremolo for panning. Data word = xxyy
FX_PANNOLO_ONCE	EQU	$37				* Pannolo once. Data word = xxyy
FX_SET_TRK_PAN	EQU	$38				* Set track panning. Data word = xxyy
FX_TPAN_SL_LEFT	EQU	$39				* Track panning slide up. Data word = xxyy
FX_TPAN_SL_RGHT	EQU	$3A				* Track panning slide down. Data word = xxyy
FX_F_TP_SL_LEFT	EQU	$3B				* Fine track panning slide up. Data word = xxyy
FX_F_TP_SL_RGHT	EQU	$3C				* Fine track panning slide down. Data word = xxyy
FX_TPAN_SLD_TO	EQU	$3D				* Track panning slide to. Data word = xxyy
FX_TRK_PANNOLO	EQU	$3E				* Track pannolo. Data word = xxyy
FX_TPANOLO_ONCE	EQU	$3F				* Track pannolo once. Data word = xxyy

* Track effects:

FX_SET_TEMPO	EQU	$40				* Set channel tempo. Data word = xxxx
FX_SET_REL_TMPO	EQU	$41				* Set relative tempo. Data word = xxxx
FX_PATT_BREAK	EQU	$42				* Pattern break. Data word = xxxx
FX_POS_JUMP		EQU	$43				* Position jump. Data word = xxxx
FX_REL_POS_JUMP	EQU	$44				* Relative pos jump. Data word = xxxx
FX_CHG_PATTERN	EQU	$45				* Change pattern. Data word = xxxx
FX_REVERSE_PLAY	EQU	$46				* Reverse play control. Data word = xxxx
FX_PATT_DELAY	EQU	$47				* Pattern delay. Data word = xxxx
FX_F_PATT_DELAY	EQU	$48				* Fine pattern delay. Data word = xxxx
FX_PATT_LOOP	EQU	$49				* Pattern loop. Data word = xxxx
FX_GOSUB		EQU	$4A				* GoSub. Data word = xxxx
FX_RETURN		EQU	$4B				* Return from GoSub. Data word = xxxx
FX_CHANNEL_SYNC	EQU	$4C				* Channel synchronize. Data word = xxyy
FX_SET_SUBSLIDE	EQU	$4D				* Set target sub-slide to. Data word = xxyy

* Set target sub-slide to xx bits
	BITDEF	TSS,VOLUME,0			* Set volume sub-slide to yy
	BITDEF	TSS,TRACKVOLUME,1		* Set track volume sub-slide to yy
	BITDEF	TSS,GLOBALVOLUME,2		* Set global volume sub-slide to yy
	BITDEF	TSS,PANNING,3			* Set panning sub-slide to yy
	BITDEF	TSS,TRACKPANNING,4		* Set track panning sub-slide to yy
	BITDEF	TSS,GLOBALPANNING,5		* Set global panning sub-slide to yy

* Instrument effects:

FX_SMP_OFF_HIGH	EQU	$50				* Sample offset HI-Word. Data word = xxxx
FX_SMP_OFF_LOW	EQU	$51				* Sample offset LO-Word. Data word = xxxx
FX_SET_HOLD		EQU	$52				* Set hold. Data word = xxxx
FX_SET_DECAY	EQU	$53				* Set decay. Data word = xxxx
FX_SET_TRANSP	EQU	$54				* Set transpose. Data word = xxyy
FX_INS_CONTROL	EQU	$55				* Instrument control. Data word = xxyy
FX_INS_CHANGE	EQU	$56				* Instrument change. Data word = xyyy
FX_SYNTH_CTRL	EQU	$57				* Synth control. Data word = xxyy
FX_SET_SYN_VAL	EQU	$58				* Set synth value. Data word = xxxx
FX_ENV_CONTROL	EQU	$59				* Envelope control. Data word = xxyy
FX_SET_ENV_VAL	EQU	$5A				* Set envelope value. Data word = xxxx
FX_NNA_CONTROL	EQU	$5B				* Set new note action. Data word = xxxx
FX_SET_LOOP		EQU	$5C				* Loop control. Data word = xyyy

* Instrument control xx (on-bits) and yy (off-bits) bits
	BITDEF	IC,PANNING,0			* Instrument panning on if bit set in xx, when in yy it's off
	BITDEF	IC,TRANSPOSE,1			* Position transposeable if bit set in xx, when in yy it's off
	BITDEF	IC,SLIDENVPORTA,3		* Slide envelope portamento bit
	BITDEF	IC,SLIDENVLINEAR,4		* Slide envelope linear frequence bit
	BITDEF	IC,AUTOVIBLINEAR,7		* Auto vibrato linear frequence bit

* Instrument change x values
IC_GLOBAL_VOL	EQU	$0				* Change instrument global volume to 0yy
IC_VOL_SWING	EQU	$1				* Change instrument volume swing to yyy
IC_PAN_SWING	EQU	$2				* Change instrument panning swing to yyy
IC_PITCH_SWING	EQU	$3				* Change instrument pitch swing to yyy
IC_FADEOUT		EQU	$4				* Change instrument fadeout to yyy0
IC_FADE_COUNT	EQU	$5				* Change fadeout count to yyy0
IC_A_VIB_CTRL	EQU	$6				* Set Auto Vibrato/Tremolo/Pannolo wave.
IC_A_VIB_SWEEP	EQU	$60				* Set auto vibrato sweep to yy
IC_A_VIB_DEPTH	EQU	$61				* Set auto vibrato depth to yy
IC_A_VIB_RATE	EQU	$62				* Set auto vibrato rate to yy
IC_A_TREM_SWEEP	EQU	$64				* Set auto tremolo sweep to yy
IC_A_TREM_DEPTH	EQU	$65				* Set auto tremolo depth to yy
IC_A_TREM_RATE	EQU	$66				* Set auto tremolo rate to yy
IC_A_PAN_SWEEP	EQU	$68				* Set auto pannolo sweep to yy
IC_A_PAN_DEPTH	EQU	$69				* Set auto pannolo depth to yy
IC_A_PAN_RATE	EQU	$6A				* Set auto pannolo rate to yy
IC_PCH_PAN_SEP	EQU	$7				* Set pitch panning separation to yyy
IC_PCH_PAN_CNTR	EQU	$8				* Set pitch panning center to 0yy

* Global effects:

FX_SET_SPEED	EQU	$60				* Set speed. Data word = xyyy
FX_SPD_SLD_FAST	EQU	$61				* Speed slide faster. Data word = xxyy
FX_SPD_SLD_SLOW	EQU	$62				* Speed slide slower. Data word = xxyy
FX_F_S_SLD_FAST	EQU	$63				* Fine speed slide faster. Data word = xxyy
FX_F_S_SLD_SLOW	EQU	$64				* Fine speed slide slower. Data word = xxyy
FX_SPD_SLD_TO	EQU	$65				* Set speed slide to. Data word = xxyy
FX_SPENOLO		EQU	$66				* Spenolo (Vibrato for speed). Data word = xxyy
FX_SPENOLO_ONCE	EQU	$67				* Spenolo once. Data word = xxyy
FX_CHANNEL_CTRL	EQU	$68				* Channel control. Data word = xyzz
FX_SET_G_VOLUME	EQU	$69				* Set global volume. Data word = xxyy
FX_G_VOLSL_UP	EQU	$6A				* Global volume slide up. Data word = xxyy
FX_G_VOLSL_DOWN	EQU	$6B				* Global volume slide down. Data word = xxyy
FX_F_G_VOL_UP	EQU	$6C				* Fine global vol slide up. Data word = xxyy
FX_F_G_VOL_DOWN	EQU	$6D				* Fine global vol slide down. Data word = xxyy
FX_G_VOLSL_TO	EQU	$6E				* Set global volume slide to. Data word = xxyy
FX_G_TREMOLO	EQU	$6F				* Global Tremolo. Data word = xxyy
FX_G_TREMO_ONCE	EQU	$70				* Global Tremolo once. Data word = xxyy
FX_SET_G_PAN	EQU	$71				* Set global panning position. Data word = xxyy
FX_GPANSL_LEFT	EQU	$72				* Global panning slide left. Data word = xxyy
FX_GPANSL_RIGHT	EQU	$73				* Global panning slide right. Data word = xxyy
FX_FGP_SL_LEFT	EQU	$74				* Global fine panning slide left. Data word = xxyy
FX_FGP_SL_RIGHT	EQU	$75				* Global fine panning slide right. Data word = xxyy
FX_GPANSL_TO	EQU	$76				* Set global panning slide to. Data word = xxyy
FX_G_PANNOLO	EQU	$77				* Global pannolo. Data word = xxyy
FX_G_PANNOLO_O	EQU	$78				* Global pannolo once. Data word = xxyy

* Channel control x contents:
CC_EFFECT_CHANNEL	EQU	$0			* Effect channel related control.
CC_OUTPUT_CONTROL	EQU	$1			* Channel output control.

* Effect channel control (xy):

EC_SET_CC_MODE	EQU	$00				* Set channel control mode to zz.
EC_SET_O_EFFECT	EQU	$01				* Set once effect channel to zz.
EC_SET_EFFECT	EQU	$02				* Set effect channel to zz.
EC_SLD_E_LEFT	EQU	$03				* Slide effect channel to left by zz.
EC_SLD_E_RIGHT	EQU	$04				* Slide effect channel to right by zz.
EC_F_S_E_LEFT	EQU	$05				* Fine slide effect channel to left by zz.
EC_F_S_E_RIGHT	EQU	$06				* Fine slide effect channel to right by zz.
EC_F_SO_E_LEFT	EQU	$07				* Fine slide effect channel to left once by zz.
EC_F_SO_E_RIGHT	EQU	$08				* Fine slide effect channel to right once by zz.
EC_CHANNOLO		EQU	$09				* Channolo (Vibrato for channels) to zz.
EC_F_CHANNOLO	EQU	$0A				* Fine channolo to zz.
EC_F_CHANNOLO_O	EQU	$0B				* Fine channolo once to zz.
OC_SURROUND_CHN	EQU	$10				* If zz == 00 then disable surround, else
									* enable it.
OC_MUTE_CHANNEL	EQU	$11				* If zz == 00 then MUTE channel else play
									* it.

* Track packed structure. Used by PackTrack(), UnPackTrack(), LoadTrack(),
* and SaveTrack().
	STRUCTURE	TuComposerPacked,0
	APTR	tcp_FileName	* Pointer to packed file name.
							* (e.g. MainPart.TRK). Remember that TuComposer
							* is also available for MS-DOS and other
							* platforms. So, please try to use the limited
							* 8x3 MS-DOS file/dir name length.
	APTR	tcp_Name		* Pointer to track info, e.g. (Main Part)
	APTR	tcp_Data		* Pointer to packed track data (notes, etc.)
	ULONG	tcp_PackLength	* Track packed size
	UWORD	tcp_Length		* Track length in rows - 1 (default 63)
	UBYTE	tcp_Volume		* Track global volume
	UBYTE	tcp_SubVolume	* Sub volume (used when you slide)
	BYTE	tcp_Panning		* Panning for track if ins panning is off
	UBYTE	tcp_SubPanning	* Sub Panning (used when you slide)
	BYTE	tcp_Transpose	* Track transpose
	UBYTE	tcp_CompFlags	* Compatibility flags (look bit def table)
	UWORD	tcp_Flags		* Track flags, see bit defs
	UWORD	tcp_Frames		* Number of frames per row (default 6)
	UBYTE	tcp_SpeedMul	* Speed multiplier (allowing you e.g. 2/3)
	UBYTE	tcp_SpeedDiv	* Speed divider (the divider for the multiplier)
	UWORD	tcp_SPDSpeed	* Track SPD
	UWORD	tcp_BPMTempo	* Track BPM tempo (number of rows of a beat).
	UWORD	tcp_BPMSpeed	* Track BPM speed.
	STRUCT	tcp_UnknownChunks,MLH_SIZE	* Linked list of unknown chunks
	STRUCT	tcp_Reserved,8	* Reserved for future expansions
	APTR	tcp_UserData	* This field is ignored by TuComposer.Library.
	LABEL	tcp_SIZEOF

* IFF-TCT1 THDR structure. Used by disk operations
* (e.g. by LoadTrack() & SaveTrack())

	STRUCTURE	IFF_THDR,iff_Data
	UBYTE	thdr_Version	* Version number of TCT1 file
	UBYTE	thdr_Revision	* Revision number of TCT1 file
	UWORD	thdr_Length		* Last row of track (default 63 ($3F))
	UBYTE	thdr_Volume		* Track global volume
	UBYTE	thdr_SubVolume	* Sub volume
	BYTE	thdr_Panning	* Track panning
	UBYTE	thdr_SubPanning	* Sub panning
	BYTE	thdr_Transpose	* Transposing of track
	UBYTE	thdr_CompFlags	* Compatibility flags (look bit def table)
	UWORD	thdr_Flags		* Track flags, see bit defs
	UWORD	thdr_Frames		* Number of frames per row (default 6)
	UBYTE	thdr_SpeedMul	* Speed multiplier (allowing you e.g. 2/3)
	UBYTE	thdr_SpeedDiv	* Speed divider (the divider for the multiplier)
	UWORD	thdr_SPDSpeed	* Track SPD
	UWORD	thdr_BPMTempo	* Track BPM tempo (number of rows of a beat).
	UWORD	thdr_BPMSpeed	* Track BPM speed.
	LABEL	thdr_SIZEOF		* This will increase in future. So never assume
							* that the THDR chunk is thdr_SIZEOF bytes long.

* IFF-TCM1 THDR structure. Used by disk operations
* (e.g. by LoadTCModule() & SaveTCModule())

	STRUCTURE	MIFF_THDR,iff_Data
	UWORD	mthdr_Length	* Last row of track (default 63 ($3F))
	UBYTE	mthdr_Volume	* Track global volume
	UBYTE	mthdr_SubVolume	* Sub volume
	BYTE	mthdr_Panning	* Track panning
	UBYTE	mthdr_SubPan	* Sub panning
	BYTE	mthdr_Transpose	* Transposing of track
	UBYTE	mthdr_CompFlags	* Compatibility flags (look bit def table)
	UWORD	mthdr_Flags		* Track flags, see bit defs
	UWORD	mthdr_Frames	* Number of frames per row (default 6)
	UBYTE	mthdr_SpeedMul	* Speed multiplier (allowing you e.g. 2/3)
	UBYTE	mthdr_SpeedDiv	* Speed divider (the divider for the multiplier)
	UWORD	mthdr_SPDSpeed	* Track SPD
	UWORD	mthdr_BPMTempo	* Track BPM tempo (number of rows of a beat).
	UWORD	mthdr_BPMSpeed	* Track BPM speed.
	LABEL	mthdr_SIZEOF	* This will increase in future. So never assume
							* that the THDR chunk is mthdr_SIZEOF bytes long.

TCT_NAME	EQU	(('T'<<24)!('C'<<16)!('T'<<8)!('1'))
PATT_NAME	EQU	(('P'<<24)!('A'<<16)!('T'<<8)!('T'))
TRAK_NAME	EQU	(('T'<<24)!('R'<<16)!('A'<<8)!('K'))
THDR_NAME	EQU	(('T'<<24)!('H'<<16)!('D'<<8)!('R'))

THDR_VERSION	EQU	1		* Current version 1
THDR_REVISION	EQU	0		* Current revision 0

C_TCT	MACRO
	dc.b	'TCT1'
	ENDM

TCT_CHUNK	MACRO	* Length
	C_FORM
	dc.l	\1
	C_TCT
	ENDM

C_PATT	MACRO
	dc.b	'PATT'
	ENDM

PATT_CHUNK	MACRO	* Length
	C_FORM
	dc.l	\1
	C_PATT
	ENDM

C_TRAK	MACRO
	dc.b	'TRAK'
	ENDM
	
TRAK_CHUNK	MACRO	* Length
	C_FORM
	dc.l	\1
	C_TRAK
	ENDM

C_THDR	MACRO
	dc.b	'THDR'
	ENDM

THDR_CHUNK	MACRO	* Length
	C_THDR
	dc.l	\1
	ENDM

	ENDC	; TUCOMPOSER_TRACK_I
