	IFND	TUCOMPOSER_TUCOMPOSER_I
TUCOMPOSER_TUCOMPOSER_I	SET	1
**
**	$Filename: tucomposer/tucomposer.i $
**	$Release : 31.22 $
**
**
**
**	(C) Copyright 1996-98 by The united Coders (TuC)
**		Main code: Basty/TuC
**		All Rights Reserved
**

		IFND	EXEC_TYPES_I
		include	"exec/types.i"
		ENDC	; EXEC_TYPES_I

		IFND	EXEC_LIBRARIES_I
		include	"exec/libraries.i"
		ENDC	; EXEC_LIBRARIES_I

		IFND	EXEC_LISTS_I
		include	"exec/lists.i"
		ENDC	; EXEC_LISTS_I

		IFND	LIBRARIES_DOS_I
		include	"libraries/dos.i"
		ENDC	; LIBRARIES_DOS_I

* Bit definitions for peh_Flags:
	BITDEF	PEH,SongEnd,0			* Signal song ends only
	BITDEF	PEH,Beginning,1			* Signal before executing player code
									* (only useful when you give exec code)

* The library structure.
	STRUCTURE	TuComposerBase,LIB_SIZE
	BPTR	tcb_SegList				* BPTR to LoadSeg() array of the library
	APTR	tcb_DOSBase				* APTR to dos.library base
	APTR	tcb_IntBase				* APTR to intuition.library base
	APTR	tcb_MemPool				* APTR to memory pool (only OS3.0+)
	APTR	tcb_MemSigSem			* APTR to memory pool signal semaphore
	APTR	tcb_PlayModule			* APTR to playing module or zero
	APTR	tcb_PlaySong			* APTR to playing song or zero
	APTR	tcb_PlaySoundDeviceBase	* APTR to playing sound device lib base
	APTR	tcb_PlayMixerAlloc		* APTR to playing mixer alloc structure
	APTR	tcb_SineTable			* APTR to sine table
	APTR	tcb_LinearFreqTable		* APTR to linear frequency table
	APTR	tcb_FrequencyTable		* APTR to frequency table
	APTR	tcb_OldSTTable			* APTR to old SoundTracker tempos table
	APTR	tcb_EffectsTable		* APTR to player effects table
	APTR	tcb_SynthInstrTable		* APTR to synth code instruction table
	APTR	tcb_SynthExecTable		* APTR to synth execution table
	ULONG	tcb_RandomSeed			* Current randomize seed
	STRUCT	tcb_ModuleList,MLH_SIZE	* Linked list of loaded MODs
	STRUCT	tcb_ExecList,MLH_SIZE	* Linked list of signalling tasks on each
									* tick.
	STRUCT	tcb_ModuleBuf,MLH_SIZE	* List of buffered MODs (cut, copy, etc.)
	STRUCT	tcb_SongBuf,MLH_SIZE	* Linked list of buffered songs.
	STRUCT	tcb_TrackBuf,MLH_SIZE	* Linked list of buffered tracks.
	STRUCT	tcb_InstrBuf,MLH_SIZE	* Linked list of buffered instruments.
	STRUCT	tcb_SampleBuf,MLH_SIZE	* Linked list of buffered samples.
	STRUCT	tcb_SynthBuf,MLH_SIZE	* Linked list of buffered synthetics.
	STRUCT	tcb_WavesBuf,MLH_SIZE	* Linked list of buffered waveforms.
	STRUCT	tcb_ExtCrunch,MLH_SIZE	* Linked list of external crunchers.
	STRUCT	tcb_ExtDevice,MLH_SIZE	* Linked list of external devices.
	STRUCT	tcb_ExtRecord,MLH_SIZE	* Linked list of external recorders.
	STRUCT	tcb_ExtMixer,MLH_SIZE	* Linked list of external mixers.
	STRUCT	tcb_ExtPostProc,MLH_SIZE	* Linked list of external mixer
										* post processors.

	STRUCT	tcb_ExtModule,MLH_SIZE	* Linked list of external modules.
	STRUCT	tcb_ExtSong,MLH_SIZE	* Linked list of external songs.
	STRUCT	tcb_ExtTrack,MLH_SIZE	* Linked list of external tracks.
	STRUCT	tcb_ExtInstr,MLH_SIZE	* Linked list of external instruments.
	STRUCT	tcb_ExtSample,MLH_SIZE	* Linked list of external samples.
	STRUCT	tcb_ExtSynth,MLH_SIZE	* Linked list of external synthetics.
	APTR	tcb_ModuleListSigSem	* APTR to module list signal semaphore
	APTR	tcb_PlaySigSem			* APTR to playing access semaphore
	APTR	tcb_ModuleSigSem		* APTR to module protection semaphore
	APTR	tcb_SongSigSem			* APTR to song protection semaphore
	APTR	tcb_TrackSigSem			* APTR to track protection semaphore
	APTR	tcb_InstrSigSem			* APTR to instrument protection semaphore
	APTR	tcb_SampleSigSem		* APTR to sample protection semaphore
	APTR	tcb_SynthSigSem			* APTR to synth protection semaphore
	APTR	tcb_WavesSigSem			* APTR to waveform protection semaphore
	APTR	tcb_ExternalSigSem		* APTR to external libraries semaphore
	LABEL	tcb_SIZEOF

* PlayExec structure for AddPlayExecHandler() & RemPlayExecHandler()
	STRUCTURE	PlayExecHandler,MLN_SIZE
	UBYTE	peh_Flags				* Special flags (see above)
	BYTE	peh_Pri					* Sorting priority
	LABEL	peh_Task				* APTR to signalling task
	FPTR	peh_Code				* If peh_SigBit is $FF, this one is used
	UBYTE	peh_SigBit				* Signalling bit
	UBYTE	peh_Pad					* Just for even alignment
	ULONG	peh_Data				* Any data value put in A0 when peh_Task
									* points to any code to be executed
	STRUCT	peh_Reserved,10			* Reserved for future expansions
	LABEL	peh_SIZEOF

* The code gets the following parameters on the stack:
*  0(SP) = Return address.
*  4(SP) = Pointer to tucomposer.library base
*  8(SP) = Pointer to module currently playing
* 12(SP) = Pointer to song currently playing
* 16(SP) = User data (peh_Data).
*
* Note: You MUST save/restore all registers you use except d0-d1/a0-a1

* Date structure for Stamp2Date()
	STRUCTURE	StampDate,0
	UBYTE	sds_Day					* Day (01 - 07)
	UBYTE	sds_Month				* Month (01 - 12)
	UWORD	sds_Year				* Year (from 0 A.D.)
	UBYTE	sds_TimeHours			* Hours (0 - 23)
	UBYTE	sds_TimeMins			* Mins (0 - 59)
	UBYTE	sds_TimeSecs			* Seconds (0 - 59)
	UBYTE	sds_TimeHundreds		* 1/100 seconds (0 - 99)
	LABEL	sds_SIZEOF

* Unknown chunk structure. This structure is used by all chunks stated as
* unknown.
	STRUCTURE	UnknownChunk,MLN_SIZE
	ULONG	uc_Identifier			* Unknown IFF-Chunk identifier
	ULONG	uc_Length				* Unknown IFF-Chunk length
	LABEL	uc_Data					* Unknown IFF-Chunk data
	LABEL	uc_SIZEOF

* IFF-Header structure
	STRUCTURE	IFFHeader,0
	ULONG		ifh_FORMId			* FORM id
	ULONG		ifh_Length			* Length of IFF file from ifh_TypeId
	ULONG		ifh_TypeId			* Type id (TCM1 in this case)
	LABEL		ifh_SIZEOF

* IFF Chunk structure

	STRUCTURE	IFFChunk,0
	ULONG		iff_Identifier		* IFF-Chunk identifier
	ULONG		iff_Length			* Length
	LABEL		iff_Data			* Data string
	LABEL		iff_SIZEOF

* GetLinearTable() types:
LINEAR_FINE_UP		EQU	0			* Fine up linear frequence table
LINEAR_FINE_DOWN	EQU	1			* Fine down linear frequence table
LINEAR_UP			EQU	2			* Linear up frequence table
LINEAR_DOWN			EQU	3			* Linear down frequence table

* Global error codes

ERROR_MODULE	EQU	$FFFFFFF0		* Module related errors
ERROR_SONG	EQU	$FFFFFFE0			* Song related errors
ERROR_TRACK	EQU	$FFFFFFD0			* Track related errors
ERROR_POSITION	EQU	$FFFFFFC0		* Position/order list related errors
ERROR_INSTR	EQU	$FFFFFFB0			* Instrument related errors
ERROR_SAMPLE	EQU	$FFFFFFA0		* Sample related errors
ERROR_SYNTH	EQU	$FFFFFF90			* Synthetic related errors
ERROR_EXTLIB	EQU	$FFFFFF80		* External library related errors

FORM_NAME	EQU	(('F'<<24)!('O'<<16)!('R'<<8)!('M'))
BODY_NAME	EQU	(('B'<<24)!('O'<<16)!('D'<<8)!('Y'))
FILE_NAME	EQU	(('F'<<24)!('I'<<16)!('L'<<8)!('E'))
NAME_NAME	EQU	(('N'<<24)!('A'<<16)!('M'<<8)!('E'))
STIL_NAME	EQU	(('S'<<24)!('T'<<16)!('I'<<8)!('L'))
AUTH_NAME	EQU	(('A'<<24)!('U'<<16)!('T'<<8)!('H'))
CMNT_NAME	EQU	(('C'<<24)!('M'<<16)!('N'<<8)!('T'))

C_FORM	MACRO
	dc.b	'FORM'
	ENDM

FORM_ID	MACRO	* Length
	C_FORM
	dc.l	\1
	ENDM

C_BODY	MACRO
	dc.b	'BODY'
	ENDM

BODY_CHUNK	MACRO	* Length
	C_BODY
	dc.l	\1
	ENDM

C_FILE	MACRO
	dc.b	'FILE'
	ENDM

FILE_CHUNK	MACRO
	C_FILE
	dc.l	\1
	ENDM

C_NAME	MACRO
	dc.b	'NAME'
	ENDM
NAME_CHUNK	MACRO	* Length
	C_NAME
	dc.l	\1
	ENDM

C_STIL	MACRO
	dc.b	'STIL'
	ENDM

STIL_CHUNK	MACRO	* Length		
	C_STIL
	dc.l	\1
	ENDM

C_AUTH	MACRO
	dc.b	'AUTH'
	ENDM

AUTH_CHUNK	MACRO	* Length
	C_AUTH
	dc.l	\1
	ENDM

C_CMNT	MACRO
	dc.b	'CMNT'
	ENDM

CMNT_CHUNK	MACRO	* Length
	C_CMNT
	dc.l	\1
	ENDM

	ENDC	; TUCOMPOSER_TUCOMPOSER_I
