
	XDEF	_DoPlayerIRQ
	XDEF	_LinearFreqTable
	XDEF	_FXTable
	XDEF	_PitchTable
	XDEF	_SETab

	XREF	_Is68060

	IFND	_G2
	MACHINE	MC68020
	ENDC

	include	"exec/types.i"
	include	"exec/libraries.i"
	include	"exec/exec_lib.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/player.i"
	include	"tucomposer/module.i"
	include	"tucomposer/song.i"
	include	"tucomposer/position.i"
	include	"tucomposer/track.i"
	include	"tucomposer/instr.i"
	include	"tucomposer/sample.i"
	include	"tucomposer/synth.i"
	include	"tucomposer/external.i"

RANDOM_CONST	EQU	-1153374675
SLIDE_CONST		EQU	(8363*1712*4)

	SECTION	"DoPlayerIRQ",CODE

_DoPlayerIRQ:
	IFD	NDEBUG
	move.w	#$00f,$dff180
	ENDC
	movem.l	d2-d7/a2-a6,-(sp)
	move.l	48(sp),a6
	move.l	tcb_PlayModule(a6),d0
	beq	NotRefreshSongEnd
	move.l	d0,a5
	move.l	a6,d2
	moveq	#0,d7
	move.l	tcm_ChannelData(a5),a2
	move.l	tcb_PlayMixerAlloc(a6),a3
	move.l	(a3),a6
UpdateNNAChannels:	move.l	d7,d0
	move.l	a2,a0
	move.l	a3,a1
	jsr	_LVOExternalMixerGetChannel(a6)
	lea	pc_PlayerChannelx(a2),a2
	addq.w	#1,d7
	cmp.w	tcm_Channels(a5),d7
	bne.s	UpdateNNAChannels
	move.l	d2,a6
	move.l	tcb_PlaySong(a6),a4
	move.l	tcso_GlobalData(a4),a0
	btst	#PGB_TraceMode,(a0)
	beq.s	NotTracePlay
	subq.w	#1,pg_TraceCount(a0)
	bcc.s	NotTracePlay
	clr.w	pg_TraceCount(a0)
	bra	NotRefreshSongEnd
NotTracePlay:	lea	tcb_ExecList(a6),a2
	move.l	a6,a3
FirstPlayExecLoop:	move.l	(a2),a2
	tst.l	(a2)
	beq.s	FirstPlayExecDone
	btst	#PEHB_Beginning,peh_Flags(a2)
	beq.s	FirstPlayExecLoop
	move.l	peh_Task(a2),d0
	beq.s	FirstPlayExecLoop
	move.l	d0,a1
	move.l	tcso_GlobalData(a4),a0
	btst	#PEHB_SongEnd,peh_Flags(a2)
	beq.s	IgnoreFirstPlayExecSongEnd
	btst	#PGB_SongEnd,(a0)
	beq.s	FirstPlayExecLoop
IgnoreFirstPlayExecSongEnd:	moveq	#0,d0
	move.b	peh_SigBit(a2),d1
	bset	d1,d0
	not.b	d1
	beq.s	FirstDoExecCode
	move.l	4.w,a6
	jsr	_LVOSignal(a6)
	bra.s	FirstPlayExecLoop
FirstDoExecCode:	move.l	peh_Data(a2),-(sp)
	move.l	a4,-(sp)
	move.l	a5,-(sp)
	move.l	a3,-(sp)
	jsr	(a1)
	lea	16(sp),sp
	bra.s	FirstPlayExecLoop
FirstPlayExecDone:	move.l	a3,a6
	move.l	tcso_GlobalData(a4),a3
	tst.b	pg_PlayType(a3)
	bpl.s	NotAddPlayTime
	move.l	pg_Tempo(a3),d0
	move.l	pg_RelativeSpeed(a3),d1
	bsr	MULU64
	move.w	d1,d0
	swap	d0
	move.l	#65536*1000,d4
	move.l	d4,d6
	divul.l	d0,d1:d4
	move.l	d0,d2
	moveq	#0,d0
	bsr	DIVU64
	move.l	pg_PlayTime(a3),d5
	add.l	d0,pg_PlayTimeFrac(a3)
	addx.l	d4,d5
	move.l	d5,pg_PlayTime(a3)
	move.l	pg_Tempo(a3),d2
	divul.l	d2,d1:d6
	moveq	#0,d0
	bsr	DIVU64
	move.l	pg_PlayTics(a3),d2
	add.l	d0,pg_PlayTicsFrac(a3)
	addx.l	d6,d2
	move.l	d2,pg_PlayTics(a3)
NotAddPlayTime:	moveq	#0,d7
	move.l	tcso_ChannelData(a4),a3
ProcessChannels:	move.w	phc_VirtualChannel(a3),d6
	mulu.w	#pc_PlayerChannelx,d6
	move.l	tcm_ChannelData(a5),a2
	add.l	d6,a2
	btst	#PHCB_SetInstr-16,phc_Flags+1(a3)
	beq.s	NotPlayRow
	btst	#PHCB_SetSample-16,phc_Flags+1(a3)
	beq.s	NotPlayRow
	and.l	#~(PHCF_SetInstr|PHCF_SetSample),phc_Flags(a3)
	move.l	phc_Track(a3),-(sp)
	move.l	phc_Effect(a3),-(sp)
	move.l	phc_TempoCounter(a3),-(sp)
	move.w	phc_Row(a3),-(sp)
	move.l	phc_Instrument(a3),phc_Track(a3)
	clr.l	phc_Effect(a3)
	move.w	phc_Sample+2(a3),phc_Row(a3)
	clr.l	phc_Instrument(a3)
	clr.l	phc_Sample(a3)
	bsr	GetEffects
	moveq	#0,d0
	move.w	phc_NoteDelay(a3),d0
	move.l	d0,phc_TempoCounter(a3)
	bsr	GetNote
PlayRowCont:	bsr	RunEffects
	move.w	(sp)+,phc_Row(a3)
	move.l	(sp)+,phc_TempoCounter(a3)
	move.l	(sp)+,phc_Effect(a3)
	move.l	(sp)+,phc_Track(a3)
NotPlayRow:	bclr	#PHCB_SetInstr-16,phc_Flags+1(a3)
	beq.s	NotSetInstr
	move.l	phc_Instrument(a3),a0
	moveq	#0,d2
	move.b	phc_InstrNote(a3),d2
	bpl.s	NotSetSpecialNote
	pea	NotSetSample(pc)
	addq.b	#1,d2
	beq	PlayNoteKill
	cmp.w	pc_HostChannel(a2),d7
	bne	AlreadySustained
	addq.b	#1,d2
	beq	PlayNoteOff
	addq.b	#1,d2
	beq	PlayKeyOff
	addq.b	#1,d2
	beq	PlayHoldDelay
	addq.b	#1,d2
	beq	PlayNoteFade
	rts
NotSetSpecialNote:	divu.w	#NUMNOTES,d2
	move.w	d2,d1
	swap	d2
	bsr	PlayNote
	move.b	phc_SampleNote(a2),pc_Volume(a2)
	clr.b	pc_SubVol(a2)
	bsr	InitNewInstr
	bsr	InitNewSample
NotSetInstr:	bclr	#PHCB_SetSample-16,phc_Flags+1(a3)
	beq	NotSetSample
	move.l	phc_Sample(a3),a1
	move.l	phc_Instrument(a3),d3
	clr.b	phc_DCT(a3)
	clr.b	phc_NNA(a3)
	move.b	tcs_FineTune(a1),phc_FineTune(a3)
	move.l	pc_AutoVibEnv(a2),phc_PrevAutoVibEnv(a3)
	move.l	pc_AutoTremoEnv(a2),phc_PrevAutoTremEnv(a3)
	move.l	pc_AutoPanEnv(a2),phc_PrevAutoPanEnv(a3)
	bsr	TriggerNNA
	move.l	a1,a2
	move.l	phc_Sample(a3),a1
	move.l	tcs_StartOffset(a1),(a2)
	move.w	d6,phc_VirtualChannel(a3)
	move.w	d7,pc_HostChannel(a2)
	clr.l	phc_Instrument(a3)
	move.l	a1,pc_Sample(a2)
	move.l	d3,pc_Frequency(a2)
	move.b	phc_InstrNote(a3),pc_Volume(a2)
	clr.b	pc_SubVol(a2)
	clr.b	phc_InstrNote(a3)
	sub.l	a0,a0
	bsr	InitNewInstr
	lea	tcm_InstrList(a5),a0
GetInstrPtrLoop:	move.l	(a0),a0
	tst.l	(a0)
	beq.s	GetInstrPtrDone
	lea	tci_Samples(a0),a1
GetSmpPtrLoop:	move.l	(a1),a1
	tst.l	(a1)
	beq.s	GetInstrPtrLoop
	cmp.l	phc_Sample(a3),a1
	bne.s	GetSmpPtrLoop
	move.l	a0,phc_Instrument(a3)
GetInstrPtrDone:	move.l	phc_Instrument(a3),pc_Instrument(a2)
	move.l	phc_Sample(a3),a1
	bsr	InitNewSample
NotSetSample:	move.l	tcso_GlobalData(a4),a0
	btst	#PGB_NoProcPattern,(a0)
	bne.s	ChannelDone
	tst.w	phc_Tempo(a3)
	beq.s	ChannelDone
ReScanRow:	bsr	ProcessRow
	bsr	GetEffects
	cmp.w	pc_HostChannel(a2),d7
	bne.s	NoResetTremolo
	btst	#PHCB_Vibrato-8,phc_Flags+2(a3)
	bne.s	NoResetVibrato
	move.l	phc_VibratoSlideValue(a3),d0
	clr.l	phc_VibratoSlideValue(a3)
	sub.l	d0,pc_Frequency(a2)
NoResetVibrato:	tst.b	phc_Flags+2(a3)
	bmi.s	NoResetTremolo
	moveq	#0,d1
	move.b	pc_Volume(a2),d1
	move.w	phc_TremoloSlideValue(a3),d0
	clr.w	phc_TremoloSlideValue(a3)
	sub.w	d0,d1
	bpl.s	TrmVolDnOk
	moveq	#0,d1
TrmVolDnOk:	cmp.w	#255,d1
	blo.s	TrmVolUpOk
	moveq	#-1,d1
TrmVolUpOk:	move.b	d1,pc_Volume(a2)
NoResetTremolo:	bsr	GetNote
ChannelDone:	clr.w	phc_NumVirtual(a3)
	addq.w	#1,d7
	lea	phc_NextHostChannel(a3),a3
	cmp.w	tcso_Channels(a4),d7
	bne	ProcessChannels
	moveq	#0,d7
	move.l	tcso_ChannelData(a4),a3
ProcessEffects:	move.l	tcso_GlobalData(a4),a0
	btst	#PGB_NoProcPattern,(a0)
	bne.s	ChannelFXDone
	tst.w	phc_Tempo(a3)
	beq.s	ChannelFXDone
	move.w	phc_VirtualChannel(a3),d6
	mulu.w	#pc_PlayerChannelx,d6
	move.l	tcm_ChannelData(a5),a2
	add.l	d6,a2
	bsr	RunEffects
ChannelFXDone:	addq.w	#1,d7
	lea	phc_NextHostChannel(a3),a3
	cmp.w	tcso_Channels(a4),d7
	bne.s	ProcessEffects
	moveq	#0,d6
	moveq	#0,d7
	move.l	tcm_ChannelData(a5),a2
CalcFinalOutput:	tst.b	pc_Flags(a2)
	bpl.s	NotJustAlloc
	bclr	#MSB_Play,ms_Flags(a2)
NotJustAlloc:	tst.b	ms_Flags(a2)
	bpl	NotCalcNoPlaying
	move.w	pc_HostChannel(a2),d0
	mulu.w	#phc_NextHostChannel,d0
	move.l	tcso_ChannelData(a4),a3
	add.l	d0,a3
	lea	pc_VolEnvelope(a2),a0
	moveq	#1,d4
	tst.w	pes_EnvelopeTempo(a0)
	beq.s	NoPlayVolEnv
	move.w	#$8000,d5
	bsr	RunEnvelope
	tst.w	pc_VolEnvelope+pes_EnvelopeTempo(a2)
	bne.s	NoPlayVolEnv
	lsr.w	#8,d0
	beq	TurnNoteOff
	bset	#PCB_Fading,pc_Flags+1(a2)
NoPlayVolEnv:	moveq	#0,d5
	lea	pc_PanEnvelope(a2),a0
	bsr	RunEnvelope
	lea	pc_SlideEnvelope(a2),a0
	bsr	RunEnvelope
	btst	#PCB_PortaSlideEnv-8,pc_Flags(a2)
	beq.s	SlideEnvTranspose
	move.l	pc_SlideEnvelopeFrequency(a2),d2
	move.l	pc_Frequency(a2),a1
	add.l	d2,pc_Frequency(a2)
	move.l	pc_Frequency(a2),d5
	beq	SlideEnvDone
	moveq	#0,d2
	move.w	d0,d2
	bmi.s	ChkEnvSlideDn
	move.l	d2,d3
	lea	LinearSlideUp(pc),a0
	btst	#PCB_LinearSlideEnv-8,pc_Flags(a2)
	bne.s	UpdateSlideEnv
	lea	AmigaSlideUp(pc),a0
	bra.s	UpdateSlideEnv
ChkEnvSlideDn:	neg.l	d2
	move.l	d2,d3
	lea	LinearSlideDn(pc),a0
	btst	#PCB_LinearSlideEnv-8,pc_Flags(a2)
	bne.s	UpdateSlideEnv
	lea	AmigaSlideDn(pc),a0
UpdateSlideEnv:	jsr	(a0)
	sub.l	d0,a1
	move.l	a1,d0
	add.l	d0,pc_SlideEnvelopeFrequency(a2)
	bra.s	SlideEnvDone
SlideEnvTranspose:	move.b	pc_SlideEnvelope+pes_EnvelopeValue(a2),d1
	extb.l	d1
	moveq	#12,d0
	moveq	#0,d2
	move.b	pc_SlideEnvelope+pes_EnvelopeValue+1(a2),d2
	divs.w	d0,d1
	swap	d1
	tst.w	d1
	bpl.s	PlaySlideValOk
	swap	d1
	subq.w	#1,d1
	swap	d1
	add.w	d0,d1
	neg.w	d2
PlaySlideValOk:	lea	([tcb_FrequencyTable.w,a6],d1.w*4),a0
	move.l	(a0)+,d0
	move.l	(a0),d3
	sub.l	d0,d3
	muls.w	d2,d3
	asr.l	#8,d3
	add.w	d3,d0
	swap	d1
	tst.w	d1
	bpl.s	ShiftSlideFreqLeft
	neg.w	d1
	lsr.l	d1,d0
	bra.s	ShiftSlideFreqDone
ShiftSlideFreqLeft:	lsl.l	d1,d0
ShiftSlideFreqDone:	move.l	pc_SlideEnvelopeFrequency(a2),d1
	move.l	pc_Frequency(a2),d2
	add.l	d2,d1
	bsr	MULU64
	move.w	d1,d0
	swap	d0
	sub.l	d0,d2
	add.l	d2,pc_SlideEnvelopeFrequency(a2)
	move.l	d0,pc_Frequency(a2)
SlideEnvDone:	btst	#PCB_Fading,pc_Flags+1(a2)
	beq.s	NotDoFadeOut
	move.w	pc_FadeOut(a2),d0
	sub.w	d0,pc_FadeOutCount(a2)
	bhi.s	NotDoFadeOut
TurnNoteOff:	clr.b	ms_Flags(a2)
	bra	NotCalcNoPlaying
NotDoFadeOut:	moveq	#0,d4
	move.b	pc_AutoVibRate(a2),d4
	moveq	#0,d5
	lea	pc_AutoVibEnv(a2),a0
	bsr	RunEnvelope
	move.w	pc_AutoVibSweep(a2),d4
	move.b	pc_AutoVibDepth(a2),d5
	lsl.w	#8,d5
	moveq	#0,d3
	move.w	pc_AutoVibCount(a2),d3
	add.l	d4,d3
	cmp.l	d5,d3
	bls.s	AutoVibDepthOk
	move.l	d5,d3
AutoVibDepthOk:	move.w	d3,pc_AutoVibCount(a2)
	lsr.w	#8,d3
	neg.w	d0
	muls.w	d3,d0
	beq.s	NoAutoVibrato
	asr.l	#7-2,d0
	move.l	pc_AutoVibFrequency(a2),d2
	move.l	pc_Frequency(a2),a1
	sub.l	d2,pc_Frequency(a2)
	move.l	pc_Frequency(a2),d5
	beq.s	NoAutoVibrato
	move.l	d0,d2
	bmi.s	ChkAVibSlideUp
	move.l	d2,d3
	lea	LinearSlideDn(pc),a0
	btst	#PCB_LinearFreqAutoVib-8,pc_Flags(a2)
	bne.s	UpdateAutoVib
	lea	AmigaSlideDn(pc),a0
	bra.s	UpdateAutoVib
ChkAVibSlideUp:	neg.l	d2
	move.l	d2,d3
	lea	LinearSlideUp(pc),a0
	btst	#PCB_LinearFreqAutoVib-8,pc_Flags(a2)
	bne.s	UpdateAutoVib
	lea	AmigaSlideUp(pc),a0
UpdateAutoVib:	jsr	(a0)
	sub.l	d0,a1
	move.l	a1,d0
	sub.l	d0,pc_AutoVibFrequency(a2)
NoAutoVibrato:	move.l	pc_Sample(a2),a0
	move.l	tcs_Synth(a0),d0
	beq.s	NotExecuteSynth
	moveq	#0,d4
	bsr	ExecuteSynth
	moveq	#1,d4
	bsr	ExecuteSynth
	moveq	#2,d4
	bsr	ExecuteSynth
	moveq	#3,d4
	bsr	ExecuteSynth
NotExecuteSynth:	tst.b	ms_BitDepth(a2)
	beq.s	CheckInitEmptyPlay
	tst.l	ms_SampleData(a2)
	bne.s	NotInitEmptySmpData
CheckInitEmptyPlay:	tst.b	ms_Flags(a2)
	bpl.s	NotInitEmptySmpData
	lea	EmptyWaveform(pc),a0
	move.l	a2,a1
	addq.l	#ms_SampleLen,a1
	moveq	#0,d0
	moveq	#64,d1
	lsl.l	#2,d1
	move.l	d1,(a1)+
	move.l	a0,(a1)
	addq.l	#ms_Repeat-ms_SampleData,a1
	move.l	d0,(a1)+
	move.l	d1,(a1)+
	move.l	d0,(a1)+
	move.l	d0,(a1)+
	move.w	#8*256|MSF_Loop|MSF_Play,(a1)
NotInitEmptySmpData:	move.l	pc_Frequency(a2),d0
	move.l	pc_Sample(a2),a0
	movem.l	tcs_LowerRateLimit(a0),d1-d2
	cmp.l	d1,d0
	bhs.s	LowerLimitOk
	move.l	d1,d0
LowerLimitOk:	cmp.l	d2,d0
	bls.s	HigherLimitOk
	move.l	d2,d0
HigherLimitOk:	move.l	d0,pc_Frequency(a2)
	beq	TurnNoteOff
	move.l	tcso_GlobalData(a4),a0
	move.l	pg_RelativePitch(a0),d1
	bsr	MULU64
	move.w	d1,d0
	swap	d0
	move.l	d0,ms_SampleRate(a2)
	beq	TurnNoteOff
	btst	#TCSOCB_GlobalNewOnly,tcso_CompFlags(a4)
	bne.s	NotUpdateGlobalVol
	move.l	pg_GlobalVolume(a0),pc_GlobalVolume(a2)
NotUpdateGlobalVol:	moveq	#0,d0
	move.b	pc_Volume(a2),d0
	addq.w	#1,phc_NumVirtual(a3)
	addq.w	#1,d6
	tst.b	pc_Flags+1(a2)
	bmi.s	RunBackChan
	cmp.w	phc_VirtualChannel(a3),d7
	bne.s	RunBackChan
	btst	#PHCB_TremorExec-8,phc_Flags+2(a3)
	beq.s	RunBackChan
	btst	#PHCB_TremorOff-8,phc_Flags+2(a3)
	beq.s	RunBackChan
	moveq	#0,d0
RunBackChan:	moveq	#0,d2
	move.b	phc_TrackVolume(a3),d2
	mulu.w	d2,d0
	mulu.w	pc_InstrVolume(a2),d0
	move.w	pc_VolEnvelope+pes_EnvelopeValue(a2),d2
	lsr.w	#8,d2
	moveq	#0,d1
	move.b	pc_GlobalVolume(a2),d1
	mulu.w	d1,d2
	mulu.w	pc_FadeOutCount(a2),d2
	move.l	d2,d1
	bsr	MULU64
	move.l	#-66716671,d2			* (= 255*255*255*255) PhxAss bugfix.
	bsr	DIVU64
	divu.l	#65535*255,d0
	move.b	d0,pc_FinalVolume(a2)
	move.b	d0,ms_Volume(a2)
	moveq	#0,d1
	move.w	#128,d3
	bclr	#PCB_Surround,pc_Flags+1(a2)
	bclr	#MSB_Surround,ms_Flags(a2)
	btst	#PCB_SmpSurPan,pc_Flags+1(a2)
	beq.s	NotUseSmpSurPan
	moveq	#PCF_Surround,d1
NotUseSmpSurPan:	move.b	pc_Panning(a2),d0
	btst	#PCB_TrackPan,pc_Flags+1(a2)
	beq.s	NotUseTrackPan
	move.b	phc_TrackPanning(a3),d0
	moveq	#0,d1
	btst	#PHCB_TrackSurPan,phc_Flags+3(a3)
	beq.s	NotUseTrackPan
	moveq	#PCF_Surround,d1
NotUseTrackPan:	btst	#PHCB_ChannelSurPan,phc_Flags+3(a3)
	beq.s	NotChanSurPan
	moveq	#PCF_Surround,d1
NotChanSurPan:	or.w	d1,pc_Flags(a2)
	btst	#TCSOB_Mono,tcso_Flags(a4)
	bne.s	NotMonoSurround
	or.b	d1,ms_Flags(a2)
NotMonoSurround:	cmp.b	#255,d0
	bne.s	NotRightPan
	addq.w	#1,d0
NotRightPan:	move.w	d0,d1
	sub.w	d3,d0
	bpl.s	NotAbsPan
	neg.w	d0
NotAbsPan:	move.w	d3,d2
	sub.w	d0,d2
	move.w	pc_PanEnvelope+pes_EnvelopeValue(a2),d0
	asr.w	#8,d0
	cmp.b	#127,d0
	bne.s	NotRightPanEnv
	addq.b	#1,d0
NotRightPanEnv:	muls.w	d0,d2
	asr.w	#7,d2
	add.w	d1,d2
	move.w	d3,d0
	sub.w	d2,d0
	moveq	#0,d2
	move.b	phc_ChannelPanning(a3),d2
	cmp.b	#255,d2
	bne.s	NotRightTPan
	addq.w	#1,d2
NotRightTPan:	sub.w	d3,d2
	muls.w	d0,d2
	asr.w	#7,d2
	add.w	d3,d2
	move.w	d2,d1
	cmp.w	#256,d1
	bne.s	FinalPanOk
	moveq	#-1,d1
FinalPanOk:	move.b	d1,pc_FinalPanning(a2)
	move.w	d3,d0
	btst	#TCSOB_Mono,tcso_Flags(a4)
	bne.s	OutputPanning
	btst	#PCB_GlobalSurPan,pc_Flags+1(a2)
	beq.s	NotGlobalSurPan
	bset	#MSB_Surround,ms_Flags(a2)
NotGlobalSurPan:	sub.w	d2,d0
	moveq	#0,d2
	move.b	pc_GlobalPanning(a2),d2
	cmp.b	#255,d2
	bne.s	NotRightGPan
	addq.w	#1,d2
NotRightGPan:	sub.w	d3,d2
	muls.w	d2,d0
	asr.w	#7,d0
	add.w	d3,d0
	cmp.w	#256,d0
	bne.s	OutputPanning
	moveq	#-1,d0
OutputPanning:	move.b	d0,ms_Panning(a2)
	move.l	d7,d0
	move.l	a2,a0
	move.l	a6,d2
	move.l	tcb_PlayMixerAlloc(a6),a1
	move.l	(a1),a6
	jsr	_LVOExternalMixerSetChannelVolPanPitch(a6)
	move.l	d2,a6
NotCalcNoPlaying:	move.l	d7,d0
	move.l	a2,a0
	move.l	a6,d2
	move.l	tcb_PlayMixerAlloc(a6),a1
	move.l	(a1),a6
	jsr	_LVOExternalMixerSetChannelPosRepFlags(a6)
	move.l	d2,a6
	lea	pc_PlayerChannelx(a2),a2
	addq.w	#1,d7
	cmp.w	tcm_Channels(a5),d7
	bne	CalcFinalOutput
	move.l	tcso_GlobalData(a4),a0
	move.w	d6,pg_Channels(a0)
	cmp.w	pg_MaxChannels(a0),d6
	bls.s	NotPlaying
	move.w	d6,pg_MaxChannels(a0)
NotPlaying:	move.w	tcso_Channels(a4),d7
	move.l	tcso_ChannelData(a4),a3
CheckSongEndLoop:	tst.b	phc_Flags(a3)
	bpl.s	CheckSongEndDone
	lea	phc_NextHostChannel(a3),a3
	subq.w	#1,d7
	bne.s	CheckSongEndLoop
	bset	#PGB_SongEnd,(a0)
CheckSongEndDone:	lea	tcb_ExecList(a6),a2
	move.l	a6,a3
PlayExecLoop:	move.l	(a2),a2
	tst.l	(a2)
	beq.s	PlayExecDone
	btst	#PEHB_Beginning,peh_Flags(a2)
	bne.s	PlayExecLoop
	move.l	peh_Task(a2),d0
	beq.s	PlayExecLoop
	move.l	d0,a1
	move.l	tcso_GlobalData(a4),a0
	btst	#PEHB_SongEnd,peh_Flags(a2)
	beq.s	IgnorePlayExecSongEnd
	btst	#PGB_SongEnd,(a0)
	beq.s	PlayExecLoop
IgnorePlayExecSongEnd:	moveq	#0,d0
	move.b	peh_SigBit(a2),d1
	bset	d1,d0
	not.b	d1
	beq.s	DoExecCode
	move.l	4.w,a6
	jsr	_LVOSignal(a6)
	bra.s	PlayExecLoop
DoExecCode:	move.l	peh_Data(a2),-(sp)
	move.l	a4,-(sp)
	move.l	a5,-(sp)
	move.l	a3,-(sp)
	jsr	(a1)
	lea	16(sp),sp
	bra.s	PlayExecLoop
PlayExecDone:	move.l	tcso_GlobalData(a4),a0
	btst	#PGB_SongEnd,(a0)
	beq.s	NotRefreshSongEnd
	move.l	tcso_ChannelData(a4),a3
	tst.b	phc_Flags(a3)
	bpl.s	NotRefreshSongEnd
	move.l	tcso_Position(a4),a2
	move.w	tcso_Channels(a4),d0
	move.l	tcso_GlobalData(a4),a1
ClearSongEndMarkLoop:	tst.w	phc_Tempo(a3)
	beq.s	NotClearSongEndMark
	bclr	#PHCB_SongEnd-24,phc_Flags(a3)
NotClearSongEndMark:	move.l	a2,a0
ClearOrderMarkLoop:	move.l	(a0),a0
	tst.l	(a0)
	beq.s	ClearOrderMarkDone
	cmp.l	(a3),a0
	beq.s	ClearOrderMarkLoop
	clr.w	tcol_Played(a0)
	bra.s	ClearOrderMarkLoop
ClearOrderMarkDone:	lea	tco_NextOrderx(a2),a2
	lea	phc_NextHostChannel(a3),a3
	subq.w	#1,d0
	bne.s	ClearSongEndMarkLoop
NotRefreshSongEnd:	movem.l	(sp)+,d2-d7/a2-a6
	IFD	NDEBUG
	move.w	#$aaa,$dff180
	ENDC
Nop:	rts
ProcessRow:	moveq	#0,d5
	bclr	#PHCB_TremorExec-8,phc_Flags+2(a3)
	move.l	phc_TempoCounter(a3),d0
	addq.l	#1,d0
	moveq	#0,d1
	move.w	phc_FinePatternDelay(a3),d1
	moveq	#0,d2
	move.w	phc_Tempo(a3),d2
	add.l	d2,d1
	cmp.l	d1,d0
	blo.s	NotNextRow
	moveq	#0,d0
NotNextRow:	move.l	d0,phc_TempoCounter(a3)
	bne	PlayRowDone
	moveq	#0,d1
	cmp.w	pc_HostChannel(a2),d7
	bne.s	NotResetArp
	move.l	phc_ArpeggioFrequency(a3),d3
	move.l	d1,phc_ArpeggioFrequency(a3)
	add.l	d3,pc_Frequency(a2)
NotResetArp:	and.l	#~(PHCF_ExecFX|PHCF_TonePorta|PHCF_SetTranspose|PHCF_Vibrato|PHCF_Tremolo),phc_Flags(a3)
	lea	phc_EffectsUsed(a3),a0
	move.l	d1,(a0)+
	move.l	d1,(a0)+
	move.l	d1,(a0)+
	move.l	d1,(a0)
	move.l	d1,phc_Effect(a3)
	move.b	d1,phc_ArpeggioTick(a3)
	move.w	d1,phc_NoteDelay(a3)
	move.w	d1,phc_RetrigTickCount(a3)
	move.w	phc_PatternDelay(a3),d2
	beq.s	NoPatternDelay
	move.w	phc_PatternDelayCount(a3),d3
	addq.w	#1,phc_PatternDelayCount(a3)
	cmp.w	d3,d2
	bhi	PlayRowDone
NoPatternDelay:	move.l	d1,phc_PatternDelayCount(a3)
	move.w	phc_Row(a3),d1
	bclr	#PHCB_PattLoop-16,phc_Flags+1(a3)
	beq.s	NotLoopPattern
	movem.l	(a3),a0-a1
	bra	LoopToRow
NotLoopPattern:	bclr	#PHCB_PattLoopJmp-16,phc_Flags+1(a3)
	bclr	#PHCB_ChgPattern-16,phc_Flags+1(a3)
	beq.s	NotChangePattern
	move.l	(a3),a0
	lea	tcso_TrackList(a4),a1
	move.w	phc_ChgPattern(a3),d0
FindChgPattern:	move.l	(a1),a1
	tst.l	(a1)
	beq.s	NotChangePattern
	dbra	d0,FindChgPattern
	move.l	a1,phc_Track(a3)
	bra	LoopToRow
NotChangePattern:	btst	#PHCB_PatternBreak,phc_Flags+3(a3)
	bne.s	GetNewPattern
	btst	#PHCB_Backwards,phc_Flags+3(a3)
	beq.s	ForwardPlay
	subq.w	#1,d1
	bcs.s	GetNewPattern
	bra	PlayFromTrackEnd
ForwardPlay:	addq.w	#1,d1
	cmp.l	phc_MaxRow(a3),d1
	blo	PlayFromTrackEnd
GetNewPattern:	move.l	tcso_GlobalData(a4),a0
	btst	#PGB_PlayPattern,(a0)
	move.l	(a3),a0
	beq.s	CheckNextEmptyOrder
	move.l	phc_Track(a3),a1
	bra	LoopToRow
DisableChannel:	bset	#PHCB_SongEnd-24,phc_Flags(a3)
	clr.w	phc_Tempo(a3)
PlayRowDone:	rts
CheckNextEmptyOrder:	move.l	(a0),a0
	tst.l	(a0)
	bne.s	PlayOrderOk
SongEndFound:	bset	#PHCB_SongEnd-24,phc_Flags(a3)
	move.l	tcso_Position(a4),a0
	move.l	d7,d0
	lsl.l	#5,d0
	add.l	d0,a0
	move.w	tco_RepStart(a0),d1
ScanValidOrderLoop:	move.l	(a0),a0
	tst.l	(a0)
	beq.s	DisableChannel
	dbra	d1,ScanValidOrderLoop
	bftst	tcol_Flags-3(a0){32-2-TCOLB_EndOrder:2}
	bne.s	DisableChannel
ChannelStateOk:	moveq	#0,d1
	move.l	tcso_GlobalData(a4),a1
	btst	#PGB_PlayOnce,(a1)
	beq.s	CheckOrderOnceFlag
	btst	#TCOLB_NotInOnce,tcol_Flags(a0)
	beq.s	CheckOrderTrack
	bra.s	DisableChannel
CheckOrderOnceFlag:	btst	#TCOLB_NotInRepeat,tcol_Flags(a0)
	bne.s	DisableChannel
CheckOrderTrack:	move.l	tcol_Track(a0),d0
	beq.s	ScanValidOrderLoop
PlayOrderOk:	move.l	tcso_GlobalData(a4),a1
	btst	#TCOLB_EndOrder,tcol_Flags(a0)
	bne.s	SongEndFound
	btst	#TCOLB_EndSong,tcol_Flags(a0)
	beq.s	SongEndNotFound
	btst	#PGB_PlayOnce,(a1)
	beq.s	SongEndFound
	bra.s	DisableChannel
SongEndNotFound:	btst	#PGB_PlayOnce,(a1)
	beq.s	CheckOrderOnceFlag2
	btst	#TCOLB_NotInOnce,tcol_Flags(a0)
	beq.s	CheckOrderTrack2
	bra.s	CheckNextEmptyOrder
CheckOrderOnceFlag2:	btst	#TCOLB_NotInRepeat,tcol_Flags(a0)
	bne	CheckNextEmptyOrder
CheckOrderTrack2:	move.l	tcol_Track(a0),d0
	beq	CheckNextEmptyOrder
	move.l	a0,(a3)
	move.l	d0,phc_Track(a3)
	move.l	tcso_GlobalData(a4),a1
	move.b	(a1),d2
	lea	tcol_Played(a0),a1
	move.w	phc_GoSubDepth(a3),d1
	cmp.w	(a1),d1
	bhs.s	NotAlreadyPlayed
	bset	#PHCB_SongEnd-24,phc_Flags(a3)
	btst	#PGB_PlayOnce,d2
	beq.s	NotAlreadyPlayed
	clr.w	phc_Tempo(a3)
NotAlreadyPlayed:	addq.w	#1,(a1)
	bclr	#PHCB_PattReset-16,phc_Flags+1(a3)
	move.l	d0,a1
LoopToRow:	moveq	#0,d0
	move.w	tct_Length(a1),d0
	move.w	tcol_FirstRow(a0),d1
	move.w	tcol_LastRow(a0),d2
	bclr	#PHCB_PatternBreak,phc_Flags+3(a3)
	beq.s	NoPattBreak
	move.w	phc_BreakRow(a3),d1
	cmp.w	d1,d0
	bhs.s	NoPattBreak
	move.w	tcol_FirstRow(a0),d1
NoPattBreak:	cmp.w	d1,d0
	blo	CheckNextEmptyOrder
	cmp.w	d2,d0
	blo.s	EndRowOk
	move.w	d2,d0
EndRowOk:	move.l	d0,d2
	addq.l	#1,d0
	move.l	d0,phc_MaxRow(a3)
	move.w	tcol_Tempo(a0),d0
	beq.s	NotSetPosTempo
	move.w	d0,phc_Tempo(a3)
NotSetPosTempo:	btst	#PHCB_Backwards,phc_Flags+3(a3)
	beq.s	PlayFromTrackEnd
	sub.l	d1,d2
	move.w	d2,d1
PlayFromTrackEnd:	move.w	d1,phc_Row(a3)
	move.l	phc_Track(a3),a1
	move.l	tct_Data(a1),a1
	move.l	d1,d0
	lsl.l	#4,d0
	add.l	d0,a1
	cmp.w	#NOTE_END,(a1)
	bne	PlayRowDone
	addq.w	#1,d5
	bne	GetNewPattern
	bra	DisableChannel
GetTonePitch:	moveq	#12,d0
	ext.l	d1
	divs.w	d0,d1
	swap	d1
	tst.w	d1
	bpl.s	PlayNoteValOk
	swap	d1
	subq.w	#1,d1
	swap	d1
	add.w	d0,d1
PlayNoteValOk:	move.b	phc_FineTune(a3),d2
	bpl.s	FineTunePosOk
	add.b	#$80,d2
	subq.w	#1,d1
FineTunePosOk:	ext.w	d2
	lea	([tcb_FrequencyTable.w,a6],d1.w*4),a0
	move.l	pc_Sample(a2),a1
	move.l	(a0)+,d0
	move.l	(a0),d3
	sub.l	d0,d3
	muls.w	d2,d3
	asr.l	#7,d3
	add.l	d3,d0
	moveq	#1,d2
	swap	d2
	swap	d1
	subq.w	#4,d1
	bpl.s	ShiftFreqLeft
	neg.w	d1
	lsl.l	d1,d2
	move.l	tcs_Rate(a1),d1
	bsr	MULU64
	bra	DIVU64
ShiftFreqLeft:	lsl.l	d1,d0
	move.l	tcs_Rate(a1),d1
	bsr	MULU64
	bra	DIVU64
Arpeggio:	bne.s	NotUseArpMem
	move.w	phc_ArpeggioFirst(a3),d2
NotUseArpMem:	move.w	d2,phc_ArpeggioFirst(a3)
	moveq	#0,d1
	move.b	phc_ArpeggioTick(a3),d0
	beq.s	ArpeggioDone
	subq.w	#1,d0
	beq.s	SecondArpeggio
	subq.b	#3,phc_ArpeggioTick(a3)
	move.b	d2,d1
	bra.s	ArpeggioDone
SecondArpeggio:	lsr.w	#8,d2
	move.b	d2,d1
ArpeggioDone:	cmp.w	pc_HostChannel(a2),d7
	bne.s	NotArpHostChan
	extb.l	d1
	moveq	#12,d0
	divs.w	d0,d1
	swap	d1
	tst.w	d1
	bpl.s	PlayArpValOk
	swap	d1
	subq.w	#1,d1
	swap	d1
	add.w	d0,d1
PlayArpValOk:	move.l	([tcb_FrequencyTable.w,a6],d1.w*4),d0
	move.l	pc_Frequency(a2),d3
	move.l	d3,d4
	add.l	phc_ArpeggioFrequency(a3),d3
	swap	d1
	moveq	#1,d2
	swap	d2
	tst.w	d1
	bpl.s	ShiftArpFreqLeft
	neg.w	d1
	lsl.l	d1,d2
	move.l	d3,d1
	bsr	MULU64
	bra.s	ShiftArpFreqDone
ShiftArpFreqLeft:	lsl.l	d1,d0
	move.l	d3,d1
	bsr	MULU64
ShiftArpFreqDone:	bsr	DIVU64
	sub.l	d0,d4
	add.l	d4,phc_ArpeggioFrequency(a3)
	move.l	d0,pc_Frequency(a2)
NotArpHostChan:	addq.b	#1,phc_ArpeggioTick(a3)
	rts
GetKeyTableNote:	mulu.w	#12,d1
	add.w	d2,d1
GetKeyTable:	tst.l	phc_Instrument(a3)
	bne.s	NotGetNNA
	move.b	tci_NNA(a0),phc_NNA(a3)
NotGetNNA:	move.b	d1,phc_InstrNote(a3)
	move.b	d1,phc_SampleNote(a3)
	move.l	a0,phc_Instrument(a3)
	move.l	tci_KeyboardDefs(a0),a1
	moveq	#1,d0
	move.l	a1,d5
	beq.s	NotPlayKeyDef
	lea	-4(a1,d1.w*4),a1
	move.b	tcik_Octave_C_0(a1),d1
	and.w	#$7f,d1
	mulu.w	#12,d1
	move.b	tcik_Note_C_0(a1),d2
	add.w	d2,d1
	move.b	d1,phc_SampleNote(a3)
	move.w	tcik_Sample_C_0(a1),d0
	beq.s	CheckPrevSample
NotPlayKeyDef:	btst	#TCICB_SeparateSamples,tci_CompFlags(a0)
	bne.s	GetSepSample
	lea	tci_Samples(a0),a1
GetSample:	move.l	(a1),a1
	tst.l	(a1)
	beq.s	GetKeyTableDone
	subq.w	#1,d0
	bne.s	GetSample
	bra.s	SetSample
GetKeyTableDone:	moveq	#0,d0
	rts
CheckPrevSample:	move.l	phc_Sample(a3),a1
	btst	#TCICB_PrevSample,tci_CompFlags(a0)
	beq.s	GetKeyTableDone
	move.l	a1,d0
	beq.s	GetKeyTableDone
	bra.s	SetSample
GetSepSample:	lea	tcm_InstrList(a5),a1
GetSepSmp:	move.l	(a1),a1
	tst.l	(a1)
	beq.s	GetKeyTableDone
	subq.w	#1,d0
	bne.s	GetSepSmp
	move.l	tci_Samples(a1),a1
	tst.l	(a1)
	beq.s	GetKeyTableDone
SetSample:	move.l	a1,phc_Sample(a3)
	move.b	tcs_Transpose(a1),d2
	btst	#PHCB_SetTranspose-8,phc_Flags+2(a3)
	beq.s	NotSetTranspose
	move.b	phc_Transpose(a3),d2
NotSetTranspose:	ext.w	d2
	add.w	d2,d1
	btst	#TCIB_NoTranspose,tci_Flags(a0)
	bne.s	NotAddOrderTransp
	move.l	(a3),a0
	move.b	tcol_Transpose(a0),d2
	ext.w	d2
	add.w	d2,d1
NotAddOrderTransp:	move.l	phc_Track(a3),a0
	move.b	tct_Transpose(a0),d2
	ext.w	d2
	add.w	d2,d1
	subq.w	#1,d1
	moveq	#1,d0
	rts
InitNewInstr:	move.l	phc_Instrument(a3),a0
	move.l	a0,d1
	beq.s	NotSetGlobalInstrVolume
	moveq	#0,d0
	move.b	tcs_GlobalVolume(a1),d0
	moveq	#0,d4
	move.b	tci_GlobalVolume(a0),d4
	mulu.w	d0,d4
	move.l	d4,d2
	mulu.w	tci_VolumeSwing(a0),d4
	lsr.l	#8,d4
	move.l	d4,d5
	add.l	d5,d5
	addq.l	#1,d5
	move.l	tcb_RandomSeed(a6),d1
	muls.l	#RANDOM_CONST,d1
	addq.l	#1,d1
	move.l	d1,tcb_RandomSeed(a6)
	move.l	d5,d0
	bsr	MULU64
	exg	d0,d1
	sub.l	d4,d2
	add.l	d2,d0
	bpl.s	VolSwingLowValOk
	moveq	#0,d0
VolSwingLowValOk:	move.l	#255*255,d1
	cmp.l	d1,d0
	bls.s	VolSwingHiValOk
	move.l	d1,d0
	bra.s	VolSwingHiValOk
NotSetGlobalInstrVolume:	moveq	#0,d0
	move.b	tcs_GlobalVolume(a1),d0
	mulu.w	#255,d0
VolSwingHiValOk:	move.w	d0,pc_InstrVolume(a2)
	move.l	([tcso_GlobalData.w,a4],pg_GlobalVolume.w),pc_GlobalVolume(a2)
	move.l	a0,d0
	beq.s	NotSetInstrFadeOut
	move.w	tci_FadeOut(a0),pc_FadeOut(a2)
	move.w	#FADE_OUT_START,pc_FadeOutCount(a2)
	move.b	tci_NNA(a0),phc_NNA(a3)
NotSetInstrFadeOut:	movem.l	d6/a1/a5-a6,-(sp)
	movem.l	tcs_VibratoSweep(a1),d0-d2
	movem.l	d0-d2,pc_AutoVibSweep(a2)
	moveq	#0,d1
	move.l	d1,pc_SlideEnvelopeFrequency(a2)
	move.l	d1,pc_AutoVibCount(a2)
	move.w	d1,pc_AutoPanCount(a2)
	and.w	#PCF_Allocated,pc_Flags(a2)
	move.l	d1,phc_VibratoSlideValue(a3)
	move.w	d1,phc_TremoloSlideValue(a3)
	move.l	d1,pc_AutoVibFrequency(a2)
	move.l	d1,pc_AutoTremoVolume(a2)
	bclr	#PCB_LinearFreqAutoVib-8,pc_Flags(a2)
	tst.b	tcs_EnvProcFlags(a1)
	bpl.s	AutoVibratoIsLinear
	bset	#PCB_LinearFreqAutoVib-8,pc_Flags(a2)
AutoVibratoIsLinear:	bfextu	tci_Flags-3(a0){32-2-TCIB_PortaSlideEnv:2},d1
	bfins	d1,pc_Flags(a2){16-2-PCB_PortaSlideEnv:2}
	moveq	#12-1,d6
	lea	AssignEnvTab(pc),a5
	move.l	a0,a6
AssignEnvsLoop:	move.w	(a5)+,d0
	move.l	a6,d1
	beq.s	NotAssignInstrEnv
	jsr	-2(a5,d0.w)
	movem.w	tci_EnvUsageFlags(a6),d1-d4
	beq.s	AlwaysInitFirstEnv
	btst	d6,d1
	bne.s	NotInitEnv
AlwaysInitFirstEnv:	move.l	a0,(a1)
	beq.s	NotInitEnv
	moveq	#0,d0
	moveq	#0,d1
	moveq	#0,d5
	btst	d6,d2
	beq.s	NotFirstAddEnv
	moveq	#PESF_FirstAdd,d5
NotFirstAddEnv:	btst	d6,d3
	beq.s	NotRetrigEnv
	addq.b	#PESF_NoRetrig,d5
	move.w	pes_EnvelopePos(a1),d0
	move.w	pes_EnvelopeValue(a1),d1
NotRetrigEnv:	btst	d6,d4
	beq.s	NotRandomAssignEnv
	addq.b	#PESF_Random,d5
NotRandomAssignEnv:	move.w	tci_EnvRndDelayFlags(a6),d2
	btst	d6,d2
	beq.s	NotRndDelayEnv
	addq.b	#PESF_RndDelay,d5
NotRndDelayEnv:	move.w	d1,pes_EnvelopeValue(a1)
	move.w	tcie_Tempo(a0),pes_EnvelopeTempo(a1)
	clr.w	pes_EnvelopeTempoCount(a1)
	clr.l	pes_EnvelopeSustainCounted(a1)
	movem.l	tcie_SustainStart(a0),d1-d4
	movem.l	d1-d4,pes_EnvelopeSustainStart(a1)
	move.b	tcie_Flags+1(a0),pes_EnvelopeRepFlags(a1)
	bsr	SetEnvelope
	or.b	d5,pes_EnvelopeFlags(a1)
	bra.s	NotInitEnv
NotAssignInstrEnv:	jsr	-2(a5,d0.w)
	clr.l	(a1)
	clr.w	pes_EnvelopeValue(a1)
NotInitEnv:	dbra	d6,AssignEnvsLoop
	move.w	#-1,pc_VolEnvelope+pes_EnvelopeValue(a2)
	moveq	#3-1,d6
	lea	AssignAutoEnvTab(pc),a5
	move.l	4(sp),a0
	move.l	a6,4(sp)
	move.l	a0,a6
AssignAutoEnvsLoop:	move.w	(a5)+,d0
	jsr	-2(a5,d0.w)
	move.b	tcs_EnvUsageFlags(a6),d1
	move.b	tcs_EnvProcFlags(a6),d2
	move.b	tcs_EnvRetrigFlags(a6),d3
	move.b	tcs_EnvRandomFlags(a6),d4
	tst.l	(a1)
	beq.s	AlwaysAutoInitFirstEnv
	btst	d6,d1
	bne.s	NotAutoInitEnv
AlwaysAutoInitFirstEnv:	move.l	a0,(a1)
	beq.s	NotAutoInitEnv
	moveq	#0,d0
	moveq	#0,d1
	moveq	#0,d5
	btst	d6,d2
	beq.s	NotAutoFirstAddEnv
	moveq	#PESF_FirstAdd,d5
NotAutoFirstAddEnv:	btst	d6,d3
	beq.s	NotAutoRetrigEnv
	addq.b	#PESF_NoRetrig,d5
	move.w	pes_EnvelopePos(a1),d0
	move.w	pes_EnvelopeValue(a1),d1
NotAutoRetrigEnv:	btst	d6,d4
	beq.s	NotAutoRandomAssignEnv
	addq.b	#PESF_Random,d5
NotAutoRandomAssignEnv:	move.w	d1,pes_EnvelopeValue(a1)
	move.w	tcie_Tempo(a0),pes_EnvelopeTempo(a1)
	clr.w	pes_EnvelopeTempoCount(a1)
	clr.l	pes_EnvelopeSustainCounted(a1)
	movem.l	tcie_SustainStart(a0),d1-d4
	movem.l	d1-d4,pes_EnvelopeSustainStart(a1)
	move.b	tcie_Flags+1(a0),pes_EnvelopeRepFlags(a1)
	bsr	SetEnvelope
	or.b	d5,pes_EnvelopeFlags(a1)
NotAutoInitEnv:	dbra	d6,AssignAutoEnvsLoop
	move.l	a6,a0
	movem.l	(sp)+,d6/a1/a5-a6
	exg	a0,a1
	moveq	#0,d3
	move.b	phc_TrackNotePan(a3),d3
	bset	#PCB_TrackPan,pc_Flags+1(a2)
	btst	#TCSB_SmpPanning,tcs_Flags(a1)
	beq.s	NoPlaySmpPan
	and.w	#~(PCF_SmpSurPan|PCF_TrackPan),pc_Flags(a2)
	btst	#TCSB_SurroundPan,tcs_Flags(a1)
	beq.s	NotSmpSurPan
	bset	#PCB_SmpSurPan,pc_Flags+1(a2)
NotSmpSurPan:	move.w	tcs_Panning(a1),pc_Panning(a2)
	clr.w	phc_PannoloSlideValue(a3)
	move.b	pc_Panning(a2),d3
	btst	#TCSCB_AffectChanPan,tcs_CompFlags(a1)
	beq.s	EvalPanDone
	move.w	pc_Panning(a2),phc_TrackPanning(a3)
	move.w	pc_Panning(a2),phc_TrackNotePan(a3)
	bclr	#PHCB_TrackSurPan,phc_Flags+3(a3)
	btst	#PCB_SmpSurPan,pc_Flags+1(a2)
	beq.s	EvalPanDone
	bset	#PHCB_TrackSurPan,phc_Flags+3(a3)
	bra.s	EvalPanDone
NoPlaySmpPan:	move.w	phc_TrackPanning(a3),pc_Panning(a2)
	move.l	phc_Flags(a3),d1
	and.w	#PHCF_TrackSurPan,d1
	and.w	#~(PCF_SmpSurPan),pc_Flags(a2)
	or.w	d1,pc_Flags(a2)
EvalPanDone:	bset	#PHCB_AffectChanPan,phc_Flags+3(a3)
	move.l	a0,d0
	beq	SwingPanDone
	btst	#TCICB_AffectChanPan,tci_CompFlags(a0)
	beq.s	AffectChPan
	btst	#TCSCB_AffectChanPan,tcs_CompFlags(a1)
	beq.s	AffectChPan
	bclr	#PHCB_AffectChanPan,phc_Flags+3(a3)
AffectChPan:	btst	#TCIB_DefaultPanning,tci_Flags(a0)
	beq.s	NoPlayInsPan
	and.w	#~(PCF_SmpSurPan|PCF_TrackPan),pc_Flags(a2)
	btst	#TCIB_SurroundPanning,tci_Flags(a0)
	beq.s	NotSurroundPan
	bset	#PCB_SmpSurPan,pc_Flags+1(a2)
NotSurroundPan:	move.w	tci_DefaultPanning(a0),pc_Panning(a2)
	clr.w	phc_PannoloSlideValue(a3)
	move.b	pc_Panning(a2),d3
	btst	#TCICB_AffectChanPan,tci_CompFlags(a0)
	beq.s	NoPlayInsPan
	move.w	pc_Panning(a2),phc_TrackPanning(a3)
	bclr	#PHCB_TrackSurPan,phc_Flags+3(a3)
	btst	#PCB_SmpSurPan,pc_Flags+1(a2)
	beq.s	NoPlayInsPan
	bset	#PHCB_TrackSurPan,phc_Flags+3(a3)
NoPlayInsPan:	moveq	#0,d2
	move.b	phc_InstrNote(a3),d2
	moveq	#1,d4
	add.b	tci_PitchPanCenter(a0),d4
	sub.w	d4,d2
	muls.w	tci_PitchPanSeparation(a0),d2
	asr.l	#8,d2
	move.w	tci_PanningSwing(a0),d4
	move.l	d4,d5
	add.l	d5,d5
	addq.l	#1,d5
	move.l	tcb_RandomSeed(a6),d1
	muls.l	#RANDOM_CONST,d1
	addq.l	#1,d1
	move.l	d1,tcb_RandomSeed(a6)
	move.l	d5,d0
	bsr	MULU64
	sub.l	d4,d1
	add.l	d3,d1
	add.l	d1,d2
	bpl.s	PanSwingLowValOk
	moveq	#0,d2
PanSwingLowValOk:	cmp.w	#255,d2
	bls.s	PanSwingHiValOk
	moveq	#-1,d2
PanSwingHiValOk:	btst	#PCB_TrackPan,pc_Flags+1(a2)
	beq.s	PutSwingPan
	move.b	d2,phc_TrackPanning(a3)
	bra.s	CheckPutSwing
PutSwingPan:	move.b	d2,pc_Panning(a2)
CheckPutSwing:	btst	#PHCB_AffectChanPan,phc_Flags+3(a3)
	beq.s	SwingPanDone
	move.b	d2,phc_TrackPanning(a3)
	move.b	d2,pc_Panning(a2)
SwingPanDone:	rts
InitNewSample:	move.l	tcs_Samples(a1),d3
	beq.s	InitSynthSmp
	move.l	a2,a0
	addq.l	#4,a0
	move.l	d3,(a0)+
	move.l	tcs_Data(a1),(a0)+
	move.l	pc_Frequency(a2),(a0)+
	move.b	tcs_Flags(a1),d1
	btst	#TCSB_SustainLoop,d1
	beq.s	UseNormalLoop
	movem.l	tcs_SustainRepeat(a1),d0/d3-d4
	move.l	d0,(a0)+
	move.l	d3,(a0)+
	move.l	d4,(a0)+
	move.b	tcs_SustainRepMode(a1),d2
	lsr.b	#1,d1
	bra.s	PlayLoopOk
UseNormalLoop:	movem.l	tcs_Repeat(a1),d0/d3-d4
	move.l	d0,(a0)+
	move.l	d3,(a0)+
	move.l	d4,(a0)+
	move.b	tcs_RepMode(a1),d2
PlayLoopOk:	clr.l	(a0)+
	move.b	tcs_BitDepth(a1),(a0)+
	move.b	#MSF_Play,d0
	btst	#TCSB_Reverse,tcs_Flags(a1)
	beq.s	NotInitBackwards
	bset	#MSB_Backwards,d0
NotInitBackwards:	btst	#TCSB_Loop,d1
	beq.s	NotPlayLoop
	tst.l	d3
	beq.s	NotPlayLoop
	addq.b	#MSF_Loop,d0
	btst	#TCSRB_Pingpong,d2
	beq.s	NotPingpongPlay
	addq.b	#MSF_Pingpong,d0
NotPingpongPlay:	btst	#TCSRB_Backwards,d2
	beq.s	NotPlayLoop
	bset	#MSB_Backwards,d0
NotPlayLoop:	move.b	d0,(a0)
InitSynthSmp:	move.l	tcs_Synth(a1),a0
	move.l	a0,d0
	beq.s	InitSynthCode
	move.l	phc_Synth(a3),d0
	beq.s	InitSynthCode
	tst.b	tcy_PosKeepMask(a0)
	bmi.s	NotInitSynthCode
InitSynthCode:	move.l	a0,phc_Synth(a3)
NotInitSynthCode:	move.l	phc_Synth(a3),pc_Synth(a2)
	beq	NotInitSynth
	bset	#MSB_Play,ms_Flags(a2)
	move.l	phc_WaveformList(a3),d0
	beq.s	InitWaveformList
	btst	#TCYPB_Waveforms,tcy_PosKeepMask(a0)
	bne.s	NotInitWaveformList
InitWaveformList:	lea	tcy_Waves(a0),a1
	move.l	a1,phc_WaveformList(a3)
	moveq	#0,d0
	move.l	(a1),a1
	tst.l	(a1)
	beq.s	ClearInitWaveform
	move.l	a1,d0
ClearInitWaveform:	lea	pc_VibratoWaveform(a2),a1
	move.l	d0,(a1)+
	move.l	d0,(a1)+
	move.l	d0,(a1)+
	move.l	d0,(a1)
NotInitWaveformList:	move.l	phc_WaveformList(a3),pc_WaveformList(a2)
	move.b	tcy_PosKeepMask(a0),d0
	lsr.b	#1,d0
	bcs.s	KeepVolPos
	move.w	tcy_VolumePos(a0),phc_VolumePos(a3)
KeepVolPos:	lsr.b	#1,d0
	bcs.s	KeepPanPos
	move.w	tcy_PanningPos(a0),phc_PanningPos(a3)
KeepPanPos:	lsr.b	#1,d0
	bcs.s	KeepSlidePos
	move.w	tcy_SlidePos(a0),phc_SlidePos(a3)
KeepSlidePos:	lsr.b	#1,d0
	bcs.s	KeepSpecialPos
	move.w	tcy_SpecialPos(a0),phc_SpecialPos(a3)
KeepSpecialPos:	move.b	tcy_UseSusFlags(a0),d0
	move.b	d0,pc_UseSusFlags(a2)
	lsr.b	#TCYSB_VolSusKeep+1,d0
	bcs.s	KeepVolSusPos
	move.w	tcy_VolumeSusPos(a0),phc_VolumeSusPos(a3)
KeepVolSusPos:	lsr.b	#1,d0
	bcs.s	KeepPanSusPos
	move.w	tcy_PanningSusPos(a0),phc_PanningSusPos(a3)
KeepPanSusPos:	lsr.b	#1,d0
	bcs.s	KeepSldSusPos
	move.w	tcy_SlideSusPos(a0),phc_SlideSusPos(a3)
KeepSldSusPos:	lsr.b	#1,d0
	bcs.s	KeepSpcSusPos
	move.w	tcy_SpecialSusPos(a0),phc_SpecialSusPos(a3)
KeepSpcSusPos:	move.b	tcy_UseNNAFlags(a0),pc_UseNNAFlags(a2)
	move.b	tcy_NNAPosKeepMask(a0),d0
	lsr.b	#1,d0
	bcs.s	KeepVolNNAPos
	move.w	tcy_VolNNAPos(a0),phc_VolNNAPos(a3)
KeepVolNNAPos:	lsr.b	#1,d0
	bcs.s	KeepPanNNAPos
	move.w	tcy_PanNNAPos(a0),phc_PanNNAPos(a3)
KeepPanNNAPos:	lsr.b	#1,d0
	bcs.s	KeepSlideNNAPos
	move.w	tcy_SlideNNAPos(a0),phc_SlideNNAPos(a3)
KeepSlideNNAPos:	lsr.b	#1,d0
	bcs.s	KeepSpecialNNAPos
	move.w	tcy_SpecialNNAPos(a0),phc_SpecialNNAPos(a3)
KeepSpecialNNAPos:	lsr.b	#1,d0
	bcs.s	KeepVolDNAPos
	move.w	tcy_VolDNAPos(a0),phc_VolDNAPos(a3)
KeepVolDNAPos:	lsr.b	#1,d0
	bcs.s	KeepPanDNAPos
	move.w	tcy_PanDNAPos(a0),phc_PanDNAPos(a3)
KeepPanDNAPos:	lsr.b	#1,d0
	bcs.s	KeepSlideDNAPos
	move.w	tcy_SlideDNAPos(a0),phc_SlideDNAPos(a3)
KeepSlideDNAPos:	lsr.b	#1,d0
	bcs.s	KeepSpecialDNAPos
	move.w	tcy_SpecialDNAPos(a0),phc_SpecialDNAPos(a3)
KeepSpecialDNAPos:	move.w	tcy_VarKeepMask(a0),d0
	moveq	#16-1,d1
	lea	tcy_Variable0(a0),a0
	lea	phc_Variable0(a3),a1
SetSynthVarLoop:	lsr.w	#1,d0
	bcs.s	KeepSynthVar
	move.w	(a0),(a1)
KeepSynthVar:	addq.l	#2,a0
	addq.l	#2,a1
	dbra	d1,SetSynthVarLoop
	move.l	(a0)+,(a1)+
	move.l	(a0),(a1)
	moveq	#(pc_UseNNAFlags-pc_VolumePos)/8-1,d0
	lea	phc_VolumePos(a3),a0
	lea	pc_VolumePos(a2),a1
CopyPHCSynthToPC:	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	dbra	d0,CopyPHCSynthToPC
	addq.l	#pc_FineTune-pc_UseNNAFlags,a1
	moveq	#0,d0
	moveq	#(pc_Reserved-pc_FineTune)/8-1,d1
ClearSmpSynthLoop:	move.l	d0,(a1)+
	move.l	d0,(a1)+
	dbra	d1,ClearSmpSynthLoop
NotInitSynth:	move.b	phc_FineTune(a3),pc_FineTune(a2)
	move.l	d6,d0
	move.l	a2,a0
	move.l	a6,d2
	move.l	tcb_PlayMixerAlloc(a6),a1
	move.l	(a1),a6
	jsr	_LVOExternalMixerSetChannel(a6)
	move.l	d2,a6
	rts
PlayNoteKill:	clr.l	phc_Instrument(a3)
	clr.l	phc_Sample(a3)
	clr.w	phc_InstrNote(a3)
	cmp.w	pc_HostChannel(a2),d7
	bne.s	AlreadySustained
	clr.b	ms_Flags(a2)
	rts
PlayNoteFade:	bset	#PCB_Fading,pc_Flags+1(a2)
	rts
PlayNoteOff:	clr.b	pc_Volume(a2)
	rts
PlayHoldDelay:
	rts
AlreadySustained:	rts
PlaySpecialNote:	cmp.b	#NOTE_END,d2
	beq.s	PlayNoteEnd
	addq.b	#1,d2
	beq.s	PlayNoteKill
	cmp.w	pc_HostChannel(a2),d7
	bne.s	AlreadySustained
	addq.b	#1,d2
	beq.s	PlayNoteOff
	addq.b	#1,d2
	beq.s	PlayKeyOff
	addq.b	#1,d2
	beq.s	PlayHoldDelay
	addq.b	#1,d2
	beq.s	PlayNoteFade
PlayNoteEndDone:	rts
PlayNoteEnd:	lea	PlayRowCont(pc),a0
	cmp.l	(sp),a0
	beq.s	PlayNoteEndDone
	addq.l	#4,sp
	btst	#PHCB_PattLoop-16,phc_Flags+1(a3)
	bne	ReScanRow
	bset	#PHCB_PatternBreak,phc_Flags+3(a3)
	clr.w	phc_BreakRow(a3)
	bra	ReScanRow
PlayKeyOff:	bset	#PCB_Sustain,pc_Flags+1(a2)
	bne.s	AlreadySustained
	moveq	#(pc_AutoVibFrequency-pc_VolEnvelope)/pes_SIZEOF-1,d1
	lea	pc_VolEnvelope(a2),a1
ReleaseSusPoints:	move.w	pes_EnvelopePos(a1),d0
	bsr	SetEnvelope
	lea	pes_SIZEOF(a1),a1
	dbra	d1,ReleaseSusPoints
	tst.l	pc_VolEnvelope(a2)
	beq.s	StartFadeOut
	tst.w	pc_VolEnvelope+pes_EnvelopeTempo(a2)
	beq.s	StartFadeOut
	btst	#PESB_Looping,pc_VolEnvelope+pes_EnvelopeFlags(a2)
	beq.s	NotStartFadeOut
StartFadeOut:	bset	#PCB_Fading,pc_Flags+1(a2)
NotStartFadeOut:	move.l	pc_Sample(a2),a1
	btst	#TCSB_SustainLoop,tcs_Flags(a1)
	beq	AlreadySustained
	movem.l	tcs_Repeat(a1),d0-d2
	movem.l	d0-d2,ms_Repeat(a2)
	move.b	ms_Flags(a2),d0
	and.b	#~(MSF_Loop|MSF_Pingpong|MSF_Backwards),d0
	btst	#TCSB_Loop,tcs_Flags(a1)
	beq.s	NotSusPlayLoop
	tst.l	d1
	beq.s	NotSusPlayLoop
	addq.b	#MSF_Loop,d0
	btst	#TCSRB_Pingpong,tcs_RepMode(a1)
	beq.s	NotSusPingpongPlay
	addq.b	#MSF_Pingpong,d0
NotSusPingpongPlay:	btst	#TCSRB_Backwards,tcs_RepMode(a1)
	beq.s	NotSusPlayLoop
	bset	#MSB_Backwards,d0
NotSusPlayLoop:	move.b	d0,ms_Flags(a2)
	move.b	pc_UseSusFlags(a2),d1
	lsr.b	#1,d1
	bcc.s	NotTrigVolSus
	move.w	pc_VolumeSusPos(a1),pc_VolumePos(a1)
NotTrigVolSus:	lsr.b	#1,d1
	bcc.s	NotTrigPanSus
	move.w	pc_PanningSusPos(a1),pc_PanningPos(a1)
NotTrigPanSus:	lsr.b	#1,d1
	bcc.s	NotTrigSldSus
	move.w	pc_SlideSusPos(a1),pc_SlidePos(a1)
NotTrigSldSus:	lsr.b	#1,d1
	bcc.s	NotPlayNote
	move.w	pc_SpecialSusPos(a1),pc_SpecialPos(a1)
NotPlayNote:	rts
GetNote:	tst.w	phc_PatternDelayCount(a3)
	bne.s	NotPlayNote
	move.l	phc_TempoCounter(a3),d0
	moveq	#0,d1
	move.w	phc_NoteDelay(a3),d1
	cmp.l	d1,d0
	bne.s	NotPlayNote
	move.l	phc_Track(a3),d0
	beq.s	NotPlayNote
	move.l	d0,a0
	move.l	tct_Data(a0),a0
	moveq	#0,d0
	move.w	phc_Row(a3),d0
	lsl.l	#4,d0
	add.l	d0,a0
	tst.l	(a0)
	beq.s	NotPlayNote
	moveq	#0,d1
	move.w	(a0),d3
	move.b	(a0)+,d1
	moveq	#0,d2
	move.b	(a0)+,d2
	bmi	PlaySpecialNote
	move.w	(a0),d0
	beq	NoPlayInstr
	move.w	d0,d4
	lea	tcm_InstrList(a5),a0
GetPlayInstr:	move.l	(a0),a0
	tst.l	(a0)
	beq.s	NotPlayNote
	subq.w	#1,d0
	bne.s	GetPlayInstr
	btst	#TCIB_NoInstrTranspose,tci_Flags(a0)
	bne.s	NotAllowInstrTrsp
	move.l	(a3),a1
	move.w	tcol_InstrTranspose(a1),d0
	beq.s	NotAllowInstrTrsp
	add.w	d4,d0
	lea	tcm_InstrList(a5),a1
GetPlayTrspInstr:	move.l	(a1),a1
	tst.l	(a1)
	beq.s	NotAllowInstrTrsp
	subq.w	#1,d0
	bne.s	GetPlayTrspInstr
	move.l	a1,a0
NotAllowInstrTrsp:	btst	#PHCB_TonePorta-8,phc_Flags+2(a3)
	bne.s	RunTonePorta
	tst.w	d3
	bne.s	TonePortaNotRun
	move.l	a0,d4
	beq.s	NoPlayNote
	move.b	phc_InstrNote(a3),d1
	bne.s	InstrNoteOk
	moveq	#1,d1
	bsr	GetKeyTable
	clr.w	phc_InstrNote(a3)
	bsr	PlayNoteGot
	bset	#PCB_Allocated-8,pc_Flags(a2)
	bra.s	InstrLocked2
InstrNoteOk:	bsr	GetKeyTable
	beq.s	NoPlayNote
	cmp.w	pc_HostChannel(a2),d7
	bne.s	WrongNNACh
	cmp.l	phc_Instrument(a3),d4
	beq.s	InstrLocked2
WrongNNACh:	bsr	PlayNoteGot
InstrLocked2:	exg	d4,a0
	btst	#TCICB_LockInsWave,tci_CompFlags(a0)
	exg	d4,a0
	bne.s	InstrLock2
	bra.s	InstrLocked
RunTonePorta:	bsr	GetKeyTableNote
	bsr	GetTonePitch
	move.l	d0,phc_TonePortaTargetPitch(a3)
NoPlayNote:	rts
TonePortaNotRun:	bsr.s	PlayNote
InstrLocked:	pea	InitNewSample(pc)
InstrLock2:	move.w	tcs_Volume(a1),pc_Volume(a2)
	bra	InitNewInstr
NoPlayInstr:	move.l	phc_Instrument(a3),d0
	beq.s	NoPlayNote
	move.l	d0,a0
	btst	#TCIB_NoInstrTranspose,tci_Flags(a0)
	bne.s	NotAllowInstrTrsp2
	move.l	(a3),a1
	move.w	tcol_InstrTranspose(a1),d0
	beq.s	NotAllowInstrTrsp2
	lea	tcm_InstrList(a5),a1
GetPlayTrspInstr2:	move.l	(a1),a1
	tst.l	(a1)
	beq.s	NotAllowInstrTrsp2
	subq.w	#1,d0
	bne.s	GetPlayTrspInstr2
	move.l	a1,a0
NotAllowInstrTrsp2:	move.l	a2,-(sp)
	bsr.s	PlayNote
	move.l	(sp)+,a0
	beq.s	NoPlayNote
	move.l	tcs_StartOffset(a1),(a2)
	btst	#TCSCB_VolumeOnly,tcs_Flags(a1)
	bne.s	InitNewVolOnly
	cmp.l	a2,a0
	beq.s	NotCloneIdentical
	moveq	#(pc_InstrNote-pc_Volume)/4-1,d0
	lea	pc_Volume(a0),a0
	lea	pc_Volume(a2),a1
CopyIdInstrLoop:	move.l	(a0)+,(a1)+
	dbra	d0,CopyIdInstrLoop
	move.w	d7,pc_HostChannel(a2)
	move.l	phc_Sample(a3),a1
NotCloneIdentical:	pea	InitNewSample(pc)
	bra	InitNewInstr
InitNewVolOnly:	move.w	pc_Volume(a0),pc_Volume(a2)
	pea	InitNewSample(pc)
	bra	InitNewInstr
NoPlayNote2:	rts
PlayNote:	bset	#PHCB_RetrigNote-8,phc_Flags+2(a3)
	bsr	GetKeyTableNote
	beq.s	NoPlayNote2
PlayNoteGot:	move.l	phc_Instrument(a3),a0
	move.w	tci_DCT(a0),phc_DCT(a3)
	move.b	tci_NoteSwing(a0),d0
	move.l	d0,d3
	add.l	d3,d3
	addq.l	#1,d3
	move.l	tcb_RandomSeed(a6),d2
	muls.l	#RANDOM_CONST,d2
	addq.l	#1,d2
	move.l	d2,tcb_RandomSeed(a6)
	exg	d0,d2
	exg	d1,d3
	bsr	MULU64
	sub.l	d2,d1
	add.l	d1,d3
	move.w	d3,phc_FinalNote(a3)
	move.b	tcs_FineTune(a1),phc_FineTune(a3)
	btst	#PHCB_SetTranspose-8,phc_Flags+2(a3)
	beq.s	DoNotSetFineTune
	move.b	phc_TransFineTune(a3),phc_FineTune(a3)
DoNotSetFineTune:	move.l	pc_VolEnvelope(a2),phc_PrevVolumeEnv(a3)
	move.l	pc_PanEnvelope(a2),phc_PrevPanningEnv(a3)
	move.l	pc_SlideEnvelope(a2),phc_PrevSlideEnv(a3)
	move.l	pc_AutoVibEnv(a2),phc_PrevAutoVibEnv(a3)
	move.l	pc_AutoTremoEnv(a2),phc_PrevAutoTremEnv(a3)
	move.l	pc_AutoPanEnv(a2),phc_PrevAutoPanEnv(a3)
	bsr.s	TriggerNNA
	move.l	a1,a2
	move.l	phc_Sample(a3),a1
	move.l	tcs_StartOffset(a1),(a2)
	move.w	d6,phc_VirtualChannel(a3)
	move.w	d7,pc_HostChannel(a2)
	move.l	phc_Instrument(a3),pc_Instrument(a2)
	move.l	a1,pc_Sample(a2)
	moveq	#0,d0
	move.w	phc_InstrNote(a3),pc_InstrNote(a2)
	beq.s	GetTonePitchOk
	move.w	phc_FinalNote(a3),d1
	move.w	d1,pc_FinalNote(a2)
	bsr	GetTonePitch
GetTonePitchOk:	move.l	phc_Instrument(a3),a0
	move.l	d0,d4
	move.l	tci_PitchSwing(a0),d1
	bsr	MULU64
	exg	d0,d4
	move.l	d1,d3
	move.w	d3,d4
	swap	d4
	add.l	d4,d4
	bcc.s	PitchSwingWrong
	moveq	#-2,d4
PitchSwingWrong:	move.l	d4,d5
	addq.l	#1,d4
	lsr.l	#1,d5
	move.l	tcb_RandomSeed(a6),d3
	muls.l	#RANDOM_CONST,d3
	addq.l	#1,d3
	move.l	d3,tcb_RandomSeed(a6)
	exg	d0,d3
	move.l	d4,d1
	bsr	MULU64
	sub.l	d5,d1
	add.l	d1,d3
	bpl.s	PitchPanLowValOk
	moveq	#0,d3
PitchPanLowValOk:	move.l	d3,pc_Frequency(a2)
PlayNoteDone:	rts
TriggerNNA:	moveq	#0,d6
	move.w	phc_VirtualChannel(a3),d6
	move.l	a2,a1
	cmp.w	pc_HostChannel(a2),d7
	beq.s	CheckPrevNNA
	moveq	#0,d5
	move.l	tcm_ChannelData(a5),a1
ScanPrevNNALoop:	cmp.w	pc_HostChannel(a1),d7
	beq.s	PrevNNAFound
	lea	pc_PlayerChannelx(a1),a1
	addq.w	#1,d5
	cmp.w	tcm_Channels(a5),d5
	bne.s	ScanPrevNNALoop
	bra	FindNNA
PrevNNAFound:	move.w	d5,d6
CheckPrevNNA:	bclr	#PCB_Allocated-8,pc_Flags(a1)
	bne	NNAFound
	move.b	phc_NNA(a3),d0
	beq	NNAFound
	move.b	pc_UseNNAFlags(a1),d1
	lsr.b	#1,d1
	bcc.s	NotTrigVolNNA
	move.w	pc_VolNNAPos(a1),pc_VolumePos(a1)
NotTrigVolNNA:	lsr.b	#1,d1
	bcc.s	NotTrigPanNNA
	move.w	pc_PanNNAPos(a1),pc_PanningPos(a1)
NotTrigPanNNA:	lsr.b	#1,d1
	bcc.s	NotTrigSldNNA
	move.w	pc_SlideNNAPos(a1),pc_SlidePos(a1)
NotTrigSldNNA:	lsr.b	#1,d1
	bcc.s	NotTrigSpcNNA
	move.w	pc_SpecialNNAPos(a1),pc_SpecialPos(a1)
NotTrigSpcNNA:	bset	#PCB_Background,pc_Flags+1(a1)
	subq.b	#2,d0
	blo.s	CheckDCT
	bne.s	ExecNNAFade
	move.l	a2,-(sp)
	move.l	a1,a2
	bsr	PlayKeyOff
	move.l	(sp)+,a2
	bra.s	CheckDCT
ExecNNAFade:	subq.b	#1,d0
	bne.s	CheckDCT
	bset	#PCB_Fading,pc_Flags+1(a1)
CheckDCT:	tst.b	phc_DCT(a3)
	beq.s	FindNNA
	tst.b	phc_DNA(a3)
	bne.s	FindNNA
	moveq	#0,d5
	move.l	tcm_ChannelData(a5),a0
CheckDCTLoop:	cmp.w	pc_HostChannel(a0),d7
	bne.s	NoCheckDCT
	move.b	phc_DCT(a3),d0
	bsr	TriggerDCT
	beq.s	NoCheckDCT
	move.w	d5,d6
	move.l	a0,a1
	bra.s	NNAFound
NoCheckDCT:	lea	pc_PlayerChannelx(a0),a0
	addq.w	#1,d5
	cmp.w	tcm_Channels(a5),d5
	bne.s	CheckDCTLoop
FindNNA:	moveq	#0,d5
	move.l	tcm_ChannelData(a5),a0
	sub.l	a1,a1
ScanNNALoop:	tst.b	pc_Flags(a0)
	bmi.s	NextScanNNA
	tst.b	ms_Flags(a0)
	bmi.s	NextScanNNA
	move.w	d5,d6
	move.l	a0,a1
	bra.s	NNAFound
NextScanNNA:	lea	pc_PlayerChannelx(a0),a0
	addq.w	#1,d5
	cmp.w	tcm_Channels(a5),d5
	bne.s	ScanNNALoop
	move.w	#256,d1
	moveq	#0,d2
	moveq	#0,d5
	move.l	tcm_ChannelData(a5),a0
FindNNALowestChannel:	tst.b	pc_Flags+1(a0)
	bpl.s	NextNNALowest
	move.b	pc_FinalVolume(a0),d2
	cmp.w	d2,d1
	bls.s	NextNNALowest
	move.w	d2,d1
	move.l	a0,a1
	move.w	d5,d6
NextNNALowest:	lea	pc_PlayerChannelx(a0),a0
	addq.w	#1,d5
	cmp.w	tcm_Channels(a5),d5
	bne.s	FindNNALowestChannel
	move.l	a1,d0
	bne.s	NNAFound
	move.l	a2,a1
NNAFound:	tst.b	phc_DCT(a3)
	beq.s	NoTriggerDNA
	cmp.l	a2,a1
	beq.s	NoTriggerDNA
	moveq	#0,d5
	move.l	tcm_ChannelData(a5),a0
TriggerDCTLoop:	cmp.w	pc_HostChannel(a0),d7
	bne.s	NoTriggerDCT
	move.b	phc_DCT(a3),d0
	bsr.s	TriggerDCT
	beq.s	NoTriggerDCT
	move.b	pc_UseNNAFlags(a0),d0
	lsr.b	#TCYNB_VolDNA+1,d0
	bcc.s	NotTrigVolDNA
	move.w	pc_VolDNAPos(a0),pc_VolumePos(a0)
NotTrigVolDNA:	lsr.b	#1,d0
	bcc.s	NotTrigPanDNA
	move.w	pc_PanDNAPos(a0),pc_PanningPos(a0)
NotTrigPanDNA:	lsr.b	#1,d0
	bcc.s	NotTrigSldDNA
	move.w	pc_SlideDNAPos(a0),pc_SlidePos(a0)
NotTrigSldDNA:	lsr.b	#1,d0
	bcc.s	NotTrigSpcDNA
	move.w	pc_SpecialDNAPos(a0),pc_SpecialPos(a0)
NotTrigSpcDNA:	move.b	phc_DNA(a3),d1
	bne.s	CheckDCTOff
	clr.b	ms_Flags(a0)
NoTriggerDCT:	lea	pc_PlayerChannelx(a0),a0
	addq.w	#1,d5
	cmp.w	tcm_Channels(a5),d5
	bne.s	TriggerDCTLoop
NoTriggerDNA:	bclr	#PCB_Allocated-8,pc_Flags(a1)
	rts
CheckDCTOff:	subq.b	#1,d1
	beq.s	DCTNoteOff
	subq.l	#1,d1
	bne.s	DCTNoteCont
	bset	#PCB_Fading,pc_Flags+1(a0)
DCTNoteCont:	rts
DCTNoteOff:	move.l	a2,-(sp)
	move.l	a0,a2
	bsr	PlayKeyOff
	move.l	a2,a0
	move.l	(sp)+,a2
	rts
TriggerDCT:	moveq	#0,d1
	move.b	phc_SampleNote(a3),d3
	move.l	phc_Instrument(a3),d4
	lsr.b	#1,d0
	bcc.s	NoDCTInstrNoteOR
	move.b	phc_InstrNote(a3),d2
	cmp.b	pc_InstrNote(a0),d2
	seq	d1
NoDCTInstrNoteOR:	lsr.b	#1,d0
	bcc.s	NoDCTSampleNoteOR
	cmp.b	pc_SampleNote(a0),d3
	seq	d2
	or.b	d2,d1
NoDCTSampleNoteOR:	lsr.b	#1,d0
	bcc.s	NoDCTInstrOR
	cmp.l	pc_Instrument(a0),d4
	seq	d2
	or.b	d2,d1
NoDCTInstrOR:	lsr.b	#1,d0
	bcc.s	NoDCTSampleOR
	move.l	phc_Sample(a3),d2
	cmp.l	pc_Sample(a0),d2
	seq	d2
	or.b	d2,d1
NoDCTSampleOR:	lsr.b	#1,d0
	bcc.s	NoDCTInstrNoteAND
	move.b	phc_InstrNote(a3),d2
	cmp.b	pc_InstrNote(a0),d2
	seq	d2
	and.b	d2,d1
NoDCTInstrNoteAND:	lsr.b	#1,d0
	bcc.s	NoDCTSampleNoteAND
	cmp.b	pc_SampleNote(a0),d3
	seq	d2
	and.b	d2,d1
NoDCTSampleNoteAND:	lsr.b	#1,d0
	bcc.s	NoDCTInstrAND
	cmp.l	pc_Instrument(a0),d4
	seq	d2
	and.b	d2,d1
NoDCTInstrAND:	lsr.b	#1,d0
	bcc.s	NoDCTSampleAND
	move.l	phc_Sample(a3),d2
	cmp.l	pc_Sample(a0),d2
	seq	d2
	and.b	d2,d1
NoDCTSampleAND:	tst.b	d1
TriggerDCTDone:	rts
GetEffects:	move.l	phc_Track(a3),d1
	beq.s	TriggerDCTDone
	move.l	d1,a1
	move.l	tct_Data(a1),a1
	move.l	phc_Effect(a3),d0
	bne.s	ScanEffects
	move.w	phc_Row(a3),d0
	add.l	d0,d0
	move.l	tctd_Effects(a1,d0.l*8),d0
ScanEffects:	move.l	d0,phc_Effect(a3)
	move.l	d0,a0
	tst.l	(a0)
	beq.s	ExecFXDone
	moveq	#FX_EXECUTE_FX,d2
ExecFXLoop:	move.b	tcte_EffectByte(a0),d0
	cmp.b	d2,d0
	bne.s	NotExecFX
	bset	#PHCB_ExecFX,phc_Flags+3(a3)
	move.w	tcte_DataWord(a0),phc_ExecFX(a3)
	move.l	phc_TempoCounter(a3),d1
	moveq	#0,d2
	move.w	phc_ExecFX(a3),d2
	cmp.l	d2,d1
	blo.s	ExecFXOk
NotExecFX:	move.l	(a0),a0
	tst.l	(a0)
	bne.s	ExecFXLoop
ExecFXOk:	moveq	#0,d0
	cmp.l	phc_Effect(a3),a0
	beq.s	ExecFXScanGlobal
	move.l	a0,phc_Effect(a3)
	lea	phc_EffectsUsed(a3),a0
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)
ExecFXScanGlobal:	move.w	phc_Row(a3),d0
	add.l	d0,d0
	lea	tctd_Effects(a1,d0.l*8),a0
	moveq	#0,d0
CheckGlobalLoop:	move.l	(a0),a0
	tst.l	(a0)
	beq.s	ExecFXDone
	move.b	tcte_EffectByte(a0),d0
	move.l	tcb_EffectsTable(a6),a1
	move.b	2(a1,d0.w*4),d4
	btst	#6,d4
	beq.s	CheckGlobalLoop
	add.w	(a1,d0.w*4),a1
	add.w	-4(a1),a1
	jsr	(a1)
	bra.s	CheckGlobalLoop
ExecFXDone:	rts
RunEffects:	move.l	phc_Track(a3),d0
	beq.s	ExecFXDone
	move.l	phc_Effect(a3),d1
	beq.s	ExecFXDone
	move.l	d0,a0
	move.l	tct_Data(a0),a0
	moveq	#0,d0
	move.w	phc_Row(a3),d0
	add.l	d0,d0
	lea	tctd_Effects(a0,d0.l*8),a0
	move.l	a0,-(sp)
OnceExecFX:	move.l	(a0),a0
	cmp.l	phc_Effect(a3),a0
	beq	RunFXNormal
	move.l	tcb_EffectsTable(a6),a1
	moveq	#0,d0
	move.b	tcte_EffectByte(a0),d0
	move.b	2(a1,d0.w*4),d4
	bpl.s	NotCheckOnceType
	add.w	(a1,d0.w*4),a1
	add.w	-(a1),a1
	jsr	(a1)
	move.l	tcb_EffectsTable(a6),a1
NotCheckOnceType:	btst	#4,d4
	bne.s	OnceExecFX
	move.l	phc_TempoCounter(a3),d3
	moveq	#0,d4
	move.w	phc_ExecFX(a3),d4
	tst.b	phc_Flags+3(a3)
	bmi.s	RunOnceExecFXCalled
	move.b	3(a1,d0.w*4),d4
RunOnceExecFXCalled:	cmp.l	d4,d3
	bne.s	OnceExecFX
	bftst	phc_EffectsUsed(a3){d0:1}
	bne.s	OnceExecFX
FXAlreadyUsed:	move.l	tcb_EffectsTable(a6),a1
	add.w	(a1,d0.w*4),a1
	moveq	#0,d2
	move.w	tcte_DataWord(a0),d2
	movem.l	d0/d2/a0,-(sp)
	jsr	(a1)
	move.b	phc_ChControlType(a3),d1
	bne.s	ChControlActive
OnceExecFXOk:	movem.l	(sp)+,d0/d2/a0
	bra.s	OnceExecFX
ChControlActive:	move.l	(sp),d0
	move.l	tcb_EffectsTable(a6),a1
	move.b	2(a1,d0.w*4),d0
	and.b	phc_ChControlAffect(a3),d0
	beq.s	OnceExecFXOk
	movem.l	d7/a2-a3,-(sp)
	moveq	#0,d7
	move.l	tcso_ChannelData(a4),a3
	subq.b	#1,d1
	beq	ChControlNormal
	subq.b	#1,d1
	beq.s	ChControlMulti
ChControlGlobalLoop:	cmp.l	(sp),d7
	beq.s	NotThisChCtrlGlobal
	move.l	tcm_ChannelData(a5),a2
	move.w	phc_VirtualChannel(a3),d6
	mulu.w	#pc_PlayerChannelx,d6
	add.l	d6,a2
	move.l	12(sp),d0
	move.l	tcb_EffectsTable(a6),a1
	move.b	2(a1,d0.w*4),d4
	bpl.s	NotCheckOnceGlobalType
	add.w	(a1,d0.w*4),a1
	add.w	-(a1),a1
	jsr	(a1)
	move.l	tcb_EffectsTable(a6),a1
NotCheckOnceGlobalType:	add.w	(a1,d0.w*4),a1
	move.l	16(sp),d2
	jsr	(a1)
NotThisChCtrlGlobal:	addq.w	#1,d7
	lea	phc_NextHostChannel(a3),a3
	cmp.w	tcso_Channels(a4),d7
	bne.s	ChControlGlobalLoop
ChCtrlDone:	movem.l	(sp)+,d7/a2-a3
	movem.l	(sp)+,d0/d2/a0
	bra	OnceExecFX
ChControlMulti:	cmp.l	(sp),d7
	beq.s	NotThisChCtrlMulti
	bftst	phc_ControlChannels(a3){d7:1}
	beq.s	NotThisChCtrlMulti
	move.l	tcm_ChannelData(a5),a2
	move.w	phc_VirtualChannel(a3),d6
	mulu.w	#pc_PlayerChannelx,d6
	add.l	d6,a2
	move.l	12(sp),d0
	move.l	tcb_EffectsTable(a6),a1
	move.b	2(a1,d0.w*4),d4
	bpl.s	NotCheckOnceMultiType
	add.w	(a1,d0.w*4),a1
	add.w	-(a1),a1
	jsr	(a1)
	move.l	tcb_EffectsTable(a6),a1
NotCheckOnceMultiType:	add.w	(a1,d0.w*4),a1
	move.l	16(sp),d2
	jsr	(a1)
NotThisChCtrlMulti:	addq.w	#1,d7
	lea	phc_NextHostChannel(a3),a3
	cmp.w	tcso_Channels(a4),d7
	bne.s	ChControlMulti
ChCtrlDone2:	bra.s	ChCtrlDone
ChControlNormal:	move.b	phc_ChControlChannel(a3),d7
	cmp.l	(sp),d7
	beq.s	ChCtrlDone
	move.w	d7,d6
	mulu.w	#phc_NextHostChannel,d6
	add.l	d6,a3
	move.l	tcm_ChannelData(a5),a2
	move.w	phc_VirtualChannel(a3),d6
	mulu.w	#pc_PlayerChannelx,d6
	add.l	d6,a2
	move.l	12(sp),d0
	move.l	tcb_EffectsTable(a6),a1
	move.b	2(a1,d0.w*4),d4
	bpl.s	NotCheckOnceNormalType
	add.w	(a1,d0.w*4),a1
	add.w	-(a1),a1
	jsr	(a1)
	move.l	tcb_EffectsTable(a6),a1
NotCheckOnceNormalType:	add.w	(a1,d0.w*4),a1
	move.l	16(sp),d2
	jsr	(a1)
	bra.s	ChCtrlDone2
RunFXDone:	rts
RunFXNormal:	move.l	(sp)+,a0
RunFXLoop:	move.l	(a0),a0
	cmp.l	phc_Effect(a3),a0
	beq.s	RunFXDone
	move.l	tcb_EffectsTable(a6),a1
	moveq	#0,d0
	move.b	tcte_EffectByte(a0),d0
	move.b	2(a1,d0.w*4),d4
	bpl.s	NotCheckRunType
	add.w	(a1,d0.w*4),a1
	add.w	-(a1),a1
	jsr	(a1)
	move.l	tcb_EffectsTable(a6),a1
NotCheckRunType:	btst	#4,d4
	beq.s	RunFXLoop
	move.l	phc_TempoCounter(a3),d3
	moveq	#0,d4
	move.w	phc_ExecFX(a3),d4
	tst.b	phc_Flags+3(a3)
	bmi.s	RunExecFXCalled
	move.b	3(a1,d0.w*4),d4
RunExecFXCalled:	cmp.l	d4,d3
	blo.s	RunFXLoop
	bftst	phc_EffectsUsed(a3){d0:1}
	bne.s	RunFXLoop
	add.w	(a1,d0.w*4),a1
	moveq	#0,d2
	move.w	tcte_DataWord(a0),d2
	movem.l	d0/d2/a0,-(sp)
	jsr	(a1)
	move.b	phc_ChControlType(a3),d1
	bne.s	ChControlRunActive
RunExecFXOk:	movem.l	(sp)+,d0/d2/a0
	bra.s	RunFXLoop
ChControlRunActive:	move.l	(sp),d0
	move.l	tcb_EffectsTable(a6),a1
	move.b	2(a1,d0.w*4),d0
	and.b	phc_ChControlAffect(a3),d0
	beq.s	RunExecFXOk
	movem.l	d7/a2-a3,-(sp)
	moveq	#0,d7
	move.l	tcso_ChannelData(a4),a3
	subq.b	#1,d1
	beq	ChControlRunNormal
	subq.b	#1,d1
	beq.s	ChControlRunMulti
ChControlRunGlobalLoop:	cmp.l	(sp),d7
	beq.s	NotThisChCtrlRunGlobal
	move.l	tcm_ChannelData(a5),a2
	move.w	phc_VirtualChannel(a3),d6
	mulu.w	#pc_PlayerChannelx,d6
	add.l	d6,a2
	move.l	12(sp),d0
	move.l	tcb_EffectsTable(a6),a1
	move.b	2(a1,d0.w*4),d4
	bpl.s	NotCheckRunGlobalType
	add.w	(a1,d0.w*4),a1
	add.w	-(a1),a1
	jsr	(a1)
	move.l	tcb_EffectsTable(a6),a1
NotCheckRunGlobalType:	bftst	phc_EffectsUsed(a3){d0:1}
	bne.s	NotThisChCtrlRunGlobal
	add.w	(a1,d0.w*4),a1
	move.l	16(sp),d2
	jsr	(a1)
NotThisChCtrlRunGlobal:	addq.w	#1,d7
	lea	phc_NextHostChannel(a3),a3
	cmp.w	tcso_Channels(a4),d7
	bne.s	ChControlRunGlobalLoop
ChCtrlRunDone:	movem.l	(sp)+,d7/a2-a3
	movem.l	(sp)+,d0/d2/a0
	bra	RunFXLoop
ChControlRunMulti:	cmp.l	(sp),d7
	beq.s	NotThisChCtrlRunMulti
	bftst	phc_ControlChannels(a3){d7:1}
	beq.s	NotThisChCtrlRunMulti
	move.l	tcm_ChannelData(a5),a2
	move.w	phc_VirtualChannel(a3),d6
	mulu.w	#pc_PlayerChannelx,d6
	add.l	d6,a2
	move.l	12(sp),d0
	move.l	tcb_EffectsTable(a6),a1
	move.b	2(a1,d0.w*4),d4
	bpl.s	NotCheckRunMultiType
	add.w	(a1,d0.w*4),a1
	add.w	-(a1),a1
	jsr	(a1)
	move.l	tcb_EffectsTable(a6),a1
NotCheckRunMultiType:	bftst	phc_EffectsUsed(a3){d0:1}
	bne.s	NotThisChCtrlRunMulti
	add.w	(a1,d0.w*4),a1
	move.l	16(sp),d2
	jsr	(a1)
NotThisChCtrlRunMulti:	addq.w	#1,d7
	lea	phc_NextHostChannel(a3),a3
	cmp.w	tcso_Channels(a4),d7
	bne.s	ChControlRunMulti
ChCtrlRunDone2:	bra.s	ChCtrlRunDone
ChControlRunNormal:	move.b	phc_ChControlChannel(a3),d7
	cmp.l	(sp),d7
	beq.s	ChCtrlRunDone
	move.w	d7,d6
	mulu.w	#phc_NextHostChannel,d6
	add.l	d6,a3
	move.l	tcm_ChannelData(a5),a2
	move.w	phc_VirtualChannel(a3),d6
	mulu.w	#pc_PlayerChannelx,d6
	add.l	d6,a2
	move.l	12(sp),d0
	move.l	tcb_EffectsTable(a6),a1
	move.b	2(a1,d0.w*4),d4
	bpl.s	NotCheckRunNormalType
	add.w	(a1,d0.w*4),a1
	add.w	-(a1),a1
	jsr	(a1)
	move.l	tcb_EffectsTable(a6),a1
NotCheckRunNormalType:	bftst	phc_EffectsUsed(a3){d0:1}
	bne.s	ChCtrlRunDone2
	add.w	(a1,d0.w*4),a1
	move.l	16(sp),d2
	jsr	(a1)
	bra.s	ChCtrlRunDone2
AssignVolumeEnv:	move.l	tci_VolumeEnvelope(a6),a0
	lea	pc_VolEnvelope(a2),a1
	tst.l	phc_PrevVolumeEnv(a3)
	rts
AssignPanningEnv:	move.l	tci_PanningEnvelope(a6),a0
	lea	pc_PanEnvelope(a2),a1
	tst.l	phc_PrevPanningEnv(a3)
	rts
AssignSlideEnv:	move.l	tci_SlideEnvelope(a6),a0
	lea	pc_SlideEnvelope(a2),a1
	tst.l	phc_PrevSlideEnv(a3)
	rts
AssignVibratoEnv:	move.l	tci_VibratoEnvelope(a6),a0
	lea	phc_VibratoEnv(a3),a1
	tst.l	(a1)
	rts
AssignTremoloEnv:	move.l	tci_TremoloEnvelope(a6),a0
	lea	phc_TremoloEnv(a3),a1
	tst.l	(a1)
	rts
AssignPannoloEnv:	move.l	tci_PannoloEnvelope(a6),a0
	lea	phc_PannoloEnv(a3),a1
	tst.l	(a1)
	rts
AssignChannoloEnv:	move.l	tci_ChannoloEnvelope(a6),a0
	lea	phc_ChannoloEnv(a3),a1
	tst.l	(a1)
	rts
AssignSpenoloEnv:	move.l	tci_SpenoloEnvelope(a6),a0
	lea	([tcso_GlobalData.w,a4],pg_SpenoloEnv.w),a1
	tst.l	(a1)
	rts
AssignTTremoloEnv:	move.l	tci_TremoloEnvelope(a6),a0
	lea	phc_TrackTremEnv(a3),a1
	tst.l	(a1)
	rts
AssignTPannoloEnv:	move.l	tci_PannoloEnvelope(a6),a0
	lea	phc_TrackPanEnv(a3),a1
	tst.l	(a1)
	rts
AssignGTremoloEnv:	move.l	tci_TremoloEnvelope(a6),a0
	lea	([tcso_GlobalData.w,a4],pg_TremoloEnv.w),a1
	tst.l	(a1)
	rts
AssignGPannoloEnv:	move.l	tci_PannoloEnvelope(a6),a0
	lea	([tcso_GlobalData.w,a4],pg_PannoloEnv.w),a1
	tst.l	(a1)
	rts
AssignAutoVibEnv:	move.l	tcs_AutoVibratoEnv(a6),a0
	lea	pc_AutoVibEnv(a2),a1
	rts
AssignAutoTremEnv:	move.l	tcs_AutoTremoloEnv(a6),a0
	lea	pc_AutoTremoEnv(a2),a1
	rts
AssignAutoPanEnv:	move.l	tcs_AutoPannoloEnv(a6),a0
	lea	pc_AutoPanEnv(a2),a1
	rts
AssignAutoEnvTab:	dc.w	AssignAutoPanEnv-AssignAutoEnvTab
	dc.w	AssignAutoTremEnv-AssignAutoEnvTab-2
	dc.w	AssignAutoVibEnv-AssignAutoEnvTab-4
AssignEnvTab:	dc.w	AssignGPannoloEnv-AssignEnvTab
	dc.w	AssignGTremoloEnv-AssignEnvTab-2
	dc.w	AssignTPannoloEnv-AssignEnvTab-4
	dc.w	AssignTTremoloEnv-AssignEnvTab-6
	dc.w	AssignSpenoloEnv-AssignEnvTab-8
	dc.w	AssignChannoloEnv-AssignEnvTab-10
	dc.w	AssignPannoloEnv-AssignEnvTab-12
	dc.w	AssignTremoloEnv-AssignEnvTab-14
	dc.w	AssignVibratoEnv-AssignEnvTab-16
	dc.w	AssignSlideEnv-AssignEnvTab-18
	dc.w	AssignPanningEnv-AssignEnvTab-20
	dc.w	AssignVolumeEnv-AssignEnvTab-22
SetEnvelope:	move.l	(a1),d4
	beq.s	SetEnvPosDone
	move.l	d4,a0
	moveq	#PESF_Looping,d4
	movem.w	pes_EnvelopeLoopStart(a1),d2-d3
	btst	#PESRB_Sustain,pes_EnvelopeRepFlags(a1)
	beq.s	NotEnvSetSusLoop
	btst	#PCB_Sustain,pc_Flags+1(a2)
	bne.s	NotEnvSetSusLoop
	movem.w	pes_EnvelopeSustainStart(a1),d2-d3
	bra.s	SetEnvSusLoop
NotEnvSetSusLoop:	btst	#PESRB_Loop,pes_EnvelopeRepFlags(a1)
	bne.s	SetEnvSusLoop
	moveq	#0,d4
	move.w	tcie_NumPoints(a0),d3
	subq.w	#1,d3
SetEnvSusLoop:	cmp.w	d3,d2
	bls.s	EnvPointsOk
	move.w	d3,d2
EnvPointsOk:	cmp.w	d3,d0
	bls.s	EnvPointSetOk
	move.w	d3,d0
EnvPointSetOk:	movem.w	d0/d2-d3,pes_EnvelopePos(a1)
	move.b	d4,pes_EnvelopeFlags(a1)
SetEnvPosDone:	rts
RunEnvelope:	move.w	pes_EnvelopeValue(a0),d0
	move.l	(a0),d1
	beq	RunEnvelopeDone
	move.l	d1,a1
	move.l	tcie_Data(a1),a1
	tst.w	pes_EnvelopeTempo(a0)
	beq	RunEnvelopeDone
	movem.w	pes_EnvelopePos(a0),d2-d3
	move.w	pes_EnvelopeTempoCount(a0),d1
	bne.s	NotStepEnvelope
	bsr.s	StepEnvelope
	move.w	d0,pes_EnvelopeValue(a0)
NotStepEnvelope:	addq.w	#1,d1
	move.w	d1,pes_EnvelopeTempoCount(a0)
	btst	#PESB_Random,pes_EnvelopeFlags(a0)
	beq.s	NotRandomEnv
	btst	#PESB_RndDelay,pes_EnvelopeFlags(a0)
	beq.s	NotRandomEnv
	mulu.w	pes_EnvelopeTempo(a0),d4
	cmp.w	d4,d1
	blo	RunEnvelopeWait
	clr.w	pes_EnvelopeTempoCount(a0)
	rts
NotRandomEnv:	cmp.w	pes_EnvelopeTempo(a0),d1
	blo	RunEnvelopeWait
	clr.w	pes_EnvelopeTempoCount(a0)
	rts
StepEnvelope:	move.w	(a1,d2.w*2),d0
	btst	#PESB_Random,pes_EnvelopeFlags(a0)
	beq.s	NormalRunEnv
DoRndEnvelope:	move.l	tcb_RandomSeed(a6),d1
	muls.l	#RANDOM_CONST,d1
	addq.l	#1,d1
	move.l	d1,tcb_RandomSeed(a6)
	moveq	#0,d0
	move.w	pes_EnvelopeHighestValue(a0),d0
	sub.w	pes_EnvelopeLowestValue(a0),d0
	addq.l	#1,d0
	bsr	MULU64
	exg	d0,d1
	add.w	pes_EnvelopeLowestValue(a0),d0
NormalRunEnv:	add.w	d5,d0
	moveq	#0,d1
	btst	#PESB_Backwards,pes_EnvelopeFlags(a0)
	bne.s	RunEnvBackwards
	btst	#PESB_Looping,pes_EnvelopeFlags(a0)
	bne.s	RunEnvLoop
	add.w	d4,d2
	bcs.s	TurnOffEnv
	cmp.w	pes_EnvelopeEnd(a0),d2
	bls.s	RunEnvelopeWait
TurnOffEnv:	clr.w	pes_EnvelopeTempo(a0)
	bra.s	RunEnvelopeWait
RunEnvLoop:	add.w	d4,d2
	bcs.s	LoopEnvOver
CheckEnvLoop:	cmp.w	pes_EnvelopeEnd(a0),d2
	bls.s	RunEnvelopeWait
LoopEnvOver:	cmp.w	pes_EnvelopeEnd(a0),d3
	beq.s	RunEnvCheckPPWait
	btst	#PESB_Pingpong,pes_EnvelopeFlags(a0)
	bne.s	RunEnvPingpong
	sub.w	pes_EnvelopeEnd(a0),d2
	add.w	d3,d2
	bra.s	CheckEnvLoop
RunEnvPingpong:	bchg	#PESB_Backwards,pes_EnvelopeFlags(a0)
	sub.w	pes_EnvelopePos(a0),d2
	neg.w	d2
	add.w	pes_EnvelopeEnd(a0),d2
	bcc.s	LoopEnvOverBack
	bra.s	CheckBackEnvLoop
RunEnvCheckPPWait:	move.w	d3,d2
	btst	#PESB_Pingpong,pes_EnvelopeFlags(a0)
	beq.s	RunEnvelopeWait
	bchg	#PESB_Backwards,pes_EnvelopeFlags(a0)
RunEnvelopeWait:	move.w	d2,pes_EnvelopePos(a0)
	btst	#PESB_FirstAdd,pes_EnvelopeFlags(a0)
	beq.s	RunEnvelopeDone
	btst	#PESB_Random,pes_EnvelopeFlags(a0)
	bne.s	RunEnvelopeDone
	move.w	(a1,d2.w*2),d0
	add.w	d5,d0
RunEnvelopeDone:	rts
RunEnvBackwards:	btst	#PESB_Looping,pes_EnvelopeFlags(a0)
	bne.s	RunEnvBackLoop
	sub.w	d4,d2
	bcc.s	RunEnvelopeWait
	bra.s	TurnOffEnv
RunEnvBackLoop:	add.w	d4,d2
	bcs.s	LoopEnvOverBack
CheckBackEnvLoop:	cmp.w	d3,d2
	bhs.s	RunEnvelopeWait
LoopEnvOverBack:	cmp.w	pes_EnvelopeEnd(a0),d3
	beq.s	RunEnvCheckPPWait
	btst	#PESB_Pingpong,pes_EnvelopeFlags(a0)
	bne.s	RunEnvBackPingpong
	add.w	pes_EnvelopeEnd(a0),d2
	sub.w	d3,d2
	bra.s	CheckBackEnvLoop
RunEnvBackPingpong:	sub.w	pes_EnvelopePos(a0),d2
	neg.w	d2
	add.w	d3,d2
	bcc	LoopEnvOver
	bra	CheckEnvLoop
CheckPorta:	tst.w	tcte_DataWord(a0)
	beq.s	TriggerPortaOnce
	and.b	#~(FSF_FinePortaDown|FSF_PortaOnceDown|FSF_FinePortaOnceDown|FSF_FinePorta|FSF_PortaOnce),phc_FineSlideFlags+3(a3)
	move.b	PortaMask-FX_PORTA_UP(pc,d0.w),d1
	or.b	d1,phc_FineSlideFlags+3(a3)
	rts
PortaMask:	dc.b	0
	dc.b	0
	dc.b	FSF_FinePorta
	dc.b	FSF_FinePortaDown|FSF_FinePorta
	dc.b	FSF_PortaOnce
	dc.b	FSF_PortaOnceDown|FSF_PortaOnce
	dc.b	FSF_FinePorta|FSF_PortaOnce
	dc.b	FSF_FinePortaDown|FSF_FinePorta|FSF_PortaOnceDown|FSF_PortaOnce
TriggerPortaOnce:	move.l	phc_Track(a3),a1
	btst	#TCTCB_Slide,tct_CompFlags(a1)
	beq.s	TriggerPortaDirection
	cmp.b	#FX_PORTA_DOWN,d0
	bhi.s	TriggerSlideAllOk
	bftst	phc_FineSlideFlags(a3){32-2-FSB_FinePorta:2}
	beq.s	TriggerPortaDone
TriggerSlideAllOk:	moveq	#FX_PORTA_UP,d0
	btst	#FSB_FinePorta,phc_FineSlideFlags+3(a3)
	beq.s	NotFinePortaUsed
	moveq	#FX_F_PORTA_UP,d0
NotFinePortaUsed:	btst	#FSB_PortaOnce,phc_FineSlideFlags+3(a3)
	beq.s	TriggerPortaDirection
	addq.b	#FX_O_PORTA_UP-FX_PORTA_UP,d0
TriggerPortaDirection:	btst	#TCTCB_OpSlide,tct_CompFlags(a1)
	bne.s	TriggerPortaDone
	cmp.b	#FX_PORTA_DOWN,d0
	bls.s	TriggerPortaDone
	move.w	d0,d1
	subq.b	#FX_PORTA_UP-FX_ARPEGGIO,d0
	bclr	#0,d0
	move.b	PortaTrigMask-FX_PORTA_DOWN-1(pc,d1.w),d1
	btst	d1,phc_FineSlideFlags+3(a3)
	beq.s	TriggerPortaOk
	bset	#0,d0
TriggerPortaOk:	addq.b	#FX_PORTA_UP-FX_ARPEGGIO,d0
TriggerPortaDone:	bset	#4,d4
	cmp.b	#FX_O_PORTA_UP,d0
	blo.s	TriggerPortaFineOk
	bclr	#4,d4
TriggerPortaFineOk:	rts
PortaTrigMask:	dc.b	FSB_FinePortaDown
	dc.b	FSB_FinePortaDown
	dc.b	FSB_PortaOnceDown
	dc.b	FSB_PortaOnceDown
	dc.b	FSB_FinePortaOnceDown
	dc.b	FSB_FinePortaOnceDown
	dc.w	CheckPorta-PortaUp+2
PortaUp:	bne.s	OldPortaUpVal
	move.w	phc_PortaUpValue(a3),d2
OldPortaUpVal:	moveq	#16,d1
	moveq	#8-4,d4
	bsr	PortaSlideUp
	move.l	phc_Track(a3),a1
	btst	#TCTCB_VolPitch,tct_CompFlags(a1)
	beq.s	PortaUpOk
	bsr	VolSlUpOk
PortaUpOk:	movem.w	phc_FinePortaUpValue(a3),d0-d1/d3-d5/a0
	btst	#TCTCB_Slide,tct_CompFlags(a1)
	beq.s	NotPortaUpAll
	move.w	d2,d0
	move.w	d2,d3
	move.w	d2,d5
NotPortaUpAll:	btst	#TCTCB_OpSlide,tct_CompFlags(a1)
	bne.s	NotPortaUpOpposite
	move.w	d2,phc_PortaDownValue(a3)
	move.w	d0,d1
	move.w	d3,d4
	move.w	d5,a0
NotPortaUpOpposite:	move.w	d2,phc_PortaUpValue(a3)
	movem.w	d0-d1/d3-d5/a0,phc_FinePortaUpValue(a3)
	btst	#TCTCB_TPorta,tct_CompFlags(a1)
	beq.s	PortaUpDone
	movem.w	phc_FineTonePortaValue(a3),d1/d4/a0
	btst	#TCTCB_Slide,tct_CompFlags(a1)
	beq.s	NotPortaUpAllTPorta
	move.w	d0,d1
	move.w	d3,d4
	move.w	d5,a0
NotPortaUpAllTPorta:	move.w	d2,d0
	movem.w	d0-d1/d4/a0,phc_TonePortaValue(a3)
PortaUpDone:	rts
	dc.w	CheckPorta-PortaUpOnce+2
PortaUpOnce:	bne.s	OldPortaUpOnceVal
	move.w	phc_PortaUpOnceValue(a3),d2
OldPortaUpOnceVal:	moveq	#16,d1
	moveq	#8-4,d4
	bsr.s	PortaSlideUp
	move.l	phc_Track(a3),a1
	btst	#TCTCB_VolPitch,tct_CompFlags(a1)
	beq.s	PortaUpOnceOk
	bsr	FVolSlUpOk
PortaUpOnceOk:	movem.w	phc_PortaUpValue(a3),d0-d1/d3-d4
	movem.w	phc_FinePortaUpOnceValue(a3),d5/a0
	btst	#TCTCB_Slide,tct_CompFlags(a1)
	beq.s	NotPortaUpOnceAll
	move.w	d2,d0
	move.w	d2,d3
	move.w	d2,d5
NotPortaUpOnceAll:	btst	#TCTCB_OpSlide,tct_CompFlags(a1)
	bne.s	NotPortaUpOnceOpposite
	move.w	d2,phc_PortaDownOnceValue(a3)
	move.w	d0,d1
	move.w	d3,d4
	move.w	d5,a0
NotPortaUpOnceOpposite:	move.w	d2,phc_PortaUpOnceValue(a3)
	movem.w	d0-d1/d3-d4,phc_PortaUpValue(a3)
	movem.w	d5/a0,phc_FinePortaUpOnceValue(a3)
	btst	#TCTCB_TPorta,tct_CompFlags(a1)
	beq.s	PortaUpOnceDone
	movem.w	phc_TonePortaValue(a3),d1/d4
	move.w	phc_FineTonePortaOnceValue(a3),a0
	btst	#TCTCB_Slide,tct_CompFlags(a1)
	beq.s	NotPortaUpOnceAllTPorta
	move.w	d0,d1
	move.w	d3,d4
	move.w	d5,a0
NotPortaUpOnceAllTPorta:	movem.w	d1/d4,phc_TonePortaValue(a3)
	movem.w	d2/a0,phc_TonePortaOnceValue(a3)
PortaUpOnceDone:	rts
DoPortaSlideUp:	neg.l	d2
PortaSlideUp:	cmp.w	pc_HostChannel(a2),d7
	bne.s	PortaUpOnceDone
	move.l	d2,d3
	clr.b	d3
	lsr.l	d4,d3
	beq.s	PortaUpOnceDone
	add.b	d2,phc_SubSlideValue(a3)
	bcc.s	NotAddPortaUpSubSlide
	add.l	d1,d3
NotAddPortaUpSubSlide:	move.l	pc_Frequency(a2),d5
	beq.s	PortaUpOnceDone
	btst	#PHCB_LinearFreq,phc_Flags+3(a3)
	bne.s	LinearSlideUp
AmigaSlideUp:	move.l	#SLIDE_CONST,d0
	move.l	d0,d1
	divu.l	d5,d1
	sub.l	d3,d1
	bhi.s	PortaSlUpFreqOk
	moveq	#-1,d0
	bra.s	PutPortaUpFrequency
PortaSlUpFreqOk:	divu.l	d1,d0
PutPortaUpFrequency:	move.l	d0,pc_Frequency(a2)
	rts
LinearSlideUp:	move.l	d2,-(sp)
	move.l	d5,d0
	moveq	#1,d2
	swap	d2
	move.l	tcb_LinearFreqTable(a6),a0
	divu.w	#3072,d3
	move.w	d3,d1
	swap	d3
	move.w	(a0,d3.w*2),d2
	lsl.l	d1,d2
	move.l	d2,d1
	bsr	MULU64
	move.w	d1,d0
	swap	d0
	swap	d1
	tst.w	d1
	beq.s	LinearSlideUpOk
	moveq	#-1,d0
LinearSlideUpOk:	move.l	(sp)+,d2
	move.l	d0,pc_Frequency(a2)
	rts
	dc.w	CheckPorta-FPortaUp+2
FPortaUp:	bne.s	OldFPortaUpVal
	move.w	phc_FinePortaUpValue(a3),d2
OldFPortaUpVal:	moveq	#1,d1
	moveq	#8,d4
	bsr	PortaSlideUp
	move.l	phc_Track(a3),a1
	btst	#TCTCB_VolPitch,tct_CompFlags(a1)
	beq.s	FPortaUpOk
	bsr	VolSlUpOk
FPortaUpOk:	movem.w	phc_PortaUpValue(a3),d0-d1
	movem.w	phc_PortaUpOnceValue(a3),d3-d5/a0
	btst	#TCTCB_Slide,tct_CompFlags(a1)
	beq.s	NotFPortaUpAll
	move.w	d2,d0
	move.w	d2,d3
	move.w	d2,d5
NotFPortaUpAll:	btst	#TCTCB_OpSlide,tct_CompFlags(a1)
	bne.s	NotFPortaUpOpposite
	move.w	d2,phc_FinePortaDownValue(a3)
	move.w	d0,d1
	move.w	d3,d4
	move.w	d5,a0
NotFPortaUpOpposite:	movem.w	d0-d2,phc_PortaUpValue(a3)
	movem.w	d3-d5/a0,phc_PortaUpOnceValue(a3)
	btst	#TCTCB_TPorta,tct_CompFlags(a1)
	beq.s	FPortaUpDone
	move.w	phc_TonePortaValue(a3),d1
	movem.w	phc_TonePortaOnceValue(a3),d4/a0
	btst	#TCTCB_Slide,tct_CompFlags(a1)
	beq.s	NotFPortaUpAllTPorta
	move.w	d0,d1
	move.w	d3,d4
	move.w	d5,a0
NotFPortaUpAllTPorta:	movem.w	d1-d2/d4/a0,phc_TonePortaValue(a3)
FPortaUpDone:	rts
	dc.w	CheckPorta-FPortaUpOnce+2
FPortaUpOnce:	bne.s	OldFPortaUpOnceVal
	move.w	phc_FinePortaUpOnceValue(a3),d2
OldFPortaUpOnceVal:	moveq	#1,d1
	moveq	#8,d4
	bsr	PortaSlideUp
	move.l	phc_Track(a3),a1
	btst	#TCTCB_VolPitch,tct_CompFlags(a1)
	beq.s	FPortaUpOnceOk
	bsr	FVolSlUpOk
FPortaUpOnceOk:	movem.w	phc_PortaUpValue(a3),d0-d1/d3-d5/a0
	btst	#TCTCB_Slide,tct_CompFlags(a1)
	beq.s	NotFPortaUpOnceAll
	move.w	d2,d0
	move.w	d2,d3
	move.w	d2,d5
NotFPortaUpOnceAll:	btst	#TCTCB_OpSlide,tct_CompFlags(a1)
	bne.s	NotFPortaUpOnceOpposite
	move.w	d2,phc_FinePortaDownOnceValue(a3)
	move.w	d0,d1
	move.w	d3,d4
	move.w	d5,a0
NotFPortaUpOnceOpposite:	move.w	d2,phc_FinePortaUpOnceValue(a3)
	movem.w	d0-d1/d3-d5/a0,phc_PortaUpValue(a3)
	btst	#TCTCB_TPorta,tct_CompFlags(a1)
	beq.s	FPortaUpOnceDone
	movem.w	phc_TonePortaValue(a3),d1/d4/a0
	btst	#TCTCB_Slide,tct_CompFlags(a1)
	beq.s	NotFPortaUpOnceAllTPorta
	move.w	d0,d1
	move.w	d3,d4
	move.w	d5,a0
NotFPortaUpOnceAllTPorta:	movem.w	d1/d4/a0,phc_TonePortaValue(a3)
	move.w	d2,phc_FineTonePortaOnceValue(a3)
FPortaUpOnceDone:	rts
	dc.w	CheckPorta-PortaDn+2
PortaDn:	bne.s	OldPortaDnVal
	move.w	phc_PortaDownValue(a3),d2
OldPortaDnVal:	moveq	#16,d1
	moveq	#8-4,d4
	bsr	PortaSlideDn
	move.l	phc_Track(a3),a1
	btst	#TCTCB_VolPitch,tct_CompFlags(a1)
	beq.s	PortaDnOk
	bsr	VolSlDnOk
PortaDnOk:	movem.w	phc_FinePortaUpValue(a3),d0-d1/d3-d5/a0
	btst	#TCTCB_Slide,tct_CompFlags(a1)
	beq.s	NotPortaDnAll
	move.w	d2,d1
	move.w	d2,d4
	move.w	d2,a0
NotPortaDnAll:	btst	#TCTCB_OpSlide,tct_CompFlags(a1)
	bne.s	NotPortaDnOpposite
	move.w	d2,phc_PortaUpValue(a3)
	move.w	d1,d0
	move.w	d4,d3
	move.w	a0,d5
NotPortaDnOpposite:	move.w	d2,phc_PortaDownValue(a3)
	movem.w	d0-d1/d3-d5/a0,phc_FinePortaUpValue(a3)
	btst	#TCTCB_TPorta,tct_CompFlags(a1)
	beq.s	PortaDnDone
	movem.w	phc_FineTonePortaValue(a3),d0/d3/d5
	btst	#TCTCB_Slide,tct_CompFlags(a1)
	beq.s	NotPortaDnAllTPorta
	move.w	d1,d0
	move.w	d4,d3
	move.w	a0,d5
NotPortaDnAllTPorta:	exg	d2,d0
	movem.w	d0/d2-d3/d5,phc_TonePortaValue(a3)
PortaDnDone:	rts
	dc.w	CheckPorta-PortaDnOnce+2
PortaDnOnce:	bne.s	OldPortaDnOnceVal
	move.w	phc_PortaDownOnceValue(a3),d2
OldPortaDnOnceVal:	moveq	#16,d1
	moveq	#8-4,d4
	bsr.s	PortaSlideDn
	move.l	phc_Track(a3),a1
	btst	#TCTCB_VolPitch,tct_CompFlags(a1)
	beq.s	PortaDnOnceOk
	bsr	FVolSlDnOk
PortaDnOnceOk:	movem.w	phc_PortaUpValue(a3),d0-d1/d3-d4
	movem.w	phc_FinePortaUpOnceValue(a3),d5/a0
	btst	#TCTCB_Slide,tct_CompFlags(a1)
	beq.s	NotPortaDnOnceAll
	move.w	d2,d1
	move.w	d2,d4
	move.w	d2,a0
NotPortaDnOnceAll:	btst	#TCTCB_OpSlide,tct_CompFlags(a1)
	bne.s	NotPortaDnOnceOpposite
	move.w	d2,phc_PortaUpOnceValue(a3)
	move.w	d1,d0
	move.w	d4,d3
	move.w	a0,d5
NotPortaDnOnceOpposite:	move.w	d2,phc_PortaDownOnceValue(a3)
	movem.w	d0-d1/d3-d4,phc_PortaUpValue(a3)
	movem.w	d5/a0,phc_FinePortaUpOnceValue(a3)
	btst	#TCTCB_TPorta,tct_CompFlags(a1)
	beq.s	PortaDnOnceDone
	movem.w	phc_TonePortaValue(a3),d0/d3
	move.w	phc_FineTonePortaOnceValue(a3),d5
	btst	#TCTCB_Slide,tct_CompFlags(a1)
	beq.s	NotPortaDnOnceAllTPorta
	move.w	d1,d0
	move.w	d4,d3
	move.w	a0,d5
NotPortaDnOnceAllTPorta:	move.w	d2,d4
	movem.w	d0/d3-d5,phc_TonePortaValue(a3)
PortaDnOnceDone:	rts
PortaSlideDn:	cmp.w	pc_HostChannel(a2),d7
	bne.s	PortaDnOnceDone
	move.l	d2,d3
	bmi	DoPortaSlideUp
	clr.b	d3
	lsr.l	d4,d3
	beq.s	PortaDnOnceDone
	sub.b	d2,phc_SubSlideValue(a3)
	bcc.s	NotSubPortaDnSubSlide
	add.l	d1,d3
	bcc.s	NotSubPortaDnSubSlide
	moveq	#-1,d3
NotSubPortaDnSubSlide:	move.l	pc_Frequency(a2),d5
	beq.s	PortaDnOnceDone
	btst	#PHCB_LinearFreq,phc_Flags+3(a3)
	bne.s	LinearSlideDn
AmigaSlideDn:	move.l	#SLIDE_CONST,d0
	move.l	d0,d1
	divu.l	d5,d1
	add.l	d3,d1
	bcc.s	PortaSlDnFreqOk
	moveq	#0,d0
	bra.s	PortaDnFreqOk
PortaSlDnFreqOk:	divu.l	d1,d0
PutPortaDnFrequency:	cmp.l	d5,d0
	bne.s	PortaDnFreqOk
	subq.l	#1,d0
	bcc.s	PortaDnFreqOk
	moveq	#0,d0
PortaDnFreqOk:	move.l	d0,pc_Frequency(a2)
	rts
LinearSlideDn:	move.l	d2,-(sp)
	move.l	d5,d0
	moveq	#1,d2
	swap	d2
	move.l	tcb_LinearFreqTable(a6),a0
	divu.w	#3072,d3
	move.w	d3,d1
	swap	d3
	tst.w	d3
	bne.s	LinearSlideNormDn
	add.l	d2,d2
LinearSlideNormDn:	neg.w	d3
	add.w	#3072,d3
	move.w	(a0,d3.w*2),d2
	move.l	d1,a0
	move.l	d2,d1
	bsr	MULU64
	move.l	d1,d3
	move.l	a0,d1
	move.w	d3,d0
	swap	d0
	addq.w	#1,d1
	lsr.l	d1,d0
	move.l	(sp)+,d2
	move.l	d0,pc_Frequency(a2)
	rts
	dc.w	CheckPorta-FPortaDn+2
FPortaDn:	bne.s	OldFPortaDnVal
	move.w	phc_FinePortaDownValue(a3),d2
OldFPortaDnVal:	moveq	#1,d1
	moveq	#8,d4
	bsr	PortaSlideDn
	move.l	phc_Track(a3),a1
	btst	#TCTCB_VolPitch,tct_CompFlags(a1)
	beq.s	FPortaDnOk
	bsr	VolSlDnOk
FPortaDnOk:	movem.w	phc_PortaUpValue(a3),d0-d1
	movem.w	phc_PortaUpOnceValue(a3),d3-d5/a0
	btst	#TCTCB_Slide,tct_CompFlags(a1)
	beq.s	NotFPortaDnAll
	move.w	d2,d1
	move.w	d2,d4
	move.w	d2,a0
NotFPortaDnAll:	btst	#TCTCB_OpSlide,tct_CompFlags(a1)
	bne.s	NotFPortaDnOpposite
	move.w	d2,phc_FinePortaUpValue(a3)
	move.w	d1,d0
	move.w	d4,d3
	move.w	a0,d5
NotFPortaDnOpposite:	movem.w	d0-d1,phc_PortaUpValue(a3)
	movem.w	d2-d5/a0,phc_FinePortaDownValue(a3)
	btst	#TCTCB_TPorta,tct_CompFlags(a1)
	beq.s	FPortaDnDone
	move.w	phc_TonePortaValue(a3),d0
	movem.w	phc_TonePortaOnceValue(a3),d3/d5
	btst	#TCTCB_Slide,tct_CompFlags(a1)
	beq.s	NotFPortaDnAllTPorta
	move.w	d1,d0
	move.w	d4,d3
	move.w	a0,d5
NotFPortaDnAllTPorta:	movem.w	d0/d2-d3/d5,phc_TonePortaValue(a3)
FPortaDnDone:	rts
	dc.w	CheckPorta-FPortaDnOnce+2
FPortaDnOnce:	bne.s	OldFPortaDnOnceVal
	move.w	phc_FinePortaDownOnceValue(a3),d2
OldFPortaDnOnceVal:	moveq	#1,d1
	moveq	#8,d4
	bsr	PortaSlideDn
	move.l	phc_Track(a3),a1
	btst	#TCTCB_VolPitch,tct_CompFlags(a1)
	beq.s	FPortaDnOnceOk
	bsr	FVolSlDnOk
FPortaDnOnceOk:	movem.w	phc_PortaUpValue(a3),d0-d1/d3-d5/a0
	btst	#TCTCB_Slide,tct_CompFlags(a1)
	beq.s	NotFPortaDnOnceAll
	move.w	d2,d0
	move.w	d2,d3
	move.w	d2,d5
NotFPortaDnOnceAll:	btst	#TCTCB_OpSlide,tct_CompFlags(a1)
	bne.s	NotFPortaDnOnceOpposite
	move.w	d2,phc_FinePortaUpOnceValue(a3)
	move.w	d0,d1
	move.w	d3,d4
	move.w	d5,a0
NotFPortaDnOnceOpposite:	move.w	d2,phc_FinePortaDownOnceValue(a3)
	movem.w	d0-d1/d3-d5/a0,phc_PortaUpValue(a3)
	btst	#TCTCB_TPorta,tct_CompFlags(a1)
	beq.s	FPortaDnOnceDone
	movem.w	phc_TonePortaValue(a3),d0/d3/d5
	btst	#TCTCB_Slide,tct_CompFlags(a1)
	beq.s	NotFPortaDnOnceAllTPorta
	move.w	d1,d0
	move.w	d4,d3
	move.w	a0,d5
NotFPortaDnOnceAllTPorta:	move.w	d2,d4
	movem.w	d0/d3-d5,phc_TonePortaValue(a3)
FPortaDnOnceDone:	rts
PresetTonePorta:	bset	#PHCB_TonePorta-8,phc_Flags+2(a3)
	rts
CheckTonePorta:	rts
	dc.w	PresetTonePorta-TonePorta
	dc.w	CheckTonePorta-TonePorta+2
TonePorta:	bne.s	OldTonePortaVal
	move.w	phc_TonePortaValue(a3),d2
OldTonePortaVal:	move.l	phc_TonePortaTargetPitch(a3),d6
	beq.s	FPortaDnOnceDone
	cmp.w	pc_HostChannel(a2),d7
	bne.s	UpdateTPortaMemory
	moveq	#16,d1
	moveq	#8-4,d4
	cmp.l	pc_Frequency(a2),d6
	bhi.s	TonePortaUp
	bsr	PortaSlideDn
	cmp.l	pc_Frequency(a2),d6
	blo.s	UpdateTPortaMemory
TPortaPitchDone:	move.l	d6,pc_Frequency(a2)
	clr.l	phc_TonePortaTargetPitch(a3)
	bra.s	UpdateTPortaMemory
TonePortaUp:	bsr	PortaSlideUp
	move.l	pc_Frequency(a2),d0
	beq.s	TPortaPitchDone
	cmp.l	d0,d6
	bls.s	TPortaPitchDone
UpdateTPortaMemory:	move.l	phc_Track(a3),a1
	movem.w	phc_FineTonePortaValue(a3),d0-d1/d3
	btst	#TCTCB_Slide,tct_CompFlags(a1)
	beq.s	NotTPortaAll
	move.w	d2,d0
	move.w	d2,d1
	move.w	d2,d3
NotTPortaAll:	move.w	d2,phc_TonePortaValue(a3)
	movem.w	d0-d1/d3,phc_FineTonePortaValue(a3)
	btst	#TCTCB_TPorta,tct_CompFlags(a1)
	beq.s	NotTPortaAffect
	move.w	d2,d0
	move.w	d2,d1
	move.w	d2,d3
	move.w	d2,d4
	move.w	d2,d5
	move.w	d2,a0
	move.w	d2,a1
	movem.w	d0-d5/a0-a1,phc_PortaUpValue(a3)
NotTPortaAffect:	rts
	dc.w	PresetTonePorta-FTonePorta
	dc.w	CheckTonePorta-FTonePorta+2
FTonePorta:	bne.s	OldFTonePortaVal
	move.w	phc_FineTonePortaValue(a3),d2
OldFTonePortaVal:	move.l	phc_TonePortaTargetPitch(a3),d6
	beq.s	NotTPortaAffect
	cmp.w	pc_HostChannel(a2),d7
	bne.s	UpdateFTPortaMemory
	moveq	#1,d1
	moveq	#8,d4
	cmp.l	pc_Frequency(a2),d6
	bhi.s	FTonePortaUp
	bsr	PortaSlideDn
	cmp.l	pc_Frequency(a2),d6
	blo.s	UpdateFTPortaMemory
FTPortaPitchDone:	move.l	d6,pc_Frequency(a2)
	clr.l	phc_TonePortaTargetPitch(a3)
	bra.s	UpdateFTPortaMemory
FTonePortaUp:	bsr	PortaSlideUp
	move.l	pc_Frequency(a2),d0
	beq.s	FTPortaPitchDone
	cmp.l	d0,d6
	bls.s	FTPortaPitchDone
UpdateFTPortaMemory:	move.l	phc_Track(a3),a1
	movem.w	phc_TonePortaValue(a3),d0-d1/d3-d4
	btst	#TCTCB_Slide,tct_CompFlags(a1)
	beq.s	NotFTPortaAll
	move.w	d2,d0
	move.w	d2,d3
	move.w	d2,d4
NotFTPortaAll:	movem.w	d0/d2-d4,phc_TonePortaValue(a3)
	btst	#TCTCB_TPorta,tct_CompFlags(a1)
	beq.s	NotFTPortaAffect
	move.w	d2,d0
	move.w	d2,d1
	move.w	d2,d3
	move.w	d2,d4
	move.w	d2,d5
	move.w	d2,a0
	move.w	d2,a1
	movem.w	d0-d5/a0-a1,phc_PortaUpValue(a3)
NotFTPortaAffect:	rts
	dc.w	PresetTonePorta-TPortaOnce
	dc.w	CheckTonePorta-TPortaOnce+2
TPortaOnce:	bne.s	OldTonePortaOnceVal
	move.w	phc_TonePortaOnceValue(a3),d2
OldTonePortaOnceVal:	move.l	phc_TonePortaTargetPitch(a3),d6
	beq.s	NotFTPortaAffect
	cmp.w	pc_HostChannel(a2),d7
	bne.s	UpdateTPortaOnceMemory
	moveq	#16,d1
	moveq	#8-4,d4
	cmp.l	pc_Frequency(a2),d6
	bhi.s	TonePortaOnceUp
	bsr	PortaSlideDn
	cmp.l	pc_Frequency(a2),d6
	blo.s	UpdateTPortaOnceMemory
TPortaOncePitchDone:	move.l	d6,pc_Frequency(a2)
	clr.l	phc_TonePortaTargetPitch(a3)
	bra.s	UpdateTPortaOnceMemory
TonePortaOnceUp:	bsr	PortaSlideUp
	move.l	pc_Frequency(a2),d0
	beq.s	TPortaOncePitchDone
	cmp.l	d0,d6
	bls.s	TPortaOncePitchDone
UpdateTPortaOnceMemory:	move.l	phc_Track(a3),a1
	movem.w	phc_TonePortaValue(a3),d0-d1/d3-d4
	btst	#TCTCB_Slide,tct_CompFlags(a1)
	beq.s	NotTPortaOnceAll
	move.w	d2,d0
	move.w	d2,d1
	move.w	d2,d4
NotTPortaOnceAll:	movem.w	d0-d2/d4,phc_TonePortaValue(a3)
	btst	#TCTCB_TPorta,tct_CompFlags(a1)
	beq.s	NotTPortaOnceAffect
	move.w	d2,d0
	move.w	d2,d1
	move.w	d2,d3
	move.w	d2,d4
	move.w	d2,d5
	move.w	d2,a0
	move.w	d2,a1
	movem.w	d0-d5/a0-a1,phc_PortaUpValue(a3)
NotTPortaOnceAffect:	rts
	dc.w	PresetTonePorta-FTPortaOnce
	dc.w	CheckTonePorta-FTPortaOnce+2
FTPortaOnce:	bne.s	OldFTonePortaOnceVal
	move.w	phc_FineTonePortaOnceValue(a3),d2
OldFTonePortaOnceVal:	move.l	phc_TonePortaTargetPitch(a3),d6
	beq.s	NotTPortaOnceAffect
	cmp.w	pc_HostChannel(a2),d7
	bne.s	UpdateFTPortaOnceMemory
	moveq	#1,d1
	moveq	#8,d4
	cmp.l	pc_Frequency(a2),d6
	bhi.s	FTonePortaOnceUp
	bsr	PortaSlideDn
	cmp.l	pc_Frequency(a2),d6
	blo.s	UpdateFTPortaOnceMemory
FTPortaOncePitchDone:	move.l	d6,pc_Frequency(a2)
	clr.l	phc_TonePortaTargetPitch(a3)
	bra.s	UpdateFTPortaOnceMemory
FTonePortaOnceUp:	bsr	PortaSlideUp
	move.l	pc_Frequency(a2),d0
	beq.s	FTPortaOncePitchDone
	cmp.l	d0,d6
	bls.s	FTPortaOncePitchDone
UpdateFTPortaOnceMemory:	move.l	phc_Track(a3),a1
	movem.w	phc_TonePortaValue(a3),d0-d1/d3-d4
	btst	#TCTCB_Slide,tct_CompFlags(a1)
	beq.s	NotFTPortaOnceAll
	move.w	d2,d0
	move.w	d2,d1
	move.w	d2,d3
NotFTPortaOnceAll:	move.w	d2,d4
	movem.w	d0-d1/d3-d4,phc_TonePortaValue(a3)
	btst	#TCTCB_TPorta,tct_CompFlags(a1)
	beq.s	NotFTPortaOnceAffect
	move.w	d2,d0
	move.w	d2,d1
	move.w	d2,d3
	move.w	d2,d4
	move.w	d2,d5
	move.w	d2,a0
	move.w	d2,a1
	movem.w	d0-d5/a0-a1,phc_PortaUpValue(a3)
NotFTPortaOnceAffect:	rts
CheckNoteSlide:	move.b	tcte_DataWord(a0),d2
	bne.s	CheckNoteSlTypeOk
	move.b	phc_NoteSlideType(a3),d2
CheckNoteSlTypeOk:	and.b	#$f,d2
	beq.s	CheckNoteSlideDone
	bclr	#4,d4
CheckNoteSlideDone:	rts
	dc.w	CheckNoteSlide-NoteSlide+2
NoteSlide:	move.b	d2,d0
	bne.s	NoteSlideValueOk
	move.b	phc_NoteSlideValue(a3),d0
NoteSlideValueOk:	move.b	d0,phc_NoteSlideValue(a3)
	lsr.w	#8,d2
	bne.s	NoteSlideTypeOk
	move.b	phc_NoteSlideType(a3),d2
NoteSlideTypeOk:	move.b	d2,phc_NoteSlideType(a3)
	lsr.b	#4+1,d2
	bcs.s	NoteSlideDirOk
	neg.w	d0
NoteSlideDirOk:	move.w	d0,d1
	add.w	phc_FinalNote(a3),d1
	move.w	d1,phc_FinalNote(a3)
	cmp.w	pc_HostChannel(a2),d7
	bne.s	NotNoteSlHostChan
	bsr	GetTonePitch
	move.l	d0,pc_Frequency(a2)
NotNoteSlHostChan:	rts
PresetVibrato:	bset	#PHCB_Vibrato-8,phc_Flags+2(a3)
	rts
	dc.w	PresetVibrato-Vibrato
	dc.w	0
Vibrato:	move.w	d2,d4
	lsr.w	#8,d4
	bne.s	NotPrevVibSpd
	move.w	phc_VibratoRate(a3),d4
NotPrevVibSpd:	move.w	d4,phc_VibratoRate(a3)
	ext.w	d2
	asl.w	#2,d2
DoVibrato:	bne.s	NotPrevVibDepth
	move.w	phc_VibratoDepth(a3),d2
NotPrevVibDepth:	move.w	d2,phc_VibratoDepth(a3)
	neg.w	d2
	move.w	d2,-(sp)
	moveq	#0,d5
	lea	phc_VibratoEnv(a3),a0
	bsr	RunEnvelope
	muls.w	(sp)+,d0
	asr.l	#7-2,d0
	asl.l	#8,d0
RunVibrato:	cmp.w	pc_HostChannel(a2),d7
	bne.s	NotNoteSlHostChan
	moveq	#1,d1
	moveq	#8,d4
	move.l	phc_VibratoSlideValue(a3),d2
	move.l	pc_Frequency(a2),d6
	sub.l	d2,pc_Frequency(a2)
	move.l	d0,d2
	bsr	PortaSlideDn
	sub.l	pc_Frequency(a2),d6
	sub.l	d6,phc_VibratoSlideValue(a3)
	rts
	dc.w	PresetVibrato-FVibrato
	dc.w	0
FVibrato:	move.w	d2,d4
	lsr.w	#8,d4
	bne.s	NotPrevFVibSpd
	move.w	phc_VibratoRate(a3),d4
NotPrevFVibSpd:	move.w	d4,phc_VibratoRate(a3)
	ext.w	d2
	bra.s	DoVibrato
DoKeyOff:	cmp.l	d3,d2
	blo.s	NotNoteFade
	bra	PlayKeyOff
HoldDelay:
	rts
NoteFade:	cmp.l	d3,d2
	blo.s	NotNoteFade
	bfset	phc_EffectsUsed(a3){d0:1}
	cmp.w	pc_HostChannel(a2),d7
	bne.s	NotNoteFade
	bset	#PCB_Fading,pc_Flags+1(a2)
NotNoteFade:	rts
NoteCut:	move.w	d2,d0
	and.w	#$fff,d2
	cmp.l	d3,d2
	blo.s	NotNoteFade
	bfset	phc_EffectsUsed(a3){d0:1}
	cmp.w	pc_HostChannel(a2),d7
	bne.s	NotNoteFade
	clr.w	pc_Volume(a2)
	and.w	#$f000,d0
	beq.s	NotNoteFade
	clr.l	phc_Instrument(a3)
	clr.l	phc_Sample(a3)
	clr.b	ms_Flags(a2)
	rts
PresetNoteDelay:	move.w	tcte_DataWord(a0),phc_NoteDelay(a3)
	beq.s	NoteDelay
	bset	#PHCB_ExecFX,phc_Flags+3(a3)
	bne.s	NoteDelay
	move.w	phc_NoteDelay(a3),phc_ExecFX(a3)
	rts
	dc.w	PresetNoteDelay-NoteDelay
	dc.w	0
NoteDelay:	rts
Tremor:	bset	#PHCB_TremorExec-8,phc_Flags+2(a3)
	move.b	d2,d0
	bne.s	TremorOffOk
	move.b	phc_TremorOffTicks(a3),d0
TremorOffOk:	move.b	d0,phc_TremorOffTicks(a3)
	lsr.w	#8,d2
	bne.s	TremorOnOk
	move.b	phc_TremorOnTicks(a3),d2
TremorOnOk:	move.b	d2,phc_TremorOnTicks(a3)
	btst	#PHCB_TremorOff-8,phc_Flags+2(a3)
	bne.s	TremorSwapOk
	move.b	d2,d0
TremorSwapOk:	cmp.b	phc_TremorCount(a3),d0
	bhi.s	TremorNotChange
	bchg	#PHCB_TremorOff-8,phc_Flags+2(a3)
	clr.b	phc_TremorCount(a3)
TremorNotChange:	addq.b	#1,phc_TremorCount(a3)
	rts
MulRetrig:	move.b	d2,d0
	lsr.w	#8,d2
	bne.s	NotMRTickNull
	move.b	phc_MultiRetrigTick(a3),d2
NotMRTickNull:	move.b	d2,phc_MultiRetrigTick(a3)
	tst.b	d0
	bne.s	NotMRVolChgNull
	move.b	phc_MultiRetrigVolChg(a3),d0
NotMRVolChgNull:	move.b	d0,phc_MultiRetrigVolChg(a3)
	move.w	phc_RetrigTickCount(a3),d3
	bne.s	RetrigNext
	bclr	#PHCB_RetrigNote-8,phc_Flags+2(a3)
	bne.s	RetrigIt
	cmp.w	pc_HostChannel(a2),d7
	bne.s	RetrigIt
	tst.b	d0
	bmi.s	AddSubMRVolume
	moveq	#0,d5
	move.w	pc_Volume(a2),d5
	btst	#PHCB_SubSlideRetrig-8,phc_Flags+2(a3)
	bne.s	SubSlideMROk
	clr.b	d5
SubSlideMROk:	move.b	d0,d1
	beq.s	RetrigIt
	lsr.w	#4,d0
	beq.s	NotMRMul
	mulu.w	d0,d5
NotMRMul:	and.w	#$f,d1
	bne.s	MRDivValOk
	moveq	#1,d1
MRDivValOk:	divu.w	d1,d5
	bvc.s	MRDivOk
	moveq	#-1,d5
MRDivOk:	btst	#PHCB_SubSlideRetrig-8,phc_Flags+2(a3)
	bne.s	WriteSubSlideMR
	lsr.w	#8,d5
	move.b	d5,pc_Volume(a2)
	bra.s	RetrigIt
WriteSubSlideMR:	move.w	d5,pc_Volume(a2)
Retrig:	bclr	#15,d2
	beq.s	RetrigIt
	tst.w	d2
	beq.s	RetrigIt
	move.w	phc_Tempo(a3),d3
	divu.w	d2,d3
	move.w	d3,d2
RetrigIt:	move.w	phc_RetrigTickCount(a3),d3
	beq.s	DoRetrig
RetrigNext:	subq.w	#1,d2
	beq.s	DoRetrig
	cmp.w	d3,d2
	bhi.s	RetrigDone
	moveq	#-1,d3
	bra.s	RetrigDone
DoRetrig:	cmp.w	pc_HostChannel(a2),d7
	bne.s	RetrigDone
	clr.l	(a2)
RetrigDone:	addq.w	#1,d3
	move.w	d3,phc_RetrigTickCount(a3)
	rts
AddSubMRVolume:	moveq	#4,d4
	btst	#TCSOCB_OldVolumes,tcso_CompFlags(a4)
	bne.s	NotMRScaleVol
	move.b	phc_MultiRetrigScale(a3),d4
NotMRScaleVol:	sub.b	#$bf,d0
	bls.s	AddScaleVol
	mulu.w	d4,d0
	cmp.w	#$100,d0
	beq.s	ZeroMRVol
	sub.b	d0,pc_Volume(a2)
	bcc.s	RetrigIt
ZeroMRVol:	clr.w	pc_Volume(a2)
	bra.s	RetrigIt
AddScaleVol:	add.b	#$40,d0
	mulu.w	d4,d0
	cmp.w	#$100,d0
	beq.s	FullMRVol
	add.b	d0,pc_Volume(a2)
	bcc.s	RetrigIt
FullMRVol:	move.w	#-1,pc_Volume(a2)
	bra.s	RetrigIt
ExtCtrl:	beq.s	SetUseLinFreq
	move.w	d2,d0
	and.w	#$fff,d2
	clr.b	d0
	rol.w	#4,d0
	beq.s	NotUseLinFreq
	subq.b	#1,d0
	beq.s	SetGlissCtrl
	subq.b	#1,d0
	beq.s	MulRetrigCtrl
	subq.b	#6-2,d0
	bcs.s	PastNNACtrl
	beq.s	UnknownExtCtrl
	move.b	d2,phc_SubSlideValue(a3)
UnknownExtCtrl:	rts
SetGlissCtrl:	move.b	d2,phc_GlissandoValue(a3)
	rts
MulRetrigCtrl:	move.w	d2,d1
	swap	d1
	rol.l	#8,d1
	subq.b	#1,d1
	bcs.s	SetMulRetrigAmp
	beq.s	SetMulRetrigSubSlide
	subq.b	#1,d1
	bne.s	SubSlideRetrigClr
	move.b	d2,d0
	beq.s	SubSlideRetrigClr
	moveq	#0,d1
	move.w	phc_Tempo(a3),d1
	divu.w	d0,d1
	move.b	d1,phc_MultiRetrigTick(a3)
	rts
SetMulRetrigSubSlide:	bclr	#PHCB_SubSlideRetrig-8,phc_Flags+2(a3)
	tst.b	d2
	beq.s	SubSlideRetrigClr
	bset	#PHCB_SubSlideRetrig-8,phc_Flags+2(a3)
SubSlideRetrigClr:	rts
SetMulRetrigAmp:	tst.b	d2
	bne.s	RetrigAmpOk
	moveq	#1,d2
RetrigAmpOk:	cmp.b	#4,d2
	bls.s	RetrigAmpMax
	moveq	#4,d2
RetrigAmpMax:	move.b	d2,phc_MultiRetrigScale(a3)
	rts
NotUseLinFreq:	bclr	#PHCB_LinearFreq,phc_Flags+3(a3)
	rts
SetUseLinFreq:	bset	#PHCB_LinearFreq,phc_Flags+3(a3)
	rts
PastNNACtrl:	move.l	tcm_ChannelData(a5),a0
	move.b	d0,d3
	moveq	#0,d5
ScanPastNNALoop:	cmp.w	pc_HostChannel(a0),d7
	bne.s	NotCorrectPastNNA
	tst.b	pc_Flags+1(a0)
	bpl.s	NotCorrectPastNNA
	cmp.b	#1-4,d3
	beq.s	CutPastNote
	cmp.b	#2-4,d3
	beq.s	FadePastNote
NoteOffPastNote:	movem.l	d3/a2,-(sp)
	move.l	a0,a2
	bsr	PlayKeyOff
	move.l	a2,a0
	movem.l	(sp)+,d3/a2
	bra.s	NotCorrectPastNNA
FadePastNote:	bset	#PCB_Fading,pc_Flags+1(a0)
	bra.s	NotCorrectPastNNA
CutPastNote:	clr.b	ms_Flags(a0)
NotCorrectPastNNA:	lea	pc_PlayerChannelx(a0),a0
	addq.w	#1,d5
	cmp.w	tcm_Channels(a5),d5
	bne.s	ScanPastNNALoop
	rts
InvLoop:
	rts
ExecFX:	bset	#PHCB_ExecFX,phc_Flags+3(a3)
	move.w	d2,phc_ExecFX(a3)
	rts
StopFX:	move.b	d2,d0
	bpl.s	StopFXOk
	moveq	#127,d0
StopFXOk:	lsr.w	#8,d2
	bne.s	NotStopZero
	move.w	phc_ExecFX(a3),d2
NotStopZero:	cmp.l	d3,d2
	blo.s	StopFXDone
	bfset	phc_EffectsUsed(a3){d0:1}
StopFXDone:	rts
CheckVolSlide:	tst.w	tcte_DataWord(a0)
	beq.s	TriggerFineVol
	and.w	#~(FSF_VolSlideDown|FSF_FineVolSlideDown|FSF_FineVolSlide),phc_FineSlideFlags+2(a3)
	move.w	VolSlideMask-(FX_VOL_SLD_UP*2)(pc,d0.w*2),d1
	or.w	d1,phc_FineSlideFlags+2(a3)
	rts
VolSlideMask:	dc.w	0
	dc.w	FSF_VolSlideDown
	dc.w	FSF_FineVolSlide
	dc.w	FSF_FineVolSlideDown|FSF_FineVolSlide
TriggerFineVol:	move.l	phc_Track(a3),a1
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotTrigFineVol
	moveq	#FX_VOL_SLD_UP,d0
	btst	#FSB_FineVolSlide-8,phc_FineSlideFlags+2(a3)
	beq.s	NotTrigFineVol
	moveq	#FX_F_VOLSL_UP,d0
NotTrigFineVol:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	TriggerVolSlDone
	move.w	d0,d1
	subq.b	#FX_VOL_SLD_UP-FX_SET_VOLUME,d0
	bclr	#0,d0
	move.w	VolSlideTrigMask-(FX_VOL_SLD_UP*2)(pc,d1.w*2),d1
	and.w	phc_FineSlideFlags+2(a3),d1
	beq.s	TriggerVolSlOk
	bset	#0,d0
TriggerVolSlOk:	addq.b	#FX_VOL_SLD_UP-FX_SET_VOLUME,d0
TriggerVolSlDone:	bset	#4,d4
	cmp.b	#FX_F_VOLSL_UP,d0
	blo.s	TriggerVolSlFineOk
	bclr	#4,d4
TriggerVolSlFineOk:	rts
VolSlideTrigMask:	dc.w	FSF_VolSlideDown
	dc.w	FSF_VolSlideDown
	dc.w	FSF_FineVolSlideDown
	dc.w	FSF_FineVolSlideDown
	dc.w	CheckVolSlide-VolSlUp+2
VolSlUp:	bne.s	NotVolSlUpNew
	move.w	phc_VolSlideUpValue(a3),d2
NotVolSlUpNew:	bsr	DoVolumeSlide
	move.l	phc_Track(a3),a1
	btst	#TCTCB_VolPitch,tct_CompFlags(a1)
	beq.s	VolSlUpOk
	bsr	PortaUpOk
VolSlUpOk:	movem.w	phc_VolSlideDownValue(a3),d3-d5
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotVolSlUpAll
	move.w	d2,d4
NotVolSlUpAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotVolSlUpOpposite
	move.w	d2,d3
	move.w	d4,d5
NotVolSlUpOpposite:	movem.w	d2-d5,phc_VolSlideUpValue(a3)
VolSlUpDone:	rts
	dc.w	CheckVolSlide-VolSlDn+2
VolSlDn:	bne.s	NotVolSlDnNew
	move.w	phc_VolSlideDownValue(a3),d2
NotVolSlDnNew:	bsr.s	DoVolumeSlideDn
	move.l	phc_Track(a3),a1
	btst	#TCTCB_VolPitch,tct_CompFlags(a1)
	beq.s	VolSlDnOk
	bsr	PortaDnOk
VolSlDnOk:	movem.w	phc_VolSlideUpValue(a3),d0-d1/d3-d4
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotVolSlDnAll
	move.w	d2,d4
NotVolSlDnAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotVolSlDnOpposite
	move.w	d2,d0
	move.w	d4,d3
NotVolSlDnOpposite:	movem.w	d0/d2-d4,phc_VolSlideUpValue(a3)
VolSlDnDone:	rts
SetVol:	clr.w	phc_TremoloSlideValue(a3)
	bsr.s	CheckOldVolume
	move.w	d2,pc_Volume(a2)
	rts
CheckOldVolume:	cmp.w	pc_HostChannel(a2),d7
	bne.s	WrongChkVol
CheckOldTVol:	btst	#TCSOCB_OldVolumes,tcso_CompFlags(a4)
	beq.s	NotSetVol
	move.b	d2,d0
	clr.b	d2
	add.w	d2,d2
	bcs.s	OldSetVol
	add.w	d2,d2
	bcc.s	NotOldSetVol
OldSetVol:	moveq	#-1,d2
	rts
NotOldSetVol:	move.b	d0,d2
NotSetVol:	rts
WrongChkVol:	addq.l	#4,sp
	rts
DoVolumeSlide:	bsr.s	CheckOldVolume
	add.w	d2,pc_Volume(a2)
	bcc.s	VolSlDone
	move.w	#-1,pc_Volume(a2)
VolSlDone:	rts
DoVolumeSlideDn:	bsr.s	CheckOldVolume
	sub.w	d2,pc_Volume(a2)
	bcc.s	VolSlDone
	clr.w	pc_Volume(a2)
	rts
	dc.w	CheckVolSlide-FVolSlUp+2
FVolSlUp:	bne.s	NotFVolSlUpNew
	move.w	phc_FineVolSlideUpValue(a3),d2
NotFVolSlUpNew:	bsr.s	DoVolumeSlide
	move.l	phc_Track(a3),a1
	btst	#TCTCB_VolPitch,tct_CompFlags(a1)
	beq.s	FVolSlUpOk
	bsr	PortaUpOnceOk
FVolSlUpOk:	movem.w	phc_VolSlideUpValue(a3),d0-d1/d3-d4
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotFVolSlUpAll
	move.w	d2,d0
NotFVolSlUpAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotFVolSlUpOpposite
	move.w	d0,d1
	move.w	d2,d4
NotFVolSlUpOpposite:	movem.w	d0-d2/d4,phc_VolSlideUpValue(a3)
FVolSlUpDone:	rts
	dc.w	CheckVolSlide-FVolSlDn+2
FVolSlDn:	bne.s	NotFVolSlDnNew
	move.w	phc_FineVolSlideDownValue(a3),d2
NotFVolSlDnNew:	bsr.s	DoVolumeSlideDn
	move.l	phc_Track(a3),a1
	btst	#TCTCB_VolPitch,tct_CompFlags(a1)
	beq.s	FVolSlDnOk
	bsr	PortaDnOnceOk
FVolSlDnOk:	movem.w	phc_VolSlideUpValue(a3),d0-d1/d3
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotFVolSlDnAll
	move.w	d2,d1
NotFVolSlDnAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotFVolSlDnOpposite
	move.w	d1,d0
	move.w	d2,d3
NotFVolSlDnOpposite:	exg	d3,d2
	movem.w	d0-d3,phc_VolSlideUpValue(a3)
FVolSlDnDone:	rts
CheckVolSlTo:	cmp.b	#$ff,tcte_DataWord(a0)
	bne.s	FVolSlDnDone
	bclr	#4,d4
	rts
	dc.w	CheckVolSlTo-VolSlTo+2
VolSlTo:	tst.b	d2
	bne.s	NotVolSlToNewSpd
	move.b	phc_VolumeSlideToValue(a3),d2
NotVolSlToNewSpd:	move.b	d2,phc_VolumeSlideToValue(a3)
	move.b	d2,phc_VolumeSlideToSlide(a3)
	lsr.w	#8,d2
	beq.s	DoVolSlideTo
	move.b	d2,d1
	addq.b	#1,d1
	beq.s	DoVolSlideTo
	move.b	d2,phc_VolumeSlideToVolume(a3)
	bra.s	VolSlToDone
DoVolSlideTo:	tst.b	phc_VolumeSlideToVolume(a3)
	beq.s	VolSlToDone
	cmp.w	pc_HostChannel(a2),d7
	bne.s	VolSlToDone
	move.w	phc_VolumeSlideToSlide(a3),d2
	move.w	phc_VolumeSlideToVolume(a3),d1
	move.w	pc_Volume(a2),d0
	cmp.w	d1,d0
	blo.s	VolSlideToUp
	bsr	DoVolumeSlideDn
	cmp.w	pc_Volume(a2),d1
	blo.s	VolSlToDone
	move.w	d1,pc_Volume(a2)
	clr.b	phc_VolumeSlideToVolume(a3)
	rts
VolSlideToUp:	bsr	DoVolumeSlide
	cmp.w	pc_Volume(a2),d1
	bhi.s	VolSlToDone
	move.w	d1,pc_Volume(a2)
	clr.b	phc_VolumeSlideToVolume(a3)
VolSlToDone:	rts
PresetTremolo:	bset	#PHCB_Tremolo-8,phc_Flags+2(a3)
	rts
	dc.w	PresetTremolo-Tremo
	dc.w	0
Tremo:	move.w	d2,d4
	lsr.w	#8,d4
	bne.s	NotPrevTrmSpd
	move.b	phc_TremoloRate(a3),d4
NotPrevTrmSpd:	move.b	d4,phc_TremoloRate(a3)
	ext.w	d2
	bne.s	NotPrevTrmDepth
	move.b	phc_TremoloDepth(a3),d2
NotPrevTrmDepth:	move.b	d2,phc_TremoloDepth(a3)
	ext.w	d2
	btst	#TCSOCB_OldVolumes,tcso_CompFlags(a4)
	beq.s	OldTremoVals
	cmp.w	#63,d2
	ble.s	OldTremoVolUpOk
	moveq	#63,d2
OldTremoVolUpOk:	cmp.w	#-63,d2
	bge.s	OldTremoVolUpOk
	moveq	#-63,d2
OldTremoVals:	neg.w	d2
	move.w	d2,-(sp)
	moveq	#0,d5
	lea	phc_TremoloEnv(a3),a0
	bsr	RunEnvelope
	muls.w	(sp)+,d0
	asr.l	#7,d0
	btst	#TCSOCB_OldVolumes,tcso_CompFlags(a4)
	beq.s	NotTremoOldVol
	asl.w	#2,d0
NotTremoOldVol:	cmp.w	pc_HostChannel(a2),d7
	bne.s	VolSlToDone
	sub.w	phc_TremoloSlideValue(a3),d0
	move.b	pc_Volume(a2),d5
	add.w	d5,d0
	bpl.s	TremoLoOk
	moveq	#0,d0
TremoLoOk:	cmp.w	#255,d0
	ble.s	TremoHiOk
	move.w	#255,d0
TremoHiOk:	move.b	d0,pc_Volume(a2)
	sub.w	d0,d5
	sub.w	d5,phc_TremoloSlideValue(a3)
	rts
CheckTVolSlide:	tst.w	tcte_DataWord(a0)
	beq.s	TriggerFineTVol
	and.b	#~(FSF_TrackVolSlideDown>>8|FSF_FineTrackVolSlideDown>>8|FSF_FineTrackVolSlide>>8),phc_FineSlideFlags+2(a3)
	move.b	TVolSlideMask-(FX_TVOL_SL_UP)(pc,d0.w),d1
	or.b	d1,phc_FineSlideFlags+2(a3)
	rts
TVolSlideMask:	dc.b	0
	dc.b	FSF_TrackVolSlideDown>>8
	dc.b	FSF_FineTrackVolSlide>>8
	dc.b	FSF_FineTrackVolSlideDown>>8|FSF_FineTrackVolSlide>>8
TriggerFineTVol:	move.l	phc_Track(a3),a1
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotTrigFineTVol
	moveq	#FX_TVOL_SL_UP,d0
	btst	#FSB_FineTrackVolSlide-8,phc_FineSlideFlags+2(a3)
	beq.s	NotTrigFineTVol
	moveq	#FX_F_TVOL_SL_UP,d0
NotTrigFineTVol:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	TriggerTVolSlDone
	move.w	d0,d1
	subq.b	#FX_TVOL_SL_UP-FX_SET_TRK_VOL,d0
	bclr	#0,d0
	move.b	TVolSlideTrigMask-(FX_TVOL_SL_UP)(pc,d1.w),d1
	btst	d1,phc_FineSlideFlags+2(a3)
	beq.s	TriggerTVolSlOk
	bset	#0,d0
TriggerTVolSlOk:	addq.b	#FX_TVOL_SL_UP-FX_SET_TRK_VOL,d0
TriggerTVolSlDone:	bset	#4,d4
	cmp.b	#FX_F_TVOL_SL_UP,d0
	blo.s	TriggerTVolSlFineOk
	bclr	#4,d4
TriggerTVolSlFineOk:	rts
TVolSlideTrigMask:	dc.b	FSB_TrackVolSlideDown-8
	dc.b	FSB_TrackVolSlideDown-8
	dc.b	FSB_FineTrackVolSlideDown-8
	dc.b	FSB_FineTrackVolSlideDown-8
	dc.w	CheckTVolSlide-TVolSlUp+2
TVolSlUp:	bne.s	NotTVolSlUpNew
	move.w	phc_TrackVolSlideUpValue(a3),d2
NotTVolSlUpNew:	bsr.s	DoTVolumeSlide
	move.l	phc_Track(a3),a1
	movem.w	phc_TrackVolSlideDownValue(a3),d3-d5
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotTVolSlUpAll
	move.w	d2,d4
NotTVolSlUpAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotTVolSlUpOpposite
	move.w	d2,d3
	move.w	d4,d5
NotTVolSlUpOpposite:	movem.w	d2-d5,phc_TrackVolSlideUpValue(a3)
TVolSlUpDone:	rts
	dc.w	CheckTVolSlide-TVolSlDn+2
TVolSlDn:	bne.s	NotTVolSlDnNew
	move.w	phc_TrackVolSlideDownValue(a3),d2
NotTVolSlDnNew:	bsr.s	DoTVolumeSlideDn
	move.l	phc_Track(a3),a1
	movem.w	phc_TrackVolSlideUpValue(a3),d0-d1/d3-d4
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotTVolSlDnAll
	move.w	d2,d4
NotTVolSlDnAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotTVolSlDnOpposite
	move.w	d2,d0
	move.w	d4,d3
NotTVolSlDnOpposite:	movem.w	d0/d2-d4,phc_TrackVolSlideUpValue(a3)
TVolSlDnDone:	rts
SetTVol:	bsr	CheckOldTVol
	move.w	d2,phc_TrackVolume(a3)
	rts
DoTVolumeSlide:	bsr	CheckOldTVol
	add.w	d2,phc_TrackVolume(a3)
	bcc.s	TVolSlDone
	move.w	#-1,phc_TrackVolume(a3)
TVolSlDone:	rts
DoTVolumeSlideDn:	bsr	CheckOldTVol
	sub.w	d2,phc_TrackVolume(a3)
	bcc.s	TVolSlDone
	clr.w	phc_TrackVolume(a3)
	rts
	dc.w	CheckTVolSlide-FTVolSlUp+2
FTVolSlUp:	bne.s	NotFTVolSlUpNew
	move.w	phc_FineTrkVolSlideUpValue(a3),d2
NotFTVolSlUpNew:	bsr.s	DoTVolumeSlide
	move.l	phc_Track(a3),a1
	movem.w	phc_TrackVolSlideUpValue(a3),d0-d1/d3-d4
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotFTVolSlUpAll
	move.w	d2,d0
NotFTVolSlUpAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotFTVolSlUpOpposite
	move.w	d0,d1
	move.w	d2,d4
NotFTVolSlUpOpposite:	movem.w	d0-d2/d4,phc_TrackVolSlideUpValue(a3)
FTVolSlUpDone:	rts
	dc.w	CheckTVolSlide-FTVolSlDn+2
FTVolSlDn:	bne.s	NotFTVolSlDnNew
	move.w	phc_FineTrkVolSlideDnValue(a3),d2
NotFTVolSlDnNew:	bsr.s	DoTVolumeSlideDn
	move.l	phc_Track(a3),a1
	movem.w	phc_TrackVolSlideUpValue(a3),d0-d1/d3-d4
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotFTVolSlDnAll
	move.w	d2,d1
NotFTVolSlDnAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotFTVolSlDnOpposite
	move.w	d1,d0
	move.w	d2,d3
NotFTVolSlDnOpposite:	exg	d3,d2
	movem.w	d0-d3,phc_TrackVolSlideUpValue(a3)
FTVolSlDnDone:	rts
	dc.w	CheckVolSlTo-TVolSlTo+2
TVolSlTo:	tst.b	d2
	bne.s	NotTVolSlToNewSpd
	move.b	phc_TrackVolSlideToValue(a3),d2
NotTVolSlToNewSpd:	move.b	d2,phc_TrackVolSlideToValue(a3)
	move.b	d2,phc_TrackVolSlideToSlide(a3)
	lsr.w	#8,d2
	beq.s	DoTVolSlideTo
	move.b	d2,d1
	addq.b	#1,d1
	beq.s	DoTVolSlideTo
	move.b	d2,phc_TrackVolSlideToVolume(a3)
	bra.s	TVolSlToDone
DoTVolSlideTo:	tst.b	phc_TrackVolSlideToVolume(a3)
	beq.s	TVolSlToDone
	move.w	phc_TrackVolSlideToSlide(a3),d2
	move.w	phc_TrackVolSlideToVolume(a3),d1
	move.w	phc_TrackVolume(a3),d0
	cmp.w	d1,d0
	blo.s	TVolSlideToUp
	bsr	DoTVolumeSlideDn
	cmp.w	phc_TrackVolume(a3),d1
	blo.s	TVolSlToDone
	move.w	d1,phc_TrackVolume(a3)
	clr.b	phc_TrackVolSlideToVolume(a3)
	rts
TVolSlideToUp:	bsr	DoTVolumeSlide
	cmp.w	phc_TrackVolume(a3),d1
	bhi.s	TVolSlToDone
	move.w	d1,phc_TrackVolume(a3)
	clr.b	phc_TrackVolSlideToVolume(a3)
TVolSlToDone:	rts
TTremo:	move.w	d2,d4
	lsr.w	#8,d4
	bne.s	NotPrevTTrmSpd
	move.b	phc_TrackTremRate(a3),d4
NotPrevTTrmSpd:	move.b	d4,phc_TrackTremRate(a3)
	ext.w	d2
	bne.s	NotPrevTTrmDepth
	move.b	phc_TrackTremDepth(a3),d2
NotPrevTTrmDepth:	move.b	d2,phc_TrackTremDepth(a3)
	ext.w	d2
	btst	#TCSOCB_OldVolumes,tcso_CompFlags(a4)
	beq.s	OldTTremoVals
	cmp.w	#63,d2
	ble.s	OldTTremoVolUpOk
	moveq	#63,d2
OldTTremoVolUpOk:	cmp.w	#-63,d2
	bge.s	OldTTremoVolUpOk
	moveq	#-63,d2
OldTTremoVals:	neg.w	d2
	move.w	d2,-(sp)
	moveq	#0,d5
	lea	phc_TrackTremEnv(a3),a0
	bsr	RunEnvelope
	muls.w	(sp)+,d0
	asr.l	#7,d0
	btst	#TCSOCB_OldVolumes,tcso_CompFlags(a4)
	beq.s	NotTTremoOldVol
	asl.w	#2,d0
NotTTremoOldVol:	sub.w	phc_TrackTremSlideValue(a3),d0
	move.b	phc_TrackVolume(a3),d5
	add.w	d5,d0
	bpl.s	TTremoLoOk
	moveq	#0,d0
TTremoLoOk:	cmp.w	#255,d0
	ble.s	TTremoHiOk
	move.w	#255,d0
TTremoHiOk:	move.b	d0,phc_TrackVolume(a3)
	sub.w	d0,d5
	sub.w	d5,phc_TrackTremSlideValue(a3)
	rts
CheckPanSlide:	tst.w	tcte_DataWord(a0)
	beq.s	TriggerFinePan
	and.b	#~(FSF_PanSlideRight>>8|FSF_FinePanSlideRight>>8|FSF_FinePanSlide>>8),phc_FineSlideFlags+2(a3)
	move.b	PanSlideMask-(FX_PAN_SL_LEFT)(pc,d0.w),d1
	or.b	d1,phc_FineSlideFlags+2(a3)
	rts
PanSlideMask:	dc.b	0
	dc.b	FSF_PanSlideRight>>8
	dc.b	FSF_FinePanSlide>>8
	dc.b	FSF_FinePanSlideRight>>8|FSF_FinePanSlide>>8
TriggerFinePan:	move.l	phc_Track(a3),a1
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotTrigFinePan
	moveq	#FX_PAN_SL_LEFT,d0
	tst.b	phc_FineSlideFlags+2(a3)
	bpl.s	NotTrigFinePan
	moveq	#FX_F_P_SL_LEFT,d0
NotTrigFinePan:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	TriggerPanSlDone
	move.w	d0,d1
	subq.b	#FX_PAN_SL_LEFT-FX_SET_PANNING,d0
	bclr	#0,d0
	move.b	PanSlideTrigMask-(FX_PAN_SL_LEFT)(pc,d1.w),d1
	btst	d1,phc_FineSlideFlags+2(a3)
	beq.s	TriggerPanSlOk
	bset	#0,d0
TriggerPanSlOk:	addq.b	#FX_PAN_SL_LEFT-FX_SET_PANNING,d0
TriggerPanSlDone:	bset	#4,d4
	cmp.b	#FX_F_P_SL_LEFT,d0
	blo.s	TriggerPanSlFineOk
	bclr	#4,d4
TriggerPanSlFineOk:	rts
PanSlideTrigMask:	dc.b	FSB_PanSlideRight-8
	dc.b	FSB_PanSlideRight-8
	dc.b	FSB_FinePanSlideRight-8
	dc.b	FSB_FinePanSlideRight-8
SetPan:	cmp.w	pc_HostChannel(a2),d7
	bne.s	SetPanTrk
	move.w	d2,pc_Panning(a2)
	bclr	#PCB_SmpSurPan,pc_Flags+1(a2)
SetPanTrk:	bclr	#PHCB_TrackSurPan,phc_Flags+3(a3)
CheckUpdPan:	move.w	d2,phc_TrackPanning(a3)
	move.w	d2,phc_TrackNotePan(a3)
	rts
	dc.w	CheckPanSlide-PanSlLeft+2
PanSlLeft:	bne.s	NotPanSlLeftNew
	move.w	phc_PanSlideLeftValue(a3),d2
NotPanSlLeftNew:	bsr.s	DoPanSlide
	move.l	phc_Track(a3),a1
	movem.w	phc_PanSlideRightValue(a3),d3-d5/a0
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotPanSlLeftAll
	move.w	d2,d4
	move.w	d2,a0
NotPanSlLeftAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotPanSlLeftOpposite
	move.w	d2,d3
	move.w	d4,d5
NotPanSlLeftOpposite:	movem.w	d2-d5/a0,phc_PanSlideLeftValue(a3)
PanSlLeftDone:	rts
	dc.w	CheckPanSlide-PanSlRight+2
PanSlRight:	bne.s	NotPanSlRightNew
	move.w	phc_PanSlideRightValue(a3),d2
NotPanSlRightNew:	bsr.s	DoPanSlideRight
	move.l	phc_Track(a3),a1
	movem.w	phc_PanSlideLeftValue(a3),d0-d1/d3-d5
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotPanSlRightAll
	move.w	d2,d4
	move.w	d2,d5
NotPanSlRightAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotPanSlRightOpposite
	move.w	d2,d0
	move.w	d4,d3
NotPanSlRightOpposite:	movem.w	d0/d2-d5,phc_PanSlideLeftValue(a3)
PanSlRightDone:	rts
DoPanSlide:	cmp.w	pc_HostChannel(a2),d7
	bne.s	PanSlOnly
	sub.w	d2,pc_Panning(a2)
	bcc.s	PanSlDone
	clr.w	pc_Panning(a2)
PanSlDone:	move.w	pc_Panning(a2),phc_TrackPanning(a3)
PanSlTDone:	move.w	phc_TrackPanning(a3),phc_TrackNotePan(a3)
	rts
PanSlOnly:	sub.w	d2,phc_TrackPanning(a3)
	bcc.s	PanSlTDone
	clr.w	phc_TrackPanning(a2)
	bra.s	PanSlTDone
DoPanSlideRight:	cmp.w	pc_HostChannel(a2),d7
	bne.s	PanSlRightOnly
	add.w	d2,pc_Panning(a2)
	bcc.s	PanSlDone
	move.w	#-1,pc_Panning(a2)
	bra.s	PanSlDone
PanSlRightOnly:	add.w	d2,phc_TrackPanning(a3)
	bcc.s	PanSlTDone
	move.w	#-1,phc_TrackPanning(a2)
	bra.s	PanSlTDone
	dc.w	CheckPanSlide-FPanSlLeft+2
FPanSlLeft:	bne.s	NotFPanSlLeftNew
	move.w	phc_FinePanSlideLeftValue(a3),d2
NotFPanSlLeftNew:	bsr.s	DoPanSlide
	move.l	phc_Track(a3),a1
	movem.w	phc_PanSlideLeftValue(a3),d0-d1/d3-d5
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotFPanSlLeftAll
	move.w	d2,d0
	move.w	d2,d5
NotFPanSlLeftAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotFPanSlLeftOpposite
	move.w	d0,d1
	move.w	d2,d4
NotFPanSlLeftOpposite:	movem.w	d0-d2/d4-d5,phc_PanSlideLeftValue(a3)
FPanSlLeftDone:	rts
	dc.w	CheckPanSlide-FPanSlRight+2
FPanSlRight:	bne.s	NotFPanSlRightNew
	move.w	phc_FinePanSlideRightValue(a3),d2
NotFPanSlRightNew:	bsr.s	DoPanSlideRight
	move.l	phc_Track(a3),a1
	movem.w	phc_PanSlideLeftValue(a3),d0-d1/d3-d5
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotFPanSlRightAll
	move.w	d2,d1
	move.w	d2,d5
NotFPanSlRightAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotFPanSlRightOpposite
	move.w	d1,d0
	move.w	d2,d3
NotFPanSlRightOpposite:	exg	d3,d2
	movem.w	d0-d3/d5,phc_PanSlideLeftValue(a3)
FPanSlRightDone:	rts
	dc.w	CheckVolSlTo-PanSlTo+2
PanSlTo:	tst.b	d2
	bne.s	NotPanSlToNewSpd
	move.b	phc_PanningSlideToValue(a3),d2
NotPanSlToNewSpd:	move.b	d2,phc_PanningSlideToValue(a3)
	move.b	d2,phc_PanningSlideToSlide(a3)
	lsr.w	#8,d2
	beq.s	DoPanSlideTo
	move.b	d2,d1
	addq.b	#1,d1
	beq.s	DoPanSlideTo
	move.b	d2,phc_PanningSlideToPanning(a3)
	bra.s	FPanSlRightDone
DoPanSlideTo:	tst.b	phc_PanningSlideToPanning(a3)
	beq.s	FPanSlRightDone
	cmp.w	pc_HostChannel(a2),d7
	bne.s	FPanSlRightDone
	move.w	phc_PanningSlideToSlide(a3),d2
	move.w	phc_PanningSlideToPanning(a3),d1
	move.w	pc_Panning(a2),d0
	cmp.w	d1,d0
	blo.s	PanSlideToRight
	bsr	DoPanSlide
	cmp.w	pc_Panning(a2),d1
	blo.s	FPanSlRightDone
	move.w	d1,pc_Panning(a2)
	clr.b	phc_PanningSlideToPanning(a3)
	bra	CheckUpdPan
PanSlideToRight:	bsr	DoPanSlideRight
	cmp.w	pc_Panning(a2),d1
	bhi.s	FPanSlRightDone
	move.w	d1,pc_Panning(a2)
	clr.b	phc_PanningSlideToPanning(a3)
	bra	CheckUpdPan
Pannolo:	move.w	d2,d4
	lsr.w	#8,d4
	bne.s	NotPrevPanSpd
	move.b	phc_PannoloRate(a3),d4
NotPrevPanSpd:	move.b	d4,phc_PannoloRate(a3)
	ext.w	d2
	bne.s	NotPrevPanDepth
	move.b	phc_PannoloDepth(a3),d2
NotPrevPanDepth:	move.b	d2,phc_PannoloDepth(a3)
	ext.w	d2
	neg.w	d2
	move.w	d2,-(sp)
	moveq	#0,d5
	lea	phc_PannoloEnv(a3),a0
	bsr	RunEnvelope
	muls.w	(sp)+,d0
	asr.l	#7,d0
	sub.w	phc_PannoloSlideValue(a3),d0
	cmp.w	pc_HostChannel(a2),d7
	bne.s	PannoDone
	move.b	pc_Panning(a2),d5
	add.w	d5,d0
	bpl.s	PannoLoOk
	moveq	#0,d0
PannoLoOk:	cmp.w	#255,d0
	ble.s	PannoHiOk
	move.w	#255,d0
PannoHiOk:	move.b	d0,pc_Panning(a2)
	sub.w	d0,d5
	sub.w	d5,phc_PannoloSlideValue(a3)
	move.w	d0,d2
	lsl.w	#8,d2
	move.b	pc_SubPan(a2),d2
	bra	CheckUpdPan
SetTPan:	move.w	d2,phc_ChannelPanning(a3)
	bclr	#PHCB_ChannelSurPan,phc_Flags+3(a3)
PannoDone:	rts
CheckTPanSlide:	tst.w	tcte_DataWord(a0)
	beq.s	TriggerFineTPan
	and.b	#~(FSF_TrackPanSlideRight>>16|FSF_FineTrkPanSlideRight>>16|FSF_FineTrackPanSlide>>16),phc_FineSlideFlags+1(a3)
	move.b	TPanSlideMask-(FX_TPAN_SL_LEFT)(pc,d0.w),d1
	or.b	d1,phc_FineSlideFlags+1(a3)
	rts
TPanSlideMask:	dc.b	0
	dc.b	FSF_TrackPanSlideRight>>16
	dc.b	FSF_FineTrackPanSlide>>16
	dc.b	FSF_FineTrkPanSlideRight>>16|FSF_FineTrackPanSlide>>16
TriggerFineTPan:	move.l	phc_Track(a3),a1
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotTrigFineTPan
	moveq	#FX_TPAN_SL_LEFT,d0
	btst	#FSB_FineTrackPanSlide-16,phc_FineSlideFlags+1(a3)
	beq.s	NotTrigFineTPan
	moveq	#FX_F_TP_SL_LEFT,d0
NotTrigFineTPan:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	TriggerTPanSlDone
	move.w	d0,d1
	subq.b	#FX_TPAN_SL_LEFT-FX_SET_TRK_PAN,d0
	bclr	#0,d0
	move.b	TPanSlideTrigMask-(FX_TPAN_SL_LEFT)(pc,d1.w),d1
	btst	d1,phc_FineSlideFlags+1(a3)
	beq.s	TriggerTPanSlOk
	bset	#0,d0
TriggerTPanSlOk:	addq.b	#FX_TPAN_SL_LEFT-FX_SET_TRK_PAN,d0
TriggerTPanSlDone:	bset	#4,d4
	cmp.b	#FX_F_TP_SL_LEFT,d0
	blo.s	TriggerTPanSlFineOk
	bclr	#4,d4
TriggerTPanSlFineOk:	rts
TPanSlideTrigMask:	dc.b	FSB_TrackPanSlideRight-16
	dc.b	FSB_TrackPanSlideRight-16
	dc.b	FSB_FineTrkPanSlideRight-16
	dc.b	FSB_FineTrkPanSlideRight-16
	dc.w	CheckTPanSlide-TPanSlLeft+2
TPanSlLeft:	bne.s	NotTPanSlLeftNew
	move.w	phc_TrackPanSlideLeftValue(a3),d2
NotTPanSlLeftNew:	bsr.s	DoTPanSlide
	move.l	phc_Track(a3),a1
	movem.w	phc_TrackPanSlideRightValue(a3),d3-d5/a0
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotTPanSlLeftAll
	move.w	d2,d4
	move.w	d2,a0
NotTPanSlLeftAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotTPanSlLeftOpposite
	move.w	d2,d3
	move.w	d4,d5
NotTPanSlLeftOpposite:	movem.w	d2-d5/a0,phc_TrackPanSlideLeftValue(a3)
TPanSlLeftDone:	rts
	dc.w	CheckTPanSlide-TPanSlRight+2
TPanSlRight:	bne.s	NotTPanSlRightNew
	move.w	phc_TrackPanSlideRightValue(a3),d2
NotTPanSlRightNew:	bsr.s	DoTPanSlideRight
	move.l	phc_Track(a3),a1
	movem.w	phc_TrackPanSlideLeftValue(a3),d0-d1/d3-d5
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotTPanSlRightAll
	move.w	d2,d4
	move.w	d2,d5
NotTPanSlRightAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotTPanSlRightOpposite
	move.w	d2,d0
	move.w	d4,d3
NotTPanSlRightOpposite:	movem.w	d0/d2-d5,phc_TrackPanSlideLeftValue(a3)
TPanSlRightDone:	rts
DoTPanSlide:	sub.w	d2,phc_ChannelPanning(a3)
	bcc.s	TPanSlDone
	clr.w	phc_ChannelPanning(a3)
TPanSlDone:	rts
DoTPanSlideRight:	add.w	d2,phc_ChannelPanning(a3)
	bcc.s	TPanSlDone
	move.w	#-1,phc_ChannelPanning(a3)
	rts
	dc.w	CheckTPanSlide-FTPanSlLeft+2
FTPanSlLeft:	bne.s	NotFTPanSlLeftNew
	move.w	phc_FineTrkPanSldLeftValue(a3),d2
NotFTPanSlLeftNew:	bsr.s	DoTPanSlide
	move.l	phc_Track(a3),a1
	movem.w	phc_TrackPanSlideLeftValue(a3),d0-d1/d3-d5
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotFTPanSlLeftAll
	move.w	d2,d0
	move.w	d2,d5
NotFTPanSlLeftAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotFTPanSlLeftOpposite
	move.w	d0,d1
	move.w	d2,d4
NotFTPanSlLeftOpposite:	movem.w	d0-d2/d4-d5,phc_TrackPanSlideLeftValue(a3)
FTPanSlLeftDone:	rts
	dc.w	CheckTPanSlide-FTPanSlRight+2
FTPanSlRight:	bne.s	NotFTPanSlRightNew
	move.w	phc_FineTrkPanSldRightValue(a3),d2
NotFTPanSlRightNew:	bsr.s	DoTPanSlideRight
	move.l	phc_Track(a3),a1
	movem.w	phc_TrackPanSlideLeftValue(a3),d0-d1/d3-d5
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotFTPanSlRightAll
	move.w	d2,d1
	move.w	d2,d5
NotFTPanSlRightAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotFTPanSlRightOpposite
	move.w	d1,d0
	move.w	d2,d3
NotFTPanSlRightOpposite:	exg	d3,d2
	movem.w	d0-d3/d5,phc_TrackPanSlideLeftValue(a3)
FTPanSlRightDone:	rts
	dc.w	CheckVolSlTo-TPanSlTo+2
TPanSlTo:	tst.b	d2
	bne.s	NotTPanSlToNewSpd
	move.b	phc_TrackPanSlideToValue(a3),d2
NotTPanSlToNewSpd:	move.b	d2,phc_TrackPanSlideToValue(a3)
	move.b	d2,phc_TrackPanSlideToSlide(a3)
	lsr.w	#8,d2
	beq.s	DoTPanSlideTo
	move.b	d2,d1
	addq.b	#1,d1
	beq.s	DoTPanSlideTo
	move.b	d2,phc_TrackPanSlideToPanning(a3)
	bra.s	TPanSlToDone
DoTPanSlideTo:	tst.b	phc_TrackPanSlideToPanning(a3)
	beq.s	TPanSlToDone
	move.w	phc_TrackPanSlideToSlide(a3),d2
	move.w	phc_TrackPanSlideToPanning(a3),d1
	move.w	phc_TrackPanning(a3),d0
	cmp.w	d1,d0
	blo.s	TPanSlideToRight
	bsr	DoTPanSlide
	cmp.w	phc_TrackPanning(a3),d1
	blo.s	TPanSlToDone
	move.w	d1,phc_TrackPanning(a3)
	clr.b	phc_TrackPanSlideToPanning(a3)
	rts
TPanSlideToRight:	bsr	DoTPanSlideRight
	cmp.w	phc_TrackPanning(a3),d1
	bhi.s	TPanSlToDone
	move.w	d1,phc_TrackPanning(a3)
	clr.b	phc_TrackPanSlideToPanning(a3)
TPanSlToDone:	rts
TPannolo:	move.w	d2,d4
	lsr.w	#8,d4
	bne.s	NotPrevTPanSpd
	move.b	phc_TrackPanRate(a3),d4
NotPrevTPanSpd:	move.b	d4,phc_TrackPanRate(a3)
	ext.w	d2
	bne.s	NotPrevTPanDepth
	move.b	phc_TrackPanDepth(a3),d2
NotPrevTPanDepth:	move.b	d2,phc_TrackPanDepth(a3)
	ext.w	d2
	neg.w	d2
	move.w	d2,-(sp)
	moveq	#0,d5
	lea	phc_TrackPanEnv(a3),a0
	bsr	RunEnvelope
	muls.w	(sp)+,d0
	asr.l	#7,d0
	sub.w	phc_TrackPanSlideValue(a3),d0
	move.b	phc_TrackPanning(a3),d5
	move.w	d5,d1
	add.w	d5,d0
	bpl.s	TPannoLoOk
	moveq	#0,d0
TPannoLoOk:	cmp.w	#255,d0
	ble.s	TPannoHiOk
	move.w	#255,d0
TPannoHiOk:	move.b	d0,phc_TrackPanning(a3)
	sub.w	d0,d1
	sub.w	d1,phc_TrackPanSlideValue(a3)
	rts
SetTempo:	move.w	d2,phc_Tempo(a3)
ChkZeroTempo:	bne.s	PattBrkDone
	bset	#PHCB_SongEnd-24,phc_Flags(a3)
	rts
SetRelTempo:	add.w	d2,phc_Tempo(a3)
	bra.s	ChkZeroTempo
PattBrk:	btst	#PHCB_PattLoop-16,phc_Flags+1(a3)
	bne.s	PattBrkDone
	bset	#PHCB_PatternBreak,phc_Flags+3(a3)
	move.w	d2,phc_BreakRow(a3)
PattBrkDone:	rts
PosJump:	btst	#PHCB_PattLoop-16,phc_Flags+1(a3)
	bne.s	PattBrkDone
	move.l	d7,d0
	lsl.l	#5,d0
	move.l	tcso_Position(a4),a0
	add.l	d0,a0
	tst.w	d2
	beq.s	FindPosOk
	move.l	a0,a1
FindPosJmp:	move.l	(a0),d0
	beq.s	FindPosDone
	move.l	d0,a0
	subq.w	#1,d2
	bne.s	FindPosJmp
FindPosDone:	move.l	(a0),d0
	bne.s	FindPosOk
	move.l	a1,a0
FindPosOk:	move.l	a0,(a3)
	moveq	#0,d2
	bra.s	PattBrk
RelPosJmp:	bne.s	RelPosJmpOk
	move.w	phc_PosJump(a3),d2
RelPosJmpOk:	move.l	d7,d0
	lsl.l	#5,d0
	move.l	tcso_Position(a4),a1
	add.l	d0,a1
	move.w	d2,phc_PosJump(a3)
	beq.s	PattBrkDone
	move.l	(a3),a0
	bmi.s	NegRelPosJmp
	move.l	MLN_PRED(a0),a0
	bra.s	FindPosJmp
NegRelPosJmp:	neg.w	d2
	move.l	(a0),a0
FindNegPos:	move.l	MLN_PRED(a0),d0
	beq.s	FindPosDone
	move.l	d0,a0
	subq.w	#1,d2
	bne.s	FindNegPos
	bra.s	FindPosDone
ChgPattern:	move.w	d2,phc_ChgPattern(a3)
	bset	#PHCB_ChgPattern-16,phc_Flags+1(a3)
	rts
RevPattPlay:	lea	phc_Flags+3(a3),a0
	beq.s	ChgRevInvPlay
	bmi.s	ChgRevPlay
	bclr	#PHCB_Backwards,(a0)
	rts
ChgRevInvPlay:	bchg	#PHCB_Backwards,(a0)
	rts
ChgRevPlay:	bset	#PHCB_Backwards,(a0)
	rts
FPattDelay:	move.w	d2,phc_FinePatternDelay(a3)
	rts
PattDelay:	move.w	d2,phc_PatternDelay(a3)
	rts
PattLoop:	move.w	phc_PatternLoopDepth(a3),d0
	move.w	d0,d1
	add.l	d0,d0
	add.l	d0,d0
	move.l	tcso_LoopStackPtr(a4),a0
	move.w	tcso_LoopStackSize(a4),d3
	mulu.w	d7,d3
	add.l	d3,d3
	add.l	d3,d3
	add.l	d3,d0
	add.l	d0,a0
	move.w	d2,d0
	beq.s	SetLoopMark
	cmp.w	(a0),d2
	beq.s	PattLoopCompleted
	addq.w	#1,(a0)+
	or.l	#PHCF_PatternBreak|PHCF_PattLoop|PHCF_PattLoopJmp,phc_Flags(a3)
	move.w	(a0),phc_BreakRow(a3)
	btst	#PHCB_PattReset-16,phc_Flags+1(a3)
	beq.s	PattLoopDone
	bset	#PHCB_SongEnd-24,phc_Flags(a3)
PattLoopDone:	rts
PattLoopCompleted:	clr.w	(a0)
	subq.w	#1,d1
	bcs.s	PattLoopNeedReset
	move.w	d1,phc_PatternLoopDepth(a3)
	rts
PattLoopNeedReset:	bset	#PHCB_PattReset-16,phc_Flags+1(a3)
	rts
SetLoopMark:	btst	#PHCB_PattLoopJmp-16,phc_Flags+1(a3)
	bne.s	PattLoopDone
	bclr	#PHCB_PattReset-16,phc_Flags+1(a3)
	clr.w	(a0)+
	move.w	phc_Row(a3),(a0)
	addq.w	#1,d1
	cmp.w	tcso_LoopStackSize(a4),d1
	beq.s	PattLoopDone
	move.w	d1,phc_PatternLoopDepth(a3)
	rts
GoSub:
	rts
Return:
	rts
ChanSync:
	rts
SetSubSl:	move.w	d2,d0
	lsr.w	#8,d0
	bne.s	SetSubSlOk
	move.b	phc_SubSlideBits(a3),d0
SetSubSlOk:	move.l	tcso_GlobalData(a4),a0
	move.b	d0,phc_SubSlideBits(a3)
	lsr.b	#1,d0
	bcc.s	NotVolSubSl
	move.b	d2,phc_VolumeSlideToSubVol(a3)
NotVolSubSl:	lsr.b	#1,d0
	bcc.s	NotTrkVolSubSl
	move.b	d2,phc_TrackVolSlideToSubVol(a3)
NotTrkVolSubSl:	lsr.b	#1,d0
	bcc.s	NotGlobalVolSubSl
	move.b	d2,pg_GlobalVolumeSlToSubVol(a0)
NotGlobalVolSubSl:	lsr.b	#1,d0
	bcc.s	NotPanSubSl
	move.b	d2,phc_PanningSlideToSubPan(a3)
NotPanSubSl:	lsr.b	#1,d0
	bcc.s	NotTrkPanSubSl
	move.b	d2,phc_TrackPanSlideToSubPan(a3)
NotTrkPanSubSl:	lsr.b	#1,d0
	bcc.s	NotGlobalPanSubSl
	move.b	d2,pg_GlobalPanSlideToSubPan(a0)
NotGlobalPanSubSl:	rts
SmpOffHI:	move.w	d2,phc_SmpOffsetHI(a3)
NoSmpOffset:	rts
SmpOffLO:	cmp.w	pc_HostChannel(a2),d7
	bne.s	NoSmpOffset
	move.w	phc_SmpOffsetHI(a3),d4
	swap	d4
	move.w	d2,d4
	btst	#PHCB_SmpOffsetRel,phc_Flags+3(a3)
	bne.s	RelateSmpOff
	move.l	phc_Track(a3),a1
	btst	#TCTCB_SOffset,tct_CompFlags(a1)
	beq.s	NotCheckSmpOffset
	move.l	pc_Sample(a2),a1
	cmp.l	tcs_Samples(a1),d4
	bhs.s	NoSmpOffset
NotCheckSmpOffset:	clr.l	(a2)
	btst	#MSB_Loop,ms_Flags(a2)
	beq.s	RelateSmpOff
	move.l	ms_Repeat(a2),d1
	add.l	ms_RepLen(a2),d1
	cmp.l	d4,d1
	bhs.s	RelateSmpOff
	move.l	d1,d4
RelateSmpOff:	add.l	d4,(a2)
	rts
SetHold:
	rts
SetDecay:
	rts
PresetSetTransp:	bset	#PHCB_SetTranspose-8,phc_Flags+2(a3)
	move.w	tcte_DataWord(a0),phc_Transpose(a3)
	rts
	dc.w	PresetSetTransp-SetTransp
	dc.w	0
SetTransp:	rts
InsCtrl:
	rts
InsChg:
	rts
SynthCtrl:	move.w	d2,phc_SynthCtrlCount(a3)
	tst.b	d2
	bpl.s	SetSynthValDone
	move.w	phc_SynthCtrlValue(a3),d2
SetSynthVal:	move.w	d2,phc_SynthCtrlValue(a3)
	move.b	phc_SynthCtrlCount(a3),d0
	move.b	phc_SynthCtrlChange(a3),d1
	and.w	#$7f,d1
	lea	(pc_SampleWaveform-(24*4).w,a2,d1.w*4),a0
	lea	(pc_VolumePos.w,a2,d1.w*2),a1
SetSynthValLoop:	cmp.w	#$24,d1
	blo.s	SetSynthValue
	cmp.w	#$28,d1
	bhi.s	SetSynthValDone
	move.w	d2,d3
	move.l	pc_WaveformList(a2),a1
ScanSynWaveLoop:	move.l	(a1),a1
	tst.l	(a1)
	beq.s	SetSynthNextVal
	dbra	d3,ScanSynWaveLoop
	move.l	a1,(a0)
	bra.s	SetSynthNextVal
SetSynthValue:	move.w	d2,(a1)+
SetSynthNextVal:	addq.w	#1,d1
	addq.l	#4,a0
	addq.l	#2,a1
	dbra	d0,SetSynthValLoop
SetSynthValDone:	rts
EnvCtrlCodeTab:	dc.b	$00,$fe,$fc,$f8,$01,$02,$05,$06,$07,$08,$09,$0b,$0d,$0e,$0f,$10
	dc.b	$ff,$fd,$fb,$f7,$7f,$03,$11,$11,$11,$11,$0a,$0c,$11,$11,$11,$11
	dc.b	$11,$11,$fa,$11,$11,$04,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11
	dc.b	$11,$11,$f9,$11
EnvCtrlWaveTab:	dc.w	RefreshVolEnv-EnvCtrlWaveTab
	dc.w	RefreshPanEnv-EnvCtrlWaveTab-2
	dc.w	RefreshSlideEnv-EnvCtrlWaveTab-4
	dc.w	NotResetWave-EnvCtrlWaveTab-6
	dc.w	NotResetWave-EnvCtrlWaveTab-8
	dc.w	NotResetWave-EnvCtrlWaveTab-10
	dc.w	NotResetWave-EnvCtrlWaveTab-12
	dc.w	NotResetWave-EnvCtrlWaveTab-14
	dc.w	RefreshAutoVibEnv-EnvCtrlWaveTab-16
	dc.w	RefreshAutoTremEnv-EnvCtrlWaveTab-18
	dc.w	RefreshAutoPanEnv-EnvCtrlWaveTab-20
	dc.w	NotResetWave-EnvCtrlWaveTab-22
	dc.w	NotResetWave-EnvCtrlWaveTab-24
	dc.w	NotResetWave-EnvCtrlWaveTab-26
	dc.w	NotResetWave-EnvCtrlWaveTab-28
	dc.w	NotResetWave-EnvCtrlWaveTab-30
EnvCtrl:	move.w	d2,d1
	lsr.w	#8,d1
	move.b	d1,d3
	bclr	#7,d1
	cmp.b	#$f,d1
	bhi.s	EnvCtrlDone
	move.b	d1,phc_EnvCtrlKind(a3)
	move.b	d2,d0
	cmp.b	#$32,d2
	bhi.s	EnvCtrlDone
	move.b	EnvCtrlCodeTab(pc,d0.w),d0
	bmi.s	EnvCtrlSpecialCase
	move.b	d0,phc_EnvCtrlChange(a3)
	move.w	phc_EnvCtrlValue(a3),d2
	tst.b	d3
	bmi.s	SetEnvVal
EnvCtrlDone:	rts
SetEnvWaveform:	move.b	phc_EnvCtrlKind(a3),d0
	lea	EnvCtrlWaveTab(pc,d0.w*2),a0
	add.w	(a0),a0
	jsr	(a0)
	moveq	#0,d0
	lea	tcm_Envelopes(a5),a0
SetEnvWaveLoop:	move.l	(a0),a0
	tst.l	(a0)
	beq.s	SetWaveNotFound
	dbra	d2,SetEnvWaveLoop
	move.l	a0,d0
SetWaveNotFound:	move.l	d0,(a1)
	rts
EnvCtrlTypeTab:	dc.w	UseVolEnv-EnvCtrlTypeTab
	dc.w	UsePanEnv-EnvCtrlTypeTab-2
	dc.w	UseSlideEnv-EnvCtrlTypeTab-4
	dc.w	UseVibEnv-EnvCtrlTypeTab-6
	dc.w	UseTremoEnv-EnvCtrlTypeTab-8
	dc.w	UsePannoEnv-EnvCtrlTypeTab-10
	dc.w	UseChanEnv-EnvCtrlTypeTab-12
	dc.w	UseSpenEnv-EnvCtrlTypeTab-14
	dc.w	UseAutoVibEnv-EnvCtrlTypeTab-16
	dc.w	UseAutoTremEnv-EnvCtrlTypeTab-18
	dc.w	UseAutoPanEnv-EnvCtrlTypeTab-20
	dc.w	UseTrkTremEnv-EnvCtrlTypeTab-22
	dc.w	UseTrkPanEnv-EnvCtrlTypeTab-24
	dc.w	UseGlobTremEnv-EnvCtrlTypeTab-26
	dc.w	UseGlobPanEnv-EnvCtrlTypeTab-28
	dc.w	UseArpEnv-EnvCtrlTypeTab-30
SetEnvVal:	move.w	d2,phc_EnvCtrlValue(a3)
	move.b	phc_EnvCtrlKind(a3),d0
	lea	EnvCtrlTypeTab(pc,d0.w*2),a1
	add.w	(a1),a1
	jsr	(a1)
	move.b	phc_EnvCtrlChange(a3),d0
	moveq	#0,d1
	move.b	EnvCtrlChgTab(pc,d0.w),d1
	bmi.s	NotResetWave
	add.l	d1,a1
	addq.b	#1,d1
	bvs.s	SetEnvPosNode
	tst.b	d0
	beq.s	SetEnvWaveform
	subq.b	#3,d0
	beq.s	SetEnvRelValue
	move.w	d2,(a1)
	rts
EnvCtrlSpecialCase:	lea	EnvCtrlTypeTab(pc,d1.w*2),a1
	add.w	(a1),a1
	jsr	(a1)
	not.b	d0
	beq.s	ResetEnvWaveform
	move.b	EnvCtrlSpecTab-1(pc,d0.w),d0
	bpl.s	EnvCtrlSpecSet
	not.b	d0
	bclr	d0,pes_EnvelopeFlags(a1)
	rts
EnvCtrlSpecSet:	bset	d0,pes_EnvelopeFlags(a1)
NotResetWave:	rts
SetEnvRelValue:	add.w	d2,(a1)
	rts
ResetEnvWaveform:	move.l	(a1),d0
	beq.s	NotResetWave
	move.l	d0,a0
	move.w	tcie_Tempo(a0),pes_EnvelopeTempo(a1)
	clr.l	pes_EnvelopeSustainCounted(a1)
	clr.w	pes_EnvelopeTempoCount(a1)
	movem.l	tcie_SustainStart(a0),d0/d2-d4
	movem.l	d0/d2-d4,pes_EnvelopeSustainStart(a1)
	move.b	tcie_Flags+1(a0),pes_EnvelopeRepFlags(a1)
	move.w	pes_EnvelopePos(a1),d0
	bra	SetEnvelope
EnvCtrlChgTab:	dc.b	pes_EnvelopeStructure
	dc.b	pes_EnvelopePos
	dc.b	pes_EnvelopeTempo
	dc.b	pes_EnvelopeTempo
	dc.b	pes_EnvelopeTempoCount
	dc.b	pes_EnvelopeSustainStart
	dc.b	pes_EnvelopeSustainEnd
	dc.b	pes_EnvelopeSustainCount
	dc.b	pes_EnvelopeSustainCounted
	dc.b	pes_EnvelopeLoopStart
	dc.b	pes_EnvelopeRestart
	dc.b	pes_EnvelopeLoopEnd
	dc.b	pes_EnvelopeEnd
	dc.b	pes_EnvelopeLoopCount
	dc.b	pes_EnvelopeLoopCounted
	dc.b	pes_EnvelopeLowestValue
	dc.b	pes_EnvelopeHighestValue
	dc.b	-1
EnvCtrlSpecTab:	dc.b	PESB_NoRetrig,~PESB_NoRetrig,~PESB_Random,PESB_Random,~PESB_RndDelay,PESB_RndDelay,~PESB_FirstAdd,PESB_FirstAdd
SetEnvPosNode:	move.l	(a1),d0
	beq.s	NotResetWave
	move.l	d0,a0
	move.w	tcie_NumNodes(a0),d1
	addq.w	#1,d2
	cmp.w	d1,d2
	blo.s	SetEnvPosNodeOk
	move.w	d1,d2
SetEnvPosNodeOk:	move.l	tcie_NodePoints(a0),a0
	move.w	-2(a0,d2.l*2),pes_EnvelopePos(a1)
	rts
UseVolEnv:	lea	pc_VolEnvelope(a2),a1
	rts
UsePanEnv:	lea	pc_PanEnvelope(a2),a1
	rts
UseSlideEnv:	lea	pc_SlideEnvelope(a2),a1
	rts
UseVibEnv:	lea	phc_VibratoEnv(a3),a1
	rts
UseTremoEnv:	lea	phc_TremoloEnv(a3),a1
	rts
UsePannoEnv:	lea	phc_PannoloEnv(a3),a1
	rts
UseChanEnv:	lea	phc_ChannoloEnv(a3),a1
	rts
UseSpenEnv:	lea	([tcso_GlobalData.w,a4],pg_SpenoloEnv.w),a1
	rts
UseAutoVibEnv:	lea	pc_AutoVibEnv(a2),a1
	rts
UseAutoTremEnv:	lea	pc_AutoTremoEnv(a2),a1
	rts
UseAutoPanEnv:	lea	pc_AutoPanEnv(a2),a1
	rts
UseTrkTremEnv:	lea	phc_TrackTremEnv(a3),a1
	rts
UseTrkPanEnv:	lea	phc_TrackPanEnv(a3),a1
	rts
UseGlobTremEnv:	lea	([tcso_GlobalData.w,a4],pg_TremoloEnv.w),a1
	rts
UseGlobPanEnv:	lea	([tcso_GlobalData.w,a4],pg_PannoloEnv.w),a1
	rts
UseArpEnv:	lea	phc_ArpStructure(a3),a1
	rts
RefreshVolEnv:	move.l	(a1),phc_PrevVolumeEnv(a3)
	rts
RefreshPanEnv:	move.l	(a1),phc_PrevPanningEnv(a3)
	rts
RefreshSlideEnv:	move.l	(a1),phc_PrevSlideEnv(a3)
	rts
RefreshAutoVibEnv:	move.l	(a1),phc_PrevAutoVibEnv(a3)
	rts
RefreshAutoTremEnv:	move.l	(a1),phc_PrevAutoTremEnv(a3)
	rts
RefreshAutoPanEnv:	move.l	(a1),phc_PrevAutoPanEnv(a3)
	rts
NNACtrl:	move.w	d2,d1
	lsr.w	#8,d1
	beq.s	NNAControl
	subq.b	#1,d1
	beq.s	ClrDCTBits
	subq.b	#1,d1
	beq.s	DNACtrl
	cmp.b	#$11-2,d1
	bne.s	NNACtrlDone
	tst.b	d2
	bne.s	DCTCtrlOR
	moveq	#-1,d2
DCTCtrlOR:	or.b	d2,phc_DCT(a3)
NNACtrlDone:	rts
DNACtrl:	move.b	d2,phc_DNA(a3)
	rts
NNAControl:	move.b	d2,d1
	cmp.b	#$3,d1
	bhi.s	NNACtrlDone
	move.b	NNACtrlTab(pc,d1.w),phc_NNA(a3)
	rts
ClrDCTBits:	tst.b	d2
	bne.s	DCTCtrlAND
	moveq	#-1,d2
DCTCtrlAND:	not.b	d2
	and.b	d2,phc_DCT(a3)
	rts
NNACtrlTab:	dc.b	NNA_NOTE_CUT,NNA_NOTE_OFF,NNA_NOTE_CONTINUE,NNA_NOTE_FADE
LoopCtrl:
	rts
SetSpeed:	move.l	tcso_GlobalData(a4),a0
	move.l	d2,d0
	and.w	#$f000,d0
	rol.w	#4,d0
	bsr.s	GetSpeedAdr
	beq.s	SetSpeedDone
	and.w	#$fff,d2
	bne.s	SpeedValOk
	move.w	(a1),d2
SpeedValOk:	cmp.w	d4,d2
	bhs.s	SpeedLowerLimitOk
	move.w	d4,d2
SpeedLowerLimitOk:	cmp.w	d5,d2
	bls.s	SpeedHigherLimitOk
	move.w	d5,d2
SpeedHigherLimitOk:	move.w	d2,(a1)
	move.b	d0,pg_SpeedType(a0)
	asl.b	#4,d0
	bmi.s	SetSpeedDone
	move.b	d0,d3
	and.b	#7,d3
	beq.s	SetBpMMode
	subq.b	#2,d3
	bne.s	UpdateSpeed
	bset	#PGB_SPD,(a0)
	bra.s	UpdateSpeed
GetSpeedAdr:	movem.w	tcso_BPMSpeedLowerLimit(a4),d4-d5
	lea	pg_BPMSpeed(a0),a1
	move.b	d0,d3
	and.b	#7,d3
	beq.s	SpeedAdrOk
	movem.w	tcso_BPMTempoLowerLimit(a4),d4-d5
	lea	pg_BPMTempo(a0),a1
	subq.b	#1,d3
	beq.s	SpeedAdrOk
	movem.w	tcso_SPDLowerLimit(a4),d4-d5
	lea	pg_SPDSpeed(a0),a1
	subq.b	#1,d3
	beq.s	SpeedAdrOk
	moveq	#1,d4
	moveq	#-1,d5
	lea	pg_SpeedMul(a0),a1
	subq.b	#5,d3
	beq.s	SpeedAdrOk
	moveq	#0,d3
SetSpeedDone:	rts
SpeedAdrOk:	moveq	#-1,d3
	rts
SetBpMMode:	bclr	#PGB_SPD,(a0)
UpdateSpeed:	btst	#PGB_SPD,(a0)
	beq.s	UpdateBpM
	cmp.w	#10,d2
	bhi.s	UseSPDTempo
	move.l	([tcb_OldSTTable.w,a6],d2.w*4),d2
	bra.s	UpdateSPD
UseSPDTempo:	mulu.l	#989156,d2
	bra.s	UpdateSPD
UpdateBpM:	mulu.w	pg_BPMTempo(a0),d2
	swap	d2
	moveq	#0,d3
	move.w	d2,d3
	clr.w	d2
	tst.l	d3
	beq.s	NoSpeedDiv
	move.b	pg_SpeedDiv(a0),d0
	exg	d0,d2
	move.l	d3,d1
	bsr	DIVU64
	move.l	d0,d2
	moveq	#0,d0
	move.b	pg_SpeedMul(a0),d0
	mulu.l	d0,d2
	bra.s	NoSpeedDiv
UpdateSPD:	moveq	#0,d3
	move.b	pg_SpeedMul(a0),d0
	move.l	d2,d1
	bsr	MULU64
	moveq	#0,d2
	move.b	pg_SpeedDiv(a0),d2
	bsr	DIVU64
	move.l	d0,d2
NoSpeedDiv:	move.l	d2,pg_Tempo(a0)
	move.l	d2,d0
	move.l	pg_RelativeSpeed(a0),d1
	bsr	MULU64
	move.w	d1,d0
	swap	d0
	move.l	a6,d3
	move.l	a0,d4
	move.l	tcb_PlayMixerAlloc(a6),a0
	move.l	(a0),a6
	jsr	_LVOExternalMixerChangeTempo(a6)
	move.l	d4,a0
	move.l	d3,a6
	rts
CheckSpeedSlide:	tst.w	tcte_DataWord(a0)
	beq.s	TriggerFineSpdSlide
	and.w	#~(FSF_SpeedSlideSlower>>16|FSF_FineSpeedSlideSlower>>16|FSF_FineSpeedSlide>>16),phc_FineSlideFlags(a3)
	move.w	(SpeedSlideMask-(FX_SPD_SLD_FAST*2).w,pc,d0.w*2),d1
	or.w	d1,phc_FineSlideFlags(a3)
	rts
SpeedSlideMask:	dc.w	0
	dc.w	FSF_SpeedSlideSlower>>16
	dc.w	FSF_FineSpeedSlide>>16
	dc.w	FSF_FineSpeedSlideSlower>>16|FSF_FineSpeedSlide>>16
TriggerFineSpdSlide:	move.l	phc_Track(a3),a1
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotTrigFineSpd
	moveq	#FX_SPD_SLD_FAST,d0
	btst	#FSB_FineSpeedSlide-16,phc_FineSlideFlags+1(a3)
	beq.s	NotTrigFineSpd
	moveq	#FX_F_S_SLD_FAST,d0
NotTrigFineSpd:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	TriggerSpdSlDone
	move.w	d0,d1
	subq.b	#FX_SPD_SLD_FAST-FX_SET_SPEED,d0
	bclr	#0,d0
	move.w	(SpeedSlideTrigMask-(FX_SPD_SLD_FAST*2).w,pc,d1.w*2),d1
	and.w	phc_FineSlideFlags(a3),d1
	beq.s	TriggerSpdSlOk
	bset	#0,d0
TriggerSpdSlOk:	addq.b	#FX_SPD_SLD_FAST-FX_SET_SPEED,d0
TriggerSpdSlDone:	bset	#4,d4
	cmp.b	#FX_F_S_SLD_FAST,d0
	blo.s	TriggerSpdSlFineOk
	bclr	#4,d4
TriggerSpdSlFineOk:	rts
SpeedSlideTrigMask:	dc.w	FSF_SpeedSlideSlower>>16
	dc.w	FSF_SpeedSlideSlower>>16
	dc.w	FSF_FineSpeedSlideSlower>>16
	dc.w	FSF_FineSpeedSlideSlower>>16
	dc.w	CheckSpeedSlide-SpdSlFast+2
SpdSlFast:	move.l	tcso_GlobalData(a4),a0
	bne.s	NotSpdSlFastNew
	move.w	pg_SpeedSlideFasterValue(a0),d2
NotSpdSlFastNew:	bsr.s	DoSpeedSlide
	move.l	phc_Track(a3),a1
	movem.w	pg_SpeedSlideSlowerValue(a0),d3-d5
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotSpdSlFastAll
	move.w	d2,d4
NotSpdSlFastAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotSpdSlFastOpposite
	move.w	d2,d3
	move.w	d4,d5
NotSpdSlFastOpposite:	movem.w	d2-d5,pg_SpeedSlideFasterValue(a0)
SpdSlFastDone:	rts
	dc.w	CheckSpeedSlide-SpdSlSlow+2
SpdSlSlow:	move.l	tcso_GlobalData(a4),a0
	bne.s	NotSpdSlSlowNew
	move.w	pg_SpeedSlideSlowerValue(a0),d2
NotSpdSlSlowNew:	bsr.s	DoSpeedSlideSlow
	move.l	phc_Track(a3),a1
	movem.w	pg_SpeedSlideFasterValue(a0),d0-d1/d3-d4
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotSpdSlSlowAll
	move.w	d2,d4
NotSpdSlSlowAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotSpdSlSlowOpposite
	move.w	d2,d0
	move.w	d4,d3
NotSpdSlSlowOpposite:	movem.w	d0/d2-d4,pg_SpeedSlideFasterValue(a0)
SpdSlSlowDone:	rts
DoSpeedSlide:	move.l	d2,-(sp)
	moveq	#0,d0
	move.b	pg_SpeedType(a0),d0
	bsr	GetSpeedAdr
	beq.s	SpdSlSlowDone
	add.w	(a1),d2
	bcc.s	NotSpdSlOverflow
	moveq	#-1,d2
NotSpdSlOverflow:	bsr	SpeedValOk
	move.l	(sp)+,d2
	rts
DoSpeedSlideSlow:	move.l	d2,-(sp)
	moveq	#0,d0
	move.b	pg_SpeedType(a0),d0
	bsr	GetSpeedAdr
	beq.s	SpdSlSlowDone
	sub.w	(a1),d2
	bcs.s	NotSpeedSlideTooSlow
	moveq	#0,d2
NotSpeedSlideTooSlow:	neg.w	d2
	bsr	SpeedValOk
	move.l	(sp)+,d2
	rts
	dc.w	CheckSpeedSlide-FSpdSlFast+2
FSpdSlFast:	move.l	tcso_GlobalData(a4),a0
	bne.s	NotFSpdSlFastNew
	move.w	pg_FineSpeedSlideFastValue(a0),d2
NotFSpdSlFastNew:	bsr.s	DoSpeedSlide
	move.l	phc_Track(a3),a1
	movem.w	pg_SpeedSlideFasterValue(a0),d0-d1/d3-d4
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotFSpdSlFastAll
	move.w	d2,d0
NotFSpdSlFastAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotFSpdSlFastOpposite
	move.w	d0,d1
	move.w	d2,d4
NotFSpdSlFastOpposite:	movem.w	d0-d2/d4,pg_SpeedSlideFasterValue(a0)
FSpdSlFastDone:	rts
	dc.w	CheckSpeedSlide-FSpdSlSlow+2
FSpdSlSlow:	move.l	tcso_GlobalData(a4),a0
	bne.s	NotFSpdSlSlowNew
	move.w	pg_FineSpeedSlideSlowValue(a0),d2
NotFSpdSlSlowNew:	bsr.s	DoSpeedSlideSlow
	move.l	phc_Track(a3),a1
	movem.w	pg_SpeedSlideFasterValue(a0),d0-d1/d3-d4
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotFSpdSlSlowAll
	move.w	d2,d1
NotFSpdSlSlowAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotFSpdSlSlowOpposite
	move.w	d1,d0
	move.w	d2,d3
NotFSpdSlSlowOpposite:	exg	d3,d2
	movem.w	d0-d3,pg_SpeedSlideFasterValue(a0)
FSpdSlSlowDone:	rts
SpdSlTo:
	rts
Spenolo:
	rts
CheckChCtrl:	rts
	dc.w	CheckChCtrl-ChCtrl+2
ChCtrl:	move.w	d2,d0
	lsr.w	#8,d0
	cmp.w	#$10,d0
	bne.s	FXChCtrlDone
	lea	pc_Flags+1(a2),a0
	subq.b	#1,d2
	bcs.s	SurOff
	beq.s	SurOn
	lea	phc_Flags+3(a3),a0
	cmp.b	#$10,d2
	bcs.s	TSurOff
	beq.s	TSurOn
	move.l	tcso_GlobalData(a4),a0
	cmp.b	#$20,d2
	bcs.s	GSurOff
	bne.s	FXChCtrlDone
	bset	#PGB_Surround,(a0)
	rts
GSurOff:	bclr	#PGB_Surround,(a0)
	rts
SurOn:	bsr.s	CheckSurTPan
SurOnSkip:	bset	#PHCB_TrackSurPan,phc_Flags+3(a3)
SurroundOn:	bset	#PCB_SmpSurPan,(a0)
	rts
CheckSurTPan:	cmp.w	pc_HostChannel(a2),d7
	bne.s	WrongSurCh
	btst	#PHCB_AffectChanPan,phc_Flags+3(a3)
	bne.s	FXChCtrlDone
	tst.b	d2
	bne.s	SurroundOff
	addq.l	#4,sp
	bra.s	SurroundOn
WrongSurCh:	btst	#PHCB_AffectChanPan,phc_Flags+3(a3)
	beq.s	NotDoSurCh
	bclr	#PHCB_TrackSurPan,phc_Flags+3(a3)
	tst.b	d2
	bne.s	NotDoSurCh
	bset	#PHCB_TrackSurPan,phc_Flags+3(a3)
NotDoSurCh:	addq.l	#4,sp
	rts
SurOff:	bsr.s	CheckSurTPan
	bclr	#PHCB_TrackSurPan,phc_Flags+3(a3)
SurroundOff:	bclr	#PCB_SmpSurPan,(a0)
FXChCtrlDone:	rts
TSurOn:	bset	#PHCB_ChannelSurPan,(a0)
	rts
TSurOff:	bclr	#PHCB_ChannelSurPan,(a0)
	rts
CheckGVolSlide:	tst.w	tcte_DataWord(a0)
	beq.s	TriggerFineGVol
	and.w	#~(FSF_GlobalVolSlideDown>>16|FSF_FineGVolSlideDown>>16|FSF_FineGlobalVolSlide>>16),phc_FineSlideFlags(a3)
	move.w	(GVolSlideMask-(FX_G_VOLSL_UP*2).w,pc,d0.w*2),d1
	or.w	d1,phc_FineSlideFlags(a3)
	rts
GVolSlideMask:	dc.w	0
	dc.w	FSF_GlobalVolSlideDown>>16
	dc.w	FSF_FineGlobalVolSlide>>16
	dc.w	FSF_FineGVolSlideDown>>16|FSF_FineGlobalVolSlide>>16
TriggerFineGVol:	move.l	phc_Track(a3),a1
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotTrigFineGVol
	moveq	#FX_G_VOLSL_UP,d0
	btst	#FSB_FineGlobalVolSlide-24,phc_FineSlideFlags(a3)
	beq.s	NotTrigFineGVol
	moveq	#FX_F_G_VOL_UP,d0
NotTrigFineGVol:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	TriggerGVolSlDone
	move.w	d0,d1
	bclr	#0,d0
	move.w	(GVolSlideTrigMask-(FX_G_VOLSL_UP*2).w,pc,d1.w*2),d1
	and.w	phc_FineSlideFlags(a3),d1
	beq.s	TriggerGVolSlDone
	bset	#0,d0
TriggerGVolSlDone:	bset	#4,d4
	cmp.b	#FX_F_G_VOL_UP,d0
	blo.s	TriggerGVolSlFineOk
	bclr	#4,d4
TriggerGVolSlFineOk:	rts
GVolSlideTrigMask:	dc.w	FSF_GlobalVolSlideDown>>16
	dc.w	FSF_GlobalVolSlideDown>>16
	dc.w	FSF_FineGVolSlideDown>>16
	dc.w	FSF_FineGVolSlideDown>>16
	dc.w	CheckGVolSlide-GVolSlUp+2
GVolSlUp:	move.l	tcso_GlobalData(a4),a0
	bne.s	NotGVolSlUpNew
	move.w	pg_GlobalVolSlideUpValue(a0),d2
NotGVolSlUpNew:	bsr.s	DoGVolumeSlide
	move.l	phc_Track(a3),a1
	movem.w	pg_GlobalVolSlideDownValue(a0),d3-d5
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotGVolSlUpAll
	move.w	d2,d4
NotGVolSlUpAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotGVolSlUpOpposite
	move.w	d2,d3
	move.w	d4,d5
NotGVolSlUpOpposite:	movem.w	d2-d5,pg_GlobalVolSlideUpValue(a0)
GVolSlUpDone:	rts
	dc.w	CheckGVolSlide-GVolSlDn+2
GVolSlDn:	move.l	tcso_GlobalData(a4),a0
	bne.s	NotGVolSlDnNew
	move.w	pg_GlobalVolSlideDownValue(a0),d2
NotGVolSlDnNew:	bsr.s	DoGVolumeSlideDn
	move.l	phc_Track(a3),a1
	movem.w	pg_GlobalVolSlideUpValue(a0),d0-d1/d3-d4
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotGVolSlDnAll
	move.w	d2,d4
NotGVolSlDnAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotGVolSlDnOpposite
	move.w	d2,d0
	move.w	d4,d3
NotGVolSlDnOpposite:	movem.w	d0/d2-d4,pg_GlobalVolSlideUpValue(a0)
GVolSlDnDone:	rts
SetGVol:	move.l	tcso_GlobalData(a4),a0
	bsr	CheckOldTVol
	move.w	d2,pg_GlobalVolume(a0)
	rts
DoGVolumeSlide:	bsr	CheckOldTVol
	add.w	d2,pg_GlobalVolume(a0)
	bcc.s	GVolSlDone
	move.w	#-1,pg_GlobalVolume(a0)
GVolSlDone:	rts
DoGVolumeSlideDn:	bsr	CheckOldTVol
	sub.w	d2,pg_GlobalVolume(a0)
	bcc.s	GVolSlDone
	clr.w	pg_GlobalVolume(a0)
	rts
	dc.w	CheckGVolSlide-FGVolSlUp+2
FGVolSlUp:	move.l	tcso_GlobalData(a4),a0
	bne.s	NotFGVolSlUpNew
	move.w	pg_FineGlobalVolSlUpValue(a0),d2
NotFGVolSlUpNew:	bsr.s	DoGVolumeSlide
	move.l	phc_Track(a3),a1
	movem.w	pg_GlobalVolSlideUpValue(a0),d0-d1/d3-d4
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotFGVolSlUpAll
	move.w	d2,d0
NotFGVolSlUpAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotFGVolSlUpOpposite
	move.w	d0,d1
	move.w	d2,d4
NotFGVolSlUpOpposite:	movem.w	d0-d2/d4,pg_GlobalVolSlideUpValue(a0)
FGVolSlUpDone:	rts
	dc.w	CheckGVolSlide-FGVolSlDn+2
FGVolSlDn:	move.l	tcso_GlobalData(a4),a0
	bne.s	NotFGVolSlDnNew
	move.w	pg_FineGlobalVolSlDownValue(a0),d2
NotFGVolSlDnNew:	bsr.s	DoGVolumeSlideDn
	move.l	phc_Track(a3),a1
	movem.w	pg_GlobalVolSlideUpValue(a0),d0-d1/d3-d4
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotFGVolSlDnAll
	move.w	d2,d1
NotFGVolSlDnAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotFGVolSlDnOpposite
	move.w	d1,d0
	move.w	d2,d3
NotFGVolSlDnOpposite:	exg	d3,d2
	movem.w	d0-d3,pg_GlobalVolSlideUpValue(a0)
FGVolSlDnDone:	rts
	dc.w	CheckVolSlTo-GVolSlTo+2
GVolSlTo:	move.l	tcso_GlobalData(a4),a0
	tst.b	d2
	bne.s	NotGVolSlToNewSpd
	move.b	pg_GlobalVolumeSlideToValue(a0),d2
NotGVolSlToNewSpd:	move.b	d2,pg_GlobalVolumeSlideToValue(a0)
	move.b	d2,pg_GlobalVolumeSlideToSlide(a0)
	lsr.w	#8,d2
	beq.s	DoGVolSlideTo
	move.b	d2,d1
	addq.b	#1,d1
	beq.s	DoGVolSlideTo
	move.b	d2,pg_GlobalVolumeSlToVolume(a0)
	bra.s	GVolSlToDone
DoGVolSlideTo:	tst.b	pg_GlobalVolumeSlToVolume(a0)
	beq.s	GVolSlToDone
	move.w	pg_GlobalVolumeSlideToSlide(a0),d2
	move.w	pg_GlobalVolumeSlToVolume(a0),d1
	move.w	pg_GlobalVolume(a0),d0
	cmp.w	d1,d0
	blo.s	GVolSlideToUp
	bsr	DoGVolumeSlideDn
	cmp.w	pg_GlobalVolume(a0),d1
	blo.s	GVolSlToDone
	move.w	d1,pg_GlobalVolume(a0)
	clr.b	pg_GlobalVolumeSlToVolume(a0)
	rts
GVolSlideToUp:	bsr	DoGVolumeSlide
	cmp.w	pg_GlobalVolume(a0),d1
	bhi.s	GVolSlToDone
	move.w	d1,pg_GlobalVolume(a0)
	clr.b	pg_GlobalVolumeSlToVolume(a0)
GVolSlToDone:	rts
GTremo:	move.l	tcso_GlobalData(a4),a0
	move.w	d2,d4
	lsr.w	#8,d4
	bne.s	NotPrevGTrmSpd
	move.b	pg_TremoloRate(a0),d4
NotPrevGTrmSpd:	move.b	d4,pg_TremoloRate(a0)
	ext.w	d2
	bne.s	NotPrevGTrmDepth
	move.b	pg_TremoloDepth(a0),d2
NotPrevGTrmDepth:	move.b	d2,pg_TremoloDepth(a0)
	ext.w	d2
	btst	#TCSOCB_OldVolumes,tcso_CompFlags(a4)
	beq.s	OldGTremoVals
	cmp.w	#63,d2
	ble.s	OldGTremoVolUpOk
	moveq	#63,d2
OldGTremoVolUpOk:	cmp.w	#-63,d2
	bge.s	OldGTremoVolUpOk
	moveq	#-63,d2
OldGTremoVals:	neg.w	d2
	move.w	d2,-(sp)
	moveq	#0,d5
	lea	pg_TremoloEnv(a0),a0
	bsr	RunEnvelope
	move.l	tcso_GlobalData(a4),a0
	muls.w	(sp)+,d0
	asr.l	#7,d0
	btst	#TCSOCB_OldVolumes,tcso_CompFlags(a4)
	beq.s	NotGTremoOldVol
	asl.w	#2,d0
NotGTremoOldVol:	sub.w	pg_TremoloSlideValue(a0),d0
	move.b	pg_GlobalVolume(a0),d5
	add.w	d5,d0
	bpl.s	GTremoLoOk
	moveq	#0,d0
GTremoLoOk:	cmp.w	#256,d0
	blt.s	GTremoHiOk
	move.w	#255,d0
GTremoHiOk:	move.b	d0,pg_GlobalVolume(a0)
	sub.w	d0,d5
	sub.w	d5,pg_TremoloSlideValue(a0)
	rts
SetGPan:	move.l	tcso_GlobalData(a4),a0
	bclr	#PGB_Surround,(a0)
	move.w	d2,pg_GlobalPanning(a0)
	rts
CheckGPanSlide:	tst.w	tcte_DataWord(a0)
	beq.s	TriggerFineGPan
	and.b	#~(FSF_GlobalPanSlideRight>>24|FSF_FineGPanSlideRight>>24|FSF_FineGlobalPanSlide>>24),phc_FineSlideFlags(a3)
	move.b	GPanSlideMask-(FX_GPANSL_LEFT)(pc,d0.w),d1
	or.b	d1,phc_FineSlideFlags(a3)
	rts
GPanSlideMask:	dc.b	0
	dc.b	FSF_GlobalPanSlideRight>>24
	dc.b	FSF_FineGlobalPanSlide>>24
	dc.b	FSF_FineGPanSlideRight>>24|FSF_FineGlobalPanSlide>>24
TriggerFineGPan:	move.l	phc_Track(a3),a1
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotTrigFineGPan
	moveq	#FX_GPANSL_LEFT,d0
	btst	#FSB_FineGlobalPanSlide-24,phc_FineSlideFlags(a3)
	beq.s	NotTrigFineGPan
	moveq	#FX_FGP_SL_LEFT,d0
NotTrigFineGPan:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	TriggerGPanSlDone
	move.w	d0,d1
	bclr	#0,d0
	move.b	GPanSlideTrigMask-(FX_GPANSL_LEFT)(pc,d1.w),d1
	btst	d1,phc_FineSlideFlags(a3)
	beq.s	TriggerGPanSlDone
	bset	#0,d0
TriggerGPanSlDone:	bset	#4,d4
	cmp.b	#FX_FGP_SL_LEFT,d0
	blo.s	TriggerGPanSlFineOk
	bclr	#4,d4
TriggerGPanSlFineOk:	rts
GPanSlideTrigMask:	dc.b	FSB_GlobalPanSlideRight-24
	dc.b	FSB_GlobalPanSlideRight-24
	dc.b	FSB_FineGPanSlideRight-24
	dc.b	FSB_FineGPanSlideRight-24
	dc.w	CheckGPanSlide-GPanSlLeft+2
GPanSlLeft:	move.l	tcso_GlobalData(a4),a0
	bne.s	NotGPanSlLeftNew
	move.w	pg_GlobalPanSlideLeftValue(a0),d2
NotGPanSlLeftNew:	bsr.s	DoGPanSlide
	move.l	phc_Track(a3),a1
	movem.w	pg_GlobalPanSlideRightValue(a0),d3-d5/a0
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotGPanSlLeftAll
	move.w	d2,d4
	move.w	d2,a0
NotGPanSlLeftAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotGPanSlLeftOpposite
	move.w	d2,d3
	move.w	d4,d5
NotGPanSlLeftOpposite:	movem.w	d2-d5/a0,pg_GlobalPanSlideLeftValue(a0)
GPanSlLeftDone:	rts
	dc.w	CheckGPanSlide-GPanSlRight+2
GPanSlRight:	move.l	tcso_GlobalData(a4),a0
	bne.s	NotGPanSlRightNew
	move.w	pg_GlobalPanSlideRightValue(a0),d2
NotGPanSlRightNew:	bsr.s	DoGPanSlideRight
	move.l	phc_Track(a3),a1
	movem.w	pg_GlobalPanSlideLeftValue(a0),d0-d1/d3-d5
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotGPanSlRightAll
	move.w	d2,d4
	move.w	d2,d5
NotGPanSlRightAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotGPanSlRightOpposite
	move.w	d2,d0
	move.w	d4,d3
NotGPanSlRightOpposite:	movem.w	d0/d2-d5,pg_GlobalPanSlideLeftValue(a0)
GPanSlRightDone:	rts
DoGPanSlide:	bclr	#PGB_Surround,(a0)
	sub.w	d2,pg_GlobalPanning(a0)
	bcc.s	GPanSlDone
	clr.w	pg_GlobalPanning(a0)
GPanSlDone:	rts
DoGPanSlideRight:	bclr	#PGB_Surround,(a0)
	add.w	d2,pg_GlobalPanning(a0)
	bcc.s	GPanSlDone
	move.w	#-1,pg_GlobalPanning(a0)
	rts
	dc.w	CheckGPanSlide-FGPanSlLeft+2
FGPanSlLeft:	move.l	tcso_GlobalData(a4),a0
	bne.s	NotFGPanSlLeftNew
	move.w	pg_FineGlobalPanSlLeftValue(a0),d2
NotFGPanSlLeftNew:	bsr.s	DoGPanSlide
	move.l	phc_Track(a3),a1
	movem.w	pg_GlobalPanSlideLeftValue(a0),d0-d1/d3-d5
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotFGPanSlLeftAll
	move.w	d2,d0
	move.w	d2,d5
NotFGPanSlLeftAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotFGPanSlLeftOpposite
	move.w	d0,d1
	move.w	d2,d4
NotFGPanSlLeftOpposite:	movem.w	d0-d2/d4-d5,pg_GlobalPanSlideLeftValue(a0)
FGPanSlLeftDone:	rts
	dc.w	CheckGPanSlide-FGPanSlRight+2
FGPanSlRight:	move.l	tcso_GlobalData(a4),a0
	bne.s	NotFGPanSlRightNew
	move.w	pg_FineGlobalPanSlRightVal(a0),d2
NotFGPanSlRightNew:	bsr.s	DoGPanSlideRight
	move.l	phc_Track(a3),a1
	movem.w	pg_GlobalPanSlideLeftValue(a0),d0-d1/d3-d5
	btst	#TCTCB_VolSlide,tct_CompFlags(a1)
	beq.s	NotFGPanSlRightAll
	move.w	d2,d1
	move.w	d2,d5
NotFGPanSlRightAll:	btst	#TCTCB_OpVSlide,tct_CompFlags(a1)
	bne.s	NotFGPanSlRightOpposite
	move.w	d1,d0
	move.w	d2,d3
NotFGPanSlRightOpposite:	exg	d3,d2
	movem.w	d0-d3/d5,pg_GlobalPanSlideLeftValue(a0)
FGPanSlRightDone:	rts
	dc.w	CheckVolSlTo-GPanSlTo+2
GPanSlTo:	move.l	tcso_GlobalData(a4),a0
	tst.b	d2
	bne.s	NotGPanSlToNewSpd
	move.b	pg_GlobalPanSlideToValue(a0),d2
NotGPanSlToNewSpd:	move.b	d2,pg_GlobalPanSlideToValue(a0)
	move.b	d2,pg_GlobalPanSlideToSlide(a0)
	lsr.w	#8,d2
	beq.s	DoGPanSlideTo
	move.b	d2,d1
	addq.b	#1,d1
	beq.s	DoGPanSlideTo
	move.b	d2,pg_GlobalPanSlideToPanning(a0)
	bra.s	GPanSlToDone
DoGPanSlideTo:	tst.b	pg_GlobalPanSlideToPanning(a0)
	beq.s	GPanSlToDone
	move.w	pg_GlobalPanSlideToSlide(a0),d2
	move.w	pg_GlobalPanSlideToPanning(a0),d1
	move.w	pg_GlobalPanning(a0),d0
	cmp.w	d1,d0
	blo.s	GPanSlideToRight
	bsr	DoGPanSlide
	cmp.w	pg_GlobalPanning(a0),d1
	blo.s	GPanSlToDone
	move.w	d1,pg_GlobalPanning(a0)
	clr.b	pg_GlobalPanSlideToPanning(a0)
	rts
GPanSlideToRight:	bsr	DoGPanSlideRight
	cmp.w	pg_GlobalPanning(a0),d1
	bhi.s	GPanSlToDone
	move.w	d1,pg_GlobalPanning(a0)
	clr.b	pg_GlobalPanSlideToPanning(a0)
GPanSlToDone:	rts
GPannolo:	move.w	d2,d4
	lsr.w	#8,d4
	bne.s	NotPrevGPanSpd
	move.b	pg_PannoloRate(a0),d4
NotPrevGPanSpd:	move.b	d4,pg_PannoloRate(a0)
	ext.w	d2
	bne.s	NotPrevGPanDepth
	move.b	pg_PannoloDepth(a0),d2
NotPrevGPanDepth:	move.b	d2,pg_PannoloDepth(a0)
	ext.w	d2
	neg.w	d2
	move.w	d2,-(sp)
	moveq	#0,d5
	lea	pg_PannoloEnv(a0),a0
	bsr	RunEnvelope
	move.l	tcso_GlobalData(a4),a0
	muls.w	(sp)+,d0
	asr.l	#7,d0
	sub.w	pg_PannoloSlideValue(a0),d0
	move.b	pg_GlobalPanning(a0),d5
	add.w	d5,d0
	bpl.s	GPannoLoOk
	moveq	#0,d0
GPannoLoOk:	cmp.w	#255,d0
	ble.s	GPannoHiOk
	move.w	#255,d0
GPannoHiOk:	move.b	d0,pg_GlobalPanning(a0)
	sub.w	d0,d5
	sub.w	d5,pg_PannoloSlideValue(a0)
	rts
UserSync:
	rts
; Player effects table. Each entry has one WORD and two UBYTEs. First is
; relative offset of this effect to this table. The first UBYTE (the left) is
; a bitfield and the second is the standard execution tick. The bitfield has
; these following entries:
; Bit # | Meanings
;   0-1 | AND-Mask for control effects.
;     4 | If set, the effect will be executed the whole row, else only once.
;     6 | This effect has to set flags before the pattern row is evaluated.
;         The routine is accessed with (assumed that FXTable is in A1 and
;         the effect number in D0):
;         add.w	(a1,d0.w*4),a1	; Get effect execute code
;         add.w	-4(a1),a1		; Get the pre-pattern evaluation FX-routine.
;                               ; Call the routine with JSR/JMP.
;     7 | This effect needs checking its parameters (e.g. on 0 by portamento)
;         and restore/change the effect/value if needed. The code pointer is
;         the WORD before the function, i.e. you can get it with code like
;         (assumed that the FXTable is in A1 and the effect number in D0):
;         add.w	(a1,d0.w*4),a1	; Get effect execution code (jump this to
;         						; execute the effect with data word in D2)
;         add.w	-(a1),a1		; Get check execution code (jump this to
;         						; execute checking with bitfield in D4,
;         						; effect number in D0 and data word in D2).
;         						; D0/D2/D4 might be changed on return. Use
;         						; these values to execute the effect.

_FXTable:	dc.w	Arpeggio-_FXTable,$1100,PortaUp-_FXTable,$9101,PortaDn-_FXTable,$9101,FPortaUp-_FXTable,$9101,FPortaDn-_FXTable,$9101,PortaUpOnce-_FXTable,$8100,PortaDnOnce-_FXTable,$8100,FPortaUpOnce-_FXTable,$8100	* 00-07
	dc.w	FPortaDnOnce-_FXTable,$8100,TonePorta-_FXTable,$d101,FTonePorta-_FXTable,$d101,TPortaOnce-_FXTable,$c100,FTPortaOnce-_FXTable,$c100,NoteSlide-_FXTable,$9101,Vibrato-_FXTable,$5101,FVibrato-_FXTable,$5101		* 08-0F
	dc.w	Vibrato-_FXTable,$4100,FVibrato-_FXTable,$4100,DoKeyOff-_FXTable,$1100,HoldDelay-_FXTable,$1100,NoteFade-_FXTable,$1100,NoteCut-_FXTable,$1100,NoteDelay-_FXTable,$4000,Tremor-_FXTable,$1100					* 10-17
	dc.w	Retrig-_FXTable,$1100,MulRetrig-_FXTable,$1100,ExtCtrl-_FXTable,$100,InvLoop-_FXTable,$1101,ExecFX-_FXTable,$100,StopFX-_FXTable,$100,Nop-_FXTable,0,Nop-_FXTable,0												* 18-1F
	dc.w	SetVol-_FXTable,$100,VolSlUp-_FXTable,$9101,VolSlDn-_FXTable,$9101,FVolSlUp-_FXTable,$8100,FVolSlDn-_FXTable,$8100,VolSlTo-_FXTable,$9101,Tremo-_FXTable,$5101,Tremo-_FXTable,$4100								* 20-27
	dc.w	SetTVol-_FXTable,$100,TVolSlUp-_FXTable,$9101,TVolSlDn-_FXTable,$9101,FTVolSlUp-_FXTable,$8100,FTVolSlDn-_FXTable,$8100,TVolSlTo-_FXTable,$9101,TTremo-_FXTable,$1101,TTremo-_FXTable,$100						* 28-2F
	dc.w	SetPan-_FXTable,$100,PanSlLeft-_FXTable,$9101,PanSlRight-_FXTable,$9101,FPanSlLeft-_FXTable,$8100,FPanSlRight-_FXTable,$8100,PanSlTo-_FXTable,$9101,Pannolo-_FXTable,$1101,Pannolo-_FXTable,$100				* 30-37
	dc.w	SetTPan-_FXTable,$100,TPanSlLeft-_FXTable,$9101,TPanSlRight-_FXTable,$9101,FTPanSlLeft-_FXTable,$8100,FTPanSlRight-_FXTable,$8100,TPanSlTo-_FXTable,$9101,TPannolo-_FXTable,$1101,TPannolo-_FXTable,$100		* 38-3F
	dc.w	SetTempo-_FXTable,$200,SetRelTempo-_FXTable,$200,PattBrk-_FXTable,$200,PosJump-_FXTable,$200,RelPosJmp-_FXTable,$200,ChgPattern-_FXTable,$200,RevPattPlay-_FXTable,$200,PattDelay-_FXTable,$200					* 40-47
	dc.w	FPattDelay-_FXTable,$200,PattLoop-_FXTable,$200,GoSub-_FXTable,$200,Return-_FXTable,$200,ChanSync-_FXTable,$200,SetSubSl-_FXTable,$100,Nop-_FXTable,0,Nop-_FXTable,0											* 48-4F
	dc.w	SmpOffHI-_FXTable,$100,SmpOffLO-_FXTable,$100,SetHold-_FXTable,$100,SetDecay-_FXTable,$100,SetTransp-_FXTable,$4100,InsCtrl-_FXTable,$100,InsChg-_FXTable,$100,SynthCtrl-_FXTable,$100							* 50-57
	dc.w	SetSynthVal-_FXTable,$100,EnvCtrl-_FXTable,$100,SetEnvVal-_FXTable,$100,NNACtrl-_FXTable,$100,LoopCtrl-_FXTable,$100,Nop-_FXTable,0,Nop-_FXTable,0,Nop-_FXTable,0												* 58-5F
	dc.w	SetSpeed-_FXTable,0,SpdSlFast-_FXTable,$9001,SpdSlSlow-_FXTable,$9001,FSpdSlFast-_FXTable,$8000,FSpdSlSlow-_FXTable,$8000,SpdSlTo-_FXTable,$9101,Spenolo-_FXTable,$1001,Spenolo-_FXTable,0						* 60-67
	dc.w	ChCtrl-_FXTable,$8000,SetGVol-_FXTable,0,GVolSlUp-_FXTable,$9001,GVolSlDn-_FXTable,$9001,FGVolSlUp-_FXTable,$8000,FGVolSlDn-_FXTable,$8000,GVolSlTo-_FXTable,$9001,GTremo-_FXTable,$1001						* 68-6F
	dc.w	GTremo-_FXTable,0,SetGPan-_FXTable,0,GPanSlLeft-_FXTable,$9001,GPanSlRight-_FXTable,$9001,FGPanSlLeft-_FXTable,$8000,FGPanSlRight-_FXTable,$8000,GPanSlTo-_FXTable,$9001,GPannolo-_FXTable,$1001				* 70-77
	dc.w	GPannolo-_FXTable,0,Nop-_FXTable,0,Nop-_FXTable,0,Nop-_FXTable,0,Nop-_FXTable,0,Nop-_FXTable,0,Nop-_FXTable,0,UserSync-_FXTable,$1000																			* 78-7F

ExecuteSynth:	moveq	#0,d0
	moveq	#0,d3
	moveq	#0,d5
ExecSynthLoop:	move.l	pc_Synth(a2),a0
	lea	pc_WaitVolCount(a2),a1
	move.w	pc_VolumePos-pc_WaitVolCount(a1,d4.l*2),d0
	subq.w	#1,(a1,d4.l*2)
	bcc.s	ExecSynthDone
	clr.w	(a1,d4.l*2)
	cmp.w	tcy_CodeEntries(a0),d0
	bhs.s	ExecSynthDone
	tst.b	pc_WaitVolType-pc_WaitVolCount(a1,d4.l)
	bmi.s	ExecSynthDone
	moveq	#4-1,d2
Wait4LineLoop:	move.b	pc_WaitVolType-pc_WaitVolCount(a1,d2.l),d3
	bpl.s	NotWait4Line
	not.b	d3
	cmp.l	d3,d4
	bne.s	NotWait4Line
	cmp.w	pc_WaitVolLine-pc_WaitVolCount(a1,d2.l*2),d0
	bne.s	NotWait4Line
	clr.b	pc_WaitVolType-pc_WaitVolCount(a1,d2.l)
NotWait4Line:	dbra	d2,Wait4LineLoop
	lea	([tcy_SynthCode.w,a0],d0.w*4),a0
	move.b	(a0)+,d3
	moveq	#0,d1
	move.b	(a0)+,d1
	move.w	(a0)+,d2
	tst.l	-(a0)
	beq.s	ExecSynthDone
	swap	d1
	ror.l	#4,d1
	rol.w	#4,d1
	swap	d1
	addq.w	#1,d0
	lea	pc_Variable0(a2),a0
	tst.b	d3
	bmi.s	ExecSynthFX
	move.l	tcb_SynthExecTable(a6),a1
	add.w	(a1,d3.l*2),a1
	jsr	(a1)
	lea	pc_VolumePos(a2),a0
	move.w	d0,(a0,d4.l*2)
	addq.w	#1,d5
	bne.s	ExecSynthLoop
ExecSynthError:	addq.l	#4,sp
	bra	TurnNoteOff
ExecSynthDone:	btst	d4,pc_SynthFlags+1(a2)
	beq.s	ExecSynthCompleted
	subq.w	#1,(pc_KillVolCount.w,a2,d4.l*2)
	bcc.s	ExecSynthCompleted
	addq.l	#4,sp
	bra	TurnNoteOff
SE_STOP:	add.w	(a0,d1.w*2),d2
	bmi.s	ClrSTOPMask
	or.b	d2,pc_StopForbidMask(a2)
ExecSynthCompleted:	rts
ExecSynthFX:	not.b	d3
	move.l	tcb_EffectsTable(a6),a1
	movem.l	d0/d3-d7,-(sp)
	moveq	#0,d0
	move.b	d3,d0
	add.w	(a0,d1.w*2),d2
	move.l	d2,-(sp)
	move.b	2(a1,d0.w*4),d4
	bpl.s	NotCheckSynthType
	add.w	(a1,d0.w*4),a1
	add.w	-(a1),a1
	jsr	(a1)
	move.l	tcb_EffectsTable(a6),a1
NotCheckSynthType:	btst	#6,d4
	bne.s	NotCheckSynthExec
	add.w	(a1,d0.w*4),a1
	move.l	(sp)+,d2
	move.w	phc_VirtualChannel(a3),-(sp)
	move.w	d7,phc_VirtualChannel(a3)
	move.w	pc_HostChannel(a2),d7
	move.l	d2,d1
	jsr	(a1)
	move.w	phc_VirtualChannel(a3),d7
	move.w	(sp)+,phc_VirtualChannel(a3)
NotCheckSynthExec:	movem.l	(sp)+,d0/d3-d7
	lea	pc_VolumePos(a2),a0
	move.w	d0,(a0,d4.l*2)
	addq.w	#1,d5
	bne	ExecSynthLoop
	bra	ExecSynthError
ClrSTOPMask:	not.w	d2
	and.b	d2,pc_StopForbidMask(a2)
	rts
SE_KILL:	add.w	(a0,d1.w*2),d2
	move.w	d2,pc_KillVolCount-pc_Variable0(a0,d4.l*2)
	bset	d4,pc_SynthFlags+1(a2)
	rts
SE_WAIT:	add.w	(a0,d1.w*2),d2
	move.w	d2,pc_WaitVolCount-pc_Variable0(a0,d4.l*2)
	rts
SE_WAITVOL:	add.w	(a0,d1.w*2),d2
	move.w	d2,pc_WaitVolLine-pc_Variable0(a0,d4.l*2)
	st	pc_WaitVolType-pc_Variable0(a0,d4.l)
	rts
SE_WAITPAN:	add.w	(a0,d1.w*2),d2
	move.w	d2,pc_WaitVolLine-pc_Variable0(a0,d4.l*2)
	move.b	#~1,pc_WaitVolType-pc_Variable0(a0,d4.l)
	rts
SE_WAITSLD:	add.w	(a0,d1.w*2),d2
	move.w	d2,pc_WaitVolLine-pc_Variable0(a0,d4.l*2)
	move.b	#~2,pc_WaitVolType-pc_Variable0(a0,d4.l)
	rts
SE_WAITSPC:	add.w	(a0,d1.w*2),d2
	move.w	d2,pc_WaitVolLine-pc_Variable0(a0,d4.l*2)
	move.b	#~3,pc_WaitVolType-pc_Variable0(a0,d4.l)
	rts
SE_JUMP:	add.w	(a0,d1.w*2),d2
	move.w	d2,d0
	rts
SE_JUMPEQ:	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	beq.s	SE_JUMP
	rts
SE_JUMPNE:	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	bne.s	SE_JUMP
	rts
SE_JUMPPL:	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	bpl.s	SE_JUMP
	rts
SE_JUMPMI:	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	bmi.s	SE_JUMP
	rts
SE_JUMPLT:	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	blt.s	SE_JUMP
	rts
SE_JUMPLE:	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	ble.s	SE_JUMP
	rts
SE_JUMPGT:	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	bgt.s	SE_JUMP
	rts
SE_JUMPGE:	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	bge.s	SE_JUMP
	rts
SE_JUMPVS:	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	bvs.s	SE_JUMP
	rts
SE_JUMPVC:	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	bvc.s	SE_JUMP
	rts
SE_JUMPCS:	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	bcs.s	SE_JUMP
	rts
SE_JUMPCC:	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	bcc.s	SE_JUMP
	rts
SE_JUMPLS:	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	bls.s	SE_JUMP
	rts
SE_JUMPHI:	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	bhi.s	SE_JUMP
	rts
SE_JUMPVOL:	btst	#0,pc_StopForbidMask(a2)
	bne.s	SE_JUMPVOL_Not
	add.w	(a0,d1.w*2),d2
	move.w	d2,pc_VolumePos(a2)
SE_JUMPVOL_Not:	rts
SE_JUMPPAN:	btst	#1,pc_StopForbidMask(a2)
	bne.s	SE_JUMPVOL_Not
	add.w	(a0,d1.w*2),d2
	move.w	d2,pc_PanningPos(a2)
	rts
SE_JUMPSLD:	btst	#2,pc_StopForbidMask(a2)
	bne.s	SE_JUMPVOL_Not
	add.w	(a0,d1.w*2),d2
	move.w	d2,pc_SlidePos(a2)
	rts
SE_JUMPSPC:	btst	#3,pc_StopForbidMask(a2)
	bne.s	SE_JUMPVOL_Not
	add.w	(a0,d1.w*2),d2
	move.w	d2,pc_SpecialPos(a2)
	rts
SE_CALL:	swap	d1
	move.w	d0,(a0,d1.w*2)
	swap	d1
	add.w	(a0,d1.w*2),d2
	move.w	d2,d0
	rts
SE_RETURN:	add.w	(a0,d1.w*2),d2
	swap	d1
	subq.w	#1,d0
	move.w	d0,(a0,d1.w*2)
	move.w	d2,d0
	rts
SE_POSVAR:	add.w	d0,d2
	subq.w	#1,d2
	move.w	d2,(a0,d1.w*2)
	rts
SE_LOAD:	add.w	(a0,d1.w*2),d2
	swap	d1
	move.w	d2,(a0,d1.w*2)
	rts
SE_ADD:	add.w	(a0,d1.w*2),d2
	swap	d1
	add.w	d2,(a0,d1.w*2)
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	rts
SE_ADDX:	swap	d0
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.w	(a0,d1.w*2),d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	addx.w	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	move.w	d0,(a0,d1.w*2)
	swap	d0
	rts
SE_SUB:	add.w	(a0,d1.w*2),d2
	swap	d1
	sub.w	d2,(a0,d1.w*2)
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	rts
SE_SUBX:	swap	d0
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.w	(a0,d1.w*2),d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	subx.w	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	move.w	d0,(a0,d1.w*2)
	swap	d0
	rts
SE_CMP:	swap	d0
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.w	(a0,d1.w*2),d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	cmp.w	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	swap	d0
	rts
SE_MULU:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	lsl.w	#8,d2
	swap	d1
	move.w	(a0,d1.w*2),d0
	lsl.w	#8,d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	mulu.w	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	swap	d0
	move.w	d0,(a0,d1.w*2)
	move.w	(sp)+,d0
	rts
SE_MULS:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	lsl.w	#8,d2
	swap	d1
	move.w	(a0,d1.w*2),d0
	lsl.w	#8,d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	muls.w	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	swap	d0
	move.w	d0,(a0,d1.w*2)
	move.w	(sp)+,d0
	rts
SE_DMULU:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.w	(a0,d1.w*2),d0
	cmp.w	#15,d1
	beq.s	SE_DMULU_Not
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	mulu.w	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	move.l	d0,(a0,d1.w*2)
	move.w	(sp)+,d0
	rts
SE_DMULU_Not:	swap	d0
	clr.w	d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	mulu.l	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	swap	d0
	move.w	d0,15*2(a0)
	move.w	(sp)+,d0
	rts
SE_DMULS:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.w	(a0,d1.w*2),d0
	cmp.w	#15,d1
	beq.s	SE_DMULS_Not
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	muls.w	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	move.l	d0,(a0,d1.w*2)
	move.w	(sp)+,d0
	rts
SE_DMULS_Not:	swap	d0
	clr.w	d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	muls.l	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	swap	d0
	move.w	d0,15*2(a0)
	move.w	(sp)+,d0
	rts
SE_DIVU:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	beq.s	SE_DIVU_Not
	swap	d1
	moveq	#0,d0
	move.w	(a0,d1.w*2),d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	divu.w	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	move.w	d0,(a0,d1.w*2)
	move.w	(sp)+,d0
	rts
SE_DIVS:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	beq.s	SE_DIVU_Not
	swap	d1
	move.w	(a0,d1.w*2),d0
	ext.l	d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	divs.w	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	move.w	d0,(a0,d1.w*2)
	move.w	(sp)+,d0
	rts
SE_DDIVS:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	beq.s	SE_DIVU_Not
	swap	d1
	move.l	(a0,d1.w*2),d0
	cmp.w	#15,d1
	beq.s	SE_DDIVS_Not
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	divs.w	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	bvs.s	SE_DDIVU_V
	move.l	d0,(a0,d1.w*2)
	move.w	(sp)+,d0
	rts
SE_DDIVS_Not:	clr.w	d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	divs.w	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	bvs.s	SE_DDIVU_V
	move.w	d0,(a0,d1.w*2)
	move.w	(sp)+,d0
	rts
SE_DIVU_Not:	move.w	#TCYCF_Carry|TCYCF_Overflow|TCYCF_Zero|TCYCF_Negative,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	move.w	(sp)+,d0
	rts
SE_MODU:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	beq.s	SE_DIVU_Not
	swap	d1
	moveq	#0,d0
	move.w	(a0,d1.w*2),d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	divu.w	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	swap	d0
	move.w	d0,(a0,d1.w*2)
	move.w	(sp)+,d0
	rts
SE_MODS:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	beq.s	SE_DIVU_Not
	swap	d1
	move.w	(a0,d1.w*2),d0
	ext.l	d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	divs.w	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	swap	d0
	move.w	d0,(a0,d1.w*2)
	move.w	(sp)+,d0
	rts
SE_DDIVU_V:	and.w	#~(TCYCF_Zero|TCYCF_Negative),pc_VolConVar-pc_Variable0(a0,d4.l*2)
	move.w	(sp)+,d0
	rts
SE_DDIVU:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	beq.s	SE_DIVU_Not
	swap	d1
	move.l	(a0,d1.w*2),d0
	cmp.w	#15,d1
	beq.s	SE_DDIVU_Not
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	divu.w	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	bvs.s	SE_DDIVU_V
	move.l	d0,(a0,d1.w*2)
	move.w	(sp)+,d0
	rts
SE_DDIVU_Not:	clr.w	d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	divu.w	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	bvs.s	SE_DDIVU_V
	move.w	d0,(a0,d1.w*2)
	move.w	(sp)+,d0
	rts
SE_ASHL:	swap	d0
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.w	(a0,d1.w*2),d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	asl.w	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	move.w	d0,(a0,d1.w*2)
	swap	d0
	rts
SE_ASHR:	swap	d0
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.w	(a0,d1.w*2),d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	asr.w	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	move.w	d0,(a0,d1.w*2)
	swap	d0
	rts
SE_LSHL:	swap	d0
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.w	(a0,d1.w*2),d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	lsl.w	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	move.w	d0,(a0,d1.w*2)
	swap	d0
	rts
SE_LSHR:	swap	d0
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.w	(a0,d1.w*2),d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	lsr.w	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	move.w	d0,(a0,d1.w*2)
	swap	d0
	rts
SE_ROL:	swap	d0
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.w	(a0,d1.w*2),d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	rol.w	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	move.w	d0,(a0,d1.w*2)
	swap	d0
	rts
SE_ROR:	swap	d0
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.w	(a0,d1.w*2),d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	ror.w	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	move.w	d0,(a0,d1.w*2)
	swap	d0
	rts
SE_ROLX:	swap	d0
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.w	(a0,d1.w*2),d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	roxl.w	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	move.w	d0,(a0,d1.w*2)
	swap	d0
	rts
SE_RORX:	swap	d0
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.w	(a0,d1.w*2),d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	roxr.w	d2,d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	move.w	d0,(a0,d1.w*2)
	swap	d0
	rts
SE_OR:	add.w	(a0,d1.w*2),d2
	swap	d1
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	or.w	d2,(a0,d1.w*2)
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	rts
SE_AND:	add.w	(a0,d1.w*2),d2
	swap	d1
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	and.w	d2,(a0,d1.w*2)
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	rts
SE_XOR:	add.w	(a0,d1.w*2),d2
	swap	d1
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	eor.w	d2,(a0,d1.w*2)
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	rts
SE_NOT:	add.w	(a0,d1.w*2),d2
	swap	d1
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	not.w	(a0,d1.w*2)
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	add.w	d2,(a0,d1.w*2)
	rts
SE_NEG:	add.w	(a0,d1.w*2),d2
	swap	d1
	neg.w	(a0,d1.w*2)
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	add.w	d2,(a0,d1.w*2)
	rts
SE_NEGX:	swap	d0
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.w	(a0,d1.w*2),d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	negx.w	d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	add.w	d2,d0
	move.w	d0,(a0,d1.w*2)
	swap	d0
	rts
SE_EXTB:	swap	d0
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.w	(a0,d1.w*2),d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	ext.w	d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	add.w	d2,d0
	move.w	d0,(a0,d1.w*2)
	swap	d0
	rts
SE_EXT:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.l	(a0,d1.w*2),d0
	cmp.w	#15,d1
	bne.s	SE_EXT_Not
	clr.w	d0
SE_EXT_Not:	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	ext.l	d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	swap	d0
	add.w	d2,d0
	move.w	d0,(a0,d1.w*2)
	move.w	(sp)+,d0
	rts
SE_XCHG:	move.w	d0,-(sp)
	move.w	(a0,d1.w*2),d0
	swap	d0
	swap	d1
	move.w	(a0,d1.w*2),d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	swap	d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	add.w	d2,d0
	move.w	d0,(a0,d1.w*2)
	swap	d0
	swap	d1
	move.w	d0,(a0,d1.w*2)
	move.w	(sp)+,d0
	rts
SE_SWAP:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.b	(a0,d1.w*2),d0
	swap	d0
	move.b	1(a0,d1.w*2),d0
	lsl.l	#8,d0
	move.w	pc_VolConVar-pc_Variable0(a0,d4.l*2),ccr
	swap	d0
	move.w	ccr,pc_VolConVar-pc_Variable0(a0,d4.l*2)
	lsr.l	#8,d0
	move.b	d0,1(a0,d1.w*2)
	swap	d0
	move.b	d0,(a0,d1.w*2)
	add.w	d2,(a0,d1.w*2)
	move.w	(sp)+,d0
	rts
SE_GETWAVE:	movem.l	d0/a2,-(sp)
	moveq	#-1,d0
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.l	pc_WaveformList(a2),a1
	move.l	pc_SampleWaveform(a2),a2
SE_GETWAVE_Loop:	addq.l	#1,d0
	move.l	(a1),a1
	tst.l	(a1)
	beq.s	SE_GETWAVE_Not
	cmp.l	a2,a1
	bne.s	SE_GETWAVE_Loop
	add.w	d2,d0
	move.w	d0,(a0,d1.w*2)
	movem.l	(sp)+,d0/a2
	rts
SE_GETWAVE_Not:	move.w	d2,(a0,d1.w*2)
	movem.l	(sp)+,d0/a2
	rts
SE_GETWLEN:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	moveq	#-1,d0
	tst.w	ms_SampleLen(a2)
	bne.s	SE_GETWLEN_Not
	move.l	ms_SampleLen(a2),d0
SE_GETWLEN_Not:	add.w	d2,d0
	swap	d1
	move.w	d0,(a0,d1.w*2)
	move.w	(sp)+,d0
	rts
SE_GETWPOS:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	moveq	#-1,d0
	tst.w	(a2)
	bne.s	SE_GETWPOS_Not
	move.l	(a2),d0
SE_GETWPOS_Not:	add.w	d2,d0
	swap	d1
	move.w	d0,(a0,d1.w*2)
	move.w	(sp)+,d0
	rts
SE_GETCHAN:	add.w	(a0,d1.w*2),d2
	add.w	pc_HostChannel(a2),d2
	swap	d1
	move.w	d2,(a0,d1.w*2)
	rts
SE_GETNOTE:	swap	d0
	add.w	(a0,d1.w*2),d2
	clr.w	d0
	move.b	pc_SampleNote(a2),d0
	add.w	d2,d0
	subq.w	#1,d0
	swap	d1
	move.w	d0,(a0,d1.w*2)
	swap	d0
	rts
SE_GETRANS:	swap	d0
	clr.w	d0
	add.w	(a0,d1.w*2),d2
	add.w	pc_FinalNote(a2),d2
	move.b	pc_SampleNote(a2),d0
	subq.w	#1,d0
	sub.w	d0,d2
	swap	d1
	move.w	d2,(a0,d1.w*2)
	swap	d0
	rts
SE_GETPTCH:	move.w	d0,-(sp)
	move.l	pc_Frequency(a2),d0
	add.w	(a0,d1.w*2),d2
	add.l	d2,d0
	swap	d1
	cmp.w	#15,d1
	beq.s	SE_GETPTCH_Not
	move.l	d0,(a0,d1.w*2)
	move.w	(sp)+,d0
	rts
SE_GETPTCH_Not:	move.w	d0,(a0,d1.w*2)
	move.w	(sp)+,d0
	rts
SE_GETPER:	movem.l	d0/d3,-(sp)
	move.l	#SLIDE_CONST,d0
	move.l	pc_Frequency(a2),d3
	beq.s	SE_GETPER_NoFreq
	divu.l	d3,d0
	add.w	(a0,d1.w*2),d2
	add.l	d2,d0
	swap	d1
	cmp.w	#15,d1
	beq.s	SE_GETPER_Not
	move.l	d0,(a0,d1.w*2)
	movem.l	(sp)+,d0/d3
	rts
SE_GETPER_NoFreq:	add.w	(a0,d1.w*2),d2
	move.l	d2,d0
	swap	d1
	cmp.w	#15,d1
	beq.s	SE_GETPER_Not
	move.l	d0,(a0,d1.w*2)
	movem.l	(sp)+,d0/d3
SE_GETPER_Not:	move.w	d0,(a0,d1.w*2)
	movem.l	(sp)+,d0/d3
	rts
SE_GETFX:
	rts
SE_GETARPW:	movem.l	d0/a2,-(sp)
	moveq	#-1,d0
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.l	pc_WaveformList(a2),a1
	move.l	pc_ArpeggioWaveform(a2),a2
SE_GETARPW_Loop:	addq.l	#1,d0
	move.l	(a1),a1
	tst.l	(a1)
	beq.s	SE_GETARPW_Not
	cmp.l	a2,a1
	bne.s	SE_GETARPW_Loop
	add.w	d2,d0
	move.w	d0,(a0,d1.w*2)
	movem.l	(sp)+,d0/a2
	rts
SE_GETARPW_Not:	move.w	d2,(a0,d1.w*2)
	movem.l	(sp)+,d0/a2
	rts
SE_GETARPV:	movem.l	d0/d3,-(sp)
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.l	pc_ArpeggioWaveform(a2),d0
	beq.s	SE_GETARPV_Not
	move.l	d0,a1
	move.l	tcyw_Samples(a1),d0
	divul.l	d0,d3:d2
	tst.w	tcyw_Flags(a1)
	bmi.s	SE_GETARPV_8Bit
	move.l	tcyw_WaveData(a1),a1
	move.w	(a1,d3.l*2),(a0,d1.w*2)
	movem.l	(sp)+,d0/d3
	rts
SE_GETARPV_8Bit:	move.l	tcyw_WaveData(a1),a1
	move.b	(a1,d3.l),d0
	lsl.w	#8,d0
SE_GETARPV_Not:	move.w	d0,(a0,d1.w*2)
	movem.l	(sp)+,d0/d3
	rts
SE_GETARPL:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.l	pc_ArpeggioWaveform(a2),d0
	beq.s	SE_GETARPL_Not
	move.l	d0,a1
	moveq	#-1,d0
	tst.w	tcyw_Samples(a1)
	bne.s	SE_GETARPL_Not
	move.l	tcyw_Samples(a1),d0
SE_GETARPL_Not:	add.w	d2,d0
	move.w	d0,(a0,d1.w*2)
	move.w	(sp)+,d0
	rts
SE_GETARPP:	add.w	(a0,d1.w*2),d2
	swap	d1
	add.w	pc_ArpeggioPos(a2),d2
	move.w	d2,(a0,d1.w*2)
	rts
SE_GETVIBW:	movem.l	d0/a2,-(sp)
	moveq	#-1,d0
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.l	pc_WaveformList(a2),a1
	move.l	pc_VibratoWaveform(a2),a2
SE_GETVIBW_Loop:	addq.l	#1,d0
	move.l	(a1),a1
	tst.l	(a1)
	beq.s	SE_GETVIBW_Not
	cmp.l	a2,a1
	bne.s	SE_GETVIBW_Loop
	add.w	d2,d0
	move.w	d0,(a0,d1.w*2)
	movem.l	(sp)+,d0/a2
	rts
SE_GETVIBW_Not:	move.w	d2,(a0,d1.w*2)
	movem.l	(sp)+,d0/a2
	rts
SE_GETVIBV:	movem.l	d0/d3,-(sp)
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.l	pc_VibratoWaveform(a2),d0
	beq.s	SE_GETVIBV_Not
	move.l	d0,a1
	move.l	tcyw_Samples(a1),d0
	divul.l	d0,d3:d2
	tst.w	tcyw_Flags(a1)
	bmi.s	SE_GETVIBV_8Bit
	move.l	tcyw_WaveData(a1),a1
	move.w	(a1,d3.l*2),(a0,d1.w*2)
	movem.l	(sp)+,d0/d3
	rts
SE_GETVIBV_8Bit:	move.l	tcyw_WaveData(a1),a1
	move.b	(a1,d3.l),d0
	lsl.w	#8,d0
SE_GETVIBV_Not:	move.w	d0,(a0,d1.w*2)
	movem.l	(sp)+,d0/d3
	rts
SE_GETVIBL:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.l	pc_VibratoWaveform(a2),d0
	beq.s	SE_GETVIBL_Not
	move.l	d0,a1
	moveq	#-1,d0
	tst.w	tcyw_Samples(a1)
	bne.s	SE_GETVIBL_Not
	move.l	tcyw_Samples(a1),d0
SE_GETVIBL_Not:	add.w	d2,d0
	move.w	d0,(a0,d1.w*2)
	move.w	(sp)+,d0
	rts
SE_GETVIBP:	add.w	(a0,d1.w*2),d2
	swap	d1
	add.w	pc_VibratoPos(a2),d2
	move.w	d2,(a0,d1.w*2)
	rts
SE_GETTRMW:	movem.l	d0/a2,-(sp)
	moveq	#-1,d0
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.l	pc_WaveformList(a2),a1
	move.l	pc_TremoloWaveform(a2),a2
SE_GETTRMW_Loop:	addq.l	#1,d0
	move.l	(a1),a1
	tst.l	(a1)
	beq.s	SE_GETTRMW_Not
	cmp.l	a2,a1
	bne.s	SE_GETTRMW_Loop
	add.w	d2,d0
	move.w	d0,(a0,d1.w*2)
	movem.l	(sp)+,d0/a2
	rts
SE_GETTRMW_Not:	move.w	d2,(a0,d1.w*2)
	movem.l	(sp)+,d0/a2
	rts
SE_GETTRMV:	movem.l	d0/d3,-(sp)
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.l	pc_TremoloWaveform(a2),d0
	beq.s	SE_GETTRMV_Not
	move.l	d0,a1
	move.l	tcyw_Samples(a1),d0
	divul.l	d0,d3:d2
	tst.w	tcyw_Flags(a1)
	bmi.s	SE_GETTRMV_8Bit
	move.l	tcyw_WaveData(a1),a1
	move.w	(a1,d3.l*2),(a0,d1.w*2)
	movem.l	(sp)+,d0/d3
	rts
SE_GETTRMV_8Bit:	move.l	tcyw_WaveData(a1),a1
	move.b	(a1,d3.l),d0
	lsl.w	#8,d0
SE_GETTRMV_Not:	move.w	d0,(a0,d1.w*2)
	movem.l	(sp)+,d0/d3
	rts
SE_GETTRML:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.l	pc_TremoloWaveform(a2),d0
	beq.s	SE_GETTRML_Not
	move.l	d0,a1
	moveq	#-1,d0
	tst.w	tcyw_Samples(a1)
	bne.s	SE_GETTRML_Not
	move.l	tcyw_Samples(a1),d0
SE_GETTRML_Not:	add.w	d2,d0
	move.w	d0,(a0,d1.w*2)
	move.w	(sp)+,d0
	rts
SE_GETTRMP:	add.w	(a0,d1.w*2),d2
	swap	d1
	add.w	pc_TremoloPos(a2),d2
	move.w	d2,(a0,d1.w*2)
	rts
SE_GETPANW:	movem.l	d0/a2,-(sp)
	moveq	#-1,d0
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.l	pc_WaveformList(a2),a1
	move.l	pc_PannoloWaveform(a2),a2
SE_GETPANW_Loop:	addq.l	#1,d0
	move.l	(a1),a1
	tst.l	(a1)
	beq.s	SE_GETPANW_Not
	cmp.l	a2,a1
	bne.s	SE_GETPANW_Loop
	add.w	d2,d0
	move.w	d0,(a0,d1.w*2)
	movem.l	(sp)+,d0/a2
	rts
SE_GETPANW_Not:	move.w	d2,(a0,d1.w*2)
	movem.l	(sp)+,d0/a2
	rts
SE_GETPANV:	movem.l	d0/d3,-(sp)
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.l	pc_PannoloWaveform(a2),d0
	beq.s	SE_GETPANV_Not
	move.l	d0,a1
	move.l	tcyw_Samples(a1),d0
	divul.l	d0,d3:d2
	tst.w	tcyw_Flags(a1)
	bmi.s	SE_GETPANV_8Bit
	move.l	tcyw_WaveData(a1),a1
	move.w	(a1,d3.l*2),(a0,d1.w*2)
	movem.l	(sp)+,d0/d3
	rts
SE_GETPANV_8Bit:	move.l	tcyw_WaveData(a1),a1
	move.b	(a1,d3.l),d0
	lsl.w	#8,d0
SE_GETPANV_Not:	move.w	d0,(a0,d1.w*2)
	movem.l	(sp)+,d0/d3
	rts
SE_GETPANL:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.l	pc_PannoloWaveform(a2),d0
	beq.s	SE_GETPANL_Not
	move.l	d0,a1
	moveq	#-1,d0
	tst.w	tcyw_Samples(a1)
	bne.s	SE_GETPANL_Not
	move.l	tcyw_Samples(a1),d0
SE_GETPANL_Not:	add.w	d2,d0
	move.w	d0,(a0,d1.w*2)
	move.w	(sp)+,d0
	rts
SE_GETPANP:	add.w	(a0,d1.w*2),d2
	swap	d1
	add.w	pc_PannoloPos(a2),d2
	move.w	d2,(a0,d1.w*2)
	rts
SE_GETRND:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	move.l	tcb_RandomSeed(a6),d0
	muls.l	#RANDOM_CONST,d0
	addq.l	#1,d0
	move.l	d0,tcb_RandomSeed(a6)
	move.l	d1,a1
	move.l	d2,d1
	bsr	MULU64
	move.l	d1,d0
	move.l	a1,d1
	swap	d1
	move.w	d0,(a0,d1.w*2)
	move.w	(sp)+,d0
	rts
SE_GETSINE:	add.w	(a0,d1.w*2),d2
	divs.w	#360,d2
	swap	d2
	tst.w	d2
	bpl.s	SE_GETSINE_Not
	add.w	#360,d2
SE_GETSINE_Not:	swap	d1
	move.w	([tcb_SineTable.w,a6],d2.w*2),(a0,d1.w*2)
	moveq	#0,d2
	rts
SE_PORTAUP:	movem.l	d0-d1/d3/d5,-(sp)
	add.w	(a0,d1.w*2),d2
	bne.s	SE_PORTAUP_Ok
	move.w	pc_PortaUpValue(a2),d2
SE_PORTAUP_Ok:	move.w	d2,pc_PortaUpValue(a2)
	add.l	d2,pc_PortamentoValue(a2)
	move.l	d2,d3
	beq.s	SE_PORTAUP_Not
	bsr	NotAddPortaUpSubSlide
SE_PORTAUP_Not:	movem.l	(sp)+,d0-d1/d3/d5
	rts
SE_PORTADN:	movem.l	d0-d1/d3/d5,-(sp)
	add.w	(a0,d1.w*2),d2
	bne.s	SE_PORTADN_Ok
	move.w	pc_PortaDnValue(a2),d2
SE_PORTADN_Ok:	move.w	d2,pc_PortaDnValue(a2)
	sub.l	d2,pc_PortamentoValue(a2)
	move.l	d2,d3
	beq.s	SE_PORTADN_Not
	bsr	NotSubPortaDnSubSlide
SE_PORTADN_Not:	movem.l	(sp)+,d0-d1/d3/d5
	rts
SE_VIBSPD:	add.w	(a0,d1.w*2),d2
	move.w	d2,pc_VibratoRate(a2)
	rts
SE_VIBDPTH:	add.w	(a0,d1.w*2),d2
	move.w	d2,pc_VibratoDepth(a2)
	rts
SE_VIBWAVE:	move.w	d0,-(sp)
	moveq	#-1,d0
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.l	pc_WaveformList(a2),a1
SE_VIBWAVE_Loop:	addq.l	#1,d0
	move.l	(a1),a1
	tst.l	(a1)
	beq.s	SE_VIBWAVE_Not
	cmp.l	d2,d0
	bne.s	SE_VIBWAVE_Loop
	move.l	a1,pc_VibratoWaveform(a2)
	move.w	(sp)+,d0
	rts
SE_VIBWAVE_Not:	clr.l	pc_VibratoWaveform(a2)
	move.w	(sp)+,d0
	rts
SE_VIBWAVP:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	move.l	pc_VibratoWaveform(a2),d0
	beq.s	SE_VIBWAVP_Not
	move.l	d0,a1
	move.l	tcyw_Samples(a1),d0
	divul.l	d0,d1:d2
	move.w	d1,pc_VibratoPos(a2)
	move.w	(sp)+,d0
	rts
SE_VIBWAVP_Not:	move.w	d0,pc_VibratoPos(a2)
	move.w	(sp)+,d0
	rts
SE_VIBRATO:	movem.l	d0-d1/d3/d5-d6,-(sp)
	add.w	(a0,d1.w*2),d2
	move.w	d2,d5
	lsr.w	#8,d5
	bne.s	SE_VIBRATO_NotPrevVibSpd
	move.w	pc_VibratoRate(a2),d5
SE_VIBRATO_NotPrevVibSpd:	move.w	d5,pc_VibratoRate(a2)
	ext.w	d2
	asl.w	#2,d2
	bne.s	SE_VIBRATO_NotPrevVibDepth
	move.w	pc_VibratoDepth(a2),d2
SE_VIBRATO_NotPrevVibDepth:	move.w	d2,pc_VibratoDepth(a2)
	neg.w	d2
	move.l	pc_VibratoWaveform(a2),d0
	beq.s	SE_VIBRATO_Not
	move.l	d0,a0
	move.l	tcyw_Samples(a0),d0
	moveq	#0,d3
	move.w	pc_VibratoPos(a2),d3
	divul.l	d0,d1:d3
	move.l	tcyw_WaveData(a0),a1
	tst.w	tcyw_Flags(a0)
	bmi.s	SE_VIBRATO_8Bit
	muls.w	(a1,d1.l*2),d2
	bra.s	SE_VIBRATO_16Bit
SE_VIBRATO_8Bit:	move.b	(a1,d1.l),d3
	asl.w	#8,d3
	muls.w	d3,d2
SE_VIBRATO_16Bit:	asr.l	#7-2,d2
	add.l	d5,d1
	divul.l	d0,d3:d1
	move.w	d3,pc_VibratoPos(a2)
SE_VIBRATO_Do:	move.l	pc_VibratoSlideValue(a2),d0
	move.l	pc_Frequency(a2),d6
	sub.l	d0,pc_Frequency(a2)
	lea	NotSubPortaDnSubSlide(pc),a1
	move.l	d2,d3
	bpl.s	SE_VIBRATO_Pos
	neg.l	d3
	lea	NotAddPortaUpSubSlide(pc),a1
SE_VIBRATO_Pos:	jsr	(a1)
	sub.l	pc_Frequency(a2),d6
	sub.l	d6,pc_VibratoSlideValue(a2)
SE_VIBRATO_Not:	movem.l	(sp)+,d0-d1/d3/d5-d6
	rts
SE_VIBVAL:	movem.l	d0-d1/d3/d5-d6,-(sp)
	add.w	(a0,d1.w*2),d2
	ext.l	d2
	bra.s	SE_VIBRATO_Do
SE_ARPSPD:	add.w	(a0,d1.w*2),d2
	move.w	d2,pc_ArpeggioSpeed(a2)
	rts
SE_ARPWAVE:	move.w	d0,-(sp)
	moveq	#-1,d0
	add.w	(a0,d1.w*2),d2
	swap	d1
	move.l	pc_WaveformList(a2),a1
SE_ARPWAVE_Loop:	addq.l	#1,d0
	move.l	(a1),a1
	tst.l	(a1)
	beq.s	SE_ARPWAVE_Not
	cmp.l	d2,d0
	bne.s	SE_ARPWAVE_Loop
	move.l	a1,pc_ArpeggioWaveform(a2)
	move.w	(sp)+,d0
	rts
SE_ARPWAVE_Not:	clr.l	pc_ArpeggioWaveform(a2)
	move.w	(sp)+,d0
	rts
SE_ARPWAVP:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	move.l	pc_ArpeggioWaveform(a2),d0
	beq.s	SE_ARPWAVP_Not
	move.l	d0,a1
	move.l	tcyw_Samples(a1),d0
	divul.l	d0,d1:d2
	move.w	d1,pc_ArpeggioPos(a2)
	move.w	(sp)+,d0
	rts
SE_ARPWAVP_Not:	move.w	d0,pc_ArpeggioPos(a2)
	move.w	(sp)+,d0
	rts
SE_ARPEGIO:	movem.l	d0/d3-d5,-(sp)
	add.w	(a0,d1.w*2),d2
	move.l	pc_ArpeggioWaveform(a2),d0
	beq	SE_ARPEGIO_Not
	move.l	d0,a0
	move.w	d2,d5
	lsr.w	#8,d5
	bne.s	SE_ARPEGIO_NotUsePrevSpd
	move.w	pc_ArpeggioSpeed(a2),d5
SE_ARPEGIO_NotUsePrevSpd:	move.l	tcyw_Samples(a0),d0
	moveq	#0,d3
	move.w	pc_ArpeggioPos(a2),d3
	divul.l	d0,d4:d3
	move.l	tcyw_WaveData(a0),a1
	tst.w	tcyw_Flags(a0)
	bmi.s	SE_ARPEGIO_8Bit
	move.w	(a1,d4.l*2),d1
	bra.s	SE_ARPEGIO_16Bit
SE_ARPEGIO_8Bit:	move.b	(a1,d4.l),d1
	lsl.w	#8,d1
SE_ARPEGIO_16Bit:	move.w	d1,pc_ArpeggioTranspose(a2)
	add.l	d5,d4
	divul.l	d0,d3:d4
	move.w	d3,pc_ArpeggioPos(a2)
	add.b	d1,d2
SE_ARPEGIO_Do:	moveq	#12,d0
	and.w	#$00ff,d2
	lsr.w	#8,d1
	extb.l	d1
	divs.w	d0,d1
	swap	d1
	tst.w	d1
	bpl.s	SE_ARPEGIO_PlaySlideValOk
	swap	d1
	subq.w	#1,d1
	swap	d1
	add.w	d0,d1
	neg.w	d2
SE_ARPEGIO_PlaySlideValOk:	lea	([tcb_FrequencyTable.w,a6],d1.w*4),a0
	move.l	(a0)+,d0
	move.l	(a0),d3
	sub.l	d0,d3
	muls.w	d2,d3
	asr.l	#8,d3
	add.w	d3,d0
	swap	d1
	tst.w	d1
	bpl.s	SE_ARPEGIO_ShiftSlideFreqLeft
	neg.w	d1
	lsr.l	d1,d0
	bra.s	SE_ARPEGIO_ShiftSlideFreqDone
SE_ARPEGIO_ShiftSlideFreqLeft:	lsl.l	d1,d0
SE_ARPEGIO_ShiftSlideFreqDone:	move.l	pc_ArpeggioSlideValue(a2),d1
	move.l	pc_Frequency(a2),d2
	move.l	d2,d3
	add.l	d2,d1
	bsr	MULU64
	move.w	d1,d0
	swap	d0
	sub.l	d0,d3
	add.l	d3,pc_ArpeggioSlideValue(a2)
	move.l	d0,pc_Frequency(a2)
SE_ARPEGIO_Not:	movem.l	(sp)+,d0/d3-d5
	rts
SE_ARPVAL:	movem.l	d0/d3-d5,-(sp)
	add.w	(a0,d1.w*2),d2
	move.w	d2,d1
	move.w	d1,pc_ArpeggioTranspose(a2)
	bra.s	SE_ARPEGIO_Do
SE_SETWAVE:	move.w	d0,-(sp)
	moveq	#-1,d0
	add.w	(a0,d1.w*2),d2
	move.l	pc_WaveformList(a2),a1
SE_SETWAVE_Loop:	addq.l	#1,d0
	move.l	(a1),a1
	tst.l	(a1)
	beq.s	SE_SETWAVE_Not
	cmp.l	d2,d0
	bne.s	SE_SETWAVE_Loop
	move.l	a1,pc_SampleWaveform(a2)
	moveq	#0,d0
	move.l	a2,d2
	move.l	d0,(a2)+
	move.l	tcyw_Samples(a1),(a2)+
	move.l	tcyw_WaveData(a1),(a2)+
	addq.l	#ms_Repeat-ms_SampleRate,a2
	move.l	tcyw_Repeat(a1),(a2)+
	move.l	tcyw_RepLen(a1),d1
	move.l	d1,(a2)+
	move.l	d0,(a2)+
	move.l	d0,(a2)+
	moveq	#16,d0
	tst.w	tcyw_Flags(a1)
	bpl.s	SE_SETWAVE_16Bit
	moveq	#8,d0
SE_SETWAVE_16Bit:	move.b	d0,(a2)+
	move.b	(a2),d0
	and.b	#MSF_Surround|MSF_Play,d0
	tst.b	tcyw_Flags+1(a1)
	bmi.s	SE_SETWAVE_NoLoop
	tst.l	d1
	beq.s	SE_SETWAVE_NoLoop
	bset	#MSB_Loop,d0
SE_SETWAVE_NoLoop:	bset	#MSB_Synth,d0
	move.b	d0,(a2)
	move.l	d2,a2
	move.l	d7,d0
	move.l	a2,a0
	move.l	a6,d2
	move.l	tcb_PlayMixerAlloc(a6),a1
	move.l	(a1),a6
	jsr	_LVOExternalMixerSetChannel(a6)
	move.l	d7,d0
	move.l	a2,a0
	move.l	d2,a1
	move.l	tcb_PlayMixerAlloc(a1),a1
	jsr	_LVOExternalMixerGetChannel(a6)
	move.l	d2,a6
	move.w	(sp)+,d0
	rts
SE_SETWAVE_Not:	move.w	(sp)+,d0
	rts
SE_ISETWAV:	move.w	d0,-(sp)
	moveq	#-1,d0
	add.w	(a0,d1.w*2),d2
	move.l	pc_WaveformList(a2),a1
SE_ISETWAV_Loop:	addq.l	#1,d0
	move.l	(a1),a1
	tst.l	(a1)
	beq.s	SE_ISETWAV_Not
	cmp.l	d2,d0
	bne.s	SE_ISETWAV_Loop
	move.l	a1,pc_SampleWaveform(a2)
	moveq	#0,d0
	move.l	a2,d2
	move.l	d0,(a2)+
	move.l	tcyw_Samples(a1),(a2)+
	move.l	tcyw_WaveData(a1),(a2)+
	addq.l	#ms_Repeat-ms_SampleRate,a2
	move.l	tcyw_Repeat(a1),(a2)+
	move.l	tcyw_RepLen(a1),d1
	move.l	d1,(a2)+
	move.l	d0,(a2)+
	move.l	d0,(a2)+
	moveq	#16,d0
	tst.w	tcyw_Flags(a1)
	bpl.s	SE_ISETWAV_16Bit
	moveq	#8,d0
SE_ISETWAV_16Bit:	move.b	d0,(a2)+
	move.b	(a2),d0
	and.b	#MSF_Surround|MSF_Play,d0
	tst.b	tcyw_Flags+1(a1)
	bmi.s	SE_ISETWAV_NoLoop
	tst.l	d1
	beq.s	SE_ISETWAV_NoLoop
	bset	#MSB_Loop,d0
SE_ISETWAV_NoLoop:	move.b	d0,(a2)
	move.l	d2,a2
	move.l	d7,d0
	move.l	a2,a0
	move.l	a6,d2
	move.l	tcb_PlayMixerAlloc(a6),a1
	move.l	(a1),a6
	jsr	_LVOExternalMixerSetChannel(a6)
	move.l	d2,a6
	move.w	(sp)+,d0
	rts
SE_ISETWAV_Not:	move.w	(sp)+,d0
	rts
SE_SETWAVP:	add.w	(a0,d1.w*2),d2
	move.l	d2,(a2)
	rts
SE_SETRANS:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	move.b	pc_SampleNote(a2),d1
	add.w	d2,d1
	move.w	d1,pc_FinalNote(a2)
	moveq	#12,d0
	ext.l	d1
	divs.w	d0,d1
	swap	d1
	tst.w	d1
	bpl.s	SE_SETRANS_PlayNoteValOk
	swap	d1
	subq.w	#1,d1
	swap	d1
	add.w	d0,d1
SE_SETRANS_PlayNoteValOk:	move.b	pc_FineTune(a2),d2
	bpl.s	SE_SETRANS_FineTunePosOk
	add.b	#$80,d2
	subq.w	#1,d1
SE_SETRANS_FineTunePosOk:	ext.w	d2
	lea	([tcb_FrequencyTable.w,a6],d1.w*4),a0
	move.l	pc_Sample(a2),a1
	move.l	(a0)+,d0
	move.l	(a0),d3
	sub.l	d0,d3
	muls.w	d2,d3
	asr.l	#7,d3
	add.l	d3,d0
	moveq	#1,d2
	swap	d2
	swap	d1
	subq.w	#4,d1
	bpl.s	SE_SETRANS_ShiftFreqLeft
	neg.w	d1
	lsl.l	d1,d2
	move.l	tcs_Rate(a1),d1
	bsr	MULU64
	bsr	DIVU64
	move.l	d0,pc_Frequency(a2)
	move.w	(sp)+,d0
	rts
SE_SETRANS_ShiftFreqLeft:	lsl.l	d1,d0
	move.l	tcs_Rate(a1),d1
	bsr	MULU64
	bsr	DIVU64
	move.l	d0,pc_Frequency(a2)
	move.w	(sp)+,d0
	rts
SE_SETNOTE:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	moveq	#12,d0
	move.w	d2,d1
	ext.l	d1
	divs.w	d0,d1
	swap	d1
	tst.w	d1
	bpl.s	SE_SETNOTE_PlayNoteValOk
	swap	d1
	subq.w	#2,d1
	swap	d1
	add.w	d0,d1
SE_SETNOTE_PlayNoteValOk:	move.b	pc_FineTune(a2),d2
	bpl.s	SE_SETNOTE_FineTunePosOk
	add.b	#$80,d2
	subq.w	#1,d1
SE_SETNOTE_FineTunePosOk:	ext.w	d2
	lea	([tcb_FrequencyTable.w,a6],d1.w*4),a0
	move.l	pc_Sample(a2),a1
	move.l	(a0)+,d0
	move.l	(a0),d3
	sub.l	d0,d3
	muls.w	d2,d3
	asr.l	#7,d3
	add.l	d3,d0
	moveq	#1,d2
	swap	d2
	swap	d1
	subq.w	#4,d1
	bpl.s	SE_SETNOTE_ShiftFreqLeft
	neg.w	d1
	lsl.l	d1,d2
	move.l	tcs_Rate(a1),d1
	bsr	MULU64
	bsr	DIVU64
	move.l	d0,pc_Frequency(a2)
	move.w	(sp)+,d0
	rts
SE_SETNOTE_ShiftFreqLeft:	lsl.l	d1,d0
	move.l	tcs_Rate(a1),d1
	bsr	MULU64
	bsr	DIVU64
	move.l	d0,pc_Frequency(a2)
	move.w	(sp)+,d0
	rts
SE_SETPTCH:	add.w	(a0,d1.w*2),d2
	swap	d1
	cmp.w	#15,d1
	beq.s	SE_SETPTCH_Not
	add.l	(a0,d1.w*2),d2
SE_SETPTCH_Freq:	move.l	d2,pc_Frequency(a2)
	rts
SE_SETPTCH_Not:	add.w	(a0,d1.w*2),d2
	move.l	d2,pc_Frequency(a2)
	rts
SE_SETPER:	add.w	(a0,d1.w*2),d2
	swap	d1
	cmp.w	#15,d1
	beq.s	SE_SETPTCH_Not
	add.l	(a0,d1.w*2),d2
SE_SETPER_Freq:	beq.s	SE_SETPTCH_Freq
	move.l	#SLIDE_CONST,d1
	divu.l	d2,d1
	move.l	d1,pc_Frequency(a2)
	rts
SE_SETPER_Not:	add.w	(a0,d1.w*2),d2
	bra.s	SE_SETPER_Freq
SE_RESET:	movem.l	d0-d1/d3/d5,-(sp)
	add.w	(a0,d1.w*2),d2
	lsr.w	#1,d2
	bcs.s	NotResetArpVal
	clr.l	pc_ArpeggioSlideValue(a2)
NotResetArpVal:	lsr.w	#1,d2
	bcs.s	NotResetVibVal
	clr.l	pc_VibratoSlideValue(a2)
NotResetVibVal:	lsr.w	#1,d2
	bcs.s	NotResetTrmVal
	clr.w	pc_TremoloSlideValue(a2)
NotResetTrmVal:	lsr.w	#1,d2
	bcs.s	NotResetPanVal
	clr.w	pc_PannoloSlideValue(a2)
NotResetPanVal:	lsr.w	#1,d2
	bcs.s	NotRedoPorta
	lea	NotAddPortaUpSubSlide(pc),a1
	move.l	pc_PortamentoValue(a2),d3
	beq.s	NotResetPortaVal
	bpl.s	ResetDoPortaDn
	neg.l	d3
	lea	NotSubPortaDnSubSlide(pc),a1
ResetDoPortaDn:	jsr	(a1)
NotRedoPorta:	lsr.w	#1,d2
	bcs.s	NotResetPortaVal
	clr.l	pc_PortamentoValue(a2)
NotResetPortaVal:	movem.l	(sp)+,d0-d1/d3/d5
	rts
SE_VOLSLUP:	add.w	(a0,d1.w*2),d2
	bne.s	SE_VOLSLUP_Mem
	move.w	pc_VolSlUpValue(a2),d2
SE_VOLSLUP_Mem:	move.w	d2,pc_VolSlUpValue(a2)
	add.w	d2,pc_Volume(a2)
	bcc.s	SE_VOLSLUP_Not
	move.w	#-1,pc_Volume(a2)
SE_VOLSLUP_Not:	rts
SE_VOLSLDN:	add.w	(a0,d1.w*2),d2
	bne.s	SE_VOLSLDN_Mem
	move.w	pc_VolSlDnValue(a2),d2
SE_VOLSLDN_Mem:	move.w	d2,pc_VolSlDnValue(a2)
	sub.w	d2,pc_Volume(a2)
	bcc.s	SE_VOLSLUP_Not
	clr.w	pc_Volume(a2)
	rts
SE_TRMSPD:	add.w	(a0,d1.w*2),d2
	move.w	d2,pc_TremoloRate(a2)
	rts
SE_TRMDPTH:	add.w	(a0,d1.w*2),d2
	move.w	d2,pc_TremoloDepth(a2)
	rts
SE_TRMWAVE:	move.w	d0,-(sp)
	moveq	#-1,d0
	add.w	(a0,d1.w*2),d2
	move.l	pc_WaveformList(a2),a1
SE_TRMWAVE_Loop:	addq.l	#1,d0
	move.l	(a1),a1
	tst.l	(a1)
	beq.s	SE_TRMWAVE_Not
	cmp.l	d2,d0
	bne.s	SE_TRMWAVE_Loop
	move.l	a1,pc_TremoloWaveform(a2)
	move.w	(sp)+,d0
	rts
SE_TRMWAVE_Not:	clr.l	pc_TremoloWaveform(a2)
	move.w	(sp)+,d0
	rts
SE_TRMWAVP:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	move.l	pc_TremoloWaveform(a2),d0
	beq.s	SE_TRMWAVP_Not
	move.l	d0,a1
	move.l	tcyw_Samples(a1),d0
	divul.l	d0,d1:d2
	move.w	d1,pc_TremoloPos(a2)
	move.w	(sp)+,d0
	rts
SE_TRMWAVP_Not:	move.w	d0,pc_TremoloPos(a2)
	move.w	(sp)+,d0
	rts
SE_TREMOLO:	movem.l	d0-d1/d3/d5-d6,-(sp)
	add.w	(a0,d1.w*2),d2
	move.w	d2,d5
	lsr.w	#8,d5
	bne.s	SE_TREMOLO_NotPrevTrmSpd
	move.w	pc_TremoloRate(a2),d5
SE_TREMOLO_NotPrevTrmSpd:	move.w	d5,pc_TremoloRate(a2)
	ext.w	d2
	asl.w	#2,d2
	bne.s	SE_TREMOLO_NotPrevTrmDepth
	move.w	pc_TremoloDepth(a2),d2
SE_TREMOLO_NotPrevTrmDepth:	move.w	d2,pc_TremoloDepth(a2)
	neg.w	d2
	move.l	pc_TremoloWaveform(a2),d0
	beq.s	SE_TREMOLO_Not
	move.l	d0,a0
	move.l	tcyw_Samples(a0),d0
	moveq	#0,d3
	move.w	pc_TremoloPos(a2),d3
	divul.l	d0,d1:d3
	move.l	tcyw_WaveData(a0),a1
	tst.w	tcyw_Flags(a0)
	bmi.s	SE_TREMOLO_8Bit
	muls.w	(a1,d1.l*2),d2
	bra.s	SE_TREMOLO_16Bit
SE_TREMOLO_8Bit:	move.b	(a1,d1.l),d3
	asl.w	#8,d3
	muls.w	d3,d2
SE_TREMOLO_16Bit:	asr.l	#7-2,d2
	add.l	d5,d1
	divul.l	d0,d3:d1
	move.w	d3,pc_TremoloPos(a2)
SE_TREMOLO_Do:	sub.w	pc_TremoloSlideValue(a2),d2
	move.b	pc_Volume(a2),d5
	add.w	d5,d2
	bpl.s	SE_TREMOLO_TremoLoOk
	moveq	#0,d2
SE_TREMOLO_TremoLoOk:	cmp.w	#255,d2
	ble.s	SE_TREMOLO_TremoHiOk
	move.w	#255,d2
SE_TREMOLO_TremoHiOk:	move.b	d2,pc_Volume(a2)
	sub.w	d2,d5
	sub.w	d5,pc_TremoloSlideValue(a2)
SE_TREMOLO_Not:	movem.l	(sp)+,d0-d1/d3/d5-d6
	rts
SE_TRMVAL:	movem.l	d0-d1/d3/d5-d6,-(sp)
	add.w	(a0,d1.w*2),d2
	bra.s	SE_TREMOLO_Do
SE_PANLEFT:	add.w	(a0,d1.w*2),d2
	bne.s	SE_PANLEFT_Mem
	move.w	pc_PanSlLeftValue(a2),d2
SE_PANLEFT_Mem:	move.w	d2,pc_PanSlLeftValue(a2)
	sub.w	d2,pc_Panning(a2)
	bcc.s	SE_PANLEFT_Not
	clr.w	pc_Panning(a2)
SE_PANLEFT_Not:	rts
SE_PANRGHT:	add.w	(a0,d1.w*2),d2
	bne.s	SE_PANRGHT_Mem
	move.w	pc_PanSlRightValue(a2),d2
SE_PANRGHT_Mem:	move.w	d2,pc_PanSlRightValue(a2)
	add.w	d2,pc_Panning(a2)
	bcc.s	SE_PANLEFT_Not
	move.w	#-1,pc_Panning(a2)
	rts
SE_PANSPD:	add.w	(a0,d1.w*2),d2
	move.w	d2,pc_PannoloRate(a2)
	rts
SE_PANDPTH:	add.w	(a0,d1.w*2),d2
	move.w	d2,pc_PannoloDepth(a2)
	rts
SE_PANWAVE:	move.w	d0,-(sp)
	moveq	#-1,d0
	add.w	(a0,d1.w*2),d2
	move.l	pc_WaveformList(a2),a1
SE_PANWAVE_Loop:	addq.l	#1,d0
	move.l	(a1),a1
	tst.l	(a1)
	beq.s	SE_PANWAVE_Not
	cmp.l	d2,d0
	bne.s	SE_PANWAVE_Loop
	move.l	a1,pc_PannoloWaveform(a2)
	move.w	(sp)+,d0
	rts
SE_PANWAVE_Not:	clr.l	pc_PannoloWaveform(a2)
	move.w	(sp)+,d0
	rts
SE_PANWAVP:	move.w	d0,-(sp)
	add.w	(a0,d1.w*2),d2
	move.l	pc_PannoloWaveform(a2),d0
	beq.s	SE_PANWAVP_Not
	move.l	d0,a1
	move.l	tcyw_Samples(a1),d0
	divul.l	d0,d1:d2
	move.w	d1,pc_PannoloPos(a2)
	move.w	(sp)+,d0
	rts
SE_PANWAVP_Not:	move.w	d0,pc_PannoloPos(a2)
	move.w	(sp)+,d0
	rts
SE_PANNOLO:	movem.l	d0-d1/d3/d5-d6,-(sp)
	add.w	(a0,d1.w*2),d2
	move.w	d2,d5
	lsr.w	#8,d5
	bne.s	SE_PANNOLO_NotPrevPanSpd
	move.w	pc_PannoloRate(a2),d5
SE_PANNOLO_NotPrevPanSpd:	move.w	d5,pc_PannoloRate(a2)
	ext.w	d2
	asl.w	#2,d2
	bne.s	SE_PANNOLO_NotPrevPanDepth
	move.w	pc_TremoloDepth(a2),d2
SE_PANNOLO_NotPrevPanDepth:	move.w	d2,pc_PannoloDepth(a2)
	neg.w	d2
	move.l	pc_PannoloWaveform(a2),d0
	beq.s	SE_PANNOLO_Not
	move.l	d0,a0
	move.l	tcyw_Samples(a0),d0
	moveq	#0,d3
	move.w	pc_PannoloPos(a2),d3
	divul.l	d0,d1:d3
	move.l	tcyw_WaveData(a0),a1
	tst.w	tcyw_Flags(a0)
	bmi.s	SE_PANNOLO_8Bit
	muls.w	(a1,d1.l*2),d2
	bra.s	SE_PANNOLO_16Bit
SE_PANNOLO_8Bit:	move.b	(a1,d1.l),d3
	asl.w	#8,d3
	muls.w	d3,d2
SE_PANNOLO_16Bit:	asr.l	#7-2,d2
	add.l	d5,d1
	divul.l	d0,d3:d1
	move.w	d3,pc_PannoloPos(a2)
SE_PANNOLO_Do:	sub.w	pc_PannoloSlideValue(a2),d2
	move.b	pc_Panning(a2),d5
	add.w	d5,d2
	bpl.s	SE_PANNOLO_TremoLoOk
	moveq	#0,d2
SE_PANNOLO_TremoLoOk:	cmp.w	#255,d2
	ble.s	SE_PANNOLO_TremoHiOk
	move.w	#255,d2
SE_PANNOLO_TremoHiOk:	move.b	d2,pc_Panning(a2)
	sub.w	d2,d5
	sub.w	d5,pc_PannoloSlideValue(a2)
SE_PANNOLO_Not:	movem.l	(sp)+,d0-d1/d3/d5-d6
	rts
SE_PANVAL:	movem.l	d0-d1/d3/d5-d6,-(sp)
	add.w	(a0,d1.w*2),d2
	bra.s	SE_PANNOLO_Do

	cnop	0,4

CPU_MULU64:	mulu.l	d1,d1:d0
	rts

	cnop	0,4

MULU64:	tst.b	_Is68060
	beq.s	CPU_MULU64
	movem.l	d2-d5,-(sp)
	move.w	d0,d3
	mulu.w	d1,d3
	move.w	d0,d2
	swap	d0
	move.l	d0,d4
	mulu.w	d1,d0
	swap	d1
	move.l	d1,d5
	mulu.w	d2,d1
	moveq	#0,d2
	add.w	d1,d0
	addx.l	d2,d2
	swap	d0
	add.w	d0,d2
	clr.w	d0
	clr.w	d1
	swap	d1
	mulu.w	d5,d4
	add.l	d3,d0
	addx.l	d4,d1
	add.l	d2,d1
	movem.l	(sp)+,d2-d5
	rts

	cnop	0,4

CPU_DIVU64:	divu.l	d2,d1:d0
	rts

	cnop	0,4

DIVU64:	tst.b	_Is68060
	beq.s	CPU_DIVU64
	movem.l	d3-d5,-(sp)
	moveq	#0,d3
	moveq	#0,d4
	moveq	#$41,d5
DIVU64_Loop:	subq.l	#1,d5
	beq.s	DIVU64_Done
	add.l	d3,d3
	add.l	d0,d0
	roxl.l	#1,d1
	roxl.l	#1,d4
	cmp.l	d2,d4
	bcs.s	DIVU64_Loop
	sub.l	d2,d4
	addq.l	#1,d3
	bra.s	DIVU64_Loop
DIVU64_Done:	move.l	d3,d0
	move.l	d4,d1
	movem.l	(sp)+,d3-d5
	rts

	cnop	0,4

_SETab:	dc.w	SE_STOP-_SETab,SE_KILL-_SETab,SE_WAIT-_SETab,SE_WAITVOL-_SETab,SE_WAITPAN-_SETab,SE_WAITSLD-_SETab,SE_WAITSPC-_SETab,SE_JUMP-_SETab			* 00-07
	dc.w	SE_JUMPEQ-_SETab,SE_JUMPNE-_SETab,SE_JUMPPL-_SETab,SE_JUMPMI-_SETab,SE_JUMPLT-_SETab,SE_JUMPLE-_SETab,SE_JUMPGT-_SETab,SE_JUMPGE-_SETab			* 08-0F
	dc.w	SE_JUMPVS-_SETab,SE_JUMPVC-_SETab,SE_JUMPCS-_SETab,SE_JUMPCC-_SETab,SE_JUMPLS-_SETab,SE_JUMPHI-_SETab,SE_JUMPVOL-_SETab,SE_JUMPPAN-_SETab		* 11-17
	dc.w	SE_JUMPSLD-_SETab,SE_JUMPSPC-_SETab,SE_CALL-_SETab,SE_RETURN-_SETab,SE_POSVAR-_SETab,SE_LOAD-_SETab,SE_ADD-_SETab,SE_ADDX-_SETab				* 18-1F
	dc.w	SE_SUB-_SETab,SE_SUBX-_SETab,SE_CMP-_SETab,SE_MULU-_SETab,SE_MULS-_SETab,SE_DMULU-_SETab,SE_DMULS-_SETab,SE_DIVU-_SETab							* 20-27
	dc.w	SE_DIVS-_SETab,SE_MODU-_SETab,SE_MODS-_SETab,SE_DDIVU-_SETab,SE_DDIVS-_SETab,SE_ASHL-_SETab,SE_ASHR-_SETab,SE_LSHL-_SETab						* 28-2F
	dc.w	SE_LSHR-_SETab,SE_ROL-_SETab,SE_ROR-_SETab,SE_ROLX-_SETab,SE_RORX-_SETab,SE_OR-_SETab,SE_AND-_SETab,SE_XOR-_SETab								* 30-37
	dc.w	SE_NOT-_SETab,SE_NEG-_SETab,SE_NEGX-_SETab,SE_EXTB-_SETab,SE_EXT-_SETab,SE_XCHG-_SETab,SE_SWAP-_SETab,SE_GETWAVE-_SETab							* 38-3F
	dc.w	SE_GETWLEN-_SETab,SE_GETWPOS-_SETab,SE_GETCHAN-_SETab,SE_GETNOTE-_SETab,SE_GETRANS-_SETab,SE_GETPTCH-_SETab,SE_GETPER-_SETab,SE_GETFX-_SETab	* 40-47
	dc.w	SE_GETARPW-_SETab,SE_GETARPV-_SETab,SE_GETARPL-_SETab,SE_GETARPP-_SETab,SE_GETVIBW-_SETab,SE_GETVIBV-_SETab,SE_GETVIBL-_SETab,SE_GETVIBP-_SETab	* 48-4F
	dc.w	SE_GETTRMW-_SETab,SE_GETTRMV-_SETab,SE_GETTRML-_SETab,SE_GETTRMP-_SETab,SE_GETPANW-_SETab,SE_GETPANV-_SETab,SE_GETPANL-_SETab,SE_GETPANP-_SETab	* 50-57
	dc.w	SE_GETRND-_SETab,SE_GETSINE-_SETab,SE_PORTAUP-_SETab,SE_PORTADN-_SETab,SE_VIBSPD-_SETab,SE_VIBDPTH-_SETab,SE_VIBWAVE-_SETab,SE_VIBWAVP-_SETab	* 58-5F
	dc.w	SE_VIBRATO-_SETab,SE_VIBVAL-_SETab,SE_ARPSPD-_SETab,SE_ARPWAVE-_SETab,SE_ARPWAVP-_SETab,SE_ARPEGIO-_SETab,SE_ARPVAL-_SETab,SE_SETWAVE-_SETab	* 60-67
	dc.w	SE_ISETWAV-_SETab,SE_SETWAVP-_SETab,SE_SETRANS-_SETab,SE_SETNOTE-_SETab,SE_SETPTCH-_SETab,SE_SETPER-_SETab,SE_RESET-_SETab,SE_VOLSLUP-_SETab	* 68-6F
	dc.w	SE_VOLSLDN-_SETab,SE_TRMSPD-_SETab,SE_TRMDPTH-_SETab,SE_TRMWAVE-_SETab,SE_TRMWAVP-_SETab,SE_TREMOLO-_SETab,SE_TRMVAL-_SETab,SE_PANLEFT-_SETab	* 70-77
	dc.w	SE_PANRGHT-_SETab,SE_PANSPD-_SETab,SE_PANDPTH-_SETab,SE_PANWAVE-_SETab,SE_PANWAVP-_SETab,SE_PANNOLO-_SETab,SE_PANVAL-_SETab,Nop-_SETab			* 78-7F

	cnop	0,4

Msg:	dc.b	'Zuzana Burkertova, I love you !!! Signed, Basty/Seasons.',0

	cnop	0,4

EmptyWaveform:	ds.b	256

	cnop	0,4

; Note frequency table. Value is 65536*2^(x/12).
; Please note that the pointer actually points to the 2nd element.
; So the base C-4 is PitchTable[0], not PitchTable[-1]. B-3 is
; PitchTable[-1] */

_PitchTable:	dc.w	0,61858				* B-3 [-1]
	dc.w	1,0								* C-4 [0]
	dc.w	1,3897							* C#4 [1]
	dc.w	1,8026							* D-4 [2]
	dc.w	1,12400							* D#4 [3]
	dc.w	1,17034							* E-4 [4]
	dc.w	1,21944							* F-4 [5]
	dc.w	1,27146							* F#4 [6]
	dc.w	1,32657							* G-4 [7]
	dc.w	1,38496							* G#4 [8]
	dc.w	1,44682							* A-4 [9]
	dc.w	1,51236							* A#4 [10]
	dc.w	1,58179							* B-4 [11]
	dc.w	2,0								* C-5 [12]

	cnop	0,4

; Linear frequence table (value is 65536*2^(x/3072))
_LinearFreqTable:	dc.w	0,15,30,44,59,74,89,104,118,133,148,163,178,193,207,222
	dc.w	237,252,267,282,296,311,326,341,356,371,386,400,415,430,445,460
	dc.w	475,490,505,520,535,549,564,579,594,609,624,639,654,669,684,699
	dc.w	714,729,744,758,773,788,803,818,833,848,863,878,893,908,923,938
	dc.w	953,968,983,998,1013,1028,1043,1058,1073,1088,1103,1118,1134,1149,1164,1179
	dc.w	1194,1209,1224,1239,1254,1269,1284,1299,1314,1329,1344,1360,1375,1390,1405,1420
	dc.w	1435,1450,1465,1480,1496,1511,1526,1541,1556,1571,1586,1601,1617,1632,1647,1662
	dc.w	1677,1692,1708,1723,1738,1753,1768,1784,1799,1814,1829,1844,1859,1875,1890,1905
	dc.w	1920,1936,1951,1966,1981,1996,2012,2027,2042,2057,2073,2088,2103,2119,2134,2149
	dc.w	2164,2180,2195,2210,2225,2241,2256,2271,2287,2302,2317,2333,2348,2363,2379,2394
	dc.w	2409,2425,2440,2455,2471,2486,2501,2517,2532,2547,2563,2578,2593,2609,2624,2640
	dc.w	2655,2670,2686,2701,2716,2732,2747,2763,2778,2794,2809,2824,2840,2855,2871,2886
	dc.w	2902,2917,2932,2948,2963,2979,2994,3010,3025,3041,3056,3072,3087,3103,3118,3134
	dc.w	3149,3165,3180,3196,3211,3227,3242,3258,3273,3289,3304,3320,3335,3351,3366,3382
	dc.w	3397,3413,3429,3444,3460,3475,3491,3506,3522,3538,3553,3569,3584,3600,3616,3631
	dc.w	3647,3662,3678,3694,3709,3725,3740,3756,3772,3787,3803,3819,3834,3850,3866,3881
	dc.w	3897,3913,3928,3944,3960,3975,3991,4007,4022,4038,4054,4070,4085,4101,4117,4132
	dc.w	4148,4164,4180,4195,4211,4227,4242,4258,4274,4290,4305,4321,4337,4353,4369,4384
	dc.w	4400,4416,4432,4447,4463,4479,4495,4511,4526,4542,4558,4574,4590,4606,4621,4637
	dc.w	4653,4669,4685,4701,4716,4732,4748,4764,4780,4796,4812,4827,4843,4859,4875,4891
	dc.w	4907,4923,4939,4955,4971,4986,5002,5018,5034,5050,5066,5082,5098,5114,5130,5146
	dc.w	5162,5178,5194,5210,5226,5241,5257,5273,5289,5305,5321,5337,5353,5369,5385,5401
	dc.w	5417,5433,5449,5465,5481,5497,5513,5530,5546,5562,5578,5594,5610,5626,5642,5658
	dc.w	5674,5690,5706,5722,5738,5754,5770,5787,5803,5819,5835,5851,5867,5883,5899,5915
	dc.w	5932,5948,5964,5980,5996,6012,6028,6044,6061,6077,6093,6109,6125,6141,6158,6174
	dc.w	6190,6206,6222,6239,6255,6271,6287,6303,6320,6336,6352,6368,6384,6401,6417,6433
	dc.w	6449,6466,6482,6498,6514,6531,6547,6563,6579,6596,6612,6628,6645,6661,6677,6693
	dc.w	6710,6726,6742,6759,6775,6791,6808,6824,6840,6857,6873,6889,6906,6922,6938,6955
	dc.w	6971,6987,7004,7020,7037,7053,7069,7086,7102,7118,7135,7151,7168,7184,7200,7217
	dc.w	7233,7250,7266,7283,7299,7315,7332,7348,7365,7381,7398,7414,7431,7447,7463,7480
	dc.w	7496,7513,7529,7546,7562,7579,7595,7612,7628,7645,7661,7678,7694,7711,7728,7744
	dc.w	7761,7777,7794,7810,7827,7843,7860,7876,7893,7910,7926,7943,7959,7976,7992,8009
	dc.w	8026,8042,8059,8075,8092,8109,8125,8142,8159,8175,8192,8208,8225,8242,8258,8275
	dc.w	8292,8308,8325,8342,8358,8375,8392,8408,8425,8442,8458,8475,8492,8509,8525,8542
	dc.w	8559,8575,8592,8609,8626,8642,8659,8676,8693,8709,8726,8743,8760,8776,8793,8810
	dc.w	8827,8843,8860,8877,8894,8911,8927,8944,8961,8978,8995,9012,9028,9045,9062,9079
	dc.w	9096,9112,9129,9146,9163,9180,9197,9214,9230,9247,9264,9281,9298,9315,9332,9349
	dc.w	9366,9382,9399,9416,9433,9450,9467,9484,9501,9518,9535,9552,9569,9586,9603,9620
	dc.w	9636,9653,9670,9687,9704,9721,9738,9755,9772,9789,9806,9823,9840,9857,9874,9891
	dc.w	9908,9925,9942,9959,9976,9993,10011,10028,10045,10062,10079,10096,10113,10130,10147,10164
	dc.w	10181,10198,10215,10232,10250,10267,10284,10301,10318,10335,10352,10369,10386,10404,10421,10438
	dc.w	10455,10472,10489,10506,10524,10541,10558,10575,10592,10610,10627,10644,10661,10678,10695,10713
	dc.w	10730,10747,10764,10782,10799,10816,10833,10850,10868,10885,10902,10919,10937,10954,10971,10988
	dc.w	11006,11023,11040,11058,11075,11092,11109,11127,11144,11161,11179,11196,11213,11231,11248,11265
	dc.w	11283,11300,11317,11335,11352,11369,11387,11404,11421,11439,11456,11473,11491,11508,11526,11543
	dc.w	11560,11578,11595,11613,11630,11647,11665,11682,11700,11717,11735,11752,11769,11787,11804,11822
	dc.w	11839,11857,11874,11892,11909,11927,11944,11961,11979,11996,12014,12031,12049,12066,12084,12102
	dc.w	12119,12137,12154,12172,12189,12207,12224,12242,12259,12277,12294,12312,12330,12347,12365,12382
	dc.w	12400,12417,12435,12453,12470,12488,12505,12523,12541,12558,12576,12594,12611,12629,12646,12664
	dc.w	12682,12699,12717,12735,12752,12770,12788,12805,12823,12841,12858,12876,12894,12912,12929,12947
	dc.w	12965,12982,13000,13018,13036,13053,13071,13089,13106,13124,13142,13160,13177,13195,13213,13231
	dc.w	13249,13266,13284,13302,13320,13337,13355,13373,13391,13409,13427,13444,13462,13480,13498,13516
	dc.w	13533,13551,13569,13587,13605,13623,13641,13658,13676,13694,13712,13730,13748,13766,13784,13802
	dc.w	13819,13837,13855,13873,13891,13909,13927,13945,13963,13981,13999,14017,14035,14053,14071,14088
	dc.w	14106,14124,14142,14160,14178,14196,14214,14232,14250,14268,14286,14304,14322,14340,14358,14376
	dc.w	14394,14413,14431,14449,14467,14485,14503,14521,14539,14557,14575,14593,14611,14629,14647,14665
	dc.w	14684,14702,14720,14738,14756,14774,14792,14810,14829,14847,14865,14883,14901,14919,14937,14956
	dc.w	14974,14992,15010,15028,15046,15065,15083,15101,15119,15137,15156,15174,15192,15210,15228,15247
	dc.w	15265,15283,15301,15320,15338,15356,15374,15393,15411,15429,15447,15466,15484,15502,15521,15539
	dc.w	15557,15575,15594,15612,15630,15649,15667,15685,15704,15722,15740,15759,15777,15795,15814,15832
	dc.w	15850,15869,15887,15906,15924,15942,15961,15979,15997,16016,16034,16053,16071,16089,16108,16126
	dc.w	16145,16163,16182,16200,16218,16237,16255,16274,16292,16311,16329,16348,16366,16385,16403,16422
	dc.w	16440,16459,16477,16496,16514,16533,16551,16570,16588,16607,16625,16644,16662,16681,16700,16718
	dc.w	16737,16755,16774,16792,16811,16830,16848,16867,16885,16904,16922,16941,16960,16978,16997,17016
	dc.w	17034,17053,17071,17090,17109,17127,17146,17165,17183,17202,17221,17239,17258,17277,17295,17314
	dc.w	17333,17352,17370,17389,17408,17426,17445,17464,17483,17501,17520,17539,17557,17576,17595,17614
	dc.w	17633,17651,17670,17689,17708,17726,17745,17764,17783,17802,17820,17839,17858,17877,17896,17914
	dc.w	17933,17952,17971,17990,18009,18028,18046,18065,18084,18103,18122,18141,18160,18179,18197,18216
	dc.w	18235,18254,18273,18292,18311,18330,18349,18368,18387,18405,18424,18443,18462,18481,18500,18519
	dc.w	18538,18557,18576,18595,18614,18633,18652,18671,18690,18709,18728,18747,18766,18785,18804,18823
	dc.w	18842,18861,18880,18899,18918,18937,18957,18976,18995,19014,19033,19052,19071,19090,19109,19128
	dc.w	19147,19167,19186,19205,19224,19243,19262,19281,19300,19320,19339,19358,19377,19396,19415,19435
	dc.w	19454,19473,19492,19511,19530,19550,19569,19588,19607,19626,19646,19665,19684,19703,19723,19742
	dc.w	19761,19780,19800,19819,19838,19857,19877,19896,19915,19934,19954,19973,19992,20012,20031,20050
	dc.w	20070,20089,20108,20128,20147,20166,20186,20205,20224,20244,20263,20282,20302,20321,20340,20360
	dc.w	20379,20399,20418,20437,20457,20476,20496,20515,20534,20554,20573,20593,20612,20632,20651,20670
	dc.w	20690,20709,20729,20748,20768,20787,20807,20826,20846,20865,20885,20904,20924,20943,20963,20982
	dc.w	21002,21021,21041,21060,21080,21099,21119,21139,21158,21178,21197,21217,21236,21256,21276,21295
	dc.w	21315,21334,21354,21374,21393,21413,21432,21452,21472,21491,21511,21531,21550,21570,21589,21609
	dc.w	21629,21648,21668,21688,21708,21727,21747,21767,21786,21806,21826,21845,21865,21885,21905,21924
	dc.w	21944,21964,21984,22003,22023,22043,22063,22082,22102,22122,22142,22161,22181,22201,22221,22241
	dc.w	22260,22280,22300,22320,22340,22360,22379,22399,22419,22439,22459,22479,22498,22518,22538,22558
	dc.w	22578,22598,22618,22638,22658,22677,22697,22717,22737,22757,22777,22797,22817,22837,22857,22877
	dc.w	22897,22917,22937,22957,22977,22996,23016,23036,23056,23076,23096,23116,23136,23156,23176,23196
	dc.w	23216,23237,23257,23277,23297,23317,23337,23357,23377,23397,23417,23437,23457,23477,23497,23517
	dc.w	23537,23558,23578,23598,23618,23638,23658,23678,23698,23719,23739,23759,23779,23799,23819,23839
	dc.w	23860,23880,23900,23920,23940,23961,23981,24001,24021,24041,24062,24082,24102,24122,24142,24163
	dc.w	24183,24203,24223,24244,24264,24284,24304,24325,24345,24365,24386,24406,24426,24446,24467,24487
	dc.w	24507,24528,24548,24568,24589,24609,24629,24650,24670,24690,24711,24731,24752,24772,24792,24813
	dc.w	24833,24853,24874,24894,24915,24935,24956,24976,24996,25017,25037,25058,25078,25099,25119,25139
	dc.w	25160,25180,25201,25221,25242,25262,25283,25303,25324,25344,25365,25385,25406,25426,25447,25467
	dc.w	25488,25508,25529,25550,25570,25591,25611,25632,25652,25673,25694,25714,25735,25755,25776,25797
	dc.w	25817,25838,25858,25879,25900,25920,25941,25962,25982,26003,26023,26044,26065,26085,26106,26127
	dc.w	26148,26168,26189,26210,26230,26251,26272,26292,26313,26334,26355,26375,26396,26417,26438,26458
	dc.w	26479,26500,26521,26541,26562,26583,26604,26625,26645,26666,26687,26708,26729,26749,26770,26791
	dc.w	26812,26833,26854,26874,26895,26916,26937,26958,26979,27000,27021,27041,27062,27083,27104,27125
	dc.w	27146,27167,27188,27209,27230,27251,27271,27292,27313,27334,27355,27376,27397,27418,27439,27460
	dc.w	27481,27502,27523,27544,27565,27586,27607,27628,27649,27670,27691,27712,27733,27754,27775,27796
	dc.w	27818,27839,27860,27881,27902,27923,27944,27965,27986,28007,28028,28049,28071,28092,28113,28134
	dc.w	28155,28176,28197,28219,28240,28261,28282,28303,28324,28346,28367,28388,28409,28430,28452,28473
	dc.w	28494,28515,28536,28558,28579,28600,28621,28643,28664,28685,28706,28728,28749,28770,28791,28813
	dc.w	28834,28855,28877,28898,28919,28941,28962,28983,29005,29026,29047,29069,29090,29111,29133,29154
	dc.w	29175,29197,29218,29240,29261,29282,29304,29325,29346,29368,29389,29411,29432,29454,29475,29496
	dc.w	29518,29539,29561,29582,29604,29625,29647,29668,29690,29711,29733,29754,29776,29797,29819,29840
	dc.w	29862,29883,29905,29926,29948,29969,29991,30012,30034,30056,30077,30099,30120,30142,30164,30185
	dc.w	30207,30228,30250,30272,30293,30315,30336,30358,30380,30401,30423,30445,30466,30488,30510,30531
	dc.w	30553,30575,30596,30618,30640,30661,30683,30705,30727,30748,30770,30792,30814,30835,30857,30879
	dc.w	30900,30922,30944,30966,30988,31009,31031,31053,31075,31097,31118,31140,31162,31184,31206,31227
	dc.w	31249,31271,31293,31315,31337,31359,31380,31402,31424,31446,31468,31490,31512,31534,31555,31577
	dc.w	31599,31621,31643,31665,31687,31709,31731,31753,31775,31797,31819,31841,31863,31885,31907,31929
	dc.w	31951,31973,31995,32017,32039,32061,32083,32105,32127,32149,32171,32193,32215,32237,32259,32281
	dc.w	32303,32325,32347,32369,32392,32414,32436,32458,32480,32502,32524,32546,32568,32591,32613,32635
	dc.w	32657,32679,32701,32724,32746,32768,32790,32812,32834,32857,32879,32901,32923,32945,32968,32990
	dc.w	33012,33034,33057,33079,33101,33123,33146,33168,33190,33213,33235,33257,33279,33302,33324,33346
	dc.w	33369,33391,33413,33436,33458,33480,33503,33525,33547,33570,33592,33614,33637,33659,33682,33704
	dc.w	33726,33749,33771,33794,33816,33838,33861,33883,33906,33928,33951,33973,33995,34018,34040,34063
	dc.w	34085,34108,34130,34153,34175,34198,34220,34243,34265,34288,34310,34333,34355,34378,34400,34423
	dc.w	34446,34468,34491,34513,34536,34558,34581,34604,34626,34649,34671,34694,34717,34739,34762,34785
	dc.w	34807,34830,34852,34875,34898,34920,34943,34966,34988,35011,35034,35057,35079,35102,35125,35147
	dc.w	35170,35193,35216,35238,35261,35284,35307,35329,35352,35375,35398,35420,35443,35466,35489,35512
	dc.w	35534,35557,35580,35603,35626,35648,35671,35694,35717,35740,35763,35785,35808,35831,35854,35877
	dc.w	35900,35923,35946,35969,35991,36014,36037,36060,36083,36106,36129,36152,36175,36198,36221,36244
	dc.w	36267,36290,36313,36336,36359,36382,36405,36428,36451,36474,36497,36520,36543,36566,36589,36612
	dc.w	36635,36658,36681,36704,36727,36750,36773,36796,36820,36843,36866,36889,36912,36935,36958,36981
	dc.w	37004,37028,37051,37074,37097,37120,37143,37167,37190,37213,37236,37259,37282,37306,37329,37352
	dc.w	37375,37399,37422,37445,37468,37491,37515,37538,37561,37584,37608,37631,37654,37678,37701,37724
	dc.w	37747,37771,37794,37817,37841,37864,37887,37911,37934,37957,37981,38004,38028,38051,38074,38098
	dc.w	38121,38144,38168,38191,38215,38238,38261,38285,38308,38332,38355,38379,38402,38426,38449,38472
	dc.w	38496,38519,38543,38566,38590,38613,38637,38660,38684,38707,38731,38754,38778,38802,38825,38849
	dc.w	38872,38896,38919,38943,38966,38990,39014,39037,39061,39084,39108,39132,39155,39179,39202,39226
	dc.w	39250,39273,39297,39321,39344,39368,39392,39415,39439,39463,39486,39510,39534,39558,39581,39605
	dc.w	39629,39652,39676,39700,39724,39747,39771,39795,39819,39843,39866,39890,39914,39938,39961,39985
	dc.w	40009,40033,40057,40081,40104,40128,40152,40176,40200,40224,40248,40271,40295,40319,40343,40367
	dc.w	40391,40415,40439,40463,40486,40510,40534,40558,40582,40606,40630,40654,40678,40702,40726,40750
	dc.w	40774,40798,40822,40846,40870,40894,40918,40942,40966,40990,41014,41038,41062,41086,41110,41134
	dc.w	41158,41182,41207,41231,41255,41279,41303,41327,41351,41375,41399,41424,41448,41472,41496,41520
	dc.w	41544,41568,41593,41617,41641,41665,41689,41714,41738,41762,41786,41810,41835,41859,41883,41907
	dc.w	41932,41956,41980,42004,42029,42053,42077,42101,42126,42150,42174,42199,42223,42247,42272,42296
	dc.w	42320,42345,42369,42393,42418,42442,42466,42491,42515,42539,42564,42588,42613,42637,42661,42686
	dc.w	42710,42735,42759,42784,42808,42833,42857,42881,42906,42930,42955,42979,43004,43028,43053,43077
	dc.w	43102,43126,43151,43175,43200,43224,43249,43274,43298,43323,43347,43372,43396,43421,43446,43470
	dc.w	43495,43519,43544,43569,43593,43618,43642,43667,43692,43716,43741,43766,43790,43815,43840,43864
	dc.w	43889,43914,43938,43963,43988,44013,44037,44062,44087,44111,44136,44161,44186,44210,44235,44260
	dc.w	44285,44310,44334,44359,44384,44409,44434,44458,44483,44508,44533,44558,44583,44607,44632,44657
	dc.w	44682,44707,44732,44757,44781,44806,44831,44856,44881,44906,44931,44956,44981,45006,45031,45056
	dc.w	45081,45106,45131,45155,45180,45205,45230,45255,45280,45305,45330,45355,45381,45406,45431,45456
	dc.w	45481,45506,45531,45556,45581,45606,45631,45656,45681,45706,45731,45757,45782,45807,45832,45857
	dc.w	45882,45907,45932,45958,45983,46008,46033,46058,46083,46109,46134,46159,46184,46209,46235,46260
	dc.w	46285,46310,46336,46361,46386,46411,46437,46462,46487,46512,46538,46563,46588,46614,46639,46664
	dc.w	46690,46715,46740,46766,46791,46816,46842,46867,46892,46918,46943,46968,46994,47019,47045,47070
	dc.w	47095,47121,47146,47172,47197,47223,47248,47273,47299,47324,47350,47375,47401,47426,47452,47477
	dc.w	47503,47528,47554,47579,47605,47630,47656,47681,47707,47733,47758,47784,47809,47835,47860,47886
	dc.w	47912,47937,47963,47988,48014,48040,48065,48091,48117,48142,48168,48194,48219,48245,48271,48296
	dc.w	48322,48348,48373,48399,48425,48450,48476,48502,48528,48553,48579,48605,48631,48656,48682,48708
	dc.w	48734,48759,48785,48811,48837,48863,48888,48914,48940,48966,48992,49018,49044,49069,49095,49121
	dc.w	49147,49173,49199,49225,49251,49276,49302,49328,49354,49380,49406,49432,49458,49484,49510,49536
	dc.w	49562,49588,49614,49640,49666,49692,49718,49744,49770,49796,49822,49848,49874,49900,49926,49952
	dc.w	49978,50004,50030,50056,50082,50108,50135,50161,50187,50213,50239,50265,50291,50317,50343,50370
	dc.w	50396,50422,50448,50474,50500,50527,50553,50579,50605,50631,50658,50684,50710,50736,50763,50789
	dc.w	50815,50841,50868,50894,50920,50946,50973,50999,51025,51052,51078,51104,51131,51157,51183,51210
	dc.w	51236,51262,51289,51315,51341,51368,51394,51420,51447,51473,51500,51526,51552,51579,51605,51632
	dc.w	51658,51685,51711,51738,51764,51790,51817,51843,51870,51896,51923,51949,51976,52002,52029,52056
	dc.w	52082,52109,52135,52162,52188,52215,52241,52268,52295,52321,52348,52374,52401,52428,52454,52481
	dc.w	52507,52534,52561,52587,52614,52641,52667,52694,52721,52747,52774,52801,52827,52854,52881,52908
	dc.w	52934,52961,52988,53015,53041,53068,53095,53122,53148,53175,53202,53229,53256,53282,53309,53336
	dc.w	53363,53390,53416,53443,53470,53497,53524,53551,53578,53605,53631,53658,53685,53712,53739,53766
	dc.w	53793,53820,53847,53874,53901,53928,53955,53981,54008,54035,54062,54089,54116,54143,54170,54197
	dc.w	54224,54251,54278,54306,54333,54360,54387,54414,54441,54468,54495,54522,54549,54576,54603,54630
	dc.w	54658,54685,54712,54739,54766,54793,54820,54848,54875,54902,54929,54956,54983,55011,55038,55065
	dc.w	55092,55119,55147,55174,55201,55228,55256,55283,55310,55337,55365,55392,55419,55447,55474,55501
	dc.w	55529,55556,55583,55611,55638,55665,55693,55720,55747,55775,55802,55829,55857,55884,55912,55939
	dc.w	55966,55994,56021,56049,56076,56104,56131,56158,56186,56213,56241,56268,56296,56323,56351,56378
	dc.w	56406,56433,56461,56488,56516,56543,56571,56599,56626,56654,56681,56709,56736,56764,56792,56819
	dc.w	56847,56874,56902,56930,56957,56985,57013,57040,57068,57096,57123,57151,57179,57206,57234,57262
	dc.w	57289,57317,57345,57373,57400,57428,57456,57484,57511,57539,57567,57595,57622,57650,57678,57706
	dc.w	57734,57761,57789,57817,57845,57873,57901,57929,57956,57984,58012,58040,58068,58096,58124,58152
	dc.w	58179,58207,58235,58263,58291,58319,58347,58375,58403,58431,58459,58487,58515,58543,58571,58599
	dc.w	58627,58655,58683,58711,58739,58767,58795,58823,58851,58879,58907,58935,58964,58992,59020,59048
	dc.w	59076,59104,59132,59160,59189,59217,59245,59273,59301,59329,59357,59386,59414,59442,59470,59498
	dc.w	59527,59555,59583,59611,59640,59668,59696,59724,59753,59781,59809,59837,59866,59894,59922,59951
	dc.w	59979,60007,60036,60064,60092,60121,60149,60177,60206,60234,60263,60291,60319,60348,60376,60405
	dc.w	60433,60461,60490,60518,60547,60575,60604,60632,60661,60689,60717,60746,60774,60803,60831,60860
	dc.w	60889,60917,60946,60974,61003,61031,61060,61088,61117,61146,61174,61203,61231,61260,61289,61317
	dc.w	61346,61374,61403,61432,61460,61489,61518,61546,61575,61604,61632,61661,61690,61718,61747,61776
	dc.w	61805,61833,61862,61891,61920,61948,61977,62006,62035,62063,62092,62121,62150,62179,62208,62236
	dc.w	62265,62294,62323,62352,62381,62409,62438,62467,62496,62525,62554,62583,62612,62641,62670,62698
	dc.w	62727,62756,62785,62814,62843,62872,62901,62930,62959,62988,63017,63046,63075,63104,63133,63162
	dc.w	63191,63220,63249,63278,63308,63337,63366,63395,63424,63453,63482,63511,63540,63569,63599,63628
	dc.w	63657,63686,63715,63744,63774,63803,63832,63861,63890,63919,63949,63978,64007,64036,64066,64095
	dc.w	64124,64153,64183,64212,64241,64270,64300,64329,64358,64388,64417,64446,64476,64505,64534,64564
	dc.w	64593,64622,64652,64681,64711,64740,64769,64799,64828,64858,64887,64916,64946,64975,65005,65034
	dc.w	65064,65093,65123,65152,65182,65211,65241,65270,65300,65329,65359,65388,65418,65447,65477,65506
