	include	"exec/types.i"
	include	"exec/libraries.i"
	include	"exec/exec_lib.i"
	include	"exec/memory.i"
	include	"tucomposer/tucomposer.i"
	include	"tucomposer/tucomposer_lib.i"
	include	"tucomposer/player.i"
	include	"tucomposer/module.i"
	include	"tucomposer/song.i"
	include	"tucomposer/position.i"
	include	"tucomposer/track.i"
	include	"tucomposer/instr.i"
	include	"tucomposer/sample.i"
	include	"tucomposer/synth.i"
	include	"tucomposer/external.i"

	XDEF	_InternalMixer
	XDEF	_InternalMixerBase

	XREF	_Is68060

	IFND	_G2
	MACHINE	MC68020
	ENDC

	SECTION	"InternalLQMix",CODE

_InternalMixer:	ds.l	2
	dc.b	EXTLF_Intern|EXTLF_Saver
	dc.b	0
	dc.l	_InternalMixerBase
	dc.l	0
	dc.l	LQMixName
	dc.l	LQIDString
	dc.l	0
	dc.l	LQSaveFlags
	ds.l	2

	cnop	0,4

LQNegSize:	jmp	DoLQMix
	jmp	SetLQChannelPos
	jmp	SetLQChannelVol
	jmp	SetLQChannel
	jmp	GetLQChannel
	jmp	ChangeLQMixVolTable
	jmp	ChangeLQMixTempo
	jmp	ChangeLQMixRate
	jmp	InitLQMix
	jmp	FreeLQMix
	jmp	AllocLQMix
	jmp	ExtLib
	jmp	ExtLib
	jmp	LQUpdate
	jmp	ExtLib
	jmp	ExtLib
	jmp	ExtLib
	jmp	CloseExtLib
	jmp	Open
_InternalMixerBase:	ds.l	2
	dc.b	NT_LIBRARY
	dc.b	0
	dc.l	LQMixName
	dc.b	LIBF_SUMUSED
	dc.b	0
	dc.w	_InternalMixerBase-LQNegSize
	dc.w	LQSaveFlags-_InternalMixerBase
	dc.w	EXTLIB_MIXER_VERSION
	dc.w	22
	dc.l	LQIDString
	dc.l	0
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	_InternalMixer
	dc.b	MIF_StereoSupport|MIF_Surround
	dc.b	0
	dc.l	16000
	dc.l	512
	dc.l	65536
	dc.l	1000,256000
	dc.l	16,32768
	dc.w	65535
	ds.b	14
LQSaveFlags:	dc.w	3
	dc.w	0
	dc.l	LQSit0
	dc.b	EXTFLAG_BOOLEAN
	dc.b	TEFSF_Update
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	LQSit1
	dc.b	EXTFLAG_BOOLEAN
	dc.b	TEFSF_Update
	dc.w	0
	dc.l	0
	dc.l	0
	dc.l	-1
	dc.l	0
	dc.l	LQButton2
	dc.b	EXTFLAG_BUTTON
	dc.b	TEFSF_Update
	dc.w	1+4
	dc.l	0
	dc.l	0
	dc.l	2
	dc.l	0
LQButton2:	dc.l	LQSit2
	dc.l	LQSit21
	dc.l	LQSit22
	dc.l	LQSit23
	dc.l	LQSit24
LQUpdate:	move.l	extb_TuComposerBase(a6),a0
	move.l	tcb_PlayMixerAlloc(a0),a0
	cmp.l	(a0),a6
	bne.s	LQUpdDone
	btst	#MASB_Mixing,mas_Flags(a0)
	beq.s	LQUpdDone
	move.l	mas_SoundDevLibBase(a0),a1
	move.l	a2,-(sp)
	sub.l	a2,a2
	bsr	InitLQMix
	move.l	(sp)+,a2
LQUpdDone:	rts
AllocLQMix:	movem.l	a2/a6,-(sp)
	moveq	#lqmas_SIZEOF/2,d0
	add.l	d0,d0
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOAllocPMem(a6)
	tst.l	d0
	beq.s	AllocErr
	move.l	d0,a2
	move.l	4(sp),(a2)
	moveq	#4,d0
	swap	d0
	jsr	_LVOAllocPMem(a6)
	move.l	d0,lqmas_VolTable(a2)
	beq.s	AllocErr2
	sub.l	a1,a1
	move.l	4.w,a6
	jsr	_LVOFindTask(a6)
	move.l	d0,mas_Task(a2)
	lea	mas_PostProcs(a2),a0
	move.l	a0,(a0)
	move.l	a0,MLH_TAILPRED(a0)
	addq.l	#4,(a0)
	move.l	a2,d0
AllocErr:	movem.l	(sp)+,a2/a6
	rts
AllocErr2:	moveq	#lqmas_SIZEOF/2,d0
	add.l	d0,d0
	move.l	a2,a1
	jsr	_LVOFreePMem(a6)
	moveq	#0,d0
	bra.s	AllocErr
FreeLQMix:	moveq	#ERROR_EXTLIB_MIXNOALLOC,d0
	movem.l	a2/a6,-(sp)
	move.l	a0,d0
	beq.s	AllocErr
	move.l	d0,a2
	move.l	lqmas_ChInfo(a2),d0
	beq.s	NoChInfo
	move.l	d0,a1
	move.w	mas_MaxChannels(a2),d0
	mulu.w	#chi_SIZEOF,d0
	move.l	extb_TuComposerBase(a6),a6
	jsr	_LVOFreePMem(a6)
NoChInfo:	move.l	lqmas_MixBuffer(a2),d0
	beq.s	NoMixBuffers
	move.l	d0,a1
	move.l	lqmas_MixBufSize(a2),d0
	jsr	_LVOFreePMem(a6)
NoMixBuffers:	move.l	lqmas_VolTable(a2),d0
	beq.s	NoVolTable
	move.l	d0,a1
	moveq	#4,d0
	swap	d0
	jsr	_LVOFreePMem(a6)
NoVolTable:	moveq	#lqmas_SIZEOF/2,d0
	add.l	d0,d0
	move.l	a2,a1
	jsr	_LVOFreePMem(a6)
	moveq	#0,d0
	movem.l	(sp)+,a2/a6
	rts
InitLQMix:	movem.l	d2-d7/a2-a6,-(sp)
	move.l	a0,a5
	move.l	4(a2),d6
	beq.s	ChgStereoOk
	btst	#SDIB_Stereo,sdi_Flags(a1)
	bne.s	ChgStereoOk
	moveq	#0,d6
ChgStereoOk:	move.l	a2,a4
	move.l	a1,a2
	move.l	a6,a3
	move.l	a2,a6
	cmp.l	mas_SoundDevLibBase(a5),a2
	beq.s	SameSoundDev
	move.l	a2,mas_SoundDevLibBase(a5)
	btst	#MASB_Mixing,mas_Flags(a5)
	beq.s	SameSoundDev
	move.l	a6,-(sp)
	move.l	mas_SoundDevLibBase(a5),a6
	jsr	_LVOExternalDeviceStop(a6)
	move.l	(sp)+,a6
SameSoundDev:	move.l	mas_MixRate(a5),d0
	move.l	d0,d2
	jsr	_LVOExternalDeviceCheckRate(a6)
	move.l	d0,mas_MixRate(a5)
	move.l	d2,d0
	jsr	_LVOExternalDeviceCheckRateFraction(a6)
	move.l	d0,lqmas_MixFract(a5)
	move.w	mas_MaxChannels(a5),d0
	cmp.w	lqmas_Channels(a5),d0
	bne.s	ChgNewVolTable
	move.l	mas_VolumeBoost(a5),d0
	cmp.l	lqmas_Amplify(a5),d0
	bne.s	ChgNewVolTable
	cmp.b	lqmas_Stereo(a5),d6
	beq.s	ChgVolTableEnd
ChgNewVolTable:	moveq	#0,d2
	move.w	mas_MaxChannels(a5),d2
	move.l	mas_VolumeBoost(a5),d7
	move.l	d7,lqmas_Amplify(a5)
	move.b	lqmas_Stereo(a5),lqmas_PrevStereo(a5)
	move.b	d6,lqmas_Stereo(a5)
	lsl.l	#8,d2
	move.l	lqmas_VolTable(a5),a0
	moveq	#0,d3
ChgVolTabOutLoop:	moveq	#0,d4
	move.l	d3,d5
	mulu.l	d7,d5
ChgVolTabInLoop:	move.l	d4,d0
	lsl.w	#8,d0
	ext.l	d0
	muls.l	d5,d1:d0
	divs.l	d2,d1:d0
	move.l	d0,(a0)+
	addq.b	#1,d4
	bcc.s	ChgVolTabInLoop
	addq.b	#1,d3
	bcc.s	ChgVolTabOutLoop
ChgVolTableEnd:	btst	#MASB_Mixing,mas_Flags(a5)
	beq.s	NoStopDevice
	jsr	_LVOExternalDeviceStop(a6)
NoStopDevice:	move.w	mas_MaxChannels(a5),d0
	move.l	extb_TuComposerBase(a6),a6
	tst.l	lqmas_ChInfo(a5)
	beq.s	ChgAllocNewChInfo
	cmp.w	lqmas_Channels(a5),d0
	beq.s	ChgNotAllocNewChInfo
ChgAllocNewChInfo:	move.w	d0,d4
	mulu.w	#chi_SIZEOF,d0
	jsr	_LVOAllocPMem(a6)
	move.l	d0,d2
	beq.s	ChgNotAllocNewChInfo
	move.w	d4,d5
	move.l	lqmas_ChInfo(a5),d0
	beq.s	NotChgFreeOldChInfo
	move.l	d0,a0
	move.l	d2,a1
	cmp.w	lqmas_Channels(a5),d5
	bcs.s	CopyChInfo
	move.w	lqmas_Channels(a5),d5
CopyChInfo:	mulu.w	#chi_SIZEOF/4,d5
CopyChInfoLoop:	move.l	(a0)+,(a1)+
	subq.l	#1,d5
	bne.s	CopyChInfoLoop
	move.w	lqmas_Channels(a5),d0
	mulu.w	#chi_SIZEOF,d0
	move.l	lqmas_ChInfo(a5),a1
	jsr	_LVOFreePMem(a6)
NotChgFreeOldChInfo:	move.l	d2,lqmas_ChInfo(a5)
	move.w	d4,lqmas_Channels(a5)
ChgNotAllocNewChInfo:	move.w	lqmas_Channels(a5),mas_MaxChannels(a5)
	move.l	mas_MixBufSize(a5),d2
	tst.l	lqmas_MixBuffer(a5)
	beq.s	ChgAllocNewChBuf
	cmp.l	lqmas_MixBufSize(a5),d2
	beq.s	ChgNotAllocNewChBuf
ChgAllocNewChBuf:	move.l	d2,d5
	lsl.l	#2,d2
	tst.l	d6
	beq.s	ChgNoStereo
	add.l	d2,d2
ChgNoStereo:	move.l	lqmas_MixBufSize(a5),d7
	move.l	d2,lqmas_MixBufSize(a5)
	move.l	d2,d0
	jsr	_LVOAllocPMem(a6)
	move.l	d0,d3
	beq.s	ChgNotAllocNewChBuf
	move.l	lqmas_MixBuffer(a5),d2
	movem.l	d3/d5,lqmas_MixBuffer(a5)
	move.l	d5,sdi_ChannelBufLen(a2)
	tst.l	d2
	beq.s	ChgNotAllocNewChBuf
	move.l	d7,d0
	move.l	d2,a1
	jsr	_LVOFreePMem(a6)
ChgNotAllocNewChBuf:	move.l	lqmas_BuffSize(a5),mas_MixBufSize(a5)
	move.l	lqmas_MixBuffer(a5),d0
	move.l	d0,sdi_ChannelBuf(a2)
	move.l	d0,mas_MixBuf(a5)
	move.l	mas_MixRate(a5),d0
	move.l	d0,lqmas_MixRate(a5)
	move.l	d0,sdi_ChannelFreq(a2)
	bfins	d6,sdi_ChannelFlags(a2){8-1-SDICB_Stereo:1}
	bfins	d6,mas_Flags(a5){8-1-MASB_Stereo:1}
	move.l	a2,mas_SoundDevLibBase(a5)
	move.l	d0,d1
	lsl.l	#3,d0
	add.l	d1,d0
	add.l	d1,d0
	move.l	lqmas_MixFract(a5),d1
	move.w	d0,d1
	clr.w	d0
	swap	d0
	swap	d1
	divu.l	mas_Tempo(a5),d0:d1
	move.l	d1,lqmas_PassLength(a5)
	moveq	#0,d1
	divu.l	mas_Tempo(a5),d0:d1
	move.l	d1,lqmas_PassFrac(a5)
	tst.l	(a4)
	seq	lqmas_Real16Bit(a5)
	move.l	8(a4),d0
	subq.l	#1,d0
	move.b	d0,lqmas_Interpolation(a5)
	move.w	lqmas_Channels(a5),d4
	move.l	lqmas_ChInfo(a5),a4
CorrectChInfo:	move.l	chi_SampleRate(a4),d0
	move.l	a4,a1
	bsr	SetSmpMixRate
	lea	chi_SIZEOF(a4),a4
	subq.w	#1,d4
	bne.s	CorrectChInfo
	btst	#MASB_Mixing,mas_Flags(a5)
	beq.s	MixChangeCmp
	move.l	extb_ExtLibList(a2),a0
	move.l	tcb_PlayMixerAlloc(a6),a1
	sub.l	a2,a2
	jsr	_LVOPlaySoundDevice(a6)
MixChangeCmp:	moveq	#0,d0
MixChangeDone:	movem.l	(sp)+,d2-d7/a2-a6
	rts

	cnop	0,4

ChangeLQMixRate:	move.l	d0,mas_MixRate(a0)
	movem.l	d2-d3/a2/a5,-(sp)
	btst	#MASB_Mixing,mas_Flags(a0)
	beq	ChgRateDone
	move.l	a0,a5
	move.l	a6,a2
	move.l	mas_SoundDevLibBase(a5),a6
	move.l	d0,d2
	jsr	_LVOExternalDeviceCheckRate(a6)
	exg	d0,d2
	jsr	_LVOExternalDeviceCheckRateFraction(a6)
	move.l	d0,d3
	move.l	d2,d0
	jsr	_LVOExternalDeviceUpdateRate(a6)
	move.l	a2,a6
	tst.l	d0
	bne	SameRate
	cmp.l	lqmas_MixRate(a5),d2
	beq	SameRate
	movem.l	d2-d3,lqmas_MixRate(a5)
	move.l	a5,a0
	move.l	mas_Tempo(a5),d0
	bsr	ChangeLQMixTempo
	move.w	lqmas_Channels(a5),d3
	move.l	lqmas_ChInfo(a5),a2
AdjustChInfo:	move.l	chi_SampleRate(a2),d0
	divul.l	d2,d1:d0
	cmp.l	#$10000,d0
	blo.s	AdjSmpRateOk
	moveq	#-1,d0
AdjSmpRateOk:	move.w	d0,chi_Advance+2(a2)
	moveq	#0,d0
	bsr	DIVU64
	swap	d0
	move.w	d0,chi_AdvFract+2(a2)
	move.l	chi_Advance(a2),d1
	moveq	#0,d0
	move.b	chi_BitDepth(a2),d0
	mulu.l	d0,d1
	move.l	d1,chi_RealAdv(a2)
	move.l	chi_NewSampleRate(a2),d0
	divul.l	d2,d1:d0
	cmp.l	#$10000,d0
	blo.s	AdjNewSmpRateOk
	moveq	#-1,d0
AdjNewSmpRateOk:	move.w	d0,chi_NewAdvance+2(a2)
	moveq	#0,d0
	bsr	DIVU64
	swap	d0
	move.w	d0,chi_NewAdvFract+2(a2)
	move.l	chi_NewAdvance(a2),d1
	moveq	#0,d0
	move.b	chi_NewBitDepth(a2),d0
	mulu.l	d0,d1
	move.l	d1,chi_NewRealAdv(a2)
	lea	chi_SIZEOF(a2),a2
	subq.w	#1,d3
	bne.s	AdjustChInfo
ChgRateDone:	moveq	#0,d0
SameRate:	movem.l	(sp)+,d2-d3/a2/a5
NotMixing:	rts

	cnop	0,4

ChangeLQMixTempo:	move.l	d2,-(sp)
	move.l	d0,mas_Tempo(a0)
	move.l	lqmas_MixRate(a0),d1
	move.l	d1,d0
	lsl.l	#3,d0
	add.l	d1,d0
	add.l	d1,d0
	move.l	lqmas_MixFract(a0),d1
	move.w	d0,d1
	clr.w	d0
	swap	d0
	swap	d1
	move.l	mas_Tempo(a0),d2
	exg	d0,d1
	bsr	DIVU64
	move.l	d0,lqmas_PassLength(a0)
	moveq	#0,d0
	bsr	DIVU64
	move.l	d0,lqmas_PassFrac(a0)
	moveq	#0,d0
	move.l	(sp)+,d2
	rts

	cnop	0,4

ChangeLQMixVolTable:	movem.l	d2-d7/a2-a6,-(sp)
	move.l	d0,d7
	move.l	a0,a5
	move.l	d1,a4
	cmp.w	lqmas_Channels(a5),d3
	beq.s	NewNotAllocNewChInfo
	move.w	d0,d4
	mulu.w	#chi_SIZEOF,d0
	move.l	#MEMF_PUBLIC|MEMF_CLEAR,d1
	jsr	_LVOAllocPMem(a6)
	move.l	d0,d1
	beq	AllocChInfoErr
	exg	d1,a4
NewNotAllocNewChInfo:	move.l	d7,mas_VolumeBoost(a5)
	movem.w	d1-d2,mas_LeftVolume(a5)
	move.l	d3,d2
	move.w	d3,mas_MaxChannels(a5)
	cmp.w	lqmas_Channels(a5),d3
	bne.s	ChgNewMixVolTable
	cmp.l	lqmas_Amplify(a5),d7
	beq.s	ChgVolTableDone
ChgNewMixVolTable:	move.l	d7,lqmas_Amplify(a5)
	lsl.l	#8,d2
	moveq	#0,d3
	move.l	lqmas_VolTable(a5),a0
NewVolTabOutLoop:	moveq	#0,d4
	move.l	d3,d5
	mulu.l	d7,d5
NewVolTabInLoop:	move.l	d4,d0
	lsl.w	#8,d0
	ext.l	d0
	muls.l	d5,d6:d0
	divs.l	d2,d6:d0
	move.l	d0,(a0)+
	addq.b	#1,d4
	bcc.s	NewVolTabInLoop
	addq.b	#1,d3
	bcc.s	NewVolTabOutLoop
ChgVolTableDone:	move.l	extb_TuComposerBase(a6),a6
	move.l	a6,a3
	move.l	4(sp),d0
	cmp.w	lqmas_Channels(a5),d0
	beq.s	NewNotAllocNewChInfo2
	move.w	d4,d5
	move.l	4.w,a6
	jsr	_LVODisable(a6)
	move.l	lqmas_ChInfo(a5),a0
	move.l	a4,a1
	cmp.w	lqmas_Channels(a5),d5
	bcs.s	CopyNewChInfo
	move.w	lqmas_Channels(a5),d5
CopyNewChInfo:	mulu.w	#chi_SIZEOF/4,d5
CopyNewChInfoLoop:	move.l	(a0)+,(a1)+
	subq.l	#1,d5
	bne.s	CopyNewChInfoLoop
	move.w	lqmas_Channels(a5),d3
	mulu.w	#chi_SIZEOF,d3
	move.l	lqmas_ChInfo(a5),a2
	move.l	a4,lqmas_ChInfo(a5)
	move.w	d4,lqmas_Channels(a5)
	jsr	_LVOEnable(a6)
	move.l	d3,d0
	move.l	a2,a1
	move.l	a3,a6
	jsr	_LVOFreePMem(a6)
NewNotAllocNewChInfo2:	move.w	lqmas_Channels(a5),d4
	move.l	lqmas_ChInfo(a5),a2
	move.l	4.w,a6
	jsr	_LVODisable(a6)
CorrectNewChInfo:	move.l	chi_SampleRate(a2),d0
	move.l	a2,a1
	bsr	SetSmpMixRate
	lea	chi_SIZEOF(a2),a2
	subq.w	#1,d4
	bne.s	CorrectNewChInfo
	jsr	_LVOEnable(a6)
	moveq	#0,d0
	movem.l	(sp)+,d2-d7/a2-a6
	rts
AllocChInfoErr:	movem.l	(sp)+,d2-d7/a2-a6
	moveq	#ERROR_EXTLIB_MIXNOALLOC,d0
	rts

	cnop	0,4

GetLQChannel:	cmp.w	lqmas_Channels(a1),d0
	bhs.s	GetLQInvalid
	mulu.w	#chi_SIZEOF,d0
	move.l	lqmas_ChInfo(a1),a1
	add.l	d0,a1
	move.l	chi_Offset(a1),(a0)
	move.l	chi_BitDepth(a1),ms_BitDepth(a0)
	move.l	(a1),ms_SampleData(a0)
	move.l	chi_SampleLen(a1),ms_SampleLen(a0)
	movem.l	chi_Repeat(a1),d0-d1
	movem.l	d0-d1,ms_Repeat(a0)
	movem.l	chi_CountRestart(a1),d0-d1
	movem.l	d0-d1,ms_RepCount(a0)
	move.l	chi_SampleRate(a1),ms_SampleRate(a0)
GetLQInvalid:	rts

	cnop	0,4

SetLQChannel:	cmp.w	lqmas_Channels(a1),d0
	bhs.s	GetLQInvalid
	move.l	a5,-(sp)
	move.l	a1,a5
	mulu.w	#chi_SIZEOF,d0
	move.l	lqmas_ChInfo(a1),a1
	add.l	d0,a1
SetLQCh:	clr.l	chi_NewSampleStartAdr(a1)
	btst	#MSB_Synth,ms_Flags(a0)
	beq.s	NotSetLQChSynth
	bset	#MSB_Synth,chi_Flags(a1)
	lea	chi_NewSampleStartAdr(a1),a1
NotSetLQChSynth:	move.l	(a0),chi_Offset(a1)
	clr.l	chi_Fraction(a1)
	move.l	ms_BitDepth(a0),chi_BitDepth(a1)
	move.l	ms_SampleData(a0),(a1)
	move.l	ms_SampleLen(a0),chi_SampleLen(a1)
	movem.l	ms_Repeat(a0),d0-d1
	movem.l	d0-d1,chi_Repeat(a1)
	btst	#MSB_Loop,chi_Flags(a1)
	bne.s	SetLoopCh
	move.l	ms_SampleLen(a0),d0
	moveq	#0,d1
SetLoopCh:	add.l	d1,d0
	btst	#MSB_Backwards,chi_Flags(a1)
	beq.s	NotBackwards
	sub.l	d1,d0
	btst	#MSB_Loop,chi_Flags(a1)
	bne.s	NotBackwards
	moveq	#-1,d0
NotBackwards:	movem.l	d0-d1,chi_EndOffset(a1)
	movem.l	ms_RepCount(a0),d0-d1
	movem.l	d0-d1,chi_CountRestart(a1)
	move.l	ms_SampleRate(a0),d0
SetSmpMixSave:	move.l	d0,chi_SampleRate(a1)
	move.l	lqmas_MixRate(a5),d1
	move.l	d2,-(sp)
	divul.l	d1,d2:d0
	cmp.l	#$10000,d0
	blo.s	SmpRateOk
	moveq	#-1,d0
SmpRateOk:	move.w	d0,chi_Advance+2(a1)
	moveq	#0,d0
	exg	d1,d2
	bsr	DIVU64
	move.l	(sp)+,d2
	swap	d0
	move.w	d0,chi_AdvFract+2(a1)
AdvOk:	move.l	chi_Advance(a1),d1
	moveq	#0,d0
	move.b	chi_BitDepth(a1),d0
	mulu.l	d0,d1
	move.l	d1,chi_RealAdv(a1)
	btst	#MSB_Muted,chi_Flags(a1)
	bne.s	ChannelMuted
Check0Vol:	move.b	chi_Volume(a1),d0
	bne.s	Not0Vol
ChannelMuted:	lea	Mixr_Skip(pc),a0
	bra.s	mstv_Set
SetSmpMixRate:	move.l	a5,-(sp)
	bra.s	SetSmpMixSave
Not0Vol:	tst.b	lqmas_Stereo(a5)
	bne.s	mstv_Stereo
	lea	Mixr_Mono(pc),a0
	bra.s	mstv_Set
mstv_Stereo:	btst	#MSB_Surround,chi_Flags(a1)
	beq.s	mstv_NoSurround
	move.b	#$80,d1
	move.w	mas_LeftVolume(a5),a0
	cmp.w	mas_RightVolume(a5),a0
	bne.s	mstv_NoCenter
	lea	Mixr_StereoSur(pc),a0
	bra.s	mstv_Set
mstv_NoSurround:	moveq	#0,d1
	move.b	chi_Panning(a1),d1
	bne.s	mstv_NoLeftPan
ChannelLeft:	lea	Mixr_StereoL(pc),a0
	tst.w	mas_LeftVolume(a5)
	beq.s	ChannelMuted
	bra.s	mstv_Set
mstv_NoLeftPan:	cmp.b	#$ff,d1
	bne.s	mstv_NoRightPan
ChannelRight:	lea	Mixr_StereoR(pc),a0
	tst.w	mas_RightVolume(a5)
	beq.s	ChannelMuted
	bra.s	mstv_Set
mstv_NoRightPan:	cmp.b	#$80,d1
	bne.s	mstv_NoCenter
	move.w	mas_LeftVolume(a5),a0
	cmp.w	mas_RightVolume(a5),a0
	bne.s	mstv_NoCenter
	lea	Mixr_StereoC(pc),a0
	bra.s	mstv_Set
mstv_NoCenter:	lea	Mixr_Stereo(pc),a0
mstv_Set:	cmp.b	#9,chi_BitDepth(a1)
	bcs.s	NoReal16Bit
	move.w	lqmas_Interpolation(a5),ccr
	bne.s	DoReal16Bit
NoReal16Bit:	lea	Mixr_Skip168-Mixr_Skip(a0),a0
DoReal16Bit:	pea	PopLQStack(pc)
	cmp.b	#16,chi_BitDepth(a1)
	beq.s	mstv_Set16
	cmp.b	#32,chi_BitDepth(a1)
	beq.s	mstv_Set32
	cmp.b	#8,chi_BitDepth(a1)
	bne	mstv_SetX
	btst	#MSB_Backwards,chi_Flags(a1)
	bne.s	mstv_Set8B
	move.l	12(a0),chi_MixRoutine(a1)
	move.l	28(a0),chi_AltMixRoutine(a1)
	move.l	(a0),a0
	jmp	(a0)
mstv_Set8B:	move.l	12(a0),chi_AltMixRoutine(a1)
	move.l	28(a0),chi_MixRoutine(a1)
	move.l	(a0),a0
	jmp	(a0)
mstv_Set16:	btst	#MSB_Backwards,chi_Flags(a1)
	bne.s	mstv_Set16B
	move.l	16(a0),chi_MixRoutine(a1)
	move.l	32(a0),chi_AltMixRoutine(a1)
	move.l	4(a0),a0
	jmp	(a0)
mstv_Set16B:	move.l	32(a0),chi_MixRoutine(a1)
	move.l	16(a0),chi_AltMixRoutine(a1)
	move.l	4(a0),a0
	jmp	(a0)
mstv_Set32:	btst	#MSB_Backwards,chi_Flags(a1)
	bne.s	mstv_Set32B
	move.l	20(a0),chi_MixRoutine(a1)
	move.l	36(a0),chi_AltMixRoutine(a1)
	move.l	8(a0),a0
	jmp	(a0)
mstv_Set32B:	move.l	36(a0),chi_MixRoutine(a1)
	move.l	20(a0),chi_AltMixRoutine(a1)
	move.l	8(a0),a0
	jmp	(a0)
mstv_SetX:	btst	#MSB_Backwards,chi_Flags(a1)
	bne.s	mstv_SetXB
	move.l	40(a0),chi_MixRoutine(a1)
	move.l	24(a0),chi_AltMixRoutine(a1)
	move.l	8(a0),a0
	jmp	(a0)
mstv_SetXB:	move.l	40(a0),chi_MixRoutine(a1)
	move.l	24(a0),chi_AltMixRoutine(a1)
	move.l	8(a0),a0
	jmp	(a0)
PopLQStack:	move.l	(sp)+,a5
SetLQInvalid:	rts

	cnop	0,4

SetLQChannelVol:	cmp.w	lqmas_Channels(a1),d0
	bhs.s	SetLQInvalid
	mulu.w	#chi_SIZEOF,d0
	move.l	a5,-(sp)
	move.l	a1,a5
	move.l	lqmas_ChInfo(a1),a1
	add.l	d0,a1
	move.w	ms_Volume(a0),d0
	cmp.w	chi_Volume(a1),d0
	beq.s	NoVolChange
	move.w	d0,chi_Volume(a1)
	move.w	d0,chi_NewVolume(a1)
	move.l	ms_SampleRate(a0),d0
	move.l	d0,chi_SampleRate(a1)
	move.l	d0,chi_NewSampleRate(a1)
	move.l	lqmas_MixRate(a5),d1
	move.l	d2,-(sp)
	divul.l	d1,d2:d0
	move.w	d0,chi_Advance+2(a1)
	move.w	d0,chi_NewAdvance+2(a1)
	moveq	#0,d0
	exg	d1,d2
	bsr	DIVU64
	move.l	(sp)+,d2
	swap	d0
	move.w 	d0,chi_AdvFract+2(a1)
	move.w	d0,chi_NewAdvFract+2(a1)
	move.l	chi_Advance(a1),d1
	moveq	#0,d0
	move.b	chi_BitDepth(a1),d0
	mulu.l	d0,d1
	move.l	d1,chi_RealAdv(a1)
	move.l	d1,chi_NewRealAdv(a1)
	pea	AdvOk2(pc)
	move.l	a5,-(sp)
	bra	AdvOk
AdvOk2:	lea	chi_NewSampleStartAdr(a1),a1
	bra	AdvOk
NoVolChange:	move.l	ms_SampleRate(a0),d0
	move.l	d0,chi_SampleRate(a1)
	move.l	d0,chi_NewSampleRate(a1)
	move.l	lqmas_MixRate(a5),d1
	move.l	d2,-(sp)
	divul.l	d1,d2:d0
	move.w	d0,chi_Advance+2(a1)
	move.w	d0,chi_NewAdvance+2(a1)
	moveq	#0,d0
	exg	d1,d2
	bsr	DIVU64
	move.l	(sp)+,d2
	swap	d0
	move.w 	d0,chi_AdvFract+2(a1)
	move.w	d0,chi_NewAdvFract+2(a1)
	move.l	chi_Advance(a1),d1
	moveq	#0,d0
	move.b	chi_BitDepth(a1),d0
	mulu.l	d0,d1
	move.l	d1,chi_RealAdv(a1)
	move.l	d1,chi_NewRealAdv(a1)
	move.l	(sp)+,a5
SetLQInvalid2:	rts

	cnop	0,4

SetLQChannelPos:	cmp.w	lqmas_Channels(a1),d0
	bhs.s	SetLQInvalid2
	mulu.w	#chi_SIZEOF,d0
	move.l	a5,-(sp)
	move.l	a1,a5
	move.l	lqmas_ChInfo(a1),a1
	add.l	d0,a1
	move.b	ms_Flags(a0),d0
	cmp.b	chi_Flags(a1),d0
	beq.s	NoChangeFlags
	move.b	d0,chi_Flags(a1)
	move.l	(a0),d0
	cmp.l	chi_Offset(a1),d0
	beq.s	NotChgOffset
	move.l	d0,chi_Offset(a1)
	clr.l	chi_Fraction(a1)
NotChgOffset:	movem.l	ms_Repeat(a0),d0-d1
	movem.l	d0-d1,chi_Repeat(a1)
	btst	#MSB_Loop,chi_Flags(a1)
	bne.s	SetLoopCh2
	move.l	ms_SampleLen(a0),d0
	moveq	#0,d1
SetLoopCh2:	add.l	d1,d0
	btst	#MSB_Backwards,chi_Flags(a1)
	beq.s	NotBackwards2
	sub.l	d1,d0
	btst	#MSB_Loop,chi_Flags(a1)
	bne.s	NotBackwards2
	moveq	#-1,d0
NotBackwards2:	movem.l	d0-d1,chi_EndOffset(a1)
	movem.l	ms_RepCount(a0),d0-d1
	movem.l	d0-d1,chi_CountRestart(a1)
	bra	AdvOk
NoChangeFlags:	move.l	(a0),d0
	cmp.l	chi_Offset(a1),d0
	beq.s	NoChgNotChgOffset
	move.l	d0,chi_Offset(a1)
	clr.l	chi_Fraction(a1)
NoChgNotChgOffset:	movem.l	ms_Repeat(a0),d0-d1
	movem.l	d0-d1,chi_Repeat(a1)
	btst	#MSB_Loop,chi_Flags(a1)
	bne.s	NoChgSetLoopCh2
	move.l	ms_SampleLen(a0),d0
	moveq	#0,d1
NoChgSetLoopCh2:	add.l	d1,d0
	btst	#MSB_Backwards,chi_Flags(a1)
	beq.s	NoChgNotBackwards2
	sub.l	d1,d0
	btst	#MSB_Loop,chi_Flags(a1)
	bne.s	NoChgNotBackwards2
	moveq	#-1,d0
NoChgNotBackwards2:	movem.l	d0-d1,chi_EndOffset(a1)
	movem.l	ms_RepCount(a0),d0-d1
	movem.l	d0-d1,chi_CountRestart(a1)
	move.l	(sp)+,a5
	rts

	cnop	0,4

DoLQMix:	move.l	extb_TuComposerBase(a6),d0
	movem.l	d0/d2-d5/a0/a2/a5-a6,-(sp)
	move.l	a0,a6
	movem.l	lqmas_CurrLeft(a6),d3/d5
	move.l	lqmas_BuffSize(a6),d4
	move.l	d4,d0
	moveq	#0,d1
	move.l	a2,a0
	tst.b	lqmas_Stereo(a6)
	bne.s	ClearBuff
	lsr.l	#1,d0
	bcc.s	ClearBuff
	move.l	d1,(a0)+
ClrLoop:	move.l	d1,(a0)+
	move.l	d1,(a0)+
ClearBuff:	dbra	d0,ClrLoop
DM_Loop:	tst.l	d4
	beq.s	DM_Exit
	tst.l	d3
	beq.s	DM_NoMix
	move.l	d4,d2
	cmp.l	d3,d4
	bls.s	NoMin
	move.l	d3,d2
NoMin:	move.l	a2,a1
	sub.l	d2,d3
	sub.l	d2,d4
	bsr.s	MixSample
	tst.b	lqmas_Stereo(a6)
	beq.s	DM_Mono
	add.l	d2,d2
DM_Mono:	add.l	d2,d2
	add.l	d2,d2
	add.l	d2,a2
DM_NoMix:	tst.l	d3
	bne.s	DM_Loop
	move.l	(sp),a0
	jsr	_LVODoPlayerIRQ(a0)
	move.l	lqmas_PassLength(a6),d3
	add.l	lqmas_PassFrac(a6),d5
	bcc.s	DM_Loop
	addq.l	#1,d3
	bra.s	DM_Loop
DM_Exit:	movem.l	d3/d5,lqmas_CurrLeft(a6)
	lea	mas_PostProcs(a6),a5
CallPostProcs:	move.l	(a5),a5
	tst.l	(a5)
	beq.s	CallPostProcsDone
	move.l	a5,a0
	move.l	24(sp),a2
	move.l	pas_PostProcLibBase(a5),a6
	jsr	_LVOExternalPostProcDoMix(a6)
	bra.s	CallPostProcs
CallPostProcsDone:	movem.l	(sp)+,d0/d2-d5/a0/a2/a5-a6
	rts

	cnop	0,4

MixSample:	movem.l	d2-d7/a2-a6,-(sp)
	move.w	lqmas_Channels(a6),d7
	move.l	lqmas_ChInfo(a6),a5
	subq.w	#1,d7
MixSmp_ChLoop:	tst.b	chi_Flags(a5)
	bpl	MixSmp_ChLoopEnd
	movem.l	chi_MixRegs(a5),d2/d4-d6/a4
	move.l	(sp),d3
	move.l	a1,a2
	btst	#MSB_Backwards,chi_Flags(a5)
	bne	MixSmp_Backwards
MixSmp_Loop2:	move.l	d5,d1
	ext.l	d3
	swap	d1
	move.w	d6,d1
	move.l	d3,d0
	bsr	MULU64
	exg	d0,d1
	add.l	d4,d1
	move.w	d0,d1
	swap	d1
	move.l	chi_EndOffset(a5),d0
	sub.l	d2,d0
	ble.s	MixSmp_SmpEnd
	cmp.l	d0,d1
	bhs.s	MixSmp_CalcSize
	move.w	d3,d0
	jsr	(a4)
	cmp.l	chi_EndOffset(a5),d2
	blo.s	MixSmp_SaveReg
	moveq	#0,d3
	bra.s	MixSmp_SmpEnd
MixSmp_CalcSize:	swap	d0
	clr.w	d0
	sub.l	d4,d0
	subq.l	#1,d0
	move.w	d5,d1
	swap	d1
	move.w	d6,d1
	divu.l	d1,d0
	addq.w	#1,d0
	sub.w	d0,d3
	jsr	(a4)
	cmp.l	chi_EndOffset(a5),d2
	bhs.s	MixSmp_SmpEnd
	tst.w	d3
	beq.s	MixSmp_SaveReg
MixSmp_SmpEnd:	btst	#MSB_Loop,chi_Flags(a5)
	beq.s	MixSmp_StopChan
	move.l	chi_Counted(a5),d0
	addq.l	#1,chi_Counted(a5)
	move.l	chi_CountRestart(a5),d1
	beq.s	MixSmp_NotCountRepeat
	cmp.l	d1,d0
	beq.s	MixSmp_CountRepeatDone
MixSmp_NotCountRepeat:	btst	#MSB_Pingpong,chi_Flags(a5)
	bne.s	MixSmp_Pingpong
	sub.l	chi_RestartOffset(a5),d2
	move.l	chi_NewSampleStartAdr(a5),d0
	beq.s	MixSmp_LoopEnd
MixSmp_Synth:	bsr	MixSmp_SetSynth
MixSmp_LoopEnd:	tst.w	d3
	bgt	MixSmp_Loop2
	bra.s	MixSmp_SaveReg
MixSmp_StopChan:	move.l	chi_NewSampleStartAdr(a5),d0
	bne.s	MixSmp_Synth
	bclr	#MSB_Play,chi_Flags(a5)
MixSmp_SaveReg:	movem.l	d2/d4,chi_MixRegs(a5)
MixSmp_ChLoopEnd:	lea	chi_SIZEOF(a5),a5
	dbra	d7,MixSmp_ChLoop
	movem.l	(sp)+,d2-d7/a2-a6
	rts
MixSmp_CountRepeatDone:	bclr	#MSB_Loop,chi_Flags(a5)
	move.l	chi_SampleLen(a5),chi_EndOffset(a5)
	bra.s	MixSmp_Synth
MixSmp_Pingpong:	move.l	chi_NewSampleStartAdr(a5),d0
	beq.s	MixSmp_NotNewWave
	bsr	MixSmp_SetSynth
MixSmp_NotNewWave:	move.l	chi_AltMixRoutine(a5),d0
	move.l	a4,chi_AltMixRoutine(a5)
	move.l	d0,a4
	move.l	d0,chi_MixRoutine(a5)
	bchg	#MSB_Backwards,chi_Flags(a5)
	move.l	chi_EndOffset(a5),d0
	sub.l	d0,d2
	neg.l	d2
	add.l	d0,d2
	sub.l	chi_RestartOffset(a5),d0
	move.l	d0,chi_EndOffset(a5)
	tst.w	d3
	beq.s	MixSmp_SaveReg
MixSmp_Backwards:	
MixSmpB_Loop2:	move.l	d5,d1
	ext.l	d3
	swap	d1
	move.w	d6,d1
	move.l	d3,d0
	bsr	MULU64
	exg	d0,d1
	move.w	d0,d1
	swap	d1
	move.l	d2,d0
	sub.l	chi_EndOffset(a5),d0
	ble.s	MixSmpB_SmpEnd
	cmp.l	d0,d1
	bhs.s	MixSmpB_CalcSize
	move.w	d3,d0
	jsr	(a4)
	cmp.l	chi_EndOffset(a5),d2
	bgt.s	MixSmp_SaveReg
	moveq	#0,d3
	bra.s	MixSmpB_SmpEnd
MixSmpB_CalcSize:	swap	d0
	clr.w	d0
	sub.l	d4,d0
	subq.l	#1,d0
	move.w	d5,d1
	swap	d1
	move.w	d6,d1
	divu.l	d1,d0
	addq.w	#1,d0
	sub.w	d0,d3
	jsr	(a4)
	cmp.l	chi_EndOffset(a5),d2
	ble.s	MixSmpB_SmpEnd
	tst.w	d3
	beq	MixSmp_SaveReg
MixSmpB_SmpEnd:	btst	#MSB_Loop,chi_Flags(a5)
	beq	MixSmp_StopChan
	move.l	chi_Counted(a5),d1
	addq.l	#1,chi_Counted(a5)
	move.l	chi_CountRestart(a5),d0
	beq.s	MixSmpB_NotCountRepeat
	cmp.l	d1,d0
	beq.s	MixSmpB_CountRepeatDone
MixSmpB_NotCountRepeat:	btst	#MSB_Pingpong,chi_Flags(a5)
	bne.s	MixSmp_Pingpong2
	add.l	chi_RestartOffset(a5),d2
	move.l	chi_NewSampleStartAdr(a5),d0
	bne	MixSmp_Synth
MixSmpB_LoopEnd2:	tst.w	d3
	bgt	MixSmpB_Loop2
	bra	MixSmp_SaveReg
MixSmpB_CountRepeatDone:	bclr	#MSB_Loop,chi_Flags(a5)
	moveq	#-1,d0
	move.l	d0,chi_EndOffset(a5)
	bra	MixSmp_Synth
MixSmp_Pingpong2:	move.l	chi_NewSampleStartAdr(a5),d0
	beq.s	MixSmpB_NotNewWave
	bsr.s	MixSmp_SetSynth
MixSmpB_NotNewWave:	move.l	chi_AltMixRoutine(a5),d0
	move.l	a4,chi_AltMixRoutine(a5)
	move.l	d0,a4
	move.l	d0,chi_MixRoutine(a5)
	bchg	#MSB_Backwards,chi_Flags(a5)
	move.l	chi_EndOffset(a5),d0
	sub.l	d0,d2
	neg.l	d2
	add.l	d0,d2
	add.l	chi_RestartOffset(a5),d0
	move.l	d0,chi_EndOffset(a5)
	tst.w	d3
	bgt	MixSmp_Loop2
	bra	MixSmp_SaveReg
MixSmp_SetSynth:	move.l	a1,d0
	lea	chi_NewSampleStartAdr(a5),a0
	move.l	a5,a1
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0),(a1)
	move.l	d0,a1
	clr.l	chi_NewSampleStartAdr(a5)
	rts

	cnop	0,4

Skip:	move.w	d5,d1
	swap	d1
	move.w	d6,d1
	ext.l	d0
	bsr	MULU64
	exg	d0,d1
	add.w	d1,d4
	move.w	d0,d1
	swap	d1
	addx.l	d1,d2
	rts

	cnop	0,4

Skipb:	move.w	d5,d1
	swap	d1
	move.w	d6,d1
	ext.l	d0
	bsr	MULU64
	exg	d0,d1
	add.w	d1,d4
	move.w	d0,d1
	swap	d1
	subx.l	d1,d2
	rts

	cnop	0,4

mstv_Stereo8:	move.l	d2,-(sp)
	move.w	#255,d2
	sub.w	d1,d2
	mulu.w	mas_LeftVolume(a5),d2
	mulu.w	d0,d2
	lsr.l	#8,d2
	clr.b	d2
	add.l	d2,d2
	add.l	d2,d2
	move.l	lqmas_VolTable(a5),a0
	add.l	a0,d2
	move.l	d2,chi_VolTable_L(a1)
	mulu.w	mas_RightVolume(a5),d1
	mulu.w	d0,d1
	lsr.l	#8,d1
	clr.b	d1
	add.l	d1,d1
	add.l	d1,d1
	add.l	d1,a0
	move.l	a0,chi_VolTable_R(a1)
	move.l	(sp)+,d2
mstv_Skip:	rts

	cnop	0,4

mstv_Stereo8L:	mulu.w	mas_LeftVolume(a5),d0
	clr.b	d0
	move.l	lqmas_VolTable(a5),a0
	add.l	d0,d0
	add.l	d0,d0
	add.l	d0,a0
	move.l	a0,chi_VolTable_L(a1)
	rts

	cnop	0,4

mstv_Stereo8R:	mulu.w	mas_RightVolume(a5),d0
	clr.b	d0
	move.l	lqmas_VolTable(a5),a0
	add.l	d0,d0
	add.l	d0,d0
	add.l	d0,a0
	move.l	a0,chi_VolTable_R(a1)
	rts

	cnop	0,4

mstv_Stereo8C:	mulu.w	mas_LeftVolume(a5),d0
	lsr.w	#1,d0
	clr.b	d0
	move.l	lqmas_VolTable(a5),a0
	add.l	d0,d0
	add.l	d0,d0
	add.l	d0,a0
	move.l	a0,chi_VolTable_L(a1)
	rts

	cnop	0,4

mstv_Stereo16:	movem.l	d2-d3,-(sp)
	move.w	#255,d3
	sub.w	d1,d3
	mulu.w	mas_LeftVolume(a5),d3
	mulu.w	d0,d3
	clr.w	d3
	swap	d3
	mulu.l	lqmas_Amplify(a5),d3
	move.l	d3,chi_Multiply_L(a1)
	mulu.w	mas_RightVolume(a5),d1
	mulu.w	d0,d1
	clr.w	d1
	swap	d1
	mulu.l	lqmas_Amplify(a5),d1
	move.l	d1,chi_Multiply_R(a1)
	moveq	#0,d1
	move.w	lqmas_Channels(a5),d1
	lsl.l	#8,d1
	move.l	d1,chi_Divider(a1)
	movem.l	(sp)+,d2-d3
	rts

	cnop	0,4

mstv_Stereo16L:	mulu.w	mas_LeftVolume(a5),d0
	lsr.w	#8,d0
	mulu.l	lqmas_Amplify(a5),d0
	move.l	d0,chi_Multiply_L(a1)
	move.w	lqmas_Channels(a5),d1
	lsl.l	#8,d1
	move.l	d1,chi_Divider(a1)
	rts

	cnop	0,4

mstv_Stereo16R:	mulu.w	mas_RightVolume(a5),d0
	lsr.w	#8,d0
	mulu.l	lqmas_Amplify(a5),d0
	move.l	d0,chi_Multiply_R(a1)
	move.w	lqmas_Channels(a5),d1
	lsl.l	#8,d1
	move.l	d1,chi_Divider(a1)
	rts

	cnop	0,4

mstv_Stereo16C:	mulu.w	mas_LeftVolume(a5),d0
	moveq	#9,d1
	lsr.w	d1,d0
	mulu.l	lqmas_Amplify(a5),d0
	move.l	d0,chi_Multiply_L(a1)
	move.w	lqmas_Channels(a5),d1
	lsl.l	#8,d1
	move.l	d1,chi_Divider(a1)
	rts

	cnop	0,4

mstv_Stereo32:	movem.l	d2-d3,-(sp)
	move.w	#255,d3
	sub.w	d1,d3
	mulu.w	mas_LeftVolume(a5),d3
	mulu.w	d0,d3
	clr.w	d3
	swap	d3
	mulu.l	lqmas_Amplify(a5),d3
	lsr.l	#8,d3
	move.l	d3,chi_Multiply_L(a1)
	mulu.w	mas_RightVolume(a5),d1
	mulu.w	d0,d1
	clr.w	d1
	swap	d1
	mulu.l	lqmas_Amplify(a5),d1
	lsr.l	#8,d3
	move.l	d1,chi_Multiply_R(a1)
	moveq	#0,d1
	move.w	lqmas_Channels(a5),d1
	swap	d1
	move.l	d1,chi_Divider(a1)
	movem.l	(sp)+,d2-d3
	rts

	cnop	0,4

mstv_Stereo32L:	mulu.w	mas_LeftVolume(a5),d0
	lsr.w	#8,d0
	mulu.l	lqmas_Amplify(a5),d0
	lsr.l	#8,d0
	move.l	d0,chi_Multiply_L(a1)
	moveq	#0,d1
	move.w	lqmas_Channels(a5),d1
	swap	d1
	move.l	d1,chi_Divider(a1)
	rts

	cnop	0,4

mstv_Stereo32R:	mulu.w	mas_RightVolume(a5),d0
	lsr.w	#8,d0
	mulu.l	lqmas_Amplify(a5),d0
	lsr.l	#8,d0
	move.l	d0,chi_Multiply_R(a1)
	moveq	#0,d1
	move.w	lqmas_Channels(a5),d1
	swap	d1
	move.l	d1,chi_Divider(a1)
	rts

	cnop	0,4

mstv_Stereo32C:	mulu.w	mas_LeftVolume(a5),d0
	moveq	#9,d1
	lsr.w	d1,d0
	mulu.l	lqmas_Amplify(a5),d0
	lsr.l	#8,d0
	move.l	d0,chi_Multiply_L(a1)
	moveq	#0,d1
	move.w	lqmas_Channels(a5),d1
	swap	d1
	move.l	d1,chi_Divider(a1)
	rts

	cnop	0,4

MIX_Mono8:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
.2:	move.b	(a6,d2.l),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	move.l	a6,a3
	add.l	d2,a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.b	(a3)+,d3
	move.l	(a0,d3.l*4),d1
.6:	add.l	d1,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	move.b	(a3)+,d3
	move.l	(a0,d3.l*4),d1
.7:	add.l	d1,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	subq.l	#1,d2
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIXb_Mono8:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
.2:	move.b	(a6,d2.l),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	lea	1(a6,d2.l),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.b	-(a3),d3
	move.l	(a0,d3.l*4),d1
.6:	add.l	d1,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	move.b	-(a3),d3
	move.l	(a0,d3.l*4),d1
.7:	add.l	d1,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	subq.l	#1,d2
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIX_Mono16:	move.l	(a5),a6
	movem.l	d3/d6-d7,-(sp)
	move.l	d6,a3
	movem.l	chi_Multiply_L(a5),d6-d7
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	add.w	a3,d4
	addx.l	d5,d2
.2:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	add.w	a3,d4
	addx.l	d5,d2
	dbra	d0,.1
	movem.l	(sp)+,d3/d6-d7
	rts
.3:	lea	(a6,d2.l*2),a0
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.w	(a0)+,d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
.6:	add.l	d1,(a2)+
	add.w	a3,d4
	bcc.s	.7
.5:	move.w	(a0)+,d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
.7:	add.l	d1,(a2)+
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#1,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts
.8:	dbra	d0,.4
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts

	cnop	0,4

MIXb_Mono16:	move.l	(a5),a6
	movem.l	d3/d6-d7,-(sp)
	move.l	d6,a3
	movem.l	chi_Multiply_L(a5),d6-d7
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	add.w	a3,d4
	subx.l	d5,d2
.2:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	add.w	a3,d4
	subx.l	d5,d2
	dbra	d0,.1
	movem.l	(sp)+,d3/d6-d7
	rts
.3:	lea	2(a6,d2.l*2),a0
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.w	-(a0),d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
.6:	add.l	d1,(a2)+
	add.w	a3,d4
	bcc.s	.7
.5:	move.w	-(a0),d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
.7:	add.l	d1,(a2)+
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts
.8:	dbra	d0,.4
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#1,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts

	cnop	0,4

MIX_Mono32:	move.l	(a5),a6
	movem.l	d3/d6-d7,-(sp)
	move.l	d6,a3
	movem.l	chi_Multiply_L(a5),d6-d7
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.l	(a6,d2.l*4),d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	add.w	a3,d4
	addx.l	d5,d2
.2:	move.l	(a6,d2.l*4),d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	add.w	a3,d4
	addx.l	d5,d2
	dbra	d0,.1
	movem.l	(sp)+,d3/d6-d7
	rts
.3:	lea	(a6,d2.l*4),a0
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.l	(a0)+,d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
.6:	add.l	d1,(a2)+
	add.w	a3,d4
	bcc.s	.7
.5:	move.l	(a0)+,d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
.7:	add.l	d1,(a2)+
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#2,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts
.8:	dbra	d0,.4
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#2,d2
	movem.l	(sp)+,d3/d6-d7
	rts

	cnop	0,4

MIXb_Mono32:	move.l	(a5),a6
	movem.l	d3/d6-d7,-(sp)
	move.l	d6,a3
	movem.l	chi_Multiply_L(a5),d6-d7
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.l	(a6,d2.l*4),d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	add.w	a3,d4
	subx.l	d5,d2
.2:	move.w	(a6,d2.l*4),d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	add.w	a3,d4
	subx.l	d5,d2
	dbra	d0,.1
	movem.l	(sp)+,d3/d6-d7
	rts
.3:	lea	4(a6,d2.l*4),a0
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.l	-(a0),d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
.6:	add.l	d1,(a2)+
	add.w	a3,d4
	bcc.s	.7
.5:	move.l	-(a0),d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
.7:	add.l	d1,(a2)+
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#2,d2
	movem.l	(sp)+,d3/d6-d7
	rts
.8:	dbra	d0,.4
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#2,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts

	cnop	0,4

MIX_MonoX:	move.l	(a5),a6
	movem.l	d3/d5-d7,-(sp)
	move.l	d6,a0
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	move.l	chi_Divider(a5),d7
	move.l	chi_RealAdv(a5),d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	add.l	d5,d2
	add.w	a0,d4
	bcc.s	.2
	add.l	d6,d2
.2:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	add.l	d5,d2
	add.w	a0,d4
	bcc.s	.9
	add.l	d6,d2
.9:	dbra	d0,.1
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts
.3:	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d6,d2
.6:	add.l	d1,(a2)+
	add.w	a0,d4
	bcc.s	.7
.5:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d6,d2
.7:	add.l	d1,(a2)+
	add.w	a0,d4
	bcs.s	.8
	dbra	d0,.6
	divu.l	d6,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d5-d7
	rts
.8:	dbra	d0,.4
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts

	cnop	0,4

MIXb_MonoX:	move.l	(a5),a6
	movem.l	d3/d5-d7,-(sp)
	move.l	d6,a0
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	move.l	chi_Divider(a5),d7
	move.l	chi_RealAdv(a5),d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	sub.l	d5,d2
	add.w	a0,d4
	bcc.s	.2
	sub.l	d6,d2
.2:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	sub.l	d5,d2
	add.w	a0,d4
	bcc.s	.9
	sub.l	d6,d2
.9:	dbra	d0,.1
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts
.3:	add.l	d6,d2
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	sub.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
.6:	add.l	d1,(a2)+
	add.w	a0,d4
	bcc.s	.7
.5:	sub.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
.7:	add.l	d1,(a2)+
	add.w	a0,d4
	bcs.s	.8
	dbra	d0,.6
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts
.8:	dbra	d0,.4
	divu.l	d6,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d5-d7
	rts

	cnop	0,4

MIX_Mono168:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l*2),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
.2:	move.b	(a6,d2.l*2),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	lea	(a6,d2.l*2),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.b	(a3),d3
	addq.l	#2,a3
	move.l	(a0,d3.l*4),d1
.6:	add.l	d1,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	move.b	(a3),d3
	addq.l	#2,a3
	move.l	(a0,d3.l*4),d1
.7:	add.l	d1,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#1,d2
	subq.l	#1,d2
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#1,d2
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIXb_Mono168:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l*2),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
.2:	move.b	(a6,d2.l*2),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	lea	2(a6,d2.l*2),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	subq.l	#2,a3
	move.b	(a3),d3
	move.l	(a0,d3.l*4),d1
.6:	add.l	d1,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	subq.l	#2,a3
	move.b	(a3),d3
	move.l	(a0,d3.l*4),d1
.7:	add.l	d1,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#1,d2
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#1,d2
	subq.l	#1,d2
	move.w	(sp)+,d3
	rts
	cnop	0,4

MIX_Mono328:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l*4),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
.2:	move.b	(a6,d2.l*4),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	lea	(a6,d2.l*4),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.b	(a3),d3
	addq.l	#4,a3
	move.l	(a0,d3.l*4),d1
.6:	add.l	d1,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	move.b	(a3),d3
	addq.l	#4,a3
	move.l	(a0,d3.l*4),d1
.7:	add.l	d1,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#2,d2
	subq.l	#1,d2
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#2,d2
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIXb_Mono328:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l*4),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
.2:	move.b	(a6,d2.l*4),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	lea	4(a6,d2.l*4),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	subq.l	#4,a3
	move.b	(a3),d3
	move.l	(a0,d3.l*4),d1
.6:	add.l	d1,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	subq.l	#4,a3
	move.b	(a3),d3
	move.l	(a0,d3.l*4),d1
.7:	add.l	d1,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#2,d2
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#2,d2
	subq.l	#1,d2
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIX_MonoX8:	move.l	(a5),a6
	movem.l	d3/d5/a1,-(sp)
	move.l	d6,a1
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	moveq	#0,d3
	not.b	d3
	move.l	chi_VolTable_L(a5),a0
	move.l	chi_RealAdv(a5),d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
	add.l	d1,(a2)+
	add.l	d5,d2
	add.w	a1,d4
	bcc.s	.2
	add.l	d6,d2
.2:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
	add.l	d1,(a2)+
	add.l	d5,d2
	add.w	a1,d4
	bcc.s	.9
	add.l	d6,d2
.9:	dbra	d0,.1
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/a1
	rts
.3:	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
.6:	add.l	d1,(a2)+
	add.w	a1,d4
	bcc.s	.7
	add.l	d6,d2
.5:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
.7:	add.l	d1,(a2)+
	add.w	a1,d4
	bcs.s	.8
	dbra	d0,.6
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/a1
	rts
.8:	add.l	d6,d2
	dbra	d0,.4
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/a1
	rts

	cnop	0,4

MIXb_MonoX8:	move.l	(a5),a6
	movem.l	d3/d5/a1,-(sp)
	move.l	d6,a1
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	moveq	#0,d3
	not.b	d3
	move.l	chi_VolTable_L(a5),a0
	move.l	chi_RealAdv(a5),d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
	add.l	d1,(a2)+
	sub.l	d5,d2
	add.w	a1,d4
	bcc.s	.2
	sub.l	d6,d2
.2:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
	add.l	d1,(a2)+
	sub.l	d5,d2
	add.w	a1,d4
	bcc.s	.9
	sub.l	d6,d2
.9:	dbra	d0,.1
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/a1
	rts
.3:	add.l	d6,d2
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	sub.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
.6:	add.l	d1,(a2)+
	add.w	a1,d4
	bcc.s	.7
.5:	sub.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
.7:	add.l	d1,(a2)+
	add.w	a1,d4
	bcs.s	.8
	dbra	d0,.6
	divu.l	d6,d2
	swap	d3
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/a1
	rts
.8:	dbra	d0,.4
	divu.l	d6,d2
	subq.l	#1,d2
	swap	d3
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/a1
	rts

	cnop	0,4

MIX_Stereo8:	move.l	(a5),a6
	movem.l	chi_VolTable_L(a5),a0/a3
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	move.l	(a3,d3.l*4),d1
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
.2:	move.b	(a6,d2.l),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	move.l	(a3,d3.l*4),d1
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	movem.l	d7/a4,-(sp)
	movea.l	a6,a4
	add.l	d2,a4
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.b	(a4)+,d3
	move.l	(a0,d3.l*4),d7
	move.l	(a3,d3.l*4),d1
.6:	add.l	d7,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	move.b	(a4)+,d3
	move.l	(a0,d3.l*4),d7
	move.l	(a3,d3.l*4),d1
.7:	add.l	d7,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a4
	move.l	a4,d2
	subq.l	#1,d2
	movem.l	(sp)+,d7/a4
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a4
	move.l	a4,d2
	movem.l	(sp)+,d7/a4
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIXb_Stereo8:	move.l	(a5),a6
	movem.l	chi_VolTable_L(a5),a0/a3
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l),d3
	move.w	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	move.w	(a3,d3.l*4),d1
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
.2:	move.b	(a6,d2.l),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	move.l	(a3,d3.l*4),d1
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	movem.l	d7/a4,-(sp)
	lea	1(a6,d2.l),a4
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.b	-(a4),d3
	move.l	(a0,d3.l*4),d7
	move.l	(a3,d3.l*4),d1
.6:	add.l	d7,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	move.b	-(a4),d3
	move.l	(a0,d3.l*4),d7
	move.l	(a3,d3.l*4),d1
.7:	add.l	d7,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a4
	move.l	a4,d2
	movem.l	(sp)+,d7/a4
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a4
	move.l	a4,d2
	subq.l	#1,d2
	movem.l	(sp)+,d7/a4
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIX_Stereo16:	move.l	(a5),a6
	movem.l	d3/d6-d7,-(sp)
	move.l	d6,a3
	move.l	chi_Divider(a5),d7
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	move.l	d1,d6
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	muls.l	chi_Multiply_R(a5),d3:d6
	divs.l	d7,d3:d6
	add.l	d6,(a2)+
	add.w	a3,d4
	addx.l	d5,d2
.2:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	move.l	d1,d6
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	muls.l	chi_Multiply_R(a5),d3:d6
	divs.l	d7,d3:d6
	add.l	d6,(a2)+
	add.w	a3,d4
	addx.l	d5,d2
	dbra	d0,.1
	movem.l	(sp)+,d3/d6-d7
	rts
.3:	lea	(a6,d2.l*2),a0
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.w	(a0)+,d1
	ext.l	d1
	move.l	d1,d6
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	muls.l	chi_Multiply_R(a5),d3:d6
	divs.l	d7,d3:d6
.6:	add.l	d1,(a2)+
	add.l	d6,(a2)+
	add.w	a3,d4
	bcc.s	.7
.5:	move.w	(a0)+,d1
	ext.l	d1
	move.l	d1,d6
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	muls.l	chi_Multiply_R(a5),d3:d6
	divs.l	d7,d3:d6
.7:	add.l	d1,(a2)+
	add.l	d6,(a2)+
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#1,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts
.8:	dbra	d0,.4
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts

	cnop	0,4

MIXb_Stereo16:	move.l	(a5),a6
	movem.l	d3/d6-d7,-(sp)
	move.l	d6,a3
	move.l	chi_Divider(a5),d7
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	move.l	d1,d6
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	muls.l	chi_Multiply_R(a5),d3:d6
	divs.l	d7,d3:d6
	add.l	d6,(a2)+
	add.w	a3,d4
	subx.l	d5,d2
.2:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	move.l	d1,d6
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	muls.l	chi_Multiply_R(a5),d3:d6
	divs.l	d7,d3:d6
	add.l	d6,(a2)+
	add.w	a3,d4
	subx.l	d5,d2
	dbra	d0,.1
	movem.l	(sp)+,d3/d6-d7
	rts
.3:	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	move.l	d1,d6
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	muls.l	chi_Multiply_R(a5),d3:d6
	divs.l	d7,d3:d6
.6:	add.l	d1,(a2)+
	add.l	d6,(a2)+
	add.w	a3,d4
	bcc.s	.7
	subq.l	#1,d2
.5:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	move.l	d1,d6
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	muls.l	chi_Multiply_R(a5),d3:d6
	divs.l	d7,d3:d6
.7:	add.l	d1,(a2)+
	add.l	d6,(a2)+
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	movem.l	(sp)+,d3/d6-d7
	rts
.8:	subq.l	#1,d2
	dbra	d0,.4
	movem.l	(sp)+,d3/d6-d7
	rts

	cnop	0,4

MIX_Stereo32:	move.l	(a5),a6
	movem.l	d3/d6-d7,-(sp)
	move.l	d6,a3
	move.l	chi_Divider(a5),d7
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.l	(a6,d2.l*4),d1
	move.l	d1,d6
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	muls.l	chi_Multiply_R(a5),d3:d6
	divs.l	d7,d3:d6
	add.l	d6,(a2)+
	add.w	a3,d4
	addx.l	d5,d2
.2:	move.w	(a6,d2.l*4),d1
	move.l	d1,d6
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	muls.l	chi_Multiply_R(a5),d3:d6
	divs.l	d7,d3:d6
	add.l	d6,(a2)+
	add.w	a3,d4
	addx.l	d5,d2
	dbra	d0,.1
	movem.l	(sp)+,d3/d6-d7
	rts
.3:	lea	(a6,d2.l*4),a0
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.l	(a0)+,d1
	move.l	d1,d6
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	muls.l	chi_Multiply_R(a5),d3:d6
	divs.l	d7,d3:d6
.6:	add.l	d1,(a2)+
	add.l	d6,(a2)+
	add.w	a3,d4
	bcc.s	.7
.5:	move.l	(a0)+,d1
	move.l	d1,d6
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	muls.l	chi_Multiply_R(a5),d3:d6
	divs.l	d7,d3:d6
.7:	add.l	d1,(a2)+
	add.l	d6,(a2)+
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#2,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts
.8:	dbra	d0,.4
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#2,d2
	movem.l	(sp)+,d3/d6-d7
	rts

	cnop	0,4

MIXb_Stereo32:	move.l	(a5),a6
	movem.l	d3/d6-d7,-(sp)
	move.l	d6,a3
	move.l	chi_Divider(a5),d7
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.l	(a6,d2.l*4),d1
	move.l	d1,d6
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	muls.l	chi_Multiply_R(a5),d3:d6
	divs.l	d7,d3:d6
	add.l	d6,(a2)+
	add.w	a3,d4
	subx.l	d5,d2
.2:	move.l	(a6,d2.l*4),d1
	move.l	d1,d6
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	muls.l	chi_Multiply_R(a5),d3:d6
	divs.l	d7,d3:d6
	add.l	d6,(a2)+
	add.w	a3,d4
	subx.l	d5,d2
	dbra	d0,.1
	movem.l	(sp)+,d3/d6-d7
	rts
.3:	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.l	(a6,d2.l*4),d1
	move.l	d1,d6
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	muls.l	chi_Multiply_R(a5),d3:d6
	divs.l	d7,d3:d6
.6:	add.l	d1,(a2)+
	add.l	d6,(a2)+
	add.w	a3,d4
	bcc.s	.7
	subq.l	#1,d2
.5:	move.l	(a6,d2.l*4),d1
	move.l	d1,d6
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	muls.l	chi_Multiply_R(a5),d3:d6
	divs.l	d7,d3:d6
.7:	add.l	d1,(a2)+
	add.l	d6,(a2)+
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	movem.l	(sp)+,d3/d6-d7
	rts
.8:	subq.l	#1,d2
	dbra	d0,.4
	movem.l	(sp)+,d3/d6-d7
	rts

	cnop	0,4

MIX_StereoX:	move.l	(a5),a6
	movem.l	d3/d5-d7,-(sp)
	move.l	d6,a3
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	move.l	chi_RealAdv(a5),d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	move.l	d1,d7
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	chi_Divider(a5),d3:d1
	add.l	d1,(a2)+
	muls.l	chi_Multiply_R(a5),d3:d7
	divs.l	chi_Divider(a5),d3:d7
	add.l	d7,(a2)+
	add.l	d5,d2
	add.w	a3,d4
	bcc.s	.2
	add.l	d6,d2
.2:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	move.l	d1,d7
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	chi_Divider(a5),d3:d1
	add.l	d1,(a2)+
	muls.l	chi_Multiply_R(a5),d3:d7
	divs.l	chi_Divider(a5),d3:d7
	add.l	d7,(a2)+
	add.l	d5,d2
	add.w	a3,d4
	bcc.s	.9
	add.l	d6,d2
.9:	dbra	d0,.1
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts
.3:	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	move.l	d1,d7
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	chi_Divider(a5),d3:d1
	muls.l	chi_Multiply_R(a5),d3:d7
	divs.l	chi_Divider(a5),d3:d7
.6:	add.l	d1,(a2)+
	add.l	d7,(a2)+
	add.w	a3,d4
	bcc.s	.7
.5:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	move.l	d1,d7
	muls.l	chi_Multiply_R(a5),d3:d1
	divs.l	chi_Divider(a5),d3:d1
	muls.l	chi_Multiply_R(a5),d3:d7
	divs.l	chi_Divider(a5),d3:d7
.7:	add.l	d1,(a2)+
	add.l	d7,(a2)+
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	divu.l	d6,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d5-d7
	rts
.8:	dbra	d0,.4
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts

	cnop	0,4

MIXb_StereoX:	move.l	(a5),a6
	movem.l	d3/d5-d7,-(sp)
	move.l	d6,a3
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	move.l	chi_RealAdv(a5),d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	move.l	d1,d7
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	chi_Divider(a5),d3:d1
	add.l	d1,(a2)+
	muls.l	chi_Multiply_R(a5),d3:d7
	divs.l	chi_Divider(a5),d3:d7
	add.l	d7,(a2)+
	sub.l	d5,d2
	add.w	a3,d4
	bcc.s	.2
	sub.l	d6,d2
.2:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	move.l	d1,d7
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	chi_Divider(a5),d3:d1
	add.l	d1,(a2)+
	muls.l	chi_Multiply_R(a5),d3:d7
	divs.l	chi_Divider(a5),d3:d7
	add.l	d7,(a2)+
	sub.l	d5,d2
	add.w	a3,d4
	bcc.s	.9
	sub.l	d6,d2
.9:	dbra	d0,.1
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts
.3:	add.l	d6,d2
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	sub.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	move.l	d1,d7
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	chi_Divider(a5),d3:d1
	muls.l	chi_Multiply_R(a5),d3:d7
	divs.l	chi_Divider(a5),d3:d7
.6:	add.l	d1,(a2)+
	add.l	d7,(a2)+
	add.w	a3,d4
	bcc.s	.7
	sub.l	d6,d2
.5:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	move.l	d1,d7
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	chi_Divider(a5),d3:d1
	muls.l	chi_Multiply_R(a5),d3:d7
	divs.l	chi_Divider(a5),d3:d7
.7:	add.l	d1,(a2)+
	add.l	d7,(a2)+
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts
.8:	sub.l	d6,d2
	dbra	d0,.4
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts

	cnop	0,4

MIX_Stereo168:	move.l	(a5),a6
	movem.l	chi_VolTable_L(a5),a0/a3
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l*2),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	move.l	(a3,d3.l*4),d1
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
.2:	move.b	(a6,d2.l*2),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	move.l	(a3,d3.l*4),d1
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	movem.l	d7/a4,-(sp)
	lea	(a6,d2.l*2),a4
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.b	(a4),d3
	addq.l	#2,a4
	move.l	(a0,d3.l*4),d7
	move.l	(a3,d3.l*4),d1
.6:	add.l	d7,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	move.b	(a4),d3
	addq.l	#2,a4
	move.l	(a0,d3.l*4),d7
	move.l	(a3,d3.l*4),d1
.7:	add.l	d7,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a4
	move.l	a4,d2
	lsr.l	#1,d2
	subq.l	#1,d2
	movem.l	(sp)+,d7/a4
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a4
	move.l	a4,d2
	lsr.l	#1,d2
	movem.l	(sp)+,d7/a4
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIXb_Stereo168:	move.l	(a5),a6
	movem.l	chi_VolTable_L(a5),a0/a3
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l*2),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	move.l	(a3,d3.l*4),d1
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
.2:	move.b	(a6,d2.l*2),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	move.l	(a3,d3.l*4),d1
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	movem.l	d7/a4,-(sp)
	lea	2(a6,d2.l*2),a4
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	subq.l	#2,a4
	move.b	(a4),d3
	move.l	(a0,d3.l*4),d7
	move.l	(a3,d3.l*4),d1
.6:	add.l	d7,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	subq.l	#2,a4
	move.b	(a4),d3
	move.l	(a0,d3.l*4),d7
	move.l	(a3,d3.l*4),d1
.7:	add.l	d7,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a4
	move.l	a4,d2
	lsr.l	#1,d2
	movem.l	(sp)+,d7/a4
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a4
	move.l	a4,d2
	lsr.l	#1,d2
	subq.l	#1,d2
	movem.l	(sp)+,d7/a4
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIX_Stereo328:	move.l	(a5),a6
	movem.l	chi_VolTable_L(a5),a0/a3
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l*4),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	move.l	(a3,d3.l*4),d1
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
.2:	move.b	(a6,d2.l*4),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	move.l	(a3,d3.l*4),d1
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	movem.l	d7/a4,-(sp)
	lea	(a6,d2.l*4),a4
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.b	(a4),d3
	addq.l	#4,a4
	move.l	(a0,d3.l*4),d7
	move.l	(a3,d3.l*4),d1
.6:	add.l	d7,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	move.b	(a4),d3
	addq.l	#4,a4
	move.l	(a0,d3.l*4),d7
	move.l	(a3,d3.l*4),d1
.7:	add.l	d7,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a4
	move.l	a4,d2
	lsr.l	#1,d2
	subq.l	#1,d2
	movem.l	(sp)+,d7/a4
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a4
	move.l	a4,d2
	lsr.l	#1,d2
	movem.l	(sp)+,d7/a4
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIXb_Stereo328:	move.l	(a5),a6
	movem.l	chi_VolTable_L(a5),a0/a3
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l*4),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	move.l	(a3,d3.l*4),d1
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
.2:	move.b	(a6,d2.l*4),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	move.l	(a3,d3.l*4),d1
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	movem.l	d7/a4,-(sp)
	lea	4(a6,d2.l*4),a4
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	subq.l	#4,a4
	move.b	(a4),d3
	move.l	(a0,d3.l*4),d7
	move.l	(a3,d3.l*4),d1
.6:	add.l	d7,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	subq.l	#4,a4
	move.b	(a4),d3
	move.l	(a0,d3.l*4),d7
	move.l	(a3,d3.l*4),d1
.7:	add.l	d7,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a4
	move.l	a4,d2
	lsr.l	#1,d2
	movem.l	(sp)+,d7/a4
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a4
	move.l	a4,d2
	lsr.l	#1,d2
	subq.l	#1,d2
	movem.l	(sp)+,d7/a4
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIX_StereoX8:	move.l	(a5),a6
	movem.l	d3/d5/d7/a1,-(sp)
	move.l	d6,a1
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	moveq	#0,d3
	not.b	d3
	movem.l	chi_VolTable_L(a5),a0/a3
	move.l	chi_RealAdv(a5),d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d7
	add.l	d7,(a2)+
	move.l	(a3,d1.l*4),d1
	add.l	d1,(a2)+
	add.l	d5,d2
	add.w	a1,d4
	bcc.s	.2
	add.l	d6,d2
.2:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d7
	add.l	d7,(a2)+
	move.l	(a3,d1.l*4),d1
	add.l	d1,(a2)+
	add.l	d5,d2
	add.w	a1,d4
	bcc.s	.9
	add.l	d6,d2
.9:	dbra	d0,.1
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d7/d5/a1
	rts
.3:	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d7
	move.l	(a3,d1.l*4),d1
.6:	add.l	d7,(a2)+
	add.l	d1,(a2)+
	add.w	a1,d4
	bcc.s	.7
.5:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d7
	move.l	(a3,d1.l*4),d1
.7:	add.l	d7,(a2)+
	add.l	d1,(a2)+
	add.w	a1,d4
	bcs.s	.8
	dbra	d0,.6
	divu.l	d6,d2
	subq.l	#1,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/d7/a1
	rts
.8:	dbra	d0,.4
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/d7/a1
	rts

	cnop	0,4

MIXb_StereoX8:	move.l	(a5),a6
	movem.l	d3/d5/d7/a1,-(sp)
	move.l	d6,a1
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	moveq	#0,d3
	not.b	d3
	movem.l	chi_VolTable_L(a5),a0/a3
	move.l	chi_RealAdv(a5),d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d7
	add.l	d7,(a2)+
	move.l	(a3,d1.l*4),d1
	add.l	d1,(a2)+
	sub.l	d5,d2
	add.w	a1,d4
	bcc.s	.2
	sub.l	d6,d2
.2:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d7
	add.l	d7,(a2)+
	move.l	(a3,d1.l*4),d1
	add.l	d1,(a2)+
	sub.l	d5,d2
	add.w	a1,d4
	bcc.s	.9
	sub.l	d6,d2
.9:	dbra	d0,.1
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/d7/a1
	rts
.3:	add.l	d6,d2
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	sub.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d7
	move.l	(a3,d1.l*4),d1
.6:	add.l	d7,(a2)+
	add.l	d1,(a2)+
	add.w	a1,d4
	bcc.s	.7
.5:	sub.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d7
	move.l	(a3,d1.l*4),d1
.7:	add.l	d7,(a2)+
	add.l	d1,(a2)+
	add.w	a1,d4
	bcs.s	.8
	dbra	d0,.6
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/d7/a1
	rts
.8:	dbra	d0,.4
	divu.l	d6,d2
	subq.l	#1,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/d7/a1
	rts

	cnop	0,4

MIX_Stereo8L:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	d6,d4
	addx.l	d5,d2
.2:	move.b	(a6,d2.l),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	d6,d4
	addx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	move.l	a6,a3
	add.l	d2,a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.b	(a3)+,d3
	move.l	(a0,d3.l*4),d1
.6:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	d6,d4
	bcc.s	.7
.5:	move.b	(a3)+,d3
	move.l	(a0,d3.l*4),d1
.7:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	subq.l	#1,d2
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIXb_Stereo8L:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	d6,d4
	subx.l	d5,d2
.2:	move.b	(a6,d2.l),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	d6,d4
	subx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	lea	1(a6,d2.l),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.b	-(a3),d3
	move.l	(a0,d3.l*4),d1
.6:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	d6,d4
	bcc.s	.7
.5:	move.b	-(a3),d3
	move.l	(a0,d3.l*4),d1
.7:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	subq.l	#1,d2
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIX_Stereo16L:	move.l	(a5),a6
	movem.l	d3/d6-d7,-(sp)
	move.l	d6,a3
	movem.l	chi_Multiply_L(a5),d6-d7
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a3,d4
	addx.l	d5,d2
.2:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a3,d4
	addx.l	d5,d2
	dbra	d0,.1
	movem.l	(sp)+,d3/d6-d7/a3
	rts
.3:	lea	(a6,d2.l*2),a0
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.w	(a0)+,d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
.6:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a3,d4
	bcc.s	.7
.5:	move.w	(a0)+,d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
.7:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#1,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts
.8:	dbra	d0,.4
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts

	cnop	0,4

MIXb_Stereo16L:	move.l	(a5),a6
	movem.l	d3/d6-d7,-(sp)
	move.l	d6,a3
	movem.l	chi_Multiply_L(a5),d6-d7
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a3,d4
	subx.l	d5,d2
.2:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a3,d4
	subx.l	d5,d2
	dbra	d0,.1
	movem.l	(sp)+,d3/d6-d7
	rts
.3:	lea	2(a6,d2.l*2),a0
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.w	-(a0),d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
.6:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a3,d4
	bcc.s	.7
.5:	move.w	-(a0),d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
.7:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts
.8:	dbra	d0,.4
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#1,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts

	cnop	0,4

MIX_Stereo32L:	move.l	(a5),a6
	movem.l	d3/d6-d7,-(sp)
	move.l	d6,a3
	movem.l	chi_Multiply_L(a5),d6-d7
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.l	(a6,d2.l*4),d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a3,d4
	addx.l	d5,d2
.2:	move.l	(a6,d2.l*4),d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a3,d4
	addx.l	d5,d2
	dbra	d0,.1
	movem.l	(sp)+,d3/d6-d7/a3
	rts
.3:	lea	(a6,d2.l*4),a0
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.l	(a0)+,d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
.6:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a3,d4
	bcc.s	.7
.5:	move.l	(a0)+,d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
.7:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#2,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts
.8:	dbra	d0,.4
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#2,d2
	movem.l	(sp)+,d3/d6-d7
	rts

	cnop	0,4

MIXb_Stereo32L:	move.l	(a5),a6
	movem.l	d3/d6-d7,-(sp)
	move.l	d6,a3
	movem.l	chi_Multiply_L(a5),d6-d7
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.l	(a6,d2.l*4),d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a3,d4
	subx.l	d5,d2
.2:	move.l	(a6,d2.l*4),d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a3,d4
	subx.l	d5,d2
	dbra	d0,.1
	movem.l	(sp)+,d3/d6-d7
	rts
.3:	lea	4(a6,d2.l*4),a0
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.l	-(a0),d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
.6:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a3,d4
	bcc.s	.7
.5:	move.l	-(a0),d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
.7:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#2,d2
	movem.l	(sp)+,d3/d6-d7
	rts
.8:	dbra	d0,.4
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#2,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts

	cnop	0,4

MIX_StereoXL:	move.l	(a5),a6
	movem.l	d3/d5-d7,-(sp)
	move.l	d6,a0
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	move.l	chi_Divider(a5),d7
	move.l	chi_RealAdv(a5),d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)
	addq.l	#8,a2
	add.l	d5,d2
	add.w	a0,d4
	bcc.s	.2
	add.l	d6,d2
.2:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)
	addq.l	#8,a2
	add.l	d5,d2
	add.w	a0,d4
	bcc.s	.9
	add.l	d6,d2
.9:	dbra	d0,.1
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts
.3:	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d6,d2
.6:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a0,d4
	bcc.s	.7
.5:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d6,d2
.7:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a0,d4
	bcs.s	.8
	dbra	d0,.6
	divu.l	d6,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d5-d7
	rts
.8:	dbra	d0,.4
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts

	cnop	0,4

MIXb_StereoXL:	move.l	(a5),a6
	movem.l	d3/d5-d7,-(sp)
	move.l	d6,a0
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	move.l	chi_Divider(a5),d7
	move.l	chi_RealAdv(a5),d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)
	addq.l	#8,a2
	sub.l	d5,d2
	add.w	a0,d4
	bcc.s	.2
	sub.l	d6,d2
.2:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)
	addq.l	#8,a2
	sub.l	d5,d2
	add.w	a0,d4
	bcc.s	.9
	sub.l	d6,d2
.9:	dbra	d0,.1
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts
.3:	add.l	d6,d2
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	sub.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
.6:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a0,d4
	bcc.s	.7
.5:	sub.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
.7:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a0,d4
	bcs.s	.8
	dbra	d0,.6
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts
.8:	dbra	d0,.4
	divu.l	d6,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d5-d7
	rts

	cnop	0,4

MIX_Stereo168L:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l*2),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	d6,d4
	addx.l	d5,d2
.2:	move.b	(a6,d2.l*2),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	d6,d4
	addx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	lea	(a6,d2.l*2),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.b	(a3),d3
	addq.l	#2,a3
	move.l	(a0,d3.l*4),d1
.6:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	d6,d4
	bcc.s	.7
.5:	move.b	(a3),d3
	addq.l	#2,a3
	move.l	(a0,d3.l*4),d1
.7:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#1,d2
	subq.l	#1,d2
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#1,d2
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIXb_Stereo168L:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l*2),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	d6,d4
	subx.l	d5,d2
.2:	move.b	(a6,d2.l*2),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	d6,d4
	subx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	lea	2(a6,d2.l*2),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	subq.l	#2,a3
	move.b	(a3),d3
	move.l	(a0,d3.l*4),d1
.6:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	d6,d4
	bcc.s	.7
.5:	subq.l	#2,a3
	move.b	(a3),d3
	move.l	(a0,d3.l*4),d1
.7:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#1,d2
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#1,d2
	subq.l	#1,d2
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIX_Stereo328L:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l*4),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	d6,d4
	addx.l	d5,d2
.2:	move.b	(a6,d2.l*4),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	d6,d4
	addx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	lea	(a6,d2.l*4),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.b	(a3),d3
	addq.l	#4,a3
	move.l	(a0,d3.l*4),d1
.6:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	d6,d4
	bcc.s	.7
.5:	move.b	(a3),d3
	addq.l	#4,a3
	move.l	(a0,d3.l*4),d1
.7:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#2,d2
	subq.l	#1,d2
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#2,d2
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIXb_Stereo328L:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l*4),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	d6,d4
	subx.l	d5,d2
.2:	move.b	(a6,d2.l*4),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	d6,d4
	subx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	lea	4(a6,d2.l*4),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	subq.l	#4,a3
	move.b	(a3),d3
	move.l	(a0,d3.l*4),d1
.6:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	d6,d4
	bcc.s	.7
.5:	subq.l	#4,a3
	move.b	(a3),d3
	move.l	(a0,d3.l*4),d1
.7:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#2,d2
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#2,d2
	subq.l	#1,d2
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIX_StereoX8L:	move.l	(a5),a6
	movem.l	d3/d5/a1,-(sp)
	move.l	d6,a1
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	moveq	#0,d3
	not.b	d3
	move.l	chi_VolTable_L(a5),a0
	move.l	chi_RealAdv(a5),d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
	add.l	d1,(a2)
	addq.l	#8,a2
	add.l	d5,d2
	add.w	a1,d4
	bcc.s	.2
	add.l	d6,d2
.2:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
	add.l	d1,(a2)
	addq.l	#8,a2
	add.l	d5,d2
	add.w	a1,d4
	bcc.s	.9
	add.l	d6,d2
.9:	dbra	d0,.1
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/a1
	rts
.3:	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
.6:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a1,d4
	bcc.s	.7
	add.l	d6,d2
.5:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
.7:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a1,d4
	bcs.s	.8
	dbra	d0,.6
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/a1
	rts
.8:	add.l	d6,d2
	dbra	d0,.4
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/a1
	rts

	cnop	0,4

MIXb_StereoX8L:	move.l	(a5),a6
	movem.l	d3/d5/a1,-(sp)
	move.l	d6,a1
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	moveq	#0,d3
	not.b	d3
	move.l	chi_VolTable_L(a5),a0
	move.l	chi_RealAdv(a5),d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
	add.l	d1,(a2)
	addq.l	#8,a2
	sub.l	d5,d2
	add.w	a1,d4
	bcc.s	.2
	sub.l	d6,d2
.2:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
	add.l	d1,(a2)
	addq.l	#8,a2
	sub.l	d5,d2
	add.w	a1,d4
	bcc.s	.9
	sub.l	d6,d2
.9:	dbra	d0,.1
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/a1
	rts
.3:	add.l	d6,d2
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	sub.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
.6:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a1,d4
	bcc.s	.7
.5:	sub.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
.7:	add.l	d1,(a2)
	addq.l	#8,a2
	add.w	a1,d4
	bcs.s	.8
	dbra	d0,.6
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/a1
	rts
.8:	dbra	d0,.4
	divu.l	d6,d2
	subq.l	#1,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/a1
	rts

	cnop	0,4

MIX_Stereo8R:	move.l	(a5),a6
	move.l	chi_VolTable_R(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l),d3
	move.l	(a0,d3.l*4),d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
.2:	move.b	(a6,d2.l),d3
	move.l	(a0,d3.l*4),d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	move.l	a6,a3
	add.l	d2,a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.b	(a3)+,d3
	move.l	(a0,d3.l*4),d1
.6:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	move.b	(a3)+,d3
	move.l	(a0,d3.l*4),d1
.7:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	subq.l	#1,d2
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIXb_Stereo8R:	move.l	(a5),a6
	move.l	chi_VolTable_R(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l),d3
	move.l	(a0,d3.l*4),d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
.2:	move.b	(a6,d2.l),d3
	move.l	(a0,d3.l*4),d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	lea	1(a6,d2.l),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.b	-(a3),d3
	move.l	(a0,d3.l*4),d1
.6:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	move.b	-(a3),d3
	move.l	(a0,d3.l*4),d1
.7:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	subq.l	#1,d2
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIX_Stereo16R:	move.l	(a5),a6
	movem.l	d3/d6-d7,-(sp)
	move.l	d6,a3
	movem.l	chi_Divider(a5),d6-d7
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	muls.l	d7,d3:d1
	divs.l	d6,d3:d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a3,d4
	addx.l	d5,d2
.2:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	muls.l	d7,d3:d1
	divs.l	d6,d3:d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a3,d4
	addx.l	d5,d2
	dbra	d0,.1
	movem.l	(sp)+,d3/d6-d7
	rts
.3:	lea	(a6,d2.l*2),a0
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.w	(a0)+,d1
	ext.l	d1
	muls.l	d7,d3:d1
	divs.l	d6,d3:d1
.6:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a3,d4
	bcc.s	.7
.5:	move.w	(a0)+,d1
	ext.l	d1
	muls.l	d7,d3:d1
	divs.l	d6,d3:d1
.7:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#1,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts
.8:	dbra	d0,.4
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts

	cnop	0,4

MIXb_Stereo16R:	move.l	(a5),a6
	movem.l	d3/d6-d7,-(sp)
	move.l	d6,a3
	movem.l	chi_Divider(a5),d6-d7
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	muls.l	d7,d3:d1
	divs.l	d6,d3:d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a3,d4
	subx.l	d5,d2
.2:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	muls.l	d7,d3:d1
	divs.l	d6,d3:d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a3,d4
	subx.l	d5,d2
	dbra	d0,.1
	movem.l	(sp)+,d3/d6-d7
	rts
.3:	lea	2(a6,d2.l*2),a0
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.w	-(a0),d1
	ext.l	d1
	muls.l	d7,d3:d1
	divs.l	d6,d3:d1
.6:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a3,d4
	bcc.s	.7
.5:	move.w	-(a0),d1
	ext.l	d1
	muls.l	d7,d3:d1
	divs.l	d6,d3:d1
.7:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts
.8:	dbra	d0,.4
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#1,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts

	cnop	0,4

MIX_Stereo32R:	move.l	(a5),a6
	movem.l	d3/d6-d7,-(sp)
	move.l	d6,a3
	movem.l	chi_Divider(a5),d6-d7
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.l	(a6,d2.l*4),d1
	muls.l	d7,d3:d1
	divs.l	d6,d3:d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a3,d4
	addx.l	d5,d2
.2:	move.l	(a6,d2.l*4),d1
	muls.l	d7,d3:d1
	divs.l	d6,d3:d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a3,d4
	addx.l	d5,d2
	dbra	d0,.1
	movem.l	(sp)+,d3/d6-d7
	rts
.3:	lea	(a6,d2.l*4),a0
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.l	(a0)+,d1
	muls.l	d7,d3:d1
	divs.l	d6,d3:d1
.6:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a3,d4
	bcc.s	.7
.5:	move.l	(a0)+,d1
	muls.l	d7,d3:d1
	divs.l	d6,d3:d1
.7:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#2,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts
.8:	dbra	d0,.4
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#2,d2
	movem.l	(sp)+,d3/d6-d7
	rts

	cnop	0,4

MIXb_Stereo32R:	move.l	(a5),a6
	movem.l	d3/d6-d7,-(sp)
	move.l	d6,a3
	movem.l	chi_Divider(a5),d6-d7
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.l	(a6,d2.l*4),d1
	muls.l	d7,d3:d1
	divs.l	d6,d3:d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a3,d4
	subx.l	d5,d2
.2:	move.l	(a6,d2.l*4),d1
	muls.l	d7,d3:d1
	divs.l	d6,d3:d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a3,d4
	subx.l	d5,d2
	dbra	d0,.1
	movem.l	(sp)+,d3/d6-d7
	rts
.3:	lea	4(a6,d2.l*4),a0
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.l	-(a0),d1
	muls.l	d7,d3:d1
	divs.l	d6,d3:d1
.6:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a3,d4
	bcc.s	.7
.5:	move.l	-(a0),d1
	muls.l	d7,d3:d1
	divs.l	d6,d3:d1
.7:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#2,d2
	movem.l	(sp)+,d3/d6-d7
	rts
.8:	dbra	d0,.4
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#2,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts

	cnop	0,4

MIX_StereoXR:	move.l	(a5),a6
	movem.l	d3/d5-d7,-(sp)
	move.l	d6,a0
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	move.l	chi_Divider(a5),d7
	move.l	chi_RealAdv(a5),d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_R(a5),d3:d1
	divs.l	d7,d3:d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	add.l	d5,d2
	add.w	a0,d4
	bcc.s	.2
	add.l	d6,d2
.2:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_R(a5),d3:d1
	divs.l	d7,d3:d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	add.l	d5,d2
	add.w	a0,d4
	bcc.s	.9
	add.l	d6,d2
.9:	dbra	d0,.1
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts
.3:	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_R(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d6,d2
.6:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a0,d4
	bcc.s	.7
.5:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_R(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d6,d2
.7:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a0,d4
	bcs.s	.8
	dbra	d0,.6
	divu.l	d6,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d5-d7
	rts
.8:	dbra	d0,.4
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts

	cnop	0,4

MIXb_StereoXR:	move.l	(a5),a6
	movem.l	d3/d5-d7,-(sp)
	move.l	d6,a0
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	move.l	chi_Divider(a5),d7
	move.l	chi_RealAdv(a5),d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_R(a5),d3:d1
	divs.l	d7,d3:d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	sub.l	d5,d2
	add.w	a0,d4
	bcc.s	.2
	sub.l	d6,d2
.2:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_R(a5),d3:d1
	divs.l	d7,d3:d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	sub.l	d5,d2
	add.w	a0,d4
	bcc.s	.9
	sub.l	d6,d2
.9:	dbra	d0,.1
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts
.3:	add.l	d6,d2
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	sub.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_R(a5),d3:d1
	divs.l	d7,d3:d1
.6:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a0,d4
	bcc.s	.7
.5:	sub.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_R(a5),d3:d1
	divs.l	d7,d3:d1
.7:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a0,d4
	bcs.s	.8
	dbra	d0,.6
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts
.8:	dbra	d0,.4
	divu.l	d6,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d5-d7
	rts

	cnop	0,4

MIX_Stereo168R:	move.l	(a5),a6
	move.l	chi_VolTable_R(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l*2),d3
	move.l	(a0,d3.l*4),d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
.2:	move.b	(a6,d2.l*2),d3
	move.l	(a0,d3.l*4),d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	lea	(a6,d2.l*2),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.b	(a3),d3
	addq.l	#2,a3
	move.l	(a0,d3.l*4),d1
.6:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	move.b	(a3),d3
	addq.l	#2,a3
	move.l	(a0,d3.l*4),d1
.7:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#1,d2
	subq.l	#1,d2
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#1,d2
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIXb_Stereo168R:	move.l	(a5),a6
	move.l	chi_VolTable_R(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l*2),d3
	move.l	(a0,d3.l*4),d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
.2:	move.b	(a6,d2.l*2),d3
	move.l	(a0,d3.l*4),d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	lea	2(a6,d2.l*2),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	subq.l	#2,a3
	move.b	(a3),d3
	move.l	(a0,d3.l*4),d1
.6:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	subq.l	#2,a3
	move.b	(a3),d3
	move.l	(a0,d3.l*4),d1
.7:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#1,d2
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#1,d2
	subq.l	#1,d2
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIX_Stereo328R:	move.l	(a5),a6
	move.l	chi_VolTable_R(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l*4),d3
	move.l	(a0,d3.l*4),d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
.2:	move.b	(a6,d2.l*4),d3
	move.l	(a0,d3.l*4),d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	lea	(a6,d2.l*4),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.b	(a3),d3
	addq.l	#4,a3
	move.l	(a0,d3.l*4),d1
.6:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	move.b	(a3),d3
	addq.l	#4,a3
	move.l	(a0,d3.l*4),d1
.7:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#2,d2
	subq.l	#1,d2
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#2,d2
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIXb_Stereo328R:	move.l	(a5),a6
	move.l	chi_VolTable_R(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l*4),d3
	move.l	(a0,d3.l*4),d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
.2:	move.b	(a6,d2.l*4),d3
	move.l	(a0,d3.l*4),d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	lea	4(a6,d2.l*4),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	subq.l	#4,a3
	move.b	(a3),d3
	move.l	(a0,d3.l*4),d1
.6:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	subq.l	#4,a3
	move.b	(a3),d3
	move.l	(a0,d3.l*4),d1
.7:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#2,d2
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#2,d2
	subq.l	#1,d2
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIX_StereoX8R:	move.l	(a5),a6
	movem.l	d3/d5/a1,-(sp)
	move.l	d6,a1
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	moveq	#0,d3
	not.b	d3
	move.l	chi_VolTable_R(a5),a0
	move.l	chi_RealAdv(a5),d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	add.l	d5,d2
	add.w	a1,d4
	bcc.s	.2
	add.l	d6,d2
.2:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	add.l	d5,d2
	add.w	a1,d4
	bcc.s	.9
	add.l	d6,d2
.9:	dbra	d0,.1
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/a1
	rts
.3:	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
.6:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a1,d4
	bcc.s	.7
	add.l	d6,d2
.5:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
.7:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a1,d4
	bcs.s	.8
	dbra	d0,.6
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/a1
	rts
.8:	add.l	d6,d2
	dbra	d0,.4
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/a1
	rts

	cnop	0,4

MIXb_StereoX8R:	move.l	(a5),a6
	movem.l	d3/d5/a1,-(sp)
	move.l	d6,a1
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	moveq	#0,d3
	not.b	d3
	move.l	chi_VolTable_R(a5),a0
	move.l	chi_RealAdv(a5),d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	sub.l	d5,d2
	add.w	a1,d4
	bcc.s	.2
	sub.l	d6,d2
.2:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
	addq.l	#4,a2
	add.l	d1,(a2)+
	sub.l	d5,d2
	add.w	a1,d4
	bcc.s	.9
	sub.l	d6,d2
.9:	dbra	d0,.1
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/a1
	rts
.3:	add.l	d6,d2
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	sub.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
.6:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a1,d4
	bcc.s	.7
.5:	sub.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
.7:	addq.l	#4,a2
	add.l	d1,(a2)+
	add.w	a1,d4
	bcs.s	.8
	dbra	d0,.6
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/a1
	rts
.8:	dbra	d0,.4
	divu.l	d6,d2
	subq.l	#1,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/a1
	rts

	cnop	0,4

MIX_Stereo8C:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
.2:	move.b	(a6,d2.l),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	move.l	a6,a3
	add.l	d2,a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.b	(a3)+,d3
	move.l	(a0,d3.l*4),d1
.6:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	move.b	(a3)+,d3
	move.l	(a0,d3.l*4),d1
.7:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	subq.l	#1,d2
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIXb_Stereo8C:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
.2:	move.b	(a6,d2.l),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	lea	1(a6,d2.l),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.b	-(a3),d3
	move.l	(a0,d3.l*4),d1
.6:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	move.b	-(a3),d3
	move.l	(a0,d3.l*4),d1
.7:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	subq.l	#1,d2
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIX_Stereo16C:	move.l	(a5),a6
	movem.l	d3/d6-d7,-(sp)
	move.l	d6,a3
	movem.l	chi_Multiply_L(a5),d6-d7
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a3,d4
	addx.l	d5,d2
.2:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a3,d4
	addx.l	d5,d2
	dbra	d0,.1
	movem.l	(sp)+,d3/d6-d7
	rts
.3:	lea	(a6,d2.l*2),a0
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.w	(a0)+,d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
.6:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a3,d4
	bcc.s	.7
.5:	move.w	(a0)+,d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
.7:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#1,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts
.8:	dbra	d0,.4
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts

	cnop	0,4

MIXb_Stereo16C:	move.l	(a5),a6
	movem.l	d3/d6-d7,-(sp)
	move.l	d6,a3
	movem.l	chi_Multiply_L(a5),d6-d7
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a3,d4
	subx.l	d5,d2
.2:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a3,d4
	subx.l	d5,d2
	dbra	d0,.1
	movem.l	(sp)+,d3/d6-d7
	rts
.3:	lea	2(a6,d2.l*2),a0
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.w	-(a0),d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
.6:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a3,d4
	bcc.s	.7
.5:	move.w	-(a0),d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
.7:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts
.8:	dbra	d0,.4
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#1,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts

	cnop	0,4

MIX_Stereo32C:	move.l	(a5),a6
	movem.l	d3/d6-d7,-(sp)
	move.l	d6,a3
	movem.l	chi_Multiply_L(a5),d6-d7
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.l	(a6,d2.l*4),d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a3,d4
	addx.l	d5,d2
.2:	move.l	(a6,d2.l*4),d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a3,d4
	addx.l	d5,d2
	dbra	d0,.1
	movem.l	(sp)+,d3/d6-d7
	rts
.3:	lea	(a6,d2.l*4),a0
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.l	(a0)+,d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
.6:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a3,d4
	bcc.s	.7
.5:	move.l	(a0)+,d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
.7:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#2,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts
.8:	dbra	d0,.4
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#2,d2
	movem.l	(sp)+,d3/d6-d7
	rts

	cnop	0,4

MIXb_Stereo32C:	move.l	(a5),a6
	movem.l	d3/d6-d7,-(sp)
	move.l	d6,a3
	movem.l	chi_Multiply_L(a5),d6-d7
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.l	(a6,d2.l*4),d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a3,d4
	subx.l	d5,d2
.2:	move.l	(a6,d2.l*4),d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a3,d4
	subx.l	d5,d2
	dbra	d0,.1
	movem.l	(sp)+,d3/d6-d7
	rts
.3:	lea	4(a6,d2.l*4),a0
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.l	-(a0),d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
.6:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a3,d4
	bcc.s	.7
.5:	move.l	-(a0),d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
.7:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#2,d2
	movem.l	(sp)+,d3/d6-d7
	rts
.8:	dbra	d0,.4
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#2,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d6-d7
	rts

	cnop	0,4

MIX_StereoXC:	move.l	(a5),a6
	movem.l	d3/d5-d7,-(sp)
	move.l	d6,a0
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	move.l	chi_Divider(a5),d7
	move.l	chi_RealAdv(a5),d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.l	d5,d2
	add.w	a0,d4
	bcc.s	.2
	add.l	d6,d2
.2:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.l	d5,d2
	add.w	a0,d4
	bcc.s	.9
	add.l	d6,d2
.9:	dbra	d0,.1
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts
.3:	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d6,d2
.6:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a0,d4
	bcc.s	.7
.5:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d6,d2
.7:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a0,d4
	bcs.s	.8
	dbra	d0,.6
	divu.l	d6,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d5-d7
	rts
.8:	dbra	d0,.4
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts

	cnop	0,4

MIXb_StereoXC:	move.l	(a5),a6
	movem.l	d3/d5-d7,-(sp)
	move.l	d6,a0
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	move.l	chi_Divider(a5),d7
	move.l	chi_RealAdv(a5),d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	sub.l	d5,d2
	add.w	a0,d4
	bcc.s	.2
	sub.l	d6,d2
.2:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	sub.l	d5,d2
	add.w	a0,d4
	bcc.s	.9
	sub.l	d6,d2
.9:	dbra	d0,.1
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts
.3:	add.l	d6,d2
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	sub.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
.6:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a0,d4
	bcc.s	.7
.5:	sub.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
.7:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a0,d4
	bcs.s	.8
	dbra	d0,.6
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts
.8:	dbra	d0,.4
	divu.l	d6,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d5-d7
	rts

	cnop	0,4

MIX_Stereo168C:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l*2),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
.2:	move.b	(a6,d2.l*2),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	lea	(a6,d2.l*2),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.b	(a3),d3
	addq.l	#2,a3
	move.l	(a0,d3.l*4),d1
.6:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	move.b	(a3),d3
	addq.l	#2,a3
	move.l	(a0,d3.l*4),d1
.7:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#1,d2
	subq.l	#1,d2
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#1,d2
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIXb_Stereo168C:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l*2),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
.2:	move.b	(a6,d2.l*2),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	lea	2(a6,d2.l*2),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	subq.l	#2,a3
	move.b	(a3),d3
	move.l	(a0,d3.l*4),d1
.6:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	subq.l	#2,a3
	move.b	(a3),d3
	move.l	(a0,d3.l*4),d1
.7:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#1,d2
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#1,d2
	subq.l	#1,d2
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIX_Stereo328C:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l*4),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
.2:	move.b	(a6,d2.l*4),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	lea	(a6,d2.l*4),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.b	(a3),d3
	addq.l	#4,a3
	move.l	(a0,d3.l*4),d1
.6:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	move.b	(a3),d3
	addq.l	#4,a3
	move.l	(a0,d3.l*4),d1
.7:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#2,d2
	subq.l	#1,d2
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#2,d2
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIXb_Stereo328C:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l*4),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
.2:	move.b	(a6,d2.l*4),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	lea	4(a6,d2.l*4),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	subq.l	#4,a3
	move.b	(a3),d3
	move.l	(a0,d3.l*4),d1
.6:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	subq.l	#4,a3
	move.b	(a3),d3
	move.l	(a0,d3.l*4),d1
.7:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#2,d2
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#2,d2
	subq.l	#1,d2
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIX_StereoX8C:	move.l	(a5),a6
	movem.l	d3/d5/a1,-(sp)
	move.l	d6,a1
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	moveq	#0,d3
	not.b	d3
	move.l	chi_VolTable_L(a5),a0
	move.l	chi_RealAdv(a5),d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.l	d5,d2
	add.w	a1,d4
	bcc.s	.2
	add.l	d6,d2
.2:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.l	d5,d2
	add.w	a1,d4
	bcc.s	.9
	add.l	d6,d2
.9:	dbra	d0,.1
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/a1
	rts
.3:	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
.6:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a1,d4
	bcc.s	.7
	add.l	d6,d2
.5:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
.7:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a1,d4
	bcs.s	.8
	dbra	d0,.6
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/a1
	rts
.8:	add.l	d6,d2
	dbra	d0,.4
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/a1
	rts

	cnop	0,4

MIXb_StereoX8C:	move.l	(a5),a6
	movem.l	d5/a1,-(sp)
	move.l	d6,a1
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	moveq	#0,d3
	not.b	d3
	move.l	chi_VolTable_L(a5),a0
	move.l	chi_RealAdv(a5),d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	sub.l	d5,d2
	add.w	a1,d4
	bcc.s	.2
	sub.l	d6,d2
.2:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
	add.l	d1,(a2)+
	add.l	d1,(a2)+
	sub.l	d5,d2
	add.w	a1,d4
	bcc.s	.9
	sub.l	d6,d2
.9:	dbra	d0,.1
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/a1
	rts
.3:	add.l	d6,d2
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	sub.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
.6:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a1,d4
	bcc.s	.7
.5:	sub.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
.7:	add.l	d1,(a2)+
	add.l	d1,(a2)+
	add.w	a1,d4
	bcs.s	.8
	dbra	d0,.6
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/a1
	rts
.8:	dbra	d0,.4
	divu.l	d6,d2
	subq.l	#1,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/a1
	rts

	cnop	0,4

MIX_Stereo8Sur:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
.2:	move.b	(a6,d2.l),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	move.w	d7,-(sp)
	move.l	a6,a3
	add.l	d2,a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.b	(a3)+,d3
	move.l	(a0,d3.l*4),d1
	move.l	d1,d7
	not.l	d7
.6:	add.l	d1,(a2)+
	add.l	d7,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	move.b	(a3)+,d3
	move.l	(a0,d3.l*4),d1
	move.l	d1,d7
	not.l	d7
.7:	add.l	d1,(a2)+
	add.l	d7,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	subq.l	#1,d2
	move.w	(sp)+,d7
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	move.w	(sp)+,d7
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIXb_Stereo8Sur:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
.2:	move.b	(a6,d2.l),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	move.w	d7,-(sp)
	lea	1(a6,d2.l),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.b	-(a3),d3
	move.l	(a0,d3.l*4),d1
	move.l	d1,d7
	not.l	d7
.6:	add.l	d1,(a2)+
	add.l	d7,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	move.b	-(a3),d3
	move.l	(a0,d3.l*4),d1
	move.l	d1,d7
	not.l	d7
.7:	add.l	d1,(a2)+
	add.l	d7,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	move.w	(sp)+,d7
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	subq.l	#1,d2
	move.w	(sp)+,d7
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIX_Stereo16Sur:	move.l	(a5),a6
	movem.l	d3/d6-d7,-(sp)
	move.l	d6,a3
	movem.l	chi_Multiply_L(a5),d6-d7
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.w	a3,d4
	addx.l	d5,d2
.2:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.w	a3,d4
	addx.l	d5,d2
	dbra	d0,.1
	movem.l	(sp)+,d3/d6-d7
	rts
.3:	move.w	d5,-(sp)
	lea	(a6,d2.l*2),a0
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.w	(a0)+,d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	move.l	d1,d5
	not.l	d5
.6:	add.l	d1,(a2)+
	add.l	d5,(a2)+
	add.w	a3,d4
	bcc.s	.7
.5:	move.w	(a0)+,d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	move.l	d1,d5
	not.l	d5
.7:	add.l	d1,(a2)+
	add.l	d5,(a2)+
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a0
	move.l	a0,d2
	subq.l	#2,d2
	lsr.l	#1,d2
	move.w	(sp)+,d5
	movem.l	(sp)+,d3/d6-d7
	rts
.8:	dbra	d0,.4
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#1,d2
	move.w	(sp)+,d5
	movem.l	(sp)+,d3/d6-d7
	rts

	cnop	0,4

MIXb_Stereo16Sur:	move.l	(a5),a6
	movem.l	d3/d6-d7,-(sp)
	move.l	d6,a3
	movem.l	chi_Multiply_L(a5),d6-d7
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.w	a3,d4
	subx.l	d5,d2
.2:	move.w	(a6,d2.l*2),d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.w	a3,d4
	subx.l	d5,d2
	dbra	d0,.1
	movem.l	(sp)+,d3/d6-d7
	rts
.3:	move.w	d5,-(sp)
	lea	2(a6,d2.l*2),a0
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.w	-(a0),d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	move.l	d1,d5
	not.l	d5
.6:	add.l	d1,(a2)+
	add.l	d5,(a2)+
	add.w	a3,d4
	bcc.s	.7
.5:	move.w	-(a0),d1
	ext.l	d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	move.l	d1,d5
	not.l	d5
.7:	add.l	d1,(a2)+
	add.l	d5,(a2)+
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#1,d2
	move.w	(sp)+,d5
	movem.l	(sp)+,d3/d6-d7
	rts
.8:	dbra	d0,.4
	sub.l	a6,a0
	move.l	a0,d2
	subq.l	#2,d2
	lsr.l	#1,d2
	move.w	(sp)+,d5
	movem.l	(sp)+,d3/d6-d7
	rts

	cnop	0,4

MIX_Stereo32Sur:	move.l	(a5),a6
	movem.l	d3/d6-d7,-(sp)
	move.l	d6,a3
	movem.l	chi_Multiply_L(a5),d6-d7
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.l	(a6,d2.l*4),d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.w	a3,d4
	addx.l	d5,d2
.2:	move.l	(a6,d2.l*4),d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.w	a3,d4
	addx.l	d5,d2
	dbra	d0,.1
	movem.l	(sp)+,d3/d6-d7
	rts
.3:	move.w	d5,-(sp)
	lea	(a6,d2.l*4),a0
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.l	(a0)+,d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	move.l	d1,d5
	not.l	d5
.6:	add.l	d1,(a2)+
	add.l	d5,(a2)+
	add.w	a3,d4
	bcc.s	.7
.5:	move.l	(a0)+,d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	move.l	d1,d5
	not.l	d5
.7:	add.l	d1,(a2)+
	add.l	d5,(a2)+
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#2,d2
	subq.l	#1,d2
	move.w	(sp)+,d5
	movem.l	(sp)+,d3/d6-d7
	rts
.8:	dbra	d0,.4
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#2,d2
	move.w	(sp)+,d5
	movem.l	(sp)+,d3/d6-d7
	rts

	cnop	0,4

MIXb_Stereo32Sur:	move.l	(a5),a6
	movem.l	d3/d6-d7,-(sp)
	move.l	d6,a3
	movem.l	chi_Multiply_L(a5),d6-d7
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.l	(a6,d2.l*4),d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.w	a3,d4
	subx.l	d5,d2
.2:	move.l	(a6,d2.l*4),d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.w	a3,d4
	subx.l	d5,d2
	dbra	d0,.1
	movem.l	(sp)+,d3/d6-d7
	rts
.3:	move.w	d5,-(sp)
	lea	4(a6,d2.l*4),a0
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.l	-(a0),d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	move.l	d1,d5
	not.l	d5
.6:	add.l	d1,(a2)+
	add.l	d5,(a2)+
	add.w	a3,d4
	bcc.s	.7
.5:	move.l	-(a0),d1
	muls.l	d6,d3:d1
	divs.l	d7,d3:d1
	move.l	d1,d5
	not.l	d5
.7:	add.l	d1,(a2)+
	add.l	d5,(a2)+
	add.w	a3,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#2,d2
	move.w	(sp)+,d5
	movem.l	(sp)+,d3/d6-d7
	rts
.8:	dbra	d0,.4
	sub.l	a6,a0
	move.l	a0,d2
	lsr.l	#2,d2
	subq.l	#1,d2
	move.w	(sp)+,d5
	movem.l	(sp)+,d3/d6-d7
	rts

	cnop	0,4

MIX_StereoXSur:	move.l	(a5),a6
	movem.l	d3/d5-d7,-(sp)
	move.l	d6,a0
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	move.l	chi_RealAdv(a5),d5
	beq.s	.3
	move.l	chi_Divider(a5),d7
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.l	d5,d2
	add.w	a0,d4
	bcc.s	.2
	add.l	d6,d2
.2:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.l	d5,d2
	add.w	a0,d4
	bcc.s	.9
	add.l	d6,d2
.9:	dbra	d0,.1
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts
.3:	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	chi_Divider(a5),d3:d1
	move.l	d1,d7
	not.l	d7
	add.l	d6,d2
.6:	add.l	d1,(a2)+
	add.l	d7,(a2)+
	add.w	a0,d4
	bcc.s	.7
.5:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	chi_Divider(a5),d3:d1
	move.l	d1,d7
	not.l	d7
	add.l	d6,d2
.7:	add.l	d1,(a2)+
	add.l	d7,(a2)+
	add.w	a0,d4
	bcs.s	.8
	dbra	d0,.6
	divu.l	d6,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d5-d7
	rts
.8:	dbra	d0,.4
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts

	cnop	0,4

MIXb_StereoXSur:	move.l	(a5),a6
	movem.l	d3/d5-d7,-(sp)
	move.l	d6,a0
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	move.l	chi_RealAdv(a5),d5
	beq.s	.3
	move.l	chi_Divider(a5),d7
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	sub.l	d5,d2
	add.w	a0,d4
	bcc.s	.2
	sub.l	d6,d2
.2:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	d7,d3:d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	sub.l	d5,d2
	add.w	a0,d4
	bcc.s	.9
	sub.l	d6,d2
.9:	dbra	d0,.1
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts
.3:	add.l	d6,d2
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	sub.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	chi_Divider(a5),d3:d1
	move.l	d1,d7
	not.l	d7
.6:	add.l	d1,(a2)+
	add.l	d7,(a2)+
	add.w	a0,d4
	bcc.s	.7
.5:	sub.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	muls.l	chi_Multiply_L(a5),d3:d1
	divs.l	chi_Divider(a5),d3:d1
	move.l	d1,d7
	not.l	d7
.7:	add.l	d1,(a2)+
	add.l	d7,(a2)+
	add.w	a0,d4
	bcs.s	.8
	dbra	d0,.6
	divu.l	d6,d2
	movem.l	(sp)+,d3/d5-d7
	rts
.8:	dbra	d0,.4
	divu.l	d6,d2
	subq.l	#1,d2
	movem.l	(sp)+,d3/d5-d7
	rts

	cnop	0,4

MIX_Stereo168Sur:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l*2),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
.2:	move.b	(a6,d2.l*2),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	move.w	d7,-(sp)
	lea	(a6,d2.l*2),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.b	(a3),d3
	addq.l	#2,a3
	move.l	(a0,d3.l*4),d1
	move.l	d1,d7
	not.l	d7
.6:	add.l	d1,(a2)+
	add.l	d7,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	move.b	(a3),d3
	addq.l	#2,a3
	move.l	(a0,d3.l*4),d1
	move.l	d1,d7
	not.l	d7
.7:	add.l	d1,(a2)+
	add.l	d7,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#1,d2
	subq.l	#1,d2
	move.w	(sp)+,d7
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#1,d2
	move.w	(sp)+,d7
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIXb_Stereo168Sur:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l*2),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
.2:	move.b	(a6,d2.l*2),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	move.w	d7,-(sp)
	lea	2(a6,d2.l*2),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	subq.l	#2,a3
	move.b	(a3),d3
	move.l	(a0,d3.l*4),d1
	move.l	d1,d7
	not.l	d7
.6:	add.l	d1,(a2)+
	add.l	d7,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	subq.l	#2,a3
	move.b	(a3),d3
	move.l	(a0,d3.l*4),d1
	move.l	d1,d7
	not.l	d7
.7:	add.l	d1,(a2)+
	add.l	d7,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#1,d2
	move.w	(sp)+,d7
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#1,d2
	subq.l	#1,d2
	move.w	(sp)+,d7
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIX_Stereo328Sur:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l*4),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
.2:	move.b	(a6,d2.l*4),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.w	d6,d4
	addx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	move.w	d7,-(sp)
	lea	(a6,d2.l*4),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	move.b	(a3),d3
	addq.l	#4,a3
	move.l	(a0,d3.l*4),d1
	move.l	d1,d7
	not.l	d7
.6:	add.l	d1,(a2)+
	add.l	d7,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	move.b	(a3),d3
	addq.l	#4,a3
	move.l	(a0,d3.l*4),d1
	move.l	d1,d7
	not.l	d7
.7:	add.l	d1,(a2)+
	add.l	d7,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#2,d2
	subq.l	#1,d2
	move.w	(sp)+,d7
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#2,d2
	move.w	(sp)+,d7
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIXb_Stereo328Sur:	move.l	(a5),a6
	move.l	chi_VolTable_L(a5),a0
	move.w	d3,-(sp)
	moveq	#0,d3
	tst.w	d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	move.b	(a6,d2.l*4),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
.2:	move.b	(a6,d2.l*4),d3
	move.l	(a0,d3.l*4),d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.w	d6,d4
	subx.l	d5,d2
	dbra	d0,.1
	move.w	(sp)+,d3
	rts
.3:	move.w	d7,-(sp)
	lea	4(a6,d2.l*4),a3
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	subq.l	#4,a3
	move.b	(a3),d3
	move.l	(a0,d3.l*4),d1
	move.l	d1,d7
	not.l	d7
.6:	add.l	d1,(a2)+
	add.l	d7,(a2)+
	add.w	d6,d4
	bcc.s	.7
.5:	subq.l	#4,a3
	move.b	(a3),d3
	move.l	(a0,d3.l*4),d1
	move.l	d1,d7
	not.l	d7
.7:	add.l	d1,(a2)+
	add.l	d7,(a2)+
	add.w	d6,d4
	bcs.s	.8
	dbra	d0,.6
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#2,d2
	move.w	(sp)+,d7
	move.w	(sp)+,d3
	rts
.8:	dbra	d0,.4
	sub.l	a6,a3
	move.l	a3,d2
	lsr.l	#2,d2
	subq.l	#1,d2
	move.w	(sp)+,d7
	move.w	(sp)+,d3
	rts

	cnop	0,4

MIX_StereoX8Sur:	move.l	(a5),a6
	movem.l	d3/d5/d7/a1,-(sp)
	move.l	d6,a1
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	moveq	#0,d3
	not.b	d3
	move.l	chi_VolTable_L(a5),a0
	move.l	chi_RealAdv(a5),d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.l	d5,d2
	add.w	a1,d4
	bcc.s	.2
	add.l	d6,d2
.2:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	add.l	d5,d2
	add.w	a1,d4
	bcc.s	.9
	add.l	d6,d2
.9:	dbra	d0,.1
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/d7/a1
	rts
.3:	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
	move.l	d1,d7
	not.l	d7
.6:	add.l	d1,(a2)+
	add.l	d7,(a2)+
	add.w	a1,d4
	bcc.s	.7
	add.l	d6,d2
.5:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
	move.l	d1,d7
	not.l	d7
.7:	add.l	d1,(a2)+
	add.l	d7,(a2)+
	add.w	a1,d4
	bcs.s	.8
	dbra	d0,.6
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/d7/a1
	rts
.8:	add.l	d6,d2
	dbra	d0,.4
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/d7/a1
	rts

	cnop	0,4

MIXb_StereoX8Sur:	move.l	(a5),a6
	movem.l	d3/d5/d7/a1,-(sp)
	move.l	d6,a1
	moveq	#0,d6
	move.b	chi_BitDepth(a5),d6
	mulu.l	d6,d2
	moveq	#0,d3
	not.b	d3
	move.l	chi_VolTable_L(a5),a0
	move.l	chi_RealAdv(a5),d5
	beq.s	.3
	lsr.w	#1,d0
	bcs.s	.2
	subq.w	#1,d0
.1:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	sub.l	d5,d2
	add.w	a1,d4
	bcc.s	.2
	sub.l	d6,d2
.2:	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
	add.l	d1,(a2)+
	not.l	d1
	add.l	d1,(a2)+
	sub.l	d5,d2
	add.w	a1,d4
	bcc.s	.9
	sub.l	d6,d2
.9:	dbra	d0,.1
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/d7/a1
	rts
.3:	add.l	d6,d2
	lsr.w	#1,d0
	bcs.s	.5
	subq.w	#1,d0
.4:	sub.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
	move.l	d1,d7
	not.l	d7
.6:	add.l	d1,(a2)+
	add.l	d7,(a2)+
	add.w	a1,d4
	bcc.s	.7
.5:	sub.l	d6,d2
	bfextu	(a6){d2:d6},d1
	ror.l	d6,d1
	rol.l	#8,d1
	and.l	d3,d1
	move.l	(a0,d1.l*4),d1
	move.l	d1,d7
	not.l	d7
.7:	add.l	d1,(a2)+
	add.l	d7,(a2)+
	add.w	a1,d4
	bcs.s	.8
	dbra	d0,.6
	divu.l	d6,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/d7/a1
	rts
.8:	dbra	d0,.4
	divu.l	d6,d2
	subq.l	#1,d2
	move.l	a1,d6
	movem.l	(sp)+,d3/d5/d7/a1
	rts

Open:	addq.w	#1,LIB_OPENCNT(a6)
	move.l	a6,d0
	rts
CloseExtLib:	subq.w	#1,LIB_OPENCNT(a6)
ExtLib:	moveq	#0,d0
	rts

	cnop	0,4

CPU_MULU64:	mulu.l	d1,d1:d0
	rts

	cnop	0,4

MULU64:	tst.b	_Is68060
	beq.s	CPU_MULU64
	movem.l	d2-d5,-(sp)
	move.w	d0,d3
	mulu.w	d1,d3
	move.w	d0,d2
	swap	d0
	move.l	d0,d4
	mulu.w	d1,d0
	swap	d1
	move.l	d1,d5
	mulu.w	d2,d1
	moveq	#0,d2
	add.w	d1,d0
	addx.l	d2,d2
	swap	d0
	add.w	d0,d2
	clr.w	d0
	clr.w	d1
	swap	d1
	mulu.w	d5,d4
	add.l	d3,d0
	addx.l	d4,d1
	add.l	d2,d1
	movem.l	(sp)+,d2-d5
	rts

	cnop	0,4

CPU_DIVU64:	divu.l	d2,d1:d0
	rts

	cnop	0,4

DIVU64:	tst.b	_Is68060
	beq.s	CPU_DIVU64
	movem.l	d3-d5,-(sp)
	moveq	#0,d3
	moveq	#0,d4
	moveq	#$41,d5
DIVU64_Loop:	subq.l	#1,d5
	beq.s	DIVU64_Done
	add.l	d3,d3
	add.l	d0,d0
	roxl.l	#1,d1
	roxl.l	#1,d4
	cmp.l	d2,d4
	bcs.s	DIVU64_Loop
	sub.l	d2,d4
	addq.l	#1,d3
	bra.s	DIVU64_Loop
DIVU64_Done:	move.l	d3,d0
	move.l	d4,d1
	movem.l	(sp)+,d3-d5
	rts

	cnop	0,4

Mixr_Skip:	dc.l	mstv_Skip,mstv_Skip,mstv_Skip,Skip,Skip,Skip,Skip,Skipb,Skipb,Skipb,Skipb
Mixr_Mono:	dc.l	mstv_Stereo8C,mstv_Stereo16C,mstv_Stereo32C,MIX_Mono8,MIX_Mono16,MIX_Mono32,MIX_MonoX,MIXb_Mono8,MIXb_Mono16,MIXb_Mono32,MIXb_MonoX
Mixr_Stereo:	dc.l	mstv_Stereo8,mstv_Stereo16,mstv_Stereo32,MIX_Stereo8,MIX_Stereo16,MIX_Stereo32,MIX_StereoX,MIXb_Stereo8,MIXb_Stereo16,MIXb_Stereo32,MIXb_StereoX
Mixr_StereoL:	dc.l	mstv_Stereo8L,mstv_Stereo16L,mstv_Stereo32L,MIX_Stereo8L,MIX_Stereo16L,MIX_Stereo32L,MIX_StereoXL,MIXb_Stereo8L,MIXb_Stereo16L,MIXb_Stereo32L,MIXb_StereoXL
Mixr_StereoR:	dc.l	mstv_Stereo8R,mstv_Stereo16R,mstv_Stereo32R,MIX_Stereo8R,MIX_Stereo16R,MIX_Stereo32R,MIX_StereoXR,MIXb_Stereo8R,MIXb_Stereo16R,MIXb_Stereo32R,MIXb_StereoXR
Mixr_StereoC:	dc.l	mstv_Stereo8C,mstv_Stereo16C,mstv_Stereo32C,MIX_Stereo8C,MIX_Stereo16C,MIX_Stereo32C,MIX_StereoXC,MIXb_Stereo8C,MIXb_Stereo16C,MIXb_Stereo32C,MIXb_StereoXC
Mixr_StereoSur:	dc.l	mstv_Stereo8C,mstv_Stereo16C,mstv_Stereo32C,MIX_Stereo8Sur,MIX_Stereo16Sur,MIX_Stereo32Sur,MIX_StereoXSur,MIXb_Stereo8Sur,MIXb_Stereo16Sur,MIXb_Stereo32Sur,MIXb_StereoXSur
Mixr_Skip168:	dc.l	mstv_Skip,mstv_Skip,mstv_Skip,Skip,Skip,Skip,Skip,Skipb,Skipb,Skipb,Skipb
Mixr_Mono168:	dc.l	mstv_Stereo8C,mstv_Stereo8C,mstv_Stereo8C,MIX_Mono8,MIX_Mono168,MIX_Mono328,MIX_MonoX8,MIXb_Mono8,MIXb_Mono168,MIXb_Mono328,MIXb_MonoX8
Mixr_Stereo168:	dc.l	mstv_Stereo8,mstv_Stereo8,mstv_Stereo8,MIX_Stereo8,MIX_Stereo168,MIX_Stereo328,MIX_StereoX8,MIXb_Stereo8,MIXb_Stereo168,MIXb_Stereo328,MIXb_StereoX8
Mixr_StereoL168:	dc.l	mstv_Stereo8L,mstv_Stereo8L,mstv_Stereo8L,MIX_Stereo8L,MIX_Stereo168L,MIX_Stereo328L,MIX_StereoX8L,MIXb_Stereo8L,MIXb_Stereo168L,MIXb_Stereo328L,MIXb_StereoX8L
Mixr_StereoR168:	dc.l	mstv_Stereo8R,mstv_Stereo8R,mstv_Stereo8R,MIX_Stereo8R,MIX_Stereo168R,MIX_Stereo328R,MIX_StereoX8R,MIXb_Stereo8R,MIXb_Stereo168R,MIXb_Stereo328R,MIXb_StereoX8R
Mixr_StereoC168:	dc.l	mstv_Stereo8C,mstv_Stereo8C,mstv_Stereo8C,MIX_Stereo8C,MIX_Stereo168C,MIX_Stereo328C,MIX_StereoX8C,MIXb_Stereo8C,MIXb_Stereo168C,MIXb_Stereo328C,MIXb_StereoX8C
Mixr_StereoSur168:	dc.l	mstv_Stereo8C,mstv_Stereo8C,mstv_Stereo8C,MIX_Stereo8Sur,MIX_Stereo168Sur,MIX_Stereo328Sur,MIX_StereoX8Sur,MIXb_Stereo8Sur,MIXb_Stereo168Sur,MIXb_Stereo328Sur,MIXb_StereoX8Sur

LQMixName:	dc.b	'internal_lqmix.library',0
LQIDString:	dc.b	'Internal Low Quality Mixer Version 1.00 (v31) (68020+, OS2.04+) (28 Mar 97) by Basty/TuC.',0
LQSit0:	dc.b	'True 16-bit mixing',0
LQSit1:	dc.b	'Stereo mixing',0
LQSit2:	dc.b	'Interpolation',0
LQSit21:	dc.b	'Disabled',0
LQSit22:	dc.b	'Fast',0
LQSit23:	dc.b	'Effective',0
LQSit24:	dc.b	'Full',0
LQLoaderID:	dc.b	'Low Quality Mixer',0

	STRUCTURE	InternalLQMixAlloc,mas_SIZEOF
	APTR	lqmas_MixBuffer
	ULONG	lqmas_BuffSize
	ULONG	lqmas_MixBufSize
	APTR	lqmas_VolTable
	APTR	lqmas_ChInfo
	ULONG	lqmas_Amplify
	ULONG	lqmas_MixRate
	ULONG	lqmas_MixFract
	ULONG	lqmas_CurrLeft
	ULONG	lqmas_CurrLeftFrac
	ULONG	lqmas_PassLength
	ULONG	lqmas_PassFrac
	UWORD	lqmas_Channels
	UBYTE	lqmas_Interpolation
	UBYTE	lqmas_Real16Bit
	UBYTE	lqmas_Stereo
	UBYTE	lqmas_PrevStereo
	LABEL	lqmas_SIZEOF

	rsset	0
chi_SampleStartAdr:	rs.l	1
chi_SampleLen:	rs.l	1
chi_MixRegs:	rs.l	0
chi_Offset:	rs.l	1
chi_Fraction:	rs.l	1
chi_Advance:	rs.l	1
chi_AdvFract:	rs.l	1
chi_MixRoutine:	rs.l	1
chi_EndOffset:	rs.l	1
chi_RestartOffset:	rs.l	1
chi_Repeat:	rs.l	1
chi_RepLen:	rs.l	1
chi_CountRestart:	rs.l	1
chi_Counted:	rs.l	1
chi_SampleRate:	rs.l	1
chi_RealAdv:	rs.l	1
chi_VolTable_L:	rs.l	1
chi_VolTable_R:	rs.l	1
chi_Multiply_L:	rs.l	1
chi_Divider:	rs.l	1
chi_Multiply_R:	rs.l	1
chi_AltMixRoutine:	rs.l	1
chi_BitDepth:	rs.b	1
chi_Flags:	rs.b	1
chi_Volume:	rs.b	1
chi_Panning:	rs.b	1
chi_NewSampleStartAdr:	rs.l	1
chi_NewSampleLen:	rs.l	1
chi_NewOffset:	rs.l	1
chi_NewFraction:	rs.l	1
chi_NewAdvance:	rs.l	1
chi_NewAdvFract:	rs.l	1
chi_NewMixRoutine:	rs.l	1
chi_NewEndOffset:	rs.l	1
chi_NewRestartOffset:	rs.l	1
chi_NewRepeat:	rs.l	1
chi_NewRepLen:	rs.l	1
chi_NewCountRestart:	rs.l	1
chi_NewCounted:	rs.l	1
chi_NewSampleRate:	rs.l	1
chi_NewRealAdv:	rs.l	1
chi_NewVolTable_L:	rs.l	1
chi_NewVolTable_R:	rs.l	1
chi_NewMultiply_L:	rs.l	1
chi_NewDivider:	rs.l	1
chi_NewMultiply_R:	rs.l	1
chi_NewAltMixRoutine:	rs.l	1
chi_NewBitDepth:	rs.b	1
chi_NewFlags:	rs.b	1
chi_NewVolume:	rs.b	1
chi_NewPanning:	rs.b	1
chi_SIZEOF:	rs.l	0
