/* TuComposer Amiga Shared-Library function prototypes.
**
** $VER: library.h 31.22 (4.4.99)
**
** (C) 1999 by Sebastian Vater (known as Basty/Seasons).
**
*/

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif /* EXEC_TYPES_H */

#ifndef TUCOMPOSER_TUCOMPOSER_H
#include <tucomposer/tucomposer.h>
#endif /* TUCOMPOSER_TUCOMPOSER_H */

#ifndef CLIB_TUCOMPOSER_PROTOS_H
#include <clib/tucomposer_protos.h>
#endif /* CLIB_TUCOMPOSER_PROTOS_H */

#include "compiler.h"

#ifdef __cplusplus
extern "C" {
#endif

APTR ASM libAllocPMem ( register __d0 unsigned long byteSize GNUCREG(d0));
void ASM libFreePMem ( register __a1 APTR memoryBlock GNUCREG(a1), register __d0 unsigned long byteSize GNUCREG(d0));
void ASM libInitNodeList ( register __a0 struct List *NodeList GNUCREG(a0));
void ASM libInsertNode ( register __a0 struct List *NodeList GNUCREG(a0), register __a1 struct Node *Node GNUCREG(a1),
    register __a2 struct Node *PredNode GNUCREG(a2));
void ASM libAddNodeHead ( register __a0 struct List *NodeList GNUCREG(a0), register __a1 struct Node *Node GNUCREG(a1));
void ASM libAddNodeTail ( register __a0 struct List *NodeList GNUCREG(a0), register __a1 struct Node *Node GNUCREG(a1));
void ASM libRemoveNode ( register __a1 struct Node *Node GNUCREG(a1));
void ASM libRemNodeHead ( register __a0 struct List *NodeList GNUCREG(a0));
void ASM libRemNodeTail ( register __a0 struct List *NodeList GNUCREG(a0));
void ASM libEnqueueNode ( register __a0 struct List *NodeList GNUCREG(a0), register __a1 struct Node *Node GNUCREG(a1));
ULONG ASM libDupNodeList ( register __a0 struct MinList *SrcNodeList GNUCREG(a0),
    register __a1 struct MinList *DestNodeList GNUCREG(a1), register __d0 unsigned long NodeSize GNUCREG(d0));
void ASM libReMapNodeList ( register __a0 struct List *SrcNodeList GNUCREG(a0), register __a1 struct List *DestNodeList GNUCREG(a1));
STRPTR ASM libAllocNameStr ( register __a0 STRPTR CStr GNUCREG(a0));
ULONG ASM libFreeNameStr ( register __a0 STRPTR NameStr GNUCREG(a0));
STRPTR ASM libSetString ( register __a0 STRPTR *StructPos GNUCREG(a0), register __a1 STRPTR CStr GNUCREG(a1));
STRPTR ASM libSetNameStr ( register __a0 STRPTR *StructPos GNUCREG(a0), register __a1 STRPTR NameStr GNUCREG(a1));
LONG ASM libSin ( register __d0 long Degrees GNUCREG(d0), register __d1 long Amplify GNUCREG(d1));
LONG ASM libCos ( register __d0 long Degrees GNUCREG(d0), register __d1 long Amplify GNUCREG(d1));
LONG ASM libTan ( register __d0 long Degrees GNUCREG(d0), register __d1 long Amplify GNUCREG(d1));
void ASM libDoPlayerIRQ ( register __a0 struct TuComposerBase *TuCBase GNUCREG(a0));
struct PlayExecHandler * ASM libAddPlayExecHandler ( register __a0 struct PlayExecHandler
    *PlayExecStr GNUCREG(a0));
void ASM libRemPlayExecHandler ( register __a0 struct PlayExecHandler *PlayExecStr GNUCREG(a0));
void ASM libSetPlayExecHandlerPri ( register __a0 struct PlayExecHandler *PlayExecStr GNUCREG(a0),
    register __d0 long Pri GNUCREG(d0));
void ASM libStamp2Date ( register __a0 struct StampDate *StampDateStr GNUCREG(a0),
    register __a1 struct DateStamp *DateStampStr GNUCREG(a1));
struct TuComposerBase * ASM libAllocSimulateMix ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0));
void ASM libFreeSimulateMix ( register __a0 struct TuComposerBase *PseudoTuCBase GNUCREG(a0));
struct UnknownChunk * ASM libAllocUnknownChunk ( register __a0 APTR PreFillData GNUCREG(a0),
    register __d0 unsigned long ChunkName GNUCREG(d0), register __d1 unsigned long ChunkLen GNUCREG(d1));
void ASM libFreeUnknownChunk ( register __a0 struct UnknownChunk *UnknownChunkStr GNUCREG(a0));
void ASM libDeleteUnknownChunk ( register __a0 struct UnknownChunk *UnknownChunkStr GNUCREG(a0));
ULONG ASM libRandomize ( register __d0 unsigned long Seed GNUCREG(d0));
ULONG ASM libRnd ( register __d0 unsigned long UpperBound GNUCREG(d0));
ULONG ASM libAllocSoundDevice ( register __a0 struct TuComposerExtList *ExtLibStr GNUCREG(a0),
    register __a1 union FlagPass *FlagPassStr GNUCREG(a1));
ULONG ASM libFreeSoundDevice ( register __a0 struct TuComposerExtList *ExtLibStr GNUCREG(a0));
ULONG ASM libPlaySoundDevice ( register __a0 struct TuComposerExtList *ExtLibStr GNUCREG(a0),
    register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2));
ULONG ASM libStopSoundDevice ( register __a0 struct TuComposerExtList *ExtLibStr GNUCREG(a0));
ULONG ASM libCheckSoundDeviceRate ( register __a0 struct TuComposerExtList *ExtLibStr GNUCREG(a0),
    register __d0 unsigned long SmpRate GNUCREG(d0));
ULONG ASM libCheckSoundDeviceRateFraction ( register __a0 struct TuComposerExtList
    *ExtLibStr GNUCREG(a0), register __d0 unsigned long SmpRate GNUCREG(d0));
void ASM libUpdateSoundDeviceRate ( register __a0 struct TuComposerExtList *ExtLibStr GNUCREG(a0),
    register __d0 unsigned long SmpRate GNUCREG(d0));
struct MixerAllocStruct * ASM libAllocMixer ( register __a0 struct TuComposerExtList *ExtLibStr GNUCREG(a0));
ULONG ASM libFreeMixer ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0));
ULONG ASM libInitMixer ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0),
    register __a1 struct SoundDeviceInfo *ExtSoundDevStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2));
ULONG ASM libChangeMixerRate ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0),
    register __d0 unsigned long NewMixRate GNUCREG(d0));
ULONG ASM libChangeMixerTempo ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0),
    register __d0 unsigned long NewTempo GNUCREG(d0));
ULONG ASM libChangeMixerVolTable ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0),
    register __d0 unsigned long Amplify GNUCREG(d0), register __d1 unsigned long LeftVol GNUCREG(d1), register __d2 unsigned long RightVol GNUCREG(d2),
    register __d3 unsigned long NumChannels GNUCREG(d3));
void ASM libGetMixChannel ( register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1),
    register __a0 struct MixerStruct *MixStr GNUCREG(a0), register __d0 unsigned long Channel GNUCREG(d0));
void ASM libSetMixChannel ( register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1),
    register __a0 struct MixerStruct *MixStr GNUCREG(a0), register __d0 unsigned long Channel GNUCREG(d0));
void ASM libSetMixChannelVolPanPitch ( register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1),
    register __a0 struct MixerStruct *MixStr GNUCREG(a0), register __d0 unsigned long Channel GNUCREG(d0));
void ASM libSetMixChannelPosRepFlags ( register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1),
    register __a0 struct MixerStruct *MixStr GNUCREG(a0), register __d0 unsigned long Channel GNUCREG(d0));
void ASM libDoMix ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0), register __a1 long *MixBuffer GNUCREG(a1));
struct PostProcAllocStruct * ASM libAllocPostProcessor ( register __a0 struct TuComposerExtList *ExtLibStr GNUCREG(a0),
    register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1));
ULONG ASM libFreePostProcessor ( register __a0 struct PostProcAllocStruct *PostAllocStr GNUCREG(a0));
ULONG ASM libInitPostProcessor ( register __a0 struct PostProcAllocStruct *PostAllocStr GNUCREG(a0),
    register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2));
ULONG ASM libChangePostProcessor ( register __a0 struct PostProcAllocStruct *PostAllocStr GNUCREG(a0),
    register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1));
void ASM libDoPostProcessorMix ( register __a0 struct PostProcAllocStruct *PostAllocStr GNUCREG(a0),
    register __a2 long *MixBuffer GNUCREG(a2));
struct PostProcAllocStruct * ASM libAddPostProcessor ( register __a0 struct MixerAllocStruct
    *MixAllocStr GNUCREG(a0), register __a1 struct PostProcAllocStruct *PostAllocStr GNUCREG(a1));
void ASM libRemPostProcessor ( register __a0 struct PostProcAllocStruct *PostAllocStr GNUCREG(a0));
void ASM libSetPostProcessorPri ( register __a0 struct PostProcAllocStruct *PostAllocStr GNUCREG(a0),
    register __d0 long Pri GNUCREG(d0));
struct TuComposerModule * ASM libAllocTCModule ( register __d0 unsigned long Channels GNUCREG(d0));
ULONG ASM libFreeTCModule ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0));
ULONG ASM libAddTCModule ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0));
ULONG ASM libRemTCModule ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0));
struct TuComposerModule * ASM libDupTCModule ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0));
ULONG ASM libReMapTCModule ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerModule *NewModuleStr GNUCREG(a1));
struct TuComposerModule * ASM libLoadTCModule ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerModule *ModuleStr GNUCREG(a1),
    register __a2 struct TuComposerExtList *ExtLibStr GNUCREG(a2), register __a3 union FlagPass *FlagPassStr GNUCREG(a3),
    register __d0 unsigned long NumModule GNUCREG(d0));
ULONG ASM libSaveTCModule ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerModule *ModuleStr GNUCREG(a1),
    register __a2 struct TuComposerExtList *ExtLibStr GNUCREG(a2), register __a3 union FlagPass *FlagPassStr GNUCREG(a3));
struct TuComposerExtList * ASM libIdentifyTCModule ( register __a0 struct CFHandle *CFHandle GNUCREG(a0));
struct ModuleInfo * ASM libGetTCModuleInfo ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerExtList *ExtLibStr GNUCREG(a1), register __d0 unsigned long NumModule GNUCREG(d0));
ULONG ASM libFreeTCModuleInfo ( register __a0 struct ModuleInfo *ModuleInfoStr GNUCREG(a0));
ULONG ASM libGetTCModules ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerExtList *ExtLibStr GNUCREG(a1));
struct TuComposerModule * ASM libPushTCModule ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0));
ULONG ASM libPopTCModule ( register __a0 struct TuComposerModule *ModuleBuf GNUCREG(a0));
struct TuComposerModule * ASM libCutTCModule ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerModule *ModuleBuf GNUCREG(a1));
struct TuComposerModule * ASM libCopyTCModule ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerModule *ModuleBuf GNUCREG(a1));
struct TuComposerModule * ASM libPasteTCModule ( register __a0 struct TuComposerModule *ModuleBuf GNUCREG(a0),
    register __a1 struct TuComposerModule *ModuleStr GNUCREG(a1));
ULONG ASM libSwapTCModule ( register __a0 struct TuComposerModule *ModuleBuf GNUCREG(a0),
    register __a1 struct TuComposerModule *ModuleStr GNUCREG(a1));
ULONG ASM libClearTCModule ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0));
ULONG ASM libAddTCModuleUnknownChunk ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1));
ULONG ASM libRemTCModuleUnknownChunk ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0));
ULONG ASM libInsertTCModuleUnknownChunk ( register __a0 struct TuComposerModule
    *ModuleStr GNUCREG(a0), register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1),
    register __a2 struct UnknownChunk *UnknownChunkPos GNUCREG(a2));
ULONG ASM libAllocPlayTCModule ( void );
void ASM libFreePlayTCModule ( void );
ULONG ASM libPlayTCModule ( register __a0 union FlagPass *FlagPassStr GNUCREG(a0));
ULONG ASM libStopTCModule ( void );
ULONG ASM libSetTCMChannels ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __d0 unsigned long Channels GNUCREG(d0));
ULONG ASM libCalcTCMPlayTime ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct PlayExecHandler *PlayExecStr GNUCREG(a1));
ULONG ASM libGetOptimalVChannels ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0));
struct TuComposerSong * ASM libAllocSong ( register __d0 unsigned long Channels GNUCREG(d0),
    register __d1 unsigned long GoSubStack GNUCREG(d1), register __d2 unsigned long LoopStack GNUCREG(d2));
ULONG ASM libFreeSong ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0));
ULONG ASM libAddSong ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerSong *SongStr GNUCREG(a1));
ULONG ASM libRemSong ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0));
ULONG ASM libInsertSong ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerSong *SongStr GNUCREG(a1), register __a2 struct TuComposerSong *SongPos GNUCREG(a2));
ULONG ASM libDeleteSong ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0));
struct TuComposerSong * ASM libDupSong ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0));
ULONG ASM libReMapSong ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __a1 struct TuComposerSong *NewSongStr GNUCREG(a1));
ULONG ASM libGetNumSongs ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0));
ULONG ASM libGetSongNum ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerSong *SongStr GNUCREG(a1));
struct TuComposerSong * ASM libGetSongAddr ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __d0 unsigned long Num GNUCREG(d0));
struct TuComposerSong * ASM libLoadSong ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSong *SongStr GNUCREG(a1), register __a2 struct TuComposerExtList *ExtLibStr GNUCREG(a2),
    register __a3 union FlagPass *FlagPassStr GNUCREG(a3), register __d0 unsigned long NumSong GNUCREG(d0));
ULONG ASM libSaveSong ( register __a0 struct CFHandle *CFHandle GNUCREG(a0), register __a1 struct TuComposerSong *SongStr GNUCREG(a1),
    register __a2 struct TuComposerExtList *ExtLibStr GNUCREG(a2), register __a3 union FlagPass *FlagPassStr GNUCREG(a3));
struct TuComposerExtList * ASM libIdentifySong ( register __a0 struct CFHandle *CFHandle GNUCREG(a0));
struct SongInfo * ASM libGetSongInfo ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerExtList *ExtLibStr GNUCREG(a1), register __d0 unsigned long NumSong GNUCREG(d0));
ULONG ASM libFreeSongInfo ( register __a0 struct SongInfo *SongInfoStr GNUCREG(a0));
ULONG ASM libGetSongs ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerExtList *ExtLibStr GNUCREG(a1));
struct TuComposerSong * ASM libPushSong ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0));
ULONG ASM libPopSong ( register __a0 struct TuComposerSong *SongBuf GNUCREG(a0));
struct TuComposerSong * ASM libCutSong ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __a1 struct TuComposerSong *SongBuf GNUCREG(a1));
struct TuComposerSong * ASM libCopySong ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __a1 struct TuComposerSong *SongBuf GNUCREG(a1));
struct TuComposerSong * ASM libPasteSong ( register __a0 struct TuComposerSong *SongBuf GNUCREG(a0),
    register __a1 struct TuComposerSong *SongStr GNUCREG(a1));
ULONG ASM libSwapSong ( register __a0 struct TuComposerSong *SongBuf GNUCREG(a0),
    register __a1 struct TuComposerSong *SongStr GNUCREG(a1));
ULONG ASM libClearSong ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0));
ULONG ASM libAddSongUnknownChunk ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1));
ULONG ASM libRemSongUnknownChunk ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0));
ULONG ASM libInsertSongUnknownChunk ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1),
    register __a2 struct UnknownChunk *UnknownChunkPos GNUCREG(a2));
struct TuComposerInstr ** ASM libGetSongInstrs ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0));
ULONG ASM libFreeSongInstrs ( register __a0 struct TuComposerInstr **InstrList GNUCREG(a0));
struct TuComposerInstrEnvelope ** ASM libGetSongEnvelopes ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0));
ULONG ASM libFreeSongEnvelopes ( register __a0 struct TuComposerInstrEnvelope **EnvList GNUCREG(a0));
struct TuComposerInstrKeyboard ** ASM libGetSongKeyboards ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0));
ULONG ASM libFreeSongKeyboards ( register __a0 struct TuComposerInstrKeyboard **KeybrdList GNUCREG(a0));
struct TuComposerInstrArpeggio ** ASM libGetSongArpeggios ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0));
ULONG ASM libFreeSongArpeggios ( register __a0 struct TuComposerInstrArpeggio **ArpList GNUCREG(a0));
struct TuComposerTrack * ASM libReMapSongInstrs ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1),
    register __a2 struct TuComposerInstr **InstrList GNUCREG(a2));
ULONG ASM libSetBaseSongInstrs ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1), register __d0 unsigned long FirstInsNum GNUCREG(d0));
ULONG ASM libSetSongChannels ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __d0 unsigned long Channels GNUCREG(d0));
ULONG ASM libSetStack ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0), register __d0 unsigned long GoSubStack GNUCREG(d0),
    register __d1 unsigned long LoopStack GNUCREG(d1));
ULONG ASM libCalcSongPlayTime ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __a1 struct PlayExecHandler *PlayExecStr GNUCREG(a1));
ULONG ASM libGetOptimalChannels ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0));
ULONG ASM libResetSong ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0));
ULONG ASM libCalcPlayerSpeed ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0));
struct TuComposerOrders * ASM libAllocPosition ( register __d0 unsigned long Channels GNUCREG(d0));
ULONG ASM libFreePosition ( register __a0 struct TuComposerOrders *PosStr GNUCREG(a0),
    register __d0 unsigned long Channels GNUCREG(d0));
ULONG ASM libSwapPosition ( register __a0 struct TuComposerOrders *PosStr GNUCREG(a0),
    register __d0 unsigned long Channel GNUCREG(d0), register __d1 unsigned long SwapChannel GNUCREG(d1));
ULONG ASM libSetPosition ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __a1 struct TuComposerOrders *PosStr GNUCREG(a1));
struct TuComposerOrders * ASM libDupPosition ( register __a0 struct TuComposerOrders *PosStr GNUCREG(a0),
    register __d0 unsigned long Channels GNUCREG(d0));
ULONG ASM libGetPositionNum ( register __a0 struct TuComposerOrders *PosStr GNUCREG(a0),
   register __a1 struct TuComposerOrderList *PosListStr GNUCREG(a1), register __d0 unsigned long Channel GNUCREG(d0));
struct TuComposerOrderList * ASM libGetPositionAddr ( register __a0 struct TuComposerOrders
    *PosStr GNUCREG(a0), register __d0 unsigned long Channel GNUCREG(d0), register __d1 unsigned long Num GNUCREG(d1));
ULONG ASM libClearPosition ( register __a0 struct TuComposerOrders *PosStr GNUCREG(a0),
    register __d0 unsigned long Channels GNUCREG(d0));
ULONG ASM libPlayPosition ( register __a0 struct TuComposerOrders *PosStr GNUCREG(a0),
    register __a1 union FlagPass *FlagPassStr GNUCREG(a1), register __d0 unsigned long Order GNUCREG(d0),
    register __d1 unsigned long Row GNUCREG(d1));
ULONG ASM libDupPositionChannel ( register __a0 struct TuComposerOrders *SrcPosStr GNUCREG(a0),
    register __a1 struct TuComposerOrders *DestPosStr GNUCREG(a1), register __d0 unsigned long SrcChannel GNUCREG(d0),
    register __d1 unsigned long DestChannel GNUCREG(d1));
ULONG ASM libClearPositionChannel ( register __a0 struct TuComposerOrders *PosStr GNUCREG(a0),
    register __d0 unsigned long Channel GNUCREG(d0));
struct TuComposerOrderList * ASM libAllocPositionList ( void );
ULONG ASM libFreePositionList ( register __a0 struct TuComposerOrderList *PosListStr GNUCREG(a0));
ULONG ASM libAddPositionList ( register __a0 struct TuComposerOrders *PosStr GNUCREG(a0),
    register __a1 struct TuComposerOrderList *PosListStr GNUCREG(a1), register __d0 unsigned long Channel GNUCREG(d0));
ULONG ASM libRemPositionList ( register __a0 struct TuComposerOrders *PosStr GNUCREG(a0),
    register __d0 unsigned long Channel GNUCREG(d0));
ULONG ASM libInsertPositionList ( register __a0 struct TuComposerOrders *PosStr GNUCREG(a0),
    register __a1 struct TuComposerOrderList *PosListStr GNUCREG(a1),
    register __a2 struct TuComposerOrderList *PosListPos GNUCREG(a2), register __d0 unsigned long Channel GNUCREG(d0));
ULONG ASM libDeletePositionList ( register __a0 struct TuComposerOrderList *PosListStr GNUCREG(a0));
struct TuComposerOrderList * ASM libDupPositionList ( register __a0 struct TuComposerOrderList
    *PosListStr GNUCREG(a0));
ULONG ASM libSwapPositionList ( register __a0 struct TuComposerOrderList *PosListStr GNUCREG(a0),
    register __a1 struct TuComposerOrderList *SwapPosListStr GNUCREG(a1));
ULONG ASM libClearPositionList ( register __a0 struct TuComposerOrderList *PosListStr GNUCREG(a0));
struct TuComposerTrack * ASM libAllocTrack ( register __d0 unsigned long DefLength GNUCREG(d0));
ULONG ASM libFreeTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0));
ULONG ASM libAddTrack ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1));
ULONG ASM libRemTrack ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0));
ULONG ASM libInsertTrack ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1), register __a2 struct TuComposerTrack *TrackPos GNUCREG(a2));
ULONG ASM libDeleteTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0));
ULONG ASM libClearTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0));
struct TuComposerTrack * ASM libDupTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0));
ULONG ASM libReMapTrack ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1), register __a2 struct TuComposerTrack *NewTrackStr GNUCREG(a2));
ULONG ASM libReSizeTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long NewLen GNUCREG(d0));
ULONG ASM libAddTrackUnknownChunk ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1));
ULONG ASM libRemTrackUnknownChunk ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0));
ULONG ASM libInsertTrackUnknownChunk ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1),
    register __a2 struct UnknownChunk *UnknownChunkPos GNUCREG(a2));
ULONG ASM libGetNumTracks ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0));
ULONG ASM libGetTrackNum ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
   register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1));
struct TuComposerTrack * ASM libGetTrackAddr ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __d0 unsigned long Num GNUCREG(d0));
void ASM libGetNoteStr ( register __a0 STRPTR StrBuf GNUCREG(a0), register __d0 unsigned long Octave GNUCREG(d0), register __d1 unsigned long Note GNUCREG(d1),
    register __d2 unsigned long Flags GNUCREG(d2));
void ASM libGetIndexNoteStr ( register __a0 STRPTR StrBuf GNUCREG(a0), register __d0 unsigned long IndexNote GNUCREG(d0),
    register __d1 unsigned long Flags GNUCREG(d1));
ULONG ASM libNoteToIndex ( register __d0 unsigned long Octave GNUCREG(d0), register __d1 unsigned long Note GNUCREG(d1));
ULONG ASM libIndexToNote ( register __d0 unsigned long IndexNote GNUCREG(d0));
ULONG ASM libGetTrackRowStr ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __a1 STRPTR StrBuf GNUCREG(a1),
    register __a2 struct TuComposerTrackEffect *EffStr GNUCREG(a2), register __d0 unsigned long Row GNUCREG(d0),
    register __d1 unsigned long Flags GNUCREG(d1), register __d2 unsigned long SpcChar GNUCREG(d2));
struct TuComposerTrackEffect * ASM libAllocEffect ( register __d0 unsigned long EffectByte GNUCREG(d0),
    register __d1 unsigned long DataWord GNUCREG(d1));
ULONG ASM libFreeEffect ( register __a0 struct TuComposerTrackEffect *EffStr GNUCREG(a0));
ULONG ASM libAddEffect ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0),
    register __a1 struct TuComposerTrackEffect *EffStr GNUCREG(a1), register __d0 unsigned long Row GNUCREG(d0));
ULONG ASM libRemEffect ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long Row GNUCREG(d0));
ULONG ASM libInsertEffect ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0),
    register __a1 struct TuComposerTrackEffect *EffStr GNUCREG(a1),
    register __a2 struct TuComposerTrackEffect *EffPos GNUCREG(a2), register __d0 unsigned long Row GNUCREG(d0));
ULONG ASM libDeleteEffect ( register __a0 struct TuComposerTrackEffect *EffStr GNUCREG(a0));
ULONG ASM libClearEffects ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long Row GNUCREG(d0),
    register __d1 unsigned long NumRows GNUCREG(d1));
ULONG ASM libReMapEffects ( register __a0 struct TuComposerTrack *SrcTrackStr GNUCREG(a0),
    register __a1 struct TuComposerTrack *DestTrackStr GNUCREG(a1), register __d0 unsigned long SrcRow GNUCREG(d0),
    register __d1 unsigned long DestRow GNUCREG(d1), register __d2 unsigned long NumRows GNUCREG(d2));
struct TuComposerTrackData * ASM libAllocTrackData ( register __d0 unsigned long Length GNUCREG(d0));
ULONG ASM libFreeTrackData ( register __a0 struct TuComposerTrackData *TrackData GNUCREG(a0),
    register __d0 unsigned long Length GNUCREG(d0));
ULONG ASM libAddRows ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long NumRows GNUCREG(d0));
ULONG ASM libRemRows ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long NumRows GNUCREG(d0));
ULONG ASM libInsertRows ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long Row GNUCREG(d0),
    register __d1 unsigned long NumRows GNUCREG(d1), register __d2 unsigned long Flags GNUCREG(d2));
ULONG ASM libDeleteRows ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long Row GNUCREG(d0),
    register __d1 unsigned long NumRows GNUCREG(d1), register __d2 unsigned long Flags GNUCREG(d2));
ULONG ASM libClearRows ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long Row GNUCREG(d0),
    register __d1 unsigned long NumRows GNUCREG(d1));
ULONG ASM libReMapRows ( register __a0  struct TuComposerTrack *SrcTrackStr GNUCREG(a0),
    register __a1 struct TuComposerTrack *DestTrackStr GNUCREG(a1), register __d0 unsigned long SrcRow GNUCREG(d0),
    register __d1 unsigned long DestRow GNUCREG(d1), register __d2 unsigned long NumRows GNUCREG(d2));
ULONG ASM libCopyRows ( register __a0 struct TuComposerTrack *SrcTrackStr GNUCREG(a0),
    register __a1 struct TuComposerTrack *DestTrackStr GNUCREG(a1), register __d0 unsigned long SrcRow GNUCREG(d0),
    register __d1 unsigned long DestRow GNUCREG(d1), register __d2 unsigned long NumRows GNUCREG(d2));
ULONG ASM libSwapRows ( register __a0 struct TuComposerTrack *SrcTrackStr GNUCREG(a0),
    register __a1 struct TuComposerTrack *DestTrackStr GNUCREG(a1), register __d0 unsigned long SrcRow GNUCREG(d0),
    register __d1 unsigned long DestRow GNUCREG(d1), register __d2 unsigned long NumRows GNUCREG(d2));
ULONG ASM libPlayRow ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0),
    register __a1 union FlagPass *FlagPassStr GNUCREG(a1),
    register __d0 unsigned long Row GNUCREG(d0), register __d1 unsigned long Channel GNUCREG(d1));
LONG ASM libCmpTracks ( register __a0 struct TuComposerTrack *SrcTrackStr GNUCREG(a0),
   register __a1 struct TuComposerTrack *DestTrackStr GNUCREG(a1));
struct TuComposerPacked * ASM libPackTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0));
struct TuComposerTrack * ASM libUnPackTrack ( register __a0 struct TuComposerPacked *PackedTrackStr GNUCREG(a0),
     register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1));
void ASM libFreePackedTrack ( register __a0 struct TuComposerPacked *PackedTrackStr GNUCREG(a0));
struct TuComposerTrack * ASM libLoadTrack ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1), register __a2 struct TuComposerExtList *ExtLibStr GNUCREG(a2),
    register __a3 union FlagPass *FlagPassStr GNUCREG(a3), register __d0 unsigned long NumTrack GNUCREG(d0));
ULONG ASM libSaveTrack ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1), register __a2 struct TuComposerExtList *ExtLibStr GNUCREG(a2),
    register __a3 union FlagPass *FlagPassStr GNUCREG(a3));
struct TuComposerExtList * ASM libIdentifyTrack ( register __a0 struct CFHandle *CFHandle GNUCREG(a0));
struct TrackInfo * ASM libGetTrackInfo ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerExtList *ExtLibStr GNUCREG(a1), register __d0 unsigned long NumTrack GNUCREG(d0));
ULONG ASM libFreeTrackInfo ( register __a0 struct TrackInfo *TrackInfoStr GNUCREG(a0));
ULONG ASM libGetTracks ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerExtList *ExtLibStr GNUCREG(a1));
struct TuComposerTrack * ASM libPushTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0));
ULONG ASM libPopTrack ( register __a0 struct TuComposerTrack *TrackBuf GNUCREG(a0));
struct TuComposerTrack * ASM libCutTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0),
    register __a1 struct TuComposerTrack *TrackBuf GNUCREG(a1));
struct TuComposerTrack * ASM libCopyTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0),
    register __a1 struct TuComposerTrack *TrackBuf GNUCREG(a1));
struct TuComposerTrack * ASM libPasteTrack ( register __a0  struct TuComposerTrack *TrackBuf GNUCREG(a0),
    register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1));
ULONG ASM libSwapTrack ( register __a0 struct TuComposerTrack *TrackBuf GNUCREG(a0),
     register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1));
ULONG ASM libSwapTrackInSong ( register __a0 struct TuComposerTrack *TrackBuf GNUCREG(a0),
     register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1),
     register __d0 unsigned long Flags GNUCREG(d0));
ULONG ASM libShrinkTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long Scale GNUCREG(d0));
ULONG ASM libExpandTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long Scale GNUCREG(d0));
ULONG ASM libHalveTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long Scale GNUCREG(d0));
ULONG ASM libDoubleTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long Scale GNUCREG(d0));
struct TuComposerTrack * ASM libSplitTrack ( register __a0 struct TuComposerTrack *SrcTrackStr GNUCREG(a0),
     register __a1 struct TuComposerTrack *DestTrackStr GNUCREG(a1), register __d0 unsigned long Row GNUCREG(d0));
ULONG ASM libJoinTrack ( register __a0 struct TuComposerTrack *SrcTrackStr GNUCREG(a0),
    register __a1 struct TuComposerTrack *DestTrackStr GNUCREG(a1));
ULONG ASM libPlayTrack ( register __a0 union FlagPass *FlagPassStr GNUCREG(a0),
    register __d0 unsigned long Order GNUCREG(d0), register __d1 unsigned long Channel GNUCREG(d1),
    register __d2 unsigned long Row GNUCREG(d2));
ULONG ASM libTrackNoteShift ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0),
   register __d0 long HalfNotes GNUCREG(d0), register __d1 unsigned long StartRow GNUCREG(d1), register __d2 unsigned long EndRow GNUCREG(d2));
ULONG ASM libScrollTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 long Rows GNUCREG(d0),
    register __d1 unsigned long StartRow GNUCREG(d1), register __d2 unsigned long EndRow GNUCREG(d2));
ULONG ASM libRotateTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 long Rows GNUCREG(d0),
    register __d1 unsigned long StartRow GNUCREG(d1), register __d2 unsigned long EndRow GNUCREG(d2));
ULONG ASM libFlipTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long Scale GNUCREG(d0),
    register __d1 unsigned long StartRow GNUCREG(d1), register __d2 unsigned long EndRow GNUCREG(d2));
struct TuComposerInstr * ASM libAllocInstr ( register __d0 unsigned long NumSamples GNUCREG(d0));
ULONG ASM libFreeInstr ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0));
ULONG ASM libAddInstr ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerInstr *InstrStr GNUCREG(a1));
ULONG ASM libRemInstr ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0));
ULONG ASM libInsertInstr ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerInstr *InstrStr GNUCREG(a1), register __a2 struct TuComposerInstr *InstrPos GNUCREG(a2));
ULONG ASM libDeleteInstr ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0));
ULONG ASM libClearInstr ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0));
struct TuComposerInstr * ASM libDupInstr ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0));
ULONG ASM libReMapInstr ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0),
    register __a1 struct TuComposerInstr *NewInstrStr GNUCREG(a1));
ULONG ASM libAddInstrUnknownChunk ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1));
ULONG ASM libRemInstrUnknownChunk ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0));
ULONG ASM libInsertInstrUnknownChunk ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1),
    register __a2 struct UnknownChunk *UnknownChunkPos GNUCREG(a2));
ULONG ASM libGetNumInstrs ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0));
ULONG ASM libGetInstrNum ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerInstr *InstrStr GNUCREG(a1));
struct TuComposerInstr * ASM libGetInstrAddr ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __d0 unsigned long Num GNUCREG(d0));
struct TuComposerInstr * ASM libLoadInstr ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerInstr *InstrStr GNUCREG(a1), register __a2 struct TuComposerExtList *ExtLibStr GNUCREG(a2),
    register __a3 union FlagPass *FlagPassStr GNUCREG(a3), register __d0 unsigned long NumInstr GNUCREG(d0));
ULONG ASM libSaveInstr ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerInstr *InstrStr GNUCREG(a1), register __a2 struct TuComposerExtList *ExtLibStr GNUCREG(a2),
    register __a3 union FlagPass *FlagPassStr GNUCREG(a3));
struct TuComposerExtList * ASM libIdentifyInstr ( register __a0 struct CFHandle *CFHandle GNUCREG(a0));
struct InstrInfo * ASM libGetInstrInfo ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerExtList *ExtLibStr GNUCREG(a1), register __d0 unsigned long NumInstr GNUCREG(d0));
ULONG ASM libFreeInstrInfo ( register __a0 struct InstrInfo *InstrInfoStr GNUCREG(a0));
ULONG ASM libGetInstrs ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerExtList *ExtLibStr GNUCREG(a1));
struct TuComposerInstr * ASM libPushInstr ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0));
ULONG ASM libPopInstr ( register __a0 struct TuComposerInstr *InstrBuf GNUCREG(a0));
struct TuComposerInstr * ASM libCutInstr ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0),
    register __a1 struct TuComposerInstr *InstrBuf GNUCREG(a1));
struct TuComposerInstr * ASM libCopyInstr ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0),
    register __a1 struct TuComposerInstr *InstrBuf GNUCREG(a1));
struct TuComposerInstr * ASM libPasteInstr ( register __a0 struct TuComposerInstr *InstrBuf GNUCREG(a0),
    register __a1 struct TuComposerInstr *InstrStr GNUCREG(a1));
ULONG ASM libSwapInstr ( register __a0 struct TuComposerInstr *InstrBuf GNUCREG(a0),
    register __a1 struct TuComposerInstr *InstrStr GNUCREG(a1));
ULONG ASM libSwapInstrInModule ( register __a0 struct TuComposerInstr *InstrBuf GNUCREG(a0),
    register __a1 struct TuComposerInstr *InstrStr GNUCREG(a1),
    register __d0 unsigned long Flags GNUCREG(d0));
ULONG ASM libPlayInstr ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0),
    register __a1 union FlagPass *FlagPassStr GNUCREG(a1),
    register __d0 unsigned long Channel GNUCREG(d0), register __d1 unsigned long Note GNUCREG(d1),
    register __d2 unsigned long Volume GNUCREG(d2));
LONG ASM libCmpInstrs ( register __a0 struct TuComposerInstr *SrcInstrStr GNUCREG(a0),
    register __a1 struct TuComposerInstr *DestInstrStr GNUCREG(a1));
struct TuComposerInstrEnvelope ** ASM libGetInstrEnvelopes ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0));
ULONG ASM libFreeInstrEnvelopes ( register __a0 struct TuComposerInstrEnvelope **InstrEnvStr GNUCREG(a0));
ULONG ASM libAddInstrEnvelopes ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0),
    register __d0 unsigned long Flags GNUCREG(d0));
struct TuComposerInstrKeyboard * ASM libGetInstrKeyboard ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0));
struct TuComposerSample ** ASM libGetInstrSamples ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0));
ULONG ASM libFreeInstrSamples ( register __a0 struct TuComposerSample **InstrSmpStr GNUCREG(a0));
struct TuComposerInstrEnvelope * ASM libCreateEnvelope ( register __d0 unsigned long NumPoints GNUCREG(d0),
    register __d1 unsigned long Type GNUCREG(d1), register __d2 unsigned long Scale GNUCREG(d2), register __d3 long YOffset GNUCREG(d3),
    register __d4 unsigned long Nodes GNUCREG(d4));
ULONG ASM libFreeEnvelope ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0));
ULONG ASM libAddEnvelope ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
     register __a1 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a1));
ULONG ASM libRemEnvelope ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0));
ULONG ASM libInsertEnvelope ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
     register __a1 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a1),
     register __a2 struct TuComposerInstrEnvelope *EnvPos GNUCREG(a2));
ULONG ASM libDeleteEnvelope ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0));
ULONG ASM libClearEnvelope ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __d0 unsigned long Type GNUCREG(d0), register __d1 unsigned long Scale GNUCREG(d1), register __d2 unsigned long YOffset GNUCREG(d2));
struct TuComposerInstrEnvelope * ASM libDupEnvelope ( register __a0 struct TuComposerInstrEnvelope
    *EnvStr GNUCREG(a0));
ULONG ASM libReMapEnvelope ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __a1 struct TuComposerInstrEnvelope *NewEnvStr GNUCREG(a1));
ULONG ASM libReSizeEnvelope ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __d0 unsigned long Entries GNUCREG(d0));
ULONG ASM libValidateEnvNodes ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0));
ULONG ASM libAddEnvelopeUnknownChunk ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1));
ULONG ASM libRemEnvelopeUnknownChunk ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0));
ULONG ASM libInsertEnvelopeUnknownChunk ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1),
    register __a2 struct UnknownChunk *UnknownChunkPos GNUCREG(a2));
ULONG ASM libGetNumEnvelopes ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0));
ULONG ASM libGetEnvelopeNum ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a1));
struct TuComposerInstrEnvelope * ASM libGetEnvelopeAddr ( register __a0 struct TuComposerModule
    *ModuleStr GNUCREG(a0), register __d0 unsigned long Num GNUCREG(d0));
ULONG ASM libSwapEnvelopeInModule ( register __a0 struct TuComposerInstrEnvelope *EnvBuf GNUCREG(a0),
    register __a1 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a1),
    register __d0 unsigned long Flags GNUCREG(d0));
struct TuComposerInstrEnvelope * ASM libLoadEnvelope ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a1), register __d0 unsigned long NumEnv GNUCREG(d0));
ULONG ASM libSaveEnvelope ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a1));
ULONG ASM libShrinkEnvelope ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __d0 unsigned long Scale GNUCREG(d0));
ULONG ASM libExpandEnvelope ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __d0 unsigned long Scale GNUCREG(d0));
ULONG ASM libHalveEnvelope ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __d0 unsigned long Scale GNUCREG(d0));
ULONG ASM libDoubleEnvelope ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __d0 unsigned long Scale GNUCREG(d0));
struct TuComposerInstrEnvelope * ASM libSplitEnvelope (     register __a0 struct TuComposerInstrEnvelope *SrcEnvStr GNUCREG(a0),
    register __a1 struct TuComposerInstrEnvelope *DestEnvStr GNUCREG(a1), register __d0 unsigned long Point GNUCREG(d0));
ULONG ASM libJoinEnvelope ( register __a0 struct TuComposerInstrEnvelope *SrcEnvStr GNUCREG(a0),
    register __a1 struct TuComposerInstrEnvelope *DestEnvStr GNUCREG(a1));
ULONG ASM libScrollEnvelope ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0), register __d0 long Points GNUCREG(d0),
    register __d1 unsigned long StartPoint GNUCREG(d1), register __d2 unsigned long EndPoint GNUCREG(d2));
ULONG ASM libRotateEnvelope ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0), register __d0 long Points GNUCREG(d0),
    register __d1 unsigned long StartPoint GNUCREG(d1), register __d2 unsigned long EndPoint GNUCREG(d2));
ULONG ASM libFlipEnvelope ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __d0 unsigned long Scale GNUCREG(d0), register __d1 unsigned long StartPoint GNUCREG(d1), register __d2 unsigned long EndPoint GNUCREG(d2));
ULONG ASM libAddEnvPoint ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __d0 unsigned long Points GNUCREG(d0));
ULONG ASM libRemEnvPoint ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __d0 unsigned long Points GNUCREG(d0));
ULONG ASM libInsertEnvPoint ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __d0 unsigned long Point GNUCREG(d0), register __d1 unsigned long Points GNUCREG(d1), register __d2 unsigned long Flags GNUCREG(d2));
ULONG ASM libDeleteEnvPoint ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __d0 unsigned long Point GNUCREG(d0), register __d1 unsigned long Points GNUCREG(d1), register __d2 unsigned long Flags GNUCREG(d2));
LONG ASM libCmpEnvelopes ( register __a0 struct TuComposerInstrEnvelope *SrcEnvStr GNUCREG(a0),
    register __a1 struct TuComposerInstrEnvelope *DestEnvStr GNUCREG(a1));
struct TuComposerInstrKeyboard * ASM libAllocKeyboard ( void );
ULONG ASM libFreeKeyboard ( register __a0 struct TuComposerInstrKeyboard *KeybrdStr GNUCREG(a0));
ULONG ASM libAddKeyboard ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerInstrKeyboard *KeybrdStr GNUCREG(a1));
ULONG ASM libRemKeyboard ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0));
ULONG ASM libInsertKeyboard ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerInstrKeyboard *KeybrdStr GNUCREG(a1),
    register __a2 struct TuComposerInstrKeyboard *KeybrdPos GNUCREG(a2));
ULONG ASM libDeleteKeyboard ( register __a0 struct TuComposerInstrKeyboard *KeybrdStr GNUCREG(a0));
ULONG ASM libClearKeyboard ( register __a0 struct TuComposerInstrKeyboard *KeybrdStr GNUCREG(a0));
struct TuComposerInstrKeyboard * ASM libDupKeyboard ( register __a0 struct TuComposerInstrKeyboard
    *KeybrdStr GNUCREG(a0));
ULONG ASM libReMapKeyboard ( register __a0 struct TuComposerInstrKeyboard *KeybrdStr GNUCREG(a0),
    register __a1 struct TuComposerInstrKeyboard *NewKeybrdStr GNUCREG(a1));
ULONG ASM libGetNumKeyboards ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0));
ULONG ASM libGetKeyboardNum ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerInstrKeyboard *KeybrdStr GNUCREG(a1));
struct TuComposerInstrKeyboard * ASM libGetKeyboardAddr (     register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0), register __d0 unsigned long Num GNUCREG(d0));
ULONG ASM libSwapKeyboardInModule ( register __a0 struct TuComposerInstrKeyboard *KeybrdBuf GNUCREG(a0),
    register __a1 struct TuComposerInstrKeyboard *KeybrdStr GNUCREG(a1),
    register __d0 unsigned long Flags GNUCREG(d0));
ULONG ASM libSetKeyboard ( register __a0 struct TuComposerInstrKeyboard *KeybrdStr GNUCREG(a0),
    register __d0 unsigned long SampleNum GNUCREG(d0), register __d1 unsigned long Octave GNUCREG(d1), register __d2 unsigned long Note GNUCREG(d2),
    register __d3 unsigned long NewOctave GNUCREG(d3), register __d4 unsigned long NewNote GNUCREG(d4));
LONG ASM libCheckKeyboard ( register __a0 struct TuComposerInstrKeyboard *KeybrdStr GNUCREG(a0));
LONG ASM libCmpKeyboards ( register __a0 struct TuComposerInstrKeyboard *SrcKeybrdStr GNUCREG(a0),
    register __a1 struct TuComposerInstrKeyboard *DestKeybrdStr GNUCREG(a1));
struct TuComposerInstrArpeggio * ASM libAllocArpeggio ( register __d0 unsigned long NumEntries GNUCREG(d0));
ULONG ASM libFreeArpeggio ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0));
ULONG ASM libAddArpeggio ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a1));
ULONG ASM libRemArpeggio ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0));
ULONG ASM libInsertArpeggio ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a1),
    register __a2 struct TuComposerInstrArpeggio *ArpPos GNUCREG(a2));
ULONG ASM libDeleteArpeggio ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0));
ULONG ASM libClearArpeggio ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0));
struct TuComposerInstrArpeggio * ASM libDupArpeggio ( register __a0 struct TuComposerInstrArpeggio
    *ArpStr GNUCREG(a0));
ULONG ASM libReMapArpeggio ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0),
    register __a1 struct TuComposerInstrArpeggio *NewArpStr GNUCREG(a1));
ULONG ASM libReSizeArpeggio ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0),
    register __d0 unsigned long Entries GNUCREG(d0));
ULONG ASM libGetNumArpeggios ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0));
ULONG ASM libGetArpeggioNum ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a1));
struct TuComposerInstrArpeggio * ASM libGetArpeggioAddr ( register __a0 struct TuComposerModule
    *ModuleStr GNUCREG(a0), register __d0 unsigned long Num GNUCREG(d0));
ULONG ASM libSwapArpeggioInModule ( register __a0 struct TuComposerInstrArpeggio *ArpBuf GNUCREG(a0),
    register __a1 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a1),
    register __d0 unsigned long Flags GNUCREG(d0));
ULONG ASM libShrinkArpeggio ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0),
    register __d0 unsigned long Scale GNUCREG(d0));
ULONG ASM libExpandArpeggio ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0),
    register __d0 unsigned long Scale GNUCREG(d0));
ULONG ASM libHalveArpeggio ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0),
    register __d0 unsigned long Scale GNUCREG(d0));
ULONG ASM libDoubleArpeggio ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0),
    register __d0 unsigned long Scale GNUCREG(d0));
struct TuComposerInstrArpeggio * ASM libSplitArpeggio (     register __a0 struct TuComposerInstrArpeggio *SrcArpStr GNUCREG(a0),
    register __a1 struct TuComposerInstrArpeggio *DestArpStr GNUCREG(a1), register __d0 unsigned long Tick GNUCREG(d0));
ULONG ASM libJoinArpeggio ( register __a0 struct TuComposerInstrArpeggio *SrcArpStr GNUCREG(a0),
    register __a1 struct TuComposerInstrArpeggio *DestArpStr GNUCREG(a1));
ULONG ASM libScrollArpeggio ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0), register __d0 long Ticks GNUCREG(d0),
    register __d1 unsigned long StartTick GNUCREG(d1), register __d2 unsigned long EndTick GNUCREG(d2));
ULONG ASM libRotateArpeggio ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0), register __d0 long Ticks GNUCREG(d0),
    register __d1 unsigned long StartTick GNUCREG(d1), register __d2 unsigned long EndTick GNUCREG(d2));
ULONG ASM libFlipArpeggio ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0),
    register __d0 unsigned long Scale GNUCREG(d0), register __d1 unsigned long StartTick GNUCREG(d1), register __d2 unsigned long EndTick GNUCREG(d2));
ULONG ASM libAddArpeggioTick ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0),
    register __d0 unsigned long Ticks GNUCREG(d0));
ULONG ASM libRemArpeggioTick ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0),
    register __d0 unsigned long Ticks GNUCREG(d0));
ULONG ASM libInsertArpeggioTick ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0),
    register __d0 unsigned long Tick GNUCREG(d0), register __d1 unsigned long Ticks GNUCREG(d1), register __d2 unsigned long Flags GNUCREG(d2));
ULONG ASM libDeleteArpeggioTick ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0),
    register __d0 unsigned long Tick GNUCREG(d0), register __d1 unsigned long Ticks GNUCREG(d1), register __d2 unsigned long Flags GNUCREG(d2));
LONG ASM libCmpArpeggios ( register __a0 struct TuComposerInstrArpeggio *SrcArpStr GNUCREG(a0),
    register __a1 struct TuComposerInstrArpeggio *DestArpStr GNUCREG(a1));
struct TuComposerSample * ASM libAllocSample ( register __a0 WORD *SampleData GNUCREG(a0),
    register __d0 unsigned long Length GNUCREG(d0));
ULONG ASM libFreeSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0));
ULONG ASM libAddSample ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleStr GNUCREG(a1));
ULONG ASM libRemSample ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0));
ULONG ASM libInsertSample ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleStr GNUCREG(a1),
    register __a2 struct TuComposerSample *SamplePos GNUCREG(a2));
ULONG ASM libDeleteSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0));
ULONG ASM libClearSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0));
struct TuComposerSample * ASM libDupSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0));
ULONG ASM libReSizeSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long NewSamples GNUCREG(d0));
ULONG ASM libAddSampleUnknownChunk ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1));
ULONG ASM libRemSampleUnknownChunk ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0));
ULONG ASM libInsertSampleUnknownChunk ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1),
    register __a2 struct UnknownChunk *UnknownChunkPos GNUCREG(a2));
ULONG ASM libGetNumSamples ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0));
ULONG ASM libGetSampleNum ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleStr GNUCREG(a1));
struct TuComposerSample * ASM libGetSampleAddr ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0),
    register __d0 unsigned long Num GNUCREG(d0));
struct TuComposerSample * ASM libPushSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0));
ULONG ASM libPopSample ( register __a0 struct TuComposerSample *SampleBuf GNUCREG(a0));
struct TuComposerSample * ASM libCutSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleBuf GNUCREG(a1));
struct TuComposerSample * ASM libCopySample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleBuf GNUCREG(a1));
struct TuComposerSample * ASM libPasteSample ( register __a0 struct TuComposerSample *SampleBuf GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleStr GNUCREG(a1));
ULONG ASM libSwapSample ( register __a0 struct TuComposerSample *SampleBuf GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleStr GNUCREG(a1));
ULONG ASM libSwapSampleInInstr ( register __a0 struct TuComposerSample *SampleBuf GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleStr GNUCREG(a1),
    register __d0 unsigned long Flags GNUCREG(d0));
ULONG ASM libPlaySample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __a1 union FlagPass *FlagPassStr GNUCREG(a1),
    register __d0 unsigned long Channel GNUCREG(d0), register __d1 unsigned long Frequency GNUCREG(d1),
    register __d2 unsigned long Volume GNUCREG(d2));
struct TuComposerSample * ASM libLoadSample ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleStr GNUCREG(a1), register __a2 struct TuComposerExtList *ExtLibStr GNUCREG(a2),
    register __a3 union FlagPass *FlagPassStr GNUCREG(a3), register __d0 unsigned long NumSample GNUCREG(d0));
ULONG ASM libSaveSample ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleStr GNUCREG(a1), register __a2 struct TuComposerExtList *ExtLibStr GNUCREG(a2),
    register __a3 union FlagPass *FlagPassStr GNUCREG(a3));
struct TuComposerExtList * ASM libIdentifySample ( register __a0 struct CFHandle *CFHandle GNUCREG(a0));
struct SampleInfo * ASM libGetSampleInfo ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerExtList *ExtLibStr GNUCREG(a1), register __d0 unsigned long NumSample GNUCREG(d0));
ULONG ASM libFreeSampleInfo ( register __a0 struct SampleInfo *SampleInfoStr GNUCREG(a0));
ULONG ASM libGetSamples ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerExtList *ExtLibStr GNUCREG(a1));
ULONG ASM libCalcSamplePlayFreq ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long Octave GNUCREG(d0), register __d1 unsigned long Note GNUCREG(d1));
ULONG ASM libCalcFineTune ( register __d0 unsigned long Note GNUCREG(d0), register __d1 long FineTune GNUCREG(d1));
ULONG ASM libConvertSampleFrequency ( register __d0 unsigned long Period GNUCREG(d0));
ULONG ASM libCalcLinearFrequency ( register __d0 unsigned long SampleFreq GNUCREG(d0), register __d1 long SlideValue GNUCREG(d1));
WORD *ASM libAllocSampleData ( register __d0 unsigned long Length GNUCREG(d0));
ULONG ASM libFreeSampleData ( register __a0 WORD *SampleData GNUCREG(a0), register __d0 unsigned long Length GNUCREG(d0));
ULONG ASM libSetSampleData ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0), register __a1 WORD *SampleData GNUCREG(a1),
    register __d0 unsigned long Length GNUCREG(d0));
ULONG ASM libAddSampleData ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long NumSamples GNUCREG(d0));
ULONG ASM libRemSampleData ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long NumSamples GNUCREG(d0));
ULONG ASM libInsertSampleData ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long SamplePos GNUCREG(d0), register __d1 unsigned long NumSamples GNUCREG(d1));
ULONG ASM libDeleteSampleData ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long SamplePos GNUCREG(d0), register __d1 unsigned long NumSamples GNUCREG(d1));
ULONG ASM libClearSampleData ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long FirstSmp GNUCREG(d0), register __d1 unsigned long LastSmp GNUCREG(d1));
WORD *ASM libDupSampleData ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0));
struct TuComposerSample * ASM libCutSampleData ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleBuf GNUCREG(a1),
    register __d0 unsigned long FirstSmp GNUCREG(d0), register __d1 unsigned long LastSmp GNUCREG(d1));
struct TuComposerSample * ASM libCopySampleData ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleBuf GNUCREG(a1),
    register __d0 unsigned long FirstSmp GNUCREG(d0), register __d1 unsigned long LastSmp GNUCREG(d1));
struct TuComposerSample * ASM libPasteSampleData ( register __a0 struct TuComposerSample
    *SampleBuf GNUCREG(a0), register __a1 struct TuComposerSample *SampleStr GNUCREG(a1),
    register __d0 unsigned long PasteSmp GNUCREG(d0), register __d1 unsigned long Flags GNUCREG(d1));
struct TuComposerSample * ASM libCropSampleData ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleBuf GNUCREG(a1),
    register __d0 unsigned long FirstSmp GNUCREG(d0), register __d1 unsigned long LastSmp GNUCREG(d1));
struct TuComposerSample * ASM libLoadSampleData ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleStr GNUCREG(a1), register __d0 unsigned long NumBytes GNUCREG(d0));
ULONG ASM libSaveSampleData ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleStr GNUCREG(a1), register __d0 unsigned long FirstSmp GNUCREG(d0),
    register __d1 unsigned long LastSmp GNUCREG(d1));
ULONG ASM libConvertBits ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long DestBitDepth GNUCREG(d0), register __d1 unsigned long Flags GNUCREG(d1));
ULONG ASM libGetOptimalBits ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long Flags GNUCREG(d0));
ULONG ASM libConvertSigned ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0));
ULONG ASM libConvertWord ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0));
ULONG ASM libDecrunchSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long DeltaBitDepth GNUCREG(d0));
ULONG ASM libBackwards ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0), register __d0 unsigned long StartSmp GNUCREG(d0),
    register __d1 unsigned long LastSmp GNUCREG(d1));
ULONG ASM libMixSamples ( register __a0 struct TuComposerSample *SrcSampleStr GNUCREG(a0),
    register __a1 struct TuComposerSample *DestSampleStr GNUCREG(a1), register __d0 unsigned long SrcStartSmp GNUCREG(d0),
    register __d1 unsigned long SrcLastSmp GNUCREG(d1), register __d2 unsigned long DestStartSmp GNUCREG(d2));
struct TuComposerSample * ASM libSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __a1 struct TuComposerExtList *InpDevStr GNUCREG(a1), register __a2 WORD *Buffer GNUCREG(a2),
    register __d0 unsigned long Frequency GNUCREG(d0), register __d1 unsigned long BitDepth GNUCREG(d1), register __d2 unsigned long BufLen GNUCREG(d2),
    register __d3 unsigned long Flags GNUCREG(d3));
ULONG ASM libOctaveUp ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0));
ULONG ASM libOctaveDown ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0));
ULONG ASM libReSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long NewFrequency GNUCREG(d0), register __d1 unsigned long OldFrequency GNUCREG(d1),
    register __d2 unsigned long Flags GNUCREG(d2));
ULONG ASM libInvertSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0));
ULONG ASM libXFadeSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0));
ULONG ASM libAmplifySample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long StartAmplify GNUCREG(d0), register __d1 unsigned long EndAmplify GNUCREG(d1),
    register __d2 unsigned long StartSmp GNUCREG(d2), register __d3 unsigned long LastSmp GNUCREG(d3));
ULONG ASM libGetBiggestAmplify ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long StartSmp GNUCREG(d0), register __d1 unsigned long LastSmp GNUCREG(d1));
ULONG ASM libGetLowestAmplify ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long StartSmp GNUCREG(d0), register __d1 unsigned long LastSmp GNUCREG(d1));
ULONG ASM libCreateEcho ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0));
ULONG ASM libBoostSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0));
ULONG ASM libFilterSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0));
ULONG ASM libMorphSamples ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0));
ULONG ASM libMinimizeSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0));
struct TuComposerSample * ASM libFindOriginSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0));
LONG ASM libGetSampleValue ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long Sample GNUCREG(d0));
ULONG ASM libGetSampleValueArray ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __a1 LONG *ArrayPtr GNUCREG(a1), register __d0 unsigned long StartSmp GNUCREG(d0), register __d1 unsigned long ArrayEntries GNUCREG(d1));
LONG ASM libCmpSamples ( register __a0 struct TuComposerSample *SrcSampleStr GNUCREG(a0),
    register __a1 struct TuComposerSample *DestSampleStr GNUCREG(a1));
struct TuComposerSynth * ASM libAllocSynth ( register __d0 unsigned long CodeLen GNUCREG(d0),
    register __d1 unsigned long Waveforms GNUCREG(d1), register __d2 unsigned long WaveLen GNUCREG(d2));
ULONG ASM libFreeSynth ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0));
ULONG ASM libAssignSynth ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthStr GNUCREG(a1));
ULONG ASM libClearSynth ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0));
struct TuComposerSynth * ASM libDupSynth ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0));
ULONG ASM libReMapSynth ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynth *NewSynthStr GNUCREG(a1));
ULONG ASM libAddSynthUnknownChunk ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1));
ULONG ASM libRemSynthUnknownChunk ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0));
ULONG ASM libInsertSynthUnknownChunk ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1),
    register __a2 struct UnknownChunk *UnknownChunkPos GNUCREG(a2));
ULONG ASM libGetNumSynths ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0));
ULONG ASM libGetSynthNum ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthStr GNUCREG(a1));
struct TuComposerSynth * ASM libGetSynthAddr ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __d0 unsigned long SynthNum GNUCREG(d0));
struct TuComposerSynth * ASM libPushSynth ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0));
ULONG ASM libPopSynth ( register __a0 struct TuComposerSynth *SynthBuf GNUCREG(a0));
struct TuComposerSynth * ASM libCutSynth ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthBuf GNUCREG(a1));
struct TuComposerSynth * ASM libCopySynth ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthBuf GNUCREG(a1));
struct TuComposerSynth * ASM libPasteSynth ( register __a0 struct TuComposerSynth *SynthBuf GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthStr GNUCREG(a1));
ULONG ASM libSwapSynth ( register __a0 struct TuComposerSynth *SynthBuf GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthStr GNUCREG(a1));
struct TuComposerSynth * ASM libLoadSynth ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthStr GNUCREG(a1), register __a2  struct TuComposerExtList *ExtLibStr GNUCREG(a2),
    register __a3 union FlagPass *FlagPassStr GNUCREG(a3), register __d0 unsigned long NumSynth GNUCREG(d0));
ULONG ASM libSaveSynth ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthStr GNUCREG(a1), register __a2 struct TuComposerExtList *ExtLibStr GNUCREG(a2),
    register __a3 union FlagPass *FlagPassStr GNUCREG(a3));
struct TuComposerExtList * ASM libIdentifySynth ( register __a0 struct CFHandle *CFHandle GNUCREG(a0));
struct SynthInfo * ASM libGetSynthInfo ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerExtList *ExtLibStr GNUCREG(a1), register __d0 unsigned long NumSynth GNUCREG(d0));
ULONG ASM libFreeSynthInfo ( register __a0 struct SynthInfo *SynthInfoStr GNUCREG(a0));
ULONG ASM libGetSynths ( register __a0 struct CFHandle *CFHandle GNUCREG(a0), register __a1 struct TuComposerExtList
    *ExtLibStr GNUCREG(a1));
LONG ASM libCmpSynths ( register __a0 struct TuComposerSynth *SrcSynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynth *DestSynthStr GNUCREG(a1));
struct TuComposerSynthWave * ASM libAllocWaveform ( register __d0 unsigned long WaveLength GNUCREG(d0));
ULONG ASM libFreeWaveform ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0));
ULONG ASM libAddWaveform ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynthWave *WaveformStr GNUCREG(a1));
ULONG ASM libRemWaveform ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0));
ULONG ASM libInsertWaveform ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynthWave *WaveformStr GNUCREG(a1),
    register __a2 struct TuComposerSynthWave *WaveformPos GNUCREG(a2));
ULONG ASM libDeleteWaveform ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0));
ULONG ASM libClearWaveform ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0));
struct TuComposerSynthWave * ASM libDupWaveform ( register __a0 struct TuComposerSynthWave
    *WaveformStr GNUCREG(a0));
ULONG ASM libReSizeWaveform ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0),
    register __d0 unsigned long NewLen GNUCREG(d0));
ULONG ASM libGetNumWaveforms ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0));
ULONG ASM libGetWaveformNum ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynthWave *WaveformStr GNUCREG(a1));
struct TuComposerSynthWave * ASM libGetWaveformAddr ( register __a0 struct TuComposerSynth
    *SynthStr GNUCREG(a0), register __d0 unsigned long WaveformNum GNUCREG(d0));
struct TuComposerSynthWave * ASM libPushWaveform ( register __a0 struct TuComposerSynthWave
    *WaveformStr GNUCREG(a0));
ULONG ASM libPopWaveform ( register __a0 struct TuComposerSynthWave *WaveformBuf GNUCREG(a0));
struct TuComposerSynthWave * ASM libCutWaveform ( register __a0 struct TuComposerSynthWave
    *WaveformStr GNUCREG(a0), register __a1 struct TuComposerSynthWave *WaveformBuf GNUCREG(a1));
struct TuComposerSynthWave * ASM libCopyWaveform ( register __a0 struct TuComposerSynthWave
    *WaveformStr GNUCREG(a0), register __a1 struct TuComposerSynthWave *WaveformBuf GNUCREG(a1));
struct TuComposerSynthWave * ASM libPasteWaveform ( register __a0 struct TuComposerSynthWave
    *WaveformBuf GNUCREG(a0), register __a1 struct TuComposerSynthWave *WaveformStr GNUCREG(a1));
ULONG ASM libSwapWaveform ( register __a0 struct TuComposerSynthWave *WaveformBuf GNUCREG(a0),
    register __a1 struct TuComposerSynthWave *WaveformStr GNUCREG(a1));
ULONG ASM libSwapWaveformInSynth ( register __a0 struct TuComposerSynthWave *WaveformBuf GNUCREG(a0),
    register __a1 struct TuComposerSynthWave *WaveformStr GNUCREG(a1));
struct TuComposerSynthWave * ASM libLoadWaveform ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSynthWave *WaveformStr GNUCREG(a1), register __d0 unsigned long NumBytes GNUCREG(d0));
ULONG ASM libSaveWaveform ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSynthWave *WaveformStr GNUCREG(a1), register __d0 unsigned long FirstSmp GNUCREG(d0),
    register __d1 unsigned long LastSmp GNUCREG(d1));
ULONG ASM libPlayWaveform ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0), register __a1 union FlagPass *FlagPassStr GNUCREG(a1),
    register __d0 unsigned long Frequency GNUCREG(d0));
ULONG ASM libAddWaveformPoint ( register __a0 struct TuComposerSynthWave * WaveformStr GNUCREG(a0),
    register __d0 unsigned long Points GNUCREG(d0));
ULONG ASM libRemWaveformPoint ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0),
    register __d0 unsigned long Points GNUCREG(d0));
ULONG ASM libInsertWaveformPoint ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0),
    register __d0 unsigned long Point GNUCREG(d0), register __d1 unsigned long Points GNUCREG(d1), register __d2 unsigned long Flags GNUCREG(d2));
ULONG ASM libDeleteWaveformPoint ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0),
    register __d0 unsigned long Point GNUCREG(d0), register __d1 unsigned long Points GNUCREG(d1), register __d2 unsigned long Flags GNUCREG(d2));
ULONG ASM libFillWaveform ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0),
    register __d0 unsigned long RepLen GNUCREG(d0), register __d1 unsigned long Type GNUCREG(d1), register __d2 unsigned long Scale GNUCREG(d2),
    register __d3 long YOffset GNUCREG(d3));
ULONG ASM libConvertWaveform ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0),
    register __d0 unsigned long DestBitDepth GNUCREG(d0), register __d1 unsigned long Flags GNUCREG(d1));
ULONG ASM libConvertWaveformSigned ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0));
ULONG ASM libConvertWaveformWord ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0));
ULONG ASM libBackwardsWaveform ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0));
ULONG ASM libMixWaveforms ( register __a0 struct TuComposerSynthWave *SrcWaveformStr GNUCREG(a0),
    register __a1 struct TuComposerSynthWave *DestWaveformStr GNUCREG(a1));
ULONG ASM libHalveWaveform ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0));
ULONG ASM libDoubleWaveform ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0));
ULONG ASM libScaleWaveformSize ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0),
    register __d0 unsigned long NewLength GNUCREG(d0), register __d1 unsigned long OldLength GNUCREG(d1), register __d2 unsigned long Flags GNUCREG(d2));
ULONG ASM libInvertWaveform ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0));
ULONG ASM libAmplifyWaveform ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0),
    register __d0 unsigned long Amplify GNUCREG(d0));
ULONG ASM libGetMaxWaveformAmplify ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0));
ULONG ASM libGetMinWaveformAmplify ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0));
ULONG ASM libCopySample2Waveform ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __a1 struct TuComposerSynthWave *WaveformStr GNUCREG(a1));
ULONG ASM libCopyWaveform2Sample ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleStr GNUCREG(a1));
ULONG ASM libCopyEnvelope2Waveform ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __a1 struct TuComposerSynthWave *WaveformStr GNUCREG(a1));
ULONG ASM libCopyWaveform2Envelope ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0),
    register __a1 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a1));
ULONG ASM libTransformWaveform ( register __a0 struct TuComposerSynthWave *SrcWaveformStr GNUCREG(a0),
    register __a1 struct TuComposerSynthWave *DestWaveformStr GNUCREG(a1));
LONG ASM libCmpWaveforms ( register __a0 struct TuComposerSynthWave *SrcWaveformStr GNUCREG(a0),
    register __a1 struct TuComposerSynthWave *DestWaveformStr GNUCREG(a1));
struct TuComposerSynthCode * ASM libAllocSynthCode ( register __d0 unsigned long Lines GNUCREG(d0));
ULONG ASM libFreeSynthCode ( register __a0 struct TuComposerSynthCode *SynthCodeStr GNUCREG(a0),
    register __d0 unsigned long Lines GNUCREG(d0));
ULONG ASM libAssignSynthCode ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynthCode *SynthCodeStr GNUCREG(a1), register __d0 unsigned long Lines GNUCREG(d0));
ULONG ASM libClearSynthCode ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0));
struct TuComposerSynthCode * ASM libDupSynthCode ( register __a0 struct TuComposerSynth
    *SynthStr GNUCREG(a0));
ULONG ASM libReSizeSynthCode ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __d0 unsigned long NewLen GNUCREG(d0));
struct TuComposerSynth * ASM libPushSynthCode ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0));
ULONG ASM libPopSynthCode ( register __a0 struct TuComposerSynth *SynthBuf GNUCREG(a0));
struct TuComposerSynth * ASM libCutSynthCode ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthBuf GNUCREG(a1));
struct TuComposerSynth * ASM libCopySynthCode ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthBuf GNUCREG(a1));
struct TuComposerSynth * ASM libPasteSynthCode ( register __a0 struct TuComposerSynth *SynthBuf GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthStr GNUCREG(a1));
ULONG ASM libSwapSynthCode ( register __a0 struct TuComposerSynth *SynthBuf GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthStr GNUCREG(a1));
ULONG ASM libAddSynthCodeLine ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __d0 unsigned long Lines GNUCREG(d0));
ULONG ASM libRemSynthCodeLine ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __d0 unsigned long Lines GNUCREG(d0));
ULONG ASM libInsertSynthCodeLine ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __d0 unsigned long Line GNUCREG(d0), register __d1 unsigned long Lines GNUCREG(d1), register __d2 unsigned long Flags GNUCREG(d2));
ULONG ASM libDeleteSynthCodeLine ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __d0 unsigned long Line GNUCREG(d0), register __d1 unsigned long Lines GNUCREG(d1), register __d2 unsigned long Flags GNUCREG(d2));
ULONG ASM libGetSynthCodeParams ( register __d0 unsigned long Code GNUCREG(d0));
STRPTR ASM libAssembleCodeLine ( register __a0 STRPTR AsmBuf GNUCREG(a0), register __a1 struct TuComposerSynth *SynthStr GNUCREG(a1),
    register __d0 unsigned long CodeLine GNUCREG(d0), register __d1 unsigned long Flags GNUCREG(d1));
ULONG ASM libDisassembleCodeLine ( register __a0 STRPTR AsmBuf GNUCREG(a0), register __a1 struct TuComposerSynth *SynthStr GNUCREG(a1),
    register __d0 unsigned long CodeLine GNUCREG(d0), register __d1 unsigned long Flags GNUCREG(d1));
struct TuComposerSynthSymbolTable * ASM libAllocSymbol ( register __a0 STRPTR Name GNUCREG(a0));
ULONG ASM libFreeSymbol ( register __a0 struct TuComposerSynthSymbolTable *SymbolStr GNUCREG(a0));
ULONG ASM libAssignSymbol ( register __a0 struct TuComposerSynthSymbolTable *SymbolStr GNUCREG(a0),
    register __a1 STRPTR Name GNUCREG(a1));
struct TuComposerSynthSymbolTable * ASM libDupSymbol (     register __a0 struct TuComposerSynthSymbolTable *SymbolStr GNUCREG(a0));
ULONG ASM libAddSymbol ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynthSymbolTable *SymbolStr GNUCREG(a1));
ULONG ASM libRemSymbol ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0));
ULONG ASM libInsertSymbol ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynthSymbolTable *SymbolStr GNUCREG(a1),
    register __a2 struct TuComposerSynthSymbolTable *SymbolPos GNUCREG(a2));
ULONG ASM libDeleteSymbol ( register __a0 struct TuComposerSynthSymbolTable *SymbolStr GNUCREG(a0));
ULONG ASM libGetNumSymbols ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0));
ULONG ASM libGetSymbolNum ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynthSymbolTable *SymbolStr GNUCREG(a1));
struct TuComposerSynthSymbolTable * ASM libGetSymbolAddr (     register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0), register __d0 unsigned long SymbolNum GNUCREG(d0));
struct TuComposerSynthSymbolTable * ASM libMatchSymbol (     register __a0 struct TuComposerSynthSymbolTable *SymbolStr GNUCREG(a0), register __a1 STRPTR Name GNUCREG(a1),
    register __d0 unsigned long Line GNUCREG(d0), register __d1 unsigned long Type GNUCREG(d1));
ULONG ASM libAddExternalLib ( register __a0 struct TuComposerExtList *ExtLibStr GNUCREG(a0),
    register __d0 unsigned long Type GNUCREG(d0));
struct TuComposerExtList * ASM libRemExternalLib ( register __a0 struct TuComposerExtList
    *ExtLibStr GNUCREG(a0));
struct TuComposerExtLibBase * ASM libOpenExternalLib ( register __a0 struct TuComposerExtList
    *ExtLibStr GNUCREG(a0));
struct TuComposerExtList * ASM libCloseExternalLib ( register __a0 struct TuComposerExtList
    *ExtLibStr GNUCREG(a0));
ULONG ASM libGetExternalLibs ( register __a0 STRPTR ExtLibPatStr GNUCREG(a0));
struct TuComposerExtFlagStr * ASM libAllocFlagStr ( register __a0 struct TuComposerExtFlagStr
    *FlagStr GNUCREG(a0));
struct TuComposerExtList * ASM libCIdentify ( register __d1 STRPTR FileName GNUCREG(d1));
struct CFHandle * ASM libCOpen ( register __d1 STRPTR FileName GNUCREG(d1), register __d2 unsigned long Mode GNUCREG(d2),
    register __d3 struct TuComposerExtList *ExtLibStr GNUCREG(d3));
ULONG ASM libCClose ( register __d1 struct CFHandle *CFHandle GNUCREG(d1));
ULONG ASM libCRead ( register __d1 struct CFHandle *CFHandle GNUCREG(d1), register __d2 APTR Buffer GNUCREG(d2), register __d3 unsigned long Length GNUCREG(d3));
ULONG ASM libCWrite ( register __d1 struct CFHandle *CFHandle GNUCREG(d1), register __d2 APTR Buffer GNUCREG(d2),
    register __d3 unsigned long Length GNUCREG(d3));
ULONG ASM libCSeek ( register __d1 struct CFHandle *CFHandle GNUCREG(d1), register __d2 unsigned long Position GNUCREG(d2),
    register __d3 unsigned long Relative GNUCREG(d3));
ULONG ASM libCGetInfo ( register __d1 struct CFHandle *CFHandle GNUCREG(d1), register __d2 struct CruncherInfo *CInfoStr GNUCREG(d2));

#ifdef __cplusplus
}
#endif

APTR ASM libAllocPMem ( register __d0 unsigned long byteSize GNUCREG(d0))
{
  return ( AllocPMem ( byteSize ));
}

void ASM libFreePMem ( register __a1 APTR memoryBlock GNUCREG(a1), register __d0 unsigned long byteSize GNUCREG(d0))
{
  FreePMem ( memoryBlock, byteSize );
}

void ASM libInitNodeList ( register __a0 struct List *NodeList GNUCREG(a0))
{
  InitNodeList ( NodeList );
}

void ASM libInsertNode ( register __a0 struct List *NodeList GNUCREG(a0), register __a1 struct Node *Node GNUCREG(a1),
    register __a2 struct Node *PredNode GNUCREG(a2))
{
  InsertNode ( NodeList, Node, PredNode );
}

void ASM libAddNodeHead ( register __a0 struct List *NodeList GNUCREG(a0), register __a1 struct Node *Node GNUCREG(a1))
{
  AddNodeHead ( NodeList, Node );
}

void ASM libAddNodeTail ( register __a0 struct List *NodeList GNUCREG(a0), register __a1 struct Node *Node GNUCREG(a1))
{
  AddNodeTail ( NodeList, Node );
}

void ASM libRemoveNode ( register __a1 struct Node *Node GNUCREG(a1))
{
  RemoveNode ( Node );
}

void ASM libRemNodeHead ( register __a0 struct List *NodeList GNUCREG(a0))
{
  RemNodeHead ( NodeList );
}

void ASM libRemNodeTail ( register __a0 struct List *NodeList GNUCREG(a0))
{
  RemNodeTail ( NodeList );
}

void ASM libEnqueueNode ( register __a0 struct List *NodeList GNUCREG(a0), register __a1 struct Node *Node GNUCREG(a1))
{
  EnqueueNode ( NodeList, Node );
}

ULONG ASM libDupNodeList ( register __a0 struct MinList *SrcNodeList GNUCREG(a0),
    register __a1 struct MinList *DestNodeList GNUCREG(a1), register __d0 unsigned long NodeSize GNUCREG(d0))
{
  return ( DupNodeList ( SrcNodeList, DestNodeList, NodeSize ));
}

void ASM libReMapNodeList ( register __a0 struct List *SrcNodeList GNUCREG(a0), register __a1 struct List *DestNodeList GNUCREG(a1))
{
  ReMapNodeList ( SrcNodeList, DestNodeList );
}

STRPTR ASM libAllocNameStr ( register __a0 STRPTR CStr GNUCREG(a0))
{
  return ( AllocNameStr ( CStr ));
}

ULONG ASM libFreeNameStr ( register __a0 STRPTR NameStr GNUCREG(a0))
{
  return ( FreeNameStr ( NameStr ));
}

STRPTR ASM libSetString ( register __a0 STRPTR *StructPos GNUCREG(a0), register __a1 STRPTR CStr GNUCREG(a1))
{
  return ( SetString ( StructPos, CStr ));
}

STRPTR ASM libSetNameStr ( register __a0 STRPTR *StructPos GNUCREG(a0), register __a1 STRPTR NameStr GNUCREG(a1))
{
  return ( SetNameStr ( StructPos, NameStr ));
}

LONG ASM libSin ( register __d0 long Degrees GNUCREG(d0), register __d1 long Amplify GNUCREG(d1))
{
  return ( Sin ( Degrees, Amplify ));
}

LONG ASM libCos ( register __d0 long Degrees GNUCREG(d0), register __d1 long Amplify GNUCREG(d1))
{
  return ( Cos ( Degrees, Amplify ));
}

LONG ASM libTan ( register __d0 long Degrees GNUCREG(d0), register __d1 long Amplify GNUCREG(d1))
{
  return ( Tan ( Degrees, Amplify ));
}

void ASM libDoPlayerIRQ ( register __a0 struct TuComposerBase *TuCBase GNUCREG(a0))
{
  DoPlayerIRQ ( TuCBase );
}

struct PlayExecHandler * ASM libAddPlayExecHandler ( register __a0 struct PlayExecHandler
    *PlayExecStr GNUCREG(a0))
{
  return ( AddPlayExecHandler ( PlayExecStr ));
}

void ASM libRemPlayExecHandler ( register __a0 struct PlayExecHandler *PlayExecStr GNUCREG(a0))
{
  RemPlayExecHandler ( PlayExecStr );
}

void ASM libSetPlayExecHandlerPri ( register __a0 struct PlayExecHandler *PlayExecStr GNUCREG(a0),
    register __d0 long Pri GNUCREG(d0))
{
  SetPlayExecHandlerPri ( PlayExecStr, Pri );
}

void ASM libStamp2Date ( register __a0 struct StampDate *StampDateStr GNUCREG(a0),
    register __a1 struct DateStamp *DateStampStr GNUCREG(a1))
{
  Stamp2Date ( StampDateStr, DateStampStr );
}

struct TuComposerBase * ASM libAllocSimulateMix ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0))
{
  return ( AllocSimulateMix ( SongStr ));
}

void ASM libFreeSimulateMix ( register __a0 struct TuComposerBase *PseudoTuCBase GNUCREG(a0))
{
  FreeSimulateMix ( PseudoTuCBase );
}

struct UnknownChunk * ASM libAllocUnknownChunk ( register __a0 APTR PreFillData GNUCREG(a0),
    register __d0 unsigned long ChunkName GNUCREG(d0), register __d1 unsigned long ChunkLen GNUCREG(d1))
{
  return ( AllocUnknownChunk ( PreFillData, ChunkName, ChunkLen ));
}

void ASM libFreeUnknownChunk ( register __a0 struct UnknownChunk *UnknownChunkStr GNUCREG(a0))
{
  FreeUnknownChunk ( UnknownChunkStr );
}

void ASM libDeleteUnknownChunk ( register __a0 struct UnknownChunk *UnknownChunkStr GNUCREG(a0))
{
  DeleteUnknownChunk ( UnknownChunkStr );
}

ULONG ASM libRandomize ( register __d0 unsigned long Seed GNUCREG(d0))
{
  return ( Randomize ( Seed ));
}

ULONG ASM libRnd ( register __d0 unsigned long UpperBound GNUCREG(d0))
{
  return ( Rnd ( UpperBound ));
}

ULONG ASM libAllocSoundDevice ( register __a0 struct TuComposerExtList *ExtLibStr GNUCREG(a0),
    register __a1 union FlagPass *FlagPassStr GNUCREG(a1))
{
  return ( AllocSoundDevice ( ExtLibStr, FlagPassStr ));
}

ULONG ASM libFreeSoundDevice ( register __a0 struct TuComposerExtList *ExtLibStr GNUCREG(a0))
{
  return ( FreeSoundDevice ( ExtLibStr ));
}

ULONG ASM libPlaySoundDevice ( register __a0 struct TuComposerExtList *ExtLibStr GNUCREG(a0),
    register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2))
{
  return ( PlaySoundDevice ( ExtLibStr, MixAllocStr, FlagPassStr ));
}

ULONG ASM libStopSoundDevice ( register __a0 struct TuComposerExtList *ExtLibStr GNUCREG(a0))
{
  return ( StopSoundDevice ( ExtLibStr ));
}

ULONG ASM libCheckSoundDeviceRate ( register __a0 struct TuComposerExtList *ExtLibStr GNUCREG(a0),
    register __d0 unsigned long SmpRate GNUCREG(d0))
{
  return ( CheckSoundDeviceRate ( ExtLibStr, SmpRate ));
}

ULONG ASM libCheckSoundDeviceRateFraction ( register __a0 struct TuComposerExtList
    *ExtLibStr GNUCREG(a0), register __d0 unsigned long SmpRate GNUCREG(d0))
{
  return ( CheckSoundDeviceRateFraction ( ExtLibStr, SmpRate ));
}

void ASM libUpdateSoundDeviceRate ( register __a0 struct TuComposerExtList *ExtLibStr GNUCREG(a0),
    register __d0 unsigned long SmpRate GNUCREG(d0))
{
  UpdateSoundDeviceRate ( ExtLibStr, SmpRate );
}

struct MixerAllocStruct * ASM libAllocMixer ( register __a0 struct TuComposerExtList *ExtLibStr GNUCREG(a0))
{
  return ( AllocMixer ( ExtLibStr ));
}

ULONG ASM libFreeMixer ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0))
{
  return ( FreeMixer ( MixAllocStr ));
}

ULONG ASM libInitMixer ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0),
    register __a1 struct SoundDeviceInfo *ExtSoundDevStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2))
{
  return ( InitMixer ( MixAllocStr, ExtSoundDevStr, FlagPassStr ));
}

ULONG ASM libChangeMixerRate ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0),
    register __d0 unsigned long NewMixRate GNUCREG(d0))
{
  return ( ChangeMixerRate ( MixAllocStr, NewMixRate ));
}

ULONG ASM libChangeMixerTempo ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0),
    register __d0 unsigned long NewTempo GNUCREG(d0))
{
  return ( ChangeMixerTempo ( MixAllocStr, NewTempo ));
}

ULONG ASM libChangeMixerVolTable ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0),
    register __d0 unsigned long Amplify GNUCREG(d0), register __d1 unsigned long LeftVol GNUCREG(d1), register __d2 unsigned long RightVol GNUCREG(d2),
    register __d3 unsigned long NumChannels GNUCREG(d3))
{
  return ( ChangeMixerVolTable ( MixAllocStr, Amplify, LeftVol, RightVol, NumChannels ));
}

void ASM libGetMixChannel ( register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1),
    register __a0 struct MixerStruct *MixStr GNUCREG(a0), register __d0 unsigned long Channel GNUCREG(d0))
{
  GetMixChannel ( MixAllocStr, MixStr, Channel );
}

void ASM libSetMixChannel ( register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1),
    register __a0 struct MixerStruct *MixStr GNUCREG(a0), register __d0 unsigned long Channel GNUCREG(d0))
{
  SetMixChannel ( MixAllocStr, MixStr, Channel );
}

void ASM libSetMixChannelVolPanPitch ( register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1),
    register __a0 struct MixerStruct *MixStr GNUCREG(a0), register __d0 unsigned long Channel GNUCREG(d0))
{
  SetMixChannelVolPanPitch ( MixAllocStr, MixStr, Channel );
}

void ASM libSetMixChannelPosRepFlags ( register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1),
    register __a0 struct MixerStruct *MixStr GNUCREG(a0), register __d0 unsigned long Channel GNUCREG(d0))
{
  SetMixChannelPosRepFlags ( MixAllocStr, MixStr, Channel );
}

void ASM libDoMix ( register __a0 struct MixerAllocStruct *MixAllocStr GNUCREG(a0), register __a1 long *MixBuffer GNUCREG(a1))
{
  DoMix ( MixAllocStr, MixBuffer );
}

struct PostProcAllocStruct * ASM libAllocPostProcessor ( register __a0 struct TuComposerExtList *ExtLibStr GNUCREG(a0),
    register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1))
{
  return ( AllocPostProcessor ( ExtLibStr, MixAllocStr ));
}

ULONG ASM libFreePostProcessor ( register __a0 struct PostProcAllocStruct *PostAllocStr GNUCREG(a0))
{
  return ( FreePostProcessor ( PostAllocStr ));
}

ULONG ASM libInitPostProcessor ( register __a0 struct PostProcAllocStruct *PostAllocStr GNUCREG(a0),
    register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1), register __a2 union FlagPass *FlagPassStr GNUCREG(a2))
{
  return ( InitPostProcessor ( PostAllocStr, MixAllocStr, FlagPassStr ));
}

ULONG ASM libChangePostProcessor ( register __a0 struct PostProcAllocStruct *PostAllocStr GNUCREG(a0),
    register __a1 struct MixerAllocStruct *MixAllocStr GNUCREG(a1))
{
  return ( ChangePostProcessor ( PostAllocStr, MixAllocStr ));
}

void ASM libDoPostProcessorMix ( register __a0 struct PostProcAllocStruct *PostAllocStr GNUCREG(a0),
    register __a2 long *MixBuffer GNUCREG(a2))
{
  DoPostProcessorMix ( PostAllocStr, MixBuffer );
}

struct PostProcAllocStruct * ASM libAddPostProcessor ( register __a0 struct MixerAllocStruct
    *MixAllocStr GNUCREG(a0), register __a1 struct PostProcAllocStruct *PostAllocStr GNUCREG(a1))
{
  return ( AddPostProcessor ( MixAllocStr, PostAllocStr ));
}

void ASM libRemPostProcessor ( register __a0 struct PostProcAllocStruct *PostAllocStr GNUCREG(a0))
{
  RemPostProcessor ( PostAllocStr );
}

void ASM libSetPostProcessorPri ( register __a0 struct PostProcAllocStruct *PostAllocStr GNUCREG(a0),
    register __d0 long Pri GNUCREG(d0))
{
  SetPostProcessorPri ( PostAllocStr, Pri );
}

struct TuComposerModule * ASM libAllocTCModule ( register __d0 unsigned long Channels GNUCREG(d0))
{
  return ( AllocTCModule ( Channels ));
}

ULONG ASM libFreeTCModule ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0))
{
  return ( FreeTCModule ( ModuleStr ));
}

ULONG ASM libAddTCModule ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0))
{
  return ( AddTCModule ( ModuleStr ));
}

ULONG ASM libRemTCModule ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0))
{
  return ( RemTCModule ( ModuleStr ));
}

struct TuComposerModule * ASM libDupTCModule ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0))
{
  return ( DupTCModule ( ModuleStr ));
}

ULONG ASM libReMapTCModule ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerModule *NewModuleStr GNUCREG(a1))
{
  return ( ReMapTCModule ( ModuleStr, NewModuleStr ));
}

struct TuComposerModule * ASM libLoadTCModule ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerModule *ModuleStr GNUCREG(a1),
    register __a2 struct TuComposerExtList *ExtLibStr GNUCREG(a2), register __a3 union FlagPass *FlagPassStr GNUCREG(a3),
    register __d0 unsigned long NumModule GNUCREG(d0))
{
  return ( LoadTCModule ( CFHandle, ModuleStr, ExtLibStr, FlagPassStr, NumModule ));
}

ULONG ASM libSaveTCModule ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerModule *ModuleStr GNUCREG(a1),
    register __a2 struct TuComposerExtList *ExtLibStr GNUCREG(a2), register __a3 union FlagPass *FlagPassStr GNUCREG(a3))
{
  return ( SaveTCModule ( CFHandle, ModuleStr, ExtLibStr, FlagPassStr ));
}

struct TuComposerExtList * ASM libIdentifyTCModule ( register __a0 struct CFHandle *CFHandle GNUCREG(a0))
{
  return ( IdentifyTCModule ( CFHandle ));
}

struct ModuleInfo * ASM libGetTCModuleInfo ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerExtList *ExtLibStr GNUCREG(a1), register __d0 unsigned long NumModule GNUCREG(d0))
{
  return ( GetTCModuleInfo ( CFHandle, ExtLibStr, NumModule ));
}

ULONG ASM libFreeTCModuleInfo ( register __a0 struct ModuleInfo *ModuleInfoStr GNUCREG(a0))
{
  return ( FreeTCModuleInfo ( ModuleInfoStr ));
}

ULONG ASM libGetTCModules ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerExtList *ExtLibStr GNUCREG(a1))
{
  return ( GetTCModules ( CFHandle, ExtLibStr ));
}

struct TuComposerModule * ASM libPushTCModule ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0))
{
  return ( PushTCModule ( ModuleStr ));
}

ULONG ASM libPopTCModule ( register __a0 struct TuComposerModule *ModuleBuf GNUCREG(a0))
{
  return ( PopTCModule ( ModuleBuf ));
}

struct TuComposerModule * ASM libCutTCModule ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerModule *ModuleBuf GNUCREG(a1))
{
  return ( CutTCModule ( ModuleStr, ModuleBuf ));
}

struct TuComposerModule * ASM libCopyTCModule ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerModule *ModuleBuf GNUCREG(a1))
{
  return ( CopyTCModule ( ModuleStr, ModuleBuf ));
}

struct TuComposerModule * ASM libPasteTCModule ( register __a0 struct TuComposerModule *ModuleBuf GNUCREG(a0),
    register __a1 struct TuComposerModule *ModuleStr GNUCREG(a1))
{
  return ( PasteTCModule ( ModuleBuf, ModuleStr ));
}

ULONG ASM libSwapTCModule ( register __a0 struct TuComposerModule *ModuleBuf GNUCREG(a0),
    register __a1 struct TuComposerModule *ModuleStr GNUCREG(a1))
{
  return ( SwapTCModule ( ModuleBuf, ModuleStr ));
}

ULONG ASM libClearTCModule ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0))
{
  return ( ClearTCModule ( ModuleStr ));
}

ULONG ASM libAddTCModuleUnknownChunk ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1))
{
  return ( AddTCModuleUnknownChunk ( ModuleStr, UnknownChunkStr ));
}

ULONG ASM libRemTCModuleUnknownChunk ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0))
{
  return ( RemTCModuleUnknownChunk ( ModuleStr ));
}

ULONG ASM libInsertTCModuleUnknownChunk ( register __a0 struct TuComposerModule
    *ModuleStr GNUCREG(a0), register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1),
    register __a2 struct UnknownChunk *UnknownChunkPos GNUCREG(a2))
{
  return ( InsertTCModuleUnknownChunk ( ModuleStr, UnknownChunkStr, UnknownChunkPos ));
}

ULONG ASM libAllocPlayTCModule ( void )

{
  return ( AllocPlayTCModule());
}

void ASM libFreePlayTCModule ( void )

{
  FreePlayTCModule ();
}

ULONG ASM libPlayTCModule ( register __a0 union FlagPass *FlagPassStr GNUCREG(a0))
{
  return ( PlayTCModule ( FlagPassStr ));
}

ULONG ASM libStopTCModule ( void )

{
  return ( StopTCModule ());
}

ULONG ASM libSetTCMChannels ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __d0 unsigned long Channels GNUCREG(d0))
{
  return ( SetTCMChannels ( ModuleStr, Channels ));
}

ULONG ASM libCalcTCMPlayTime ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct PlayExecHandler *PlayExecStr GNUCREG(a1))
{
  return ( CalcTCMPlayTime ( ModuleStr, PlayExecStr ));
}

ULONG ASM libGetOptimalVChannels ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0))
{
  return ( GetOptimalVChannels ( ModuleStr ));
}

struct TuComposerSong * ASM libAllocSong ( register __d0 unsigned long Channels GNUCREG(d0),
    register __d1 unsigned long GoSubStack GNUCREG(d1), register __d2 unsigned long LoopStack GNUCREG(d2))
{
  return ( AllocSong ( Channels, GoSubStack, LoopStack ));
}

ULONG ASM libFreeSong ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0))
{
  return ( FreeSong ( SongStr ));
}

ULONG ASM libAddSong ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerSong *SongStr GNUCREG(a1))
{
  return ( AddSong ( ModuleStr, SongStr ));
}

ULONG ASM libRemSong ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0))
{
  return ( RemSong ( ModuleStr ));
}

ULONG ASM libInsertSong ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerSong *SongStr GNUCREG(a1), register __a2 struct TuComposerSong *SongPos GNUCREG(a2))
{
  return ( InsertSong ( ModuleStr, SongStr, SongPos ));
}

ULONG ASM libDeleteSong ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0))
{
  return ( DeleteSong ( SongStr ));
}

struct TuComposerSong * ASM libDupSong ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0))
{
  return ( DupSong ( SongStr ));
}

ULONG ASM libReMapSong ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __a1 struct TuComposerSong *NewSongStr GNUCREG(a1))
{
  return ( ReMapSong ( SongStr, NewSongStr ));
}

ULONG ASM libGetNumSongs ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0))
{
  return ( GetNumSongs ( ModuleStr ));
}

ULONG ASM libGetSongNum ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerSong *SongStr GNUCREG(a1))
{
  return ( GetSongNum ( ModuleStr, SongStr ));
}

struct TuComposerSong * ASM libGetSongAddr ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __d0 unsigned long Num GNUCREG(d0))
{
  return ( GetSongAddr ( ModuleStr, Num ));
}

struct TuComposerSong * ASM libLoadSong ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSong *SongStr GNUCREG(a1), register __a2 struct TuComposerExtList *ExtLibStr GNUCREG(a2),
    register __a3 union FlagPass *FlagPassStr GNUCREG(a3), register __d0 unsigned long NumSong GNUCREG(d0))
{
  return ( LoadSong ( CFHandle, SongStr, ExtLibStr, FlagPassStr, NumSong ));
}

ULONG ASM libSaveSong ( register __a0 struct CFHandle *CFHandle GNUCREG(a0), register __a1 struct TuComposerSong *SongStr GNUCREG(a1),
    register __a2 struct TuComposerExtList *ExtLibStr GNUCREG(a2), register __a3 union FlagPass *FlagPassStr GNUCREG(a3))
{
  return ( SaveSong ( CFHandle, SongStr, ExtLibStr, FlagPassStr ));
}

struct TuComposerExtList * ASM libIdentifySong ( register __a0 struct CFHandle *CFHandle GNUCREG(a0))
{
  return ( IdentifySong ( CFHandle ));
}

struct SongInfo * ASM libGetSongInfo ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerExtList *ExtLibStr GNUCREG(a1), register __d0 unsigned long NumSong GNUCREG(d0))
{
  return ( GetSongInfo ( CFHandle, ExtLibStr, NumSong ));
}

ULONG ASM libFreeSongInfo ( register __a0 struct SongInfo *SongInfoStr GNUCREG(a0))
{
  return ( FreeSongInfo ( SongInfoStr ));
}

ULONG ASM libGetSongs ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerExtList *ExtLibStr GNUCREG(a1))
{
  return ( GetSongs ( CFHandle, ExtLibStr ));
}

struct TuComposerSong * ASM libPushSong ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0))
{
  return ( PushSong ( SongStr ));
}

ULONG ASM libPopSong ( register __a0 struct TuComposerSong *SongBuf GNUCREG(a0))
{
  return ( PopSong ( SongBuf ));
}

struct TuComposerSong * ASM libCutSong ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __a1 struct TuComposerSong *SongBuf GNUCREG(a1))
{
  return ( CutSong ( SongStr, SongBuf ));
}

struct TuComposerSong * ASM libCopySong ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __a1 struct TuComposerSong *SongBuf GNUCREG(a1))
{
  return ( CopySong ( SongStr, SongBuf ));
}

struct TuComposerSong * ASM libPasteSong ( register __a0 struct TuComposerSong *SongBuf GNUCREG(a0),
    register __a1 struct TuComposerSong *SongStr GNUCREG(a1))
{
  return ( PasteSong ( SongBuf, SongStr ));
}

ULONG ASM libSwapSong ( register __a0 struct TuComposerSong *SongBuf GNUCREG(a0),
    register __a1 struct TuComposerSong *SongStr GNUCREG(a1))
{
  return ( SwapSong ( SongBuf, SongStr ));
}

ULONG ASM libClearSong ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0))
{
  return ( ClearSong ( SongStr ));
}

ULONG ASM libAddSongUnknownChunk ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1))
{
  return ( AddSongUnknownChunk ( SongStr, UnknownChunkStr ));
}

ULONG ASM libRemSongUnknownChunk ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0))
{
  return ( RemSongUnknownChunk ( SongStr ));
}

ULONG ASM libInsertSongUnknownChunk ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1),
    register __a2 struct UnknownChunk *UnknownChunkPos GNUCREG(a2))
{
  return ( InsertSongUnknownChunk ( SongStr, UnknownChunkStr, UnknownChunkPos ));
}

struct TuComposerInstr ** ASM libGetSongInstrs ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0))
{
  return ( GetSongInstrs ( SongStr ));
}

ULONG ASM libFreeSongInstrs ( register __a0 struct TuComposerInstr **InstrList GNUCREG(a0))
{
  return ( FreeSongInstrs ( InstrList ));
}

struct TuComposerInstrEnvelope ** ASM libGetSongEnvelopes ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0))
{
  return ( GetSongEnvelopes ( SongStr ));
}

ULONG ASM libFreeSongEnvelopes ( register __a0 struct TuComposerInstrEnvelope **EnvList GNUCREG(a0))
{
  return ( FreeSongEnvelopes ( EnvList ));
}

struct TuComposerInstrKeyboard ** ASM libGetSongKeyboards ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0))
{
  return ( GetSongKeyboards ( SongStr ));
}

ULONG ASM libFreeSongKeyboards ( register __a0 struct TuComposerInstrKeyboard **KeybrdList GNUCREG(a0))
{
  return ( FreeSongKeyboards ( KeybrdList ));
}

struct TuComposerInstrArpeggio ** ASM libGetSongArpeggios ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0))
{
  return ( GetSongArpeggios ( SongStr ));
}

ULONG ASM libFreeSongArpeggios ( register __a0 struct TuComposerInstrArpeggio **ArpList GNUCREG(a0))
{
  return ( FreeSongArpeggios ( ArpList ));
}

struct TuComposerTrack * ASM libReMapSongInstrs ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1),
    register __a2 struct TuComposerInstr **InstrList GNUCREG(a2))
{
  return ( ReMapSongInstrs ( SongStr, TrackStr, InstrList ));
}

ULONG ASM libSetBaseSongInstrs ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1), register __d0 unsigned long FirstInsNum GNUCREG(d0))
{
  return ( SetBaseSongInstrs ( SongStr, TrackStr, FirstInsNum ));
}

ULONG ASM libSetSongChannels ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __d0 unsigned long Channels GNUCREG(d0))
{
  return ( SetSongChannels ( SongStr, Channels ));
}

ULONG ASM libSetStack ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0), register __d0 unsigned long GoSubStack GNUCREG(d0),
    register __d1 unsigned long LoopStack GNUCREG(d1))
{
  return ( SetStack ( SongStr, GoSubStack, LoopStack ));
}

ULONG ASM libCalcSongPlayTime ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __a1 struct PlayExecHandler *PlayExecStr GNUCREG(a1))
{
  return ( CalcSongPlayTime ( SongStr, PlayExecStr ));
}

ULONG ASM libGetOptimalChannels ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0))
{
  return ( GetOptimalChannels ( SongStr ));
}

ULONG ASM libResetSong ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0))
{
  return ( ResetSong ( SongStr ));
}

ULONG ASM libCalcPlayerSpeed ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0))
{
  return ( CalcPlayerSpeed ( SongStr ));
}

struct TuComposerOrders * ASM libAllocPosition ( register __d0 unsigned long Channels GNUCREG(d0))
{
  return ( AllocPosition ( Channels ));
}

ULONG ASM libFreePosition ( register __a0 struct TuComposerOrders *PosStr GNUCREG(a0),
    register __d0 unsigned long Channels GNUCREG(d0))
{
  return ( FreePosition ( PosStr, Channels ));
}

ULONG ASM libSwapPosition ( register __a0 struct TuComposerOrders *PosStr GNUCREG(a0),
    register __d0 unsigned long Channel GNUCREG(d0), register __d1 unsigned long SwapChannel GNUCREG(d1))
{
  return ( SwapPosition ( PosStr, Channel, SwapChannel ));
}

ULONG ASM libSetPosition ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __a1 struct TuComposerOrders *PosStr GNUCREG(a1))
{
  return ( SetPosition ( SongStr, PosStr ));
}

struct TuComposerOrders * ASM libDupPosition ( register __a0 struct TuComposerOrders *PosStr GNUCREG(a0),
    register __d0 unsigned long Channels GNUCREG(d0))
{
  return ( DupPosition ( PosStr, Channels ));
}

ULONG ASM libGetPositionNum ( register __a0 struct TuComposerOrders *PosStr GNUCREG(a0),
   register __a1 struct TuComposerOrderList *PosListStr GNUCREG(a1), register __d0 unsigned long Channel GNUCREG(d0))
{
  return ( GetPositionNum ( PosStr, PosListStr, Channel ));
}

struct TuComposerOrderList * ASM libGetPositionAddr ( register __a0 struct TuComposerOrders
    *PosStr GNUCREG(a0), register __d0 unsigned long Channel GNUCREG(d0), register __d1 unsigned long Num GNUCREG(d1))
{
  return ( GetPositionAddr ( PosStr, Channel, Num ));
}

ULONG ASM libClearPosition ( register __a0 struct TuComposerOrders *PosStr GNUCREG(a0),
    register __d0 unsigned long Channels GNUCREG(d0))
{
  return ( ClearPosition ( PosStr, Channels ));
}

ULONG ASM libPlayPosition ( register __a0 struct TuComposerOrders *PosStr GNUCREG(a0),
    register __a1 union FlagPass *FlagPassStr GNUCREG(a1), register __d0 unsigned long Order GNUCREG(d0),
    register __d1 unsigned long Row GNUCREG(d1))
{
  return ( PlayPosition ( PosStr, FlagPassStr, Order, Row ));
}

ULONG ASM libDupPositionChannel ( register __a0 struct TuComposerOrders *SrcPosStr GNUCREG(a0),
    register __a1 struct TuComposerOrders *DestPosStr GNUCREG(a1), register __d0 unsigned long SrcChannel GNUCREG(d0),
    register __d1 unsigned long DestChannel GNUCREG(d1))
{
  return ( DupPositionChannel ( SrcPosStr, DestPosStr, SrcChannel, DestChannel ));
}

ULONG ASM libClearPositionChannel ( register __a0 struct TuComposerOrders *PosStr GNUCREG(a0),
    register __d0 unsigned long Channel GNUCREG(d0))
{
  return ( ClearPositionChannel ( PosStr, Channel ));
}

struct TuComposerOrderList * ASM libAllocPositionList ( void )

{
  return ( AllocPositionList ());
}

ULONG ASM libFreePositionList ( register __a0 struct TuComposerOrderList *PosListStr GNUCREG(a0))
{
  return ( FreePositionList ( PosListStr ));
}

ULONG ASM libAddPositionList ( register __a0 struct TuComposerOrders *PosStr GNUCREG(a0),
    register __a1 struct TuComposerOrderList *PosListStr GNUCREG(a1), register __d0 unsigned long Channel GNUCREG(d0))
{
  return ( AddPositionList ( PosStr, PosListStr, Channel ));
}

ULONG ASM libRemPositionList ( register __a0 struct TuComposerOrders *PosStr GNUCREG(a0),
    register __d0 unsigned long Channel GNUCREG(d0))
{
  return ( RemPositionList ( PosStr, Channel ));
}

ULONG ASM libInsertPositionList ( register __a0 struct TuComposerOrders *PosStr GNUCREG(a0),
    register __a1 struct TuComposerOrderList *PosListStr GNUCREG(a1),
    register __a2 struct TuComposerOrderList *PosListPos GNUCREG(a2), register __d0 unsigned long Channel GNUCREG(d0))
{
  return ( InsertPositionList ( PosStr, PosListStr, PosListPos, Channel ));
}

ULONG ASM libDeletePositionList ( register __a0 struct TuComposerOrderList *PosListStr GNUCREG(a0))
{
  return ( DeletePositionList ( PosListStr ));
}

struct TuComposerOrderList * ASM libDupPositionList ( register __a0 struct TuComposerOrderList
    *PosListStr GNUCREG(a0))
{
  return ( DupPositionList ( PosListStr ));
}

ULONG ASM libSwapPositionList ( register __a0 struct TuComposerOrderList *PosListStr GNUCREG(a0),
    register __a1 struct TuComposerOrderList *SwapPosListStr GNUCREG(a1))
{
  return ( SwapPositionList ( PosListStr, SwapPosListStr ));
}

ULONG ASM libClearPositionList ( register __a0 struct TuComposerOrderList *PosListStr GNUCREG(a0))
{
  return ( ClearPositionList ( PosListStr ));
}

struct TuComposerTrack * ASM libAllocTrack ( register __d0 unsigned long DefLength GNUCREG(d0))
{
  return ( AllocTrack ( DefLength ));
}

ULONG ASM libFreeTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0))
{
  return ( FreeTrack ( TrackStr ));
}

ULONG ASM libAddTrack ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1))
{
  return ( AddTrack ( SongStr, TrackStr ));
}

ULONG ASM libRemTrack ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0))
{
  return ( RemTrack ( SongStr ));
}

ULONG ASM libInsertTrack ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1), register __a2 struct TuComposerTrack *TrackPos GNUCREG(a2))
{
  return ( InsertTrack ( SongStr, TrackStr, TrackPos ));
}

ULONG ASM libDeleteTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0))
{
  return ( DeleteTrack ( TrackStr ));
}

ULONG ASM libClearTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0))
{
  return ( ClearTrack ( TrackStr ));
}

struct TuComposerTrack * ASM libDupTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0))
{
  return ( DupTrack ( TrackStr ));
}

ULONG ASM libReMapTrack ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1), register __a2 struct TuComposerTrack *NewTrackStr GNUCREG(a2))
{
  return ( ReMapTrack ( SongStr, TrackStr, NewTrackStr ));
}

ULONG ASM libReSizeTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long NewLen GNUCREG(d0))
{
  return ( ReSizeTrack ( TrackStr, NewLen ));
}

ULONG ASM libAddTrackUnknownChunk ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1))
{
  return ( AddTrackUnknownChunk ( TrackStr, UnknownChunkStr ));
}

ULONG ASM libRemTrackUnknownChunk ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0))
{
  return ( RemTrackUnknownChunk ( TrackStr ));
}

ULONG ASM libInsertTrackUnknownChunk ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1),
    register __a2 struct UnknownChunk *UnknownChunkPos GNUCREG(a2))
{
  return ( InsertTrackUnknownChunk ( TrackStr, UnknownChunkStr, UnknownChunkPos ));
}

ULONG ASM libGetNumTracks ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0))
{
  return ( GetNumTracks ( SongStr ));
}

ULONG ASM libGetTrackNum ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
   register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1))
{
  return ( GetTrackNum ( SongStr, TrackStr ));
}

struct TuComposerTrack * ASM libGetTrackAddr ( register __a0 struct TuComposerSong *SongStr GNUCREG(a0),
    register __d0 unsigned long Num GNUCREG(d0))
{
  return ( GetTrackAddr ( SongStr, Num ));
}

void ASM libGetNoteStr ( register __a0 STRPTR StrBuf GNUCREG(a0), register __d0 unsigned long Octave GNUCREG(d0), register __d1 unsigned long Note GNUCREG(d1),
    register __d2 unsigned long Flags GNUCREG(d2))
{
  GetNoteStr ( StrBuf, Octave, Note, Flags );
}

void ASM libGetIndexNoteStr ( register __a0 STRPTR StrBuf GNUCREG(a0), register __d0 unsigned long IndexNote GNUCREG(d0),
    register __d1 unsigned long Flags GNUCREG(d1))
{
  GetIndexNoteStr ( StrBuf, IndexNote, Flags );
}

ULONG ASM libNoteToIndex ( register __d0 unsigned long Octave GNUCREG(d0), register __d1 unsigned long Note GNUCREG(d1))
{
  return ( NoteToIndex ( Octave, Note ));
}

ULONG ASM libIndexToNote ( register __d0 unsigned long IndexNote GNUCREG(d0))
{
  return ( IndexToNote ( IndexNote ));
}

ULONG ASM libGetTrackRowStr ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __a1 STRPTR StrBuf GNUCREG(a1),
    register __a2 struct TuComposerTrackEffect *EffStr GNUCREG(a2), register __d0 unsigned long Row GNUCREG(d0),
    register __d1 unsigned long Flags GNUCREG(d1), register __d2 unsigned long SpcChar GNUCREG(d2))
{
  return ( GetTrackRowStr ( TrackStr, StrBuf, EffStr, Row, Flags, SpcChar ));
}

struct TuComposerTrackEffect * ASM libAllocEffect ( register __d0 unsigned long EffectByte GNUCREG(d0),
    register __d1 unsigned long DataWord GNUCREG(d1))
{
  return ( AllocEffect ( EffectByte, DataWord ));
}

ULONG ASM libFreeEffect ( register __a0 struct TuComposerTrackEffect *EffStr GNUCREG(a0))
{
  return ( FreeEffect ( EffStr ));
}

ULONG ASM libAddEffect ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0),
    register __a1 struct TuComposerTrackEffect *EffStr GNUCREG(a1), register __d0 unsigned long Row GNUCREG(d0))
{
  return ( AddEffect ( TrackStr, EffStr, Row ));
}

ULONG ASM libRemEffect ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long Row GNUCREG(d0))
{
  return ( RemEffect ( TrackStr, Row ));
}

ULONG ASM libInsertEffect ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0),
    register __a1 struct TuComposerTrackEffect *EffStr GNUCREG(a1),
    register __a2 struct TuComposerTrackEffect *EffPos GNUCREG(a2), register __d0 unsigned long Row GNUCREG(d0))
{
  return ( InsertEffect ( TrackStr, EffStr, EffPos, Row ));
}

ULONG ASM libDeleteEffect ( register __a0 struct TuComposerTrackEffect *EffStr GNUCREG(a0))
{
  return ( DeleteEffect ( EffStr ));
}

ULONG ASM libClearEffects ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long Row GNUCREG(d0),
    register __d1 unsigned long NumRows GNUCREG(d1))
{
  return ( ClearEffects ( TrackStr, Row, NumRows ));
}

ULONG ASM libReMapEffects ( register __a0 struct TuComposerTrack *SrcTrackStr GNUCREG(a0),
    register __a1 struct TuComposerTrack *DestTrackStr GNUCREG(a1), register __d0 unsigned long SrcRow GNUCREG(d0),
    register __d1 unsigned long DestRow GNUCREG(d1), register __d2 unsigned long NumRows GNUCREG(d2))
{
  return ( ReMapEffects ( SrcTrackStr, DestTrackStr, SrcRow, DestRow, NumRows ));
}

struct TuComposerTrackData * ASM libAllocTrackData ( register __d0 unsigned long Length GNUCREG(d0))
{
  return ( AllocTrackData ( Length ));
}

ULONG ASM libFreeTrackData ( register __a0 struct TuComposerTrackData *TrackData GNUCREG(a0),
    register __d0 unsigned long Length GNUCREG(d0))
{
  return ( FreeTrackData ( TrackData, Length ));
}

ULONG ASM libAddRows ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long NumRows GNUCREG(d0))
{
  return ( AddRows ( TrackStr, NumRows ));
}

ULONG ASM libRemRows ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long NumRows GNUCREG(d0))
{
  return ( RemRows ( TrackStr, NumRows ));
}

ULONG ASM libInsertRows ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long Row GNUCREG(d0),
    register __d1 unsigned long NumRows GNUCREG(d1), register __d2 unsigned long Flags GNUCREG(d2))
{
  return ( InsertRows ( TrackStr, Row, NumRows, Flags ));
}

ULONG ASM libDeleteRows ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long Row GNUCREG(d0),
    register __d1 unsigned long NumRows GNUCREG(d1), register __d2 unsigned long Flags GNUCREG(d2))
{
  return ( DeleteRows ( TrackStr, Row, NumRows, Flags ));
}

ULONG ASM libClearRows ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long Row GNUCREG(d0),
    register __d1 unsigned long NumRows GNUCREG(d1))
{
  return ( ClearRows ( TrackStr, Row, NumRows ));
}

ULONG ASM libReMapRows ( register __a0  struct TuComposerTrack *SrcTrackStr GNUCREG(a0),
    register __a1 struct TuComposerTrack *DestTrackStr GNUCREG(a1), register __d0 unsigned long SrcRow GNUCREG(d0),
    register __d1 unsigned long DestRow GNUCREG(d1), register __d2 unsigned long NumRows GNUCREG(d2))
{
  return ( ReMapRows ( SrcTrackStr, DestTrackStr, SrcRow, DestRow, NumRows ));
}

ULONG ASM libCopyRows ( register __a0 struct TuComposerTrack *SrcTrackStr GNUCREG(a0),
    register __a1 struct TuComposerTrack *DestTrackStr GNUCREG(a1), register __d0 unsigned long SrcRow GNUCREG(d0),
    register __d1 unsigned long DestRow GNUCREG(d1), register __d2 unsigned long NumRows GNUCREG(d2))
{
  return ( CopyRows ( SrcTrackStr, DestTrackStr, SrcRow, DestRow, NumRows ));
}

ULONG ASM libSwapRows ( register __a0 struct TuComposerTrack *SrcTrackStr GNUCREG(a0),
    register __a1 struct TuComposerTrack *DestTrackStr GNUCREG(a1), register __d0 unsigned long SrcRow GNUCREG(d0),
    register __d1 unsigned long DestRow GNUCREG(d1), register __d2 unsigned long NumRows GNUCREG(d2))
{
  return ( SwapRows ( SrcTrackStr, DestTrackStr, SrcRow, DestRow, NumRows ));
}

ULONG ASM libPlayRow ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0),
    register __a1 union FlagPass *FlagPassStr GNUCREG(a1),
    register __d0 unsigned long Row GNUCREG(d0), register __d1 unsigned long Channel GNUCREG(d1))
{
  return ( PlayRow ( TrackStr, FlagPassStr, Row, Channel ));
}

LONG ASM libCmpTracks ( register __a0 struct TuComposerTrack *SrcTrackStr GNUCREG(a0),
   register __a1 struct TuComposerTrack *DestTrackStr GNUCREG(a1))
{
  return ( CmpTracks ( SrcTrackStr, DestTrackStr ));
}

struct TuComposerPacked * ASM libPackTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0))
{
  return ( PackTrack ( TrackStr ));
}

struct TuComposerTrack * ASM libUnPackTrack ( register __a0 struct TuComposerPacked *PackedTrackStr GNUCREG(a0),
     register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1))
{
  return ( UnPackTrack ( PackedTrackStr, TrackStr ));
}

void ASM libFreePackedTrack ( register __a0 struct TuComposerPacked *PackedTrackStr GNUCREG(a0))
{
  FreePackedTrack ( PackedTrackStr );
}

struct TuComposerTrack * ASM libLoadTrack ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1), register __a2 struct TuComposerExtList *ExtLibStr GNUCREG(a2),
    register __a3 union FlagPass *FlagPassStr GNUCREG(a3), register __d0 unsigned long NumTrack GNUCREG(d0))
{
  return ( LoadTrack ( CFHandle, TrackStr, ExtLibStr, FlagPassStr, NumTrack ));
}

ULONG ASM libSaveTrack ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1), register __a2 struct TuComposerExtList *ExtLibStr GNUCREG(a2),
    register __a3 union FlagPass *FlagPassStr GNUCREG(a3))
{
  return ( SaveTrack ( CFHandle, TrackStr, ExtLibStr, FlagPassStr ));
}

struct TuComposerExtList * ASM libIdentifyTrack ( register __a0 struct CFHandle *CFHandle GNUCREG(a0))
{
  return ( IdentifyTrack ( CFHandle ));
}

struct TrackInfo * ASM libGetTrackInfo ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerExtList *ExtLibStr GNUCREG(a1), register __d0 unsigned long NumTrack GNUCREG(d0))
{
  return ( GetTrackInfo ( CFHandle, ExtLibStr, NumTrack ));
}

ULONG ASM libFreeTrackInfo ( register __a0 struct TrackInfo *TrackInfoStr GNUCREG(a0))
{
  return ( FreeTrackInfo ( TrackInfoStr ));
}

ULONG ASM libGetTracks ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerExtList *ExtLibStr GNUCREG(a1))
{
  return ( GetTracks ( CFHandle, ExtLibStr ));
}

struct TuComposerTrack * ASM libPushTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0))
{
  return ( PushTrack ( TrackStr ));
}

ULONG ASM libPopTrack ( register __a0 struct TuComposerTrack *TrackBuf GNUCREG(a0))
{
  return ( PopTrack ( TrackBuf ));
}

struct TuComposerTrack * ASM libCutTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0),
    register __a1 struct TuComposerTrack *TrackBuf GNUCREG(a1))
{
  return ( CutTrack ( TrackStr, TrackBuf ));
}

struct TuComposerTrack * ASM libCopyTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0),
    register __a1 struct TuComposerTrack *TrackBuf GNUCREG(a1))
{
  return ( CopyTrack ( TrackStr, TrackBuf ));
}

struct TuComposerTrack * ASM libPasteTrack ( register __a0  struct TuComposerTrack *TrackBuf GNUCREG(a0),
    register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1))
{
  return ( PasteTrack ( TrackBuf, TrackStr ));
}

ULONG ASM libSwapTrack ( register __a0 struct TuComposerTrack *TrackBuf GNUCREG(a0),
     register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1))
{
  return ( SwapTrack ( TrackBuf, TrackStr ));
}

ULONG ASM libSwapTrackInSong ( register __a0 struct TuComposerTrack *TrackBuf GNUCREG(a0),
     register __a1 struct TuComposerTrack *TrackStr GNUCREG(a1),
     register __d0 unsigned long Flags GNUCREG(d0))
{
  return ( SwapTrackInSong ( TrackBuf, TrackStr, Flags ));
}

ULONG ASM libShrinkTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long Scale GNUCREG(d0))
{
  return ( ShrinkTrack ( TrackStr, Scale ));
}

ULONG ASM libExpandTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long Scale GNUCREG(d0))
{
  return ( ExpandTrack ( TrackStr, Scale ));
}

ULONG ASM libHalveTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long Scale GNUCREG(d0))
{
  return ( HalveTrack ( TrackStr, Scale ));
}

ULONG ASM libDoubleTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long Scale GNUCREG(d0))
{
  return ( DoubleTrack ( TrackStr, Scale ));
}

struct TuComposerTrack * ASM libSplitTrack ( register __a0 struct TuComposerTrack *SrcTrackStr GNUCREG(a0),
     register __a1 struct TuComposerTrack *DestTrackStr GNUCREG(a1), register __d0 unsigned long Row GNUCREG(d0))
{
  return ( SplitTrack ( SrcTrackStr, DestTrackStr, Row ));
}

ULONG ASM libJoinTrack ( register __a0 struct TuComposerTrack *SrcTrackStr GNUCREG(a0),
    register __a1 struct TuComposerTrack *DestTrackStr GNUCREG(a1))
{
  return ( JoinTrack ( SrcTrackStr, DestTrackStr ));
}

ULONG ASM libPlayTrack ( register __a0 union FlagPass *FlagPassStr GNUCREG(a0),
    register __d0 unsigned long Order GNUCREG(d0), register __d1 unsigned long Channel GNUCREG(d1),
    register __d2 unsigned long Row GNUCREG(d2))
{
  return ( PlayTrack ( FlagPassStr, Order, Channel, Row ));
}

ULONG ASM libTrackNoteShift ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0),
    register __d0 long HalfNotes GNUCREG(d0), register __d1 unsigned long StartRow GNUCREG(d1), register __d2 unsigned long EndRow GNUCREG(d2))
{
  return ( TrackNoteShift ( TrackStr, HalfNotes, StartRow, EndRow ));
}

ULONG ASM libScrollTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 long Rows GNUCREG(d0),
    register __d1 unsigned long StartRow GNUCREG(d1), register __d2 unsigned long EndRow GNUCREG(d2))
{
  return ( ScrollTrack ( TrackStr, Rows, StartRow, EndRow ));
}

ULONG ASM libRotateTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 long Rows GNUCREG(d0),
    register __d1 unsigned long StartRow GNUCREG(d1), register __d2 unsigned long EndRow GNUCREG(d2))
{
  return ( RotateTrack ( TrackStr, Rows, StartRow, EndRow ));
}

ULONG ASM libFlipTrack ( register __a0 struct TuComposerTrack *TrackStr GNUCREG(a0), register __d0 unsigned long Scale GNUCREG(d0),
    register __d1 unsigned long StartRow GNUCREG(d1), register __d2 unsigned long EndRow GNUCREG(d2))
{
  return ( FlipTrack ( TrackStr, Scale, StartRow, EndRow ));
}

struct TuComposerInstr * ASM libAllocInstr ( register __d0 unsigned long NumSamples GNUCREG(d0))
{
  return ( AllocInstr ( NumSamples ));
}

ULONG ASM libFreeInstr ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0))
{
  return ( FreeInstr ( InstrStr ));
}

ULONG ASM libAddInstr ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerInstr *InstrStr GNUCREG(a1))
{
  return ( AddInstr ( ModuleStr, InstrStr ));
}

ULONG ASM libRemInstr ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0))
{
  return ( RemInstr ( ModuleStr ));
}

ULONG ASM libInsertInstr ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerInstr *InstrStr GNUCREG(a1), register __a2 struct TuComposerInstr *InstrPos GNUCREG(a2))
{
  return ( InsertInstr ( ModuleStr, InstrStr, InstrPos ));
}

ULONG ASM libDeleteInstr ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0))
{
  return ( DeleteInstr ( InstrStr ));
}

ULONG ASM libClearInstr ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0))
{
  return ( ClearInstr ( InstrStr ));
}

struct TuComposerInstr * ASM libDupInstr ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0))
{
  return ( DupInstr ( InstrStr ));
}

ULONG ASM libReMapInstr ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0),
    register __a1 struct TuComposerInstr *NewInstrStr GNUCREG(a1))
{
  return ( ReMapInstr ( InstrStr, NewInstrStr ));
}

ULONG ASM libAddInstrUnknownChunk ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1))
{
  return ( AddInstrUnknownChunk ( InstrStr, UnknownChunkStr ));
}

ULONG ASM libRemInstrUnknownChunk ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0))
{
  return ( RemInstrUnknownChunk ( InstrStr ));
}

ULONG ASM libInsertInstrUnknownChunk ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1),
    register __a2 struct UnknownChunk *UnknownChunkPos GNUCREG(a2))
{
  return ( InsertInstrUnknownChunk ( InstrStr, UnknownChunkStr, UnknownChunkPos ));
}

ULONG ASM libGetNumInstrs ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0))
{
  return ( GetNumInstrs ( ModuleStr ));
}

ULONG ASM libGetInstrNum ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerInstr *InstrStr GNUCREG(a1))
{
  return ( GetInstrNum ( ModuleStr, InstrStr ));
}

struct TuComposerInstr * ASM libGetInstrAddr ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __d0 unsigned long Num GNUCREG(d0))
{
  return ( GetInstrAddr ( ModuleStr, Num ));
}

struct TuComposerInstr * ASM libLoadInstr ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerInstr *InstrStr GNUCREG(a1), register __a2 struct TuComposerExtList *ExtLibStr GNUCREG(a2),
    register __a3 union FlagPass *FlagPassStr GNUCREG(a3), register __d0 unsigned long NumInstr GNUCREG(d0))
{
  return ( LoadInstr ( CFHandle, InstrStr, ExtLibStr, FlagPassStr, NumInstr ));
}

ULONG ASM libSaveInstr ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerInstr *InstrStr GNUCREG(a1), register __a2 struct TuComposerExtList *ExtLibStr GNUCREG(a2),
    register __a3 union FlagPass *FlagPassStr GNUCREG(a3))
{
  return ( SaveInstr ( CFHandle, InstrStr, ExtLibStr, FlagPassStr ));
}

struct TuComposerExtList * ASM libIdentifyInstr ( register __a0 struct CFHandle *CFHandle GNUCREG(a0))
{
  return ( IdentifyInstr ( CFHandle ));
}

struct InstrInfo * ASM libGetInstrInfo ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerExtList *ExtLibStr GNUCREG(a1), register __d0 unsigned long NumInstr GNUCREG(d0))
{
  return ( GetInstrInfo ( CFHandle, ExtLibStr, NumInstr ));
}

ULONG ASM libFreeInstrInfo ( register __a0 struct InstrInfo *InstrInfoStr GNUCREG(a0))
{
  return ( FreeInstrInfo ( InstrInfoStr ));
}

ULONG ASM libGetInstrs ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerExtList *ExtLibStr GNUCREG(a1))
{
  return ( GetInstrs ( CFHandle, ExtLibStr ));
}

struct TuComposerInstr * ASM libPushInstr ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0))
{
  return ( PushInstr ( InstrStr ));
}

ULONG ASM libPopInstr ( register __a0 struct TuComposerInstr *InstrBuf GNUCREG(a0))
{
  return ( PopInstr ( InstrBuf ));
}

struct TuComposerInstr * ASM libCutInstr ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0),
    register __a1 struct TuComposerInstr *InstrBuf GNUCREG(a1))
{
  return ( CutInstr ( InstrStr, InstrBuf ));
}

struct TuComposerInstr * ASM libCopyInstr ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0),
    register __a1 struct TuComposerInstr *InstrBuf GNUCREG(a1))
{
  return ( CopyInstr ( InstrStr, InstrBuf ));
}

struct TuComposerInstr * ASM libPasteInstr ( register __a0 struct TuComposerInstr *InstrBuf GNUCREG(a0),
    register __a1 struct TuComposerInstr *InstrStr GNUCREG(a1))
{
  return ( PasteInstr ( InstrBuf, InstrStr ));
}

ULONG ASM libSwapInstr ( register __a0 struct TuComposerInstr *InstrBuf GNUCREG(a0),
    register __a1 struct TuComposerInstr *InstrStr GNUCREG(a1))
{
  return ( SwapInstr ( InstrBuf, InstrStr ));
}

ULONG ASM libSwapInstrInModule ( register __a0 struct TuComposerInstr *InstrBuf GNUCREG(a0),
    register __a1 struct TuComposerInstr *InstrStr GNUCREG(a1),
    register __d0 unsigned long Flags GNUCREG(d0))
{
  return ( SwapInstrInModule ( InstrBuf, InstrStr, Flags ));
}

ULONG ASM libPlayInstr ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0),
    register __a1 union FlagPass *FlagPassStr GNUCREG(a1),
    register __d0 unsigned long Channel GNUCREG(d0), register __d1 unsigned long Note GNUCREG(d1),
    register __d2 unsigned long Volume GNUCREG(d2))
{
  return ( PlayInstr ( InstrStr, FlagPassStr, Channel, Note, Volume ));
}

LONG ASM libCmpInstrs ( register __a0 struct TuComposerInstr *SrcInstrStr GNUCREG(a0),
    register __a1 struct TuComposerInstr *DestInstrStr GNUCREG(a1))
{
  return ( CmpInstrs ( SrcInstrStr, DestInstrStr ));
}

struct TuComposerInstrEnvelope ** ASM libGetInstrEnvelopes ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0))
{
  return ( GetInstrEnvelopes ( InstrStr ));
}

ULONG ASM libFreeInstrEnvelopes ( register __a0 struct TuComposerInstrEnvelope **InstrEnvStr GNUCREG(a0))
{
  return ( FreeInstrEnvelopes ( InstrEnvStr ));
}

ULONG ASM libAddInstrEnvelopes ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0),
    register __d0 unsigned long Flags GNUCREG(d0))
{
  return ( AddInstrEnvelopes ( InstrStr, Flags ));
}

struct TuComposerInstrKeyboard * ASM libGetInstrKeyboard ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0))
{
  return ( GetInstrKeyboard ( InstrStr ));
}

struct TuComposerSample ** ASM libGetInstrSamples ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0))
{
  return ( GetInstrSamples ( InstrStr ));
}

ULONG ASM libFreeInstrSamples ( register __a0 struct TuComposerSample **InstrSmpStr GNUCREG(a0))
{
  return ( FreeInstrSamples ( InstrSmpStr ));
}

struct TuComposerInstrEnvelope * ASM libCreateEnvelope ( register __d0 unsigned long NumPoints GNUCREG(d0),
    register __d1 unsigned long Type GNUCREG(d1), register __d2 unsigned long Scale GNUCREG(d2), register __d3 long YOffset GNUCREG(d3),
    register __d4 unsigned long Nodes GNUCREG(d4))
{
  return ( CreateEnvelope ( NumPoints, Type, Scale, YOffset, Nodes ));
}

ULONG ASM libFreeEnvelope ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0))
{
  return ( FreeEnvelope ( EnvStr ));
}

ULONG ASM libAddEnvelope ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
     register __a1 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a1))
{
  return ( AddEnvelope ( ModuleStr, EnvStr ));
}

ULONG ASM libRemEnvelope ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0))
{
  return ( RemEnvelope ( ModuleStr ));
}

ULONG ASM libInsertEnvelope ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
     register __a1 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a1),
     register __a2 struct TuComposerInstrEnvelope *EnvPos GNUCREG(a2))
{
  return ( InsertEnvelope ( ModuleStr, EnvStr, EnvPos ));
}

ULONG ASM libDeleteEnvelope ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0))
{
  return ( DeleteEnvelope ( EnvStr ));
}

ULONG ASM libClearEnvelope ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __d0 unsigned long Type GNUCREG(d0), register __d1 unsigned long Scale GNUCREG(d1), register __d2 unsigned long YOffset GNUCREG(d2))
{
  return ( ClearEnvelope ( EnvStr, Type, Scale, YOffset ));
}

struct TuComposerInstrEnvelope * ASM libDupEnvelope ( register __a0 struct TuComposerInstrEnvelope
    *EnvStr GNUCREG(a0))
{
  return ( DupEnvelope ( EnvStr ));
}

ULONG ASM libReMapEnvelope ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __a1 struct TuComposerInstrEnvelope *NewEnvStr GNUCREG(a1))
{
  return ( ReMapEnvelope ( EnvStr, NewEnvStr ));
}

ULONG ASM libReSizeEnvelope ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __d0 unsigned long Entries GNUCREG(d0))
{
  return ( ReSizeEnvelope ( EnvStr, Entries ));
}

ULONG ASM libValidateEnvNodes ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0))
{
  return ( ValidateEnvNodes ( EnvStr ));
}

ULONG ASM libAddEnvelopeUnknownChunk ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1))
{
  return ( AddEnvelopeUnknownChunk ( EnvStr, UnknownChunkStr ));
}

ULONG ASM libRemEnvelopeUnknownChunk ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0))
{
  return ( RemEnvelopeUnknownChunk ( EnvStr ));
}

ULONG ASM libInsertEnvelopeUnknownChunk ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1),
    register __a2 struct UnknownChunk *UnknownChunkPos GNUCREG(a2))
{
  return ( InsertEnvelopeUnknownChunk ( EnvStr, UnknownChunkStr, UnknownChunkPos ));
}

ULONG ASM libGetNumEnvelopes ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0))
{
  return ( GetNumEnvelopes ( ModuleStr ));
}

ULONG ASM libGetEnvelopeNum ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a1))
{
  return ( GetEnvelopeNum ( ModuleStr, EnvStr ));
}

struct TuComposerInstrEnvelope * ASM libGetEnvelopeAddr ( register __a0 struct TuComposerModule
    *ModuleStr GNUCREG(a0), register __d0 unsigned long Num GNUCREG(d0))
{
  return ( GetEnvelopeAddr ( ModuleStr, Num ));
}

ULONG ASM libSwapEnvelopeInModule ( register __a0 struct TuComposerInstrEnvelope *EnvBuf GNUCREG(a0),
    register __a1 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a1),
    register __d0 unsigned long Flags GNUCREG(d0))
{
  return ( SwapEnvelopeInModule ( EnvBuf, EnvStr, Flags ));
}

struct TuComposerInstrEnvelope * ASM libLoadEnvelope ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a1), register __d0 unsigned long NumEnv GNUCREG(d0))
{
  return ( LoadEnvelope ( CFHandle, EnvStr, NumEnv ));
}

ULONG ASM libSaveEnvelope ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a1))
{
  return ( SaveEnvelope ( CFHandle, EnvStr ));
}

ULONG ASM libShrinkEnvelope ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __d0 unsigned long Scale GNUCREG(d0))
{
  return ( ShrinkEnvelope ( EnvStr, Scale ));
}

ULONG ASM libExpandEnvelope ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __d0 unsigned long Scale GNUCREG(d0))
{
  return ( ExpandEnvelope ( EnvStr, Scale ));
}

ULONG ASM libHalveEnvelope ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __d0 unsigned long Scale GNUCREG(d0))
{
  return ( HalveEnvelope ( EnvStr, Scale ));
}

ULONG ASM libDoubleEnvelope ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __d0 unsigned long Scale GNUCREG(d0))
{
  return ( DoubleEnvelope ( EnvStr, Scale ));
}

struct TuComposerInstrEnvelope * ASM libSplitEnvelope (     register __a0 struct TuComposerInstrEnvelope *SrcEnvStr GNUCREG(a0),
    register __a1 struct TuComposerInstrEnvelope *DestEnvStr GNUCREG(a1), register __d0 unsigned long Point GNUCREG(d0))
{
  return ( SplitEnvelope ( SrcEnvStr, DestEnvStr, Point ));
}

ULONG ASM libJoinEnvelope ( register __a0 struct TuComposerInstrEnvelope *SrcEnvStr GNUCREG(a0),
    register __a1 struct TuComposerInstrEnvelope *DestEnvStr GNUCREG(a1))
{
  return ( JoinEnvelope ( SrcEnvStr, DestEnvStr ));
}

ULONG ASM libScrollEnvelope ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0), register __d0 long Points GNUCREG(d0),
    register __d1 unsigned long StartPoint GNUCREG(d1), register __d2 unsigned long EndPoint GNUCREG(d2))
{
  return ( ScrollEnvelope ( EnvStr, Points, StartPoint, EndPoint ));
}

ULONG ASM libRotateEnvelope ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0), register __d0 long Points GNUCREG(d0),
    register __d1 unsigned long StartPoint GNUCREG(d1), register __d2 unsigned long EndPoint GNUCREG(d2))
{
  return ( RotateEnvelope ( EnvStr, Points, StartPoint, EndPoint ));
}

ULONG ASM libFlipEnvelope ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __d0 unsigned long Scale GNUCREG(d0), register __d1 unsigned long StartPoint GNUCREG(d1), register __d2 unsigned long EndPoint GNUCREG(d2))
{
  return ( FlipEnvelope ( EnvStr, Scale, StartPoint, EndPoint ));
}

ULONG ASM libAddEnvPoint ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __d0 unsigned long Points GNUCREG(d0))
{
  return ( AddEnvPoint ( EnvStr, Points ));
}

ULONG ASM libRemEnvPoint ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __d0 unsigned long Points GNUCREG(d0))
{
  return ( RemEnvPoint ( EnvStr, Points ));
}

ULONG ASM libInsertEnvPoint ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __d0 unsigned long Point GNUCREG(d0), register __d1 unsigned long Points GNUCREG(d1), register __d2 unsigned long Flags GNUCREG(d2))
{
  return ( InsertEnvPoint ( EnvStr, Point, Points, Flags ));
}

ULONG ASM libDeleteEnvPoint ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __d0 unsigned long Point GNUCREG(d0), register __d1 unsigned long Points GNUCREG(d1), register __d2 unsigned long Flags GNUCREG(d2))
{
  return ( DeleteEnvPoint ( EnvStr, Point, Points, Flags ));
}

LONG ASM libCmpEnvelopes ( register __a0 struct TuComposerInstrEnvelope *SrcEnvStr GNUCREG(a0),
    register __a1 struct TuComposerInstrEnvelope *DestEnvStr GNUCREG(a1))
{
  return ( CmpEnvelopes ( SrcEnvStr, DestEnvStr ));
}

struct TuComposerInstrKeyboard * ASM libAllocKeyboard ( void )

{
  return ( AllocKeyboard ());
}

ULONG ASM libFreeKeyboard ( register __a0 struct TuComposerInstrKeyboard *KeybrdStr GNUCREG(a0))
{
  return ( FreeKeyboard ( KeybrdStr ));
}

ULONG ASM libAddKeyboard ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerInstrKeyboard *KeybrdStr GNUCREG(a1))
{
  return ( AddKeyboard ( ModuleStr, KeybrdStr ));
}

ULONG ASM libRemKeyboard ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0))
{
  return ( RemKeyboard ( ModuleStr ));
}

ULONG ASM libInsertKeyboard ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerInstrKeyboard *KeybrdStr GNUCREG(a1),
    register __a2 struct TuComposerInstrKeyboard *KeybrdPos GNUCREG(a2))
{
  return ( InsertKeyboard ( ModuleStr, KeybrdStr, KeybrdPos ));
}

ULONG ASM libDeleteKeyboard ( register __a0 struct TuComposerInstrKeyboard *KeybrdStr GNUCREG(a0))
{
  return ( DeleteKeyboard ( KeybrdStr ));
}

ULONG ASM libClearKeyboard ( register __a0 struct TuComposerInstrKeyboard *KeybrdStr GNUCREG(a0))
{
  return ( ClearKeyboard ( KeybrdStr ));
}

struct TuComposerInstrKeyboard * ASM libDupKeyboard ( register __a0 struct TuComposerInstrKeyboard
    *KeybrdStr GNUCREG(a0))
{
  return ( DupKeyboard ( KeybrdStr ));
}

ULONG ASM libReMapKeyboard ( register __a0 struct TuComposerInstrKeyboard *KeybrdStr GNUCREG(a0),
    register __a1 struct TuComposerInstrKeyboard *NewKeybrdStr GNUCREG(a1))
{
  return ( ReMapKeyboard ( KeybrdStr, NewKeybrdStr ));
}

ULONG ASM libGetNumKeyboards ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0))
{
  return ( GetNumKeyboards ( ModuleStr ));
}

ULONG ASM libGetKeyboardNum ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerInstrKeyboard *KeybrdStr GNUCREG(a1))
{
  return ( GetKeyboardNum ( ModuleStr, KeybrdStr ));
}

struct TuComposerInstrKeyboard * ASM libGetKeyboardAddr (     register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0), register __d0 unsigned long Num GNUCREG(d0))
{
  return ( GetKeyboardAddr ( ModuleStr, Num ));
}

ULONG ASM libSwapKeyboardInModule ( register __a0 struct TuComposerInstrKeyboard *KeybrdBuf GNUCREG(a0),
    register __a1 struct TuComposerInstrKeyboard *KeybrdStr GNUCREG(a1),
    register __d0 unsigned long Flags GNUCREG(d0))
{
  return ( SwapKeyboardInModule ( KeybrdBuf, KeybrdStr, Flags ));
}

ULONG ASM libSetKeyboard ( register __a0 struct TuComposerInstrKeyboard *KeybrdStr GNUCREG(a0),
    register __d0 unsigned long SampleNum GNUCREG(d0), register __d1 unsigned long Octave GNUCREG(d1), register __d2 unsigned long Note GNUCREG(d2),
    register __d3 unsigned long NewOctave GNUCREG(d3), register __d4 unsigned long NewNote GNUCREG(d4))
{
  return ( SetKeyboard ( KeybrdStr, SampleNum, Octave, Note, NewOctave, NewNote ));
}

LONG ASM libCheckKeyboard ( register __a0 struct TuComposerInstrKeyboard *KeybrdStr GNUCREG(a0))
{
  return ( CheckKeyboard ( KeybrdStr ));
}

LONG ASM libCmpKeyboards ( register __a0 struct TuComposerInstrKeyboard *SrcKeybrdStr GNUCREG(a0),
    register __a1 struct TuComposerInstrKeyboard *DestKeybrdStr GNUCREG(a1))
{
  return ( CmpKeyboards ( SrcKeybrdStr, DestKeybrdStr ));
}

struct TuComposerInstrArpeggio * ASM libAllocArpeggio ( register __d0 unsigned long NumEntries GNUCREG(d0))
{
  return ( AllocArpeggio ( NumEntries ));
}

ULONG ASM libFreeArpeggio ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0))
{
  return ( FreeArpeggio ( ArpStr ));
}

ULONG ASM libAddArpeggio ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a1))
{
  return ( AddArpeggio ( ModuleStr, ArpStr ));
}

ULONG ASM libRemArpeggio ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0))
{
  return ( RemArpeggio ( ModuleStr ));
}

ULONG ASM libInsertArpeggio ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a1),
    register __a2 struct TuComposerInstrArpeggio *ArpPos GNUCREG(a2))
{
  return ( InsertArpeggio ( ModuleStr, ArpStr, ArpPos ));
}

ULONG ASM libDeleteArpeggio ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0))
{
  return ( DeleteArpeggio ( ArpStr ));
}

ULONG ASM libClearArpeggio ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0))
{
  return ( ClearArpeggio ( ArpStr ));
}

struct TuComposerInstrArpeggio * ASM libDupArpeggio ( register __a0 struct TuComposerInstrArpeggio
    *ArpStr GNUCREG(a0))
{
  return ( DupArpeggio ( ArpStr ));
}

ULONG ASM libReMapArpeggio ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0),
    register __a1 struct TuComposerInstrArpeggio *NewArpStr GNUCREG(a1))
{
  return ( ReMapArpeggio ( ArpStr, NewArpStr ));
}

ULONG ASM libReSizeArpeggio ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0),
    register __d0 unsigned long Entries GNUCREG(d0))
{
  return ( ReSizeArpeggio ( ArpStr, Entries ));
}

ULONG ASM libGetNumArpeggios ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0))
{
  return ( GetNumArpeggios ( ModuleStr ));
}

ULONG ASM libGetArpeggioNum ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a1))
{
  return ( GetArpeggioNum ( ModuleStr, ArpStr ));
}

struct TuComposerInstrArpeggio * ASM libGetArpeggioAddr ( register __a0 struct TuComposerModule
    *ModuleStr GNUCREG(a0), register __d0 unsigned long Num GNUCREG(d0))
{
  return ( GetArpeggioAddr ( ModuleStr, Num ));
}

ULONG ASM libSwapArpeggioInModule ( register __a0 struct TuComposerInstrArpeggio *ArpBuf GNUCREG(a0),
    register __a1 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a1),
    register __d0 unsigned long Flags GNUCREG(d0))
{
  return ( SwapArpeggioInModule ( ArpBuf, ArpStr, Flags ));
}

ULONG ASM libShrinkArpeggio ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0),
    register __d0 unsigned long Scale GNUCREG(d0))
{
  return ( ShrinkArpeggio ( ArpStr, Scale ));
}

ULONG ASM libExpandArpeggio ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0),
    register __d0 unsigned long Scale GNUCREG(d0))
{
  return ( ExpandArpeggio ( ArpStr, Scale ));
}

ULONG ASM libHalveArpeggio ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0),
    register __d0 unsigned long Scale GNUCREG(d0))
{
  return ( HalveArpeggio ( ArpStr, Scale ));
}

ULONG ASM libDoubleArpeggio ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0),
    register __d0 unsigned long Scale GNUCREG(d0))
{
  return ( DoubleArpeggio ( ArpStr, Scale ));
}

struct TuComposerInstrArpeggio * ASM libSplitArpeggio (     register __a0 struct TuComposerInstrArpeggio *SrcArpStr GNUCREG(a0),
    register __a1 struct TuComposerInstrArpeggio *DestArpStr GNUCREG(a1), register __d0 unsigned long Tick GNUCREG(d0))
{
  return ( SplitArpeggio ( SrcArpStr, DestArpStr, Tick ));
}

ULONG ASM libJoinArpeggio ( register __a0 struct TuComposerInstrArpeggio *SrcArpStr GNUCREG(a0),
    register __a1 struct TuComposerInstrArpeggio *DestArpStr GNUCREG(a1))
{
  return ( JoinArpeggio ( SrcArpStr, DestArpStr ));
}

ULONG ASM libScrollArpeggio ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0), register __d0 long Ticks GNUCREG(d0),
    register __d1 unsigned long StartTick GNUCREG(d1), register __d2 unsigned long EndTick GNUCREG(d2))
{
  return ( ScrollArpeggio ( ArpStr, Ticks, StartTick, EndTick ));
}

ULONG ASM libRotateArpeggio ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0), register __d0 long Ticks GNUCREG(d0),
    register __d1 unsigned long StartTick GNUCREG(d1), register __d2 unsigned long EndTick GNUCREG(d2))
{
  return ( RotateArpeggio ( ArpStr, Ticks, StartTick, EndTick ));
}

ULONG ASM libFlipArpeggio ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0),
    register __d0 unsigned long Scale GNUCREG(d0), register __d1 unsigned long StartTick GNUCREG(d1), register __d2 unsigned long EndTick GNUCREG(d2))
{
  return ( FlipArpeggio ( ArpStr, Scale, StartTick, EndTick ));
}

ULONG ASM libAddArpeggioTick ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0),
    register __d0 unsigned long Ticks GNUCREG(d0))
{
  return ( AddArpeggioTick ( ArpStr, Ticks ));
}

ULONG ASM libRemArpeggioTick ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0),
    register __d0 unsigned long Ticks GNUCREG(d0))
{
  return ( RemArpeggioTick ( ArpStr, Ticks ));
}

ULONG ASM libInsertArpeggioTick ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0),
    register __d0 unsigned long Tick GNUCREG(d0), register __d1 unsigned long Ticks GNUCREG(d1), register __d2 unsigned long Flags GNUCREG(d2))
{
  return ( InsertArpeggioTick ( ArpStr, Tick, Ticks, Flags ));
}

ULONG ASM libDeleteArpeggioTick ( register __a0 struct TuComposerInstrArpeggio *ArpStr GNUCREG(a0),
    register __d0 unsigned long Tick GNUCREG(d0), register __d1 unsigned long Ticks GNUCREG(d1), register __d2 unsigned long Flags GNUCREG(d2))
{
  return ( DeleteArpeggioTick ( ArpStr, Tick, Ticks, Flags ));
}

LONG ASM libCmpArpeggios ( register __a0 struct TuComposerInstrArpeggio *SrcArpStr GNUCREG(a0),
    register __a1 struct TuComposerInstrArpeggio *DestArpStr GNUCREG(a1))
{
  return ( CmpArpeggios ( SrcArpStr, DestArpStr ));
}

struct TuComposerSample * ASM libAllocSample ( register __a0 WORD *SampleData GNUCREG(a0),
    register __d0 unsigned long Length GNUCREG(d0))
{
  return ( AllocSample ( SampleData, Length ));
}

ULONG ASM libFreeSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0))
{
  return ( FreeSample ( SampleStr ));
}

ULONG ASM libAddSample ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleStr GNUCREG(a1))
{
  return ( AddSample ( InstrStr, SampleStr ));
}

ULONG ASM libRemSample ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0))
{
  return ( RemSample ( InstrStr ));
}

ULONG ASM libInsertSample ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleStr GNUCREG(a1),
    register __a2 struct TuComposerSample *SamplePos GNUCREG(a2))
{
  return ( InsertSample ( InstrStr, SampleStr, SamplePos ));
}

ULONG ASM libDeleteSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0))
{
  return ( DeleteSample ( SampleStr ));
}

ULONG ASM libClearSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0))
{
  return ( ClearSample ( SampleStr ));
}

struct TuComposerSample * ASM libDupSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0))
{
  return ( DupSample ( SampleStr ));
}

ULONG ASM libReSizeSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long NewSamples GNUCREG(d0))
{
  return ( ReSizeSample ( SampleStr, NewSamples ));
}

ULONG ASM libAddSampleUnknownChunk ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1))
{
  return ( AddSampleUnknownChunk ( SampleStr, UnknownChunkStr ));
}

ULONG ASM libRemSampleUnknownChunk ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0))
{
  return ( RemSampleUnknownChunk ( SampleStr ));
}

ULONG ASM libInsertSampleUnknownChunk ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1),
    register __a2 struct UnknownChunk *UnknownChunkPos GNUCREG(a2))
{
  return ( InsertSampleUnknownChunk ( SampleStr, UnknownChunkStr, UnknownChunkPos ));
}

ULONG ASM libGetNumSamples ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0))
{
  return ( GetNumSamples ( InstrStr ));
}

ULONG ASM libGetSampleNum ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleStr GNUCREG(a1))
{
  return ( GetSampleNum ( InstrStr, SampleStr ));
}

struct TuComposerSample * ASM libGetSampleAddr ( register __a0 struct TuComposerInstr *InstrStr GNUCREG(a0),
    register __d0 unsigned long Num GNUCREG(d0))
{
  return ( GetSampleAddr ( InstrStr, Num ));
}

struct TuComposerSample * ASM libPushSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0))
{
  return ( PushSample ( SampleStr ));
}

ULONG ASM libPopSample ( register __a0 struct TuComposerSample *SampleBuf GNUCREG(a0))
{
  return ( PopSample ( SampleBuf ));
}

struct TuComposerSample * ASM libCutSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleBuf GNUCREG(a1))
{
  return ( CutSample ( SampleStr, SampleBuf ));
}

struct TuComposerSample * ASM libCopySample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleBuf GNUCREG(a1))
{
  return ( CopySample ( SampleStr, SampleBuf ));
}

struct TuComposerSample * ASM libPasteSample ( register __a0 struct TuComposerSample *SampleBuf GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleStr GNUCREG(a1))
{
  return ( PasteSample ( SampleBuf, SampleStr ));
}

ULONG ASM libSwapSample ( register __a0 struct TuComposerSample *SampleBuf GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleStr GNUCREG(a1))
{
  return ( SwapSample ( SampleBuf, SampleStr ));
}

ULONG ASM libSwapSampleInInstr ( register __a0 struct TuComposerSample *SampleBuf GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleStr GNUCREG(a1),
    register __d0 unsigned long Flags GNUCREG(d0))
{
  return ( SwapSampleInInstr ( SampleBuf, SampleStr, Flags ));
}

ULONG ASM libPlaySample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __a1 union FlagPass *FlagPassStr GNUCREG(a1),
    register __d0 unsigned long Channel GNUCREG(d0), register __d1 unsigned long Frequency GNUCREG(d1),
    register __d2 unsigned long Volume GNUCREG(d2))
{
  return ( PlaySample ( SampleStr, FlagPassStr, Channel, Frequency, Volume ));
}

struct TuComposerSample * ASM libLoadSample ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleStr GNUCREG(a1), register __a2 struct TuComposerExtList *ExtLibStr GNUCREG(a2),
    register __a3 union FlagPass *FlagPassStr GNUCREG(a3), register __d0 unsigned long NumSample GNUCREG(d0))
{
  return ( LoadSample ( CFHandle, SampleStr, ExtLibStr, FlagPassStr, NumSample ));
}

ULONG ASM libSaveSample ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleStr GNUCREG(a1), register __a2 struct TuComposerExtList *ExtLibStr GNUCREG(a2),
    register __a3 union FlagPass *FlagPassStr GNUCREG(a3))
{
  return ( SaveSample ( CFHandle, SampleStr, ExtLibStr, FlagPassStr ));
}

struct TuComposerExtList * ASM libIdentifySample ( register __a0 struct CFHandle *CFHandle GNUCREG(a0))
{
  return ( IdentifySample ( CFHandle ));
}

struct SampleInfo * ASM libGetSampleInfo ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerExtList *ExtLibStr GNUCREG(a1), register __d0 unsigned long NumSample GNUCREG(d0))
{
  return ( GetSampleInfo ( CFHandle, ExtLibStr, NumSample ));
}

ULONG ASM libFreeSampleInfo ( register __a0 struct SampleInfo *SampleInfoStr GNUCREG(a0))
{
  return ( FreeSampleInfo ( SampleInfoStr ));
}

ULONG ASM libGetSamples ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerExtList *ExtLibStr GNUCREG(a1))
{
  return ( GetSamples ( CFHandle, ExtLibStr ));
}

ULONG ASM libCalcSamplePlayFreq ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long Octave GNUCREG(d0), register __d1 unsigned long Note GNUCREG(d1))
{
  return ( CalcSamplePlayFreq ( SampleStr, Octave, Note ));
}

ULONG ASM libCalcFineTune ( register __d0 unsigned long Note GNUCREG(d0), register __d1 long FineTune GNUCREG(d1))
{
  return ( CalcFineTune ( Note, FineTune ));
}

ULONG ASM libConvertSampleFrequency ( register __d0 unsigned long Period GNUCREG(d0))
{
  return ( ConvertSampleFrequency ( Period ));
}

ULONG ASM libCalcLinearFrequency ( register __d0 unsigned long SampleFreq GNUCREG(d0), register __d1 long SlideValue GNUCREG(d1))
{
  return ( CalcLinearFrequency ( SampleFreq, SlideValue ));
}

WORD *ASM libAllocSampleData ( register __d0 unsigned long Length GNUCREG(d0))
{
  return ( AllocSampleData ( Length ));
}

ULONG ASM libFreeSampleData ( register __a0 WORD *SampleData GNUCREG(a0), register __d0 unsigned long Length GNUCREG(d0))
{
  return ( FreeSampleData ( SampleData, Length ));
}

ULONG ASM libSetSampleData ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0), register __a1 WORD *SampleData GNUCREG(a1),
    register __d0 unsigned long Length GNUCREG(d0))
{
  return ( SetSampleData ( SampleStr, SampleData, Length ));
}

ULONG ASM libAddSampleData ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long NumSamples GNUCREG(d0))
{
  return ( AddSampleData ( SampleStr, NumSamples ));
}

ULONG ASM libRemSampleData ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long NumSamples GNUCREG(d0))
{
  return ( RemSampleData ( SampleStr, NumSamples ));
}

ULONG ASM libInsertSampleData ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long SamplePos GNUCREG(d0), register __d1 unsigned long NumSamples GNUCREG(d1))
{
  return ( InsertSampleData ( SampleStr, SamplePos, NumSamples ));
}

ULONG ASM libDeleteSampleData ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long SamplePos GNUCREG(d0), register __d1 unsigned long NumSamples GNUCREG(d1))
{
  return ( DeleteSampleData ( SampleStr, SamplePos, NumSamples ));
}

ULONG ASM libClearSampleData ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long FirstSmp GNUCREG(d0), register __d1 unsigned long LastSmp GNUCREG(d1))
{
  return ( ClearSampleData ( SampleStr, FirstSmp, LastSmp ));
}

WORD *ASM libDupSampleData ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0))
{
  return ( DupSampleData ( SampleStr ));
}

struct TuComposerSample * ASM libCutSampleData ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleBuf GNUCREG(a1),
    register __d0 unsigned long FirstSmp GNUCREG(d0), register __d1 unsigned long LastSmp GNUCREG(d1))
{
  return ( CutSampleData ( SampleStr, SampleBuf, FirstSmp, LastSmp ));
}

struct TuComposerSample * ASM libCopySampleData ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleBuf GNUCREG(a1),
    register __d0 unsigned long FirstSmp GNUCREG(d0), register __d1 unsigned long LastSmp GNUCREG(d1))
{
  return ( CopySampleData ( SampleStr, SampleBuf, FirstSmp, LastSmp ));
}

struct TuComposerSample * ASM libPasteSampleData ( register __a0 struct TuComposerSample
    *SampleBuf GNUCREG(a0), register __a1 struct TuComposerSample *SampleStr GNUCREG(a1),
    register __d0 unsigned long PasteSmp GNUCREG(d0), register __d1 unsigned long Flags GNUCREG(d1))
{
  return ( PasteSampleData ( SampleBuf, SampleStr, PasteSmp, Flags ));
}

struct TuComposerSample * ASM libCropSampleData ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleBuf GNUCREG(a1),
    register __d0 unsigned long FirstSmp GNUCREG(d0), register __d1 unsigned long LastSmp GNUCREG(d1))
{
  return ( CropSampleData ( SampleStr, SampleBuf, FirstSmp, LastSmp ));
}

struct TuComposerSample * ASM libLoadSampleData ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleStr GNUCREG(a1), register __d0 unsigned long NumBytes GNUCREG(d0))
{
  return ( LoadSampleData ( CFHandle, SampleStr, NumBytes ));
}

ULONG ASM libSaveSampleData ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleStr GNUCREG(a1), register __d0 unsigned long FirstSmp GNUCREG(d0),
    register __d1 unsigned long LastSmp GNUCREG(d1))
{
  return ( SaveSampleData ( CFHandle, SampleStr, FirstSmp, LastSmp ));
}

ULONG ASM libConvertBits ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long DestBitDepth GNUCREG(d0), register __d1 unsigned long Flags GNUCREG(d1))
{
  return ( ConvertBits ( SampleStr, DestBitDepth, Flags ));
}

ULONG ASM libGetOptimalBits ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long Flags GNUCREG(d0))
{
  return ( GetOptimalBits ( SampleStr, Flags ));
}

ULONG ASM libConvertSigned ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0))
{
  return ( ConvertSigned ( SampleStr ));
}

ULONG ASM libConvertWord ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0))
{
  return ( ConvertWord ( SampleStr ));
}

ULONG ASM libDecrunchSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long DeltaBitDepth GNUCREG(d0))
{
  return ( DecrunchSample ( SampleStr, DeltaBitDepth ));
}

ULONG ASM libBackwards ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0), register __d0 unsigned long StartSmp GNUCREG(d0),
    register __d1 unsigned long LastSmp GNUCREG(d1))
{
  return ( Backwards ( SampleStr, StartSmp, LastSmp ));
}

ULONG ASM libMixSamples ( register __a0 struct TuComposerSample *SrcSampleStr GNUCREG(a0),
    register __a1 struct TuComposerSample *DestSampleStr GNUCREG(a1), register __d0 unsigned long SrcStartSmp GNUCREG(d0),
    register __d1 unsigned long SrcLastSmp GNUCREG(d1), register __d2 unsigned long DestStartSmp GNUCREG(d2))
{
  return ( MixSamples ( SrcSampleStr, DestSampleStr, SrcStartSmp, SrcLastSmp, DestStartSmp ));
}

struct TuComposerSample * ASM libSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __a1 struct TuComposerExtList *InpDevStr GNUCREG(a1), register __a2 WORD *Buffer GNUCREG(a2),
    register __d0 unsigned long Frequency GNUCREG(d0), register __d1 unsigned long BitDepth GNUCREG(d1), register __d2 unsigned long BufLen GNUCREG(d2),
    register __d3 unsigned long Flags GNUCREG(d3))
{
  return ( Sample ( SampleStr, InpDevStr, Buffer, Frequency, BitDepth, BufLen, Flags ));
}

ULONG ASM libOctaveUp ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0))
{
  return ( OctaveUp ( SampleStr ));
}

ULONG ASM libOctaveDown ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0))
{
  return ( OctaveDown ( SampleStr ));
}

ULONG ASM libReSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long NewFrequency GNUCREG(d0), register __d1 unsigned long OldFrequency GNUCREG(d1),
    register __d2 unsigned long Flags GNUCREG(d2))
{
  return ( ReSample ( SampleStr, NewFrequency, OldFrequency, Flags ));
}

ULONG ASM libInvertSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0))
{
  return ( InvertSample ( SampleStr ));
}

ULONG ASM libXFadeSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0))
{
  return ( XFadeSample ( SampleStr ));
}

ULONG ASM libAmplifySample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long StartAmplify GNUCREG(d0), register __d1 unsigned long EndAmplify GNUCREG(d1),
    register __d2 unsigned long StartSmp GNUCREG(d2), register __d3 unsigned long LastSmp GNUCREG(d3))
{
  return ( AmplifySample ( SampleStr, StartAmplify, EndAmplify, StartSmp, LastSmp ));
}

ULONG ASM libGetBiggestAmplify ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long StartSmp GNUCREG(d0), register __d1 unsigned long LastSmp GNUCREG(d1))
{
  return ( GetBiggestAmplify ( SampleStr, StartSmp, LastSmp ));
}

ULONG ASM libGetLowestAmplify ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long StartSmp GNUCREG(d0), register __d1 unsigned long LastSmp GNUCREG(d1))
{
  return ( GetLowestAmplify ( SampleStr, StartSmp, LastSmp ));
}

ULONG ASM libCreateEcho ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0))
{
  return ( CreateEcho ( SampleStr ));
}

ULONG ASM libBoostSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0))
{
  return ( BoostSample ( SampleStr ));
}

ULONG ASM libFilterSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0))
{
  return ( FilterSample ( SampleStr ));
}

ULONG ASM libMorphSamples ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0))
{
  return ( MorphSamples ( SampleStr ));
}

ULONG ASM libMinimizeSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0))
{
  return ( MinimizeSample ( SampleStr ));
}

struct TuComposerSample * ASM libFindOriginSample ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0))
{
  return ( FindOriginSample ( SampleStr ));
}

LONG ASM libGetSampleValue ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __d0 unsigned long Sample GNUCREG(d0))
{
  return ( GetSampleValue ( SampleStr, Sample ));
}

ULONG ASM libGetSampleValueArray ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __a1 LONG *ArrayPtr GNUCREG(a1), register __d0 unsigned long StartSmp GNUCREG(d0), register __d1 unsigned long ArrayEntries GNUCREG(d1))
{
  return ( GetSampleValueArray ( SampleStr, ArrayPtr, StartSmp, ArrayEntries ));
}

LONG ASM libCmpSamples ( register __a0 struct TuComposerSample *SrcSampleStr GNUCREG(a0),
    register __a1 struct TuComposerSample *DestSampleStr GNUCREG(a1))
{
  return ( CmpSamples ( SrcSampleStr, DestSampleStr ));
}

struct TuComposerSynth * ASM libAllocSynth ( register __d0 unsigned long CodeLen GNUCREG(d0),
    register __d1 unsigned long Waveforms GNUCREG(d1), register __d2 unsigned long WaveLen GNUCREG(d2))
{
  return ( AllocSynth ( CodeLen, Waveforms, WaveLen ));
}

ULONG ASM libFreeSynth ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0))
{
  return ( FreeSynth ( SynthStr ));
}

ULONG ASM libAssignSynth ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthStr GNUCREG(a1))
{
  return ( AssignSynth ( SampleStr, SynthStr ));
}

ULONG ASM libClearSynth ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0))
{
  return ( ClearSynth ( SynthStr ));
}

struct TuComposerSynth * ASM libDupSynth ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0))
{
  return ( DupSynth ( SynthStr ));
}

ULONG ASM libReMapSynth ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynth *NewSynthStr GNUCREG(a1))
{
  return ( ReMapSynth ( SynthStr, NewSynthStr ));
}

ULONG ASM libAddSynthUnknownChunk ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1))
{
  return ( AddSynthUnknownChunk ( SynthStr, UnknownChunkStr ));
}

ULONG ASM libRemSynthUnknownChunk ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0))
{
  return ( RemSynthUnknownChunk ( SynthStr ));
}

ULONG ASM libInsertSynthUnknownChunk ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct UnknownChunk *UnknownChunkStr GNUCREG(a1),
    register __a2 struct UnknownChunk *UnknownChunkPos GNUCREG(a2))
{
  return ( InsertSynthUnknownChunk ( SynthStr, UnknownChunkStr, UnknownChunkPos ));
}

ULONG ASM libGetNumSynths ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0))
{
  return ( GetNumSynths ( ModuleStr ));
}

ULONG ASM libGetSynthNum ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthStr GNUCREG(a1))
{
  return ( GetSynthNum ( ModuleStr, SynthStr ));
}

struct TuComposerSynth * ASM libGetSynthAddr ( register __a0 struct TuComposerModule *ModuleStr GNUCREG(a0),
    register __d0 unsigned long SynthNum GNUCREG(d0))
{
  return ( GetSynthAddr ( ModuleStr, SynthNum ));
}

struct TuComposerSynth * ASM libPushSynth ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0))
{
  return ( PushSynth ( SynthStr ));
}

ULONG ASM libPopSynth ( register __a0 struct TuComposerSynth *SynthBuf GNUCREG(a0))
{
  return ( PopSynth ( SynthBuf ));
}

struct TuComposerSynth * ASM libCutSynth ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthBuf GNUCREG(a1))
{
  return ( CutSynth ( SynthStr, SynthBuf ));
}

struct TuComposerSynth * ASM libCopySynth ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthBuf GNUCREG(a1))
{
  return ( CopySynth ( SynthStr, SynthBuf ));
}

struct TuComposerSynth * ASM libPasteSynth ( register __a0 struct TuComposerSynth *SynthBuf GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthStr GNUCREG(a1))
{
  return ( PasteSynth ( SynthBuf, SynthStr ));
}

ULONG ASM libSwapSynth ( register __a0 struct TuComposerSynth *SynthBuf GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthStr GNUCREG(a1))
{
  return ( SwapSynth ( SynthBuf, SynthStr ));
}

struct TuComposerSynth * ASM libLoadSynth ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthStr GNUCREG(a1), register __a2  struct TuComposerExtList *ExtLibStr GNUCREG(a2),
    register __a3 union FlagPass *FlagPassStr GNUCREG(a3), register __d0 unsigned long NumSynth GNUCREG(d0))
{
  return ( LoadSynth ( CFHandle, SynthStr, ExtLibStr, FlagPassStr, NumSynth ));
}

ULONG ASM libSaveSynth ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthStr GNUCREG(a1), register __a2 struct TuComposerExtList *ExtLibStr GNUCREG(a2),
    register __a3 union FlagPass *FlagPassStr GNUCREG(a3))
{
  return ( SaveSynth ( CFHandle, SynthStr, ExtLibStr, FlagPassStr ));
}

struct TuComposerExtList * ASM libIdentifySynth ( register __a0 struct CFHandle *CFHandle GNUCREG(a0))
{
  return ( IdentifySynth ( CFHandle ));
}

struct SynthInfo * ASM libGetSynthInfo ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerExtList *ExtLibStr GNUCREG(a1), register __d0 unsigned long NumSynth GNUCREG(d0))
{
  return ( GetSynthInfo ( CFHandle, ExtLibStr, NumSynth ));
}

ULONG ASM libFreeSynthInfo ( register __a0 struct SynthInfo *SynthInfoStr GNUCREG(a0))
{
  return ( FreeSynthInfo ( SynthInfoStr ));
}

ULONG ASM libGetSynths ( register __a0 struct CFHandle *CFHandle GNUCREG(a0), register __a1 struct TuComposerExtList
    *ExtLibStr GNUCREG(a1))
{
  return ( GetSynths ( CFHandle, ExtLibStr ));
}

LONG ASM libCmpSynths ( register __a0 struct TuComposerSynth *SrcSynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynth *DestSynthStr GNUCREG(a1))
{
  return ( CmpSynths ( SrcSynthStr, DestSynthStr ));
}

struct TuComposerSynthWave * ASM libAllocWaveform ( register __d0 unsigned long WaveLength GNUCREG(d0))
{
  return ( AllocWaveform ( WaveLength ));
}

ULONG ASM libFreeWaveform ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0))
{
  return ( FreeWaveform ( WaveformStr ));
}

ULONG ASM libAddWaveform ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynthWave *WaveformStr GNUCREG(a1))
{
  return ( AddWaveform ( SynthStr, WaveformStr ));
}

ULONG ASM libRemWaveform ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0))
{
  return ( RemWaveform ( SynthStr ));
}

ULONG ASM libInsertWaveform ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynthWave *WaveformStr GNUCREG(a1),
    register __a2 struct TuComposerSynthWave *WaveformPos GNUCREG(a2))
{
  return ( InsertWaveform ( SynthStr, WaveformStr, WaveformPos ));
}

ULONG ASM libDeleteWaveform ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0))
{
  return ( DeleteWaveform ( WaveformStr ));
}

ULONG ASM libClearWaveform ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0))
{
  return ( ClearWaveform ( WaveformStr ));
}

struct TuComposerSynthWave * ASM libDupWaveform ( register __a0 struct TuComposerSynthWave
    *WaveformStr GNUCREG(a0))
{
  return ( DupWaveform ( WaveformStr ));
}

ULONG ASM libReSizeWaveform ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0),
    register __d0 unsigned long NewLen GNUCREG(d0))
{
  return ( ReSizeWaveform ( WaveformStr, NewLen ));
}

ULONG ASM libGetNumWaveforms ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0))
{
  return ( GetNumWaveforms ( SynthStr ));
}

ULONG ASM libGetWaveformNum ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynthWave *WaveformStr GNUCREG(a1))
{
  return ( GetWaveformNum ( SynthStr, WaveformStr ));
}

struct TuComposerSynthWave * ASM libGetWaveformAddr ( register __a0 struct TuComposerSynth
    *SynthStr GNUCREG(a0), register __d0 unsigned long WaveformNum GNUCREG(d0))
{
  return ( GetWaveformAddr ( SynthStr, WaveformNum ));
}

struct TuComposerSynthWave * ASM libPushWaveform ( register __a0 struct TuComposerSynthWave
    *WaveformStr GNUCREG(a0))
{
  return ( PushWaveform ( WaveformStr ));
}

ULONG ASM libPopWaveform ( register __a0 struct TuComposerSynthWave *WaveformBuf GNUCREG(a0))
{
  return ( PopWaveform ( WaveformBuf ));
}

struct TuComposerSynthWave * ASM libCutWaveform ( register __a0 struct TuComposerSynthWave
    *WaveformStr GNUCREG(a0), register __a1 struct TuComposerSynthWave *WaveformBuf GNUCREG(a1))
{
  return ( CutWaveform ( WaveformStr, WaveformBuf ));
}

struct TuComposerSynthWave * ASM libCopyWaveform ( register __a0 struct TuComposerSynthWave
    *WaveformStr GNUCREG(a0), register __a1 struct TuComposerSynthWave *WaveformBuf GNUCREG(a1))
{
  return ( CopyWaveform ( WaveformStr, WaveformBuf ));
}

struct TuComposerSynthWave * ASM libPasteWaveform ( register __a0 struct TuComposerSynthWave
    *WaveformBuf GNUCREG(a0), register __a1 struct TuComposerSynthWave *WaveformStr GNUCREG(a1))
{
  return ( PasteWaveform ( WaveformBuf, WaveformStr ));
}

ULONG ASM libSwapWaveform ( register __a0 struct TuComposerSynthWave *WaveformBuf GNUCREG(a0),
    register __a1 struct TuComposerSynthWave *WaveformStr GNUCREG(a1))
{
  return ( SwapWaveform ( WaveformBuf, WaveformStr ));
}

ULONG ASM libSwapWaveformInSynth ( register __a0 struct TuComposerSynthWave *WaveformBuf GNUCREG(a0),
    register __a1 struct TuComposerSynthWave *WaveformStr GNUCREG(a1))
{
  return ( SwapWaveformInSynth ( WaveformBuf, WaveformStr ));
}

struct TuComposerSynthWave * ASM libLoadWaveform ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSynthWave *WaveformStr GNUCREG(a1), register __d0 unsigned long NumBytes GNUCREG(d0))
{
  return ( LoadWaveform ( CFHandle, WaveformStr, NumBytes ));
}

ULONG ASM libSaveWaveform ( register __a0 struct CFHandle *CFHandle GNUCREG(a0),
    register __a1 struct TuComposerSynthWave *WaveformStr GNUCREG(a1), register __d0 unsigned long FirstSmp GNUCREG(d0),
    register __d1 unsigned long LastSmp GNUCREG(d1))
{
  return ( SaveWaveform ( CFHandle, WaveformStr, FirstSmp, LastSmp ));
}

ULONG ASM libPlayWaveform ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0), register __a1 union FlagPass *FlagPassStr GNUCREG(a1),
    register __d0 unsigned long Frequency GNUCREG(d0))
{
  return ( PlayWaveform ( WaveformStr, FlagPassStr, Frequency ));
}

ULONG ASM libAddWaveformPoint ( register __a0 struct TuComposerSynthWave * WaveformStr GNUCREG(a0),
    register __d0 unsigned long Points GNUCREG(d0))
{
  return ( AddWaveformPoint ( WaveformStr, Points ));
}

ULONG ASM libRemWaveformPoint ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0),
    register __d0 unsigned long Points GNUCREG(d0))
{
  return ( RemWaveformPoint ( WaveformStr, Points ));
}

ULONG ASM libInsertWaveformPoint ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0),
    register __d0 unsigned long Point GNUCREG(d0), register __d1 unsigned long Points GNUCREG(d1), register __d2 unsigned long Flags GNUCREG(d2))
{
  return ( InsertWaveformPoint ( WaveformStr, Point, Points, Flags ));
}

ULONG ASM libDeleteWaveformPoint ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0),
    register __d0 unsigned long Point GNUCREG(d0), register __d1 unsigned long Points GNUCREG(d1), register __d2 unsigned long Flags GNUCREG(d2))
{
  return ( DeleteWaveformPoint ( WaveformStr, Point, Points, Flags ));
}

ULONG ASM libFillWaveform ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0),
    register __d0 unsigned long RepLen GNUCREG(d0), register __d1 unsigned long Type GNUCREG(d1), register __d2 unsigned long Scale GNUCREG(d2),
    register __d3 long YOffset GNUCREG(d3))
{
  return ( FillWaveform ( WaveformStr, RepLen, Type, Scale, YOffset ));
}

ULONG ASM libConvertWaveform ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0),
    register __d0 unsigned long DestBitDepth GNUCREG(d0), register __d1 unsigned long Flags GNUCREG(d1))
{
  return ( ConvertWaveform ( WaveformStr, DestBitDepth, Flags ));
}

ULONG ASM libConvertWaveformSigned ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0))
{
  return ( ConvertWaveformSigned ( WaveformStr ));
}

ULONG ASM libConvertWaveformWord ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0))
{
  return ( ConvertWaveformWord ( WaveformStr ));
}

ULONG ASM libBackwardsWaveform ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0))
{
  return ( BackwardsWaveform ( WaveformStr ));
}

ULONG ASM libMixWaveforms ( register __a0 struct TuComposerSynthWave *SrcWaveformStr GNUCREG(a0),
    register __a1 struct TuComposerSynthWave *DestWaveformStr GNUCREG(a1))
{
  return ( MixWaveforms ( SrcWaveformStr, DestWaveformStr ));
}

ULONG ASM libHalveWaveform ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0))
{
  return ( HalveWaveform ( WaveformStr ));
}

ULONG ASM libDoubleWaveform ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0))
{
  return ( DoubleWaveform ( WaveformStr ));
}

ULONG ASM libScaleWaveformSize ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0),
    register __d0 unsigned long NewLength GNUCREG(d0), register __d1 unsigned long OldLength GNUCREG(d1), register __d2 unsigned long Flags GNUCREG(d2))
{
  return ( ScaleWaveformSize ( WaveformStr, NewLength, OldLength, Flags ));
}

ULONG ASM libInvertWaveform ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0))
{
  return ( InvertWaveform ( WaveformStr ));
}

ULONG ASM libAmplifyWaveform ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0),
    register __d0 unsigned long Amplify GNUCREG(d0))
{
  return ( AmplifyWaveform ( WaveformStr, Amplify ));
}

ULONG ASM libGetMaxWaveformAmplify ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0))
{
  return ( GetMaxWaveformAmplify ( WaveformStr ));
}

ULONG ASM libGetMinWaveformAmplify ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0))
{
  return ( GetMinWaveformAmplify ( WaveformStr ));
}

ULONG ASM libCopySample2Waveform ( register __a0 struct TuComposerSample *SampleStr GNUCREG(a0),
    register __a1 struct TuComposerSynthWave *WaveformStr GNUCREG(a1))
{
  return ( CopySample2Waveform ( SampleStr, WaveformStr ));
}

ULONG ASM libCopyWaveform2Sample ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0),
    register __a1 struct TuComposerSample *SampleStr GNUCREG(a1))
{
  return ( CopyWaveform2Sample ( WaveformStr, SampleStr ));
}

ULONG ASM libCopyEnvelope2Waveform ( register __a0 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a0),
    register __a1 struct TuComposerSynthWave *WaveformStr GNUCREG(a1))
{
  return ( CopyEnvelope2Waveform ( EnvStr, WaveformStr ));
}

ULONG ASM libCopyWaveform2Envelope ( register __a0 struct TuComposerSynthWave *WaveformStr GNUCREG(a0),
    register __a1 struct TuComposerInstrEnvelope *EnvStr GNUCREG(a1))
{
  return ( CopyWaveform2Envelope ( WaveformStr, EnvStr ));
}

ULONG ASM libTransformWaveform ( register __a0 struct TuComposerSynthWave *SrcWaveformStr GNUCREG(a0),
    register __a1 struct TuComposerSynthWave *DestWaveformStr GNUCREG(a1))
{
  return ( TransformWaveform ( SrcWaveformStr, DestWaveformStr ));
}

LONG ASM libCmpWaveforms ( register __a0 struct TuComposerSynthWave *SrcWaveformStr GNUCREG(a0),
    register __a1 struct TuComposerSynthWave *DestWaveformStr GNUCREG(a1))
{
  return ( CmpWaveforms ( SrcWaveformStr, DestWaveformStr ));
}

struct TuComposerSynthCode * ASM libAllocSynthCode ( register __d0 unsigned long Lines GNUCREG(d0))
{
  return ( AllocSynthCode ( Lines ));
}

ULONG ASM libFreeSynthCode ( register __a0 struct TuComposerSynthCode *SynthCodeStr GNUCREG(a0),
    register __d0 unsigned long Lines GNUCREG(d0))
{
  return ( FreeSynthCode ( SynthCodeStr, Lines ));
}

ULONG ASM libAssignSynthCode ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynthCode *SynthCodeStr GNUCREG(a1), register __d0 unsigned long Lines GNUCREG(d0))
{
  return ( AssignSynthCode ( SynthStr, SynthCodeStr, Lines ));
}

ULONG ASM libClearSynthCode ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0))
{
  return ( ClearSynthCode ( SynthStr ));
}

struct TuComposerSynthCode * ASM libDupSynthCode ( register __a0 struct TuComposerSynth
    *SynthStr GNUCREG(a0))
{
  return ( DupSynthCode ( SynthStr ));
}

ULONG ASM libReSizeSynthCode ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __d0 unsigned long NewLen GNUCREG(d0))
{
  return ( ReSizeSynthCode ( SynthStr, NewLen ));
}

struct TuComposerSynth * ASM libPushSynthCode ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0))
{
  return ( PushSynthCode ( SynthStr ));
}

ULONG ASM libPopSynthCode ( register __a0 struct TuComposerSynth *SynthBuf GNUCREG(a0))
{
  return ( PopSynthCode ( SynthBuf ));
}

struct TuComposerSynth * ASM libCutSynthCode ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthBuf GNUCREG(a1))
{
  return ( CutSynthCode ( SynthStr, SynthBuf ));
}

struct TuComposerSynth * ASM libCopySynthCode ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthBuf GNUCREG(a1))
{
  return ( CopySynthCode ( SynthStr, SynthBuf ));
}

struct TuComposerSynth * ASM libPasteSynthCode ( register __a0 struct TuComposerSynth *SynthBuf GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthStr GNUCREG(a1))
{
  return ( PasteSynthCode ( SynthBuf, SynthStr ));
}

ULONG ASM libSwapSynthCode ( register __a0 struct TuComposerSynth *SynthBuf GNUCREG(a0),
    register __a1 struct TuComposerSynth *SynthStr GNUCREG(a1))
{
  return ( SwapSynthCode ( SynthBuf, SynthStr ));
}

ULONG ASM libAddSynthCodeLine ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __d0 unsigned long Lines GNUCREG(d0))
{
  return ( AddSynthCodeLine ( SynthStr, Lines ));
}

ULONG ASM libRemSynthCodeLine ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __d0 unsigned long Lines GNUCREG(d0))
{
  return ( RemSynthCodeLine ( SynthStr, Lines ));
}

ULONG ASM libInsertSynthCodeLine ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __d0 unsigned long Line GNUCREG(d0), register __d1 unsigned long Lines GNUCREG(d1), register __d2 unsigned long Flags GNUCREG(d2))
{
  return ( InsertSynthCodeLine ( SynthStr, Line, Lines, Flags ));
}

ULONG ASM libDeleteSynthCodeLine ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __d0 unsigned long Line GNUCREG(d0), register __d1 unsigned long Lines GNUCREG(d1), register __d2 unsigned long Flags GNUCREG(d2))
{
  return ( DeleteSynthCodeLine ( SynthStr, Line, Lines, Flags ));
}

ULONG ASM libGetSynthCodeParams ( register __d0 unsigned long Code GNUCREG(d0))
{
  return ( GetSynthCodeParams ( Code ));
}

STRPTR ASM libAssembleCodeLine ( register __a0 STRPTR AsmBuf GNUCREG(a0), register __a1 struct TuComposerSynth *SynthStr GNUCREG(a1),
    register __d0 unsigned long CodeLine GNUCREG(d0), register __d1 unsigned long Flags GNUCREG(d1))
{
  return ( AssembleCodeLine ( AsmBuf, SynthStr, CodeLine, Flags ));
}

ULONG ASM libDisassembleCodeLine ( register __a0 STRPTR AsmBuf GNUCREG(a0), register __a1 struct TuComposerSynth *SynthStr GNUCREG(a1),
    register __d0 unsigned long CodeLine GNUCREG(d0), register __d1 unsigned long Flags GNUCREG(d1))
{
  return ( DisassembleCodeLine ( AsmBuf, SynthStr, CodeLine, Flags ));
}

struct TuComposerSynthSymbolTable * ASM libAllocSymbol ( register __a0 STRPTR Name GNUCREG(a0))
{
  return ( AllocSymbol ( Name ));
}

ULONG ASM libFreeSymbol ( register __a0 struct TuComposerSynthSymbolTable *SymbolStr GNUCREG(a0))
{
  return ( FreeSymbol ( SymbolStr ));
}

ULONG ASM libAssignSymbol ( register __a0 struct TuComposerSynthSymbolTable *SymbolStr GNUCREG(a0),
    register __a1 STRPTR Name GNUCREG(a1))
{
  return ( AssignSymbol ( SymbolStr, Name ));
}

struct TuComposerSynthSymbolTable * ASM libDupSymbol (     register __a0 struct TuComposerSynthSymbolTable *SymbolStr GNUCREG(a0))
{
  return ( DupSymbol ( SymbolStr ));
}

ULONG ASM libAddSymbol ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynthSymbolTable *SymbolStr GNUCREG(a1))
{
  return ( AddSymbol ( SynthStr, SymbolStr ));
}

ULONG ASM libRemSymbol ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0))
{
  return ( RemSymbol ( SynthStr ));
}

ULONG ASM libInsertSymbol ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynthSymbolTable *SymbolStr GNUCREG(a1),
    register __a2 struct TuComposerSynthSymbolTable *SymbolPos GNUCREG(a2))
{
  return ( InsertSymbol ( SynthStr, SymbolStr, SymbolPos ));
}

ULONG ASM libDeleteSymbol ( register __a0 struct TuComposerSynthSymbolTable *SymbolStr GNUCREG(a0))
{
  return ( DeleteSymbol ( SymbolStr ));
}

ULONG ASM libGetNumSymbols ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0))
{
  return ( GetNumSymbols ( SynthStr ));
}

ULONG ASM libGetSymbolNum ( register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0),
    register __a1 struct TuComposerSynthSymbolTable *SymbolStr GNUCREG(a1))
{
  return ( GetSymbolNum ( SynthStr, SymbolStr ));
}

struct TuComposerSynthSymbolTable * ASM libGetSymbolAddr (     register __a0 struct TuComposerSynth *SynthStr GNUCREG(a0), register __d0 unsigned long SymbolNum GNUCREG(d0))
{
  return ( GetSymbolAddr ( SynthStr, SymbolNum ));
}

struct TuComposerSynthSymbolTable * ASM libMatchSymbol (     register __a0 struct TuComposerSynthSymbolTable *SymbolStr GNUCREG(a0), register __a1 STRPTR Name GNUCREG(a1),
    register __d0 unsigned long Line GNUCREG(d0), register __d1 unsigned long Type GNUCREG(d1))
{
  return ( MatchSymbol ( SymbolStr, Name, Line, Type ));
}

ULONG ASM libAddExternalLib ( register __a0 struct TuComposerExtList *ExtLibStr GNUCREG(a0),
    register __d0 unsigned long Type GNUCREG(d0))
{
  return ( AddExternalLib ( ExtLibStr, Type ));
}

struct TuComposerExtList * ASM libRemExternalLib ( register __a0 struct TuComposerExtList
    *ExtLibStr GNUCREG(a0))
{
  return ( RemExternalLib ( ExtLibStr ));
}

struct TuComposerExtLibBase * ASM libOpenExternalLib ( register __a0 struct TuComposerExtList
    *ExtLibStr GNUCREG(a0))
{
  return ( OpenExternalLib ( ExtLibStr ));
}

struct TuComposerExtList * ASM libCloseExternalLib ( register __a0 struct TuComposerExtList
    *ExtLibStr GNUCREG(a0))
{
  return ( CloseExternalLib ( ExtLibStr ));
}

ULONG ASM libGetExternalLibs ( register __a0 STRPTR ExtLibPatStr GNUCREG(a0))
{
  return ( GetExternalLibs ( ExtLibPatStr ));
}

struct TuComposerExtFlagStr * ASM libAllocFlagStr ( register __a0 struct TuComposerExtFlagStr
    *FlagStr GNUCREG(a0))
{
  return ( AllocFlagStr ( FlagStr ));
}

struct TuComposerExtList * ASM libCIdentify ( register __d1 STRPTR FileName GNUCREG(d1))
{
  return ( CIdentify ( FileName ));
}

struct CFHandle * ASM libCOpen ( register __d1 STRPTR FileName GNUCREG(d1), register __d2 unsigned long Mode GNUCREG(d2),
    register __d3 struct TuComposerExtList *ExtLibStr GNUCREG(d3))
{
  return ( COpen ( FileName, Mode, ExtLibStr ));
}

ULONG ASM libCClose ( register __d1 struct CFHandle *CFHandle GNUCREG(d1))
{
  return ( CClose ( CFHandle ));
}

ULONG ASM libCRead ( register __d1 struct CFHandle *CFHandle GNUCREG(d1), register __d2 APTR Buffer GNUCREG(d2), register __d3 unsigned long Length GNUCREG(d3))
{
  return ( CRead ( CFHandle, Buffer, Length ));
}

ULONG ASM libCWrite ( register __d1 struct CFHandle *CFHandle GNUCREG(d1), register __d2 APTR Buffer GNUCREG(d2),
    register __d3 unsigned long Length GNUCREG(d3))
{
  return ( CWrite ( CFHandle, Buffer, Length ));
}

ULONG ASM libCSeek ( register __d1 struct CFHandle *CFHandle GNUCREG(d1), register __d2 unsigned long Position GNUCREG(d2),
    register __d3 unsigned long Relative GNUCREG(d3))
{
  return ( CSeek ( CFHandle, Position, Relative ));
}

ULONG ASM libCGetInfo ( register __d1 struct CFHandle *CFHandle GNUCREG(d1), register __d2 struct CruncherInfo *CInfoStr GNUCREG(d2))
{
  return ( CGetInfo ( CFHandle, CInfoStr ));
}
